//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Backstitchedit.h"
#include <math.h>
#include "StringHelp.h"
#include <shellapi.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TBackStitchForm *BackStitchForm;
//---------------------------------------------------------------------------
__fastcall TBackStitchForm::TBackStitchForm(TComponent* Owner)
    : TForm(Owner)
{
	//int crTargetCursor = 10;
	crTargetCursor = 10;
    Screen->Cursors[crTargetCursor] = LoadCursor((void *)HInstance, "TARGET");
    Image1->Cursor = (TCursor) crTargetCursor;
    //int crDropperCursor = 11;
    crDropperCursor = 11;
    Screen->Cursors[crDropperCursor] = LoadCursor((void *)HInstance, "DROPPER");
    //Image1->Cursor = (TCursor) crDropperCursor;

}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::Cancel1Click(TObject *Sender)
{
    ModalResult = mrCancel;
}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::Accept1Click(TObject *Sender)
{
    ModalResult = mrOk;
}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::FormCreate(TObject *Sender)
{
    FormResize(Sender);
    Picture = new Graphics::TBitmap();
    TopLeftX = 0;
    TopLeftY = 0;
    SquareSize = 5;
    Zoom1 = 5;
    SelectedColour = 0;
    fPictureXStitchCount = 14;
    AddingStitches = false;
    DeletingStitches = false;
    PixelEditing = false;
    active = false;
    undostitchlength = 1;
    SpareControl = new TImage(this);
    SpareControl->Visible = false;
    UndoPixelEdits = new TStringList();
    imagechanged = false;

}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::FormResize(TObject *Sender)
{
    StatusBar1->Width = ClientWidth;
    StatusBar1->Top = ClientHeight - StatusBar1->Height;
    StatusBar1->Left = 0;
    Panel1->Top = 0;
    Panel1->Left = ClientWidth - Panel1->Width;
    Panel1->Height = StatusBar1->Top - 1;
    ScrollBar1->Top = 0;
    ScrollBar1->Left = Panel1->Left - ScrollBar1->Width;
    ScrollBar1->Height = Panel1->Height - ScrollBar2->Height;
    ScrollBar2->Left = 0;
    ScrollBar2->Top = ScrollBar1->Height;
    ScrollBar2->Width = ScrollBar1->Left;
    Image1->Width = ScrollBar1->Left;
    Image1->Height = ScrollBar2->Top;
    if (active) DrawBitmap();

}
//---------------------------------------------------------------------------
void __fastcall TBackStitchForm::FullPalletteDrawItem(TWinControl *Control,
      int Index, TRect &Rect, TOwnerDrawState State)
{
    // Draw coloured rectangle background & name of colour
    TRect Rectangle = Rect;
    TColor TempColour = FullPallette->Canvas->Brush->Color;
    FullPallette->Canvas->Brush->Style = bsSolid;
    FullPallette->Canvas->Brush->Color = ColourList[Index].Colour;
    FullPallette->Canvas->FillRect(Rectangle);
    FullPallette->Canvas->Brush->Color = TempColour;
    if (ColourList[Index].DrawWhite) {
        FullPallette->Canvas->Font->Color = clWhite;
        } else {
        FullPallette->Canvas->Font->Color = clBlack;
        }
    FullPallette->Canvas->Brush->Style = bsClear;
    //for some reason the next line doesn't work
    //FullPallette->Canvas->TextRect(Rectangle,1,1,FullPallette->Items->Strings[Index]);
    DrawText(FullPallette->Canvas->Handle,("  " + FullPallette->Items->Strings[Index]).c_str(),-1,(LPRECT) &Rectangle,DT_VCENTER | DT_SINGLELINE);
    FullPallette->Canvas->Brush->Style = bsSolid;


}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::FillColourList(void)
{
    FullPallette->Items->Clear();
    for (int i = 0; i < ColourList.Length; i++) {
        FullPallette->Items->Add(ColourList[i].DMCColourName);
        }

}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::FillUsedColourList(void)
{
    CurrentPallette->Items->Clear();
    for (int i = 0; i < UsedColourList.Length; i++) {
        CurrentPallette->Items->Add(UsedColourList[i].DMCColourName);
        }

}
//---------------------------------------------------------------------------


void __fastcall TBackStitchForm::CurrentPalletteDrawItem(
      TWinControl *Control, int Index, TRect &Rect, TOwnerDrawState State)
{
    // Draw coloured rectangle background & name of colour
    TRect Rectangle = Rect;
    TColor TempColour = CurrentPallette->Canvas->Brush->Color;
    CurrentPallette->Canvas->Brush->Style = bsSolid;
    CurrentPallette->Canvas->Brush->Color = UsedColourList[Index].Colour;
    CurrentPallette->Canvas->FillRect(Rectangle);
    CurrentPallette->Canvas->Brush->Color = TempColour;
    if (UsedColourList[Index].DrawWhite) {
        CurrentPallette->Canvas->Font->Color = clWhite;
        } else {
        CurrentPallette->Canvas->Font->Color = clBlack;
        }
    CurrentPallette->Canvas->Brush->Style = bsClear;
    //for some reason the next line doesn't work
    //CurrentPallette->Canvas->TextRect(Rectangle,1,1,CurrentPallette->Items->Strings[Index]);
    DrawText(CurrentPallette->Canvas->Handle,("  " + CurrentPallette->Items->Strings[Index]).c_str(),-1,(LPRECT) &Rectangle,DT_VCENTER | DT_SINGLELINE);
    CurrentPallette->Canvas->Brush->Style = bsSolid;

}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::FormDestroy(TObject *Sender)
{
    ColourList.Length = 0;
    UsedColourList.Length = 0;
    Picture->Free();
    BackStitchList.Length = 0;
    BackStitchRedo.Length = 0;
    delete SpareControl;
    delete UndoPixelEdits;


}
//---------------------------------------------------------------------------
 
void __fastcall TBackStitchForm::DrawBitmap(void)
{
    //this draws a copy of the bitmap held in memory on the image's canvas
    //int maxX = 0;
    //int maxY = 0;
    //first, clear picture
    Image1->Picture->Bitmap->Width = Image1->Width;
    Image1->Picture->Bitmap->Height = Image1->Height;
    TRect Rectangle;
    Image1->Canvas->Brush->Color = Color;
    Rectangle.left = 0;
    Rectangle.right = Image1->Picture->Bitmap->Width;
    Rectangle.top = 0;
    Rectangle.bottom = Image1->Picture->Bitmap->Height;
    Image1->Canvas->FillRect(Rectangle);

    if (Picture->Width > 0 && Picture->Height > 0) {
        /*
        //slow draw
        maxX = TopLeftX + (int) (Image1->Width / SquareSize) + 1;
        if (maxX > Picture->Width) maxX = Picture->Width;
        maxY = TopLeftY + (int) (Image1->Height / SquareSize) + 1;
        if (maxY > Picture->Height) maxY = Picture->Height;
        TColor PixelColour;
        Image1->Canvas->Brush->Style = bsSolid;
        Image1->Picture->Bitmap->Width = (maxX-TopLeftX+1)*SquareSize;
        Image1->Picture->Bitmap->Height = (maxY-TopLeftY+1)*SquareSize;
        for (int j = TopLeftY; j < maxY; j++) {
            for (int i = TopLeftX; i < maxX; i++) {
                PixelColour = Picture->Canvas->Pixels[i][j];
                Image1->Canvas->Brush->Color = PixelColour;
                Rectangle.left = i*SquareSize - TopLeftX * SquareSize;
                Rectangle.right = (i+1)*SquareSize  - TopLeftX * SquareSize;
                Rectangle.top = j*SquareSize - TopLeftY * SquareSize;
                Rectangle.bottom = (j+1)*SquareSize - TopLeftY * SquareSize;
                Image1->Canvas->FillRect(Rectangle);
                }
            }
        */
        //fast draw
        Rectangle.left = -TopLeftX * SquareSize;
        Rectangle.top = -TopLeftY * SquareSize;
        Rectangle.right = Rectangle.left + SquareSize * Picture->Width;
        Rectangle.bottom = Rectangle.top + SquareSize * Picture->Height;
        Image1->Canvas->StretchDraw(Rectangle,Picture);
        DrawStitches();
        }

    
}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::ZoomIn1Click(TObject *Sender)
{
    SquareSize++;
    DrawBitmap();
    SetScrollBars();
    wipedout = true;
    StatusBar1->Panels->Items[0]->Text = " Zoom = " + AnsiString(100 * SquareSize / Zoom1) + "%";
}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::ZoomOut1Click(TObject *Sender)
{
    SquareSize--;
    if (SquareSize < 1) SquareSize = 1;
    if (Image1->Width/SquareSize > (Picture->Width - TopLeftX)) {
        TopLeftX = Picture->Width - Image1->Width/SquareSize;
        }
    if (Image1->Width/SquareSize > Picture->Width || TopLeftX < 0) TopLeftX = 0;
    if (Image1->Height/SquareSize > (Picture->Height - TopLeftY)) {
        TopLeftY = Picture->Height - Image1->Height/SquareSize;
        }
    if (Image1->Height/SquareSize > Picture->Height || TopLeftY < 0) TopLeftY = 0;
    wipedout = true;
    DrawBitmap();
    SetScrollBars();
    StatusBar1->Panels->Items[0]->Text = " Zoom = " + AnsiString(100 * SquareSize / Zoom1) + "%";
}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::Image2Click(TObject *Sender)
{
    //want a square size of 5 and to set the scroll bars
    //SquareSize = 6;
    SquareSize = Zoom1 + 1;
    ZoomOut1Click(this);
}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::ScrollBar2Scroll(TObject *Sender,
      TScrollCode ScrollCode, int &ScrollPos)
{
    TopLeftX = ScrollBar2->Position;
    wipedout = true;
    DrawBitmap();
}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::SetScrollBars(void)
{
    int maxX = Image1->Picture->Bitmap->Width/SquareSize + TopLeftX;
    if ((maxX - TopLeftX) < Picture->Width && maxX < Picture->Width) {
        ScrollBar2->Enabled = true;
        ScrollBar2->Max = Picture->Width - 1 - maxX + TopLeftX;
        ScrollBar2->Min = 0;
        ScrollBar2->LargeChange = (Word)(Picture->Width/10);
        if (ScrollBar2->LargeChange > (Word)(maxX - TopLeftX)) {
            ScrollBar2->LargeChange = (Word)(maxX - TopLeftX);
            }
        } else {
        ScrollBar2->Enabled = false;
        TopLeftX = 0;
        }
    int maxY = Image1->Picture->Bitmap->Height/SquareSize + TopLeftY;
    if ((maxY - TopLeftY) < Picture->Height && maxY < Picture->Height) {
        ScrollBar1->Enabled = true;
        ScrollBar1->Max = Picture->Height - 1 - maxY + TopLeftY;
        ScrollBar1->Min = 0;
        ScrollBar1->LargeChange = (Word)(Picture->Height/10);
        if (ScrollBar1->LargeChange > (Word)(maxY - TopLeftY)) {
            ScrollBar1->LargeChange = (Word)(maxY - TopLeftY);
            }
        } else {
        ScrollBar1->Enabled = false;
        TopLeftY = 0;
        }

}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::ScrollBar1Scroll(TObject *Sender,
      TScrollCode ScrollCode, int &ScrollPos)
{
    TopLeftY = ScrollBar1->Position;
    wipedout = true;
    DrawBitmap();

}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::FormMouseWheelUp(TObject *Sender,
      TShiftState Shift, TPoint &MousePos, bool &Handled)
{
    if (ActiveControl != dynamic_cast<TControl *>(CurrentPallette) && ActiveControl != dynamic_cast<TControl *>(FullPallette)) {
        static int c = 0;
        c++;
        if (!(c%3)) {
            ZoomOut1Click(this);
            c = 0;
            }
        }


}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::FormMouseWheelDown(TObject *Sender,
      TShiftState Shift, TPoint &MousePos, bool &Handled)
{
    if (ActiveControl != dynamic_cast<TControl *>(CurrentPallette) && ActiveControl != dynamic_cast<TControl *>(FullPallette)) {
        static int d = 0;
        d++;
        if (!(d%3)) {
            ZoomIn1Click(this);
            d = 0;
            }
        }

}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::FullPalletteDblClick(TObject *Sender)
{
    //adds a new colour to the used colour list and selects the colour
    int pointer = 0;
    bool found = false;
    while (!found && pointer < FullPallette->Items->Count) {
        if (FullPallette->Selected[pointer]) {
            pointer--;
            found = true;
            }
        pointer++;
        }
    if (found) {
        //now to check if this one appears in the used list & get its pointer too;
        int pointer2 = 0;
        found = false;
        while (!found && pointer2 < UsedColourList.Length) {
            if (ColourList[pointer].DMCColourName == UsedColourList[pointer2].DMCColourName) {
                pointer2--;
                found = true;
                }
            pointer2++;
            }
        TColor PickedColour = ColourList[pointer].Colour;
        if (found) {
            //Select this colour
            SelectedColour = pointer2;
            } else {
            SelectedColour = UsedColourList.Length;
            UsedColourList.Length++;
            UsedColourList[UsedColourList.Length - 1].DMCColourName = ColourList[pointer].DMCColourName;
            UsedColourList[UsedColourList.Length - 1].Colour = ColourList[pointer].Colour;
            UsedColourList[UsedColourList.Length - 1].DrawWhite = ColourList[pointer].DrawWhite;
            UsedColourList[UsedColourList.Length - 1].StitchCount = ColourList[pointer].StitchCount;
            FillUsedColourList();
            }
        StatusBar1->Panels->Items[1]->Text = " Colour = " + UsedColourList[SelectedColour].DMCColourName;
        found = false;
        pointer = 0;
        while (!found && pointer < UsedColourList.Length) {
            if (PickedColour == UsedColourList[pointer].Colour) {
                pointer--;
                found = true;
                }
            pointer++;
            }
        if (found) {
            CurrentPallette->ItemIndex = pointer;
            CurrentPallette->TopIndex = pointer;
            }

        }

}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::CurrentPalletteDblClick(TObject *Sender)
{
    //selects the colour
    int pointer = 0;
    bool found = false;
    while (!found && pointer < CurrentPallette->Items->Count) {
        if (CurrentPallette->Selected[pointer]) {
            pointer--;
            found = true;
            }
        pointer++;
        }
    if (found) {
        SelectedColour = pointer;
        PrintSelectedColour();
        }
    TColor PickedColour = UsedColourList[pointer].Colour;
    found = false;
    pointer = 0;
    while (!found && pointer < ColourList.Length) {
        if (PickedColour == ColourList[pointer].Colour) {
            pointer--;
            found = true;
            }
        pointer++;
        }
    if (found) {
        FullPallette->ItemIndex = pointer;
        FullPallette->TopIndex = pointer;
        }


}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::Image1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
    float x,y;
    x = ((float) X)/ ((float) SquareSize) + (float)TopLeftX;
    y = ((float) Y)/ ((float) SquareSize) + (float)TopLeftY;
    StatusBar1->Panels->Items[2]->Text = " X = " + FloatToStrF(x,ffFixed,5,1);
    StatusBar1->Panels->Items[3]->Text = " Y = " + FloatToStrF(y,ffFixed,5,1);
    //now draw a rubber band if appropriate
    if (RubberBanding) {
        TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
        Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
        if (!wipedout /*&& RubberBandStartX != RubberBandIntermediateX && RubberBandStartY != RubberBandIntermediateY*/) {
            Image1->Picture->Bitmap->Canvas->MoveTo(((int)RubberBandStartX - TopLeftX)*SquareSize,((int)RubberBandStartY - TopLeftY)*SquareSize);
            //Image1->Picture->Bitmap->Canvas->LineTo(((int)RubberBandIntermediateX - TopLeftX)*SquareSize,((int)RubberBandIntermediateY - TopLeftY)*SquareSize);
            Image1->Picture->Bitmap->Canvas->LineTo(RBIX,RBIY);
            }
        RubberBandIntermediateX = (float)X/(float)SquareSize + (float)TopLeftX;
        RubberBandIntermediateY = (float)Y/(float)SquareSize + (float)TopLeftY;
        Image1->Picture->Bitmap->Canvas->MoveTo(((int)RubberBandStartX - TopLeftX)*SquareSize,((int)RubberBandStartY - TopLeftY)*SquareSize);
        Image1->Picture->Bitmap->Canvas->LineTo(X,Y);
        RBIX = X;
        RBIY = Y;
        Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
        }
}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::DrawStitches(void)
{
    //This method draws the backstitches on the image
    //OK. Set the scale of the line width
    //One thread is approx 1/6th of a cross stitch across at 14 count, so is about 0.3mm or 0.012"

    int linewidth = 1 + (int)(((double)SquareSize) * 0.012 * ((double) PictureXStitchCount));
    Image1->Picture->Bitmap->Canvas->Pen->Width = linewidth;

    for (int i = 0; i < BackStitchList.Length; i++) {
        Image1->Picture->Bitmap->Canvas->Pen->Color = UsedColourList[BackStitchList[i].ColourNumber].Colour;
        Image1->Picture->Bitmap->Canvas->MoveTo((int)(BackStitchList[i].X1*SquareSize - TopLeftX*SquareSize),(int)(BackStitchList[i].Y1*SquareSize - TopLeftY*SquareSize));
        Image1->Picture->Bitmap->Canvas->LineTo((int)(BackStitchList[i].X2*SquareSize - TopLeftX*SquareSize),(int)(BackStitchList[i].Y2*SquareSize - TopLeftY*SquareSize));
        }

}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::Undo1Click(TObject *Sender)
{
    //deletes the last stitch done. After adding stitches
    BackStitchList.Length = BackStitchList.Length - undostitchlength;
    undostitchlength = 1;
    DrawBitmap();
}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::ClearAll1Click(TObject *Sender)
{
    //deletes all stitches.
    BackStitchList.Length = 0;
    DrawBitmap();

}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::PrintSelectedColour(void)
{
    //updates the status bar with the selected colour
    StatusBar1->Panels->Items[1]->Text = " Colour = " + UsedColourList[SelectedColour].DMCColourName;

}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::Add1Click(TObject *Sender)
{
    //Add back stitches.
    DeletingStitches = false;
    PixelEditing = false;
    AddingStitches = !AddingStitches;
    if (AddingStitches) {
        StatusBar1->Panels->Items[4]->Text = " Click to Add Stitches";
        //now to redirect mouse clicks etc to the handling routines
        Image1->OnMouseUp = Image1StartRubberBand;
        Image1->OnMouseDown = NULL;
        Image1->OnDblClick = Add1Click;
        Undo1->OnClick = Undo1Click;
        Undo1->Caption = "&Undo Last Stitch";
        } else {
        //tell user that adding the backstitch has stopped
        StatusBar1->Panels->Items[4]->Text = " ";
        //Ends the redirect of the Image1 handling routines
        Image1->OnMouseUp = NULL;
        Image1->OnMouseDown = NULL;
        Image1->OnDblClick = NULL;
        //Stop rubber banding
        RubberBanding = false;
        //Draw picture
        DrawBitmap();
        }
}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::Image1StartRubberBand(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if (Button == mbLeft) {
        //Starts the Rubber Band for drawing a stitch
        RubberBanding = true;
        GetSnap(X,Y);
        RubberBandStartX = snapX;
        RubberBandStartY = snapY;
        wipedout = false;
        StatusBar1->Panels->Items[4]->Text = " Back Stitch started at X = " + AnsiString(snapX) + "  Y = " + AnsiString(snapY);
        //draws first rubber band line
        TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
        Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
        RubberBandIntermediateX = (float)X/(float)SquareSize + (float)TopLeftX;
        RubberBandIntermediateY = (float)Y/(float)SquareSize + (float)TopLeftY;
        Image1->Picture->Bitmap->Canvas->MoveTo(((int)RubberBandStartX - TopLeftX)*SquareSize,((int)RubberBandStartY - TopLeftY)*SquareSize);
        Image1->Picture->Bitmap->Canvas->LineTo(X,Y);
        RBIX = X;
        RBIY = Y;
        Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
        Image1->OnMouseUp = Image1ContinueRubberBand;
        }

}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::GetSnap(int X, int Y)
{
    //This converts X & Y into bitmap co-ords and rounds to the nearest 0.5, storing
    //the result in snapX and snapY.
    snapX = (floor(2.0 * ((float)X / (float) SquareSize + (float)TopLeftX + 0.25)))/2.0;
    snapY = (floor(2.0 * ((float)Y / (float) SquareSize + (float)TopLeftY + 0.25)))/2.0;

}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::GetSnapFloat(float X, float Y)
{
    //Rounds X & Y to the nearest 0.5, storing
    //the result in snapX and snapY.
    snapX = (floor(2.0 * (X + 0.25)))/2.0;
    snapY = (floor(2.0 * (Y + 0.25)))/2.0;

}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::Image1ContinueRubberBand(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if (Button == mbLeft) {
        //Continues the Rubber Band for drawing a stitch
        GetSnap(X,Y);
        //Finish this stitch
        //Check it's not of zero length
        if (RubberBandStartX != snapX || RubberBandStartY != snapY) {
            //right. Now work along the line from the start to the end
            //in up to 2 stitch length steps, snapping to the nearest snap point at each
            //step.
            double stitchlength;
            double lx, ly;
            //int length;
            lx = snapX - RubberBandStartX;
            ly = snapY - RubberBandStartY;
            stitchlength = sqrt(lx * lx + ly * ly) + 0.5 /*rounding factor to nearest integer*/;
            int steps = (int) (stitchlength/2.0);
            if (steps > 1) {
                //break down the stitch length
                float tempsnapx = snapX;
                float tempsnapy = snapY;
                float intersnapx = RubberBandStartX;
                float intersnapy = RubberBandStartY;
                //float lengthx;
                undostitchlength = 0;
                for (int i = 0; i < steps; i++) {
                    GetSnapFloat(((float)(i+1))*(lx)/((float)steps)+RubberBandStartX,((float)(i+1))*(ly)/((float)steps)+RubberBandStartY);
                    if (snapX != intersnapx || snapY != intersnapy) {
                        BackStitchList.Length++;
                        BackStitchList[BackStitchList.Length - 1].X1 = intersnapx;
                        BackStitchList[BackStitchList.Length - 1].Y1 = intersnapy;
                        BackStitchList[BackStitchList.Length - 1].X2 = snapX;
                        BackStitchList[BackStitchList.Length - 1].Y2 = snapY;
                        BackStitchList[BackStitchList.Length - 1].ColourNumber = SelectedColour;
                        BackStitchList[BackStitchList.Length - 1].Colour = UsedColourList[SelectedColour].Colour;
                        intersnapx = snapX;
                        intersnapy = snapY;
                        undostitchlength++;
                        }
                    }
                //reset end snap position
                snapX = tempsnapx;
                snapY = tempsnapy;
                } else {
                //should not get here unless the stitch is fairly short
                BackStitchList.Length++;
                BackStitchList[BackStitchList.Length - 1].X1 = RubberBandStartX;
                BackStitchList[BackStitchList.Length - 1].Y1 = RubberBandStartY;
                BackStitchList[BackStitchList.Length - 1].X2 = snapX;
                BackStitchList[BackStitchList.Length - 1].Y2 = snapY;
                BackStitchList[BackStitchList.Length - 1].ColourNumber = SelectedColour;
                BackStitchList[BackStitchList.Length - 1].Colour = UsedColourList[SelectedColour].Colour;
                undostitchlength = 1;
                }
            }
        //Finished creating the back stitches, now draw them
        DrawBitmap();
        //start new stitch
        RubberBandStartX = snapX;
        RubberBandStartY = snapY;
        //wipedout = true;
        wipedout = false;
        StatusBar1->Panels->Items[4]->Text = " Back Stitch started at X = " + AnsiString(snapX) + "  Y = " + AnsiString(snapY);
        //draws first rubber band line
        TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
        Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
        RubberBandIntermediateX = (float)X/(float)SquareSize + (float)TopLeftX;
        RubberBandIntermediateY = (float)Y/(float)SquareSize + (float)TopLeftY;
        Image1->Picture->Bitmap->Canvas->MoveTo(((int)RubberBandStartX - TopLeftX)*SquareSize,((int)RubberBandStartY - TopLeftY)*SquareSize);
        Image1->Picture->Bitmap->Canvas->LineTo(X,Y);
        RBIX = X;
        RBIY = Y;
        Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
        Image1->OnMouseUp = Image1ContinueRubberBand;
        }

}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::FormActivate(TObject *Sender)
{
    //to reverse the stop placed on drawing the picture before the form has
    //been created
    active = true;    
}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::FormDeactivate(TObject *Sender)
{
    //if the bitmap is drawn as the form is resized on destruction, an error
    //occurs. This stops it.
    active = false;    
}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::Delete1Click(TObject *Sender)
{
    //Deleting back stitches that are clicked on.
    DeletingStitches = !DeletingStitches;
    AddingStitches = false;
    PixelEditing = false;
    //Stop rubber banding
    if (RubberBanding) {
        RubberBanding = false;
        //Draw picture
        DrawBitmap();
        }
    if (DeletingStitches) {
        StatusBar1->Panels->Items[4]->Text = " Click on Stitch to Delete";
        //now to redirect mouse clicks etc to the handling routines
        Image1->OnMouseUp = NULL;
        Image1->OnMouseDown = DeleteStitchMouseUp;
        Image1->OnDblClick = Delete1Click;
        Undo1->OnClick = Undo1Click2;
        Undo1->Caption = "&Undo Last Stitch Deletion";
        } else {
        //tell user that deleting the backstitch has stopped
        StatusBar1->Panels->Items[4]->Text = " ";
        //Ends the redirect of the Image1 handling routines
        Image1->OnMouseUp = NULL;
        Image1->OnMouseDown = NULL;
        Image1->OnDblClick = NULL;
        }

}
//---------------------------------------------------------------------------


void __fastcall TBackStitchForm::DeleteStitchMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    //what to do when a stitch is deleted.
    /*
    First convert mouse position into stitch position
    Second, see if it's on, or within 0.25 stitches on either side of, the line from start to finish of the stitch.
    If so, delete stitch. Put stitch data into an undo variable ready to add it back.
    */
    if (DeletingStitches) {
        Screen->Cursor = crHourGlass;
        /*
        note, this uses a rather inefficient process as it checks each stitch
        to see if it's possible, so many which could not possibly be the one are
        checked. Basically it's the triumph of brute force and ignorance over finess.
        */
        float px = ((float) X)/ ((float)SquareSize) + (float) TopLeftX;
        float py = ((float) Y)/ ((float)SquareSize) + (float) TopLeftY;
        float tol = 0.5 * 0.5;
        float u, l, result;
        bool found = false;
        float mindist = tol;
        int pointer;
        float XS, XE, YE, YS, T;
        for (int i = 0; i < BackStitchList.Length; i++) {
            XS = BackStitchList[i].X1;
            YS = BackStitchList[i].Y1;
            XE = BackStitchList[i].X2;
            YE = BackStitchList[i].Y2;
            u = ((px - XS) * (YE - YS) - (py - YS) * (XE - XS)) * ((px - XS) * (YE - YS) - (py - YS) * (XE - XS));
            l = (XE - XS) * (XE - XS) + (YE - YS) * (YE - YS);
            T = ((XE - px) * (XE - XS) + (YE - py) * (YE - YS))/l;
            result = (float) fabs ((double)(u/l));
            if (result < tol && result < mindist && T > -0.25 && T < 1.25) {
                found = true;
                pointer = i;
                mindist = result;
                }
            }
        if (found) {
            //OK, found the stitch to be deleted, now deal with it.
            if (pointer < BackStitchList.Length) {
                if (BackStitchList.Length - pointer < undostitchlength) {
                    undostitchlength--;
                    }
                BackStitchRedo.Length++;
                BackStitchRedo[BackStitchRedo.Length - 1] = BackStitchList[pointer];
                for (int i = pointer; i < BackStitchList.Length - 1; i++) {
                    BackStitchList[i] = BackStitchList[i + 1];
                    }
                BackStitchList.Length--;
                DrawBitmap();
                }

            }
        Screen->Cursor = crDefault;
        }


}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::Undo1Click2(TObject *Sender)
{
    //undoes deletion of the last stitch deleted
    if (BackStitchRedo.Length) {
        Screen->Cursor = crHourGlass;
        BackStitchList.Length++;
        BackStitchList[BackStitchList.Length-1] = BackStitchRedo[BackStitchRedo.Length - 1];
        BackStitchRedo.Length--;
        DrawBitmap();
        Screen->Cursor = crDefault;
        }

}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::Edit1Click(TObject *Sender)
{
    Add1->Checked = AddingStitches;
    Delete1->Checked = DeletingStitches;
}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::PickColour1Click(TObject *Sender)
{
    //Allows user to select a stitch as the current colour
    Image1->Cursor = (TCursor) crDropperCursor;
    SpareControl->OnMouseDown = Image1->OnMouseDown;
    Image1->OnMouseDown = Image1PickColourMouseDown;
    SpareControl->OnMouseUp = Image1->OnMouseUp;
    Image1->OnMouseUp = NULL;

}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::Image1PickColourMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if (Button == mbLeft) {
        Image1->OnMouseDown = SpareControl->OnMouseDown;
        Image1->OnMouseUp = SpareControl->OnMouseUp;
        Image1->Cursor = (TCursor) crTargetCursor;
        //selects the colour based on the pixel found
        int pointer = 0;
        bool found = false;
        TColor PickedColour = Image1->Canvas->Pixels[X][Y];
        while (!found && pointer < UsedColourList.Length) {
            if (PickedColour == UsedColourList[pointer].Colour) {
                pointer--;
                found = true;
                }
            pointer++;
            }
        if (found) {
            SelectedColour = pointer;
            PrintSelectedColour();
            CurrentPallette->ItemIndex = pointer;
            CurrentPallette->TopIndex = pointer;
            }
        found = false;
        pointer = 0;
        while (!found && pointer < ColourList.Length) {
            if (PickedColour == ColourList[pointer].Colour) {
                pointer--;
                found = true;
                }
            pointer++;
            }
        if (found) {
            FullPallette->ItemIndex = pointer;
            FullPallette->TopIndex = pointer;
            }

        }

}
//---------------------------------------------------------------------------

void TBackStitchForm::SetPictureXStitchCount(int StitchCount)
{
    fPictureXStitchCount = StitchCount;
    Zoom1 = Screen->PixelsPerInch / StitchCount + 1;
    SquareSize = Zoom1;
    if (active) DrawBitmap();
}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::Zoom1001Click(TObject *Sender)
{
    SquareSize = Zoom1 + 1;
    //if (active) DrawBitmap();
    ZoomOut1Click(Sender);

}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::PixelEditor1Click(TObject *Sender)
{
    //Add back stitches.
    DeletingStitches = false;
    AddingStitches = false;
    PixelEditing = !PixelEditing;
    Image1->Cursor = (TCursor) crTargetCursor;
    RubberBanding = false;
    if (PixelEditing) {
        UndoPixelEdits->Clear();
        StatusBar1->Panels->Items[4]->Text = " Click to Change Pixel Colour to Current Colour";
        //now to redirect mouse clicks etc to the handling routines
        Image1->OnMouseUp = PixelEditMouseUp;
        Image1->OnMouseDown = NULL;
        Image1->OnDblClick = PixelEditor1Click;
        Undo1->OnClick = PixelEditUndo;
        Undo1->Caption = "&Undo Last Pixel Edits";
        } else {
        //tell user that adding the backstitch has stopped
        StatusBar1->Panels->Items[4]->Text = " ";
        //Ends the redirect of the Image1 handling routines
        Image1->OnMouseUp = NULL;
        Image1->OnMouseDown = NULL;
        Image1->OnDblClick = NULL;
        }

}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::PixelEditMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if (Button == mbLeft) {
        //Starts the Rubber Band for drawing a stitch
        GetSnap(X,Y);
        int pixelX = (int) snapX;
        int pixelY = (int) snapY;
        UndoPixelEdits->Add(AnsiString(pixelX) + "," + AnsiString(pixelY) + "," + AnsiString((int)Picture->Canvas->Pixels[pixelX][pixelY]) + ",");
        Picture->Canvas->Pixels[pixelX][pixelY] = UsedColourList[SelectedColour].Colour;
        imagechanged = true;
        if (active) DrawBitmap();
        }

}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::PixelEditUndo(TObject *Sender)
{
    //undoes the pixel edits
    AnsiString temp;
    int x,y,colour;
    for (int i = UndoPixelEdits->Count - 1; i > -1; i--) {
        temp = UndoPixelEdits->Strings[i];
        x = ExtractWord(temp,",").ToIntDef(0);
        temp = DeleteWord(temp,",");
        y = ExtractWord(temp,",").ToIntDef(0);
        temp = DeleteWord(temp,",");
        colour = ExtractWord(temp,",").ToIntDef(0);
        Picture->Canvas->Pixels[x][y] = (TColor) colour;
        if (active) DrawBitmap();
        }
    UndoPixelEdits->Clear();
}
//---------------------------------------------------------------------------

void __fastcall TBackStitchForm::Help2Click(TObject *Sender)
{
    //Application->HelpCommand(HELP_CONTENTS,0);
    AnsiString Address = ExtractFileDir(Application->ExeName) + "\\BackStitch.chm";
    AnsiString Location = "mk:@MSITStore:" + Address + "::/backstitch.html#start";
    ShellExecute(Application->Handle,"open",Location.c_str(),Location.c_str(),NULL,SW_SHOW);

}
//---------------------------------------------------------------------------

