//---------------------------------------------------------------------------
#ifndef BackstitcheditH
#define BackstitcheditH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ImgList.hpp>
#include <Menus.hpp>
#include <ExtCtrls.hpp>
#include <Graphics.hpp>
#include <ComCtrls.hpp>
#include "StitchStructures.h"
//---------------------------------------------------------------------------


class TBackStitchForm : public TForm
{
__published:	// IDE-managed Components
    TMainMenu *MainMenu2;
    TMenuItem *File1;
    TMenuItem *Cancel1;
    TMenuItem *N1;
    TMenuItem *Accept1;
    TMenuItem *Edit1;
    TMenuItem *Undo1;
    TMenuItem *N2;
    TMenuItem *ClearAll1;
    TMenuItem *View1;
    TMenuItem *ZoomIn1;
    TMenuItem *ZoomOut1;
    TMenuItem *Add1;
    TMenuItem *Delete1;
    TMenuItem *N3;
    TImageList *ImageList1;
    TPanel *Panel1;
    TListBox *CurrentPallette;
    TListBox *FullPallette;
    TPanel *Panel2;
    TPanel *Panel3;
    TScrollBar *ScrollBar1;
    TScrollBar *ScrollBar2;
    TImage *Image1;
    TImage *Image2;
    TStatusBar *StatusBar1;
    TMenuItem *N4;
    TMenuItem *PickColour1;
    TMenuItem *N5;
    TMenuItem *Zoom1001;
    TMenuItem *N6;
    TMenuItem *PixelEditor1;
    TMenuItem *Help1;
    TMenuItem *Help2;
    void __fastcall Cancel1Click(TObject *Sender);
    void __fastcall Accept1Click(TObject *Sender);
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall FormResize(TObject *Sender);
    void __fastcall FullPalletteDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
    void __fastcall CurrentPalletteDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
    void __fastcall FormDestroy(TObject *Sender);
    void __fastcall ZoomIn1Click(TObject *Sender);
    void __fastcall ZoomOut1Click(TObject *Sender);
    void __fastcall Image2Click(TObject *Sender);
    void __fastcall ScrollBar2Scroll(TObject *Sender,
          TScrollCode ScrollCode, int &ScrollPos);
    void __fastcall ScrollBar1Scroll(TObject *Sender,
          TScrollCode ScrollCode, int &ScrollPos);
    void __fastcall FormMouseWheelUp(TObject *Sender, TShiftState Shift,
          TPoint &MousePos, bool &Handled);
    void __fastcall FormMouseWheelDown(TObject *Sender, TShiftState Shift,
          TPoint &MousePos, bool &Handled);
    void __fastcall FullPalletteDblClick(TObject *Sender);
    void __fastcall CurrentPalletteDblClick(TObject *Sender);
    void __fastcall Image1MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
    void __fastcall Undo1Click(TObject *Sender);
    void __fastcall ClearAll1Click(TObject *Sender);
    void __fastcall Add1Click(TObject *Sender);
    void __fastcall Image1StartRubberBand(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall Image1ContinueRubberBand(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
    void __fastcall FormActivate(TObject *Sender);
    void __fastcall FormDeactivate(TObject *Sender);
    void __fastcall Delete1Click(TObject *Sender);
    void __fastcall DeleteStitchMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall Undo1Click2(TObject *Sender);
    void __fastcall Edit1Click(TObject *Sender);
    void __fastcall PickColour1Click(TObject *Sender);
    void __fastcall Zoom1001Click(TObject *Sender);
    void __fastcall PixelEditor1Click(TObject *Sender);
    void __fastcall Help2Click(TObject *Sender);
private:	// User declarations
    int TopLeftX;
    int TopLeftY;
    int SquareSize;
    int SelectedColour;
    bool AddingStitches;
    bool DeletingStitches;
    bool RubberBanding;
    bool PixelEditing;
    void __fastcall SetScrollBars(void);
    void __fastcall DrawStitches(void);
    float RubberBandStartX;
    float RubberBandStartY;
    float RubberBandIntermediateX;
    float RubberBandIntermediateY;
    int RBIX;
    int RBIY;
    float snapX;
    float snapY;
    bool wipedout;
    bool active;
    void __fastcall GetSnap(int X, int Y);
    void __fastcall GetSnapFloat(float X, float Y);
    int undostitchlength;
    DynamicArray <BackStitchData> BackStitchRedo;
    int crTargetCursor;
    int crDropperCursor;
    TImage *SpareControl;
    void __fastcall Image1PickColourMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y);
    int fPictureXStitchCount;
    void SetPictureXStitchCount(int StitchCount);
    TStringList *UndoPixelEdits;
    void __fastcall PixelEditMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y);
    void __fastcall PixelEditUndo(TObject *Sender);
public:		// User declarations
    __fastcall TBackStitchForm(TComponent* Owner);

    DynamicArray <ColourData> ColourList;
    DynamicArray <ColourData> UsedColourList;
    DynamicArray <BackStitchData> BackStitchList;
    Graphics::TBitmap *Picture;
    int Zoom1;
    __property int PictureXStitchCount = {read = fPictureXStitchCount, write = SetPictureXStitchCount};
    bool imagechanged;

    void __fastcall FillColourList(void);
    void __fastcall FillUsedColourList(void);
    void __fastcall DrawBitmap(void);
    void __fastcall PrintSelectedColour(void);

};
//---------------------------------------------------------------------------
extern PACKAGE TBackStitchForm *BackStitchForm;
//---------------------------------------------------------------------------
#endif
