//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "CropChartImage.h"
#include <clipbrd.hpp>
#include <shellapi.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TCropChartImageForm *CropChartImageForm;
//---------------------------------------------------------------------------
__fastcall TCropChartImageForm::TCropChartImageForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TCropChartImageForm::FormCreate(TObject *Sender)
{
    OriginalBitmap = new Graphics::TBitmap();
    //ModifiedBitmap = new Graphics::TBitmap();
    changed = false;
    TopLeftCorner.X = 0;
    TopLeftCorner.Y = 0;
    BottomRightCorner.X = 0;
    BottomRightCorner.Y = 0;
    dragging = false;
    Application->OnHint = DisplayHint;

}
//---------------------------------------------------------------------------
void __fastcall TCropChartImageForm::FormDestroy(TObject *Sender)
{
    delete OriginalBitmap;
    //delete ModifiedBitmap;
    Application->OnHint = NULL;

}
//---------------------------------------------------------------------------

void __fastcall TCropChartImageForm::ImageResize(void)
{
    Image2->Top = Image1->Top + Image1->Height + 24;
    Label2->Top = Image2->Top - 16;
}
//---------------------------------------------------------------------------

void __fastcall TCropChartImageForm::Initialise(void)
{
    Image1->Width = OriginalBitmap->Width;
    Image1->Height = OriginalBitmap->Height;
    Image1->Picture->Bitmap->Width = OriginalBitmap->Width;
    Image1->Picture->Bitmap->Height = OriginalBitmap->Height;
    Image2->Width = OriginalBitmap->Width;
    Image2->Height = OriginalBitmap->Height;
    Image2->Picture->Bitmap->Width = OriginalBitmap->Width;
    Image2->Picture->Bitmap->Height = OriginalBitmap->Height;
    ImageResize();
    BottomRightCorner.X = OriginalBitmap->Width;
    BottomRightCorner.Y = OriginalBitmap->Height;
    DrawBitmaps();
    ShowRectangle();
    ShowMousePosition(-1,-1);
}
//---------------------------------------------------------------------------

void __fastcall TCropChartImageForm::DrawBitmaps(void)
{
    DrawOriginalBitmap();
    DrawModifiedBitmap();
}
//---------------------------------------------------------------------------

void __fastcall TCropChartImageForm::DrawOriginalBitmap(void)
{
    //draws the visible section of the original bitmap in Image 1
    TRect Rectangle;
    //clear image
    Image1->Picture->Bitmap->Assign(OriginalBitmap);
    //draw new image
    Rectangle.Left = TopLeftCorner.X;
    Rectangle.Top = TopLeftCorner.Y;
    Rectangle.Right = BottomRightCorner.X;
    Rectangle.Bottom = BottomRightCorner.Y;
    if (Rectangle.Left > Rectangle.Right) {
        int swap = Rectangle.Left;
        Rectangle.Left = Rectangle.Right;
        Rectangle.Right = swap;
        }
    if (Rectangle.Top > Rectangle.Bottom) {
        int swap = Rectangle.Top;
        Rectangle.Top = Rectangle.Bottom;
        Rectangle.Bottom = swap;
        }
    Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
    wipedout = false;


}
//---------------------------------------------------------------------------

void __fastcall TCropChartImageForm::DrawModifiedBitmap(void)
{
    //draws the cropped section of the modifiedl bitmap in Image 2
    TRect Rectangle;
    //draw new image
    Rectangle.Left = TopLeftCorner.X;
    Rectangle.Top = TopLeftCorner.Y;
    Rectangle.Right = BottomRightCorner.X;
    Rectangle.Bottom = BottomRightCorner.Y;
    if (Rectangle.Left > Rectangle.Right) {
        int swap = Rectangle.Left;
        Rectangle.Left = Rectangle.Right;
        Rectangle.Right = swap;
        }
    if (Rectangle.Top > Rectangle.Bottom) {
        int swap = Rectangle.Top;
        Rectangle.Top = Rectangle.Bottom;
        Rectangle.Bottom = swap;
        }
    Image2->Picture->Bitmap->Width = BottomRightCorner.X - TopLeftCorner.X;
    Image2->Picture->Bitmap->Height = BottomRightCorner.Y - TopLeftCorner.Y;
    TRect RectangleDest;
    RectangleDest.Left = 0;
    RectangleDest.Top = 0;
    RectangleDest.Right = Image2->Picture->Bitmap->Width;
    RectangleDest.Bottom = Image2->Picture->Bitmap->Height;

    Image2->Picture->Bitmap->Canvas->CopyRect(RectangleDest,OriginalBitmap->Canvas,Rectangle);
    if (Image2->Picture->Bitmap->Width != OriginalBitmap->Width || Image2->Picture->Bitmap->Height != OriginalBitmap->Height) {
        changed = true;
        } else {
        changed = false;
        }

}
//---------------------------------------------------------------------------
void __fastcall TCropChartImageForm::OKButtonClick(TObject *Sender)
{
    ModalResult = mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TCropChartImageForm::Image1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if (Button == mbLeft) {
        dragging = true;
        TRect Rectangle;
        if (!wipedout) {
            Rectangle.Left = TopLeftCorner.X;
            Rectangle.Top = TopLeftCorner.Y;
            Rectangle.Right = BottomRightCorner.X;
            Rectangle.Bottom = BottomRightCorner.Y;
            Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
            }
        wipedout = true;
        TopLeftCorner.X = X;
        TopLeftCorner.Y = Y;
        OriginalClickedPoisition = TopLeftCorner;
        }
}
//---------------------------------------------------------------------------
void __fastcall TCropChartImageForm::Image1MouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if (Button == mbLeft) {
        dragging = false;
        if (OriginalClickedPoisition.X <= X) {
            BottomRightCorner.X = X;
            } else {
            TopLeftCorner.X = X;
            }
        if (OriginalClickedPoisition.Y <= Y) {
            BottomRightCorner.Y = Y;
            } else {
            TopLeftCorner.Y = Y;
            }
        DrawBitmaps();
        }
}
//---------------------------------------------------------------------------
void __fastcall TCropChartImageForm::Image1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
    if (dragging) {
        TRect Rectangle;
        if (!wipedout) {
            Rectangle.Left = TopLeftCorner.X;
            Rectangle.Top = TopLeftCorner.Y;
            Rectangle.Right = BottomRightCorner.X;
            Rectangle.Bottom = BottomRightCorner.Y;
            Image1->Canvas->DrawFocusRect(Rectangle);
            }
        if (OriginalClickedPoisition.X <= X) {
            BottomRightCorner.X = X;
            } else {
            TopLeftCorner.X = X;
            }
        if (OriginalClickedPoisition.Y <= Y) {
            BottomRightCorner.Y = Y;
            } else {
            TopLeftCorner.Y = Y;
            }
        Rectangle.Left = TopLeftCorner.X;
        Rectangle.Top = TopLeftCorner.Y;
        Rectangle.Right = BottomRightCorner.X;
        Rectangle.Bottom = BottomRightCorner.Y;
        Image1->Canvas->DrawFocusRect(Rectangle);
        wipedout = false;
        ShowRectangle();
        }
    ShowMousePosition(X,Y);
}
//---------------------------------------------------------------------------

void __fastcall TCropChartImageForm::DisplayHint(TObject *Sender)
{
    StatusBar1->Panels->Items[3]->Text = " " + GetLongHint(Application->Hint);

}
//---------------------------------------------------------------------------

void __fastcall TCropChartImageForm::ShowRectangle(void)
{
    StatusBar1->Panels->Items[0]->Text = " " + AnsiString(TopLeftCorner.X) + "," + AnsiString(TopLeftCorner.Y) + "->" + AnsiString(BottomRightCorner.X) + "," + AnsiString(BottomRightCorner.Y);

}
//---------------------------------------------------------------------------

void __fastcall TCropChartImageForm::ShowMousePosition(int X, int Y)
{
    if (X > -1) {
        StatusBar1->Panels->Items[1]->Text = " X = " + AnsiString(X);
        } else {
        StatusBar1->Panels->Items[1]->Text = " X = ---";
        }
    if (Y > -1) {
        StatusBar1->Panels->Items[2]->Text = " Y = " + AnsiString(Y);
        } else {
        StatusBar1->Panels->Items[2]->Text = " Y = ---";
        }

}
//---------------------------------------------------------------------------
void __fastcall TCropChartImageForm::FormMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
    ShowMousePosition(-1,-1);
}
//---------------------------------------------------------------------------
void __fastcall TCropChartImageForm::CopytoClipboard1Click(TObject *Sender)
{
  unsigned int DataHandle = 0;
    HPALETTE APalette;
    unsigned short MyFormat = CF_BITMAP;
    Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
    try {
        // generate a clipboard format, with data and palette
        // save the data to the clipboard using that format and
        // the generated data
        //The use of an intervening bitmap allows the background to be either transparent or solid.
        //If the Image1->Picture->Bitmap is saved straight to clipboard, then the transparency info is
        //lost.
        Bitmap->Width = Image1->Width;
        Bitmap->Height = Image1->Height;
        Bitmap->Canvas->Draw(0,0,Image1->Picture->Bitmap);
        Bitmap->SaveToClipboardFormat(MyFormat,DataHandle,APalette);
        Clipboard()->SetAsHandle(CF_BITMAP,DataHandle);
        }

    catch (...) {
        ShowMessage("Sorry, Failed to copy image to clipboard.");
        }

    delete Bitmap;
    
}
//---------------------------------------------------------------------------

void __fastcall TCropChartImageForm::CopytoClipboard2Click(TObject *Sender)
{
  unsigned int DataHandle = 0;
    HPALETTE APalette;
    unsigned short MyFormat = CF_BITMAP;
    Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
    try {
        // generate a clipboard format, with data and palette
        // save the data to the clipboard using that format and
        // the generated data
        //The use of an intervening bitmap allows the background to be either transparent or solid.
        //If the Image1->Picture->Bitmap is saved straight to clipboard, then the transparency info is
        //lost.
        Bitmap->Width = Image2->Width;
        Bitmap->Height = Image2->Height;
        Bitmap->Canvas->Draw(0,0,Image2->Picture->Bitmap);
        Bitmap->SaveToClipboardFormat(MyFormat,DataHandle,APalette);
        Clipboard()->SetAsHandle(CF_BITMAP,DataHandle);
        }

    catch (...) {
        ShowMessage("Sorry, Failed to copy image to clipboard.");
        }

    delete Bitmap;

}
//---------------------------------------------------------------------------

void __fastcall TCropChartImageForm::HelpButtonClick(TObject *Sender)
{
    AnsiString Address = ExtractFileDir(Application->ExeName) + "\\BackStitch.chm";
    AnsiString Location = "mk:@MSITStore:" + Address + "::/cropimage.html#start";
    ShellExecute(Application->Handle,"open",Location.c_str(),Location.c_str(),NULL,SW_SHOW);

}
//---------------------------------------------------------------------------

