//---------------------------------------------------------------------------
#ifndef CropChartImageH
#define CropChartImageH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include "StitchStructures.h"
#include <ComCtrls.hpp>
#include <Menus.hpp>
#include <ImgList.hpp>
//---------------------------------------------------------------------------
class TCropChartImageForm : public TForm
{
__published:	// IDE-managed Components
    TPanel *Panel1;
    TImage *Image1;
    TImage *Image2;
    TLabel *Label1;
    TLabel *Label2;
    TButton *OKButton;
    TStatusBar *StatusBar1;
    TButton *CancelButton;
    TPopupMenu *PopupMenu1;
    TMenuItem *CopytoClipboard1;
    TPopupMenu *PopupMenu2;
    TMenuItem *CopytoClipboard2;
    TImageList *ImageList1;
    TButton *HelpButton;
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall FormDestroy(TObject *Sender);
    void __fastcall OKButtonClick(TObject *Sender);
    void __fastcall Image1MouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall Image1MouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall Image1MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
    void __fastcall FormMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
    void __fastcall CopytoClipboard1Click(TObject *Sender);
    void __fastcall CopytoClipboard2Click(TObject *Sender);
    void __fastcall HelpButtonClick(TObject *Sender);
private:	// User declarations
    void __fastcall ImageResize(void);
    void __fastcall DrawBitmaps(void);
    void __fastcall DrawOriginalBitmap(void);
    void __fastcall DrawModifiedBitmap(void);
    void __fastcall DisplayHint(TObject *Sender);
    void __fastcall ShowRectangle(void);
    void __fastcall ShowMousePosition(int X, int Y);
    chartposition BottomRightCorner;
    chartposition OriginalClickedPoisition;
    bool dragging;
    bool wipedout;
public:		// User declarations
    bool changed;
    Graphics::TBitmap *OriginalBitmap;
    //Graphics::TBitmap *ModifiedBitmap;
    chartposition TopLeftCorner;
    void __fastcall Initialise(void);


    __fastcall TCropChartImageForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TCropChartImageForm *CropChartImageForm;
//---------------------------------------------------------------------------
#endif
