//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "DefaultSettings.h"
#include <IniFiles.hpp>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TDefaultSettingsForm *DefaultSettingsForm;
//---------------------------------------------------------------------------
__fastcall TDefaultSettingsForm::TDefaultSettingsForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TDefaultSettingsForm::FormCreate(TObject *Sender)
{

    //fill font name lists
    for (int i = 0; i < Screen->Fonts->Count; i++) {
        TitleFont->Items->Add(Screen->Fonts->Strings[i]);
        ImageFont->Items->Add(Screen->Fonts->Strings[i]);
        ChartCopyright->Items->Add(Screen->Fonts->Strings[i]);
        ChartFont->Items->Add(Screen->Fonts->Strings[i]);
        }

    //opens the .ini file
    TIniFile *IniFile = new TIniFile(ChangeFileExt(Application->ExeName, ".ini"));
    ThreadSortMethod->ItemIndex = ThreadSortMethod->Items->IndexOf(IniFile->ReadString("ChartSettings","SortMethod","Stitch Count"));
    StitchCount->ItemIndex = StitchCount->Items->IndexOf(IniFile->ReadString("ChartSettings","StitchCount","14"));
    PlanCount->ItemIndex = PlanCount->Items->IndexOf(IniFile->ReadString("ChartSettings","PlanCount","10"));
    ShowBackground->Checked = IniFile->ReadBool("ChartSettings","ShowBackground",false);
    SimpleKey->Checked = IniFile->ReadBool("ChartSettings","SimpleKey",true);

    //Print Settings
    FrontSheet->Checked = IniFile->ReadBool("PrintSettings","FrontSheet",true);
    ContentsPage->Checked = IniFile->ReadBool("PrintSettings","ContentsPage",true);
    ColourChart->Checked = IniFile->ReadBool("PrintSettings","ColourChart",true);
    MonochromeChart->Checked = IniFile->ReadBool("PrintSettings","MonochromeChart",true);
    BackStitches->Checked = IniFile->ReadBool("PrintSettings","BackStitches",true);
    DetailedKey->Checked = IniFile->ReadBool("PrintSettings","DetailedKey",true);
    StitchInfo->Checked = IniFile->ReadBool("PrintSettings","StitchInfo",true);
    FabricDetails->Checked = IniFile->ReadBool("PrintSettings","FabricDetails",true);
    XRefImage->Checked = IniFile->ReadBool("PrintSettings","XRefImage",true);

    //font settings
    TitleFont->ItemIndex = TitleFont->Items->IndexOf(IniFile->ReadString("PrintSettings","TitleFont","Arial"));
    TitleSize->ItemIndex = TitleSize->Items->IndexOf(IniFile->ReadString("PrintSettings","TitleSize","20"));
    ImageFont->ItemIndex = ImageFont->Items->IndexOf(IniFile->ReadString("PrintSettings","ImageFont","Arial"));
    ImageFontSize->ItemIndex = ImageFontSize->Items->IndexOf(IniFile->ReadString("PrintSettings","ImageFontSize","12"));
    ChartCopyright->ItemIndex = ChartCopyright->Items->IndexOf(IniFile->ReadString("PrintSettings","ChartCopyright","Arial"));
    ChartCopyrightFontSize->ItemIndex = ChartCopyrightFontSize->Items->IndexOf(IniFile->ReadString("PrintSettings","ChartCopyrightFontSize","12"));
    ChartFont->ItemIndex = ChartFont->Items->IndexOf(IniFile->ReadString("PrintSettings","ChartFont","Arial"));
    ChartFontSize->ItemIndex = ChartFontSize->Items->IndexOf(IniFile->ReadString("PrintSettings","ChartFontSize","8"));

    XRefImage->Enabled = ContentsPage->Checked;

    delete IniFile;

}
//---------------------------------------------------------------------------

void __fastcall TDefaultSettingsForm::ContentsPageClick(TObject *Sender)
{
    XRefImage->Enabled = ContentsPage->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TDefaultSettingsForm::ResetButtonClick(TObject *Sender)
{
    ThreadSortMethod->ItemIndex = ThreadSortMethod->Items->IndexOf("Stitch Count");
    StitchCount->ItemIndex = StitchCount->Items->IndexOf("14");
    PlanCount->ItemIndex = PlanCount->Items->IndexOf("10");
    ShowBackground->Checked = false;
    SimpleKey->Checked = true;

    //Print Settings
    FrontSheet->Checked = true;
    ContentsPage->Checked = true;
    ColourChart->Checked = true;
    MonochromeChart->Checked = true;
    BackStitches->Checked = true;
    DetailedKey->Checked = true;
    StitchInfo->Checked = true;
    FabricDetails->Checked = true;
    XRefImage->Checked = true;

    //font settings
    TitleFont->ItemIndex = TitleFont->Items->IndexOf("Arial");
    TitleSize->ItemIndex = TitleSize->Items->IndexOf("20");
    ImageFont->ItemIndex = ImageFont->Items->IndexOf("Arial");
    ImageFontSize->ItemIndex = ImageFontSize->Items->IndexOf("12");
    ChartCopyright->ItemIndex = ChartCopyright->Items->IndexOf("Arial");
    ChartCopyrightFontSize->ItemIndex = ChartCopyrightFontSize->Items->IndexOf("12");
    ChartFont->ItemIndex = ChartFont->Items->IndexOf("Arial");
    ChartFontSize->ItemIndex = ChartFontSize->Items->IndexOf("8");

    XRefImage->Enabled = ContentsPage->Checked;

}
//---------------------------------------------------------------------------

void __fastcall TDefaultSettingsForm::OKButtonClick(TObject *Sender)
{
    //opens the .ini file
    TIniFile *IniFile = new TIniFile(ChangeFileExt(Application->ExeName, ".ini"));

    IniFile->WriteString("ChartSettings","SortMethod",ThreadSortMethod->Items->Strings[ThreadSortMethod->ItemIndex]);
    IniFile->WriteString("ChartSettings","StitchCount",StitchCount->Items->Strings[StitchCount->ItemIndex]);
    IniFile->WriteString("ChartSettings","PlanCount",PlanCount->Items->Strings[PlanCount->ItemIndex]);
    IniFile->WriteBool("ChartSettings","ShowBackground",ShowBackground->Checked);
    IniFile->WriteBool("ChartSettings","SimpleKey",SimpleKey->Checked);

    //Print Settings
    IniFile->WriteBool("PrintSettings","FrontSheet",FrontSheet->Checked);
    IniFile->WriteBool("PrintSettings","ContentsPage",ContentsPage->Checked);
    IniFile->WriteBool("PrintSettings","ColourChart",ColourChart->Checked);
    IniFile->WriteBool("PrintSettings","MonochromeChart",MonochromeChart->Checked);
    IniFile->WriteBool("PrintSettings","BackStitches",BackStitches->Checked);
    IniFile->WriteBool("PrintSettings","DetailedKey",DetailedKey->Checked);
    IniFile->WriteBool("PrintSettings","StitchInfo",StitchInfo->Checked);
    IniFile->WriteBool("PrintSettings","FabricDetails",FabricDetails->Checked);
    IniFile->WriteBool("PrintSettings","XRefImage",XRefImage->Checked);

    //font settings
    IniFile->WriteString("PrintSettings","TitleFont",TitleFont->Items->Strings[TitleFont->ItemIndex]);
    IniFile->WriteString("PrintSettings","TitleSize",TitleSize->Items->Strings[TitleSize->ItemIndex]);
    IniFile->WriteString("PrintSettings","ImageFont",ImageFont->Items->Strings[ImageFont->ItemIndex]);
    IniFile->WriteString("PrintSettings","ImageFontSize",ImageFontSize->Items->Strings[ImageFontSize->ItemIndex]);
    IniFile->WriteString("PrintSettings","ChartCopyright",ChartCopyright->Items->Strings[ChartCopyright->ItemIndex]);
    IniFile->WriteString("PrintSettings","ChartCopyrightFontSize",ChartCopyrightFontSize->Items->Strings[ChartCopyrightFontSize->ItemIndex]);
    IniFile->WriteString("PrintSettings","ChartFont",ChartFont->Items->Strings[ChartFont->ItemIndex]);
    IniFile->WriteString("PrintSettings","ChartFontSize",ChartFontSize->Items->Strings[ChartFontSize->ItemIndex]);


    delete IniFile;

    ModalResult = mrOk;
}
//---------------------------------------------------------------------------

