//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "DefinePrintout.h"
#include "PrintPreview.h"
#include "StitchForm.h"
#include <Printers.hpp>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TDefinePrintoutForm *DefinePrintoutForm;
//---------------------------------------------------------------------------
__fastcall TDefinePrintoutForm::TDefinePrintoutForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TDefinePrintoutForm::FrontSheetClick(TObject *Sender)
{
    Title->Enabled = FrontSheet->Checked;
    TitleFont->Enabled = FrontSheet->Checked;
    TitleSize->Enabled = FrontSheet->Checked;
    ImageCopyright->Enabled = FrontSheet->Checked;
    ImageCopyrightFont->Enabled = FrontSheet->Checked;
    ImageCopyrightSize->Enabled = FrontSheet->Checked;
    ChartCopyright->Enabled = FrontSheet->Checked;
    ChartCopyrightFont->Enabled = FrontSheet->Checked;
    ChartCopyrightSize->Enabled = FrontSheet->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TDefinePrintoutForm::FormCreate(TObject *Sender)
{
    //fill the font boxes
    for (int i = 0; i < Screen->Fonts->Count; i++) {
        TitleFont->Items->Add(Screen->Fonts->Strings[i]);
        ImageCopyrightFont->Items->Add(Screen->Fonts->Strings[i]);
        ChartCopyrightFont->Items->Add(Screen->Fonts->Strings[i]);
        ChartFont->Items->Add(Screen->Fonts->Strings[i]);
        }
    //setup default Chart Printout settings
    ChartPrintout.FrontSheet = true;
    ChartPrintout.IndexPage = true;
    ChartPrintout.ColourChart = true;
    ChartPrintout.MonochromeChart = true;
    ChartPrintout.DetailedKey = true;
    ChartPrintout.BackStitches = true;
    ChartPrintout.StitchesPerPage = true;
    ChartPrintout.FabricDetails = true;
    ChartPrintout.ChartPageXRef = true;
    ChartPrintout.TitleSize = 20;
    ChartPrintout.ImageCopyrightSize = 12;
    ChartPrintout.ChartCopyrightSize = 12;
    ChartPrintout.TitleFont = "Arial";
    ChartPrintout.ImageCopyrightFont = "Arial";
    ChartPrintout.ChartCopyrightFont = "Arial";
    ChartPrintout.ChartFont = "Arial";
    ChartPrintout.ChartFontSize = 8;
    ChartPrintout.Title = "This Chart";
    ChartPrintout.ImageCopyright = "Image  The Artist";
    ChartPrintout.ChartCopyright = "Chart  The Author";
    Accept = false;

}
//---------------------------------------------------------------------------

void __fastcall TDefinePrintoutForm::Initialise(void)
{
    FrontSheet->Checked = ChartPrintout.FrontSheet;
    IndexPage->Checked = ChartPrintout.IndexPage;
    ColourChart->Checked = ChartPrintout.ColourChart;
    MonochromeChart->Checked = ChartPrintout.MonochromeChart;
    DetailedKey->Checked = ChartPrintout.DetailedKey;
    BackStitches->Checked = ChartPrintout.BackStitches;
    StitchesPerPage->Checked = ChartPrintout.StitchesPerPage;
    FabricDetails->Checked = ChartPrintout.FabricDetails;
    ChartPageXRef->Checked = ChartPrintout.ChartPageXRef;
    TitleSize->ItemIndex = TitleSize->Items->IndexOf(AnsiString(ChartPrintout.TitleSize));
    ImageCopyrightSize->ItemIndex = ImageCopyrightSize->Items->IndexOf(AnsiString(ChartPrintout.ImageCopyrightSize));
    ChartCopyrightSize->ItemIndex = ChartCopyrightSize->Items->IndexOf(AnsiString(ChartPrintout.ChartCopyrightSize));
    TitleFont->ItemIndex = TitleFont->Items->IndexOf(ChartPrintout.TitleFont);
    ImageCopyrightFont->ItemIndex = ImageCopyrightFont->Items->IndexOf(ChartPrintout.ImageCopyrightFont);
    ChartCopyrightFont->ItemIndex = ChartCopyrightFont->Items->IndexOf(ChartPrintout.ChartCopyrightFont);
    ChartFont->ItemIndex = ChartFont->Items->IndexOf(ChartPrintout.ChartFont);
    ChartFontSize->ItemIndex = ChartFontSize->Items->IndexOf(AnsiString(ChartPrintout.ChartFontSize));
    Title->Text = ChartPrintout.Title;
    ImageCopyright->Text = ChartPrintout.ImageCopyright;
    ChartCopyright->Text = ChartPrintout.ChartCopyright;
    FrontSheetClick(this);
    IndexPageClick(this);
}
//---------------------------------------------------------------------------

printout __fastcall TDefinePrintoutForm::RetrieveData(void)
{
    ChartPrintout.FrontSheet = FrontSheet->Checked;
    ChartPrintout.IndexPage = IndexPage->Checked;
    ChartPrintout.ColourChart = ColourChart->Checked;
    ChartPrintout.MonochromeChart = MonochromeChart->Checked;
    ChartPrintout.DetailedKey = DetailedKey->Checked;
    ChartPrintout.BackStitches = BackStitches->Checked;
    ChartPrintout.StitchesPerPage = StitchesPerPage->Checked;
    ChartPrintout.FabricDetails = FabricDetails->Checked;
    ChartPrintout.ChartPageXRef = ChartPageXRef->Checked;
    ChartPrintout.TitleSize = TitleSize->Items->Strings[TitleSize->ItemIndex].ToIntDef(20);
    ChartPrintout.ImageCopyrightSize = ImageCopyrightSize->Items->Strings[ImageCopyrightSize->ItemIndex].ToIntDef(12);
    ChartPrintout.ChartCopyrightSize = ChartCopyrightSize->Items->Strings[ChartCopyrightSize->ItemIndex].ToIntDef(12);
    ChartPrintout.TitleFont = TitleFont->Items->Strings[TitleFont->ItemIndex];
    ChartPrintout.ImageCopyrightFont = ImageCopyrightFont->Items->Strings[ImageCopyrightFont->ItemIndex];
    ChartPrintout.ChartCopyrightFont = ChartCopyrightFont->Items->Strings[ChartCopyrightFont->ItemIndex];
    ChartPrintout.ChartFont = ChartFont->Items->Strings[ChartFont->ItemIndex];
    ChartPrintout.ChartFontSize = ChartFontSize->Items->Strings[ChartFontSize->ItemIndex].ToIntDef(8);
    ChartPrintout.Title = Title->Text;
    ChartPrintout.ImageCopyright = ImageCopyright->Text;
    ChartPrintout.ChartCopyright = ChartCopyright->Text;


    return ChartPrintout;
}
//---------------------------------------------------------------------------


void __fastcall TDefinePrintoutForm::IndexPageClick(TObject *Sender)
{
    ChartPageXRef->Enabled = IndexPage->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TDefinePrintoutForm::PrintPreviewButtonClick(
      TObject *Sender)
{
    //this is a real leap in the dark for me, to do a print preview.

    //It will take a method in one form, and use that method to print to a third form

    if (dynamic_cast<TPlanForm *>(Owner)) {
        //set up the pages
        //pageinfo PageInfo = PlanForm->FindPages();
        pageinfo PageInfo = dynamic_cast<TPlanForm *>(Owner)->FindPages();
        int chartpages = PageInfo.rows * PageInfo.columns;
        int keypages = 0;
        int spppages = 0;

        int totalpages = 0;
        if (FrontSheet->Checked) totalpages++;
        if (IndexPage->Checked) totalpages++;
        if (ColourChart->Checked) {
            if (PageNumber->ItemIndex == 0) {
                totalpages += chartpages;
                } else {
                totalpages++;
                }
            }
        if (MonochromeChart->Checked) {
            if (PageNumber->ItemIndex == 0) {
                totalpages += chartpages;
                } else {
                totalpages++;
                }
            }
        if (BackStitches->Checked && BackStitches->Enabled) {
            if (PageNumber->ItemIndex == 0) {
                totalpages += chartpages;
                } else {
                totalpages++;
                }
            }
        if (DetailedKey->Checked) {
            //keypages = PlanForm->FindPagesforKey();
            keypages = dynamic_cast<TPlanForm *>(Owner)->FindPagesforKey();
            totalpages += keypages;
            }
        if (StitchesPerPage->Checked) {
            //spppages = PlanForm->FindPagesforSPP();
            spppages = dynamic_cast<TPlanForm *>(Owner)->FindPagesforSPP();
            totalpages+= spppages;
            }
        if (FabricDetails->Checked) totalpages++;

        if (totalpages > 0) {
            Screen->Cursor = crHourGlass;
            //right set up the viewer window.
            TPrintPreviewForm *PrintPreviewForm = new TPrintPreviewForm(this);
            PrintPreviewForm->PageList->Capacity = totalpages;
            //test
            //PrintPreviewForm->PageList->Capacity = 1;

            //now find pagesize for preview page
            int ScreenPPI = Screen->PixelsPerInch;
            int PrinterPPI = (int)(((double)Printer()->Canvas->TextWidth("Hi There")) * 25.4 / 13.0);

            PrintPreviewForm->PageSize.x = Printer()->PageWidth * ScreenPPI / PrinterPPI;
            PrintPreviewForm->PageSize.y = Printer()->PageHeight * ScreenPPI / PrinterPPI;


            //create bitmaps to be drawn on
            PrintPreviewForm->CreatePages();

            RetrieveData();
            //PlanForm->LocalChartPrintout = ChartPrintout;
            dynamic_cast<TPlanForm *>(Owner)->LocalChartPrintout = ChartPrintout;

            int currentpage = 0;
            if (FrontSheet->Checked) {
                Label10->Caption = "Generating Page " + AnsiString(currentpage + 1) + " of " + AnsiString(totalpages);
                Label10->Refresh();
                Graphics::TBitmap *TempPicture =  (Graphics::TBitmap *) PrintPreviewForm->PageList->Items[currentpage];
                //PlanForm->DrawFrontSheet(TempPicture->Canvas,TempPicture->Width,TempPicture->Height);
                dynamic_cast<TPlanForm *>(Owner)->DrawFrontSheet(TempPicture->Canvas,TempPicture->Width,TempPicture->Height);
                currentpage++;
                }
            if (IndexPage->Checked) {
                Label10->Caption = "Generating Page " + AnsiString(currentpage + 1) + " of " + AnsiString(totalpages);
                Label10->Refresh();
                Graphics::TBitmap *TempPicture =  (Graphics::TBitmap *) PrintPreviewForm->PageList->Items[currentpage];
                //PlanForm->DrawIndexSheet(TempPicture->Canvas,TempPicture->Width,TempPicture->Height,PageInfo,PageNumber->ItemIndex);
                dynamic_cast<TPlanForm *>(Owner)->DrawIndexSheet(TempPicture->Canvas,TempPicture->Width,TempPicture->Height,PageInfo,PageNumber->ItemIndex);
                currentpage++;
                }
            //int oldglyphsize = PlanForm->GlyphSize;
            //PlanForm->GlyphSize = PlanForm->GlyphSize * ScreenPPI / PrinterPPI;
            int oldglyphsize = dynamic_cast<TPlanForm *>(Owner)->GlyphSize;
            dynamic_cast<TPlanForm *>(Owner)->GlyphSize = dynamic_cast<TPlanForm *>(Owner)->GlyphSize * ScreenPPI / PrinterPPI;
            if (ColourChart->Checked) {
                //PlanForm->PrintColour->OnClick = NULL;
                //bool oldcheck = PlanForm->PrintColour->Checked;
                //PlanForm->PrintColour->Checked = true;
                dynamic_cast<TPlanForm *>(Owner)->PrintColour->OnClick = NULL;
                bool oldcheck = dynamic_cast<TPlanForm *>(Owner)->PrintColour->Checked;
                dynamic_cast<TPlanForm *>(Owner)->PrintColour->Checked = true;
                if (PageNumber->ItemIndex == 0) {
                    for (int i = 0; i < PageInfo.rows; i++ ) {
                        for (int j = 0; j < PageInfo.columns; j++) {
                            Label10->Caption = "Generating Page " + AnsiString(currentpage + 1) + " of " + AnsiString(totalpages);
                            Label10->Refresh();
                            Graphics::TBitmap *TempPicture =  (Graphics::TBitmap *) PrintPreviewForm->PageList->Items[currentpage];
                            //PlanForm->DrawChartSheet(TempPicture->Canvas,TempPicture->Width,TempPicture->Height,i,j, PageInfo.numglyphswide, PageInfo.numglyphshigh);
                            dynamic_cast<TPlanForm *>(Owner)->DrawChartSheet(TempPicture->Canvas,TempPicture->Width,TempPicture->Height,i,j, PageInfo.numglyphswide, PageInfo.numglyphshigh);
                            currentpage++;
                            }
                        }
                    } else {
                    //print one page
                    Label10->Caption = "Generating Page " + AnsiString(currentpage + 1) + " of " + AnsiString(totalpages);
                    Label10->Refresh();
                    Graphics::TBitmap *TempPicture =  (Graphics::TBitmap *) PrintPreviewForm->PageList->Items[currentpage];
                    int sheetcolumn = PageNumber->ItemIndex % PageInfo.columns;
                    int sheetrow = (PageNumber->ItemIndex - sheetcolumn) / PageInfo.columns;
                    //PlanForm->DrawChartSheet(TempPicture->Canvas,TempPicture->Width,TempPicture->Height,sheetrow,sheetcolumn,PageInfo.numglyphswide, PageInfo.numglyphshigh);
                    dynamic_cast<TPlanForm *>(Owner)->DrawChartSheet(TempPicture->Canvas,TempPicture->Width,TempPicture->Height,sheetrow,sheetcolumn,PageInfo.numglyphswide, PageInfo.numglyphshigh);
                    currentpage++;
                    }
                //PlanForm->PrintColour->Checked = oldcheck;
                //PlanForm->PrintColour->OnClick = PlanForm->PrintCountChange;
                dynamic_cast<TPlanForm *>(Owner)->PrintColour->Checked = oldcheck;
                dynamic_cast<TPlanForm *>(Owner)->PrintColour->OnClick = PlanForm->PrintCountChange;
                }
            if (MonochromeChart->Checked) {
                //PlanForm->PrintColour->OnClick = NULL;
                //bool oldcheck = PlanForm->PrintColour->Checked;
                //PlanForm->PrintColour->Checked = false;
                dynamic_cast<TPlanForm *>(Owner)->PrintColour->OnClick = NULL;
                bool oldcheck = dynamic_cast<TPlanForm *>(Owner)->PrintColour->Checked;
                dynamic_cast<TPlanForm *>(Owner)->PrintColour->Checked = false;
                if (PageNumber->ItemIndex == 0) {
                    for (int i = 0; i < PageInfo.rows; i++ ) {
                        for (int j = 0; j < PageInfo.columns; j++) {
                            Label10->Caption = "Generating Page " + AnsiString(currentpage + 1) + " of " + AnsiString(totalpages);
                            Label10->Refresh();
                            Graphics::TBitmap *TempPicture =  (Graphics::TBitmap *) PrintPreviewForm->PageList->Items[currentpage];
                            //PlanForm->DrawChartSheet(TempPicture->Canvas,TempPicture->Width,TempPicture->Height,i,j, PageInfo.numglyphswide, PageInfo.numglyphshigh);
                            dynamic_cast<TPlanForm *>(Owner)->DrawChartSheet(TempPicture->Canvas,TempPicture->Width,TempPicture->Height,i,j, PageInfo.numglyphswide, PageInfo.numglyphshigh);
                            currentpage++;
                            }
                        }
                    } else {
                    //print one page
                    Label10->Caption = "Generating Page " + AnsiString(currentpage + 1) + " of " + AnsiString(totalpages);
                    Label10->Refresh();
                    Graphics::TBitmap *TempPicture =  (Graphics::TBitmap *) PrintPreviewForm->PageList->Items[currentpage];
                    int sheetcolumn = PageNumber->ItemIndex % PageInfo.columns;
                    int sheetrow = (PageNumber->ItemIndex - sheetcolumn) / PageInfo.columns;
                    //PlanForm->DrawChartSheet(TempPicture->Canvas,TempPicture->Width,TempPicture->Height,sheetrow,sheetcolumn,PageInfo.numglyphswide, PageInfo.numglyphshigh);
                    dynamic_cast<TPlanForm *>(Owner)->DrawChartSheet(TempPicture->Canvas,TempPicture->Width,TempPicture->Height,sheetrow,sheetcolumn,PageInfo.numglyphswide, PageInfo.numglyphshigh);
                    currentpage++;
                    }
                //PlanForm->PrintColour->Checked = oldcheck;
                //PlanForm->PrintColour->OnClick = PlanForm->PrintCountChange;
                dynamic_cast<TPlanForm *>(Owner)->PrintColour->Checked = oldcheck;
                dynamic_cast<TPlanForm *>(Owner)->PrintColour->OnClick = PlanForm->PrintCountChange;
                }
            if (BackStitches->Checked && BackStitches->Enabled) {
                //PlanForm->PrintColour->OnClick = NULL;
                //bool oldcheck = PlanForm->PrintColour->Checked;
                //PlanForm->PrintColour->Checked = true;
                dynamic_cast<TPlanForm *>(Owner)->PrintColour->OnClick = NULL;
                bool oldcheck = dynamic_cast<TPlanForm *>(Owner)->PrintColour->Checked;
                dynamic_cast<TPlanForm *>(Owner)->PrintColour->Checked = true;
                if (PageNumber->ItemIndex == 0) {
                    for (int i = 0; i < PageInfo.rows; i++ ) {
                        for (int j = 0; j < PageInfo.columns; j++) {
                            Label10->Caption = "Generating Page " + AnsiString(currentpage + 1) + " of " + AnsiString(totalpages);
                            Label10->Refresh();
                            Graphics::TBitmap *TempPicture =  (Graphics::TBitmap *) PrintPreviewForm->PageList->Items[currentpage];
                            //PlanForm->DrawBackstitchSheet(TempPicture->Canvas,TempPicture->Width,TempPicture->Height,i,j, PageInfo.numglyphswide, PageInfo.numglyphshigh);
                            dynamic_cast<TPlanForm *>(Owner)->DrawBackstitchSheet(TempPicture->Canvas,TempPicture->Width,TempPicture->Height,i,j, PageInfo.numglyphswide, PageInfo.numglyphshigh);
                            currentpage++;
                            }
                        }
                    } else {
                    //print one page
                    Label10->Caption = "Generating Page " + AnsiString(currentpage + 1) + " of " + AnsiString(totalpages);
                    Label10->Refresh();
                    Graphics::TBitmap *TempPicture =  (Graphics::TBitmap *) PrintPreviewForm->PageList->Items[currentpage];
                    int sheetcolumn = PageNumber->ItemIndex % PageInfo.columns;
                    int sheetrow = (PageNumber->ItemIndex - sheetcolumn) / PageInfo.columns;
                    //PlanForm->DrawBackstitchSheet(TempPicture->Canvas,TempPicture->Width,TempPicture->Height,sheetrow,sheetcolumn,PageInfo.numglyphswide, PageInfo.numglyphshigh);
                    dynamic_cast<TPlanForm *>(Owner)->DrawBackstitchSheet(TempPicture->Canvas,TempPicture->Width,TempPicture->Height,sheetrow,sheetcolumn,PageInfo.numglyphswide, PageInfo.numglyphshigh);
                    currentpage++;
                    }
                //PlanForm->PrintColour->Checked = oldcheck;
                //PlanForm->PrintColour->OnClick = PlanForm->PrintCountChange;
                dynamic_cast<TPlanForm *>(Owner)->PrintColour->Checked = oldcheck;
                dynamic_cast<TPlanForm *>(Owner)->PrintColour->OnClick = PlanForm->PrintCountChange;
                }
            if (DetailedKey->Checked) {
                for (int i = 0; i < keypages; i++) {
                    Label10->Caption = "Generating Page " + AnsiString(currentpage + 1) + " of " + AnsiString(totalpages);
                    Label10->Refresh();
                    Graphics::TBitmap *TempPicture =  (Graphics::TBitmap *) PrintPreviewForm->PageList->Items[currentpage];
                    //PlanForm->DrawKeySheet(TempPicture->Canvas,TempPicture->Width,TempPicture->Height,i,10 * ScreenPPI / PrinterPPI);
                    dynamic_cast<TPlanForm *>(Owner)->DrawKeySheet(TempPicture->Canvas,TempPicture->Width,TempPicture->Height,i,10 * ScreenPPI / PrinterPPI);
                    currentpage++;
                    }
                }
            if (StitchesPerPage->Checked) {
                for (int i = 0; i < spppages; i++) {
                    Label10->Caption = "Generating Page " + AnsiString(currentpage + 1) + " of " + AnsiString(totalpages);
                    Label10->Refresh();
                    Graphics::TBitmap *TempPicture =  (Graphics::TBitmap *) PrintPreviewForm->PageList->Items[currentpage];
                    //PlanForm->DrawSPPSheet(TempPicture->Canvas,TempPicture->Width,TempPicture->Height,i,PageInfo,10 * ScreenPPI / PrinterPPI);
                    dynamic_cast<TPlanForm *>(Owner)->DrawSPPSheet(TempPicture->Canvas,TempPicture->Width,TempPicture->Height,i,PageInfo,10 * ScreenPPI / PrinterPPI);
                    currentpage++;
                    }
                }
            if (FabricDetails->Checked) {
                Label10->Caption = "Generating Page " + AnsiString(currentpage + 1) + " of " + AnsiString(totalpages);
                Label10->Refresh();
                Graphics::TBitmap *TempPicture =  (Graphics::TBitmap *) PrintPreviewForm->PageList->Items[currentpage];
                //PlanForm->DrawFabricSheet(TempPicture->Canvas,TempPicture->Width,TempPicture->Height);
                dynamic_cast<TPlanForm *>(Owner)->DrawFabricSheet(TempPicture->Canvas,TempPicture->Width,TempPicture->Height);
                //currentpage++;
                }

            //PlanForm->GlyphSize = oldglyphsize;
            dynamic_cast<TPlanForm *>(Owner)->GlyphSize = oldglyphsize;

            PrintPreviewForm->PageNumber = 0;
            PrintPreviewForm->DisplayCurrentPage();
            Screen->Cursor = crDefault;
            Label10->Caption = "";
            Label10->Refresh();
            PrintPreviewForm->ShowModal();
    
            delete PrintPreviewForm;
            }  //end of 'if (totalpages > 0)'
        } //end of 'if(dynamic_cast<TPlanForm *>(Owner))
}
//---------------------------------------------------------------------------

void __fastcall TDefinePrintoutForm::AcceptButtonClick(TObject *Sender)
{
    Accept = true;
    ModalResult = mrOk;    
}
//---------------------------------------------------------------------------

