//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "DeleteThreadRange.h"
#include <IniFiles.hpp>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TDeleteThreadRangeForm *DeleteThreadRangeForm;
//---------------------------------------------------------------------------
__fastcall TDeleteThreadRangeForm::TDeleteThreadRangeForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TDeleteThreadRangeForm::FormCreate(TObject *Sender)
{
    ThreadList.Length = 0;
    TIniFile *IniFile = new TIniFile(ChangeFileExt(Application->ExeName, ".ini"));
    int numberofthreadranges = IniFile->ReadInteger("ThreadSettings","NumberofRanges",3);
    CurrentRange = IniFile->ReadInteger("ThreadSettings","CurrentRange",0);

    if (numberofthreadranges != 3) {
        for (int i = 3; i < numberofthreadranges; i++) {
            ThreadList.Length++;
            ThreadList[ThreadList.Length - 1].arrayentry = ThreadList.Length - 1;
            ThreadList[ThreadList.Length - 1].description = IniFile->ReadString("ThreadSettings","RangeTitle" + AnsiString(i),"DMC Cotton Floss");
            ThreadList[ThreadList.Length - 1].filename = IniFile->ReadString("ThreadSettings","RangeFilename" + AnsiString(i),"DMCCottonFloss");
            }
        }
    delete IniFile;

    DisplayThreadList();
}
//---------------------------------------------------------------------------

void __fastcall TDeleteThreadRangeForm::DisplayThreadList(void)
{
    ListBox1->Clear();
    AnsiString text;
    for (int i = 0; i < ThreadList.Length; i++) {
        text = ThreadList[i].description;
        if (i + 3 == CurrentRange) text = text + "  (Current - Can't Delete)";
        ListBox1->Items->Add(text);
        }

}
//---------------------------------------------------------------------------

void __fastcall TDeleteThreadRangeForm::ListBox1DblClick(TObject *Sender)
{
    //deletes the selected thread range
    if (ListBox1->ItemIndex > -1 && (ListBox1->ItemIndex + 3) != CurrentRange && ListBox1->ItemIndex < ThreadList.Length) {
        //can delete it. First Undo
        UndoList.Length++;
        UndoList[UndoList.Length - 1].arrayentry = ThreadList[ListBox1->ItemIndex].arrayentry;
        UndoList[UndoList.Length - 1].description = ThreadList[ListBox1->ItemIndex].description;
        UndoList[UndoList.Length - 1].filename = ThreadList[ListBox1->ItemIndex].filename;
        UndoButton->Enabled = true;
        //now delete from list
        for (int i = ListBox1->ItemIndex; i < ThreadList.Length - 1; i++) {
            ThreadList[i].description = ThreadList[i + 1].description;
            ThreadList[i].filename = ThreadList[i + 1].filename;
            }
        ThreadList.Length--;
        if (CurrentRange > ListBox1->ItemIndex + 3) CurrentRange--;
        DisplayThreadList();
        }
    ListBox1->ShowHint = false;
}
//---------------------------------------------------------------------------

void __fastcall TDeleteThreadRangeForm::UndoButtonClick(TObject *Sender)
{
    //Restores the last undo
    if (UndoList.Length) {
        ThreadList.Length++;
        ThreadList[ThreadList.Length - 1].arrayentry = ThreadList.Length - 1;
        for (int i = ThreadList.Length - 1; i > UndoList[UndoList.Length - 1].arrayentry; i--) {
            ThreadList[i].description = ThreadList[i - 1].description;
            ThreadList[i].filename = ThreadList[i - 1].filename;
            }
        ThreadList[UndoList[UndoList.Length - 1].arrayentry].description = UndoList[UndoList.Length - 1].description;
        ThreadList[UndoList[UndoList.Length - 1].arrayentry].filename = UndoList[UndoList.Length - 1].filename;
        if (CurrentRange >= (UndoList[UndoList.Length - 1].arrayentry + 3)) CurrentRange++;
        UndoList.Length--;
        UndoButton->Enabled = (bool)(UndoList.Length);
        DisplayThreadList();
        }
}
//---------------------------------------------------------------------------

void __fastcall TDeleteThreadRangeForm::OKButtonClick(TObject *Sender)
{
    TIniFile *IniFile = new TIniFile(ChangeFileExt(Application->ExeName, ".ini"));
    IniFile->EraseSection("ThreadSettings");
    IniFile->WriteInteger("ThreadSettings","NumberofRanges",ThreadList.Length + 3);
    IniFile->WriteInteger("ThreadSettings","CurrentRange",CurrentRange);

    if (ThreadList.Length) {
        for (int i = 0; i < ThreadList.Length; i++) {
            IniFile->WriteString("ThreadSettings","RangeTitle" + AnsiString(i + 3),ThreadList[i].description);
            IniFile->WriteString("ThreadSettings","RangeFilename" + AnsiString(i + 3),ThreadList[i].filename);
            }
        }
    delete IniFile;

    ModalResult = mrOk;

}
//---------------------------------------------------------------------------
void __fastcall TDeleteThreadRangeForm::ListBox1Click(TObject *Sender)
{
    ListBox1->ShowHint = false;    
}
//---------------------------------------------------------------------------

