//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "EnterColour.h"
#include "ImageEditor.h"
#include "StringHelp.h"
#include "GraphicsHelp.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TEnterColourForm *EnterColourForm;
//---------------------------------------------------------------------------
__fastcall TEnterColourForm::TEnterColourForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TEnterColourForm::FormCreate(TObject *Sender)
{
    UseBlend = false;    
}
//---------------------------------------------------------------------------
void __fastcall TEnterColourForm::RedChange(TObject *Sender)
{
    if (Red->Text.ToIntDef(0) > 255) Red->Text = "255";
    if (Green->Text.ToIntDef(0) > 255) Green->Text = "255";
    if (Blue->Text.ToIntDef(0) > 255) Blue->Text = "255";
    TColor Colour = (TColor)(Red->Text.ToIntDef(0) + 256 * Green->Text.ToIntDef(0) + 256 * 256 * Blue->Text.ToIntDef(0));
    Shape1->Brush->Color = Colour;
    Shape2->Brush->Color = dynamic_cast <TImageEditorForm *>(Owner)->FindNearestDMCColour(Colour);
    rgb Extract = ExtractRGB(Shape2->Brush->Color);
    Shape2->Hint = "R:" + AnsiString(Extract.R) + "  G:" + AnsiString(Extract.G) + "  B:" + AnsiString(Extract.B);
    Shape3->Brush->Color = dynamic_cast <TImageEditorForm *>(Owner)->FindNearestBlendColour(Colour);
    Extract = ExtractRGB(Shape3->Brush->Color);
    Shape3->Hint = "R:" + AnsiString(Extract.R) + "  G:" + AnsiString(Extract.G) + "  B:" + AnsiString(Extract.B);

}
//---------------------------------------------------------------------------
void __fastcall TEnterColourForm::DMCButtonClick(TObject *Sender)
{
    UseBlend = false;
    ModalResult = mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TEnterColourForm::BlendButtonClick(TObject *Sender)
{
    UseBlend = true;
    ModalResult = mrOk;

}
//---------------------------------------------------------------------------
void __fastcall TEnterColourForm::Shape2MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    DMCButtonClick(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TEnterColourForm::Shape3MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    BlendButtonClick(Sender);
}
//---------------------------------------------------------------------------

