//---------------------------------------------------------------------------
#ifndef GraphicsHelpH
#define GraphicsHelpH

#include <Graphics.hpp>
//---------------------------------------------------------------------------
//normal usage
typedef struct {
    int R,G,B;
    } rgb;

//sometimes useful, will take longer
typedef struct {
    double R,G,B;
    } redgreenblue;

typedef struct {
    //Ranges    Hue        0.0 to 360.0 degrees(full circle),
    //          Saturation 0.0 to   1.0
    //          Brightness 0.0 to   1.0
    double Hue, Saturation, Brightness;
    } hsb;

rgb __fastcall ExtractRGB(TColor colour);
TColor __fastcall GetColourFromRGB(rgb Value);
redgreenblue __fastcall ExtractRedGreenBlue(TColor colour);
TColor __fastcall GetColourFromRedGreenBlue(redgreenblue Value);
hsb __fastcall RGBtoHSB(rgb Value);
rgb __fastcall HSBtoRGB(hsb Value);

redgreenblue __fastcall RGBtoRedGreenBlue(rgb value);
rgb __fastcall RedGreenBluetoRGB(redgreenblue value);
redgreenblue __fastcall ScaleRedGreenBlue(redgreenblue value,double scalefactor);
redgreenblue __fastcall AddRedGreenBlue(redgreenblue value1,redgreenblue value2);

rgb __fastcall MeanRGB(rgb Value1, rgb Value2);
rgb __fastcall AddRGB(rgb Value1, rgb Value2);
rgb __fastcall SubtractRGB(rgb Value1, rgb Value2);
rgb __fastcall MultiplyRGB(rgb Value, int scalefactor);
rgb __fastcall DivideRGB(rgb Value, int scalefactor);



#endif
