//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "ImageDetails.h"
#include <vcl\clipbrd.hpp>
#include "printers.hpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TImageDetailsForm *ImageDetailsForm;
//---------------------------------------------------------------------------
__fastcall TImageDetailsForm::TImageDetailsForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TImageDetailsForm::OKButtonClick(TObject *Sender)
{
    Close();    
}
//---------------------------------------------------------------------------
void __fastcall TImageDetailsForm::Undo1Click(TObject *Sender)
{
	//undoes last change
    if ( RichEdit1->HandleAllocated() )
        SendMessage(RichEdit1->Handle, EM_UNDO, 0, 0);

}
//---------------------------------------------------------------------------
void __fastcall TImageDetailsForm::Cut1Click(TObject *Sender)
{
	//cuts selected data
    RichEdit1->CutToClipboard();
    
}
//---------------------------------------------------------------------------
void __fastcall TImageDetailsForm::Copy1Click(TObject *Sender)
{
	//copies selected data
    RichEdit1->CopyToClipboard();	
     
}
//---------------------------------------------------------------------------
void __fastcall TImageDetailsForm::Paste1Click(TObject *Sender)
{
	//paste
    //first check to see of the clipboard has format CF_TEXT
    if (Clipboard()->HasFormat(CF_TEXT)) {
        //now to check to see if the RichEdit's got enough room to paste all
        //the clipboard contents.
        int maxsize = SendMessage(RichEdit1->Handle,EM_GETLIMITTEXT,0,0) - 2048;
        int requiredsize = Clipboard()->AsText.Length() + RichEdit1->Text.Length();

        //increase size if necessary
        if (requiredsize > maxsize) SendMessage(RichEdit1->Handle,EM_EXLIMITTEXT,0,(LPARAM) (DWORD) (requiredsize + 2048));

        //now to paste
        RichEdit1->PasteFromClipboard();
        RichEdit1->Refresh();
        }
    
}
//---------------------------------------------------------------------------
void __fastcall TImageDetailsForm::SelectAll1Click(TObject *Sender)
{
	RichEdit1->SelectAll();	

}
//---------------------------------------------------------------------------
void __fastcall TImageDetailsForm::PopupMenu1Popup(TObject *Sender)
{
    Undo1->Enabled = RichEdit1->CanUndo;
    Copy1->Enabled = (bool) RichEdit1->SelLength;
    Cut1->Enabled = (bool) RichEdit1->SelLength;
    Paste1->Enabled = Clipboard()->HasFormat(CF_TEXT);
    if (RichEdit1->Text.Length() > 0) {
        Print1->Enabled = true;
        SaveAs1->Enabled = true;
        SelectAll1->Enabled = true;
        } else {
        Print1->Enabled = false;
        SaveAs1->Enabled = false;
        SelectAll1->Enabled = false;
        }

}
//---------------------------------------------------------------------------
void __fastcall TImageDetailsForm::SaveAs1Click(TObject *Sender)
{
    if (SaveDialog->Execute()) {
        if (FileExists(SaveDialog->FileName)){
            int result = Application->MessageBox("The File Already Exists\n\n  Overwrite?","Warning",MB_YESNO | MB_ICONINFORMATION);
            if (result == IDNO) return ;
            }
        if (ExtractFileExt(SaveDialog->FileName).LowerCase() != ".rtf") {
            RichEdit1->PlainText = true;
            } else {
            RichEdit1->PlainText = false;
            }
        RichEdit1->Lines->SaveToFile(SaveDialog->FileName);
        }

}
//---------------------------------------------------------------------------
void __fastcall TImageDetailsForm::Print1Click(TObject *Sender)
{
    AnsiString a = Caption;
    RichEdit1->PageRect.Right = Printer()->PageWidth - 40;
    RichEdit1->PageRect.Bottom = Printer()->PageHeight - 40;
    RichEdit1->Print(a);

}
//---------------------------------------------------------------------------
