//---------------------------------------------------------------------------
#ifndef ObtainRGBH
#define ObtainRGBH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include "StitchStructures.h"
#include <ImgList.hpp>
#include <Dialogs.hpp>
//---------------------------------------------------------------------------
class TObtainRGBForm : public TForm
{
__published:	// IDE-managed Components
    TPanel *Panel1;
    TMainMenu *MainMenu1;
    TMenuItem *File1;
    TMenuItem *SaveAs1;
    TMenuItem *N1;
    TMenuItem *Exit1;
    TMenuItem *Edit1;
    TMenuItem *PasteImage1;
    TImage *Image1;
    TLabel *Label1;
    TEdit *Red;
    TLabel *Label2;
    TEdit *Green;
    TEdit *Blue;
    TLabel *Label3;
    TButton *AddButton;
    TSpeedButton *PanButton;
    TSpeedButton *PickRectangle;
    TSpeedButton *PickEyeDropper;
    TImageList *ImageList1;
    TLabel *Label4;
    TLabel *Label5;
    TEdit *ColourNumber;
    TLabel *Label6;
    TEdit *ColourName;
    TMenuItem *AppendColoursto1;
    TMenuItem *N2;
    TOpenDialog *OpenDialog1;
    TSaveDialog *SaveDialog1;
    TBevel *Bevel1;
    TLabel *Label7;
    TEdit *ShortThreadName;
    TShape *Shape1;
    TSpeedButton *ZoomOut;
    TSpeedButton *ZoomIn;
    TSpeedButton *PasteButton;
    TLabel *Label8;
    TMenuItem *Save1;
    TMenuItem *Help1;
    TMenuItem *Help2;
    TSpeedButton *SaveButton;
    TMenuItem *N3;
    TMenuItem *RegisterDefinitionFile1;
    TListBox *ListBox1;
    TPopupMenu *PopupMenu1;
    TMenuItem *Edit2;
    TMenuItem *N4;
    TMenuItem *MoveUpOne1;
    TMenuItem *MoveDownOne1;
    TMenuItem *N5;
    TMenuItem *Delete1;
    TMenuItem *N6;
    TMenuItem *Undo1;
    TMenuItem *N7;
    TMenuItem *Undo2;
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall FormDestroy(TObject *Sender);
    void __fastcall PasteImage1Click(TObject *Sender);
    void __fastcall Edit1Click(TObject *Sender);
    void __fastcall AppendColoursto1Click(TObject *Sender);
    void __fastcall SaveAs1Click(TObject *Sender);
    void __fastcall RedChange(TObject *Sender);
    void __fastcall PickRectangleClick(TObject *Sender);
    void __fastcall PickEyeDropperClick(TObject *Sender);
    void __fastcall PanButtonClick(TObject *Sender);
    void __fastcall Exit1Click(TObject *Sender);
    void __fastcall Image1MouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall AddButtonClick(TObject *Sender);
    void __fastcall ColourNumberChange(TObject *Sender);
    void __fastcall ZoomInClick(TObject *Sender);
    void __fastcall ZoomOutClick(TObject *Sender);
    void __fastcall Image1MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
    void __fastcall Image1MouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall FormMouseWheelDown(TObject *Sender, TShiftState Shift,
          TPoint &MousePos, bool &Handled);
    void __fastcall FormMouseWheelUp(TObject *Sender, TShiftState Shift,
          TPoint &MousePos, bool &Handled);
    void __fastcall SaveButtonClick(TObject *Sender);
    void __fastcall RegisterDefinitionFile1Click(TObject *Sender);
    void __fastcall Help2Click(TObject *Sender);
    void __fastcall ListBox1DrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
    void __fastcall ListBox1Click(TObject *Sender);
    void __fastcall ListBox1DblClick(TObject *Sender);
    void __fastcall PopupMenu1Popup(TObject *Sender);
    void __fastcall MoveUpOne1Click(TObject *Sender);
    void __fastcall MoveDownOne1Click(TObject *Sender);
    void __fastcall Delete1Click(TObject *Sender);
    void __fastcall Undo1Click(TObject *Sender);
private:	// User declarations
    Graphics::TBitmap *Picture;
    TActionType ActionType;
    TPoint TopLeft;
    TPoint StartPointPicture;
    TPoint EndPointScreen;
    TPoint OldTopLeft;
    int SquareSize;
    bool dragging;
    bool wipedout;
    void __fastcall DisplayImage(void);
    void __fastcall UpdateNumberofColours(void);
    chartposition __fastcall FindPicturePosition(int X, int Y);
    chartposition __fastcall FindImagePosition(int X, int Y);
    void __fastcall SaveThreads(void);
    
    TCursor crDrawRectangle;
    TCursor crGrab;
    TCursor crDropperCursor;

    DynamicArray <colourdefineundo> UndoList;
public:		// User declarations
    __fastcall TObtainRGBForm(TComponent* Owner);
    DynamicArray <DMCColourData> DMCColourList;
    bool RegisteredThreads;
};
//---------------------------------------------------------------------------
extern PACKAGE TObtainRGBForm *ObtainRGBForm;
//---------------------------------------------------------------------------
#endif
