//---------------------------------------------------------------------------
#ifndef PrintPreviewH
#define PrintPreviewH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <Menus.hpp>
//---------------------------------------------------------------------------
class TPrintPreviewForm : public TForm
{
__published:	// IDE-managed Components
    TPanel *Panel1;
    TImage *Image1;
    TBitBtn *FirstBtn1;
    TBitBtn *PreviousBtn;
    TEdit *PageNumberEdit;
    TBitBtn *NextBtn;
    TBitBtn *LastBtn;
    TButton *OKButton;
    TLabel *Label1;
    TButton *ResetButton;
    TPopupMenu *PopupMenu1;
    TImageList *ImageList1;
    TMenuItem *CopyPagetoClipboard1;
    TLabel *Label2;
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall FormDestroy(TObject *Sender);
    void __fastcall FormResize(TObject *Sender);
    void __fastcall FormMouseWheelUp(TObject *Sender, TShiftState Shift,
          TPoint &MousePos, bool &Handled);
    void __fastcall FormMouseWheelDown(TObject *Sender, TShiftState Shift,
          TPoint &MousePos, bool &Handled);
    void __fastcall PageNumberEditKeyPress(TObject *Sender, char &Key);
    void __fastcall NextBtnClick(TObject *Sender);
    void __fastcall PreviousBtnClick(TObject *Sender);
    void __fastcall FirstBtn1Click(TObject *Sender);
    void __fastcall LastBtnClick(TObject *Sender);
    void __fastcall ResetButtonClick(TObject *Sender);
    void __fastcall Image1MouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall Image1MouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall Image1MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
    void __fastcall CopyPagetoClipboard1Click(TObject *Sender);
private:	// User declarations
    TPoint TopLeftCorner;
    TPoint OldTopLeftCorner;
    TPoint OldXY;
    bool dragging;
    int MagScale;
    int ShrinkScale;
public:		// User declarations
    TList *PageList;
    int PageNumber;
    void __fastcall DisplayCurrentPage(void);
    TPoint PageSize;
    void __fastcall CreatePages(void);
    __fastcall TPrintPreviewForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TPrintPreviewForm *PrintPreviewForm;
//---------------------------------------------------------------------------
#endif
