//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "RestoreStitches.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TRestoreStitchesForm *RestoreStitchesForm;
//---------------------------------------------------------------------------
__fastcall TRestoreStitchesForm::TRestoreStitchesForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TRestoreStitchesForm::FormDestroy(TObject *Sender)
{
    Stitches.Length = 0;
}
//---------------------------------------------------------------------------

void __fastcall TRestoreStitchesForm::FillList(void)
{
    AnsiString text;
    for (int i = 0; i < Stitches.Length; i++) {
        text = "   Start = " + AnsiString(Stitches[i].Stitch.X1) +
               " , " + AnsiString(Stitches[i].Stitch.Y1) +
               "   End = " + AnsiString(Stitches[i].Stitch.X2) +
               " , " + AnsiString(Stitches[i].Stitch.Y2);
        ListBox1->Items->Add(text);
        }
}
//---------------------------------------------------------------------------

void __fastcall TRestoreStitchesForm::ListBox1DrawItem(
      TWinControl *Control, int Index, TRect &Rect, TOwnerDrawState State)
{
    // Draw coloured rectangle background & text
    TRect Rectangle = Rect;
    TColor TempColour = ListBox1->Canvas->Brush->Color;
    ListBox1->Canvas->Brush->Style = bsSolid;
    //if (ListBox1->Selected[Index]) {
    if (Stitches[Index].selected) {
        ListBox1->Canvas->Brush->Color = clHighlight;
        ListBox1->Canvas->Font->Color = clHighlightText;
        } else {
        ListBox1->Canvas->Brush->Color = Stitches[Index].Colour;
        if (Stitches[Index].DrawWhite) {
            ListBox1->Canvas->Font->Color = clWhite;
            } else {
            ListBox1->Canvas->Font->Color = clBlack;
            }
        }
    ListBox1->Canvas->FillRect(Rectangle);
    ListBox1->Canvas->Brush->Color = TempColour;
    ListBox1->Canvas->Brush->Style = bsClear;
    //for some reason the next line doesn't work
    //ListBox1->Canvas->TextRect(Rectangle,1,1,ListBox1->Items->Strings[Index]);
    DrawText(ListBox1->Canvas->Handle,(ListBox1->Items->Strings[Index]).c_str(),-1,(LPRECT) &Rectangle,DT_VCENTER | DT_SINGLELINE);
    ListBox1->Canvas->Brush->Style = bsSolid;

}
//---------------------------------------------------------------------------

void __fastcall TRestoreStitchesForm::ListBox1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    for (int i = 0; i < ListBox1->Items->Count; i++) {
        if (ListBox1->Selected[i]) {
            Stitches[i].selected = !Stitches[i].selected;
            }
        }
    ListBox1->Repaint();

}
//---------------------------------------------------------------------------

void __fastcall TRestoreStitchesForm::InvertButtonClick(TObject *Sender)
{
    for (int i = 0; i < Stitches.Length; i++) {
        Stitches[i].selected = !Stitches[i].selected;
        }
    ListBox1->Repaint();

}
//---------------------------------------------------------------------------

