//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "SetDefaultSymbols.h"
#include "StitchForm.h"
#include <shellapi.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TSetDefaultSymbolsForm *SetDefaultSymbolsForm;
//---------------------------------------------------------------------------
__fastcall TSetDefaultSymbolsForm::TSetDefaultSymbolsForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TSetDefaultSymbolsForm::FormCreate(TObject *Sender)
{
    SymbolCursor = (TCursor)(10);
    //make a cursor for this to refer to. Should never be seen, but needs to be defined.
    Graphics::TBitmap *CursorBitmap = new Graphics::TBitmap();
    CursorBitmap->Height = 64;
    CursorBitmap->Width = 32;
   //And Mask
    CursorBitmap->Canvas->Pen->Style = psClear;
    CursorBitmap->Canvas->Brush->Style = bsSolid;
    CursorBitmap->Canvas->Brush->Color = clWhite;
    CursorBitmap->Canvas->Rectangle(0,0,33,33);
    //little active spot
    CursorBitmap->Canvas->Pen->Style = psSolid;
    CursorBitmap->Canvas->Pen->Color = clBlack;
    CursorBitmap->Canvas->MoveTo(1,0);
    CursorBitmap->Canvas->LineTo(1,2);
    CursorBitmap->Canvas->MoveTo(0,1);
    CursorBitmap->Canvas->LineTo(2,1);
    //XOR Mask
    CursorBitmap->Canvas->Brush->Color = clBlack;
    CursorBitmap->Canvas->Rectangle(0,32,33,65);
    CursorBitmap->Canvas->Brush->Color = clWhite;
    CursorBitmap->Canvas->Ellipse(2,2 + 32,29,29 + 32);
    CursorBitmap->PixelFormat = pf1bit;

    ICONINFO iconinfo;
    iconinfo.fIcon = false;
    iconinfo.xHotspot = 1;
    iconinfo.yHotspot = 1;
    iconinfo.hbmMask = CursorBitmap->Handle;
    iconinfo.hbmColor = NULL;


    SymbolIcon = CreateIconIndirect(&iconinfo);

    Screen->Cursors[SymbolCursor] = SymbolIcon;
    delete CursorBitmap;

    dragging = false;
    dragindex = -1;

    UndoList.Length = 0;

}
//---------------------------------------------------------------------------
void __fastcall TSetDefaultSymbolsForm::FormDestroy(TObject *Sender)
{
    DestroyIcon(SymbolIcon);
    Symbols.Length = 0;
    UndoList.Length = 0;

}
//---------------------------------------------------------------------------

void __fastcall TSetDefaultSymbolsForm::Initialise(void)
{
    //Fill up the listbox data from the arrays
    for (int i = 0; i < Symbols.Length; i++) {
        ListBox1->Items->Add(AnsiString(Symbols[i]));
        ListBox2->Items->Add(AnsiString(Symbols[i]));
        }

}
//---------------------------------------------------------------------------
void __fastcall TSetDefaultSymbolsForm::ListBox1DrawItem(
      TWinControl *Control, int Index, TRect &Rect, TOwnerDrawState State)
{
    //This draws the contents of the SymbolList row identified by Index.    
    if (dynamic_cast<TPlanForm *>(Owner)) {
    // Draw coloured rectangle background & name of colour
        TRect Rectangle = Rect;
        Rectangle.Left = Rectangle.Left + Rectangle.Bottom - Rectangle.Top;
        TColor TempColour = dynamic_cast<TListBox *>(Control)->Canvas->Brush->Color;
        dynamic_cast<TListBox *>(Control)->Canvas->Brush->Style = bsSolid;
        dynamic_cast<TListBox *>(Control)->Canvas->Brush->Color = TempColour;
        dynamic_cast<TListBox *>(Control)->Canvas->Font->Color = clBlack;
        dynamic_cast<TListBox *>(Control)->Canvas->Brush->Style = bsClear;
        //for some reason the next line doesn't work
        //dynamic_cast<TListBox *>(Control)->Canvas->TextRect(Rectangle,1,1,dynamic_cast<TListBox *>(Control)->Items->Strings[Index]);
        DrawText(dynamic_cast<TListBox *>(Control)->Canvas->Handle,("  " + dynamic_cast<TListBox *>(Control)->Items->Strings[Index]).c_str(),-1,(LPRECT) &Rectangle,DT_VCENTER | DT_SINGLELINE);
        //draw glyph
        if (Index < Symbols.Length) dynamic_cast<TPlanForm *>(Owner)->DrawGlyph2(dynamic_cast<TListBox *>(Control)->Canvas, Rect.Left, Rect.Top, Rect.Bottom - Rect.Top, Symbols[Index], false, clBlack, clWhite);
        dynamic_cast<TListBox *>(Control)->Canvas->Brush->Style = bsSolid;
        }

}
//---------------------------------------------------------------------------
void __fastcall TSetDefaultSymbolsForm::ListBox1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    //crates a cursor with the glyph
    //This starts the drag process
    if (!dragging) {
        dragindex = dynamic_cast<TListBox *>(Sender)->ItemAtPos(Point(X,Y),true);
        if (dragindex > -1 && dragindex < Symbols.Length && dynamic_cast<TPlanForm *>(Owner)) {
            dragging = true;
            //make cursor as per symbol
            Graphics::TBitmap *CursorBitmap = new Graphics::TBitmap();
            CursorBitmap->Height = 64;
            CursorBitmap->Width = 32;
            //And Mask
            CursorBitmap->Canvas->Pen->Style = psClear;
            CursorBitmap->Canvas->Brush->Style = bsSolid;
            CursorBitmap->Canvas->Brush->Color = clWhite;
            CursorBitmap->Canvas->Rectangle(0,0,33,33);
            //little active spot
            CursorBitmap->Canvas->Pen->Style = psSolid;
            CursorBitmap->Canvas->Pen->Color = clBlack;
            CursorBitmap->Canvas->MoveTo(1,0);
            CursorBitmap->Canvas->LineTo(1,2);
            CursorBitmap->Canvas->MoveTo(0,1);
            CursorBitmap->Canvas->LineTo(2,1);
            //XOR Mask
            //DrawGlyph2(TCanvas *Canvas,int X, int Y, int PictureSize, int glyphno, bool PlotEdge, TColor PenColour, TColor BrushColour);
            dynamic_cast<TPlanForm *>(Owner)->DrawGlyph2(CursorBitmap->Canvas,0,32,32,Symbols[dragindex],false, clWhite, clBlack);
            CursorBitmap->PixelFormat = pf1bit;

            ICONINFO iconinfo;
            iconinfo.fIcon = false;
            iconinfo.xHotspot = 1;
            iconinfo.yHotspot = 1;
            iconinfo.hbmMask = CursorBitmap->Handle;
            iconinfo.hbmColor = NULL;

            DestroyIcon(SymbolIcon);
            SymbolIcon = CreateIconIndirect(&iconinfo);

            Screen->Cursors[SymbolCursor] = SymbolIcon;
            delete CursorBitmap;
            ListBox1->Cursor = SymbolCursor;
            ListBox2->Cursor = SymbolCursor;
            Cursor = SymbolCursor;
            } else {
            dragindex = -1;
            dragging = false;
            ListBox1->Cursor = crDefault;
            ListBox2->Cursor = crDefault;
            Cursor = crDefault;
            }
        } else {
        if (dragindex > -1 && dragindex < Symbols.Length) {
            dragging = false;
            int destination = dynamic_cast<TListBox *>(Sender)->ItemAtPos(Point(X,Y),true);
            if (destination < Symbols.Length && destination > -1) {
                //collect undo data first
                int pointer = UndoList.Length;
                UndoList.Length += 3;
                UndoList[pointer].undotype = TStartUndo;
                pointer++;
                UndoList[pointer].undotype = TThreadListEntry;
                UndoList[pointer].row = destination;
                UndoList[pointer].value = Symbols[destination];
                pointer++;
                UndoList[pointer].undotype = TSymbolListEntry;
                UndoList[pointer].row = dragindex;
                UndoList[pointer].value = Symbols[dragindex];

                //do the actual operation
                int swap = Symbols[destination];
                Symbols[destination] = Symbols[dragindex];
                Symbols[dragindex] = swap;
                ListBox1->Invalidate();
                ListBox2->Invalidate();
                UndoButton->Enabled = true;
                }
            dragindex = -1;
            dragging = false;
            ListBox1->Cursor = crDefault;
            ListBox2->Cursor = crDefault;
            Cursor = crDefault;
            }

        }

}
//---------------------------------------------------------------------------
void __fastcall TSetDefaultSymbolsForm::UndoButtonClick(TObject *Sender)
{
    // Undoes the last swap.
    if (UndoList.Length) {
        int pointer = UndoList.Length - 1;
        while (pointer > -1 && UndoList[pointer].undotype != TStartUndo) {
            Symbols[UndoList[pointer].row] = UndoList[pointer].value;
            pointer--;
            }
        if (pointer < 0) pointer = 0;
        UndoList.Length = pointer;
        ListBox1->Invalidate();
        ListBox2->Invalidate();
        UndoButton->Enabled = (bool)(pointer);
        }

}
//---------------------------------------------------------------------------

void __fastcall TSetDefaultSymbolsForm::ResetButtonClick(TObject *Sender)
{
    //Resets the symbols to their default state
    //save the undo data first
    int pointer = UndoList.Length;
    UndoList.Length = UndoList.Length + Symbols.Length + 1;
    UndoList[pointer].undotype = TStartUndo;
    for (int i = 0; i < Symbols.Length; i++) {
        pointer++;
        UndoList[pointer].undotype = TThreadListEntry;
        UndoList[pointer].row = i;
        UndoList[pointer].value = Symbols[i];
        }

    //now re-allocate numbers to factory default
    for (int i = 0; i < Symbols.Length; i++) {
        Symbols[i] = i;
        }
    ListBox1->Invalidate();
    ListBox2->Invalidate();
    UndoButton->Enabled = true;


}
//---------------------------------------------------------------------------

void __fastcall TSetDefaultSymbolsForm::HelpButtonClick(TObject *Sender)
{
    //Opens the help file at the right page
    AnsiString Address = ExtractFileDir(Application->ExeName) + "\\BackStitch.chm";
    AnsiString Location = "mk:@MSITStore:" + Address + "::/symbolxrefformat.html#start";
    ShellExecute(Application->Handle,"open",Location.c_str(),Location.c_str(),NULL,SW_SHOW);

}
//---------------------------------------------------------------------------

