//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "SetSymbols.h"
#include "StitchForm.h"
#include <shellapi.h>
#include "GraphicsHelp.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TSetSymbolsForm *SetSymbolsForm;
//---------------------------------------------------------------------------
__fastcall TSetSymbolsForm::TSetSymbolsForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TSetSymbolsForm::ThreadListDrawItem(TWinControl *Control,
      int Index, TRect &Rect, TOwnerDrawState State)
{
    //This draws the contents of the ThreadList row identified by Index
    if (dynamic_cast<TPlanForm *>(Owner)) {
        // Draw coloured rectangle background & name of colour
        TRect Rectangle = Rect;
        Rectangle.Left = Rectangle.Left + Rectangle.Bottom - Rectangle.Top;
        TColor TempColour = dynamic_cast<TListBox *>(Control)->Canvas->Brush->Color;
        dynamic_cast<TListBox *>(Control)->Canvas->Brush->Style = bsSolid;
        dynamic_cast<TListBox *>(Control)->Canvas->Brush->Color = PictureColourPallette[Index].Colour;
        dynamic_cast<TListBox *>(Control)->Canvas->FillRect(Rectangle);
        dynamic_cast<TListBox *>(Control)->Canvas->Brush->Color = TempColour;
        if (PictureColourPallette[Index].DrawWhite) {
            dynamic_cast<TListBox *>(Control)->Canvas->Font->Color = clWhite;
            } else {
            dynamic_cast<TListBox *>(Control)->Canvas->Font->Color = clBlack;
            }
        dynamic_cast<TListBox *>(Control)->Canvas->Brush->Style = bsClear;
        //for some reason the next line doesn't work
        //dynamic_cast<TListBox *>(Control)->Canvas->TextRect(Rectangle,1,1,dynamic_cast<TListBox *>(Control)->Items->Strings[Index]);
        DrawText(dynamic_cast<TListBox *>(Control)->Canvas->Handle,("  " + dynamic_cast<TListBox *>(Control)->Items->Strings[Index]).c_str(),-1,(LPRECT) &Rectangle,DT_VCENTER | DT_SINGLELINE);
        //draw glyph
        if (Index < UsedSymbols.Length) dynamic_cast<TPlanForm *>(Owner)->DrawGlyph2(dynamic_cast<TListBox *>(Control)->Canvas, Rect.Left, Rect.Top, Rect.Bottom - Rect.Top, UsedSymbols[Index], false, clBlack, clWhite);
        //if (State.Contains(odSelected)) {
            //dynamic_cast<TListBox *>(Control)->Canvas->DrawFocusRect(Rect);
            //}
        dynamic_cast<TListBox *>(Control)->Canvas->Brush->Style = bsSolid;
        }
}
//---------------------------------------------------------------------------
void __fastcall TSetSymbolsForm::SymbolListDrawItem(TWinControl *Control,
      int Index, TRect &Rect, TOwnerDrawState State)
{
    //This draws the contents of the SymbolList row identified by Index.    
    if (dynamic_cast<TPlanForm *>(Owner)) {
    // Draw coloured rectangle background & name of colour
        TRect Rectangle = Rect;
        Rectangle.Left = Rectangle.Left + Rectangle.Bottom - Rectangle.Top;
        TColor TempColour = dynamic_cast<TListBox *>(Control)->Canvas->Brush->Color;
        dynamic_cast<TListBox *>(Control)->Canvas->Brush->Style = bsSolid;
        dynamic_cast<TListBox *>(Control)->Canvas->Brush->Color = TempColour;
        dynamic_cast<TListBox *>(Control)->Canvas->Font->Color = clBlack;
        dynamic_cast<TListBox *>(Control)->Canvas->Brush->Style = bsClear;
        //for some reason the next line doesn't work
        //dynamic_cast<TListBox *>(Control)->Canvas->TextRect(Rectangle,1,1,dynamic_cast<TListBox *>(Control)->Items->Strings[Index]);
        DrawText(dynamic_cast<TListBox *>(Control)->Canvas->Handle,("  " + dynamic_cast<TListBox *>(Control)->Items->Strings[Index]).c_str(),-1,(LPRECT) &Rectangle,DT_VCENTER | DT_SINGLELINE);
        //draw glyph
        if (Index < UnUsedSymbols.Length) dynamic_cast<TPlanForm *>(Owner)->DrawGlyph2(dynamic_cast<TListBox *>(Control)->Canvas, Rect.Left, Rect.Top, Rect.Bottom - Rect.Top, UnUsedSymbols[Index], false, clBlack, clWhite);
        /*if (Index == dragindex) {
            dynamic_cast<TListBox *>(Control)->Canvas->Pen->Width = 1;
            dynamic_cast<TListBox *>(Control)->Canvas->Pen->Style = psDash;
            dynamic_cast<TListBox *>(Control)->Canvas->Pen->Color = clBlack;
            dynamic_cast<TListBox *>(Control)->Canvas->Brush->Style = bsClear;
            dynamic_cast<TListBox *>(Control)->Canvas->Rectangle(Rect.Top, Rect.Left, Rect.Right, Rect.Bottom);
            }*/
        dynamic_cast<TListBox *>(Control)->Canvas->Brush->Style = bsSolid;
        }
}
//---------------------------------------------------------------------------
void __fastcall TSetSymbolsForm::FormCreate(TObject *Sender)
{
    SymbolCursor = (TCursor)(10);
    //make a cursor for this to refer to. Should never be seen, but needs to be defined.
    Graphics::TBitmap *CursorBitmap = new Graphics::TBitmap();
    CursorBitmap->Height = 64;
    CursorBitmap->Width = 32;
   //And Mask
    CursorBitmap->Canvas->Pen->Style = psClear;
    CursorBitmap->Canvas->Brush->Style = bsSolid;
    CursorBitmap->Canvas->Brush->Color = clWhite;
    CursorBitmap->Canvas->Rectangle(0,0,33,33);
    //little active spot
    CursorBitmap->Canvas->Pen->Style = psSolid;
    CursorBitmap->Canvas->Pen->Color = clBlack;
    CursorBitmap->Canvas->MoveTo(1,0);
    CursorBitmap->Canvas->LineTo(1,2);
    CursorBitmap->Canvas->MoveTo(0,1);
    CursorBitmap->Canvas->LineTo(2,1);
    //XOR Mask
    CursorBitmap->Canvas->Brush->Color = clBlack;
    CursorBitmap->Canvas->Rectangle(0,32,33,65);
    CursorBitmap->Canvas->Brush->Color = clWhite;
    CursorBitmap->Canvas->Ellipse(2,2 + 32,29,29 + 32);
    CursorBitmap->PixelFormat = pf1bit;

    ICONINFO iconinfo;
    iconinfo.fIcon = false;
    iconinfo.xHotspot = 1;
    iconinfo.yHotspot = 1;
    iconinfo.hbmMask = CursorBitmap->Handle;
    iconinfo.hbmColor = NULL;


    SymbolIcon = CreateIconIndirect(&iconinfo);

    Screen->Cursors[SymbolCursor] = SymbolIcon;
    delete CursorBitmap;

    dragging = false;
    dragindex = -1;

    UndoList.Length = 0;


}
//---------------------------------------------------------------------------

void __fastcall TSetSymbolsForm::FormDestroy(TObject *Sender)
{
    DestroyIcon(SymbolIcon);
    PictureColourPallette.Length = 0;
    UsedSymbols.Length = 0;
    UnUsedSymbols.Length = 0;
    UndoList.Length = 0;
}
//---------------------------------------------------------------------------

void __fastcall TSetSymbolsForm::Initialise(void)
{
    //Fill up the listbox data from the arrays
    for (int i = 0; i < PictureColourPallette.Length; i++) {
        ThreadList->Items->Add("DMC " + PictureColourPallette[i].DMCColourNumber);
        }
    for (int i = 0; i < UnUsedSymbols.Length; i++) {
        SymbolList->Items->Add(AnsiString(UnUsedSymbols[i]));
        }

}
//---------------------------------------------------------------------------

void __fastcall TSetSymbolsForm::SymbolListMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    //This starts the drag process
    dragindex = SymbolList->ItemAtPos(Point(X,Y),true);
    if (dragindex > -1 && dragindex < UnUsedSymbols.Length && dynamic_cast<TPlanForm *>(Owner)) {
        dragging = true;
        //make cursor as per symbol
        Graphics::TBitmap *CursorBitmap = new Graphics::TBitmap();
        CursorBitmap->Height = 64;
        CursorBitmap->Width = 32;
        //And Mask
        CursorBitmap->Canvas->Pen->Style = psClear;
        CursorBitmap->Canvas->Brush->Style = bsSolid;
        CursorBitmap->Canvas->Brush->Color = clWhite;
        CursorBitmap->Canvas->Rectangle(0,0,33,33);
        //little active spot
        CursorBitmap->Canvas->Pen->Style = psSolid;
        CursorBitmap->Canvas->Pen->Color = clBlack;
        CursorBitmap->Canvas->MoveTo(1,0);
        CursorBitmap->Canvas->LineTo(1,2);
        CursorBitmap->Canvas->MoveTo(0,1);
        CursorBitmap->Canvas->LineTo(2,1);
        //XOR Mask
        //DrawGlyph2(TCanvas *Canvas,int X, int Y, int PictureSize, int glyphno, bool PlotEdge, TColor PenColour, TColor BrushColour);
        dynamic_cast<TPlanForm *>(Owner)->DrawGlyph2(CursorBitmap->Canvas,0,32,32,UnUsedSymbols[dragindex],false, clWhite, clBlack);
        CursorBitmap->PixelFormat = pf1bit;

        ICONINFO iconinfo;
        iconinfo.fIcon = false;
        iconinfo.xHotspot = 1;
        iconinfo.yHotspot = 1;
        iconinfo.hbmMask = CursorBitmap->Handle;
        iconinfo.hbmColor = NULL;

        DestroyIcon(SymbolIcon);
        SymbolIcon = CreateIconIndirect(&iconinfo);

        Screen->Cursors[SymbolCursor] = SymbolIcon;
        delete CursorBitmap;
        SymbolList->Cursor = SymbolCursor;
        ThreadList->Cursor = SymbolCursor;
        Cursor = SymbolCursor;

        } else {
        dragindex = -1;
        dragging = false;
        SymbolList->Cursor = crDefault;
        ThreadList->Cursor = crDefault;
        Cursor = crDefault;
        }
}
//---------------------------------------------------------------------------

void __fastcall TSetSymbolsForm::ThreadListMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if (dragging && dragindex > -1 && dragindex < UnUsedSymbols.Length) {
        dragging = false;
        int destination = ThreadList->ItemAtPos(Point(X,Y),true);
        if (destination < PictureColourPallette.Length && destination > -1) {
            //collect undo data first
            int pointer = UndoList.Length;
            UndoList.Length += 3;
            UndoList[pointer].undotype = TStartUndo;
            pointer++;
            UndoList[pointer].undotype = TThreadListEntry;
            UndoList[pointer].row = destination;
            UndoList[pointer].value = UsedSymbols[destination];
            pointer++;
            UndoList[pointer].undotype = TSymbolListEntry;
            UndoList[pointer].row = dragindex;
            UndoList[pointer].value = UnUsedSymbols[dragindex];

            //do the actual operation
            int swap = UsedSymbols[destination];
            UsedSymbols[destination] = UnUsedSymbols[dragindex];
            UnUsedSymbols[dragindex] = swap;
            SymbolList->Items->Strings[dragindex] = AnsiString(swap);
            ThreadList->Invalidate();
            SymbolList->Invalidate();
            UndoButton->Enabled = true;
            }
        dragindex = -1;
        dragging = false;
        SymbolList->Cursor = crDefault;
        ThreadList->Cursor = crDefault;
        Cursor = crDefault;
        }
}
//---------------------------------------------------------------------------

void __fastcall TSetSymbolsForm::SortButtonClick(TObject *Sender)
{
    Screen->Cursor = crHourGlass;
    //sorts the symbols so the brightness of the symbol is related to the brightness of the colour.
    DynamicArray <threadbrightnesssort> ThreadBrightness;
    DynamicArray <symboldarknesssort> SymbolDarkness;

    //get relative brightness of colour. Will be in range 0-765
    ThreadBrightness.Length = PictureColourPallette.Length;
    rgb Colour;
    for (int i = 0; i < ThreadBrightness.Length; i++) {
        ThreadBrightness[i].threadnumber = i;
        //ThreadBrightness[i].threadbrightness = PictureColourPallette[i].R + PictureColourPallette[i].G + PictureColourPallette[i].B;
        Colour = ExtractRGB(PictureColourPallette[i].Colour);
        ThreadBrightness[i].threadbrightness = Colour.R + Colour.G + Colour.B;
        ThreadBrightness[i].symbolnumber = -1;
        }
    //now sort by brightness
    bool swapped = true;
    threadbrightnesssort swapthread;
    while (swapped) {
        swapped = false;
        for (int i = 0; i < ThreadBrightness.Length - 1; i++) {
            if (ThreadBrightness[i].threadbrightness > ThreadBrightness[i + 1].threadbrightness) {
                swapped = true;
                swapthread = ThreadBrightness[i];
                ThreadBrightness[i] = ThreadBrightness[i + 1];
                ThreadBrightness[i + 1] = swapthread;
                }
            }
        }

    //get number of black pixels in symbol if drawn on a white background. Will be in range 0-1024
    Graphics::TBitmap *Symbol = new Graphics::TBitmap();
    Symbol->Height = 32;
    Symbol->Width = 32;
    SymbolDarkness.Length = UsedSymbols.Length + UnUsedSymbols.Length;
    int blackpixelcount;
    for (int i = 0; i < SymbolDarkness.Length; i++) {
        SymbolDarkness[i].symbolnumber = i;
        //DrawGlyph2(TCanvas *Canvas,int X, int Y, int PictureSize, int glyphno, bool PlotEdge, TColor PenColour, TColor BrushColour);
        dynamic_cast<TPlanForm *>(Owner)->DrawGlyph2(Symbol->Canvas,0,0,32,i,false, clBlack, clWhite);
        blackpixelcount = 0;
        for (int j = 0; j < 32; j++) {
            for (int k = 0; k < 32; k++) {
                if (Symbol->Canvas->Pixels[j][k] == clBlack) blackpixelcount++;
                }
            }
        SymbolDarkness[i].darkpixels = blackpixelcount;
        }
    delete Symbol;

    //now to sort symbols such that highest number of dark pixels is at index 0, and the symbol number increments with index
    //for symbols with the same number of dark pixels
    //use inefficient bubble sort as it's quick to program
    swapped = true;
    symboldarknesssort swap;
    while (swapped) {
        swapped = false;
        for (int i = 0; i < SymbolDarkness.Length - 1; i++) {
            if (SymbolDarkness[i].darkpixels < SymbolDarkness[i + 1].darkpixels || (SymbolDarkness[i].darkpixels == SymbolDarkness[i + 1].darkpixels && SymbolDarkness[i].symbolnumber > SymbolDarkness[i + 1].symbolnumber)) {
                swapped = true;
                swap = SymbolDarkness[i];
                SymbolDarkness[i] = SymbolDarkness[i + 1];
                SymbolDarkness[i + 1] = swap;
                }
            }
        }

    //that's the sorting complete, now allocate the symbol numbers
    //debug
    //Memo1->Lines->Add("Deleted Symbols");
    //end debug
    int targetdarkness, targetindex;
    for (int i = 0; i < ThreadBrightness.Length; i++) {
        targetdarkness = ((767 - ThreadBrightness[i].threadbrightness) * 400) / 767;
        targetindex = SymbolDarkness.Length - 1;
        while ((targetindex > 0 && SymbolDarkness[targetindex].darkpixels < targetdarkness) || SymbolDarkness[targetindex].darkpixels == 0) {
            targetindex--;
            }
        //now see if earlier ones have the same darkness of pixels to keep symbol numbers low
        while (targetindex > 0 && SymbolDarkness[targetindex].darkpixels == SymbolDarkness[targetindex - 1].darkpixels) {
            targetindex--;
            }
        ThreadBrightness[i].symbolnumber = SymbolDarkness[targetindex].symbolnumber;
        //debug
        //Memo1->Lines->Add("Symbol Entry:" + AnsiString(targetindex) + "  Symbol No:" + AnsiString(SymbolDarkness[targetindex].symbolnumber) + "  DarkPixels:" + AnsiString(SymbolDarkness[targetindex].darkpixels) + "  targetdarkness:" + AnsiString(targetdarkness));
        //end debug
        //delete this symbol from the available list to prevent duplication
        for (int j = targetindex; j < SymbolDarkness.Length - 1; j++) {
            SymbolDarkness[j] = SymbolDarkness[j+1];
            }
        SymbolDarkness.Length--;
        }


    //That's allocation complete, now save the current settings in the undo list
    int pointer = UndoList.Length;
    UndoList.Length = UndoList.Length + UsedSymbols.Length + UnUsedSymbols.Length + 1;
    UndoList[pointer].undotype = TStartUndo;
    for (int i = 0; i < UsedSymbols.Length; i++) {
        pointer++;
        UndoList[pointer].undotype = TThreadListEntry;
        UndoList[pointer].row = i;
        UndoList[pointer].value = UsedSymbols[i];
        }
    for (int i = 0; i < UnUsedSymbols.Length; i++) {
        pointer++;
        UndoList[pointer].undotype = TSymbolListEntry;
        UndoList[pointer].row = i;
        UndoList[pointer].value = UnUsedSymbols[i];
        }


    //apply the new settings
    for (int i = 0; i < ThreadBrightness.Length; i++) {
        UsedSymbols[ThreadBrightness[i].threadnumber] = ThreadBrightness[i].symbolnumber;
        }
    if (UnUsedSymbols.Length != SymbolDarkness.Length) {
        //debug check - should be the same!
        UnUsedSymbols.Length = SymbolDarkness.Length;
        }
    for (int i = 0; i < SymbolDarkness.Length; i++) {
        UnUsedSymbols[i] = SymbolDarkness[i].symbolnumber;
        }
    ThreadList->Invalidate();
    SymbolList->Clear();
    for (int i = 0; i < UnUsedSymbols.Length; i++) {
        SymbolList->Items->Add(AnsiString(UnUsedSymbols[i]));
        }
    UndoButton->Enabled = true;

    //debug code
    /*
    Memo1->Lines->Add("Thread Brightness");
    for (int i = 0; i < ThreadBrightness.Length; i++) {
        Memo1->Lines->Add("i:" + AnsiString(i) + "  threadnumber:" + AnsiString(ThreadBrightness[i].threadnumber) + "  threadbrightness:" + AnsiString(ThreadBrightness[i].threadbrightness) + "  symbolnumber:" + AnsiString(ThreadBrightness[i].symbolnumber) + "  targetdarkness:" + AnsiString(((767 - ThreadBrightness[i].threadbrightness) * 1024) / 767));
        }
    Memo1->Lines->Add("SymbolDarkness");
    for (int i = 0; i < SymbolDarkness.Length; i++) {
        Memo1->Lines->Add("i:" + AnsiString(i) + "  symbolnumber:" + AnsiString(SymbolDarkness[i].symbolnumber) + "  darkpixels:" + AnsiString(SymbolDarkness[i].darkpixels));
        }
    */
    //end debug


    ThreadBrightness.Length = 0;
    SymbolDarkness.Length = 0;

    Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------

void __fastcall TSetSymbolsForm::HelpButtonClick(TObject *Sender)
{
    //Opens the help file at the right page
    AnsiString Address = ExtractFileDir(Application->ExeName) + "\\BackStitch.chm";
    AnsiString Location = "mk:@MSITStore:" + Address + "::/setsymbols.html#start";
    ShellExecute(Application->Handle,"open",Location.c_str(),Location.c_str(),NULL,SW_SHOW);

}
//---------------------------------------------------------------------------

void __fastcall TSetSymbolsForm::UndoButtonClick(TObject *Sender)
{
    // Undoes the last swap.
    if (UndoList.Length) {
        int pointer = UndoList.Length - 1;
        while (pointer > -1 && UndoList[pointer].undotype != TStartUndo) {
            switch (UndoList[pointer].undotype) {
                case TThreadListEntry:  {
                                        UsedSymbols[UndoList[pointer].row] = UndoList[pointer].value;
                                        }
                                        break;
                default:                {
                                        UnUsedSymbols[UndoList[pointer].row] = UndoList[pointer].value;
                                        SymbolList->Items->Strings[UndoList[pointer].row] = AnsiString(UndoList[pointer].value);
                                        }
                                        break;
                }
            pointer--;
            }
        if (pointer < 0) pointer = 0;
        UndoList.Length = pointer;
        ThreadList->Invalidate();
        SymbolList->Invalidate();
        UndoButton->Enabled = (bool)(pointer);
        }
}
//---------------------------------------------------------------------------

