//---------------------------------------------------------------------------
#ifndef SetSymbolsH
#define SetSymbolsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "StitchStructures.h"
#include <Buttons.hpp>
//---------------------------------------------------------------------------

class TSetSymbolsForm : public TForm
{
__published:	// IDE-managed Components
    TButton *OKButton;
    TButton *CancelButton;
    TListBox *ThreadList;
    TListBox *SymbolList;
    TLabel *Label1;
    TLabel *Label2;
    TButton *SortButton;
    TButton *HelpButton;
    TSpeedButton *UndoButton;
    void __fastcall ThreadListDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
    void __fastcall SymbolListDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall FormDestroy(TObject *Sender);
    void __fastcall SymbolListMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
    void __fastcall ThreadListMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
    void __fastcall SortButtonClick(TObject *Sender);
    void __fastcall HelpButtonClick(TObject *Sender);
    void __fastcall UndoButtonClick(TObject *Sender);
private:	// User declarations
    TCursor SymbolCursor;
    HICON SymbolIcon;
    bool dragging;
    int dragindex;
    DynamicArray <undolist> UndoList;
public:		// User declarations
    __fastcall TSetSymbolsForm(TComponent* Owner);
    DynamicArray <DMCColourData> PictureColourPallette;
    DynamicArray <int> UsedSymbols;
    DynamicArray <int> UnUsedSymbols;
    void __fastcall Initialise(void);
};
//---------------------------------------------------------------------------
extern PACKAGE TSetSymbolsForm *SetSymbolsForm;
//---------------------------------------------------------------------------
#endif
