//---------------------------------------------------------------------------
#ifndef StitchFormH
#define StitchFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <ExtDlgs.hpp>
#include <Menus.hpp>
#include <ImgList.hpp>
#include "StitchStructures.h"
#include <Graphics.hpp>

//---------------------------------------------------------------------------
typedef struct {
    int rows, columns;
    int numglyphswide, numglyphshigh;
    } pageinfo;


class TPlanForm : public TForm
{
__published:	// IDE-managed Components
    TMainMenu *MainMenu1;
    TMenuItem *File1;
    TMenuItem *Exit1;
    TOpenPictureDialog *OpenDialog1;
    TImage *Image1;
    TMenuItem *Open1;
    TPrinterSetupDialog *PrinterSetupDialog1;
    TMenuItem *N1;
    TMenuItem *PrintSetup1;
    TMenuItem *PrintKey;
    TMenuItem *N2;
    TMenuItem *Help1;
    TMenuItem *Help2;
    TMenuItem *N3;
    TMenuItem *About1;
    TImageList *ImageList1;
    TMenuItem *PrintChart;
    TGroupBox *GroupBox1;
    TLabel *Label1;
    TLabel *HeightLabel;
    TLabel *Label2;
    TLabel *WidthLabel;
    TLabel *Label12;
    TLabel *Label13;
    TMemo *Memo1;
    TGroupBox *GroupBox2;
    TGroupBox *GroupBox3;
    TLabel *Label6;
    TComboBox *StitchCount;
    TLabel *Label7;
    TLabel *Label8;
    TLabel *Label10;
    TLabel *Label9;
    TLabel *Label11;
    TCheckBox *PrintColour;
    TCheckBox *Background;
    TCheckBox *SimpleKey;
    TLabel *Label20;
    TComboBox *PrintCount;
    TLabel *Label25;
    TScrollBox *ScrollBox1;
    TImage *Image2;
    TLabel *Label15;
    TLabel *Label14;
    TLabel *Label16;
    TLabel *Label17;
    TLabel *Label18;
    TLabel *Label19;
    TImage *Image3;
    TLabel *Label21;
    TLabel *Label22;
    TLabel *Label23;
    TLabel *Label24;
    TLabel *Label26;
    TLabel *Label3;
    TComboBox *PageNumber;
    TLabel *Label4;
    TLabel *Label5;
    TMenuItem *PrintFabricDetails1;
    TMenuItem *Edit1;
    TMenuItem *Paste1;
    TMenuItem *Copy1;
    TSavePictureDialog *SavePictureDialog1;
    TMenuItem *Save1;
    TMenuItem *PrintFronticePiece1;
    TPopupMenu *PopupMenu1;
    TMenuItem *Copy2;
    TMenuItem *Paste2;
    TCheckBox *UseAnchor;
    TMenuItem *N4;
    TMenuItem *BackStitch1;
    TMenuItem *SaveBackStitches1;
    TSaveDialog *SaveDialog1;
    TMenuItem *PrintBackStitches1;
    TButton *Button1;
    TMenuItem *CopyPlanSheetXRef1;
    TImage *Image4;
    TPopupMenu *PopupMenu2;
    TMenuItem *Copy3;
    TMenuItem *N5;
    TMenuItem *SavePageIndex1;
    TMenuItem *PrintPageStitchInfo;
    TLabel *Label27;
    TMenuItem *OpenImage1;
    TMenuItem *N6;
    TMenuItem *PasteHighResImage1;
    TMenuItem *CopyHighResImage1;
    TMenuItem *SaveHighResImage1;
    TMenuItem *TransparencyBackStitch1;
    TMenuItem *PrintWholeChartDocument1;
    TMenuItem *N7;
    TMenuItem *ColourReduction1;
    TMenuItem *ReverttoOriginalImage1;
    TMenuItem *MergeSubstituteColours1;
    TMenuItem *CropImage1;
    TRadioGroup *ThreadSortMethod;
    TMenuItem *N8;
    TMenuItem *DebugLists1;
    TMenuItem *ImageInfo1;
    TMenuItem *ImageComplexity1;
    TMenuItem *LowComplexity1;
    TMenuItem *MediumComplexity1;
    TMenuItem *HighlyComplex1;
    TMenuItem *AlmostImpossiblyComplex1;
    TMenuItem *ImageDetails1;
    TMenuItem *N9;
    TMenuItem *New1;
    TMenuItem *ImageEditor1;
    TMenuItem *N10;
    TMenuItem *Open2;
    TOpenDialog *OpenDialog2;
    TMenuItem *N11;
    TMenuItem *SetSymbols1;
    TMenuItem *Settings;
    TMenuItem *SetSymbols2;
    TLabel *Label28;
    TMenuItem *DefaultSettings1;
    TMenuItem *FlossType;
    TMenuItem *Range1;
    TMenuItem *N12;
    TMenuItem *EditRangeColours1;
    TMenuItem *NewRange1;
    TMenuItem *N13;
    TMenuItem *DeleteRange1;
    TMenuItem *DMC1;
    TMenuItem *DMCMonochromeFloss1;
    TMenuItem *AnchorFloss1;
    TMenuItem *N14;
    TMenuItem *AddFlossRange1;
    TOpenDialog *OpenDialog3;
    TMenuItem *FromScratch1;
    TMenuItem *CopyARange1;
    TCheckBox *MultiplesofTenCheckBox;
    void __fastcall Exit1Click(TObject *Sender);
    void __fastcall PrintSetup1Click(TObject *Sender);
    void __fastcall Open1Click(TObject *Sender);
    void __fastcall PrintKeyClick(TObject *Sender);
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall About1Click(TObject *Sender);
    void __fastcall FormDestroy(TObject *Sender);
    void __fastcall StitchCountChange(TObject *Sender);
    void __fastcall Image1MouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall PrintCountChange(TObject *Sender);
    void __fastcall BackgroundClick(TObject *Sender);
    void __fastcall PrintChartClick(TObject *Sender);
    void __fastcall FormResize(TObject *Sender);
    void __fastcall Help1Click(TObject *Sender);
    void __fastcall PrintFabricDetails1Click(TObject *Sender);
    void __fastcall Paste1Click(TObject *Sender);
    void __fastcall Edit1Click(TObject *Sender);
    void __fastcall Copy1Click(TObject *Sender);
    void __fastcall Save1Click(TObject *Sender);
    void __fastcall PrintFronticePiece1Click(TObject *Sender);
    void __fastcall BackStitch1Click(TObject *Sender);
    void __fastcall SaveBackStitches1Click(TObject *Sender);
    void __fastcall File1Click(TObject *Sender);
    void __fastcall PrintBackStitches1Click(TObject *Sender);
    void __fastcall Button1Click(TObject *Sender);
    void __fastcall CopyPlanXRef1Click(TObject *Sender);
    void __fastcall SavePageIndex1Click(TObject *Sender);
    void __fastcall PrintPageStitchInfoClick(TObject *Sender);
    void __fastcall UseAnchorClick(TObject *Sender);
    void __fastcall OpenImage1Click(TObject *Sender);
    void __fastcall SaveHighResImage1Click(TObject *Sender);
    void __fastcall CopyHighResImage1Click(TObject *Sender);
    void __fastcall PasteHighResImage1Click(TObject *Sender);
    void __fastcall TransparencyBackStitch1Click(TObject *Sender);
    void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
    void __fastcall PrintWholeChartDocument1Click(TObject *Sender);
    void __fastcall ColourReduction1Click(TObject *Sender);
    void __fastcall ReverttoOriginalImage1Click(TObject *Sender);
    void __fastcall MergeSubstituteColours1Click(TObject *Sender);
    void __fastcall CropImage1Click(TObject *Sender);
    void __fastcall ThreadSortMethodClick(TObject *Sender);
    void __fastcall DebugLists1Click(TObject *Sender);
    void __fastcall ImageComplexity1Click(TObject *Sender);
    void __fastcall LowComplexity1Click(TObject *Sender);
    void __fastcall ImageDetails1Click(TObject *Sender);
    void __fastcall New1Click(TObject *Sender);
    void __fastcall ImageEditor1Click(TObject *Sender);
    void __fastcall Open2Click(TObject *Sender);
    void __fastcall SetSymbols1Click(TObject *Sender);
    void __fastcall SetSymbols2Click(TObject *Sender);
    void __fastcall DefaultSettings1Click(TObject *Sender);
    void __fastcall Range1Click(TObject *Sender);
    void __fastcall OpenFlossRange(TObject *Sender);
    void __fastcall AddFlossRange1Click(TObject *Sender);
    void __fastcall DeleteRange1Click(TObject *Sender);
    void __fastcall FlossTypeClick(TObject *Sender);
    void __fastcall FromScratch1Click(TObject *Sender);
    void __fastcall EditARange1Click(TObject *Sender);
    void __fastcall CopyARange1Click(TObject *Sender);
private:	// User declarations
    void __fastcall FillPrinterData(void);
    void __fastcall FillPictureData(void);
    void __fastcall ShowPictureSize(void);
    void __fastcall FillNoBlendPictureData(void);
    void __fastcall FillBlendPictureData(void);
    void __fastcall OpenImage(void);
    void __fastcall OpenDMCList(void);
    void __fastcall ReadSymbolToGlyphXRef(void);
    void __fastcall ImageListCreate(void);
    void __fastcall DrawAnchorGlyph(TCanvas *Canvas,int X, int Y, int PictureSize, int i, bool PlotEdge, TColor colour, bool usewhite);
    void __fastcall DrawAnchorGlyph2(TCanvas *Canvas,int X, int Y, int PictureSize, int glyphno, int i, bool PlotEdge, TColor colour, bool usewhite);
    void __fastcall DrawGlyph(TCanvas *Canvas,int X, int Y, int PictureSize, int i, bool PlotEdge);
    //void __fastcall DrawGlyph2(TCanvas *Canvas,int X, int Y, int PictureSize, int glyphno, int i, bool PlotEdge);
    //void __fastcall DrawGlyph2(TCanvas *Canvas,int X, int Y, int PictureSize, int glyphno, bool PlotEdge, TColor PenColour, TColor BrushColour); //Made Public
    void __fastcall DrawEmptyGlyph(TCanvas *Canvas,int X, int Y, int PictureSize);
    void __fastcall ReadBackStitches(AnsiString FileName);
    void __fastcall SaveStitches(AnsiString FileName);
    void __fastcall CountCrossStitches(void);
    void __fastcall CountBackStitches(void);
    void __fastcall AssignAnchorColours(void);
    bool __fastcall FindIntersection(float X1, float Y1, float X2, float Y2, float X3, float Y3, float X4, float Y4);
    int __fastcall FindColoutRefAtPixel(int X, int Y);
    colourcomplexity __fastcall FindImageComplexity(void);
    //pageinfo __fastcall FindPages(void);
    void __fastcall CreatePageXRef(TCanvas *Canvas);
    void __fastcall CreateImage4(void);
    void __fastcall FillMemo1(bool found);
    float XIntersect;
    float YIntersect;
    TStringList * inputfile;
    double __fastcall ROUND(double value);
    DynamicArray <DMCColourData> DMCColourList;
    DynamicArray <DMCColourData> PictureColourPallette;
    DynamicArray <DMCColourData> BackgroundList;
    DynamicArray <BackStitchData> BackStitches;
    int ThreadFileNamePointer;
    //TStringList *ThreadFileNameList;
    AnsiString ShortThreadName;
    //int GlyphSize;
    bool backgroundfilefound;
    bool backgroundcolourfound;
    bool printingbackstitches;
    Graphics::TBitmap *OriginalImage;
    originalimagefile OriginalImageFile;
    bool backstitcheschanged;
    AnsiString PictureFileName;
    bool PictureChanged;
    printout ChartPrintout;
    TThreadSortOrder SortOrder;
    void __fastcall SortThreads(void);
    //void __fastcall SelectBackground(void);
    bool __fastcall SelectBackground(void);
    TConfettiLevel ConfettiLevel;
    bool forceConfettiLevel;

    //Printing document parts
    void __fastcall PrintFrontSheet(void);
    void __fastcall PrintIndexPage(void);
    //int __fastcall FindPagesforKey(void);
    //int __fastcall FindPagesforSPP(void);
    void __fastcall PrintChartSheets(void);
    void __fastcall PrintBackstitchPages(void);
    void __fastcall PrintKeyPages(void);
    void __fastcall PrintSPPPages(void);
    void __fastcall PrintFabricPages(void);

    //holding original image & undo
    Graphics::TBitmap *OriginalBitmap;
    chartposition UndoStitchOffset;

    //thread conversion
    threadconvsettings Conversion;

    //thread blending
    bool blendthreads;
    //DynamicArray <TweedColourData> TweedList;                //Made public
    DynamicArray <BlendXRef> BlendReference;

    //symbol number re-assignment
    DynamicArray <int> SymboltoGlyphXRef;
    bool setsymbols;

    //read initialisation data
    void __fastcall ReadIniFile(void);

public:		// User declarations

    pageinfo __fastcall FindPages(void);
    int __fastcall FindPagesforKey(void);
    int __fastcall FindPagesforSPP(void);
    void __fastcall DrawFrontSheet(TCanvas *Canvas, int Width, int Height);
    void __fastcall DrawIndexSheet(TCanvas *Canvas, int Width, int Height, pageinfo PageInfo,int ItemIndex);
    void __fastcall DrawChartSheet(TCanvas *Canvas, int Width, int Height, int Row, int Column, int GlyphsWide, int GlyphsHigh);
    void __fastcall DrawBackstitchSheet(TCanvas *Canvas, int Width, int Height, int Row, int Column, int GlyphsWide, int GlyphsHigh);
    void __fastcall DrawKeySheet(TCanvas *Canvas, int Width, int Height, int PageNumber, int RowSpacing);
    void __fastcall DrawSPPSheet(TCanvas *Canvas, int Width, int Height, int PageNumber, pageinfo PageInfo, int RowSpacing);
    void __fastcall DrawFabricSheet(TCanvas *Canvas, int Width, int Height);
    void __fastcall DrawGlyph2(TCanvas *Canvas,int X, int Y, int PictureSize, int glyphno, bool PlotEdge, TColor PenColour, TColor BrushColour);
    printout LocalChartPrintout;
    int GlyphSize;
    DynamicArray <TweedColourData> TweedList;
    TStringList *ThreadFileNameList;


    __fastcall TPlanForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TPlanForm *PlanForm;
//---------------------------------------------------------------------------
#endif
