#ifndef StringHelpH
#define StringHelpH

//#include <system.hpp>
//#include <sysutils.hpp>
//#include <vcl\dstring.h>

//String to number function
float __fastcall ToFloatDef(AnsiString Value, float DefaultVal);
double __fastcall ToDoubleDef(AnsiString Value, double DefaultVal);

//obsolete functions - use the overloaded versions of these functions
AnsiString __fastcall FixedLenFloat(int Length, long double value, TFloatFormat format, int precision, int digits);
AnsiString __fastcall FixedLenInt(int Length, int value);
AnsiString __fastcall FixedLenString(int Length, AnsiString string);
AnsiString __fastcall FixedLenIntZeroPadded(int Length, int value);

//now to duplicate the above with overloaded functions
//Pads to left of number with spaces if shorter than Length. Doesn't return an
//error if length is longer than Length
AnsiString __fastcall FixedLen(int Length, bool value);
AnsiString __fastcall FixedLen(int Length, int value);
AnsiString __fastcall FixedLen(int Length, long double value, TFloatFormat format, int precision, int digits);
AnsiString __fastcall FixedLen(int Length, AnsiString string);

//similar to FixedLen, but tries harder to maintain the length. More processing
//required, so don't use unless absolutely required to have returned string
//with length Length. Downgrades digit then precision in an attempt to make
//number fit in available space. If there is no "." character it calls itself
//using TFloatFormat ffExponent.
AnsiString __fastcall ForceLen(int Length, long double value, TFloatFormat format, int precision, int digits);

//now to pad out with zeros to left of number
AnsiString __fastcall FixedLenZeroPadded(int Length, bool value);
AnsiString __fastcall FixedLenZeroPadded(int Length, int value);

//do same with Padding after the value. 
AnsiString __fastcall Pad(int Length, bool value);
AnsiString __fastcall Pad(int Length, int value);
AnsiString __fastcall Pad(int Length, long double value, TFloatFormat format, int precision, int digits);
AnsiString __fastcall Pad(int Length, AnsiString string);

//word extraction functions
//ExtractWord finds the next word followed by 'Delimiter', so if Delimiter = ","
//and string is ",,Hello There, World", it will return "Hello There"
AnsiString __fastcall ExtractWord(AnsiString string, AnsiString Delimiter);
//DeleteWord deletes everything up to and including word, so if word = "There,"
//and string is ",,Hello There, World", it will return " World"
AnsiString __fastcall DeleteWord(AnsiString string, AnsiString word);
//RemoveWord deletes the first occurrence of word, so if word = "There,"
//and string is ",,Hello There, World", it will return ",,Hello  World"
AnsiString __fastcall RemoveWord(AnsiString string, AnsiString word);

//character functions
AnsiString __fastcall RemoveCommas(AnsiString string); //replaces commas with spaces
AnsiString __fastcall RemoveChars(AnsiString string, AnsiString character);
AnsiString __fastcall ReturnSpaceIfNoLength(AnsiString string);
AnsiString __fastcall ReplaceChars(AnsiString string, AnsiString original, AnsiString replacement);
AnsiString __fastcall LeftString(AnsiString string, int Length);
AnsiString __fastcall RightString(AnsiString string, int Length);
AnsiString __fastcall ChopOffFirstChars(AnsiString string, int Length);
AnsiString __fastcall ChopOffLastChars(AnsiString string, int Length);
AnsiString __fastcall ExtractString(AnsiString string, int Start, int Length);
int __fastcall AnyLettersPresent(AnsiString string);
int __fastcall AnyofTheseCharsPresent(AnsiString List, AnsiString string);

//format functions
AnsiString __fastcall DecimalPlaces(int decimalplaces, int value);
AnsiString __fastcall DecimalPlaces(int decimalplaces, double value);
AnsiString __fastcall DP(int decimalplaces, double value);
AnsiString __fastcall IntToHex(int value);

//String length functions
AnsiString __fastcall RemoveLeftChars(int numberofchars, AnsiString string);

//String Date functions
TDate __fastcall GetDate(AnsiString date);

//angle functions
AnsiString __fastcall HourMinSec(double Angle);


#endif

