//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "ThreadConversion.h"
#include "StringHelp.h"
#include "MathsHelp.h"
#include <shellapi.h>
#include <clipbrd.hpp>
#include "CustomDither.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TThreadConversionForm *ThreadConversionForm;
//---------------------------------------------------------------------------
__fastcall TThreadConversionForm::TThreadConversionForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TThreadConversionForm::UpDown1Click(TObject *Sender,
      TUDBtnType Button)
{
    numberofdivisions = (int) UpDown1->Position;
    Label2->Caption = "Possible numbers of Colours  " + AnsiString((numberofdivisions + 2) * (numberofdivisions + 2)* (numberofdivisions + 2));
    FillThreadImage();
}
//---------------------------------------------------------------------------

void __fastcall TThreadConversionForm::FillThreadImage(void)
{
    if (BlendThreads->Checked) {
        FullBlend();
        } else {
        NoBlend();
        }
}
//---------------------------------------------------------------------------

void __fastcall TThreadConversionForm::FullBlend(void)
{
    Screen->Cursor = crHourGlass;

    //save undo data
    if (!Image2->Picture->Bitmap->Empty) {
        Graphics::TBitmap *TempPicture = new Graphics::TBitmap();
        TempPicture->Assign(Image2->Picture->Bitmap);
        UndoList->Expand();
        UndoList->Add(TempPicture);
        RetrieveData();
        UndoConvList.Length++;
        UndoConvList[UndoConvList.Length - 1] = Conversion;
        UndoButton->Enabled = (UndoList->Count > 0);
        }
    //check that there are enough points in the lasso and set it to no lasso if that's the case.
    if ((LassoType == TFlexLasso && Points.Length <3) || ((LassoType == TNoLasso || LassoType == TRectLasso) && Points.Length != 4)) {
        Points.Length = 4;
        Points[0].x = 0;
        Points[0].y = 0;
        Points[1].x = Picture->Width;
        Points[1].y = 0;
        Points[2].x = Picture->Width;
        Points[2].y = Picture->Height;
        Points[3].x = 0;
        Points[3].y = Picture->Height;
        LassoType = TNoLasso;
        Image1->Picture->Bitmap->Assign(Picture);
        }
    //Change size
    Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
    int numpoints = Points.Length;
    POINT vertexes [700];
    if (ImageHeight->Text.ToIntDef(Image1->Picture->Bitmap->Height) == Image1->Picture->Bitmap->Height) {
        //Same Size in and out
        Bitmap->Width = Image1->Picture->Bitmap->Width;
        Bitmap->Height = Image1->Picture->Bitmap->Height;
        //Bitmap->Assign(Image1->Picture->Bitmap);
        Bitmap->Assign(Picture);
        Image2->Picture->Bitmap->Width = Bitmap->Width;
        Image2->Picture->Bitmap->Height = Bitmap->Height;
        Image2->Width = Bitmap->Width;
        Image2->Height = Bitmap->Height;
        //Image3->Top = Image2->Top + Image2->Height + 24;
        //Label25->Top = Image3->Top - 16;
        //Image3->Picture->Bitmap->Width = Bitmap->Width;
        //Image3->Picture->Bitmap->Height = Bitmap->Height;
        //Image3->Width = Bitmap->Width;
        //Image3->Height = Bitmap->Height;

        //making vertexes for region
        for (int i = 0; i < Points.Length; i++) {
            vertexes[i].x = Points[i].x;
            vertexes[i].y = Points[i].y;
            }
        } else {
        //size changes
        Bitmap->Width = ImageWidth->Text.ToIntDef(Image1->Picture->Bitmap->Width);
        Bitmap->Height = Image1->Picture->Bitmap->Height * Bitmap->Width / Image1->Picture->Bitmap->Width;
        Image2->Picture->Bitmap->Width = Bitmap->Width;
        Image2->Picture->Bitmap->Height = Bitmap->Height;
        Image2->Width = Bitmap->Width;
        Image2->Height = Bitmap->Height;
        //Image3->Top = Image2->Top + Image2->Height + 24;
        //Label25->Top = Image3->Top - 16;
        //Image3->Picture->Bitmap->Width = Bitmap->Width;
        //Image3->Picture->Bitmap->Height = Bitmap->Height;
        //Image3->Width = Bitmap->Width;
        //Image3->Height = Bitmap->Height;
        //variables
        //with any luck this'll be much faster
        TRect Rectangle;
        Rectangle.Left = 0;
        Rectangle.Top = 0;
        Rectangle.Bottom = Bitmap->Height;
        Rectangle.Right = Bitmap->Width;
        Bitmap->Canvas->StretchDraw(Rectangle,Image1->Picture->Bitmap);
        } //end of'if (ImageHeight->Text.ToIntDef(Image1->Picture->Bitmap->Height) == Image1->Picture->Bitmap->Height)'

    //OK, set up region
    HRGN Region = CreatePolygonRgn(vertexes,numpoints,WINDING);
    bool paintoutside = BlankOutsideSelection->Checked;
    TColor paintcolour = DMCColourList[FillColour->ItemIndex].Colour;
    //now create a combined dmc/tweed list
    DynamicArray <DMCColourData> CompleteColourList;
    CompleteColourList.Length = DMCColourList.Length + TweedList.Length;
    for (int i = 0; i < DMCColourList.Length; i++) {
        CompleteColourList[i] = DMCColourList[i];
        }
    int tweedarrayoffset = DMCColourList.Length;
    for (int i = 0; i < TweedList.Length; i++) {
        CompleteColourList[i + tweedarrayoffset] = TweedList[i].Data;
        }

    //colour conversion
    //starting point is the scaled image in 'Bitmap'
    DynamicArray <coloursub> ColourSub;
    DynamicArray <int> ColourSquares;
    DynamicArray <double> HSBSquares;
    DynamicArray <bool> DMCColourUsed;
    DMCColourUsed.Length = DMCColourList.Length;
    for (int i = 0; i < DMCColourUsed.Length; i++) {
        DMCColourUsed[i] = false;
        }
    ColourSquares.Length = CompleteColourList.Length;
    if (numberofdivisions > 255) numberofdivisions = 255;
    if (numberofdivisions < 1) numberofdivisions = 1;
    TColor tempcolour, newcolour/*, newcolour2*/;
    rgb splitrgb,modified,quanterror,modified2;
    //for 'find thread colour'
    bool found;
    int pointer, pointer2, value;
    hsb HSB;
    double HSBValue;
    int colweighting = Edit1->Text.ToIntDef(100);
    int redweighting = Edit2->Text.ToIntDef(100);
    int greenweighting = Edit3->Text.ToIntDef(100);
    int blueweighting = Edit4->Text.ToIntDef(100);
    double Hueweighting = ToDoubleDef(Edit6->Text,100.0)/100.0;
    double Satweighting = ToDoubleDef(Edit7->Text,100.0)/100.0;
    double Brightweighting = ToDoubleDef(Edit8->Text,100.0)/100.0;
    double HSBweighting = ToDoubleDef(Edit5->Text,100.0)/100.0;
    double deltahue;
    //safety check to see that a weighting exists
    if ((colweighting == 0 && HSBweighting == 0.0) || (HSBweighting == 0.0 && colweighting != 0 && redweighting == 0 && greenweighting == 0 && blueweighting == 0) || (colweighting == 0 && HSBweighting != 0.0 && Hueweighting == 0.0 && Satweighting == 0.0 && Brightweighting == 0.0)) {
        colweighting = 100;
        Edit1->Text = "100";
        if (redweighting == 0 && greenweighting == 0 && blueweighting == 0) {
            redweighting = 100;
            greenweighting = 100;
            blueweighting = 100;
            Edit2->Text = "100";
            Edit3->Text = "100";
            Edit4->Text = "100";
            }
        }
    //doing things now
    double numb = (double) numberofdivisions;
    bool yes;

    for (int i = 0; i < Bitmap->Width; i++) {
        for (int j = 0; j < Bitmap->Height; j++) {
            //find image2 colour
            tempcolour = Bitmap->Canvas->Pixels[i][j];
            splitrgb = ExtractRGB(tempcolour);
            modified.R = (int)(ROUND(((double)splitrgb.R)*numb/255.0,0) * 255.0 / numb);
            modified.G = (int)(ROUND(((double)splitrgb.G)*numb/255.0,0) * 255.0 / numb);
            modified.B = (int)(ROUND(((double)splitrgb.B)*numb/255.0,0) * 255.0 / numb);
            modified2.R = splitrgb.R*numb/255;
            modified2.R = modified2.R * 255/numb;
            modified2.G = splitrgb.G*numb/255;
            modified2.G = modified2.G * 255/numb;
            modified2.B = splitrgb.B*numb/255;
            modified2.B = modified2.B * 255/numb;

            newcolour = GetColourFromRGB(modified);
            //newcolour2 = GetColourFromRGB(modified2);
            //find thread colour
            found = false;
            pointer = 0;
            while (!found && pointer < ColourSub.Length) {
                if (ColourSub[pointer].Original == newcolour) {
                    found = true;
                    pointer--;
                    }
                pointer++;
                }
            if (!found) {
                //thread colour hasn't been used yet, so find what to put in its place.
                HSB = RGBtoHSB(modified);
                for (int k = 0; k < CompleteColourList.Length; k++) {
                    //hues can never be more than 180 degrees away from each other, so hue 1 deg and 359 deg are only 2 degrees away from each other, not 358.
                    deltahue = max(HSB.Hue,CompleteColourList[k].Hue) - min(HSB.Hue,CompleteColourList[k].Hue);
                    if (fabs(deltahue) > 180.0) deltahue = 360 - deltahue;
                    ColourSquares[k] = colweighting * (redweighting * (modified.R - CompleteColourList[k].R) * (modified.R - CompleteColourList[k].R) + greenweighting * (modified.G - CompleteColourList[k].G) * (modified.G - CompleteColourList[k].G) + blueweighting * (modified.B - CompleteColourList[k].B) * (modified.B - CompleteColourList[k].B))/(100 * 100);
                    //HSBValue = Hueweighting * pow(((HSB.Hue - DMCColourList[k].Hue))/360.0,2.0) + Satweighting * (HSB.Saturation - DMCColourList[k].Saturation) * (HSB.Saturation - DMCColourList[k].Saturation) + Brightweighting * (HSB.Brightness - DMCColourList[k].Brightness) * (HSB.Brightness - DMCColourList[k].Brightness);
                    HSBValue = Hueweighting * pow(deltahue/180.0,2.0) + Satweighting * (HSB.Saturation - CompleteColourList[k].Saturation) * (HSB.Saturation - CompleteColourList[k].Saturation) + Brightweighting * (HSB.Brightness - CompleteColourList[k].Brightness) * (HSB.Brightness - CompleteColourList[k].Brightness);
                    ColourSquares[k] += (int) (HSBValue * HSBweighting * 65536.0);
                    }
                pointer2 = 0;
                value = ColourSquares[0];
                for (int k = 1; k < ColourSquares.Length; k++) {
                    if (ColourSquares[k] < value) {
                        value = ColourSquares[k];
                        pointer2 = k;
                        }
                    }
                pointer = ColourSub.Length;
                ColourSub.Length++;
                ColourSub[pointer].Original = newcolour;
                ColourSub[pointer].Used = CompleteColourList[pointer2].Colour;
                //now to indicate which colours are used
                if (pointer2 < tweedarrayoffset) {
                    DMCColourUsed[pointer2] = true;
                    } else {
                    DMCColourUsed[TweedList[pointer2 - tweedarrayoffset].ColourPairs[0].x] = true;
                    DMCColourUsed[TweedList[pointer2 - tweedarrayoffset].ColourPairs[0].y] = true;
                    }
                }
            //Image2->Picture->Bitmap->Canvas->Pixels[i][j] = ColourSub[pointer].Used;
            //if it's in the region to be converted, allow the pixel to be modified
            if (LassoType != TNoLasso) {
                yes = PtInRegion(Region,i,j);
                } else {
                yes = true;
                }
            if (yes) {
                Image2->Picture->Bitmap->Canvas->Pixels[i][j] = ColourSub[pointer].Used;
                } else {
                if (paintoutside) Image2->Picture->Bitmap->Canvas->Pixels[i][j] = paintcolour;
                }
            //if (PtInRegion(Region,i,j))Image2->Picture->Bitmap->Canvas->Pixels[i][j] = ColourSub[pointer].Used;
            if (Dithering->Checked) {
                //now to go through the dithering process
                quanterror = SubtractRGB(splitrgb,ExtractRGB(ColourSub[pointer].Used));
                switch(RadioGroup1->ItemIndex) {
                    case 8:     {
                                //User Defined dither
                                if (i < Bitmap->Width - 1) {
                                    Bitmap->Canvas->Pixels[i + 1][j] = GetColour(Bitmap->Canvas->Pixels[i + 1][j],quanterror,UserDefinedDither[0],UserDefinedDither[12]);
                                    }
                                if (i < Bitmap->Width - 2) {
                                    Bitmap->Canvas->Pixels[i + 2][j] = GetColour(Bitmap->Canvas->Pixels[i + 2][j],quanterror,UserDefinedDither[1],UserDefinedDither[12]);
                                    }
                                if (j < Bitmap->Height - 1) {
                                    if (i > 1) {
                                        Bitmap->Canvas->Pixels[i - 2][j + 1] = GetColour(Bitmap->Canvas->Pixels[i - 2][j + 1],quanterror,UserDefinedDither[2],UserDefinedDither[12]);
                                        }
                                    if (i > 0) {
                                        Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i - 1][j + 1],quanterror,UserDefinedDither[3],UserDefinedDither[12]);
                                        }
                                    Bitmap->Canvas->Pixels[i][j + 1] = GetColour(Bitmap->Canvas->Pixels[i][j + 1],quanterror,UserDefinedDither[4],UserDefinedDither[12]);
                                    if (i < Bitmap->Width - 1) {
                                        Bitmap->Canvas->Pixels[i + 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i + 1][j + 1],quanterror,UserDefinedDither[5],UserDefinedDither[12]);
                                        }
                                    if (i < Bitmap->Width - 2) {
                                        Bitmap->Canvas->Pixels[i + 2][j + 1] = GetColour(Bitmap->Canvas->Pixels[i + 2][j + 1],quanterror,UserDefinedDither[6],UserDefinedDither[12]);
                                        }
                                    }
                                if (j < Bitmap->Height - 2) {
                                    if (i > 1) {
                                        Bitmap->Canvas->Pixels[i - 2][j + 2] = GetColour(Bitmap->Canvas->Pixels[i - 2][j + 2],quanterror,UserDefinedDither[7],UserDefinedDither[12]);
                                        }
                                    if (i > 0) {
                                        Bitmap->Canvas->Pixels[i - 1][j + 2] = GetColour(Bitmap->Canvas->Pixels[i - 1][j + 2],quanterror,UserDefinedDither[8],UserDefinedDither[12]);
                                        }
                                    Bitmap->Canvas->Pixels[i][j + 2] = GetColour(Bitmap->Canvas->Pixels[i][j + 2],quanterror,UserDefinedDither[9],UserDefinedDither[12]);
                                    if (i < Bitmap->Width - 1) {
                                        Bitmap->Canvas->Pixels[i + 1][j + 2] = GetColour(Bitmap->Canvas->Pixels[i + 1][j + 2],quanterror,UserDefinedDither[10],UserDefinedDither[12]);
                                        }
                                    if (i < Bitmap->Width - 2) {
                                        Bitmap->Canvas->Pixels[i + 2][j + 2] = GetColour(Bitmap->Canvas->Pixels[i + 2][j + 2],quanterror,UserDefinedDither[11],UserDefinedDither[12]);
                                        }
                                    }
                                }
                                break;
                    case 7:     {
                                //Chestnut Pens random dither 2
                                //based on Sierra 2-4a
                                int factora = random(4);
                                int factorb = random(2);
                                int factorc = random(2);
                                int divisor = factora + factorb + factorc;
                                if (divisor == 0) divisor = 1;
                                if (i < Bitmap->Width - 1) {
                                    //Bitmap->Canvas->Pixels[i + 1][j] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j]),DivideRGB(MultiplyRGB(quanterror,factora),divisor)));
                                    Bitmap->Canvas->Pixels[i + 1][j] = GetColour(Bitmap->Canvas->Pixels[i + 1][j],quanterror,factora,divisor);
                                    }
                                if (j < Bitmap->Height - 1) {
                                    if (i > 0) {
                                        //Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 1][j + 1]),DivideRGB(MultiplyRGB(quanterror,factorb),divisor)));
                                        Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i - 1][j + 1],quanterror,factorb,divisor);
                                        }
                                    //Bitmap->Canvas->Pixels[i][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i][j + 1]),DivideRGB(MultiplyRGB(quanterror,factorc),divisor)));
                                    Bitmap->Canvas->Pixels[i][j + 1] = GetColour(Bitmap->Canvas->Pixels[i][j + 1],quanterror,factorc,divisor);
                                    }
                                }
                                break;
                    case 6:     {
                                //Chestnut Pens random dither 1
                                //based on Jarvis
                                int factora = random(9);
                                int factorb = random(7);
                                int factorc = random(6);
                                int factord = random(7);
                                int factore = random(9);
                                int factorf = random(7);
                                int factorg = random(5);
                                int factorh = random(3);
                                int factori = random(5);
                                int factorj = random(7);
                                int factork = random(5);
                                int factorl = random(3);
                                int divisor = factora + factorb + factorc + factord + factore + factorf + factorg + factorh + factori + factorj + factork + factorl;
                                if (divisor == 0) divisor = 1;
                                if (i < Bitmap->Width - 1) {
                                    //Bitmap->Canvas->Pixels[i + 1][j] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j]),DivideRGB(MultiplyRGB(quanterror,factora),divisor)));
                                    Bitmap->Canvas->Pixels[i + 1][j] = GetColour(Bitmap->Canvas->Pixels[i + 1][j],quanterror,factora,divisor);
                                    }
                                if (i < Bitmap->Width - 2) {
                                    //Bitmap->Canvas->Pixels[i + 2][j] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 2][j]),DivideRGB(MultiplyRGB(quanterror,factorb),divisor)));
                                    Bitmap->Canvas->Pixels[i + 2][j] = GetColour(Bitmap->Canvas->Pixels[i + 2][j],quanterror,factorb,divisor);
                                    }
                                if (j < Bitmap->Height - 1) {
                                    if (i > 1) {
                                        //Bitmap->Canvas->Pixels[i - 2][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 2][j + 1]),DivideRGB(MultiplyRGB(quanterror,factorc),divisor)));
                                        Bitmap->Canvas->Pixels[i - 2][j + 1] = GetColour(Bitmap->Canvas->Pixels[i - 2][j + 1],quanterror,factorc,divisor);
                                        }
                                    if (i > 0) {
                                        //Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 1][j + 1]),DivideRGB(MultiplyRGB(quanterror,factord),divisor)));
                                        Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i - 1][j + 1],quanterror,factord,divisor);
                                        }
                                    //Bitmap->Canvas->Pixels[i][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i][j + 1]),DivideRGB(MultiplyRGB(quanterror,factore),divisor)));
                                    Bitmap->Canvas->Pixels[i][j + 1] = GetColour(Bitmap->Canvas->Pixels[i][j + 1],quanterror,factore,divisor);
                                    if (i < Bitmap->Width - 1) {
                                        //Bitmap->Canvas->Pixels[i + 1][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j + 1]),DivideRGB(MultiplyRGB(quanterror,factorf),divisor)));
                                        Bitmap->Canvas->Pixels[i + 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i + 1][j + 1],quanterror,factorf,divisor);
                                        }
                                    if (i < Bitmap->Width - 2) {
                                        //Bitmap->Canvas->Pixels[i + 2][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 2][j + 1]),DivideRGB(MultiplyRGB(quanterror,factorg),divisor)));
                                        Bitmap->Canvas->Pixels[i + 2][j + 1] = GetColour(Bitmap->Canvas->Pixels[i + 2][j + 1],quanterror,factorg,divisor);
                                        }
                                    }
                                if (j < Bitmap->Height - 2) {
                                    if (i > 1) {
                                        //Bitmap->Canvas->Pixels[i - 2][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 2][j + 2]),DivideRGB(MultiplyRGB(quanterror,factorh),divisor)));
                                        Bitmap->Canvas->Pixels[i - 2][j + 2] = GetColour(Bitmap->Canvas->Pixels[i - 2][j + 2],quanterror,factorh,divisor);
                                        }
                                    if (i > 0) {
                                        //Bitmap->Canvas->Pixels[i - 1][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 1][j + 2]),DivideRGB(MultiplyRGB(quanterror,factori),divisor)));
                                        Bitmap->Canvas->Pixels[i - 1][j + 2] = GetColour(Bitmap->Canvas->Pixels[i - 1][j + 2],quanterror,factori,divisor);
                                        }
                                    //Bitmap->Canvas->Pixels[i][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i][j + 2]),DivideRGB(MultiplyRGB(quanterror,factorj),divisor)));
                                    Bitmap->Canvas->Pixels[i][j + 2] = GetColour(Bitmap->Canvas->Pixels[i][j + 2],quanterror,factorj,divisor);
                                    if (i < Bitmap->Width - 1) {
                                        //Bitmap->Canvas->Pixels[i + 1][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j + 2]),DivideRGB(MultiplyRGB(quanterror,factork),divisor)));
                                        Bitmap->Canvas->Pixels[i + 1][j + 2] = GetColour(Bitmap->Canvas->Pixels[i + 1][j + 2],quanterror,factork,divisor);
                                        }
                                    if (i < Bitmap->Width - 2) {
                                        //Bitmap->Canvas->Pixels[i + 2][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 2][j + 2]),DivideRGB(MultiplyRGB(quanterror,factorl),divisor)));
                                        Bitmap->Canvas->Pixels[i + 2][j + 2] = GetColour(Bitmap->Canvas->Pixels[i + 2][j + 2],quanterror,factorl,divisor);
                                        }
                                    }
                                }
                                break;
                    case 5:     {
                                //Sierra2-4a
                                if (i < Bitmap->Width - 1) {
                                    //Bitmap->Canvas->Pixels[i + 1][j] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j]),DivideRGB(MultiplyRGB(quanterror,2),4)));
                                    Bitmap->Canvas->Pixels[i + 1][j] = GetColour(Bitmap->Canvas->Pixels[i + 1][j],quanterror,2,4);
                                    }
                                if (j < Bitmap->Height - 1) {
                                    if (i > 0) {
                                        //Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 1][j + 1]),DivideRGB(quanterror,4)));
                                        Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i - 1][j + 1],quanterror,1,4);
                                        }
                                    //Bitmap->Canvas->Pixels[i][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i][j + 1]),DivideRGB(quanterror,4)));
                                    Bitmap->Canvas->Pixels[i][j + 1] = GetColour(Bitmap->Canvas->Pixels[i][j + 1],quanterror,1,4);
                                    }
                                }
                                break;
                    case 4:     {
                                //Sierra
                                if (i < Bitmap->Width - 1) {
                                    //Bitmap->Canvas->Pixels[i + 1][j] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j]),DivideRGB(MultiplyRGB(quanterror,5),32)));
                                    Bitmap->Canvas->Pixels[i + 1][j] = GetColour(Bitmap->Canvas->Pixels[i + 1][j],quanterror,5,32);
                                    }
                                if (i < Bitmap->Width - 2) {
                                    //Bitmap->Canvas->Pixels[i + 2][j] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 2][j]),DivideRGB(MultiplyRGB(quanterror,3),32)));
                                    Bitmap->Canvas->Pixels[i + 2][j] = GetColour(Bitmap->Canvas->Pixels[i + 2][j],quanterror,3,32);
                                    }
                                if (j < Bitmap->Height - 1) {
                                    if (i > 1) {
                                        //Bitmap->Canvas->Pixels[i - 2][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 2][j + 1]),DivideRGB(MultiplyRGB(quanterror,2),32)));
                                        Bitmap->Canvas->Pixels[i - 2][j + 1] = GetColour(Bitmap->Canvas->Pixels[i - 2][j + 1],quanterror,2,32);
                                        }
                                    if (i > 0) {
                                        //Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 1][j + 1]),DivideRGB(MultiplyRGB(quanterror,4),32)));
                                        Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i - 1][j + 1],quanterror,4,32);
                                        }
                                    //Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 1][j + 1]),DivideRGB(MultiplyRGB(quanterror,4),32)));
                                    Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i - 1][j + 1],quanterror,4,32);
                                    if (i < Bitmap->Width - 1) {
                                        //Bitmap->Canvas->Pixels[i + 1][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j + 1]),DivideRGB(MultiplyRGB(quanterror,4),32)));
                                        Bitmap->Canvas->Pixels[i + 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i + 1][j + 1],quanterror,4,32);
                                        }
                                    if (i < Bitmap->Width - 2) {
                                        //Bitmap->Canvas->Pixels[i + 2][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 2][j + 1]),DivideRGB(MultiplyRGB(quanterror,2),32)));
                                        Bitmap->Canvas->Pixels[i + 2][j + 1] = GetColour(Bitmap->Canvas->Pixels[i + 2][j + 1],quanterror,2,32);
                                        }
                                    }
                                if (j < Bitmap->Height - 2) {
                                    if (i > 0) {
                                        //Bitmap->Canvas->Pixels[i - 1][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 1][j + 2]),DivideRGB(MultiplyRGB(quanterror,2),32)));
                                        Bitmap->Canvas->Pixels[i - 1][j + 2] = GetColour(Bitmap->Canvas->Pixels[i - 1][j + 2],quanterror,2,32);
                                        }
                                    //Bitmap->Canvas->Pixels[i][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i][j + 2]),DivideRGB(MultiplyRGB(quanterror,3),32)));
                                    Bitmap->Canvas->Pixels[i][j + 2] = GetColour(Bitmap->Canvas->Pixels[i][j + 2],quanterror,3,32);
                                    if (i < Bitmap->Width - 1) {
                                        //Bitmap->Canvas->Pixels[i + 1][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j + 2]),DivideRGB(MultiplyRGB(quanterror,2),32)));
                                        Bitmap->Canvas->Pixels[i + 1][j + 2] = GetColour(Bitmap->Canvas->Pixels[i + 1][j + 2],quanterror,2,32);
                                        }
                                    }
                                }
                                break;
                    case 3:     {
                                //Burkes
                                if (i < Bitmap->Width - 1) {
                                    //Bitmap->Canvas->Pixels[i + 1][j] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j]),DivideRGB(MultiplyRGB(quanterror,8),32)));
                                    Bitmap->Canvas->Pixels[i + 1][j] = GetColour(Bitmap->Canvas->Pixels[i + 1][j],quanterror,8,32);
                                    }
                                if (i < Bitmap->Width - 2) {
                                    //Bitmap->Canvas->Pixels[i + 2][j] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 2][j]),DivideRGB(MultiplyRGB(quanterror,4),32)));
                                    Bitmap->Canvas->Pixels[i + 2][j] = GetColour(Bitmap->Canvas->Pixels[i + 2][j],quanterror,4,32);
                                    }
                                if (j < Bitmap->Height - 1) {
                                    if (i > 1) {
                                        //Bitmap->Canvas->Pixels[i - 2][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 2][j + 1]),DivideRGB(MultiplyRGB(quanterror,2),32)));
                                        Bitmap->Canvas->Pixels[i - 2][j + 1] = GetColour(Bitmap->Canvas->Pixels[i - 2][j + 1],quanterror,2,32);
                                        }
                                    if (i > 0) {
                                        //Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 1][j + 1]),DivideRGB(MultiplyRGB(quanterror,4),32)));
                                        Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i - 1][j + 1],quanterror,4,32);
                                        }
                                    //Bitmap->Canvas->Pixels[i][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i][j + 1]),DivideRGB(MultiplyRGB(quanterror,8),32)));
                                    Bitmap->Canvas->Pixels[i][j + 1] = GetColour(Bitmap->Canvas->Pixels[i][j + 1],quanterror,8,32);
                                    if (i < Bitmap->Width - 1) {
                                        //Bitmap->Canvas->Pixels[i + 1][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j + 1]),DivideRGB(MultiplyRGB(quanterror,4),32)));
                                        Bitmap->Canvas->Pixels[i + 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i + 1][j + 1],quanterror,4,32);
                                        }
                                    if (i < Bitmap->Width - 2) {
                                        //Bitmap->Canvas->Pixels[i + 2][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 2][j + 1]),DivideRGB(MultiplyRGB(quanterror,2),32)));
                                        Bitmap->Canvas->Pixels[i + 2][j + 1] = GetColour(Bitmap->Canvas->Pixels[i + 2][j + 1],quanterror,2,32);
                                        }
                                    }
                                }
                                break;
                    case 2:     {
                                //Stuki
                                if (i < Bitmap->Width - 1) {
                                    //Bitmap->Canvas->Pixels[i + 1][j] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j]),DivideRGB(MultiplyRGB(quanterror,8),42)));
                                    Bitmap->Canvas->Pixels[i + 1][j] = GetColour(Bitmap->Canvas->Pixels[i + 1][j],quanterror,8,42);
                                    }
                                if (i < Bitmap->Width - 2) {
                                    //Bitmap->Canvas->Pixels[i + 2][j] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 2][j]),DivideRGB(MultiplyRGB(quanterror,4),42)));
                                    Bitmap->Canvas->Pixels[i + 2][j] = GetColour(Bitmap->Canvas->Pixels[i + 2][j],quanterror,4,42);
                                    }
                                if (j < Bitmap->Height - 1) {
                                    if (i > 1) {
                                        //Bitmap->Canvas->Pixels[i - 2][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 2][j + 1]),DivideRGB(MultiplyRGB(quanterror,2),42)));
                                        Bitmap->Canvas->Pixels[i - 2][j + 1] = GetColour(Bitmap->Canvas->Pixels[i - 2][j + 1],quanterror,2,42);
                                        }
                                    if (i > 0) {
                                        //Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 1][j + 1]),DivideRGB(MultiplyRGB(quanterror,4),42)));
                                        Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i - 1][j + 1],quanterror,4,42);
                                        }
                                    //Bitmap->Canvas->Pixels[i][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i][j + 1]),DivideRGB(MultiplyRGB(quanterror,8),42)));
                                    Bitmap->Canvas->Pixels[i][j + 1] = GetColour(Bitmap->Canvas->Pixels[i][j + 1],quanterror,8,42);
                                    if (i < Bitmap->Width - 1) {
                                        //Bitmap->Canvas->Pixels[i + 1][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j + 1]),DivideRGB(MultiplyRGB(quanterror,4),42)));
                                        Bitmap->Canvas->Pixels[i + 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i + 1][j + 1],quanterror,4,42);
                                        }
                                    if (i < Bitmap->Width - 2) {
                                        //Bitmap->Canvas->Pixels[i + 2][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 2][j + 1]),DivideRGB(MultiplyRGB(quanterror,2),42)));
                                        Bitmap->Canvas->Pixels[i + 2][j + 1] = GetColour(Bitmap->Canvas->Pixels[i + 2][j + 1],quanterror,2,42);
                                        }
                                    }
                                if (j < Bitmap->Height - 2) {
                                    if (i > 1) {
                                        //Bitmap->Canvas->Pixels[i - 2][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 2][j + 2]),DivideRGB(MultiplyRGB(quanterror,1),42)));
                                        Bitmap->Canvas->Pixels[i - 2][j + 2] = GetColour(Bitmap->Canvas->Pixels[i - 2][j + 2],quanterror,1,42);
                                        }
                                    if (i > 0) {
                                        //Bitmap->Canvas->Pixels[i - 1][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 1][j + 2]),DivideRGB(MultiplyRGB(quanterror,2),42)));
                                        Bitmap->Canvas->Pixels[i - 1][j + 2] = GetColour(Bitmap->Canvas->Pixels[i - 1][j + 2],quanterror,2,42);
                                        }
                                    //Bitmap->Canvas->Pixels[i][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i][j + 2]),DivideRGB(MultiplyRGB(quanterror,4),42)));
                                    Bitmap->Canvas->Pixels[i][j + 2] = GetColour(Bitmap->Canvas->Pixels[i][j + 2],quanterror,4,42);
                                    if (i < Bitmap->Width - 1) {
                                        //Bitmap->Canvas->Pixels[i + 1][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j + 2]),DivideRGB(MultiplyRGB(quanterror,2),42)));
                                        Bitmap->Canvas->Pixels[i + 1][j + 2] = GetColour(Bitmap->Canvas->Pixels[i + 1][j + 2],quanterror,2,42);
                                        }
                                    if (i < Bitmap->Width - 2) {
                                        //Bitmap->Canvas->Pixels[i + 2][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 2][j + 2]),DivideRGB(MultiplyRGB(quanterror,1),42)));
                                        Bitmap->Canvas->Pixels[i + 2][j + 2] = GetColour(Bitmap->Canvas->Pixels[i + 2][j + 2],quanterror,1,42);
                                        }
                                    }
                                }
                                break;
                    case 1:     {
                                //Jarvis et al
                                if (i < Bitmap->Width - 1) {
                                    //Bitmap->Canvas->Pixels[i + 1][j] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j]),DivideRGB(MultiplyRGB(quanterror,7),48)));
                                    Bitmap->Canvas->Pixels[i + 1][j] = GetColour(Bitmap->Canvas->Pixels[i + 1][j],quanterror,7,48);
                                    }
                                if (i < Bitmap->Width - 2) {
                                    //Bitmap->Canvas->Pixels[i + 2][j] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 2][j]),DivideRGB(MultiplyRGB(quanterror,5),48)));
                                    Bitmap->Canvas->Pixels[i + 2][j] = GetColour(Bitmap->Canvas->Pixels[i + 2][j],quanterror,5,48);
                                    }
                                if (j < Bitmap->Height - 1) {
                                    if (i > 1) {
                                        //Bitmap->Canvas->Pixels[i - 2][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 2][j + 1]),DivideRGB(MultiplyRGB(quanterror,3),48)));
                                        Bitmap->Canvas->Pixels[i - 2][j + 1] = GetColour(Bitmap->Canvas->Pixels[i - 2][j + 1],quanterror,3,48);
                                        }
                                    if (i > 0) {
                                        //Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 1][j + 1]),DivideRGB(MultiplyRGB(quanterror,5),48)));
                                        Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i - 1][j + 1],quanterror,5,48);
                                        }
                                    //Bitmap->Canvas->Pixels[i][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i][j + 1]),DivideRGB(MultiplyRGB(quanterror,7),48)));
                                    Bitmap->Canvas->Pixels[i][j + 1] = GetColour(Bitmap->Canvas->Pixels[i][j + 1],quanterror,7,48);
                                    if (i < Bitmap->Width - 1) {
                                        //Bitmap->Canvas->Pixels[i + 1][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j + 1]),DivideRGB(MultiplyRGB(quanterror,5),48)));
                                        Bitmap->Canvas->Pixels[i + 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i + 1][j + 1],quanterror,5,48);
                                        }
                                    if (i < Bitmap->Width - 2) {
                                        //Bitmap->Canvas->Pixels[i + 2][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 2][j + 1]),DivideRGB(MultiplyRGB(quanterror,3),48)));
                                        Bitmap->Canvas->Pixels[i + 2][j + 1] = GetColour(Bitmap->Canvas->Pixels[i + 2][j + 1],quanterror,3,48);
                                        }
                                    }
                                if (j < Bitmap->Height - 2) {
                                    if (i > 1) {
                                        //Bitmap->Canvas->Pixels[i - 2][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 2][j + 2]),DivideRGB(MultiplyRGB(quanterror,1),48)));
                                        Bitmap->Canvas->Pixels[i - 2][j + 2] = GetColour(Bitmap->Canvas->Pixels[i - 2][j + 2],quanterror,1,48);
                                        }
                                    if (i > 0) {
                                        //Bitmap->Canvas->Pixels[i - 1][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 1][j + 2]),DivideRGB(MultiplyRGB(quanterror,3),48)));
                                        Bitmap->Canvas->Pixels[i - 1][j + 2] = GetColour(Bitmap->Canvas->Pixels[i - 1][j + 2],quanterror,3,48);
                                        }
                                    //Bitmap->Canvas->Pixels[i][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i][j + 2]),DivideRGB(MultiplyRGB(quanterror,5),48)));
                                    Bitmap->Canvas->Pixels[i][j + 2] = GetColour(Bitmap->Canvas->Pixels[i][j + 2],quanterror,5,48);
                                    if (i < Bitmap->Width - 1) {
                                        //Bitmap->Canvas->Pixels[i + 1][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j + 2]),DivideRGB(MultiplyRGB(quanterror,3),48)));
                                        Bitmap->Canvas->Pixels[i + 1][j + 2] = GetColour(Bitmap->Canvas->Pixels[i + 1][j + 2],quanterror,3,48);
                                        }
                                    if (i < Bitmap->Width - 2) {
                                        //Bitmap->Canvas->Pixels[i + 2][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 2][j + 2]),DivideRGB(MultiplyRGB(quanterror,1),48)));
                                        Bitmap->Canvas->Pixels[i + 2][j + 2] = GetColour(Bitmap->Canvas->Pixels[i + 2][j + 2],quanterror,1,48);
                                        }
                                    }
                                }
                                break;
                    default:    {
                                //Use Floyd Steinberg
                                if (i < Bitmap->Width - 1) {
                                    //Bitmap->Canvas->Pixels[i + 1][j] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j]),DivideRGB(MultiplyRGB(quanterror,7),16)));
                                    Bitmap->Canvas->Pixels[i + 1][j] = GetColour(Bitmap->Canvas->Pixels[i + 1][j],quanterror,7,16);
                                    if (j < Bitmap->Height - 1) {
                                        //Bitmap->Canvas->Pixels[i + 1][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j + 1]),DivideRGB(MultiplyRGB(quanterror,1),16)));
                                        Bitmap->Canvas->Pixels[i + 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i + 1][j + 1],quanterror,1,16);
                                        }
                                    }
                                if (j < Bitmap->Height - 1) {
                                    //Bitmap->Canvas->Pixels[i][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i][j + 1]),DivideRGB(MultiplyRGB(quanterror,5),16)));
                                    Bitmap->Canvas->Pixels[i][j + 1] = GetColour(Bitmap->Canvas->Pixels[i][j + 1],quanterror,5,16);
                                    if (i > 0) {
                                        //Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 1][j + 1]),DivideRGB(MultiplyRGB(quanterror,3),16)));
                                        Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i - 1][j + 1],quanterror,3,16);
                                        }
                                    }
                                }
                                break;
                        }  //end of 'switch'

                } //end of 'if (Dithering->Checked)'
            }
        }

    //delete region
    DeleteObject(Region);

    ColourSub.Length = 0;
    ColourSquares.Length = 0;
    CountBlendColours();
    int threadcounter = 0;
    for (int i = 0; i < DMCColourUsed.Length; i++) {
        if (DMCColourUsed[i]) threadcounter++;
        }
    Label3->Caption = Label3->Caption + ", from " + AnsiString(threadcounter) + " thread colours";
    DMCColourUsed.Length = 0;
    CompleteColourList.Length = 0;

    delete Bitmap;
    Screen->Cursor = crDefault;


}
//---------------------------------------------------------------------------

void __fastcall TThreadConversionForm::CountBlendColours(void)
{
    DynamicArray <TColor> Colours;
    bool found;
    int pointer;
    TColor tempcolour;
    for (int i = 0; i < Image2->Picture->Bitmap->Width; i++) {
        for (int j = 0; j < Image2->Picture->Bitmap->Height; j++) {
            tempcolour = Image2->Picture->Bitmap->Canvas->Pixels[i][j];
            found = false;
            pointer = 0;
            while (!found && pointer < Colours.Length) {
                if (tempcolour == Colours[pointer]) {
                    found = true;
                    }
                pointer++;
                }
            if (!found) {
                Colours.Length++;
                Colours[Colours.Length - 1] = tempcolour;
                }
            }
        }
    Label3->Caption = "Actual # of Blend Colours   " + AnsiString(Colours.Length);
    Colours.Length = 0;

}
//---------------------------------------------------------------------------

void __fastcall TThreadConversionForm::NoBlend(void)
{
    Screen->Cursor = crHourGlass;

    //this routine now incorporates dithering & re-sizing
    //save undo data
    if (!Image2->Picture->Bitmap->Empty) {
        Graphics::TBitmap *TempPicture = new Graphics::TBitmap();
        TempPicture->Assign(Image2->Picture->Bitmap);
        UndoList->Expand();
        UndoList->Add(TempPicture);
        RetrieveData();
        UndoConvList.Length++;
        UndoConvList[UndoConvList.Length - 1] = Conversion;
        UndoButton->Enabled = (UndoList->Count > 0);
        }
    //check that there are enough points in the lasso and set it to no lasso if that's the case.
    if ((LassoType == TFlexLasso && Points.Length <3) || ((LassoType == TNoLasso || LassoType == TRectLasso) && Points.Length != 4)) {
        Points.Length = 4;
        Points[0].x = 0;
        Points[0].y = 0;
        Points[1].x = Picture->Width;
        Points[1].y = 0;
        Points[2].x = Picture->Width;
        Points[2].y = Picture->Height;
        Points[3].x = 0;
        Points[3].y = Picture->Height;
        LassoType = TNoLasso;
        Image1->Picture->Bitmap->Assign(Picture);
        }
    //Change size
    Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
    int numpoints = Points.Length;
    POINT vertexes [700];
    if (ImageHeight->Text.ToIntDef(Image1->Picture->Bitmap->Height) == Image1->Picture->Bitmap->Height) {
        //Same Size in and out
        Bitmap->Width = Image1->Picture->Bitmap->Width;
        Bitmap->Height = Image1->Picture->Bitmap->Height;
        //Bitmap->Assign(Image1->Picture->Bitmap);
        Bitmap->Assign(Picture);
        Image2->Picture->Bitmap->Width = Bitmap->Width;
        Image2->Picture->Bitmap->Height = Bitmap->Height;
        Image2->Width = Bitmap->Width;
        Image2->Height = Bitmap->Height;
        //making vertexes for region
        for (int i = 0; i < Points.Length; i++) {
            vertexes[i].x = Points[i].x;
            vertexes[i].y = Points[i].y;
            }
        } else {
        //size changes
        Bitmap->Width = ImageWidth->Text.ToIntDef(Image1->Picture->Bitmap->Width);
        Bitmap->Height = Image1->Picture->Bitmap->Height * Bitmap->Width / Image1->Picture->Bitmap->Width;
        Image2->Picture->Bitmap->Width = Bitmap->Width;
        Image2->Picture->Bitmap->Height = Bitmap->Height;
        Image2->Width = Bitmap->Width;
        Image2->Height = Bitmap->Height;
        //variables
        double scale = ((double) Image1->Picture->Bitmap->Width)/((double)Image2->Picture->Bitmap->Width);
        //double areafactor = scale * scale;
        //redgreenblue RGB;
        //double upperx, lowerx, uppery, lowery;
        //int upperxlim, lowerxlim, upperylim, lowerylim;
        //double xfactor, yfactor;
        //TColor newpixel;
        //making vertexes for region
        for (int i = 0; i < Points.Length; i++) {
            vertexes[i].x = (int)(ROUND(((double)Points[i].x),0)/scale);
            vertexes[i].y = (int)(ROUND(((double)Points[i].y),0)/scale);
            }
        //this is a quicker way to scale the image than I originally wrote. Much less satisfying though!
        TRect Rectangle;
        Rectangle.Left = 0;
        Rectangle.Top = 0;
        Rectangle.Bottom = Bitmap->Height;
        Rectangle.Right = Bitmap->Width;
        Bitmap->Canvas->StretchDraw(Rectangle,Image1->Picture->Bitmap);

        } //end of'if (ImageHeight->Text.ToIntDef(Image1->Picture->Bitmap->Height) == Image1->Picture->Bitmap->Height)'

    //OK, set up region
    HRGN Region = CreatePolygonRgn(vertexes,numpoints,WINDING);
    bool paintoutside = BlankOutsideSelection->Checked;
    TColor paintcolour = DMCColourList[FillColour->ItemIndex].Colour; 
    //colour conversion
    //starting point is the scaled image in 'Bitmap'
    DynamicArray <coloursub> ColourSub;
    DynamicArray <int> ColourSquares;
    DynamicArray <double> HSBSquares;
    ColourSquares.Length = DMCColourList.Length;
    if (numberofdivisions > 255) numberofdivisions = 255;
    if (numberofdivisions < 1) numberofdivisions = 1;
    TColor tempcolour, newcolour;
    rgb splitrgb,modified,quanterror;
    //for 'find thread colour'
    bool found;
    int pointer, pointer2, value;
    hsb HSB;
    double HSBValue;
    int colweighting = Edit1->Text.ToIntDef(100);
    int redweighting = Edit2->Text.ToIntDef(100);
    int greenweighting = Edit3->Text.ToIntDef(100);
    int blueweighting = Edit4->Text.ToIntDef(100);
    double Hueweighting = ToDoubleDef(Edit6->Text,100.0)/100.0;
    double Satweighting = ToDoubleDef(Edit7->Text,100.0)/100.0;
    double Brightweighting = ToDoubleDef(Edit8->Text,100.0)/100.0;
    double HSBweighting = ToDoubleDef(Edit5->Text,100.0)/100.0;
    double deltahue;
    //safety check to see that a weighting exists
    if ((colweighting == 0 && HSBweighting == 0.0) || (HSBweighting == 0.0 && colweighting != 0 && redweighting == 0 && greenweighting == 0 && blueweighting == 0) || (colweighting == 0 && HSBweighting != 0.0 && Hueweighting == 0.0 && Satweighting == 0.0 && Brightweighting == 0.0)) {
        colweighting = 100;
        Edit1->Text = "100";
        if (redweighting == 0 && greenweighting == 0 && blueweighting == 0) {
            redweighting = 100;
            greenweighting = 100;
            blueweighting = 100;
            Edit2->Text = "100";
            Edit3->Text = "100";
            Edit4->Text = "100";
            }
        }
    //doing things now
    double numb = (double) numberofdivisions;
    bool yes;

    for (int i = 0; i < Bitmap->Width; i++) {
        for (int j = 0; j < Bitmap->Height; j++) {
            //find image2 colour
            tempcolour = Bitmap->Canvas->Pixels[i][j];
            splitrgb = ExtractRGB(tempcolour);
            modified.R = (int)(ROUND(((double)splitrgb.R)*numb/255.0,0) * 255.0 / numb);
            modified.G = (int)(ROUND(((double)splitrgb.G)*numb/255.0,0) * 255.0 / numb);
            modified.B = (int)(ROUND(((double)splitrgb.B)*numb/255.0,0) * 255.0 / numb);
            newcolour = GetColourFromRGB(modified);
            //find thread colour
            found = false;
            pointer = 0;
            while (!found && pointer < ColourSub.Length) {
                if (ColourSub[pointer].Original == newcolour) {
                    found = true;
                    pointer--;
                    }
                pointer++;
                }
            if (!found) {
                //thread colour hasn't been used yet, so find what to put in its place.
                HSB = RGBtoHSB(modified);
                for (int k = 0; k < DMCColourList.Length; k++) {
                    //hues can never be more than 180 degrees away from each other, so hue 1 deg and 359 deg are only 2 degrees away from each other, not 358.
                    deltahue = max(HSB.Hue,DMCColourList[k].Hue) - min(HSB.Hue,DMCColourList[k].Hue);
                    if (fabs(deltahue) > 180.0) deltahue = 360 - deltahue;
                    ColourSquares[k] = colweighting * (redweighting * (modified.R - DMCColourList[k].R) * (modified.R - DMCColourList[k].R) + greenweighting * (modified.G - DMCColourList[k].G) * (modified.G - DMCColourList[k].G) + blueweighting * (modified.B - DMCColourList[k].B) * (modified.B - DMCColourList[k].B))/(100 * 100);
                    //HSBValue = Hueweighting * pow(((HSB.Hue - DMCColourList[k].Hue))/360.0,2.0) + Satweighting * (HSB.Saturation - DMCColourList[k].Saturation) * (HSB.Saturation - DMCColourList[k].Saturation) + Brightweighting * (HSB.Brightness - DMCColourList[k].Brightness) * (HSB.Brightness - DMCColourList[k].Brightness);
                    HSBValue = Hueweighting * pow(deltahue/180.0,2.0) + Satweighting * (HSB.Saturation - DMCColourList[k].Saturation) * (HSB.Saturation - DMCColourList[k].Saturation) + Brightweighting * (HSB.Brightness - DMCColourList[k].Brightness) * (HSB.Brightness - DMCColourList[k].Brightness);
                    ColourSquares[k] += (int) (HSBValue * HSBweighting * 65536.0);
                    }
                pointer2 = 0;
                value = ColourSquares[0];
                for (int k = 1; k < ColourSquares.Length; k++) {
                    if (ColourSquares[k] < value) {
                        value = ColourSquares[k];
                        pointer2 = k;
                        }
                    }
                pointer = ColourSub.Length;
                ColourSub.Length++;
                ColourSub[pointer].Original = newcolour;
                ColourSub[pointer].Used = DMCColourList[pointer2].Colour;
                }
            //Image2->Picture->Bitmap->Canvas->Pixels[i][j] = ColourSub[pointer].Used;
            //if it's in the region to be converted, allow the pixel to be modified
            if (LassoType != TNoLasso) {
                yes = PtInRegion(Region,i,j);
                } else {
                yes = true;
                }
            if (yes) {
                Image2->Picture->Bitmap->Canvas->Pixels[i][j] = ColourSub[pointer].Used;
                } else {
                if (paintoutside) Image2->Picture->Bitmap->Canvas->Pixels[i][j] = paintcolour;
                }
            //if (PtInRegion(Region,i,j))Image2->Picture->Bitmap->Canvas->Pixels[i][j] = ColourSub[pointer].Used;
            if (Dithering->Checked) {
                //now to go through the dithering process
                quanterror = SubtractRGB(splitrgb,ExtractRGB(ColourSub[pointer].Used));
                switch(RadioGroup1->ItemIndex) {
                    case 8:     {
                                //User Defined
                                if (i < Bitmap->Width - 1) {
                                    Bitmap->Canvas->Pixels[i + 1][j] = GetColour(Bitmap->Canvas->Pixels[i + 1][j],quanterror,UserDefinedDither[0],UserDefinedDither[12]);
                                    }
                                if (i < Bitmap->Width - 2) {
                                    Bitmap->Canvas->Pixels[i + 2][j] = GetColour(Bitmap->Canvas->Pixels[i + 2][j],quanterror,UserDefinedDither[1],UserDefinedDither[12]);
                                    }
                                if (j < Bitmap->Height - 1) {
                                    if (i > 1) {
                                        Bitmap->Canvas->Pixels[i - 2][j + 1] = GetColour(Bitmap->Canvas->Pixels[i - 2][j + 1],quanterror,UserDefinedDither[2],UserDefinedDither[12]);
                                        }
                                    if (i > 0) {
                                        Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i - 1][j + 1],quanterror,UserDefinedDither[3],UserDefinedDither[12]);
                                        }
                                    Bitmap->Canvas->Pixels[i][j + 1] = GetColour(Bitmap->Canvas->Pixels[i][j + 1],quanterror,UserDefinedDither[4],UserDefinedDither[12]);
                                    if (i < Bitmap->Width - 1) {
                                        Bitmap->Canvas->Pixels[i + 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i + 1][j + 1],quanterror,UserDefinedDither[5],UserDefinedDither[12]);
                                        }
                                    if (i < Bitmap->Width - 2) {
                                        Bitmap->Canvas->Pixels[i + 2][j + 1] = GetColour(Bitmap->Canvas->Pixels[i + 2][j + 1],quanterror,UserDefinedDither[6],UserDefinedDither[12]);
                                        }
                                    }
                                if (j < Bitmap->Height - 2) {
                                    if (i > 1) {
                                        Bitmap->Canvas->Pixels[i - 2][j + 2] = GetColour(Bitmap->Canvas->Pixels[i - 2][j + 2],quanterror,UserDefinedDither[7],UserDefinedDither[12]);
                                        }
                                    if (i > 0) {
                                        Bitmap->Canvas->Pixels[i - 1][j + 2] = GetColour(Bitmap->Canvas->Pixels[i - 1][j + 2],quanterror,UserDefinedDither[8],UserDefinedDither[12]);
                                        }
                                    Bitmap->Canvas->Pixels[i][j + 2] = GetColour(Bitmap->Canvas->Pixels[i][j + 2],quanterror,UserDefinedDither[9],UserDefinedDither[12]);
                                    if (i < Bitmap->Width - 1) {
                                        Bitmap->Canvas->Pixels[i + 1][j + 2] = GetColour(Bitmap->Canvas->Pixels[i + 1][j + 2],quanterror,UserDefinedDither[10],UserDefinedDither[12]);
                                        }
                                    if (i < Bitmap->Width - 2) {
                                        Bitmap->Canvas->Pixels[i + 2][j + 2] = GetColour(Bitmap->Canvas->Pixels[i + 2][j + 2],quanterror,UserDefinedDither[11],UserDefinedDither[12]);
                                        }
                                    }
                                }
                                break;
                    case 7:     {
                                //Chestnut Pens random dither 2
                                //basedon Sierra 2-4a
                                int factora = random(4);
                                int factorb = random(2);
                                int factorc = random(2);
                                int divisor = factora + factorb + factorc;
                                if (divisor == 0) divisor = 1;
                                if (i < Bitmap->Width - 1) {
                                    //Bitmap->Canvas->Pixels[i + 1][j] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j]),DivideRGB(MultiplyRGB(quanterror,factora),divisor)));
                                    Bitmap->Canvas->Pixels[i + 1][j] = GetColour(Bitmap->Canvas->Pixels[i + 1][j],quanterror,factora,divisor);
                                    }
                                if (j < Bitmap->Height - 1) {
                                    if (i > 0) {
                                        //Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 1][j + 1]),DivideRGB(MultiplyRGB(quanterror,factorb),divisor)));
                                        Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i - 1][j + 1],quanterror,factorb,divisor);
                                        }
                                    //Bitmap->Canvas->Pixels[i][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i][j + 1]),DivideRGB(MultiplyRGB(quanterror,factorc),divisor)));
                                    Bitmap->Canvas->Pixels[i][j + 1] = GetColour(Bitmap->Canvas->Pixels[i][j + 1],quanterror,factorc,divisor);
                                    }
                                }
                                break;
                    case 6:     {
                                //Chestnut Pens random dither 1
                                //based on Jarvis
                                int factora = random(9);
                                int factorb = random(7);
                                int factorc = random(6);
                                int factord = random(7);
                                int factore = random(9);
                                int factorf = random(7);
                                int factorg = random(5);
                                int factorh = random(3);
                                int factori = random(5);
                                int factorj = random(7);
                                int factork = random(5);
                                int factorl = random(3);
                                int divisor = factora + factorb + factorc + factord + factore + factorf + factorg + factorh + factori + factorj + factork + factorl;
                                if (divisor == 0) divisor = 1;
                                if (i < Bitmap->Width - 1) {
                                    //Bitmap->Canvas->Pixels[i + 1][j] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j]),DivideRGB(MultiplyRGB(quanterror,factora),divisor)));
                                    Bitmap->Canvas->Pixels[i + 1][j] = GetColour(Bitmap->Canvas->Pixels[i + 1][j],quanterror,factora,divisor);
                                    }
                                if (i < Bitmap->Width - 2) {
                                    //Bitmap->Canvas->Pixels[i + 2][j] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 2][j]),DivideRGB(MultiplyRGB(quanterror,factorb),divisor)));
                                    Bitmap->Canvas->Pixels[i + 2][j] = GetColour(Bitmap->Canvas->Pixels[i + 2][j],quanterror,factorb,divisor);
                                    }
                                if (j < Bitmap->Height - 1) {
                                    if (i > 1) {
                                        //Bitmap->Canvas->Pixels[i - 2][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 2][j + 1]),DivideRGB(MultiplyRGB(quanterror,factorc),divisor)));
                                        Bitmap->Canvas->Pixels[i - 2][j + 1] = GetColour(Bitmap->Canvas->Pixels[i - 2][j + 1],quanterror,factorc,divisor);
                                        }
                                    if (i > 0) {
                                        //Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 1][j + 1]),DivideRGB(MultiplyRGB(quanterror,factord),divisor)));
                                        Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i - 1][j + 1],quanterror,factord,divisor);
                                        }
                                    //Bitmap->Canvas->Pixels[i][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i][j + 1]),DivideRGB(MultiplyRGB(quanterror,factore),divisor)));
                                    Bitmap->Canvas->Pixels[i][j + 1] = GetColour(Bitmap->Canvas->Pixels[i][j + 1],quanterror,factore,divisor);
                                    if (i < Bitmap->Width - 1) {
                                        //Bitmap->Canvas->Pixels[i + 1][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j + 1]),DivideRGB(MultiplyRGB(quanterror,factorf),divisor)));
                                        Bitmap->Canvas->Pixels[i + 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i + 1][j + 1],quanterror,factorf,divisor);
                                        }
                                    if (i < Bitmap->Width - 2) {
                                        //Bitmap->Canvas->Pixels[i + 2][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 2][j + 1]),DivideRGB(MultiplyRGB(quanterror,factorg),divisor)));
                                        Bitmap->Canvas->Pixels[i + 2][j + 1] = GetColour(Bitmap->Canvas->Pixels[i + 2][j + 1],quanterror,factorg,divisor);
                                        }
                                    }
                                if (j < Bitmap->Height - 2) {
                                    if (i > 1) {
                                        //Bitmap->Canvas->Pixels[i - 2][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 2][j + 2]),DivideRGB(MultiplyRGB(quanterror,factorh),divisor)));
                                        Bitmap->Canvas->Pixels[i - 2][j + 2] = GetColour(Bitmap->Canvas->Pixels[i - 2][j + 2],quanterror,factorh,divisor);
                                        }
                                    if (i > 0) {
                                        //Bitmap->Canvas->Pixels[i - 1][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 1][j + 2]),DivideRGB(MultiplyRGB(quanterror,factori),divisor)));
                                        Bitmap->Canvas->Pixels[i - 1][j + 2] = GetColour(Bitmap->Canvas->Pixels[i - 1][j + 2],quanterror,factori,divisor);
                                        }
                                    //Bitmap->Canvas->Pixels[i][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i][j + 2]),DivideRGB(MultiplyRGB(quanterror,factorj),divisor)));
                                    Bitmap->Canvas->Pixels[i][j + 2] = GetColour(Bitmap->Canvas->Pixels[i][j + 2],quanterror,factorj,divisor);
                                    if (i < Bitmap->Width - 1) {
                                        //Bitmap->Canvas->Pixels[i + 1][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j + 2]),DivideRGB(MultiplyRGB(quanterror,factork),divisor)));
                                        Bitmap->Canvas->Pixels[i + 1][j + 2] = GetColour(Bitmap->Canvas->Pixels[i + 1][j + 2],quanterror,factork,divisor);
                                        }
                                    if (i < Bitmap->Width - 2) {
                                        //Bitmap->Canvas->Pixels[i + 2][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 2][j + 2]),DivideRGB(MultiplyRGB(quanterror,factorl),divisor)));
                                        Bitmap->Canvas->Pixels[i + 2][j + 2] = GetColour(Bitmap->Canvas->Pixels[i + 2][j + 2],quanterror,factorl,divisor);
                                        }
                                    }
                                }
                                break;
                    case 5:     {
                                //Sierra2-4a
                                if (i < Bitmap->Width - 1) {
                                    //Bitmap->Canvas->Pixels[i + 1][j] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j]),DivideRGB(MultiplyRGB(quanterror,2),4)));
                                    Bitmap->Canvas->Pixels[i + 1][j] = GetColour(Bitmap->Canvas->Pixels[i + 1][j],quanterror,2,4);
                                    }
                                if (j < Bitmap->Height - 1) {
                                    if (i > 0) {
                                        //Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 1][j + 1]),DivideRGB(quanterror,4)));
                                        Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i - 1][j + 1],quanterror,1,4);
                                        }
                                    //Bitmap->Canvas->Pixels[i][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i][j + 1]),DivideRGB(quanterror,4)));
                                    Bitmap->Canvas->Pixels[i][j + 1] = GetColour(Bitmap->Canvas->Pixels[i][j + 1],quanterror,1,4);
                                    }
                                }
                                break;
                    case 4:     {
                                //Sierra
                                if (i < Bitmap->Width - 1) {
                                    //Bitmap->Canvas->Pixels[i + 1][j] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j]),DivideRGB(MultiplyRGB(quanterror,5),32)));
                                    Bitmap->Canvas->Pixels[i + 1][j] = GetColour(Bitmap->Canvas->Pixels[i + 1][j],quanterror,5,32);
                                    }
                                if (i < Bitmap->Width - 2) {
                                    //Bitmap->Canvas->Pixels[i + 2][j] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 2][j]),DivideRGB(MultiplyRGB(quanterror,3),32)));
                                    Bitmap->Canvas->Pixels[i + 2][j] = GetColour(Bitmap->Canvas->Pixels[i + 2][j],quanterror,3,32);
                                    }
                                if (j < Bitmap->Height - 1) {
                                    if (i > 1) {
                                        //Bitmap->Canvas->Pixels[i - 2][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 2][j + 1]),DivideRGB(MultiplyRGB(quanterror,2),32)));
                                        Bitmap->Canvas->Pixels[i - 2][j + 1] = GetColour(Bitmap->Canvas->Pixels[i - 2][j + 1],quanterror,2,32);
                                        }
                                    if (i > 0) {
                                        //Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 1][j + 1]),DivideRGB(MultiplyRGB(quanterror,4),32)));
                                        Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i - 1][j + 1],quanterror,4,32);
                                        }
                                    //Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 1][j + 1]),DivideRGB(MultiplyRGB(quanterror,4),32)));
                                    Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i - 1][j + 1],quanterror,4,32);
                                    if (i < Bitmap->Width - 1) {
                                        //Bitmap->Canvas->Pixels[i + 1][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j + 1]),DivideRGB(MultiplyRGB(quanterror,4),32)));
                                        Bitmap->Canvas->Pixels[i + 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i + 1][j + 1],quanterror,4,32);
                                        }
                                    if (i < Bitmap->Width - 2) {
                                        //Bitmap->Canvas->Pixels[i + 2][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 2][j + 1]),DivideRGB(MultiplyRGB(quanterror,2),32)));
                                        Bitmap->Canvas->Pixels[i + 2][j + 1] = GetColour(Bitmap->Canvas->Pixels[i + 2][j + 1],quanterror,2,32);
                                        }
                                    }
                                if (j < Bitmap->Height - 2) {
                                    if (i > 0) {
                                        //Bitmap->Canvas->Pixels[i - 1][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 1][j + 2]),DivideRGB(MultiplyRGB(quanterror,2),32)));
                                        Bitmap->Canvas->Pixels[i - 1][j + 2] = GetColour(Bitmap->Canvas->Pixels[i - 1][j + 2],quanterror,2,32);
                                        }
                                    //Bitmap->Canvas->Pixels[i][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i][j + 2]),DivideRGB(MultiplyRGB(quanterror,3),32)));
                                    Bitmap->Canvas->Pixels[i][j + 2] = GetColour(Bitmap->Canvas->Pixels[i][j + 2],quanterror,3,32);
                                    if (i < Bitmap->Width - 1) {
                                        //Bitmap->Canvas->Pixels[i + 1][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j + 2]),DivideRGB(MultiplyRGB(quanterror,2),32)));
                                        Bitmap->Canvas->Pixels[i + 1][j + 2] = GetColour(Bitmap->Canvas->Pixels[i + 1][j + 2],quanterror,2,32);
                                        }
                                    }
                                }
                                break;
                    case 3:     {
                                //Burkes
                                if (i < Bitmap->Width - 1) {
                                    //Bitmap->Canvas->Pixels[i + 1][j] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j]),DivideRGB(MultiplyRGB(quanterror,8),32)));
                                    Bitmap->Canvas->Pixels[i + 1][j] = GetColour(Bitmap->Canvas->Pixels[i + 1][j],quanterror,8,32);
                                    }
                                if (i < Bitmap->Width - 2) {
                                    //Bitmap->Canvas->Pixels[i + 2][j] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 2][j]),DivideRGB(MultiplyRGB(quanterror,4),32)));
                                    Bitmap->Canvas->Pixels[i + 2][j] = GetColour(Bitmap->Canvas->Pixels[i + 2][j],quanterror,4,32);
                                    }
                                if (j < Bitmap->Height - 1) {
                                    if (i > 1) {
                                        //Bitmap->Canvas->Pixels[i - 2][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 2][j + 1]),DivideRGB(MultiplyRGB(quanterror,2),32)));
                                        Bitmap->Canvas->Pixels[i - 2][j + 1] = GetColour(Bitmap->Canvas->Pixels[i - 2][j + 1],quanterror,2,32);
                                        }
                                    if (i > 0) {
                                        //Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 1][j + 1]),DivideRGB(MultiplyRGB(quanterror,4),32)));
                                        Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i - 1][j + 1],quanterror,4,32);
                                        }
                                    //Bitmap->Canvas->Pixels[i][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i][j + 1]),DivideRGB(MultiplyRGB(quanterror,8),32)));
                                    Bitmap->Canvas->Pixels[i][j + 1] = GetColour(Bitmap->Canvas->Pixels[i][j + 1],quanterror,8,32);
                                    if (i < Bitmap->Width - 1) {
                                        //Bitmap->Canvas->Pixels[i + 1][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j + 1]),DivideRGB(MultiplyRGB(quanterror,4),32)));
                                        Bitmap->Canvas->Pixels[i + 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i + 1][j + 1],quanterror,4,32);
                                        }
                                    if (i < Bitmap->Width - 2) {
                                        //Bitmap->Canvas->Pixels[i + 2][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 2][j + 1]),DivideRGB(MultiplyRGB(quanterror,2),32)));
                                        Bitmap->Canvas->Pixels[i + 2][j + 1] = GetColour(Bitmap->Canvas->Pixels[i + 2][j + 1],quanterror,2,32);
                                        }
                                    }
                                }
                                break;
                    case 2:     {
                                //Stuki
                                if (i < Bitmap->Width - 1) {
                                    //Bitmap->Canvas->Pixels[i + 1][j] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j]),DivideRGB(MultiplyRGB(quanterror,8),42)));
                                    Bitmap->Canvas->Pixels[i + 1][j] = GetColour(Bitmap->Canvas->Pixels[i + 1][j],quanterror,8,42);
                                    }
                                if (i < Bitmap->Width - 2) {
                                    //Bitmap->Canvas->Pixels[i + 2][j] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 2][j]),DivideRGB(MultiplyRGB(quanterror,4),42)));
                                    Bitmap->Canvas->Pixels[i + 2][j] = GetColour(Bitmap->Canvas->Pixels[i + 2][j],quanterror,4,42);
                                    }
                                if (j < Bitmap->Height - 1) {
                                    if (i > 1) {
                                        //Bitmap->Canvas->Pixels[i - 2][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 2][j + 1]),DivideRGB(MultiplyRGB(quanterror,2),42)));
                                        Bitmap->Canvas->Pixels[i - 2][j + 1] = GetColour(Bitmap->Canvas->Pixels[i - 2][j + 1],quanterror,2,42);
                                        }
                                    if (i > 0) {
                                        //Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 1][j + 1]),DivideRGB(MultiplyRGB(quanterror,4),42)));
                                        Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i - 1][j + 1],quanterror,4,42);
                                        }
                                    //Bitmap->Canvas->Pixels[i][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i][j + 1]),DivideRGB(MultiplyRGB(quanterror,8),42)));
                                    Bitmap->Canvas->Pixels[i][j + 1] = GetColour(Bitmap->Canvas->Pixels[i][j + 1],quanterror,8,42);
                                    if (i < Bitmap->Width - 1) {
                                        //Bitmap->Canvas->Pixels[i + 1][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j + 1]),DivideRGB(MultiplyRGB(quanterror,4),42)));
                                        Bitmap->Canvas->Pixels[i + 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i + 1][j + 1],quanterror,4,42);
                                        }
                                    if (i < Bitmap->Width - 2) {
                                        //Bitmap->Canvas->Pixels[i + 2][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 2][j + 1]),DivideRGB(MultiplyRGB(quanterror,2),42)));
                                        Bitmap->Canvas->Pixels[i + 2][j + 1] = GetColour(Bitmap->Canvas->Pixels[i + 2][j + 1],quanterror,2,42);
                                        }
                                    }
                                if (j < Bitmap->Height - 2) {
                                    if (i > 1) {
                                        //Bitmap->Canvas->Pixels[i - 2][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 2][j + 2]),DivideRGB(MultiplyRGB(quanterror,1),42)));
                                        Bitmap->Canvas->Pixels[i - 2][j + 2] = GetColour(Bitmap->Canvas->Pixels[i - 2][j + 2],quanterror,1,42);
                                        }
                                    if (i > 0) {
                                        //Bitmap->Canvas->Pixels[i - 1][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 1][j + 2]),DivideRGB(MultiplyRGB(quanterror,2),42)));
                                        Bitmap->Canvas->Pixels[i - 1][j + 2] = GetColour(Bitmap->Canvas->Pixels[i - 1][j + 2],quanterror,2,42);
                                        }
                                    //Bitmap->Canvas->Pixels[i][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i][j + 2]),DivideRGB(MultiplyRGB(quanterror,4),42)));
                                    Bitmap->Canvas->Pixels[i][j + 2] = GetColour(Bitmap->Canvas->Pixels[i][j + 2],quanterror,4,42);
                                    if (i < Bitmap->Width - 1) {
                                        //Bitmap->Canvas->Pixels[i + 1][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j + 2]),DivideRGB(MultiplyRGB(quanterror,2),42)));
                                        Bitmap->Canvas->Pixels[i + 1][j + 2] = GetColour(Bitmap->Canvas->Pixels[i + 1][j + 2],quanterror,2,42);
                                        }
                                    if (i < Bitmap->Width - 2) {
                                        //Bitmap->Canvas->Pixels[i + 2][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 2][j + 2]),DivideRGB(MultiplyRGB(quanterror,1),42)));
                                        Bitmap->Canvas->Pixels[i + 2][j + 2] = GetColour(Bitmap->Canvas->Pixels[i + 2][j + 2],quanterror,1,42);
                                        }
                                    }
                                }
                                break;
                    case 1:     {
                                //Jarvis et al
                                if (i < Bitmap->Width - 1) {
                                    //Bitmap->Canvas->Pixels[i + 1][j] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j]),DivideRGB(MultiplyRGB(quanterror,7),48)));
                                    Bitmap->Canvas->Pixels[i + 1][j] = GetColour(Bitmap->Canvas->Pixels[i + 1][j],quanterror,7,48);
                                    }
                                if (i < Bitmap->Width - 2) {
                                    //Bitmap->Canvas->Pixels[i + 2][j] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 2][j]),DivideRGB(MultiplyRGB(quanterror,5),48)));
                                    Bitmap->Canvas->Pixels[i + 2][j] = GetColour(Bitmap->Canvas->Pixels[i + 2][j],quanterror,5,48);
                                    }
                                if (j < Bitmap->Height - 1) {
                                    if (i > 1) {
                                        //Bitmap->Canvas->Pixels[i - 2][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 2][j + 1]),DivideRGB(MultiplyRGB(quanterror,3),48)));
                                        Bitmap->Canvas->Pixels[i - 2][j + 1] = GetColour(Bitmap->Canvas->Pixels[i - 2][j + 1],quanterror,3,48);
                                        }
                                    if (i > 0) {
                                        //Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 1][j + 1]),DivideRGB(MultiplyRGB(quanterror,5),48)));
                                        Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i - 1][j + 1],quanterror,5,48);
                                        }
                                    //Bitmap->Canvas->Pixels[i][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i][j + 1]),DivideRGB(MultiplyRGB(quanterror,7),48)));
                                    Bitmap->Canvas->Pixels[i][j + 1] = GetColour(Bitmap->Canvas->Pixels[i][j + 1],quanterror,7,48);
                                    if (i < Bitmap->Width - 1) {
                                        //Bitmap->Canvas->Pixels[i + 1][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j + 1]),DivideRGB(MultiplyRGB(quanterror,5),48)));
                                        Bitmap->Canvas->Pixels[i + 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i + 1][j + 1],quanterror,5,48);
                                        }
                                    if (i < Bitmap->Width - 2) {
                                        //Bitmap->Canvas->Pixels[i + 2][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 2][j + 1]),DivideRGB(MultiplyRGB(quanterror,3),48)));
                                        Bitmap->Canvas->Pixels[i + 2][j + 1] = GetColour(Bitmap->Canvas->Pixels[i + 2][j + 1],quanterror,3,48);
                                        }
                                    }
                                if (j < Bitmap->Height - 2) {
                                    if (i > 1) {
                                        //Bitmap->Canvas->Pixels[i - 2][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 2][j + 2]),DivideRGB(MultiplyRGB(quanterror,1),48)));
                                        Bitmap->Canvas->Pixels[i - 2][j + 2] = GetColour(Bitmap->Canvas->Pixels[i - 2][j + 2],quanterror,1,48);
                                        }
                                    if (i > 0) {
                                        //Bitmap->Canvas->Pixels[i - 1][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 1][j + 2]),DivideRGB(MultiplyRGB(quanterror,3),48)));
                                        Bitmap->Canvas->Pixels[i - 1][j + 2] = GetColour(Bitmap->Canvas->Pixels[i - 1][j + 2],quanterror,3,48);
                                        }
                                    //Bitmap->Canvas->Pixels[i][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i][j + 2]),DivideRGB(MultiplyRGB(quanterror,5),48)));
                                    Bitmap->Canvas->Pixels[i][j + 2] = GetColour(Bitmap->Canvas->Pixels[i][j + 2],quanterror,5,48);
                                    if (i < Bitmap->Width - 1) {
                                        //Bitmap->Canvas->Pixels[i + 1][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j + 2]),DivideRGB(MultiplyRGB(quanterror,3),48)));
                                        Bitmap->Canvas->Pixels[i + 1][j + 2] = GetColour(Bitmap->Canvas->Pixels[i + 1][j + 2],quanterror,3,48);
                                        }
                                    if (i < Bitmap->Width - 2) {
                                        //Bitmap->Canvas->Pixels[i + 2][j + 2] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 2][j + 2]),DivideRGB(MultiplyRGB(quanterror,1),48)));
                                        Bitmap->Canvas->Pixels[i + 2][j + 2] = GetColour(Bitmap->Canvas->Pixels[i + 2][j + 2],quanterror,1,48);
                                        }
                                    }
                                }
                                break;
                    default:    {
                                //Use Floyd Steinberg
                                if (i < Bitmap->Width - 1) {
                                    //Bitmap->Canvas->Pixels[i + 1][j] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j]),DivideRGB(MultiplyRGB(quanterror,7),16)));
                                    Bitmap->Canvas->Pixels[i + 1][j] = GetColour(Bitmap->Canvas->Pixels[i + 1][j],quanterror,7,16);
                                    if (j < Bitmap->Height - 1) {
                                        //Bitmap->Canvas->Pixels[i + 1][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i + 1][j + 1]),DivideRGB(MultiplyRGB(quanterror,1),16)));
                                        Bitmap->Canvas->Pixels[i + 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i + 1][j + 1],quanterror,1,16);
                                        }
                                    }
                                if (j < Bitmap->Height - 1) {
                                    //Bitmap->Canvas->Pixels[i][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i][j + 1]),DivideRGB(MultiplyRGB(quanterror,5),16)));
                                    Bitmap->Canvas->Pixels[i][j + 1] = GetColour(Bitmap->Canvas->Pixels[i][j + 1],quanterror,5,16);
                                    if (i > 0) {
                                        //Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColourFromRGB(AddRGB(ExtractRGB(Bitmap->Canvas->Pixels[i - 1][j + 1]),DivideRGB(MultiplyRGB(quanterror,3),16)));
                                        Bitmap->Canvas->Pixels[i - 1][j + 1] = GetColour(Bitmap->Canvas->Pixels[i - 1][j + 1],quanterror,3,16);
                                        }
                                    }
                                }
                                break;
                        }  //end of 'switch'

                } //end of 'if (Dithering->Checked)'
            }
        }

    //delete region
    DeleteObject(Region);

    ColourSub.Length = 0;
    ColourSquares.Length = 0;
    CountNoBlendColours();

    delete Bitmap;
    Screen->Cursor = crDefault;

}
//---------------------------------------------------------------------------

void __fastcall TThreadConversionForm::Initialise(void)
{

    Image1->Top = 24;
    Image1->Left = 8;
    Image1->Width = Image1->Picture->Bitmap->Width;
    Image1->Height = Image1->Picture->Bitmap->Height;
    Image2->Left = Image1->Left;
    //Image2->Width = Image1->Width;
    //Image2->Height = Image1->Height;
    Image2->Width = Conversion.imagewidth;
    Image2->Height = Conversion.imageheight;
    Label21->Top = Image1->Top + Image1->Height + 8;
    Image2->Top = Image1->Top + Image1->Height + 24;
    //Image2->Picture->Bitmap->Width = Image1->Picture->Bitmap->Width;
    //Image2->Picture->Bitmap->Height = Image1->Picture->Bitmap->Height;
    Image2->Picture->Bitmap->Width = Conversion.imagewidth;
    Image2->Picture->Bitmap->Height = Conversion.imageheight;
    if (Panel1->Left < (Image1->Left + Image1->Width + 8)) {
        Width = Image1->Left + Image1->Width + 16 + Panel1->Width + VertScrollBar->Size;
        }
    numberofdivisions = (int) UpDown1->Position;
    ImageHeight->OnChange = NULL;
    ImageWidth->OnChange = NULL;
    //ImageWidth->Text = AnsiString(Image1->Picture->Bitmap->Width);
    //ImageHeight->Text = AnsiString(Image1->Picture->Bitmap->Height);
    ImageWidth->Text = AnsiString(Conversion.imagewidth);
    ImageHeight->Text = AnsiString(Conversion.imageheight);
    ImageHeight->OnChange = ImageHeightChange;
    ImageWidth->OnChange = ImageWidthChange;
    Label2->Caption = "Possible numbers of Colours  " + AnsiString((numberofdivisions + 2) * (numberofdivisions + 2)* (numberofdivisions + 2));
    PictureChanged = false;
    Dithering->OnClick = NULL;
    Dithering->Checked = Conversion.dither;
    Dithering->OnClick = UpdateButtonClick;
    RadioGroup1->OnClick = NULL;
    RadioGroup1->ItemIndex = Conversion.dithersetting;
    RadioGroup1->OnClick = UpdateButtonClick;
    Edit1->Text = AnsiString(Conversion.RGBOverall);
    Edit2->Text = AnsiString(Conversion.R);
    Edit3->Text = AnsiString(Conversion.G);
    Edit4->Text = AnsiString(Conversion.B);
    Edit5->Text = AnsiString(Conversion.HSBOverall);
    Edit6->Text = AnsiString(Conversion.H);
    Edit7->Text = AnsiString(Conversion.S);
    Edit8->Text = AnsiString(Conversion.Br);
    UpDown1->OnClick = NULL;
    UpDown1->Position = (short) Conversion.colourspace;
    NumberofColoursEdit->Text = AnsiString(UpDown1->Position);
    UpDown1->OnClick = UpDown1Click;

    Picture->Assign(Image1->Picture->Bitmap);
    Points.Length = 4;
    Points[0].x = 0;
    Points[0].y = 0;
    Points[1].x = Picture->Width;
    Points[1].y = 0;
    Points[2].x = Picture->Width;
    Points[2].y = Picture->Height;
    Points[3].x = 0;
    Points[3].y = Picture->Height;
    StatusBar1->Panels->Items[3]->Text = "";

    //fill selection area
    for (int i = 0; i < DMCColourList.Length; i++) {
        FillColour->Items->Add(DMCColourList[i].DMCColourName);
        }
    FillColour->ItemIndex = 0;

    FillThreadImage();

}
//---------------------------------------------------------------------------

void __fastcall TThreadConversionForm::UpdateButtonClick(TObject *Sender)
{
    if (RadioGroup1->ItemIndex == 8 && !setcustomdither && Dithering) {
        RadioGroup1Click(Sender);
        } else {
        FillThreadImage();
        }
}
//---------------------------------------------------------------------------

void __fastcall TThreadConversionForm::HelpButtonClick(TObject *Sender)
{
    AnsiString Address = ExtractFileDir(Application->ExeName) + "\\BackStitch.chm";
    AnsiString Location = "mk:@MSITStore:" + Address + "::/thread.html#start";
    ShellExecute(Application->Handle,"open",Location.c_str(),Location.c_str(),NULL,SW_SHOW);

}
//---------------------------------------------------------------------------

void __fastcall TThreadConversionForm::CountNoBlendColours(void)
{
    DynamicArray <TColor> Colours;
    bool found;
    int pointer;
    TColor tempcolour;
    for (int i = 0; i < Image2->Picture->Bitmap->Width; i++) {
        for (int j = 0; j < Image2->Picture->Bitmap->Height; j++) {
            tempcolour = Image2->Picture->Bitmap->Canvas->Pixels[i][j];
            found = false;
            pointer = 0;
            while (!found && pointer < Colours.Length) {
                if (tempcolour == Colours[pointer]) {
                    found = true;
                    }
                pointer++;
                }
            if (!found) {
                Colours.Length++;
                Colours[Colours.Length - 1] = tempcolour;
                }
            }
        }
    Label3->Caption = "Actual # of Thread Colours   " + AnsiString(Colours.Length);
    Colours.Length = 0;

}
//---------------------------------------------------------------------------

void __fastcall TThreadConversionForm::Copy2Click(TObject *Sender)
{
  unsigned int DataHandle = 0;
    HPALETTE APalette;
    unsigned short MyFormat = CF_BITMAP;
    Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
    try {
        // generate a clipboard format, with data and palette
        // save the data to the clipboard using that format and
        // the generated data
        //The use of an intervening bitmap allows the background to be either transparent or solid.
        //If the Image1->Picture->Bitmap is saved straight to clipboard, then the transparency info is
        //lost.
        Bitmap->Width = Image2->Width;
        Bitmap->Height = Image2->Height;
        Bitmap->Canvas->Draw(0,0,Image2->Picture->Bitmap);
        Bitmap->SaveToClipboardFormat(MyFormat,DataHandle,APalette);
        Clipboard()->SetAsHandle(CF_BITMAP,DataHandle);
        }

    catch (...) {
        ShowMessage("Sorry, Failed to copy image to clipboard.");
        }

    delete Bitmap;

}
//---------------------------------------------------------------------------

void __fastcall TThreadConversionForm::Copy1Click(TObject *Sender)
{
  unsigned int DataHandle = 0;
    HPALETTE APalette;
    unsigned short MyFormat = CF_BITMAP;
    Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
    try {
        // generate a clipboard format, with data and palette
        // save the data to the clipboard using that format and
        // the generated data
        //The use of an intervening bitmap allows the background to be either transparent or solid.
        //If the Image1->Picture->Bitmap is saved straight to clipboard, then the transparency info is
        //lost.
        Bitmap->Width = Image1->Width;
        Bitmap->Height = Image1->Height;
        Bitmap->Canvas->Draw(0,0,Image1->Picture->Bitmap);
        Bitmap->SaveToClipboardFormat(MyFormat,DataHandle,APalette);
        Clipboard()->SetAsHandle(CF_BITMAP,DataHandle);
        }

    catch (...) {
        ShowMessage("Sorry, Failed to copy image to clipboard.");
        }

    delete Bitmap;

}
//---------------------------------------------------------------------------

void __fastcall TThreadConversionForm::ImageWidthChange(TObject *Sender)
{
    ImageHeight->OnChange = NULL;
    ImageWidth->OnChange = NULL;
    if (ImageWidth->Text.ToIntDef(Image1->Picture->Bitmap->Width) > Image1->Picture->Bitmap->Width) ImageWidth->Text = AnsiString(Image1->Picture->Bitmap->Width);
    ImageHeight->Text = AnsiString((int)(ImageWidth->Text.ToIntDef(Image1->Picture->Bitmap->Width) * Image1->Picture->Bitmap->Height /  Image1->Picture->Bitmap->Width));
    ImageHeight->OnChange = ImageHeightChange;
    ImageWidth->OnChange = ImageWidthChange;
}
//---------------------------------------------------------------------------

void __fastcall TThreadConversionForm::ImageHeightChange(TObject *Sender)
{
    ImageHeight->OnChange = NULL;
    ImageWidth->OnChange = NULL;
    if (ImageHeight->Text.ToIntDef(Image1->Picture->Bitmap->Height) > Image1->Picture->Bitmap->Height) ImageHeight->Text = AnsiString(Image1->Picture->Bitmap->Height);
    ImageWidth->Text = AnsiString((int)(ImageHeight->Text.ToIntDef(Image1->Picture->Bitmap->Height) * Image1->Picture->Bitmap->Width /  Image1->Picture->Bitmap->Height));
    ImageHeight->OnChange = ImageHeightChange;
    ImageWidth->OnChange = ImageWidthChange;

}
//---------------------------------------------------------------------------

void __fastcall TThreadConversionForm::PastefromClipboard1Click(
      TObject *Sender)
{
    //Paste picture into Image1 and act on it.
    TClipboard *pCB = Clipboard();
    if (pCB->HasFormat(CF_BITMAP))
    {
        Screen->Cursor = crHourGlass;
        Graphics::TBitmap *pBitmap = new Graphics::TBitmap();
        try {
            pBitmap->LoadFromClipboardFormat(CF_BITMAP, pCB->GetAsHandle(CF_BITMAP), 0);
            Image1->Width = pBitmap->Width;
            Image1->Height = pBitmap->Height;
            Image1->Picture->Bitmap->Width = pBitmap->Width;
            Image1->Picture->Bitmap->Height = pBitmap->Height;
            Image1->Canvas->Draw(0,0,pBitmap);
            PictureChanged = true;
            ImageHeight->OnChange = NULL;
            ImageWidth->OnChange = NULL;
            ImageWidth->Text = AnsiString(Image1->Picture->Bitmap->Width);
            ImageHeight->Text = AnsiString(Image1->Picture->Bitmap->Height);
            ImageHeight->OnChange = ImageHeightChange;
            ImageWidth->OnChange = ImageWidthChange;
            Image2->Width = Image1->Width;
            Image2->Height = Image1->Height;
            Label21->Top = Image1->Top + Image1->Height + 8;
            Image2->Top = Image1->Top + Image1->Height + 24;
            Image2->Picture->Bitmap->Width = Image1->Picture->Bitmap->Width;
            Image2->Picture->Bitmap->Height = Image1->Picture->Bitmap->Height;
            FillThreadImage();
            }
        catch (...) {
            ShowMessage("Error during Paste Operation");
            }
        delete pBitmap;
        }

}
//---------------------------------------------------------------------------

void __fastcall TThreadConversionForm::RetrieveData(void)
{
    Conversion.colourspace = (int)UpDown1->Position;
    Conversion.imageheight = Image2->Height;
    Conversion.imagewidth = Image2->Width;
    Conversion.dithersetting = RadioGroup1->ItemIndex;
    Conversion.dither = Dithering->Checked;
    Conversion.RGBOverall = ToDoubleDef(Edit1->Text,100.0);
    Conversion.R = ToDoubleDef(Edit2->Text,100.0);
    Conversion.G = ToDoubleDef(Edit3->Text,100.0);
    Conversion.B = ToDoubleDef(Edit4->Text,100.0);
    Conversion.HSBOverall = ToDoubleDef(Edit5->Text,0.0);
    Conversion.H = ToDoubleDef(Edit6->Text,100.0);
    Conversion.S = ToDoubleDef(Edit7->Text,100.0);
    Conversion.Br = ToDoubleDef(Edit8->Text,100.0);

}
//---------------------------------------------------------------------------

void __fastcall TThreadConversionForm::FormCreate(TObject *Sender)
{
    Conversion.colourspace = 10;
    Conversion.imageheight = Image1->Height;
    Conversion.imagewidth = Image1->Width;
    Conversion.dithersetting = 1;
    Conversion.dither = false;
    Conversion.RGBOverall = 100.0;
    Conversion.R = 100.0;
    Conversion.G = 100.0;
    Conversion.B = 100.0;
    Conversion.HSBOverall = 0.0;
    Conversion.H = 100.0;
    Conversion.S = 100.0;
    Conversion.Br = 100.0;

    UndoList = new TList();
    UndoList->Capacity = 8;
    UndoList->Count = 0;

    drawing = false;
    oldpoint.x = 0;
    oldpoint.y = 0;
    wipedout = true;
    Picture = new Graphics::TBitmap();
    LassoType = TNoLasso;

    Application->OnHint = DisplayHint;

    UserDefinedDither.Length = 13;
    UserDefinedDither[0] = 2;
    UserDefinedDither[1] = 0;
    UserDefinedDither[2] = 0;
    UserDefinedDither[3] = 0;
    UserDefinedDither[4] = 1;
    UserDefinedDither[5] = 1;
    UserDefinedDither[6] = 0;
    UserDefinedDither[7] = 0;
    UserDefinedDither[8] = 0;
    UserDefinedDither[9] = 0;
    UserDefinedDither[10] = 0;
    UserDefinedDither[11] = 0;
    UserDefinedDither[12] = 5;
    setcustomdither = false;

}
//---------------------------------------------------------------------------

void __fastcall TThreadConversionForm::FormDestroy(TObject *Sender)
{
    //delete all graphics saved in the undo array
    for (int i = 0; i < UndoList->Count; i++) {
        Graphics::TBitmap *TempPicture =  (Graphics::TBitmap *) UndoList->Items[i];
        delete TempPicture;
        }
    delete UndoList;

    UndoConvList.Length = 0;
    Points.Length = 0;
    delete Picture;

    for (int i = 0; i < TweedList.Length; i++) {
        TweedList[i].ColourPairs.Length = 0;
        }
    TweedList.Length = 0;
    DMCColourList.Length = 0;
    UserDefinedDither.Length = 0;

    Application->OnHint = NULL;

}
//---------------------------------------------------------------------------

void __fastcall TThreadConversionForm::BitBtn2Click(TObject *Sender)
{
    LassoType = (TLassoType) dynamic_cast<TBitBtn *>(Sender)->Tag;
    drawing = false;
    //reset picture to get rid of any visible artefacts
    Image1->Picture->Bitmap->Assign(Picture);
    Points.Length = 0;
    wipedout = true;
    switch (LassoType) {
        case TRectLasso:    {
                    StatusBar1->Panels->Items[0]->Text = " Selection Method = Rectangle";
                    }
                    break;
        case TFlexLasso:    {
                    StatusBar1->Panels->Items[0]->Text = " Selection Method = Lasso";
                    }
                    break;
        default:    {
                    StatusBar1->Panels->Items[0]->Text = " Selection Method = Full Image";
                    }
                    break;
        }
    StatusBar1->Panels->Items[3]->Text = "";
}
//---------------------------------------------------------------------------

void __fastcall TThreadConversionForm::UndoButtonClick(TObject *Sender)
{
    if (UndoList->Count) {
        Graphics::TBitmap *TempPicture = (Graphics::TBitmap *) UndoList->Last();
        Image2->Picture->Bitmap->Assign(TempPicture);
        delete TempPicture;
        UndoList->Count--;
        Conversion = UndoConvList[UndoConvList.Length - 1];
        UndoConvList.Length--;
        UpDown1->Position = (short) Conversion.colourspace;
        RadioGroup1->ItemIndex = Conversion.dithersetting;
        Dithering->Checked = Conversion.dither;
        Edit1->Text = AnsiString(Conversion.RGBOverall);
        Edit2->Text = AnsiString(Conversion.R);
        Edit3->Text = AnsiString(Conversion.G);
        Edit4->Text = AnsiString(Conversion.B);
        Edit5->Text = AnsiString(Conversion.HSBOverall);
        Edit6->Text = AnsiString(Conversion.H);
        Edit7->Text = AnsiString(Conversion.S);
        Edit8->Text = AnsiString(Conversion.Br);
        }
    UndoButton->Enabled = (UndoList->Count > 0);

}
//---------------------------------------------------------------------------

void __fastcall TThreadConversionForm::FormMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
    StatusBar1->Panels->Items[1]->Text = " X = ---";
    StatusBar1->Panels->Items[2]->Text = " Y = ---";
}
//---------------------------------------------------------------------------

void __fastcall TThreadConversionForm::DisplayHint(TObject *Sender)
{
    StatusBar1->Panels->Items[4]->Text = " " + GetLongHint(Application->Hint);

}
//---------------------------------------------------------------------------

void __fastcall TThreadConversionForm::Image1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if (!drawing) {
        //start drawing
        switch (LassoType) {
            case TRectLasso:    {
                                drawing = true;
                                wipedout = true;
                                Points.Length = 1;
                                Points[0].x = X;
                                Points[0].y = Y;
                                oldpoint.x = X;
                                oldpoint.y = Y;
                                StatusBar1->Panels->Items[3]->Text = " Drag Rectangle to select area.";
                                Image1->Picture->Bitmap->Assign(Picture);
                                }
                                break;
            case TFlexLasso:    {
                                drawing = true;
                                wipedout = true;
                                Points.Length = 1;
                                Points[0].x = X;
                                Points[0].y = Y;
                                oldpoint.x = X;
                                oldpoint.y = Y;
                                StatusBar1->Panels->Items[3]->Text = " Click on X=" + AnsiString(X) + " Y=" + AnsiString(Y) + " to finish";
                                Image1->Picture->Bitmap->Assign(Picture);
                                }
                                break;
            default:            {
                                //don't want to select any area.
                                Points.Length = 4;
                                Points[0].x = 0;
                                Points[0].y = 0;
                                Points[1].x = Picture->Width;
                                Points[1].y = 0;
                                Points[2].x = Picture->Width;
                                Points[2].y = Picture->Height;
                                Points[3].x = 0;
                                Points[3].y = Picture->Height;
                                StatusBar1->Panels->Items[3]->Text = "";
                                }
                                break;
            }
        } else {
        if (LassoType == TFlexLasso) {
            //check if point is in lasso list. If yes, stop, else add new point
            bool found = false;
            if ((Points[0].x > X-3) && (Points[0].x < X+3) && (Points[0].y > Y-3) && (Points[0].y < Y+3)) {
                    found = true;
                    }
            if (found) {
                drawing = false;
                Image1->Picture->Bitmap->Assign(Picture);
                //draw lasso
                Image1->Canvas->Pen->Width = 1;
                Image1->Canvas->Pen->Style = psDash;
                Image1->Canvas->Pen->Mode = pmNot;
                if (Points.Length > 1) {
                    Image1->Canvas->MoveTo(Points[0].x,Points[0].y);
                    for (int i = 1; i < Points.Length; i++) {
                        Image1->Canvas->LineTo(Points[i].x,Points[i].y);
                        }
                    Image1->Canvas->LineTo(Points[0].x,Points[0].y);
                    }

                } else {
                Points.Length++;
                Points[Points.Length - 1].x = X;
                Points[Points.Length - 1].y = Y;
                oldpoint.x = X;
                oldpoint.y = Y;
                if (Points.Length == 2) {
                    Image1->Canvas->Pen->Width = 1;
                    Image1->Canvas->Pen->Style = psDash;
                    Image1->Canvas->Pen->Mode = pmNot;
                    Image1->Canvas->MoveTo(Points[0].x,Points[0].y);
                    Image1->Canvas->LineTo(Points[1].x,Points[1].y);
                    }
                }
            }//end of  'if (LassoType == TFlexLasso)'
        } //end of 'if(!drawing)'


}
//---------------------------------------------------------------------------

void __fastcall TThreadConversionForm::Image1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
    StatusBar1->Panels->Items[1]->Text = " X = " + AnsiString(X);
    StatusBar1->Panels->Items[2]->Text = " Y = " + AnsiString(Y);
    if (drawing) {
        switch (LassoType) {
            case TRectLasso:    {
                                Image1->Canvas->Pen->Width = 1;
                                Image1->Canvas->Pen->Style = psDash;
                                Image1->Canvas->Pen->Mode = pmNot;
                                if (!wipedout) {
                                    Image1->Canvas->MoveTo(Points[0].x,Points[0].y);
                                    Image1->Canvas->LineTo(oldpoint.x,Points[0].y);
                                    Image1->Canvas->LineTo(oldpoint.x,oldpoint.y);
                                    Image1->Canvas->LineTo(Points[0].x,oldpoint.y);
                                    Image1->Canvas->LineTo(Points[0].x,Points[0].y);
                                    }
                                oldpoint.x = X;
                                oldpoint.y = Y;
                                Image1->Canvas->MoveTo(Points[0].x,Points[0].y);
                                Image1->Canvas->LineTo(oldpoint.x,Points[0].y);
                                Image1->Canvas->LineTo(oldpoint.x,oldpoint.y);
                                Image1->Canvas->LineTo(Points[0].x,oldpoint.y);
                                Image1->Canvas->LineTo(Points[0].x,Points[0].y);
                                wipedout = false;
                                }
                                break;
            case TFlexLasso:    {
                                if (!wipedout) {
                                    //erase elastic band
                                    Image1->Canvas->Pen->Width = 1;
                                    Image1->Canvas->Pen->Style = psDash;
                                    Image1->Canvas->Pen->Mode = pmNot;
                                    Image1->Canvas->MoveTo(Points[0].x,Points[0].y);
                                    Image1->Canvas->LineTo(oldpoint.x,oldpoint.y);
                                    if (Points.Length > 1) {
                                        Image1->Canvas->LineTo(Points[Points.Length-1].x,Points[Points.Length-1].y);
                                        }
                                    } else {
                                    //draw fixed part of lassoo
                                    Image1->Canvas->Pen->Width = 1;
                                    Image1->Canvas->Pen->Style = psDash;
                                    Image1->Canvas->Pen->Mode = pmNot;
                                    if (Points.Length > 1) {
                                        Image1->Canvas->MoveTo(Points[0].x,Points[0].y);
                                        for (int i = 1; i < Points.Length; i++) {
                                            Image1->Canvas->LineTo(Points[i].x,Points[i].y);
                                            }
                                        }
                                    }
                                //draw elastic band
                                Image1->Canvas->MoveTo(Points[Points.Length-1].x,Points[Points.Length-1].y);
                                Image1->Canvas->LineTo(X,Y);
                                if (Points.Length > 1) {
                                    Image1->Canvas->LineTo(Points[0].x,Points[0].y);
                                    }
                                wipedout = false;
                                oldpoint.x = X;
                                oldpoint.y = Y;
                                }
                                break;
            default:            break;
            }   // end of switch
        }  //end of 'if (drawing)'

}
//---------------------------------------------------------------------------

void __fastcall TThreadConversionForm::Image1MouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if (drawing && LassoType == TRectLasso) {
        Points.Length = 4;
        Points[1].x = X;
        Points[1].y = Points[0].y;
        Points[2].x = X;
        Points[2].y = Y;
        Points[3].x = Points[0].x;
        Points[3].y = Y;
        Image1->Picture->Bitmap->Assign(Picture);
        Image1->Canvas->Pen->Width = 1;
        Image1->Canvas->Pen->Style = psDash;
        Image1->Canvas->Pen->Mode = pmNot;
        if (Points.Length > 1) {
            Image1->Canvas->MoveTo(Points[0].x,Points[0].y);
            for (int i = 1; i < Points.Length; i++) {
                Image1->Canvas->LineTo(Points[i].x,Points[i].y);
                }
            Image1->Canvas->LineTo(Points[0].x,Points[0].y);
            }
        drawing = false;
        wipedout = false;
        }
}
//---------------------------------------------------------------------------

void __fastcall TThreadConversionForm::FillColourDrawItem(
      TWinControl *Control, int Index, TRect &Rect, TOwnerDrawState State)
{
    // Draw coloured rectangle background & name of colour
    TRect Rectangle = Rect;
    TColor TempColour = FillColour->Canvas->Brush->Color;
    FillColour->Canvas->Brush->Style = bsSolid;
    FillColour->Canvas->Brush->Color = DMCColourList[Index].Colour;
    FillColour->Canvas->FillRect(Rectangle);
    FillColour->Canvas->Brush->Color = TempColour;
    if (DMCColourList[Index].DrawWhite) {
        FillColour->Canvas->Font->Color = clWhite;
        } else {
        FillColour->Canvas->Font->Color = clBlack;
        }
    FillColour->Canvas->Brush->Style = bsClear;
    //for some reason the next line doesn't work
    //FillColour->Canvas->TextRect(Rectangle,1,1,FullPallette->Items->Strings[Index]);
    DrawText(FillColour->Canvas->Handle,("  " + FillColour->Items->Strings[Index]).c_str(),-1,(LPRECT) &Rectangle,DT_VCENTER | DT_SINGLELINE);
    FillColour->Canvas->Brush->Style = bsSolid;

}
//---------------------------------------------------------------------------

TColor __fastcall TThreadConversionForm::GetColour(TColor Pixel,rgb error, int factora, int divisor)
{
//doing this: GetColourFromRGB(AddRGB(ExtractRGB(Pixel),DivideRGB(MultiplyRGB(error,factora),divisor)));
//with luck it's quicker
    //convert pixel colour
    rgb PixelColour, Value;
    TColor returnvalue;
    int c1 = (int) Pixel;
    /*PixelColour.B = c1/(256 * 256);
    c1 = c1 - (PixelColour.B * 256 * 256);
    PixelColour.G = c1/256;
    c1 = c1 - (PixelColour.G * 256);
    PixelColour.R = c1;*/
    PixelColour.B = c1 >> 16;
    c1 = c1 - (PixelColour.B << 16);
    PixelColour.G = c1 >> 8;
    c1 = c1 - (PixelColour.G << 8);
    PixelColour.R = c1;

    Value.R = PixelColour.R + error.R * factora / divisor;
    Value.G = PixelColour.G + error.G * factora / divisor;
    Value.B = PixelColour.B + error.B * factora / divisor;

    if (Value.R < 0) Value.R = 0;
    if (Value.G < 0) Value.G = 0;
    if (Value.B < 0) Value.B = 0;
    if (Value.R > 255) Value.R = 255;
    if (Value.G > 255) Value.G = 255;
    if (Value.B > 255) Value.B = 255;

    //returnvalue = (TColor)(Value.R + 256 * Value.G + 256 * 256 * Value.B);
    returnvalue = (TColor)(Value.R + (Value.G << 8) + (Value.B << 16));

    return returnvalue;
}
//---------------------------------------------------------------------------

void __fastcall TThreadConversionForm::PopupMenu3Popup(TObject *Sender)
{
    AnsiString text = StatusBar1->Panels->Items[4]->Text.Trim();
    HelpItem->Tag = -1;
    if (text == NumberofColoursEdit->Hint) HelpItem->Tag = 0;
    if (text == ImageWidth->Hint) HelpItem->Tag = 1;
    if (text == Dithering->Hint) HelpItem->Tag = 2;
    if (text == GroupBox1->Hint) HelpItem->Tag = 3;
    if (text == GroupBox3->Hint || text == BitBtn2->Hint || text == BitBtn3->Hint || text == BitBtn4->Hint || text == BlankOutsideSelection->Hint || text == FillColour->Hint) HelpItem->Tag = 4;
    if (text == BlendThreads->Hint) HelpItem->Tag = 5;
}
//---------------------------------------------------------------------------

void __fastcall TThreadConversionForm::HelpItemClick(TObject *Sender)
{
    //Context sensitive help. Pain doing it this way, but can't do it for CHM files through the normal procedure.
    int Tag = dynamic_cast <TMenuItem *>(Sender)->Tag;
    AnsiString Address = ExtractFileDir(Application->ExeName) + "\\BackStitch.chm";
    AnsiString Location;
    switch (Tag) {
        case 0:     {
                    Location = "mk:@MSITStore:" + Address + "::/thread.html#colourspace";
                    }
                    break;
        case 1:     {
                    Location = "mk:@MSITStore:" + Address + "::/thread.html#imagesize";
                    }
                    break;
        case 2:     {
                    Location = "mk:@MSITStore:" + Address + "::/thread.html#dithering";
                    }
                    break;
        case 3:     {
                    Location = "mk:@MSITStore:" + Address + "::/thread.html#weighting";
                    }
                    break;
        case 4:     {
                    Location = "mk:@MSITStore:" + Address + "::/thread.html#area";
                    }
                    break;
        case 5:     {
                    Location = "mk:@MSITStore:" + Address + "::/thread.html#blending";
                    }
                    break;
        default:    {
                    Location = "mk:@MSITStore:" + Address + "::/thread.html#start";
                    }
                    break;
        }

    ShellExecute(Application->Handle,"open",Location.c_str(),Location.c_str(),NULL,SW_SHOW);

}
//---------------------------------------------------------------------------


void __fastcall TThreadConversionForm::OKButtonClick(TObject *Sender)
{
    ModalResult = mrOk;    
}
//---------------------------------------------------------------------------

void __fastcall TThreadConversionForm::RadioGroup1Click(TObject *Sender)
{
    //if (RadioGroup1->ItemIndex == 8) {
        TCustomDitherForm *CustomDitherForm = new TCustomDitherForm(this);
        CustomDitherForm->Edit0->Text = AnsiString(UserDefinedDither[0]);
        CustomDitherForm->Edit1->Text = AnsiString(UserDefinedDither[1]);
        CustomDitherForm->Edit2->Text = AnsiString(UserDefinedDither[2]);
        CustomDitherForm->Edit3->Text = AnsiString(UserDefinedDither[3]);
        CustomDitherForm->Edit4->Text = AnsiString(UserDefinedDither[4]);
        CustomDitherForm->Edit5->Text = AnsiString(UserDefinedDither[5]);
        CustomDitherForm->Edit6->Text = AnsiString(UserDefinedDither[6]);
        CustomDitherForm->Edit7->Text = AnsiString(UserDefinedDither[7]);
        CustomDitherForm->Edit8->Text = AnsiString(UserDefinedDither[8]);
        CustomDitherForm->Edit9->Text = AnsiString(UserDefinedDither[9]);
        CustomDitherForm->Edit10->Text = AnsiString(UserDefinedDither[10]);
        CustomDitherForm->Edit11->Text = AnsiString(UserDefinedDither[11]);
        CustomDitherForm->Edit12->Text = AnsiString(UserDefinedDither[12]);

        CustomDitherForm->ShowModal();

        if (CustomDitherForm->ModalResult == mrOk) {
            UserDefinedDither[0] = CustomDitherForm->Edit0->Text.ToIntDef(0);
            UserDefinedDither[1] = CustomDitherForm->Edit1->Text.ToIntDef(0);
            UserDefinedDither[2] = CustomDitherForm->Edit2->Text.ToIntDef(0);
            UserDefinedDither[3] = CustomDitherForm->Edit3->Text.ToIntDef(0);
            UserDefinedDither[4] = CustomDitherForm->Edit4->Text.ToIntDef(0);
            UserDefinedDither[5] = CustomDitherForm->Edit5->Text.ToIntDef(0);
            UserDefinedDither[6] = CustomDitherForm->Edit6->Text.ToIntDef(0);
            UserDefinedDither[7] = CustomDitherForm->Edit7->Text.ToIntDef(0);
            UserDefinedDither[8] = CustomDitherForm->Edit8->Text.ToIntDef(0);
            UserDefinedDither[9] = CustomDitherForm->Edit9->Text.ToIntDef(0);
            UserDefinedDither[10] = CustomDitherForm->Edit10->Text.ToIntDef(0);
            UserDefinedDither[11] = CustomDitherForm->Edit11->Text.ToIntDef(0);
            UserDefinedDither[12] = CustomDitherForm->Edit12->Text.ToIntDef(1);
            }
            
        delete CustomDitherForm;
        setcustomdither = true;
        //}
    RadioGroup1->ItemIndex = 8;
    if (Dithering->Checked) UpdateButtonClick(Sender);

}
//---------------------------------------------------------------------------

