//---------------------------------------------------------------------------
#ifndef ThreadConversionH
#define ThreadConversionH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include "StitchStructures.h"
#include <Menus.hpp>
#include <ImgList.hpp>
#include <Buttons.hpp>
#include "GraphicsHelp.h"
//---------------------------------------------------------------------------
class TThreadConversionForm : public TForm
{
__published:	// IDE-managed Components
    TPanel *Panel1;
    TButton *OKButton;
    TButton *CancelButton;
    TImage *Image1;
    TImage *Image2;
    TEdit *NumberofColoursEdit;
    TUpDown *UpDown1;
    TLabel *Label1;
    TLabel *Label2;
    TLabel *Label3;
    TGroupBox *GroupBox1;
    TEdit *Edit1;
    TLabel *Label4;
    TLabel *Label5;
    TEdit *Edit2;
    TLabel *Label6;
    TLabel *Label7;
    TEdit *Edit3;
    TLabel *Label8;
    TLabel *Label9;
    TEdit *Edit4;
    TLabel *Label10;
    TLabel *Label11;
    TGroupBox *GroupBox2;
    TLabel *Label12;
    TLabel *Label13;
    TLabel *Label14;
    TLabel *Label15;
    TLabel *Label16;
    TLabel *Label17;
    TLabel *Label18;
    TLabel *Label19;
    TEdit *Edit5;
    TEdit *Edit6;
    TEdit *Edit7;
    TEdit *Edit8;
    TButton *UpdateButton;
    TButton *HelpButton;
    TLabel *Label20;
    TLabel *Label21;
    TPopupMenu *PopupMenu2;
    TMenuItem *Copy2;
    TPopupMenu *PopupMenu1;
    TMenuItem *Copy1;
    TCheckBox *Dithering;
    TRadioGroup *RadioGroup1;
    TLabel *Label22;
    TEdit *ImageWidth;
    TLabel *Label23;
    TEdit *ImageHeight;
    TLabel *Label24;
    TImageList *ImageList1;
    TMenuItem *PastefromClipboard1;
    TStatusBar *StatusBar1;
    TBitBtn *UndoButton;
    TGroupBox *GroupBox3;
    TBitBtn *BitBtn2;
    TBitBtn *BitBtn3;
    TBitBtn *BitBtn4;
    TCheckBox *BlankOutsideSelection;
    TComboBox *FillColour;
    TCheckBox *BlendThreads;
    TPopupMenu *PopupMenu3;
    TMenuItem *HelpItem;
    TBevel *Bevel1;
    TLabel *Label25;
    TButton *DefineDitherButton;
    void __fastcall UpDown1Click(TObject *Sender, TUDBtnType Button);
    void __fastcall UpdateButtonClick(TObject *Sender);
    void __fastcall HelpButtonClick(TObject *Sender);
    void __fastcall Copy2Click(TObject *Sender);
    void __fastcall Copy1Click(TObject *Sender);
    void __fastcall ImageWidthChange(TObject *Sender);
    void __fastcall ImageHeightChange(TObject *Sender);
    void __fastcall PastefromClipboard1Click(TObject *Sender);
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall FormDestroy(TObject *Sender);
    void __fastcall BitBtn2Click(TObject *Sender);
    void __fastcall UndoButtonClick(TObject *Sender);
    void __fastcall FormMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
    void __fastcall Image1MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
    void __fastcall Image1MouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall Image1MouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall FillColourDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
    void __fastcall PopupMenu3Popup(TObject *Sender);
    void __fastcall HelpItemClick(TObject *Sender);
    void __fastcall OKButtonClick(TObject *Sender);
    void __fastcall RadioGroup1Click(TObject *Sender);
private:	// User declarations
    int numberofdivisions;
    void __fastcall FillThreadImage(void);
    void __fastcall CountNoBlendColours(void);
    void __fastcall NoBlend(void);
    //blending
    void __fastcall CountBlendColours(void);
    void __fastcall FullBlend(void);
    //undo
    TList *UndoList;
    DynamicArray <threadconvsettings> UndoConvList;
    //lasso
    DynamicArray <TPoint> Points;
    bool drawing;
    bool wipedout;
    TPoint oldpoint;
    bool checking;
    TLassoType LassoType;
    //hint
    void __fastcall DisplayHint(TObject *Sender);
    TColor __fastcall GetColour(TColor Pixel,rgb error, int factora, int divisor);
    DynamicArray <int> UserDefinedDither;
    bool setcustomdither;
public:		// User declarations
    //variables
    DynamicArray <DMCColourData> DMCColourList;
    bool PictureChanged;
    threadconvsettings Conversion;
    Graphics::TBitmap *Picture;
    //Methods
    void __fastcall Initialise(void);
    void __fastcall RetrieveData(void);
    //for blending threads
    DynamicArray <TweedColourData> TweedList;

    __fastcall TThreadConversionForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TThreadConversionForm *ThreadConversionForm;
//---------------------------------------------------------------------------
#endif
