//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "ThreadMerge.h"
#include "StringHelp.h"
#include "GraphicsHelp.h"
#include <shellapi.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TThreadMergeForm *ThreadMergeForm;
//---------------------------------------------------------------------------
__fastcall TThreadMergeForm::TThreadMergeForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TThreadMergeForm::FormCreate(TObject *Sender)
{
    UndoList = new TStringList();
    UndoBitmap1 = new Graphics::TBitmap();
    UndoBitmap2 = new Graphics::TBitmap();
    UndoBitmap3 = new Graphics::TBitmap();
    UndoBitmap4 = new Graphics::TBitmap();
    UndoBitmap5 = new Graphics::TBitmap();
    UndoBitmap6 = new Graphics::TBitmap();
    UndoBitmap7 = new Graphics::TBitmap();
    UndoBitmap8 = new Graphics::TBitmap();
    changed = false;
    undolevel = 0;
    Application->OnHint = DisplayHint;
    setmerge1 = true;
	crTargetCursor = (TCursor) 10;
    crGrabCursor = (TCursor) 11;
    Screen->Cursors[crTargetCursor] = LoadCursor((void *)HInstance, "TARGET");
    Screen->Cursors[crGrabCursor] = LoadCursor((void *)HInstance, "GRAB");
    Image1->Cursor = crGrabCursor;
    Image2->Cursor = crGrabCursor;
    Image3->Cursor = crGrabCursor;
    OriginalBitmap = new Graphics::TBitmap();
    ModifiedBitmap = new Graphics::TBitmap();
    imagescale = 1;
    TopLeftCorner.X = 0;
    TopLeftCorner.Y = 0;
    dragging = 0;
    Image3inuse = false;
    BrightBitmap = new Graphics::TBitmap();
    DarkBitmap = new Graphics::TBitmap();
    blendthreads = false;
    replacementcolour = 0;

}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::FormDestroy(TObject *Sender)
{
    delete UndoList;
    delete UndoBitmap1;
    delete UndoBitmap2;
    delete UndoBitmap3;
    delete UndoBitmap4;
    delete UndoBitmap5;
    delete UndoBitmap6;
    delete UndoBitmap7;
    delete UndoBitmap8;
    delete OriginalBitmap;
    delete ModifiedBitmap;
    DMCColourList.Length = 0;
    PictureColourPallette.Length = 0;
    NearestColour.Length = 0;
    Application->OnHint = NULL;
    delete BrightBitmap;
    delete DarkBitmap;
    NearestTweed.Length = 0;

}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::ImageResize(void)
{
    Image2->Top = Image1->Top + Image1->Height + 24;
    Label2->Top = Image2->Top - 16;
    Image3->Top = Image2->Top;
    Label7->Top = Label2->Top;
    Image3->Left = Image2->Left + Image2->Width + 16;
    Label7->Left = Image3->Left;
}
//---------------------------------------------------------------------------


void __fastcall TThreadMergeForm::MergeColourCombosDrawItem(
      TWinControl *Control, int Index, TRect &Rect, TOwnerDrawState State)
{
    // Draw coloured rectangle background & name of colour
    TRect Rectangle = Rect;
    TColor TempColour = dynamic_cast<TComboBox *>(Control)->Canvas->Brush->Color;
    dynamic_cast<TComboBox *>(Control)->Canvas->Brush->Style = bsSolid;
    dynamic_cast<TComboBox *>(Control)->Canvas->Brush->Color = PictureColourPallette[Index].Colour;
    dynamic_cast<TComboBox *>(Control)->Canvas->FillRect(Rectangle);
    dynamic_cast<TComboBox *>(Control)->Canvas->Brush->Color = TempColour;
    if (PictureColourPallette[Index].DrawWhite) {
        dynamic_cast<TComboBox *>(Control)->Canvas->Font->Color = clWhite;
        } else {
        dynamic_cast<TComboBox *>(Control)->Canvas->Font->Color = clBlack;
        }
    dynamic_cast<TComboBox *>(Control)->Canvas->Brush->Style = bsClear;
    //for some reason the next line doesn't work
    //dynamic_cast<TComboBox *>(Control)->Canvas->TextRect(Rectangle,1,1,dynamic_cast<TComboBox *>(Control)->Items->Strings[Index]);
    DrawText(dynamic_cast<TComboBox *>(Control)->Canvas->Handle,("  " + dynamic_cast<TComboBox *>(Control)->Items->Strings[Index]).c_str(),-1,(LPRECT) &Rectangle,DT_VCENTER | DT_SINGLELINE);
    dynamic_cast<TComboBox *>(Control)->Canvas->Brush->Style = bsSolid;

}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::MergeButtonClick(TObject *Sender)
{
    //merges the current colours.
    int merge1 = MergeColour1->ItemIndex;
    int merge2 = MergeColour2->ItemIndex;
    int replacement = ReplacementColour->ItemIndex;
    AnsiString temp;

    if (merge1 != merge2) {
        undolevel++;
        if (undolevel > 8) undolevel = 8;
        //first, before doing anything, run through the undos
        if (!UndoBitmap7->Empty) UndoBitmap8->Assign(UndoBitmap7);
        if (!UndoBitmap6->Empty) UndoBitmap7->Assign(UndoBitmap6);
        if (!UndoBitmap5->Empty) UndoBitmap6->Assign(UndoBitmap5);
        if (!UndoBitmap4->Empty) UndoBitmap5->Assign(UndoBitmap4);
        if (!UndoBitmap3->Empty) UndoBitmap4->Assign(UndoBitmap3);
        if (!UndoBitmap2->Empty) UndoBitmap3->Assign(UndoBitmap2);
        if (!UndoBitmap1->Empty) UndoBitmap2->Assign(UndoBitmap1);
        //UndoBitmap1->Assign(Image2->Picture->Bitmap);
        UndoBitmap1->Assign(ModifiedBitmap);
        //write data to undolist merge colour 1 first
        temp = AnsiString(merge1) + "," + PictureColourPallette[merge1].DMCColourNumber;
        temp = temp + "," + PictureColourPallette[merge1].DMCColourName;
        temp = temp + "," + PictureColourPallette[merge1].AnchorColourNumber;
        temp = temp + "," + AnsiString((int)PictureColourPallette[merge1].Colour);
        temp = temp + "," + AnsiString((int)PictureColourPallette[merge1].DrawWhite);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].StitchCount);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].AnchorColourToUse);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].AnchorStitchCount);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].AnchorGlyphToUse);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].R);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].G);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].B);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].Hue);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].Saturation);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].Brightness) + ",";
        UndoList->Add(temp);
        //write data to undolist merge colour 2 next
        temp = AnsiString(merge2) + "," + PictureColourPallette[merge2].DMCColourNumber;
        temp = temp + "," + PictureColourPallette[merge2].DMCColourName;
        temp = temp + "," + PictureColourPallette[merge2].AnchorColourNumber;
        temp = temp + "," + AnsiString((int)PictureColourPallette[merge2].Colour);
        temp = temp + "," + AnsiString((int)PictureColourPallette[merge2].DrawWhite);
        temp = temp + "," + AnsiString(PictureColourPallette[merge2].StitchCount);
        temp = temp + "," + AnsiString(PictureColourPallette[merge2].AnchorColourToUse);
        temp = temp + "," + AnsiString(PictureColourPallette[merge2].AnchorStitchCount);
        temp = temp + "," + AnsiString(PictureColourPallette[merge2].AnchorGlyphToUse);
        temp = temp + "," + AnsiString(PictureColourPallette[merge2].R);
        temp = temp + "," + AnsiString(PictureColourPallette[merge2].G);
        temp = temp + "," + AnsiString(PictureColourPallette[merge2].B);
        temp = temp + "," + AnsiString(PictureColourPallette[merge2].Hue);
        temp = temp + "," + AnsiString(PictureColourPallette[merge2].Saturation);
        temp = temp + "," + AnsiString(PictureColourPallette[merge2].Brightness) + ",";
        UndoList->Add(temp);
        //write data to undolist ReplacementColour next
        temp = AnsiString(replacement) + "," + PictureColourPallette[replacement].DMCColourNumber;
        temp = temp + "," + PictureColourPallette[replacement].DMCColourName;
        temp = temp + "," + PictureColourPallette[replacement].AnchorColourNumber;
        temp = temp + "," + AnsiString((int)PictureColourPallette[replacement].Colour);
        temp = temp + "," + AnsiString((int)PictureColourPallette[replacement].DrawWhite);
        temp = temp + "," + AnsiString(PictureColourPallette[replacement].StitchCount);
        temp = temp + "," + AnsiString(PictureColourPallette[replacement].AnchorColourToUse);
        temp = temp + "," + AnsiString(PictureColourPallette[replacement].AnchorStitchCount);
        temp = temp + "," + AnsiString(PictureColourPallette[replacement].AnchorGlyphToUse);
        temp = temp + "," + AnsiString(PictureColourPallette[replacement].R);
        temp = temp + "," + AnsiString(PictureColourPallette[replacement].G);
        temp = temp + "," + AnsiString(PictureColourPallette[replacement].B);
        temp = temp + "," + AnsiString(PictureColourPallette[replacement].Hue);
        temp = temp + "," + AnsiString(PictureColourPallette[replacement].Saturation);
        temp = temp + "," + AnsiString(PictureColourPallette[replacement].Brightness) + ",";
        UndoList->Add(temp);
        //finally say which type of operation this is.
        //UndoList->Add("Merge DMC" + PictureColourPallette[merge1].DMCColourNumber + " + DMC" + PictureColourPallette[merge2].DMCColourNumber + " = DMC" + PictureColourPallette[replacement].DMCColourNumber);
        UndoList->Add("Merge " + ShortThreadName + PictureColourPallette[merge1].DMCColourNumber + " + " + ShortThreadName + PictureColourPallette[merge2].DMCColourNumber + " = " + ShortThreadName + PictureColourPallette[replacement].DMCColourNumber);

        //do the operation to the image
        TColor merge1colour, merge2colour, replacementcolour;
        merge1colour = PictureColourPallette[merge1].Colour;
        merge2colour = PictureColourPallette[merge2].Colour;
        replacementcolour = PictureColourPallette[replacement].Colour;

        //for (int j = 0; j < Image2->Picture->Bitmap->Height; j++) {
        //    for (int i = 0; i < Image2->Picture->Bitmap->Width; i++) {
        //        if (Image2->Picture->Bitmap->Canvas->Pixels[i][j] == merge1colour || Image2->Picture->Bitmap->Canvas->Pixels[i][j] == merge2colour) {
        //            Image2->Picture->Bitmap->Canvas->Pixels[i][j] = replacementcolour;
        //            }
        //        }
        //    }
        for (int j = 0; j < ModifiedBitmap->Height; j++) {
            for (int i = 0; i < ModifiedBitmap->Width; i++) {
                if (ModifiedBitmap->Canvas->Pixels[i][j] == merge1colour || ModifiedBitmap->Canvas->Pixels[i][j] == merge2colour) {
                    ModifiedBitmap->Canvas->Pixels[i][j] = replacementcolour;
                    }
                }
            }
        EraseFind();
        DrawModifiedBitmap();

        //do the operation to the arrays.
        if (merge1 != replacement) {
            PictureColourPallette[replacement].StitchCount += PictureColourPallette[merge1].StitchCount;
            if (merge1 < merge2) merge2--;
            if (merge1 < replacement) replacement--;
            for (int i = merge1; i < PictureColourPallette.Length - 1; i++) {
                PictureColourPallette[i] = PictureColourPallette[i + 1];
                }
            PictureColourPallette.Length--;
            }
        if (merge2 != replacement) {
            PictureColourPallette[replacement].StitchCount += PictureColourPallette[merge2].StitchCount;
            for (int i = merge2; i < PictureColourPallette.Length - 1; i++) {
                PictureColourPallette[i] = PictureColourPallette[i + 1];
                }
            PictureColourPallette.Length--;
            }

        changed = true;

        UndoButton->Hint = UndoList->Strings[UndoList->Count - 1];
        UndoButton->Enabled = true;

        //update the listboxes & contents
        UpdateListBoxes();

        } //end of  'if (merge1 != merge2) {'

    
}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::UndoButtonClick(TObject *Sender)
{
    //undo the last operation
    if (undolevel > 0) {
        undolevel--;
        //first the bitmaps.
        //Image2->Picture->Bitmap->Assign(UndoBitmap1);
        ModifiedBitmap->Assign(UndoBitmap1);
        DrawModifiedBitmap();
        if (!UndoBitmap2->Empty) UndoBitmap1->Assign(UndoBitmap2);
        if (!UndoBitmap3->Empty) UndoBitmap2->Assign(UndoBitmap3);
        if (!UndoBitmap4->Empty) UndoBitmap3->Assign(UndoBitmap4);
        if (!UndoBitmap5->Empty) UndoBitmap4->Assign(UndoBitmap5);
        if (!UndoBitmap6->Empty) UndoBitmap5->Assign(UndoBitmap6);
        if (!UndoBitmap7->Empty) UndoBitmap6->Assign(UndoBitmap7);
        if (!UndoBitmap8->Empty) UndoBitmap7->Assign(UndoBitmap8);

        AnsiString LastLine = UndoList->Strings[UndoList->Count - 1];

        if (LastLine.Pos("Merge")) {
            int merge1, merge2, replacement;
            DMCColourData merge1colour, merge2colour, replacementcolour;
            AnsiString text;
            //read data for merge1
            text = UndoList->Strings[UndoList->Count - 4];
            merge1 = ExtractWord(text,",").ToIntDef(1);
            merge1colour = ReadColourInfo(DeleteWord(text,","));
            //read data for merge2
            text = UndoList->Strings[UndoList->Count - 3];
            merge2 = ExtractWord(text,",").ToIntDef(1);
            merge2colour = ReadColourInfo(DeleteWord(text,","));
            //read data for replacement
            text = UndoList->Strings[UndoList->Count - 2];
            replacement = ExtractWord(text,",").ToIntDef(1);
            replacementcolour = ReadColourInfo(DeleteWord(text,","));
            //delete lines from undolist
            for (int i = 0; i < 4; i++) {
                UndoList->Delete(UndoList->Count - 1);
                }
            //now to alter the arrays, six possible conditions to account for
            if (merge1 < merge2) {
                if (replacement == merge1) {
                    //just need to substitute merge1colour for the current value of
                    //PictureColourPallette[merge1] and insert merge2colour
                    //at array index merge2;
                    PictureColourPallette[merge1] = merge1colour;
                    PictureColourPallette.Length++;
                    for (int i = PictureColourPallette.Length-1; i > merge2; i--) {
                        PictureColourPallette[i] = PictureColourPallette[i-1];
                        }
                    PictureColourPallette[merge2] = merge2colour;
                    } else {
                    if (replacement == merge2) {
                        //need to insert merge1colour at array index merge1
                        //then replace PictureColourPallette[merge2] with merge2colour
                        PictureColourPallette.Length++;
                        for (int i = PictureColourPallette.Length-1; i > merge1; i--) {
                            PictureColourPallette[i] = PictureColourPallette[i-1];
                            }
                        PictureColourPallette[merge1] = merge1colour;
                        PictureColourPallette[merge2] = merge2colour;
                        } else {
                        //need to insert merge1colour and merge2colour and overwrite
                        //PictureColourPallette[replacement]
                        PictureColourPallette.Length++;
                        for (int i = PictureColourPallette.Length-1; i > merge1; i--) {
                            PictureColourPallette[i] = PictureColourPallette[i-1];
                            }
                        PictureColourPallette[merge1] = merge1colour;
                        PictureColourPallette.Length++;
                        for (int i = PictureColourPallette.Length-1; i > merge2; i--) {
                            PictureColourPallette[i] = PictureColourPallette[i-1];
                            }
                        PictureColourPallette[merge2] = merge2colour;
                        PictureColourPallette[replacement] = replacementcolour;
                        }
                    }
                } else {
                //now, know that merge1 != merge2, so merge2 < merge1
                if (replacement == merge1) {
                    //need to insert merge2colour at array index merge2
                    //then substitute merge1colour for the current value of
                    //PictureColourPallette[merge1]
                    PictureColourPallette.Length++;
                    for (int i = PictureColourPallette.Length-1; i > merge2; i--) {
                        PictureColourPallette[i] = PictureColourPallette[i-1];
                        }
                    PictureColourPallette[merge2] = merge2colour;
                    PictureColourPallette[merge1] = merge1colour;
                    } else {
                    if (replacement == merge2) {
                        //replace PictureColourPallette[merge2] with merge2colour
                        //then insert merge1colour at array index merge1
                        PictureColourPallette[merge2] = merge2colour;
                        PictureColourPallette.Length++;
                        for (int i = PictureColourPallette.Length-1; i > merge1; i--) {
                            PictureColourPallette[i] = PictureColourPallette[i-1];
                            }
                        PictureColourPallette[merge1] = merge1colour;
                        } else {
                        //need to insert merge2colour then merge1colour and overwrite
                        //PictureColourPallette[replacement]
                        PictureColourPallette.Length++;
                        for (int i = PictureColourPallette.Length-1; i > merge2; i--) {
                            PictureColourPallette[i] = PictureColourPallette[i-1];
                            }
                        PictureColourPallette[merge2] = merge2colour;
                        PictureColourPallette.Length++;
                        for (int i = PictureColourPallette.Length-1; i > merge1; i--) {
                            PictureColourPallette[i] = PictureColourPallette[i-1];
                            }
                        PictureColourPallette[merge1] = merge1colour;
                        PictureColourPallette[replacement] = replacementcolour;
                        }
                    }
                }
            }
        if (LastLine.Pos("Replace")) {
            int merge1;
            DMCColourData merge1colour;
            AnsiString text;
            //read data for merge1
            text = UndoList->Strings[UndoList->Count - 2];
            merge1 = ExtractWord(text,",").ToIntDef(1);
            merge1colour = ReadColourInfo(DeleteWord(text,","));
            //delete lines from undolist
            for (int i = 0; i < 2; i++) {
                UndoList->Delete(UndoList->Count - 1);
                }
            //do the actual undo
            PictureColourPallette[merge1] = merge1colour;
            }

        if (undolevel > 0) {
            UndoButton->Hint = UndoList->Strings[UndoList->Count - 1];
            UndoButton->Enabled = true;
            } else {
            UndoButton->Hint = "No More to Undo";
            UndoButton->Enabled = false;
            }

        UpdateListBoxes();
        }

        
}
//---------------------------------------------------------------------------

DMCColourData __fastcall TThreadMergeForm::ReadColourInfo(AnsiString text)
{
    //reads a text line to find the colour data contained
    DMCColourData result;

    result.DMCColourNumber = ExtractWord(text,",");
    text = DeleteWord(text,",");
    result.DMCColourName = ExtractWord(text,",");
    text = DeleteWord(text,",");
    result.AnchorColourNumber = ExtractWord(text,",");
    text = DeleteWord(text,",");
    result.Colour = (TColor) ExtractWord(text,",").ToIntDef(16777215);
    text = DeleteWord(text,",");
    result.DrawWhite = (bool) ExtractWord(text,",").ToIntDef(1);
    text = DeleteWord(text,",");
    result.StitchCount = ExtractWord(text,",").ToIntDef(1);
    text = DeleteWord(text,",");
    result.AnchorColourToUse = ExtractWord(text,",").ToIntDef(1);
    text = DeleteWord(text,",");
    result.AnchorStitchCount = ExtractWord(text,",").ToIntDef(1);
    text = DeleteWord(text,",");
    result.AnchorGlyphToUse = ExtractWord(text,",").ToIntDef(1);
    text = DeleteWord(text,",");
    result.R = ExtractWord(text,",").ToIntDef(255);
    text = DeleteWord(text,",");
    result.G = ExtractWord(text,",").ToIntDef(255);
    text = DeleteWord(text,",");
    result.B = ExtractWord(text,",").ToIntDef(255);
    text = DeleteWord(text,",");
    result.Hue = ToDoubleDef(ExtractWord(text,","),180.0);
    text = DeleteWord(text,",");
    result.Saturation = ToDoubleDef(ExtractWord(text,","),1.0);
    text = DeleteWord(text,",");
    result.Brightness = ToDoubleDef(ExtractWord(text,","),1.0);


    return result;

}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::UpdateListBoxes(void)
{
    MergeColour1->Clear();
    MergeColour2->Clear();
    ReplacementColour->Clear();
    SubstituteColour->Clear();
    ReplacementColour2->Clear();

    for (int i = 0; i < PictureColourPallette.Length; i++) {
        //MergeColour1->Items->Add("DMC" + PictureColourPallette[i].DMCColourNumber + " " + PictureColourPallette[i].DMCColourName + "  " + AnsiString(PictureColourPallette[i].StitchCount) + " Stitches");
        MergeColour1->Items->Add(ShortThreadName + PictureColourPallette[i].DMCColourNumber + " " + PictureColourPallette[i].DMCColourName + "  " + AnsiString(PictureColourPallette[i].StitchCount) + " Stitches");
        MergeColour2->Items->Add(MergeColour1->Items->Strings[i]);
        ReplacementColour->Items->Add(MergeColour1->Items->Strings[i]);
        SubstituteColour->Items->Add(MergeColour1->Items->Strings[i]);
        }

    if (PictureColourPallette.Length > 2) {
        MergeColour1->ItemIndex = PictureColourPallette.Length - 1;
        MergeColour2->ItemIndex = PictureColourPallette.Length - 2;
        ReplacementColour->ItemIndex = PictureColourPallette.Length - 3;
        SubstituteColour->ItemIndex = PictureColourPallette.Length - 1;
        } else {
        MergeColour1->ItemIndex = 0;
        MergeColour2->ItemIndex = 0;
        ReplacementColour->ItemIndex = 0;
        SubstituteColour->ItemIndex = 0;
        }
    for (int i = 0; i < DMCColourList.Length; i++) {
        //ReplacementColour2->Items->Add("DMC" + DMCColourList[i].DMCColourNumber + " " + DMCColourList[i].DMCColourName);
        ReplacementColour2->Items->Add(ShortThreadName + DMCColourList[i].DMCColourNumber + " " + DMCColourList[i].DMCColourName);
        }

    MergeColour2Change(MergeColour1);
    MergeColour2Change(MergeColour2);

    ReplacementColour2->ItemIndex = 0;

    StatusBar1->Panels->Items[0]->Text = "No. Colours = " + AnsiString(PictureColourPallette.Length);

}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::DisplayHint(TObject *Sender)
{
    StatusBar1->Panels->Items[2]->Text = " " + GetLongHint(Application->Hint);

}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::MergeColour2Change(TObject *Sender)
{
    //find the nearest existing colour to this one
    int itemindex = dynamic_cast<TComboBox *>(Sender)->ItemIndex;
    NearestColour.Length = PictureColourPallette.Length;
    for (int i = 0; i < NearestColour.Length; i++) {
        NearestColour[i].leastsquares = (PictureColourPallette[itemindex].R - PictureColourPallette[i].R)
                                        * (PictureColourPallette[itemindex].R - PictureColourPallette[i].R)
                                        + (PictureColourPallette[itemindex].G - PictureColourPallette[i].G)
                                        * (PictureColourPallette[itemindex].G - PictureColourPallette[i].G)
                                        + (PictureColourPallette[itemindex].B - PictureColourPallette[i].B)
                                        * (PictureColourPallette[itemindex].B - PictureColourPallette[i].B);
        NearestColour[i].entrynumber = i;
        }
    //now to quickly sort this lot
    QuickSortThreadSquares(0, NearestColour.Length - 1);
    //The lowest match will always be the colour, so want the hint to show the next one
    //dynamic_cast<TComboBox *>(Sender)->Hint = "Suggested Merge Colour = DMC" + PictureColourPallette[NearestColour[1].entrynumber].DMCColourNumber + " " + PictureColourPallette[NearestColour[1].entrynumber].DMCColourName + "  " + AnsiString(PictureColourPallette[NearestColour[1].entrynumber].StitchCount) + " Stitches";
    dynamic_cast<TComboBox *>(Sender)->Hint = "Suggested Merge Colour = " + ShortThreadName + PictureColourPallette[NearestColour[1].entrynumber].DMCColourNumber + " " + PictureColourPallette[NearestColour[1].entrynumber].DMCColourName + "  " + AnsiString(PictureColourPallette[NearestColour[1].entrynumber].StitchCount) + " Stitches";

    NearestColour.Length = 0;

    if (FindButton1->Caption == "Stop" && Image3inuse) {
        ReplacementColourChange(Sender);
        }

}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::QuickSortThreadSquares(int low, int high)
{
    int Lo, Hi;
    double Mid;
    nearestcolour swap;

    Lo = low;
    Hi = high;

    Mid = NearestColour[(Lo + Hi)/2].leastsquares;

    do {
        while (NearestColour[Lo].leastsquares < Mid) Lo++;
        while (NearestColour[Hi].leastsquares > Mid) Hi--;
        if (Lo <= Hi) {
            swap = NearestColour[Lo];
            NearestColour[Lo] = NearestColour[Hi];
            NearestColour[Hi] = swap;
            Lo++;
            Hi--;
            }
        } while (Lo <= Hi) ;

    if (Hi > low) {
        QuickSortThreadSquares(low, Hi);
        }

    if (Lo < high) {
        QuickSortThreadSquares(Lo, high);
        }
}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::MergeColour1Change(TObject *Sender)
{
    ReplacementColour->ItemIndex = MergeColour2->ItemIndex;
    MergeColour2Change(Sender);
    if (FindButton1->Caption == "Stop" && Image3inuse) {
        ReplacementColourChange(Sender);
        }
}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::ReplacementColour2DrawItem(
      TWinControl *Control, int Index, TRect &Rect, TOwnerDrawState State)
{
    // Draw coloured rectangle background & name of colour
    TRect Rectangle = Rect;
    TColor TempColour = dynamic_cast<TComboBox *>(Control)->Canvas->Brush->Color;
    dynamic_cast<TComboBox *>(Control)->Canvas->Brush->Style = bsSolid;
    dynamic_cast<TComboBox *>(Control)->Canvas->Brush->Color = DMCColourList[Index].Colour;
    dynamic_cast<TComboBox *>(Control)->Canvas->FillRect(Rectangle);
    dynamic_cast<TComboBox *>(Control)->Canvas->Brush->Color = TempColour;
    if (DMCColourList[Index].DrawWhite) {
        dynamic_cast<TComboBox *>(Control)->Canvas->Font->Color = clWhite;
        } else {
        dynamic_cast<TComboBox *>(Control)->Canvas->Font->Color = clBlack;
        }
    dynamic_cast<TComboBox *>(Control)->Canvas->Brush->Style = bsClear;
    //for some reason the next line doesn't work
    //dynamic_cast<TComboBox *>(Control)->Canvas->TextRect(Rectangle,1,1,dynamic_cast<TComboBox *>(Control)->Items->Strings[Index]);
    DrawText(dynamic_cast<TComboBox *>(Control)->Canvas->Handle,("  " + dynamic_cast<TComboBox *>(Control)->Items->Strings[Index]).c_str(),-1,(LPRECT) &Rectangle,DT_VCENTER | DT_SINGLELINE);
    dynamic_cast<TComboBox *>(Control)->Canvas->Brush->Style = bsSolid;

}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::ReplaceButtonClick(TObject *Sender)
{
    //first thing, see if the replacement colour is in the existing pallette range
    bool found = false;
    int pointer = 0;
    TColor merge1colour = PictureColourPallette[SubstituteColour->ItemIndex].Colour;
    TColor colour = DMCColourList[ReplacementColour2->ItemIndex].Colour;

    while (!found && pointer < PictureColourPallette.Length) {
        if (colour == PictureColourPallette[pointer].Colour) {
            found = true;
            pointer--;
            }
        pointer++;
        }

    if (found) {
        //colour found so this is a merge rather than a substitute
        MergeColour1->ItemIndex = pointer;
        MergeColour2->ItemIndex = SubstituteColour->ItemIndex;
        ReplacementColour->ItemIndex = pointer;
        MergeButtonClick(Sender);
        } else {
        //This is a substitute
        int merge1 = SubstituteColour->ItemIndex;
        int replacement = ReplacementColour2->ItemIndex;
        AnsiString temp;
        undolevel++;
        if (undolevel > 8) undolevel = 8;
        //first, before doing anything, run through the undos
        if (!UndoBitmap7->Empty) UndoBitmap8->Assign(UndoBitmap7);
        if (!UndoBitmap6->Empty) UndoBitmap7->Assign(UndoBitmap6);
        if (!UndoBitmap5->Empty) UndoBitmap6->Assign(UndoBitmap5);
        if (!UndoBitmap4->Empty) UndoBitmap5->Assign(UndoBitmap4);
        if (!UndoBitmap3->Empty) UndoBitmap4->Assign(UndoBitmap3);
        if (!UndoBitmap2->Empty) UndoBitmap3->Assign(UndoBitmap2);
        if (!UndoBitmap1->Empty) UndoBitmap2->Assign(UndoBitmap1);
        UndoBitmap1->Assign(Image2->Picture->Bitmap);
        //write data to undolist merge colour 1 first
        temp = AnsiString(merge1) + "," + PictureColourPallette[merge1].DMCColourNumber;
        temp = temp + "," + PictureColourPallette[merge1].DMCColourName;
        temp = temp + "," + PictureColourPallette[merge1].AnchorColourNumber;
        temp = temp + "," + AnsiString((int)PictureColourPallette[merge1].Colour);
        temp = temp + "," + AnsiString((int)PictureColourPallette[merge1].DrawWhite);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].StitchCount);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].AnchorColourToUse);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].AnchorStitchCount);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].AnchorGlyphToUse);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].R);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].G);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].B);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].Hue);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].Saturation);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].Brightness) + ",";
        UndoList->Add(temp);
        //finally say which type of operation this is.
       // UndoList->Add("Replace DMC" + PictureColourPallette[merge1].DMCColourNumber + " with DMC" + DMCColourList[replacement].DMCColourNumber);
        UndoList->Add("Replace " + ShortThreadName + PictureColourPallette[merge1].DMCColourNumber + " with " + ShortThreadName + DMCColourList[replacement].DMCColourNumber);

        //now do the operation
        //for (int j = 0; j < Image2->Picture->Bitmap->Height; j++) {
        //    for (int i = 0; i < Image2->Picture->Bitmap->Width; i++) {
        //        if (Image2->Picture->Bitmap->Canvas->Pixels[i][j] == merge1colour) {
        //            Image2->Picture->Bitmap->Canvas->Pixels[i][j] = colour;
        //            }
        //        }
        //    }
        for (int j = 0; j < ModifiedBitmap->Height; j++) {
            for (int i = 0; i < ModifiedBitmap->Width; i++) {
                if (ModifiedBitmap->Canvas->Pixels[i][j] == merge1colour) {
                    ModifiedBitmap->Canvas->Pixels[i][j] = colour;
                    }
                }
            }
        EraseFind();
        DrawModifiedBitmap();
        DMCColourData data = PictureColourPallette[merge1];
        PictureColourPallette[merge1] = DMCColourList[replacement];

        //now update ancilliary info
        PictureColourPallette[merge1].StitchCount = data.StitchCount;
        PictureColourPallette[merge1].AnchorStitchCount = data.AnchorStitchCount;
        PictureColourPallette[merge1].AnchorGlyphToUse = data.AnchorGlyphToUse;

        //update screen info
        changed = true;

        UndoButton->Hint = UndoList->Strings[UndoList->Count - 1];
        UndoButton->Enabled = true;

        //update the listboxes & contents
        UpdateListBoxes();
        }
}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::OKButtonClick(TObject *Sender)
{
    ModalResult = mrOk;
}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::Initialise(void)
{
    Image1->Width = OriginalBitmap->Width;
    Image1->Height = OriginalBitmap->Height;
    Image1->Picture->Bitmap->Width = OriginalBitmap->Width;
    Image1->Picture->Bitmap->Height = OriginalBitmap->Height;
    Image2->Width = OriginalBitmap->Width;
    Image2->Height = OriginalBitmap->Height;
    Image2->Picture->Bitmap->Width = OriginalBitmap->Width;
    Image2->Picture->Bitmap->Height = OriginalBitmap->Height;
    Image3->Width = OriginalBitmap->Width;
    Image3->Height = OriginalBitmap->Height;
    Image3->Picture->Bitmap->Width = OriginalBitmap->Width;
    Image3->Picture->Bitmap->Height = OriginalBitmap->Height;
    ImageResize();
    UpdateListBoxes();
    RedEditChange(this);
    StatusBar1->Panels->Items[1]->Text = " Scale = " + AnsiString(imagescale);
    DrawBitmaps();
    Label12->Caption = "Nearest " + ShortThreadName + " Colour";
    UseDMCButton->Caption = "Replace with " + ShortThreadName;
}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::DrawBitmaps(void)
{
    DrawOriginalBitmap();
    DrawModifiedBitmap();
    DrawFindBitmap();
}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::DrawOriginalBitmap(void)
{
    //draws the visible section of the original bitmap in Image 1
    /*
    Graphics::TBitmap *TempBitmap = new Graphics::TBitmap();
    TempBitmap->Width = OriginalBitmap->Width/imagescale;
    TempBitmap->Height = OriginalBitmap->Height/imagescale;
    if ((-1 * TopLeftCorner.X + OriginalBitmap->Width) > TempBitmap->Width) TopLeftCorner.X = OriginalBitmap->Width - TempBitmap->Width;
    if ((-1 * TopLeftCorner.Y + OriginalBitmap->Height) > TempBitmap->Height) TopLeftCorner.Y = OriginalBitmap->Height - TempBitmap->Height;
    TempBitmap->Canvas->Draw(-1 * TopLeftCorner.X, -1 * TopLeftCorner.Y, OriginalBitmap);
    TRect Rectangle;
    Rectangle.Left = 0;
    Rectangle.Top = 0;
    Rectangle.Right = Image1->Picture->Bitmap->Width;
    Rectangle.Bottom = Image1->Picture->Bitmap->Height;
    Image1->Picture->Bitmap->Canvas->StretchDraw(Rectangle,TempBitmap);
    delete TempBitmap;
    */
    TRect Rectangle;
    //clear image
    Rectangle.Left = 0;
    Rectangle.Top = 0;
    Rectangle.Right = Image1->Picture->Bitmap->Width;
    Rectangle.Bottom = Image1->Picture->Bitmap->Height;
    Image1->Picture->Bitmap->Canvas->FillRect(Rectangle);
    //draw new image
    Rectangle.Left = -TopLeftCorner.X * imagescale;
    Rectangle.Top = -TopLeftCorner.Y * imagescale;
    Rectangle.Right = Rectangle.Left + OriginalBitmap->Width * imagescale;
    Rectangle.Bottom = Rectangle.Top + OriginalBitmap->Height * imagescale;
    if (Rectangle.Left > 0) {
        Rectangle.Left = 0;
        Rectangle.Right = OriginalBitmap->Width * imagescale;
        }
    if (Rectangle.Top > 0) {
        Rectangle.Top = 0;
        Rectangle.Bottom = OriginalBitmap->Height * imagescale;
        }
    if (Rectangle.Right < OriginalBitmap->Width) {
        Rectangle.Right = OriginalBitmap->Width;
        Rectangle.Left = Rectangle.Right - OriginalBitmap->Width * imagescale;
        }
    if (Rectangle.Bottom < OriginalBitmap->Height) {
        Rectangle.Bottom = OriginalBitmap->Height;
        Rectangle.Top = Rectangle.Bottom - OriginalBitmap->Height * imagescale;
        }
    Image1->Picture->Bitmap->Canvas->StretchDraw(Rectangle,OriginalBitmap);


}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::DrawModifiedBitmap(void)
{
    //draws the visible section of the modifiedl bitmap in Image 2
    /*
    Graphics::TBitmap *TempBitmap = new Graphics::TBitmap();
    TempBitmap->Width = ModifiedBitmap->Width/imagescale;
    TempBitmap->Height = ModifiedBitmap->Height/imagescale;
    if ((-1 * TopLeftCorner.X + ModifiedBitmap->Width) > TempBitmap->Width) TopLeftCorner.X = ModifiedBitmap->Width - TempBitmap->Width;
    if ((-1 * TopLeftCorner.Y + ModifiedBitmap->Height) > TempBitmap->Height) TopLeftCorner.Y = ModifiedBitmap->Height - TempBitmap->Height;
    TempBitmap->Canvas->Draw(-1 * TopLeftCorner.X, -1 * TopLeftCorner.Y, ModifiedBitmap);
    TRect Rectangle;
    Rectangle.Left = 0;
    Rectangle.Top = 0;
    Rectangle.Right = Image2->Picture->Bitmap->Width;
    Rectangle.Bottom = Image2->Picture->Bitmap->Height;
    Image2->Picture->Bitmap->Canvas->StretchDraw(Rectangle,TempBitmap);
    delete TempBitmap;
    */
    TRect Rectangle;
    //clear image
    Rectangle.Left = 0;
    Rectangle.Top = 0;
    Rectangle.Right = Image2->Picture->Bitmap->Width;
    Rectangle.Bottom = Image2->Picture->Bitmap->Height;
    Image2->Picture->Bitmap->Canvas->FillRect(Rectangle);
    //draw new image
    Rectangle.Left = -TopLeftCorner.X * imagescale;
    Rectangle.Top = -TopLeftCorner.Y * imagescale;
    Rectangle.Right = Rectangle.Left + ModifiedBitmap->Width * imagescale;
    Rectangle.Bottom = Rectangle.Top + ModifiedBitmap->Height * imagescale;
    if (Rectangle.Left > 0) {
        Rectangle.Left = 0;
        Rectangle.Right = ModifiedBitmap->Width * imagescale;
        }
    if (Rectangle.Top > 0) {
        Rectangle.Top = 0;
        Rectangle.Bottom = ModifiedBitmap->Height * imagescale;
        }
    if (Rectangle.Right < ModifiedBitmap->Width) {
        Rectangle.Right = ModifiedBitmap->Width;
        Rectangle.Left = Rectangle.Right - ModifiedBitmap->Width * imagescale;
        }
    if (Rectangle.Bottom < ModifiedBitmap->Height) {
        Rectangle.Bottom = ModifiedBitmap->Height;
        Rectangle.Top = Rectangle.Bottom - ModifiedBitmap->Height * imagescale;
        }
    Image2->Picture->Bitmap->Canvas->StretchDraw(Rectangle,ModifiedBitmap);

}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::FormMouseWheelUp(TObject *Sender,
      TShiftState Shift, TPoint &MousePos, bool &Handled)
{
    static int localcounter = 0;
    localcounter++;
    if (!(localcounter%3)){
        if (imagescale < 10) imagescale++;
        StatusBar1->Panels->Items[1]->Text = " Scale = " + AnsiString(imagescale);
        DrawBitmaps();
        Image1->Cursor = crTargetCursor;
        Image2->Cursor = crTargetCursor;
        Image3->Cursor = crTargetCursor;
        }
}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::FormMouseWheelDown(TObject *Sender,
      TShiftState Shift, TPoint &MousePos, bool &Handled)
{
    static int localcounter = 0;
    localcounter++;
    if (!(localcounter%3)){
        if (imagescale > 1) imagescale--;
        StatusBar1->Panels->Items[1]->Text = " Scale = " + AnsiString(imagescale);
        DrawBitmaps();
        if(imagescale == 1) {
            Image1->Cursor = crGrabCursor;
            Image2->Cursor = crGrabCursor;
            Image3->Cursor = crGrabCursor;
            }
        }
}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::Image1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
    Location.X = X;
    Location.Y = Y;
    if (dragging && (Location.X != oldLocation.X || Location.Y != oldLocation.Y)) {
        /*if (Image1->Cursor != crGrabCursor) {
            Image1->Cursor = crGrabCursor;
            Image2->Cursor = crGrabCursor;
            Refresh();
            }*/
        TopLeftCorner.X = oldTopLeftCorner.X - (Location.X - oldLocation.X)/imagescale;
        TopLeftCorner.Y = oldTopLeftCorner.Y - (Location.Y - oldLocation.Y)/imagescale;
        DrawBitmaps();
        }
}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::Image1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    dragging = true;
    //Image1->Cursor = crHourGlass;
    //Image2->Cursor = crGrabCursor;
    oldLocation.X = X;
    oldLocation.Y = Y;
    oldTopLeftCorner = TopLeftCorner;
}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::Image1MouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    dragging = false;
    Location.X = X;
    Location.Y = Y;
    TopLeftCorner.X = oldTopLeftCorner.X - (Location.X - oldLocation.X)/imagescale;
    TopLeftCorner.Y = oldTopLeftCorner.Y - (Location.Y - oldLocation.Y)/imagescale;
    //if (Image1->Cursor != crTargetCursor) {
    //Image1->Cursor = crTargetCursor;
    //Image2->Cursor = crTargetCursor;
   //     }

}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::ResetImageClick(TObject *Sender)
{
    imagescale = 1;
    TopLeftCorner.X = 0;
    TopLeftCorner.Y = 0;
    StatusBar1->Panels->Items[1]->Text = " Scale = " + AnsiString(imagescale);
    Image1->Cursor = crGrabCursor;
    Image2->Cursor = crGrabCursor;
    Image3->Cursor = crGrabCursor;
    DrawBitmaps();
}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::Image1DblClick(TObject *Sender)
{
    //find the colour at Location and select the appropriate Mergecolours combobox

    //calculate chart image position of current cursor
    chartposition ChartLocation;
    ChartLocation.X = Location.X / imagescale + TopLeftCorner.X;
    ChartLocation.Y = Location.Y / imagescale + TopLeftCorner.Y;

    //get colour at current cursor
    bool senderisimage2 = true;
    if (dynamic_cast <TImage *>(Sender)->Name == "Image1") senderisimage2 = false;
    TColor selectedpixelcolour;
    if (!senderisimage2) {
        selectedpixelcolour = OriginalBitmap->Canvas->Pixels[ChartLocation.X][ChartLocation.Y];
        } else {
        selectedpixelcolour = ModifiedBitmap->Canvas->Pixels[ChartLocation.X][ChartLocation.Y];
        }

    //find colour
    bool found = false;
    int pointer = 0;
    while (!found && pointer < PictureColourPallette.Length) {
        if (selectedpixelcolour == PictureColourPallette[pointer].Colour) {
            found = true;
            pointer--;
            }
        pointer++;
        }
    //select correct merge colour index
    if (found) {
        if (setmerge1) {
            MergeColour1->ItemIndex = pointer;
            } else {
            MergeColour2->ItemIndex = pointer;
            MergeColour1Change(MergeColour2);
            }
        } else {
        StatusBar1->Panels->Items[2]->Text = " Colour has already been merged into another colour.";
        }


    setmerge1 = !setmerge1;     

}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::FindButton1Click(TObject *Sender)
{
    if (FindButton1->Caption == "Stop") {
        Image3inuse = false;
        FindButton1->Caption = "Find";
        Image3->Visible = false;
        Label7->Visible = false;
        Timer1->Enabled = false;
        } else {
        Image3inuse = true;
        InitialiseFindBitmaps();
        FillFindBitmaps(PictureColourPallette[MergeColour1->ItemIndex].Colour);
        FillFindBitmaps(PictureColourPallette[MergeColour2->ItemIndex].Colour);
        FillFindBitmaps(PictureColourPallette[ReplacementColour->ItemIndex].Colour);
        showingbrightbitmap = true;
        DrawFindBitmap();
        Image3->Visible = true;
        Label7->Visible = true;
        Timer1->Enabled = true;
        FindButton1->Caption = "Stop";
        FindButton2->Caption = "Find";
        }

}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::Timer1Timer(TObject *Sender)
{
    showingbrightbitmap = !showingbrightbitmap;
    DrawFindBitmap();
}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::DrawFindBitmap(void)
{
    if (Image3inuse) {
        //draws the visible section of the currently flashed find bitmap in Image 3
        TRect Rectangle;
        //clear image
        Rectangle.Left = 0;
        Rectangle.Top = 0;
        Rectangle.Right = Image2->Picture->Bitmap->Width;
        Rectangle.Bottom = Image2->Picture->Bitmap->Height;
        Image3->Picture->Bitmap->Canvas->FillRect(Rectangle);
        //draw new image
        Rectangle.Left = -TopLeftCorner.X * imagescale;
        Rectangle.Top = -TopLeftCorner.Y * imagescale;
        Rectangle.Right = Rectangle.Left + ModifiedBitmap->Width * imagescale;
        Rectangle.Bottom = Rectangle.Top + ModifiedBitmap->Height * imagescale;
        if (Rectangle.Left > 0) {
            Rectangle.Left = 0;
            Rectangle.Right = ModifiedBitmap->Width * imagescale;
            }
        if (Rectangle.Top > 0) {
            Rectangle.Top = 0;
            Rectangle.Bottom = ModifiedBitmap->Height * imagescale;
            }
        if (Rectangle.Right < ModifiedBitmap->Width) {
            Rectangle.Right = ModifiedBitmap->Width;
            Rectangle.Left = Rectangle.Right - ModifiedBitmap->Width * imagescale;
            }
        if (Rectangle.Bottom < ModifiedBitmap->Height) {
            Rectangle.Bottom = ModifiedBitmap->Height;
            Rectangle.Top = Rectangle.Bottom - ModifiedBitmap->Height * imagescale;
            }
        if (showingbrightbitmap) {
            Image3->Picture->Bitmap->Canvas->StretchDraw(Rectangle,BrightBitmap);
            } else {
            Image3->Picture->Bitmap->Canvas->StretchDraw(Rectangle,DarkBitmap);
            }
        }

}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::InitialiseFindBitmaps(void)
{
    BrightBitmap->Assign(ModifiedBitmap);
    DarkBitmap->Assign(ModifiedBitmap);
}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::FillFindBitmaps(TColor Colour)
{
    TColor invertcolour = (TColor) ~Colour;
    for (int i = 0; i < ModifiedBitmap->Width; i++) {
        for (int j = 0; j < ModifiedBitmap->Height; j++) {
            if (ModifiedBitmap->Canvas->Pixels[i][j] == Colour) {
                DarkBitmap->Canvas->Pixels[i][j] = invertcolour;
                }
            }
        }
}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::FindButton2Click(TObject *Sender)
{
    if (FindButton2->Caption == "Stop") {
        Image3inuse = false;
        FindButton2->Caption = "Find";
        Image3->Visible = false;
        Label7->Visible = false;
        Timer1->Enabled = false;
        } else {
        Image3inuse = true;
        InitialiseFindBitmaps();
        FillFindBitmaps(PictureColourPallette[SubstituteColour->ItemIndex].Colour);
        showingbrightbitmap = true;
        DrawFindBitmap();
        Image3->Visible = true;
        Label7->Visible = true;
        Timer1->Enabled = true;
        FindButton2->Caption = "Stop";
        FindButton1->Caption = "Find";
        }

}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::EraseFind(void)
{
    Image3inuse = false;
    Image3->Visible = false;
    Label7->Visible = false;
    Timer1->Enabled = false;
    FindButton1->Caption = "Find";
    FindButton2->Caption = "Find";
}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::RedEditChange(TObject *Sender)
{
    //This method re-calculates the nearest colour to the rgb values entered
    int R = RedEdit->Text.ToIntDef(255);
    int G = GreenEdit->Text.ToIntDef(255);
    int B = BlueEdit->Text.ToIntDef(255);
    if (R > 255) R = 255;
    if (R < 0) R = 0;
    if (G > 255) G = 255;
    if (G < 0) G = 0;
    if (B > 255) B = 255;
    if (B < 0) B = 0;
    int Pixel = R + G * 256 + B * 256 * 256;
    rgb RGB = ExtractRGB((TColor) Pixel);
    Shape1->Brush->Color = (TColor) Pixel;
    Shape1->Hint = "Entered Colour R:" + AnsiString(RGB.R) + " G:" + AnsiString(RGB.G) + " B:" + AnsiString(RGB.B);

    //find nearest DMC colour
    DynamicArray <int> LeastSquares;
    LeastSquares.Length = DMCColourList.Length;
    for (int i = 0; i < LeastSquares.Length; i++) {
        LeastSquares[i] = (RGB.R - DMCColourList[i].R) * (RGB.R - DMCColourList[i].R) + (RGB.G - DMCColourList[i].G) * (RGB.G - DMCColourList[i].G) + (RGB.B - DMCColourList[i].B) * (RGB.B - DMCColourList[i].B);
        }
    int value = LeastSquares[0];
    int pointer = 0;
    for (int i = 1; i < LeastSquares.Length; i++) {
        if (LeastSquares[i] < value) {
            value = LeastSquares[i];
            pointer = i;
            }
        }
    LeastSquares.Length = 0;
    //Nearest DMC colour is now found.
    Shape2->Brush->Color = DMCColourList[pointer].Colour;
    //Shape2->Hint = "DMC " + DMCColourList[pointer].DMCColourNumber + " R:" + AnsiString(DMCColourList[pointer].R) + " G:" + AnsiString(DMCColourList[pointer].G) + " B:" + AnsiString(DMCColourList[pointer].B);
    Shape2->Hint = ShortThreadName + " " + DMCColourList[pointer].DMCColourNumber + " R:" + AnsiString(DMCColourList[pointer].R) + " G:" + AnsiString(DMCColourList[pointer].G) + " B:" + AnsiString(DMCColourList[pointer].B);
    replacementcolour = pointer;

    //now to do the same for the tweeded list
    NearestTweed.Length = TweedList.Length;
    for (int i = 0; i < NearestTweed.Length; i++) {
        NearestTweed[i].leastsquares = (RGB.R - TweedList[i].Data.R) * (RGB.R - TweedList[i].Data.R) + (RGB.G - TweedList[i].Data.G) * (RGB.G - TweedList[i].Data.G) + (RGB.B - TweedList[i].Data.B) * (RGB.B - TweedList[i].Data.B);
        NearestTweed[i].entrynumber = i;
        }
    //now to quickly sort this lot
    QuickSortBlendThreadSquares(0, NearestTweed.Length - 1);
    //cut down to 100
    NearestTweed.Length = 100;
    //fill display array
    TweedPallette->Items->Clear();
    for (int i = 0; i < NearestTweed.Length; i++) {
        TweedPallette->Items->Add(TweedList[NearestTweed[i].entrynumber].Data.DMCColourNumber + " R:" + AnsiString(TweedList[NearestTweed[i].entrynumber].Data.R) + " G:" + AnsiString(TweedList[NearestTweed[i].entrynumber].Data.G) + " B:" + AnsiString(TweedList[NearestTweed[i].entrynumber].Data.B) );
        }
    TweedPallette->ItemIndex = 0;
    ShowTweed();

}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::QuickSortBlendThreadSquares(int low, int high)
{
    int Lo, Hi;
    double Mid;
    nearestcolour swap;

    Lo = low;
    Hi = high;

    Mid = NearestTweed[(Lo + Hi)/2].leastsquares;

    do {
        while (NearestTweed[Lo].leastsquares < Mid) Lo++;
        while (NearestTweed[Hi].leastsquares > Mid) Hi--;
        if (Lo <= Hi) {
            swap = NearestTweed[Lo];
            NearestTweed[Lo] = NearestTweed[Hi];
            NearestTweed[Hi] = swap;
            Lo++;
            Hi--;
            }
        } while (Lo <= Hi) ;

    if (Hi > low) {
        QuickSortBlendThreadSquares(low, Hi);
        }

    if (Lo < high) {
        QuickSortBlendThreadSquares(Lo, high);
        }
}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::TweedPalletteDrawItem(
      TWinControl *Control, int Index, TRect &Rect, TOwnerDrawState State)
{
    // Draw coloured rectangle background & name of colour
    TRect Rectangle = Rect;
    TColor TempColour = dynamic_cast<TComboBox *>(Control)->Canvas->Brush->Color;
    dynamic_cast<TComboBox *>(Control)->Canvas->Brush->Style = bsSolid;
    dynamic_cast<TComboBox *>(Control)->Canvas->Brush->Color = TweedList[NearestTweed[Index].entrynumber].Data.Colour;
    dynamic_cast<TComboBox *>(Control)->Canvas->FillRect(Rectangle);
    dynamic_cast<TComboBox *>(Control)->Canvas->Brush->Color = TempColour;
    if (TweedList[NearestTweed[Index].entrynumber].Data.DrawWhite) {
        dynamic_cast<TComboBox *>(Control)->Canvas->Font->Color = clWhite;
        } else {
        dynamic_cast<TComboBox *>(Control)->Canvas->Font->Color = clBlack;
        }
    dynamic_cast<TComboBox *>(Control)->Canvas->Brush->Style = bsClear;
    //for some reason the next line doesn't work
    //dynamic_cast<TComboBox *>(Control)->Canvas->TextRect(Rectangle,1,1,dynamic_cast<TComboBox *>(Control)->Items->Strings[Index]);
    DrawText(dynamic_cast<TComboBox *>(Control)->Canvas->Handle,("  " + dynamic_cast<TComboBox *>(Control)->Items->Strings[Index]).c_str(),-1,(LPRECT) &Rectangle,DT_VCENTER | DT_SINGLELINE);
    dynamic_cast<TComboBox *>(Control)->Canvas->Brush->Style = bsSolid;

}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::ShowTweed(void)
{
        Shape3->Brush->Color = DMCColourList[TweedList[NearestTweed[TweedPallette->ItemIndex].entrynumber].ColourPairs[0].x].Colour;
        Shape3->Hint = DMCColourList[TweedList[NearestTweed[TweedPallette->ItemIndex].entrynumber].ColourPairs[0].x].DMCColourNumber
                        + " " + DMCColourList[TweedList[NearestTweed[TweedPallette->ItemIndex].entrynumber].ColourPairs[0].x].DMCColourName
                        + " R:" + AnsiString(DMCColourList[TweedList[NearestTweed[TweedPallette->ItemIndex].entrynumber].ColourPairs[0].x].R)
                        + " G:" + AnsiString(DMCColourList[TweedList[NearestTweed[TweedPallette->ItemIndex].entrynumber].ColourPairs[0].x].G)
                        + " B:" + AnsiString(DMCColourList[TweedList[NearestTweed[TweedPallette->ItemIndex].entrynumber].ColourPairs[0].x].B);
        Shape4->Brush->Color = DMCColourList[TweedList[NearestTweed[TweedPallette->ItemIndex].entrynumber].ColourPairs[0].y].Colour;
        Shape4->Hint = DMCColourList[TweedList[NearestTweed[TweedPallette->ItemIndex].entrynumber].ColourPairs[0].y].DMCColourNumber
                        + " " + DMCColourList[TweedList[NearestTweed[TweedPallette->ItemIndex].entrynumber].ColourPairs[0].y].DMCColourName
                        + " R:" + AnsiString(DMCColourList[TweedList[NearestTweed[TweedPallette->ItemIndex].entrynumber].ColourPairs[0].y].R)
                        + " G:" + AnsiString(DMCColourList[TweedList[NearestTweed[TweedPallette->ItemIndex].entrynumber].ColourPairs[0].y].G)
                        + " B:" + AnsiString(DMCColourList[TweedList[NearestTweed[TweedPallette->ItemIndex].entrynumber].ColourPairs[0].y].B);
       UpdateButtonHints(this);
}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::TweedPalletteChange(TObject *Sender)
{
    ShowTweed();
    //UpdateButtonHints(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::UpdateButtonHints(TObject *Sender)
{
    //Updates the hints on all the buttons
    //FindButton2->Hint = "Find DMC" + PictureColourPallette[SubstituteColour->ItemIndex].DMCColourNumber;
    //ReplaceButton->Hint = "Replace DMC" + PictureColourPallette[SubstituteColour->ItemIndex].DMCColourNumber + " with DMC" + DMCColourList[ReplacementColour2->ItemIndex].DMCColourNumber;
    //UseDMCButton->Hint = "Replace DMC" + PictureColourPallette[SubstituteColour->ItemIndex].DMCColourNumber + " with DMC" + DMCColourList[replacementcolour].DMCColourNumber;
    //BlendReplaceButton->Hint = "Replace DMC" + PictureColourPallette[SubstituteColour->ItemIndex].DMCColourNumber + " with Blend " + TweedList[NearestTweed[TweedPallette->ItemIndex].entrynumber].Data.DMCColourNumber;
    FindButton2->Hint = "Find " + ShortThreadName + PictureColourPallette[SubstituteColour->ItemIndex].DMCColourNumber;
    ReplaceButton->Hint = "Replace " + ShortThreadName + PictureColourPallette[SubstituteColour->ItemIndex].DMCColourNumber + " with " + ShortThreadName + DMCColourList[ReplacementColour2->ItemIndex].DMCColourNumber;
    UseDMCButton->Hint = "Replace " + ShortThreadName + PictureColourPallette[SubstituteColour->ItemIndex].DMCColourNumber + " with " + ShortThreadName + DMCColourList[replacementcolour].DMCColourNumber;
    BlendReplaceButton->Hint = "Replace " + ShortThreadName + PictureColourPallette[SubstituteColour->ItemIndex].DMCColourNumber + " with Blend " + TweedList[NearestTweed[TweedPallette->ItemIndex].entrynumber].Data.DMCColourNumber;
}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::SubstituteColourChange(TObject *Sender)
{
    if (FindButton2->Caption == "Stop" && Image3inuse) {
        InitialiseFindBitmaps();
        FillFindBitmaps(PictureColourPallette[SubstituteColour->ItemIndex].Colour);
        }
    UpdateButtonHints(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::ReplacementColourChange(TObject *Sender)
{
    if (FindButton1->Caption == "Stop" && Image3inuse) {
        InitialiseFindBitmaps();
        FillFindBitmaps(PictureColourPallette[MergeColour1->ItemIndex].Colour);
        FillFindBitmaps(PictureColourPallette[MergeColour2->ItemIndex].Colour);
        FillFindBitmaps(PictureColourPallette[ReplacementColour->ItemIndex].Colour);
        }

}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::UseDMCButtonClick(TObject *Sender)
{
    //first thing, see if the replacement colour is in the existing pallette range
    bool found = false;
    int pointer = 0;
    TColor merge1colour = PictureColourPallette[SubstituteColour->ItemIndex].Colour;
    TColor colour = DMCColourList[replacementcolour].Colour;

    while (!found && pointer < PictureColourPallette.Length) {
        if (colour == PictureColourPallette[pointer].Colour) {
            found = true;
            pointer--;
            }
        pointer++;
        }

    if (found) {
        //colour found so this is a merge rather than a substitute
        MergeColour1->ItemIndex = pointer;
        MergeColour2->ItemIndex = SubstituteColour->ItemIndex;
        ReplacementColour->ItemIndex = pointer;
        MergeButtonClick(Sender);
        } else {
        //This is a substitute
        int merge1 = SubstituteColour->ItemIndex;
        int replacement = replacementcolour;
        AnsiString temp;
        undolevel++;
        if (undolevel > 8) undolevel = 8;
        //first, before doing anything, run through the undos
        if (!UndoBitmap7->Empty) UndoBitmap8->Assign(UndoBitmap7);
        if (!UndoBitmap6->Empty) UndoBitmap7->Assign(UndoBitmap6);
        if (!UndoBitmap5->Empty) UndoBitmap6->Assign(UndoBitmap5);
        if (!UndoBitmap4->Empty) UndoBitmap5->Assign(UndoBitmap4);
        if (!UndoBitmap3->Empty) UndoBitmap4->Assign(UndoBitmap3);
        if (!UndoBitmap2->Empty) UndoBitmap3->Assign(UndoBitmap2);
        if (!UndoBitmap1->Empty) UndoBitmap2->Assign(UndoBitmap1);
        UndoBitmap1->Assign(Image2->Picture->Bitmap);
        //write data to undolist merge colour 1 first
        temp = AnsiString(merge1) + "," + PictureColourPallette[merge1].DMCColourNumber;
        temp = temp + "," + PictureColourPallette[merge1].DMCColourName;
        temp = temp + "," + PictureColourPallette[merge1].AnchorColourNumber;
        temp = temp + "," + AnsiString((int)PictureColourPallette[merge1].Colour);
        temp = temp + "," + AnsiString((int)PictureColourPallette[merge1].DrawWhite);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].StitchCount);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].AnchorColourToUse);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].AnchorStitchCount);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].AnchorGlyphToUse);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].R);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].G);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].B);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].Hue);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].Saturation);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].Brightness) + ",";
        UndoList->Add(temp);
        //finally say which type of operation this is.
        //UndoList->Add("Replace DMC" + PictureColourPallette[merge1].DMCColourNumber + " with DMC" + DMCColourList[replacement].DMCColourNumber);
        UndoList->Add("Replace " + ShortThreadName + PictureColourPallette[merge1].DMCColourNumber + " with " + ShortThreadName + DMCColourList[replacement].DMCColourNumber);

        //now do the operation
        //for (int j = 0; j < Image2->Picture->Bitmap->Height; j++) {
        //    for (int i = 0; i < Image2->Picture->Bitmap->Width; i++) {
        //        if (Image2->Picture->Bitmap->Canvas->Pixels[i][j] == merge1colour) {
        //            Image2->Picture->Bitmap->Canvas->Pixels[i][j] = colour;
        //            }
        //        }
        //    }
        for (int j = 0; j < ModifiedBitmap->Height; j++) {
            for (int i = 0; i < ModifiedBitmap->Width; i++) {
                if (ModifiedBitmap->Canvas->Pixels[i][j] == merge1colour) {
                    ModifiedBitmap->Canvas->Pixels[i][j] = colour;
                    }
                }
            }
        EraseFind();
        DrawModifiedBitmap();
        DMCColourData data = PictureColourPallette[merge1];
        PictureColourPallette[merge1] = DMCColourList[replacement];

        //now update ancilliary info
        PictureColourPallette[merge1].StitchCount = data.StitchCount;
        PictureColourPallette[merge1].AnchorStitchCount = data.AnchorStitchCount;
        PictureColourPallette[merge1].AnchorGlyphToUse = data.AnchorGlyphToUse;

        //update screen info
        changed = true;

        UndoButton->Hint = UndoList->Strings[UndoList->Count - 1];
        UndoButton->Enabled = true;

        //update the listboxes & contents
        UpdateListBoxes();
        }

}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::BlendReplaceButtonClick(TObject *Sender)
{
    //first thing, see if the replacement colour is in the existing pallette range
    bool found = false;
    int pointer = 0;
    TColor merge1colour = PictureColourPallette[SubstituteColour->ItemIndex].Colour;
    TColor colour = TweedList[NearestTweed[TweedPallette->ItemIndex].entrynumber].Data.Colour;

    while (!found && pointer < PictureColourPallette.Length) {
        if (colour == PictureColourPallette[pointer].Colour) {
            found = true;
            pointer--;
            }
        pointer++;
        }

    if (found) {
        //colour found so this is a merge rather than a substitute
        MergeColour1->ItemIndex = pointer;
        MergeColour2->ItemIndex = SubstituteColour->ItemIndex;
        ReplacementColour->ItemIndex = pointer;
        MergeButtonClick(Sender);
        } else {
        //This is a substitute
        int merge1 = SubstituteColour->ItemIndex;
        int replacement = NearestTweed[TweedPallette->ItemIndex].entrynumber;
        blendthreads = true;
        AnsiString temp;
        undolevel++;
        if (undolevel > 8) undolevel = 8;
        //first, before doing anything, run through the undos
        if (!UndoBitmap7->Empty) UndoBitmap8->Assign(UndoBitmap7);
        if (!UndoBitmap6->Empty) UndoBitmap7->Assign(UndoBitmap6);
        if (!UndoBitmap5->Empty) UndoBitmap6->Assign(UndoBitmap5);
        if (!UndoBitmap4->Empty) UndoBitmap5->Assign(UndoBitmap4);
        if (!UndoBitmap3->Empty) UndoBitmap4->Assign(UndoBitmap3);
        if (!UndoBitmap2->Empty) UndoBitmap3->Assign(UndoBitmap2);
        if (!UndoBitmap1->Empty) UndoBitmap2->Assign(UndoBitmap1);
        UndoBitmap1->Assign(Image2->Picture->Bitmap);
        //write data to undolist merge colour 1 first
        temp = AnsiString(merge1) + "," + PictureColourPallette[merge1].DMCColourNumber;
        temp = temp + "," + PictureColourPallette[merge1].DMCColourName;
        temp = temp + "," + PictureColourPallette[merge1].AnchorColourNumber;
        temp = temp + "," + AnsiString((int)PictureColourPallette[merge1].Colour);
        temp = temp + "," + AnsiString((int)PictureColourPallette[merge1].DrawWhite);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].StitchCount);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].AnchorColourToUse);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].AnchorStitchCount);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].AnchorGlyphToUse);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].R);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].G);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].B);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].Hue);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].Saturation);
        temp = temp + "," + AnsiString(PictureColourPallette[merge1].Brightness) + ",";
        UndoList->Add(temp);
        //finally say which type of operation this is.
        //UndoList->Add("Replace DMC" + PictureColourPallette[merge1].DMCColourNumber + " with Blend " + TweedList[replacement].Data.DMCColourNumber);
        UndoList->Add("Replace " + ShortThreadName  + PictureColourPallette[merge1].DMCColourNumber + " with Blend " + TweedList[replacement].Data.DMCColourNumber);

        //now do the operation
        //for (int j = 0; j < Image2->Picture->Bitmap->Height; j++) {
        //    for (int i = 0; i < Image2->Picture->Bitmap->Width; i++) {
        //        if (Image2->Picture->Bitmap->Canvas->Pixels[i][j] == merge1colour) {
        //            Image2->Picture->Bitmap->Canvas->Pixels[i][j] = colour;
        //            }
        //        }
        //    }
        for (int j = 0; j < ModifiedBitmap->Height; j++) {
            for (int i = 0; i < ModifiedBitmap->Width; i++) {
                if (ModifiedBitmap->Canvas->Pixels[i][j] == merge1colour) {
                    ModifiedBitmap->Canvas->Pixels[i][j] = colour;
                    }
                }
            }
        EraseFind();
        DrawModifiedBitmap();
        DMCColourData data = PictureColourPallette[merge1];
        PictureColourPallette[merge1] = TweedList[replacement].Data;

        //now update ancilliary info
        PictureColourPallette[merge1].StitchCount = data.StitchCount;
        PictureColourPallette[merge1].AnchorStitchCount = data.AnchorStitchCount;
        PictureColourPallette[merge1].AnchorGlyphToUse = data.AnchorGlyphToUse;

        //update screen info
        changed = true;

        UndoButton->Hint = UndoList->Strings[UndoList->Count - 1];
        UndoButton->Enabled = true;

        //update the listboxes & contents
        UpdateListBoxes();
        }

}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::Help2Click(TObject *Sender)
{
    AnsiString Address = ExtractFileDir(Application->ExeName) + "\\BackStitch.chm";
    AnsiString Location = "mk:@MSITStore:" + Address + "::/mergecolours.html";
    ShellExecute(Application->Handle,"open",Location.c_str(),Location.c_str(),NULL,SW_SHOW);

}
//---------------------------------------------------------------------------

void __fastcall TThreadMergeForm::HelpButtonClick(TObject *Sender)
{
    AnsiString Address = ExtractFileDir(Application->ExeName) + "\\BackStitch.chm";
    AnsiString Location = "mk:@MSITStore:" + Address + "::/mergecolours.html#start";
    ShellExecute(Application->Handle,"open",Location.c_str(),Location.c_str(),NULL,SW_SHOW);

}
//---------------------------------------------------------------------------

