//---------------------------------------------------------------------------
#ifndef ThreadMergeH
#define ThreadMergeH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include "StitchStructures.h"
#include <ComCtrls.hpp>
#include <ImgList.hpp>
//---------------------------------------------------------------------------
class TThreadMergeForm : public TForm
{
__published:	// IDE-managed Components
    TImage *Image1;
    TImage *Image2;
    TLabel *Label1;
    TLabel *Label2;
    TPanel *Panel1;
    TLabel *Label3;
    TComboBox *MergeColour1;
    TComboBox *MergeColour2;
    TLabel *Label4;
    TComboBox *ReplacementColour;
    TButton *MergeButton;
    TButton *OKButton;
    TButton *CancelButton;
    TBevel *Bevel1;
    TMainMenu *MainMenu1;
    TMenuItem *File1;
    TMenuItem *Cancel1;
    TMenuItem *N1;
    TMenuItem *Accept1;
    TMenuItem *Edit1;
    TMenuItem *Undo1;
    TButton *UndoButton;
    TStatusBar *StatusBar1;
    TBevel *Bevel2;
    TComboBox *SubstituteColour;
    TLabel *Label5;
    TComboBox *ReplacementColour2;
    TLabel *Label6;
    TButton *ReplaceButton;
    TButton *ResetImage;
    TImageList *ImageList1;
    TLabel *Label7;
    TImage *Image3;
    TButton *FindButton1;
    TTimer *Timer1;
    TButton *FindButton2;
    TBevel *Bevel3;
    TEdit *RedEdit;
    TLabel *Label8;
    TLabel *Label9;
    TEdit *GreenEdit;
    TLabel *Label10;
    TEdit *BlueEdit;
    TLabel *Label12;
    TBevel *Bevel4;
    TShape *Shape2;
    TButton *UseDMCButton;
    TComboBox *TweedPallette;
    TButton *BlendReplaceButton;
    TLabel *Label13;
    TShape *Shape1;
    TShape *Shape3;
    TShape *Shape4;
    TLabel *Label14;
    TLabel *Label11;
    TLabel *Label15;
    TMenuItem *Help1;
    TMenuItem *Help2;
    TButton *HelpButton;
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall FormDestroy(TObject *Sender);
    void __fastcall MergeColourCombosDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
    void __fastcall MergeButtonClick(TObject *Sender);
    void __fastcall UndoButtonClick(TObject *Sender);
    void __fastcall MergeColour2Change(TObject *Sender);
    void __fastcall MergeColour1Change(TObject *Sender);
    void __fastcall ReplacementColour2DrawItem(TWinControl *Control,
          int Index, TRect &Rect, TOwnerDrawState State);
    void __fastcall ReplaceButtonClick(TObject *Sender);
    void __fastcall OKButtonClick(TObject *Sender);
    void __fastcall Image1MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
    void __fastcall FormMouseWheelUp(TObject *Sender, TShiftState Shift,
          TPoint &MousePos, bool &Handled);
    void __fastcall FormMouseWheelDown(TObject *Sender, TShiftState Shift,
          TPoint &MousePos, bool &Handled);
    void __fastcall Image1MouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall Image1MouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall ResetImageClick(TObject *Sender);
    void __fastcall Image1DblClick(TObject *Sender);
    void __fastcall FindButton1Click(TObject *Sender);
    void __fastcall Timer1Timer(TObject *Sender);
    void __fastcall FindButton2Click(TObject *Sender);
    void __fastcall RedEditChange(TObject *Sender);
    void __fastcall TweedPalletteDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
    void __fastcall TweedPalletteChange(TObject *Sender);
    void __fastcall UpdateButtonHints(TObject *Sender);
    void __fastcall SubstituteColourChange(TObject *Sender);
    void __fastcall ReplacementColourChange(TObject *Sender);
    void __fastcall UseDMCButtonClick(TObject *Sender);
    void __fastcall BlendReplaceButtonClick(TObject *Sender);
    void __fastcall Help2Click(TObject *Sender);
    void __fastcall HelpButtonClick(TObject *Sender);
private:	// User declarations
    TStringList *UndoList;
    Graphics::TBitmap *UndoBitmap1;
    Graphics::TBitmap *UndoBitmap2;
    Graphics::TBitmap *UndoBitmap3;
    Graphics::TBitmap *UndoBitmap4;
    Graphics::TBitmap *UndoBitmap5;
    Graphics::TBitmap *UndoBitmap6;
    Graphics::TBitmap *UndoBitmap7;
    Graphics::TBitmap *UndoBitmap8;
    int undolevel;
    int imagescale;
    DMCColourData __fastcall ReadColourInfo(AnsiString text);
    void __fastcall DisplayHint(TObject *Sender);
    DynamicArray <nearestcolour> NearestColour;
    void __fastcall QuickSortThreadSquares(int low, int high);
    bool setmerge1;
    chartposition Location;
    void __fastcall UpdateListBoxes(void);
    void __fastcall ImageResize(void);
    void __fastcall DrawBitmaps(void);
    void __fastcall DrawOriginalBitmap(void);
    void __fastcall DrawModifiedBitmap(void);
    chartposition TopLeftCorner;
    chartposition oldLocation;
    chartposition oldTopLeftCorner;
    bool dragging;
    TCursor crGrabCursor;
	TCursor crTargetCursor;
    bool Image3inuse;
    Graphics::TBitmap *BrightBitmap;
    Graphics::TBitmap *DarkBitmap;
    bool showingbrightbitmap;
    void __fastcall DrawFindBitmap(void);
    void __fastcall InitialiseFindBitmaps(void);
    void __fastcall FillFindBitmaps(TColor Colour);
    void __fastcall EraseFind(void);
    DynamicArray <nearestcolour> NearestTweed;
    void __fastcall QuickSortBlendThreadSquares(int low, int high);
    void __fastcall ShowTweed(void);
    int replacementcolour;
public:		// User declarations
    DynamicArray <DMCColourData> DMCColourList;
    DynamicArray <DMCColourData> PictureColourPallette;
    DynamicArray <TweedColourData> TweedList;
    AnsiString ShortThreadName;
    bool changed;
    bool blendthreads;
    Graphics::TBitmap *OriginalBitmap;
    Graphics::TBitmap *ModifiedBitmap;

    //void __fastcall ImageResize(void);
    void __fastcall Initialise(void);

    __fastcall TThreadMergeForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TThreadMergeForm *ThreadMergeForm;
//---------------------------------------------------------------------------
#endif
