//---------------------------------------------------------------------------
#ifndef TransparencyH
#define TransparencyH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <Graphics.hpp>
#include <Buttons.hpp>
#include "StitchStructures.h"
#include <ImgList.hpp>

//---------------------------------------------------------------------------
class TTransparencyForm : public TForm
{
__published:	// IDE-managed Components
    TPanel *Panel1;
    TPanel *Panel2;
    TPanel *Panel3;
    TButton *OKButton;
    TButton *CancelButton;
    TMainMenu *MainMenu1;
    TMenuItem *File1;
    TMenuItem *Cancel1;
    TMenuItem *N1;
    TMenuItem *Exit1;
    TTrackBar *TrackBar1;
    TLabel *Label1;
    TLabel *Label2;
    TLabel *Label3;
    TImage *Image1;
    TStatusBar *StatusBar1;
    TScrollBar *ScrollBar1;
    TScrollBar *ScrollBar2;
    TUpDown *UpDown1;
    TLabel *Label4;
    TLabel *Label5;
    TUpDown *UpDown2;
    TLabel *Label6;
    TEdit *Edit1;
    TUpDown *UpDown3;
    TBevel *Bevel1;
    TEdit *Edit2;
    TUpDown *UpDown4;
    TSpeedButton *SpeedButton1;
    TSpeedButton *SpeedButton2;
    TLabel *Label7;
    TSpeedButton *SpeedButton3;
    TSpeedButton *SpeedButton4;
    TPanel *Panel4;
    TListBox *CurrentPallette;
    TPanel *Panel5;
    TListBox *FullPallette;
    TPopupMenu *PopupMenu1;
    TMenuItem *CopyDisplayedImage1;
    TMenuItem *CopyFullImage1;
    TMenuItem *CopyChartImage1;
    TMenuItem *CopyHighResImage1;
    TBevel *Bevel2;
    TMenuItem *Edit3;
    TMenuItem *AddStitches1;
    TMenuItem *DeleteStitches1;
    TMenuItem *N2;
    TMenuItem *UndoLastAddStitchOperation1;
    TButton *AddStitchesButton;
    TButton *DeleteStitchesButton;
    TMenuItem *N3;
    TMenuItem *DeleteAllStitches1;
    TMenuItem *SelectDeletedStitchestoRedo1;
    TMenuItem *N4;
    TMenuItem *PickColour1;
    TBitBtn *BitBtn1;
    TBevel *Bevel3;
    TBevel *Bevel4;
    TImageList *ImageList1;
    TMenuItem *N5;
    TMenuItem *PixelEditor1;
    TBitBtn *BitBtn2;
    TMenuItem *UndolastPixelEdits1;
    TMenuItem *N6;
    TMenuItem *Copy1;
    TMenuItem *CopyDisplayImage1;
    TMenuItem *CopyFullDisplayImage1;
    TMenuItem *CopyChartImage2;
    TMenuItem *CopyHighResImage2;
    TButton *ChangeColour;
    TMenuItem *ChangeStitchColour1;
    TButton *FixButton;
    TMenuItem *Help1;
    TMenuItem *Help2;
    TPopupMenu *PopupMenu2;
    TMenuItem *HelpItem;
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall FormDestroy(TObject *Sender);
    void __fastcall UpDown3Click(TObject *Sender, TUDBtnType Button);
    void __fastcall Edit1Change(TObject *Sender);
    void __fastcall UpDown1Click(TObject *Sender, TUDBtnType Button);
    void __fastcall TrackBar1Change(TObject *Sender);
    void __fastcall UpDown4Click(TObject *Sender, TUDBtnType Button);
    void __fastcall SpeedButton1Click(TObject *Sender);
    void __fastcall SpeedButton2Click(TObject *Sender);
    void __fastcall ScrollBar1Change(TObject *Sender);
    void __fastcall ScrollBar2Change(TObject *Sender);
    void __fastcall SpeedButton3Click(TObject *Sender);
    void __fastcall SpeedButton4Click(TObject *Sender);
    void __fastcall Exit1Click(TObject *Sender);
    void __fastcall Cancel1Click(TObject *Sender);
    void __fastcall FormResize(TObject *Sender);
    void __fastcall CurrentPalletteDrawItem(TWinControl *Control,
          int Index, TRect &Rect, TOwnerDrawState State);
    void __fastcall FullPalletteDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
    void __fastcall Image1MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
    void __fastcall FormDeactivate(TObject *Sender);
    void __fastcall FormActivate(TObject *Sender);
    void __fastcall CopyDisplayedImage1Click(TObject *Sender);
    void __fastcall CopyFullImage1Click(TObject *Sender);
    void __fastcall CopyChartImage1Click(TObject *Sender);
    void __fastcall CopyHighResImage1Click(TObject *Sender);
    void __fastcall CurrentPalletteDblClick(TObject *Sender);
    void __fastcall FullPalletteDblClick(TObject *Sender);
    void __fastcall Image1Click(TObject *Sender);
    void __fastcall FormKeyPress(TObject *Sender, char &Key);
    void __fastcall Edit3Click(TObject *Sender);
    void __fastcall UndoLastAddStitchOperation1Click(TObject *Sender);
    void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall AddStitchesButtonClick(TObject *Sender);
    void __fastcall DeleteStitches1Click(TObject *Sender);
    void __fastcall DeleteAllStitches1Click(TObject *Sender);
    void __fastcall SelectDeletedStitchestoRedo1Click(TObject *Sender);
    void __fastcall PickColour1Click(TObject *Sender);
    void __fastcall PixelEditor1Click(TObject *Sender);
    void __fastcall UndolastPixelEdits1Click(TObject *Sender);
    void __fastcall ChangeColourClick(TObject *Sender);
    void __fastcall Edit2Change(TObject *Sender);
    void __fastcall FixButtonClick(TObject *Sender);
    void __fastcall Help2Click(TObject *Sender);
    void __fastcall PopupMenu2Popup(TObject *Sender);
    void __fastcall HelpItemClick(TObject *Sender);
private:	// User declarations
    Graphics::TBitmap *DisplayImage;
    int SquareSize;
    int TopLeftX;
    int TopLeftY;
    void __fastcall ShowDisplayImage(void);
    DynamicArray <BackStitchData> BackStitchRedo;
    int crTargetCursor;
    int crDropperCursor;
    int crDrawCursor;
    mouseposition __fastcall FindMousePosition(int X, int Y);
    chartposition __fastcall FindChartPosition(mouseposition Location);
    void __fastcall DisplayMousePosition(mouseposition Location);
    bool active;
    double __fastcall RoundToNearestQuarter(double value);
    void __fastcall DisplayHint(TObject *Sender);
    int SelectedColour;
    void __fastcall PrintSelectedColour(void);
    void __fastcall DrawStitches(void);

    //Rubber banding
    bool rubberbanding;
    bool wipedout;
    rubberband RubberBand;
    bool preparingtoaddstitches;
    chartposition LastMouseMove;
    bool addstitches;
    bool changingcolour;

    //deleting stitches
    bool deletingstitches;

    //undo
    int undostitchlength;

    //colour pick
    bool colourpicking;

    //pixel editing
    bool pixelediting;
    DynamicArray <pixeleditundo> PixelEditUndo;

public:		// User declarations
    //working with the images
    Graphics::TBitmap *ChartImage;
    Graphics::TBitmap *OriginalImage;
    void __fastcall CreateDisplayImage(void);
    void __fastcall SetSpinButtons(void);
    int offsetx;
    int offsety;
    double scale;

    //working with the colours
    DynamicArray <ColourData> ColourList;
    DynamicArray <ColourData> UsedColourList;
    DynamicArray <BackStitchData> BackStitchList;
    void __fastcall FillColourList(void);
    void __fastcall FillUsedColourList(void);
    bool stitcheschanged;

    //PixelEditing
    bool imagechanged;


    __fastcall TTransparencyForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TTransparencyForm *TransparencyForm;
//---------------------------------------------------------------------------
#endif
