//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "GlyphShow.h"
#include <clipbrd.hpp>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button1Click(TObject *Sender)
{
    //create glyph ref
    Image1->Canvas->Font->Size = 14;
    Image1->Canvas->Font->Name = "Arial";
    int rowheight = Image1->Canvas->TextHeight("Mg")*5/4;
    int columnwidth = Image1->Canvas->TextWidth(" 8888    8");

    Image1->Canvas->Font->Size = 12;
    int GlyphSize = Image1->Canvas->TextHeight("Mg") * 1.5;
    columnwidth += GlyphSize;
    Image1->Canvas->Font->Size = 10;
    int textxoffset = GlyphSize + Image1->Canvas->TextWidth("  ");
    int textyoffset = (GlyphSize - Image1->Canvas->TextHeight("0123456789"))/2;
    Image1->Picture->Bitmap->Monochrome = true;
    Image1->Picture->Bitmap->Width = 10 * columnwidth;
    Image1->Picture->Bitmap->Height = 60 * rowheight;
    Image1->Picture->Bitmap->Canvas->Font->Size = 10;
    Image1->Picture->Bitmap->Canvas->Font->Name = "Arial";
    Image1->Picture->Bitmap->Canvas->Brush->Color = clWhite;
    Image1->Picture->Bitmap->Canvas->Pen->Color = clWhite;
    Image1->Picture->Bitmap->Canvas->Rectangle(0,0,Image1->Picture->Bitmap->Width,Image1->Picture->Bitmap->Height);
    Image1->Picture->Bitmap->Canvas->Pen->Color = clBlack;


    int NumberofGlyphs = 600;
    int x,y,glyph;

    for (int i = 0; i < 60; i++) {
        for (int j = 0; j < 10; j++) {
            glyph = i * 10 + j;
            if (glyph < NumberofGlyphs) {
                //plot glyph
                x = j * columnwidth;
                y = rowheight * i;
                DrawGlyph2(Image1->Picture->Bitmap->Canvas,x, y, GlyphSize, glyph, glyph, false);
                //write text
                Image1->Picture->Bitmap->Canvas->TextOut(x + textxoffset,y + textyoffset,AnsiString(glyph));
                }
            }
        }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::DrawGlyph2(TCanvas *Canvas,int X, int Y, int PictureSize, int glyphno, int i, bool PlotEdge)
{
    //this routine does all the hard work of producing the glyph.
    //The size & location is variable, so that it can be positioned anywhere on a Canvas
    //Also, with this method, it's possible to change the canvas it's drawn on, and
    //so is not limited to the printer.
    TBrush *Brush = new TBrush;
    TPen *Pen = new TPen;
    Brush->Color = Canvas->Brush->Color;
    Brush->Style = Canvas->Brush->Style;
    Pen->Color = Canvas->Pen->Color;
    Pen->Style = Canvas->Pen->Style;
    Pen->Width = Canvas->Pen->Width;
            //Fill the background with the current colour or white if not printing in colour
                Canvas->Brush->Color = clWhite;
            Canvas->FillRect(Rect(X,Y,X + PictureSize,Y + PictureSize));
            //draw the intermediate lines on the top & left edges in light grey

            //Now to draw the symbol
            //first thing, choose the symbol colour which is dependant on background
            //brightness
                    Canvas->Pen->Color = clBlack;
                    Canvas->Brush->Color = clBlack;
            //now draw the symbol's shape on the symbol area
            switch (glyphno) {
                case 1: {
                        //simple circle
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 9: {
                        //Full CG symbol
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + PictureSize/2,Y + PictureSize,X + PictureSize,Y + PictureSize/2);
                        }
                case 8: {
                        //Part CG symbol
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + PictureSize/2,Y + 0,X + 0,Y + PictureSize/2);
                        }
                case 2: {
                        //simple hollow circle
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 5: {
                        //Fills in the top of the hourglass
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize/2,Y + PictureSize/2);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        }
                case 4: {
                        //Turns the cross into an hourglass
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        }
                case 3: {
                        //simple cross
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 7: {
                        //percent symbol
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        }
                case 6: {
                        //diagonal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 10:{
                        //Circle bottom filled
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + 0,Y + PictureSize/2,X + PictureSize,Y + PictureSize/2);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 15:{
                        //fill bottom right to result in a filled square CG symbol
                        Canvas->Rectangle(X + PictureSize /2,Y + PictureSize /2,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        }
                case 14:{
                        //fill top left
                        Canvas->Rectangle(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize /2,Y + PictureSize /2);
                        }
                case 13:{
                        //turn square into cross window frame
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize /2,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize /2,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                case 12:{
                        //turn square into horizontal window frame
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize /2);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize /2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                case 11:{
                        //square
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Rectangle(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 16:{
                        //Thick Diagonal
                        Canvas->Pen->Width = PictureSize*4/20;
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 0: {
                        //Plus Sign
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = 1;
                        }
                case 78:{
                        //Stick
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        }
                case 17:{
                        //Horizontal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize /2);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize /2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 30:{
                        //Christmas tree
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        }
                case 29:{
                        //up arrow
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        }
                case 18:{
                        //Vertical Line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize /2,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize /2,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 23:{
                        //Corner triangle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        }
                case 19:{
                        //L shape
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 21:{
                        //Fills in the diagonal arrow
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        }
                case 20:{
                        //Diagonal arrow
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 22:{
                        //Top corner flag
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 28:{
                        //Five circles
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        }
                case 27:{
                        //Four circles
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        }
                case 25:{
                        //two circles
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        }
                case 24:{
                        //one circle
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 26:{
                        //three circles
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 3/10,X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 31:{
                        //up & down arrow
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 34:{
                        //cross on Z
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        }
                case 33:{
                        //finish Z
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        }
                case 32:{
                        //part Z
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 37:{
                        //flag thingy filled in
                        TPoint points[6];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[3] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[4] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[5] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 5);
                        }
                case 36:{
                        //Flag thingy
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        }
                case 35:{
                        //M
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 38:{
                        //Backwards C
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 42:{
                        //zigzag with cross bar
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        }
                case 41:{
                        //Backwards full F
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        }
                case 40:{
                        //Backwards F
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        }
                case 39:{
                        //1
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 43:{
                        //Exclamation mark
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 6/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 45:{
                        //4 dots, 2 horizontal lines
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *3/10);
                        }
                case 44:{
                        //4 dots, 1 horizontal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *7/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 47:{
                        //4 dots, 2 diagonal lines
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *7/10);
                        }
                case 46:{
                        //4 dots, 1 diagonal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *3/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 49:{
                        //2 dots, 1 diagonal line
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        }
                case 48:{
                        //1 dot, 1 diagonal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *7/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 52:{
                        //filled in A
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 7/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 51:{
                        //A
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *5/10);
                        }
                case 50:{
                        //caret
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 54:{
                        //mountain with trees
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 3/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 3);
                        }
                case 53:{
                        //mountain
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 55:{
                        //squared U
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 56:{
                        //2 circles
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 2/10,X + PictureSize * 7/10,Y + PictureSize * 5/10);
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 5/10,X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        }
                        break;
                case 57:{
                        //2 circles, lower one filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 2/10,X + PictureSize * 7/10,Y + PictureSize * 5/10);
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 5/10,X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 58:{
                        //2 circles, concentric
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        }
                        break;
                case 59:{
                        //2 circles, concentric, one filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 61:{
                        //filled flag
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 60:{
                        //single flag
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 63:{
                        //double filled flag
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        }
                case 62:{
                        //double flag
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 67:{
                        //slashed Dollar
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                case 68:{
                        //double filled dollar
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 66:{
                        //single top filled dollar
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 65:{
                        //Dollar
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                case 64:{
                        //S
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 72:{
                        //double filled dumbel S
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 4/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 71:{
                        //single bottom filled dumbel S
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 70:{
                        //Diamond Dumbel S
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                case 69:{
                        //Diamond Dumbel S
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 75:{
                        //Double triangle, both filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 74:{
                        //Double triangle, lower filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                 case 73:{
                        //Double triangle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 77:{
                        //Double triangle, lower filled
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 3);
                        }
                case 76:{
                        //Treble triangle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 82:{
                        //Right point triangle, filled in
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 81:{
                        //Right point triangle, top filled in
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 80:{
                        //Right point triangle with horizontal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        }
                case 79:{
                        //Right point triangle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 85:{
                        //Left Pennant, filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 84:{
                        //Left Pennant, top filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 83:{
                        //Left Pennant
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 87:{
                        //I crossed
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        }
                case 86:{
                        //I
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 91:{
                        //Bottom point triangle, filled in
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 90:{
                        //Bottom point triangle, left filled in
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 89:{
                        //Bottom point triangle with vertical line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        }
                case 88:{
                        //Bottom point triangle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 94:{
                        //Top Pennant, filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 93:{
                        //Top Pennant, left filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 92:{
                        //Top Pennant
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 98:{
                        //Upsidedown T double tagged
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        }
                case 96:{
                        //Upsidedown T right tagged
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        }
                case 95:{
                        //Upsidedown T
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 99:{
                        //Upsidedown T, tags filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 97:{
                        //Upsidedown T, right tag filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 100: {
                        //face
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Ellipse(X + PictureSize * 25/100,Y + PictureSize * 25/100,X + PictureSize * 45/100,Y + PictureSize * 45/100);
                        Canvas->Ellipse(X + PictureSize * 55/100,Y + PictureSize * 25/100,X + PictureSize * 75/100,Y + PictureSize * 45/100);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *6/10);
                        }
                        break;
                case 102:{
                        //upsidedown Christmas tree
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        }
                case 101:{
                        //down arrow
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 104: {
                        //right tree
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        }
                case 103: {
                        //right arrow
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 106: {
                        //right tree
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        }
                case 105: {
                        //right arrow
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 107:{
                        //Top right corner flag
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 108:{
                        //top right Corner triangle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 109:{
                        //bottom right corner flag
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 110:{
                        //bottom right Corner triangle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 111:{
                        //bottom left corner flag
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 112:{
                        //bottom left Corner triangle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 113:{
                        //Fills in the top right diagonal arrow
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        }
                case 114:{
                        //top right Diagonal arrow
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 115:{
                        //Fills in the bottom left diagonal arrow
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        }
                case 116:{
                        //bottom left Diagonal arrow
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 117:{
                        //Fills in the bottom right diagonal arrow
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        }
                case 118:{
                        //bottom left Diagonal arrow
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 119:{
                        //cross on backwards Z
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        }
                case 120:{
                        //finish backwards Z
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        }
                case 121:{
                        //part backwards Z
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 122:{
                        //upsidedown M
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 123:{
                        //left M
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 124:{
                        //right M
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 125:{
                        //vertical version of 36
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 126:{
                        //vertical version of 37
                        TPoint points[6];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[4] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[5] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 5);
                        }
                case 127:{
                        // C
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 128:{
                        // 127 rot 90
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 129:{
                        // 128 + horizontal mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 130:{
                        //F
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        }
                case 131:{
                        //39 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 132:{
                        //131 + horiz mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 133:{
                        //132 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 134:{
                        //43 + horiz mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 135:{
                        //134 + 90 deg rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 136:{
                        //135 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 4/10,Y + PictureSize * 6/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 137:{
                        //4 dots, 1 horizontal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *3/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 138:{
                        //4 dots, 1 vertical line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *7/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 139:{
                        //4 dots, 1 vertical line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *7/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 140:{
                        //4 dots, 1 vertical line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *7/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 141:{
                        //4 dots, 1 diagonal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *7/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 142:{
                        //2 dots, 1 diagonal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *7/10);
                        //Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        //Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 143:{
                        //1 dot, 1 diagonal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *7/10);
                        //Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        //Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        //Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 144:{
                        //1 dot, 1 diagonal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *7/10);
                        //Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        //Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 145:{
                        //1 dot, 1 diagonal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *7/10);
                        //Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        //Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 146:{
                        //52 + horiz mirror
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 7/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 147:{
                        //51 + horiz mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *5/10);
                        }
                case 148:{
                        //50 + horiz mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 149:{
                        //146 + 90 deg rot
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 7/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 150:{
                        //147 + 90 deg rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *7/10);
                        }
                case 151:{
                        //148 + 90 deg rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 152:{
                        //149 + vert mirror
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 7/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 153:{
                        //150 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *7/10);
                        }
                case 154:{
                        //151 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 155:{
                        //54 + vert mirror
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 3/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 3);
                        }
                case 156:{
                        //53 + horiz mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 157:{
                        //155 + rot 90
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 7/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 3);
                        }
                case 158:{
                        //156 + rot 90
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 159:{
                        //157 + vert mirror
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 7/10);
                        points[3] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 3);
                        }
                case 160:{
                        //158 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 161: {
                        //55 + 90 rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 162: {
                        //161 + 90 rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 163: {
                        //162 + 90 rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 164:{
                        //2 circles, upper one filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 2/10,X + PictureSize * 7/10,Y + PictureSize * 5/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 5/10,X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 165:{
                        //2 circles, both filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 2/10,X + PictureSize * 7/10,Y + PictureSize * 5/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 5/10,X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 166:{
                        //2 circles next to each other, neither filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 3/10,X + PictureSize * 5/10,Y + PictureSize * 7/10);
                        Canvas->Ellipse(X + PictureSize * 5/10,Y + PictureSize * 3/10,X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 167:{
                        //2 circles next to each other, left filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 3/10,X + PictureSize * 5/10,Y + PictureSize * 7/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 5/10,Y + PictureSize * 3/10,X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 168:{
                        //2 circles next to each other, Right filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 3/10,X + PictureSize * 5/10,Y + PictureSize * 7/10);
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Ellipse(X + PictureSize * 5/10,Y + PictureSize * 3/10,X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 169:{
                        //2 circles next to each other, both filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 3/10,X + PictureSize * 5/10,Y + PictureSize * 7/10);
                        Canvas->Ellipse(X + PictureSize * 5/10,Y + PictureSize * 3/10,X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 170:{
                        //Greek Key
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 171:{
                        //170 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 172:{
                        //170 + horiz mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 173:{
                        //172 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 174:{
                        //170 + 90 deg rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                 case 175:{
                        //174 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 176:{
                        //174 + horiz mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 177:{
                        //176 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 178:{
                        //61 + horiz mirror
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 179:{
                        //60 + horiz mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 180:{
                        //61 + vert mirror
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 181:{
                        //60 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 182:{
                        //180 + horiz mirror
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 183:{
                        //181 + horiz mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 184:{
                        //horiz flag up right, filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 185:{
                        //horizontal flag up right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 186:{
                        //horiz flag down right, filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 187:{
                        //horizontal flag down right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 188:{
                        //horiz flag up left, filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 189:{
                        //horizontal flag up left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 190:{
                        //horiz flag down left, filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 191:{
                        //horizontal flag down left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 192:{
                        //partial cross upper left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 193:{
                        //partial cross lower right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 194:{
                        //partial cross upper right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 195:{
                        //partial cross lower left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 196:{
                        //partial plus upper
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 197:{
                        //partial plus left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 198:{
                        //partial plus left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 199:{
                        //left point triangle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        }
                case 200:{
                        //left point triangle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 201:{
                        //left point triangle, top half filled
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 202:{
                        //left point triangle, bottom half filled
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 203:{
                        //left point triangle, filled
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 204:{
                        //up point triangle with line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        }
                case 205:{
                        //up point triangle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 206:{
                        //up point triangle, left half filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 207:{
                        //up point triangle, right half filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 208:{
                        //up point triangle, filled
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Pen->Width = 1;
                        Canvas->Polygon(points, 2);
                        }
                        break;
                case 209:{
                        //right point triangle, bottom half filled
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 210:{
                        //down point triangle, right half filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 211:{
                        //left version of 84
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 212:{
                        //left version of 83
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 213:{
                        //211, bottom filled instead
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 214:{
                        //211, filled instead
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 215:{
                        //211 + 90 deg rot
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 216:{
                        //212 + 90 rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 217:{
                        //213 + 90 rot, bottom filled instead
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 218:{
                        //216, filled instead
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 219:{
                        //as 84, only bottom filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 220:{
                        //as 93, but right filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 224:{
                        //as 221 with both arrows filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 222:{
                        //as 221 with left arrow filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 221:{
                        //horizontal central pointing arrows
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 223:{
                        //as 221, right arrow filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 228:{
                        //224 + 90 deg rot
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 226:{
                        //222 + 90 deg rot
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 225:{
                        //221 + 90 deg rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 227:{
                        //223 + 90 deg rot
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 229:{
                        //horizontal right arrow left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 230:{
                        //horizontal right arrow mid
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 231:{
                        //horizontal right arrow right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 232:{
                        //horizontal right arrow left mid
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 233:{
                        //horizontal right arrow left right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 234:{
                        //horizontal right arrow mid right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 235:{
                        //horizontal right arrow left mid right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 236:{
                        //horizontal right arrow left filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 237:{
                        //horizontal right arrow mid filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 238:{
                        //horizontal right arrow right filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 239:{
                        //horizontal right arrow left mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 240:{
                        //horizontal right arrow left right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 241:{
                        //horizontal right arrow mid right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 242:{
                        //horizontal right arrow left mid right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 243:{
                        //horizontal right arrow left mid, left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 244:{
                        //horizontal right arrow left mid, right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 245:{
                        //horizontal right arrow left right, left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        //Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 246:{
                        //horizontal right arrow left right, right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 247:{
                        //horizontal right arrow mid right, mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 248:{
                        //horizontal right arrow mid right, right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 249:{
                        //horizontal right arrow left mid right, left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 250:{
                        //horizontal right arrow left mid right, mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 251:{
                        //horizontal right arrow left mid right, right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 252:{
                        //horizontal right arrow left mid right, left mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 253:{
                        //horizontal right arrow left mid right, left right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 254:{
                        //horizontal right arrow left mid right, mid right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 255:{
                        //left arrows, left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 256:{
                        //left arrows, mid
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 257:{
                        //left arrows, right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 258:{
                        //left arrows, left mid
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 259:{
                        //left arrows, left right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 260:{
                        //left arrows, mid right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 261:{
                        //left arrows, left mid right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 262:{
                        //left arrows, left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 263:{
                        //left arrows, mid  filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 264:{
                        //left arrows, right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 265:{
                        //left arrows, left mid, left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 266:{
                        //left arrows, left mid, mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 267:{
                        //left arrows, left mid, both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 268:{
                        //left arrows, left right, left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 269:{
                        //left arrows, left right, right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 270:{
                        //left arrows, left right, both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 271:{
                        //left arrows, mid right, mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 272:{
                        //left arrows, mid right, right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 273:{
                        //left arrows, mid right, both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 274:{
                        //left arrows, left mid right, left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 275:{
                        //left arrows, left mid right, mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 276:{
                        //left arrows, left mid right, right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 277:{
                        //left arrows, left mid right, left mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 278:{
                        //left arrows, left mid right, left right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 279:{
                        //left arrows, left mid right, mid right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 280:{
                        //left arrows, left mid right, all filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 281:{
                        //up arrows, top ,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 282:{
                        //up arrows, mid ,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 283:{
                        //up arrows, bot ,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 284:{
                        //up arrows, top mid,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 285:{
                        //up arrows, top bot,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 286:{
                        //up arrows, mid bot,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 287:{
                        //up arrows, top mid bot,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 288:{
                        //up arrows, top , top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 289:{
                        //up arrows, mid , mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 290:{
                        //up arrows, bot , bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 291:{
                        //up arrows, top mid , top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 292:{
                        //up arrows, top mid , mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                         Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 293:{
                        //up arrows, top mid , both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 294:{
                        //up arrows, top bot , top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 295:{
                        //up arrows, top bot , bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 296:{
                        //up arrows, top bot , both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 297:{
                        //up arrows, mid bot , mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 298:{
                        //up arrows, mid bot , bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 299:{
                        //up arrows, mid bot , both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 300:{
                        //up arrows, top mid bot , top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 301:{
                        //up arrows, top mid bot , mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 302:{
                        //up arrows, top mid bot , bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 303:{
                        //up arrows, top mid bot , top mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 304:{
                        //up arrows, top mid bot , top bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 305:{
                        //up arrows, top mid bot , mid bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 306:{
                        //up arrows, top mid bot , all filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 307:{
                        //down arrows, top ,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 308:{
                        //down arrows, mid ,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 309:{
                        //down arrows, bot ,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 310:{
                        //down arrows, top mid ,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 311:{
                        //down arrows, top bot,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 312:{
                        //down arrows, mid bot,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 313:{
                        //down arrows, top mid bot,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 314:{
                        //down arrows, top , top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 315:{
                        //down arrows, mid , mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 316:{
                        //down arrows, bot , bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 317:{
                        //down arrows, top mid , top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 318:{
                        //down arrows, top mid , mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 319:{
                        //down arrows, top mid , top mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 320:{
                        //down arrows, top bot , top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 321:{
                        //down arrows, top bot , bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 322:{
                        //down arrows, top bot , top bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 323:{
                        //down arrows, mid bot , mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 324:{
                        //down arrows, mid bot , bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 325:{
                        //down arrows, mid bot , mid bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 326:{
                        //down arrows, top mid bot , top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 327:{
                        //down arrows, top mid bot , mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 328:{
                        //down arrows, top mid bot , bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 329:{
                        //down arrows, top mid bot , top mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 330:{
                        //down arrows, top mid bot , top bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 331:{
                        //down arrows, top mid bot , mid bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 332:{
                        //down arrows, top mid bot , top mid bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 336:{
                        //both bumps filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        }
                case 334:{
                        //right bump  filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        }
                case 333:{
                        //road bump
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 335:{
                        //left road bump filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 340:{
                        //both bumps filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        }
                case 338:{
                        //right bump  filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        }
                case 337:{
                        //road bump
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 339:{
                        //left road bump filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 342:{
                        //twin squares with line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        }
                case 341:{
                        //twin squares
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 343:{
                        //twin squares, left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 20/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 3);
                        //points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        //points[2] = Point(X + PictureSize * 80/100,Y + PictureSize * 5/10);
                        //points[3] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        //Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 344:{
                        //twin squares, right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        //points[0] = Point(X + PictureSize * 20/100,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        //points[2] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        //points[3] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        //Canvas->Polygon(points, 3);
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 80/100,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 345:{
                        //twin squares, right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 20/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 3);
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 80/100,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 3);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 346:{
                        //twin squares, vert lines down both
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 347:{
                        //twin squares, vert lines down both, left left triange filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 20/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 348:{
                        //twin squares, vert lines down both, left right triange filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 349:{
                        //twin squares, vert lines down both, right left triange filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 350:{
                        //twin squares, vert lines down both, right right triange filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 80/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 351:{
                        //twin squares, vert lines down both, left left and right right triange filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 20/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 80/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 352:{
                        //twin squares, vert lines down both, left right and right left triange filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 353:{
                        //twin squares, vert lines down both, left right and right right triange filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 80/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 354:{
                        //twin squares, vert lines down both, left left and right left triange filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 20/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 355:{
                        //twin squares, vert lines down both, left left triange not filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 80/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 356:{
                        //twin squares, vert lines down both, left right triange not filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 20/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 80/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 357:{
                        //twin squares, vert lines down both, right left triange not filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 20/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 80/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 358:{
                        //twin squares, vert lines down both, right left triange not filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 20/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 359:{
                        //diamond with cross
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 360:{
                        //diamond with cross, top left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 361:{
                        //diamond with cross, top right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 362:{
                        //diamond with cross, bot left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 363:{
                        //diamond with cross, bot right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 364:{
                        //diamond with cross, top left, top right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 365:{
                        //diamond with cross, top right bot left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 366:{
                        //diamond with cross, top right bot right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 367:{
                        //diamond with cross, top left bot left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 368:{
                        //diamond with cross, top left bot right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 369:{
                        //diamond with cross, bot left bot right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 370:{
                        //diamond with cross, top left bot left bot right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 371:{
                        //diamond with cross, top right bot left bot right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 372:{
                        //diamond with cross, top right top left bot right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 373:{
                        //diamond with cross, top right top left top right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 374:{
                        //filled diamond
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 3);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 375:{
                        //window frame filled top right
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 376:{
                        //window frame filled bot right
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 377:{
                        //window frame filled bot left
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 378:{
                        //rectangle filled top half
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 379:{
                        //rectangle filled right half
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 380:{
                        //rectangle filled bot half
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 381:{
                        //rectangle filled left half
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 382:{
                        //window frame filled top half
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 383:{
                        //window frame filled right half
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 384:{
                        //window frame filled bot half
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 385:{
                        //window frame filled left half
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 386:{
                        //reversed 15
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 3);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 387:{
                        //window frame top right not filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[6];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[4] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[5] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 5);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 388:{
                        //window frame bot right not filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[6];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[4] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[5] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 5);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 389:{
                        //window frame bot left not filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[6];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[4] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[5] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 5);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 390:{
                        //window frame top left not filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[6];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[4] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[5] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 5);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 391:{
                        //filled square
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 3);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 392:{
                        //diagonal circles
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 393:{
                        //diagonal circles top filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 394:{
                        //diagonal circles bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 395:{
                        //diagonal circles both filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 396:{
                        //diagonal circles cross bot left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 397:{
                        //diagonal circles top filled  cross bot left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 398:{
                        //diagonal circles bot filled cross bot left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 399:{
                        //diagonal circles both filled cross bot left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 400:{
                        //diagonal circles cross top right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 401:{
                        //diagonal circles top filled  cross top right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 402:{
                        //diagonal circles bot filled cross top right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 403:{
                        //diagonal circles both filled cross top right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 404:{
                        //diagonal right circles
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 405:{
                        //diagonal right circles top filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 406:{
                        //diagonal right circles bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 407:{
                        //diagonal right circles both filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 408:{
                        //diagonal right circles cross top left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 409:{
                        //diagonal right circles top filled cross top left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 410:{
                        //diagonal right circles bot filled cross top left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 411:{
                        //diagonal right circles both filled cross top left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 412:{
                        //diagonal right circles cross bot right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 413:{
                        //diagonal right circles top filled cross bot right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 414:{
                        //diagonal right circles bot filled cross bot right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 415:{
                        //diagonal right circles both filled cross bot right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 416:{
                        //stalagtites
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 417:{
                        //stalagtites right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 418:{
                        //stalagtites left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 419:{
                        //stalagtites both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 420:{
                        //stalagmites
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 2/10);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 2/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 421:{
                        //stalagmites right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 2/10);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 422:{
                        //stalagmites left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 2/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 423:{
                        //stalagmites both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 424:{
                        //left horiz stalagmites
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 35/100);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 65/100);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 425:{
                        //left horiz stalagmites top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 35/100);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 65/100);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 426:{
                        //left horiz stalagmites bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 35/100);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 65/100);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 427:{
                        //left horiz stalagmites both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 35/100);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 65/100);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 428:{
                        //right horiz stalagmites
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 35/100);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 65/100);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 429:{
                        //right horiz stalagmites top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 35/100);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 65/100);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 430:{
                        //right horiz stalagmites bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 35/100);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 65/100);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 431:{
                        //right horiz stalagmites both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 35/100);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 65/100);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 432:{
                        //closed stalagtites
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 433:{
                        //closed stalagtites right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 434:{
                        //closed stalagtites left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 435:{
                        //closed stalagtites both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 436:{
                        //closed stalagmites
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 2/10);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 2/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 437:{
                        //closed stalagmites right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 2/10);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 438:{
                        //closed stalagmites left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 2/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 439:{
                        //closed stalagmites both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 440:{
                        //closed left horiz stalagmites
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 35/100);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 65/100);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 441:{
                        //closed left horiz stalagmites top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 35/100);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 65/100);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 442:{
                        //closed left horiz stalagmites bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 35/100);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 65/100);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 443:{
                        //closed left horiz stalagmites both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 35/100);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 65/100);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 444:{
                        //closed right horiz stalagmites
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 35/100);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 65/100);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 445:{
                        //closed right horiz stalagmites top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 35/100);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 65/100);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 446:{
                        //closed right horiz stalagmites bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 35/100);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 65/100);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 447:{
                        //closed right horiz stalagmites both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 35/100);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 65/100);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 448:{
                        //Large E
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 449:{
                        //Large Backwards E
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 450:{
                        //Large E pointing up
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 451:{
                        //Large E pointing down
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 452:{
                        //Large T on left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 453:{
                        //Large T on right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 454:{
                        //Large T
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 455:{
                        //triangle top, leg bottom left
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 456:{
                        //triangle top, leg bottom right
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 457:{
                        //triangle right, leg bottom left
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 458:{
                        //triangle right, leg top left
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 459:{
                        //triangle bottom, leg top left
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 460:{
                        //triangle bottom, leg top right
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 461:{
                        //triangle left, leg bottom right
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 462:{
                        //triangle left, leg top right
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 463:{
                        //two triangles pointing right, no fill
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 464:{
                        //two triangles pointing right, left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        //Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 465:{
                        //two triangles pointing right, right fill
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        //Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 466:{
                        //two triangles pointing right, both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        //Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        //Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 467:{
                        //two triangles pointing left, no filled
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 468:{
                        //two triangles pointing left, right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        //Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 469:{
                        //two triangles pointing left, left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        //Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 470:{
                        //two triangles pointing left, both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        //Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        //Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 471:{
                        //two triangles pointing up, no filled
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 472:{
                        //two triangles pointing up, top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        //Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 473:{
                        //two triangles pointing up, bottom filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        //Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 474:{
                        //two triangles pointing up, both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        //Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        //Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 475:{
                        //two triangles pointing down, no filled
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 476:{
                        //two triangles pointing down, top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //Canvas->Polygon(points, 2);
                        //Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 477:{
                        //two triangles pointing down, bottom filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        //Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 478:{
                        //two triangles pointing down, both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        //Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        //Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 479:{
                        //square, diagonal fill top left
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 480:{
                        //square, diagonal fill bottom left
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 481:{
                        //square, diagonal fill bottom right
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 482:{
                        //square, diagonal fill top right
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 483:{
                        // top right point huge arrow
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 484:{
                        // bottom right point huge arrow
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 485:{
                        // bottom left point huge arrow
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 486:{
                        // top left point huge arrow
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 487:{
                        // top left point thick arrow
                        Canvas->Pen->Width = PictureSize*4/20;
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 488:{
                        // bottom left point thick arrow
                        Canvas->Pen->Width = PictureSize*4/20;
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 489:{
                        // bottom right point thick arrow
                        Canvas->Pen->Width = PictureSize*4/20;
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 490:{
                        // bottom right point thick arrow
                        Canvas->Pen->Width = PictureSize*4/20;
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 491:{
                        // up point thick arrow
                        Canvas->Pen->Width = PictureSize*4/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 492:{
                        // down point thick arrow
                        Canvas->Pen->Width = PictureSize*4/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 493:{
                        // right point thick arrow
                        Canvas->Pen->Width = PictureSize*4/20;
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 494:{
                        // left point thick arrow
                        Canvas->Pen->Width = PictureSize*4/20;
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 495:{
                        // stook upright
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 496:{
                        // stook on side
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 498:{
                        // fat diamond with inner diamond
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        }
                case 497:{
                        // fat diamond
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 499:{
                        // fat diamond with fill
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[3] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 501:{
                        //square with cross
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        }
                case 500:{
                        // square with tl-br diagonal
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 502:{
                        // square with tr-bl diagonal
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 503:{
                        // square with inner square
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 504:{
                        // square with solid inner square
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        points[3] = Point(X + PictureSize * 6/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 505:{
                        // Narrow Diamond
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 3);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 506:{
                        // Narrow Diamond horiz
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 3);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 507:{
                        // Narrow Diamond tl-br diag
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 6/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 3);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 509:{
                        // Narrow Diamond tr-bl diag
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 3);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 510:{
                        // DrumStick tl-br diag
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 511:{
                        // DrumStick tr-bl diag
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 512:{
                        //planet with rings edge on
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->Ellipse(X + PictureSize * 35/100,Y + PictureSize * 35/100,X + PictureSize * 65/100,Y + PictureSize * 65/100);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 514:{
                        //disc with medium thick cross through
                        Canvas->Pen->Width = PictureSize*2/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        }
                case 513:{
                        //disc with medium thick line through  tr-bl
                        Canvas->Pen->Width = PictureSize*2/20;
                        Canvas->Ellipse(X + PictureSize * 35/100,Y + PictureSize * 35/100,X + PictureSize * 65/100,Y + PictureSize * 65/100);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 515:{
                        //disc with medium thick line through  tl-br
                        Canvas->Pen->Width = PictureSize*2/20;
                        Canvas->Ellipse(X + PictureSize * 35/100,Y + PictureSize * 35/100,X + PictureSize * 65/100,Y + PictureSize * 65/100);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 516:{
                        //disc over backwards L
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 517:{
                        //disc over L
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 518:{
                        //disc under upsiddownbackwards L
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 519:{
                        //disc under upsiddown L
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 520:{
                        //divide rotated 90 deg
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 4/10,Y + PictureSize * 6/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 521:{
                        //divide
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 6/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 522:{
                        //ball over surface
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 3/10,X + PictureSize * 7/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 508:{
                        // Narrow Diamond star
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 6/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 3);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 3);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 523: {
                        //percent symbol, #7 rotated
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 524: {
                        //colon
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 25/100,X + PictureSize * 6/10,Y + PictureSize * 45/100);
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 55/100,X + PictureSize * 6/10,Y + PictureSize * 75/100);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 525: {
                        //K
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 526: {
                        //Bottom Segment
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + 0,Y + PictureSize/2,X + PictureSize,Y + PictureSize/2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 527: {
                        //Side Segment
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + PictureSize * 5/10,Y + PictureSize*8/10,X + PictureSize*5/10,Y + 0);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 528: {
                        //Pie, br
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Pie(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 12/10,Y + PictureSize * 12/10,X + PictureSize * 8/10,Y + PictureSize*2/10,X + PictureSize*2/10,Y + PictureSize*8/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 14/10,Y + PictureSize * 14/10,X + PictureSize * 8/10,Y + PictureSize*2/10,X + PictureSize*2/10,Y + PictureSize*8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 529: {
                        //pie, bl
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Pie(X + PictureSize * -2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 12/10,X + PictureSize * 8/10,Y + PictureSize*8/10,X + PictureSize*2/10,Y + PictureSize*2/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pie(X + PictureSize * -4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 14/10,X + PictureSize * 8/10,Y + PictureSize*8/10,X + PictureSize*2/10,Y + PictureSize*2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 530: {
                        //pie, tl
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Pie(X + PictureSize * -2/10,Y + PictureSize * -2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 2/10,Y + PictureSize*8/10,X + PictureSize*8/10,Y + PictureSize*2/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pie(X + PictureSize * -4/10,Y + PictureSize * -4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + PictureSize * 2/10,Y + PictureSize*8/10,X + PictureSize*8/10,Y + PictureSize*2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 531: {
                        //pie, tr
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Pie(X + PictureSize * 4/10,Y + PictureSize * -2/10,X + PictureSize * 12/10,Y + PictureSize * 6/10,X + PictureSize * 2/10,Y + PictureSize*2/10,X + PictureSize*8/10,Y + PictureSize*8/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * -4/10,X + PictureSize * 14/10,Y + PictureSize * 8/10,X + PictureSize * 2/10,Y + PictureSize*2/10,X + PictureSize*8/10,Y + PictureSize*8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                 case 532:{
                        //Circle top filled
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + + PictureSize * 8/10,Y + PictureSize/2,X + 0,Y + PictureSize/2);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 533:{
                        //Circle right filled
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + PictureSize/2,Y + PictureSize * 8/10,X + PictureSize/2,Y + 0);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 534:{
                        //Circle left filled
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + PictureSize/2,Y + 0,X + PictureSize/2,Y + PictureSize * 8/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 535:{
                        //Circle with cross
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 3/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize * 7/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 3/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 536:{
                        //Circle with plus
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 25/100);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 75/100);
                        Canvas->MoveTo(X + PictureSize * 25/100,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 75/100,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 537:{
                        //Circle with diagonal tr-bl
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 7/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 3/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 538:{
                        //Circle with diagonal tl-br
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 3/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 539:{
                        //522 rot 90
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 3/10,X + PictureSize * 7/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 540:{
                        //Venn Union
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Arc(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + PictureSize * 2/10,Y + PictureSize*6/10,X + PictureSize*8/10,Y + PictureSize*6/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 6/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 541:{
                        //540 + horiz mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Arc(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize*4/10,X + PictureSize*2/10,Y + PictureSize*4/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 4/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 542:{
                        //540 + 90 deg rot clock
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Arc(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 8/10,X + PictureSize * 4/10,Y + PictureSize*2/10,X + PictureSize*4/10,Y + PictureSize*8/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 543:{
                        //542 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Arc(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + PictureSize * 6/10,Y + PictureSize*8/10,X + PictureSize*6/10,Y + PictureSize*2/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 544:{
                        //Equals
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 6/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 545:{
                        //C++ OR
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 4/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 6/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 546:{
                        //diagonal slashes
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 547:{
                        //546 + 90 deg rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 548:{
                        //solid box
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Rectangle(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 549:{
                        //19 + 90 deg rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 550:{
                        //549 + 90 deg rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 551:{
                        //550 + 90 deg rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 552:{
                        //Hash sign
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 553: {
                        //Half Pie, R
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Pie(X + PictureSize * 5/10,Y + PictureSize * 3/10,X + PictureSize * 11/10,Y + PictureSize * 7/10,X + PictureSize * 8/10,Y + PictureSize*2/10,X + PictureSize*8/10,Y + PictureSize*8/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pie(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 12/10,Y + PictureSize * 8/10,X + PictureSize * 8/10,Y + PictureSize*2/10,X + PictureSize*8/10,Y + PictureSize*8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 554: {
                        //Half Pie, B
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Pie(X + PictureSize * 3/10,Y + PictureSize * 5/10,X + PictureSize * 7/10,Y + PictureSize * 11/10,X + PictureSize * 8/10,Y + PictureSize*8/10,X + PictureSize*2/10,Y + PictureSize*8/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 12/10,X + PictureSize * 8/10,Y + PictureSize*8/10,X + PictureSize*2/10,Y + PictureSize*8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 555: {
                        //Half Pie, L
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Pie(X + PictureSize * -1/10,Y + PictureSize * 3/10,X + PictureSize * 5/10,Y + PictureSize * 7/10,X + PictureSize * 2/10,Y + PictureSize*8/10,X + PictureSize*2/10,Y + PictureSize*2/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pie(X + PictureSize * -2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 8/10,X + PictureSize * 2/10,Y + PictureSize*8/10,X + PictureSize*2/10,Y + PictureSize*2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 556: {
                        //Half Pie, t
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Pie(X + PictureSize * 3/10,Y + PictureSize * -1/10,X + PictureSize * 7/10,Y + PictureSize * 5/10,X + PictureSize * 2/10,Y + PictureSize*2/10,X + PictureSize*8/10,Y + PictureSize*2/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * -2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10,X + PictureSize * 2/10,Y + PictureSize*2/10,X + PictureSize*8/10,Y + PictureSize*2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 557:{
                        //Arrow left with circle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 558:{
                        //Arrow right with circle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 4/10,Y + PictureSize * 6/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 559:{
                        //Arrow up with circle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 6/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 560:{
                        //Arrow down with circle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 4/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 561:{
                        //Narrow Elipse Vert
                        Canvas->Ellipse(X + PictureSize * 35/100,Y + PictureSize * 2/10,X + PictureSize * 65/100,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 562:{
                        //Narrow Elipse Horiz
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 35/100,X + PictureSize * 8/10,Y + PictureSize * 65/100);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 563:{
                        //Not Equals
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 6/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 564:{
                        //C++ Not OR
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 4/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 6/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 565:{
                        //Venn Union with dot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 3/10,X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        Canvas->Arc(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + PictureSize * 2/10,Y + PictureSize*6/10,X + PictureSize*8/10,Y + PictureSize*6/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 6/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 566:{
                        //541 + dot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 5/10,X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Arc(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize*4/10,X + PictureSize*2/10,Y + PictureSize*4/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 4/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 567:{
                        //542 + dot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 5/10,Y + PictureSize * 4/10,X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Arc(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 8/10,X + PictureSize * 4/10,Y + PictureSize*2/10,X + PictureSize*4/10,Y + PictureSize*8/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 568:{
                        //543 + dot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 4/10,X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        Canvas->Arc(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + PictureSize * 6/10,Y + PictureSize*8/10,X + PictureSize*6/10,Y + PictureSize*2/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 571:{
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 5/10,X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        }
                case 570:{
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 3/10,X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        }
                case 569:{
                        //circle with line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 572:{
                        //circle with line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 5/10,X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 573:{
                        //Narrow Elipse Vert
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 35/100,Y + PictureSize * 2/10,X + PictureSize * 65/100,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 574:{
                        //Narrow Elipse Horiz
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 35/100,X + PictureSize * 8/10,Y + PictureSize * 65/100);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 575:{
                        //add to set
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 3/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 576:{
                        //remove from set
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 577:{
                        //go up
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 578:{
                        //go down
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 7/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 579:{
                        //Gunsight
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 3/10,X + PictureSize * 7/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 580:{
                        //AE combined
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 3/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 581:{
                        //English Heritage Logo
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 582:{
                        //Music sharp
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 4/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 6/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        Canvas->MoveTo(X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 583:{
                        //Yen
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        Canvas->MoveTo(X + PictureSize * 4/10,Y + PictureSize * 6/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 584:{
                        //Less than or equals to
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 45/100);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 585:{
                        //More than or equals to
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 45/100);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 586:{
                        //Not less than
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 587:{
                        //Not greater than
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 588:{
                        //Teepee
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize * 4/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 589:{
                        //Open Teepee
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[6];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[3] = Point(X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        points[4] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        points[5] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 5);
                        Canvas->MoveTo(X + PictureSize * 4/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 590:{
                        //Waves
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 6/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 6/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 591:{
                        //Ship Bow
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 3/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 6/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 592:{
                        //Exactly Equals
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 593:{
                        //Crazy paving
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->MoveTo(X + PictureSize * 6/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 594:{
                        //Asterisk
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 595:{
                        //Asterisk + circle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 3/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize * 7/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 3/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 596:{
                        //Triangle bl + circle
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->Ellipse(X + PictureSize * 5/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 597:{
                        //Triangle br + circle
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 598:{
                        //Triangle tr + circle
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 5/10,X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 599:{
                        //Triangle tl + circle
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->Ellipse(X + PictureSize * 5/10,Y + PictureSize * 5/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
               default:{
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                }

    //Restore original Canvas Brush & Pen properties to ensure printing is correct
    Canvas->Brush->Color = Brush->Color;
    Canvas->Brush->Style = Brush->Style;
    Canvas->Pen->Color = Pen->Color;
    Canvas->Pen->Style = Pen->Style;
    Canvas->Pen->Width = Pen->Width;
    delete Pen;
    delete Brush;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
Image1->Picture->SaveToFile(ExtractFileDir(Application->ExeName) + "\\GlyphNumbers.bmp");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Copy1Click(TObject *Sender)
{
    unsigned int DataHandle = 0;
    HPALETTE APalette;
    unsigned short MyFormat = CF_BITMAP;
    Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
    try {
        // generate a clipboard format, with data and palette
        // save the data to the clipboard using that format and
        // the generated data
        //The use of an intervening bitmap allows the background to be either transparent or solid.
        //If the Image1->Picture->Bitmap is saved straight to clipboard, then the transparency info is
        //lost.
        Bitmap->Width = Image1->Picture->Bitmap->Width;
        Bitmap->Height = Image1->Picture->Bitmap->Height;
        Bitmap->Canvas->Draw(0,0,Image1->Picture->Bitmap);
        Bitmap->SaveToClipboardFormat(MyFormat,DataHandle,APalette);
        Clipboard()->SetAsHandle(CF_BITMAP,DataHandle);
        }

    catch (...) {
        ShowMessage("Sorry, Failed to copy image to clipboard.");
        }

}
//---------------------------------------------------------------------------

