//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "ImageEditor.h"
#include <clipbrd.hpp>
#include <stdio.h>
#include "StringHelp.h"
#include "MathsHelp.h"
#include "GraphicsHelp.h"
#include <shellapi.h>
#include "NewImage.h"
#include <stdlib.h>
#include "EnterColour.h"
#include "ThreadConversion.h"
#include "StitchForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TImageEditorForm *ImageEditorForm;
//---------------------------------------------------------------------------
__fastcall TImageEditorForm::TImageEditorForm(TComponent* Owner)
    : TForm(Owner)
{
	crTargetCursor = (TCursor) (10);
    Screen->Cursors[crTargetCursor] = LoadCursor((void *)HInstance, "TARGET");
    Image1->Cursor = crTargetCursor;
    crDropperCursor = (TCursor)(11);
    Screen->Cursors[crDropperCursor] = LoadCursor((void *)HInstance, "DROPPER");
    Image2->Cursor = crDropperCursor;
    Image3->Cursor = crDropperCursor;
    crFloodFill = (TCursor) (12);
    Screen->Cursors[crFloodFill] = LoadCursor((void *)HInstance, "FILL");
    crDrawCursor = (TCursor) (13);
    Screen->Cursors[crDrawCursor] = LoadCursor((void *)HInstance, "DRAWCURSOR");
    crTextCursor = (TCursor) (14);
    Screen->Cursors[crTextCursor] = LoadCursor((void *)HInstance, "TEXT");
    crLineCursor = (TCursor) (15);
    Screen->Cursors[crLineCursor] = LoadCursor((void *)HInstance, "LINE");
    crDrawRectangle = (TCursor) (16);
    Screen->Cursors[crDrawRectangle] = LoadCursor((void *)HInstance, "DRAWRECTANGLE");
    crDrawCircle = (TCursor) (17);
    Screen->Cursors[crDrawCircle] = LoadCursor((void *)HInstance, "DRAWCIRCLE");
    crDrawBlock  = (TCursor) (18);
    Screen->Cursors[crDrawBlock] = LoadCursor((void *)HInstance, "DRAWBLOCK");
    crDrawFreeForm = (TCursor) (19);
    Screen->Cursors[crDrawFreeForm] = LoadCursor((void *)HInstance, "DRAWFREEFORM");
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::FormResize(TObject *Sender)
{
    if (active) {
        Panel1->Left = ClientWidth - Panel1->Width;
        Panel1->Height = ClientHeight - StatusBar1->Height;
        Panel2->Height = Panel1->Height;
        Panel3->Height = Panel1->Height;
        Panel4->Left = Panel3->Left + Panel3->Width + 1;
        Panel4->Width = Panel1->Left - Panel4->Left;
        Image1->Width = Panel4->Width - VerticalScrollBar->Width - 2;
        Image1->Top = Panel4->Height + 1;
        Image1->Height = Panel3->Height - Panel4->Height - HorizontalScrollBar->Height - 2;
        HorizontalScrollBar->Top = Panel3->Height - HorizontalScrollBar->Height;
        HorizontalScrollBar->Width = Image1->Width;
        VerticalScrollBar->Top = Image1->Top;
        VerticalScrollBar->Height = Image1->Height;
        VerticalScrollBar->Left = Panel1->Left - VerticalScrollBar->Width - 1;
        SetScrollBars();
        LeftRuler->Top = Image1->Top;
        TopRuler->Left = Image1->Left - Panel4->Left;
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Exit1Click(TObject *Sender)
{
    ModalResult = mrOk;
    //Close();
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::FormCreate(TObject *Sender)
{
    Picture = new Graphics::TBitmap();
    fPictureXStitchCount = 14;
    SquareSize = 5;
    active = true;
    TopLeft.x = 0;
    TopLeft.y = 0;
    imagechanged = false;
    Application->OnHint = DisplayHint;
    preparetoblendforeground = false;
    preparetoblendbackground = false;
    wipedout = true;
    ActionType = TNoAction;
    //create the bitmap for the blank background
    TransparentColour = new Graphics::TBitmap;
    TransparentColour->Width = 8;
    TransparentColour->Height = 8;
    TRect Rect;
    Rect.Left = 0;
    Rect.Top = 0;
    Rect.Right = 4;
    Rect.Bottom = 4;
    TransparentColour->Canvas->Brush->Color = clBtnFace;
    TransparentColour->Canvas->FillRect(Rect);
    Rect.Left = 4;
    Rect.Top = 4;
    Rect.Right = 8;
    Rect.Bottom = 8;
    TransparentColour->Canvas->FillRect(Rect);
    //undo's
    //UndoList = new TList();
    //UndoList->Capacity = 8;
    //UndoList->Count = 0;
    UndoTitleList = new TStringList();
    preparetosaveundo = false;
    Undoing = false;
    SingleUndo = true;
    //drawing
    DisplayItemNumber = 0;
    DefaultText.Text = "Hello World";
    DefaultText.Name = "Arial";
    DefaultText.Height = -12;
    DefaultText.Bold = false;
    DefaultText.Italic = false;
    DefaultText.Underlined = false;
    DefaultText.Strikeout = false;
    dragging = false;
    LineWidth = 1;
    LinearArray.x = 2;
    LinearArray.y = 1;
    //settings
    deselectafteroperation = true;
    showbackground = true;
    floodfilldiagonals = false;
    showlinksbetweenblocks = true;
    AntiAlias = TAANone;
    colourspacedivisions = 17;
    subspacesampling = 0;
    OldAngle = 0.0;
    fFillShapes = true;

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::FormDestroy(TObject *Sender)
{
    DMCColourList.Length = 0;
    TweedList.Length = 0;
    delete Picture;
    active = false;
    Application->OnHint = NULL;
    delete TransparentColour;
    //delete all graphics saved in the undo array
    //for (int i = 0; i < UndoList->Count; i++) {
        //Graphics::TBitmap *TempPicture =  (Graphics::TBitmap *) UndoList->Items[i];
        //delete TempPicture;
        //}
    //delete UndoList;
    UndoTitleList->Clear();
    delete UndoTitleList;
    DisplayList.Length = 0;
    for (int i = 0; i < PointList.Length; i++) {
        PointList[i].Points.Length = 0;
        }
    PointList.Length = 0;
    for (int i = 0; i < FloodFillList.Length; i++) {
        FloodFillList[i].Points.Length = 0;
        }
    FloodFillList.Length = 0;
    for (int i = 0; i < TextList.Length; i++) {
        TextList[i].Points.Length = 0;
        }
    TextList.Length = 0;
    for (int i = 0; i < LineList.Length; i++) {
        LineList[i].Points.Length = 0;
        }
    LineList.Length = 0;
    for (int i = 0; i < PolyLineList.Length; i++) {
        PolyLineList[i].Points.Length = 0;
        PolyLineList[i].Corners.Length = 0;
        }
    PolyLineList.Length = 0;
    for (int i = 0; i < EraseList.Length; i++) {
        EraseList[i].Points.Length = 0;
        }
    EraseList.Length = 0;
    for (int i = 0; i < RectangleList.Length; i++) {
        RectangleList[i].Points.Length = 0;
        }
    RectangleList.Length = 0;
    for (int i = 0; i < CircleList.Length; i++) {
        CircleList[i].Points.Length = 0;
        }
    CircleList.Length = 0;
    for (int i = 0; i < FreeFormList.Length; i++) {
        FreeFormList[i].Points.Length = 0;
        FreeFormList[i].Corners.Length = 0;
        }
    FreeFormList.Length = 0;
    for (int i = 0; i < BlockList.Length; i++) {
        BlockList[i].Points.Length = 0;
        }
    BlockList.Length = 0;
    XRefs.Length = 0;
    LinePoints.Length = 0;
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Initialise(void)
{
    FormResize(this);
    //set up DMC palette.
    Image2->Picture->Bitmap->Width = 150;
    Image2->Picture->Bitmap->Height = 10 * (DMCColourList.Length / 15 + 1);
    int pointer = 0;
    int j = 0;
    Image2->Picture->Bitmap->Canvas->Brush->Style = bsSolid;
    Image2->Picture->Bitmap->Canvas->Pen->Style = psClear;

    while (pointer < DMCColourList.Length) {
        for (int i = 0; i < 15; i++) {
            if (pointer < DMCColourList.Length) {
                Image2->Picture->Bitmap->Canvas->Brush->Color = DMCColourList[pointer].Colour;
                Image2->Picture->Bitmap->Canvas->Rectangle(i*10,j*10,((i+1)*10) - 1,((j+1)*10) - 1);
                }
            pointer++;
            }
        j++;
        }
    //set up forground & background colours
    ForegroundColour = clBlack;
    BackgroundColour = clWhite;
    Foreground->Top = Image2->Top + Image2->Height + 4;
    Background->Top = Foreground->Top + 16;
    active = true;
    DisplayCurrentColours();
    //set up Blend palette.
    Label2->Top = Image2->Top + Image2->Height + 84;
    Image3->Top = Label2->Top + 16;
    Image3->Picture->Bitmap->Width = 150;
    Image3->Picture->Bitmap->Height = 2 * (TweedList.Length / 75 + 1);
    pointer = 0;
    j = 0;
    Image3->Picture->Bitmap->Canvas->Brush->Style = bsSolid;
    Image3->Picture->Bitmap->Canvas->Pen->Style = psSolid;
    TColor Pixelcolour;

    while (pointer < TweedList.Length) {
        for (int i = 0; i < 75; i++) {
            if (pointer < TweedList.Length) {
                Pixelcolour = TweedList[pointer].Colour;
                Image3->Picture->Bitmap->Canvas->Pixels[i*2][j*2] = Pixelcolour;
                Image3->Picture->Bitmap->Canvas->Pixels[i*2+1][j*2] = Pixelcolour;
                Image3->Picture->Bitmap->Canvas->Pixels[i*2][j*2+1] = Pixelcolour;
                Image3->Picture->Bitmap->Canvas->Pixels[i*2+1][j*2+1] = Pixelcolour;
                }
            pointer++;
            }
        j++;
        }
    //if already includes blended threads, so show blend palette
    Image3->Visible = blendthreads;
    Label2->Visible = Image3->Visible;

    //set font height combobox
    FontHeightComboBox->ItemIndex = 7;

    //show the picture
    DrawPicture();
    SetScrollBars();

                                    

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Complete(void)
{
    //draws all the available edits on the background picture prior to it being accepted
    SquareSize = 1;
    TopLeft.x = 0;
    TopLeft.y = 0;
    DrawVectors(Picture->Canvas);
}
//---------------------------------------------------------------------------


void __fastcall TImageEditorForm::DisplayCurrentColours(void)
{
    Foreground->Brush->Color = ForegroundColour;
    Background->Brush->Color = BackgroundColour;

    int arrayentry = 0;
    bool found = false;
    while (!found && arrayentry < DMCColourList.Length) {
        if (DMCColourList[arrayentry].Colour == ForegroundColour) {
            found = true;
            //Foreground->Hint = "DMC" + DMCColourList[arrayentry].DMCColourNumber + " " + DMCColourList[arrayentry].DMCColourName + " R:" + AnsiString(DMCColourList[arrayentry].R) + " G:" + AnsiString(DMCColourList[arrayentry].G) + " B:" + AnsiString(DMCColourList[arrayentry].B);
            Foreground->Hint = ShortThreadName + DMCColourList[arrayentry].DMCColourNumber + " " + DMCColourList[arrayentry].DMCColourName + " R:" + AnsiString(DMCColourList[arrayentry].R) + " G:" + AnsiString(DMCColourList[arrayentry].G) + " B:" + AnsiString(DMCColourList[arrayentry].B);
            }
        arrayentry++;
        }
    arrayentry = 0;
    if (!found && blendthreads) {
        while (!found && arrayentry < TweedList.Length) {
            if (TweedList[arrayentry].Colour == ForegroundColour) {
                found = true;
                //Foreground->Hint = "Blend DMC" + TweedList[arrayentry].DMCColourNumber + " R:" + AnsiString(TweedList[arrayentry].R) + " G:" + AnsiString(TweedList[arrayentry].G) + " B:" + AnsiString(TweedList[arrayentry].B);
                Foreground->Hint = "Blend " + ShortThreadName + TweedList[arrayentry].DMCColourNumber + " R:" + AnsiString(TweedList[arrayentry].R) + " G:" + AnsiString(TweedList[arrayentry].G) + " B:" + AnsiString(TweedList[arrayentry].B);
                }
            arrayentry++;
            }
        }
    arrayentry = 0;
    found = false;
    while (!found && arrayentry < DMCColourList.Length) {
        if (DMCColourList[arrayentry].Colour == BackgroundColour) {
            found = true;
            //Background->Hint = "DMC" + DMCColourList[arrayentry].DMCColourNumber + " " + DMCColourList[arrayentry].DMCColourName + " R:" + AnsiString(DMCColourList[arrayentry].R) + " G:" + AnsiString(DMCColourList[arrayentry].G) + " B:" + AnsiString(DMCColourList[arrayentry].B);
            Background->Hint = ShortThreadName + DMCColourList[arrayentry].DMCColourNumber + " " + DMCColourList[arrayentry].DMCColourName + " R:" + AnsiString(DMCColourList[arrayentry].R) + " G:" + AnsiString(DMCColourList[arrayentry].G) + " B:" + AnsiString(DMCColourList[arrayentry].B);
            }
        arrayentry++;
        }
    arrayentry = 0;
    if (!found && blendthreads) {
        while (!found && arrayentry < TweedList.Length) {
            if (TweedList[arrayentry].Colour == BackgroundColour) {
                found = true;
                //Background->Hint = "Blend DMC" + TweedList[arrayentry].DMCColourNumber + " R:" + AnsiString(TweedList[arrayentry].R) + " G:" + AnsiString(TweedList[arrayentry].G) + " B:" + AnsiString(TweedList[arrayentry].B);
                Background->Hint = "Blend " + ShortThreadName + TweedList[arrayentry].DMCColourNumber + " R:" + AnsiString(TweedList[arrayentry].R) + " G:" + AnsiString(TweedList[arrayentry].G) + " B:" + AnsiString(TweedList[arrayentry].B);
                }
            arrayentry++;
            }
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DrawPicture(void)
{
    switch (ActionType) {
        case TEditErasePoints: {
                            DrawRulers();
                            DrawTransparentBackground();
                            bool found = false;
                            int pointer = 0;
                            while (!found && pointer < DisplayList.Length) {
                                if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayEraseItem) {
                                    found = true;
                                    pointer--;
                                    }
                                pointer++;
                                }
                            if (found) DrawErase(DisplayList[pointer].ItemNumber, Image1->Picture->Bitmap->Canvas);
                            }
                            break;
        case TEditBlockPoints: {
                            DrawRulers();
                            DrawTransparentBackground();
                            bool found = false;
                            int pointer = 0;
                            while (!found && pointer < DisplayList.Length) {
                                if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayBlock) {
                                    found = true;
                                    pointer--;
                                    }
                                pointer++;
                                }
                            if (found) DrawOriginalBlock(DisplayList[pointer].ItemNumber, Image1->Picture->Bitmap->Canvas);
                            }
                            break;
        case TEditPointPoints: {
                            DrawRulers();
                            DrawTransparentBackground();
                            bool found = false;
                            int pointer = 0;
                            while (!found && pointer < DisplayList.Length) {
                                if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayPoint) {
                                    found = true;
                                    pointer--;
                                    }
                                pointer++;
                                }
                            if (found) DrawPoints(DisplayList[pointer].ItemNumber, Image1->Picture->Bitmap->Canvas);
                            }
                            break;
        default:            {
                            DrawRulers();
                            if (showbackground) {
                                DrawBitmap();
                                } else {
                                Image1->Picture->Bitmap->Width = (Picture->Width - TopLeft.x) * SquareSize;
                                Image1->Picture->Bitmap->Height = (Picture->Height - TopLeft.y) * SquareSize;
                                Image1->Picture->Bitmap->Canvas->Brush->Bitmap = NULL;
                                Image1->Picture->Bitmap->Canvas->Brush->Color = clWhite;
                                Image1->Picture->Bitmap->Canvas->Pen->Color = clWhite;
                                Image1->Picture->Bitmap->Canvas->Rectangle(0,0,(Picture->Width - TopLeft.x) * SquareSize,(Picture->Height - TopLeft.y) * SquareSize);
                                }
                            DrawVectors(Image1->Picture->Bitmap->Canvas);
                            DrawSelectedItems();
                            //if (showlinksbetweenblocks && BlockList.Length > 1) DrawLinksBetweenBlocks();
                            if (showlinksbetweenblocks && BlockList.Length > 0) DrawLinksBetweenBlocks();
                            }
                            break;
        }
    chartposition SP = FindImage1Position(StartPointChart.y,StartPointChart.y);
    StartPointScreen.x = SP.X;
    StartPointScreen.y = SP.Y;
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DrawRulers(void)
{
    //This draws the rulers at the side of the package
    //If SquareSize = 1 to 3, then do 5 & 10's, labelling 20's
    //If SquareSize > 3 then mark 1's, 5's and 10's, labelling every 10
    TopRuler->Picture->Bitmap->Width = (Picture->Width - TopLeft.x) * SquareSize;
    TopRuler->Picture->Bitmap->Height = TopRuler->Height;
    TRect Rect;
    Rect.Left = 0;
    Rect.Top = 0;
    Rect.Right = TopRuler->Picture->Bitmap->Width;
    Rect.Bottom = TopRuler->Picture->Bitmap->Height;
    TopRuler->Picture->Bitmap->Canvas->Brush->Color = clWhite;
    TopRuler->Picture->Bitmap->Canvas->Brush->Style = bsSolid;
    TopRuler->Picture->Bitmap->Canvas->Pen->Color = clBlack;
    TopRuler->Picture->Bitmap->Canvas->Pen->Width = 1;
    TopRuler->Picture->Bitmap->Canvas->FillRect(Rect);
    TopRuler->Picture->Bitmap->Canvas->Font->Name = "Arial";
    TopRuler->Picture->Bitmap->Canvas->Font->Size = 8;
    int texttop = TopRuler->Picture->Bitmap->Height - TopRuler->Picture->Bitmap->Canvas->TextHeight("1234567890") - 12;
    TopRuler->Picture->Bitmap->Canvas->Brush->Style = bsClear;
    if (SquareSize > 3) {
        for (int i = 0; i < Picture->Width; i++) {
            TopRuler->Picture->Bitmap->Canvas->MoveTo((i - TopLeft.x) * SquareSize,TopRuler->Picture->Bitmap->Height - 1);
            TopRuler->Picture->Bitmap->Canvas->LineTo((i - TopLeft.x) * SquareSize,TopRuler->Picture->Bitmap->Height - 5);
            }
        }
    for (int i = 0; i < Picture->Width; i += 5) {
        TopRuler->Picture->Bitmap->Canvas->MoveTo((i - TopLeft.x) * SquareSize,TopRuler->Picture->Bitmap->Height - 1);
        TopRuler->Picture->Bitmap->Canvas->LineTo((i - TopLeft.x) * SquareSize,TopRuler->Picture->Bitmap->Height - 7);
        }
    for (int i = 0; i < Picture->Width; i += 10) {
        TopRuler->Picture->Bitmap->Canvas->MoveTo((i - TopLeft.x) * SquareSize,TopRuler->Picture->Bitmap->Height - 1);
        TopRuler->Picture->Bitmap->Canvas->LineTo((i - TopLeft.x) * SquareSize,TopRuler->Picture->Bitmap->Height - 10);
        if (SquareSize > 3 && (i%20 != 0)) {
            TopRuler->Picture->Bitmap->Canvas->TextOut((i - TopLeft.x) * SquareSize, texttop, AnsiString(i));
            } else {
            if (i%20 == 0) TopRuler->Picture->Bitmap->Canvas->TextOut((i - TopLeft.x) * SquareSize, texttop, AnsiString(i));
            }
        }
    if (SquareSize > 10) {
        TopRuler->Picture->Bitmap->Canvas->Font->Size = 7;
        for (int i = 5; i < Picture->Width; i += 10) {
            TopRuler->Picture->Bitmap->Canvas->TextOut((i - TopLeft.x) * SquareSize, texttop + 4, AnsiString(i));
            }
        }
    LeftRuler->Picture->Bitmap->Height = (Picture->Height - TopLeft.y) * SquareSize;
    LeftRuler->Picture->Bitmap->Width = TopRuler->Height;
    Rect.Right = LeftRuler->Picture->Bitmap->Width;
    Rect.Bottom = LeftRuler->Picture->Bitmap->Height;
    LeftRuler->Picture->Bitmap->Canvas->Brush->Color = clWhite;
    LeftRuler->Picture->Bitmap->Canvas->Brush->Style = bsSolid;
    LeftRuler->Picture->Bitmap->Canvas->Pen->Color = clBlack;
    LeftRuler->Picture->Bitmap->Canvas->Pen->Width = 1;
    LeftRuler->Picture->Bitmap->Canvas->FillRect(Rect);
    LeftRuler->Picture->Bitmap->Canvas->Font->Name = "Arial";
    LeftRuler->Picture->Bitmap->Canvas->Font->Size = 8;
    LeftRuler->Picture->Bitmap->Canvas->Brush->Style = bsClear;
    if (SquareSize > 3) {
        for (int i = 0; i < Picture->Height; i++) {
            LeftRuler->Picture->Bitmap->Canvas->MoveTo(LeftRuler->Picture->Bitmap->Width - 1, (i - TopLeft.y) * SquareSize);
            LeftRuler->Picture->Bitmap->Canvas->LineTo(TopRuler->Picture->Bitmap->Height - 5, (i - TopLeft.y) * SquareSize);
            }
        }
    for (int i = 0; i < Picture->Height; i += 5) {
        LeftRuler->Picture->Bitmap->Canvas->MoveTo(LeftRuler->Picture->Bitmap->Width - 1, (i - TopLeft.y) * SquareSize);
        LeftRuler->Picture->Bitmap->Canvas->LineTo(TopRuler->Picture->Bitmap->Height - 7, (i - TopLeft.y) * SquareSize);
        }
    for (int i = 0; i < Picture->Height; i += 10) {
        LeftRuler->Picture->Bitmap->Canvas->MoveTo(LeftRuler->Picture->Bitmap->Width - 1, (i - TopLeft.y) * SquareSize);
        LeftRuler->Picture->Bitmap->Canvas->LineTo(TopRuler->Picture->Bitmap->Height - 10, (i - TopLeft.y) * SquareSize);
        texttop = LeftRuler->Picture->Bitmap->Width - LeftRuler->Picture->Bitmap->Canvas->TextWidth(AnsiString(i)) - 12;
        if (SquareSize > 3 && (i%20 != 0)) {
            LeftRuler->Picture->Bitmap->Canvas->TextOut(texttop, (i - TopLeft.y) * SquareSize, AnsiString(i));
            } else {
            if (i%20 == 0) LeftRuler->Picture->Bitmap->Canvas->TextOut(texttop, (i - TopLeft.y) * SquareSize, AnsiString(i));
            }
        }
    if (SquareSize > 10) {
        LeftRuler->Picture->Bitmap->Canvas->Font->Size = 7;
        for (int i = 5; i < Picture->Height; i += 10) {
            texttop = LeftRuler->Picture->Bitmap->Width - LeftRuler->Picture->Bitmap->Canvas->TextWidth(AnsiString(i)) - 12;
            LeftRuler->Picture->Bitmap->Canvas->TextOut(texttop + 2, (i - TopLeft.y) * SquareSize, AnsiString(i));
            }
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DrawBitmap(void)
{
    //this draws a copy of the bitmap held in memory on the image's canvas
    //int maxX = 0;
    //int maxY = 0;
    //first, clear picture
    Image1->Picture->Bitmap->Width = Image1->Width;
    Image1->Picture->Bitmap->Height = Image1->Height;
    TRect Rectangle;
    Image1->Canvas->Pen->Color = clBtnFace;
    Image1->Canvas->Brush->Color = clBtnFace;
    Rectangle.left = 0;
    Rectangle.right = Image1->Picture->Bitmap->Width;
    Rectangle.top = 0;
    Rectangle.bottom = Image1->Picture->Bitmap->Height;
    Image1->Canvas->FillRect(Rectangle);

    if (Picture->Width > 0 && Picture->Height > 0) {
        Rectangle.left = -TopLeft.x * SquareSize;
        Rectangle.top = -TopLeft.y * SquareSize;
        Rectangle.right = Rectangle.left + SquareSize * Picture->Width;
        Rectangle.bottom = Rectangle.top + SquareSize * Picture->Height;
        Image1->Canvas->StretchDraw(Rectangle,Picture);
        }



}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DrawTransparentBackground(void)
{
    //draws a transparent background for editing entities
    Image1->Picture->Bitmap->Width = (Picture->Width - TopLeft.x) * SquareSize;
    Image1->Picture->Bitmap->Height = (Picture->Height - TopLeft.y) * SquareSize;
    Image1->Picture->Bitmap->Canvas->Brush->Bitmap = NULL;
    Image1->Picture->Bitmap->Canvas->Brush->Color = clWhite;
    Image1->Picture->Bitmap->Canvas->Pen->Color = clWhite;
    Image1->Picture->Bitmap->Canvas->Rectangle(0,0,(Picture->Width - TopLeft.x) * SquareSize,(Picture->Height - TopLeft.y) * SquareSize);
    Image1->Picture->Bitmap->Canvas->Brush->Bitmap = TransparentColour;
    Image1->Picture->Bitmap->Canvas->FloodFill(0,0,clWhite,fsSurface);
    Image1->Picture->Bitmap->Canvas->Brush->Bitmap = NULL;

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DrawVectors(TCanvas *Canvas)
{
    //always happens after drawing the bitmap
    for (int i = 0; i < DisplayList.Length; i++) {
        if (DisplayList[i].visible) {
            switch (DisplayList[i].DisplayType) {
                case TDisplayBlock:         {
                                            DrawBlock(DisplayList[i].ItemNumber, Canvas);
                                            }
                                            break;
                case TDisplayFreeForm:      {
                                            DrawFreeForm(DisplayList[i].ItemNumber, Canvas);
                                            }
                                            break;
                case TDisplayCircle:        {
                                            DrawCircle(DisplayList[i].ItemNumber, Canvas);
                                            }
                                            break;
                case TDisplayRectangle:     {
                                            DrawRectangle(DisplayList[i].ItemNumber, Canvas);
                                            }
                                            break;
                case TDisplayEraseItem:     {
                                            DrawErase(DisplayList[i].ItemNumber, Canvas);
                                            }
                                            break;
                case TDisplayPolyLine:      {
                                            DrawPolyLine(DisplayList[i].ItemNumber, Canvas);
                                            }
                                            break;
                case TDisplayLine:          {
                                            DrawLine(DisplayList[i].ItemNumber, Canvas);
                                            }
                                            break;
                case TDisplayText:          {
                                            DrawText(DisplayList[i].ItemNumber, Canvas);
                                            }
                                            break;
                case TDisplayFloodFill:     {
                                            DrawFloodFill(DisplayList[i].ItemNumber, Canvas);
                                            }
                                            break;
                case TDisplayPoint:         {
                                            DrawPoints(DisplayList[i].ItemNumber, Canvas);
                                            }
                                            break;
                default:                    break;
                }
            }
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DrawVectors(TCanvas *Canvas, int Limit)
{
    //draw the vectors up to a certain limit in the display array
    int i = 0;
    if (Limit > DisplayList.Length) Limit = DisplayList.Length;
    while (i < Limit) {
        if (DisplayList[i].visible) {
            switch (DisplayList[i].DisplayType) {
                case TDisplayBlock:         {
                                            DrawBlock(DisplayList[i].ItemNumber, Canvas);
                                            }
                                            break;
                case TDisplayFreeForm:      {
                                            DrawFreeForm(DisplayList[i].ItemNumber, Canvas);
                                            }
                                            break;
                case TDisplayCircle:        {
                                            DrawCircle(DisplayList[i].ItemNumber, Canvas);
                                            }
                                            break;
                case TDisplayRectangle:     {
                                            DrawRectangle(DisplayList[i].ItemNumber, Canvas);
                                            }
                                            break;
                case TDisplayEraseItem:     {
                                            DrawErase(DisplayList[i].ItemNumber, Canvas);
                                            }
                                            break;
                case TDisplayPolyLine:      {
                                            DrawPolyLine(DisplayList[i].ItemNumber, Canvas);
                                            }
                                            break;
                case TDisplayLine:          {
                                            DrawLine(DisplayList[i].ItemNumber, Canvas);
                                            }
                                            break;
                case TDisplayText:          {
                                            DrawText(DisplayList[i].ItemNumber, Canvas);
                                            }
                                            break;
                case TDisplayFloodFill:     {
                                            DrawFloodFill(DisplayList[i].ItemNumber, Canvas);
                                            }
                                            break;
                case TDisplayPoint:         {
                                            DrawPoints(DisplayList[i].ItemNumber, Canvas);
                                            }
                                            break;
                default:                    break;
                }
            }
        i++;
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DrawPoints(int ItemNumber, TCanvas *Canvas)
{
    //draws the points.
    //first find point array
    bool found = false;
    int pointer = 0;
    while (!found && pointer < PointList.Length) {
        if (PointList[pointer].ItemNumber == ItemNumber) {
            pointer--;
            found = true;
            }
        pointer++;
        }
    //now display
    if (found) {
        Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
        Bitmap->Width = SquareSize;
        Bitmap->Height = SquareSize;
        Bitmap->Canvas->Brush->Color = PointList[pointer].Colour;
        Bitmap->Canvas->FloodFill(0,0,clWhite,fsSurface);
        chartposition Location;
        chartposition Limit;
        Limit = FindImage1Position(Picture->Width,Picture->Height);
        for (int i = 0; i < PointList[pointer].Points.Length; i++) {
            Location = FindImage1Position(PointList[pointer].Points[i].x,PointList[pointer].Points[i].y);
            //Image1->Picture->Bitmap->Canvas->Draw(Location.X,Location.Y,Bitmap);
            if (Location.X > -1 && Location.X < Limit.X && Location.Y > -1 && Location.Y < Limit.Y) Canvas->Draw(Location.X,Location.Y,Bitmap);
            }
        delete Bitmap;
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DrawFloodFill(int ItemNumber, TCanvas *Canvas)
{
    //draws the points assocoated with the flood fill.
    //first find flood fill array
    bool found = false;
    int pointer = 0;
    while (!found && pointer < FloodFillList.Length) {
        if (FloodFillList[pointer].ItemNumber == ItemNumber) {
            pointer--;
            found = true;
            }
        pointer++;
        }
    //now display
    if (found) {
        Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
        Bitmap->Width = SquareSize;
        Bitmap->Height = SquareSize;
        Bitmap->Canvas->Brush->Color = FloodFillList[pointer].Colour;
        Bitmap->Canvas->FloodFill(0,0,clWhite,fsSurface);
        chartposition Location;
        chartposition Limit;
        Limit = FindImage1Position(Picture->Width,Picture->Height);
        for (int i = 0; i < FloodFillList[pointer].Points.Length; i++) {
            Location = FindImage1Position(FloodFillList[pointer].Points[i].x,FloodFillList[pointer].Points[i].y);
            //Image1->Picture->Bitmap->Canvas->Draw(Location.X,Location.Y,Bitmap);
            if (Location.X > -1 && Location.X < Limit.X && Location.Y > -1 && Location.Y < Limit.Y) Canvas->Draw(Location.X,Location.Y,Bitmap);
            }
        delete Bitmap;
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DrawText(int ItemNumber, TCanvas *Canvas)
{
    //draws the points assocoated with the text.
    //first find text array
    bool found = false;
    int pointer = 0;
    while (!found && pointer < TextList.Length) {
        if (TextList[pointer].ItemNumber == ItemNumber) {
            pointer--;
            found = true;
            }
        pointer++;
        }
    //now display
    if (found) {
        Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
        Bitmap->Width = SquareSize;
        Bitmap->Height = SquareSize;
        //Bitmap->Canvas->Brush->Color = TextList[pointer].Colour;
        //Bitmap->Canvas->FloodFill(0,0,clWhite,fsSurface);
        chartposition Location;
        chartposition Limit;
        TColor oldcolour = clWhite;
        Limit = FindImage1Position(Picture->Width,Picture->Height);
        for (int i = 0; i < TextList[pointer].Points.Length; i++) {
            Location = FindImage1Position(TextList[pointer].Points[i].x,TextList[pointer].Points[i].y);
            Bitmap->Canvas->Brush->Color = TextList[pointer].Points[i].Colour;
            Bitmap->Canvas->FloodFill(0,0,oldcolour,fsSurface);
            if (Location.X > -1 && Location.X < Limit.X && Location.Y > -1 && Location.Y < Limit.Y) Canvas->Draw(Location.X,Location.Y,Bitmap);
            oldcolour = Bitmap->Canvas->Brush->Color;
            }
        delete Bitmap;
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DrawLine(int ItemNumber, TCanvas *Canvas)
{
    //draws the points assocoated with the line.
    //first find line array
    bool found = false;
    int pointer = 0;
    while (!found && pointer < LineList.Length) {
        if (LineList[pointer].ItemNumber == ItemNumber) {
            pointer--;
            found = true;
            }
        pointer++;
        }
    //now display
    if (found) {
        Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
        Bitmap->Width = SquareSize;
        Bitmap->Height = SquareSize;
        Bitmap->Canvas->Brush->Color = LineList[pointer].Colour;
        Bitmap->Canvas->FloodFill(0,0,clWhite,fsSurface);
        chartposition Location;
        /*chartposition Limit;
        Limit = FindImage1Position(Picture->Width,Picture->Height);
        for (int i = 0; i < LineList[pointer].Points.Length; i++) {
            Location = FindImage1Position(LineList[pointer].Points[i].x,LineList[pointer].Points[i].y);
            if (Location.X > -1 && Location.X < Limit.X && Location.Y > -1 && Location.Y < Limit.Y) Canvas->Draw(Location.X,Location.Y,Bitmap);
            }*/
        TColor oldcolour = clWhite;
        chartposition Limit;
        Limit = FindImage1Position(Picture->Width,Picture->Height);
        for (int i = 0; i < LineList[pointer].Points.Length; i++) {
            Location = FindImage1Position(LineList[pointer].Points[i].x,LineList[pointer].Points[i].y);
            Bitmap->Canvas->Brush->Color = LineList[pointer].Points[i].Colour;
            Bitmap->Canvas->FloodFill(0,0,oldcolour,fsSurface);
            if (Location.X > -1 && Location.X < Limit.X && Location.Y > -1 && Location.Y < Limit.Y) Canvas->Draw(Location.X,Location.Y,Bitmap);
            oldcolour = Bitmap->Canvas->Brush->Color;
            }
        delete Bitmap;
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DrawPolyLine(int ItemNumber, TCanvas *Canvas)
{
    //draws the points assocoated with the line.
    //first find line array
    bool found = false;
    int pointer = 0;
    while (!found && pointer < PolyLineList.Length) {
        if (PolyLineList[pointer].ItemNumber == ItemNumber) {
            pointer--;
            found = true;
            }
        pointer++;
        }
    //now display
    if (found) {
        Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
        Bitmap->Width = SquareSize;
        Bitmap->Height = SquareSize;
        Bitmap->Canvas->FloodFill(0,0,clWhite,fsSurface);
        chartposition Location;
        TColor oldcolour = clWhite;
        chartposition Limit;
        Limit = FindImage1Position(Picture->Width,Picture->Height);
        for (int i = 0; i < PolyLineList[pointer].Points.Length; i++) {
            Location = FindImage1Position(PolyLineList[pointer].Points[i].x,PolyLineList[pointer].Points[i].y);
            Bitmap->Canvas->Brush->Color = PolyLineList[pointer].Points[i].Colour;
            Bitmap->Canvas->FloodFill(0,0,oldcolour,fsSurface);
            if (Location.X > -1 && Location.X < Limit.X && Location.Y > -1 && Location.Y < Limit.Y) Canvas->Draw(Location.X,Location.Y,Bitmap);
            oldcolour = Bitmap->Canvas->Brush->Color;
            }
        delete Bitmap;
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DrawErase(int ItemNumber, TCanvas *Canvas)
{
    //draws the points where the colour is punched through to the underlying bitmap.
    //first find erase array
    bool found = false;
    int pointer = 0;
    while (!found && pointer < EraseList.Length) {
        if (EraseList[pointer].ItemNumber == ItemNumber) {
            pointer--;
            found = true;
            }
        pointer++;
        }
    //now display
    if (found) {
        Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
        Bitmap->Width = SquareSize;
        Bitmap->Height = SquareSize;
        chartposition Location;
        TColor oldcolour = clWhite;
        chartposition Limit;
        Limit = FindImage1Position(Picture->Width,Picture->Height);
        for (int i = 0; i < EraseList[pointer].Points.Length; i++) {
            Location = FindImage1Position(EraseList[pointer].Points[i].x,EraseList[pointer].Points[i].y);
            Bitmap->Canvas->Brush->Color = EraseList[pointer].Points[i].Colour;
            Bitmap->Canvas->FloodFill(0,0,oldcolour,fsSurface);
            if (Location.X > -1 && Location.X < Limit.X && Location.Y > -1 && Location.Y < Limit.Y) Canvas->Draw(Location.X,Location.Y,Bitmap);
            oldcolour = Bitmap->Canvas->Brush->Color;
            }
        delete Bitmap;
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DrawRectangle(int ItemNumber, TCanvas *Canvas)
{
    //draws the points where the rectangle is drawn
    //first find rectangle array
    bool found = false;
    int pointer = 0;
    while (!found && pointer < RectangleList.Length) {
        if (RectangleList[pointer].ItemNumber == ItemNumber) {
            pointer--;
            found = true;
            }
        pointer++;
        }
    //now display
    if (found) {
        Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
        Bitmap->Width = SquareSize;
        Bitmap->Height = SquareSize;
        chartposition Location;
        TColor oldcolour = clWhite;
        chartposition Limit;
        Limit = FindImage1Position(Picture->Width,Picture->Height);
        for (int i = 0; i < RectangleList[pointer].Points.Length; i++) {
            Location = FindImage1Position(RectangleList[pointer].Points[i].x,RectangleList[pointer].Points[i].y);
            Bitmap->Canvas->Brush->Color = RectangleList[pointer].Points[i].Colour;
            Bitmap->Canvas->FloodFill(0,0,oldcolour,fsSurface);
            if (Location.X > -1 && Location.X < Limit.X && Location.Y > -1 && Location.Y < Limit.Y) Canvas->Draw(Location.X,Location.Y,Bitmap);
            oldcolour = Bitmap->Canvas->Brush->Color;
            }
        delete Bitmap;
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DrawCircle(int ItemNumber, TCanvas *Canvas)
{
    //draws the points where the circle is drawn
    //first find Circle array
    bool found = false;
    int pointer = 0;
    while (!found && pointer < CircleList.Length) {
        if (CircleList[pointer].ItemNumber == ItemNumber) {
            pointer--;
            found = true;
            }
        pointer++;
        }
    //now display
    if (found) {
        Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
        Bitmap->Width = SquareSize;
        Bitmap->Height = SquareSize;
        chartposition Location;
        TColor oldcolour = clWhite;
        chartposition Limit;
        Limit = FindImage1Position(Picture->Width,Picture->Height);
        for (int i = 0; i < CircleList[pointer].Points.Length; i++) {
            Location = FindImage1Position(CircleList[pointer].Points[i].x,CircleList[pointer].Points[i].y);
            Bitmap->Canvas->Brush->Color = CircleList[pointer].Points[i].Colour;
            Bitmap->Canvas->FloodFill(0,0,oldcolour,fsSurface);
            if (Location.X > -1 && Location.X < Limit.X && Location.Y > -1 && Location.Y < Limit.Y) Canvas->Draw(Location.X,Location.Y,Bitmap);
            oldcolour = Bitmap->Canvas->Brush->Color;
            }
        delete Bitmap;
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DrawFreeForm(int ItemNumber, TCanvas *Canvas)
{
    //draws the points assocoated with the FreeForm object.
    //first find FreeForm array
    bool found = false;
    int pointer = 0;
    while (!found && pointer < FreeFormList.Length) {
        if (FreeFormList[pointer].ItemNumber == ItemNumber) {
            pointer--;
            found = true;
            }
        pointer++;
        }
    //now display
    if (found) {
        Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
        Bitmap->Width = SquareSize;
        Bitmap->Height = SquareSize;
        Bitmap->Canvas->FloodFill(0,0,clWhite,fsSurface);
        chartposition Location;
        TColor oldcolour = clWhite;
        chartposition Limit;
        Limit = FindImage1Position(Picture->Width,Picture->Height);
        for (int i = 0; i < FreeFormList[pointer].Points.Length; i++) {
            Location = FindImage1Position(FreeFormList[pointer].Points[i].x,FreeFormList[pointer].Points[i].y);
            Bitmap->Canvas->Brush->Color = FreeFormList[pointer].Points[i].Colour;
            Bitmap->Canvas->FloodFill(0,0,oldcolour,fsSurface);
            if (Location.X > -1 && Location.X < Limit.X && Location.Y > -1 && Location.Y < Limit.Y) Canvas->Draw(Location.X,Location.Y,Bitmap);
            oldcolour = Bitmap->Canvas->Brush->Color;
            }
        delete Bitmap;
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DrawOriginalBlock(int ItemNumber, TCanvas *Canvas)
{
    //draws the original, untransformed, points for the Block
    //first find block array
    bool found = false;
    int pointer = 0;
    while (!found && pointer < BlockList.Length) {
        if (BlockList[pointer].ItemNumber == ItemNumber) {
            pointer--;
            found = true;
            }
        pointer++;
        }
    //now display
    if (found) {
        Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
        Bitmap->Width = SquareSize;
        Bitmap->Height = SquareSize;
        chartposition Location;
        TColor oldcolour = clWhite;
        chartposition Limit;
        Limit = FindImage1Position(Picture->Width,Picture->Height);
        for (int i = 0; i < BlockList[pointer].Points.Length; i++) {
            Location = FindImage1Position(BlockList[pointer].Points[i].originalx,BlockList[pointer].Points[i].originaly);
            Bitmap->Canvas->Brush->Color = BlockList[pointer].Points[i].Colour;
            Bitmap->Canvas->FloodFill(0,0,oldcolour,fsSurface);
            if (Location.X > -1 && Location.X < Limit.X && Location.Y > -1 && Location.Y < Limit.Y && !BlockList[pointer].Points[i].transparent) Canvas->Draw(Location.X,Location.Y,Bitmap);
            oldcolour = Bitmap->Canvas->Brush->Color;
            }
        delete Bitmap;
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DrawBlock(int ItemNumber, TCanvas *Canvas)
{
    //draws the points where the Block is drawn
    //first find block array
    bool found = false;
    int pointer = 0;
    while (!found && pointer < BlockList.Length) {
        if (BlockList[pointer].ItemNumber == ItemNumber) {
            pointer--;
            found = true;
            }
        pointer++;
        }
    //now display
    if (found) {
        Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
        Bitmap->Width = SquareSize;
        Bitmap->Height = SquareSize;
        chartposition Location;
        TColor oldcolour = clWhite;
        chartposition Limit;
        Limit = FindImage1Position(Picture->Width,Picture->Height);
        for (int i = 0; i < BlockList[pointer].Points.Length; i++) {
            Location = FindImage1Position(BlockList[pointer].Points[i].x,BlockList[pointer].Points[i].y);
            Bitmap->Canvas->Brush->Color = BlockList[pointer].Points[i].Colour;
            Bitmap->Canvas->FloodFill(0,0,oldcolour,fsSurface);
            if (Location.X > -1 && Location.X < Limit.X && Location.Y > -1 && Location.Y < Limit.Y && !BlockList[pointer].Points[i].transparent) Canvas->Draw(Location.X,Location.Y,Bitmap);
            oldcolour = Bitmap->Canvas->Brush->Color;
            }
        delete Bitmap;
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DrawSelectedItems(void)
{
    if (active) {
        TPenStyle Style = Image1->Picture->Bitmap->Canvas->Pen->Style;
        TPenMode Mode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
        TBrushStyle BrushStyle = Image1->Picture->Bitmap->Canvas->Brush->Style;
        Image1->Picture->Bitmap->Canvas->Pen->Style = psDash;
        Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
        Image1->Picture->Bitmap->Canvas->Brush->Style = bsClear;
        for (int i = 0; i < DisplayList.Length; i++) {
            if (DisplayList[i].selected && DisplayList[i].visible) {
                TRect SelectedRectangle;
                chartposition ScreenLocation = FindImage1Position(DisplayList[i].Area.Left,DisplayList[i].Area.Top);
                SelectedRectangle.Left = ScreenLocation.X - 1;
                SelectedRectangle.Top = ScreenLocation.Y - 1;
                //ScreenLocation = FindImage1Position(DisplayList[i].Area.Right + 1,DisplayList[i].Area.Bottom + 1);
                ScreenLocation = FindImage1Position(DisplayList[i].Area.Right,DisplayList[i].Area.Bottom);
                SelectedRectangle.Right = ScreenLocation.X + 1;
                SelectedRectangle.Bottom = ScreenLocation.Y + 1;
                Image1->Picture->Bitmap->Canvas->Rectangle(SelectedRectangle.Left,SelectedRectangle.Top,SelectedRectangle.Right,SelectedRectangle.Bottom);
                }
            }
        Image1->Picture->Bitmap->Canvas->Pen->Style = Style;
        Image1->Picture->Bitmap->Canvas->Pen->Mode = Mode;
        Image1->Picture->Bitmap->Canvas->Brush->Style = BrushStyle;
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DrawLinksBetweenBlocks(void)
{
    if (BlockList.Length) {
        //This method draws a rectangle around each visible block and draws a line to the master block
        //the master block is outlined in a different colour.

        //right, make cross reference list
        int maxItemNumber = 0;
        for (int i = 0; i < BlockList.Length; i++) {
            if (BlockList[i].ItemNumber > maxItemNumber) {
                maxItemNumber = BlockList[i].ItemNumber;
                }
            if (BlockList[i].Linked && BlockList[i].LinkedBlock > maxItemNumber) {
                maxItemNumber = BlockList[i].LinkedBlock;
                }
            }
        DynamicArray <int> ItemNumberXRef;
        DynamicArray <bool> Visible;
        ItemNumberXRef.Length = maxItemNumber + 1;
        Visible.Length = maxItemNumber + 1;
        for (int i = 0; i < ItemNumberXRef.Length; i++) {
            ItemNumberXRef[i] = -1;
            Visible[i] = false;
            }
        for (int i = 0; i < BlockList.Length; i++) {
            ItemNumberXRef[BlockList[i].ItemNumber] = i;
            }
        for (int i = 0; i < DisplayList.Length; i++) {
            if (DisplayList[i].DisplayType == TDisplayBlock) {
                Visible[DisplayList[i].ItemNumber] = DisplayList[i].visible;
                }
            }

        //Time to start displaying the rectangles and lines.
        TColor LinkColour = clGreen;
        TColor SlaveColour = clGreen;
        TColor MasterColour = clRed;
        TPenStyle Style = Image1->Picture->Bitmap->Canvas->Pen->Style;
        TPenMode Mode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
        TBrushStyle BrushStyle = Image1->Picture->Bitmap->Canvas->Brush->Style;
        Image1->Picture->Bitmap->Canvas->Pen->Style = psDash;
        Image1->Picture->Bitmap->Canvas->Pen->Mode = pmCopy;
        Image1->Picture->Bitmap->Canvas->Brush->Style = bsClear;


        for (int i = 0; i < BlockList.Length; i++) {
            if (Visible[BlockList[i].ItemNumber]) {
                //external rectangles first
                TRect SelectedRectangle;
                chartposition ScreenLocation;
                SelectedRectangle = FindImage1Position(DisplayList[XRefs[BlockList[i].ItemNumber].DisplayXRef].Area);
                SelectedRectangle.Right += 2;
                SelectedRectangle.Bottom += 2;
                SelectedRectangle.Left -= 2;
                SelectedRectangle.Top -= 2;
                //ScreenLocation = FindImage1Position(BlockList[i].Area.Right + 1,BlockList[i].Area.Bottom + 1);
                //SelectedRectangle.Right = ScreenLocation.X + 2;
                //SelectedRectangle.Bottom = ScreenLocation.Y + 2;
                //ScreenLocation = FindImage1Position(BlockList[i].Area.Left,BlockList[i].Area.Top);
                //SelectedRectangle.Left = ScreenLocation.X - 2;
                //SelectedRectangle.Top = ScreenLocation.Y - 2;
                if (BlockList[i].Linked) {
                    Image1->Picture->Bitmap->Canvas->Pen->Color = SlaveColour;
                    } else {
                    Image1->Picture->Bitmap->Canvas->Pen->Color = MasterColour;
                    }
                Image1->Picture->Bitmap->Canvas->Rectangle(SelectedRectangle.Left,SelectedRectangle.Top,SelectedRectangle.Right,SelectedRectangle.Bottom);
                //now link lines
                if (BlockList[i].Linked) {
                    Image1->Picture->Bitmap->Canvas->Pen->Color = LinkColour;
                    //Image1->Picture->Bitmap->Canvas->MoveTo(ScreenLocation.X - 2,ScreenLocation.Y - 2);
                    //ScreenLocation = FindImage1Position(BlockList[ItemNumberXRef[BlockList[i].LinkedBlock]].Area.Left,BlockList[ItemNumberXRef[BlockList[i].LinkedBlock]].Area.Top);
                    Image1->Picture->Bitmap->Canvas->MoveTo(SelectedRectangle.Left,SelectedRectangle.Top);
                    ScreenLocation = FindImage1Position(DisplayList[XRefs[BlockList[i].LinkedBlock].DisplayXRef].Area.Left,DisplayList[XRefs[BlockList[i].LinkedBlock].DisplayXRef].Area.Top);
                    Image1->Picture->Bitmap->Canvas->LineTo(ScreenLocation.X - 2,ScreenLocation.Y - 2);
                    }
                }
            }

        Image1->Picture->Bitmap->Canvas->Pen->Style = Style;
        Image1->Picture->Bitmap->Canvas->Pen->Mode = Mode;
        Image1->Picture->Bitmap->Canvas->Brush->Style = BrushStyle;
        ItemNumberXRef.Length = 0;
        Visible.Length = 0;
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::SetPictureXStitchCount(int StitchCount)
{
    fPictureXStitchCount = StitchCount;
    Zoom1 = Screen->PixelsPerInch / StitchCount + 1;
    SquareSize = Zoom1;
    if (active) DrawPicture();
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DisplayHint(TObject *Sender)
{
    StatusBar1->Panels->Items[3]->Text = " " + GetLongHint(Application->Hint);

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Image2MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
    //find the colour it's over
    int arrayentry = X/10 + 15 * (Y/10);
    if (arrayentry < DMCColourList.Length) {
        //StatusBar1->Panels->Items[4]->Text = " DMC " + DMCColourList[arrayentry].DMCColourNumber + "  "
        StatusBar1->Panels->Items[4]->Text = " " + ShortThreadName + " " + DMCColourList[arrayentry].DMCColourNumber + "  "
                                                     + DMCColourList[arrayentry].DMCColourName
                                                     + "  R:" + AnsiString(DMCColourList[arrayentry].R)
                                                     + "  G:" + AnsiString(DMCColourList[arrayentry].G)
                                                     + "  B:" + AnsiString(DMCColourList[arrayentry].B)
                                                     ;
        Timer1->Enabled = true;
        ArrayPointer = arrayentry;
        UseDMCArray = true;
        StatusBar1->Panels->Items[4]->Style = psOwnerDraw;
        switch (ActionType) {
            case TEditBlockPoints:      {
                                        if (Shift.Contains(ssLeft)) {
                                            if (!UndoTitleList->Count || (UndoTitleList->Count && LeftString(UndoTitleList->Strings[UndoTitleList->Count-1],4) != "Fore")) {
                                                AddUndo("Foreground," + AnsiString((int)(ForegroundColour)) + ",");
                                                }
                                            //Foreground->Brush->Color = DMCColourList[arrayentry].Colour;
                                            ForegroundColour = DMCColourList[arrayentry].Colour;
                                            preparetoblendforeground = false;
                                            DisplayCurrentColours();
                                            }
                                        }
                                        break;
            case TPickPointColour:      {
                                        if (Shift.Contains(ssLeft) || Shift.Contains(ssRight)) {
                                            TColor Colour = DMCColourList[arrayentry].Colour;
                                            AddUndoTitle("Change Selected Point Colour");
                                            SingleUndo = false;
                                            for (int i = 0; i < DisplayList.Length; i++) {
                                                if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayPoint) {
                                                    ChangePointColour(DisplayList[i].ItemNumber,Colour);
                                                    if (deselectafteroperation) {
                                                        AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                                                        DisplayList[i].selected = false;
                                                        }
                                                    }
                                                }
                                            SingleUndo = true;
                                            DrawPicture();
                                            ActionType = TNoAction;
                                            Image1->Cursor = crTargetCursor;
                                            }
                                        }
                                        break;
            case TPickLineColour:       {
                                        if (Shift.Contains(ssLeft) || Shift.Contains(ssRight)) {
                                            TColor Colour = DMCColourList[arrayentry].Colour;
                                            AddUndoTitle("Change Selected Line Colour");
                                            SingleUndo = false;
                                            for (int i = 0; i < DisplayList.Length; i++) {
                                                if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayLine) {
                                                    ChangeLineColour(DisplayList[i].ItemNumber,Colour);
                                                    if (deselectafteroperation) {
                                                        AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                                                        DisplayList[i].selected = false;
                                                        }
                                                    }
                                                }
                                            SingleUndo = true;
                                            DrawPicture();
                                            ActionType = TNoAction;
                                            Image1->Cursor = crTargetCursor;
                                            }
                                        }
                                        break;
            case TPickPolyLineColour:   {
                                        if (Shift.Contains(ssLeft) || Shift.Contains(ssRight)) {
                                            TColor Colour = DMCColourList[arrayentry].Colour;
                                            AddUndoTitle("Change Selected Polyline Colour");
                                            SingleUndo = false;
                                            for (int i = 0; i < DisplayList.Length; i++) {
                                                if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayPolyLine) {
                                                    ChangePolyLineColour(DisplayList[i].ItemNumber,Colour);
                                                    if (deselectafteroperation) {
                                                        AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                                                        DisplayList[i].selected = false;
                                                        }
                                                    }
                                                }
                                            SingleUndo = true;
                                            DrawPicture();
                                            ActionType = TNoAction;
                                            Image1->Cursor = crTargetCursor;
                                            }
                                        }
                                        break;
            case TPickFloodFillColour:  {
                                        if (Shift.Contains(ssLeft) || Shift.Contains(ssRight)) {
                                            ChangeFloodFillColour(DMCColourList[arrayentry].Colour);
                                            ActionType = TNoAction;
                                            Image1->Cursor = crTargetCursor;
                                            }
                                        }
                                        break;
            case TPickTextColour:       {
                                        if (Shift.Contains(ssLeft) || Shift.Contains(ssRight)) {
                                            TColor Colour = DMCColourList[arrayentry].Colour;
                                            AddUndoTitle("Change Selected Text Colour");
                                            SingleUndo = false;
                                            for (int i = 0; i < DisplayList.Length; i++) {
                                                if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayText) {
                                                    ChangeTextColour(DisplayList[i].ItemNumber,Colour);
                                                    if (deselectafteroperation) {
                                                        AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                                                        DisplayList[i].selected = false;
                                                        }
                                                    }
                                                }
                                            SingleUndo = true;
                                            DrawPicture();
                                            ActionType = TNoAction;
                                            Image1->Cursor = crTargetCursor;
                                            }
                                        }
                                        break;
            case TPickRectangleColour:  {
                                        if (Shift.Contains(ssLeft) || Shift.Contains(ssRight)) {
                                            TColor Colour = DMCColourList[arrayentry].Colour;
                                            AddUndoTitle("Change Selected Rectangle Colour");
                                            SingleUndo = false;
                                            for (int i = 0; i < DisplayList.Length; i++) {
                                                if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayRectangle && XRefs[DisplayList[i].ItemNumber].ItemNumber == DisplayList[i].ItemNumber && XRefs[DisplayList[i].ItemNumber].EntityXRef > -1 && XRefs[DisplayList[i].ItemNumber].EntityXRef < RectangleList.Length && DisplayList[i].ItemNumber == RectangleList[XRefs[DisplayList[i].ItemNumber].EntityXRef].ItemNumber) {
                                                    if (Shift.Contains(ssLeft)) {
                                                        ChangeRectangleColour(DisplayList[i].ItemNumber,Colour,RectangleList[XRefs[DisplayList[i].ItemNumber].EntityXRef].BrushColour);
                                                        } else {
                                                        if (Shift.Contains(ssRight)) {
                                                            ChangeRectangleColour(DisplayList[i].ItemNumber,RectangleList[XRefs[DisplayList[i].ItemNumber].EntityXRef].PenColour,Colour);
                                                            }
                                                        }
                                                    if (deselectafteroperation) {
                                                        AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                                                        DisplayList[i].selected = false;
                                                        }
                                                    }
                                                }
                                            SingleUndo = true;
                                            DrawPicture();
                                            ActionType = TNoAction;
                                            Image1->Cursor = crTargetCursor;
                                            }
                                        }
                                        break;
            case TPickCircleColour:  {
                                        if (Shift.Contains(ssLeft) || Shift.Contains(ssRight)) {
                                            TColor Colour = DMCColourList[arrayentry].Colour;
                                            AddUndoTitle("Change Selected Circle Colour");
                                            SingleUndo = false;
                                            for (int i = 0; i < DisplayList.Length; i++) {
                                                if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayCircle && XRefs[DisplayList[i].ItemNumber].ItemNumber == DisplayList[i].ItemNumber && XRefs[DisplayList[i].ItemNumber].EntityXRef > -1 && XRefs[DisplayList[i].ItemNumber].EntityXRef < CircleList.Length && DisplayList[i].ItemNumber == CircleList[XRefs[DisplayList[i].ItemNumber].EntityXRef].ItemNumber) {
                                                    if (Shift.Contains(ssLeft)) {
                                                        ChangeCircleColour(DisplayList[i].ItemNumber,Colour,CircleList[XRefs[DisplayList[i].ItemNumber].EntityXRef].BrushColour);
                                                        } else {
                                                        if (Shift.Contains(ssRight)) {
                                                            ChangeCircleColour(DisplayList[i].ItemNumber,CircleList[XRefs[DisplayList[i].ItemNumber].EntityXRef].PenColour,Colour);
                                                            }
                                                        }
                                                    if (deselectafteroperation) {
                                                        AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                                                        DisplayList[i].selected = false;
                                                        }
                                                    }
                                                }
                                            SingleUndo = true;
                                            DrawPicture();
                                            ActionType = TNoAction;
                                            Image1->Cursor = crTargetCursor;
                                            }
                                        }
                                        break;
            case TPickFreeFormColour:   {
                                        if (Shift.Contains(ssLeft) || Shift.Contains(ssRight)) {
                                            TColor Colour = DMCColourList[arrayentry].Colour;
                                            AddUndoTitle("Change Selected Free-Form Shape Colour");
                                            SingleUndo = false;
                                            for (int i = 0; i < DisplayList.Length; i++) {
                                                if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayFreeForm) {
                                                    if (Shift.Contains(ssLeft)) {
                                                        ChangeFreeFormColour(DisplayList[i].ItemNumber,Colour,FreeFormList[XRefs[DisplayList[i].ItemNumber].EntityXRef].BrushColour);
                                                        } else {
                                                        if (Shift.Contains(ssRight)) {
                                                            ChangeFreeFormColour(DisplayList[i].ItemNumber,FreeFormList[XRefs[DisplayList[i].ItemNumber].EntityXRef].PenColour,Colour);
                                                            }
                                                        }
                                                    if (deselectafteroperation) {
                                                        AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                                                        DisplayList[i].selected = false;
                                                        }
                                                    }
                                                }
                                            SingleUndo = true;
                                            DrawPicture();
                                            ActionType = TNoAction;
                                            Image1->Cursor = crTargetCursor;
                                            }
                                        }
                                        break;
            default:                    {
                                        if (Shift.Contains(ssLeft)) {
                                            if (!UndoTitleList->Count || (UndoTitleList->Count && LeftString(UndoTitleList->Strings[UndoTitleList->Count-1],4) != "Fore")) {
                                                AddUndoTitle("Change Foreground Colour");
                                                AddUndo("Foreground," + AnsiString((int)(ForegroundColour)) + ",");
                                                }
                                            //Foreground->Brush->Color = DMCColourList[arrayentry].Colour;
                                            //Foreground->Hint = "DMC" + DMCColourList[arrayentry].DMCColourNumber + " " + DMCColourList[arrayentry].DMCColourName + " R:" + AnsiString(DMCColourList[arrayentry].R) + " G:" + AnsiString(DMCColourList[arrayentry].G) + " B:" + AnsiString(DMCColourList[arrayentry].B);
                                            ForegroundColour = DMCColourList[arrayentry].Colour;
                                            preparetoblendforeground = false;
                                            DisplayCurrentColours();
                                            }
                                        if (Shift.Contains(ssRight)) {
                                            if (!UndoTitleList->Count ||(UndoTitleList->Count && LeftString(UndoTitleList->Strings[UndoTitleList->Count-1],4) != "Back")) {
                                                AddUndoTitle("Change Background Colour");
                                                AddUndo("Background," + AnsiString((int)(BackgroundColour)) + ",");
                                                }
                                            //Background->Brush->Color = DMCColourList[arrayentry].Colour;
                                            //Background->Hint = "DMC" + DMCColourList[arrayentry].DMCColourNumber + " " + DMCColourList[arrayentry].DMCColourName + " R:" + AnsiString(DMCColourList[arrayentry].R) + " G:" + AnsiString(DMCColourList[arrayentry].G) + " B:" + AnsiString(DMCColourList[arrayentry].B);
                                            BackgroundColour = DMCColourList[arrayentry].Colour;
                                            preparetoblendbackground = false;
                                            DisplayCurrentColours();
                                            }
                                        }
                                        break;
            }
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Image2MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    Image2MouseMove(Sender,Shift,X,Y);
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Timer1Timer(TObject *Sender)
{
    //clear the description after 5 secs
    StatusBar1->Panels->Items[4]->Text = "";
    StatusBar1->Panels->Items[4]->Style = psText;
    Timer1->Enabled = false;
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Image3MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
    //find the blend colour the mouse is over
    int arrayentry = X/2 + 75 * (Y/2);
    if (arrayentry < TweedList.Length) {
        //StatusBar1->Panels->Items[4]->Text = " DMC " + TweedList[arrayentry].DMCColourNumber + "  "
        StatusBar1->Panels->Items[4]->Text = " " + ShortThreadName + " " + TweedList[arrayentry].DMCColourNumber + "  "
                                                     + TweedList[arrayentry].DMCColourName
                                                     + "  R:" + AnsiString(TweedList[arrayentry].R)
                                                     + "  G:" + AnsiString(TweedList[arrayentry].G)
                                                     + "  B:" + AnsiString(TweedList[arrayentry].B)
                                                     ;
        Timer1->Enabled = true;
        ArrayPointer = arrayentry;
        UseDMCArray = false;
        StatusBar1->Panels->Items[4]->Style = psOwnerDraw;
        switch (ActionType) {
            case TEditBlockPoints:      {
                                        if (Shift.Contains(ssLeft)) {
                                            if (!UndoTitleList->Count || (UndoTitleList->Count && LeftString(UndoTitleList->Strings[UndoTitleList->Count-1],4) != "Fore")) {
                                                AddUndo("Foreground," + AnsiString((int)(ForegroundColour)) + ",");
                                                }
                                            //Foreground->Brush->Color = TweedList[arrayentry].Colour;
                                            ForegroundColour = TweedList[arrayentry].Colour;
                                            preparetoblendforeground = true;
                                            DisplayCurrentColours();
                                            }
                                        }
                                        break;
            case TPickPointColour:      {
                                        if (Shift.Contains(ssLeft) || Shift.Contains(ssRight)) {
                                            TColor Colour = TweedList[arrayentry].Colour;
                                            AddUndoTitle("Change Selected Point Colour");
                                            SingleUndo = false;
                                            for (int i = 0; i < DisplayList.Length; i++) {
                                                if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayPoint) {
                                                    ChangePointColour(DisplayList[i].ItemNumber,Colour);
                                                    if (deselectafteroperation) {
                                                        AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                                                        DisplayList[i].selected = false;
                                                        }
                                                    }
                                                }
                                            SingleUndo = true;
                                            DrawPicture();
                                            ActionType = TNoAction;
                                            Image1->Cursor = crTargetCursor;
                                            blendthreads = true;
                                            }
                                        }
                                        break;
            case TPickLineColour:       {
                                        if (Shift.Contains(ssLeft) || Shift.Contains(ssRight)) {
                                            TColor Colour = TweedList[arrayentry].Colour;
                                            AddUndoTitle("Change Selected Line Colour");
                                            SingleUndo = false;
                                            for (int i = 0; i < DisplayList.Length; i++) {
                                                if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayLine) {
                                                    ChangeLineColour(DisplayList[i].ItemNumber,Colour);
                                                    if (deselectafteroperation) {
                                                        AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                                                        DisplayList[i].selected = false;
                                                        }
                                                    }
                                                }
                                            SingleUndo = true;
                                            DrawPicture();
                                            ActionType = TNoAction;
                                            Image1->Cursor = crTargetCursor;
                                            blendthreads = true;
                                            }
                                        }
                                        break;
            case TPickPolyLineColour:   {
                                        if (Shift.Contains(ssLeft) || Shift.Contains(ssRight)) {
                                            TColor Colour = TweedList[arrayentry].Colour;
                                            AddUndoTitle("Change Selected Polyline Colour");
                                            SingleUndo = false;
                                            for (int i = 0; i < DisplayList.Length; i++) {
                                                if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayPolyLine) {
                                                    ChangePolyLineColour(DisplayList[i].ItemNumber,Colour);
                                                    if (deselectafteroperation) {
                                                        AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                                                        DisplayList[i].selected = false;
                                                        }
                                                    }
                                                }
                                            SingleUndo = true;
                                            DrawPicture();
                                            ActionType = TNoAction;
                                            Image1->Cursor = crTargetCursor;
                                            blendthreads = true;
                                            }
                                        }
                                        break;
            case TPickFloodFillColour:  {
                                        if (Shift.Contains(ssLeft) || Shift.Contains(ssRight)) {
                                            ChangeFloodFillColour(TweedList[arrayentry].Colour);
                                            ActionType = TNoAction;
                                            Image1->Cursor = crTargetCursor;
                                            blendthreads = true;
                                            }
                                        }
                                        break;
            case TPickTextColour:       {
                                        if (Shift.Contains(ssLeft) || Shift.Contains(ssRight)) {
                                            TColor Colour = TweedList[arrayentry].Colour;
                                            AddUndoTitle("Change Selected Text Colour");
                                            SingleUndo = false;
                                            for (int i = 0; i < DisplayList.Length; i++) {
                                                if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayText) {
                                                    ChangeTextColour(DisplayList[i].ItemNumber,Colour);
                                                    if (deselectafteroperation) {
                                                        AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                                                        DisplayList[i].selected = false;
                                                        }
                                                    }
                                                }
                                            SingleUndo = true;
                                            DrawPicture();
                                            ActionType = TNoAction;
                                            Image1->Cursor = crTargetCursor;
                                            blendthreads = true;
                                            }
                                        }
                                        break;
            case TPickRectangleColour:  {
                                        if (Shift.Contains(ssLeft) || Shift.Contains(ssRight)) {
                                            TColor Colour = TweedList[arrayentry].Colour;
                                            AddUndoTitle("Change Selected Rectangle Colour");
                                            SingleUndo = false;
                                            for (int i = 0; i < DisplayList.Length; i++) {
                                                if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayRectangle && XRefs[DisplayList[i].ItemNumber].ItemNumber == DisplayList[i].ItemNumber && XRefs[DisplayList[i].ItemNumber].EntityXRef > -1 && XRefs[DisplayList[i].ItemNumber].EntityXRef < RectangleList.Length && DisplayList[i].ItemNumber == RectangleList[XRefs[DisplayList[i].ItemNumber].EntityXRef].ItemNumber) {
                                                    if (Shift.Contains(ssLeft)) {
                                                        ChangeRectangleColour(DisplayList[i].ItemNumber,Colour,RectangleList[XRefs[DisplayList[i].ItemNumber].EntityXRef].BrushColour);
                                                        } else {
                                                        if (Shift.Contains(ssRight)) {
                                                            ChangeRectangleColour(DisplayList[i].ItemNumber,RectangleList[XRefs[DisplayList[i].ItemNumber].EntityXRef].PenColour,Colour);
                                                            }
                                                        }
                                                    if (deselectafteroperation) {
                                                        AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                                                        DisplayList[i].selected = false;
                                                        }
                                                    }
                                                }
                                            SingleUndo = true;
                                            DrawPicture();
                                            ActionType = TNoAction;
                                            Image1->Cursor = crTargetCursor;
                                            blendthreads = true;
                                            }
                                        }
                                        break;
            case TPickCircleColour:  {
                                        if (Shift.Contains(ssLeft) || Shift.Contains(ssRight)) {
                                            TColor Colour = TweedList[arrayentry].Colour;
                                            AddUndoTitle("Change Selected Circle Colour");
                                            SingleUndo = false;
                                            for (int i = 0; i < DisplayList.Length; i++) {
                                                if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayCircle && XRefs[DisplayList[i].ItemNumber].ItemNumber == DisplayList[i].ItemNumber && XRefs[DisplayList[i].ItemNumber].EntityXRef > -1 && XRefs[DisplayList[i].ItemNumber].EntityXRef < CircleList.Length && DisplayList[i].ItemNumber == CircleList[XRefs[DisplayList[i].ItemNumber].EntityXRef].ItemNumber) {
                                                    if (Shift.Contains(ssLeft)) {
                                                        ChangeCircleColour(DisplayList[i].ItemNumber,Colour,CircleList[XRefs[DisplayList[i].ItemNumber].EntityXRef].BrushColour);
                                                        } else {
                                                        if (Shift.Contains(ssRight)) {
                                                            ChangeCircleColour(DisplayList[i].ItemNumber,CircleList[XRefs[DisplayList[i].ItemNumber].EntityXRef].PenColour,Colour);
                                                            }
                                                        }
                                                    if (deselectafteroperation) {
                                                        AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                                                        DisplayList[i].selected = false;
                                                        }
                                                    }
                                                }
                                            SingleUndo = true;
                                            DrawPicture();
                                            ActionType = TNoAction;
                                            Image1->Cursor = crTargetCursor;
                                            blendthreads = true;
                                            }
                                        }
                                        break;
            case TPickFreeFormColour:   {
                                        if (Shift.Contains(ssLeft) || Shift.Contains(ssRight)) {
                                            TColor Colour = TweedList[arrayentry].Colour;
                                            AddUndoTitle("Change Selected Free-Form Shape Colour");
                                            SingleUndo = false;
                                            for (int i = 0; i < DisplayList.Length; i++) {
                                                if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayFreeForm) {
                                                    if (Shift.Contains(ssLeft)) {
                                                        ChangeFreeFormColour(DisplayList[i].ItemNumber,Colour,FreeFormList[XRefs[DisplayList[i].ItemNumber].EntityXRef].BrushColour);
                                                        } else {
                                                        if (Shift.Contains(ssRight)) {
                                                            ChangeFreeFormColour(DisplayList[i].ItemNumber,FreeFormList[XRefs[DisplayList[i].ItemNumber].EntityXRef].PenColour,Colour);
                                                            }
                                                        }
                                                    if (deselectafteroperation) {
                                                        AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                                                        DisplayList[i].selected = false;
                                                        }
                                                    }
                                                }
                                            SingleUndo = true;
                                            DrawPicture();
                                            ActionType = TNoAction;
                                            Image1->Cursor = crTargetCursor;
                                            blendthreads = true;
                                            }
                                        }
                                        break;
            default:                    {
                                        if (Shift.Contains(ssLeft)) {
                                            //Foreground->Brush->Color = TweedList[arrayentry].Colour;
                                            ForegroundColour = TweedList[arrayentry].Colour;
                                            preparetoblendforeground = true;
                                            DisplayCurrentColours();
                                            }
                                        if (Shift.Contains(ssRight)) {
                                            //Background->Brush->Color = TweedList[arrayentry].Colour;
                                            BackgroundColour = TweedList[arrayentry].Colour;
                                            preparetoblendbackground = true;
                                            DisplayCurrentColours();
                                            }
                                        }
                                        break;
            }
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Image3MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    Image3MouseMove(Sender,Shift,X,Y);

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::CopyChartImage1Click(TObject *Sender)
{
    unsigned int DataHandle = 0;
    HPALETTE APalette;
    unsigned short MyFormat = CF_BITMAP;
    Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
    TPoint oldtopleft = TopLeft;
    int oldsquaresize = SquareSize;
    try {
        // generate a clipboard format, with data and palette
        // save the data to the clipboard using that format and
        // the generated data
        Bitmap->Assign(Picture);
        TopLeft.x = 0;
        TopLeft.y = 0;
        SquareSize = 1;
        DrawVectors(Bitmap->Canvas);
        Bitmap->SaveToClipboardFormat(MyFormat,DataHandle,APalette);
        Clipboard()->SetAsHandle(CF_BITMAP,DataHandle);
        }

    catch (...) {
        ShowMessage("Sorry, Failed to copy image to clipboard.");
        }

    SquareSize = oldsquaresize;
    TopLeft = oldtopleft;

    delete Bitmap;

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::CopyPaletteImage2Click(TObject *Sender)
{
    unsigned int DataHandle = 0;
    HPALETTE APalette;
    unsigned short MyFormat = CF_BITMAP;
    Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
    try {
        // generate a clipboard format, with data and palette
        // save the data to the clipboard using that format and
        // the generated data
        Bitmap->Width = Image2->Picture->Bitmap->Width;
        Bitmap->Height = Image2->Picture->Bitmap->Height;
        Bitmap->Canvas->Draw(0,0,Image2->Picture->Bitmap);
        Bitmap->SaveToClipboardFormat(MyFormat,DataHandle,APalette);
        Clipboard()->SetAsHandle(CF_BITMAP,DataHandle);
        }

    catch (...) {
        ShowMessage("Sorry, Failed to copy image to clipboard.");
        }

    delete Bitmap;

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::CopyPaletteImage3Click(TObject *Sender)
{
    unsigned int DataHandle = 0;
    HPALETTE APalette;
    unsigned short MyFormat = CF_BITMAP;
    Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
    try {
        // generate a clipboard format, with data and palette
        // save the data to the clipboard using that format and
        // the generated data
        Bitmap->Width = Image3->Picture->Bitmap->Width;
        Bitmap->Height = Image3->Picture->Bitmap->Height;
        Bitmap->Canvas->Draw(0,0,Image3->Picture->Bitmap);
        Bitmap->SaveToClipboardFormat(MyFormat,DataHandle,APalette);
        Clipboard()->SetAsHandle(CF_BITMAP,DataHandle);
        }

    catch (...) {
        ShowMessage("Sorry, Failed to copy image to clipboard.");
        }

    delete Bitmap;

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::StatusBar1DrawPanel(
      TStatusBar *StatusBar, TStatusPanel *Panel, const TRect &Rect)
{
    //colours the status bar background the same as the palette colour being hovered over.
    TCanvas *pCanvas = StatusBar->Canvas;
    if (UseDMCArray) {
        pCanvas->Brush->Color = DMCColourList[ArrayPointer].Colour;
        if (DMCColourList[ArrayPointer].DrawWhite) {
            pCanvas->Font->Color = clWhite;
            } else {
            pCanvas->Font->Color = clBlack;
            }
        } else {
        pCanvas->Brush->Color = TweedList[ArrayPointer].Colour;
        if (TweedList[ArrayPointer].DrawWhite) {
            pCanvas->Font->Color = clWhite;
            } else {
            pCanvas->Font->Color = clBlack;
            }
        }

    pCanvas->FillRect(Rect);
    pCanvas->TextRect(Rect,Rect.left,Rect.top,StatusBar1->Panels->Items[4]->Text);

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::View1Click(TObject *Sender)
{
    //making sure the blend palette is visible if blended threads are used.
    if (blendthreads) {
        //BlendColours1->Checked = true;
        BlendColours1->Enabled = false;
        Image3->Visible = true;
        }
    BlendColours1->Checked = Image3->Visible;
    Label2->Visible = Image3->Visible;
    if (DisplayList.Length) {
        Show1->Enabled = true;
        Hide1->Enabled = true;
        Select3->Enabled = true;
        Deselect2->Enabled = true;
        } else {
        Show1->Enabled = false;
        Hide1->Enabled = false;
        Select3->Enabled = false;
        Deselect2->Enabled = false;
        }
    ShowBackground1->Checked = showbackground;
    ShowLinksBetweenBlocks2->Checked = showlinksbetweenblocks;

    bool result = AnyItemsSelected;
    BringtoFront2->Enabled = result;
    BringForwardOne1->Enabled = result;
    BackOne2->Enabled = result;
    SendtoBack2->Enabled = result;

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::BlendColours1Click(TObject *Sender)
{
    if (!blendthreads) {
        Image3->Visible = !Image3->Visible;
        } else {
        Image3->Visible = true;
        }
    Label2->Visible = Image3->Visible;
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::ZoomIn1Click(TObject *Sender)
{
    if (SquareSize < 30) SquareSize++;
    DrawPicture();
    SetScrollBars();
    wipedout = true;
    StatusBar1->Panels->Items[2]->Text = " Zoom = " + AnsiString(100 * SquareSize / Zoom1) + "%";

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::ZoomOut1Click(TObject *Sender)
{
    SquareSize--;
    if (SquareSize < 1) SquareSize = 1;
    if (Image1->Width/SquareSize > (Picture->Width - TopLeft.x)) {
        TopLeft.x = Picture->Width - Image1->Width/SquareSize;
        }
    if (Image1->Width/SquareSize > Picture->Width || TopLeft.x < 0) TopLeft.x = 0;
    if (Image1->Height/SquareSize > (Picture->Height - TopLeft.y)) {
        TopLeft.y = Picture->Height - Image1->Height/SquareSize;
        }
    if (Image1->Height/SquareSize > Picture->Height || TopLeft.y < 0) TopLeft.y = 0;
    wipedout = true;
    DrawPicture();
    SetScrollBars();
    StatusBar1->Panels->Items[2]->Text = " Zoom = " + AnsiString(100 * SquareSize / Zoom1) + "%";

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::SetScrollBars(void)
{
    //the bit below doesn't work well
    /*
    int maxX = Image1->Picture->Bitmap->Width/SquareSize + TopLeft.x;
    if ((maxX - TopLeft.x) < Picture->Width && maxX < Picture->Width) {
        HorizontalScrollBar->Enabled = true;
        HorizontalScrollBar->Max = Picture->Width - 1 - maxX + TopLeft.x;
        HorizontalScrollBar->Min = 0;
        HorizontalScrollBar->LargeChange = (Word)Picture->Width/10;
        if (HorizontalScrollBar->LargeChange > (Word)(maxX - TopLeft.x)) {
            HorizontalScrollBar->LargeChange = (Word)(maxX - TopLeft.x);
            }
        } else {
        HorizontalScrollBar->Enabled = false;
        TopLeft.x = 0;
        }
    int maxY = Image1->Picture->Bitmap->Height/SquareSize + TopLeft.y;
    if ((maxY - TopLeft.y) < Picture->Height && maxY < Picture->Height) {
        VerticalScrollBar->Enabled = true;
        VerticalScrollBar->Max = Picture->Height - 1 - maxY + TopLeft.y;
        VerticalScrollBar->Min = 0;
        VerticalScrollBar->LargeChange = (Word)Picture->Height/10;
        if (VerticalScrollBar->LargeChange > (Word)(maxY - TopLeft.y)) {
            VerticalScrollBar->LargeChange = (Word)(maxY - TopLeft.y);
            }
        } else {
        VerticalScrollBar->Enabled = false;
        TopLeft.y = 0;
        }
    */
    int screenwidth = Image1->Width/SquareSize;
    if (screenwidth > Picture->Width) {
        TopLeft.x = 0;
        HorizontalScrollBar->Enabled = false;
        } else {
        HorizontalScrollBar->Min = 0;
        HorizontalScrollBar->Max = Picture->Width - screenwidth;
        if (HorizontalScrollBar->Max < TopLeft.x) TopLeft.x = HorizontalScrollBar->Max;
        HorizontalScrollBar->Position = TopLeft.x;
        if (screenwidth > 20) {
            HorizontalScrollBar->LargeChange = (Word)(screenwidth - 5);
            } else {
            HorizontalScrollBar->LargeChange = (Word)(screenwidth);
            }
        HorizontalScrollBar->Enabled = true;
        }
    int screenheight = Image1->Height/SquareSize;
    if (screenheight > Picture->Height) {
        TopLeft.y = 0;
        VerticalScrollBar->Enabled = false;
        } else {
        VerticalScrollBar->Min = 0;
        VerticalScrollBar->Max = Picture->Height - screenheight;
        if (VerticalScrollBar->Max < TopLeft.y) TopLeft.y = VerticalScrollBar->Max;
        VerticalScrollBar->Position = TopLeft.y;
        if (screenheight > 20) {
            VerticalScrollBar->LargeChange = (Word)(screenheight - 5);
            } else {
            VerticalScrollBar->LargeChange = (Word)(screenheight);
            }
        VerticalScrollBar->Enabled = true;
        }
    chartposition SP = FindImage1Position(StartPointScreen.x,StartPointScreen.y);
    StartPointScreen.x = SP.X;
    StartPointScreen.y = SP.Y;

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::VerticalScrollBarScroll(TObject *Sender,
      TScrollCode ScrollCode, int &ScrollPos)
{
    TopLeft.y = VerticalScrollBar->Position;
    wipedout = true;
    DrawPicture();

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::FormMouseWheelUp(TObject *Sender,
      TShiftState Shift, TPoint &MousePos, bool &Handled)
{
        static int c = 0;
        c++;
        if (!(c%3)) {
            ZoomOut1Click(this);
            c = 0;
            }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::FormMouseWheelDown(TObject *Sender,
      TShiftState Shift, TPoint &MousePos, bool &Handled)
{
        static int d = 0;
        d++;
        if (!(d%3)) {
            ZoomIn1Click(this);
            d = 0;
            }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Zoom111Click(TObject *Sender)
{
    SquareSize = Zoom1 + 1;
    //if (active) DrawPicture();
    ZoomOut1Click(Sender);

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::HorizontalScrollBarScroll(
      TObject *Sender, TScrollCode ScrollCode, int &ScrollPos)
{
    TopLeft.x = HorizontalScrollBar->Position;
    wipedout = true;
    DrawPicture();

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::PixelEditButtonClick(TObject *Sender)
{
    //sets up the pencil tool
    //if (ActionType == TPixelEdit) {
    TerminateCurrentAction();
    if (!PixelEditButton->Down) {
        ActionType = TNoAction;
        preparetosaveundo = false;
        Image1->Cursor = crTargetCursor;
        } else {
        ActionType = TPixelEdit;
        preparetosaveundo = true;
        Image1->Cursor = crDrawCursor;
        }
    //Image1->Cursor = crTargetCursor;

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::FloodFillButtonClick(TObject *Sender)
{
    //set up for flood fill
    TerminateCurrentAction();
    if (!FloodFillButton->Down) {
        ActionType = TNoAction;
        Image1->Cursor = crTargetCursor;
        } else {
        ActionType = TFloodFill;
        Image1->Cursor = crFloodFill;
        }
    preparetosaveundo = false;


}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::EyedropperButtonClick(TObject *Sender)
{
    //set up for eyedropper
    TerminateCurrentAction();
    if (!EyedropperButton->Down) {
        ActionType = TNoAction;
        Image1->Cursor = crTargetCursor;
        } else {
        ActionType = TEyeDropper;
        Image1->Cursor = crDropperCursor;
        }
    preparetosaveundo = false;
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::TextButtonClick(TObject *Sender)
{
    //sets up for the text tool
    TerminateCurrentAction();
    if (!TextButton->Down) {
        ActionType = TNoAction;
        Image1->Cursor = crTargetCursor;
        } else {
        ActionType = TTextItem;
        Image1->Cursor = crTextCursor;
        wipedout = true;
        }
    preparetosaveundo = false;
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::LineButtonClick(TObject *Sender)
{
    //prepares to draw a line
    TerminateCurrentAction();
    if (!LineButton->Down) {
        ActionType = TNoAction;
        Image1->Cursor = crTargetCursor;
        } else {
        ActionType = TDrawLine;
        Image1->Cursor = crLineCursor;
        }
    preparetosaveundo = false;
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::PolyLineButtonClick(TObject *Sender)
{
    //prepares to draw a line
    TerminateCurrentAction();
    if (!PolyLineButton->Down) {
        ActionType = TNoAction;
        Image1->Cursor = crTargetCursor;
        } else {
        ActionType = TDrawPolyLine;
        Image1->Cursor = crLineCursor;
        dragging = false;
        }
    preparetosaveundo = false;

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::EraseButtonClick(TObject *Sender)
{
    //Prepare to Erase
    TerminateCurrentAction();
    if (!EraseButton->Down) {
        ActionType = TNoAction;
        preparetosaveundo = false;
        Image1->Cursor = crTargetCursor;
        } else {
        ActionType = TEraseItem;
        preparetosaveundo = true;
        Image1->Cursor = crDrawCursor;
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::RectangleButtonClick(TObject *Sender)
{
    //starts drawing a rectangle
    TerminateCurrentAction();
    if (!RectangleButton->Down) {
        ActionType = TNoAction;
        Image1->Cursor = crTargetCursor;
        } else {
        ActionType = TDrawRectangle;
        Image1->Cursor = crDrawRectangle;
        }
    preparetosaveundo = false;
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::CircleButtonClick(TObject *Sender)
{
    //starts drawing a circle
    TerminateCurrentAction();
    if (!CircleButton->Down) {
        ActionType = TNoAction;
        Image1->Cursor = crTargetCursor;
        } else {
        ActionType = TDrawCircle;
        Image1->Cursor = crDrawCircle;
        }
    preparetosaveundo = false;

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::FreeFormButtonClick(TObject *Sender)
{
    //starts drawing a freeform object
    TerminateCurrentAction();
    if (!FreeFormButton->Down) {
        ActionType = TNoAction;
        Image1->Cursor = crTargetCursor;
        } else {
        ActionType = TDrawFreeForm;
        Image1->Cursor = crDrawFreeForm;
        }
    preparetosaveundo = false;

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::SelectButtonClick(TObject *Sender)
{
    //starts off selecting items in the window
    TerminateCurrentAction();
    if (!SelectButton->Down) {
        ActionType = TNoAction;
        Image1->Cursor = crTargetCursor;
        } else {
        ActionType = TSelectItem;
        Image1->Cursor = crArrow;
        Image1->PopupMenu = PopupMenu1;
        }
    preparetosaveundo = false;
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::BlockButtonClick(TObject *Sender)
{
    //Select an area for a block
    TerminateCurrentAction();
    if (!BlockButton->Down) {
        ActionType = TNoAction;
        Image1->Cursor = crTargetCursor;
        } else {
        ActionType = TBlockItem;
        Image1->Cursor = crDrawBlock;
        }
    preparetosaveundo = false;
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Copy1Click(TObject *Sender)
{
    //copies the selected entities
    TerminateCurrentAction();
    ActionType = TCopyItem;
    Image1->Cursor = crTargetCursor;
    StatusBar1->Panels->Items[4]->Text = " Pick 'From' point.";
    Timer1->Enabled = true;
    preparetosaveundo = false;
    dragging = false;
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Move1Click(TObject *Sender)
{
    //copies the selected entities
    TerminateCurrentAction();
    ActionType = TMoveItem;
    Image1->Cursor = crTargetCursor;
    StatusBar1->Panels->Items[4]->Text = " Pick 'From' point.";
    Timer1->Enabled = true;
    preparetosaveundo = false;
    dragging = false;

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Rotate1Click(TObject *Sender)
{
    //sets everything up for rotation

    TerminateCurrentAction();
    ActionType = TRotateItem;
    Image1->Cursor = crTargetCursor;
    StatusBar1->Panels->Items[4]->Text = " Pick 'Centre' point.";
    Timer1->Enabled = true;
    preparetosaveundo = false;
    dragging = false;

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Mirror1Click(TObject *Sender)
{
    //mirror objects

    TerminateCurrentAction();
    ActionType = TMirrorItem;
    Image1->Cursor = crTargetCursor;
    StatusBar1->Panels->Items[4]->Text = " Pick One End of Mirror Line.";
    Timer1->Enabled = true;
    preparetosaveundo = false;
    dragging = false;
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::ChangeSize1Click(TObject *Sender)
{
    bool found = false;
    int pointer = 0;
    while (!found && pointer < DisplayList.Length) {
        if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayRectangle) {
            found = true;
            pointer--;
            }
        pointer++;
        }
    found = false;
    int entitypointer = XRefs[DisplayList[pointer].ItemNumber].EntityXRef;
    if (entitypointer > -1 && pointer < RectangleList.Length && RectangleList[entitypointer].ItemNumber == DisplayList[pointer].ItemNumber) found = true;
    if (found) {
        //Change rectangle size
        TerminateCurrentAction();
        ActionType = TChangeRectangleSize;
        Image1->Cursor = crTargetCursor;
        preparetosaveundo = false;
        dragging = true;
        wipedout = true;
        StartPointChart.x = RectangleList[entitypointer].Area.Left;
        StartPointChart.y = RectangleList[entitypointer].Area.Top;
        chartposition SP = FindImage1Position(StartPointChart.x,StartPointChart.y);
        StartPointScreen.x = SP.X;
        StartPointScreen.y = SP.Y;
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::ChangeSize2Click(TObject *Sender)
{
    bool found = false;
    int pointer = 0;
    while (!found && pointer < DisplayList.Length) {
        if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayCircle) {
            found = true;
            pointer--;
            }
        pointer++;
        }
    found = false;
    int entitypointer = XRefs[DisplayList[pointer].ItemNumber].EntityXRef;
    if (entitypointer > -1 && pointer < CircleList.Length && CircleList[entitypointer].ItemNumber == DisplayList[pointer].ItemNumber) found = true;
    if (found) {
        //Change rectangle size
        TerminateCurrentAction();
        ActionType = TChangeCircleSize;
        Image1->Cursor = crTargetCursor;
        preparetosaveundo = false;
        dragging = true;
        wipedout = true;
        StartPointChart.x = CircleList[entitypointer].Area.Left;
        StartPointChart.y = CircleList[entitypointer].Area.Top;
        chartposition SP = FindImage1Position(StartPointChart.x,StartPointChart.y);
        StartPointScreen.x = SP.X;
        StartPointScreen.y = SP.Y;
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Image1DblClick(TObject *Sender)
{
    switch (ActionType) {
        case TEditPolyLine:
        case TDrawPolyLine: {
                            TerminateCurrentAction();
                            }
                            break;
        default:            break;
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Image1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    //does almost all the important things in the image window.
    chartposition Location = FindMousePosition(X,Y);
    if (!Location.outofrange) {
    switch (ActionType) {
            case TEditFreeForm:     {
                                    //find the FreeForm to be edited
                                    bool found = false;
                                    int pointer = 0;
                                    int arraypointer;
                                    while (!found && pointer < DisplayList.Length) {
                                        if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayFreeForm) {
                                            found = true;
                                            pointer--;
                                            }
                                        pointer++;
                                        }
                                    if (found) {
                                        found = false;
                                        arraypointer = XRefs[DisplayList[pointer].ItemNumber].EntityXRef;
                                        if ( arraypointer > -1
                                            && arraypointer < FreeFormList.Length
                                            && FreeFormList[arraypointer].ItemNumber == DisplayList[pointer].ItemNumber
                                            && pointbeingdragged > -1
                                            && pointbeingdragged < FreeFormList[arraypointer].Corners.Length
                                            ) found = true;
                                        }
                                    if (found) {
                                        //There will be a rectangle around each pixel that's a corner and a treble one around the nearest
                                        TRect Rectangle;
                                        chartposition SP;
                                        if (!wipedout) {
                                            //clear annotations
                                            TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                            Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                            Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                            Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                            //rectangles around corners
                                            for (int i = 0; i < FreeFormList[arraypointer].Corners.Length; i++) {
                                                SP = FindImage1Position(FreeFormList[arraypointer].Corners[i].x,FreeFormList[arraypointer].Corners[i].y);
                                                Rectangle.Left = SP.X - 1;
                                                Rectangle.Top = SP.Y - 1;
                                                Rectangle.Right = SP.X + 1 + SquareSize;
                                                Rectangle.Bottom = SP.Y + 1 + SquareSize;
                                                Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                                }
                                            //rectangles around nearest
                                            SP = FindImage1Position(FreeFormList[arraypointer].Corners[pointbeingdragged].x,FreeFormList[arraypointer].Corners[pointbeingdragged].y);
                                            Rectangle.Left = SP.X - 3;
                                            Rectangle.Top = SP.Y - 3;
                                            Rectangle.Right = SP.X + 3 + SquareSize;
                                            Rectangle.Bottom = SP.Y + 3 + SquareSize;
                                            Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                            Rectangle.Left = SP.X - 5;
                                            Rectangle.Top = SP.Y - 5;
                                            Rectangle.Right = SP.X + 5 + SquareSize;
                                            Rectangle.Bottom = SP.Y + 5 + SquareSize;
                                            Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                            Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                            wipedout = true;
                                            }
                                        //now to start drawing the elastic band etc
                                        TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                        Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                        Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                        Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                        //rectangles around corners except one being moved
                                        for (int i = 0; i < FreeFormList[arraypointer].Corners.Length; i++) {
                                            if (i != pointbeingdragged) {
                                                SP = FindImage1Position(FreeFormList[arraypointer].Corners[i].x,FreeFormList[arraypointer].Corners[i].y);
                                                Rectangle.Left = SP.X - 1;
                                                Rectangle.Top = SP.Y - 1;
                                                Rectangle.Right = SP.X + 1 + SquareSize;
                                                Rectangle.Bottom = SP.Y + 1 + SquareSize;
                                                Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                                }
                                            }
                                        //decide on elasticbanding
                                        OldMousePositionScreen.x = X;
                                        OldMousePositionScreen.y = Y;
                                        if (pointbeingdragged == 0) {
                                            StartPointChart.x = Location.X;
                                            StartPointChart.y = Location.Y;
                                            StartPointScreen.x = X;
                                            StartPointScreen.y = Y;
                                            } else {
                                            StartPointChart = FreeFormList[arraypointer].Corners[pointbeingdragged - 1];
                                            SP = FindImage1Position(StartPointChart.x, StartPointChart.y);
                                            StartPointScreen.x = SP.X;
                                            StartPointScreen.y = SP.Y;
                                            }
                                        if (pointbeingdragged == (FreeFormList[arraypointer].Corners.Length - 1)) {
                                            EndPointChart.x = Location.X;
                                            EndPointChart.y = Location.Y;
                                            EndPointScreen.x = X;
                                            EndPointScreen.y = Y;
                                            } else {
                                            EndPointChart = FreeFormList[arraypointer].Corners[pointbeingdragged + 1];
                                            SP = FindImage1Position(EndPointChart.x, EndPointChart.y);
                                            EndPointScreen.x = SP.X;
                                            EndPointScreen.y = SP.Y;
                                            }
                                        Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                        Image1->Picture->Bitmap->Canvas->LineTo(OldMousePositionScreen.x,OldMousePositionScreen.y);
                                        Image1->Picture->Bitmap->Canvas->LineTo(EndPointScreen.x,EndPointScreen.y);
                                        Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                        wipedout = false;
                                        dragging = true;
                                        }//end of 'if (found)'
                                    }  //end of 'case TEditPolyLine:'
                                    break;
            case TDrawFreeForm:     {
                                    if (dragging) {
                                        //have already started the FreeForm, so add to it
                                        if (!wipedout) {
                                            //want a line to the mouse point
                                            TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                            Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                            Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                            Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                            if (LinePoints.Length >= 2) {
                                                Image1->Picture->Bitmap->Canvas->MoveTo(LinePoints[0].x,LinePoints[0].y);
                                                Image1->Picture->Bitmap->Canvas->LineTo(LinePoints[1].x,LinePoints[1].y);
                                                }
                                            if (LinePoints.Length >= 3) {
                                                Image1->Picture->Bitmap->Canvas->LineTo(LinePoints[2].x,LinePoints[2].y);
                                                }
                                            Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                            wipedout = true;
                                            }
                                        int arraypointer = FreeFormList.Length - 1;
                                        //first check to see if it's the start point, as this will close the shape
                                        if (Location.X == FreeFormList[arraypointer].Corners[0].x && Location.Y == FreeFormList[arraypointer].Corners[0].y) {
                                            TerminateCurrentAction();
                                            } else {
                                            //This is at least the second point on the line, so add this point to the last FreeForm in the array and draw the FreeForm
                                            AddUndoTitle("Add point to Free Form Shape (" + AnsiString(FreeFormList[arraypointer].ItemNumber) + ")");
                                            AddUndoChangeFreeForm(FreeFormList[arraypointer].ItemNumber);
                                            AddUndo("ElasticBandStart," + AnsiString(StartPointChart.x) + "," + AnsiString(StartPointChart.y) + ",");
                                            FreeFormList[arraypointer].Corners.Length++;
                                            FreeFormList[arraypointer].Corners[FreeFormList[arraypointer].Corners.Length - 1].x = Location.X;
                                            FreeFormList[arraypointer].Corners[FreeFormList[arraypointer].Corners.Length - 1].y = Location.Y;
                                            FillPointsFreeForm(arraypointer,FreeFormList[arraypointer].ItemNumber);
                                            DisplayListAreaUpdate(FreeFormList[arraypointer].ItemNumber);
                                            //DrawFreeForm(FreeFormList[arraypointer].ItemNumber, Image1->Picture->Bitmap->Canvas);
                                            DrawPicture();
                                            //now to start the elastic banding from the last point again
                                            StartPointChart.x = Location.X;
                                            StartPointChart.y = Location.Y;
                                            chartposition SP = FindImage1Position(Location.X,Location.Y);
                                            StartPointScreen.x = SP.X;
                                            StartPointScreen.y = SP.Y;
                                            OldMousePositionScreen.x = X;
                                            OldMousePositionScreen.y = Y;
                                            chartposition EP = FindImage1Position(FreeFormList[arraypointer].Corners[0].x,FreeFormList[arraypointer].Corners[0].y);
                                            if (OldMousePositionScreen.x == StartPointScreen.x && OldMousePositionScreen.y == StartPointScreen.y && OldMousePositionScreen.x == EP.X && OldMousePositionScreen.y == EP.Y) {
                                                //don't want a line to the mouse point
                                                wipedout = true;
                                                LinePoints.Length = 0;
                                                } else {
                                                //want a line to the mouse point and to close the loop
                                                TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                                Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                                Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                                Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                                LinePoints.Length = 3;
                                                LinePoints[0] = StartPointScreen;
                                                LinePoints[1] = OldMousePositionScreen;
                                                LinePoints[2].x = EP.X;
                                                LinePoints[2].y = EP.Y;
                                                Image1->Picture->Bitmap->Canvas->MoveTo(LinePoints[0].x,LinePoints[0].y);
                                                Image1->Picture->Bitmap->Canvas->LineTo(LinePoints[1].x,LinePoints[1].y);
                                                Image1->Picture->Bitmap->Canvas->LineTo(LinePoints[2].x,LinePoints[2].y);
                                                Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                                wipedout = false;
                                                }
                                            }
                                        } else {
                                        //OK, have not started the FreeForm.
                                        dragging = true;
                                        StartPointChart.x = Location.X;
                                        StartPointChart.y = Location.Y;
                                        chartposition SP = FindImage1Position(Location.X,Location.Y);
                                        StartPointScreen.x = SP.X;
                                        StartPointScreen.y = SP.Y;
                                        OldMousePositionScreen.x = X;
                                        OldMousePositionScreen.y = Y;
                                        if (OldMousePositionScreen.x == StartPointScreen.x && OldMousePositionScreen.y == StartPointScreen.y) {
                                            //don't want a line to the mouse point
                                            wipedout = true;
                                            LinePoints.Length = 0;
                                            } else {
                                            //want a line to the mouse point
                                            TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                            Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                            Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                            Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                            LinePoints.Length = 2;
                                            LinePoints[0] = StartPointScreen;
                                            LinePoints[1] = OldMousePositionScreen;
                                            Image1->Picture->Bitmap->Canvas->MoveTo(LinePoints[0].x,LinePoints[0].y);
                                            Image1->Picture->Bitmap->Canvas->LineTo(LinePoints[1].x,LinePoints[1].y);
                                            Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                            wipedout = false;
                                            }
                                        //Now to add the FreeForm
                                        int displaypointer = DisplayList.Length;
                                        DisplayList.Length++;
                                        DisplayList[displaypointer].ItemNumber = DisplayItemNumber;
                                        DisplayList[displaypointer].DisplayType = TDisplayFreeForm;
                                        DisplayList[displaypointer].Area.Left = Location.X;
                                        DisplayList[displaypointer].Area.Top = Location.Y;
                                        //DisplayList[displaypointer].Area.Right = Location.X + 1;
                                        //DisplayList[displaypointer].Area.Bottom = Location.Y + 1;
                                        DisplayList[displaypointer].Area.Right = Location.X;
                                        DisplayList[displaypointer].Area.Bottom = Location.Y;
                                        DisplayList[displaypointer].selected = false;
                                        DisplayList[displaypointer].visible = true;
                                        int arraypointer = FreeFormList.Length;
                                        FreeFormList.Length++;
                                        if (preparetoblendforeground) {
                                            blendthreads = true;
                                            preparetoblendforeground = false;
                                            }
                                        if (preparetoblendbackground) {
                                            blendthreads = true;
                                            preparetoblendbackground = false;
                                            }
                                        FreeFormList[arraypointer].ItemNumber = DisplayItemNumber;
                                        FreeFormList[arraypointer].PenColour = ForegroundColour;
                                        FreeFormList[arraypointer].BrushColour = BackgroundColour;
                                        FreeFormList[arraypointer].LineWidth = LineWidth;
                                        FreeFormList[arraypointer].closed = true;
                                        FreeFormList[arraypointer].filled = FillShapes;
                                        FreeFormList[arraypointer].Points.Length = 0;
                                        FreeFormList[arraypointer].Corners.Length = 1;
                                        FreeFormList[arraypointer].Corners[0].x = Location.X;
                                        FreeFormList[arraypointer].Corners[0].y = Location.Y;
                                        AddUndoTitle("Add Free Form Shape (" + AnsiString(DisplayItemNumber) + ")");
                                        AddUndo("Delete," + AnsiString(DisplayItemNumber) + ",");
                                        CreateXRefs();
                                        DisplayItemNumber++;
                                        } //end of starting the FreeForm shape
                                    }
                                    break;
            case TPasteBlock:       {
                                    ActionType = TNoAction;
                                    int displaypointer = DisplayList.Length - 1;
                                    if (DisplayList[displaypointer].selected && !DisplayList[displaypointer].visible && DisplayList[displaypointer].DisplayType == TDisplayBlock) {
                                        //have the right block
                                        TRect Rectangle;
                                        Rectangle = FindImage1Position(DisplayList[displaypointer].Area);
                                        TPoint delta;
                                        delta.x = Rectangle.Right - Rectangle.Left;
                                        delta.y = Rectangle.Bottom - Rectangle.Top;
                                        TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                        Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                        Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                        Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                        if (!wipedout) {
                                            Rectangle.Left = OldMousePositionScreen.x;
                                            Rectangle.Top = OldMousePositionScreen.y;
                                            Rectangle.Right = Rectangle.Left + delta.x;
                                            Rectangle.Bottom = Rectangle.Top + delta.y;
                                            Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                            wipedout = true;
                                            }
                                        Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                        //now to make block visible and move it to the current position
                                        delta.x = Location.X;
                                        delta.y = Location.Y;
                                        DisplayList[displaypointer].visible = true;
                                        Undoing = true;
                                        MoveBlock(delta,DisplayList[displaypointer].ItemNumber);
                                        Undoing = false;
                                        if (deselectafteroperation) {
                                            DisplayList[displaypointer].selected = false;
                                            }
                                        DrawPicture();
                                        }
                                    }
                                    break;
            case TEditPolyLine:     {
                                    //find the polyline to be edited
                                    bool found = false;
                                    int pointer = 0;
                                    int arraypointer;
                                    while (!found && pointer < DisplayList.Length) {
                                        if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayPolyLine) {
                                            found = true;
                                            pointer--;
                                            }
                                        pointer++;
                                        }
                                    if (found) {
                                        found = false;
                                        arraypointer = XRefs[DisplayList[pointer].ItemNumber].EntityXRef;
                                        if ( arraypointer > -1
                                            && arraypointer < PolyLineList.Length
                                            && PolyLineList[arraypointer].ItemNumber == DisplayList[pointer].ItemNumber
                                            && pointbeingdragged > -1
                                            && pointbeingdragged < PolyLineList[arraypointer].Corners.Length
                                            ) found = true;
                                        }
                                    if (found) {
                                        //There will be a rectangle around each pixel that's a corner and a treble one around the nearest
                                        TRect Rectangle;
                                        chartposition SP;
                                        if (!wipedout) {
                                            //clear annotations
                                            TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                            Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                            Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                            Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                            //rectangles around corners
                                            for (int i = 0; i < PolyLineList[arraypointer].Corners.Length; i++) {
                                                SP = FindImage1Position(PolyLineList[arraypointer].Corners[i].x,PolyLineList[arraypointer].Corners[i].y);
                                                Rectangle.Left = SP.X - 1;
                                                Rectangle.Top = SP.Y - 1;
                                                Rectangle.Right = SP.X + 1 + SquareSize;
                                                Rectangle.Bottom = SP.Y + 1 + SquareSize;
                                                Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                                }
                                            //rectangles around nearest
                                            SP = FindImage1Position(PolyLineList[arraypointer].Corners[pointbeingdragged].x,PolyLineList[arraypointer].Corners[pointbeingdragged].y);
                                            Rectangle.Left = SP.X - 3;
                                            Rectangle.Top = SP.Y - 3;
                                            Rectangle.Right = SP.X + 3 + SquareSize;
                                            Rectangle.Bottom = SP.Y + 3 + SquareSize;
                                            Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                            Rectangle.Left = SP.X - 5;
                                            Rectangle.Top = SP.Y - 5;
                                            Rectangle.Right = SP.X + 5 + SquareSize;
                                            Rectangle.Bottom = SP.Y + 5 + SquareSize;
                                            Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                            Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                            wipedout = true;
                                            }
                                        //now to start drawing the elastic band etc
                                        TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                        Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                        Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                        Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                        //rectangles around corners except one being moved
                                        for (int i = 0; i < PolyLineList[arraypointer].Corners.Length; i++) {
                                            if (i != pointbeingdragged) {
                                                SP = FindImage1Position(PolyLineList[arraypointer].Corners[i].x,PolyLineList[arraypointer].Corners[i].y);
                                                Rectangle.Left = SP.X - 1;
                                                Rectangle.Top = SP.Y - 1;
                                                Rectangle.Right = SP.X + 1 + SquareSize;
                                                Rectangle.Bottom = SP.Y + 1 + SquareSize;
                                                Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                                }
                                            }
                                        //decide on elasticbanding
                                        OldMousePositionScreen.x = X;
                                        OldMousePositionScreen.y = Y;
                                        if (pointbeingdragged == 0) {
                                            StartPointChart.x = Location.X;
                                            StartPointChart.y = Location.Y;
                                            StartPointScreen.x = X;
                                            StartPointScreen.y = Y;
                                            } else {
                                            StartPointChart = PolyLineList[arraypointer].Corners[pointbeingdragged - 1];
                                            SP = FindImage1Position(StartPointChart.x, StartPointChart.y);
                                            StartPointScreen.x = SP.X;
                                            StartPointScreen.y = SP.Y;
                                            }
                                        if (pointbeingdragged == (PolyLineList[arraypointer].Corners.Length - 1)) {
                                            EndPointChart.x = Location.X;
                                            EndPointChart.y = Location.Y;
                                            EndPointScreen.x = X;
                                            EndPointScreen.y = Y;
                                            } else {
                                            EndPointChart = PolyLineList[arraypointer].Corners[pointbeingdragged + 1];
                                            SP = FindImage1Position(EndPointChart.x, EndPointChart.y);
                                            EndPointScreen.x = SP.X;
                                            EndPointScreen.y = SP.Y;
                                            }
                                        Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                        Image1->Picture->Bitmap->Canvas->LineTo(OldMousePositionScreen.x,OldMousePositionScreen.y);
                                        Image1->Picture->Bitmap->Canvas->LineTo(EndPointScreen.x,EndPointScreen.y);
                                        Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                        wipedout = false;
                                        dragging = true;
                                        }//end of 'if (found)'
                                    }  //end of 'case TEditPolyLine:'
                                    break;
            case TDrawPolyLine:     {
                                    if (dragging) {
                                        //have already started the polyline, so add to it
                                        if (!wipedout) {
                                            //want a line to the mouse point
                                            TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                            Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                            Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                            Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                            Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                            Image1->Picture->Bitmap->Canvas->LineTo(OldMousePositionScreen.x,OldMousePositionScreen.y);
                                            Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                            wipedout = true;
                                            }
                                        //This is at least the second point on the line, so add this point to the last polyline in the array and draw the polyline
                                        int arraypointer = PolyLineList.Length - 1;
                                        AddUndoTitle("Add point to Polyline (" + AnsiString(PolyLineList[arraypointer].ItemNumber) + ")");
                                        AddUndoChangePolyLine(PolyLineList[arraypointer].ItemNumber);
                                        AddUndo("ElasticBandStart," + AnsiString(StartPointChart.x) + "," + AnsiString(StartPointChart.y) + ",");
                                        PolyLineList[arraypointer].Corners.Length++;
                                        PolyLineList[arraypointer].Corners[PolyLineList[arraypointer].Corners.Length - 1].x = Location.X;
                                        PolyLineList[arraypointer].Corners[PolyLineList[arraypointer].Corners.Length - 1].y = Location.Y;
                                        FillPointsPolyLine(arraypointer,PolyLineList[arraypointer].ItemNumber);
                                        DisplayListAreaUpdate(PolyLineList[arraypointer].ItemNumber);
                                        DrawPolyLine(PolyLineList[arraypointer].ItemNumber, Image1->Picture->Bitmap->Canvas);
                                        //now to start the elastic banding from the last point again
                                        StartPointChart.x = Location.X;
                                        StartPointChart.y = Location.Y;
                                        chartposition SP = FindImage1Position(Location.X,Location.Y);
                                        StartPointScreen.x = SP.X;
                                        StartPointScreen.y = SP.Y;
                                        OldMousePositionScreen.x = X;
                                        OldMousePositionScreen.y = Y;
                                        if (OldMousePositionScreen.x == StartPointScreen.x && OldMousePositionScreen.y == StartPointScreen.y) {
                                            //don't want a line to the mouse point
                                            wipedout = true;
                                            } else {
                                            //want a line to the mouse point
                                            TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                            Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                            Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                            Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                            Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                            Image1->Picture->Bitmap->Canvas->LineTo(OldMousePositionScreen.x,OldMousePositionScreen.y);
                                            Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                            wipedout = false;
                                            }
                                        } else {
                                        //OK, have not started the line.
                                        /*LinePoints.Length = 1;
                                        LinePoints[0].x = Location.X;
                                        LinePoints[0].y = Location.Y;*/
                                        dragging = true;
                                        StartPointChart.x = Location.X;
                                        StartPointChart.y = Location.Y;
                                        chartposition SP = FindImage1Position(Location.X,Location.Y);
                                        StartPointScreen.x = SP.X;
                                        StartPointScreen.y = SP.Y;
                                        OldMousePositionScreen.x = X;
                                        OldMousePositionScreen.y = Y;
                                        if (OldMousePositionScreen.x == StartPointScreen.x && OldMousePositionScreen.y == StartPointScreen.y) {
                                            //don't want a line to the mouse point
                                            wipedout = true;
                                            } else {
                                            //want a line to the mouse point
                                            TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                            Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                            Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                            Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                            Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                            Image1->Picture->Bitmap->Canvas->LineTo(OldMousePositionScreen.x,OldMousePositionScreen.y);
                                            Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                            wipedout = false;
                                            }
                                        //Now to add the PolyLine
                                        int displaypointer = DisplayList.Length;
                                        DisplayList.Length++;
                                        DisplayList[displaypointer].ItemNumber = DisplayItemNumber;
                                        DisplayList[displaypointer].DisplayType = TDisplayPolyLine;
                                        DisplayList[displaypointer].Area.Left = Location.X;
                                        DisplayList[displaypointer].Area.Top = Location.Y;
                                        //DisplayList[displaypointer].Area.Right = Location.X + 1;
                                        //DisplayList[displaypointer].Area.Bottom = Location.Y + 1;
                                        DisplayList[displaypointer].Area.Right = Location.X;
                                        DisplayList[displaypointer].Area.Bottom = Location.Y;
                                        DisplayList[displaypointer].selected = false;
                                        DisplayList[displaypointer].visible = true;
                                        int arraypointer = PolyLineList.Length;
                                        PolyLineList.Length++;
                                        TColor Colour;
                                        if (Button == mbLeft || Button == mbMiddle) {
                                            Colour = ForegroundColour;
                                            if (preparetoblendforeground) {
                                                blendthreads = true;
                                                preparetoblendforeground = false;
                                                }
                                            } else {
                                            Colour = BackgroundColour;
                                            if (preparetoblendbackground) {
                                                blendthreads = true;
                                                preparetoblendbackground = false;
                                                }
                                            }
                                        PolyLineList[arraypointer].ItemNumber = DisplayItemNumber;
                                        PolyLineList[arraypointer].PenColour = Colour;
                                        PolyLineList[arraypointer].BrushColour = clBlack;
                                        PolyLineList[arraypointer].LineWidth = LineWidth;
                                        PolyLineList[arraypointer].closed = false;
                                        PolyLineList[arraypointer].filled = false;
                                        PolyLineList[arraypointer].Points.Length = 0;
                                        PolyLineList[arraypointer].Corners.Length = 1;
                                        PolyLineList[arraypointer].Corners[0].x = Location.X;
                                        PolyLineList[arraypointer].Corners[0].y = Location.Y;
                                        AddUndoTitle("Add Polyline (" + AnsiString(DisplayItemNumber) + ")");
                                        AddUndo("Delete," + AnsiString(DisplayItemNumber) + ",");
                                        CreateXRefs();
                                        DisplayItemNumber++;
                                        } //end of starting the poly line
                                    }
                                    break;
            case TChangeCircleSize: {
                            if (dragging && Button == mbLeft) {
                                chartposition SP;
                                if (Shift.Contains(ssShift)) {
                                    //Modify the input so that the line is vertical or horizontal if the 'Shift' key is pressed.
                                    int ref1 = abs(StartPointChart.x - Location.X);
                                    int ref2 = abs(StartPointChart.y - Location.Y);
                                    int ref3 = min(ref1,ref2);
                                    if (Location.X < StartPointChart.x) {
                                        Location.X = StartPointChart.x - ref3;
                                        if (Location.X < 0) Location.X = 0;
                                        } else {
                                        Location.X = StartPointChart.x + ref3;
                                        if (Location.X > (Picture->Width - 1)) Location.X = Picture->Width;
                                        }
                                    if (Location.Y < StartPointChart.y) {
                                        Location.Y = StartPointChart.y - ref3;
                                        if (Location.Y < 0) Location.Y = 0;
                                        } else {
                                        Location.Y = StartPointChart.y + ref3;
                                        if (Location.Y > (Picture->Height - 1)) Location.Y = Picture->Height;
                                        }
                                    //make sure the end displays in the correct place
                                    SP = FindImage1Position(Location.X,Location.Y);
                                    X = SP.X;
                                    Y = SP.Y;
                                    }
                                TRect Rectangle;
                                if (!wipedout) {
                                    //want a rectangle to the mouse point
                                    Rectangle.Left = StartPointScreen.x;
                                    Rectangle.Top = StartPointScreen.y;
                                    Rectangle.Right = OldMousePositionScreen.x;
                                    Rectangle.Bottom = OldMousePositionScreen.y;
                                    int swap;
                                    if (Rectangle.Left > Rectangle.Right) {
                                        swap = Rectangle.Right;
                                        Rectangle.Right = Rectangle.Left;
                                        Rectangle.Left = swap;
                                        }
                                    if (Rectangle.Top > Rectangle.Bottom) {
                                        swap = Rectangle.Bottom;
                                        Rectangle.Bottom = Rectangle.Top;
                                        Rectangle.Top = swap;
                                        }
                                    Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                    TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                    TBrushStyle oldstyle = Image1->Picture->Bitmap->Canvas->Brush->Style;
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                    Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                    Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                    Image1->Picture->Bitmap->Canvas->Brush->Style = bsClear;
                                    Image1->Picture->Bitmap->Canvas->Ellipse(Rectangle.Left,Rectangle.Top,Rectangle.Right,Rectangle.Bottom);
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                    Image1->Picture->Bitmap->Canvas->Brush->Style = oldstyle;
                                    wipedout = true;
                                    }
                                dragging = false;
                                bool found = false;
                                int pointer = 0;
                                while (!found && pointer < DisplayList.Length) {
                                    if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayCircle) {
                                        found = true;
                                        pointer--;
                                        }
                                    pointer++;
                                    }
                                if (found) {
                                    //undo
                                    AddUndoTitle("Change Size of Circle");
                                    int arraypointer = XRefs[DisplayList[pointer].ItemNumber].EntityXRef;
                                    /*
                                    AnsiString text;
                                    text = "Circle,ChangeContents," + AnsiString(CircleList[arraypointer].ItemNumber) + ","
                                                + AnsiString((int)(CircleList[arraypointer].PenColour)) + ","
                                                + AnsiString((int)(CircleList[arraypointer].BrushColour)) + ","
                                                + AnsiString(CircleList[arraypointer].LineWidth) + ","
                                                + AnsiString(CircleList[arraypointer].Area.Left) + ","
                                                + AnsiString(CircleList[arraypointer].Area.Top) + ","
                                                + AnsiString(CircleList[arraypointer].Area.Right) + ","
                                                + AnsiString(CircleList[arraypointer].Area.Bottom) + ","
                                                + AnsiString((int)(CircleList[arraypointer].Shape)) + ","
                                                + AnsiString(CircleList[arraypointer].Angle) + ","
                                                ;
                                    for (int j = 0; j < CircleList[arraypointer].Points.Length; j++) {
                                        text = text + AnsiString(CircleList[arraypointer].Points[j].x) + "," + AnsiString(CircleList[arraypointer].Points[j].y) + ","+ AnsiString((int)(CircleList[arraypointer].Points[j].Colour)) + ",";
                                        }
                                    AddUndo(text);
                                    */
                                    AddUndoChangeCircle(CircleList[arraypointer].ItemNumber);
                                    CircleList[arraypointer].Area.Right = Location.X;
                                    CircleList[arraypointer].Area.Bottom = Location.Y;
                                    FillPointsCircle(arraypointer,CircleList[arraypointer].ItemNumber);
                                    DisplayListAreaUpdate(CircleList[arraypointer].ItemNumber);
                                    if (deselectafteroperation) {
                                        AddUndo("Select," + AnsiString(DisplayList[pointer].ItemNumber) + ",");
                                        DisplayList[pointer].selected = false;
                                        }
                                    DrawPicture();
                                    }
                                }
                            }
                            break;
            case TChangeRectangleSize: {
                            if (dragging && Button == mbLeft) {
                                chartposition SP;
                                if (Shift.Contains(ssShift)) {
                                    //Modify the input so that the line is vertical or horizontal if the 'Shift' key is pressed.
                                    int ref1 = abs(StartPointChart.x - Location.X);
                                    int ref2 = abs(StartPointChart.y - Location.Y);
                                    int ref3 = min(ref1,ref2);
                                    if (Location.X < StartPointChart.x) {
                                        Location.X = StartPointChart.x - ref3;
                                        if (Location.X < 0) Location.X = 0;
                                        } else {
                                        Location.X = StartPointChart.x + ref3;
                                        if (Location.X > (Picture->Width - 1)) Location.X = Picture->Width;
                                        }
                                    if (Location.Y < StartPointChart.y) {
                                        Location.Y = StartPointChart.y - ref3;
                                        if (Location.Y < 0) Location.Y = 0;
                                        } else {
                                        Location.Y = StartPointChart.y + ref3;
                                        if (Location.Y > (Picture->Height - 1)) Location.Y = Picture->Height;
                                        }
                                    //make sure the end displays in the correct place
                                    SP = FindImage1Position(Location.X,Location.Y);
                                    X = SP.X;
                                    Y = SP.Y;
                                    }
                                TRect Rectangle;
                                if (!wipedout) {
                                    //want a rectangle to the mouse point
                                    Rectangle.Left = StartPointScreen.x;
                                    Rectangle.Top = StartPointScreen.y;
                                    Rectangle.Right = OldMousePositionScreen.x;
                                    Rectangle.Bottom = OldMousePositionScreen.y;
                                    int swap;
                                    if (Rectangle.Left > Rectangle.Right) {
                                        swap = Rectangle.Right;
                                        Rectangle.Right = Rectangle.Left;
                                        Rectangle.Left = swap;
                                        }
                                    if (Rectangle.Top > Rectangle.Bottom) {
                                        swap = Rectangle.Bottom;
                                        Rectangle.Bottom = Rectangle.Top;
                                        Rectangle.Top = swap;
                                        }
                                    Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                    wipedout = true;
                                    }
                                dragging = false;
                                bool found = false;
                                int pointer = 0;
                                while (!found && pointer < DisplayList.Length) {
                                    if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayRectangle) {
                                        found = true;
                                        pointer--;
                                        }
                                    pointer++;
                                    }
                                if (found) {
                                    //undo
                                    AddUndoTitle("Change Size of Rectangle");
                                    int arraypointer = XRefs[DisplayList[pointer].ItemNumber].EntityXRef;
                                    /*
                                    AnsiString text;
                                    text = "Rectangle,ChangeContents," + AnsiString(RectangleList[arraypointer].ItemNumber) + ","
                                                + AnsiString((int)(RectangleList[arraypointer].PenColour)) + ","
                                                + AnsiString((int)(RectangleList[arraypointer].BrushColour)) + ","
                                                + AnsiString(RectangleList[arraypointer].LineWidth) + ","
                                                + AnsiString(RectangleList[arraypointer].Area.Left) + ","
                                                + AnsiString(RectangleList[arraypointer].Area.Top) + ","
                                                + AnsiString(RectangleList[arraypointer].Area.Right) + ","
                                                + AnsiString(RectangleList[arraypointer].Area.Bottom) + ","
                                                + AnsiString((int)(RectangleList[arraypointer].Shape)) + ","
                                                + AnsiString(RectangleList[arraypointer].Angle) + ","
                                                + AnsiString((int)(RectangleList[arraypointer].Filled)) + ","
                                                ;
                                    for (int j = 0; j < RectangleList[arraypointer].Points.Length; j++) {
                                        text = text + AnsiString(RectangleList[arraypointer].Points[j].x) + "," + AnsiString(RectangleList[arraypointer].Points[j].y) + ","+ AnsiString((int)(RectangleList[arraypointer].Points[j].Colour)) + ",";
                                        }
                                    AddUndo(text);
                                    */
                                    AddUndoChangeRectangle(RectangleList[arraypointer].ItemNumber);
                                    RectangleList[arraypointer].Area.Right = Location.X;
                                    RectangleList[arraypointer].Area.Bottom = Location.Y;
                                    FillPointsRectangle(arraypointer,RectangleList[arraypointer].ItemNumber);
                                    DisplayListAreaUpdate(RectangleList[arraypointer].ItemNumber);
                                    if (deselectafteroperation) {
                                        AddUndo("Select," + AnsiString(DisplayList[pointer].ItemNumber) + ",");
                                        DisplayList[pointer].selected = false;
                                        }
                                    DrawPicture();
                                    }
                                }
                            }
                            break;
            case TBlockArray:   {
                            //displays the linear array of blocks being considered
                            //first find block item being copied.
                            bool found = false;
                            int pointer = 0;
                            while (!found && pointer < DisplayList.Length) {
                                if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayBlock) {
                                    found = true;
                                    pointer--;
                                    }
                                pointer++;
                                }
                            if (found) {
                                TPoint delta;
                                TRect Rectangle;
                                int swap;
                                if (!wipedout) {
                                    //want a line to the mouse point and a rectangle offset at each selected object
                                    TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                    Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                    Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                    Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                    Image1->Picture->Bitmap->Canvas->LineTo(OldMousePositionScreen.x,OldMousePositionScreen.y);
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                    if (LinearArray.x > 1) {
                                        delta.x = (OldMousePositionScreen.x - StartPointScreen.x)/(LinearArray.x - 1);
                                        } else {
                                        delta.x = 0;
                                        }
                                    if (LinearArray.y > 1) {
                                        delta.y = (OldMousePositionScreen.y - StartPointScreen.y)/(LinearArray.y - 1);
                                        } else {
                                        delta.y = 0;
                                        }
                                    for (int i = 0; i < LinearArray.x; i++) {
                                        for (int j = 0; j < LinearArray.y; j++) {
                                            Rectangle = FindImage1Position(DisplayList[pointer].Area);
                                            Rectangle.Left += delta.x * i;
                                            Rectangle.Top += delta.y * j;
                                            Rectangle.Right += delta.x * i;
                                            Rectangle.Bottom += delta.y * j;
                                            if (Rectangle.Left > Rectangle.Right) {
                                                swap = Rectangle.Right;
                                                Rectangle.Right = Rectangle.Left;
                                                Rectangle.Left = swap;
                                                }
                                            if (Rectangle.Top > Rectangle.Bottom) {
                                                swap = Rectangle.Bottom;
                                                Rectangle.Bottom = Rectangle.Top;
                                                Rectangle.Top = swap;
                                                }
                                            Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                            }
                                        }
                                    wipedout = true;
                                    }
                                OldMousePositionScreen.x = X;
                                OldMousePositionScreen.y = Y;
                                if (LinearArray.x > 1) {
                                    delta.x = (Location.X - StartPointChart.x)/(LinearArray.x - 1);
                                    } else {
                                    delta.x = 0;
                                    }
                                if (LinearArray.y > 1) {
                                    delta.y = (Location.Y - StartPointChart.y)/(LinearArray.y - 1);
                                    } else {
                                    delta.y = 0;
                                    }
                                TPoint delta2;
                                AddUndoTitle("Linear Array of Block " + AnsiString(DisplayList[pointer].ItemNumber));
                                SingleUndo = false;
                                for (int i = 0; i < LinearArray.x; i++) {
                                    for (int j = 0; j < LinearArray.y; j++) {
                                        if (i != 0 || j != 0) {
                                            delta2.x = delta.x * i;
                                            delta2.y = delta.y * j;
                                            DisplayList.Length++;
                                            DisplayList[DisplayList.Length - 1] = CopyBlock(delta2,DisplayList[pointer].ItemNumber);
                                            DisplayListAreaUpdate(DisplayList[DisplayList.Length - 1].ItemNumber);
                                            }
                                        }
                                    }
                                SingleUndo = true;
                                if (deselectafteroperation) {
                                    DisplayList[pointer].selected = false;
                                    AddUndo("Select," + AnsiString(DisplayList[pointer].ItemNumber) + ",");
                                    }
                                dragging = false;
                                Image1->Cursor = crTargetCursor;
                                ActionType = TNoAction;
                                CreateXRefs();
                                DrawPicture();
                                }
                            }
                            break;
        case TEditErasePoints:  {
                            //Editing erase points
                            //first find erase being edited.
                            bool found = false;
                            int pointer = 0;
                            while (!found && pointer < DisplayList.Length) {
                                if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayEraseItem) {
                                    found = true;
                                    pointer--;
                                    }
                                pointer++;
                                }
                            int entitypointer;
                            if (found) {
                                found = false;
                                entitypointer = XRefs[DisplayList[pointer].ItemNumber].EntityXRef;
                                if (entitypointer > -1 && entitypointer < EraseList.Length && EraseList[entitypointer].ItemNumber == DisplayList[pointer].ItemNumber) found = true;
                                }
                            if (found) {
                                //now know which one is being edited
                                //find if Location is in the list of drawn pixels
                                found = false;
                                pointer = 0;
                                while (!found && pointer < EraseList[entitypointer].Points.Length) {
                                    if (Location.X == EraseList[entitypointer].Points[pointer].x && Location.Y == EraseList[entitypointer].Points[pointer].y) found = true;
                                    pointer++;
                                    }
                                if (Button == mbLeft || Button == mbMiddle ) {
                                    //adding pixel
                                    if (!found) {
                                        EraseList[entitypointer].Points.Length++;
                                        EraseList[entitypointer].Points[pointer].x = Location.X;
                                        EraseList[entitypointer].Points[pointer].y = Location.Y;
                                        EraseList[entitypointer].Points[pointer].Colour = Picture->Canvas->Pixels[Location.X][Location.Y];
                                        }
                                    } else {
                                    //deleting pixel
                                    if (found) {
                                        for (int i = pointer; i < EraseList[entitypointer].Points.Length; i++) {
                                            EraseList[entitypointer].Points[i-1] = EraseList[entitypointer].Points[i];
                                            }
                                        EraseList[entitypointer].Points.Length--;
                                        }
                                    }
                                DrawPicture();
                                }
                            }
                            break;
        case TEditLineEnd:
        case TEditLineStart:    {
                            //first find block being edited.
                            bool found = false;
                            int pointer = 0;
                            while (!found && pointer < DisplayList.Length) {
                                if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayLine) {
                                    found = true;
                                    pointer--;
                                    }
                                pointer++;
                                }
                            int entitypointer;
                            if (found) {
                                found = false;
                                entitypointer = XRefs[DisplayList[pointer].ItemNumber].EntityXRef;
                                if (entitypointer > -1 && entitypointer < LineList.Length && LineList[entitypointer].ItemNumber == DisplayList[pointer].ItemNumber) found = true;
                                }
                            if (found) {
                                //undo
                                AddUndoTitle("Edit Line");
                                AnsiString text;
                                text = "Line,ChangeContents," + AnsiString(LineList[entitypointer].ItemNumber) + ","
                                                    + AnsiString((int)(LineList[entitypointer].Colour)) + ","
                                                    + AnsiString(LineList[entitypointer].LineWidth) + ","
                                                    + AnsiString(LineList[entitypointer].StartPoint.x) + ","
                                                    + AnsiString(LineList[entitypointer].StartPoint.y) + ","
                                                    + AnsiString(LineList[entitypointer].EndPoint.x) + ","
                                                    + AnsiString(LineList[entitypointer].EndPoint.y) + ","
                                                    ;
                                for (int j = 0; j < LineList[entitypointer].Points.Length; j++) {
                                    text = text + AnsiString(LineList[entitypointer].Points[j].x) + "," + AnsiString(LineList[entitypointer].Points[j].y) + "," + AnsiString((int)(LineList[entitypointer].Points[j].Colour)) + ",";
                                    }
                                AddUndo(text);
                                //now know which one is being edited
                                switch (ActionType) {
                                    case TEditLineStart:    {
                                                            LineList[entitypointer].StartPoint.x = Location.X;
                                                            LineList[entitypointer].StartPoint.y = Location.Y;
                                                            }
                                                            break;
                                    case TEditLineEnd:     {
                                                            LineList[entitypointer].EndPoint.x = Location.X;
                                                            LineList[entitypointer].EndPoint.y = Location.Y;
                                                            }
                                                            break;
                                    default:                break;
                                    }
                                FillPointsLine(entitypointer,LineList[entitypointer].ItemNumber);
                                DisplayListAreaUpdate(LineList[entitypointer].ItemNumber);
                                if (deselectafteroperation) {
                                    AddUndo("Select," + AnsiString(LineList[entitypointer].ItemNumber) + ",");
                                    DisplayList[pointer].selected = false;
                                    }
                                TerminateCurrentAction();
                                ResetActionButtons();
                                DrawPicture();
                                }
                            }
                            break;
        case TEditBlockPoints:  {
                            //Editing points
                            //first find block being edited.
                            bool found = false;
                            int pointer = 0;
                            while (!found && pointer < DisplayList.Length) {
                                if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayBlock) {
                                    found = true;
                                    pointer--;
                                    }
                                pointer++;
                                }
                            int entitypointer;
                            if (found) {
                                found = false;
                                entitypointer = XRefs[DisplayList[pointer].ItemNumber].EntityXRef;
                                if (entitypointer > -1 && entitypointer < BlockList.Length && BlockList[entitypointer].ItemNumber == DisplayList[pointer].ItemNumber) found = true;
                                }
                            if (found) {
                                //now know which one is being edited
                                //find if Location is in the list of drawn pixels
                                found = false;
                                pointer = 0;
                                while (!found && pointer < BlockList[entitypointer].Points.Length) {
                                    //if (Location.X == BlockList[entitypointer].Points[pointer].x && Location.Y == BlockList[entitypointer].Points[pointer].y) found = true;
                                    if (Location.X == BlockList[entitypointer].Points[pointer].originalx && Location.Y == BlockList[entitypointer].Points[pointer].originaly) found = true;
                                    pointer++;
                                    }
                                if (Button == mbLeft || Button == mbMiddle ) {
                                    //adding pixel to block list
                                    if (!found) {
                                        BlockList[entitypointer].Points.Length++;
                                        BlockList[entitypointer].Points[pointer].originalx = Location.X;
                                        BlockList[entitypointer].Points[pointer].originaly = Location.Y;
                                        BlockList[entitypointer].Points[pointer].Colour = ForegroundColour;
                                        BlockList[entitypointer].Points[pointer].transparent = false;
                                        FillPointsBlock(entitypointer,BlockList[entitypointer].ItemNumber);
                                        } else {
                                        pointer--;
                                        BlockList[entitypointer].Points[pointer].Colour = ForegroundColour;
                                        BlockList[entitypointer].Points[pointer].transparent = false;
                                        }
                                    } else {
                                    //deleting pixel from block list
                                    if (found) {
                                        for (int i = pointer; i < BlockList[entitypointer].Points.Length; i++) {
                                            BlockList[entitypointer].Points[i-1] = BlockList[entitypointer].Points[i];
                                            }
                                        BlockList[entitypointer].Points.Length--;
                                        }
                                    }
                                DrawPicture();
                                }
                            }
                            break;
        case TEditPointPoints:  {
                            //Editing points
                            //first find point being edited.
                            bool found = false;
                            int pointer = 0;
                            while (!found && pointer < DisplayList.Length) {
                                if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayPoint) {
                                    found = true;
                                    pointer--;
                                    }
                                pointer++;
                                }
                            int entitypointer;
                            if (found) {
                                found = false;
                                entitypointer = XRefs[DisplayList[pointer].ItemNumber].EntityXRef;
                                if (entitypointer > -1 && entitypointer < PointList.Length && PointList[entitypointer].ItemNumber == DisplayList[pointer].ItemNumber) found = true;
                                }
                            if (found) {
                                //now know which one is being edited
                                //find if Location is in the list of drawn pixels
                                found = false;
                                pointer = 0;
                                while (!found && pointer < PointList[entitypointer].Points.Length) {
                                    if (Location.X == PointList[entitypointer].Points[pointer].x && Location.Y == PointList[entitypointer].Points[pointer].y) found = true;
                                    pointer++;
                                    }
                                if (Button == mbLeft || Button == mbMiddle ) {
                                    //adding point
                                    if (!found) {
                                        PointList[entitypointer].Points.Length++;
                                        PointList[entitypointer].Points[pointer].x = Location.X;
                                        PointList[entitypointer].Points[pointer].y = Location.Y;
                                        }
                                    } else {
                                    //deleting point
                                    if (found) {
                                        for (int i = pointer; i < PointList[entitypointer].Points.Length; i++) {
                                            PointList[entitypointer].Points[i-1] = PointList[entitypointer].Points[i];
                                            }
                                        PointList[entitypointer].Points.Length--;
                                        }
                                    }
                                DrawPicture();
                                }
                            }
                            break;
        case TPickFreeFormColour:
        case TPickPolyLineColour:
        case TPickLineColour:
        case TPickRectangleColour:
        case TPickCircleColour:
        case TPickPointColour:
        case TPickTextColour:
        case TPickFloodFillColour: {
                            TColor Colour;
                            //Colour = Image1->Picture->Bitmap->Canvas->Pixels[X][Y];
                            //The Image1 can have strange stuff drawn on it, so create a clean bitmap
                            Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
                            Bitmap->Width = Picture->Width;
                            Bitmap->Height = Picture->Height;
                            Bitmap->Assign(Picture);
                            int oldsquare = SquareSize;
                            SquareSize = 1;
                            TPoint OldTopLeft = TopLeft;
                            TopLeft.x = 0;
                            TopLeft.y = 0;
                            DrawVectors(Bitmap->Canvas);
                            SquareSize = oldsquare;
                            TopLeft = OldTopLeft;
                            Colour = Bitmap->Canvas->Pixels[Location.X][Location.Y];
                            delete Bitmap;
                            switch (ActionType) {
                                case TPickPointColour:      {
                                                            AddUndoTitle("Change Selected Point Colour");
                                                            SingleUndo = false;
                                                            for (int i = 0; i < DisplayList.Length; i++) {
                                                                if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayPoint) {
                                                                    ChangePointColour(DisplayList[i].ItemNumber,Colour);
                                                                    if (deselectafteroperation) {
                                                                        AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                                                                        DisplayList[i].selected = false;
                                                                        }
                                                                    }
                                                                }
                                                            SingleUndo = true;
                                                            DrawPicture();
                                                            }
                                                            break;
                                case TPickLineColour:       {
                                                            AddUndoTitle("Change Selected Line Colour");
                                                            SingleUndo = false;
                                                            for (int i = 0; i < DisplayList.Length; i++) {
                                                                if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayLine) {
                                                                    ChangeLineColour(DisplayList[i].ItemNumber,Colour);
                                                                    if (deselectafteroperation) {
                                                                        AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                                                                        DisplayList[i].selected = false;
                                                                        }
                                                                    }
                                                                }
                                                            SingleUndo = true;
                                                            DrawPicture();
                                                            }
                                                            break;
                                case TPickPolyLineColour:   {
                                                            AddUndoTitle("Change Selected Polyline Colour");
                                                            SingleUndo = false;
                                                            for (int i = 0; i < DisplayList.Length; i++) {
                                                                if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayPolyLine) {
                                                                    ChangePolyLineColour(DisplayList[i].ItemNumber,Colour);
                                                                    if (deselectafteroperation) {
                                                                        AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                                                                        DisplayList[i].selected = false;
                                                                        }
                                                                    }
                                                                }
                                                            SingleUndo = true;
                                                            DrawPicture();
                                                            }
                                                            break;
                                case TPickFloodFillColour:  {
                                                            ChangeFloodFillColour(Colour);
                                                            }
                                                            break;
                                case TPickTextColour:       {
                                                            AddUndoTitle("Change Selected Text Colour");
                                                            SingleUndo = false;
                                                            for (int i = 0; i < DisplayList.Length; i++) {
                                                                if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayText) {
                                                                    ChangeTextColour(DisplayList[i].ItemNumber,Colour);
                                                                    if (deselectafteroperation) {
                                                                        AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                                                                        DisplayList[i].selected = false;
                                                                        }
                                                                    }
                                                                }
                                                            SingleUndo = true;
                                                            DrawPicture();
                                                            }
                                                            break;
                                case TPickRectangleColour:  {
                                                            AddUndoTitle("Change Selected Rectangle Colour");
                                                            SingleUndo = false;
                                                            for (int i = 0; i < DisplayList.Length; i++) {
                                                                if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayRectangle && XRefs[DisplayList[i].ItemNumber].ItemNumber == DisplayList[i].ItemNumber && XRefs[DisplayList[i].ItemNumber].EntityXRef > -1 && XRefs[DisplayList[i].ItemNumber].EntityXRef < RectangleList.Length && DisplayList[i].ItemNumber == RectangleList[XRefs[DisplayList[i].ItemNumber].EntityXRef].ItemNumber) {
                                                                    if (Button == mbLeft || Button == mbMiddle) {
                                                                        ChangeRectangleColour(DisplayList[i].ItemNumber,Colour,RectangleList[XRefs[DisplayList[i].ItemNumber].EntityXRef].BrushColour);
                                                                        } else {
                                                                        ChangeRectangleColour(DisplayList[i].ItemNumber,RectangleList[XRefs[DisplayList[i].ItemNumber].EntityXRef].PenColour,Colour);
                                                                        }
                                                                    if (deselectafteroperation) {
                                                                        AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                                                                        DisplayList[i].selected = false;
                                                                        }
                                                                    }
                                                                }
                                                            SingleUndo = true;
                                                            DrawPicture();
                                                            }
                                                            break;
                                case TPickCircleColour:  {
                                                            AddUndoTitle("Change Selected Circle Colour");
                                                            SingleUndo = false;
                                                            for (int i = 0; i < DisplayList.Length; i++) {
                                                                if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayCircle && XRefs[DisplayList[i].ItemNumber].ItemNumber == DisplayList[i].ItemNumber && XRefs[DisplayList[i].ItemNumber].EntityXRef > -1 && XRefs[DisplayList[i].ItemNumber].EntityXRef < CircleList.Length && DisplayList[i].ItemNumber == CircleList[XRefs[DisplayList[i].ItemNumber].EntityXRef].ItemNumber) {
                                                                    if (Button == mbLeft || Button == mbMiddle) {
                                                                        ChangeCircleColour(DisplayList[i].ItemNumber,Colour,CircleList[XRefs[DisplayList[i].ItemNumber].EntityXRef].BrushColour);
                                                                        } else {
                                                                        ChangeCircleColour(DisplayList[i].ItemNumber,CircleList[XRefs[DisplayList[i].ItemNumber].EntityXRef].PenColour,Colour);
                                                                        }
                                                                    if (deselectafteroperation) {
                                                                        AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                                                                        DisplayList[i].selected = false;
                                                                        }
                                                                    }
                                                                }
                                                            SingleUndo = true;
                                                            DrawPicture();
                                                            }
                                                            break;
                                case TPickFreeFormColour:   {
                                                            AddUndoTitle("Change Selected Free-Form Shape Colour");
                                                            SingleUndo = false;
                                                            for (int i = 0; i < DisplayList.Length; i++) {
                                                                if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayFreeForm) {
                                                                    if (Button == mbLeft || Button == mbMiddle) {
                                                                        ChangeFreeFormColour(DisplayList[i].ItemNumber,Colour,FreeFormList[XRefs[DisplayList[i].ItemNumber].EntityXRef].BrushColour);
                                                                        } else {
                                                                        ChangeFreeFormColour(DisplayList[i].ItemNumber,FreeFormList[XRefs[DisplayList[i].ItemNumber].EntityXRef].PenColour,Colour);
                                                                        }
                                                                    if (deselectafteroperation) {
                                                                        AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                                                                        DisplayList[i].selected = false;
                                                                        }
                                                                    }
                                                                }
                                                            SingleUndo = true;
                                                            DrawPicture();
                                                            }
                                                            break;
                                default:                    break;
                                }
                            ActionType = TNoAction;
                            Image1->Cursor = crTargetCursor;
                            }
                            break;
        case TMirrorItem:     {
                            if (Button == mbLeft) {
                                StatusBar1->Panels->Items[4]->Text = " Pick End Point of Mirror Line.";
                                Timer1->Enabled = true;
                                OldMousePositionScreen.x = X;
                                OldMousePositionScreen.y = Y;
                                StartPointChart.x = Location.X;
                                StartPointChart.y = Location.Y;
                                chartposition SP = FindImage1Position(Location.X,Location.Y);
                                StartPointScreen.x = SP.X;
                                StartPointScreen.y = SP.Y;
                                if (OldMousePositionScreen.x == StartPointScreen.x && OldMousePositionScreen.y == StartPointScreen.y) {
                                    //don't want anything to the mouse point
                                    wipedout = true;
                                    } else {
                                    //want a vertical or horizontal line to the mouse point and a mirrored rectangle for each selected object
                                    int v1 = abs(OldMousePositionScreen.x - StartPointScreen.x);
                                    int v2 = abs(OldMousePositionScreen.y - StartPointScreen.y);
                                    TMirrorAxis Axis = TMAHorizontal;
                                    if (v2 > v1) Axis = TMAVertical;
                                    TPoint delta;
                                    delta.x = 0;
                                    delta.y = 0;
                                    if (Axis == TMAHorizontal) {
                                        delta.x = OldMousePositionScreen.x - StartPointScreen.x;
                                        } else {
                                        delta.y = OldMousePositionScreen.y - StartPointScreen.y;
                                        }
                                    TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                    Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                    Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                    Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                    Image1->Picture->Bitmap->Canvas->LineTo(StartPointScreen.x + delta.x,StartPointScreen.y + delta.y);
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                    TRect Rectangle;
                                    int swap;
                                    for (int i = 0; i < DisplayList.Length; i++) {
                                        if (DisplayList[i].selected && DisplayList[i].visible) {
                                            Rectangle = FindImage1Position(DisplayList[i].Area);
                                            Rectangle = MirrorRectanglePoints(Rectangle,StartPointScreen,Axis);
                                            if (Rectangle.Left > Rectangle.Right) {
                                                swap = Rectangle.Right;
                                                Rectangle.Right = Rectangle.Left;
                                                Rectangle.Left = swap;
                                                }
                                            if (Rectangle.Top > Rectangle.Bottom) {
                                                swap = Rectangle.Bottom;
                                                Rectangle.Bottom = Rectangle.Top;
                                                Rectangle.Top = swap;
                                                }
                                            Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                            }
                                        }
                                    wipedout = false;
                                    }
                                dragging = true;
                                }
                            }
                            break;
        case TRotateItem:   {
                            if (Button == mbLeft) {
                                StatusBar1->Panels->Items[4]->Text = " Pick point that defines angle.";
                                Timer1->Enabled = true;
                                OldMousePositionScreen.x = X;
                                OldMousePositionScreen.y = Y;
                                StartPointChart.x = Location.X;
                                StartPointChart.y = Location.Y;
                                chartposition SP = FindImage1Position(Location.X,Location.Y);
                                StartPointScreen.x = SP.X;
                                StartPointScreen.y = SP.Y;
                                if (OldMousePositionScreen.x == StartPointScreen.x && OldMousePositionScreen.y == StartPointScreen.y) {
                                    //don't want anything to the mouse point
                                    wipedout = true;
                                    OldAngle = 0.0;
                                    //debug
                                    Memo1->Lines->Add("Mouse Down: No Draw");
                                    //end debug
                                    } else {
                                    //want a line to the mouse point and a rectangle rotated for each selected object
                                    TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                    Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                    Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                    Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                    Image1->Picture->Bitmap->Canvas->LineTo(OldMousePositionScreen.x,OldMousePositionScreen.y);
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                    //find angle of mousepoint relative to centre
                                    TPoint delta;
                                    delta.x = OldMousePositionScreen.x - StartPointScreen.x;
                                    delta.y = OldMousePositionScreen.y - StartPointScreen.y;
                                    double angle = ExtractAngle(delta);
                                    OldAngle = angle;
                                    //debug
                                    //Memo1->Lines->Add("Mouse Down: Draw, Angle = " + AnsiString(angle));
                                    //end debug
                                    //draw rotated rectangles
                                    TPoint Points[4];
                                    TRect Rectangle;
                                    TPoint temp;
                                    for (int i = 0; i < DisplayList.Length; i++) {
                                        if (DisplayList[i].selected) {
                                            Rectangle = FindImage1Position(DisplayList[i].Area);
                                            temp.x = Rectangle.Left;
                                            temp.y = Rectangle.Top;
                                            Points[0] = RotateTPoint(temp,StartPointScreen,angle);
                                            temp.y = Rectangle.Bottom;
                                            Points[1] = RotateTPoint(temp,StartPointScreen,angle);
                                            temp.x = Rectangle.Right;
                                            Points[2] = RotateTPoint(temp,StartPointScreen,angle);
                                            temp.y = Rectangle.Top;
                                            Points[3] = RotateTPoint(temp,StartPointScreen,angle);
                                            Image1->Picture->Bitmap->Canvas->MoveTo(Points[0].x,Points[0].y);
                                            Image1->Picture->Bitmap->Canvas->LineTo(Points[1].x,Points[1].y);
                                            Image1->Picture->Bitmap->Canvas->LineTo(Points[2].x,Points[2].y);
                                            Image1->Picture->Bitmap->Canvas->LineTo(Points[3].x,Points[3].y);
                                            Image1->Picture->Bitmap->Canvas->LineTo(Points[0].x,Points[0].y);
                                            }
                                        }
                                    wipedout = false;
                                    }
                                dragging = true;
                                }
                            }
                            break;
        case TMoveItem:
        case TCopyItem:     {
                            if (Button == mbLeft) {
                                StatusBar1->Panels->Items[4]->Text = " Pick 'To' point.";
                                Timer1->Enabled = true;
                                OldMousePositionScreen.x = X;
                                OldMousePositionScreen.y = Y;
                                StartPointChart.x = Location.X;
                                StartPointChart.y = Location.Y;
                                chartposition SP = FindImage1Position(Location.X,Location.Y);
                                StartPointScreen.x = SP.X;
                                StartPointScreen.y = SP.Y;
                                if (OldMousePositionScreen.x == StartPointScreen.x && OldMousePositionScreen.y == StartPointScreen.y) {
                                    //don't want anything to the mouse point
                                    wipedout = true;
                                    } else {
                                    //want a line to the mouse point and a rectangle offset at each selected object
                                    TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                    Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                    Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                    Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                    Image1->Picture->Bitmap->Canvas->LineTo(OldMousePositionScreen.x,OldMousePositionScreen.y);
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                    //less things to bother with if just drawing a line rather than a rectangle & make it clear etc
                                    TPoint delta;
                                    delta.x = OldMousePositionScreen.x - StartPointScreen.x;
                                    delta.y = OldMousePositionScreen.y - StartPointScreen.y;
                                    TRect Rectangle;
                                    int swap;
                                    for (int i = 0; i < DisplayList.Length; i++) {
                                        if (DisplayList[i].selected) {
                                            Rectangle = FindImage1Position(DisplayList[i].Area);
                                            Rectangle.Left += delta.x;
                                            Rectangle.Top += delta.y;
                                            Rectangle.Right += delta.x;
                                            Rectangle.Bottom += delta.y;
                                            if (Rectangle.Left > Rectangle.Right) {
                                                swap = Rectangle.Right;
                                                Rectangle.Right = Rectangle.Left;
                                                Rectangle.Left = swap;
                                                }
                                            if (Rectangle.Top > Rectangle.Bottom) {
                                                swap = Rectangle.Bottom;
                                                Rectangle.Bottom = Rectangle.Top;
                                                Rectangle.Top = swap;
                                                }
                                            Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                            }
                                        }
                                    wipedout = false;
                                    }
                                dragging = true;
                                }
                            }
                            break;
        case TSelectItem:   {
                            if (Button == mbLeft) {
                                OldMousePositionScreen.x = X;
                                OldMousePositionScreen.y = Y;
                                StartPointChart.x = Location.X;
                                StartPointChart.y = Location.Y;
                                chartposition SP = FindImage1Position(Location.X,Location.Y);
                                StartPointScreen.x = SP.X;
                                StartPointScreen.y = SP.Y;
                                if (OldMousePositionScreen.x == StartPointScreen.x && OldMousePositionScreen.y == StartPointScreen.y) {
                                    //don't want a rectangle to the mouse point
                                    wipedout = true;
                                    } else {
                                    //want a rectangle to the mouse point
                                    //less things to bother with if just drawing a line rather than a rectangle & make it clear etc
                                    TRect Rectangle;
                                    Rectangle.Left = StartPointScreen.x;
                                    Rectangle.Top = StartPointScreen.y;
                                    Rectangle.Right = OldMousePositionScreen.x;
                                    Rectangle.Bottom = OldMousePositionScreen.y;
                                    int swap;
                                    if (Rectangle.Left > Rectangle.Right) {
                                        swap = Rectangle.Right;
                                        Rectangle.Right = Rectangle.Left;
                                        Rectangle.Left = swap;
                                        }
                                    if (Rectangle.Top > Rectangle.Bottom) {
                                        swap = Rectangle.Bottom;
                                        Rectangle.Bottom = Rectangle.Top;
                                        Rectangle.Top = swap;
                                        }
                                    Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                    wipedout = false;
                                    }
                                dragging = true;
                                }
                            }
                            break;
        case TBlockItem:
        case TDrawCircle:
        case TDrawRectangle:     {
                            //set up line drawing as before
                            OldMousePositionScreen.x = X;
                            OldMousePositionScreen.y = Y;
                            StartPointChart.x = Location.X;
                            StartPointChart.y = Location.Y;
                            chartposition SP = FindImage1Position(Location.X,Location.Y);
                            StartPointScreen.x = SP.X;
                            StartPointScreen.y = SP.Y;
                            if (OldMousePositionScreen.x == StartPointScreen.x && OldMousePositionScreen.y == StartPointScreen.y) {
                                //don't want a line to the mouse point
                                wipedout = true;
                                } else {
                                //want a rectangle to the mouse point
                                //less things to bother with if just drawing a line rather than a rectangle & make it clear etc
                                TRect Rectangle;
                                Rectangle.Left = StartPointScreen.x;
                                Rectangle.Top = StartPointScreen.y;
                                Rectangle.Right = OldMousePositionScreen.x;
                                Rectangle.Bottom = OldMousePositionScreen.y;
                                int swap;
                                if (Rectangle.Left > Rectangle.Right) {
                                    swap = Rectangle.Right;
                                    Rectangle.Right = Rectangle.Left;
                                    Rectangle.Left = swap;
                                    }
                                if (Rectangle.Top > Rectangle.Bottom) {
                                    swap = Rectangle.Bottom;
                                    Rectangle.Bottom = Rectangle.Top;
                                    Rectangle.Top = swap;
                                    }
                                Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                if (ActionType == TDrawCircle) {
                                    TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                    TBrushStyle oldstyle = Image1->Picture->Bitmap->Canvas->Brush->Style;
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                    Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                    Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                    Image1->Picture->Bitmap->Canvas->Brush->Style = bsClear;
                                    Image1->Picture->Bitmap->Canvas->Ellipse(Rectangle.Left,Rectangle.Top,Rectangle.Right,Rectangle.Bottom);
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                    Image1->Picture->Bitmap->Canvas->Brush->Style = oldstyle;
                                    }
                                wipedout = false;
                                }
                            dragging = true;
                            }
                            break;
        case TEraseItem:    {
                            //add a pixel edit to the list of things to be done.
                            TColor Colour;
                            Colour = Picture->Canvas->Pixels[Location.X][Location.Y];
                            if (preparetosaveundo || !DisplayList.Length || DisplayList[DisplayList.Length - 1].DisplayType != TDisplayEraseItem) {
                                DisplayList.Length++;
                                DisplayList[DisplayList.Length - 1].ItemNumber = DisplayItemNumber;
                                DisplayList[DisplayList.Length - 1].DisplayType = TDisplayEraseItem;
                                DisplayList[DisplayList.Length - 1].Area.left = Location.X;
                                DisplayList[DisplayList.Length - 1].Area.right = Location.X;
                                DisplayList[DisplayList.Length - 1].Area.top = Location.Y;
                                DisplayList[DisplayList.Length - 1].Area.bottom = Location.Y;
                                DisplayList[DisplayList.Length - 1].UndoName = "Erase Pixel (" + AnsiString(DisplayItemNumber) + ")";
                                DisplayList[DisplayList.Length - 1].selected = false;
                                DisplayList[DisplayList.Length - 1].visible = true;
                                EraseList.Length++;
                                EraseList[EraseList.Length - 1].ItemNumber = DisplayItemNumber;
                                AddUndoTitle("Add Erase Object");
                                AddUndo("Delete," + AnsiString(DisplayItemNumber) + ",");
                                DisplayItemNumber++;
                                preparetosaveundo = false;
                                CreateXRefs();
                                }
                                    //check to see if the point clicked on is already in the list
                            bool found = false;
                            int pointer = 0;
                            while (!found && pointer < EraseList[EraseList.Length - 1].Points.Length) {
                                if (Location.X == EraseList[EraseList.Length - 1].Points[pointer].x && Location.Y == EraseList[EraseList.Length - 1].Points[pointer].y) {
                                    found = true;
                                    }
                                pointer++;
                                }
                            if (!found) {
                                EraseList[EraseList.Length - 1].Points.Length++;
                                EraseList[EraseList.Length - 1].Points[EraseList[EraseList.Length - 1].Points.Length - 1].x = Location.X;
                                EraseList[EraseList.Length - 1].Points[EraseList[EraseList.Length - 1].Points.Length - 1].y = Location.Y;
                                EraseList[EraseList.Length - 1].Points[EraseList[EraseList.Length - 1].Points.Length - 1].Colour = Colour;
                                }
                            //if (DisplayList[DisplayList.Length - 1].Area.left > Location.X) DisplayList[DisplayList.Length - 1].Area.left = Location.X;
                            //if (DisplayList[DisplayList.Length - 1].Area.right < Location.X) DisplayList[DisplayList.Length - 1].Area.right = Location.X;
                            //if (DisplayList[DisplayList.Length - 1].Area.top > Location.Y) DisplayList[DisplayList.Length - 1].Area.top = Location.Y;
                            //if (DisplayList[DisplayList.Length - 1].Area.bottom < Location.Y) DisplayList[DisplayList.Length - 1].Area.bottom = Location.Y;
                            DisplayListAreaUpdate(EraseList[EraseList.Length - 1].ItemNumber);
                            DrawErase(EraseList[EraseList.Length - 1].ItemNumber, Image1->Picture->Bitmap->Canvas);
                            dragging = true;
                            }
                            break;
        case TDrawLine:     {
                            //set up line drawing as before
                            OldMousePositionScreen.x = X;
                            OldMousePositionScreen.y = Y;
                            StartPointChart.x = Location.X;
                            StartPointChart.y = Location.Y;
                            chartposition SP = FindImage1Position(Location.X,Location.Y);
                            StartPointScreen.x = SP.X;
                            StartPointScreen.y = SP.Y;
                            if (OldMousePositionScreen.x == StartPointScreen.x && OldMousePositionScreen.y == StartPointScreen.y) {
                                //don't want a line to the mouse point
                                wipedout = true;
                                } else {
                                //want a line to the mouse point
                                TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                Image1->Picture->Bitmap->Canvas->LineTo(OldMousePositionScreen.x,OldMousePositionScreen.y);
                                Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                wipedout = false;
                                }
                            dragging = true;
                            }
                            break;
        case TTextItem:     {
                            //Finding of the pixels to colour will be done in memory
                            AnsiString Text = DefaultText.Text;
                            KeyPreview = false;
                            if (InputQuery("Text for Image","Please Enter the text to be added",Text)) {
                                TColor Colour;
                                if (Button == mbLeft || Button == mbMiddle) {
                                    Colour = ForegroundColour;
                                    if (preparetoblendforeground) {
                                        blendthreads = true;
                                        preparetoblendforeground = false;
                                        }
                                    } else {
                                    Colour = BackgroundColour;
                                    if (preparetoblendbackground) {
                                        blendthreads = true;
                                        preparetoblendbackground = false;
                                        }
                                    }
                                //set up display arrays
                                DisplayList.Length++;
                                DisplayList[DisplayList.Length - 1].ItemNumber = DisplayItemNumber;
                                DisplayList[DisplayList.Length - 1].DisplayType = TDisplayText;
                                DisplayList[DisplayList.Length - 1].UndoName = "Text '" + Text + "' (" + AnsiString(DisplayItemNumber) + ")";
                                DisplayList[DisplayList.Length - 1].selected = false;
                                DisplayList[DisplayList.Length - 1].visible = true;
                                TRect Area;
                                Area.Left = Location.X;
                                Area.Right = Location.X;
                                Area.Top = Location.Y;
                                Area.Bottom = Location.Y;
                                int arraypointer = TextList.Length;
                                TextList.Length++;
                                TextList[arraypointer].ItemNumber = DisplayItemNumber;
                                TextList[arraypointer].Text = Text;
                                TextList[arraypointer].Name = DefaultText.Name;
                                TextList[arraypointer].Height = DefaultText.Height;
                                TextList[arraypointer].Bold = DefaultText.Bold;
                                TextList[arraypointer].Italic = DefaultText.Italic;
                                TextList[arraypointer].Underlined = DefaultText.Underlined;
                                TextList[arraypointer].Strikeout = DefaultText.Strikeout;
                                TextList[arraypointer].Colour = Colour;
                                TextList[arraypointer].StartPoint.x = Location.X;
                                TextList[arraypointer].StartPoint.y = Location.Y;
                                TextList[arraypointer].Angle = 0;

                                FillPointsText(arraypointer,DisplayItemNumber);
                                /*
                                Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
                                Bitmap->Monochrome = true;
                                Bitmap->Width = Picture->Width;
                                Bitmap->Height = Picture->Height;
                                DefaultText.Text = Text;
                                Bitmap->Canvas->Font->Name = DefaultText.Name;
                                Bitmap->Canvas->Font->Height = DefaultText.Height/2;
                                while (Bitmap->Canvas->TextHeight("Hg") <  (-1*DefaultText.Height)) {
                                    Bitmap->Canvas->Font->Height = Bitmap->Canvas->Font->Height - 1;
                                    }
                                //Bitmap->Canvas->Font->Height = Bitmap->Canvas->Font->Height - 1;
                                if (DefaultText.Bold) Bitmap->Canvas->Font->Style << fsBold;
                                if (DefaultText.Italic) Bitmap->Canvas->Font->Style << fsItalic;
                                if (DefaultText.Underlined) Bitmap->Canvas->Font->Style << fsUnderline;
                                if (DefaultText.Strikeout) Bitmap->Canvas->Font->Style << fsStrikeOut;
                                Bitmap->Canvas->Font->Color = clBlack;
                                Bitmap->Canvas->TextOut(Location.X,Location.Y,Text);
                                TextList[arraypointer].Points.Length = Bitmap->Width * Bitmap->Height + 1;
                                int pointer = 0;

                                for (int i = 0; i < Bitmap->Width; i++) {
                                    for (int j = 0; j < Bitmap->Height; j++) {
                                        if (Bitmap->Canvas->Pixels[i][j] == clBlack) {
                                            TextList[arraypointer].Points[pointer].x = i;
                                            TextList[arraypointer].Points[pointer].y = j;
                                            TextList[arraypointer].Colour = Colour;
                                            pointer++;
                                            }
                                        }
                                    }
                                TextList[arraypointer].Points.Length = pointer;
                                delete Bitmap;
                                */
                                for (int i = 0; i < TextList[arraypointer].Points.Length; i++) {
                                    if (TextList[arraypointer].Points[i].x < Area.Left) Area.Left = TextList[arraypointer].Points[i].x;
                                    if (TextList[arraypointer].Points[i].x > Area.Right) Area.Right = TextList[arraypointer].Points[i].x;
                                    if (TextList[arraypointer].Points[i].y < Area.Top) Area.Top = TextList[arraypointer].Points[i].y;
                                    if (TextList[arraypointer].Points[i].y > Area.Bottom) Area.Bottom = TextList[arraypointer].Points[i].y;
                                    }
                                //DisplayList[DisplayList.Length - 1].Area = Area;
                                AddUndoTitle("Add Text Object");
                                AddUndo("Delete," + AnsiString(DisplayItemNumber) + ",");
                                DisplayItemNumber++;
                                CreateXRefs();
                                DisplayListAreaUpdate(TextList[arraypointer].ItemNumber);
                                DrawText(TextList[arraypointer].ItemNumber, Image1->Picture->Bitmap->Canvas);
                                }
                            KeyPreview = true;
                            }
                            break;
        case TFloodFill:    {
                            //Flood filling will be done on a copy of the image held in memory
                            TColor Colour;
                                if (Button == mbLeft || Button == mbMiddle) {
                                    Colour = ForegroundColour;
                                    if (preparetoblendforeground) {
                                        blendthreads = true;
                                        preparetoblendforeground = false;
                                        }
                                    } else {
                                    Colour = BackgroundColour;
                                    if (preparetoblendbackground) {
                                        blendthreads = true;
                                        preparetoblendbackground = false;
                                        }
                                    }
                            TColor FilledColour = Image1->Picture->Bitmap->Canvas->Pixels[X][Y];
                            if (Colour != FilledColour) {
                                //create memory bitmap of current complete picture
                                Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
                                Bitmap->Assign(Picture);
                                int oldSquareSize = SquareSize;
                                TPoint OldTopLeft = TopLeft;
                                SquareSize = 1;
                                TopLeft.x = 0;
                                TopLeft.y = 0;
                                DrawVectors(Bitmap->Canvas);
                                SquareSize = oldSquareSize;
                                TopLeft = OldTopLeft;
                                //set up display arrays
                                DisplayList.Length++;
                                DisplayList[DisplayList.Length - 1].ItemNumber = DisplayItemNumber;
                                DisplayList[DisplayList.Length - 1].DisplayType = TDisplayFloodFill;
                                DisplayList[DisplayList.Length - 1].UndoName = "Flood Fill at X" + AnsiString(Location.X) + ",Y" + AnsiString(Location.Y) + " (" + AnsiString(DisplayItemNumber) + ")";
                                DisplayList[DisplayList.Length - 1].selected = false;
                                DisplayList[DisplayList.Length - 1].visible = true;
                                TRect Area;
                                Area.Left = Location.X;
                                Area.Right = Location.X;
                                Area.Top = Location.Y;
                                Area.Bottom = Location.Y;
                                int arraypointer = FloodFillList.Length;
                                FloodFillList.Length++;
                                FloodFillList[arraypointer].ItemNumber = DisplayItemNumber;
                                FloodFillList[arraypointer].Colour = Colour;
                                FloodFillList[arraypointer].FilledColour = FilledColour;
                                FloodFillList[arraypointer].StartPoint.x = Location.X;
                                FloodFillList[arraypointer].StartPoint.y = Location.Y;
                                FloodFillList[arraypointer].Points.Length = Bitmap->Width * Bitmap->Height + 1;
                                //now to fill in bitmap
                                int maxpointer = 0;
                                int pointer = 0;
                                bool found = true;
                                FloodFillList[arraypointer].Points[0].x = Location.X;
                                FloodFillList[arraypointer].Points[0].y = Location.Y;
                                Bitmap->Canvas->Pixels[Location.X][Location.Y] = Colour;
                                TPoint Point;
                                while (found || pointer <= maxpointer) {
                                    found = false;
                                    //for each entry in the points list, look all around it for other instances of filledcolour and save them at the end of the list after changing their colours too
                                    //note - does diagonals too, not just in the NESW directions. Helpful for changing regularly dithered colours
                                    if (maxpointer + 8 >= FloodFillList[arraypointer].Points.Length) {
                                        FloodFillList[arraypointer].Points.Length += 1000;
                                        }
                                    Point = FloodFillList[arraypointer].Points[pointer];
                                    if (Point.y > 0) {
                                        //Top Left pixel
                                        if (Point.x > 0 && floodfilldiagonals) {
                                            if (Bitmap->Canvas->Pixels[Point.x - 1][Point.y - 1] == FilledColour) {
                                                Bitmap->Canvas->Pixels[Point.x - 1][Point.y - 1] = Colour;
                                                maxpointer++;
                                                found = true;
                                                FloodFillList[arraypointer].Points[maxpointer].x = Point.x - 1;
                                                FloodFillList[arraypointer].Points[maxpointer].y = Point.y - 1;
                                                }
                                            }
                                        //top middle pixel
                                        if (Bitmap->Canvas->Pixels[Point.x][Point.y - 1] == FilledColour) {
                                            Bitmap->Canvas->Pixels[Point.x][Point.y - 1] = Colour;
                                            maxpointer++;
                                            found = true;
                                            FloodFillList[arraypointer].Points[maxpointer].x = Point.x;
                                            FloodFillList[arraypointer].Points[maxpointer].y = Point.y - 1;
                                            }
                                        //Top right pixel
                                        if (Point.x < Bitmap->Width - 1 && floodfilldiagonals) {
                                            if (Bitmap->Canvas->Pixels[Point.x + 1][Point.y - 1] == FilledColour) {
                                                Bitmap->Canvas->Pixels[Point.x + 1][Point.y - 1] = Colour;
                                                maxpointer++;
                                                found = true;
                                                FloodFillList[arraypointer].Points[maxpointer].x = Point.x + 1;
                                                FloodFillList[arraypointer].Points[maxpointer].y = Point.y - 1;
                                                }
                                            }
                                        } //end of 'if (Point.y > 0)'
                                    //Middle Left pixel
                                    if (Point.x > 0) {
                                        if (Bitmap->Canvas->Pixels[Point.x - 1][Point.y] == FilledColour) {
                                            Bitmap->Canvas->Pixels[Point.x - 1][Point.y] = Colour;
                                            maxpointer++;
                                            found = true;
                                            FloodFillList[arraypointer].Points[maxpointer].x = Point.x - 1;
                                            FloodFillList[arraypointer].Points[maxpointer].y = Point.y;
                                            }
                                        } //end of 'if (Point.x > 0)'
                                    //Middle Right pixel
                                    if (Point.x < Bitmap->Width - 1) {
                                        if (Bitmap->Canvas->Pixels[Point.x + 1][Point.y] == FilledColour) {
                                            Bitmap->Canvas->Pixels[Point.x + 1][Point.y] = Colour;
                                            maxpointer++;
                                            found = true;
                                            FloodFillList[arraypointer].Points[maxpointer].x = Point.x + 1;
                                            FloodFillList[arraypointer].Points[maxpointer].y = Point.y;
                                            }
                                        } //end of 'if (Point.x < Bitmap->Width - 1)'
                                    if (Point.y < Bitmap->Height - 1) {
                                        //Bottom Left pixel
                                        if (Point.x > 0 && floodfilldiagonals) {
                                            if (Bitmap->Canvas->Pixels[Point.x - 1][Point.y + 1] == FilledColour) {
                                                Bitmap->Canvas->Pixels[Point.x - 1][Point.y + 1] = Colour;
                                                maxpointer++;
                                                found = true;
                                                FloodFillList[arraypointer].Points[maxpointer].x = Point.x - 1;
                                                FloodFillList[arraypointer].Points[maxpointer].y = Point.y + 1;
                                                }
                                            }
                                        //bottom middle pixel
                                        if (Bitmap->Canvas->Pixels[Point.x][Point.y + 1] == FilledColour) {
                                            Bitmap->Canvas->Pixels[Point.x][Point.y + 1] = Colour;
                                            maxpointer++;
                                            found = true;
                                            FloodFillList[arraypointer].Points[maxpointer].x = Point.x;
                                            FloodFillList[arraypointer].Points[maxpointer].y = Point.y + 1;
                                            }
                                        //bottom right pixel
                                        if (Point.x < Bitmap->Width - 1 && floodfilldiagonals) {
                                            if (Bitmap->Canvas->Pixels[Point.x + 1][Point.y + 1] == FilledColour) {
                                                Bitmap->Canvas->Pixels[Point.x + 1][Point.y + 1] = Colour;
                                                maxpointer++;
                                                found = true;
                                                FloodFillList[arraypointer].Points[maxpointer].x = Point.x + 1;
                                                FloodFillList[arraypointer].Points[maxpointer].y = Point.y + 1;
                                                }
                                            }
                                        } //end of 'if (Point.y < Bitmap->Height - 1)'
                                    pointer++;
                                    //if (pointer > maxpointer) found = false;
                                    } //end of 'while (found)'

                                FloodFillList[arraypointer].Points.Length = maxpointer + 1;
                                delete Bitmap;
                                for (int i = 0; i < FloodFillList[arraypointer].Points.Length; i++) {
                                    if (FloodFillList[arraypointer].Points[i].x < Area.Left) Area.Left = FloodFillList[arraypointer].Points[i].x;
                                    if (FloodFillList[arraypointer].Points[i].x > Area.Right) Area.Right = FloodFillList[arraypointer].Points[i].x;
                                    if (FloodFillList[arraypointer].Points[i].y < Area.Top) Area.Top = FloodFillList[arraypointer].Points[i].y;
                                    if (FloodFillList[arraypointer].Points[i].y > Area.Bottom) Area.Bottom = FloodFillList[arraypointer].Points[i].y;
                                    }
                                //DisplayList[DisplayList.Length - 1].Area = Area;
                                AddUndoTitle("Add Flood Fill");
                                AddUndo("Delete," + AnsiString(DisplayItemNumber) + ",");
                                DisplayItemNumber++;
                                CreateXRefs();
                                DisplayListAreaUpdate(FloodFillList[arraypointer].ItemNumber);
                                DrawFloodFill(FloodFillList[arraypointer].ItemNumber, Image1->Picture->Bitmap->Canvas);
                                /*
                                //debug
                                Memo1->Lines->Add(DisplayList[DisplayList.Length - 1].UndoName);
                                for (int i = 0; i < FloodFillList[arraypointer].Points.Length; i++) {
                                    Memo1->Lines->Add(AnsiString(i) + " X" + AnsiString(FloodFillList[arraypointer].Points[i].x) + ",Y" + AnsiString(FloodFillList[arraypointer].Points[i].y));
                                    }
                                //end debug
                                */
                                } //end of 'if (Colour != FilledColour)' which stops an infinite loop
                            }
                            break;
        case TEyeDropper:   {
                            TColor Colour;
                            //The Image1 can have strange stuff drawn on it, so create a clean bitmap
                            Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
                            Bitmap->Width = Picture->Width;
                            Bitmap->Height = Picture->Height;
                            if (showbackground) Bitmap->Assign(Picture);
                            int oldsquare = SquareSize;
                            SquareSize = 1;
                            TPoint OldTopLeft = TopLeft;
                            TopLeft.x = 0;
                            TopLeft.y = 0;
                            DrawVectors(Bitmap->Canvas);
                            SquareSize = oldsquare;
                            TopLeft = OldTopLeft;
                            Colour = Bitmap->Canvas->Pixels[Location.X][Location.Y];
                            delete Bitmap;
                            //Colour = Image1->Picture->Bitmap->Canvas->Pixels[X][Y];
                            if (Button == mbLeft || Button == mbMiddle) {
                                AddUndoTitle("Change Foreground Colour");
                                AddUndo("Foreground," + AnsiString((int)(ForegroundColour)) + ",");
                                ForegroundColour = Colour;
                                //Foreground->Brush->Color = Colour;
                                preparetoblendforeground = false;
                                DisplayCurrentColours();
                                } else {
                                AddUndoTitle("Change Foreground Colour");
                                AddUndo("Background," + AnsiString((int)(BackgroundColour)) + ",");
                                BackgroundColour = Colour;
                                //Background->Brush->Color = Colour;
                                preparetoblendbackground = false;
                                DisplayCurrentColours();
                                }
                            }
                            break;
        case TPixelEdit:    {
                            //add a pixel edit to the list of things to be done.
                            TColor Colour;
                                if (Button == mbLeft || Button == mbMiddle) {
                                    Colour = ForegroundColour;
                                    if (preparetoblendforeground) {
                                        blendthreads = true;
                                        preparetoblendforeground = false;
                                        }
                                    } else {
                                    Colour = BackgroundColour;
                                    if (preparetoblendbackground) {
                                        blendthreads = true;
                                        preparetoblendbackground = false;
                                        }
                                    }
                            if (preparetosaveundo || !DisplayList.Length ||(DisplayList.Length  && (DisplayList[DisplayList.Length - 1].DisplayType != TDisplayPoint || PointList[PointList.Length - 1].Colour != Colour))) {
                                DisplayList.Length++;
                                DisplayList[DisplayList.Length - 1].ItemNumber = DisplayItemNumber;
                                DisplayList[DisplayList.Length - 1].DisplayType = TDisplayPoint;
                                DisplayList[DisplayList.Length - 1].Area.left = Location.X;
                                DisplayList[DisplayList.Length - 1].Area.right = Location.X;
                                DisplayList[DisplayList.Length - 1].Area.top = Location.Y;
                                DisplayList[DisplayList.Length - 1].Area.bottom = Location.Y;
                                DisplayList[DisplayList.Length - 1].UndoName = "Pixel Edit (" + AnsiString(DisplayItemNumber) + ")";
                                DisplayList[DisplayList.Length - 1].selected = false;
                                DisplayList[DisplayList.Length - 1].visible = true;
                                PointList.Length++;
                                PointList[PointList.Length - 1].ItemNumber = DisplayItemNumber;
                                PointList[PointList.Length - 1].Colour = Colour;
                                AddUndoTitle("Add Pencil Object");
                                AddUndo("Delete," + AnsiString(DisplayItemNumber) + ",");
                                DisplayItemNumber++;
                                CreateXRefs();
                                preparetosaveundo = false;
                                }
                                    //check to see if the point clicked on is already in the list
                            bool found = false;
                            int pointer = 0;
                            while (!found && pointer < PointList[PointList.Length - 1].Points.Length) {
                                if (Location.X == PointList[PointList.Length - 1].Points[pointer].x && Location.Y == PointList[PointList.Length - 1].Points[pointer].y) {
                                    found = true;
                                    }
                                pointer++;
                                }
                            if (!found) {
                                PointList[PointList.Length - 1].Points.Length++;
                                PointList[PointList.Length - 1].Points[PointList[PointList.Length - 1].Points.Length - 1].x = Location.X;
                                PointList[PointList.Length - 1].Points[PointList[PointList.Length - 1].Points.Length - 1].y = Location.Y;
                                }
                            //if (DisplayList[DisplayList.Length - 1].Area.left > Location.X) DisplayList[DisplayList.Length - 1].Area.left = Location.X;
                            //if (DisplayList[DisplayList.Length - 1].Area.right < Location.X) DisplayList[DisplayList.Length - 1].Area.right = Location.X;
                            //if (DisplayList[DisplayList.Length - 1].Area.top > Location.Y) DisplayList[DisplayList.Length - 1].Area.top = Location.Y;
                            //if (DisplayList[DisplayList.Length - 1].Area.bottom < Location.Y) DisplayList[DisplayList.Length - 1].Area.bottom = Location.Y;
                            DisplayListAreaUpdate(DisplayList[DisplayList.Length - 1].ItemNumber);
                            DrawPoints(PointList[PointList.Length - 1].ItemNumber, Image1->Picture->Bitmap->Canvas);
                            dragging = true;
                            }
                            break;
        default:            break;
        }
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Image1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
    //fills in the location points for the current mouse position.
    chartposition Location = FindMousePosition(X,Y);
    if (!Location.outofrange) {
        StatusBar1->Panels->Items[0]->Text = " X = " + AnsiString(Location.X);
        StatusBar1->Panels->Items[1]->Text = " Y = " + AnsiString(Location.Y);
        } else {
        StatusBar1->Panels->Items[0]->Text = " X = ---";
        StatusBar1->Panels->Items[1]->Text = " Y = ---";
        }
    if (!Location.outofrange) {
        int overdisplayitem = FindTopmostDisplayItem(Location.X,Location.Y);
        if (overdisplayitem > -1) {
            Image1->Hint = DisplayList[overdisplayitem].UndoName;
            } else {
            Image1->Hint = "Background Image";
            }
        switch (ActionType) {
            case TEyeDropper:   {
                                TColor Colour;
                                //The Image1 can have strange stuff drawn on it, so create a clean bitmap
                                Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
                                Bitmap->Width = Picture->Width;
                                Bitmap->Height = Picture->Height;
                                if (showbackground) Bitmap->Assign(Picture);
                                int oldsquare = SquareSize;
                                SquareSize = 1;
                                TPoint OldTopLeft = TopLeft;
                                TopLeft.x = 0;
                                TopLeft.y = 0;
                                DrawVectors(Bitmap->Canvas);
                                SquareSize = oldsquare;
                                TopLeft = OldTopLeft;
                                Colour = Bitmap->Canvas->Pixels[Location.X][Location.Y];
                                delete Bitmap;
                                //Colour = Image1->Picture->Bitmap->Canvas->Pixels[X][Y];

                                int arrayentry = 0;
                                bool found = false;
                                while (!found && arrayentry < DMCColourList.Length) {
                                    if (DMCColourList[arrayentry].Colour == Colour) {
                                        found = true;
                                        StatusBar1->Panels->Items[4]->Style = psText;
                                        //StatusBar1->Panels->Items[4]->Text = "DMC" + DMCColourList[arrayentry].DMCColourNumber + " " + DMCColourList[arrayentry].DMCColourName + " R:" + AnsiString(DMCColourList[arrayentry].R) + " G:" + AnsiString(DMCColourList[arrayentry].G) + " B:" + AnsiString(DMCColourList[arrayentry].B);
                                        StatusBar1->Panels->Items[4]->Text = ShortThreadName + DMCColourList[arrayentry].DMCColourNumber + " " + DMCColourList[arrayentry].DMCColourName + " R:" + AnsiString(DMCColourList[arrayentry].R) + " G:" + AnsiString(DMCColourList[arrayentry].G) + " B:" + AnsiString(DMCColourList[arrayentry].B);
                                        Timer1->Enabled = true;
                                        }
                                    arrayentry++;
                                    }
                                arrayentry = 0;
                                if (!found && blendthreads) {
                                    while (!found && arrayentry < TweedList.Length) {
                                        if (TweedList[arrayentry].Colour == Colour) {
                                            found = true;
                                            StatusBar1->Panels->Items[4]->Style = psText;
                                            //StatusBar1->Panels->Items[4]->Text = "Blend DMC" + TweedList[arrayentry].DMCColourNumber + " R:" + AnsiString(TweedList[arrayentry].R) + " G:" + AnsiString(TweedList[arrayentry].G) + " B:" + AnsiString(TweedList[arrayentry].B);
                                            StatusBar1->Panels->Items[4]->Text = "Blend " + ShortThreadName + TweedList[arrayentry].DMCColourNumber + " R:" + AnsiString(TweedList[arrayentry].R) + " G:" + AnsiString(TweedList[arrayentry].G) + " B:" + AnsiString(TweedList[arrayentry].B);
                                            Timer1->Enabled = true;
                                            }
                                        arrayentry++;
                                        }
                                    }
                                }
                                break;
            case TEditFreeForm: {
                                //find FreeForm being edited
                                bool found = false;
                                int pointer = 0;
                                int arraypointer;
                                while (!found && pointer < DisplayList.Length) {
                                    if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayFreeForm) {
                                        found = true;
                                        pointer--;
                                        }
                                    pointer++;
                                    }
                                if (found) {
                                    found = false;
                                    arraypointer = XRefs[DisplayList[pointer].ItemNumber].EntityXRef;
                                    if ( arraypointer > -1
                                        && arraypointer < FreeFormList.Length
                                        && FreeFormList[arraypointer].ItemNumber == DisplayList[pointer].ItemNumber
                                        ) found = true;
                                    }
                                if (found) {
                                    if (dragging) {
                                        //are moving a point
                                        //now to start drawing the elastic band etc
                                        chartposition SP;
                                        TRect Rectangle;
                                        TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                        Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                        Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                        Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                        if (!wipedout) {
                                            //rectangles around corners except one being moved
                                            for (int i = 0; i < FreeFormList[arraypointer].Corners.Length; i++) {
                                                if (i != pointbeingdragged) {
                                                    SP = FindImage1Position(FreeFormList[arraypointer].Corners[i].x,FreeFormList[arraypointer].Corners[i].y);
                                                    Rectangle.Left = SP.X - 1;
                                                    Rectangle.Top = SP.Y - 1;
                                                    Rectangle.Right = SP.X + 1 + SquareSize;
                                                    Rectangle.Bottom = SP.Y + 1 + SquareSize;
                                                    Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                                    }
                                                }
                                            Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                            Image1->Picture->Bitmap->Canvas->LineTo(OldMousePositionScreen.x,OldMousePositionScreen.y);
                                            Image1->Picture->Bitmap->Canvas->LineTo(EndPointScreen.x,EndPointScreen.y);
                                            }
                                        //decide on elasticbanding
                                        OldMousePositionScreen.x = X;
                                        OldMousePositionScreen.y = Y;
                                        if (pointbeingdragged == 0) {
                                            StartPointChart.x = Location.X;
                                            StartPointChart.y = Location.Y;
                                            StartPointScreen.x = X;
                                            StartPointScreen.y = Y;
                                            }
                                        if (pointbeingdragged == (FreeFormList[arraypointer].Corners.Length - 1)) {
                                            EndPointChart.x = Location.X;
                                            EndPointChart.y = Location.Y;
                                            EndPointScreen.x = X;
                                            EndPointScreen.y = Y;
                                            }
                                        for (int i = 0; i < FreeFormList[arraypointer].Corners.Length; i++) {
                                            if (i != pointbeingdragged) {
                                                SP = FindImage1Position(FreeFormList[arraypointer].Corners[i].x,FreeFormList[arraypointer].Corners[i].y);
                                                Rectangle.Left = SP.X - 1;
                                                Rectangle.Top = SP.Y - 1;
                                                Rectangle.Right = SP.X + 1 + SquareSize;
                                                Rectangle.Bottom = SP.Y + 1 + SquareSize;
                                                Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                                }
                                            }
                                        Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                        Image1->Picture->Bitmap->Canvas->LineTo(OldMousePositionScreen.x,OldMousePositionScreen.y);
                                        Image1->Picture->Bitmap->Canvas->LineTo(EndPointScreen.x,EndPointScreen.y);
                                        Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                        wipedout = false;
                                        } else {
                                        //Looking for a point to move. There will be a rectangle around each pixel that's a corner and a treble one around the nearest
                                        TRect Rectangle;
                                        chartposition SP;
                                        if (!wipedout) {
                                            //clear annotations
                                            TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                            Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                            Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                            Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                            //rectangles around corners
                                            for (int i = 0; i < FreeFormList[arraypointer].Corners.Length; i++) {
                                                SP = FindImage1Position(FreeFormList[arraypointer].Corners[i].x,FreeFormList[arraypointer].Corners[i].y);
                                                Rectangle.Left = SP.X - 1;
                                                Rectangle.Top = SP.Y - 1;
                                                Rectangle.Right = SP.X + 1 + SquareSize;
                                                Rectangle.Bottom = SP.Y + 1 + SquareSize;
                                                Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                                }
                                            //rectangles around nearest
                                            SP = FindImage1Position(FreeFormList[arraypointer].Corners[pointbeingdragged].x,FreeFormList[arraypointer].Corners[pointbeingdragged].y);
                                            Rectangle.Left = SP.X - 3;
                                            Rectangle.Top = SP.Y - 3;
                                            Rectangle.Right = SP.X + 3 + SquareSize;
                                            Rectangle.Bottom = SP.Y + 3 + SquareSize;
                                            Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                            Rectangle.Left = SP.X - 5;
                                            Rectangle.Top = SP.Y - 5;
                                            Rectangle.Right = SP.X + 5 + SquareSize;
                                            Rectangle.Bottom = SP.Y + 5 + SquareSize;
                                            Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                            Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                            wipedout = true;
                                            }
                                        //now to find which point is closest to the current mouse position
                                        int distance = (FreeFormList[arraypointer].Corners[0].x - Location.X) * (FreeFormList[arraypointer].Corners[0].x - Location.X) + (FreeFormList[arraypointer].Corners[0].y - Location.Y) * (FreeFormList[arraypointer].Corners[0].y - Location.Y);
                                        int value;
                                        pointbeingdragged = 0;
                                        for (int i = 1; i < FreeFormList[arraypointer].Corners.Length; i++) {
                                            value = (FreeFormList[arraypointer].Corners[i].x - Location.X) * (FreeFormList[arraypointer].Corners[i].x - Location.X) + (FreeFormList[arraypointer].Corners[i].y - Location.Y) * (FreeFormList[arraypointer].Corners[i].y - Location.Y);
                                            if (value < distance) {
                                                distance = value;
                                                pointbeingdragged = i;
                                                }
                                            }
                                        OldMousePositionScreen.x = X;
                                        OldMousePositionScreen.y = Y;
                                        //now to re-display the points
                                        //draw annotations
                                        TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                        Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                        Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                        Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                        //rectangles around corners
                                        for (int i = 0; i < FreeFormList[arraypointer].Corners.Length; i++) {
                                            SP = FindImage1Position(FreeFormList[arraypointer].Corners[i].x,FreeFormList[arraypointer].Corners[i].y);
                                            Rectangle.Left = SP.X - 1;
                                            Rectangle.Top = SP.Y - 1;
                                            Rectangle.Right = SP.X + 1 + SquareSize;
                                            Rectangle.Bottom = SP.Y + 1 + SquareSize;
                                            Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                            }
                                        //rectangles around nearest
                                        SP = FindImage1Position(FreeFormList[arraypointer].Corners[pointbeingdragged].x,FreeFormList[arraypointer].Corners[pointbeingdragged].y);
                                        Rectangle.Left = SP.X - 3;
                                        Rectangle.Top = SP.Y - 3;
                                        Rectangle.Right = SP.X + 3 + SquareSize;
                                        Rectangle.Bottom = SP.Y + 3 + SquareSize;
                                        Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                        Rectangle.Left = SP.X - 5;
                                        Rectangle.Top = SP.Y - 5;
                                        Rectangle.Right = SP.X + 5 + SquareSize;
                                        Rectangle.Bottom = SP.Y + 5 + SquareSize;
                                        Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                        Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                        wipedout = false;
                                        }
                                    }
                                }
                                break;
            case TDrawFreeForm:     {
                                    int arraypointer = FreeFormList.Length - 1;
                                    if (dragging) {
                                        //have already started the FreeForm, so add to it
                                        if (!wipedout) {
                                            //want a line to the mouse point
                                            TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                            Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                            Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                            Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                            if (LinePoints.Length >= 2) {
                                                Image1->Picture->Bitmap->Canvas->MoveTo(LinePoints[0].x,LinePoints[0].y);
                                                Image1->Picture->Bitmap->Canvas->LineTo(LinePoints[1].x,LinePoints[1].y);
                                                }
                                            if (LinePoints.Length >= 3) {
                                                Image1->Picture->Bitmap->Canvas->LineTo(LinePoints[2].x,LinePoints[2].y);
                                                }
                                            Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                            wipedout = true;
                                            }
                                        //now to start the elastic banding from the last point again
                                        StartPointChart.x = Location.X;
                                        StartPointChart.y = Location.Y;
                                        chartposition SP = FindImage1Position(Location.X,Location.Y);
                                        StartPointScreen.x = SP.X;
                                        StartPointScreen.y = SP.Y;
                                        OldMousePositionScreen.x = X;
                                        OldMousePositionScreen.y = Y;
                                        chartposition EP;
                                        if (LinePoints.Length == 3)EP = FindImage1Position(FreeFormList[arraypointer].Corners[0].x,FreeFormList[arraypointer].Corners[0].y);
                                        if (OldMousePositionScreen.x == StartPointScreen.x && OldMousePositionScreen.y == StartPointScreen.y && OldMousePositionScreen.x == EP.X && OldMousePositionScreen.y == EP.Y) {
                                            //don't want a line to the mouse point
                                            wipedout = true;
                                            LinePoints.Length = 0;
                                            } else {
                                            //want a line to the mouse point and to close the loop
                                            TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                            Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                            Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                            Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                            LinePoints[1] = OldMousePositionScreen;
                                            Image1->Picture->Bitmap->Canvas->MoveTo(LinePoints[0].x,LinePoints[0].y);
                                            Image1->Picture->Bitmap->Canvas->LineTo(LinePoints[1].x,LinePoints[1].y);
                                            if (LinePoints.Length == 3) {
                                                LinePoints[2].x = EP.X;
                                                LinePoints[2].y = EP.Y;
                                                Image1->Picture->Bitmap->Canvas->LineTo(LinePoints[2].x,LinePoints[2].y);
                                                }
                                            Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                            wipedout = false;
                                            }
                                        } //end of doing the FreeForm shape
                                    }
                                    break;
            case TPasteBlock:   {
                                int displaypointer = DisplayList.Length - 1;
                                if (DisplayList[displaypointer].selected && !DisplayList[displaypointer].visible && DisplayList[displaypointer].DisplayType == TDisplayBlock) {
                                    //have the right block
                                    TRect Rectangle;
                                    Rectangle = FindImage1Position(DisplayList[displaypointer].Area);
                                    TPoint delta;
                                    delta.x = Rectangle.Right - Rectangle.Left;
                                    delta.y = Rectangle.Bottom - Rectangle.Top;
                                    TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                    Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                    Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                    if (!wipedout) {
                                        Rectangle.Left = OldMousePositionScreen.x;
                                        Rectangle.Top = OldMousePositionScreen.y;
                                        Rectangle.Right = Rectangle.Left + delta.x;
                                        Rectangle.Bottom = Rectangle.Top + delta.y;
                                        Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                        wipedout = true;
                                        }
                                    OldMousePositionScreen.x = X;
                                    OldMousePositionScreen.y = Y;
                                    Rectangle.Left = OldMousePositionScreen.x;
                                    Rectangle.Top = OldMousePositionScreen.y;
                                    Rectangle.Right = Rectangle.Left + delta.x;
                                    Rectangle.Bottom = Rectangle.Top + delta.y;
                                    Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                    wipedout = false;
                                    }
                                }
                                break;
            case TEditPolyLine: {
                                //find polyline being edited
                                bool found = false;
                                int pointer = 0;
                                int arraypointer;
                                while (!found && pointer < DisplayList.Length) {
                                    if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayPolyLine) {
                                        found = true;
                                        pointer--;
                                        }
                                    pointer++;
                                    }
                                if (found) {
                                    found = false;
                                    arraypointer = XRefs[DisplayList[pointer].ItemNumber].EntityXRef;
                                    if ( arraypointer > -1
                                        && arraypointer < PolyLineList.Length
                                        && PolyLineList[arraypointer].ItemNumber == DisplayList[pointer].ItemNumber
                                        ) found = true;
                                    }
                                if (found) {
                                    if (dragging) {
                                        //are moving a point
                                        //now to start drawing the elastic band etc
                                        chartposition SP;
                                        TRect Rectangle;
                                        TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                        Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                        Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                        Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                        if (!wipedout) {
                                            //rectangles around corners except one being moved
                                            for (int i = 0; i < PolyLineList[arraypointer].Corners.Length; i++) {
                                                if (i != pointbeingdragged) {
                                                    SP = FindImage1Position(PolyLineList[arraypointer].Corners[i].x,PolyLineList[arraypointer].Corners[i].y);
                                                    Rectangle.Left = SP.X - 1;
                                                    Rectangle.Top = SP.Y - 1;
                                                    Rectangle.Right = SP.X + 1 + SquareSize;
                                                    Rectangle.Bottom = SP.Y + 1 + SquareSize;
                                                    Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                                    }
                                                }
                                            Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                            Image1->Picture->Bitmap->Canvas->LineTo(OldMousePositionScreen.x,OldMousePositionScreen.y);
                                            Image1->Picture->Bitmap->Canvas->LineTo(EndPointScreen.x,EndPointScreen.y);
                                            }
                                        //decide on elasticbanding
                                        OldMousePositionScreen.x = X;
                                        OldMousePositionScreen.y = Y;
                                        if (pointbeingdragged == 0) {
                                            StartPointChart.x = Location.X;
                                            StartPointChart.y = Location.Y;
                                            StartPointScreen.x = X;
                                            StartPointScreen.y = Y;
                                            }
                                        if (pointbeingdragged == (PolyLineList[arraypointer].Corners.Length - 1)) {
                                            EndPointChart.x = Location.X;
                                            EndPointChart.y = Location.Y;
                                            EndPointScreen.x = X;
                                            EndPointScreen.y = Y;
                                            }
                                        for (int i = 0; i < PolyLineList[arraypointer].Corners.Length; i++) {
                                            if (i != pointbeingdragged) {
                                                SP = FindImage1Position(PolyLineList[arraypointer].Corners[i].x,PolyLineList[arraypointer].Corners[i].y);
                                                Rectangle.Left = SP.X - 1;
                                                Rectangle.Top = SP.Y - 1;
                                                Rectangle.Right = SP.X + 1 + SquareSize;
                                                Rectangle.Bottom = SP.Y + 1 + SquareSize;
                                                Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                                }
                                            }
                                        Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                        Image1->Picture->Bitmap->Canvas->LineTo(OldMousePositionScreen.x,OldMousePositionScreen.y);
                                        Image1->Picture->Bitmap->Canvas->LineTo(EndPointScreen.x,EndPointScreen.y);
                                        Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                        wipedout = false;
                                        } else {
                                        //Looking for a point to move. There will be a rectangle around each pixel that's a corner and a treble one around the nearest
                                        TRect Rectangle;
                                        chartposition SP;
                                        if (!wipedout) {
                                            //clear annotations
                                            TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                            Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                            Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                            Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                            //rectangles around corners
                                            for (int i = 0; i < PolyLineList[arraypointer].Corners.Length; i++) {
                                                SP = FindImage1Position(PolyLineList[arraypointer].Corners[i].x,PolyLineList[arraypointer].Corners[i].y);
                                                Rectangle.Left = SP.X - 1;
                                                Rectangle.Top = SP.Y - 1;
                                                Rectangle.Right = SP.X + 1 + SquareSize;
                                                Rectangle.Bottom = SP.Y + 1 + SquareSize;
                                                Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                                }
                                            //rectangles around nearest
                                            SP = FindImage1Position(PolyLineList[arraypointer].Corners[pointbeingdragged].x,PolyLineList[arraypointer].Corners[pointbeingdragged].y);
                                            Rectangle.Left = SP.X - 3;
                                            Rectangle.Top = SP.Y - 3;
                                            Rectangle.Right = SP.X + 3 + SquareSize;
                                            Rectangle.Bottom = SP.Y + 3 + SquareSize;
                                            Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                            Rectangle.Left = SP.X - 5;
                                            Rectangle.Top = SP.Y - 5;
                                            Rectangle.Right = SP.X + 5 + SquareSize;
                                            Rectangle.Bottom = SP.Y + 5 + SquareSize;
                                            Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                            Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                            wipedout = true;
                                            }
                                        //now to find which point is closest to the current mouse position
                                        int distance = (PolyLineList[arraypointer].Corners[0].x - Location.X) * (PolyLineList[arraypointer].Corners[0].x - Location.X) + (PolyLineList[arraypointer].Corners[0].y - Location.Y) * (PolyLineList[arraypointer].Corners[0].y - Location.Y);
                                        int value;
                                        pointbeingdragged = 0;
                                        for (int i = 1; i < PolyLineList[arraypointer].Corners.Length; i++) {
                                            value = (PolyLineList[arraypointer].Corners[i].x - Location.X) * (PolyLineList[arraypointer].Corners[i].x - Location.X) + (PolyLineList[arraypointer].Corners[i].y - Location.Y) * (PolyLineList[arraypointer].Corners[i].y - Location.Y);
                                            if (value < distance) {
                                                distance = value;
                                                pointbeingdragged = i;
                                                }
                                            }
                                        OldMousePositionScreen.x = X;
                                        OldMousePositionScreen.y = Y;
                                        //now to re-display the points
                                        //draw annotations
                                        TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                        Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                        Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                        Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                        //rectangles around corners
                                        for (int i = 0; i < PolyLineList[arraypointer].Corners.Length; i++) {
                                            SP = FindImage1Position(PolyLineList[arraypointer].Corners[i].x,PolyLineList[arraypointer].Corners[i].y);
                                            Rectangle.Left = SP.X - 1;
                                            Rectangle.Top = SP.Y - 1;
                                            Rectangle.Right = SP.X + 1 + SquareSize;
                                            Rectangle.Bottom = SP.Y + 1 + SquareSize;
                                            Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                            }
                                        //rectangles around nearest
                                        SP = FindImage1Position(PolyLineList[arraypointer].Corners[pointbeingdragged].x,PolyLineList[arraypointer].Corners[pointbeingdragged].y);
                                        Rectangle.Left = SP.X - 3;
                                        Rectangle.Top = SP.Y - 3;
                                        Rectangle.Right = SP.X + 3 + SquareSize;
                                        Rectangle.Bottom = SP.Y + 3 + SquareSize;
                                        Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                        Rectangle.Left = SP.X - 5;
                                        Rectangle.Top = SP.Y - 5;
                                        Rectangle.Right = SP.X + 5 + SquareSize;
                                        Rectangle.Bottom = SP.Y + 5 + SquareSize;
                                        Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                        Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                        wipedout = false;
                                        }
                                    }
                                }
                                break;
            case TBlockArray:   {
                                //displays the linear array of blocks being considered
                                //first find block item being copied.
                                bool found = false;
                                int pointer = 0;
                                while (!found && pointer < DisplayList.Length) {
                                    if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayBlock) {
                                        found = true;
                                        pointer--;
                                        }
                                    pointer++;
                                    }
                                if (found) {
                                    TPoint delta;
                                    TRect Rectangle;
                                    int swap;
                                    if (!wipedout) {
                                        //want a line to the mouse point and a rectangle offset at each selected object
                                        TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                        Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                        Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                        Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                        Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                        Image1->Picture->Bitmap->Canvas->LineTo(OldMousePositionScreen.x,OldMousePositionScreen.y);
                                        Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                        if (LinearArray.x > 1) {
                                            delta.x = (OldMousePositionScreen.x - StartPointScreen.x)/(LinearArray.x - 1);
                                            } else {
                                            delta.x = 0;
                                            }
                                        if (LinearArray.y > 1) {
                                            delta.y = (OldMousePositionScreen.y - StartPointScreen.y)/(LinearArray.y - 1);
                                            } else {
                                            delta.y = 0;
                                            }
                                        for (int i = 0; i < LinearArray.x; i++) {
                                            for (int j = 0; j < LinearArray.y; j++) {
                                                Rectangle = FindImage1Position(DisplayList[pointer].Area);
                                                Rectangle.Left += delta.x * i;
                                                Rectangle.Top += delta.y * j;
                                                Rectangle.Right += delta.x * i;
                                                Rectangle.Bottom += delta.y * j;
                                                if (Rectangle.Left > Rectangle.Right) {
                                                    swap = Rectangle.Right;
                                                    Rectangle.Right = Rectangle.Left;
                                                    Rectangle.Left = swap;
                                                    }
                                                if (Rectangle.Top > Rectangle.Bottom) {
                                                    swap = Rectangle.Bottom;
                                                    Rectangle.Bottom = Rectangle.Top;
                                                    Rectangle.Top = swap;
                                                    }
                                                Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                                }
                                            }
                                        wipedout = true;
                                        }
                                    OldMousePositionScreen.x = X;
                                    OldMousePositionScreen.y = Y;
                                    //want a line to the mouse point and a rectangle offset at each selected object
                                    TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                    Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                    Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                    Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                    Image1->Picture->Bitmap->Canvas->LineTo(OldMousePositionScreen.x,OldMousePositionScreen.y);
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                    if (LinearArray.x > 1) {
                                        delta.x = (OldMousePositionScreen.x - StartPointScreen.x)/(LinearArray.x - 1);
                                        } else {
                                        delta.x = 0;
                                        }
                                    if (LinearArray.y > 1) {
                                        delta.y = (OldMousePositionScreen.y - StartPointScreen.y)/(LinearArray.y - 1);
                                        } else {
                                        delta.y = 0;
                                        }
                                    for (int i = 0; i < LinearArray.x; i++) {
                                        for (int j = 0; j < LinearArray.y; j++) {
                                            Rectangle = FindImage1Position(DisplayList[pointer].Area);
                                            Rectangle.Left += delta.x * i;
                                            Rectangle.Top += delta.y * j;
                                            Rectangle.Right += delta.x * i;
                                            Rectangle.Bottom += delta.y * j;
                                            if (Rectangle.Left > Rectangle.Right) {
                                                swap = Rectangle.Right;
                                                Rectangle.Right = Rectangle.Left;
                                                Rectangle.Left = swap;
                                                }
                                            if (Rectangle.Top > Rectangle.Bottom) {
                                                swap = Rectangle.Bottom;
                                                Rectangle.Bottom = Rectangle.Top;
                                                Rectangle.Top = swap;
                                                }
                                            Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                            }
                                        }
                                    wipedout = false;
                                    }
                                }
                                break;
            case TEditErasePoints:  {
                                //Editing Erase Item
                                //first find erase item being edited.
                                bool found = false;
                                int pointer = 0;
                                while (!found && pointer < DisplayList.Length) {
                                    if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayEraseItem) {
                                        found = true;
                                        pointer--;
                                        }
                                    pointer++;
                                    }
                                int entitypointer;
                                if (found) {
                                    found = false;
                                    entitypointer = XRefs[DisplayList[pointer].ItemNumber].EntityXRef;
                                    if (entitypointer > -1 && entitypointer < EraseList.Length && EraseList[entitypointer].ItemNumber == DisplayList[pointer].ItemNumber) found = true;
                                    }
                                if (found) {
                                    //now know which one is being edited
                                    //find if Location is in the list of drawn pixels
                                    found = false;
                                    pointer = 0;
                                    while (!found && pointer < EraseList[entitypointer].Points.Length) {
                                        if (Location.X == EraseList[entitypointer].Points[pointer].x && Location.Y == EraseList[entitypointer].Points[pointer].y) found = true;
                                        pointer++;
                                        }
                                    if (Shift.Contains(ssLeft) || Shift.Contains(ssMiddle) ) {
                                        //adding point
                                        if (!found) {
                                            EraseList[entitypointer].Points.Length++;
                                            EraseList[entitypointer].Points[pointer].x = Location.X;
                                            EraseList[entitypointer].Points[pointer].y = Location.Y;
                                            EraseList[entitypointer].Points[pointer].Colour = Picture->Canvas->Pixels[Location.X][Location.Y];
                                            DrawPicture();
                                            }
                                        } else {
                                        //deleting point
                                        if (found && Shift.Contains(ssRight)) {
                                            for (int i = pointer; i < EraseList[entitypointer].Points.Length; i++) {
                                                EraseList[entitypointer].Points[i-1] = EraseList[entitypointer].Points[i];
                                                }
                                            EraseList[entitypointer].Points.Length--;
                                            DrawPicture();
                                            }
                                        }
                                    }
                                }
                                break;
            case TEditBlockPoints:  {
                                //Editing block points
                                //first find block being edited.
                                bool found = false;
                                int pointer = 0;
                                while (!found && pointer < DisplayList.Length) {
                                    if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayBlock) {
                                        found = true;
                                        pointer--;
                                        }
                                    pointer++;
                                    }
                                int entitypointer;
                                if (found) {
                                    found = false;
                                    entitypointer = XRefs[DisplayList[pointer].ItemNumber].EntityXRef;
                                    if (entitypointer > -1 && entitypointer < BlockList.Length && BlockList[entitypointer].ItemNumber == DisplayList[pointer].ItemNumber) found = true;
                                    }
                                if (found) {
                                    //now know which one is being edited
                                    //find if Location is in the list of drawn pixels
                                    found = false;
                                    pointer = 0;
                                    while (!found && pointer < BlockList[entitypointer].Points.Length) {
                                        //if (Location.X == BlockList[entitypointer].Points[pointer].x && Location.Y == BlockList[entitypointer].Points[pointer].y) found = true;
                                        if (Location.X == BlockList[entitypointer].Points[pointer].originalx && Location.Y == BlockList[entitypointer].Points[pointer].originaly) found = true;
                                        pointer++;
                                        }
                                    if (Shift.Contains(ssLeft) || Shift.Contains(ssMiddle) ) {
                                        //adding pixel
                                        if (!found) {
                                            BlockList[entitypointer].Points.Length++;
                                            //BlockList[entitypointer].Points[pointer].x = Location.X;
                                            //BlockList[entitypointer].Points[pointer].y = Location.Y;
                                            BlockList[entitypointer].Points[pointer].originalx = Location.X;
                                            BlockList[entitypointer].Points[pointer].originaly = Location.Y;
                                            BlockList[entitypointer].Points[pointer].Colour = ForegroundColour;
                                            BlockList[entitypointer].Points[pointer].transparent = false;
                                            DrawPicture();
                                            } else {
                                            pointer--;
                                            BlockList[entitypointer].Points[pointer].Colour = ForegroundColour;
                                            BlockList[entitypointer].Points[pointer].transparent = false;
                                            DrawPicture();
                                            }
                                        } else {
                                        //deleting pixel
                                        if (found && Shift.Contains(ssRight)) {
                                            for (int i = pointer; i < BlockList[entitypointer].Points.Length; i++) {
                                                BlockList[entitypointer].Points[i-1] = BlockList[entitypointer].Points[i];
                                                }
                                            BlockList[entitypointer].Points.Length--;
                                            DrawPicture();
                                            }
                                        }
                                    }
                                }
                                break;
            case TEditPointPoints:  {
                                //Editing points
                                //first find point being edited.
                                bool found = false;
                                int pointer = 0;
                                while (!found && pointer < DisplayList.Length) {
                                    if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayPoint) {
                                        found = true;
                                        pointer--;
                                        }
                                    pointer++;
                                    }
                                int entitypointer;
                                if (found) {
                                    found = false;
                                    entitypointer = XRefs[DisplayList[pointer].ItemNumber].EntityXRef;
                                    if (entitypointer > -1 && entitypointer < PointList.Length && PointList[entitypointer].ItemNumber == DisplayList[pointer].ItemNumber) found = true;
                                    }
                                if (found) {
                                    //now know which one is being edited
                                    //find if Location is in the list of drawn pixels
                                    found = false;
                                    pointer = 0;
                                    while (!found && pointer < PointList[entitypointer].Points.Length) {
                                        if (Location.X == PointList[entitypointer].Points[pointer].x && Location.Y == PointList[entitypointer].Points[pointer].y) found = true;
                                        pointer++;
                                        }
                                    if (Shift.Contains(ssLeft) || Shift.Contains(ssMiddle) ) {
                                        //adding point
                                        if (!found) {
                                            PointList[entitypointer].Points.Length++;
                                            PointList[entitypointer].Points[pointer].x = Location.X;
                                            PointList[entitypointer].Points[pointer].y = Location.Y;
                                            DrawPicture();
                                            }
                                        } else {
                                        //deleting point
                                        if (found && Shift.Contains(ssRight)) {
                                            for (int i = pointer; i < PointList[entitypointer].Points.Length; i++) {
                                                PointList[entitypointer].Points[i-1] = PointList[entitypointer].Points[i];
                                                }
                                            PointList[entitypointer].Points.Length--;
                                            DrawPicture();
                                            }
                                        }
                                    }
                                }
                                break;
            case TTextItem:     {
                                Image1->Picture->Bitmap->Canvas->Font->Name = DefaultText.Name;
                                Image1->Picture->Bitmap->Canvas->Font->Height = DefaultText.Height;
                                TRect Rectangle;
                                if (!wipedout) {
                                    Rectangle.Left = StartPointScreen.x;
                                    Rectangle.Top = StartPointScreen.y;
                                    Rectangle.Right = OldMousePositionScreen.x;
                                    Rectangle.Bottom = OldMousePositionScreen.y;
                                    Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                    wipedout = true;
                                    }
                                chartposition SP;
                                SP = FindImage1Position(Location.X,Location.Y);
                                StartPointScreen.x = SP.X;
                                StartPointScreen.y = SP.Y;
                                OldMousePositionScreen.x = StartPointScreen.x + SquareSize * Image1->Picture->Bitmap->Canvas->TextWidth(DefaultText.Text);
                                OldMousePositionScreen.y = StartPointScreen.y + SquareSize * Image1->Picture->Bitmap->Canvas->TextHeight(DefaultText.Text);
                                Rectangle.Left = StartPointScreen.x;
                                Rectangle.Top = StartPointScreen.y;
                                Rectangle.Right = OldMousePositionScreen.x;
                                Rectangle.Bottom = OldMousePositionScreen.y;
                                Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                wipedout = false;
                                }
                                break;
        case TMirrorItem:       {
                                if (Shift.Contains(ssLeft)) {
                                    int v1;
                                    int v2;
                                    TPoint delta;
                                    TMirrorAxis Axis;
                                    TPenMode oldmode;
                                    TRect Rectangle;
                                    int swap;
                                    if (!wipedout) {
                                        //want a vertical or horizontal line to the mouse point and a mirrored rectangle for each selected object
                                        v1 = abs(OldMousePositionScreen.x - StartPointScreen.x);
                                        v2 = abs(OldMousePositionScreen.y - StartPointScreen.y);
                                        Axis = TMAHorizontal;
                                        if (v2 > v1) Axis = TMAVertical;
                                        delta.x = 0;
                                        delta.y = 0;
                                        if (Axis == TMAHorizontal) {
                                            delta.x = OldMousePositionScreen.x - StartPointScreen.x;
                                            } else {
                                            delta.y = OldMousePositionScreen.y - StartPointScreen.y;
                                            }
                                        oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                        Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                        Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                        Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                        Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                        Image1->Picture->Bitmap->Canvas->LineTo(StartPointScreen.x + delta.x,StartPointScreen.y + delta.y);
                                        Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;


                                        for (int i = 0; i < DisplayList.Length; i++) {
                                            if (DisplayList[i].selected && DisplayList[i].visible) {
                                                Rectangle = FindImage1Position(DisplayList[i].Area);
                                                Rectangle = MirrorRectanglePoints(Rectangle,StartPointScreen,Axis);
                                                if (Rectangle.Left > Rectangle.Right) {
                                                    swap = Rectangle.Right;
                                                    Rectangle.Right = Rectangle.Left;
                                                    Rectangle.Left = swap;
                                                    }
                                                if (Rectangle.Top > Rectangle.Bottom) {
                                                    swap = Rectangle.Bottom;
                                                    Rectangle.Bottom = Rectangle.Top;
                                                    Rectangle.Top = swap;
                                                    }
                                                Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                                }
                                            }
                                        wipedout = true;
                                        }
                                    OldMousePositionScreen.x = X;
                                    OldMousePositionScreen.y = Y;
                                    //want a vertical or horizontal line to the mouse point and a mirrored rectangle for each selected object
                                    v1 = abs(OldMousePositionScreen.x - StartPointScreen.x);
                                    v2 = abs(OldMousePositionScreen.y - StartPointScreen.y);
                                    Axis = TMAHorizontal;
                                    if (v2 > v1) Axis = TMAVertical;
                                    delta.x = 0;
                                    delta.y = 0;
                                    if (Axis == TMAHorizontal) {
                                        delta.x = OldMousePositionScreen.x - StartPointScreen.x;
                                        } else {
                                        delta.y = OldMousePositionScreen.y - StartPointScreen.y;
                                        }
                                    oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                    Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                    Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                    Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                    Image1->Picture->Bitmap->Canvas->LineTo(StartPointScreen.x + delta.x,StartPointScreen.y + delta.y);
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;


                                    for (int i = 0; i < DisplayList.Length; i++) {
                                        if (DisplayList[i].selected && DisplayList[i].visible) {
                                            Rectangle = FindImage1Position(DisplayList[i].Area);
                                            Rectangle = MirrorRectanglePoints(Rectangle,StartPointScreen,Axis);
                                            if (Rectangle.Left > Rectangle.Right) {
                                                swap = Rectangle.Right;
                                                Rectangle.Right = Rectangle.Left;
                                                Rectangle.Left = swap;
                                                }
                                            if (Rectangle.Top > Rectangle.Bottom) {
                                                swap = Rectangle.Bottom;
                                                Rectangle.Bottom = Rectangle.Top;
                                                Rectangle.Top = swap;
                                                }
                                            Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                            }
                                        }
                                    wipedout = false;
                                    }
                                }
                                break;
            case TRotateItem:   {
                                if (Shift.Contains(ssLeft)) {
                                    double angle;
                                    TPoint delta;
                                    TPoint Points[4];
                                    TRect Rectangle;
                                    TPoint temp;
                                    TPenMode oldmode;
                                    if (!wipedout) {
                                        //want a line to the mouse point and a rectangle rotated for each selected object
                                        oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                        Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                        Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                        Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                        Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                        Image1->Picture->Bitmap->Canvas->LineTo(OldMousePositionScreen.x,OldMousePositionScreen.y);
                                        //find angle of mousepoint relative to centre
                                        delta.x = OldMousePositionScreen.x - StartPointScreen.x;
                                        delta.y = OldMousePositionScreen.y - StartPointScreen.y;
                                        //angle = ExtractAngle(delta);
                                        angle = OldAngle;
                                        //debug
                                        //Memo1->Lines->Add("Mouse Move: Wipeout, Angle = " + AnsiString(angle));
                                        //end debug
                                        //draw rotated rectangles
                                        for (int i = 0; i < DisplayList.Length; i++) {
                                            if (DisplayList[i].selected) {
                                                Rectangle = FindImage1Position(DisplayList[i].Area);
                                                temp.x = Rectangle.Left;
                                                temp.y = Rectangle.Top;
                                                Points[0] = RotateTPoint(temp,StartPointScreen,angle);
                                                temp.y = Rectangle.Bottom;
                                                Points[1] = RotateTPoint(temp,StartPointScreen,angle);
                                                temp.x = Rectangle.Right;
                                                Points[2] = RotateTPoint(temp,StartPointScreen,angle);
                                                temp.y = Rectangle.Top;
                                                Points[3] = RotateTPoint(temp,StartPointScreen,angle);
                                                Image1->Picture->Bitmap->Canvas->MoveTo(Points[0].x,Points[0].y);
                                                Image1->Picture->Bitmap->Canvas->LineTo(Points[1].x,Points[1].y);
                                                Image1->Picture->Bitmap->Canvas->LineTo(Points[2].x,Points[2].y);
                                                Image1->Picture->Bitmap->Canvas->LineTo(Points[3].x,Points[3].y);
                                                Image1->Picture->Bitmap->Canvas->LineTo(Points[0].x,Points[0].y);
                                                }
                                            }
                                        Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                        wipedout = true;
                                        }
                                    //right. That's the old one wiped out. Now get the angle
                                    delta.x = X - StartPointScreen.x;
                                    delta.y = Y - StartPointScreen.y;
                                    angle = ExtractAngle(delta);
                                    if (Shift.Contains(ssShift)) {
                                        //round angle to nearest 15 degrees
                                        angle = 15.0 * ROUND((angle + 7.5)/15.0,0);
                                        }
                                    OldAngle = angle;
                                    //get new 'effective' mouse point
                                    int l = (int)(sqrt((double)(delta.x * delta.x)+ (double)(delta.y * delta.y)) + 0.5);
                                    delta.x = StartPointScreen.x + l;
                                    delta.y = StartPointScreen.y;
                                        //debug
                                        //Memo1->Lines->Add("Mouse Move: Draw,    Angle = " + AnsiString(angle));
                                        //end debug
                                    OldMousePositionScreen = RotateTPoint(delta,StartPointScreen,angle);
                                    oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                    Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                    Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                    Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                    Image1->Picture->Bitmap->Canvas->LineTo(OldMousePositionScreen.x,OldMousePositionScreen.y);
                                    for (int i = 0; i < DisplayList.Length; i++) {
                                        if (DisplayList[i].selected) {
                                            Rectangle = FindImage1Position(DisplayList[i].Area);
                                            temp.x = Rectangle.Left;
                                            temp.y = Rectangle.Top;
                                            Points[0] = RotateTPoint(temp,StartPointScreen,angle);
                                            temp.y = Rectangle.Bottom;
                                            Points[1] = RotateTPoint(temp,StartPointScreen,angle);
                                            temp.x = Rectangle.Right;
                                            Points[2] = RotateTPoint(temp,StartPointScreen,angle);
                                            temp.y = Rectangle.Top;
                                            Points[3] = RotateTPoint(temp,StartPointScreen,angle);
                                            Image1->Picture->Bitmap->Canvas->MoveTo(Points[0].x,Points[0].y);
                                            Image1->Picture->Bitmap->Canvas->LineTo(Points[1].x,Points[1].y);
                                            Image1->Picture->Bitmap->Canvas->LineTo(Points[2].x,Points[2].y);
                                            Image1->Picture->Bitmap->Canvas->LineTo(Points[3].x,Points[3].y);
                                            Image1->Picture->Bitmap->Canvas->LineTo(Points[0].x,Points[0].y);
                                            }
                                        }
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                    wipedout = false;
                                    }
                                }
                                break;
            case TMoveItem:
            case TCopyItem:     {
                                if (dragging) {
                                    chartposition SP;
                                    if (Shift.Contains(ssShift)) {
                                        //Modify the input so that the line is vertical or horizontal if the 'Shift' key is pressed.
                                        //However, don't constrain if selecting
                                        int ref1 = abs(StartPointChart.x - Location.X);
                                        int ref2 = abs(StartPointChart.y - Location.Y);
                                        int ref3 = min(ref1,ref2);
                                        if (ref3 == ref2) {
                                            //free in X only
                                            Location.Y = StartPointChart.y;
                                            } else {
                                            //free in Y only
                                            Location.X = StartPointChart.x;
                                            }
                                        /*
                                        if (Location.X < StartPointChart.x) {
                                            Location.X = StartPointChart.x - ref3;
                                            if (Location.X < 0) Location.X = 0;
                                            } else {
                                            Location.X = StartPointChart.x + ref3;
                                            if (Location.X > (Picture->Width - 1)) Location.X = Picture->Width;
                                            }
                                        if (Location.Y < StartPointChart.y) {
                                            Location.Y = StartPointChart.y - ref3;
                                            if (Location.Y < 0) Location.Y = 0;
                                            } else {
                                            Location.Y = StartPointChart.y + ref3;
                                            if (Location.Y > (Picture->Height - 1)) Location.Y = Picture->Height;
                                            }
                                        */
                                        //make sure the end displays in the correct place
                                        SP = FindImage1Position(Location.X,Location.Y);
                                        X = SP.X;
                                        Y = SP.Y;
                                        }
                                    TRect Rectangle;
                                    int swap;
                                    TPoint delta;
                                    if (!wipedout) {
                                        //want a line to the mouse point and a rectangle offset at each selected object
                                        TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                        Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                        Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                        Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                        Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                        Image1->Picture->Bitmap->Canvas->LineTo(OldMousePositionScreen.x,OldMousePositionScreen.y);
                                        Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                        delta.x = OldMousePositionScreen.x - StartPointScreen.x;
                                        delta.y = OldMousePositionScreen.y - StartPointScreen.y;
                                        for (int i = 0; i < DisplayList.Length; i++) {
                                            if (DisplayList[i].selected) {
                                                Rectangle = FindImage1Position(DisplayList[i].Area);
                                                Rectangle.Left += delta.x;
                                                Rectangle.Top += delta.y;
                                                Rectangle.Right += delta.x;
                                                Rectangle.Bottom += delta.y;
                                                if (Rectangle.Left > Rectangle.Right) {
                                                    swap = Rectangle.Right;
                                                    Rectangle.Right = Rectangle.Left;
                                                    Rectangle.Left = swap;
                                                    }
                                                if (Rectangle.Top > Rectangle.Bottom) {
                                                    swap = Rectangle.Bottom;
                                                    Rectangle.Bottom = Rectangle.Top;
                                                    Rectangle.Top = swap;
                                                    }
                                                Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                                }
                                            }
                                        wipedout = true;
                                        }
                                    OldMousePositionScreen.x = X;
                                    OldMousePositionScreen.y = Y;
                                    //want a line to the mouse point and a rectangle offset at each selected object
                                    TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                    Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                    Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                    Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                    Image1->Picture->Bitmap->Canvas->LineTo(OldMousePositionScreen.x,OldMousePositionScreen.y);
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                    delta.x = OldMousePositionScreen.x - StartPointScreen.x;
                                    delta.y = OldMousePositionScreen.y - StartPointScreen.y;
                                    for (int i = 0; i < DisplayList.Length; i++) {
                                        if (DisplayList[i].selected) {
                                            Rectangle = FindImage1Position(DisplayList[i].Area);
                                            Rectangle.Left += delta.x;
                                            Rectangle.Top += delta.y;
                                            Rectangle.Right += delta.x;
                                            Rectangle.Bottom += delta.y;
                                            if (Rectangle.Left > Rectangle.Right) {
                                                swap = Rectangle.Right;
                                                Rectangle.Right = Rectangle.Left;
                                                Rectangle.Left = swap;
                                                }
                                            if (Rectangle.Top > Rectangle.Bottom) {
                                                swap = Rectangle.Bottom;
                                                Rectangle.Bottom = Rectangle.Top;
                                                Rectangle.Top = swap;
                                                }
                                            Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                            }
                                        }
                                    wipedout = false;
                                    } //end of 'if (dragging)'
                                }
                                break;
            case TChangeCircleSize:
            case TChangeRectangleSize:
            case TSelectItem:
            case TBlockItem:
            case TDrawCircle:
            case TDrawRectangle: {
                                if (dragging) {
                                    //currently drawing a rectangle
                                    chartposition SP;
                                    if (Shift.Contains(ssShift) && ActionType != TSelectItem) {
                                        //Modify the input so that the line is vertical or horizontal if the 'Shift' key is pressed.
                                        //However, don't constrain if selecting
                                        int ref1 = abs(StartPointChart.x - Location.X);
                                        int ref2 = abs(StartPointChart.y - Location.Y);
                                        int ref3 = min(ref1,ref2);
                                        if (Location.X < StartPointChart.x) {
                                            Location.X = StartPointChart.x - ref3;
                                            if (Location.X < 0) Location.X = 0;
                                            } else {
                                            Location.X = StartPointChart.x + ref3;
                                            if (Location.X > (Picture->Width - 1)) Location.X = Picture->Width;
                                            }
                                        if (Location.Y < StartPointChart.y) {
                                            Location.Y = StartPointChart.y - ref3;
                                            if (Location.Y < 0) Location.Y = 0;
                                            } else {
                                            Location.Y = StartPointChart.y + ref3;
                                            if (Location.Y > (Picture->Height - 1)) Location.Y = Picture->Height;
                                            }
                                        //make sure the end displays in the correct place
                                        SP = FindImage1Position(Location.X,Location.Y);
                                        X = SP.X;
                                        Y = SP.Y;
                                        }
                                    TRect Rectangle;
                                    if (!wipedout) {
                                        //want a rectangle to the mouse point
                                        Rectangle.Left = StartPointScreen.x;
                                        Rectangle.Top = StartPointScreen.y;
                                        Rectangle.Right = OldMousePositionScreen.x;
                                        Rectangle.Bottom = OldMousePositionScreen.y;
                                        int swap;
                                        if (Rectangle.Left > Rectangle.Right) {
                                            swap = Rectangle.Right;
                                            Rectangle.Right = Rectangle.Left;
                                            Rectangle.Left = swap;
                                            }
                                        if (Rectangle.Top > Rectangle.Bottom) {
                                            swap = Rectangle.Bottom;
                                            Rectangle.Bottom = Rectangle.Top;
                                            Rectangle.Top = swap;
                                            }
                                        Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                        if (ActionType == TDrawCircle || ActionType == TChangeCircleSize) {
                                            TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                            TBrushStyle oldstyle = Image1->Picture->Bitmap->Canvas->Brush->Style;
                                            Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                            Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                            Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                            Image1->Picture->Bitmap->Canvas->Brush->Style = bsClear;
                                            Image1->Picture->Bitmap->Canvas->Ellipse(Rectangle.Left,Rectangle.Top,Rectangle.Right,Rectangle.Bottom);
                                            Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                            Image1->Picture->Bitmap->Canvas->Brush->Style = oldstyle;
                                            }
                                        wipedout = true;
                                        }
                                    OldMousePositionScreen.x = X;
                                    OldMousePositionScreen.y = Y;
                                    Rectangle.Left = StartPointScreen.x;
                                    Rectangle.Top = StartPointScreen.y;
                                    Rectangle.Right = OldMousePositionScreen.x;
                                    Rectangle.Bottom = OldMousePositionScreen.y;
                                    int swap;
                                    if (Rectangle.Left > Rectangle.Right) {
                                        swap = Rectangle.Right;
                                        Rectangle.Right = Rectangle.Left;
                                        Rectangle.Left = swap;
                                        }
                                    if (Rectangle.Top > Rectangle.Bottom) {
                                        swap = Rectangle.Bottom;
                                        Rectangle.Bottom = Rectangle.Top;
                                        Rectangle.Top = swap;
                                        }
                                    Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                    if (ActionType == TDrawCircle || ActionType == TChangeCircleSize) {
                                        TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                        TBrushStyle oldstyle = Image1->Picture->Bitmap->Canvas->Brush->Style;
                                        Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                        Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                        Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                        Image1->Picture->Bitmap->Canvas->Brush->Style = bsClear;
                                        Image1->Picture->Bitmap->Canvas->Ellipse(Rectangle.Left,Rectangle.Top,Rectangle.Right,Rectangle.Bottom);
                                        Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                        Image1->Picture->Bitmap->Canvas->Brush->Style = oldstyle;
                                        }
                                    wipedout = false;
                                    }
                                }
                                break;
            case TEraseItem:    {
                                if (dragging) {
                                    //check to see if the point clicked on is already in the list
                                    if (DisplayList[DisplayList.Length - 1].DisplayType == TDisplayEraseItem && DisplayList[DisplayList.Length - 1].ItemNumber == EraseList[EraseList.Length - 1].ItemNumber) {
                                        bool found = false;
                                        int pointer = 0;
                                        while (!found && pointer < EraseList[EraseList.Length - 1].Points.Length) {
                                            if (Location.X == EraseList[EraseList.Length - 1].Points[pointer].x && Location.Y == EraseList[EraseList.Length - 1].Points[pointer].y) {
                                                found = true;
                                                }
                                            pointer++;
                                            }
                                        if (!found) {
                                            EraseList[EraseList.Length - 1].Points.Length++;
                                            EraseList[EraseList.Length - 1].Points[EraseList[EraseList.Length - 1].Points.Length - 1].x = Location.X;
                                            EraseList[EraseList.Length - 1].Points[EraseList[EraseList.Length - 1].Points.Length - 1].y = Location.Y;
                                            EraseList[EraseList.Length - 1].Points[EraseList[EraseList.Length - 1].Points.Length - 1].Colour = Picture->Canvas->Pixels[Location.X][Location.Y];
                                            //if (DisplayList[DisplayList.Length - 1].Area.left > Location.X) DisplayList[DisplayList.Length - 1].Area.left = Location.X;
                                            //if (DisplayList[DisplayList.Length - 1].Area.right < Location.X) DisplayList[DisplayList.Length - 1].Area.right = Location.X;
                                            //if (DisplayList[DisplayList.Length - 1].Area.top > Location.Y) DisplayList[DisplayList.Length - 1].Area.top = Location.Y;
                                            //if (DisplayList[DisplayList.Length - 1].Area.bottom < Location.Y) DisplayList[DisplayList.Length - 1].Area.bottom = Location.Y;
                                            DisplayListAreaUpdate(EraseList[EraseList.Length - 1].ItemNumber);
                                            DrawErase(EraseList[EraseList.Length - 1].ItemNumber, Image1->Picture->Bitmap->Canvas);
                                            }
                                        }
                                    }
                                }
                                break;
            case TDrawPolyLine:
            case TEditLineStart:
            case TEditLineEnd:
            case TDrawLine:     {
                                if (dragging) {
                                    //currently drawing a line
                                    chartposition SP;
                                    if (Shift.Contains(ssShift)) {
                                        //Modify the input so that the line is vertical or horizontal if the 'Shift' key is pressed.
                                        if (abs(StartPointChart.x - Location.X) > abs(StartPointChart.y - Location.Y)) {
                                            Location.Y = StartPointChart.y;
                                            } else {
                                            Location.X = StartPointChart.x;
                                            }
                                        //make sure the end displays in the correct place
                                        SP = FindImage1Position(Location.X,Location.Y);
                                        X = SP.X;
                                        Y = SP.Y;
                                        }
                                    if (!wipedout) {
                                        //want to erase the line to the old mouse point
                                        TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                        Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                        Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                        Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                        Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                        Image1->Picture->Bitmap->Canvas->LineTo(OldMousePositionScreen.x,OldMousePositionScreen.y);
                                        Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                        wipedout = true;
                                        }
                                    OldMousePositionScreen.x = X;
                                    OldMousePositionScreen.y = Y;
                                    //recalculate start pointscreen as it may be different from last calc
                                    SP = FindImage1Position(StartPointChart.x, StartPointChart.y);
                                    //now draw line
                                    TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                    Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                    Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                    Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                    Image1->Picture->Bitmap->Canvas->LineTo(OldMousePositionScreen.x,OldMousePositionScreen.y);
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                    wipedout = false;
                                    }
                                }
                                break;
            case TPixelEdit:    {
                                if (dragging) {
                                    //check to see if the point clicked on is already in the list
                                    bool found = false;
                                    int pointer = 0;
                                    while (!found && pointer < PointList[PointList.Length - 1].Points.Length) {
                                        if (Location.X == PointList[PointList.Length - 1].Points[pointer].x && Location.Y == PointList[PointList.Length - 1].Points[pointer].y) {
                                            found = true;
                                            }
                                        pointer++;
                                        }
                                    if (!found) {
                                        PointList[PointList.Length - 1].Points.Length++;
                                        PointList[PointList.Length - 1].Points[PointList[PointList.Length - 1].Points.Length - 1].x = Location.X;
                                        PointList[PointList.Length - 1].Points[PointList[PointList.Length - 1].Points.Length - 1].y = Location.Y;
                                        //if (DisplayList[DisplayList.Length - 1].Area.left > Location.X) DisplayList[DisplayList.Length - 1].Area.left = Location.X;
                                        //if (DisplayList[DisplayList.Length - 1].Area.right < Location.X) DisplayList[DisplayList.Length - 1].Area.right = Location.X;
                                        //if (DisplayList[DisplayList.Length - 1].Area.top > Location.Y) DisplayList[DisplayList.Length - 1].Area.top = Location.Y;
                                        //if (DisplayList[DisplayList.Length - 1].Area.bottom < Location.Y) DisplayList[DisplayList.Length - 1].Area.bottom = Location.Y;
                                        DisplayListAreaUpdate(PointList[PointList.Length - 1].ItemNumber);
                                        DrawPoints(PointList[PointList.Length - 1].ItemNumber, Image1->Picture->Bitmap->Canvas);
                                        }
                                    }
                                }
                                break;
            default:            break;
            }
        } else {
        Image1->Hint = "Chart Image";
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Image1MouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    //This forms the end point of some actions
    chartposition Location = FindMousePosition(X,Y);
    switch (ActionType) {
        case TEditFreeForm:     {
                                //find FreeForm being edited
                                bool found = false;
                                int pointer = 0;
                                int arraypointer;
                                while (!found && pointer < DisplayList.Length) {
                                    if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayFreeForm) {
                                        found = true;
                                        pointer--;
                                        }
                                    pointer++;
                                    }
                                if (found) {
                                    found = false;
                                    arraypointer = XRefs[DisplayList[pointer].ItemNumber].EntityXRef;
                                    if ( arraypointer > -1
                                        && arraypointer < FreeFormList.Length
                                        && FreeFormList[arraypointer].ItemNumber == DisplayList[pointer].ItemNumber
                                        ) found = true;
                                    }
                                if (found && dragging && pointbeingdragged > -1 && pointbeingdragged < FreeFormList[arraypointer].Corners.Length) {
                                    //are moving a point
                                    //now to start drawing the elastic band etc
                                    chartposition SP;
                                    TRect Rectangle;
                                    TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                    Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                    Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                    if (!wipedout) {
                                        //rectangles around corners except one being moved
                                        for (int i = 0; i < FreeFormList[arraypointer].Corners.Length; i++) {
                                            if (i != pointbeingdragged) {
                                                SP = FindImage1Position(FreeFormList[arraypointer].Corners[i].x,FreeFormList[arraypointer].Corners[i].y);
                                                Rectangle.Left = SP.X - 1;
                                                Rectangle.Top = SP.Y - 1;
                                                Rectangle.Right = SP.X + 1 + SquareSize;
                                                Rectangle.Bottom = SP.Y + 1 + SquareSize;
                                                Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                                }
                                            }
                                        Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                        Image1->Picture->Bitmap->Canvas->LineTo(OldMousePositionScreen.x,OldMousePositionScreen.y);
                                        Image1->Picture->Bitmap->Canvas->LineTo(EndPointScreen.x,EndPointScreen.y);
                                        wipedout = true;
                                        }
                                    //implement new position
                                    dragging = false;
                                    AddUndoTitle("Move Free-Form Shape Point");
                                    AddUndoChangeFreeForm(FreeFormList[arraypointer].ItemNumber);
                                    FreeFormList[arraypointer].Corners[pointbeingdragged].x = Location.X;
                                    FreeFormList[arraypointer].Corners[pointbeingdragged].y = Location.Y;
                                    FillPointsFreeForm(arraypointer,FreeFormList[arraypointer].ItemNumber);
                                    DisplayListAreaUpdate(FreeFormList[arraypointer].ItemNumber);
                                    DrawPicture();
                                    //show selection squares again
                                    for (int i = 0; i < FreeFormList[arraypointer].Corners.Length; i++) {
                                        SP = FindImage1Position(FreeFormList[arraypointer].Corners[i].x,FreeFormList[arraypointer].Corners[i].y);
                                        Rectangle.Left = SP.X - 1;
                                        Rectangle.Top = SP.Y - 1;
                                        Rectangle.Right = SP.X + 1 + SquareSize;
                                        Rectangle.Bottom = SP.Y + 1 + SquareSize;
                                        Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                        }
                                    //rectangles around nearest
                                    SP = FindImage1Position(FreeFormList[arraypointer].Corners[pointbeingdragged].x,FreeFormList[arraypointer].Corners[pointbeingdragged].y);
                                    Rectangle.Left = SP.X - 3;
                                    Rectangle.Top = SP.Y - 3;
                                    Rectangle.Right = SP.X + 3 + SquareSize;
                                    Rectangle.Bottom = SP.Y + 3 + SquareSize;
                                    Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                    Rectangle.Left = SP.X - 5;
                                    Rectangle.Top = SP.Y - 5;
                                    Rectangle.Right = SP.X + 5 + SquareSize;
                                    Rectangle.Bottom = SP.Y + 5 + SquareSize;
                                    Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                    wipedout = false;
                                    }
                                }
                                break;
        case TEditPolyLine:     {
                                //find polyline being edited
                                bool found = false;
                                int pointer = 0;
                                int arraypointer;
                                while (!found && pointer < DisplayList.Length) {
                                    if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayPolyLine) {
                                        found = true;
                                        pointer--;
                                        }
                                    pointer++;
                                    }
                                if (found) {
                                    found = false;
                                    arraypointer = XRefs[DisplayList[pointer].ItemNumber].EntityXRef;
                                    if ( arraypointer > -1
                                        && arraypointer < PolyLineList.Length
                                        && PolyLineList[arraypointer].ItemNumber == DisplayList[pointer].ItemNumber
                                        ) found = true;
                                    }
                                if (found && dragging && pointbeingdragged > -1 && pointbeingdragged < PolyLineList[arraypointer].Corners.Length) {
                                    //are moving a point
                                    //now to start drawing the elastic band etc
                                    chartposition SP;
                                    TRect Rectangle;
                                    TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                    Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                    Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                    if (!wipedout) {
                                        //rectangles around corners except one being moved
                                        for (int i = 0; i < PolyLineList[arraypointer].Corners.Length; i++) {
                                            if (i != pointbeingdragged) {
                                                SP = FindImage1Position(PolyLineList[arraypointer].Corners[i].x,PolyLineList[arraypointer].Corners[i].y);
                                                Rectangle.Left = SP.X - 1;
                                                Rectangle.Top = SP.Y - 1;
                                                Rectangle.Right = SP.X + 1 + SquareSize;
                                                Rectangle.Bottom = SP.Y + 1 + SquareSize;
                                                Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                                }
                                            }
                                        Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                        Image1->Picture->Bitmap->Canvas->LineTo(OldMousePositionScreen.x,OldMousePositionScreen.y);
                                        Image1->Picture->Bitmap->Canvas->LineTo(EndPointScreen.x,EndPointScreen.y);
                                        wipedout = true;
                                        }
                                    //implement new position
                                    dragging = false;
                                    AddUndoTitle("Move Polyline Point");
                                    AddUndoChangePolyLine(PolyLineList[arraypointer].ItemNumber);
                                    PolyLineList[arraypointer].Corners[pointbeingdragged].x = Location.X;
                                    PolyLineList[arraypointer].Corners[pointbeingdragged].y = Location.Y;
                                    FillPointsPolyLine(arraypointer,PolyLineList[arraypointer].ItemNumber);
                                    DisplayListAreaUpdate(PolyLineList[arraypointer].ItemNumber);
                                    DrawPicture();
                                    //show selection squares again
                                    for (int i = 0; i < PolyLineList[arraypointer].Corners.Length; i++) {
                                        SP = FindImage1Position(PolyLineList[arraypointer].Corners[i].x,PolyLineList[arraypointer].Corners[i].y);
                                        Rectangle.Left = SP.X - 1;
                                        Rectangle.Top = SP.Y - 1;
                                        Rectangle.Right = SP.X + 1 + SquareSize;
                                        Rectangle.Bottom = SP.Y + 1 + SquareSize;
                                        Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                        }
                                    //rectangles around nearest
                                    SP = FindImage1Position(PolyLineList[arraypointer].Corners[pointbeingdragged].x,PolyLineList[arraypointer].Corners[pointbeingdragged].y);
                                    Rectangle.Left = SP.X - 3;
                                    Rectangle.Top = SP.Y - 3;
                                    Rectangle.Right = SP.X + 3 + SquareSize;
                                    Rectangle.Bottom = SP.Y + 3 + SquareSize;
                                    Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                    Rectangle.Left = SP.X - 5;
                                    Rectangle.Top = SP.Y - 5;
                                    Rectangle.Right = SP.X + 5 + SquareSize;
                                    Rectangle.Bottom = SP.Y + 5 + SquareSize;
                                    Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                    wipedout = false;
                                    }
                                }
                                break;
        case TMirrorItem:       {
                                if (Button == mbLeft) {
                                    int v1;
                                    int v2;
                                    TPoint delta;
                                    TMirrorAxis Axis;
                                    TPenMode oldmode;
                                    TRect Rectangle;
                                    int swap;
                                    if (!wipedout) {
                                        //want a vertical or horizontal line to the mouse point and a mirrored rectangle for each selected object
                                        v1 = abs(OldMousePositionScreen.x - StartPointScreen.x);
                                        v2 = abs(OldMousePositionScreen.y - StartPointScreen.y);
                                        Axis = TMAHorizontal;
                                        if (v2 > v1) Axis = TMAVertical;
                                        delta.x = 0;
                                        delta.y = 0;
                                        if (Axis == TMAHorizontal) {
                                            delta.x = OldMousePositionScreen.x - StartPointScreen.x;
                                            } else {
                                            delta.y = OldMousePositionScreen.y - StartPointScreen.y;
                                            }
                                        oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                        Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                        Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                        Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                        Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                        Image1->Picture->Bitmap->Canvas->LineTo(StartPointScreen.x + delta.x,StartPointScreen.y + delta.y);
                                        Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;


                                        for (int i = 0; i < DisplayList.Length; i++) {
                                            if (DisplayList[i].selected && DisplayList[i].visible) {
                                                Rectangle = FindImage1Position(DisplayList[i].Area);
                                                Rectangle = MirrorRectanglePoints(Rectangle,StartPointScreen,Axis);
                                                if (Rectangle.Left > Rectangle.Right) {
                                                    swap = Rectangle.Right;
                                                    Rectangle.Right = Rectangle.Left;
                                                    Rectangle.Left = swap;
                                                    }
                                                if (Rectangle.Top > Rectangle.Bottom) {
                                                    swap = Rectangle.Bottom;
                                                    Rectangle.Bottom = Rectangle.Top;
                                                    Rectangle.Top = swap;
                                                    }
                                                Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                                }
                                            }
                                        wipedout = true;
                                        }
                                    OldMousePositionScreen.x = X;
                                    OldMousePositionScreen.y = Y;
                                    //want a vertical or horizontal line to the mouse point and a mirrored rectangle for each selected object
                                    v1 = abs(OldMousePositionScreen.x - StartPointScreen.x);
                                    v2 = abs(OldMousePositionScreen.y - StartPointScreen.y);
                                    Axis = TMAHorizontal;
                                    if (v2 > v1) Axis = TMAVertical;
                                    SingleUndo = false;
                                    AnsiString text;
                                    if (Axis == TMAHorizontal) {
                                        text = "Horizontal";
                                        } else {
                                        text = "Vertical";
                                        }
                                    text += " Mirror of Selected Items.";
                                    AddUndoTitle(text);
                                    for (int i = 0; i < DisplayList.Length; i++) {
                                        if (DisplayList[i].selected && DisplayList[i].visible) {
                                            switch (DisplayList[i].DisplayType) {
                                                case TDisplayBlock:     {
                                                                        MirrorCopyBlock(StartPointChart,DisplayList[i].ItemNumber,Axis);
                                                                        }
                                                                        break;
                                                case TDisplayEraseItem: {
                                                                        MirrorCopyErase(StartPointChart,DisplayList[i].ItemNumber,Axis);
                                                                        }
                                                                        break;
                                                case TDisplayFreeForm:  {
                                                                        MirrorCopyFreeForm(StartPointChart,DisplayList[i].ItemNumber,Axis);
                                                                        }
                                                                        break;
                                                case TDisplayCircle:    {
                                                                        MirrorCopyCircle(StartPointChart,DisplayList[i].ItemNumber,Axis);
                                                                        }
                                                                        break;
                                                case TDisplayRectangle: {
                                                                        MirrorCopyRectangle(StartPointChart,DisplayList[i].ItemNumber,Axis);
                                                                        }
                                                                        break;
                                                case TDisplayText:      {
                                                                        //MirrorText(StartPointChart,DisplayList[i].ItemNumber,Axis);
                                                                        }
                                                                        break;
                                                case TDisplayFloodFill: {
                                                                        MirrorCopyFloodFill(StartPointChart,DisplayList[i].ItemNumber,Axis);
                                                                        }
                                                                        break;
                                                case TDisplayPolyLine:  {
                                                                        MirrorCopyPolyLine(StartPointChart,DisplayList[i].ItemNumber,Axis);
                                                                        }
                                                                        break;
                                                case TDisplayLine:      {
                                                                        MirrorCopyLine(StartPointChart,DisplayList[i].ItemNumber,Axis);
                                                                        }
                                                                        break;
                                                case TDisplayPoint:     {
                                                                        MirrorCopyPoint(StartPointChart,DisplayList[i].ItemNumber,Axis);
                                                                        }
                                                                        break;
                                                default:                break;
                                                }
                                            }
                                        }

                                    dragging = false;
                                    ActionType = TNoAction;
                                    ResetActionButtons();
                                    SingleUndo = true;
                                    DrawPicture();
                                    }
                                }
                                break;
            case TRotateItem:   {
                                if (Button == mbLeft) {
                                    double angle;
                                    TPoint delta;
                                    TPoint Points[4];
                                    TRect Rectangle;
                                    TPoint temp;
                                    TPenMode oldmode;
                                    if (!wipedout) {
                                        //want a line to the mouse point and a rectangle rotated for each selected object
                                        oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                        Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                        Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                        Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                        Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                        Image1->Picture->Bitmap->Canvas->LineTo(OldMousePositionScreen.x,OldMousePositionScreen.y);
                                        //find angle of mousepoint relative to centre
                                        delta.x = OldMousePositionScreen.x - StartPointScreen.x;
                                        delta.y = OldMousePositionScreen.y - StartPointScreen.y;
                                        //angle = ExtractAngle(delta);
                                        angle = OldAngle;
                                        //debug
                                        //Memo1->Lines->Add("Mouse Move: Wipeout, Angle = " + AnsiString(angle));
                                        //end debug
                                        //draw rotated rectangles
                                        for (int i = 0; i < DisplayList.Length; i++) {
                                            if (DisplayList[i].selected) {
                                                Rectangle = FindImage1Position(DisplayList[i].Area);
                                                temp.x = Rectangle.Left;
                                                temp.y = Rectangle.Top;
                                                Points[0] = RotateTPoint(temp,StartPointScreen,angle);
                                                temp.y = Rectangle.Bottom;
                                                Points[1] = RotateTPoint(temp,StartPointScreen,angle);
                                                temp.x = Rectangle.Right;
                                                Points[2] = RotateTPoint(temp,StartPointScreen,angle);
                                                temp.y = Rectangle.Top;
                                                Points[3] = RotateTPoint(temp,StartPointScreen,angle);
                                                Image1->Picture->Bitmap->Canvas->MoveTo(Points[0].x,Points[0].y);
                                                Image1->Picture->Bitmap->Canvas->LineTo(Points[1].x,Points[1].y);
                                                Image1->Picture->Bitmap->Canvas->LineTo(Points[2].x,Points[2].y);
                                                Image1->Picture->Bitmap->Canvas->LineTo(Points[3].x,Points[3].y);
                                                Image1->Picture->Bitmap->Canvas->LineTo(Points[0].x,Points[0].y);
                                                }
                                            }
                                        Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                        wipedout = true;
                                        }
                                    //right. That's the old one wiped out. Now get the angle
                                    delta.x = X - StartPointScreen.x;
                                    delta.y = Y - StartPointScreen.y;
                                    angle = ExtractAngle(delta);
                                    if (Shift.Contains(ssShift)) {
                                        //round angle to nearest 15 degrees
                                        angle = 15.0 * ROUND((angle + 7.5)/15.0,0);
                                        }
                                    OldAngle = angle;
                                    int Angle = (int) (ROUND(angle * 10,0));
                                    SingleUndo = false;
                                    AddUndoTitle("Rotate Selected Items " + AnsiString(angle) + " degrees.");
                                    for (int i = 0; i < DisplayList.Length; i++) {
                                        if (DisplayList[i].selected) {
                                            switch (DisplayList[i].DisplayType) {
                                                case TDisplayBlock:     {
                                                                        RotateBlock(StartPointChart,DisplayList[i].ItemNumber,Angle);
                                                                        //debug
                                                                        DebugBlock(XRefs[DisplayList[i].ItemNumber].EntityXRef);
                                                                        }
                                                                        break;
                                                case TDisplayEraseItem: {
                                                                        RotateErase(StartPointChart,DisplayList[i].ItemNumber,Angle);
                                                                        }
                                                                        break;
                                                case TDisplayFreeForm:  {
                                                                        RotateFreeForm(StartPointChart,DisplayList[i].ItemNumber,Angle);
                                                                        }
                                                                        break;
                                                case TDisplayCircle:    {
                                                                        RotateCircle(StartPointChart,DisplayList[i].ItemNumber,Angle);
                                                                        }
                                                                        break;
                                                case TDisplayRectangle: {
                                                                        RotateRectangle(StartPointChart,DisplayList[i].ItemNumber,Angle);
                                                                        }
                                                                        break;
                                                case TDisplayText:      {
                                                                        RotateText(StartPointChart,DisplayList[i].ItemNumber,Angle);
                                                                        }
                                                                        break;
                                                case TDisplayFloodFill: {
                                                                        RotateFloodFill(StartPointChart,DisplayList[i].ItemNumber,Angle);
                                                                        }
                                                                        break;
                                                case TDisplayPolyLine:  {
                                                                        RotatePolyLine(StartPointChart,DisplayList[i].ItemNumber,Angle);
                                                                        }
                                                                        break;
                                                case TDisplayLine:      {
                                                                        RotateLine(StartPointChart,DisplayList[i].ItemNumber,Angle);
                                                                        }
                                                                        break;
                                                case TDisplayPoint:     {
                                                                        RotatePoint(StartPointChart,DisplayList[i].ItemNumber,Angle);
                                                                        }
                                                                        break;
                                                default:                break;
                                                }
                                            }
                                        }

                                    dragging = false;
                                    ActionType = TNoAction;
                                    ResetActionButtons();
                                    SingleUndo = true;
                                    DrawPicture();
                                    }
                                }
                                break;
            case TMoveItem: {
                            chartposition SP;
                            if (Shift.Contains(ssShift)) {
                                //Modify the input so that the line is vertical or horizontal if the 'Shift' key is pressed.
                                int ref1 = abs(StartPointChart.x - Location.X);
                                int ref2 = abs(StartPointChart.y - Location.Y);
                                int ref3 = min(ref1,ref2);
                                if (ref3 == ref2) {
                                    //free in X only
                                    Location.Y = StartPointChart.y;
                                    } else {
                                    //free in Y only
                                    Location.X = StartPointChart.x;
                                    }
                                //make sure the end displays in the correct place
                                SP = FindImage1Position(Location.X,Location.Y);
                                X = SP.X;
                                Y = SP.Y;
                                }
                            TRect Rectangle;
                            int swap;
                            TPoint delta;
                            if (!wipedout) {
                                //want a line to the mouse point and a rectangle offset at each selected object
                                TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                Image1->Picture->Bitmap->Canvas->LineTo(OldMousePositionScreen.x,OldMousePositionScreen.y);
                                Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                delta.x = OldMousePositionScreen.x - StartPointScreen.x;
                                delta.y = OldMousePositionScreen.y - StartPointScreen.y;
                                for (int i = 0; i < DisplayList.Length; i++) {
                                    if (DisplayList[i].selected) {
                                        Rectangle = FindImage1Position(DisplayList[i].Area);
                                        Rectangle.Left += delta.x;
                                        Rectangle.Top += delta.y;
                                        Rectangle.Right += delta.x;
                                        Rectangle.Bottom += delta.y;
                                        if (Rectangle.Left > Rectangle.Right) {
                                            swap = Rectangle.Right;
                                            Rectangle.Right = Rectangle.Left;
                                            Rectangle.Left = swap;
                                            }
                                        if (Rectangle.Top > Rectangle.Bottom) {
                                            swap = Rectangle.Bottom;
                                            Rectangle.Bottom = Rectangle.Top;
                                            Rectangle.Top = swap;
                                            }
                                        Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                        }
                                    }
                                wipedout = true;
                                }
                            OldMousePositionScreen.x = X;
                            OldMousePositionScreen.y = Y;
                            //So, the ghost outlines have been deleted, now to do the moving.
                            delta.x = Location.X - StartPointChart.x;
                            delta.y = Location.Y - StartPointChart.y;
                            AddUndoTitle("Move Selected Objects X" + AnsiString(delta.x) + " Y" + AnsiString(delta.y));
                            SingleUndo = false;
                            for (int i = 0; i < DisplayList.Length; i++) {
                                if (DisplayList[i].selected) {
                                    if (deselectafteroperation){
                                        DisplayList[i].selected = false;
                                        AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                                        }
                                    switch (DisplayList[i].DisplayType) {
                                        case TDisplayBlock:     {
                                                                MoveBlock(delta,DisplayList[i].ItemNumber);
                                                                }
                                                                break;
                                        case TDisplayEraseItem: {
                                                                MoveErase(delta,DisplayList[i].ItemNumber);
                                                                }
                                                                break;
                                        case TDisplayFreeForm:  {
                                                                MoveFreeForm(delta,DisplayList[i].ItemNumber);
                                                                }
                                                                break;
                                        case TDisplayCircle:    {
                                                                MoveCircle(delta,DisplayList[i].ItemNumber);
                                                                }
                                                                break;
                                        case TDisplayRectangle: {
                                                                MoveRectangle(delta,DisplayList[i].ItemNumber);
                                                                }
                                                                break;
                                        case TDisplayText:      {
                                                                MoveText(delta,DisplayList[i].ItemNumber);
                                                                }
                                                                break;
                                        case TDisplayFloodFill: {
                                                                MoveFloodFill(delta,DisplayList[i].ItemNumber);
                                                                }
                                                                break;
                                        case TDisplayPolyLine:  {
                                                                MovePolyLine(delta,DisplayList[i].ItemNumber);
                                                                }
                                                                break;
                                        case TDisplayLine:      {
                                                                MoveLine(delta,DisplayList[i].ItemNumber);
                                                                }
                                                                break;
                                        case TDisplayPoint:     {
                                                                MovePoint(delta,DisplayList[i].ItemNumber);
                                                                }
                                                                break;
                                        default:                break;
                                        }
                                    //DisplayListAreaUpdate(DisplayList[i].ItemNumber);
                                    }
                                }
                            dragging = false;
                            ActionType = TNoAction;
                            ResetActionButtons();
                            SingleUndo = true;
                            DrawPicture();
                            }
                            break;
            case TCopyItem: {
                            chartposition SP;
                            if (Shift.Contains(ssShift)) {
                                //Modify the input so that the line is vertical or horizontal if the 'Shift' key is pressed.
                                int ref1 = abs(StartPointChart.x - Location.X);
                                int ref2 = abs(StartPointChart.y - Location.Y);
                                int ref3 = min(ref1,ref2);
                                if (ref3 == ref2) {
                                    //free in X only
                                    Location.Y = StartPointChart.y;
                                    } else {
                                    //free in Y only
                                    Location.X = StartPointChart.x;
                                    }
                                /*
                                if (Location.X < StartPointChart.x) {
                                    Location.X = StartPointChart.x - ref3;
                                    if (Location.X < 0) Location.X = 0;
                                    } else {
                                    Location.X = StartPointChart.x + ref3;
                                    if (Location.X > (Picture->Width - 1)) Location.X = Picture->Width;
                                    }
                                if (Location.Y < StartPointChart.y) {
                                    Location.Y = StartPointChart.y - ref3;
                                    if (Location.Y < 0) Location.Y = 0;
                                    } else {
                                    Location.Y = StartPointChart.y + ref3;
                                    if (Location.Y > (Picture->Height - 1)) Location.Y = Picture->Height;
                                    }
                                */
                                //make sure the end displays in the correct place
                                SP = FindImage1Position(Location.X,Location.Y);
                                X = SP.X;
                                Y = SP.Y;
                                }
                            TRect Rectangle;
                            int swap;
                            TPoint delta;
                            if (!wipedout) {
                                //want a line to the mouse point and a rectangle offset at each selected object
                                TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                Image1->Picture->Bitmap->Canvas->LineTo(OldMousePositionScreen.x,OldMousePositionScreen.y);
                                Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                delta.x = OldMousePositionScreen.x - StartPointScreen.x;
                                delta.y = OldMousePositionScreen.y - StartPointScreen.y;
                                for (int i = 0; i < DisplayList.Length; i++) {
                                    if (DisplayList[i].selected) {
                                        Rectangle = FindImage1Position(DisplayList[i].Area);
                                        Rectangle.Left += delta.x;
                                        Rectangle.Top += delta.y;
                                        Rectangle.Right += delta.x;
                                        Rectangle.Bottom += delta.y;
                                        if (Rectangle.Left > Rectangle.Right) {
                                            swap = Rectangle.Right;
                                            Rectangle.Right = Rectangle.Left;
                                            Rectangle.Left = swap;
                                            }
                                        if (Rectangle.Top > Rectangle.Bottom) {
                                            swap = Rectangle.Bottom;
                                            Rectangle.Bottom = Rectangle.Top;
                                            Rectangle.Top = swap;
                                            }
                                        Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                        }
                                    }
                                wipedout = true;
                                }
                            OldMousePositionScreen.x = X;
                            OldMousePositionScreen.y = Y;
                            //So, the ghost outlines have been deleted, now to do the copies
                            delta.x = Location.X - StartPointChart.x;
                            delta.y = Location.Y - StartPointChart.y;
                            int toppoint = DisplayList.Length;
                            //AnsiString UndoName = "Copy Entities (" + AnsiString(DisplayItemNumber) + ")";
                            SingleUndo = false;
                            AddUndoTitle("Copy Selected Items X" + AnsiString(delta.x) + " Y" + AnsiString(delta.y));
                            for (int i = 0; i < toppoint; i++) {
                                if (DisplayList[i].selected) {
                                    if (deselectafteroperation) {
                                        DisplayList[i].selected = false;
                                        AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                                        }
                                    DisplayList.Length++;
                                    switch (DisplayList[i].DisplayType) {
                                        case TDisplayBlock:     {
                                                                DisplayList[DisplayList.Length - 1] = CopyBlock(delta,DisplayList[i].ItemNumber);
                                                                }
                                                                break;
                                        case TDisplayEraseItem: {
                                                                DisplayList[DisplayList.Length - 1] = CopyErase(delta,DisplayList[i].ItemNumber);
                                                                }
                                                                break;
                                        case TDisplayFreeForm:  {
                                                                DisplayList[DisplayList.Length - 1] = CopyFreeForm(delta,DisplayList[i].ItemNumber);
                                                                }
                                                                break;
                                        case TDisplayCircle:    {
                                                                DisplayList[DisplayList.Length - 1] = CopyCircle(delta,DisplayList[i].ItemNumber);
                                                                }
                                                                break;
                                        case TDisplayRectangle: {
                                                                DisplayList[DisplayList.Length - 1] = CopyRectangle(delta,DisplayList[i].ItemNumber);
                                                                }
                                                                break;
                                        case TDisplayText:      {
                                                                DisplayList[DisplayList.Length - 1] = CopyText(delta,DisplayList[i].ItemNumber);
                                                                }
                                                                break;
                                        case TDisplayFloodFill: {
                                                                DisplayList[DisplayList.Length - 1] = CopyFloodFill(delta,DisplayList[i].ItemNumber);
                                                                }
                                                                break;
                                        case TDisplayPolyLine:  {
                                                                DisplayList[DisplayList.Length - 1] = CopyPolyLine(delta,DisplayList[i].ItemNumber);
                                                                }
                                                                break;
                                        case TDisplayLine:      {
                                                                DisplayList[DisplayList.Length - 1] = CopyLine(delta,DisplayList[i].ItemNumber);
                                                                }
                                                                break;
                                        case TDisplayPoint:     {
                                                                DisplayList[DisplayList.Length - 1] = CopyPoint(delta,DisplayList[i].ItemNumber);
                                                                }
                                                                break;
                                        default:                {
                                                                DisplayList.Length--;
                                                                }
                                                                break;
                                        }
                                    if (DisplayList.Length) DisplayListAreaUpdate(DisplayList[DisplayList.Length - 1].ItemNumber);
                                    }
                                }
                            //for (int i = toppoint; i < DisplayList.Length; i++) {
                            //    DisplayList[i].UndoName = UndoName;
                            //    }
                            dragging = false;
                            ActionType = TNoAction;
                            ResetActionButtons();
                            SingleUndo = true;
                            //no need to create xrefs - done with every DisplayListAreaUpdate
                            //CreateXRefs();
                            DrawPicture();
                            }
                            break;
        case TSelectItem:   {
                            //erase the rectangle
                            if (!wipedout) {
                                //want a rectangle to the mouse point
                                TRect Rectangle;
                                Rectangle.Left = StartPointScreen.x;
                                Rectangle.Top = StartPointScreen.y;
                                Rectangle.Right = OldMousePositionScreen.x;
                                Rectangle.Bottom = OldMousePositionScreen.y;
                                int swap;
                                if (Rectangle.Left > Rectangle.Right) {
                                    swap = Rectangle.Right;
                                    Rectangle.Right = Rectangle.Left;
                                    Rectangle.Left = swap;
                                    }
                                if (Rectangle.Top > Rectangle.Bottom) {
                                    swap = Rectangle.Bottom;
                                    Rectangle.Bottom = Rectangle.Top;
                                    Rectangle.Top = swap;
                                    }
                                Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                wipedout = true;
                                }
                            dragging = false;
                            //only respond if the left mouse button has been clicked.
                            if (Button == mbLeft && !Location.outofrange) {
                                if (Location.X == StartPointChart.x && Location.Y == StartPointChart.y) {
                                    //single click, no drag, so the only thing to be done is to select the item that's immediately under the mouse.
                                    int overdisplayitem = FindTopmostDisplayItem(Location.X,Location.Y);
                                    if (overdisplayitem > -1) {
                                        if (DisplayList[overdisplayitem].selected && Shift.Contains(ssCtrl)) {
                                            AddUndoTitle("Deselect Item " + AnsiString(DisplayList[overdisplayitem].ItemNumber));
                                            } else {
                                            AddUndoTitle("Select Item " + AnsiString(DisplayList[overdisplayitem].ItemNumber));
                                            }
                                        if (DisplayList[overdisplayitem].selected) {
                                            AddUndo("Select," + AnsiString(DisplayList[overdisplayitem].ItemNumber) + ",");
                                            } else {
                                            AddUndo("Deselect," + AnsiString(DisplayList[overdisplayitem].ItemNumber) + ",");
                                            }
                                        }
                                    if (!Shift.Contains(ssCtrl)) {
                                        for (int i = 0; i < DisplayList.Length; i++) {
                                            if (DisplayList[i].selected) AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                                            DisplayList[i].selected = false;
                                            }
                                        }
                                    if (overdisplayitem > -1) DisplayList[overdisplayitem].selected = !DisplayList[overdisplayitem].selected;
                                    DrawPicture();
                                    } else {
                                    //a rectangle was used to select the items. If the rectangle was dragged to the left, then it'll be selected if
                                    //any painted pixel falls inside the rectangle. If dragged to the right, it'll only be selected if the whole
                                    //object falls inside the rectangle.
                                    AddUndoTitle("Select Objects");
                                    if (!Shift.Contains(ssCtrl)) {
                                        for (int i = 0; i < DisplayList.Length; i++) {
                                            if (DisplayList[i].selected) AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                                            DisplayList[i].selected = false;
                                            }
                                        }
                                    bool SelectIfPartlyInside = (StartPointChart.x > Location.X);
                                    TRect Rectangle;
                                    Rectangle.Left = StartPointChart.x;
                                    Rectangle.Top = StartPointChart.y;
                                    Rectangle.Right = Location.X;
                                    Rectangle.Bottom = Location.Y;
                                    int swap;
                                    if (Rectangle.Left > Rectangle.Right) {
                                        swap = Rectangle.Right;
                                        Rectangle.Right = Rectangle.Left;
                                        Rectangle.Left = swap;
                                        }
                                    if (Rectangle.Top > Rectangle.Bottom) {
                                        swap = Rectangle.Bottom;
                                        Rectangle.Bottom = Rectangle.Top;
                                        Rectangle.Top = swap;
                                        }
                                    bool select;
                                    for (int i = 0; i < DisplayList.Length; i++) {
                                        if (SelectIfPartlyInside) {
                                            if (DisplayList[i].visible && (DisplayList[i].Area.Left <= Rectangle.Right
                                                || DisplayList[i].Area.Right >= Rectangle.Left )
                                                &&(DisplayList[i].Area.Top <= Rectangle.Bottom
                                                || DisplayList[i].Area.Bottom >= Rectangle.Top)) {
                                                switch (DisplayList[i].DisplayType) {
                                                    case TDisplayBlock:     {
                                                                            select = CheckBlockPixelsinArea(Rectangle,DisplayList[i].ItemNumber);
                                                                            }
                                                                            break;
                                                    case TDisplayEraseItem: {
                                                                            select = CheckErasePixelsinArea(Rectangle,DisplayList[i].ItemNumber);
                                                                            }
                                                                            break;
                                                    case TDisplayFreeForm:  {
                                                                            select = CheckFreeFormPixelsinArea(Rectangle,DisplayList[i].ItemNumber);
                                                                            }
                                                                            break;
                                                    case TDisplayCircle:    {
                                                                            select = CheckCirclePixelsinArea(Rectangle,DisplayList[i].ItemNumber);
                                                                            }
                                                                            break;
                                                    case TDisplayRectangle: {
                                                                            select = CheckRectanglePixelsinArea(Rectangle,DisplayList[i].ItemNumber);
                                                                            }
                                                                            break;
                                                    case TDisplayText:      {
                                                                            select = CheckTextPixelsinArea(Rectangle,DisplayList[i].ItemNumber);
                                                                            }
                                                                            break;
                                                    case TDisplayFloodFill: {
                                                                            select = CheckFloodFillPixelsinArea(Rectangle,DisplayList[i].ItemNumber);
                                                                            }
                                                                            break;
                                                    case TDisplayPolyLine:  {
                                                                            select = CheckPolyLinePixelsinArea(Rectangle,DisplayList[i].ItemNumber);
                                                                            }
                                                                            break;
                                                    case TDisplayLine:      {
                                                                            select = CheckLinePixelsinArea(Rectangle,DisplayList[i].ItemNumber);
                                                                            }
                                                                            break;
                                                    case TDisplayPoint:     {
                                                                            select = CheckPointPixelsinArea(Rectangle,DisplayList[i].ItemNumber);
                                                                            }
                                                                            break;
                                                    default:                break;
                                                    }
                                                if (select) DisplayList[i].selected = true;
                                                }
                                            } else {
                                            //check if completely inside
                                            if (DisplayList[i].visible && DisplayList[i].Area.Left >= Rectangle.Left
                                                    &&  DisplayList[i].Area.Right <= Rectangle.Right
                                                    && DisplayList[i].Area.Top >= Rectangle.Top
                                                    && DisplayList[i].Area.Bottom <= Rectangle.Bottom) {
                                                    if (!DisplayList[i].selected) AddUndo("Deselect," + AnsiString(DisplayList[i].ItemNumber) + ",");
                                                    DisplayList[i].selected = true;
                                                    }
                                            }
                                        }
                                    DrawPicture();
                                    }
                                }
                            }
                            break;
        case TBlockItem:    {
                            if (!Location.outofrange) {
                                chartposition SP;
                                if (Shift.Contains(ssShift)) {
                                    //Modify the input so that the line is vertical or horizontal if the 'Shift' key is pressed.
                                    int ref1 = abs(StartPointChart.x - Location.X);
                                    int ref2 = abs(StartPointChart.y - Location.Y);
                                    int ref3 = min(ref1,ref2);
                                    if (Location.X < StartPointChart.x) {
                                        Location.X = StartPointChart.x - ref3;
                                        if (Location.X < 0) Location.X = 0;
                                        } else {
                                        Location.X = StartPointChart.x + ref3;
                                        if (Location.X > (Picture->Width - 1)) Location.X = Picture->Width;
                                        }
                                    if (Location.Y < StartPointChart.y) {
                                        Location.Y = StartPointChart.y - ref3;
                                        if (Location.Y < 0) Location.Y = 0;
                                        } else {
                                        Location.Y = StartPointChart.y + ref3;
                                        if (Location.Y > (Picture->Height - 1)) Location.Y = Picture->Height;
                                        }
                                    //make sure the end displays in the correct place
                                    SP = FindImage1Position(Location.X,Location.Y);
                                    X = SP.X;
                                    Y = SP.Y;
                                    }
                                TRect Rectangle;
                                if (!wipedout) {
                                    //want a rectangle to the mouse point
                                    Rectangle.Left = StartPointScreen.x;
                                    Rectangle.Top = StartPointScreen.y;
                                    Rectangle.Right = OldMousePositionScreen.x;
                                    Rectangle.Bottom = OldMousePositionScreen.y;
                                    int swap;
                                    if (Rectangle.Left > Rectangle.Right) {
                                        swap = Rectangle.Right;
                                        Rectangle.Right = Rectangle.Left;
                                        Rectangle.Left = swap;
                                        }
                                    if (Rectangle.Top > Rectangle.Bottom) {
                                        swap = Rectangle.Bottom;
                                        Rectangle.Bottom = Rectangle.Top;
                                        Rectangle.Top = swap;
                                        }
                                    Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                    wipedout = true;
                                    }
                                dragging = false;
                                //right, now to create the block by drawing everything on a canvas and then extracting only the area defined by the rectangle
                                //set up display arrays
                                DisplayList.Length++;
                                DisplayList[DisplayList.Length - 1].ItemNumber = DisplayItemNumber;
                                DisplayList[DisplayList.Length - 1].DisplayType = TDisplayBlock;
                                DisplayList[DisplayList.Length - 1].UndoName = "Block (" + AnsiString(DisplayItemNumber) + ")";
                                DisplayList[DisplayList.Length - 1].selected = false;
                                DisplayList[DisplayList.Length - 1].visible = true;
                                //want a rectangle to the mouse point
                                Rectangle.Left = StartPointChart.x;
                                Rectangle.Top = StartPointChart.y;
                                Rectangle.Right = Location.X;
                                Rectangle.Bottom = Location.Y;
                                int swap;
                                if (Rectangle.Left > Rectangle.Right) {
                                    swap = Rectangle.Right;
                                    Rectangle.Right = Rectangle.Left;
                                    Rectangle.Left = swap;
                                    }
                                if (Rectangle.Top > Rectangle.Bottom) {
                                    swap = Rectangle.Bottom;
                                    Rectangle.Bottom = Rectangle.Top;
                                    Rectangle.Top = swap;
                                    }
                                DisplayList[DisplayList.Length - 1].Area = Rectangle;
                                int arraypointer = BlockList.Length;
                                BlockList.Length++;
                                BlockList[arraypointer].ItemNumber = DisplayItemNumber;
                                BlockList[arraypointer].Linked = false;
                                BlockList[arraypointer].LinkedBlock = -1;
                                BlockList[arraypointer].Area = Rectangle;
                                BlockList[arraypointer].RotationCentre.x = Rectangle.Left;
                                BlockList[arraypointer].RotationCentre.y = Rectangle.Top;
                                BlockList[arraypointer].Angle = 0;
                                BlockList[arraypointer].MirrorCentre = BlockList[arraypointer].RotationCentre;
                                BlockList[arraypointer].Axis = TMANone;
                                BlockList[arraypointer].delta.x = 0;
                                BlockList[arraypointer].delta.y = 0;

                                Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
                                Bitmap->Width = Picture->Width;
                                Bitmap->Height = Picture->Height;
                                Bitmap->Assign(Picture);
                                int oldsquare = SquareSize;
                                SquareSize = 1;
                                TPoint OldTopLeft = TopLeft;
                                TopLeft.x = 0;
                                TopLeft.y = 0;
                                DrawVectors(Bitmap->Canvas);
                                SquareSize = oldsquare;
                                TopLeft = OldTopLeft;
                                BlockList[arraypointer].Points.Length = Bitmap->Width * Bitmap->Height + 1;

                                int pointer = 0;

                                for (int i = Rectangle.Left; i < Rectangle.Right + 1; i++) {
                                    for (int j = Rectangle.Top; j < Rectangle.Bottom + 1; j++) {
                                        BlockList[arraypointer].Points[pointer].x = i;
                                        BlockList[arraypointer].Points[pointer].y = j;
                                        BlockList[arraypointer].Points[pointer].originalx = i;
                                        BlockList[arraypointer].Points[pointer].originaly = j;
                                        BlockList[arraypointer].Points[pointer].Colour = Bitmap->Canvas->Pixels[i][j];
                                        BlockList[arraypointer].Points[pointer].transparent = false;
                                        pointer++;
                                        }
                                    }
                                BlockList[arraypointer].Points.Length = pointer;
                                delete Bitmap;
                                AddUndoTitle("Add Block " + AnsiString(DisplayItemNumber));
                                AddUndo("Delete," + AnsiString(DisplayItemNumber) + ",");
                                DisplayItemNumber++;
                                CreateXRefs();
                                DisplayListAreaUpdate(BlockList[arraypointer].ItemNumber);
                                DrawBlock(BlockList[arraypointer].ItemNumber, Image1->Picture->Bitmap->Canvas);
                                DrawLinksBetweenBlocks();
                                Memo1->Lines->Add("Create Block");
                                //debug
                                DebugBlock(arraypointer);
                                }
                            }
                            break;
        case TDrawCircle:   {
                            if (!Location.outofrange) {
                                chartposition SP;
                                if (Shift.Contains(ssShift)) {
                                    //Modify the input so that the line is vertical or horizontal if the 'Shift' key is pressed.
                                    int ref1 = abs(StartPointChart.x - Location.X);
                                    int ref2 = abs(StartPointChart.y - Location.Y);
                                    int ref3 = min(ref1,ref2);
                                    if (Location.X < StartPointChart.x) {
                                        Location.X = StartPointChart.x - ref3;
                                        if (Location.X < 0) Location.X = 0;
                                        } else {
                                        Location.X = StartPointChart.x + ref3;
                                        if (Location.X > (Picture->Width - 1)) Location.X = Picture->Width;
                                        }
                                    if (Location.Y < StartPointChart.y) {
                                        Location.Y = StartPointChart.y - ref3;
                                        if (Location.Y < 0) Location.Y = 0;
                                        } else {
                                        Location.Y = StartPointChart.y + ref3;
                                        if (Location.Y > (Picture->Height - 1)) Location.Y = Picture->Height;
                                        }
                                    //make sure the end displays in the correct place
                                    SP = FindImage1Position(Location.X,Location.Y);
                                    X = SP.X;
                                    Y = SP.Y;
                                    }
                                TRect Rectangle;
                                if (!wipedout) {
                                    //want a rectangle to the mouse point
                                    Rectangle.Left = StartPointScreen.x;
                                    Rectangle.Top = StartPointScreen.y;
                                    Rectangle.Right = OldMousePositionScreen.x;
                                    Rectangle.Bottom = OldMousePositionScreen.y;
                                    int swap;
                                    if (Rectangle.Left > Rectangle.Right) {
                                        swap = Rectangle.Right;
                                        Rectangle.Right = Rectangle.Left;
                                        Rectangle.Left = swap;
                                        }
                                    if (Rectangle.Top > Rectangle.Bottom) {
                                        swap = Rectangle.Bottom;
                                        Rectangle.Bottom = Rectangle.Top;
                                        Rectangle.Top = swap;
                                        }
                                    Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                    TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                    TBrushStyle oldstyle = Image1->Picture->Bitmap->Canvas->Brush->Style;
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                    Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                    Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                    Image1->Picture->Bitmap->Canvas->Brush->Style = bsClear;
                                    Image1->Picture->Bitmap->Canvas->Ellipse(Rectangle.Left,Rectangle.Top,Rectangle.Right,Rectangle.Bottom);
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                    Image1->Picture->Bitmap->Canvas->Brush->Style = oldstyle;
                                    wipedout = true;
                                    }
                                dragging = false;
                                //right, now to create the line by drawing it on a canvas and recording the points not background colour
                                TColor ForeColour = ForegroundColour;
                                TColor BackColour = BackgroundColour;
                                if (preparetoblendforeground) {
                                    blendthreads = true;
                                    preparetoblendforeground = false;
                                    }
                                if (preparetoblendbackground) {
                                    blendthreads = true;
                                    preparetoblendbackground = false;
                                    }
                                /*TColor BitmapColour = clWhite;
                                if (ForeColour == clWhite || BackColour == clWhite) {
                                    BitmapColour = clSilver;
                                    if (ForeColour == clSilver || BackColour == clSilver) {
                                        BitmapColour = clAqua;
                                        }
                                    }*/
                                //set up display arrays
                                DisplayList.Length++;
                                DisplayList[DisplayList.Length - 1].ItemNumber = DisplayItemNumber;
                                DisplayList[DisplayList.Length - 1].DisplayType = TDisplayCircle;
                                DisplayList[DisplayList.Length - 1].UndoName = "Ellipse/Circle (" + AnsiString(DisplayItemNumber) + ")";
                                DisplayList[DisplayList.Length - 1].selected = false;
                                DisplayList[DisplayList.Length - 1].visible = true;
                                //want a rectangle to the mouse point
                                Rectangle.Left = StartPointChart.x;
                                Rectangle.Top = StartPointChart.y;
                                Rectangle.Right = Location.X;
                                Rectangle.Bottom = Location.Y;
                                int swap;
                                if (Rectangle.Left > Rectangle.Right) {
                                    swap = Rectangle.Right;
                                    Rectangle.Right = Rectangle.Left;
                                    Rectangle.Left = swap;
                                    }
                                if (Rectangle.Top > Rectangle.Bottom) {
                                    swap = Rectangle.Bottom;
                                    Rectangle.Bottom = Rectangle.Top;
                                    Rectangle.Top = swap;
                                    }
                                //Rectangle.Bottom--;
                                //Rectangle.Right--;
                                Rectangle.Bottom++;
                                Rectangle.Right++;
                                DisplayList[DisplayList.Length - 1].Area = Rectangle;
                                int arraypointer = CircleList.Length;
                                CircleList.Length++;
                                CircleList[arraypointer].ItemNumber = DisplayItemNumber;
                                CircleList[arraypointer].PenColour = ForeColour;
                                CircleList[arraypointer].BrushColour = BackColour;
                                CircleList[arraypointer].LineWidth = LineWidth;
                                CircleList[arraypointer].Area = Rectangle;
                                CircleList[arraypointer].Shape = stEllipse;
                                CircleList[arraypointer].Angle = 0;
                                CircleList[arraypointer].Filled = FillShapes;
                                /*
                                Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
                                Bitmap->Width = Picture->Width;
                                Bitmap->Height = Picture->Height;
                                if (BitmapColour != clWhite) {
                                    Bitmap->Canvas->Brush->Color = BitmapColour;
                                    Bitmap->Canvas->FloodFill(0,0,clWhite,fsSurface);
                                    }
                                Bitmap->Canvas->Pen->Color = CircleList[arraypointer].PenColour;
                                Bitmap->Canvas->Pen->Width = CircleList[arraypointer].LineWidth;
                                Bitmap->Canvas->Brush->Color = CircleList[arraypointer].BrushColour;
                                Bitmap->Canvas->Brush->Style = bsSolid;
                                Bitmap->Canvas->Ellipse(Rectangle.Left,Rectangle.Top,Rectangle.Right,Rectangle.Bottom);
                                CircleList[arraypointer].Points.Length = Bitmap->Width * Bitmap->Height + 1;

                                int pointer = 0;

                                for (int i = 0; i < Bitmap->Width; i++) {
                                    for (int j = 0; j < Bitmap->Height; j++) {
                                        if (Bitmap->Canvas->Pixels[i][j] != BitmapColour) {
                                            CircleList[arraypointer].Points[pointer].x = i;
                                            CircleList[arraypointer].Points[pointer].y = j;
                                            CircleList[arraypointer].Points[pointer].Colour = Bitmap->Canvas->Pixels[i][j];
                                            pointer++;
                                            }
                                        }
                                    }
                                CircleList[arraypointer].Points.Length = pointer;
                                delete Bitmap;
                                */
                                FillPointsCircle(arraypointer,DisplayItemNumber);
                                CreateXRefs();
                                DisplayListAreaUpdate(DisplayItemNumber);
                                AddUndoTitle("Add Ellipse/Circle " + AnsiString(DisplayItemNumber));
                                AddUndo("Delete," + AnsiString(DisplayItemNumber) + ",");
                                DisplayItemNumber++;
                                DrawCircle(CircleList[arraypointer].ItemNumber, Image1->Picture->Bitmap->Canvas);
                                }
                            }
                            break;
        case TDrawRectangle:   {
                            if (!Location.outofrange) {
                                chartposition SP;
                                if (Shift.Contains(ssShift)) {
                                    //Modify the input so that the line is vertical or horizontal if the 'Shift' key is pressed.
                                    int ref1 = abs(StartPointChart.x - Location.X);
                                    int ref2 = abs(StartPointChart.y - Location.Y);
                                    int ref3 = min(ref1,ref2);
                                    if (Location.X < StartPointChart.x) {
                                        Location.X = StartPointChart.x - ref3;
                                        if (Location.X < 0) Location.X = 0;
                                        } else {
                                        Location.X = StartPointChart.x + ref3;
                                        if (Location.X > (Picture->Width - 1)) Location.X = Picture->Width;
                                        }
                                    if (Location.Y < StartPointChart.y) {
                                        Location.Y = StartPointChart.y - ref3;
                                        if (Location.Y < 0) Location.Y = 0;
                                        } else {
                                        Location.Y = StartPointChart.y + ref3;
                                        if (Location.Y > (Picture->Height - 1)) Location.Y = Picture->Height;
                                        }
                                    //make sure the end displays in the correct place
                                    SP = FindImage1Position(Location.X,Location.Y);
                                    X = SP.X;
                                    Y = SP.Y;
                                    }
                                TRect Rectangle;
                                if (!wipedout) {
                                    //want a rectangle to the mouse point
                                    Rectangle.Left = StartPointScreen.x;
                                    Rectangle.Top = StartPointScreen.y;
                                    Rectangle.Right = OldMousePositionScreen.x;
                                    Rectangle.Bottom = OldMousePositionScreen.y;
                                    int swap;
                                    if (Rectangle.Left > Rectangle.Right) {
                                        swap = Rectangle.Right;
                                        Rectangle.Right = Rectangle.Left;
                                        Rectangle.Left = swap;
                                        }
                                    if (Rectangle.Top > Rectangle.Bottom) {
                                        swap = Rectangle.Bottom;
                                        Rectangle.Bottom = Rectangle.Top;
                                        Rectangle.Top = swap;
                                        }
                                    Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                    wipedout = true;
                                    }
                                dragging = false;
                                //right, now to create the line by drawing it on a canvas and recording the points different from the background
                                TColor ForeColour = ForegroundColour;
                                TColor BackColour = BackgroundColour;
                                if (preparetoblendforeground) {
                                    blendthreads = true;
                                    preparetoblendforeground = false;
                                    }
                                if (preparetoblendbackground) {
                                    blendthreads = true;
                                    preparetoblendbackground = false;
                                    }
                                /*TColor BitmapColour = clWhite;
                                if (ForeColour == clWhite || BackColour == clWhite) {
                                    BitmapColour = clSilver;
                                    if (ForeColour == clSilver || BackColour == clSilver) {
                                        BitmapColour = clAqua;
                                        }
                                    }*/
                                //set up display arrays
                                DisplayList.Length++;
                                DisplayList[DisplayList.Length - 1].ItemNumber = DisplayItemNumber;
                                DisplayList[DisplayList.Length - 1].DisplayType = TDisplayRectangle;
                                DisplayList[DisplayList.Length - 1].UndoName = "Rectangle (" + AnsiString(DisplayItemNumber) + ")";
                                DisplayList[DisplayList.Length - 1].selected = false;
                                DisplayList[DisplayList.Length - 1].visible = true;
                                //want a rectangle to the mouse point
                                Rectangle.Left = StartPointChart.x;
                                Rectangle.Top = StartPointChart.y;
                                Rectangle.Right = Location.X;
                                Rectangle.Bottom = Location.Y;
                                int swap;
                                if (Rectangle.Left > Rectangle.Right) {
                                    swap = Rectangle.Right;
                                    Rectangle.Right = Rectangle.Left;
                                    Rectangle.Left = swap;
                                    }
                                if (Rectangle.Top > Rectangle.Bottom) {
                                    swap = Rectangle.Bottom;
                                    Rectangle.Bottom = Rectangle.Top;
                                    Rectangle.Top = swap;
                                    }
                                //Rectangle.Right++;
                                //Rectangle.Bottom++;
                                //DisplayList[DisplayList.Length - 1].Area = Rectangle;
                                //DisplayList[DisplayList.Length - 1].Area.Right--;
                                //DisplayList[DisplayList.Length - 1].Area.Bottom--;
                                int arraypointer = RectangleList.Length;
                                RectangleList.Length++;
                                RectangleList[arraypointer].ItemNumber = DisplayItemNumber;
                                RectangleList[arraypointer].PenColour = ForeColour;
                                RectangleList[arraypointer].BrushColour = BackColour;
                                RectangleList[arraypointer].LineWidth = LineWidth;
                                RectangleList[arraypointer].Area = Rectangle;
                                //RectangleList[arraypointer].Area.Right--;
                                //RectangleList[arraypointer].Area.Bottom--;
                                RectangleList[arraypointer].Shape = stRectangle;
                                RectangleList[arraypointer].Angle = 0;
                                RectangleList[arraypointer].Filled = FillShapes;
                                /*
                                Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
                                Bitmap->Width = Picture->Width;
                                Bitmap->Height = Picture->Height;
                                if (BitmapColour != clWhite) {
                                    Bitmap->Canvas->Brush->Color = BitmapColour;
                                    Bitmap->Canvas->FloodFill(0,0,clWhite,fsSurface);
                                    }
                                Bitmap->Canvas->Pen->Color = RectangleList[arraypointer].PenColour;
                                Bitmap->Canvas->Pen->Width = RectangleList[arraypointer].LineWidth;
                                Bitmap->Canvas->Brush->Color = RectangleList[arraypointer].BrushColour;
                                Bitmap->Canvas->Brush->Style = bsSolid;
                                Bitmap->Canvas->Rectangle(Rectangle.Left,Rectangle.Top,Rectangle.Right,Rectangle.Bottom);
                                RectangleList[arraypointer].Points.Length = Bitmap->Width * Bitmap->Height + 1;

                                int pointer = 0;

                                for (int i = 0; i < Bitmap->Width; i++) {
                                    for (int j = 0; j < Bitmap->Height; j++) {
                                        if (Bitmap->Canvas->Pixels[i][j] != BitmapColour) {
                                            RectangleList[arraypointer].Points[pointer].x = i;
                                            RectangleList[arraypointer].Points[pointer].y = j;
                                            RectangleList[arraypointer].Points[pointer].Colour = Bitmap->Canvas->Pixels[i][j];
                                            pointer++;
                                            }
                                        }
                                    }
                                RectangleList[arraypointer].Points.Length = pointer;
                                delete Bitmap;
                                */
                                FillPointsRectangle(arraypointer,DisplayItemNumber);
                                CreateXRefs();
                                DisplayListAreaUpdate(DisplayItemNumber);
                                AddUndoTitle("Add Rectangle " + AnsiString(DisplayItemNumber));
                                AddUndo("Delete," + AnsiString(DisplayItemNumber) + ",");
                                DisplayItemNumber++;
                                DrawRectangle(RectangleList[arraypointer].ItemNumber, Image1->Picture->Bitmap->Canvas);
                                }
                            }
                            break;
        case TEraseItem:    {
                            dragging = false;
                            }
                            break;
        case TDrawLine:     {
                            if (!Location.outofrange) {
                                if (Shift.Contains(ssShift)) {
                                    //Modify the input so that the line is vertical or horizontal if the 'Shift' key is pressed.
                                    if (abs(StartPointChart.x - Location.X) > abs(StartPointChart.y - Location.Y)) {
                                        Location.Y = StartPointChart.y;
                                        } else {
                                        Location.X = StartPointChart.x;
                                        }
                                    }
                                if (!wipedout) {
                                    //want to erase the line to the old mouse point
                                    TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                    Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                    Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                    Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                    Image1->Picture->Bitmap->Canvas->LineTo(OldMousePositionScreen.x,OldMousePositionScreen.y);
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                    wipedout = true;
                                    }
                                dragging = false;
                                //right, now to create the line by drawing it on a monochrome canvas and recording the points made black
                                TColor Colour;
                                if (Button == mbLeft || Button == mbMiddle) {
                                    Colour = ForegroundColour;
                                    if (preparetoblendforeground) {
                                        blendthreads = true;
                                        preparetoblendforeground = false;
                                        }
                                    } else {
                                    Colour = BackgroundColour;
                                    if (preparetoblendbackground) {
                                        blendthreads = true;
                                        preparetoblendbackground = false;
                                        }
                                    }
                                //set up display arrays
                                DisplayList.Length++;
                                DisplayList[DisplayList.Length - 1].ItemNumber = DisplayItemNumber;
                                DisplayList[DisplayList.Length - 1].DisplayType = TDisplayLine;
                                DisplayList[DisplayList.Length - 1].UndoName = "Line (" + AnsiString(DisplayItemNumber) + ")";
                                DisplayList[DisplayList.Length - 1].selected = false;
                                DisplayList[DisplayList.Length - 1].visible = true;
                                TRect Area;
                                Area.Left = Location.X;
                                Area.Right = Location.X;
                                Area.Top = Location.Y;
                                Area.Bottom = Location.Y;
                                int arraypointer = LineList.Length;
                                LineList.Length++;
                                LineList[arraypointer].ItemNumber = DisplayItemNumber;
                                LineList[arraypointer].Colour = Colour;
                                LineList[arraypointer].LineWidth = LineWidth;
                                LineList[arraypointer].StartPoint.x = StartPointChart.x;
                                LineList[arraypointer].StartPoint.y = StartPointChart.y;
                                LineList[arraypointer].EndPoint.x = Location.X;
                                LineList[arraypointer].EndPoint.y = Location.Y;
                                FillPointsLine(arraypointer,DisplayItemNumber);
                                /*
                                Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
                                Bitmap->Monochrome = true;
                                Bitmap->Width = Picture->Width;
                                Bitmap->Height = Picture->Height;
                                Bitmap->Canvas->Pen->Color = clBlack;
                                Bitmap->Canvas->Pen->Width = LineWidth;
                                Bitmap->Canvas->MoveTo(StartPointChart.x,StartPointChart.y);
                                Bitmap->Canvas->LineTo(Location.X,Location.Y);
                                LineList[arraypointer].Points.Length = Bitmap->Width * Bitmap->Height + 1;

                                int pointer = 0;

                                for (int i = 0; i < Bitmap->Width; i++) {
                                    for (int j = 0; j < Bitmap->Height; j++) {
                                        if (Bitmap->Canvas->Pixels[i][j] == clBlack) {
                                            LineList[arraypointer].Points[pointer].x = i;
                                            LineList[arraypointer].Points[pointer].y = j;
                                            pointer++;
                                            }
                                        }
                                    }
                                LineList[arraypointer].Points.Length = pointer;
                                */
                                for (int i = 0; i < LineList[arraypointer].Points.Length; i++) {
                                    if (LineList[arraypointer].Points[i].x < Area.Left) Area.Left = LineList[arraypointer].Points[i].x;
                                    if (LineList[arraypointer].Points[i].x > Area.Right) Area.Right = LineList[arraypointer].Points[i].x;
                                    if (LineList[arraypointer].Points[i].y < Area.Top) Area.Top = LineList[arraypointer].Points[i].y;
                                    if (LineList[arraypointer].Points[i].y > Area.Bottom) Area.Bottom = LineList[arraypointer].Points[i].y;
                                    }
                                //DisplayList[DisplayList.Length - 1].Area = Area;
                                //delete Bitmap;
                                AddUndoTitle("Add Line " + AnsiString(DisplayItemNumber));
                                AddUndo("Delete," + AnsiString(DisplayItemNumber) + ",");
                                DisplayItemNumber++;
                                CreateXRefs();
                                DisplayListAreaUpdate(LineList[arraypointer].ItemNumber);
                                DrawLine(LineList[arraypointer].ItemNumber, Image1->Picture->Bitmap->Canvas);
                                }
                            }
                            break;
        case TPixelEdit:    {
                            dragging = false;
                            }
                            break;
        default:            break;
        }

}
//---------------------------------------------------------------------------

chartposition  __fastcall TImageEditorForm::FindMousePosition(int X, int Y)
{
    //This is an interesting problem. It takes the mouse position & converts
    //it into the location on the chart image.
    //The chart image may be scrolled & scaled in the image box.

    //Where the mouse is out of the chart image area, Location.outofrange is set to true.

    chartposition Location;
    Location.outofrange = false;
    Location.X = X;
    Location.Y = Y;

    //Transform to Picture co-ords
    Location.X = (TopLeft.x) + Location.X/(SquareSize);
    Location.Y = (TopLeft.y) + Location.Y/(SquareSize);

    //now check if within Picture limits.
    if (Location.X < 0
        || Location.X > Picture->Width
        || Location.Y < 0
        || Location.Y > Picture->Height) {
            Location.outofrange = true;
            }

    return Location;

}
//---------------------------------------------------------------------------

chartposition __fastcall TImageEditorForm::FindImage1Position(int X, int Y)
{
    //Takes a chart position & transforms to an image position

    //Where the mouse is out of the image area, Location.outofrange is set to true.

    chartposition Location;
    Location.outofrange = false;
    Location.X = X;
    Location.Y = Y;

    //Transform to Picture co-ords
    /*
    Location.X = Location.X * SquareSize - TopLeft.x;
    Location.Y = Location.Y * SquareSize - TopLeft.y;
    */
    Location.X = (Location.X - TopLeft.x) * SquareSize;
    Location.Y = (Location.Y - TopLeft.y) * SquareSize;

    //now check if within Picture limits.
    if (Location.X < 0
        || Location.X > Image1->Width
        || Location.Y < 0
        || Location.Y > Image1->Height) {
            Location.outofrange = true;
            }

    return Location;

}
//---------------------------------------------------------------------------

TRect __fastcall TImageEditorForm::FindImage1Position(TRect Rectangle)
{
    //Takes a chart position & transforms to an image position

    //Where the mouse is out of the image area, Location.outofrange is set to true.

    TRect Location;
    //Transform to Picture co-ords
    Location.Left = (Rectangle.Left - TopLeft.x) * SquareSize;
    Location.Top = (Rectangle.Top - TopLeft.y) * SquareSize;
    Location.Right = (Rectangle.Right - TopLeft.x) * SquareSize;
    Location.Bottom = (Rectangle.Bottom - TopLeft.y) * SquareSize;


    return Location;

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::FormMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
        StatusBar1->Panels->Items[0]->Text = " X = ---";
        StatusBar1->Panels->Items[1]->Text = " Y = ---";

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Edit1Click(TObject *Sender)
{
    if (DisplayList.Length) {
        Undo1->Hint = DisplayList[DisplayList.Length - 1].UndoName;
        Undo1->Enabled = true;
        Select2->Enabled = true;
        } else {
        Undo1->Enabled = false;
        Select2->Enabled = false;
        }
    if (AnyItemsSelected) {
        Cut1->Enabled = true;
        Copy1->Enabled = true;
        Move1->Enabled = true;
        Rotate2->Enabled = true;
        Mirror1->Enabled = true;
        Deselect1->Enabled = true;
        } else {
        Cut1->Enabled = false;
        Copy1->Enabled = false;
        Move1->Enabled = false;
        Rotate2->Enabled = false;
        Mirror1->Enabled = false;
        Deselect1->Enabled = false;
        }
    CopyBlendPalette1->Visible = Image3->Visible;
    //checks to see if the clipboard has a compatible picture
    if (Clipboard()->HasFormat(CF_BITMAP)) {
        PasteAsBackgroundImage1->Enabled = true;
        PasteAsBlock1->Enabled = true;
        } else {
        PasteAsBackgroundImage1->Enabled = false;
        PasteAsBlock1->Enabled = false;
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::UndoButtonMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
    /*if (DisplayList.Length) {
        UndoButton->Hint = DisplayList[DisplayList.Length - 1].UndoName;
        } else {
        UndoButton->Hint = "No Undo's Available";
        }*/
    AnsiString Hint = LastUndoTitle();

    if (Hint == "No Undo's Available") {
        UndoButton->Hint = Hint;
        } else {
        UndoButton->Hint = "Undo '" + Hint + "'";
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::LineButtonMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
    LineButton->Hint = "Line Tool, Width = " + AnsiString(LineWidth);
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::RectangleButtonMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
    RectangleButton->Hint = "Draw Rectangle, Line Width = " + AnsiString(LineWidth);

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::CircleButtonMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
    CircleButton->Hint = "Draw Ellipse/Circle, Line Width = " + AnsiString(LineWidth);

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Undo1Click(TObject *Sender)
{
    /*
    //delete the last items
    if (DisplayList.Length) {
        AnsiString UndoName = DisplayList[DisplayList.Length - 1].UndoName;
        while (DisplayList.Length && DisplayList[DisplayList.Length - 1].UndoName == UndoName) {
            switch (DisplayList[DisplayList.Length - 1].DisplayType) {
                case TDisplayBlock:    {
                                        DeleteBlock(DisplayList[DisplayList.Length - 1].ItemNumber);
                                        }
                                        break;
                case TDisplayCircle:    {
                                        DeleteCircle(DisplayList[DisplayList.Length - 1].ItemNumber);
                                        }
                                        break;
                case TDisplayRectangle: {
                                        DeleteRectangle(DisplayList[DisplayList.Length - 1].ItemNumber);
                                        }
                                        break;
                case TDisplayEraseItem: {
                                        DeleteErase(DisplayList[DisplayList.Length - 1].ItemNumber);
                                        }
                                        break;
                case TDisplayLine:      {
                                        DeleteLine(DisplayList[DisplayList.Length - 1].ItemNumber);
                                        }
                                        break;
                case TDisplayText:      {
                                        DeleteText(DisplayList[DisplayList.Length - 1].ItemNumber);
                                        }
                                        break;
                case TDisplayFloodFill: {
                                        DeleteFloodFill(DisplayList[DisplayList.Length - 1].ItemNumber);
                                        }
                                        break;
                case TDisplayPoint:     {
                                        DeletePoints(DisplayList[DisplayList.Length - 1].ItemNumber);
                                        }
                                        break;
                default:                break;
                }
            DisplayList.Length--;
            }
        }
    DrawPicture();
    */
    //revised undo
    TerminateCurrentAction();
    ResetActionButtons();
    Undoing = true;
    if (UndoTitleList->Count) {
        while (UndoTitleList->Count && LeftString(UndoTitleList->Strings[UndoTitleList->Count - 1],6) != "Title,") {
            AnsiString text = UndoTitleList->Strings[UndoTitleList->Count - 1];
            AnsiString temp;
            int ivalue;
            UndoTitleList->Delete(UndoTitleList->Count - 1);
            //now to interpret text
            temp = ExtractWord(text,",");
            text = DeleteWord(text,",");

            if (temp.LowerCase() == "add") {
                temp = ExtractWord(text,",");
                text = DeleteWord(text,",");

                if (temp.LowerCase() == "point") {
                    ivalue = ExtractWord(text,",").ToIntDef(-1);
                    text = DeleteWord(text,",");
                    //check that this value of index doesn't exist
                    if (ivalue > -1 && !CheckifEntityExists(ivalue)) {
                        //Have established that the item does not exist, so will re-create it.
                        int arrayentry = PointList.Length;
                        PointList.Length++;
                        PointList[arrayentry].ItemNumber = ivalue;
                        PointList[arrayentry].Colour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                        text = DeleteWord(text,",");
                        int pointer = 0;
                        //allocate a huge lump of memory in one go, as it'll be safer than asking to add one at a time
                        PointList[arrayentry].Points.Length = Picture->Height * Picture->Width + 1;
                        while (text.Length()) {
                            PointList[arrayentry].Points[pointer].x = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            PointList[arrayentry].Points[pointer].y = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            pointer++;
                            }
                        PointList[arrayentry].Points.Length = pointer;
                        CreateXRefs();
                        DisplayListAreaUpdate(PointList[arrayentry].ItemNumber);
                        }
                    } //end of 'Add,Point, int ItemNumber, TColor Colour, [int point.x,int point.y,]repeated'

                if (temp.LowerCase() == "displayitem") {
                    ivalue = ExtractWord(text,",").ToIntDef(-1);
                    text = DeleteWord(text,",");
                    //check that this value of index doesn't exist
                    if (ivalue > -1 && !CheckifDisplayItemExists(ivalue)) {
                        //Have established that the item does not exist, so will re-create it.
                        displaylist DisplayItem;
                        DisplayItem.ItemNumber = ivalue;
                        DisplayItem.DisplayType = (TDisplayType)(ExtractWord(text,",").ToIntDef(0));
                        text = DeleteWord(text,",");
                        if (DisplayList.Length < 0) DisplayList.Length = 0;
                        int arrayentry = ExtractWord(text,",").ToIntDef(-1);
                        if (arrayentry > -1 && arrayentry < DisplayList.Length + 1) {
                            DisplayItem.selected = (bool)(ExtractWord(text,",").ToIntDef(0));
                            text = DeleteWord(text,",");
                            DisplayItem.visible = (bool)(ExtractWord(text,",").ToIntDef(1));
                            text = DeleteWord(text,",");
                            DisplayItem.Area.Left = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            DisplayItem.Area.Top = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            DisplayItem.Area.Right = ExtractWord(text,",").ToIntDef(1);
                            text = DeleteWord(text,",");
                            DisplayItem.Area.Bottom = ExtractWord(text,",").ToIntDef(1);
                            DisplayList.Length++;
                            for (int i = DisplayList.Length-1; i > arrayentry; i--) {
                                DisplayList[i] = DisplayList[i-1];
                                }
                            DisplayList[arrayentry] = DisplayItem;
                            }
                        }
                    } //end of 'Add,DisplayItem, int ItemNumber, TDisplayType DisplayType, int arrayposition, bool selected, bool visible, int Area.Left, .Top, .Right, .Bottom,'

                if (temp.LowerCase() == "line") {
                    ivalue = ExtractWord(text,",").ToIntDef(-1);
                    text = DeleteWord(text,",");
                    //check that this value of index doesn't exist
                    if (ivalue > -1 && !CheckifEntityExists(ivalue)) {
                        //Have established that the item does not exist, so will re-create it.
                        int arrayentry = LineList.Length;
                        LineList.Length++;
                        LineList[arrayentry].ItemNumber = ivalue;
                        LineList[arrayentry].Colour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                        text = DeleteWord(text,",");
                        LineList[arrayentry].LineWidth = ExtractWord(text,",").ToIntDef(1);
                        text = DeleteWord(text,",");
                        LineList[arrayentry].StartPoint.x = ExtractWord(text,",").ToIntDef(0);
                        text = DeleteWord(text,",");
                        LineList[arrayentry].StartPoint.y = ExtractWord(text,",").ToIntDef(0);
                        text = DeleteWord(text,",");
                        LineList[arrayentry].EndPoint.x = ExtractWord(text,",").ToIntDef(0);
                        text = DeleteWord(text,",");
                        LineList[arrayentry].EndPoint.y = ExtractWord(text,",").ToIntDef(0);
                        text = DeleteWord(text,",");
                        int pointer = 0;
                        //allocate a huge lump of memory in one go, as it'll be safer than asking to add one at a time
                        LineList[arrayentry].Points.Length = Picture->Height * Picture->Width + 1;
                        while (text.Length()) {
                            LineList[arrayentry].Points[pointer].x = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            LineList[arrayentry].Points[pointer].y = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            LineList[arrayentry].Points[pointer].Colour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                            text = DeleteWord(text,",");
                            pointer++;
                            }
                        LineList[arrayentry].Points.Length = pointer;
                        CreateXRefs();
                        DisplayListAreaUpdate(LineList[arrayentry].ItemNumber);
                        }
                    } //end of 'Add,line, int ItemNumber, TColor Colour, int LineWidth, int StartPoint x, y, int EndPoint x, y, [int point.x,int point.y,]repeated'

                if (temp.LowerCase() == "polyline") {
                    ivalue = ExtractWord(text,",").ToIntDef(-1);
                    text = DeleteWord(text,",");
                    //check that this value of index doesn't exist
                    if (ivalue > -1 && !CheckifEntityExists(ivalue)) {
                        //Have established that the item does not exist, so will re-create it.
                        int arrayentry = PolyLineList.Length;
                        PolyLineList.Length++;
                        PolyLineList[arrayentry].ItemNumber = ivalue;
                        PolyLineList[arrayentry].PenColour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                        text = DeleteWord(text,",");
                        PolyLineList[arrayentry].BrushColour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                        text = DeleteWord(text,",");
                        PolyLineList[arrayentry].LineWidth = ExtractWord(text,",").ToIntDef(1);
                        text = DeleteWord(text,",");
                        PolyLineList[arrayentry].closed = (bool)(ExtractWord(text,",").ToIntDef(0));
                        text = DeleteWord(text,",");
                        PolyLineList[arrayentry].filled = (bool)(ExtractWord(text,",").ToIntDef(0));
                        text = DeleteWord(text,",");
                        int pointer = ExtractWord(text,",").ToIntDef(0);
                        text = DeleteWord(text,",");
                        PolyLineList[arrayentry].Points.Length = pointer;
                        for (int j = 0; j < pointer; j++) {
                            PolyLineList[arrayentry].Points[j].x = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            PolyLineList[arrayentry].Points[j].y = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            PolyLineList[arrayentry].Points[j].Colour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                            text = DeleteWord(text,",");
                            }
                        pointer = ExtractWord(text,",").ToIntDef(0);
                        text = DeleteWord(text,",");
                        PolyLineList[arrayentry].Corners.Length = pointer;
                        for (int j = 0; j < pointer; j++) {
                            PolyLineList[arrayentry].Corners[j].x = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            PolyLineList[arrayentry].Corners[j].y = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            }
                        CreateXRefs();
                        DisplayListAreaUpdate(PolyLineList[arrayentry].ItemNumber);
                        }
                    } //end of 'Add,Polyline, int ItemNumber, TColor PenColour, TColor BrushColour, int LineWidth, int pointcount, [int point.x,int point.y,]repeated, int cornercount, [int corner.x, int corner.y] repeated'

                if (temp.LowerCase() == "floodfill") {
                    ivalue = ExtractWord(text,",").ToIntDef(-1);
                    text = DeleteWord(text,",");
                    //check that this value of index doesn't exist
                    if (ivalue > -1 && !CheckifEntityExists(ivalue)) {
                        //Have established that the item does not exist, so will re-create it.
                        int arrayentry = FloodFillList.Length;
                        FloodFillList.Length++;
                        FloodFillList[arrayentry].ItemNumber = ivalue;
                        FloodFillList[arrayentry].Colour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                        text = DeleteWord(text,",");
                        FloodFillList[arrayentry].FilledColour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                        text = DeleteWord(text,",");
                        FloodFillList[arrayentry].StartPoint.x = ExtractWord(text,",").ToIntDef(0);
                        text = DeleteWord(text,",");
                        FloodFillList[arrayentry].StartPoint.y = ExtractWord(text,",").ToIntDef(0);
                        text = DeleteWord(text,",");
                        int pointer = 0;
                        //allocate a huge lump of memory in one go, as it'll be safer than asking to add one at a time
                        FloodFillList[arrayentry].Points.Length = Picture->Height * Picture->Width + 1;
                        while (text.Length()) {
                            FloodFillList[arrayentry].Points[pointer].x = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            FloodFillList[arrayentry].Points[pointer].y = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            pointer++;
                            }
                        FloodFillList[arrayentry].Points.Length = pointer;
                        CreateXRefs();
                        DisplayListAreaUpdate(FloodFillList[arrayentry].ItemNumber);
                        }
                    } //end of 'Add,FloodFill, int ItemNumber, TColor Colour, TColor FilledColour, int StartPoint x, y, [int point.x,int point.y,]repeated'

                if (temp.LowerCase() == "text") {
                    ivalue = ExtractWord(text,",").ToIntDef(-1);
                    text = DeleteWord(text,",");
                    //check that this value of index doesn't exist
                    if (ivalue > -1 && !CheckifEntityExists(ivalue)) {
                        //Have established that the item does not exist, so will re-create it.
                        int arrayentry = TextList.Length;
                        TextList.Length++;
                        TextList[arrayentry].ItemNumber = ivalue;
                        TextList[arrayentry].Name = ExtractWord(text,",");
                        text = DeleteWord(text,",");
                        TextList[arrayentry].Height = ExtractWord(text,",").ToIntDef(12);
                        text = DeleteWord(text,",");
                        TextList[arrayentry].Bold = (bool)(ExtractWord(text,",").ToIntDef(0));
                        text = DeleteWord(text,",");
                        TextList[arrayentry].Italic = (bool)(ExtractWord(text,",").ToIntDef(0));
                        text = DeleteWord(text,",");
                        TextList[arrayentry].Underlined = (bool)(ExtractWord(text,",").ToIntDef(0));
                        text = DeleteWord(text,",");
                        TextList[arrayentry].Strikeout = (bool)(ExtractWord(text,",").ToIntDef(0));
                        text = DeleteWord(text,",");
                        TextList[arrayentry].Colour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                        text = DeleteWord(text,",");
                        TextList[arrayentry].StartPoint.x = ExtractWord(text,",").ToIntDef(0);
                        text = DeleteWord(text,",");
                        TextList[arrayentry].StartPoint.y = ExtractWord(text,",").ToIntDef(0);
                        text = DeleteWord(text,",");
                        TextList[arrayentry].Angle = ExtractWord(text,",").ToIntDef(0);
                        text = DeleteWord(text,",");
                        TextList[arrayentry].Points.Length = ExtractWord(text,",").ToIntDef(0);
                        text = DeleteWord(text,",");
                        for (int i = 0; i < TextList[arrayentry].Points.Length; i++) {
                            TextList[arrayentry].Points[i].x = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            TextList[arrayentry].Points[i].y = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            TextList[arrayentry].Points[i].Colour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                            text = DeleteWord(text,",");
                            }
                        TextList[arrayentry].Text = text;
                        CreateXRefs();
                        DisplayListAreaUpdate(TextList[arrayentry].ItemNumber);
                        }
                    } //end of 'Add,Text, int ItemNumber, AnsiString FontName, int Height, bool bold, bool Italic, bool Underlined, bool Strikeout, TColor Colour, int StartPoint x, y, int Angle, int NumberofPoints, [int point.x,int point.y,]repeated' , Text;

                if (temp.LowerCase() == "rectangle") {
                    ivalue = ExtractWord(text,",").ToIntDef(-1);
                    text = DeleteWord(text,",");
                    //check that this value of index doesn't exist
                    if (ivalue > -1 && !CheckifEntityExists(ivalue)) {
                        //Have established that the item does not exist, so will re-create it.
                        int arrayentry = RectangleList.Length;
                        RectangleList.Length++;
                        RectangleList[arrayentry].ItemNumber = ivalue;
                        int pointer = 0;
                        RectangleList[arrayentry].PenColour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                        text = DeleteWord(text,",");
                        RectangleList[arrayentry].BrushColour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                        text = DeleteWord(text,",");
                        RectangleList[arrayentry].LineWidth = ExtractWord(text,",").ToIntDef(1);
                        text = DeleteWord(text,",");
                        RectangleList[arrayentry].Area.Left = ExtractWord(text,",").ToIntDef(0);
                        text = DeleteWord(text,",");
                        RectangleList[arrayentry].Area.Top = ExtractWord(text,",").ToIntDef(0);
                        text = DeleteWord(text,",");
                        RectangleList[arrayentry].Area.Right = ExtractWord(text,",").ToIntDef(Picture->Width - 1);
                        text = DeleteWord(text,",");
                        RectangleList[arrayentry].Area.Bottom = ExtractWord(text,",").ToIntDef(Picture->Height - 1);
                        text = DeleteWord(text,",");
                        RectangleList[arrayentry].Shape = (TShapeType)(ExtractWord(text,",").ToIntDef((int)(stRectangle)));
                        text = DeleteWord(text,",");
                        RectangleList[arrayentry].Angle = ExtractWord(text,",").ToIntDef(0);
                        text = DeleteWord(text,",");
                        RectangleList[arrayentry].Filled = ((bool)(ExtractWord(text,",").ToIntDef(0)));
                        text = DeleteWord(text,",");
                        //allocate a huge lump of memory in one go, as it'll be safer than asking to add one at a time
                        RectangleList[arrayentry].Points.Length = Picture->Height * Picture->Width + 1;
                        while (text.Length()) {
                            RectangleList[arrayentry].Points[pointer].x = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            RectangleList[arrayentry].Points[pointer].y = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            RectangleList[arrayentry].Points[pointer].Colour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                            text = DeleteWord(text,",");
                            pointer++;
                            }
                        RectangleList[arrayentry].Points.Length = pointer;
                        CreateXRefs();
                        DisplayListAreaUpdate(RectangleList[arrayentry].ItemNumber);
                        }
                    } //end of 'Add,Rectangle, int ItemNumber, TColor PenColour, BrushColour, int LineWidth, int left, int top, int right, int bottom, TShapeType Shape, int angle * 10, bool filled, [int point.x,int point.y, TColor Colour,]repeated'

                if (temp.LowerCase() == "circle") {
                    ivalue = ExtractWord(text,",").ToIntDef(-1);
                    text = DeleteWord(text,",");
                    //check that this value of index doesn't exist
                    if (ivalue > -1 && !CheckifEntityExists(ivalue)) {
                        //Have established that the item does not exist, so will re-create it.
                        int arrayentry = CircleList.Length;
                        CircleList.Length++;
                        CircleList[arrayentry].ItemNumber = ivalue;
                        int pointer = 0;
                        CircleList[arrayentry].PenColour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                        text = DeleteWord(text,",");
                        CircleList[arrayentry].BrushColour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                        text = DeleteWord(text,",");
                        CircleList[arrayentry].LineWidth = ExtractWord(text,",").ToIntDef(1);
                        text = DeleteWord(text,",");
                        CircleList[arrayentry].Area.Left = ExtractWord(text,",").ToIntDef(0);
                        text = DeleteWord(text,",");
                        CircleList[arrayentry].Area.Top = ExtractWord(text,",").ToIntDef(0);
                        text = DeleteWord(text,",");
                        CircleList[arrayentry].Area.Right = ExtractWord(text,",").ToIntDef(Picture->Width - 1);
                        text = DeleteWord(text,",");
                        CircleList[arrayentry].Area.Bottom = ExtractWord(text,",").ToIntDef(Picture->Height - 1);
                        text = DeleteWord(text,",");
                        CircleList[arrayentry].Shape = (TShapeType)(ExtractWord(text,",").ToIntDef((int)(stCircle)));
                        text = DeleteWord(text,",");
                        CircleList[arrayentry].Angle = ExtractWord(text,",").ToIntDef(0);
                        text = DeleteWord(text,",");
                        CircleList[arrayentry].Filled = ((bool)(ExtractWord(text,",").ToIntDef(0)));
                        text = DeleteWord(text,",");
                        //allocate a huge lump of memory in one go, as it'll be safer than asking to add one at a time
                        CircleList[arrayentry].Points.Length = Picture->Height * Picture->Width + 1;
                        while (text.Length()) {
                            CircleList[arrayentry].Points[pointer].x = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            CircleList[arrayentry].Points[pointer].y = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            CircleList[arrayentry].Points[pointer].Colour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                            text = DeleteWord(text,",");
                            pointer++;
                            }
                        CircleList[arrayentry].Points.Length = pointer;
                        CreateXRefs();
                        DisplayListAreaUpdate(CircleList[arrayentry].ItemNumber);
                        }
                    } //end of 'Add,Circle, int ItemNumber, TColor PenColour, BrushColour, int LineWidth, int left, int top, int right, int bottom, TShapeType Shape, int angle * 10, bool Filled, [int point.x,int point.y, TColor Colour,]repeated'

                if (temp.LowerCase() == "freeform") {
                    ivalue = ExtractWord(text,",").ToIntDef(-1);
                    text = DeleteWord(text,",");
                    //check that this value of index doesn't exist
                    if (ivalue > -1 && !CheckifEntityExists(ivalue)) {
                        //Have established that the item does not exist, so will re-create it.
                        int arrayentry = FreeFormList.Length;
                        FreeFormList.Length++;
                        FreeFormList[arrayentry].ItemNumber = ivalue;
                        FreeFormList[arrayentry].PenColour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                        text = DeleteWord(text,",");
                        FreeFormList[arrayentry].BrushColour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                        text = DeleteWord(text,",");
                        FreeFormList[arrayentry].LineWidth = ExtractWord(text,",").ToIntDef(1);
                        text = DeleteWord(text,",");
                        FreeFormList[arrayentry].closed = (bool)(ExtractWord(text,",").ToIntDef(0));
                        text = DeleteWord(text,",");
                        FreeFormList[arrayentry].filled = (bool)(ExtractWord(text,",").ToIntDef(0));
                        text = DeleteWord(text,",");
                        int pointer = ExtractWord(text,",").ToIntDef(0);
                        text = DeleteWord(text,",");
                        FreeFormList[arrayentry].Points.Length = pointer;
                        for (int j = 0; j < pointer; j++) {
                            FreeFormList[arrayentry].Points[j].x = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            FreeFormList[arrayentry].Points[j].y = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            FreeFormList[arrayentry].Points[j].Colour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                            text = DeleteWord(text,",");
                            }
                        pointer = ExtractWord(text,",").ToIntDef(0);
                        text = DeleteWord(text,",");
                        FreeFormList[arrayentry].Corners.Length = pointer;
                        for (int j = 0; j < pointer; j++) {
                            FreeFormList[arrayentry].Corners[j].x = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            FreeFormList[arrayentry].Corners[j].y = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            }
                        CreateXRefs();
                        DisplayListAreaUpdate(FreeFormList[arrayentry].ItemNumber);
                        }
                    } //end of 'Add,FreeForm, int ItemNumber, TColor PenColour, TColor BrushColour, int LineWidth, int pointcount, [int point.x,int point.y,]repeated, int cornercount, [int corner.x, int corner.y] repeated'

                if (temp.LowerCase() == "eraseobject") {
                    ivalue = ExtractWord(text,",").ToIntDef(-1);
                    text = DeleteWord(text,",");
                    //check that this value of index doesn't exist
                    if (ivalue > -1 && !CheckifEntityExists(ivalue)) {
                        //Have established that the item does not exist, so will re-create it.
                        int arrayentry = EraseList.Length;
                        EraseList.Length++;
                        EraseList[arrayentry].ItemNumber = ivalue;
                        int pointer = 0;
                        //allocate a huge lump of memory in one go, as it'll be safer than asking to add one at a time
                        EraseList[arrayentry].Points.Length = Picture->Height * Picture->Width + 1;
                        while (text.Length()) {
                            EraseList[arrayentry].Points[pointer].x = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            EraseList[arrayentry].Points[pointer].y = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            EraseList[arrayentry].Points[pointer].Colour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                            text = DeleteWord(text,",");
                            pointer++;
                            }
                        EraseList[arrayentry].Points.Length = pointer;
                        CreateXRefs();
                        DisplayListAreaUpdate(EraseList[arrayentry].ItemNumber);
                        }
                    } //end of 'Add,EraseObject, int ItemNumber, [int point.x,int point.y, TColor Colour,]repeated'

                if (temp.LowerCase() == "block") {
                    ivalue = ExtractWord(text,",").ToIntDef(-1);
                    text = DeleteWord(text,",");
                    //check that this value of index doesn't exist
                    if (ivalue > -1 && !CheckifEntityExists(ivalue)) {
                        //Have established that the item does not exist, so will re-create it.
                        int arrayentry = BlockList.Length;
                        BlockList.Length++;
                        BlockList[arrayentry].ItemNumber = ivalue;
                        int pointer = 0;
                        BlockList[arrayentry].Area.Left = ExtractWord(text,",").ToIntDef(0);
                        text = DeleteWord(text,",");
                        BlockList[arrayentry].Area.Top = ExtractWord(text,",").ToIntDef(0);
                        text = DeleteWord(text,",");
                        BlockList[arrayentry].Area.Right = ExtractWord(text,",").ToIntDef(Picture->Width - 1);
                        text = DeleteWord(text,",");
                        BlockList[arrayentry].Area.Bottom = ExtractWord(text,",").ToIntDef(Picture->Height - 1);
                        text = DeleteWord(text,",");
                        BlockList[arrayentry].Linked = (bool)(ExtractWord(text,",").ToIntDef(0));
                        text = DeleteWord(text,",");
                        BlockList[arrayentry].LinkedBlock = ExtractWord(text,",").ToIntDef(-1);
                        text = DeleteWord(text,",");
                        BlockList[arrayentry].RotationCentre.x = ExtractWord(text,",").ToIntDef(0);
                        text = DeleteWord(text,",");
                        BlockList[arrayentry].RotationCentre.y = ExtractWord(text,",").ToIntDef(0);
                        text = DeleteWord(text,",");
                        BlockList[arrayentry].Angle = ExtractWord(text,",").ToIntDef(0);
                        text = DeleteWord(text,",");
                        BlockList[arrayentry].MirrorCentre.x = ExtractWord(text,",").ToIntDef(-1);
                        text = DeleteWord(text,",");
                        BlockList[arrayentry].MirrorCentre.y = ExtractWord(text,",").ToIntDef(-1);
                        text = DeleteWord(text,",");
                        BlockList[arrayentry].Axis = (TMirrorAxis)(ExtractWord(text,",").ToIntDef(2));
                        text = DeleteWord(text,",");
                        BlockList[arrayentry].delta.x = ExtractWord(text,",").ToIntDef(0);
                        text = DeleteWord(text,",");
                        BlockList[arrayentry].delta.y = ExtractWord(text,",").ToIntDef(0);
                        text = DeleteWord(text,",");
                        BlockList[arrayentry].Points.Length = Picture->Height * Picture->Width + 1;
                        while (text.Length()) {
                            BlockList[arrayentry].Points[pointer].x = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            BlockList[arrayentry].Points[pointer].y = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            BlockList[arrayentry].Points[pointer].originalx = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            BlockList[arrayentry].Points[pointer].originaly = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            BlockList[arrayentry].Points[pointer].Colour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                            text = DeleteWord(text,",");
                            BlockList[arrayentry].Points[pointer].transparent = (bool)(ExtractWord(text,",").ToIntDef(0));
                            text = DeleteWord(text,",");
                            pointer++;
                            }
                        BlockList[arrayentry].Points.Length = pointer;
                        CreateXRefs();
                        DisplayListAreaUpdate(BlockList[arrayentry].ItemNumber);
                        }
                    } //end of 'Add,Block, int ItemNumber, int left, int top, int right, int bottom, bool Linked, int LinkedBlock, int RotationCentre.x,.y, int Angle, Int MirrorCentre.x, .y, TMirrorAxis Axis, int Delta.x, .y  [int point.x,.y,.originalx,.originaly,  TColor Colour,]repeated'

                } //end of 'Add'

            if (temp.LowerCase() == "antialias") {
                AntiAlias = (TAntiAlias)(ExtractWord(text,",").ToIntDef(0));
                text = DeleteWord(text,",");
                subspacesampling = ExtractWord(text,",").ToIntDef(0);
                } //end of 'AntiAlias'

            if (temp.LowerCase() == "background") {
                temp = ExtractWord(text,",");
                BackgroundColour = (TColor)(temp.ToIntDef(16777215));
                Background->Brush->Color = BackgroundColour;
                } //end of 'Background'

            if (temp.LowerCase() == "block") {
                temp = ExtractWord(text,",");
                text = DeleteWord(text,",");

                if (temp.LowerCase() == "changecontents") {
                    ivalue = ExtractWord(text,",").ToIntDef(-1);
                    text = DeleteWord(text,",");
                    //check that this value of index does exist
                    if (ivalue > -1 && CheckifEntityExists(ivalue)) {
                        int arrayentry = 0;
                        bool found = false;
                        while (!found && arrayentry < BlockList.Length) {
                            if (BlockList[arrayentry].ItemNumber == ivalue) {
                                arrayentry--;
                                found = true;
                                }
                            arrayentry++;
                            }
                        if (found) {
                            int pointer = 0;
                            BlockList[arrayentry].Area.Left = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            BlockList[arrayentry].Area.Top = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            BlockList[arrayentry].Area.Right = ExtractWord(text,",").ToIntDef(Picture->Width - 1);
                            text = DeleteWord(text,",");
                            BlockList[arrayentry].Area.Bottom = ExtractWord(text,",").ToIntDef(Picture->Height - 1);
                            text = DeleteWord(text,",");
                            BlockList[arrayentry].Linked = (bool)(ExtractWord(text,",").ToIntDef(0));
                            text = DeleteWord(text,",");
                            BlockList[arrayentry].LinkedBlock = ExtractWord(text,",").ToIntDef(-1);
                            text = DeleteWord(text,",");
                            BlockList[arrayentry].RotationCentre.x = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            BlockList[arrayentry].RotationCentre.y = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            BlockList[arrayentry].Angle = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            BlockList[arrayentry].MirrorCentre.x = ExtractWord(text,",").ToIntDef(-1);
                            text = DeleteWord(text,",");
                            BlockList[arrayentry].MirrorCentre.y = ExtractWord(text,",").ToIntDef(-1);
                            text = DeleteWord(text,",");
                            BlockList[arrayentry].Axis = (TMirrorAxis)(ExtractWord(text,",").ToIntDef(2));
                            text = DeleteWord(text,",");
                            BlockList[arrayentry].delta.x = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            BlockList[arrayentry].delta.y = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            BlockList[arrayentry].Points.Length = Picture->Height * Picture->Width + 1;
                            while (text.Length()) {
                                BlockList[arrayentry].Points[pointer].x = ExtractWord(text,",").ToIntDef(0);
                                text = DeleteWord(text,",");
                                BlockList[arrayentry].Points[pointer].y = ExtractWord(text,",").ToIntDef(0);
                                text = DeleteWord(text,",");
                                BlockList[arrayentry].Points[pointer].originalx = ExtractWord(text,",").ToIntDef(0);
                                text = DeleteWord(text,",");
                                BlockList[arrayentry].Points[pointer].originaly = ExtractWord(text,",").ToIntDef(0);
                                text = DeleteWord(text,",");
                                BlockList[arrayentry].Points[pointer].Colour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                                text = DeleteWord(text,",");
                                BlockList[arrayentry].Points[pointer].transparent = (bool)(ExtractWord(text,",").ToIntDef(0));
                                text = DeleteWord(text,",");
                                pointer++;
                                }
                            BlockList[arrayentry].Points.Length = pointer;
                            CreateXRefs();
                            DisplayListAreaUpdate(BlockList[arrayentry].ItemNumber);
                            //debug
                            DebugBlock(arrayentry);
                            }
                        }
                    } //end of 'Block,changecontents, int ItemNumber, int left, int top, int right, int bottom, bool Linked, int LinkedBlock, int RotationCentre.x,.y, int Angle, Int MirrorCentre.x, .y, TMirrorAxis Axis, int Delta.x, .y  [int point.x,.y,.originalx,.originaly,  TColor Colour,]repeated'
                if (temp.LowerCase() == "link") {
                    int ItemNumber = ExtractWord(text,",").ToIntDef(-1);
                    text = DeleteWord(text,",");
                    bool Linked = (bool)(ExtractWord(text,",").ToIntDef(0));
                    text = DeleteWord(text,",");
                    int LinkedBlock = ExtractWord(text,",").ToIntDef(-1);
                    LinkBlock(ItemNumber,Linked,LinkedBlock);
                    } //end of 'Block,Link,int ItemNumber,bool Linked, int LinkedBlock'

                } //end of 'Block'

            if (temp.LowerCase() == "circle") {
                temp = ExtractWord(text,",");
                text = DeleteWord(text,",");

                if (temp.LowerCase() == "changecontents") {
                    ivalue = ExtractWord(text,",").ToIntDef(-1);
                    text = DeleteWord(text,",");
                    //check that this value of index does exist
                    if (ivalue > -1 && CheckifEntityExists(ivalue)) {
                        int arrayentry = 0;
                        bool found = false;
                        while (!found && arrayentry < EraseList.Length) {
                            if (EraseList[arrayentry].ItemNumber == ivalue) {
                                arrayentry--;
                                found = true;
                                }
                            arrayentry++;
                            }
                        if (found) {
                            CircleList[arrayentry].ItemNumber = ivalue;
                            int pointer = 0;
                            CircleList[arrayentry].PenColour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                            text = DeleteWord(text,",");
                            CircleList[arrayentry].BrushColour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                            text = DeleteWord(text,",");
                            CircleList[arrayentry].LineWidth = ExtractWord(text,",").ToIntDef(1);
                            text = DeleteWord(text,",");
                            CircleList[arrayentry].Area.Left = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            CircleList[arrayentry].Area.Top = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            CircleList[arrayentry].Area.Right = ExtractWord(text,",").ToIntDef(Picture->Width - 1);
                            text = DeleteWord(text,",");
                            CircleList[arrayentry].Area.Bottom = ExtractWord(text,",").ToIntDef(Picture->Height - 1);
                            text = DeleteWord(text,",");
                            CircleList[arrayentry].Shape = (TShapeType)(ExtractWord(text,",").ToIntDef((int)(stCircle)));
                            text = DeleteWord(text,",");
                            CircleList[arrayentry].Angle = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            CircleList[arrayentry].Filled = ((bool)(ExtractWord(text,",").ToIntDef(0)));
                            text = DeleteWord(text,",");
                            //allocate a huge lump of memory in one go, as it'll be safer than asking to add one at a time
                            CircleList[arrayentry].Points.Length = Picture->Height * Picture->Width + 1;
                            while (text.Length()) {
                                CircleList[arrayentry].Points[pointer].x = ExtractWord(text,",").ToIntDef(0);
                                text = DeleteWord(text,",");
                                CircleList[arrayentry].Points[pointer].y = ExtractWord(text,",").ToIntDef(0);
                                text = DeleteWord(text,",");
                                CircleList[arrayentry].Points[pointer].Colour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                                text = DeleteWord(text,",");
                                pointer++;
                                }
                            CircleList[arrayentry].Points.Length = pointer;
                            CreateXRefs();
                            DisplayListAreaUpdate(CircleList[arrayentry].ItemNumber);
                            }
                        }
                    } //end of 'Circle,changecontents, int ItemNumber, TColor PenColour, BrushColour, int LineWidth, int left, int top, int right, int bottom, TShapeType Shape, int angle * 10, bool Filled, [int point.x,int point.y, TColor Colour,]repeated'

                if (temp.LowerCase() == "colour") {
                    temp = ExtractWord(text,",");
                    text = DeleteWord(text,",");
                    int ItemNumber = temp.ToIntDef(-1);
                    temp = ExtractWord(text,",");
                    text = DeleteWord(text,",");
                    TColor PenColour = (TColor)(temp.ToIntDef(16777215));
                    temp = ExtractWord(text,",");
                    TColor BrushColour = (TColor)(temp.ToIntDef(16777215));
                    ChangeCircleColour(ItemNumber,PenColour,BrushColour);
                    } //end of Circle,Colour,ItemNumber,TColor PenColour, TColor BrushColour

                } //end of 'Circle'

            if (temp.LowerCase() == "delete") {
                temp = ExtractWord(text,",");
                ivalue = temp.ToIntDef(-1);
                if (ivalue > -1 && ivalue < XRefs.Length) {
                    TDisplayType displaytype = XRefs[ivalue].DisplayType;
                    switch (displaytype) {
                        case TDisplayBlock:    {
                                                DeleteBlock(ivalue);
                                                }
                                                break;
                        case TDisplayFreeForm:  {
                                                DeleteFreeForm(ivalue);
                                                }
                                                break;
                        case TDisplayCircle:    {
                                                DeleteCircle(ivalue);
                                                }
                                                break;
                        case TDisplayRectangle: {
                                                DeleteRectangle(ivalue);
                                                }
                                                break;
                        case TDisplayEraseItem: {
                                                DeleteErase(ivalue);
                                                }
                                                break;
                        case TDisplayLine:      {
                                                DeleteLine(ivalue);
                                                }
                                                break;
                        case TDisplayPolyLine:  {
                                                DeletePolyLine(ivalue);
                                                }
                                                break;
                        case TDisplayText:      {
                                                DeleteText(ivalue);
                                                }
                                                break;
                        case TDisplayFloodFill: {
                                                DeleteFloodFill(ivalue);
                                                }
                                                break;
                        case TDisplayPoint:     {
                                                DeletePoints(ivalue);
                                                }
                                                break;
                        default:                break;
                        }
                    //DeleteDisplayItem(ivalue, displaytype);
                    } //end of 'Delete,ItemNumber'
                } //end of 'Delete'

            if (temp.LowerCase() == "deselect") {
                ivalue = ExtractWord(text,",").ToIntDef(1);
                if (ivalue > -1 && ivalue < XRefs.Length) {
                    int EntityNo = XRefs[ivalue].EntityXRef;
                    if (EntityNo > -1 && EntityNo < DisplayList.Length && DisplayList[EntityNo].ItemNumber == ivalue) {
                        DisplayList[EntityNo].selected = false;
                        }
                    }
                }//end of 'Deselect,ItemNumber'

            if (temp.LowerCase() == "displayorder") {
                ivalue = ExtractWord(text,",").ToIntDef(1);
                text = DeleteWord(text,",");
                if (ivalue > -1 && ivalue < XRefs.Length) {
                    int EntityNo = XRefs[ivalue].EntityXRef;
                    if (EntityNo > -1 && EntityNo < DisplayList.Length && DisplayList[EntityNo].ItemNumber == ivalue) {
                        //have established that we're looking at the right item.
                        int newarrayposition = ExtractWord(text,",").ToIntDef(0);
                        if (EntityNo != newarrayposition) {
                            displaylist swap;
                            swap = DisplayList[EntityNo];
                            if (EntityNo < newarrayposition) {
                                //all entities between EntityNo and newarrayposition move down one.
                                for (int i = EntityNo ; i < newarrayposition; i++) {
                                    DisplayList[i] = DisplayList[i + 1];
                                    }
                                DisplayList[newarrayposition] = swap;
                                } else {
                                //all entities between EntityNo and newarrayposition move up one.
                                for (int i = EntityNo ; i > newarrayposition; i--) {
                                    DisplayList[i] = DisplayList[i - 1];
                                    }
                                DisplayList[newarrayposition] = swap;
                                }
                            CreateXRefs();
                            }
                        }
                    }
                }//end of 'DisplayOrder,ItemNumber,array index'

            if (temp.LowerCase() == "elasticbandstart") {
                StartPointChart.x = ExtractWord(text,",").ToIntDef(0);
                text = DeleteWord(text,",");
                StartPointChart.y = ExtractWord(text,",").ToIntDef(0);
                chartposition Location = FindImage1Position(StartPointChart.x,StartPointChart.y);
                StartPointScreen.x = Location.X;
                StartPointScreen.y = Location.Y;
                }  // end of 'ElasticBandStart,x,y,'

            if (temp.LowerCase() == "erase") {
                temp = ExtractWord(text,",");
                text = DeleteWord(text,",");
                if (temp.LowerCase() == "eraseobject") {
                    ivalue = ExtractWord(text,",").ToIntDef(-1);
                    text = DeleteWord(text,",");
                    //check that this value of index does exist
                    if (ivalue > -1 && CheckifEntityExists(ivalue)) {
                        //Have established that the item does exist, so can edit it.
                        int arrayentry = 0;
                        bool found = false;
                        while (!found && arrayentry < EraseList.Length) {
                            if (EraseList[arrayentry].ItemNumber == ivalue) {
                                arrayentry--;
                                found = true;
                                }
                            arrayentry++;
                            }
                        if (found) {
                            int pointer = 0;
                            //allocate a huge lump of memory in one go, as it'll be safer than asking to add one at a time
                            EraseList[arrayentry].Points.Length = Picture->Height * Picture->Width + 1;
                            while (text.Length()) {
                                EraseList[arrayentry].Points[pointer].x = ExtractWord(text,",").ToIntDef(0);
                                text = DeleteWord(text,",");
                                EraseList[arrayentry].Points[pointer].y = ExtractWord(text,",").ToIntDef(0);
                                text = DeleteWord(text,",");
                                EraseList[arrayentry].Points[pointer].Colour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                                text = DeleteWord(text,",");
                                pointer++;
                                }
                            EraseList[arrayentry].Points.Length = pointer;
                            DisplayListAreaUpdate(EraseList[arrayentry].ItemNumber);
                            }
                        }
                    } //end of 'Erase,changecontents, int ItemNumber, [int point.x,int point.y, TColor Colour,]repeated'
                } //end of 'Erase'

            if (temp.LowerCase() == "fillshapes") {
                temp = ExtractWord(text,",");
                text = DeleteWord(text,",");
                FillShapes = ((bool)(ExtractWord(temp,",").ToIntDef(0)));
                } //end of 'FillShapes,bool value'

            if (temp.LowerCase() == "floodfill") {
                temp = ExtractWord(text,",");
                text = DeleteWord(text,",");
                if (temp.LowerCase() == "changecontents") {
                    ivalue = ExtractWord(text,",").ToIntDef(-1);
                    text = DeleteWord(text,",");
                    //check that this value of index does exist
                    if (ivalue > -1 && CheckifEntityExists(ivalue)) {
                        //Have established that the item does exist, so can edit it.
                        int arrayentry = 0;
                        bool found = false;
                        while (!found && arrayentry < FloodFillList.Length) {
                            if (FloodFillList[arrayentry].ItemNumber == ivalue) {
                                arrayentry--;
                                found = true;
                                }
                            arrayentry++;
                            }
                        if (found) {
                            FloodFillList[arrayentry].Colour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                            text = DeleteWord(text,",");
                            FloodFillList[arrayentry].FilledColour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                            text = DeleteWord(text,",");
                            FloodFillList[arrayentry].StartPoint.x = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            FloodFillList[arrayentry].StartPoint.y = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            int pointer = 0;
                            //allocate a huge lump of memory in one go, as it'll be safer than asking to add one at a time
                            FloodFillList[arrayentry].Points.Length = Picture->Height * Picture->Width + 1;
                            while (text.Length()) {
                                FloodFillList[arrayentry].Points[pointer].x = ExtractWord(text,",").ToIntDef(0);
                                text = DeleteWord(text,",");
                                FloodFillList[arrayentry].Points[pointer].y = ExtractWord(text,",").ToIntDef(0);
                                text = DeleteWord(text,",");
                                pointer++;
                                }
                            FloodFillList[arrayentry].Points.Length = pointer;
                            DisplayListAreaUpdate(FloodFillList[arrayentry].ItemNumber);
                            }
                        }
                    } //end of 'FloodFill,changecontents, int ItemNumber, TColor Colour, TColor FilledColour, int StartPoint x, y, [int point.x,int point.y,]repeated'
                if (temp.LowerCase() == "colour") {
                    temp = ExtractWord(text,",");
                    text = DeleteWord(text,",");
                    int ItemNumber = temp.ToIntDef(-1);
                    temp = ExtractWord(text,",");
                    TColor Colour = (TColor)(temp.ToIntDef(16777215));
                    ChangeFloodFillColour(ItemNumber,Colour);
                    } //end of FloodFill,Colour,ItemNumber,TColor

                } //end of 'FloodFill'

            if (temp.LowerCase() == "foreground") {
                temp = ExtractWord(text,",");
                ForegroundColour = (TColor)(temp.ToIntDef(0));
                Foreground->Brush->Color = ForegroundColour;
                DisplayCurrentColours();
                } //end of 'Foreground'

            if (temp.LowerCase() == "freeform") {
                temp = ExtractWord(text,",");
                text = DeleteWord(text,",");
                if (temp.LowerCase() == "changecontents") {
                    ivalue = ExtractWord(text,",").ToIntDef(-1);
                    text = DeleteWord(text,",");
                    //check that this value of index doesn't exist
                    if (ivalue > -1 && CheckifEntityExists(ivalue)) {
                        //Have established that the item does exist, so will re-create it.
                        int arrayentry = 0;
                        bool found = false;
                        while (!found && arrayentry < FreeFormList.Length) {
                            if (FreeFormList[arrayentry].ItemNumber == ivalue) {
                                arrayentry--;
                                found = true;
                                }
                            arrayentry++;
                            }
                        if (found) {
                            FreeFormList[arrayentry].PenColour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                            text = DeleteWord(text,",");
                            FreeFormList[arrayentry].BrushColour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                            text = DeleteWord(text,",");
                            FreeFormList[arrayentry].LineWidth = ExtractWord(text,",").ToIntDef(1);
                            text = DeleteWord(text,",");
                            FreeFormList[arrayentry].closed = (bool)(ExtractWord(text,",").ToIntDef(0));
                            text = DeleteWord(text,",");
                            FreeFormList[arrayentry].filled = (bool)(ExtractWord(text,",").ToIntDef(0));
                            text = DeleteWord(text,",");
                            int pointer = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            FreeFormList[arrayentry].Points.Length = pointer;
                            for (int j = 0; j < pointer; j++) {
                                FreeFormList[arrayentry].Points[j].x = ExtractWord(text,",").ToIntDef(0);
                                text = DeleteWord(text,",");
                                FreeFormList[arrayentry].Points[j].y = ExtractWord(text,",").ToIntDef(0);
                                text = DeleteWord(text,",");
                                FreeFormList[arrayentry].Points[j].Colour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                                text = DeleteWord(text,",");
                                }
                            pointer = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            FreeFormList[arrayentry].Corners.Length = pointer;
                            for (int j = 0; j < pointer; j++) {
                                FreeFormList[arrayentry].Corners[j].x = ExtractWord(text,",").ToIntDef(0);
                                text = DeleteWord(text,",");
                                FreeFormList[arrayentry].Corners[j].y = ExtractWord(text,",").ToIntDef(0);
                                text = DeleteWord(text,",");
                                }
                            CreateXRefs();
                            DisplayListAreaUpdate(FreeFormList[arrayentry].ItemNumber);
                            }
                        }
                    } //end of 'FreeForm,changecontents, int ItemNumber, TColor PenColour, TColor BrushColour, int LineWidth, int pointcount, [int point.x,int point.y,]repeated, int cornercount, [int corner.x, int corner.y] repeated'
                } //end of 'FreeForm'

            if (temp.LowerCase() == "hide") {
                ivalue = ExtractWord(text,",").ToIntDef(1);
                if (ivalue > -1 && ivalue < XRefs.Length) {
                    int EntityNo = XRefs[ivalue].EntityXRef;
                    if (EntityNo > -1 && EntityNo < DisplayList.Length && DisplayList[EntityNo].ItemNumber == ivalue) {
                        DisplayList[EntityNo].visible = false;
                        }
                    }
                }//end of 'Hide,ItemNumber'

            if (temp.LowerCase() == "line") {
                temp = ExtractWord(text,",");
                text = DeleteWord(text,",");
                if (temp.LowerCase() == "changecontents") {
                    ivalue = ExtractWord(text,",").ToIntDef(-1);
                    text = DeleteWord(text,",");
                    //check that this value of index does exist
                    if (ivalue > -1 && CheckifEntityExists(ivalue)) {
                        //Have established that the item does exist, so can edit it.
                        int arrayentry = 0;
                        bool found = false;
                        while (!found && arrayentry < LineList.Length) {
                            if (LineList[arrayentry].ItemNumber == ivalue) {
                                arrayentry--;
                                found = true;
                                }
                            arrayentry++;
                            }
                        if (found) {
                            LineList[arrayentry].Colour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                            text = DeleteWord(text,",");
                            LineList[arrayentry].LineWidth = ExtractWord(text,",").ToIntDef(1);
                            text = DeleteWord(text,",");
                            LineList[arrayentry].StartPoint.x = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            LineList[arrayentry].StartPoint.y = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            LineList[arrayentry].EndPoint.x = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            LineList[arrayentry].EndPoint.y = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            int pointer = 0;
                            //allocate a huge lump of memory in one go, as it'll be safer than asking to add one at a time
                            LineList[arrayentry].Points.Length = Picture->Height * Picture->Width + 1;
                            while (text.Length()) {
                                LineList[arrayentry].Points[pointer].x = ExtractWord(text,",").ToIntDef(0);
                                text = DeleteWord(text,",");
                                LineList[arrayentry].Points[pointer].y = ExtractWord(text,",").ToIntDef(0);
                                text = DeleteWord(text,",");
                                LineList[arrayentry].Points[pointer].Colour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                                text = DeleteWord(text,",");
                                pointer++;
                                }
                            LineList[arrayentry].Points.Length = pointer;
                            DisplayListAreaUpdate(LineList[arrayentry].ItemNumber);
                            }
                        }
                    } //end of 'line,changecontents, int ItemNumber, TColor Colour, int LineWidth, int StartPoint x, y, int EndPoint x, y, [int point.x,int point.y,]repeated'
                if (temp.LowerCase() == "colour") {
                    temp = ExtractWord(text,",");
                    text = DeleteWord(text,",");
                    int ItemNumber = temp.ToIntDef(-1);
                    temp = ExtractWord(text,",");
                    TColor Colour = (TColor)(temp.ToIntDef(16777215));
                    ChangeLineColour(ItemNumber,Colour);
                    } //end of Line,Colour,ItemNumber,TColor

                } //end of 'Line'

            if (temp.LowerCase() == "linewidth") {
                ivalue = ExtractWord(text,",").ToIntDef(1);
                LineWidth = ivalue;
                }//end of 'LineWidth'

            if (temp.LowerCase() == "move") {
                temp = ExtractWord(text,",");
                ivalue = temp.ToIntDef(-1);
                text = DeleteWord(text,",");
                if (ivalue > -1 && ivalue < XRefs.Length) {
                    TDisplayType displaytype = XRefs[ivalue].DisplayType;
                    TPoint delta;
                    temp = ExtractWord(text,",");
                    delta.x = temp.ToIntDef(0);
                    text = DeleteWord(text,",");
                    temp = ExtractWord(text,",");
                    delta.y = temp.ToIntDef(0);
                    switch (displaytype) {
                        case TDisplayBlock:    {
                                                MoveBlock(delta,ivalue);
                                                }
                                                break;
                        case TDisplayFreeForm:  {
                                                MoveFreeForm(delta,ivalue);
                                                }
                                                break;
                        case TDisplayCircle:    {
                                                MoveCircle(delta,ivalue);
                                                }
                                                break;
                        case TDisplayRectangle: {
                                                MoveRectangle(delta,ivalue);
                                                }
                                                break;
                        case TDisplayEraseItem: {
                                                MoveErase(delta,ivalue);
                                                }
                                                break;
                        case TDisplayLine:      {
                                                MoveLine(delta,ivalue);
                                                }
                                                break;
                        case TDisplayPolyLine:  {
                                                MovePolyLine(delta,ivalue);
                                                }
                                                break;
                        case TDisplayText:      {
                                                MoveText(delta,ivalue);
                                                }
                                                break;
                        case TDisplayFloodFill: {
                                                MoveFloodFill(delta,ivalue);
                                                }
                                                break;
                        case TDisplayPoint:     {
                                                MovePoint(delta,ivalue);
                                                }
                                                break;
                        default:                break;
                        }
                    } //end of 'Move,ItemNumber,delta x,y'
                } //end of 'Move'

            if (temp.LowerCase() == "point") {
                temp = ExtractWord(text,",");
                text = DeleteWord(text,",");
                if (temp.LowerCase() == "changecontents") {
                    ivalue = ExtractWord(text,",").ToIntDef(-1);
                    text = DeleteWord(text,",");
                    //check that this value of index doesn't exist
                    if (ivalue > -1 && CheckifEntityExists(ivalue)) {
                        //Have established that the item does exist, so can edit it.
                        int arrayentry = 0;
                        bool found = false;
                        while (!found && arrayentry < PointList.Length) {
                            if (PointList[arrayentry].ItemNumber == ivalue) {
                                arrayentry--;
                                found = true;
                                }
                            arrayentry++;
                            }
                        if (found) {
                            PointList[arrayentry].Colour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                            text = DeleteWord(text,",");
                            int pointer = 0;
                            //allocate a huge lump of memory in one go, as it'll be safer than asking to add one at a time
                            PointList[arrayentry].Points.Length = Picture->Height * Picture->Width + 1;
                            while (text.Length()) {
                                PointList[arrayentry].Points[pointer].x = ExtractWord(text,",").ToIntDef(0);
                                text = DeleteWord(text,",");
                                PointList[arrayentry].Points[pointer].y = ExtractWord(text,",").ToIntDef(0);
                                text = DeleteWord(text,",");
                                pointer++;
                                }
                            PointList[arrayentry].Points.Length = pointer;
                            DisplayListAreaUpdate(PointList[arrayentry].ItemNumber);
                            }
                        }
                    } //end of 'Point, ChangeContents, int ItemNumber, TColor Colour, [int point.x,int point.y,]repeated'
                if (temp.LowerCase() == "colour") {
                    ivalue = ExtractWord(text,",").ToIntDef(-1);
                    text = DeleteWord(text,",");
                    //check that this value of index doesn't exist
                    if (ivalue > -1 && CheckifEntityExists(ivalue)) {
                        //Have established that the item does exist, so can edit it.
                        int arrayentry = 0;
                        bool found = false;
                        while (!found && arrayentry < PointList.Length) {
                            if (PointList[arrayentry].ItemNumber == ivalue) {
                                arrayentry--;
                                found = true;
                                }
                            arrayentry++;
                            }
                        if (found) {
                            PointList[arrayentry].Colour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                            text = DeleteWord(text,",");
                            }
                        }
                    } //end of 'Point, Colour, int ItemNumber, TColor Colour'

                } //end of Point

            if (temp.LowerCase() == "polyline") {
                temp = ExtractWord(text,",");
                text = DeleteWord(text,",");
                if (temp.LowerCase() == "changecontents") {
                    ivalue = ExtractWord(text,",").ToIntDef(-1);
                    text = DeleteWord(text,",");
                    //check that this value of index doesn't exist
                    if (ivalue > -1 && CheckifEntityExists(ivalue)) {
                        //Have established that the item does exist, so will re-create it.
                        int arrayentry = 0;
                        bool found = false;
                        while (!found && arrayentry < PolyLineList.Length) {
                            if (PolyLineList[arrayentry].ItemNumber == ivalue) {
                                arrayentry--;
                                found = true;
                                }
                            arrayentry++;
                            }
                        if (found) {
                            PolyLineList[arrayentry].PenColour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                            text = DeleteWord(text,",");
                            PolyLineList[arrayentry].BrushColour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                            text = DeleteWord(text,",");
                            PolyLineList[arrayentry].LineWidth = ExtractWord(text,",").ToIntDef(1);
                            text = DeleteWord(text,",");
                            PolyLineList[arrayentry].closed = (bool)(ExtractWord(text,",").ToIntDef(0));
                            text = DeleteWord(text,",");
                            PolyLineList[arrayentry].filled = (bool)(ExtractWord(text,",").ToIntDef(0));
                            text = DeleteWord(text,",");
                            int pointer = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            PolyLineList[arrayentry].Points.Length = pointer;
                            for (int j = 0; j < pointer; j++) {
                                PolyLineList[arrayentry].Points[j].x = ExtractWord(text,",").ToIntDef(0);
                                text = DeleteWord(text,",");
                                PolyLineList[arrayentry].Points[j].y = ExtractWord(text,",").ToIntDef(0);
                                text = DeleteWord(text,",");
                                PolyLineList[arrayentry].Points[j].Colour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                                text = DeleteWord(text,",");
                                }
                            pointer = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            PolyLineList[arrayentry].Corners.Length = pointer;
                            for (int j = 0; j < pointer; j++) {
                                PolyLineList[arrayentry].Corners[j].x = ExtractWord(text,",").ToIntDef(0);
                                text = DeleteWord(text,",");
                                PolyLineList[arrayentry].Corners[j].y = ExtractWord(text,",").ToIntDef(0);
                                text = DeleteWord(text,",");
                                }
                            CreateXRefs();
                            DisplayListAreaUpdate(PolyLineList[arrayentry].ItemNumber);
                            }
                        }
                    } //end of 'Polyline,changecontents, int ItemNumber, TColor PenColour, TColor BrushColour, int LineWidth, int pointcount, [int point.x,int point.y,]repeated, int cornercount, [int corner.x, int corner.y] repeated'
                } //end of 'polyline'

            if (temp.LowerCase() == "rectangle") {
                temp = ExtractWord(text,",");
                text = DeleteWord(text,",");

                if (temp.LowerCase() == "changecontents") {
                    ivalue = ExtractWord(text,",").ToIntDef(-1);
                    text = DeleteWord(text,",");
                    //check that this value of index does exist
                    if (ivalue > -1 && CheckifEntityExists(ivalue)) {
                        //Have established that the item does exist, so can edit it.
                        int arrayentry = 0;
                        bool found = false;
                        while (!found && arrayentry < TextList.Length) {
                            if (TextList[arrayentry].ItemNumber == ivalue) {
                                arrayentry--;
                                found = true;
                                }
                            arrayentry++;
                            }
                        if (found) {
                            int pointer = 0;
                            RectangleList[arrayentry].PenColour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                            text = DeleteWord(text,",");
                            RectangleList[arrayentry].BrushColour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                            text = DeleteWord(text,",");
                            RectangleList[arrayentry].LineWidth = ExtractWord(text,",").ToIntDef(1);
                            text = DeleteWord(text,",");
                            RectangleList[arrayentry].Area.Left = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            RectangleList[arrayentry].Area.Top = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            RectangleList[arrayentry].Area.Right = ExtractWord(text,",").ToIntDef(Picture->Width - 1);
                            text = DeleteWord(text,",");
                            RectangleList[arrayentry].Area.Bottom = ExtractWord(text,",").ToIntDef(Picture->Height - 1);
                            text = DeleteWord(text,",");
                            RectangleList[arrayentry].Shape = (TShapeType)(ExtractWord(text,",").ToIntDef((int)(stRectangle)));
                            text = DeleteWord(text,",");
                            RectangleList[arrayentry].Angle = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            RectangleList[arrayentry].Filled = ((bool)(ExtractWord(text,",").ToIntDef(0)));
                            text = DeleteWord(text,",");
                            //allocate a huge lump of memory in one go, as it'll be safer than asking to add one at a time
                            RectangleList[arrayentry].Points.Length = Picture->Height * Picture->Width + 1;
                            while (text.Length()) {
                                RectangleList[arrayentry].Points[pointer].x = ExtractWord(text,",").ToIntDef(0);
                                text = DeleteWord(text,",");
                                RectangleList[arrayentry].Points[pointer].y = ExtractWord(text,",").ToIntDef(0);
                                text = DeleteWord(text,",");
                                RectangleList[arrayentry].Points[pointer].Colour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                                text = DeleteWord(text,",");
                                pointer++;
                                }
                            RectangleList[arrayentry].Points.Length = pointer;
                            CreateXRefs();
                            DisplayListAreaUpdate(RectangleList[arrayentry].ItemNumber);
                            }
                        }
                    } //end of 'Rectangle,changecontents, int ItemNumber, TColor PenColour, BrushColour, int LineWidth, int left, int top, int right, int bottom, TShapeType Shape, int angle * 10, bool Filled, [int point.x,int point.y, TColor Colour,]repeated'


                if (temp.LowerCase() == "colour") {
                    temp = ExtractWord(text,",");
                    text = DeleteWord(text,",");
                    int ItemNumber = temp.ToIntDef(-1);
                    temp = ExtractWord(text,",");
                    text = DeleteWord(text,",");
                    TColor PenColour = (TColor)(temp.ToIntDef(0));
                    temp = ExtractWord(text,",");
                    TColor BrushColour = (TColor)(temp.ToIntDef(16777215));
                    ChangeRectangleColour(ItemNumber,PenColour,BrushColour);
                    } //end of Rectangle,Colour,ItemNumber,TColor PenColour, TColor BrushColour

                } //end of 'Rectangle'

            if (temp.LowerCase() == "rotate") {
                temp = ExtractWord(text,",");
                ivalue = temp.ToIntDef(-1);
                text = DeleteWord(text,",");
                if (ivalue > -1 && ivalue < XRefs.Length) {
                    TDisplayType displaytype = XRefs[ivalue].DisplayType;
                    TPoint delta;
                    temp = ExtractWord(text,",");
                    delta.x = temp.ToIntDef(0);
                    text = DeleteWord(text,",");
                    temp = ExtractWord(text,",");
                    delta.y = temp.ToIntDef(0);
                    text = DeleteWord(text,",");
                    int Angle = ExtractWord(text,",").ToIntDef(0);
                    switch (displaytype) {
                        case TDisplayBlock:    {
                                                RotateBlock(delta,ivalue,Angle);
                                                }
                                                break;
                        case TDisplayCircle:    {
                                                RotateCircle(delta,ivalue,Angle);
                                                }
                                                break;
                        case TDisplayRectangle: {
                                                RotateRectangle(delta,ivalue,Angle);
                                                }
                                                break;
                        case TDisplayEraseItem: {
                                                RotateErase(delta,ivalue,Angle);
                                                }
                                                break;
                        case TDisplayLine:      {
                                                RotateLine(delta,ivalue,Angle);
                                                }
                                                break;
                        case TDisplayPolyLine:  {
                                                RotatePolyLine(delta,ivalue,Angle);
                                                }
                                                break;
                        case TDisplayText:      {
                                                RotateText(delta,ivalue,Angle);
                                                }
                                                break;
                        case TDisplayFloodFill: {
                                                RotateFloodFill(delta,ivalue,Angle);
                                                }
                                                break;
                        case TDisplayPoint:     {
                                                RotatePoint(delta,ivalue,Angle);
                                                }
                                                break;
                        default:                break;
                        }
                    } //end of 'Rotate,ItemNumber,delta x,y, int (angle * 10)'
                } //end of 'Rotate'

            if (temp.LowerCase() == "select") {
                ivalue = ExtractWord(text,",").ToIntDef(1);
                if (ivalue > -1 && ivalue < XRefs.Length) {
                    int EntityNo = XRefs[ivalue].EntityXRef;
                    if (EntityNo > -1 && EntityNo < DisplayList.Length && DisplayList[EntityNo].ItemNumber == ivalue) {
                        DisplayList[EntityNo].selected = true;
                        }
                    }
                }//end of 'Select,ItemNumber'

            if (temp.LowerCase() == "show") {
                ivalue = ExtractWord(text,",").ToIntDef(1);
                if (ivalue > -1 && ivalue < XRefs.Length) {
                    int EntityNo = XRefs[ivalue].EntityXRef;
                    if (EntityNo > -1 && EntityNo < DisplayList.Length && DisplayList[EntityNo].ItemNumber == ivalue) {
                        DisplayList[EntityNo].visible = true;
                        }
                    }
                }//end of 'Show,ItemNumber'

            if (temp.LowerCase() == "text") {
                temp = ExtractWord(text,",");
                text = DeleteWord(text,",");

                if (temp.LowerCase() == "changecontents") {
                    ivalue = ExtractWord(text,",").ToIntDef(-1);
                    text = DeleteWord(text,",");
                    //check that this value of index does exist
                    if (ivalue > -1 && CheckifEntityExists(ivalue)) {
                        //Have established that the item does exist, so can edit it.
                        int arrayentry = 0;
                        bool found = false;
                        while (!found && arrayentry < TextList.Length) {
                            if (TextList[arrayentry].ItemNumber == ivalue) {
                                arrayentry--;
                                found = true;
                                }
                            arrayentry++;
                            }
                        if (found) {
                            TextList[arrayentry].Name = ExtractWord(text,",");
                            text = DeleteWord(text,",");
                            TextList[arrayentry].Height = ExtractWord(text,",").ToIntDef(12);
                            text = DeleteWord(text,",");
                            TextList[arrayentry].Bold = (bool)(ExtractWord(text,",").ToIntDef(0));
                            text = DeleteWord(text,",");
                            TextList[arrayentry].Italic = (bool)(ExtractWord(text,",").ToIntDef(0));
                            text = DeleteWord(text,",");
                            TextList[arrayentry].Underlined = (bool)(ExtractWord(text,",").ToIntDef(0));
                            text = DeleteWord(text,",");
                            TextList[arrayentry].Strikeout = (bool)(ExtractWord(text,",").ToIntDef(0));
                            text = DeleteWord(text,",");
                            TextList[arrayentry].Colour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                            text = DeleteWord(text,",");
                            TextList[arrayentry].StartPoint.x = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            TextList[arrayentry].StartPoint.y = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            TextList[arrayentry].Angle = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            TextList[arrayentry].Points.Length = ExtractWord(text,",").ToIntDef(0);
                            text = DeleteWord(text,",");
                            for (int i = 0; i < TextList[arrayentry].Points.Length; i++) {
                                TextList[arrayentry].Points[i].x = ExtractWord(text,",").ToIntDef(0);
                                text = DeleteWord(text,",");
                                TextList[arrayentry].Points[i].y = ExtractWord(text,",").ToIntDef(0);
                                text = DeleteWord(text,",");
                                TextList[arrayentry].Points[i].Colour = (TColor)(ExtractWord(text,",").ToIntDef(0));
                                text = DeleteWord(text,",");
                                }
                            TextList[arrayentry].Text = text;
                            CreateXRefs();
                            DisplayListAreaUpdate(TextList[arrayentry].ItemNumber);
                            }
                        }
                    } //end of 'Text,changecontents, int ItemNumber, AnsiString FontName, int Height, bool bold, bool Italic, bool Underlined, bool Strikeout, TColor Colour, int StartPoint x, y, int Angle, int NumberofPoints, [int point.x,int point.y,]repeated' , Text;

                if (temp.LowerCase() == "changetext") {
                    temp = ExtractWord(text,",");
                    text = DeleteWord(text,",");
                    int ItemNumber = temp.ToIntDef(-1);
                    ChangeText(ItemNumber,text);
                    } //end of Text,ChangeText,ItemNumber,New Text

                if (temp.LowerCase() == "colour") {
                    temp = ExtractWord(text,",");
                    text = DeleteWord(text,",");
                    int ItemNumber = temp.ToIntDef(-1);
                    temp = ExtractWord(text,",");
                    TColor Colour = (TColor)(temp.ToIntDef(16777215));
                    ChangeTextColour(ItemNumber,Colour);
                    } //end of Text,Colour,ItemNumber,TColor

                } //end of 'Text'

            }  // end of line interpretation loop
        if (UndoTitleList->Count && LeftString(UndoTitleList->Strings[UndoTitleList->Count - 1],6) == "Title,") {
            UndoTitleList->Delete(UndoTitleList->Count - 1);
            }
        CreateXRefs();
        DrawPicture();
        }
    Undoing = false;
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DeleteDisplayItem(int ItemNumber, TDisplayType DisplayType)
{
    int pointer = XRefs[ItemNumber].DisplayXRef;
    bool found = false;

    if (pointer > -1 && pointer < DisplayList.Length && DisplayList[pointer].ItemNumber == ItemNumber && DisplayList[pointer].DisplayType == DisplayType) found = true;

    if (found) {
        if (!Undoing) {
            AnsiString text;
            text = "Add,DisplayItem," + AnsiString(ItemNumber) + ","
                                + AnsiString((int)(DisplayType)) + ","
                                + AnsiString(pointer) + ","
                                + AnsiString((int)(DisplayList[pointer].selected)) + ","
                                + AnsiString((int)(DisplayList[pointer].visible)) + ","
                                + AnsiString(DisplayList[pointer].Area.Left) + ","
                                + AnsiString(DisplayList[pointer].Area.Top) + ","
                                + AnsiString(DisplayList[pointer].Area.Right) + ","
                                + AnsiString(DisplayList[pointer].Area.Bottom) + ","
                                ;
            AddUndo(text);
            }
        for (int i = pointer; i < DisplayList.Length - 1; i++) {
            DisplayList[i] = DisplayList[i+1];
            }
        DisplayList.Length--;
        CreateXRefs();
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DeletePoints(int ItemNumber)
{
    //start looking at the end of the array as the most common deletion will be from undo
    /*int pointer = PointList.Length - 1;
    bool found = false;

    while (!found && pointer > -1) {
        if (PointList[pointer].ItemNumber == ItemNumber) {
            found = true;
            pointer++;
            }
        pointer--;
        }

    if (found) {
        for (int i = pointer; i < PointList.Length - 2; i++) {
            PointList[i].ItemNumber = PointList[i + 1].ItemNumber;
            PointList[i].Colour = PointList[i + 1].Colour;
            PointList[i].Points.Length = PointList[i + 1].Points.Length;
            for (int j = 0; j < PointList[i].Points.Length; j++) {
                PointList[i].Points[j] = PointList[i+1].Points[j];
                }
            }
        PointList[PointList.Length - 1].Points.Length = 0;
        PointList.Length--;
        }*/

    int pointer = XRefs[ItemNumber].EntityXRef;
    bool found = false;

    if (XRefs[ItemNumber].DisplayType == TDisplayPoint && pointer > -1 && pointer < PointList.Length && PointList[pointer].ItemNumber == ItemNumber) found = true;

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Delete Pencil Object");
            AnsiString text;
            text = "Add,Point," + AnsiString(ItemNumber) + ","
                                + AnsiString((int)(PointList[pointer].Colour)) + ","
                                ;
            for (int j = 0; j < PointList[pointer].Points.Length; j++) {
                text = text + AnsiString(PointList[pointer].Points[j].x) + "," + AnsiString(PointList[pointer].Points[j].y) + ",";
                }
            AddUndo(text);
            /*text = "Add,DisplayItem," + AnsiString(ItemNumber) + ","
                                      + AnsiString((int)(TDisplayPoint)) + ","
                                      + AnsiString(XRefs[ItemNumber].DisplayXRef) + ","
                                      ;
            AddUndo(text);*/
            }
        for (int i = pointer; i < PointList.Length - 1; i++) {
            PointList[i].ItemNumber = PointList[i + 1].ItemNumber;
            PointList[i].Colour = PointList[i + 1].Colour;
            PointList[i].Points.Length = PointList[i + 1].Points.Length;
            for (int j = 0; j < PointList[i].Points.Length; j++) {
                PointList[i].Points[j] = PointList[i+1].Points[j];
                }
            }
        PointList[PointList.Length - 1].Points.Length = 0;
        PointList.Length--;
        CreateXRefs();
        DeleteDisplayItem(ItemNumber, TDisplayPoint);
        CreateXRefs();
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DeleteFloodFill(int ItemNumber)
{
    //start looking at the end of the array as the most common deletion will be from undo
    /*
    int pointer = FloodFillList.Length - 1;
    bool found = false;

    while (!found && pointer > -1) {
        if (FloodFillList[pointer].ItemNumber == ItemNumber) {
            found = true;
            pointer++;
            }
        pointer--;
        }

    if (found) {
        for (int i = pointer; i < FloodFillList.Length - 2; i++) {
            FloodFillList[i].ItemNumber = FloodFillList[i + 1].ItemNumber;
            FloodFillList[i].Colour = FloodFillList[i + 1].Colour;
            FloodFillList[i].FilledColour = FloodFillList[i + 1].FilledColour;
            FloodFillList[i].StartPoint = FloodFillList[i + 1].StartPoint;
            FloodFillList[i].Points.Length = FloodFillList[i + 1].Points.Length;
            for (int j = 0; j < FloodFillList[i].Points.Length; j++) {
                FloodFillList[i].Points[j] = FloodFillList[i+1].Points[j];
                }
            }
        FloodFillList[FloodFillList.Length - 1].Points.Length = 0;
        FloodFillList.Length--;
        }
    */
    int pointer = XRefs[ItemNumber].EntityXRef;
    bool found = false;

    if (XRefs[ItemNumber].DisplayType == TDisplayFloodFill && pointer > -1 && pointer < FloodFillList.Length && FloodFillList[pointer].ItemNumber == ItemNumber) found = true;

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Delete Flood Fill");
            AnsiString text;
            text = "Add,FloodFill," + AnsiString(ItemNumber) + ","
                                + AnsiString((int)(FloodFillList[pointer].Colour)) + ","
                                + AnsiString((int)(FloodFillList[pointer].FilledColour)) + ","
                                + AnsiString(FloodFillList[pointer].StartPoint.x) + ","
                                + AnsiString(FloodFillList[pointer].StartPoint.y) + ","
                                ;
            for (int j = 0; j < FloodFillList[pointer].Points.Length; j++) {
                text = text + AnsiString(FloodFillList[pointer].Points[j].x) + "," + AnsiString(FloodFillList[pointer].Points[j].y) + ",";
                }
            AddUndo(text);
            /*text = "Add,DisplayItem," + AnsiString(ItemNumber) + ","
                                      + AnsiString((int)(TDisplayFloodFill)) + ","
                                      + AnsiString(XRefs[ItemNumber].DisplayXRef) + ","
                                      ;
            AddUndo(text);*/
            }
        for (int i = pointer; i < FloodFillList.Length - 1; i++) {
            FloodFillList[i].ItemNumber = FloodFillList[i + 1].ItemNumber;
            FloodFillList[i].Colour = FloodFillList[i + 1].Colour;
            FloodFillList[i].FilledColour = FloodFillList[i + 1].FilledColour;
            FloodFillList[i].StartPoint = FloodFillList[i + 1].StartPoint;
            FloodFillList[i].Points.Length = FloodFillList[i + 1].Points.Length;
            for (int j = 0; j < FloodFillList[i].Points.Length; j++) {
                FloodFillList[i].Points[j] = FloodFillList[i+1].Points[j];
                }
            }
        FloodFillList[FloodFillList.Length - 1].Points.Length = 0;
        FloodFillList.Length--;
        CreateXRefs();
        DeleteDisplayItem(ItemNumber, TDisplayFloodFill);
        CreateXRefs();
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DeleteText(int ItemNumber)
{
    //start looking at the end of the array as the most common deletion will be from undo
    /*
    int pointer = TextList.Length - 1;
    bool found = false;

    while (!found && pointer > -1) {
        if (TextList[pointer].ItemNumber == ItemNumber) {
            found = true;
            pointer++;
            }
        pointer--;
        }

    if (found) {
        for (int i = pointer; i < TextList.Length - 2; i++) {
            TextList[i].ItemNumber = TextList[i + 1].ItemNumber;
            TextList[i].Text = TextList[i + 1].Text;
            TextList[i].Name = TextList[i + 1].Name;
            TextList[i].Height = TextList[i + 1].Height;
            TextList[i].Bold = TextList[i + 1].Bold;
            TextList[i].Italic = TextList[i + 1].Italic;
            TextList[i].Underlined = TextList[i + 1].Underlined;
            TextList[i].Strikeout = TextList[i + 1].Strikeout;
            TextList[i].Colour = TextList[i + 1].Colour;
            TextList[i].StartPoint = TextList[i + 1].StartPoint;
            TextList[i].Points.Length = TextList[i + 1].Points.Length;
            for (int j = 0; j < TextList[i].Points.Length; j++) {
                TextList[i].Points[j] = TextList[i+1].Points[j];
                }
            }
        TextList[TextList.Length - 1].Points.Length = 0;
        TextList.Length--;
        }
    */
    int pointer = XRefs[ItemNumber].EntityXRef;
    bool found = false;

    if (XRefs[ItemNumber].DisplayType == TDisplayText && pointer > -1 && pointer < TextList.Length && TextList[pointer].ItemNumber == ItemNumber) found = true;

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Delete Text");
            AnsiString text;
            text = "Add,Text," + AnsiString(ItemNumber) + ","
                                + TextList[pointer].Name + ","
                                + AnsiString(TextList[pointer].Height) + ","
                                + AnsiString((int)(TextList[pointer].Bold)) + ","
                                + AnsiString((int)(TextList[pointer].Italic)) + ","
                                + AnsiString((int)(TextList[pointer].Underlined)) + ","
                                + AnsiString((int)(TextList[pointer].Strikeout)) + ","
                                + AnsiString((int)(TextList[pointer].Colour)) + ","
                                + AnsiString(TextList[pointer].StartPoint.x) + ","
                                + AnsiString(TextList[pointer].StartPoint.y) + ","
                                + AnsiString(TextList[pointer].Angle) + ","
                                + AnsiString(TextList[pointer].Points.Length) + ","
                                ;
            for (int j = 0; j < TextList[pointer].Points.Length; j++) {
                text = text + AnsiString(TextList[pointer].Points[j].x) + "," + AnsiString(TextList[pointer].Points[j].y) + ","+ AnsiString((int)(TextList[pointer].Points[j].Colour)) + ",";
                }
            text = text + TextList[pointer].Text;
            AddUndo(text);
            /*text = "Add,DisplayItem," + AnsiString(ItemNumber) + ","
                                      + AnsiString((int)(TDisplayText)) + ","
                                      + AnsiString(XRefs[ItemNumber].DisplayXRef) + ","
                                      ;
            AddUndo(text);*/
            }
        for (int i = pointer; i < TextList.Length - 1; i++) {
            TextList[i].ItemNumber = TextList[i + 1].ItemNumber;
            TextList[i].Text = TextList[i + 1].Text;
            TextList[i].Name = TextList[i + 1].Name;
            TextList[i].Height = TextList[i + 1].Height;
            TextList[i].Bold = TextList[i + 1].Bold;
            TextList[i].Italic = TextList[i + 1].Italic;
            TextList[i].Underlined = TextList[i + 1].Underlined;
            TextList[i].Strikeout = TextList[i + 1].Strikeout;
            TextList[i].Colour = TextList[i + 1].Colour;
            TextList[i].StartPoint = TextList[i + 1].StartPoint;
            TextList[i].Points.Length = TextList[i + 1].Points.Length;
            for (int j = 0; j < TextList[i].Points.Length; j++) {
                TextList[i].Points[j] = TextList[i+1].Points[j];
                }
            }
        TextList[TextList.Length - 1].Points.Length = 0;
        TextList.Length--;
        CreateXRefs();
        DeleteDisplayItem(ItemNumber, TDisplayText);
        CreateXRefs();
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DeleteLine(int ItemNumber)
{
    //start looking at the end of the array as the most common deletion will be from undo
    /*
    int pointer = LineList.Length - 1;
    bool found = false;

    while (!found && pointer > -1) {
        if (LineList[pointer].ItemNumber == ItemNumber) {
            found = true;
            pointer++;
            }
        pointer--;
        }

    if (found) {
        for (int i = pointer; i < LineList.Length - 2; i++) {
            LineList[i].ItemNumber = LineList[i + 1].ItemNumber;
            LineList[i].Colour = LineList[i + 1].Colour;
            LineList[i].LineWidth = LineList[i + 1].LineWidth;
            LineList[i].StartPoint = LineList[i + 1].StartPoint;
            LineList[i].EndPoint = LineList[i + 1].EndPoint;
            LineList[i].Points.Length = LineList[i + 1].Points.Length;
            for (int j = 0; j < LineList[i].Points.Length; j++) {
                LineList[i].Points[j] = LineList[i+1].Points[j];
                }
            }
        LineList[LineList.Length - 1].Points.Length = 0;
        LineList.Length--;
        }
    */
    int pointer = XRefs[ItemNumber].EntityXRef;
    bool found = false;

    if (XRefs[ItemNumber].DisplayType == TDisplayLine && pointer > -1 && pointer < LineList.Length && LineList[pointer].ItemNumber == ItemNumber) found = true;

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Delete Line");
            AnsiString text;
            text = "Add,Line," + AnsiString(ItemNumber) + ","
                                + AnsiString((int)(LineList[pointer].Colour)) + ","
                                + AnsiString(LineList[pointer].LineWidth) + ","
                                + AnsiString(LineList[pointer].StartPoint.x) + ","
                                + AnsiString(LineList[pointer].StartPoint.y) + ","
                                + AnsiString(LineList[pointer].EndPoint.x) + ","
                                + AnsiString(LineList[pointer].EndPoint.y) + ","
                                ;
            for (int j = 0; j < LineList[pointer].Points.Length; j++) {
                text = text + AnsiString(LineList[pointer].Points[j].x) + "," + AnsiString(LineList[pointer].Points[j].y) + "," + AnsiString((int)(LineList[pointer].Points[j].Colour)) + ",";
                }
            AddUndo(text);
            /*text = "Add,DisplayItem," + AnsiString(ItemNumber) + ","
                                      + AnsiString((int)(TDisplayLine)) + ","
                                      + AnsiString(XRefs[ItemNumber].DisplayXRef) + ","
                                      ;
            AddUndo(text);*/
            }
        for (int i = pointer; i < LineList.Length - 1; i++) {
            LineList[i].ItemNumber = LineList[i + 1].ItemNumber;
            LineList[i].Colour = LineList[i + 1].Colour;
            LineList[i].LineWidth = LineList[i + 1].LineWidth;
            LineList[i].StartPoint = LineList[i + 1].StartPoint;
            LineList[i].EndPoint = LineList[i + 1].EndPoint;
            LineList[i].Points.Length = LineList[i + 1].Points.Length;
            for (int j = 0; j < LineList[i].Points.Length; j++) {
                LineList[i].Points[j] = LineList[i+1].Points[j];
                }
            }
        LineList[LineList.Length - 1].Points.Length = 0;
        LineList.Length--;
        CreateXRefs();
        DeleteDisplayItem(ItemNumber, TDisplayLine);
        CreateXRefs();
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DeletePolyLine(int ItemNumber)
{
    //start looking at the end of the array as the most common deletion will be from undo
    int pointer = XRefs[ItemNumber].EntityXRef;
    bool found = false;

    if (XRefs[ItemNumber].DisplayType == TDisplayPolyLine && pointer > -1 && pointer < PolyLineList.Length && PolyLineList[pointer].ItemNumber == ItemNumber) found = true;

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Delete Polyline");
            AnsiString text;
            text = "Add,PolyLine," + AnsiString(ItemNumber) + ","
                                + AnsiString((int)(PolyLineList[pointer].PenColour)) + ","
                                + AnsiString((int)(PolyLineList[pointer].BrushColour)) + ","
                                + AnsiString(PolyLineList[pointer].LineWidth) + ","
                                + AnsiString((int)(PolyLineList[pointer].closed)) + ","
                                + AnsiString((int)(PolyLineList[pointer].filled)) + ","
                                + AnsiString(PolyLineList[pointer].Points.Length) + ","
                                ;
            for (int j = 0; j < PolyLineList[pointer].Points.Length; j++) {
                text = text + AnsiString(PolyLineList[pointer].Points[j].x) + "," + AnsiString(PolyLineList[pointer].Points[j].y) + "," + AnsiString((int)(PolyLineList[pointer].Points[j].Colour)) + ",";
                }
            text = text + AnsiString(PolyLineList[pointer].Corners.Length) + ",";
            for (int j = 0; j < PolyLineList[pointer].Corners.Length; j++) {
                text = text + AnsiString(PolyLineList[pointer].Corners[j].x) + "," + AnsiString(PolyLineList[pointer].Corners[j].y) + ",";
                }
            AddUndo(text);
            }
        for (int i = pointer; i < PolyLineList.Length - 1; i++) {
            PolyLineList[i].ItemNumber = PolyLineList[i + 1].ItemNumber;
            PolyLineList[i].PenColour = PolyLineList[i + 1].PenColour;
            PolyLineList[i].BrushColour = PolyLineList[i + 1].BrushColour;
            PolyLineList[i].LineWidth = PolyLineList[i + 1].LineWidth;
            PolyLineList[i].closed = PolyLineList[i + 1].closed;
            PolyLineList[i].filled = PolyLineList[i + 1].filled;
            PolyLineList[i].Points.Length = PolyLineList[i + 1].Points.Length;
            for (int j = 0; j < PolyLineList[i].Points.Length; j++) {
                PolyLineList[i].Points[j] = PolyLineList[i+1].Points[j];
                }
            PolyLineList[i].Corners.Length = PolyLineList[i + 1].Corners.Length;
            for (int j = 0; j < PolyLineList[i].Corners.Length; j++) {
                PolyLineList[i].Corners[j] = PolyLineList[i+1].Corners[j];
                }
            }
        PolyLineList[PolyLineList.Length - 1].Points.Length = 0;
        PolyLineList[PolyLineList.Length - 1].Corners.Length = 0;
        PolyLineList.Length--;
        CreateXRefs();
        DeleteDisplayItem(ItemNumber, TDisplayPolyLine);
        CreateXRefs();
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DeleteErase(int ItemNumber)
{
    //start looking at the end of the array as the most common deletion will be from undo
    /*
    int pointer = EraseList.Length - 1;
    bool found = false;

    while (!found && pointer > -1) {
        if (EraseList[pointer].ItemNumber == ItemNumber) {
            found = true;
            pointer++;
            }
        pointer--;
        }

    if (found) {
        for (int i = pointer; i < EraseList.Length - 2; i++) {
            EraseList[i].ItemNumber = EraseList[i + 1].ItemNumber;
            EraseList[i].Points.Length = EraseList[i + 1].Points.Length;
            for (int j = 0; j < EraseList[i].Points.Length; j++) {
                EraseList[i].Points[j] = EraseList[i+1].Points[j];
                }
            }
        EraseList[EraseList.Length - 1].Points.Length = 0;
        EraseList.Length--;
        }
    */
    int pointer = XRefs[ItemNumber].EntityXRef;
    bool found = false;

    if (XRefs[ItemNumber].DisplayType == TDisplayEraseItem && pointer > -1 && pointer < EraseList.Length && EraseList[pointer].ItemNumber == ItemNumber) found = true;

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Delete Erase Object");
            AnsiString text;
            text = "Add,EraseObject," + AnsiString(ItemNumber) + ","
                                ;
            for (int j = 0; j < EraseList[pointer].Points.Length; j++) {
                text = text + AnsiString(EraseList[pointer].Points[j].x) + "," + AnsiString(EraseList[pointer].Points[j].y) + "," + AnsiString((int)(EraseList[pointer].Points[j].Colour)) + ",";
                }
            AddUndo(text);
            /*text = "Add,DisplayItem," + AnsiString(ItemNumber) + ","
                                      + AnsiString((int)(TDisplayEraseItem)) + ","
                                      + AnsiString(XRefs[ItemNumber].DisplayXRef) + ","
                                      ;
            AddUndo(text);*/
            }
        for (int i = pointer; i < EraseList.Length - 1; i++) {
            EraseList[i].ItemNumber = EraseList[i + 1].ItemNumber;
            EraseList[i].Points.Length = EraseList[i + 1].Points.Length;
            for (int j = 0; j < EraseList[i].Points.Length; j++) {
                EraseList[i].Points[j] = EraseList[i+1].Points[j];
                }
            }
        EraseList[EraseList.Length - 1].Points.Length = 0;
        EraseList.Length--;
        CreateXRefs();
        DeleteDisplayItem(ItemNumber, TDisplayEraseItem);
        CreateXRefs();
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DeleteRectangle(int ItemNumber)
{
    //start looking at the end of the array as the most common deletion will be from undo
    /*
    int pointer = RectangleList.Length - 1;
    bool found = false;

    while (!found && pointer > -1) {
        if (RectangleList[pointer].ItemNumber == ItemNumber) {
            found = true;
            pointer++;
            }
        pointer--;
        }

    if (found) {
        for (int i = pointer; i < RectangleList.Length - 2; i++) {
            RectangleList[i].ItemNumber = RectangleList[i + 1].ItemNumber;
            RectangleList[i].PenColour = RectangleList[i + 1].PenColour;
            RectangleList[i].BrushColour = RectangleList[i + 1].BrushColour;
            RectangleList[i].LineWidth = RectangleList[i + 1].LineWidth;
            RectangleList[i].Area = RectangleList[i + 1].Area;
            RectangleList[i].Shape = RectangleList[i + 1].Shape;
            RectangleList[i].Points.Length = RectangleList[i + 1].Points.Length;
            for (int j = 0; j < RectangleList[i].Points.Length; j++) {
                RectangleList[i].Points[j] = RectangleList[i+1].Points[j];
                }
            }
        RectangleList[RectangleList.Length - 1].Points.Length = 0;
        RectangleList.Length--;
        }
    */
    int pointer = XRefs[ItemNumber].EntityXRef;
    bool found = false;

    if (XRefs[ItemNumber].DisplayType == TDisplayRectangle && pointer > -1 && pointer < RectangleList.Length && RectangleList[pointer].ItemNumber == ItemNumber) found = true;

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Delete Rectangle");
            AnsiString text;
            text = "Add,Rectangle," + AnsiString(ItemNumber) + ","
                                + AnsiString((int)(RectangleList[pointer].PenColour)) + ","
                                + AnsiString((int)(RectangleList[pointer].BrushColour)) + ","
                                + AnsiString(RectangleList[pointer].LineWidth) + ","
                                + AnsiString(RectangleList[pointer].Area.Left) + ","
                                + AnsiString(RectangleList[pointer].Area.Top) + ","
                                + AnsiString(RectangleList[pointer].Area.Right) + ","
                                + AnsiString(RectangleList[pointer].Area.Bottom) + ","
                                + AnsiString((int)(RectangleList[pointer].Shape)) + ","
                                + AnsiString(RectangleList[pointer].Angle) + ","
                                + AnsiString((int)(RectangleList[pointer].Filled)) + ","
                                ;
            for (int j = 0; j < RectangleList[pointer].Points.Length; j++) {
                text = text + AnsiString(RectangleList[pointer].Points[j].x) + "," + AnsiString(RectangleList[pointer].Points[j].y) + "," + AnsiString((int)(RectangleList[pointer].Points[j].Colour)) + ",";
                }
            AddUndo(text);
            /*text = "Add,DisplayItem," + AnsiString(ItemNumber) + ","
                                      + AnsiString((int)(TDisplayRectangle)) + ","
                                      + AnsiString(XRefs[ItemNumber].DisplayXRef) + ","
                                      ;
            AddUndo(text);*/
            }
        for (int i = pointer; i < RectangleList.Length - 1; i++) {
            RectangleList[i].ItemNumber = RectangleList[i + 1].ItemNumber;
            RectangleList[i].PenColour = RectangleList[i + 1].PenColour;
            RectangleList[i].BrushColour = RectangleList[i + 1].BrushColour;
            RectangleList[i].LineWidth = RectangleList[i + 1].LineWidth;
            RectangleList[i].Area = RectangleList[i + 1].Area;
            RectangleList[i].Shape = RectangleList[i + 1].Shape;
            RectangleList[i].Angle = RectangleList[i + 1].Angle;
            RectangleList[i].Points.Length = RectangleList[i + 1].Points.Length;
            for (int j = 0; j < RectangleList[i].Points.Length; j++) {
                RectangleList[i].Points[j] = RectangleList[i+1].Points[j];
                }
            }
        RectangleList[RectangleList.Length - 1].Points.Length = 0;
        RectangleList.Length--;
        CreateXRefs();
        DeleteDisplayItem(ItemNumber, TDisplayRectangle);
        CreateXRefs();
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DeleteCircle(int ItemNumber)
{
    //start looking at the end of the array as the most common deletion will be from undo
    /*
    int pointer = CircleList.Length - 1;
    bool found = false;

    while (!found && pointer > -1) {
        if (CircleList[pointer].ItemNumber == ItemNumber) {
            found = true;
            pointer++;
            }
        pointer--;
        }

    if (found) {
        for (int i = pointer; i < CircleList.Length - 2; i++) {
            CircleList[i].ItemNumber = CircleList[i + 1].ItemNumber;
            CircleList[i].PenColour = CircleList[i + 1].PenColour;
            CircleList[i].BrushColour = CircleList[i + 1].BrushColour;
            CircleList[i].LineWidth = CircleList[i + 1].LineWidth;
            CircleList[i].Area = CircleList[i + 1].Area;
            CircleList[i].Shape = CircleList[i + 1].Shape;
            CircleList[i].Points.Length = CircleList[i + 1].Points.Length;
            for (int j = 0; j < CircleList[i].Points.Length; j++) {
                CircleList[i].Points[j] = CircleList[i+1].Points[j];
                }
            }
        CircleList[CircleList.Length - 1].Points.Length = 0;
        CircleList.Length--;
        }
    */
    int pointer = XRefs[ItemNumber].EntityXRef;
    bool found = false;

    if (XRefs[ItemNumber].DisplayType == TDisplayCircle && pointer > -1 && pointer < CircleList.Length && CircleList[pointer].ItemNumber == ItemNumber) found = true;

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Delete Ellipse/Circle");
            AnsiString text;
            text = "Add,Circle," + AnsiString(ItemNumber) + ","
                                + AnsiString((int)(CircleList[pointer].PenColour)) + ","
                                + AnsiString((int)(CircleList[pointer].BrushColour)) + ","
                                + AnsiString(CircleList[pointer].LineWidth) + ","
                                + AnsiString(CircleList[pointer].Area.Left) + ","
                                + AnsiString(CircleList[pointer].Area.Top) + ","
                                + AnsiString(CircleList[pointer].Area.Right) + ","
                                + AnsiString(CircleList[pointer].Area.Bottom) + ","
                                + AnsiString((int)(CircleList[pointer].Shape)) + ","
                                + AnsiString(CircleList[pointer].Angle) + ","
                                + AnsiString((int)(CircleList[pointer].Filled)) + ","
                                ;
            for (int j = 0; j < CircleList[pointer].Points.Length; j++) {
                text = text + AnsiString(CircleList[pointer].Points[j].x) + "," + AnsiString(CircleList[pointer].Points[j].y) + "," + AnsiString((int)(CircleList[pointer].Points[j].Colour)) + ",";
                }
            AddUndo(text);
            /*text = "Add,DisplayItem," + AnsiString(ItemNumber) + ","
                                      + AnsiString((int)(TDisplayCircle)) + ","
                                      + AnsiString(XRefs[ItemNumber].DisplayXRef) + ","
                                      ;
            AddUndo(text);*/
            }
        for (int i = pointer; i < CircleList.Length - 1; i++) {
            CircleList[i].ItemNumber = CircleList[i + 1].ItemNumber;
            CircleList[i].PenColour = CircleList[i + 1].PenColour;
            CircleList[i].BrushColour = CircleList[i + 1].BrushColour;
            CircleList[i].LineWidth = CircleList[i + 1].LineWidth;
            CircleList[i].Area = CircleList[i + 1].Area;
            CircleList[i].Shape = CircleList[i + 1].Shape;
            CircleList[i].Angle = CircleList[i + 1].Angle;
            CircleList[i].Points.Length = CircleList[i + 1].Points.Length;
            for (int j = 0; j < CircleList[i].Points.Length; j++) {
                CircleList[i].Points[j] = CircleList[i+1].Points[j];
                }
            }
        CircleList[CircleList.Length - 1].Points.Length = 0;
        CircleList.Length--;
        CreateXRefs();
        DeleteDisplayItem(ItemNumber, TDisplayCircle);
        CreateXRefs();
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DeleteFreeForm(int ItemNumber)
{
    //start looking at the end of the array as the most common deletion will be from undo
    int pointer = XRefs[ItemNumber].EntityXRef;
    bool found = false;

    if (XRefs[ItemNumber].DisplayType == TDisplayFreeForm && pointer > -1 && pointer < FreeFormList.Length && FreeFormList[pointer].ItemNumber == ItemNumber) found = true;

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Delete Free Form Shape");
            AnsiString text;
            text = "Add,FreeForm," + AnsiString(ItemNumber) + ","
                                + AnsiString((int)(FreeFormList[pointer].PenColour)) + ","
                                + AnsiString((int)(FreeFormList[pointer].BrushColour)) + ","
                                + AnsiString(FreeFormList[pointer].LineWidth) + ","
                                + AnsiString((int)(FreeFormList[pointer].closed)) + ","
                                + AnsiString((int)(FreeFormList[pointer].filled)) + ","
                                + AnsiString(FreeFormList[pointer].Points.Length) + ","
                                ;
            for (int j = 0; j < FreeFormList[pointer].Points.Length; j++) {
                text = text + AnsiString(FreeFormList[pointer].Points[j].x) + "," + AnsiString(FreeFormList[pointer].Points[j].y) + "," + AnsiString((int)(FreeFormList[pointer].Points[j].Colour)) + ",";
                }
            text = text + AnsiString(FreeFormList[pointer].Corners.Length) + ",";
            for (int j = 0; j < FreeFormList[pointer].Corners.Length; j++) {
                text = text + AnsiString(FreeFormList[pointer].Corners[j].x) + "," + AnsiString(FreeFormList[pointer].Corners[j].y) + ",";
                }
            AddUndo(text);
            }
        for (int i = pointer; i < FreeFormList.Length - 1; i++) {
            FreeFormList[i].ItemNumber = FreeFormList[i + 1].ItemNumber;
            FreeFormList[i].PenColour = FreeFormList[i + 1].PenColour;
            FreeFormList[i].BrushColour = FreeFormList[i + 1].BrushColour;
            FreeFormList[i].LineWidth = FreeFormList[i + 1].LineWidth;
            FreeFormList[i].closed = FreeFormList[i + 1].closed;
            FreeFormList[i].filled = FreeFormList[i + 1].filled;
            FreeFormList[i].Points.Length = FreeFormList[i + 1].Points.Length;
            for (int j = 0; j < FreeFormList[i].Points.Length; j++) {
                FreeFormList[i].Points[j] = FreeFormList[i+1].Points[j];
                }
            FreeFormList[i].Corners.Length = FreeFormList[i + 1].Corners.Length;
            for (int j = 0; j < FreeFormList[i].Corners.Length; j++) {
                FreeFormList[i].Corners[j] = FreeFormList[i+1].Corners[j];
                }
            }
        FreeFormList[FreeFormList.Length - 1].Points.Length = 0;
        FreeFormList[FreeFormList.Length - 1].Corners.Length = 0;
        FreeFormList.Length--;
        CreateXRefs();
        DeleteDisplayItem(ItemNumber, TDisplayFreeForm);
        CreateXRefs();
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DeleteBlock(int ItemNumber)
{
    //start looking at the end of the array as the most common deletion will be from undo
    /*
    int pointer = BlockList.Length - 1;
    bool found = false;

    while (!found && pointer > -1) {
        if (BlockList[pointer].ItemNumber == ItemNumber) {
            found = true;
            pointer++;
            }
        pointer--;
        }

    if (found) {
        for (int i = pointer; i < BlockList.Length - 2; i++) {
            BlockList[i].ItemNumber = BlockList[i + 1].ItemNumber;
            BlockList[i].Area = BlockList[i + 1].Area;
            BlockList[i].Linked = BlockList[i + 1].Linked;
            BlockList[i].LinkedBlock = BlockList[i + 1].LinkedBlock;
            BlockList[i].Points.Length = BlockList[i + 1].Points.Length;
            for (int j = 0; j < BlockList[i].Points.Length; j++) {
                BlockList[i].Points[j] = BlockList[i+1].Points[j];
                }
            }
        BlockList[BlockList.Length - 1].Points.Length = 0;
        BlockList.Length--;
        }
    */
    int pointer = XRefs[ItemNumber].EntityXRef;
    bool found = false;

    if (XRefs[ItemNumber].DisplayType == TDisplayBlock && pointer > -1 && pointer < BlockList.Length && BlockList[pointer].ItemNumber == ItemNumber) found = true;

    if (found) {
        //now to re-assign all links if this one was a master block.
        //This is done before the deletion so the undone block will retain a linkage
        //even though it's no longer the master
        bool ismaster = false;
        int numberofslaves = 0;
        int newmaster;
        for (int i = 0; i < BlockList.Length; i++) {
            if (BlockList[i].Linked && BlockList[i].LinkedBlock == ItemNumber) {
                if (!ismaster) newmaster = BlockList[i].ItemNumber;
                ismaster = true;
                numberofslaves++;
                }
            }
        if (ismaster) {
            BlockList[pointer].Linked = true;
            BlockList[pointer].LinkedBlock = newmaster;
            if (numberofslaves == 1) {
                for (int i = 0; i < BlockList.Length; i++) {
                    if (BlockList[i].Linked && BlockList[i].LinkedBlock == ItemNumber) {
                        BlockList[i].Linked = false;
                        BlockList[i].LinkedBlock = -1;
                        }
                    }
                } else {
                for (int i = 0; i < BlockList.Length; i++) {
                    if (BlockList[i].Linked && BlockList[i].LinkedBlock == ItemNumber) {
                        if (BlockList[i].ItemNumber == newmaster) {
                            BlockList[i].Linked = false;
                            BlockList[i].LinkedBlock = -1;
                            } else {
                            BlockList[i].LinkedBlock = newmaster;
                            }
                        }
                    }
                }
            }
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Delete Block");
            AnsiString text;
            text = "Add,Block," + AnsiString(ItemNumber) + ","
                                + AnsiString(BlockList[pointer].Area.Left) + ","
                                + AnsiString(BlockList[pointer].Area.Top) + ","
                                + AnsiString(BlockList[pointer].Area.Right) + ","
                                + AnsiString(BlockList[pointer].Area.Bottom) + ","
                                + AnsiString((int)(BlockList[pointer].Linked)) + ","
                                + AnsiString(BlockList[pointer].LinkedBlock) + ","
                                + AnsiString(BlockList[pointer].RotationCentre.x) + ","
                                + AnsiString(BlockList[pointer].RotationCentre.y) + ","
                                + AnsiString(BlockList[pointer].Angle) + ","
                                + AnsiString(BlockList[pointer].MirrorCentre.x) + ","
                                + AnsiString(BlockList[pointer].MirrorCentre.y) + ","
                                + AnsiString((int)(BlockList[pointer].Axis)) + ","
                                + AnsiString(BlockList[pointer].delta.x) + ","
                                + AnsiString(BlockList[pointer].delta.y) + ","
                                ;
            for (int j = 0; j < BlockList[pointer].Points.Length; j++) {
                text = text + AnsiString(BlockList[pointer].Points[j].x) + ","
                            + AnsiString(BlockList[pointer].Points[j].y) + ","
                            + AnsiString(BlockList[pointer].Points[j].originalx) + ","
                            + AnsiString(BlockList[pointer].Points[j].originaly) + ","
                            + AnsiString((int)(BlockList[pointer].Points[j].Colour)) + ","
                            + AnsiString((int)(BlockList[pointer].Points[j].transparent)) + ","
                            ;
                }
            AddUndo(text);
            /*text = "Add,DisplayItem," + AnsiString(ItemNumber) + ","
                                      + AnsiString((int)(TDisplayBlock)) + ","
                                      + AnsiString(XRefs[ItemNumber].DisplayXRef) + ","
                                      ;
            AddUndo(text);*/
            }
        for (int i = pointer; i < BlockList.Length - 1; i++) {
            BlockList[i].ItemNumber = BlockList[i + 1].ItemNumber;
            BlockList[i].Area = BlockList[i + 1].Area;
            BlockList[i].Linked = BlockList[i + 1].Linked;
            BlockList[i].LinkedBlock = BlockList[i + 1].LinkedBlock;
            BlockList[i].Points.Length = BlockList[i + 1].Points.Length;
            for (int j = 0; j < BlockList[i].Points.Length; j++) {
                BlockList[i].Points[j] = BlockList[i+1].Points[j];
                }
            }
        BlockList[BlockList.Length - 1].Points.Length = 0;
        BlockList.Length--;
        CreateXRefs();
        DeleteDisplayItem(ItemNumber, TDisplayBlock);
        CreateXRefs();
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::FontButtonClick(TObject *Sender)
{
    FontDialog1->Font->Name = DefaultText.Name;
    FontDialog1->Font->Height = DefaultText.Height;
    if (DefaultText.Bold) {
        FontDialog1->Font->Style << fsBold;
        } else {
        FontDialog1->Font->Style >> fsBold;
        }
    if (DefaultText.Italic) {
        FontDialog1->Font->Style << fsItalic;
        } else {
        FontDialog1->Font->Style >> fsItalic;
        }
    if (DefaultText.Underlined) {
        FontDialog1->Font->Style << fsUnderline;
        } else {
        FontDialog1->Font->Style >> fsUnderline;
        }
    if (DefaultText.Strikeout) {
        FontDialog1->Font->Style << fsStrikeOut;
        } else {
        FontDialog1->Font->Style >> fsStrikeOut;
        }
    if (FontDialog1->Execute()) {
        DefaultText.Name = FontDialog1->Font->Name;
        //DefaultText.Height = FontDialog1->Font->Height;
        DefaultText.Bold = FontDialog1->Font->Style.Contains(fsBold);
        DefaultText.Italic = FontDialog1->Font->Style.Contains(fsItalic);
        DefaultText.Underlined = FontDialog1->Font->Style.Contains(fsUnderline);
        DefaultText.Strikeout = FontDialog1->Font->Style.Contains(fsStrikeOut);
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::FontHeightComboBoxChange(TObject *Sender)
{
    DefaultText.Height = -1* (FontHeightComboBox->Items->Strings[FontHeightComboBox->ItemIndex]).ToIntDef(12);
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::LineWidth1ButtonClick(TObject *Sender)
{
    AddUndoTitle("Change Line Width");
    AddUndo("LineWidth," + AnsiString(LineWidth) + ",");
    LineWidth = dynamic_cast <TComponent*>(Sender)->Tag;
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::TerminateCurrentAction(void)
{
    //terminates the current action without completing it
    switch (ActionType) {
            case TEditFreeForm: {
                                ActionType = TNoAction;
                                Image1->Cursor = crTargetCursor;
                                //find FreeForm being edited
                                bool found = false;
                                int pointer = 0;
                                int arraypointer;
                                while (!found && pointer < DisplayList.Length) {
                                    if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayFreeForm) {
                                        found = true;
                                        pointer--;
                                        }
                                    pointer++;
                                    }
                                if (found) {
                                    found = false;
                                    arraypointer = XRefs[DisplayList[pointer].ItemNumber].EntityXRef;
                                    if ( arraypointer > -1
                                        && arraypointer < FreeFormList.Length
                                        && FreeFormList[arraypointer].ItemNumber == DisplayList[pointer].ItemNumber
                                        ) found = true;
                                    }
                                if (found) {
                                    dragging = false;
                                    if (deselectafteroperation) {
                                        AddUndo("Select," + AnsiString(DisplayList[pointer].ItemNumber) + ",");
                                        DisplayList[pointer].selected = false;
                                        }
                                    }
                                pointbeingdragged = -1;
                                DrawPicture();
                                }
                                break;
            case TDrawFreeForm: {
                                ActionType = TNoAction;
                                if (!wipedout) {
                                    //want a line to the mouse point
                                    TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                    Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                    Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                    if (LinePoints.Length >= 2) {
                                        Image1->Picture->Bitmap->Canvas->MoveTo(LinePoints[0].x,LinePoints[0].y);
                                        Image1->Picture->Bitmap->Canvas->LineTo(LinePoints[1].x,LinePoints[1].y);
                                        }
                                    if (LinePoints.Length >= 3) {
                                        Image1->Picture->Bitmap->Canvas->LineTo(LinePoints[2].x,LinePoints[2].y);
                                        }
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                    wipedout = true;
                                    }
                                LinePoints.Length = 0;
                                dragging = false;
                                Image1->Cursor = crTargetCursor;
                                FreeFormButton->Down = false;
                                DrawPicture();
                                }
                                break;
            case TPasteBlock:   {
                                ActionType = TNoAction;
                                int displaypointer = DisplayList.Length - 1;
                                if (DisplayList[displaypointer].selected && !DisplayList[displaypointer].visible && DisplayList[displaypointer].DisplayType == TDisplayBlock) {
                                    //have the right block
                                    TRect Rectangle;
                                    Rectangle = FindImage1Position(DisplayList[displaypointer].Area);
                                    TPoint delta;
                                    delta.x = Rectangle.Right - Rectangle.Left;
                                    delta.y = Rectangle.Bottom - Rectangle.Top;
                                    TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                    Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                    Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                    if (!wipedout) {
                                        Rectangle.Left = OldMousePositionScreen.x;
                                        Rectangle.Top = OldMousePositionScreen.y;
                                        Rectangle.Right = Rectangle.Left + delta.x;
                                        Rectangle.Bottom = Rectangle.Top + delta.y;
                                        Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                        wipedout = true;
                                        }
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                    //now to delete the unwanted block
                                    Undo1Click(this);
                                    }
                                }
                                break;
            case TEditPolyLine: {
                                ActionType = TNoAction;
                                Image1->Cursor = crTargetCursor;
                                //find polyline being edited
                                bool found = false;
                                int pointer = 0;
                                int arraypointer;
                                while (!found && pointer < DisplayList.Length) {
                                    if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayPolyLine) {
                                        found = true;
                                        pointer--;
                                        }
                                    pointer++;
                                    }
                                if (found) {
                                    found = false;
                                    arraypointer = XRefs[DisplayList[pointer].ItemNumber].EntityXRef;
                                    if ( arraypointer > -1
                                        && arraypointer < PolyLineList.Length
                                        && PolyLineList[arraypointer].ItemNumber == DisplayList[pointer].ItemNumber
                                        ) found = true;
                                    }
                                if (found) {
                                    dragging = false;
                                    if (deselectafteroperation) {
                                        AddUndo("Select," + AnsiString(DisplayList[pointer].ItemNumber) + ",");
                                        DisplayList[pointer].selected = false;
                                        }
                                    }
                                pointbeingdragged = -1;
                                DrawPicture();
                                }
                                break;
            case TDrawPolyLine: {
                                ActionType = TNoAction;
                                if (!wipedout) {
                                    //want to erase the line to the old mouse point
                                    TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                    Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                    Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                    Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                    Image1->Picture->Bitmap->Canvas->LineTo(OldMousePositionScreen.x,OldMousePositionScreen.y);
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                    wipedout = true;
                                    }
                                dragging = false;
                                Image1->Cursor = crTargetCursor;
                                PolyLineButton->Down = false;
                                }
                                break;
            case TMirrorItem:   {
                                dragging = false;
                                if (!wipedout) {
                                    //want a vertical or horizontal line to the mouse point and a mirrored rectangle for each selected object
                                    int v1,v2;
                                    TMirrorAxis Axis;
                                    TPoint delta;
                                    TPenMode oldmode;
                                    TRect Rectangle;
                                    int swap;
                                    v1 = abs(OldMousePositionScreen.x - StartPointScreen.x);
                                    v2 = abs(OldMousePositionScreen.y - StartPointScreen.y);
                                    Axis = TMAHorizontal;
                                    if (v2 > v1) Axis = TMAVertical;
                                    delta.x = 0;
                                    delta.y = 0;
                                    if (Axis == TMAHorizontal) {
                                        delta.x = OldMousePositionScreen.x - StartPointScreen.x;
                                        } else {
                                        delta.y = OldMousePositionScreen.y - StartPointScreen.y;
                                        }
                                    oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                    Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                    Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                    Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                    Image1->Picture->Bitmap->Canvas->LineTo(StartPointScreen.x + delta.x,StartPointScreen.y + delta.y);
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;


                                    for (int i = 0; i < DisplayList.Length; i++) {
                                        if (DisplayList[i].selected && DisplayList[i].visible) {
                                            Rectangle = FindImage1Position(DisplayList[i].Area);
                                            Rectangle = MirrorRectanglePoints(Rectangle,StartPointScreen,Axis);
                                            if (Rectangle.Left > Rectangle.Right) {
                                                swap = Rectangle.Right;
                                                Rectangle.Right = Rectangle.Left;
                                                Rectangle.Left = swap;
                                                }
                                            if (Rectangle.Top > Rectangle.Bottom) {
                                                swap = Rectangle.Bottom;
                                                Rectangle.Bottom = Rectangle.Top;
                                                Rectangle.Top = swap;
                                                }
                                            Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                            }
                                        }
                                    wipedout = true;
                                    }
                                ActionType = TNoAction;
                                }
                                break;
            case TBlockArray:   {
                                //displays the linear array of blocks being considered
                                //first find block item being copied.
                                bool found = false;
                                int pointer = 0;
                                while (!found && pointer < DisplayList.Length) {
                                    if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayBlock) {
                                        found = true;
                                        pointer--;
                                        }
                                    pointer++;
                                    }
                                dragging = false;
                                if (found) {
                                    TPoint delta;
                                    TRect Rectangle;
                                    int swap;
                                    if (!wipedout) {
                                        //want a line to the mouse point and a rectangle offset at each selected object
                                        TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                        Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                        Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                        Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                        Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                        Image1->Picture->Bitmap->Canvas->LineTo(OldMousePositionScreen.x,OldMousePositionScreen.y);
                                        Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                        if (LinearArray.x > 1) {
                                            delta.x = (OldMousePositionScreen.x - StartPointScreen.x)/(LinearArray.x - 1);
                                            } else {
                                            delta.x = 0;
                                            }
                                        if (LinearArray.y > 1) {
                                            delta.y = (OldMousePositionScreen.y - StartPointScreen.y)/(LinearArray.y - 1);
                                            } else {
                                            delta.y = 0;
                                            }
                                        for (int i = 0; i < LinearArray.x; i++) {
                                            for (int j = 0; j < LinearArray.y; j++) {
                                                Rectangle = FindImage1Position(DisplayList[pointer].Area);
                                                Rectangle.Left += delta.x * i;
                                                Rectangle.Top += delta.y * j;
                                                Rectangle.Right += delta.x * i;
                                                Rectangle.Bottom += delta.y * j;
                                                if (Rectangle.Left > Rectangle.Right) {
                                                    swap = Rectangle.Right;
                                                    Rectangle.Right = Rectangle.Left;
                                                    Rectangle.Left = swap;
                                                    }
                                                if (Rectangle.Top > Rectangle.Bottom) {
                                                    swap = Rectangle.Bottom;
                                                    Rectangle.Bottom = Rectangle.Top;
                                                    Rectangle.Top = swap;
                                                    }
                                                Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                                }
                                            }
                                        wipedout = true;
                                        }
                                    }
                                }
                                break;
        case TEditBlockPoints:  {
                            ActionType = TNoAction;
                            Undo1Click(this);
                            //Label1->Visible = true;
                            //Image2->Visible = true;
                            //if (blendthreads || !BlendColours1->Enabled) Image3->Visible = true;
                            //Label2->Visible = Image3->Visible;
                            //Foreground->Brush->Color = ForegroundColour;
                            Background->Brush->Bitmap = NULL;
                            //Background->Brush->Color = BackgroundColour;
                            DisplayCurrentColours();
                            Timer1->Enabled = true;
                            Image1->Cursor = crTargetCursor;
                            DrawPicture();
                            }
                            break;
        case TEditErasePoints:
        case TEditPointPoints: {
                            ActionType = TNoAction;
                            Undo1Click(this);
                            Label1->Visible = true;
                            Image2->Visible = true;
                            if (blendthreads || !BlendColours1->Enabled) Image3->Visible = true;
                            Label2->Visible = Image3->Visible;
                            //Foreground->Brush->Color = ForegroundColour;
                            Background->Brush->Bitmap = NULL;
                            //Background->Brush->Color = BackgroundColour;
                            DisplayCurrentColours();
                            Timer1->Enabled = true;
                            Image1->Cursor = crTargetCursor;
                            DrawPicture();
                            }
                            break;
        case TTextItem:     {
                            if (!wipedout) {
                                TRect Rectangle;
                                Rectangle.Left = StartPointScreen.x;
                                Rectangle.Top = StartPointScreen.y;
                                Rectangle.Right = OldMousePositionScreen.x;
                                Rectangle.Bottom = OldMousePositionScreen.y;
                                Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                wipedout = true;
                                }
                            }
                            break;
        case TMoveItem:
        case TCopyItem:     {
                            if (!wipedout) {
                                //want a line to the mouse point and a rectangle offset at each selected object
                                TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                Image1->Picture->Bitmap->Canvas->LineTo(OldMousePositionScreen.x,OldMousePositionScreen.y);
                                Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                TPoint delta;
                                TRect Rectangle;
                                int swap;
                                delta.x = OldMousePositionScreen.x - StartPointScreen.x;
                                delta.y = OldMousePositionScreen.y - StartPointScreen.y;
                                for (int i = 0; i < DisplayList.Length; i++) {
                                    if (DisplayList[i].selected) {
                                        Rectangle = FindImage1Position(DisplayList[i].Area);
                                        Rectangle.Left += delta.x;
                                        Rectangle.Top += delta.y;
                                        Rectangle.Right += delta.x;
                                        Rectangle.Bottom += delta.y;
                                        if (Rectangle.Left > Rectangle.Right) {
                                            swap = Rectangle.Right;
                                            Rectangle.Right = Rectangle.Left;
                                            Rectangle.Left = swap;
                                            }
                                        if (Rectangle.Top > Rectangle.Bottom) {
                                            swap = Rectangle.Bottom;
                                            Rectangle.Bottom = Rectangle.Top;
                                            Rectangle.Top = swap;
                                            }
                                        Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                        }
                                    }
                                wipedout = true;
                                }
                            dragging = false;
                            }
                            break;
        case TSelectItem:   {
                            //in addition to wiping out a rectangle as given below, need also to get rid of the popup menu on right click
                            Image1->PopupMenu = NULL;
                            }
        case TChangeRectangleSize:
        case TChangeCircleSize:
        case TBlockItem:
        case TDrawCircle:
        case TDrawRectangle:    {
                            if (!wipedout) {
                                TRect Rectangle;
                                //want a rectangle to the mouse point
                                Rectangle.Left = StartPointScreen.x;
                                Rectangle.Top = StartPointScreen.y;
                                Rectangle.Right = OldMousePositionScreen.x;
                                Rectangle.Bottom = OldMousePositionScreen.y;
                                int swap;
                                if (Rectangle.Left > Rectangle.Right) {
                                    swap = Rectangle.Right;
                                    Rectangle.Right = Rectangle.Left;
                                    Rectangle.Left = swap;
                                    }
                                if (Rectangle.Top > Rectangle.Bottom) {
                                    swap = Rectangle.Bottom;
                                    Rectangle.Bottom = Rectangle.Top;
                                    Rectangle.Top = swap;
                                    }
                                Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                if (ActionType == TDrawCircle || ActionType == TChangeCircleSize) {
                                    Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                    TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                    TBrushStyle oldstyle = Image1->Picture->Bitmap->Canvas->Brush->Style;
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                    Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                    Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                    Image1->Picture->Bitmap->Canvas->Brush->Style = bsClear;
                                    Image1->Picture->Bitmap->Canvas->Ellipse(Rectangle.Left,Rectangle.Top,Rectangle.Right,Rectangle.Bottom);
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                    Image1->Picture->Bitmap->Canvas->Brush->Style = oldstyle;
                                    }
                                wipedout = true;
                                }
                            dragging = false;
                            }
                            break;
        case TEditLineStart:
        case TEditLineEnd:
        case TDrawLine:     {
                            if (!wipedout) {
                                //want to erase the line to the old mouse point
                                TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                Image1->Picture->Bitmap->Canvas->MoveTo(StartPointScreen.x,StartPointScreen.y);
                                Image1->Picture->Bitmap->Canvas->LineTo(OldMousePositionScreen.x,OldMousePositionScreen.y);
                                Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                wipedout = true;
                                }
                            dragging = false;
                            Image1->Cursor = crTargetCursor;
                            }
                            break;
        case TEraseItem:
        case TPixelEdit:    {
                            dragging = false;
                            }
                            break;
        default:            break;
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::LineWidth1Click(TObject *Sender)
{
    OneStitch1->Checked = LineWidth1Button->Down;
    TwoStitches1->Checked = LineWidth2Button->Down;
    FourStitches1->Checked = LineWidth4Button->Down;
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DrawingTools1Click(TObject *Sender)
{
    Pencil1->Checked = PixelEditButton->Down;
    Line1->Checked = LineButton->Down;
    FloodFill1->Checked = FloodFillButton->Down;
    EyeDropper1->Checked = EyedropperButton->Down;
    Text1->Checked = TextButton->Down;
    Rectangle1->Checked = RectangleButton->Down;
    Ellipse1->Checked = CircleButton->Down;
    FillShape1->Checked = FillShapes;
    Select1->Checked = SelectButton->Down;
    Erase1->Checked = EraseButton->Down;
    Block1->Checked = BlockButton->Down;
    Undo2->Enabled = (bool)(DisplayList.Length);

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Pencil1Click(TObject *Sender)
{
    PixelEditButton->Down = !PixelEditButton->Down;
    PixelEditButtonClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Line1Click(TObject *Sender)
{
    LineButton->Down = !LineButton->Down;
    LineButtonClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::PolylineTool1Click(TObject *Sender)
{
    PolyLineButton->Down = !PolyLineButton->Down;
    PolyLineButtonClick(Sender);

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::FloodFill1Click(TObject *Sender)
{
    FloodFillButton->Down = !FloodFillButton->Down;
    FloodFillButtonClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::EyeDropper1Click(TObject *Sender)
{
    EyedropperButton->Down = !EyedropperButton->Down;
    EyedropperButtonClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Text1Click(TObject *Sender)
{
    TextButton->Down = !TextButton->Down;
    TextButtonClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Rectangle1Click(TObject *Sender)
{
    RectangleButton->Down = !RectangleButton->Down;
    RectangleButtonClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Ellipse1Click(TObject *Sender)
{
    CircleButton->Down = !CircleButton->Down;
    CircleButtonClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::FreeForm1Click(TObject *Sender)
{
    FreeFormButton->Down = !FreeFormButton->Down;
    FreeFormButtonClick(Sender);

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Select1Click(TObject *Sender)
{
    SelectButton->Down = !SelectButton->Down;
    SelectButtonClick(Sender);

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Erase1Click(TObject *Sender)
{
    EraseButton->Down = !EraseButton->Down;
    EraseButtonClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Block1Click(TObject *Sender)
{
    BlockButton->Down = !BlockButton->Down;
    BlockButtonClick(Sender);

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Settings1Click(TObject *Sender)
{
    DeselectafterOperation1->Checked = deselectafteroperation;
    ShowBackground2->Checked = showbackground;
    FloodFillFillDiagonalstoo1->Checked = floodfilldiagonals;
    ShowLinksBetweenBlocks1->Checked = showlinksbetweenblocks;
    SetColourSpaceDivisions1->Enabled = (bool)(AntiAlias != TAANone);
    SetColourSpaceDivisions1->Caption = "Set # of Colour Space Divisions (" + AnsiString(colourspacedivisions) + ")";
    SubspaceSampling1->Enabled = SetColourSpaceDivisions1->Enabled;
    FillShapes1->Checked = FillShapes;
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DeselectafterOperation1Click(
      TObject *Sender)
{
    deselectafteroperation = !deselectafteroperation;
}
//---------------------------------------------------------------------------

int __fastcall TImageEditorForm::FindTopmostDisplayItem(int X, int Y)
{
    //returns the location in the display array for the topmost display item
    //if only over the background, the it returns -1

    int returnvalue = DisplayList.Length - 1;
    bool found = false;
    displaylist DisplayItem;

    while (!found && returnvalue > -1) {
        DisplayItem = DisplayList[returnvalue];
        if (X >= DisplayItem.Area.Left && X <= DisplayItem.Area.Right && Y >= DisplayItem.Area.Top && Y <= DisplayItem.Area.Bottom && DisplayItem.visible) {
            switch (DisplayItem.DisplayType) {
                case TDisplayBlock:         {
                                            found = QueryDisplayBlock(X,Y,DisplayItem.ItemNumber);
                                            }
                                            break;
                case TDisplayFreeForm:      {
                                            found = QueryDisplayFreeForm(X,Y,DisplayItem.ItemNumber);
                                            }
                                            break;
                case TDisplayCircle:        {
                                            found = QueryDisplayCircle(X,Y,DisplayItem.ItemNumber);
                                            }
                                            break;
                case TDisplayRectangle:     {
                                            found = QueryDisplayRectangle(X,Y,DisplayItem.ItemNumber);
                                            }
                                            break;
                case TDisplayEraseItem:     {
                                            found = QueryDisplayErase(X,Y,DisplayItem.ItemNumber);
                                            }
                                            break;
                case TDisplayPolyLine:      {
                                            found = QueryDisplayPolyLine(X,Y,DisplayItem.ItemNumber);
                                            }
                                            break;
                case TDisplayLine:          {
                                            found = QueryDisplayLine(X,Y,DisplayItem.ItemNumber);
                                            }
                                            break;
                case TDisplayText:          {
                                            found = QueryDisplayText(X,Y,DisplayItem.ItemNumber);
                                            }
                                            break;
                case TDisplayFloodFill:     {
                                            found = QueryDisplayFloodFill(X,Y,DisplayItem.ItemNumber);
                                            }
                                            break;
                case TDisplayPoint:         {
                                            found = QueryDisplayPoint(X,Y,DisplayItem.ItemNumber);
                                            }
                                            break;
                default:                    break;
                }
            if (found) returnvalue++;
            }
        returnvalue--;
        }


    return returnvalue;
}
//---------------------------------------------------------------------------

bool __fastcall TImageEditorForm::QueryDisplayPoint(int X, int Y, int ItemNumber)
{
    //checks to see of X,Y is painted by the points array
    //first find point array
    bool found = false;
    int pointer = 0;
    int pointer2 = 0;
    while (!found && pointer < PointList.Length) {
        if (PointList[pointer].ItemNumber == ItemNumber) {
            pointer--;
            found = true;
            }
        pointer++;
        }
    //now check if the exact point is painted
    if (found) {
        found = false;
        while (!found && pointer2 < PointList[pointer].Points.Length) {
            if (PointList[pointer].Points[pointer2].x == X && PointList[pointer].Points[pointer2].y == Y) found = true;
            pointer2++;
            }
        }

    return found;
}
//---------------------------------------------------------------------------

bool __fastcall TImageEditorForm::QueryDisplayFloodFill(int X, int Y, int ItemNumber)
{
    //checks to see of X,Y is painted by the flood fill array
    //first find flood fill array entry
    bool found = false;
    int pointer = 0;
    int pointer2 = 0;
    while (!found && pointer < FloodFillList.Length) {
        if (FloodFillList[pointer].ItemNumber == ItemNumber) {
            pointer--;
            found = true;
            }
        pointer++;
        }
    //now check if the exact pixel is painted
    if (found) {
        found = false;
        while (!found && pointer2 < FloodFillList[pointer].Points.Length) {
            if (FloodFillList[pointer].Points[pointer2].x == X && FloodFillList[pointer].Points[pointer2].y == Y) found = true;
            pointer2++;
            }
        }

    return found;
}
//---------------------------------------------------------------------------

bool __fastcall TImageEditorForm::QueryDisplayText(int X, int Y, int ItemNumber)
{
    //checks to see of X,Y is painted by the text array
    //first find text array entry
    bool found = false;
    int pointer = 0;
    int pointer2 = 0;
    while (!found && pointer < TextList.Length) {
        if (TextList[pointer].ItemNumber == ItemNumber) {
            pointer--;
            found = true;
            }
        pointer++;
        }
    //now check if the exact pixel is painted
    if (found) {
        found = false;
        while (!found && pointer2 < TextList[pointer].Points.Length) {
            if (TextList[pointer].Points[pointer2].x == X && TextList[pointer].Points[pointer2].y == Y) found = true;
            pointer2++;
            }
        }

    return found;
}
//---------------------------------------------------------------------------

bool __fastcall TImageEditorForm::QueryDisplayLine(int X, int Y, int ItemNumber)
{
    //checks to see of X,Y is painted by the line array
    //first find line array entry
    bool found = false;
    int pointer = 0;
    int pointer2 = 0;
    while (!found && pointer < LineList.Length) {
        if (LineList[pointer].ItemNumber == ItemNumber) {
            pointer--;
            found = true;
            }
        pointer++;
        }
    //now check if the exact pixel is painted
    if (found) {
        found = false;
        while (!found && pointer2 < LineList[pointer].Points.Length) {
            if (LineList[pointer].Points[pointer2].x == X && LineList[pointer].Points[pointer2].y == Y) found = true;
            pointer2++;
            }
        }

    return found;
}
//---------------------------------------------------------------------------

bool __fastcall TImageEditorForm::QueryDisplayPolyLine(int X, int Y, int ItemNumber)
{
    //checks to see of X,Y is painted by the polyline array
    //first find Polyline array entry
    bool found = false;
    int pointer = 0;
    int pointer2 = 0;
    while (!found && pointer < PolyLineList.Length) {
        if (PolyLineList[pointer].ItemNumber == ItemNumber) {
            pointer--;
            found = true;
            }
        pointer++;
        }
    //now check if the exact pixel is painted
    if (found) {
        found = false;
        while (!found && pointer2 < PolyLineList[pointer].Points.Length) {
            if (PolyLineList[pointer].Points[pointer2].x == X && PolyLineList[pointer].Points[pointer2].y == Y) found = true;
            pointer2++;
            }
        }

    return found;
}
//---------------------------------------------------------------------------

bool __fastcall TImageEditorForm::QueryDisplayErase(int X, int Y, int ItemNumber)
{
    //checks to see of X,Y is painted by the erase array
    //first find erase array entry
    bool found = false;
    int pointer = 0;
    int pointer2 = 0;
    while (!found && pointer < EraseList.Length) {
        if (EraseList[pointer].ItemNumber == ItemNumber) {
            pointer--;
            found = true;
            }
        pointer++;
        }
    //now check if the exact pixel is painted
    if (found) {
        found = false;
        while (!found && pointer2 < EraseList[pointer].Points.Length) {
            if (EraseList[pointer].Points[pointer2].x == X && EraseList[pointer].Points[pointer2].y == Y) found = true;
            pointer2++;
            }
        }

    return found;
}
//---------------------------------------------------------------------------

bool __fastcall TImageEditorForm::QueryDisplayRectangle(int X, int Y, int ItemNumber)
{
    //checks to see of X,Y is painted by the Rectangle array
    //first find Rectangle array entry
    bool found = false;
    int pointer = 0;
    int pointer2 = 0;
    while (!found && pointer < RectangleList.Length) {
        if (RectangleList[pointer].ItemNumber == ItemNumber) {
            pointer--;
            found = true;
            }
        pointer++;
        }
    //now check if the exact pixel is painted
    if (found) {
        found = false;
        while (!found && pointer2 < RectangleList[pointer].Points.Length) {
            if (RectangleList[pointer].Points[pointer2].x == X && RectangleList[pointer].Points[pointer2].y == Y) found = true;
            pointer2++;
            }
        }

    return found;
}
//---------------------------------------------------------------------------

bool __fastcall TImageEditorForm::QueryDisplayCircle(int X, int Y, int ItemNumber)
{
    //checks to see of X,Y is painted by the Circle array
    //first find Circle array entry
    bool found = false;
    int pointer = 0;
    int pointer2 = 0;
    while (!found && pointer < CircleList.Length) {
        if (CircleList[pointer].ItemNumber == ItemNumber) {
            pointer--;
            found = true;
            }
        pointer++;
        }
    //now check if the exact pixel is painted
    if (found) {
        found = false;
        while (!found && pointer2 < CircleList[pointer].Points.Length) {
            if (CircleList[pointer].Points[pointer2].x == X && CircleList[pointer].Points[pointer2].y == Y) found = true;
            pointer2++;
            }
        }

    return found;
}
//---------------------------------------------------------------------------

bool __fastcall TImageEditorForm::QueryDisplayFreeForm(int X, int Y, int ItemNumber)
{
    //checks to see of X,Y is painted by the FreeForm array
    //first find FreeForm array entry
    bool found = false;
    int pointer = 0;
    int pointer2 = 0;
    while (!found && pointer < FreeFormList.Length) {
        if (FreeFormList[pointer].ItemNumber == ItemNumber) {
            pointer--;
            found = true;
            }
        pointer++;
        }
    //now check if the exact pixel is painted
    if (found) {
        found = false;
        while (!found && pointer2 < FreeFormList[pointer].Points.Length) {
            if (FreeFormList[pointer].Points[pointer2].x == X && FreeFormList[pointer].Points[pointer2].y == Y) found = true;
            pointer2++;
            }
        }

    return found;
}
//---------------------------------------------------------------------------

bool __fastcall TImageEditorForm::QueryDisplayBlock(int X, int Y, int ItemNumber)
{
    //checks to see of X,Y is painted by the Block array
    //first find Block array entry
    bool found = false;
    int pointer = 0;
    int pointer2 = 0;
    while (!found && pointer < BlockList.Length) {
        if (BlockList[pointer].ItemNumber == ItemNumber) {
            pointer--;
            found = true;
            }
        pointer++;
        }
    //now check if the exact pixel is painted
    if (found) {
        found = false;
        while (!found && pointer2 < BlockList[pointer].Points.Length) {
            if (BlockList[pointer].Points[pointer2].x == X && BlockList[pointer].Points[pointer2].y == Y) found = true;
            pointer2++;
            }
        }

    return found;
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::PopupMenu1Popup(TObject *Sender)
{
    bool result = AnyItemsSelected;
    //viewing order section
    BringtoFront1->Enabled = result;
    ForwardOne1->Enabled = result;
    BackOne1->Enabled = result;
    SendtoBack1->Enabled = result;
    HideSelected1->Enabled = result;
    //cut/copy/move/rotate
    Cut2->Enabled = result;
    Copy2->Enabled = result;
    Mirror2->Enabled = result;
    Move2->Enabled = result;
    Rotate1->Enabled = result;
    //Editing section
    N30->Visible = (AnyPointsExist || AnyLinesExist|| AnyPolyLinesExist || AnyFloodFillsExist || AnyTextItemsExist || AnyRectanglesExist || AnyCirclesExist || AnyFreeFormsExist || AnyEraseItemsExist);
    EditPencilObject1->Visible = AnyPointsExist;
    EditPencilObject1->Enabled = (bool)(NumberPointsSelected == 1);
    EditLine1->Visible = AnyLinesExist;
    EditLine1->Enabled = (bool)(NumberLinesSelected);
    EditPolyLine1->Visible = AnyPolyLinesExist;
    EditPolyLine1->Enabled = (bool)(NumberPolyLinesSelected);
    EditFloodFill1->Visible = AnyFloodFillsExist;
    EditFloodFill1->Enabled = (bool)(NumberFloodFillsSelected == 1);
    EditFloodFill->Enabled = EditFloodFill1->Enabled;
    EditFloodFill->Visible = EditFloodFill1->Visible;
    RegenerateFloodFill1->Visible = AnyFloodFillsExist;
    RegenerateFloodFill1->Enabled = (bool)(NumberFloodFillsSelected == 1);
    EditText1->Visible = AnyTextItemsExist;
    EditText1->Enabled = (bool) (NumberTextItemsSelected);
    EditRectangle1->Visible = AnyRectanglesExist;
    EditRectangle1->Enabled = EditRectangle1->Visible;
    EditEllipseCircle1->Visible = AnyCirclesExist;
    EditEllipseCircle1->Enabled = EditEllipseCircle1->Visible;
    EditFreeFormShape1->Visible = AnyFreeFormsExist;
    EditFreeFormShape1->Enabled = (bool)(NumberFreeFormsSelected);
    EditEraseItem1->Visible = AnyEraseItemsExist;
    EditEraseItem1->Enabled = (bool)(NumberEraseItemsSelected == 1);
    //Block section
    N31->Visible = AnyBlocksExist;
    EditBlock2->Visible = N31->Visible;
    int numblockssel = NumberBlocksSelected;
    EditBlock1->Visible = N31->Visible;
    EditBlock1->Enabled = (bool)(numblockssel == 1);
    BreakLink1->Visible = N31->Visible;
    BreakLink1->Enabled = (bool)(numblockssel > 0);
    LinkBlocks1->Visible = N31->Visible;
    LinkBlocks1->Enabled = (bool)(numblockssel == 2);

}
//---------------------------------------------------------------------------

bool __fastcall TImageEditorForm::CheckifItemsSelected(void)
{
    //checks to see if any items are selected
    bool found = false;
    int pointer = 0;

    while (!found && pointer < DisplayList.Length) {
        if (DisplayList[pointer].selected) found = true;
        pointer++;
        }

    return found;

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::BringtoFront1Click(TObject *Sender)
{
    //The selected items are brought to the front of the display list
    displaylist swap;
    int pointer = 0;
    int toppointer = DisplayList.Length - 1;
    AddUndoTitle("Bring Selected Items to the Front");
    while (pointer < toppointer) {
        if (DisplayList[pointer].selected) {
            AddUndo("DisplayOrder," + AnsiString(DisplayList[pointer].ItemNumber) + "," + AnsiString(pointer) + ",");
            swap = DisplayList[pointer];
            for (int i = pointer; i < toppointer; i++) {
                DisplayList[i] = DisplayList[i+1];
                }
            DisplayList[toppointer] = swap;
            pointer--;
            toppointer--;
            }
        pointer++;
        }
    if (deselectafteroperation) {
        for (int i = 0; i < DisplayList.Length; i++) {
            if (DisplayList[i].selected) AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
            DisplayList[i].selected = false;
            }
        }
    CreateXRefs();
    DrawPicture();
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::ForwardOne1Click(TObject *Sender)
{
    //The selected items are brought one forward in the display list
    displaylist swap;
    AddUndoTitle("Bring Selected Items Forward One in Display Order");
    for (int i = DisplayList.Length - 2; i > -1; i--) {
        if (DisplayList[i].selected) {
            AddUndo("DisplayOrder," + AnsiString(DisplayList[i].ItemNumber) + "," + AnsiString(i) + ",");
            swap = DisplayList[i];
            DisplayList[i] = DisplayList[i+1];
            DisplayList[i+1] = swap;
            }
        }
    if (deselectafteroperation) {
        for (int i = 0; i < DisplayList.Length; i++) {
            if (DisplayList[i].selected) AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
            DisplayList[i].selected = false;
            }
        }
    CreateXRefs();
    DrawPicture();
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::BackOne1Click(TObject *Sender)
{
    //The selected items are sent one back in the display list
    displaylist swap;
    AddUndoTitle("Send Selected Items Back One in Display Order");
    for (int i = 1; i < DisplayList.Length; i++) {
        if (DisplayList[i].selected) {
            AddUndo("DisplayOrder," + AnsiString(DisplayList[i].ItemNumber) + "," + AnsiString(i) + ",");
            swap = DisplayList[i];
            DisplayList[i] = DisplayList[i-1];
            DisplayList[i-1] = swap;
            }
        }
    if (deselectafteroperation) {
        for (int i = 0; i < DisplayList.Length; i++) {
            if (DisplayList[i].selected) AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
            DisplayList[i].selected = false;
            }
        }
    CreateXRefs();
    DrawPicture();

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::SendtoBack1Click(TObject *Sender)
{
    //The selected items are sent to the back of the display list
    displaylist swap;
    int pointer = DisplayList.Length - 1;
    int toppointer = 0;
    AddUndoTitle("Send Selected Items to the Back");
    while (pointer > toppointer) {
        if (DisplayList[pointer].selected) {
            AddUndo("DisplayOrder," + AnsiString(DisplayList[pointer].ItemNumber) + "," + AnsiString(pointer) + ",");
            swap = DisplayList[pointer];
            for (int i = pointer; i > toppointer; i--) {
                DisplayList[i] = DisplayList[i-1];
                }
            DisplayList[toppointer] = swap;
            pointer++;
            toppointer++;
            }
        pointer--;
        }
    if (deselectafteroperation) {
        for (int i = 0; i < DisplayList.Length; i++) {
            if (DisplayList[i].selected) AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
            DisplayList[i].selected = false;
            }
        }
    CreateXRefs();
    DrawPicture();

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::SelectAll1Click(TObject *Sender)
{
    AddUndoTitle("Select All Objects");
    for (int i = 0; i < DisplayList.Length; i++) {
        if (!DisplayList[i].selected) AddUndo("Deselect," + AnsiString(DisplayList[i].ItemNumber) + ",");
        if (!DisplayList[i].visible) AddUndo("Hide," + AnsiString(DisplayList[i].ItemNumber) + ",");
        DisplayList[i].selected = true;
        DisplayList[i].visible = true;
        }
    DrawPicture();

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DeselectAll1Click(TObject *Sender)
{
    AddUndoTitle("Deselect All Objects");
    for (int i = 0; i < DisplayList.Length; i++) {
        if (DisplayList[i].selected) AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
        DisplayList[i].selected = false;
        }
    DrawPicture();

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::All1Click(TObject *Sender)
{
    //show all items
    AddUndoTitle("Show All Objects");
    for (int i = 0; i < DisplayList.Length; i++) {
        if (!DisplayList[i].visible) AddUndo("Hide," + AnsiString(DisplayList[i].ItemNumber) + ",");
        DisplayList[i].visible = true;
        }
    DrawPicture();

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::AllPoints1Click(TObject *Sender)
{
    //show all of a type
    if (dynamic_cast <TComponent *>(Sender)) {
        TDisplayType DisplayType = (TDisplayType)(dynamic_cast <TComponent *>(Sender)->Tag);
        AnsiString text = "Show All ";
        switch (DisplayType) {
            case TDisplayBlock:     {
                                    text = text + "Blocks";
                                    }
                                    break;
            case TDisplayEraseItem: {
                                    text = text + "Erase Objects";
                                    }
                                    break;
            case TDisplayFreeForm:  {
                                    text = text + "Free-Form Shapes";
                                    }
                                    break;
            case TDisplayCircle:    {
                                    text = text + "Circles";
                                    }
                                    break;
            case TDisplayRectangle: {
                                    text = text + "Rectangles";
                                    }
                                    break;
            case TDisplayText:      {
                                    text = text + "Text Objects";
                                    }
                                    break;
            case TDisplayFloodFill: {
                                    text = text + "Flood Fills";
                                    }
                                    break;
            case TDisplayPolyLine:  {
                                    text = text + "Polylines";
                                    }
                                    break;
            case TDisplayLine:      {
                                    text = text + "Lines";
                                    }
                                    break;
            case TDisplayPoint:     {
                                    text = text + "Pencil Objects";
                                    }
                                    break;
            default:                break;
            }
        AddUndoTitle(text);
        for (int i = 0; i < DisplayList.Length; i++) {
            if (DisplayList[i].DisplayType == DisplayType) {
                if (!DisplayList[i].visible) AddUndo("Hide," + AnsiString(DisplayList[i].ItemNumber) + ",");
                DisplayList[i].visible = true;
                }
            }
        DrawPicture();
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::All2Click(TObject *Sender)
{
    //hide all items
    AddUndoTitle("Hide All Objects");
    for (int i = 0; i < DisplayList.Length; i++) {
        if (DisplayList[i].selected) AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
        if (DisplayList[i].visible) AddUndo("Show," + AnsiString(DisplayList[i].ItemNumber) + ",");
        DisplayList[i].selected = false;
        DisplayList[i].visible = false;
        }
    DrawPicture();

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::AllPencilObjects1Click(TObject *Sender)
{
    //hide all of a type
    if (dynamic_cast <TComponent *>(Sender)) {
        TDisplayType DisplayType = (TDisplayType)(dynamic_cast <TComponent *>(Sender)->Tag);
        AnsiString text = "Hide All ";
        switch (DisplayType) {
            case TDisplayBlock:     {
                                    text = text + "Blocks";
                                    }
                                    break;
            case TDisplayEraseItem: {
                                    text = text + "Erase Objects";
                                    }
                                    break;
            case TDisplayFreeForm:  {
                                    text = text + "Free-Form Shapes";
                                    }
                                    break;
            case TDisplayCircle:    {
                                    text = text + "Circles";
                                    }
                                    break;
            case TDisplayRectangle: {
                                    text = text + "Rectangles";
                                    }
                                    break;
            case TDisplayText:      {
                                    text = text + "Text Objects";
                                    }
                                    break;
            case TDisplayFloodFill: {
                                    text = text + "Flood Fills";
                                    }
                                    break;
            case TDisplayPolyLine:  {
                                    text = text + "Polylines";
                                    }
                                    break;
            case TDisplayLine:      {
                                    text = text + "Lines";
                                    }
                                    break;
            case TDisplayPoint:     {
                                    text = text + "Pencil Objects";
                                    }
                                    break;
            default:                break;
            }
        AddUndoTitle(text);
        for (int i = 0; i < DisplayList.Length; i++) {
            if (DisplayList[i].DisplayType == DisplayType) {
                if (DisplayList[i].selected) AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                if (DisplayList[i].visible) AddUndo("Show," + AnsiString(DisplayList[i].ItemNumber) + ",");
                DisplayList[i].selected = false;
                DisplayList[i].visible = false;
                }
            }
        DrawPicture();
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Show1Click(TObject *Sender)
{
    All1->Enabled = (bool)(DisplayList.Length);
    AllPoints1->Enabled = (bool)(PointList.Length);
    AllLines1->Enabled = (bool)(LineList.Length);
    AllPolylines1->Enabled = (bool)(PolyLineList.Length);
    AllFloodFills1->Enabled = (bool)(FloodFillList.Length);
    AllTextObjects1->Enabled = (bool)(TextList.Length);
    AllRectangles1->Enabled = (bool)(RectangleList.Length);
    AllEllipsesCircles1->Enabled = (bool)(CircleList.Length);
    AllFreeFormShapes1->Enabled = (bool)(FreeFormList.Length);
    AllEraseObjects1->Enabled = (bool)(EraseList.Length);
    AllBlocks1->Enabled = (bool)(BlockList.Length);
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::SelectedItems1Click(TObject *Sender)
{
    //hide all selected items
    AddUndoTitle("Hide Selected Objects");
    for (int i = 0; i < DisplayList.Length; i++) {
        if (DisplayList[i].selected) {
            AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
            DisplayList[i].selected = false;
            if (DisplayList[i].visible) AddUndo("Show," + AnsiString(DisplayList[i].ItemNumber) + ",");
            DisplayList[i].visible = false;
            }
        }
    DrawPicture();

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::SelectAllPencilTools1Click(
      TObject *Sender)
{
    //select all objects all of a type
    if (dynamic_cast <TComponent *>(Sender)) {
        TDisplayType DisplayType = (TDisplayType)(dynamic_cast <TComponent *>(Sender)->Tag);
        AnsiString text = "Select All ";
        switch (DisplayType) {
            case TDisplayBlock:     {
                                    text = text + "Blocks";
                                    }
                                    break;
            case TDisplayEraseItem: {
                                    text = text + "Erase Objects";
                                    }
                                    break;
            case TDisplayCircle:    {
                                    text = text + "Circles";
                                    }
                                    break;
            case TDisplayRectangle: {
                                    text = text + "Rectangles";
                                    }
                                    break;
            case TDisplayText:      {
                                    text = text + "Text Objects";
                                    }
                                    break;
            case TDisplayFloodFill: {
                                    text = text + "Flood Fills";
                                    }
                                    break;
            case TDisplayLine:      {
                                    text = text + "Lines";
                                    }
                                    break;
            case TDisplayPoint:     {
                                    text = text + "Pencil Objects";
                                    }
                                    break;
            default:                break;
            }
        AddUndoTitle(text);
        for (int i = 0; i < DisplayList.Length; i++) {
            if (DisplayList[i].DisplayType == DisplayType) {
                if (!DisplayList[i].selected) AddUndo("Deselect," + AnsiString(DisplayList[i].ItemNumber) + ",");
                if (!DisplayList[i].visible) AddUndo("Hide," + AnsiString(DisplayList[i].ItemNumber) + ",");
                DisplayList[i].selected = true;
                DisplayList[i].visible = true;
                }
            }
        DrawPicture();
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DeselectAllPencilObjects1Click(
      TObject *Sender)
{
    //deselect all objects all of a type
    if (dynamic_cast <TComponent *>(Sender)) {
        TDisplayType DisplayType = (TDisplayType)(dynamic_cast <TComponent *>(Sender)->Tag);
        AnsiString text = "Deselect All ";
        switch (DisplayType) {
            case TDisplayBlock:     {
                                    text = text + "Blocks";
                                    }
                                    break;
            case TDisplayEraseItem: {
                                    text = text + "Erase Objects";
                                    }
                                    break;
            case TDisplayCircle:    {
                                    text = text + "Circles";
                                    }
                                    break;
            case TDisplayRectangle: {
                                    text = text + "Rectangles";
                                    }
                                    break;
            case TDisplayText:      {
                                    text = text + "Text Objects";
                                    }
                                    break;
            case TDisplayFloodFill: {
                                    text = text + "Flood Fills";
                                    }
                                    break;
            case TDisplayLine:      {
                                    text = text + "Lines";
                                    }
                                    break;
            case TDisplayPoint:     {
                                    text = text + "Pencil Objects";
                                    }
                                    break;
            default:                break;
            }
        AddUndoTitle(text);
        for (int i = 0; i < DisplayList.Length; i++) {
            if (DisplayList[i].DisplayType == DisplayType) {
                if (DisplayList[i].selected) AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                DisplayList[i].selected = false;
                }
            }
        DrawPicture();
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Hide1Click(TObject *Sender)
{
    if (DisplayList.Length) {
        All2->Enabled = true;
        } else {
        All2->Enabled = false;
        }
    AllPencilObjects1->Enabled = (bool)(PointList.Length);
    AllLines2->Enabled = (bool)(LineList.Length);
    AllPolylines2->Enabled = (bool)(PolyLineList.Length);
    AllFloodFills2->Enabled = (bool)(FloodFillList.Length);
    AllText1->Enabled = (bool)(TextList.Length);
    AllRectangles2->Enabled = (bool)(RectangleList.Length);
    AllEllipsesCircles2->Enabled = (bool)(CircleList.Length);
    AllFreeFormShapes2->Enabled = (bool)(FreeFormList.Length);
    AllEraseObjects2->Enabled = (bool)(EraseList.Length);
    AllBlocks2->Enabled = (bool)(BlockList.Length);
    SelectedItems1->Enabled =  AnyItemsSelected;

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::ShowBackground1Click(TObject *Sender)
{
    //toggle showing the background
    showbackground = ! showbackground;
    DrawPicture();
}
//---------------------------------------------------------------------------

bool __fastcall TImageEditorForm::CheckPointPixelsinArea(TRect Rectangle, int ItemNumber)
{
    //checks if any painted pixels in the point array with item number ItemNumber are inside Rectangle
    int pointer = PointList.Length - 1;
    int pointer2 = 0;
    bool found = false;

    while (!found && pointer > -1) {
        if (PointList[pointer].ItemNumber == ItemNumber) {
            found = true;
            pointer++;
            }
        pointer--;
        }

    if (found) {
        found = false;
        while (!found && pointer2 < PointList[pointer].Points.Length) {
            if (PointList[pointer].Points[pointer2].x >= Rectangle.Left
                && PointList[pointer].Points[pointer2].x <= Rectangle.Right
                && PointList[pointer].Points[pointer2].y >= Rectangle.Top
                && PointList[pointer].Points[pointer2].y <= Rectangle.Bottom
                ) found = true;
            pointer2++;
            }
        }

    return found;

}
//---------------------------------------------------------------------------

bool __fastcall TImageEditorForm::CheckLinePixelsinArea(TRect Rectangle, int ItemNumber)
{
    //checks if any painted pixels in the Line array with item number ItemNumber are inside Rectangle
    int pointer = LineList.Length - 1;
    int pointer2 = 0;
    bool found = false;

    while (!found && pointer > -1) {
        if (LineList[pointer].ItemNumber == ItemNumber) {
            found = true;
            pointer++;
            }
        pointer--;
        }

    if (found) {
        found = false;
        while (!found && pointer2 < LineList[pointer].Points.Length) {
            if (LineList[pointer].Points[pointer2].x >= Rectangle.Left
                && LineList[pointer].Points[pointer2].x <= Rectangle.Right
                && LineList[pointer].Points[pointer2].y >= Rectangle.Top
                && LineList[pointer].Points[pointer2].y <= Rectangle.Bottom
                ) found = true;
            pointer2++;
            }
        }

    return found;

}
//---------------------------------------------------------------------------

bool __fastcall TImageEditorForm::CheckPolyLinePixelsinArea(TRect Rectangle, int ItemNumber)
{
    //checks if any painted pixels in the PolyLine array with item number ItemNumber are inside Rectangle
    int pointer = PolyLineList.Length - 1;
    int pointer2 = 0;
    bool found = false;

    while (!found && pointer > -1) {
        if (PolyLineList[pointer].ItemNumber == ItemNumber) {
            found = true;
            pointer++;
            }
        pointer--;
        }

    if (found) {
        found = false;
        while (!found && pointer2 < PolyLineList[pointer].Points.Length) {
            if (PolyLineList[pointer].Points[pointer2].x >= Rectangle.Left
                && PolyLineList[pointer].Points[pointer2].x <= Rectangle.Right
                && PolyLineList[pointer].Points[pointer2].y >= Rectangle.Top
                && PolyLineList[pointer].Points[pointer2].y <= Rectangle.Bottom
                ) found = true;
            pointer2++;
            }
        }

    return found;

}
//---------------------------------------------------------------------------

bool __fastcall TImageEditorForm::CheckFloodFillPixelsinArea(TRect Rectangle, int ItemNumber)
{
    //checks if any painted pixels in the FloodFill array with item number ItemNumber are inside Rectangle
    int pointer = FloodFillList.Length - 1;
    int pointer2 = 0;
    bool found = false;

    while (!found && pointer > -1) {
        if (FloodFillList[pointer].ItemNumber == ItemNumber) {
            found = true;
            pointer++;
            }
        pointer--;
        }

    if (found) {
        found = false;
        while (!found && pointer2 < FloodFillList[pointer].Points.Length) {
            if (FloodFillList[pointer].Points[pointer2].x >= Rectangle.Left
                && FloodFillList[pointer].Points[pointer2].x <= Rectangle.Right
                && FloodFillList[pointer].Points[pointer2].y >= Rectangle.Top
                && FloodFillList[pointer].Points[pointer2].y <= Rectangle.Bottom
                ) found = true;
            pointer2++;
            }
        }

    return found;

}
//---------------------------------------------------------------------------

bool __fastcall TImageEditorForm::CheckTextPixelsinArea(TRect Rectangle, int ItemNumber)
{
    //checks if any painted pixels in the Text array with item number ItemNumber are inside Rectangle
    int pointer = TextList.Length - 1;
    int pointer2 = 0;
    bool found = false;

    while (!found && pointer > -1) {
        if (TextList[pointer].ItemNumber == ItemNumber) {
            found = true;
            pointer++;
            }
        pointer--;
        }

    if (found) {
        found = false;
        while (!found && pointer2 < TextList[pointer].Points.Length) {
            if (TextList[pointer].Points[pointer2].x >= Rectangle.Left
                && TextList[pointer].Points[pointer2].x <= Rectangle.Right
                && TextList[pointer].Points[pointer2].y >= Rectangle.Top
                && TextList[pointer].Points[pointer2].y <= Rectangle.Bottom
                ) found = true;
            pointer2++;
            }
        }

    return found;

}
//---------------------------------------------------------------------------

bool __fastcall TImageEditorForm::CheckRectanglePixelsinArea(TRect Rectangle, int ItemNumber)
{
    //checks if any painted pixels in the Rectangle array with item number ItemNumber are inside Rectangle
    int pointer = RectangleList.Length - 1;
    int pointer2 = 0;
    bool found = false;

    while (!found && pointer > -1) {
        if (RectangleList[pointer].ItemNumber == ItemNumber) {
            found = true;
            pointer++;
            }
        pointer--;
        }

    if (found) {
        found = false;
        while (!found && pointer2 < RectangleList[pointer].Points.Length) {
            if (RectangleList[pointer].Points[pointer2].x >= Rectangle.Left
                && RectangleList[pointer].Points[pointer2].x <= Rectangle.Right
                && RectangleList[pointer].Points[pointer2].y >= Rectangle.Top
                && RectangleList[pointer].Points[pointer2].y <= Rectangle.Bottom
                ) found = true;
            pointer2++;
            }
        }

    return found;

}
//---------------------------------------------------------------------------

bool __fastcall TImageEditorForm::CheckCirclePixelsinArea(TRect Rectangle, int ItemNumber)
{
    //checks if any painted pixels in the Circle array with item number ItemNumber are inside Rectangle
    int pointer = CircleList.Length - 1;
    int pointer2 = 0;
    bool found = false;

    while (!found && pointer > -1) {
        if (CircleList[pointer].ItemNumber == ItemNumber) {
            found = true;
            pointer++;
            }
        pointer--;
        }

    if (found) {
        found = false;
        while (!found && pointer2 < CircleList[pointer].Points.Length) {
            if (CircleList[pointer].Points[pointer2].x >= Rectangle.Left
                && CircleList[pointer].Points[pointer2].x <= Rectangle.Right
                && CircleList[pointer].Points[pointer2].y >= Rectangle.Top
                && CircleList[pointer].Points[pointer2].y <= Rectangle.Bottom
                ) found = true;
            pointer2++;
            }
        }

    return found;

}
//---------------------------------------------------------------------------

bool __fastcall TImageEditorForm::CheckFreeFormPixelsinArea(TRect Rectangle, int ItemNumber)
{
    //checks if any painted pixels in the FreeForm array with item number ItemNumber are inside Rectangle
    int pointer = FreeFormList.Length - 1;
    int pointer2 = 0;
    bool found = false;

    while (!found && pointer > -1) {
        if (FreeFormList[pointer].ItemNumber == ItemNumber) {
            found = true;
            pointer++;
            }
        pointer--;
        }

    if (found) {
        found = false;
        while (!found && pointer2 < FreeFormList[pointer].Points.Length) {
            if (FreeFormList[pointer].Points[pointer2].x >= Rectangle.Left
                && FreeFormList[pointer].Points[pointer2].x <= Rectangle.Right
                && FreeFormList[pointer].Points[pointer2].y >= Rectangle.Top
                && FreeFormList[pointer].Points[pointer2].y <= Rectangle.Bottom
                ) found = true;
            pointer2++;
            }
        }

    return found;

}
//---------------------------------------------------------------------------

bool __fastcall TImageEditorForm::CheckErasePixelsinArea(TRect Rectangle, int ItemNumber)
{
    //checks if any painted pixels in the Erase array with item number ItemNumber are inside Rectangle
    int pointer = EraseList.Length - 1;
    int pointer2 = 0;
    bool found = false;

    while (!found && pointer > -1) {
        if (EraseList[pointer].ItemNumber == ItemNumber) {
            found = true;
            pointer++;
            }
        pointer--;
        }

    if (found) {
        found = false;
        while (!found && pointer2 < EraseList[pointer].Points.Length) {
            if (EraseList[pointer].Points[pointer2].x >= Rectangle.Left
                && EraseList[pointer].Points[pointer2].x <= Rectangle.Right
                && EraseList[pointer].Points[pointer2].y >= Rectangle.Top
                && EraseList[pointer].Points[pointer2].y <= Rectangle.Bottom
                ) found = true;
            pointer2++;
            }
        }

    return found;

}
//---------------------------------------------------------------------------

bool __fastcall TImageEditorForm::CheckBlockPixelsinArea(TRect Rectangle, int ItemNumber)
{
    //checks if any painted pixels in the Block array with item number ItemNumber are inside Rectangle
    int pointer = BlockList.Length - 1;
    int pointer2 = 0;
    bool found = false;

    while (!found && pointer > -1) {
        if (BlockList[pointer].ItemNumber == ItemNumber) {
            found = true;
            pointer++;
            }
        pointer--;
        }

    if (found) {
        found = false;
        while (!found && pointer2 < BlockList[pointer].Points.Length) {
            if (BlockList[pointer].Points[pointer2].x >= Rectangle.Left
                && BlockList[pointer].Points[pointer2].x <= Rectangle.Right
                && BlockList[pointer].Points[pointer2].y >= Rectangle.Top
                && BlockList[pointer].Points[pointer2].y <= Rectangle.Bottom
                ) found = true;
            pointer2++;
            }
        }

    return found;

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Cut1Click(TObject *Sender)
{
    //Deletes selected objects
    if (AnyItemsSelected) {
        SingleUndo = false;
        AddUndoTitle("Delete Selected Items");
        int pointer = DisplayList.Length - 1;
        while (pointer > -1) {
            if (DisplayList[pointer].selected) {
                //delete the entity pointed to
                switch (DisplayList[pointer].DisplayType) {
                    case TDisplayBlock:     {
                                            DeleteBlock(DisplayList[pointer].ItemNumber);
                                            }
                                            break;
                    case TDisplayFreeForm:  {
                                            DeleteFreeForm(DisplayList[pointer].ItemNumber);
                                            }
                                            break;
                    case TDisplayCircle:    {
                                            DeleteCircle(DisplayList[pointer].ItemNumber);
                                            }
                                            break;
                    case TDisplayRectangle: {
                                            DeleteRectangle(DisplayList[pointer].ItemNumber);
                                            }
                                            break;
                    case TDisplayEraseItem: {
                                            DeleteErase(DisplayList[pointer].ItemNumber);
                                            }
                                            break;
                    case TDisplayPolyLine:  {
                                            DeletePolyLine(DisplayList[pointer].ItemNumber);
                                            }
                                            break;
                    case TDisplayLine:      {
                                            DeleteLine(DisplayList[pointer].ItemNumber);
                                            }
                                            break;
                    case TDisplayText:      {
                                            DeleteText(DisplayList[pointer].ItemNumber);
                                            }
                                            break;
                    case TDisplayFloodFill: {
                                            DeleteFloodFill(DisplayList[pointer].ItemNumber);
                                            }
                                            break;
                    case TDisplayPoint:     {
                                            DeletePoints(DisplayList[pointer].ItemNumber);
                                            }
                                            break;
                    default:                break;
                    }
                //now delete the entry in the display array
                /*for (int i = pointer; i < DisplayList.Length - 1; i++) {
                    DisplayList[i] = DisplayList[i+1];
                    }
                DisplayList.Length--;
                */
                }
            pointer--;
            }

        SingleUndo = true;
        DrawPicture();
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Cancel1Click(TObject *Sender)
{
    ModalResult = mrCancel;
}
//---------------------------------------------------------------------------

displaylist __fastcall TImageEditorForm::CopyPoint(TPoint delta, int ItemNumber)
{
    //copies the points indicated by ItemNumber by the offset delta
    int pointer = PointList.Length - 1;
    bool found = false;
    displaylist ReturnValue;

    ReturnValue.ItemNumber = -1;
    ReturnValue.DisplayType = TDisplayPoint;
    ReturnValue.Area.Top = 0;
    ReturnValue.Area.Left = 0;
    ReturnValue.Area.Right = 0;
    ReturnValue.Area.Bottom = 0;
    ReturnValue.UndoName = "Not Allocated";
    ReturnValue.selected = false;
    ReturnValue.visible = true;

    while (!found && pointer > -1) {
        if (PointList[pointer].ItemNumber == ItemNumber) {
            found = true;
            pointer++;
            }
        pointer--;
        }

    if (found) {
        //have found the point to be copied
        ReturnValue.ItemNumber = DisplayItemNumber;

        int arrayentry = PointList.Length;
        PointList.Length++;
        PointList[arrayentry].ItemNumber = DisplayItemNumber;
        PointList[arrayentry].Colour = PointList[pointer].Colour;
        PointList[arrayentry].Points.Length = PointList[pointer].Points.Length;
        for (int i = 0; i < PointList[arrayentry].Points.Length; i++) {
            PointList[arrayentry].Points[i].x = PointList[pointer].Points[i].x + delta.x;
            PointList[arrayentry].Points[i].y = PointList[pointer].Points[i].y + delta.y;
            }

        ReturnValue.Area.Left = PointList[arrayentry].Points[0].x;
        ReturnValue.Area.Top = PointList[arrayentry].Points[0].y;
        ReturnValue.Area.Right = PointList[arrayentry].Points[0].x;
        ReturnValue.Area.Bottom = PointList[arrayentry].Points[0].y;
        for (int i = 1; i < PointList[arrayentry].Points.Length; i++) {
            if (PointList[arrayentry].Points[i].x < ReturnValue.Area.Left) ReturnValue.Area.Left = PointList[arrayentry].Points[i].x;
            if (PointList[arrayentry].Points[i].y < ReturnValue.Area.Top) ReturnValue.Area.Top = PointList[arrayentry].Points[i].y;
            if (PointList[arrayentry].Points[i].x > ReturnValue.Area.Right) ReturnValue.Area.Right = PointList[arrayentry].Points[i].x;
            if (PointList[arrayentry].Points[i].y > ReturnValue.Area.Bottom) ReturnValue.Area.Bottom = PointList[arrayentry].Points[i].y;
            }

        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Copy Pencil Object X" + AnsiString(delta.x) + " Y" + AnsiString(delta.y));
            AddUndo("Delete," + AnsiString(DisplayItemNumber) + ",");
            }
        DisplayItemNumber++;
        }

    return ReturnValue;
}
//---------------------------------------------------------------------------

displaylist __fastcall TImageEditorForm::CopyLine(TPoint delta, int ItemNumber)
{
    //copies the Line indicated by ItemNumber by the offset delta
    int pointer = LineList.Length - 1;
    bool found = false;
    displaylist ReturnValue;

    ReturnValue.ItemNumber = -1;
    ReturnValue.DisplayType = TDisplayLine;
    ReturnValue.Area.Top = 0;
    ReturnValue.Area.Left = 0;
    ReturnValue.Area.Right = 0;
    ReturnValue.Area.Bottom = 0;
    ReturnValue.UndoName = "Not Allocated";
    ReturnValue.selected = false;
    ReturnValue.visible = true;

    while (!found && pointer > -1) {
        if (LineList[pointer].ItemNumber == ItemNumber) {
            found = true;
            pointer++;
            }
        pointer--;
        }

    if (found) {
        //have found the Line to be copied
        ReturnValue.ItemNumber = DisplayItemNumber;

        int arrayentry = LineList.Length;
        LineList.Length++;
        LineList[arrayentry].ItemNumber = DisplayItemNumber;
        LineList[arrayentry].Colour = LineList[pointer].Colour;
        LineList[arrayentry].LineWidth = LineList[pointer].LineWidth;
        LineList[arrayentry].StartPoint.x = LineList[pointer].StartPoint.x + delta.x;
        LineList[arrayentry].StartPoint.y = LineList[pointer].StartPoint.x + delta.y;
        LineList[arrayentry].EndPoint.x = LineList[pointer].EndPoint.x + delta.x;
        LineList[arrayentry].EndPoint.y = LineList[pointer].EndPoint.y + delta.y;
        /*
        LineList[arrayentry].Points.Length = LineList[pointer].Points.Length;
        for (int i = 0; i < LineList[arrayentry].Points.Length; i++) {
            LineList[arrayentry].Points[i].x = LineList[pointer].Points[i].x + delta.x;
            LineList[arrayentry].Points[i].y = LineList[pointer].Points[i].y + delta.y;
            }
        */
        //take antialiasing into account
        FillPointsLine(arrayentry,LineList[arrayentry].ItemNumber);

        ReturnValue.Area.Left = LineList[arrayentry].Points[0].x;
        ReturnValue.Area.Top = LineList[arrayentry].Points[0].y;
        ReturnValue.Area.Right = LineList[arrayentry].Points[0].x;
        ReturnValue.Area.Bottom = LineList[arrayentry].Points[0].y;
        for (int i = 1; i < LineList[arrayentry].Points.Length; i++) {
            if (LineList[arrayentry].Points[i].x < ReturnValue.Area.Left) ReturnValue.Area.Left = LineList[arrayentry].Points[i].x;
            if (LineList[arrayentry].Points[i].y < ReturnValue.Area.Top) ReturnValue.Area.Top = LineList[arrayentry].Points[i].y;
            if (LineList[arrayentry].Points[i].x > ReturnValue.Area.Right) ReturnValue.Area.Right = LineList[arrayentry].Points[i].x;
            if (LineList[arrayentry].Points[i].y > ReturnValue.Area.Bottom) ReturnValue.Area.Bottom = LineList[arrayentry].Points[i].y;
            }
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Copy Line X" + AnsiString(delta.x) + " Y" + AnsiString(delta.y));
            AddUndo("Delete," + AnsiString(DisplayItemNumber) + ",");
            }
        DisplayItemNumber++;
        }

    return ReturnValue;
}
//---------------------------------------------------------------------------

displaylist __fastcall TImageEditorForm::CopyPolyLine(TPoint delta, int ItemNumber)
{
    //copies the PolyLine indicated by ItemNumber by the offset delta
    int pointer = PolyLineList.Length - 1;
    bool found = false;
    displaylist ReturnValue;

    ReturnValue.ItemNumber = -1;
    ReturnValue.DisplayType = TDisplayPolyLine;
    ReturnValue.Area.Top = 0;
    ReturnValue.Area.Left = 0;
    ReturnValue.Area.Right = 0;
    ReturnValue.Area.Bottom = 0;
    ReturnValue.UndoName = "Not Allocated";
    ReturnValue.selected = false;
    ReturnValue.visible = true;

    while (!found && pointer > -1) {
        if (PolyLineList[pointer].ItemNumber == ItemNumber) {
            found = true;
            pointer++;
            }
        pointer--;
        }

    if (found) {
        //have found the Line to be copied
        ReturnValue.ItemNumber = DisplayItemNumber;

        int arrayentry = PolyLineList.Length;
        PolyLineList.Length++;
        PolyLineList[arrayentry].ItemNumber = DisplayItemNumber;
        PolyLineList[arrayentry].PenColour = PolyLineList[pointer].PenColour;
        PolyLineList[arrayentry].BrushColour = PolyLineList[pointer].BrushColour;
        PolyLineList[arrayentry].LineWidth = PolyLineList[pointer].LineWidth;
        PolyLineList[arrayentry].closed = PolyLineList[pointer].closed;
        PolyLineList[arrayentry].filled = PolyLineList[pointer].filled;
        PolyLineList[arrayentry].Corners.Length = PolyLineList[pointer].Corners.Length;
        for (int i = 0; i < PolyLineList[arrayentry].Corners.Length; i++) {
            PolyLineList[arrayentry].Corners[i].x = PolyLineList[pointer].Corners[i].x + delta.x;
            PolyLineList[arrayentry].Corners[i].y = PolyLineList[pointer].Corners[i].y + delta.y;
            }
        FillPointsPolyLine(arrayentry,PolyLineList[arrayentry].ItemNumber);
        ReturnValue.Area.Left = PolyLineList[arrayentry].Points[0].x;
        ReturnValue.Area.Top = PolyLineList[arrayentry].Points[0].y;
        ReturnValue.Area.Right = PolyLineList[arrayentry].Points[0].x;
        ReturnValue.Area.Bottom = PolyLineList[arrayentry].Points[0].y;
        for (int i = 1; i < PolyLineList[arrayentry].Points.Length; i++) {
            if (PolyLineList[arrayentry].Points[i].x < ReturnValue.Area.Left) ReturnValue.Area.Left = PolyLineList[arrayentry].Points[i].x;
            if (PolyLineList[arrayentry].Points[i].y < ReturnValue.Area.Top) ReturnValue.Area.Top = PolyLineList[arrayentry].Points[i].y;
            if (PolyLineList[arrayentry].Points[i].x > ReturnValue.Area.Right) ReturnValue.Area.Right = PolyLineList[arrayentry].Points[i].x;
            if (PolyLineList[arrayentry].Points[i].y > ReturnValue.Area.Bottom) ReturnValue.Area.Bottom = PolyLineList[arrayentry].Points[i].y;
            }
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Copy Polyline X" + AnsiString(delta.x) + " Y" + AnsiString(delta.y));
            AddUndo("Delete," + AnsiString(DisplayItemNumber) + ",");
            }
        DisplayItemNumber++;
        }

    return ReturnValue;
}
//---------------------------------------------------------------------------

displaylist __fastcall TImageEditorForm::CopyFloodFill(TPoint delta, int ItemNumber)
{
    //copies the FloodFill indicated by ItemNumber by the offset delta
    int pointer = FloodFillList.Length - 1;
    bool found = false;
    displaylist ReturnValue;

    ReturnValue.ItemNumber = -1;
    ReturnValue.DisplayType = TDisplayFloodFill;
    ReturnValue.Area.Top = 0;
    ReturnValue.Area.Left = 0;
    ReturnValue.Area.Right = 0;
    ReturnValue.Area.Bottom = 0;
    ReturnValue.UndoName = "Not Allocated";
    ReturnValue.selected = false;
    ReturnValue.visible = true;

    while (!found && pointer > -1) {
        if (FloodFillList[pointer].ItemNumber == ItemNumber) {
            found = true;
            pointer++;
            }
        pointer--;
        }

    if (found) {
        //have found the FloodFill to be copied. It is not regenerated at this point
        ReturnValue.ItemNumber = DisplayItemNumber;

        int arrayentry = FloodFillList.Length;
        FloodFillList.Length++;
        FloodFillList[arrayentry].ItemNumber = DisplayItemNumber;
        FloodFillList[arrayentry].Colour = FloodFillList[pointer].Colour;
        FloodFillList[arrayentry].FilledColour = FloodFillList[pointer].FilledColour;
        FloodFillList[arrayentry].StartPoint.x = FloodFillList[pointer].StartPoint.x + delta.x;
        FloodFillList[arrayentry].StartPoint.y = FloodFillList[pointer].StartPoint.y + delta.y;
        FloodFillList[arrayentry].Points.Length = FloodFillList[pointer].Points.Length;
        for (int i = 0; i < FloodFillList[arrayentry].Points.Length; i++) {
            FloodFillList[arrayentry].Points[i].x = FloodFillList[pointer].Points[i].x + delta.x;
            FloodFillList[arrayentry].Points[i].y = FloodFillList[pointer].Points[i].y + delta.y;
            }

        ReturnValue.Area.Left = FloodFillList[arrayentry].Points[0].x;
        ReturnValue.Area.Top = FloodFillList[arrayentry].Points[0].y;
        ReturnValue.Area.Right = FloodFillList[arrayentry].Points[0].x;
        ReturnValue.Area.Bottom = FloodFillList[arrayentry].Points[0].y;
        for (int i = 1; i < FloodFillList[arrayentry].Points.Length; i++) {
            if (FloodFillList[arrayentry].Points[i].x < ReturnValue.Area.Left) ReturnValue.Area.Left = FloodFillList[arrayentry].Points[i].x;
            if (FloodFillList[arrayentry].Points[i].y < ReturnValue.Area.Top) ReturnValue.Area.Top = FloodFillList[arrayentry].Points[i].y;
            if (FloodFillList[arrayentry].Points[i].x > ReturnValue.Area.Right) ReturnValue.Area.Right = FloodFillList[arrayentry].Points[i].x;
            if (FloodFillList[arrayentry].Points[i].y > ReturnValue.Area.Bottom) ReturnValue.Area.Bottom = FloodFillList[arrayentry].Points[i].y;
            }
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Copy Flood Fill X" + AnsiString(delta.x) + " Y" + AnsiString(delta.y));
            AddUndo("Delete," + AnsiString(DisplayItemNumber) + ",");
            }
        DisplayItemNumber++;
        }

    return ReturnValue;
}
//---------------------------------------------------------------------------

displaylist __fastcall TImageEditorForm::CopyText(TPoint delta, int ItemNumber)
{
    //copies the Text indicated by ItemNumber by the offset delta
    int pointer = TextList.Length - 1;
    bool found = false;
    displaylist ReturnValue;

    ReturnValue.ItemNumber = -1;
    ReturnValue.DisplayType = TDisplayText;
    ReturnValue.Area.Top = 0;
    ReturnValue.Area.Left = 0;
    ReturnValue.Area.Right = 0;
    ReturnValue.Area.Bottom = 0;
    ReturnValue.UndoName = "Not Allocated";
    ReturnValue.selected = false;
    ReturnValue.visible = true;

    while (!found && pointer > -1) {
        if (TextList[pointer].ItemNumber == ItemNumber) {
            found = true;
            pointer++;
            }
        pointer--;
        }

    if (found) {
        //have found the Text to be copied.
        ReturnValue.ItemNumber = DisplayItemNumber;

        int arrayentry = TextList.Length;
        TextList.Length++;
        TextList[arrayentry].ItemNumber = DisplayItemNumber;
        TextList[arrayentry].Text = TextList[pointer].Text;
        TextList[arrayentry].Height = TextList[pointer].Height;
        TextList[arrayentry].Bold = TextList[pointer].Bold;
        TextList[arrayentry].Italic = TextList[pointer].Italic;
        TextList[arrayentry].Underlined = TextList[pointer].Underlined;
        TextList[arrayentry].Strikeout = TextList[pointer].Strikeout;
        TextList[arrayentry].Colour = TextList[pointer].Colour;
        TextList[arrayentry].StartPoint.x = TextList[pointer].StartPoint.x + delta.x;
        TextList[arrayentry].StartPoint.y = TextList[pointer].StartPoint.y + delta.y;
        TextList[arrayentry].Points.Length = TextList[pointer].Points.Length;
        /*
        for (int i = 0; i < TextList[arrayentry].Points.Length; i++) {
            TextList[arrayentry].Points[i].x = TextList[pointer].Points[i].x + delta.x;
            TextList[arrayentry].Points[i].y = TextList[pointer].Points[i].y + delta.y;
            }
        */
        FillPointsText(arrayentry,TextList[arrayentry].ItemNumber);

        ReturnValue.Area.Left = TextList[arrayentry].Points[0].x;
        ReturnValue.Area.Top = TextList[arrayentry].Points[0].y;
        ReturnValue.Area.Right = TextList[arrayentry].Points[0].x;
        ReturnValue.Area.Bottom = TextList[arrayentry].Points[0].y;
        for (int i = 1; i < TextList[arrayentry].Points.Length; i++) {
            if (TextList[arrayentry].Points[i].x < ReturnValue.Area.Left) ReturnValue.Area.Left = TextList[arrayentry].Points[i].x;
            if (TextList[arrayentry].Points[i].y < ReturnValue.Area.Top) ReturnValue.Area.Top = TextList[arrayentry].Points[i].y;
            if (TextList[arrayentry].Points[i].x > ReturnValue.Area.Right) ReturnValue.Area.Right = TextList[arrayentry].Points[i].x;
            if (TextList[arrayentry].Points[i].y > ReturnValue.Area.Bottom) ReturnValue.Area.Bottom = TextList[arrayentry].Points[i].y;
            }
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Copy Text Object X" + AnsiString(delta.x) + " Y" + AnsiString(delta.y));
            AddUndo("Delete," + AnsiString(DisplayItemNumber) + ",");
            }
        DisplayItemNumber++;
        }

    return ReturnValue;
}
//---------------------------------------------------------------------------

displaylist __fastcall TImageEditorForm::CopyRectangle(TPoint delta, int ItemNumber)
{
    //copies the Rectangle indicated by ItemNumber by the offset delta
    int pointer = RectangleList.Length - 1;
    bool found = false;
    displaylist ReturnValue;

    ReturnValue.ItemNumber = -1;
    ReturnValue.DisplayType = TDisplayRectangle;
    ReturnValue.Area.Top = 0;
    ReturnValue.Area.Left = 0;
    ReturnValue.Area.Right = 0;
    ReturnValue.Area.Bottom = 0;
    ReturnValue.UndoName = "Not Allocated";
    ReturnValue.selected = false;
    ReturnValue.visible = true;

    while (!found && pointer > -1) {
        if (RectangleList[pointer].ItemNumber == ItemNumber) {
            found = true;
            pointer++;
            }
        pointer--;
        }

    if (found) {
        //have found the Rectangle to be copied.
        ReturnValue.ItemNumber = DisplayItemNumber;

        int arrayentry = RectangleList.Length;
        RectangleList.Length++;
        RectangleList[arrayentry].ItemNumber = DisplayItemNumber;
        RectangleList[arrayentry].PenColour = RectangleList[pointer].PenColour;
        RectangleList[arrayentry].BrushColour = RectangleList[pointer].BrushColour;
        RectangleList[arrayentry].LineWidth = RectangleList[pointer].LineWidth;
        RectangleList[arrayentry].Area.Left = RectangleList[pointer].Area.Left + delta.x;
        RectangleList[arrayentry].Area.Top = RectangleList[pointer].Area.Top + delta.y;
        RectangleList[arrayentry].Area.Right = RectangleList[pointer].Area.Right + delta.x;
        RectangleList[arrayentry].Area.Bottom = RectangleList[pointer].Area.Bottom + delta.y;
        RectangleList[arrayentry].Shape = RectangleList[pointer].Shape;
        RectangleList[arrayentry].Angle = RectangleList[pointer].Angle;
        RectangleList[arrayentry].Filled = RectangleList[pointer].Filled;
        RectangleList[arrayentry].Points.Length = RectangleList[pointer].Points.Length;
        /*
        for (int i = 0; i < RectangleList[arrayentry].Points.Length; i++) {
            RectangleList[arrayentry].Points[i].x = RectangleList[pointer].Points[i].x + delta.x;
            RectangleList[arrayentry].Points[i].y = RectangleList[pointer].Points[i].y + delta.y;
            RectangleList[arrayentry].Points[i].Colour = RectangleList[pointer].Points[i].Colour;
            }
        */
        FillPointsRectangle(arrayentry,RectangleList[arrayentry].ItemNumber);

        ReturnValue.Area = RectangleList[arrayentry].Area;
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Copy Rectangle X" + AnsiString(delta.x) + " Y" + AnsiString(delta.y));
            AddUndo("Delete," + AnsiString(DisplayItemNumber) + ",");
            }
        DisplayItemNumber++;
        }

    return ReturnValue;
}
//---------------------------------------------------------------------------

displaylist __fastcall TImageEditorForm::CopyCircle(TPoint delta, int ItemNumber)
{
    //copies the Circle indicated by ItemNumber by the offset delta
    int pointer = CircleList.Length - 1;
    bool found = false;
    displaylist ReturnValue;

    ReturnValue.ItemNumber = -1;
    ReturnValue.DisplayType = TDisplayCircle;
    ReturnValue.Area.Top = 0;
    ReturnValue.Area.Left = 0;
    ReturnValue.Area.Right = 0;
    ReturnValue.Area.Bottom = 0;
    ReturnValue.UndoName = "Not Allocated";
    ReturnValue.selected = false;
    ReturnValue.visible = true;

    while (!found && pointer > -1) {
        if (CircleList[pointer].ItemNumber == ItemNumber) {
            found = true;
            pointer++;
            }
        pointer--;
        }

    if (found) {
        //have found the Circle to be copied.
        ReturnValue.ItemNumber = DisplayItemNumber;

        int arrayentry = CircleList.Length;
        CircleList.Length++;
        CircleList[arrayentry].ItemNumber = DisplayItemNumber;
        CircleList[arrayentry].PenColour = CircleList[pointer].PenColour;
        CircleList[arrayentry].BrushColour = CircleList[pointer].BrushColour;
        CircleList[arrayentry].LineWidth = CircleList[pointer].LineWidth;
        CircleList[arrayentry].Area.Left = CircleList[pointer].Area.Left + delta.x;
        CircleList[arrayentry].Area.Top = CircleList[pointer].Area.Top + delta.y;
        CircleList[arrayentry].Area.Right = CircleList[pointer].Area.Right + delta.x;
        CircleList[arrayentry].Area.Bottom = CircleList[pointer].Area.Bottom + delta.y;
        CircleList[arrayentry].Shape = CircleList[pointer].Shape;
        CircleList[arrayentry].Angle = CircleList[pointer].Angle;
        CircleList[arrayentry].Filled = CircleList[pointer].Filled;
        CircleList[arrayentry].Points.Length = CircleList[pointer].Points.Length;
        /*
        for (int i = 0; i < CircleList[arrayentry].Points.Length; i++) {
            CircleList[arrayentry].Points[i].x = CircleList[pointer].Points[i].x + delta.x;
            CircleList[arrayentry].Points[i].y = CircleList[pointer].Points[i].y + delta.y;
            CircleList[arrayentry].Points[i].Colour = CircleList[pointer].Points[i].Colour;
            }
        */
        FillPointsRectangle(arrayentry,RectangleList[arrayentry].ItemNumber);

        ReturnValue.Area = CircleList[arrayentry].Area;
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Copy Circle X" + AnsiString(delta.x) + " Y" + AnsiString(delta.y));
            AddUndo("Delete," + AnsiString(DisplayItemNumber) + ",");
            }
        DisplayItemNumber++;
        }

    return ReturnValue;
}
//---------------------------------------------------------------------------

displaylist __fastcall TImageEditorForm::CopyFreeForm(TPoint delta, int ItemNumber)
{
    //copies the FreeForm indicated by ItemNumber by the offset delta
    int pointer = FreeFormList.Length - 1;
    bool found = false;
    displaylist ReturnValue;

    ReturnValue.ItemNumber = -1;
    ReturnValue.DisplayType = TDisplayFreeForm;
    ReturnValue.Area.Top = 0;
    ReturnValue.Area.Left = 0;
    ReturnValue.Area.Right = 0;
    ReturnValue.Area.Bottom = 0;
    ReturnValue.UndoName = "Not Allocated";
    ReturnValue.selected = false;
    ReturnValue.visible = true;

    while (!found && pointer > -1) {
        if (FreeFormList[pointer].ItemNumber == ItemNumber) {
            found = true;
            pointer++;
            }
        pointer--;
        }

    if (found) {
        //have found the FreeForm to be copied
        ReturnValue.ItemNumber = DisplayItemNumber;

        int arrayentry = FreeFormList.Length;
        FreeFormList.Length++;
        FreeFormList[arrayentry].ItemNumber = DisplayItemNumber;
        FreeFormList[arrayentry].PenColour = FreeFormList[pointer].PenColour;
        FreeFormList[arrayentry].BrushColour = FreeFormList[pointer].BrushColour;
        FreeFormList[arrayentry].LineWidth = FreeFormList[pointer].LineWidth;
        FreeFormList[arrayentry].closed = FreeFormList[pointer].closed;
        FreeFormList[arrayentry].filled = FreeFormList[pointer].filled;
        FreeFormList[arrayentry].Corners.Length = FreeFormList[pointer].Corners.Length;
        for (int i = 0; i < FreeFormList[arrayentry].Corners.Length; i++) {
            FreeFormList[arrayentry].Corners[i].x = FreeFormList[pointer].Corners[i].x + delta.x;
            FreeFormList[arrayentry].Corners[i].y = FreeFormList[pointer].Corners[i].y + delta.y;
            }
        FillPointsFreeForm(arrayentry,FreeFormList[arrayentry].ItemNumber);
        ReturnValue.Area.Left = FreeFormList[arrayentry].Points[0].x;
        ReturnValue.Area.Top = FreeFormList[arrayentry].Points[0].y;
        ReturnValue.Area.Right = FreeFormList[arrayentry].Points[0].x;
        ReturnValue.Area.Bottom = FreeFormList[arrayentry].Points[0].y;
        for (int i = 1; i < FreeFormList[arrayentry].Points.Length; i++) {
            if (FreeFormList[arrayentry].Points[i].x < ReturnValue.Area.Left) ReturnValue.Area.Left = FreeFormList[arrayentry].Points[i].x;
            if (FreeFormList[arrayentry].Points[i].y < ReturnValue.Area.Top) ReturnValue.Area.Top = FreeFormList[arrayentry].Points[i].y;
            if (FreeFormList[arrayentry].Points[i].x > ReturnValue.Area.Right) ReturnValue.Area.Right = FreeFormList[arrayentry].Points[i].x;
            if (FreeFormList[arrayentry].Points[i].y > ReturnValue.Area.Bottom) ReturnValue.Area.Bottom = FreeFormList[arrayentry].Points[i].y;
            }
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Copy Free-Form Shape X" + AnsiString(delta.x) + " Y" + AnsiString(delta.y));
            AddUndo("Delete," + AnsiString(DisplayItemNumber) + ",");
            }
        DisplayItemNumber++;
        }

    return ReturnValue;
}
//---------------------------------------------------------------------------

displaylist __fastcall TImageEditorForm::CopyErase(TPoint delta, int ItemNumber)
{
    //copies the Erase item indicated by ItemNumber by the offset delta
    int pointer = EraseList.Length - 1;
    bool found = false;
    displaylist ReturnValue;

    ReturnValue.ItemNumber = -1;
    ReturnValue.DisplayType = TDisplayEraseItem;
    ReturnValue.Area.Top = 0;
    ReturnValue.Area.Left = 0;
    ReturnValue.Area.Right = 0;
    ReturnValue.Area.Bottom = 0;
    ReturnValue.UndoName = "Not Allocated";
    ReturnValue.selected = false;
    ReturnValue.visible = true;

    while (!found && pointer > -1) {
        if (EraseList[pointer].ItemNumber == ItemNumber) {
            found = true;
            pointer++;
            }
        pointer--;
        }

    if (found) {
        //have found the point to be copied. It is updated now.
        ReturnValue.ItemNumber = DisplayItemNumber;

        int arrayentry = EraseList.Length;
        EraseList.Length++;
        EraseList[arrayentry].ItemNumber = DisplayItemNumber;
        EraseList[arrayentry].Points.Length = EraseList[pointer].Points.Length;
        for (int i = 0; i < EraseList[arrayentry].Points.Length; i++) {
            EraseList[arrayentry].Points[i].x = EraseList[pointer].Points[i].x + delta.x;
            EraseList[arrayentry].Points[i].y = EraseList[pointer].Points[i].y + delta.y;
            if (EraseList[arrayentry].Points[i].x > -1 && EraseList[arrayentry].Points[i].x < Picture->Width && EraseList[arrayentry].Points[i].y > -1 && EraseList[arrayentry].Points[i].y < Picture->Height) {
                EraseList[arrayentry].Points[i].Colour = Picture->Canvas->Pixels[EraseList[arrayentry].Points[i].x][EraseList[arrayentry].Points[i].y];
                } else {
                EraseList[arrayentry].Points[i].Colour = clWhite;
                }
            }

        ReturnValue.Area.Left = EraseList[arrayentry].Points[0].x;
        ReturnValue.Area.Top = EraseList[arrayentry].Points[0].y;
        ReturnValue.Area.Right = EraseList[arrayentry].Points[0].x;
        ReturnValue.Area.Bottom = EraseList[arrayentry].Points[0].y;
        for (int i = 1; i < EraseList[arrayentry].Points.Length; i++) {
            if (EraseList[arrayentry].Points[i].x < ReturnValue.Area.Left) ReturnValue.Area.Left = EraseList[arrayentry].Points[i].x;
            if (EraseList[arrayentry].Points[i].y < ReturnValue.Area.Top) ReturnValue.Area.Top = EraseList[arrayentry].Points[i].y;
            if (EraseList[arrayentry].Points[i].x > ReturnValue.Area.Right) ReturnValue.Area.Right = EraseList[arrayentry].Points[i].x;
            if (EraseList[arrayentry].Points[i].y > ReturnValue.Area.Bottom) ReturnValue.Area.Bottom = EraseList[arrayentry].Points[i].y;
            }
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Copy Erase Object X" + AnsiString(delta.x) + " Y" + AnsiString(delta.y));
            AddUndo("Delete," + AnsiString(DisplayItemNumber) + ",");
            }
        DisplayItemNumber++;
        }

    return ReturnValue;
}
//---------------------------------------------------------------------------

displaylist __fastcall TImageEditorForm::CopyBlock(TPoint delta, int ItemNumber)
{
    //copies the Block indicated by ItemNumber by the offset delta
    int pointer = BlockList.Length - 1;
    bool found = false;
    displaylist ReturnValue;

    ReturnValue.ItemNumber = -1;
    ReturnValue.DisplayType = TDisplayBlock;
    ReturnValue.Area.Top = 0;
    ReturnValue.Area.Left = 0;
    ReturnValue.Area.Right = 0;
    ReturnValue.Area.Bottom = 0;
    ReturnValue.UndoName = "Not Allocated";
    ReturnValue.selected = false;
    ReturnValue.visible = true;

    while (!found && pointer > -1) {
        if (BlockList[pointer].ItemNumber == ItemNumber) {
            found = true;
            pointer++;
            }
        pointer--;
        }

    if (found) {
        //have found the Block to be copied. It will be linked to the block being copied unless that one has a linkage to another block. This keeps the linkage 1 deep.
        ReturnValue.ItemNumber = DisplayItemNumber;

        int arrayentry = BlockList.Length;
        BlockList.Length++;
        BlockList[arrayentry].ItemNumber = DisplayItemNumber;
        BlockList[arrayentry].Area.Left = BlockList[pointer].Area.Left + delta.x;
        BlockList[arrayentry].Area.Top = BlockList[pointer].Area.Top + delta.y;
        BlockList[arrayentry].Area.Right = BlockList[pointer].Area.Right + delta.x;
        BlockList[arrayentry].Area.Bottom = BlockList[pointer].Area.Bottom + delta.y;
        BlockList[arrayentry].Linked = true;
        if (BlockList[pointer].Linked) {
            BlockList[arrayentry].LinkedBlock = BlockList[pointer].LinkedBlock;
            } else {
            BlockList[arrayentry].LinkedBlock = BlockList[pointer].ItemNumber;
            }
        BlockList[arrayentry].RotationCentre.x = BlockList[pointer].RotationCentre.x + delta.x;
        BlockList[arrayentry].RotationCentre.y = BlockList[pointer].RotationCentre.y + delta.y;
        BlockList[arrayentry].Angle = BlockList[pointer].Angle;
        BlockList[arrayentry].MirrorCentre.x = BlockList[pointer].MirrorCentre.x + delta.x;
        BlockList[arrayentry].MirrorCentre.y = BlockList[pointer].MirrorCentre.y + delta.y;
        BlockList[arrayentry].Axis = BlockList[pointer].Axis;
        //BlockList[arrayentry].delta.x = BlockList[pointer].delta.x + delta.x;
        //BlockList[arrayentry].delta.y = BlockList[pointer].delta.y + delta.y;
        BlockList[arrayentry].delta.x = BlockList[pointer].delta.x;
        BlockList[arrayentry].delta.y = BlockList[pointer].delta.y;
        BlockList[arrayentry].Points.Length = BlockList[pointer].Points.Length;
        for (int i = 0; i < BlockList[arrayentry].Points.Length; i++) {
            BlockList[arrayentry].Points[i].x = BlockList[pointer].Points[i].x + delta.x;
            BlockList[arrayentry].Points[i].y = BlockList[pointer].Points[i].y + delta.y;
            BlockList[arrayentry].Points[i].originalx = BlockList[pointer].Points[i].originalx + delta.x;
            BlockList[arrayentry].Points[i].originaly = BlockList[pointer].Points[i].originaly + delta.y;
            BlockList[arrayentry].Points[i].Colour = BlockList[pointer].Points[i].Colour;
            BlockList[arrayentry].Points[i].transparent = BlockList[pointer].Points[i].transparent;
            }

        ReturnValue.Area = BlockList[arrayentry].Area;
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Copy Block X" + AnsiString(delta.x) + " Y" + AnsiString(delta.y));
            AddUndo("Delete," + AnsiString(DisplayItemNumber) + ",");
            }
        DisplayItemNumber++;
        }

    return ReturnValue;
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::MovePoint(TPoint delta, int ItemNumber)
{
    //moves the Point indicated by ItemNumber by the offset delta
    int pointer = XRefs[ItemNumber].EntityXRef;
    bool found = false;

    if (XRefs[ItemNumber].DisplayType == TDisplayPoint && pointer > -1 && pointer < PointList.Length && PointList[pointer].ItemNumber== ItemNumber) found = true;

    if (found) {
        //have found the Point to be moved.
        for (int i = 0; i < PointList[pointer].Points.Length; i++) {
            PointList[pointer].Points[i].x = PointList[pointer].Points[i].x + delta.x;
            PointList[pointer].Points[i].y = PointList[pointer].Points[i].y + delta.y;
            }
        pointer = XRefs[ItemNumber].DisplayXRef;
        if (pointer > -1 && pointer < DisplayList.Length && DisplayList[pointer].ItemNumber == ItemNumber && DisplayList[pointer].DisplayType == TDisplayPoint) {
            DisplayList[pointer].Area.Left = DisplayList[pointer].Area.Left + delta.x;
            DisplayList[pointer].Area.Top = DisplayList[pointer].Area.Top + delta.y;
            DisplayList[pointer].Area.Right = DisplayList[pointer].Area.Right + delta.x;
            DisplayList[pointer].Area.Bottom = DisplayList[pointer].Area.Bottom + delta.y;
            }
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Move Point X" + AnsiString(delta.x) + " Y" + AnsiString(delta.y));
            AddUndo("Move," + AnsiString(ItemNumber) + "," + AnsiString(-1 * delta.x) + "," + AnsiString(-1 * delta.y) + ",");
            }
        }


}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::MoveLine(TPoint delta, int ItemNumber)
{
    //moves the Line indicated by ItemNumber by the offset delta
    int pointer = XRefs[ItemNumber].EntityXRef;
    bool found = false;

    if (XRefs[ItemNumber].DisplayType == TDisplayLine && pointer > -1 && pointer < LineList.Length && LineList[pointer].ItemNumber== ItemNumber) found = true;

    if (found) {
        //have found the Line to be moved. 
        LineList[pointer].StartPoint.x = LineList[pointer].StartPoint.x + delta.x;
        LineList[pointer].StartPoint.y = LineList[pointer].StartPoint.y + delta.y;
        LineList[pointer].EndPoint.x = LineList[pointer].EndPoint.x + delta.x;
        LineList[pointer].EndPoint.y = LineList[pointer].EndPoint.y + delta.y;
        /*
        for (int i = 0; i < LineList[pointer].Points.Length; i++) {
            LineList[pointer].Points[i].x = LineList[pointer].Points[i].x + delta.x;
            LineList[pointer].Points[i].y = LineList[pointer].Points[i].y + delta.y;
            }
        */
        FillPointsLine(pointer,ItemNumber);
        /*
        pointer = XRefs[ItemNumber].DisplayXRef;
        if (pointer > -1 && pointer < DisplayList.Length && DisplayList[pointer].ItemNumber == ItemNumber && DisplayList[pointer].DisplayType == TDisplayLine) {
            DisplayList[pointer].Area.Left = DisplayList[pointer].Area.Left + delta.x;
            DisplayList[pointer].Area.Top = DisplayList[pointer].Area.Top + delta.y;
            DisplayList[pointer].Area.Right = DisplayList[pointer].Area.Right + delta.x;
            DisplayList[pointer].Area.Bottom = DisplayList[pointer].Area.Bottom + delta.y;
            }
        */
        DisplayListAreaUpdate(ItemNumber);
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Move Line X" + AnsiString(delta.x) + " Y" + AnsiString(delta.y));
            AddUndo("Move," + AnsiString(ItemNumber) + "," + AnsiString(-1 * delta.x) + "," + AnsiString(-1 * delta.y) + ",");
            }
        }


}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::MovePolyLine(TPoint delta, int ItemNumber)
{
    //moves the PolyLine indicated by ItemNumber by the offset delta
    int pointer = XRefs[ItemNumber].EntityXRef;
    bool found = false;

    if (XRefs[ItemNumber].DisplayType == TDisplayPolyLine && pointer > -1 && pointer < PolyLineList.Length && PolyLineList[pointer].ItemNumber== ItemNumber) found = true;

    if (found) {
        //have found the PolyLine to be moved.
        for (int i = 0; i < PolyLineList[pointer].Corners.Length; i++) {
            PolyLineList[pointer].Corners[i].x = PolyLineList[pointer].Corners[i].x + delta.x;
            PolyLineList[pointer].Corners[i].y = PolyLineList[pointer].Corners[i].y + delta.y;
            }
        FillPointsPolyLine(pointer,ItemNumber);
        DisplayListAreaUpdate(ItemNumber);
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Move Polyline X" + AnsiString(delta.x) + " Y" + AnsiString(delta.y));
            AddUndo("Move," + AnsiString(ItemNumber) + "," + AnsiString(-1 * delta.x) + "," + AnsiString(-1 * delta.y) + ",");
            }
        }


}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::MoveFloodFill(TPoint delta, int ItemNumber)
{
    //moves the FloodFill indicated by ItemNumber by the offset delta
    int pointer = XRefs[ItemNumber].EntityXRef;
    bool found = false;

    if (XRefs[ItemNumber].DisplayType == TDisplayFloodFill && pointer > -1 && pointer < FloodFillList.Length && FloodFillList[pointer].ItemNumber== ItemNumber) found = true;

    if (found) {
        //have found the FloodFill to be moved.
        FloodFillList[pointer].StartPoint.x = FloodFillList[pointer].StartPoint.x + delta.x;
        FloodFillList[pointer].StartPoint.y = FloodFillList[pointer].StartPoint.y + delta.y;
        for (int i = 0; i < FloodFillList[pointer].Points.Length; i++) {
            FloodFillList[pointer].Points[i].x = FloodFillList[pointer].Points[i].x + delta.x;
            FloodFillList[pointer].Points[i].y = FloodFillList[pointer].Points[i].y + delta.y;
            }
        pointer = XRefs[ItemNumber].DisplayXRef;
        if (pointer > -1 && pointer < DisplayList.Length && DisplayList[pointer].ItemNumber == ItemNumber && DisplayList[pointer].DisplayType == TDisplayFloodFill) {
            DisplayList[pointer].Area.Left = DisplayList[pointer].Area.Left + delta.x;
            DisplayList[pointer].Area.Top = DisplayList[pointer].Area.Top + delta.y;
            DisplayList[pointer].Area.Right = DisplayList[pointer].Area.Right + delta.x;
            DisplayList[pointer].Area.Bottom = DisplayList[pointer].Area.Bottom + delta.y;
            }
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Move FloodFill X" + AnsiString(delta.x) + " Y" + AnsiString(delta.y));
            AddUndo("Move," + AnsiString(ItemNumber) + "," + AnsiString(-1 * delta.x) + "," + AnsiString(-1 * delta.y) + ",");
            }
        }


}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::MoveText(TPoint delta, int ItemNumber)
{
    //moves the Text indicated by ItemNumber by the offset delta
    int pointer = XRefs[ItemNumber].EntityXRef;
    bool found = false;

    if (XRefs[ItemNumber].DisplayType == TDisplayText && pointer > -1 && pointer < TextList.Length && TextList[pointer].ItemNumber== ItemNumber) found = true;

    if (found) {
        //have found the Text to be moved.
        TextList[pointer].StartPoint.x = TextList[pointer].StartPoint.x + delta.x;
        TextList[pointer].StartPoint.y = TextList[pointer].StartPoint.y + delta.y;
        /*for (int i = 0; i < TextList[pointer].Points.Length; i++) {
            TextList[pointer].Points[i].x = TextList[pointer].Points[i].x + delta.x;
            TextList[pointer].Points[i].y = TextList[pointer].Points[i].y + delta.y;
            }*/
        FillPointsText(pointer,ItemNumber);
        /*
        pointer = XRefs[ItemNumber].DisplayXRef;
        if (pointer > -1 && pointer < DisplayList.Length && DisplayList[pointer].ItemNumber == ItemNumber && DisplayList[pointer].DisplayType == TDisplayText) {
            DisplayList[pointer].Area.Left = DisplayList[pointer].Area.Left + delta.x;
            DisplayList[pointer].Area.Top = DisplayList[pointer].Area.Top + delta.y;
            DisplayList[pointer].Area.Right = DisplayList[pointer].Area.Right + delta.x;
            DisplayList[pointer].Area.Bottom = DisplayList[pointer].Area.Bottom + delta.y;
            }
        */
        DisplayListAreaUpdate(ItemNumber);
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Move Text X" + AnsiString(delta.x) + " Y" + AnsiString(delta.y));
            AddUndo("Move," + AnsiString(ItemNumber) + "," + AnsiString(-1 * delta.x) + "," + AnsiString(-1 * delta.y) + ",");
            }
        }


}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::MoveRectangle(TPoint delta, int ItemNumber)
{
    //moves the Rectangle indicated by ItemNumber by the offset delta
    int pointer = XRefs[ItemNumber].EntityXRef;
    bool found = false;

    if (XRefs[ItemNumber].DisplayType == TDisplayRectangle && pointer > -1 && pointer < RectangleList.Length && RectangleList[pointer].ItemNumber== ItemNumber) found = true;

    if (found) {
        //have found the Rectangle to be moved.
        RectangleList[pointer].Area.Left = RectangleList[pointer].Area.Left + delta.x;
        RectangleList[pointer].Area.Top = RectangleList[pointer].Area.Top + delta.y;
        RectangleList[pointer].Area.Right = RectangleList[pointer].Area.Right + delta.x;
        RectangleList[pointer].Area.Bottom = RectangleList[pointer].Area.Bottom + delta.y;
        /*
        for (int i = 0; i < RectangleList[pointer].Points.Length; i++) {
            RectangleList[pointer].Points[i].x = RectangleList[pointer].Points[i].x + delta.x;
            RectangleList[pointer].Points[i].y = RectangleList[pointer].Points[i].y + delta.y;
            }
        */
        FillPointsRectangle(pointer,ItemNumber);
        /*
        pointer = XRefs[ItemNumber].DisplayXRef;
        if (pointer > -1 && pointer < DisplayList.Length && DisplayList[pointer].ItemNumber == ItemNumber && DisplayList[pointer].DisplayType == TDisplayRectangle) {
            DisplayList[pointer].Area.Left = DisplayList[pointer].Area.Left + delta.x;
            DisplayList[pointer].Area.Top = DisplayList[pointer].Area.Top + delta.y;
            DisplayList[pointer].Area.Right = DisplayList[pointer].Area.Right + delta.x;
            DisplayList[pointer].Area.Bottom = DisplayList[pointer].Area.Bottom + delta.y;
            }
        */
        DisplayListAreaUpdate(ItemNumber);
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Move Rectangle X" + AnsiString(delta.x) + " Y" + AnsiString(delta.y));
            AddUndo("Move," + AnsiString(ItemNumber) + "," + AnsiString(-1 * delta.x) + "," + AnsiString(-1 * delta.y) + ",");
            }
        }


}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::MoveCircle(TPoint delta, int ItemNumber)
{
    //moves the Circle indicated by ItemNumber by the offset delta
    int pointer = XRefs[ItemNumber].EntityXRef;
    bool found = false;

    if (XRefs[ItemNumber].DisplayType == TDisplayCircle && pointer > -1 && pointer < CircleList.Length && CircleList[pointer].ItemNumber== ItemNumber) found = true;

    if (found) {
        //have found the Circle to be moved.
        CircleList[pointer].Area.Left = CircleList[pointer].Area.Left + delta.x;
        CircleList[pointer].Area.Top = CircleList[pointer].Area.Top + delta.y;
        CircleList[pointer].Area.Right = CircleList[pointer].Area.Right + delta.x;
        CircleList[pointer].Area.Bottom = CircleList[pointer].Area.Bottom + delta.y;
        /*
        for (int i = 0; i < CircleList[pointer].Points.Length; i++) {
            CircleList[pointer].Points[i].x = CircleList[pointer].Points[i].x + delta.x;
            CircleList[pointer].Points[i].y = CircleList[pointer].Points[i].y + delta.y;
            }
        */
        FillPointsCircle(pointer,ItemNumber);
        /*
        pointer = XRefs[ItemNumber].DisplayXRef;
        if (pointer > -1 && pointer < DisplayList.Length && DisplayList[pointer].ItemNumber == ItemNumber && DisplayList[pointer].DisplayType == TDisplayCircle) {
            DisplayList[pointer].Area.Left = DisplayList[pointer].Area.Left + delta.x;
            DisplayList[pointer].Area.Top = DisplayList[pointer].Area.Top + delta.y;
            DisplayList[pointer].Area.Right = DisplayList[pointer].Area.Right + delta.x;
            DisplayList[pointer].Area.Bottom = DisplayList[pointer].Area.Bottom + delta.y;
            }
        */
        DisplayListAreaUpdate(ItemNumber);
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Move Ellipse/Circle X" + AnsiString(delta.x) + " Y" + AnsiString(delta.y));
            AddUndo("Move," + AnsiString(ItemNumber) + "," + AnsiString(-1 * delta.x) + "," + AnsiString(-1 * delta.y) + ",");
            }
        }


}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::MoveFreeForm(TPoint delta, int ItemNumber)
{
    //moves the FreeForm indicated by ItemNumber by the offset delta
    int pointer = XRefs[ItemNumber].EntityXRef;
    bool found = false;

    if (XRefs[ItemNumber].DisplayType == TDisplayFreeForm && pointer > -1 && pointer < FreeFormList.Length && FreeFormList[pointer].ItemNumber== ItemNumber) found = true;

    if (found) {
        //have found the FreeForm to be moved.
        for (int i = 0; i < FreeFormList[pointer].Corners.Length; i++) {
            FreeFormList[pointer].Corners[i].x = FreeFormList[pointer].Corners[i].x + delta.x;
            FreeFormList[pointer].Corners[i].y = FreeFormList[pointer].Corners[i].y + delta.y;
            }
        FillPointsFreeForm(pointer,ItemNumber);
        DisplayListAreaUpdate(ItemNumber);
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Move Free-Form Shape X" + AnsiString(delta.x) + " Y" + AnsiString(delta.y));
            AddUndo("Move," + AnsiString(ItemNumber) + "," + AnsiString(-1 * delta.x) + "," + AnsiString(-1 * delta.y) + ",");
            }
        }


}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::MoveErase(TPoint delta, int ItemNumber)
{
    //moves the Circle indicated by ItemNumber by the offset delta
    int pointer = XRefs[ItemNumber].EntityXRef;
    bool found = false;

    if (XRefs[ItemNumber].DisplayType == TDisplayEraseItem && pointer > -1 && pointer < EraseList.Length && EraseList[pointer].ItemNumber== ItemNumber) found = true;

    if (found) {
        //have found the Erase to be moved.
        for (int i = 0; i < EraseList[pointer].Points.Length; i++) {
            EraseList[pointer].Points[i].x = EraseList[pointer].Points[i].x + delta.x;
            EraseList[pointer].Points[i].y = EraseList[pointer].Points[i].y + delta.y;
            EraseList[pointer].Points[i].Colour = Picture->Canvas->Pixels[EraseList[pointer].Points[i].x][EraseList[pointer].Points[i].y];
            }
        pointer = XRefs[ItemNumber].DisplayXRef;
        if (pointer > -1 && pointer < DisplayList.Length && DisplayList[pointer].ItemNumber == ItemNumber && DisplayList[pointer].DisplayType == TDisplayEraseItem) {
            DisplayList[pointer].Area.Left = DisplayList[pointer].Area.Left + delta.x;
            DisplayList[pointer].Area.Top = DisplayList[pointer].Area.Top + delta.y;
            DisplayList[pointer].Area.Right = DisplayList[pointer].Area.Right + delta.x;
            DisplayList[pointer].Area.Bottom = DisplayList[pointer].Area.Bottom + delta.y;
            }
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Move Erase Object X" + AnsiString(delta.x) + " Y" + AnsiString(delta.y));
            AddUndo("Move," + AnsiString(ItemNumber) + "," + AnsiString(-1 * delta.x) + "," + AnsiString(-1 * delta.y) + ",");
            }
        }


}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::MoveBlock(TPoint delta, int ItemNumber)
{
    //moves the Block indicated by ItemNumber by the offset delta
    int pointer = XRefs[ItemNumber].EntityXRef;
    bool found = false;

    if (XRefs[ItemNumber].DisplayType == TDisplayBlock && pointer > -1 && pointer < BlockList.Length && BlockList[pointer].ItemNumber== ItemNumber) found = true;

    if (found) {
        //have found the Block to be moved.
        BlockList[pointer].Area.Left = BlockList[pointer].Area.Left + delta.x;
        BlockList[pointer].Area.Top = BlockList[pointer].Area.Top + delta.y;
        BlockList[pointer].Area.Right = BlockList[pointer].Area.Right + delta.x;
        BlockList[pointer].Area.Bottom = BlockList[pointer].Area.Bottom + delta.y;
        BlockList[pointer].RotationCentre.x = BlockList[pointer].RotationCentre.x + delta.x;
        BlockList[pointer].RotationCentre.y = BlockList[pointer].RotationCentre.y + delta.y;
        BlockList[pointer].MirrorCentre.x = BlockList[pointer].MirrorCentre.x + delta.x;
        BlockList[pointer].MirrorCentre.y = BlockList[pointer].MirrorCentre.y + delta.y;
        for (int i = 0; i < BlockList[pointer].Points.Length; i++) {
            BlockList[pointer].Points[i].x = BlockList[pointer].Points[i].x + delta.x;
            BlockList[pointer].Points[i].y = BlockList[pointer].Points[i].y + delta.y;
            BlockList[pointer].Points[i].originalx = BlockList[pointer].Points[i].originalx + delta.x;
            BlockList[pointer].Points[i].originaly = BlockList[pointer].Points[i].originaly + delta.y;
            }
        pointer = XRefs[ItemNumber].DisplayXRef;
        if (pointer > -1 && pointer < DisplayList.Length && DisplayList[pointer].ItemNumber == ItemNumber && DisplayList[pointer].DisplayType == TDisplayBlock) {
            DisplayList[pointer].Area.Left = DisplayList[pointer].Area.Left + delta.x;
            DisplayList[pointer].Area.Top = DisplayList[pointer].Area.Top + delta.y;
            DisplayList[pointer].Area.Right = DisplayList[pointer].Area.Right + delta.x;
            DisplayList[pointer].Area.Bottom = DisplayList[pointer].Area.Bottom + delta.y;
            }
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Move Block X" + AnsiString(delta.x) + " Y" + AnsiString(delta.y));
            AddUndo("Move," + AnsiString(ItemNumber) + "," + AnsiString(-1 * delta.x) + "," + AnsiString(-1 * delta.y) + ",");
            }
        }


}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::ResetActionButtons(void)
{
    PixelEditButton->Down = false;
    LineButton->Down = false;
    PolyLineButton->Down = false;
    FloodFillButton->Down = false;
    TextButton->Down = false;
    RectangleButton->Down = false;
    FreeFormButton->Down = false;
    CircleButton->Down = false;
    SelectButton->Down = false;
    EraseButton->Down = false;
    BlockButton->Down = false;


}
//---------------------------------------------------------------------------

int __fastcall TImageEditorForm::CheckNumberofPointsSelected(void)
{
    int count = 0;
    for (int i = 0; i < DisplayList.Length; i++) {
        if (DisplayList[i].selected && DisplayList[i].DisplayType == TDisplayPoint) count++;
        }

    return count;
}
//---------------------------------------------------------------------------

int __fastcall TImageEditorForm::CheckNumberofLinesSelected(void)
{
    int count = 0;
    for (int i = 0; i < DisplayList.Length; i++) {
        if (DisplayList[i].selected && DisplayList[i].DisplayType == TDisplayLine) count++;
        }

    return count;
}
//---------------------------------------------------------------------------

int __fastcall TImageEditorForm::CheckNumberofPolyLinesSelected(void)
{
    int count = 0;
    for (int i = 0; i < DisplayList.Length; i++) {
        if (DisplayList[i].selected && DisplayList[i].DisplayType == TDisplayPolyLine) count++;
        }

    return count;
}
//---------------------------------------------------------------------------

int __fastcall TImageEditorForm::CheckNumberofFloodFillsSelected(void)
{
    int count = 0;
    for (int i = 0; i < DisplayList.Length; i++) {
        if (DisplayList[i].selected && DisplayList[i].DisplayType == TDisplayFloodFill) count++;
        }

    return count;
}
//---------------------------------------------------------------------------

int __fastcall TImageEditorForm::CheckNumberofTextItemsSelected(void)
{
    int count = 0;
    for (int i = 0; i < DisplayList.Length; i++) {
        if (DisplayList[i].selected && DisplayList[i].DisplayType == TDisplayText) count++;
        }

    return count;
}
//---------------------------------------------------------------------------

int __fastcall TImageEditorForm::CheckNumberofRectanglesSelected(void)
{
    int count = 0;
    for (int i = 0; i < DisplayList.Length; i++) {
        if (DisplayList[i].selected && DisplayList[i].DisplayType == TDisplayRectangle) count++;
        }

    return count;
}
//---------------------------------------------------------------------------

int __fastcall TImageEditorForm::CheckNumberofCirclesSelected(void)
{
    int count = 0;
    for (int i = 0; i < DisplayList.Length; i++) {
        if (DisplayList[i].selected && DisplayList[i].DisplayType == TDisplayCircle) count++;
        }

    return count;
}
//---------------------------------------------------------------------------

int __fastcall TImageEditorForm::CheckNumberofFreeFormsSelected(void)
{
    int count = 0;
    for (int i = 0; i < DisplayList.Length; i++) {
        if (DisplayList[i].selected && DisplayList[i].DisplayType == TDisplayFreeForm) count++;
        }

    return count;
}
//---------------------------------------------------------------------------

int __fastcall TImageEditorForm::CheckNumberofEraseItemsSelected(void)
{
    int count = 0;
    for (int i = 0; i < DisplayList.Length; i++) {
        if (DisplayList[i].selected && DisplayList[i].DisplayType == TDisplayEraseItem) count++;
        }

    return count;
}
//---------------------------------------------------------------------------

int __fastcall TImageEditorForm::CheckNumberofBlocksSelected(void)
{
    int count = 0;
    for (int i = 0; i < DisplayList.Length; i++) {
        if (DisplayList[i].selected && DisplayList[i].DisplayType == TDisplayBlock) count++;
        }

    return count;
}
//---------------------------------------------------------------------------

bool __fastcall TImageEditorForm::CheckIfAnyPoints(void)
{
    return (bool)(PointList.Length > 0);
}
//---------------------------------------------------------------------------

bool __fastcall TImageEditorForm::CheckIfAnyLines(void)
{
    return (bool)(LineList.Length > 0);
}
//---------------------------------------------------------------------------

bool __fastcall TImageEditorForm::CheckIfAnyPolyLines(void)
{
    return (bool)(PolyLineList.Length > 0);
}
//---------------------------------------------------------------------------

bool __fastcall TImageEditorForm::CheckIfAnyFloodFills(void)
{
    return (bool)(FloodFillList.Length > 0);
}
//---------------------------------------------------------------------------

bool __fastcall TImageEditorForm::CheckIfAnyRectangles(void)
{
    return (bool)(RectangleList.Length > 0);
}
//---------------------------------------------------------------------------

bool __fastcall TImageEditorForm::CheckIfAnyCircles(void)
{
    return (bool)(CircleList.Length > 0);
}
//---------------------------------------------------------------------------

bool __fastcall TImageEditorForm::CheckIfAnyTextItems(void)
{
    return (bool)(TextList.Length > 0);
}
//---------------------------------------------------------------------------

bool __fastcall TImageEditorForm::CheckIfAnyFreeForms(void)
{
    return (bool)(FreeFormList.Length > 0);
}
//---------------------------------------------------------------------------

bool __fastcall TImageEditorForm::CheckIfAnyEraseItems(void)
{
    return (bool)(EraseList.Length > 0);
}
//---------------------------------------------------------------------------

bool __fastcall TImageEditorForm::CheckIfAnyBlocks(void)
{
    return (bool)(BlockList.Length > 0);
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::RegenerateFloodFill1Click(
      TObject *Sender)
{
    //regenerate the selected flood fill.
    int pointer = 0;
    bool found = false;

    while (!found && pointer < DisplayList.Length) {
        if (DisplayList[pointer].selected && DisplayList[pointer].DisplayType == TDisplayFloodFill) {
            found = true;
            pointer--;
            }
        pointer++;
        }

    if (found) {
        TPoint delta;
        delta.x = 0;
        delta.y = 0;
        if (deselectafteroperation) DisplayList[pointer].selected = false;
        //Now to regenerate the filled area
        Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
        Bitmap->Assign(Picture);
        int oldSquareSize = SquareSize;
        TPoint OldTopLeft = TopLeft;
        SquareSize = 1;
        TopLeft.x = 0;
        TopLeft.y = 0;
        DrawVectors(Bitmap->Canvas,pointer);
        SquareSize = oldSquareSize;
        TopLeft = OldTopLeft;
        found = false;
        int arraypointer = 0;
        while (!found && arraypointer < FloodFillList.Length) {
            if (FloodFillList[arraypointer].ItemNumber == DisplayList[pointer].ItemNumber) {
                found = true;
                arraypointer--;
                }
            arraypointer++;
            }
        if (found) {
            //Undo command
            AddUndoTitle("Regenerate Flood Fill");
            AnsiString text;
            text = "FloodFill,ChangeContents," + AnsiString(FloodFillList[arraypointer].ItemNumber) + ","
                                + AnsiString((int)(FloodFillList[arraypointer].Colour)) + ","
                                + AnsiString((int)(FloodFillList[arraypointer].FilledColour)) + ","
                                + AnsiString(FloodFillList[arraypointer].StartPoint.x) + ","
                                + AnsiString(FloodFillList[arraypointer].StartPoint.y) + ","
                                ;
            for (int j = 0; j < FloodFillList[arraypointer].Points.Length; j++) {
                text = text + AnsiString(FloodFillList[arraypointer].Points[j].x) + "," + AnsiString(FloodFillList[arraypointer].Points[j].y) + ",";
                }
            AddUndo(text);

            TRect Area;
            Area.Left = FloodFillList[arraypointer].StartPoint.x;
            Area.Right = FloodFillList[arraypointer].StartPoint.x;
            Area.Top = FloodFillList[arraypointer].StartPoint.y;
            Area.Bottom = FloodFillList[arraypointer].StartPoint.y;
            FloodFillList[arraypointer].Points.Length = Bitmap->Width * Bitmap->Height + 1;
            FloodFillList[arraypointer].FilledColour = Bitmap->Canvas->Pixels[FloodFillList[arraypointer].StartPoint.x][FloodFillList[arraypointer].StartPoint.y];
            //now to fill in bitmap
            int maxpointer = 0;
            int pointer2 = 0;
            found = true;
            TColor Colour = FloodFillList[arraypointer].Colour;
            TColor FilledColour = FloodFillList[arraypointer].FilledColour;
            FloodFillList[arraypointer].Points[0].x = FloodFillList[arraypointer].StartPoint.x;
            FloodFillList[arraypointer].Points[0].y = FloodFillList[arraypointer].StartPoint.y;
            Bitmap->Canvas->Pixels[FloodFillList[arraypointer].StartPoint.x][FloodFillList[arraypointer].StartPoint.y] = Colour;
            TPoint Point;
            while (found || pointer2 <= maxpointer) {
                found = false;
                Point = FloodFillList[arraypointer].Points[pointer2];
                if (Point.y > 0) {
                    //Top Left pixel
                    if (Point.x > 0 && floodfilldiagonals) {
                        if (Bitmap->Canvas->Pixels[Point.x - 1][Point.y - 1] == FilledColour) {
                            Bitmap->Canvas->Pixels[Point.x - 1][Point.y - 1] = Colour;
                            maxpointer++;
                            found = true;
                            FloodFillList[arraypointer].Points[maxpointer].x = Point.x - 1;
                            FloodFillList[arraypointer].Points[maxpointer].y = Point.y - 1;
                            }
                        }
                    //top middle pixel
                    if (Bitmap->Canvas->Pixels[Point.x][Point.y - 1] == FilledColour) {
                        Bitmap->Canvas->Pixels[Point.x][Point.y - 1] = Colour;
                        maxpointer++;
                        found = true;
                        FloodFillList[arraypointer].Points[maxpointer].x = Point.x;
                        FloodFillList[arraypointer].Points[maxpointer].y = Point.y - 1;
                        }
                    //Top right pixel
                    if (Point.x < Bitmap->Width - 1 && floodfilldiagonals) {
                        if (Bitmap->Canvas->Pixels[Point.x + 1][Point.y - 1] == FilledColour) {
                            Bitmap->Canvas->Pixels[Point.x + 1][Point.y - 1] = Colour;
                            maxpointer++;
                            found = true;
                            FloodFillList[arraypointer].Points[maxpointer].x = Point.x + 1;
                            FloodFillList[arraypointer].Points[maxpointer].y = Point.y - 1;
                            }
                        }
                    } //end of 'if (Point.y > 0)'
                //Middle Left pixel
                if (Point.x > 0) {
                    if (Bitmap->Canvas->Pixels[Point.x - 1][Point.y] == FilledColour) {
                        Bitmap->Canvas->Pixels[Point.x - 1][Point.y] = Colour;
                        maxpointer++;
                        found = true;
                        FloodFillList[arraypointer].Points[maxpointer].x = Point.x - 1;
                        FloodFillList[arraypointer].Points[maxpointer].y = Point.y;
                        }
                    } //end of 'if (Point.x > 0)'
                //Middle Right pixel
                if (Point.x < Bitmap->Width - 1) {
                    if (Bitmap->Canvas->Pixels[Point.x + 1][Point.y] == FilledColour) {
                        Bitmap->Canvas->Pixels[Point.x + 1][Point.y] = Colour;
                        maxpointer++;
                        found = true;
                        FloodFillList[arraypointer].Points[maxpointer].x = Point.x + 1;
                        FloodFillList[arraypointer].Points[maxpointer].y = Point.y;
                        }
                    } //end of 'if (Point.x < Bitmap->Width - 1)'
                if (Point.y < Bitmap->Height - 1) {
                    //Bottom Left pixel
                    if (Point.x > 0 && floodfilldiagonals) {
                        if (Bitmap->Canvas->Pixels[Point.x - 1][Point.y + 1] == FilledColour) {
                            Bitmap->Canvas->Pixels[Point.x - 1][Point.y + 1] = Colour;
                            maxpointer++;
                            found = true;
                            FloodFillList[arraypointer].Points[maxpointer].x = Point.x - 1;
                            FloodFillList[arraypointer].Points[maxpointer].y = Point.y + 1;
                            }
                        }
                    //bottom middle pixel
                    if (Bitmap->Canvas->Pixels[Point.x][Point.y + 1] == FilledColour) {
                        Bitmap->Canvas->Pixels[Point.x][Point.y + 1] = Colour;
                        maxpointer++;
                        found = true;
                        FloodFillList[arraypointer].Points[maxpointer].x = Point.x;
                        FloodFillList[arraypointer].Points[maxpointer].y = Point.y + 1;
                        }
                    //bottom right pixel
                    if (Point.x < Bitmap->Width - 1 && floodfilldiagonals) {
                        if (Bitmap->Canvas->Pixels[Point.x + 1][Point.y + 1] == FilledColour) {
                            Bitmap->Canvas->Pixels[Point.x + 1][Point.y + 1] = Colour;
                            maxpointer++;
                            found = true;
                            FloodFillList[arraypointer].Points[maxpointer].x = Point.x + 1;
                            FloodFillList[arraypointer].Points[maxpointer].y = Point.y + 1;
                            }
                        }
                    } //end of 'if (Point.y < Bitmap->Height - 1)'
                pointer2++;
                } //end of 'while (found)'

            FloodFillList[arraypointer].Points.Length = maxpointer + 1;
            for (int i = 0; i < FloodFillList[arraypointer].Points.Length; i++) {
                if (FloodFillList[arraypointer].Points[i].x < Area.Left) Area.Left = FloodFillList[arraypointer].Points[i].x;
                if (FloodFillList[arraypointer].Points[i].x > Area.Right) Area.Right = FloodFillList[arraypointer].Points[i].x;
                if (FloodFillList[arraypointer].Points[i].y < Area.Top) Area.Top = FloodFillList[arraypointer].Points[i].y;
                if (FloodFillList[arraypointer].Points[i].y > Area.Bottom) Area.Bottom = FloodFillList[arraypointer].Points[i].y;
                }
            DisplayList[pointer].Area = Area;
            } //end of second 'if (found)'
            delete Bitmap;
        } //end of second 'if (found)'
    DrawPicture();
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::FloodFillFillDiagonalstoo1Click(
      TObject *Sender)
{
    floodfilldiagonals = !floodfilldiagonals;
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::PickObjectColourClick(TObject *Sender)
{
    //changes colour for the selected entities
    if (dynamic_cast < TComponent *>(Sender) ) {
        TDisplayType DisplayType = (TDisplayType) (dynamic_cast < TComponent *>(Sender)->Tag);
        TerminateCurrentAction();
        ResetActionButtons();
        switch (DisplayType) {
            case TDisplayLine:          {
                                        ActionType = TPickLineColour;
                                        StatusBar1->Panels->Items[4]->Text = " Pick Line Colour";
                                        }
                                        break;
            case TDisplayPolyLine:      {
                                        ActionType = TPickPolyLineColour;
                                        StatusBar1->Panels->Items[4]->Text = " Pick Polyline Colour";
                                        }
                                        break;
            case TDisplayFloodFill:     {
                                        ActionType = TPickFloodFillColour;
                                        StatusBar1->Panels->Items[4]->Text = " Pick Flood Fill Colour";
                                        }
                                        break;
            case TDisplayText:          {
                                        ActionType = TPickTextColour;
                                        StatusBar1->Panels->Items[4]->Text = " Pick Text Colour";
                                        }
                                        break;
            case TDisplayRectangle:     {
                                        ActionType = TPickRectangleColour;
                                        StatusBar1->Panels->Items[4]->Text = " Pick Rectangle Colour";
                                        }
                                        break;
            case TDisplayCircle:        {
                                        ActionType = TPickCircleColour;
                                        StatusBar1->Panels->Items[4]->Text = " Pick Ellipse/Circle Colour";
                                        }
                                        break;
            case TDisplayFreeForm:      {
                                        ActionType = TPickFreeFormColour;
                                        StatusBar1->Panels->Items[4]->Text = " Pick Free-Form Shape Colour";
                                        }
                                        break;
            default:                    break;
            }
        Image1->Cursor = crDropperCursor;
        Timer1->Enabled = true;
        preparetosaveundo = false;
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::ChangeFloodFillColour(TColor Colour)
{
    // Change selected flood fill colour
    bool found = false;
    int pointer = 0;
    while (!found && pointer < DisplayList.Length) {
        if (DisplayList[pointer].selected && DisplayList[pointer].DisplayType == TDisplayFloodFill) {
            found = true;
            pointer--;
            }
        pointer++;
        }
    if (found) {
        //now look for the flood fill & change its colour.
        found = false;
        int pointer2 = 0;
        while (!found && pointer2 < FloodFillList.Length) {
            if (FloodFillList[pointer2].ItemNumber == DisplayList[pointer].ItemNumber) {
                found = true;
                pointer2--;
                }
            pointer2++;
            }
        if (found) {
            AddUndoTitle("Change Flood Fill Colour");
            AddUndo("FloodFill,Colour," + AnsiString(FloodFillList[pointer2].ItemNumber) + "," + AnsiString((int)(FloodFillList[pointer2].Colour)) + ",");
            FloodFillList[pointer2].Colour = Colour;
            DrawPicture();
            }
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::ChangeFloodFillColour(int ItemNumber, TColor Colour)
{
    // Change selected flood fill colour
    bool found = false;
    int pointer = XRefs[ItemNumber].EntityXRef;

    if (XRefs[ItemNumber].DisplayType == TDisplayFloodFill && pointer > -1 && pointer < FloodFillList.Length && FloodFillList[pointer].ItemNumber == ItemNumber) found = true;

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Change Flood Fill Colour");
            AddUndo("FloodFill,Colour," + AnsiString(FloodFillList[pointer].ItemNumber) + "," + AnsiString((int)(FloodFillList[pointer].Colour)) + ",");
            }
        FloodFillList[pointer].Colour = Colour;
        DrawPicture();
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::ChangePointColour(int ItemNumber, TColor Colour)
{
    // Change selected Point colour
    bool found = false;
    int pointer = XRefs[ItemNumber].EntityXRef;

    if (XRefs[ItemNumber].DisplayType == TDisplayPoint && pointer > -1 && pointer < PointList.Length && PointList[pointer].ItemNumber == ItemNumber) found = true;

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Change Pencil Object Colour");
            AddUndo("Point,Colour," + AnsiString(PointList[pointer].ItemNumber) + "," + AnsiString((int)(PointList[pointer].Colour)) + ",");
            }
        PointList[pointer].Colour = Colour;
        if (SingleUndo) DrawPicture();
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::ChangeLineColour(int ItemNumber, TColor Colour)
{
    // Change selected Line colour
    bool found = false;
    int pointer = XRefs[ItemNumber].EntityXRef;

    if (XRefs[ItemNumber].DisplayType == TDisplayLine && pointer > -1 && pointer < LineList.Length && LineList[pointer].ItemNumber == ItemNumber) found = true;

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Change Line Colour");
            AddUndo("Line,Colour," + AnsiString(LineList[pointer].ItemNumber) + "," + AnsiString((int)(LineList[pointer].Colour)) + ",");
            }
        LineList[pointer].Colour = Colour;
        FillPointsLine(pointer,ItemNumber);
        DisplayListAreaUpdate(ItemNumber);
        if (SingleUndo) DrawPicture();
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::ChangePolyLineColour(int ItemNumber, TColor Colour)
{
    // Change selected PolyLine colour
    bool found = false;
    int pointer = XRefs[ItemNumber].EntityXRef;

    if (XRefs[ItemNumber].DisplayType == TDisplayPolyLine && pointer > -1 && pointer < PolyLineList.Length && PolyLineList[pointer].ItemNumber == ItemNumber) found = true;

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Change Polyline Colour");
            AddUndoChangePolyLine(ItemNumber);
            }
        PolyLineList[pointer].PenColour = Colour;
        FillPointsPolyLine(pointer,ItemNumber);
        DisplayListAreaUpdate(ItemNumber);
        if (SingleUndo) DrawPicture();
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::ChangeTextColour(int ItemNumber, TColor Colour)
{
    // Change selected text colour
    bool found = false;
    int pointer = XRefs[ItemNumber].EntityXRef;

    if (XRefs[ItemNumber].DisplayType == TDisplayText && pointer > -1 && pointer < TextList.Length && TextList[pointer].ItemNumber == ItemNumber) found = true;

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Change Text Colour");
            AddUndo("Text,Colour," + AnsiString(TextList[pointer].ItemNumber) + "," + AnsiString((int)(TextList[pointer].Colour)) + ",");
            }
        TextList[pointer].Colour = Colour;
        FillPointsText(pointer,ItemNumber);
        DisplayListAreaUpdate(ItemNumber);
        if (SingleUndo) DrawPicture();
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::ChangeRectangleColour(int ItemNumber, TColor PenColour, TColor BrushColour)
{
    // Change selected Rectangle colour
    bool found = false;
    int pointer = XRefs[ItemNumber].EntityXRef;

    if (XRefs[ItemNumber].DisplayType == TDisplayRectangle && pointer > -1 && pointer < RectangleList.Length && RectangleList[pointer].ItemNumber == ItemNumber) found = true;

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Change Rectangle Colour");
            AddUndo("Rectangle,Colour," + AnsiString(RectangleList[pointer].ItemNumber) + "," + AnsiString((int)(RectangleList[pointer].PenColour)) + "," + AnsiString((int)(RectangleList[pointer].BrushColour)) + ",");
            }
        RectangleList[pointer].PenColour = PenColour;
        RectangleList[pointer].BrushColour = BrushColour;
        FillPointsRectangle(pointer,ItemNumber);
        DisplayListAreaUpdate(ItemNumber);
        if (SingleUndo) DrawPicture();
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::ChangeCircleColour(int ItemNumber, TColor PenColour, TColor BrushColour)
{
    // Change selected Rectangle colour
    bool found = false;
    int pointer = XRefs[ItemNumber].EntityXRef;

    if (XRefs[ItemNumber].DisplayType == TDisplayCircle && pointer > -1 && pointer < CircleList.Length && CircleList[pointer].ItemNumber == ItemNumber) found = true;

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Change Circle Colour");
            AddUndo("Circle,Colour," + AnsiString(CircleList[pointer].ItemNumber) + "," + AnsiString((int)(CircleList[pointer].PenColour)) + "," + AnsiString((int)(CircleList[pointer].BrushColour)) + ",");
            }
        CircleList[pointer].PenColour = PenColour;
        CircleList[pointer].BrushColour = BrushColour;
        FillPointsCircle(pointer,ItemNumber);
        DisplayListAreaUpdate(ItemNumber);
        if (SingleUndo) DrawPicture();
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::ChangeFreeFormColour(int ItemNumber, TColor PenColour, TColor BrushColour)
{
    // Change selected FreeForm colour
    bool found = false;
    int pointer = XRefs[ItemNumber].EntityXRef;

    if (XRefs[ItemNumber].DisplayType == TDisplayFreeForm && pointer > -1 && pointer < FreeFormList.Length && FreeFormList[pointer].ItemNumber == ItemNumber) found = true;

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Change Free-Form Shape Colour");
            AddUndoChangeFreeForm(ItemNumber);
            }
        FreeFormList[pointer].PenColour = PenColour;
        FreeFormList[pointer].BrushColour = BrushColour;
        FillPointsFreeForm(pointer,ItemNumber);
        DisplayListAreaUpdate(ItemNumber);
        if (SingleUndo) DrawPicture();
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::ShowLinksBetweenBlocks1Click(
      TObject *Sender)
{
    showlinksbetweenblocks = !showlinksbetweenblocks;
    DrawPicture();
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::AntiAliasClick(TObject *Sender)
{
    if (dynamic_cast <TComponent *>(Sender)) {
        AddUndoTitle("Change Anti Aliasing");
        AddUndo("AntiAlias," + AnsiString((int)(AntiAlias)) + "," + AnsiString(subspacesampling) + ",");
        AntiAlias = (TAntiAlias)(dynamic_cast <TComponent *>(Sender)->Tag);
        if (AntiAlias != TAANone && subspacesampling == 0) {
            subspacesampling = 2;
            }
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::AntiAliasing1Click(TObject *Sender)
{
    None1->Checked = (bool)(AntiAlias == TAANone);
    DMCColoursOnly1->Checked = (bool)(AntiAlias == TAADMC);
    DMCandBlendedThreads1->Checked = (bool)(AntiAlias == TAABlend);
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::AddUndoTitle(AnsiString Title)
{
    //Adds a title to the undo list
    UndoTitleList->Add("Title," + Title);

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::AddUndo(AnsiString Text)
{
    //Adds a title to the undo list
    UndoTitleList->Add(Text);

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::AddUndoChangePoint(int ItemNumber)
{
    //adds the undo data for this Point object
    bool found = false;
    int i = 0;
    while (!found && i < PointList.Length) {
        if (PointList[i].ItemNumber == ItemNumber) {
            AnsiString text;
            text = "Point,ChangeContents,"
                                + AnsiString(ItemNumber) + ","
                                + AnsiString((int)(PointList[i].Colour)) + ","
                                ;
            for (int j = 0; j < PointList[i].Points.Length; j++) {
                text = text + AnsiString(PointList[i].Points[j].x) + ","
                            + AnsiString(PointList[i].Points[j].y) + ","
                            ;
                }
            AddUndo(text);
            found = true;
            }
        i++;
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::AddUndoChangePolyLine(int ItemNumber)
{
    //adds the undo data for this PolyLine
    bool found = false;
    int i = 0;
    while (!found && i < PolyLineList.Length) {
        if (PolyLineList[i].ItemNumber == ItemNumber) {
            AnsiString text;
            text = "PolyLine,ChangeContents," + AnsiString(PolyLineList[i].ItemNumber) + ","
                        + AnsiString((int)(PolyLineList[i].PenColour)) + ","
                        + AnsiString((int)(PolyLineList[i].BrushColour)) + ","
                        + AnsiString(PolyLineList[i].LineWidth) + ","
                        + AnsiString((int)(PolyLineList[i].closed)) + ","
                        + AnsiString((int)(PolyLineList[i].filled)) + ","
                        + AnsiString(PolyLineList[i].Points.Length) + ","
                        ;
            for (int j = 0; j < PolyLineList[i].Points.Length; j++) {
                text = text + AnsiString(PolyLineList[i].Points[j].x) + "," + AnsiString(PolyLineList[i].Points[j].y) + "," + AnsiString((int)(PolyLineList[i].Points[j].Colour)) + ",";
                }
            text = text + AnsiString(PolyLineList[i].Corners.Length) + ",";
            for (int j = 0; j < PolyLineList[i].Corners.Length; j++) {
                text = text + AnsiString(PolyLineList[i].Corners[j].x) + "," + AnsiString(PolyLineList[i].Corners[j].y) + ",";
                }
            AddUndo(text);
            found = true;
            }
        i++;
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::AddUndoChangeText(int ItemNumber)
{
    //adds the undo data for this text item
    bool found = false;
    int i = 0;
    while (!found && i < TextList.Length) {
        if (TextList[i].ItemNumber == ItemNumber) {
            AnsiString text;
            text = "Text,ChangeContents," + AnsiString(TextList[i].ItemNumber) + ","
                        + TextList[i].Name + ","
                        + AnsiString(TextList[i].Height) + ","
                        + AnsiString((int)(TextList[i].Bold)) + ","
                        + AnsiString((int)(TextList[i].Italic)) + ","
                        + AnsiString((int)(TextList[i].Underlined)) + ","
                        + AnsiString((int)(TextList[i].Strikeout)) + ","
                        + AnsiString((int)(TextList[i].Colour)) + ","
                        + AnsiString(TextList[i].StartPoint.x) + ","
                        + AnsiString(TextList[i].StartPoint.y) + ","
                        + AnsiString(TextList[i].Angle) + ","
                        + AnsiString(TextList[i].Points.Length) + ","
                        ;
            for (int j = 0; j < TextList[i].Points.Length; j++) {
                text = text + AnsiString(TextList[i].Points[j].x) + "," + AnsiString(TextList[i].Points[j].y) + ","+ AnsiString((int)(TextList[i].Points[j].Colour)) + ",";
                }
            text = text + TextList[i].Text;
            AddUndo(text);
            }
        i++;
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::AddUndoChangeRectangle(int ItemNumber)
{
    //adds the undo data for this rectangle
    bool found = false;
    int i = 0;
    while (!found && i < RectangleList.Length) {
        if (RectangleList[i].ItemNumber == ItemNumber) {
            AnsiString text;
            text = "Rectangle,ChangeContents," + AnsiString(RectangleList[i].ItemNumber) + ","
                        + AnsiString((int)(RectangleList[i].PenColour)) + ","
                        + AnsiString((int)(RectangleList[i].BrushColour)) + ","
                        + AnsiString(RectangleList[i].LineWidth) + ","
                        + AnsiString(RectangleList[i].Area.Left) + ","
                        + AnsiString(RectangleList[i].Area.Top) + ","
                        + AnsiString(RectangleList[i].Area.Right) + ","
                        + AnsiString(RectangleList[i].Area.Bottom) + ","
                        + AnsiString((int)(RectangleList[i].Shape)) + ","
                        + AnsiString(RectangleList[i].Angle) + ","
                        + AnsiString((int)(RectangleList[i].Filled)) + ","
                        ;
            for (int j = 0; j < RectangleList[i].Points.Length; j++) {
                text = text + AnsiString(RectangleList[i].Points[j].x) + "," + AnsiString(RectangleList[i].Points[j].y) + ","+ AnsiString((int)(RectangleList[i].Points[j].Colour)) + ",";
                }
            AddUndo(text);
            found = true;
            }
        i++;
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::AddUndoChangeCircle(int ItemNumber)
{
    //adds the undo data for this Circle
    bool found = false;
    int i = 0;
    while (!found && i < CircleList.Length) {
        if (CircleList[i].ItemNumber == ItemNumber) {
            AnsiString text;
            text = "Circle,ChangeContents," + AnsiString(CircleList[i].ItemNumber) + ","
                        + AnsiString((int)(CircleList[i].PenColour)) + ","
                        + AnsiString((int)(CircleList[i].BrushColour)) + ","
                        + AnsiString(CircleList[i].LineWidth) + ","
                        + AnsiString(CircleList[i].Area.Left) + ","
                        + AnsiString(CircleList[i].Area.Top) + ","
                        + AnsiString(CircleList[i].Area.Right) + ","
                        + AnsiString(CircleList[i].Area.Bottom) + ","
                        + AnsiString((int)(CircleList[i].Shape)) + ","
                        + AnsiString(CircleList[i].Angle) + ","
                        + AnsiString((int)(CircleList[i].Filled)) + ","
                        ;
            for (int j = 0; j < CircleList[i].Points.Length; j++) {
                text = text + AnsiString(CircleList[i].Points[j].x) + "," + AnsiString(CircleList[i].Points[j].y) + ","+ AnsiString((int)(CircleList[i].Points[j].Colour)) + ",";
                }
            AddUndo(text);
            found = true;
            }
        i++;
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::AddUndoChangeFreeForm(int ItemNumber)
{
    //adds the undo data for this FreeForm
    bool found = false;
    int i = 0;
    while (!found && i < FreeFormList.Length) {
        if (FreeFormList[i].ItemNumber == ItemNumber) {
            AnsiString text;
            text = "FreeForm,ChangeContents," + AnsiString(FreeFormList[i].ItemNumber) + ","
                        + AnsiString((int)(FreeFormList[i].PenColour)) + ","
                        + AnsiString((int)(FreeFormList[i].BrushColour)) + ","
                        + AnsiString(FreeFormList[i].LineWidth) + ","
                        + AnsiString((int)(FreeFormList[i].closed)) + ","
                        + AnsiString((int)(FreeFormList[i].filled)) + ","
                        + AnsiString(FreeFormList[i].Points.Length) + ","
                        ;
            for (int j = 0; j < FreeFormList[i].Points.Length; j++) {
                text = text + AnsiString(FreeFormList[i].Points[j].x) + "," + AnsiString(FreeFormList[i].Points[j].y) + "," + AnsiString((int)(FreeFormList[i].Points[j].Colour)) + ",";
                }
            text = text + AnsiString(FreeFormList[i].Corners.Length) + ",";
            for (int j = 0; j < FreeFormList[i].Corners.Length; j++) {
                text = text + AnsiString(FreeFormList[i].Corners[j].x) + "," + AnsiString(FreeFormList[i].Corners[j].y) + ",";
                }
            AddUndo(text);
            found = true;
            }
        i++;
        }
}
//---------------------------------------------------------------------------

AnsiString __fastcall TImageEditorForm::LastUndoTitle(void)
{
    AnsiString Text;
    if (UndoTitleList->Count) {
        //returns the last title found
        int pointer = UndoTitleList->Count - 1;
        bool found = false;
        while (!found && pointer > -1) {
            if (LeftString(UndoTitleList->Strings[pointer],6) == "Title,") {
                Text = ChopOffFirstChars(UndoTitleList->Strings[pointer],6);
                found = true;
                }
            pointer--;
            }
        } else {
        Text = "No Undo's Available";
        }

    return Text;
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::CreateXRefs(void)
{
    XRefs.Length = DisplayItemNumber + 1;
    for (int i = 0; i < XRefs.Length; i++){
        XRefs[i].ItemNumber = 0;
        XRefs[i].DisplayType = TDisplayNone;
        XRefs[i].DisplayXRef = -1;
        XRefs[i].EntityXRef = -1;
        }

    for (int i = 0; i < DisplayList.Length; i++) {
        XRefs[DisplayList[i].ItemNumber].ItemNumber = DisplayList[i].ItemNumber;
        XRefs[DisplayList[i].ItemNumber].DisplayType = DisplayList[i].DisplayType;
        XRefs[DisplayList[i].ItemNumber].DisplayXRef = i;
        }
    for (int i = 0; i < PointList.Length; i++) {
        XRefs[PointList[i].ItemNumber].ItemNumber = PointList[i].ItemNumber;
        XRefs[PointList[i].ItemNumber].DisplayType = TDisplayPoint;
        XRefs[PointList[i].ItemNumber].EntityXRef = i;
        }
    for (int i = 0; i < LineList.Length; i++) {
        XRefs[LineList[i].ItemNumber].ItemNumber = LineList[i].ItemNumber;
        XRefs[LineList[i].ItemNumber].DisplayType = TDisplayLine;
        XRefs[LineList[i].ItemNumber].EntityXRef = i;
        }
    for (int i = 0; i < PolyLineList.Length; i++) {
        XRefs[PolyLineList[i].ItemNumber].ItemNumber = PolyLineList[i].ItemNumber;
        XRefs[PolyLineList[i].ItemNumber].DisplayType = TDisplayPolyLine;
        XRefs[PolyLineList[i].ItemNumber].EntityXRef = i;
        }
    for (int i = 0; i < FloodFillList.Length; i++) {
        XRefs[FloodFillList[i].ItemNumber].ItemNumber = FloodFillList[i].ItemNumber;
        XRefs[FloodFillList[i].ItemNumber].DisplayType = TDisplayFloodFill;
        XRefs[FloodFillList[i].ItemNumber].EntityXRef = i;
        }
    for (int i = 0; i < TextList.Length; i++) {
        XRefs[TextList[i].ItemNumber].ItemNumber = TextList[i].ItemNumber;
        XRefs[TextList[i].ItemNumber].DisplayType = TDisplayText;
        XRefs[TextList[i].ItemNumber].EntityXRef = i;
        }
    for (int i = 0; i < RectangleList.Length; i++) {
        XRefs[RectangleList[i].ItemNumber].ItemNumber = RectangleList[i].ItemNumber;
        XRefs[RectangleList[i].ItemNumber].DisplayType = TDisplayRectangle;
        XRefs[RectangleList[i].ItemNumber].EntityXRef = i;
        }
    for (int i = 0; i < CircleList.Length; i++) {
        XRefs[CircleList[i].ItemNumber].ItemNumber = CircleList[i].ItemNumber;
        XRefs[CircleList[i].ItemNumber].DisplayType = TDisplayCircle;
        XRefs[CircleList[i].ItemNumber].EntityXRef = i;
        }
    for (int i = 0; i < FreeFormList.Length; i++) {
        XRefs[FreeFormList[i].ItemNumber].ItemNumber = FreeFormList[i].ItemNumber;
        XRefs[FreeFormList[i].ItemNumber].DisplayType = TDisplayFreeForm;
        XRefs[FreeFormList[i].ItemNumber].EntityXRef = i;
        }
    for (int i = 0; i < EraseList.Length; i++) {
        XRefs[EraseList[i].ItemNumber].ItemNumber = EraseList[i].ItemNumber;
        XRefs[EraseList[i].ItemNumber].DisplayType = TDisplayEraseItem;
        XRefs[EraseList[i].ItemNumber].EntityXRef = i;
        }
    for (int i = 0; i < BlockList.Length; i++) {
        XRefs[BlockList[i].ItemNumber].ItemNumber = BlockList[i].ItemNumber;
        XRefs[BlockList[i].ItemNumber].DisplayType = TDisplayBlock;
        XRefs[BlockList[i].ItemNumber].EntityXRef = i;
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::SelectTool1Click(TObject *Sender)
{
    SelectButton->Down = !SelectButton->Down;
    SelectButtonClick(Sender);

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Select2Click(TObject *Sender)
{
    SelectAll1->Enabled = (bool)(DisplayList.Length);
    SelectAllPencilTools1->Enabled = (bool)(PointList.Length);
    SelectAllLines1->Enabled = (bool)(LineList.Length);
    SelectAllFloodFills1->Enabled = (bool)(FloodFillList.Length);
    SelectAllTextObjects1->Enabled = (bool)(TextList.Length);
    SelectAllRectangles1->Enabled = (bool)(RectangleList.Length);
    SelectAllEllipsesCircles1->Enabled = (bool)(CircleList.Length);
    SelectAllEraseObjects1->Enabled = (bool)(EraseList.Length);
    SelectAllBlocks1->Enabled = (bool)(BlockList.Length);

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Deselect1Click(TObject *Sender)
{
    DeselectAll1->Enabled = (bool)(DisplayList.Length);
    DeselectAllPencilObjects1->Enabled = (bool)(PointList.Length);
    DeselectAllLines1->Enabled = (bool)(LineList.Length);
    DeselectAllFloodFills1->Enabled = (bool)(FloodFillList.Length);
    DeselectAllTextObjects1->Enabled = (bool)(TextList.Length);
    DeselectAllRectangles1->Enabled = (bool)(RectangleList.Length);
    DeselectAllEllipsesCircles1->Enabled = (bool)(CircleList.Length);
    DeselectallEraseObjects1->Enabled = (bool)(EraseList.Length);
    DeselectAllBlocks1->Enabled = (bool)(BlockList.Length);

}
//---------------------------------------------------------------------------

bool __fastcall TImageEditorForm::CheckifEntityExists(int ItemNumber)
{
    //returns true if the item number is found
    bool found = false;
    int pointer = 0;

    while (!found && pointer < PointList.Length) {
        if (PointList[pointer].ItemNumber == ItemNumber) {
            found = true;
            }
        pointer++;
        }

    pointer = 0;
    while (!found && pointer < LineList.Length) {
        if (LineList[pointer].ItemNumber == ItemNumber) {
            found = true;
            }
        pointer++;
        }

    pointer = 0;
    while (!found && pointer < LineList.Length) {
        if (LineList[pointer].ItemNumber == ItemNumber) {
            found = true;
            }
        pointer++;
        }

    pointer = 0;
    while (!found && pointer < PolyLineList.Length) {
        if (PolyLineList[pointer].ItemNumber == ItemNumber) {
            found = true;
            }
        pointer++;
        }

    pointer = 0;
    while (!found && pointer < FloodFillList.Length) {
        if (FloodFillList[pointer].ItemNumber == ItemNumber) {
            found = true;
            }
        pointer++;
        }

    pointer = 0;
    while (!found && pointer < TextList.Length) {
        if (TextList[pointer].ItemNumber == ItemNumber) {
            found = true;
            }
        pointer++;
        }

    pointer = 0;
    while (!found && pointer < RectangleList.Length) {
        if (RectangleList[pointer].ItemNumber == ItemNumber) {
            found = true;
            }
        pointer++;
        }

    pointer = 0;
    while (!found && pointer < CircleList.Length) {
        if (CircleList[pointer].ItemNumber == ItemNumber) {
            found = true;
            }
        pointer++;
        }

    pointer = 0;
    while (!found && pointer < FreeFormList.Length) {
        if (FreeFormList[pointer].ItemNumber == ItemNumber) {
            found = true;
            }
        pointer++;
        }

    pointer = 0;
    while (!found && pointer < EraseList.Length) {
        if (EraseList[pointer].ItemNumber == ItemNumber) {
            found = true;
            }
        pointer++;
        }

    pointer = 0;
    while (!found && pointer < BlockList.Length) {
        if (BlockList[pointer].ItemNumber == ItemNumber) {
            found = true;
            }
        pointer++;
        }

    return found;
}
//---------------------------------------------------------------------------

bool __fastcall TImageEditorForm::CheckifDisplayItemExists(int ItemNumber)
{
    //returns true if the item number is found
    bool found = false;
    int pointer = 0;

    while (!found && pointer < DisplayList.Length) {
        if (DisplayList[pointer].ItemNumber == ItemNumber) {
            found = true;
            }
        pointer++;
        }

    return found;
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::FillPointsLine(int arraypointer,int ItemNumber)
{
    //fill the points used in a line & anti-alias as required
    if (LineList[arraypointer].ItemNumber == ItemNumber) {
        //There are three types of anti Aliasing: None, DMC and Blended
        //The level of oversampling is specified by 'subspacesampling'
        switch (AntiAlias) {
            case TAADMC:
            case TAABlend:      {
                                //As windows anti-aliases text anyway, there is no need to do
                                //oversampling for text. So, need two bitmaps. A reference bitmap and the one with text on it.
                                //Both bitmaps have everything drawn on them up to the display item below the text we're
                                //dealing with at the moment.
                                //Find where this text is in the display order
                                int pointer = 0;
                                bool found = false;
                                while (!found && pointer < DisplayList.Length) {
                                    if (DisplayList[pointer].ItemNumber == ItemNumber) {
                                        found = true;
                                        pointer--;
                                        }
                                    pointer++;
                                    }

                                //fill in bitmaps
                                Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
                                Graphics::TBitmap *Reference = new Graphics::TBitmap();

                                Bitmap->Assign(Picture);
                                Reference->Assign(Picture);

                                int oldsquare = SquareSize;
                                TPoint oldTopLeft = TopLeft;
                                SquareSize = 1;
                                TopLeft.x = 0;
                                TopLeft.y = 0;
                                //draw reference picture
                                if (found) {
                                    DrawVectors(Reference->Canvas,pointer);
                                    } else {
                                    DrawVectors(Reference->Canvas);
                                    }

                                //draw the line and ensure the result is in 'Bitmap'
                                if (subspacesampling > 0) {
                                    //there is anti-aliasing, so draw everything on a bigger bitmap and then shrink it down onto bitmap
                                    SquareSize = subspacesampling;
                                    Graphics::TBitmap *BigBitmap = new Graphics::TBitmap();
                                    BigBitmap->Width = Picture->Width * subspacesampling;
                                    BigBitmap->Height = Picture->Height * subspacesampling;
                                    TRect dest;
                                    dest.Left = 0;
                                    dest.Top = 0;
                                    dest.Right = BigBitmap->Width;
                                    dest.Bottom = BigBitmap->Height;
                                    BigBitmap->Canvas->StretchDraw(dest,Picture);
                                    if (found) {
                                        DrawVectors(BigBitmap->Canvas,pointer);
                                        } else {
                                        DrawVectors(BigBitmap->Canvas);
                                        }
                                    BigBitmap->Canvas->Pen->Color = LineList[arraypointer].Colour;
                                    BigBitmap->Canvas->Pen->Width = LineList[arraypointer].LineWidth * subspacesampling;
                                    BigBitmap->Canvas->MoveTo(LineList[arraypointer].StartPoint.x * subspacesampling,LineList[arraypointer].StartPoint.y * subspacesampling);
                                    BigBitmap->Canvas->LineTo(LineList[arraypointer].EndPoint.x * subspacesampling,LineList[arraypointer].EndPoint.y * subspacesampling);
                                    //picture complete, now to compress it onto Bitmap
                                    rgb temp;
                                    int R,G,B,c1;
                                    for (int i = 0; i < Bitmap->Width; i++) {
                                        for (int j = 0; j < Bitmap->Height; j++) {
                                            R = 0;
                                            G = 0;
                                            B = 0;
                                            for (int k = 0; k < subspacesampling; k++) {
                                                for (int l = 0; l < subspacesampling; l++) {
                                                    c1 = (int)(BigBitmap->Canvas->Pixels[i*subspacesampling + k][j*subspacesampling + l]);
                                                    temp.B = c1 >> 16;
                                                    c1 = c1 - (temp.B << 16);
                                                    temp.G = c1 >> 8;
                                                    c1 = c1 - (temp.G << 8);
                                                    temp.R = c1;
                                                    R += temp.R;
                                                    G += temp.G;
                                                    B += temp.B;
                                                    }
                                                }
                                            R = R >> subspacesampling;
                                            G = G >> subspacesampling;
                                            B = B >> subspacesampling;
                                            c1 = R + (G << 8) + (B << 16);
                                            Bitmap->Canvas->Pixels[i][j] = (TColor)(c1);
                                            }
                                        }
                                    delete BigBitmap;
                                    //now anti-aliased line is on Bitmap along with the background
                                    } else {
                                    //no anti-aliasing, so draw line directly on Bitmap
                                    if (found) {
                                        DrawVectors(Bitmap->Canvas,pointer);
                                        } else {
                                        DrawVectors(Bitmap->Canvas);
                                        }
                                    Bitmap->Canvas->Pen->Color = LineList[arraypointer].Colour;
                                    Bitmap->Canvas->Pen->Width = LineList[arraypointer].LineWidth;
                                    Bitmap->Canvas->MoveTo(LineList[arraypointer].StartPoint.x,LineList[arraypointer].StartPoint.y);
                                    Bitmap->Canvas->LineTo(LineList[arraypointer].EndPoint.x,LineList[arraypointer].EndPoint.y);
                                    }
                                SquareSize =oldsquare;
                                TopLeft = oldTopLeft;

                                LineList[arraypointer].Points.Length = Bitmap->Width * Bitmap->Height + 1;
                                pointer = 0;
                                TColor Colour;

                                for (int i = 0; i < Bitmap->Width; i++) {
                                    for (int j = 0; j < Bitmap->Height; j++) {
                                        if (Bitmap->Canvas->Pixels[i][j] != Reference->Canvas->Pixels[i][j]) {
                                            if (subspacesampling > 0) {
                                                //there is anti-aliasing
                                                if (AntiAlias == TAADMC) {
                                                    //use DMC whole colours for the anti-aliasing
                                                    Colour = FindNearestDMCColour(Bitmap->Canvas->Pixels[i][j]);
                                                    } else {
                                                    //use blended colours for the anti-aliasing
                                                    Colour = FindNearestBlendColour(Bitmap->Canvas->Pixels[i][j]);
                                                    }
                                                } else {
                                                //no antialiasing, so the colour will be linecolour
                                                Colour = LineList[arraypointer].Colour;
                                                }
                                            LineList[arraypointer].Points[pointer].x = i;
                                            LineList[arraypointer].Points[pointer].y = j;
                                            LineList[arraypointer].Points[pointer].Colour = Colour;
                                            pointer++;
                                            }
                                        }
                                    }
                                LineList[arraypointer].Points.Length = pointer;

                                delete Reference;
                                delete Bitmap;
                                }
                                break;
            default:            {
                                //no anti aliasing, very simple line method.
                                Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
                                Bitmap->Monochrome = true;
                                Bitmap->Width = Picture->Width;
                                Bitmap->Height = Picture->Height;
                                Bitmap->Canvas->Pen->Color = clBlack;
                                Bitmap->Canvas->Pen->Width = LineList[arraypointer].LineWidth;
                                Bitmap->Canvas->MoveTo(LineList[arraypointer].StartPoint.x,LineList[arraypointer].StartPoint.y);
                                Bitmap->Canvas->LineTo(LineList[arraypointer].EndPoint.x,LineList[arraypointer].EndPoint.y);
                                LineList[arraypointer].Points.Length = Bitmap->Width * Bitmap->Height + 1;

                                int pointer = 0;

                                for (int i = 0; i < Bitmap->Width; i++) {
                                    for (int j = 0; j < Bitmap->Height; j++) {
                                        if (Bitmap->Canvas->Pixels[i][j] == clBlack) {
                                            LineList[arraypointer].Points[pointer].x = i;
                                            LineList[arraypointer].Points[pointer].y = j;
                                            LineList[arraypointer].Points[pointer].Colour = LineList[arraypointer].Colour;
                                            pointer++;
                                            }
                                        }
                                    }
                                LineList[arraypointer].Points.Length = pointer;
                                delete Bitmap;
                                } //end of default anti-aliasing (none!)
                                break;
            }
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::FillPointsPolyLine(int arraypointer,int ItemNumber)
{
    //fill the points used in a Polyline & anti-alias as required
    if (PolyLineList[arraypointer].ItemNumber == ItemNumber) {
        //There are three types of anti Aliasing: None, DMC and Blended
        //The level of oversampling is specified by 'subspacesampling'
        switch (AntiAlias) {
            case TAADMC:
            case TAABlend:      {
                                //So, need two bitmaps. A reference bitmap and the one with text on it.
                                //Both bitmaps have everything drawn on them up to the display item below the text we're
                                //dealing with at the moment.
                                //Find where this text is in the display order
                                int pointer = 0;
                                bool found = false;
                                while (!found && pointer < DisplayList.Length) {
                                    if (DisplayList[pointer].ItemNumber == ItemNumber) {
                                        found = true;
                                        pointer--;
                                        }
                                    pointer++;
                                    }

                                //fill in bitmaps
                                Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
                                Graphics::TBitmap *Reference = new Graphics::TBitmap();

                                Bitmap->Assign(Picture);
                                Reference->Assign(Picture);

                                int oldsquare = SquareSize;
                                TPoint oldTopLeft = TopLeft;
                                SquareSize = 1;
                                TopLeft.x = 0;
                                TopLeft.y = 0;
                                //draw reference picture
                                if (found) {
                                    DrawVectors(Reference->Canvas,pointer);
                                    } else {
                                    DrawVectors(Reference->Canvas);
                                    }

                                //draw the line and ensure the result is in 'Bitmap'
                                if (subspacesampling > 0) {
                                    //there is anti-aliasing, so draw everything on a bigger bitmap and then shrink it down onto bitmap
                                    SquareSize = subspacesampling;
                                    Graphics::TBitmap *BigBitmap = new Graphics::TBitmap();
                                    BigBitmap->Width = Picture->Width * subspacesampling;
                                    BigBitmap->Height = Picture->Height * subspacesampling;
                                    TRect dest;
                                    dest.Left = 0;
                                    dest.Top = 0;
                                    dest.Right = BigBitmap->Width;
                                    dest.Bottom = BigBitmap->Height;
                                    BigBitmap->Canvas->StretchDraw(dest,Picture);
                                    if (found) {
                                        DrawVectors(BigBitmap->Canvas,pointer);
                                        } else {
                                        DrawVectors(BigBitmap->Canvas);
                                        }
                                    BigBitmap->Canvas->Pen->Color = PolyLineList[arraypointer].PenColour;
                                    BigBitmap->Canvas->Pen->Width = PolyLineList[arraypointer].LineWidth * subspacesampling;
                                    BigBitmap->Canvas->MoveTo(PolyLineList[arraypointer].Corners[0].x * subspacesampling,PolyLineList[arraypointer].Corners[0].y * subspacesampling);
                                    for (int i = 1; i < PolyLineList[arraypointer].Corners.Length; i++) {
                                        BigBitmap->Canvas->LineTo(PolyLineList[arraypointer].Corners[i].x * subspacesampling,PolyLineList[arraypointer].Corners[i].y * subspacesampling);
                                        }
                                    //picture complete, now to compress it onto Bitmap
                                    rgb temp;
                                    int R,G,B,c1;
                                    for (int i = 0; i < Bitmap->Width; i++) {
                                        for (int j = 0; j < Bitmap->Height; j++) {
                                            R = 0;
                                            G = 0;
                                            B = 0;
                                            for (int k = 0; k < subspacesampling; k++) {
                                                for (int l = 0; l < subspacesampling; l++) {
                                                    c1 = (int)(BigBitmap->Canvas->Pixels[i*subspacesampling + k][j*subspacesampling + l]);
                                                    temp.B = c1 >> 16;
                                                    c1 = c1 - (temp.B << 16);
                                                    temp.G = c1 >> 8;
                                                    c1 = c1 - (temp.G << 8);
                                                    temp.R = c1;
                                                    R += temp.R;
                                                    G += temp.G;
                                                    B += temp.B;
                                                    }
                                                }
                                            R = R >> subspacesampling;
                                            G = G >> subspacesampling;
                                            B = B >> subspacesampling;
                                            c1 = R + (G << 8) + (B << 16);
                                            Bitmap->Canvas->Pixels[i][j] = (TColor)(c1);
                                            }
                                        }
                                    delete BigBitmap;
                                    //now anti-aliased line is on Bitmap along with the background
                                    } else {
                                    //no anti-aliasing, so draw line directly on Bitmap
                                    if (found) {
                                        DrawVectors(Bitmap->Canvas,pointer);
                                        } else {
                                        DrawVectors(Bitmap->Canvas);
                                        }
                                    Bitmap->Canvas->Pen->Color = PolyLineList[arraypointer].PenColour;
                                    Bitmap->Canvas->Pen->Width = PolyLineList[arraypointer].LineWidth;
                                    Bitmap->Canvas->MoveTo(PolyLineList[arraypointer].Corners[0].x,PolyLineList[arraypointer].Corners[0].y);
                                    for (int i = 1; i < PolyLineList[arraypointer].Corners.Length; i++) {
                                        Bitmap->Canvas->LineTo(PolyLineList[arraypointer].Corners[i].x,PolyLineList[arraypointer].Corners[i].y);
                                        }
                                    }
                                SquareSize =oldsquare;
                                TopLeft = oldTopLeft;

                                PolyLineList[arraypointer].Points.Length = Bitmap->Width * Bitmap->Height + 1;
                                pointer = 0;
                                TColor Colour;

                                for (int i = 0; i < Bitmap->Width; i++) {
                                    for (int j = 0; j < Bitmap->Height; j++) {
                                        if (Bitmap->Canvas->Pixels[i][j] != Reference->Canvas->Pixels[i][j]) {
                                            if (subspacesampling > 0) {
                                                //there is anti-aliasing
                                                if (AntiAlias == TAADMC) {
                                                    //use DMC whole colours for the anti-aliasing
                                                    Colour = FindNearestDMCColour(Bitmap->Canvas->Pixels[i][j]);
                                                    } else {
                                                    //use blended colours for the anti-aliasing
                                                    Colour = FindNearestBlendColour(Bitmap->Canvas->Pixels[i][j]);
                                                    }
                                                } else {
                                                //no antialiasing, so the colour will be linecolour
                                                Colour = PolyLineList[arraypointer].PenColour;
                                                }
                                            PolyLineList[arraypointer].Points[pointer].x = i;
                                            PolyLineList[arraypointer].Points[pointer].y = j;
                                            PolyLineList[arraypointer].Points[pointer].Colour = Colour;
                                            pointer++;
                                            }
                                        }
                                    }
                                PolyLineList[arraypointer].Points.Length = pointer;

                                delete Reference;
                                delete Bitmap;
                                }
                                break;
            default:            {
                                //no anti aliasing, very simple line method.
                                Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
                                Bitmap->Monochrome = true;
                                Bitmap->Width = Picture->Width;
                                Bitmap->Height = Picture->Height;
                                Bitmap->Canvas->Pen->Color = clBlack;
                                Bitmap->Canvas->Pen->Width = PolyLineList[arraypointer].LineWidth;
                                Bitmap->Canvas->MoveTo(PolyLineList[arraypointer].Corners[0].x,PolyLineList[arraypointer].Corners[0].y);
                                for (int i = 1; i < PolyLineList[arraypointer].Corners.Length; i++) {
                                    Bitmap->Canvas->LineTo(PolyLineList[arraypointer].Corners[i].x,PolyLineList[arraypointer].Corners[i].y);
                                    }
                                PolyLineList[arraypointer].Points.Length = Bitmap->Width * Bitmap->Height + 1;

                                int pointer = 0;

                                for (int i = 0; i < Bitmap->Width; i++) {
                                    for (int j = 0; j < Bitmap->Height; j++) {
                                        if (Bitmap->Canvas->Pixels[i][j] == clBlack) {
                                            PolyLineList[arraypointer].Points[pointer].x = i;
                                            PolyLineList[arraypointer].Points[pointer].y = j;
                                            PolyLineList[arraypointer].Points[pointer].Colour = PolyLineList[arraypointer].PenColour;
                                            pointer++;
                                            }
                                        }
                                    }
                                PolyLineList[arraypointer].Points.Length = pointer;
                                delete Bitmap;
                                } //end of default anti-aliasing (none!)
                                break;
            }
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::FillPointsText(int arraypointer,int ItemNumber)
{
    //quick check
    if (TextList[arraypointer].ItemNumber == ItemNumber) {
        //There are three types of anti Aliasing: None, DMC and Blended
        switch (AntiAlias) {
            case TAADMC:
            case TAABlend:      {
                                //As windows anti-aliases text anyway, there is no need to do
                                //oversampling for text. So, need two bitmaps. A reference bitmap and the one with text on it.
                                //Both bitmaps have everything drawn on them up to the display item below the text we're
                                //dealing with at the moment.
                                //Find where this text is in the display order
                                int pointer = 0;
                                bool found = false;
                                while (!found && pointer < DisplayList.Length) {
                                    if (DisplayList[pointer].ItemNumber == ItemNumber) {
                                        found = true;
                                        pointer--;
                                        }
                                    pointer++;
                                    }

                                //fill in bitmaps
                                Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
                                Graphics::TBitmap *Reference = new Graphics::TBitmap();

                                Bitmap->Assign(Picture);
                                Reference->Assign(Picture);

                                int oldsquare = SquareSize;
                                TPoint oldTopLeft = TopLeft;
                                SquareSize = 1;
                                TopLeft.x = 0;
                                TopLeft.y = 0;
                                if (found) {
                                    DrawVectors(Bitmap->Canvas,pointer);
                                    DrawVectors(Reference->Canvas,pointer);
                                    } else {
                                    DrawVectors(Bitmap->Canvas);
                                    DrawVectors(Reference->Canvas);
                                    }
                                SquareSize =oldsquare;
                                TopLeft = oldTopLeft;

                                //draw the text on Bitmap
                                Bitmap->Canvas->Font->Name = TextList[arraypointer].Name;
                                Bitmap->Canvas->Font->Height = TextList[arraypointer].Height/2;
                                while (Bitmap->Canvas->TextHeight("Hg") <  (-1*TextList[arraypointer].Height)) {
                                    Bitmap->Canvas->Font->Height = Bitmap->Canvas->Font->Height - 1;
                                    }
                                //if (TextList[arraypointer].Bold) Bitmap->Canvas->Font->Style << fsBold;
                                //if (TextList[arraypointer].Italic) Bitmap->Canvas->Font->Style << fsItalic;
                                //if (TextList[arraypointer].Underlined) Bitmap->Canvas->Font->Style << fsUnderline;
                                //if (TextList[arraypointer].Strikeout) Bitmap->Canvas->Font->Style << fsStrikeOut;
                                //Bitmap->Canvas->Font->Color = TextList[arraypointer].Colour;
                                //Bitmap->Canvas->Brush->Style = bsClear;
                                //Bitmap->Canvas->TextOut(TextList[arraypointer].StartPoint.x,TextList[arraypointer].StartPoint.y,TextList[arraypointer].Text);
                                if (TextList[arraypointer].Angle == 0) {
                                    Bitmap->Canvas->Font->Color = TextList[arraypointer].Colour;
                                    Bitmap->Canvas->Brush->Style = bsClear;
                                    if (TextList[arraypointer].Bold) Bitmap->Canvas->Font->Style << fsBold;
                                    if (TextList[arraypointer].Italic) Bitmap->Canvas->Font->Style << fsItalic;
                                    if (TextList[arraypointer].Underlined) Bitmap->Canvas->Font->Style << fsUnderline;
                                    if (TextList[arraypointer].Strikeout) Bitmap->Canvas->Font->Style << fsStrikeOut;
                                    Bitmap->Canvas->TextOut(TextList[arraypointer].StartPoint.x,TextList[arraypointer].StartPoint.y,TextList[arraypointer].Text);
                                    } else {
                                    int weight = FW_NORMAL;
                                    if (TextList[arraypointer].Bold) weight = FW_BOLD;
                                    HFONT oldfont = Image1->Picture->Bitmap->Canvas->Font->Handle;
                                    HFONT newfont = CreateFont((Bitmap->Canvas->Font->Height),0,(TextList[arraypointer].Angle),(TextList[arraypointer].Angle),weight,(DWORD)(TextList[arraypointer].Italic),(DWORD)(TextList[arraypointer].Underlined),(DWORD)(TextList[arraypointer].Strikeout),DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,FF_DONTCARE,TextList[arraypointer].Name.c_str());
                                    Bitmap->Canvas->Font->Handle = newfont;
                                    Bitmap->Canvas->Font->Color = TextList[arraypointer].Colour;
                                    Bitmap->Canvas->Brush->Style = bsClear;
                                    Bitmap->Canvas->TextOut(TextList[arraypointer].StartPoint.x,TextList[arraypointer].StartPoint.y,TextList[arraypointer].Text);
                                    Bitmap->Canvas->Font->Handle = oldfont;
                                    DeleteObject(newfont);
                                    }
                                TextList[arraypointer].Points.Length = Bitmap->Width * Bitmap->Height + 1;
                                pointer = 0;
                                TColor Colour;
                                //TColor Colour2;

                                for (int i = 0; i < Bitmap->Width; i++) {
                                    for (int j = 0; j < Bitmap->Height; j++) {
                                        if (Bitmap->Canvas->Pixels[i][j] != Reference->Canvas->Pixels[i][j]) {
                                            //Colour2 = Bitmap->Canvas->Pixels[i][j];
                                            if (AntiAlias == TAADMC) {
                                                //use DMC whole colours for the anti-aliasing
                                                Colour = FindNearestDMCColour(Bitmap->Canvas->Pixels[i][j]);
                                                } else {
                                                //use blended colours for the anti-aliasing
                                                Colour = FindNearestBlendColour(Bitmap->Canvas->Pixels[i][j]);
                                                }
                                            TextList[arraypointer].Points[pointer].x = i;
                                            TextList[arraypointer].Points[pointer].y = j;
                                            TextList[arraypointer].Points[pointer].Colour = Colour;
                                            pointer++;
                                            }
                                        }
                                    }
                                TextList[arraypointer].Points.Length = pointer;

                                delete Reference;
                                delete Bitmap;
                                }
                                break;
            default:            {
                                //no anti aliasing, very simple text method.
                                Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
                                Bitmap->Monochrome = true;
                                Bitmap->Width = Picture->Width;
                                Bitmap->Height = Picture->Height;
                                Bitmap->Canvas->Font->Name = TextList[arraypointer].Name;
                                Bitmap->Canvas->Font->Height = TextList[arraypointer].Height/2;
                                while (Bitmap->Canvas->TextHeight("Hg") <  (-1*TextList[arraypointer].Height)) {
                                    Bitmap->Canvas->Font->Height = Bitmap->Canvas->Font->Height - 1;
                                    }
                                Bitmap->Canvas->Font->Color = clBlack;
                                if (TextList[arraypointer].Angle == 0) {
                                    if (TextList[arraypointer].Bold) Bitmap->Canvas->Font->Style << fsBold;
                                    if (TextList[arraypointer].Italic) Bitmap->Canvas->Font->Style << fsItalic;
                                    if (TextList[arraypointer].Underlined) Bitmap->Canvas->Font->Style << fsUnderline;
                                    if (TextList[arraypointer].Strikeout) Bitmap->Canvas->Font->Style << fsStrikeOut;
                                    Bitmap->Canvas->TextOut(TextList[arraypointer].StartPoint.x,TextList[arraypointer].StartPoint.y,TextList[arraypointer].Text);
                                    } else {
                                    int weight = FW_NORMAL;
                                    if (TextList[arraypointer].Bold) weight = FW_BOLD;
                                    HFONT oldfont = Image1->Picture->Bitmap->Canvas->Font->Handle;
                                    HFONT newfont = CreateFont((Bitmap->Canvas->Font->Height),0,(TextList[arraypointer].Angle),(TextList[arraypointer].Angle),weight,(DWORD)(TextList[arraypointer].Italic),(DWORD)(TextList[arraypointer].Underlined),(DWORD)(TextList[arraypointer].Strikeout),DEFAULT_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,FF_DONTCARE,TextList[arraypointer].Name.c_str());
                                    Bitmap->Canvas->Font->Handle = newfont;
                                    Bitmap->Canvas->TextOut(TextList[arraypointer].StartPoint.x,TextList[arraypointer].StartPoint.y,TextList[arraypointer].Text);
                                    Bitmap->Canvas->Font->Handle = oldfont;
                                    DeleteObject(newfont);
                                    }
                                TextList[arraypointer].Points.Length = Bitmap->Width * Bitmap->Height + 1;
                                int pointer = 0;

                                for (int i = 0; i < Bitmap->Width; i++) {
                                    for (int j = 0; j < Bitmap->Height; j++) {
                                        if (Bitmap->Canvas->Pixels[i][j] == clBlack) {
                                            TextList[arraypointer].Points[pointer].x = i;
                                            TextList[arraypointer].Points[pointer].y = j;
                                            TextList[arraypointer].Points[pointer].Colour = TextList[arraypointer].Colour;
                                            //debug
                                            //Memo1->Lines->Add(AnsiString(pointer) + " " + AnsiString(i) + " " + AnsiString(j) + AnsiString(TextList[arraypointer].Points[pointer].Colour));
                                            pointer++;
                                            }
                                        }
                                    }
                                TextList[arraypointer].Points.Length = pointer;
                                delete Bitmap;
                                } //end of default anti-aliasing (none!)
                                break;
            }
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::FillPointsRectangle(int arraypointer,int ItemNumber)
{
    //fill the points used in a rectangle & anti-alias as required
    if (RectangleList[arraypointer].ItemNumber == ItemNumber) {
        //There are three types of anti Aliasing: None, DMC and Blended
        //The level of oversampling is specified by 'subspacesampling'
        TAntiAlias LocalAlias;
        if (AntiAlias == TAANone || RectangleList[arraypointer].Angle == 0 || RectangleList[arraypointer].Angle == 900 ||  RectangleList[arraypointer].Angle == 1800 || RectangleList[arraypointer].Angle == 2700) {
            LocalAlias = TAANone;
            } else {
            LocalAlias = AntiAlias;
            }
        switch (LocalAlias) {
            case TAADMC:
            case TAABlend:      {
                                //Find where this rectangle is in the display order
                                int pointer = 0;
                                bool found = false;
                                while (!found && pointer < DisplayList.Length) {
                                    if (DisplayList[pointer].ItemNumber == ItemNumber) {
                                        found = true;
                                        pointer--;
                                        }
                                    pointer++;
                                    }

                                //fill in bitmaps
                                Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
                                Graphics::TBitmap *Reference = new Graphics::TBitmap();

                                Bitmap->Assign(Picture);
                                Reference->Assign(Picture);

                                int oldsquare = SquareSize;
                                TPoint oldTopLeft = TopLeft;
                                SquareSize = 1;
                                TopLeft.x = 0;
                                TopLeft.y = 0;
                                //draw reference picture
                                if (found) {
                                    DrawVectors(Reference->Canvas,pointer);
                                    } else {
                                    DrawVectors(Reference->Canvas);
                                    }

                                //draw the rectangle and ensure the result is in 'Bitmap'
                                if (subspacesampling > 0) {
                                    //there is anti-aliasing, so draw everything on a bigger bitmap and then shrink it down onto bitmap
                                    SquareSize = subspacesampling;
                                    Graphics::TBitmap *BigBitmap = new Graphics::TBitmap();
                                    BigBitmap->Width = Picture->Width * subspacesampling;
                                    BigBitmap->Height = Picture->Height * subspacesampling;
                                    TRect dest;
                                    dest.Left = 0;
                                    dest.Top = 0;
                                    dest.Right = BigBitmap->Width;
                                    dest.Bottom = BigBitmap->Height;
                                    BigBitmap->Canvas->StretchDraw(dest,Picture);
                                    if (found) {
                                        DrawVectors(BigBitmap->Canvas,pointer);
                                        } else {
                                        DrawVectors(BigBitmap->Canvas);
                                        }
                                    BigBitmap->Canvas->Pen->Color = RectangleList[arraypointer].PenColour;
                                    BigBitmap->Canvas->Pen->Width = RectangleList[arraypointer].LineWidth * subspacesampling;
                                    BigBitmap->Canvas->Brush->Color = RectangleList[arraypointer].BrushColour;
                                    //BigBitmap->Canvas->MoveTo(LineList[arraypointer].StartPoint.x * subspacesampling,LineList[arraypointer].StartPoint.y * subspacesampling);
                                    //BigBitmap->Canvas->LineTo(LineList[arraypointer].EndPoint.x * subspacesampling,LineList[arraypointer].EndPoint.y * subspacesampling);
                                    TPoint points[4];
                                    //points[0] = Point(subspacesampling * (RectangleList[arraypointer].Area.Left),subspacesampling * (RectangleList[arraypointer].Area.Top));
                                    TPoint delta;
                                    double Angle = (double)(RectangleList[arraypointer].Angle)/10.0;
                                    /*
                                    delta.x = RectangleList[arraypointer].Area.Right - RectangleList[arraypointer].Area.Left;
                                    delta.y = RectangleList[arraypointer].Area.Bottom - RectangleList[arraypointer].Area.Top;
                                    points[1] = Point(subspacesampling * (RectangleList[arraypointer].Area.Left + (int)(((double)(delta.y)) * sinD(Angle))),subspacesampling * (RectangleList[arraypointer].Area.Top + (int)(((double)(delta.y)) * cosD(Angle))));
                                    points[2] = Point(subspacesampling * (RectangleList[arraypointer].Area.Left + (int)(((double)(delta.y)) * sinD(Angle)) + (int)(((double)(delta.x)) * cosD(Angle))),subspacesampling * (RectangleList[arraypointer].Area.Top + (int)(((double)(delta.y)) * cosD(Angle)) - (int)(((double)(delta.x)) * sinD(Angle))));
                                    points[3] = Point(subspacesampling * (RectangleList[arraypointer].Area.Left + (int)(((double)(delta.x)) * cosD(Angle))),subspacesampling * (RectangleList[arraypointer].Area.Top - (int)(((double)(delta.x)) * sinD(Angle))));
                                    */
                                    TPoint Ptemp, centre;
                                    centre.x = subspacesampling * RectangleList[arraypointer].Area.Left;
                                    centre.y = subspacesampling * RectangleList[arraypointer].Area.Top;
                                    points[0] = centre;
                                    Ptemp.x = subspacesampling * RectangleList[arraypointer].Area.Left;
                                    Ptemp.y = subspacesampling * RectangleList[arraypointer].Area.Bottom;
                                    points[1] = RotateTPoint(Ptemp,centre,Angle);
                                    Ptemp.x = subspacesampling * RectangleList[arraypointer].Area.Right;
                                    points[2] = RotateTPoint(Ptemp,centre,Angle);
                                    Ptemp.y = subspacesampling * RectangleList[arraypointer].Area.Top;
                                    points[3] = RotateTPoint(Ptemp,centre,Angle);
                                    if (!RectangleList[arraypointer].Filled) BigBitmap->Canvas->Brush->Style = bsClear;
                                    BigBitmap->Canvas->Polygon(points, 3);
                                    //picture complete, now to compress it onto Bitmap
                                    rgb temp;
                                    int R,G,B,c1;
                                    for (int i = 0; i < Bitmap->Width; i++) {
                                        for (int j = 0; j < Bitmap->Height; j++) {
                                            R = 0;
                                            G = 0;
                                            B = 0;
                                            for (int k = 0; k < subspacesampling; k++) {
                                                for (int l = 0; l < subspacesampling; l++) {
                                                    c1 = (int)(BigBitmap->Canvas->Pixels[i*subspacesampling + k][j*subspacesampling + l]);
                                                    temp.B = c1 >> 16;
                                                    c1 = c1 - (temp.B << 16);
                                                    temp.G = c1 >> 8;
                                                    c1 = c1 - (temp.G << 8);
                                                    temp.R = c1;
                                                    R += temp.R;
                                                    G += temp.G;
                                                    B += temp.B;
                                                    }
                                                }
                                            R = R >> subspacesampling;
                                            G = G >> subspacesampling;
                                            B = B >> subspacesampling;
                                            c1 = R + (G << 8) + (B << 16);
                                            Bitmap->Canvas->Pixels[i][j] = (TColor)(c1);
                                            }
                                        }
                                    delete BigBitmap;
                                    //now anti-aliased line is on Bitmap along with the background
                                    } else {
                                    //no anti-aliasing, so draw rectangle directly on Bitmap
                                    if (found) {
                                        DrawVectors(Bitmap->Canvas,pointer);
                                        } else {
                                        DrawVectors(Bitmap->Canvas);
                                        }
                                    Bitmap->Canvas->Pen->Color = RectangleList[arraypointer].PenColour;
                                    Bitmap->Canvas->Pen->Width = RectangleList[arraypointer].LineWidth;
                                    Bitmap->Canvas->Brush->Color = RectangleList[arraypointer].BrushColour;
                                    TPoint points[4];
                                    //points[0] = Point(RectangleList[arraypointer].Area.Left,RectangleList[arraypointer].Area.Top);
                                    TPoint delta;
                                    double Angle = (double)(RectangleList[arraypointer].Angle) / 10.0;
                                    /*
                                    delta.x = RectangleList[arraypointer].Area.Right - RectangleList[arraypointer].Area.Left;
                                    delta.y = RectangleList[arraypointer].Area.Bottom - RectangleList[arraypointer].Area.Top;
                                    points[1] = Point(RectangleList[arraypointer].Area.Left + (int)(((double)(delta.y)) * sinD(Angle)),RectangleList[arraypointer].Area.Top + (int)(((double)(delta.y)) * cosD(Angle)));
                                    points[2] = Point(RectangleList[arraypointer].Area.Left + (int)(((double)(delta.y)) * sinD(Angle)) + (int)(((double)(delta.x)) * cosD(Angle)),RectangleList[arraypointer].Area.Top + (int)(((double)(delta.y)) * cosD(Angle)) - (int)(((double)(delta.x)) * sinD(Angle)));
                                    points[3] = Point(RectangleList[arraypointer].Area.Left + (int)(((double)(delta.x)) * cosD(Angle)),RectangleList[arraypointer].Area.Top - (int)(((double)(delta.x)) * sinD(Angle)));
                                    */
                                    TPoint temp, centre;
                                    centre.x = RectangleList[arraypointer].Area.Left;
                                    centre.y = RectangleList[arraypointer].Area.Top;
                                    points[0] = centre;
                                    temp.x = RectangleList[arraypointer].Area.Left;
                                    temp.y = RectangleList[arraypointer].Area.Bottom;
                                    points[1] = RotateTPoint(temp,centre,Angle);
                                    temp.x = RectangleList[arraypointer].Area.Right;
                                    points[2] = RotateTPoint(temp,centre,Angle);
                                    temp.y = RectangleList[arraypointer].Area.Top;
                                    points[3] = RotateTPoint(temp,centre,Angle);
                                    if (!RectangleList[arraypointer].Filled) Bitmap->Canvas->Brush->Style = bsClear;
                                    Bitmap->Canvas->Polygon(points, 3);
                                    }
                                SquareSize =oldsquare;
                                TopLeft = oldTopLeft;

                                RectangleList[arraypointer].Points.Length = Bitmap->Width * Bitmap->Height + 1;
                                pointer = 0;
                                TColor Colour;

                                for (int i = 0; i < Bitmap->Width; i++) {
                                    for (int j = 0; j < Bitmap->Height; j++) {
                                        if (Bitmap->Canvas->Pixels[i][j] != Reference->Canvas->Pixels[i][j]) {
                                            if (subspacesampling > 0) {
                                                //there is anti-aliasing
                                                if (LocalAlias == TAADMC) {
                                                    //use DMC whole colours for the anti-aliasing
                                                    Colour = FindNearestDMCColour(Bitmap->Canvas->Pixels[i][j]);
                                                    } else {
                                                    //use blended colours for the anti-aliasing
                                                    Colour = FindNearestBlendColour(Bitmap->Canvas->Pixels[i][j]);
                                                    }
                                                } else {
                                                //no antialiasing, so the colour will be a standard colour
                                                Colour = Bitmap->Canvas->Pixels[i][j];
                                                }
                                            RectangleList[arraypointer].Points[pointer].x = i;
                                            RectangleList[arraypointer].Points[pointer].y = j;
                                            RectangleList[arraypointer].Points[pointer].Colour = Colour;
                                            pointer++;
                                            }
                                        }
                                    }
                                RectangleList[arraypointer].Points.Length = pointer;

                                delete Reference;
                                delete Bitmap;
                                }
                                break;
            default:            {
                                //no anti aliasing, very simple line method.
                                Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
                                Bitmap->Width = Picture->Width;
                                Bitmap->Height = Picture->Height;
                                //colour background other than white if needbe
                                TColor BitmapColour = clWhite;
                                if (RectangleList[arraypointer].PenColour == clWhite || RectangleList[arraypointer].BrushColour == clWhite) {
                                    BitmapColour = clSilver;
                                    if (RectangleList[arraypointer].PenColour == clSilver || RectangleList[arraypointer].BrushColour == clSilver) {
                                        BitmapColour = clAqua;
                                        }
                                    }
                                if (BitmapColour != clWhite) {
                                    Bitmap->Canvas->Brush->Color = BitmapColour;
                                    //Bitmap->Canvas->FloodFill(0,0,clWhite,fsSurface);
                                    Bitmap->Canvas->Rectangle(-1,-1,Bitmap->Width + 1,Bitmap->Height + 1);
                                    }

                                //do the rectangle
                                Bitmap->Canvas->Pen->Color = RectangleList[arraypointer].PenColour;
                                Bitmap->Canvas->Pen->Width = RectangleList[arraypointer].LineWidth;
                                Bitmap->Canvas->Brush->Color = RectangleList[arraypointer].BrushColour;
                                Bitmap->Canvas->Brush->Style = bsSolid;
                                TPoint Points[4];
                                TPoint temp, centre;
                                //TRect Rectangle;
                                //int swap;
                                double Angle = ((double)(RectangleList[arraypointer].Angle)) / 10.0;
                                centre.x = RectangleList[arraypointer].Area.Left;
                                centre.y = RectangleList[arraypointer].Area.Top;
                                Points[0] = centre;
                                temp.x = RectangleList[arraypointer].Area.Left;
                                temp.y = RectangleList[arraypointer].Area.Bottom;
                                Points[1] = RotateTPoint(temp,centre,Angle);
                                temp.x = RectangleList[arraypointer].Area.Right;
                                Points[2] = RotateTPoint(temp,centre,Angle);
                                temp.y = RectangleList[arraypointer].Area.Top;
                                Points[3] = RotateTPoint(temp,centre,Angle);
                                if (!RectangleList[arraypointer].Filled) Bitmap->Canvas->Brush->Style = bsClear;
                                Bitmap->Canvas->Polygon(Points, 3);
                                /*
                                Rectangle.Left = centre.x;
                                Rectangle.Top = centre.y;
                                Rectangle.Right = temp.x;
                                Rectangle.Bottom = temp.y;
                                if (Rectangle.Left > Rectangle.Right) {
                                    swap = Rectangle.Left;
                                    Rectangle.Left = Rectangle.Right;
                                    Rectangle.Right = swap;
                                    }
                                if (Rectangle.Top > Rectangle.Bottom) {
                                    swap = Rectangle.Top;
                                    Rectangle.Top = Rectangle.Bottom;
                                    Rectangle.Bottom = swap;
                                    }
                                Bitmap->Canvas->Rectangle(Rectangle.Left,Rectangle.Top,Rectangle.Right,Rectangle.Bottom);
                                */

                                RectangleList[arraypointer].Points.Length = Bitmap->Width * Bitmap->Height + 1;
                                /*
                                TColor BitmapColour = clWhite;
                                if (RectangleList[arraypointer].PenColour == clWhite || RectangleList[arraypointer].BrushColour == clWhite) {
                                    BitmapColour = clSilver;
                                    if (RectangleList[arraypointer].PenColour == clSilver || RectangleList[arraypointer].BrushColour == clSilver) {
                                        BitmapColour = clAqua;
                                        }
                                    }
                                if (BitmapColour != clWhite) {
                                    //Bitmap->Canvas->Brush->Color = BitmapColour;
                                    //Bitmap->Canvas->FloodFill(0,0,clWhite,fsSurface);
                                    Bitmap->Canvas->Rectangle(-1,-1,Bitmap->Width + 1,Bitmap->Height + 1);
                                    }
                                */

                                int pointer = 0;

                                for (int i = 0; i < Bitmap->Width; i++) {
                                    for (int j = 0; j < Bitmap->Height; j++) {
                                        if (Bitmap->Canvas->Pixels[i][j] != BitmapColour) {
                                            RectangleList[arraypointer].Points[pointer].x = i;
                                            RectangleList[arraypointer].Points[pointer].y = j;
                                            RectangleList[arraypointer].Points[pointer].Colour = Bitmap->Canvas->Pixels[i][j];
                                            pointer++;
                                            }
                                        }
                                    }
                                RectangleList[arraypointer].Points.Length = pointer;
                                delete Bitmap;
                                } //end of default anti-aliasing (none!)
                                break;
            }
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::FillPointsCircle(int arraypointer,int ItemNumber)
{
    //fill the points used in a circle & anti-alias as required
    if (CircleList[arraypointer].ItemNumber == ItemNumber) {
        //There are three types of anti Aliasing: None, DMC and Blended
        //The level of oversampling is specified by 'subspacesampling'
        TAntiAlias LocalAlias;
        if (AntiAlias == TAANone) {
            LocalAlias = TAANone;
            } else {
            LocalAlias = AntiAlias;
            }
        switch (LocalAlias) {
            case TAADMC:
            case TAABlend:      {
                                //Find where this Circle is in the display order
                                int pointer = 0;
                                bool found = false;
                                while (!found && pointer < DisplayList.Length) {
                                    if (DisplayList[pointer].ItemNumber == ItemNumber) {
                                        found = true;
                                        pointer--;
                                        }
                                    pointer++;
                                    }

                                //fill in bitmaps
                                Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
                                Graphics::TBitmap *Reference = new Graphics::TBitmap();

                                Bitmap->Assign(Picture);
                                Reference->Assign(Picture);

                                int oldsquare = SquareSize;
                                TPoint oldTopLeft = TopLeft;
                                SquareSize = 1;
                                TopLeft.x = 0;
                                TopLeft.y = 0;
                                //draw reference picture
                                if (found) {
                                    DrawVectors(Reference->Canvas,pointer);
                                    } else {
                                    DrawVectors(Reference->Canvas);
                                    }

                                //draw the rectangle and ensure the result is in 'Bitmap'
                                if (subspacesampling > 0) {
                                    //there is anti-aliasing, so draw everything on a bigger bitmap and then shrink it down onto bitmap
                                    SquareSize = subspacesampling;
                                    Graphics::TBitmap *BigBitmap = new Graphics::TBitmap();
                                    BigBitmap->Width = Picture->Width * subspacesampling;
                                    BigBitmap->Height = Picture->Height * subspacesampling;
                                    TRect dest;
                                    dest.Left = 0;
                                    dest.Top = 0;
                                    dest.Right = BigBitmap->Width;
                                    dest.Bottom = BigBitmap->Height;
                                    BigBitmap->Canvas->StretchDraw(dest,Picture);
                                    if (found) {
                                        DrawVectors(BigBitmap->Canvas,pointer);
                                        } else {
                                        DrawVectors(BigBitmap->Canvas);
                                        }
                                    BigBitmap->Canvas->Pen->Color = CircleList[arraypointer].PenColour;
                                    BigBitmap->Canvas->Pen->Width = CircleList[arraypointer].LineWidth * subspacesampling;
                                    BigBitmap->Canvas->Brush->Color = CircleList[arraypointer].BrushColour;
                                    TPoint points[36];
                                    TPoint arccentre;
                                    double r1 = ((double)(subspacesampling * CircleList[arraypointer].Area.Right) - (double)(subspacesampling * CircleList[arraypointer].Area.Left))/2.0;
                                    double r2 = ((double)(subspacesampling * CircleList[arraypointer].Area.Bottom) - (double)(subspacesampling * CircleList[arraypointer].Area.Top))/2.0;
                                    arccentre.x = subspacesampling * CircleList[arraypointer].Area.Left + (int)(r1);
                                    arccentre.y = subspacesampling * CircleList[arraypointer].Area.Top + (int)(r2);
                                    double Angle = (double)(CircleList[arraypointer].Angle)/10.0;
                                    TPoint centre;
                                    centre.x = subspacesampling * CircleList[arraypointer].Area.Left;
                                    centre.y = subspacesampling * CircleList[arraypointer].Area.Top;
                                    int localangle;
                                    for (int i = 0; i < 36; i++) {
                                        localangle = 10.0 * ((double)(i));
                                        points[i].x = arccentre.x + (int)(r1 * cosD(localangle));
                                        points[i].y = arccentre.y - (int)(r2 * sinD(localangle));
                                        points[i] = RotateTPoint(points[i],centre,Angle);
                                        }
                                    //if (!CircleList[arraypointer].Filled) BigBitmap->Canvas->Brush->Style = bsClear;
                                    //BigBitmap->Canvas->Polygon(points, 35);
                                    if (CircleList[arraypointer].Filled) {
                                        BigBitmap->Canvas->Polygon(points, 35);
                                        } else {
                                        BigBitmap->Canvas->MoveTo(points[0].x,points[0].y);
                                        for (int i = 1; i < 36; i++) {
                                            BigBitmap->Canvas->LineTo(points[i].x,points[i].y);
                                            }
                                        BigBitmap->Canvas->LineTo(points[0].x,points[0].y);
                                        }
                                    //picture complete, now to compress it onto Bitmap
                                    rgb temp;
                                    int R,G,B,c1;
                                    for (int i = 0; i < Bitmap->Width; i++) {
                                        for (int j = 0; j < Bitmap->Height; j++) {
                                            R = 0;
                                            G = 0;
                                            B = 0;
                                            for (int k = 0; k < subspacesampling; k++) {
                                                for (int l = 0; l < subspacesampling; l++) {
                                                    c1 = (int)(BigBitmap->Canvas->Pixels[i*subspacesampling + k][j*subspacesampling + l]);
                                                    temp.B = c1 >> 16;
                                                    c1 = c1 - (temp.B << 16);
                                                    temp.G = c1 >> 8;
                                                    c1 = c1 - (temp.G << 8);
                                                    temp.R = c1;
                                                    R += temp.R;
                                                    G += temp.G;
                                                    B += temp.B;
                                                    }
                                                }
                                            R = R >> subspacesampling;
                                            G = G >> subspacesampling;
                                            B = B >> subspacesampling;
                                            c1 = R + (G << 8) + (B << 16);
                                            Bitmap->Canvas->Pixels[i][j] = (TColor)(c1);
                                            }
                                        }
                                    delete BigBitmap;
                                    //now anti-aliased line is on Bitmap along with the background
                                    } else {
                                    //no anti-aliasing, so draw circle directly on Bitmap
                                    if (found) {
                                        DrawVectors(Bitmap->Canvas,pointer);
                                        } else {
                                        DrawVectors(Bitmap->Canvas);
                                        }
                                    Bitmap->Canvas->Pen->Color = CircleList[arraypointer].PenColour;
                                    Bitmap->Canvas->Pen->Width = CircleList[arraypointer].LineWidth;
                                    Bitmap->Canvas->Brush->Color = CircleList[arraypointer].BrushColour;
                                    TPoint points[36];
                                    TPoint arccentre;
                                    double r1 = ((double)(CircleList[arraypointer].Area.Right) - (double)(CircleList[arraypointer].Area.Left))/2.0;
                                    double r2 = ((double)(CircleList[arraypointer].Area.Bottom) - (double)(CircleList[arraypointer].Area.Top))/2.0;
                                    arccentre.x = CircleList[arraypointer].Area.Left + (int)(r1);
                                    arccentre.y = CircleList[arraypointer].Area.Top + (int)(r2);
                                    double Angle = (double)(CircleList[arraypointer].Angle)/10.0;
                                    TPoint centre;
                                    centre.x = CircleList[arraypointer].Area.Left;
                                    centre.y = CircleList[arraypointer].Area.Top;
                                    int localangle;
                                    for (int i = 0; i < 36; i++) {
                                        localangle = 10.0 * ((double)(i));
                                        points[i].x = arccentre.x + (int)(r1 * cosD(localangle));
                                        points[i].y = arccentre.y - (int)(r2 * sinD(localangle));
                                        points[i] = RotateTPoint(points[i],centre,Angle);
                                        }
                                    //if (!CircleList[arraypointer].Filled) Bitmap->Canvas->Brush->Style = bsClear;
                                    //Bitmap->Canvas->Polygon(points, 35);
                                    if (CircleList[arraypointer].Filled) {
                                        Bitmap->Canvas->Polygon(points, 35);
                                        } else {
                                        Bitmap->Canvas->MoveTo(points[0].x,points[0].y);
                                        for (int i = 1; i < 36; i++) {
                                            Bitmap->Canvas->LineTo(points[i].x,points[i].y);
                                            }
                                        Bitmap->Canvas->LineTo(points[0].x,points[0].y);
                                        }
                                    }
                                SquareSize =oldsquare;
                                TopLeft = oldTopLeft;

                                CircleList[arraypointer].Points.Length = Bitmap->Width * Bitmap->Height + 1;
                                pointer = 0;
                                TColor Colour;

                                for (int i = 0; i < Bitmap->Width; i++) {
                                    for (int j = 0; j < Bitmap->Height; j++) {
                                        if (Bitmap->Canvas->Pixels[i][j] != Reference->Canvas->Pixels[i][j]) {
                                            if (subspacesampling > 0) {
                                                //there is anti-aliasing
                                                if (LocalAlias == TAADMC) {
                                                    //use DMC whole colours for the anti-aliasing
                                                    Colour = FindNearestDMCColour(Bitmap->Canvas->Pixels[i][j]);
                                                    } else {
                                                    //use blended colours for the anti-aliasing
                                                    Colour = FindNearestBlendColour(Bitmap->Canvas->Pixels[i][j]);
                                                    }
                                                } else {
                                                //no antialiasing, so the colour will be a standard colour
                                                Colour = Bitmap->Canvas->Pixels[i][j];
                                                }
                                            CircleList[arraypointer].Points[pointer].x = i;
                                            CircleList[arraypointer].Points[pointer].y = j;
                                            CircleList[arraypointer].Points[pointer].Colour = Colour;
                                            pointer++;
                                            }
                                        }
                                    }
                                CircleList[arraypointer].Points.Length = pointer;

                                delete Reference;
                                delete Bitmap;
                                }
                                break;
            default:            {
                                //no anti aliasing, very simple line method.
                                Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
                                Bitmap->Width = Picture->Width;
                                Bitmap->Height = Picture->Height;
                                //colour background
                                TColor BitmapColour = clWhite;
                                if (CircleList[arraypointer].PenColour == clWhite || CircleList[arraypointer].BrushColour == clWhite) {
                                    BitmapColour = clSilver;
                                    if (CircleList[arraypointer].PenColour == clSilver || CircleList[arraypointer].BrushColour == clSilver) {
                                        BitmapColour = clAqua;
                                        }
                                    }
                                if (BitmapColour != clWhite) {
                                    Bitmap->Canvas->Brush->Color = BitmapColour;
                                    //Bitmap->Canvas->FloodFill(0,0,clWhite,fsSurface);
                                    Bitmap->Canvas->Rectangle(-1,-1,Bitmap->Width + 1,Bitmap->Height + 1);
                                    }
                                //draw foreground
                                Bitmap->Canvas->Pen->Color = CircleList[arraypointer].PenColour;
                                Bitmap->Canvas->Pen->Width = CircleList[arraypointer].LineWidth;
                                Bitmap->Canvas->Brush->Color = CircleList[arraypointer].BrushColour;
                                Bitmap->Canvas->Brush->Style = bsSolid;
                                TPoint points[36];
                                TPoint arccentre;
                                double r1 = ((double)(CircleList[arraypointer].Area.Right) - (double)(CircleList[arraypointer].Area.Left))/2.0;
                                double r2 = ((double)(CircleList[arraypointer].Area.Bottom) - (double)(CircleList[arraypointer].Area.Top))/2.0;
                                arccentre.x = CircleList[arraypointer].Area.Left + (int)(r1);
                                arccentre.y = CircleList[arraypointer].Area.Top + (int)(r2);
                                double Angle = (double)(CircleList[arraypointer].Angle)/10.0;
                                TPoint centre;
                                centre.x = CircleList[arraypointer].Area.Left;
                                centre.y = CircleList[arraypointer].Area.Top;
                                int localangle;
                                for (int i = 0; i < 36; i++) {
                                    localangle = 10.0 * ((double)(i));
                                    points[i].x = arccentre.x + (int)(r1 * cosD(localangle));
                                    points[i].y = arccentre.y - (int)(r2 * sinD(localangle));
                                    points[i] = RotateTPoint(points[i],centre,Angle);
                                    }
                                /*
                                TColor BitmapColour = clWhite;
                                if (CircleList[arraypointer].PenColour == clWhite || CircleList[arraypointer].BrushColour == clWhite) {
                                    BitmapColour = clSilver;
                                    if (CircleList[arraypointer].PenColour == clSilver || CircleList[arraypointer].BrushColour == clSilver) {
                                        BitmapColour = clAqua;
                                        }
                                    }
                                if (BitmapColour != clWhite) {
                                    Bitmap->Canvas->Brush->Color = BitmapColour;
                                    //Bitmap->Canvas->FloodFill(0,0,clWhite,fsSurface);
                                    Bitmap->Canvas->Rectangle(-1,-1,Bitmap->Width + 1,Bitmap->Height + 1);
                                    }
                                */
                                    
                                //if (!CircleList[arraypointer].Filled) Bitmap->Canvas->Brush->Style = bsClear;
                                //Bitmap->Canvas->Polygon(points, 35);
                                if (CircleList[arraypointer].Filled) {
                                    Bitmap->Canvas->Polygon(points, 35);
                                    } else {
                                    Bitmap->Canvas->MoveTo(points[0].x,points[0].y);
                                    for (int i = 1; i < 36; i++) {
                                        Bitmap->Canvas->LineTo(points[i].x,points[i].y);
                                        }
                                    Bitmap->Canvas->LineTo(points[0].x,points[0].y);
                                    }

                                CircleList[arraypointer].Points.Length = Bitmap->Width * Bitmap->Height + 1;

                                /*TColor BitmapColour = clWhite;
                                if (CircleList[arraypointer].PenColour == clWhite || CircleList[arraypointer].BrushColour == clWhite) {
                                    BitmapColour = clSilver;
                                    if (CircleList[arraypointer].PenColour == clSilver || CircleList[arraypointer].BrushColour == clSilver) {
                                        BitmapColour = clAqua;
                                        }
                                    }
                                if (BitmapColour != clWhite) {
                                    Bitmap->Canvas->Brush->Color = BitmapColour;
                                    Bitmap->Canvas->FloodFill(0,0,clWhite,fsSurface);
                                    } */

                                int pointer = 0;

                                for (int i = 0; i < Bitmap->Width; i++) {
                                    for (int j = 0; j < Bitmap->Height; j++) {
                                        if (Bitmap->Canvas->Pixels[i][j] != BitmapColour) {
                                            CircleList[arraypointer].Points[pointer].x = i;
                                            CircleList[arraypointer].Points[pointer].y = j;
                                            CircleList[arraypointer].Points[pointer].Colour = Bitmap->Canvas->Pixels[i][j];
                                            pointer++;
                                            }
                                        }
                                    }
                                CircleList[arraypointer].Points.Length = pointer;
                                delete Bitmap;
                                } //end of default anti-aliasing (none!)
                                break;
            }
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::FillPointsFreeForm(int arraypointer,int ItemNumber)
{
    //fill the points used in a FreeForm & anti-alias as required
    if (FreeFormList[arraypointer].ItemNumber == ItemNumber) {
        //There are three types of anti Aliasing: None, DMC and Blended
        //The level of oversampling is specified by 'subspacesampling'
        switch (AntiAlias) {
            case TAADMC:
            case TAABlend:      {
                                //So, need two bitmaps. A reference bitmap and the one with text on it.
                                //Both bitmaps have everything drawn on them up to the display item below the text we're
                                //dealing with at the moment.
                                //Find where this text is in the display order
                                int pointer = 0;
                                bool found = false;
                                while (!found && pointer < DisplayList.Length) {
                                    if (DisplayList[pointer].ItemNumber == ItemNumber) {
                                        found = true;
                                        pointer--;
                                        }
                                    pointer++;
                                    }

                                //fill in bitmaps
                                Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
                                Graphics::TBitmap *Reference = new Graphics::TBitmap();

                                Bitmap->Assign(Picture);
                                Reference->Assign(Picture);

                                int oldsquare = SquareSize;
                                TPoint oldTopLeft = TopLeft;
                                SquareSize = 1;
                                TopLeft.x = 0;
                                TopLeft.y = 0;
                                //draw reference picture
                                if (found) {
                                    DrawVectors(Reference->Canvas,pointer);
                                    } else {
                                    DrawVectors(Reference->Canvas);
                                    }

                                //draw the FreeForm and ensure the result is in 'Bitmap'
                                if (subspacesampling > 0) {
                                    //there is anti-aliasing, so draw everything on a bigger bitmap and then shrink it down onto bitmap
                                    SquareSize = subspacesampling;
                                    Graphics::TBitmap *BigBitmap = new Graphics::TBitmap();
                                    BigBitmap->Width = Picture->Width * subspacesampling;
                                    BigBitmap->Height = Picture->Height * subspacesampling;
                                    TRect dest;
                                    dest.Left = 0;
                                    dest.Top = 0;
                                    dest.Right = BigBitmap->Width;
                                    dest.Bottom = BigBitmap->Height;
                                    BigBitmap->Canvas->StretchDraw(dest,Picture);
                                    if (found) {
                                        DrawVectors(BigBitmap->Canvas,pointer);
                                        } else {
                                        DrawVectors(BigBitmap->Canvas);
                                        }
                                    BigBitmap->Canvas->Pen->Color = FreeFormList[arraypointer].PenColour;
                                    BigBitmap->Canvas->Pen->Width = FreeFormList[arraypointer].LineWidth * subspacesampling;
                                    BigBitmap->Canvas->Brush->Color = FreeFormList[arraypointer].BrushColour;
                                    if (FreeFormList[arraypointer].Corners.Length < 1000) {
                                        TPoint points[1000];
                                        for (int i = 0; i < FreeFormList[arraypointer].Corners.Length; i++) {
                                            points[i].x = FreeFormList[arraypointer].Corners[i].x * subspacesampling;
                                            points[i].y = FreeFormList[arraypointer].Corners[i].y * subspacesampling;
                                            }
                                        int length = FreeFormList[arraypointer].Corners.Length - 1;
                                        if (!FreeFormList[arraypointer].filled) BigBitmap->Canvas->Brush->Style = bsClear;
                                        BigBitmap->Canvas->Polygon(points, length);
                                        }
                                    rgb temp;
                                    int R,G,B,c1;
                                    for (int i = 0; i < Bitmap->Width; i++) {
                                        for (int j = 0; j < Bitmap->Height; j++) {
                                            R = 0;
                                            G = 0;
                                            B = 0;
                                            for (int k = 0; k < subspacesampling; k++) {
                                                for (int l = 0; l < subspacesampling; l++) {
                                                    c1 = (int)(BigBitmap->Canvas->Pixels[i*subspacesampling + k][j*subspacesampling + l]);
                                                    temp.B = c1 >> 16;
                                                    c1 = c1 - (temp.B << 16);
                                                    temp.G = c1 >> 8;
                                                    c1 = c1 - (temp.G << 8);
                                                    temp.R = c1;
                                                    R += temp.R;
                                                    G += temp.G;
                                                    B += temp.B;
                                                    }
                                                }
                                            R = R >> subspacesampling;
                                            G = G >> subspacesampling;
                                            B = B >> subspacesampling;
                                            c1 = R + (G << 8) + (B << 16);
                                            Bitmap->Canvas->Pixels[i][j] = (TColor)(c1);
                                            }
                                        }
                                    delete BigBitmap;
                                    //now anti-aliased line is on Bitmap along with the background
                                    } else {
                                    //no anti-aliasing, so draw line directly on Bitmap
                                    if (found) {
                                        DrawVectors(Bitmap->Canvas,pointer);
                                        } else {
                                        DrawVectors(Bitmap->Canvas);
                                        }
                                    Bitmap->Canvas->Pen->Color = FreeFormList[arraypointer].PenColour;
                                    Bitmap->Canvas->Pen->Width = FreeFormList[arraypointer].LineWidth;
                                    Bitmap->Canvas->Brush->Color = FreeFormList[arraypointer].BrushColour;
                                    if (FreeFormList[arraypointer].Corners.Length < 1000) {
                                        TPoint points[1000];
                                        for (int i = 0; i < FreeFormList[arraypointer].Corners.Length; i++) {
                                            points[i].x = FreeFormList[arraypointer].Corners[i].x;
                                            points[i].y = FreeFormList[arraypointer].Corners[i].y;
                                            }
                                        int length = FreeFormList[arraypointer].Corners.Length - 1;
                                        if (!FreeFormList[arraypointer].filled) Bitmap->Canvas->Brush->Style = bsClear;
                                        Bitmap->Canvas->Polygon(points, length);
                                        }
                                    }
                                SquareSize =oldsquare;
                                TopLeft = oldTopLeft;

                                FreeFormList[arraypointer].Points.Length = Bitmap->Width * Bitmap->Height + 1;
                                pointer = 0;
                                TColor Colour;

                                for (int i = 0; i < Bitmap->Width; i++) {
                                    for (int j = 0; j < Bitmap->Height; j++) {
                                        if (Bitmap->Canvas->Pixels[i][j] != Reference->Canvas->Pixels[i][j]) {
                                            if (subspacesampling > 0) {
                                                //there is anti-aliasing
                                                if (AntiAlias == TAADMC) {
                                                    //use DMC whole colours for the anti-aliasing
                                                    Colour = FindNearestDMCColour(Bitmap->Canvas->Pixels[i][j]);
                                                    } else {
                                                    //use blended colours for the anti-aliasing
                                                    Colour = FindNearestBlendColour(Bitmap->Canvas->Pixels[i][j]);
                                                    }
                                                } else {
                                                //no antialiasing, so the colour will be linecolour
                                                Colour = FreeFormList[arraypointer].PenColour;
                                                }
                                            FreeFormList[arraypointer].Points[pointer].x = i;
                                            FreeFormList[arraypointer].Points[pointer].y = j;
                                            FreeFormList[arraypointer].Points[pointer].Colour = Colour;
                                            pointer++;
                                            }
                                        }
                                    }
                                FreeFormList[arraypointer].Points.Length = pointer;

                                delete Reference;
                                delete Bitmap;
                                }
                                break;
            default:            {
                                //no anti aliasing, very simple line method.
                                Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
                                Bitmap->Width = Picture->Width;
                                Bitmap->Height = Picture->Height;
                                TColor BitmapColour = clWhite;
                                if (FreeFormList[arraypointer].PenColour == clWhite || FreeFormList[arraypointer].BrushColour == clWhite) {
                                    BitmapColour = clSilver;
                                    if (FreeFormList[arraypointer].PenColour == clSilver || FreeFormList[arraypointer].BrushColour == clSilver) {
                                        BitmapColour = clAqua;
                                        }
                                    }
                                if (BitmapColour != clWhite) {
                                    Bitmap->Canvas->Brush->Color = BitmapColour;
                                    //Bitmap->Canvas->FloodFill(0,0,clWhite,fsSurface);
                                    Bitmap->Canvas->Rectangle(-1,-1,Bitmap->Width + 1,Bitmap->Height + 1);
                                    }
                                Bitmap->Canvas->Pen->Color = FreeFormList[arraypointer].PenColour;
                                Bitmap->Canvas->Pen->Width = FreeFormList[arraypointer].LineWidth;
                                Bitmap->Canvas->Brush->Color = FreeFormList[arraypointer].BrushColour;
                                TPoint points[1000];
                                int length = FreeFormList[arraypointer].Corners.Length;
                                if (length > 1000) length = 1000;
                                for (int i = 0; i < length; i++) {
                                    points[i].x = FreeFormList[arraypointer].Corners[i].x;
                                    points[i].y = FreeFormList[arraypointer].Corners[i].y;
                                    }
                                length--;
                                if (!FreeFormList[arraypointer].filled) Bitmap->Canvas->Brush->Style = bsClear;
                                Bitmap->Canvas->Polygon(points, length);
                                FreeFormList[arraypointer].Points.Length = Bitmap->Width * Bitmap->Height + 1;
                                int pointer = 0;

                                for (int i = 0; i < Bitmap->Width; i++) {
                                    for (int j = 0; j < Bitmap->Height; j++) {
                                        if (Bitmap->Canvas->Pixels[i][j] != BitmapColour) {
                                            FreeFormList[arraypointer].Points[pointer].x = i;
                                            FreeFormList[arraypointer].Points[pointer].y = j;
                                            FreeFormList[arraypointer].Points[pointer].Colour = Bitmap->Canvas->Pixels[i][j];
                                            pointer++;
                                            }
                                        }
                                    }
                                FreeFormList[arraypointer].Points.Length = pointer;
                                delete Bitmap;
                                } //end of default anti-aliasing (none!)
                                break;
            }
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::FillPointsBlock(int arraypointer,int ItemNumber)
{
    //transform the points used in a block from their origin
    if (BlockList[arraypointer].ItemNumber == ItemNumber) {
        TPoint RotationCentre = BlockList[arraypointer].RotationCentre;
        double Angle = ((double)(BlockList[arraypointer].Angle))/10.0;
        TPoint MirrorCentre = BlockList[arraypointer].MirrorCentre;
        bool mirror = (bool)(BlockList[arraypointer].Axis != TMANone);
        TMirrorAxis Axis = BlockList[arraypointer].Axis;
        TPoint Point;
        TPoint delta;
        delta = BlockList[arraypointer].delta;
        int swap;
        for (int i = 0; i < BlockList[arraypointer].Points.Length; i++) {
            Point.x = BlockList[arraypointer].Points[i].originalx;
            Point.y = BlockList[arraypointer].Points[i].originaly;
            if (Angle != 0.0) {
                if (Angle == 270.0) {
                    Point.x = Point.x - RotationCentre.x;
                    Point.y = Point.y - RotationCentre.y;
                    swap = Point.x;
                    Point.x = -1 * Point.y;
                    Point.y = swap;
                    Point.x = Point.x + RotationCentre.x;
                    Point.y = Point.y + RotationCentre.y;
                    } else {
                    if (Angle == 180.0) {
                        Point.x = Point.x - RotationCentre.x;
                        Point.y = Point.y - RotationCentre.y;
                        Point.x = -1 * Point.x;
                        Point.y = -1 * Point.y;
                        Point.x = Point.x + RotationCentre.x;
                        Point.y = Point.y + RotationCentre.y;
                        } else {
                        if (Angle == 90.0) {
                            Point.x = Point.x - RotationCentre.x;
                            Point.y = Point.y - RotationCentre.y;
                            swap = -1 * Point.x;
                            Point.x = Point.y;
                            Point.y = swap;
                            Point.x = Point.x + RotationCentre.x;
                            Point.y = Point.y + RotationCentre.y;
                            } else {
                            Point = RotateTPoint(Point, RotationCentre, Angle);
                            }
                        }
                    }
                }
            if (mirror) {
                Point = MirrorTPoint(Point,MirrorCentre, Axis);
                }
            BlockList[arraypointer].Points[i].x = Point.x + delta.x;
            BlockList[arraypointer].Points[i].y = Point.y + delta.y;
            }
        }
}
//---------------------------------------------------------------------------

TColor __fastcall TImageEditorForm::FindNearestDMCColour(TColor Colour)
{
    rgb splitrgb,modified;
    TColor ReturnColour;
    TColor tempcolour = Colour;
    splitrgb = ExtractRGB(tempcolour);
    double numb = (double)(colourspacedivisions);

    //reducing colour space divisions
    modified.R = (int)(ROUND(((double)splitrgb.R)*numb/255.0,0) * 255.0 / numb);
    modified.G = (int)(ROUND(((double)splitrgb.G)*numb/255.0,0) * 255.0 / numb);
    modified.B = (int)(ROUND(((double)splitrgb.B)*numb/255.0,0) * 255.0 / numb);
    //TColor newcolour = GetColourFromRGB(modified);

    //finding nearest colour
    DynamicArray <int> ColourSquares;
    ColourSquares.Length = DMCColourList.Length;
    for (int k = 0; k < DMCColourList.Length; k++) {
        ColourSquares[k] = (modified.R - DMCColourList[k].R) * (modified.R - DMCColourList[k].R) + (modified.G - DMCColourList[k].G) * (modified.G - DMCColourList[k].G) + (modified.B - DMCColourList[k].B) * (modified.B - DMCColourList[k].B);
        }
    int value = ColourSquares[0];
    int pointer = 0;
    for (int k = 1; k < ColourSquares.Length; k++) {
        if (ColourSquares[k] < value) {
            value = ColourSquares[k];
            pointer = k;
            }
        }

    //finishing off
    ReturnColour = DMCColourList[pointer].Colour;
    ColourSquares.Length = 0;

    return ReturnColour;
}
//---------------------------------------------------------------------------

TColor __fastcall TImageEditorForm::FindNearestBlendColour(TColor Colour)
{
    rgb splitrgb,modified;
    TColor ReturnColour;
    TColor tempcolour = Colour;
    splitrgb = ExtractRGB(tempcolour);
    double numb = (double)(colourspacedivisions);

    //reducing colour space divisions
    modified.R = (int)(ROUND(((double)splitrgb.R)*numb/255.0,0) * 255.0 / numb);
    modified.G = (int)(ROUND(((double)splitrgb.G)*numb/255.0,0) * 255.0 / numb);
    modified.B = (int)(ROUND(((double)splitrgb.B)*numb/255.0,0) * 255.0 / numb);
    //TColor newcolour = GetColourFromRGB(modified);

    //finding nearest colour
    DynamicArray <int> ColourSquares;
    ColourSquares.Length = DMCColourList.Length + TweedList.Length;
    int L = TweedList.Length;
    for (int k = 0; k < TweedList.Length; k++) {
        ColourSquares[k] = (modified.R - TweedList[k].R) * (modified.R - TweedList[k].R) + (modified.G - TweedList[k].G) * (modified.G - TweedList[k].G) + (modified.B - TweedList[k].B) * (modified.B - TweedList[k].B);
        }
    for (int k = L; k < (L + DMCColourList.Length); k++) {
        ColourSquares[k] = (modified.R - DMCColourList[k - L].R) * (modified.R - DMCColourList[k - L].R) + (modified.G - DMCColourList[k - L].G) * (modified.G - DMCColourList[k - L].G) + (modified.B - DMCColourList[k - L].B) * (modified.B - DMCColourList[k - L].B);
        }
    int value = ColourSquares[0];
    int pointer = 0;
    for (int k = 1; k < ColourSquares.Length; k++) {
        if (ColourSquares[k] < value) {
            value = ColourSquares[k];
            pointer = k;
            }
        }

    //finishing off
    if (pointer < L) {
        ReturnColour = TweedList[pointer].Colour;
        blendthreads = true;
        } else {
        ReturnColour = DMCColourList[pointer - L].Colour;
        }
    ColourSquares.Length = 0;

    return ReturnColour;
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::SetBlendThreads(bool bvalue)
{
    if (bvalue && !fblendthreads) {
        fblendthreads = true;
        Image3->Visible = true;
        Label2->Visible = true;
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::RegenerateObject(TObject *Sender)
{
    //regenerates anti-aliasing for the selected entities
    CreateXRefs();
    if (dynamic_cast < TComponent *>(Sender) ) {
        TDisplayType DisplayType = (TDisplayType) (dynamic_cast < TComponent *>(Sender)->Tag);
        TerminateCurrentAction();
        switch (DisplayType) {
            case TDisplayFreeForm:      {
                                        AddUndoTitle("Regenerate Selected Free-Form Shapes");
                                        SingleUndo = false;
                                        for (int i = 0; i < DisplayList.Length; i++) {
                                            if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayFreeForm && XRefs[DisplayList[i].ItemNumber].DisplayType == TDisplayFreeForm) {
                                                int pointer = XRefs[DisplayList[i].ItemNumber].EntityXRef;
                                                AddUndoChangeFreeForm(FreeFormList[pointer].ItemNumber);
                                                FillPointsFreeForm(XRefs[DisplayList[i].ItemNumber].EntityXRef,DisplayList[i].ItemNumber);
                                                DisplayListAreaUpdate(DisplayList[i].ItemNumber);
                                                if (deselectafteroperation) {
                                                    AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                                                    DisplayList[i].selected = false;
                                                    }
                                                }
                                            }
                                        SingleUndo = true;
                                        }
                                        break;
            case TDisplayCircle:        {
                                        AddUndoTitle("Regenerate Selected Ellipses/Circles");
                                        SingleUndo = false;
                                        for (int i = 0; i < DisplayList.Length; i++) {
                                            if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayCircle && XRefs[DisplayList[i].ItemNumber].DisplayType == TDisplayCircle) {
                                                int pointer = XRefs[DisplayList[i].ItemNumber].EntityXRef;
                                                AddUndoChangeCircle(CircleList[pointer].ItemNumber);
                                                FillPointsCircle(XRefs[DisplayList[i].ItemNumber].EntityXRef,DisplayList[i].ItemNumber);
                                                DisplayListAreaUpdate(DisplayList[i].ItemNumber);
                                                if (deselectafteroperation) {
                                                    AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                                                    DisplayList[i].selected = false;
                                                    }
                                                }
                                            }
                                        SingleUndo = true;
                                        }
                                        break;
            case TDisplayRectangle:     {
                                        AddUndoTitle("Regenerate Selected Rectangles");
                                        SingleUndo = false;
                                        for (int i = 0; i < DisplayList.Length; i++) {
                                            if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayRectangle && XRefs[DisplayList[i].ItemNumber].DisplayType == TDisplayRectangle) {
                                                int pointer = XRefs[DisplayList[i].ItemNumber].EntityXRef;
                                                AddUndoChangeRectangle(RectangleList[pointer].ItemNumber);
                                                FillPointsRectangle(XRefs[DisplayList[i].ItemNumber].EntityXRef,DisplayList[i].ItemNumber);
                                                DisplayListAreaUpdate(DisplayList[i].ItemNumber);
                                                if (deselectafteroperation) {
                                                    AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                                                    DisplayList[i].selected = false;
                                                    }
                                                }
                                            }
                                        SingleUndo = true;
                                        }
                                        break;
            case TDisplayText:          {
                                        AddUndoTitle("Regenerate Selected Text");
                                        SingleUndo = false;
                                        for (int i = 0; i < DisplayList.Length; i++) {
                                            if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayText && XRefs[DisplayList[i].ItemNumber].DisplayType == TDisplayText) {
                                                int pointer = XRefs[DisplayList[i].ItemNumber].EntityXRef;
                                                AddUndoChangeText(TextList[pointer].ItemNumber);
                                                FillPointsText(XRefs[DisplayList[i].ItemNumber].EntityXRef,DisplayList[i].ItemNumber);
                                                DisplayListAreaUpdate(DisplayList[i].ItemNumber);
                                                if (deselectafteroperation) {
                                                    AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                                                    DisplayList[i].selected = false;
                                                    }
                                                }
                                            }
                                        SingleUndo = true;
                                        }
                                        break;
            case TDisplayPolyLine:      {
                                        AddUndoTitle("Regenerate Selected Polyline(s)");
                                        SingleUndo = false;
                                        for (int i = 0; i < DisplayList.Length; i++) {
                                            if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayPolyLine && XRefs[DisplayList[i].ItemNumber].DisplayType == TDisplayPolyLine) {
                                                int pointer = XRefs[DisplayList[i].ItemNumber].EntityXRef;
                                                AddUndoChangePolyLine(DisplayList[i].ItemNumber);
                                                FillPointsPolyLine(pointer,DisplayList[i].ItemNumber);
                                                DisplayListAreaUpdate(DisplayList[i].ItemNumber);
                                                if (deselectafteroperation) {
                                                    AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                                                    DisplayList[i].selected = false;
                                                    }
                                                }
                                            }
                                        SingleUndo = true;
                                        }
                                        break;
            case TDisplayLine:          {
                                        AddUndoTitle("Regenerate Selected Line(s)");
                                        SingleUndo = false;
                                        for (int i = 0; i < DisplayList.Length; i++) {
                                            if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayLine && XRefs[DisplayList[i].ItemNumber].DisplayType == TDisplayLine) {
                                                int pointer = XRefs[DisplayList[i].ItemNumber].EntityXRef;
                                                AnsiString text;
                                                text = "Line,ChangeContents," + AnsiString(LineList[pointer].ItemNumber) + ","
                                                                + AnsiString((int)(LineList[pointer].Colour)) + ","
                                                                + AnsiString(LineList[pointer].LineWidth) + ","
                                                                + AnsiString(LineList[pointer].StartPoint.x) + ","
                                                                + AnsiString(LineList[pointer].StartPoint.y) + ","
                                                                + AnsiString(LineList[pointer].EndPoint.x) + ","
                                                                + AnsiString(LineList[pointer].EndPoint.y) + ","
                                                                ;
                                                for (int j = 0; j < LineList[pointer].Points.Length; j++) {
                                                    text = text + AnsiString(LineList[pointer].Points[j].x) + "," + AnsiString(LineList[pointer].Points[j].y) + "," + AnsiString((int)(LineList[pointer].Points[j].Colour)) + ",";
                                                    }
                                                AddUndo(text);
                                                FillPointsLine(XRefs[DisplayList[i].ItemNumber].EntityXRef,DisplayList[i].ItemNumber);
                                                DisplayListAreaUpdate(DisplayList[i].ItemNumber);
                                                if (deselectafteroperation) {
                                                    AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                                                    DisplayList[i].selected = false;
                                                    }
                                                }
                                            }
                                        SingleUndo = true;
                                        }
                                        break;
            default:                    break;
            }
        Image1->Cursor = crTargetCursor;
        //Timer1->Enabled = true;
        preparetosaveundo = false;
        ResetActionButtons();
        DrawPicture();
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DisplayListAreaUpdate(int ItemNumber)
{
    CreateXRefs();
    if (ItemNumber > -1 && ItemNumber < XRefs.Length) {
        TDisplayType DisplayType = XRefs[ItemNumber].DisplayType;
        int displayarrayentry = XRefs[ItemNumber].DisplayXRef;
        int entityarrayentry = XRefs[ItemNumber].EntityXRef;

        if (displayarrayentry > -1 && entityarrayentry > -1 && displayarrayentry < DisplayList.Length && DisplayType == DisplayList[displayarrayentry].DisplayType  && ItemNumber == DisplayList[displayarrayentry].ItemNumber) {
            switch (DisplayType) {
                case TDisplayPoint:     {
                                        if (entityarrayentry < PointList.Length && PointList[entityarrayentry].ItemNumber == ItemNumber && PointList[entityarrayentry].Points.Length) {
                                            DisplayList[displayarrayentry].UndoName = "Point (" + AnsiString(ItemNumber) + ")";
                                            DisplayList[displayarrayentry].Area.Left = PointList[entityarrayentry].Points[0].x;
                                            DisplayList[displayarrayentry].Area.Top = PointList[entityarrayentry].Points[0].y;
                                            DisplayList[displayarrayentry].Area.Right = PointList[entityarrayentry].Points[0].x;
                                            DisplayList[displayarrayentry].Area.Bottom = PointList[entityarrayentry].Points[0].y;
                                            for (int i = 1; i < PointList[entityarrayentry].Points.Length; i++) {
                                                if (DisplayList[displayarrayentry].Area.Left > PointList[entityarrayentry].Points[i].x) DisplayList[displayarrayentry].Area.Left = PointList[entityarrayentry].Points[i].x;
                                                if (DisplayList[displayarrayentry].Area.Top > PointList[entityarrayentry].Points[i].y) DisplayList[displayarrayentry].Area.Top = PointList[entityarrayentry].Points[i].y;
                                                if (DisplayList[displayarrayentry].Area.Right < PointList[entityarrayentry].Points[i].x) DisplayList[displayarrayentry].Area.Right = PointList[entityarrayentry].Points[i].x;
                                                if (DisplayList[displayarrayentry].Area.Bottom < PointList[entityarrayentry].Points[i].y) DisplayList[displayarrayentry].Area.Bottom = PointList[entityarrayentry].Points[i].y;
                                                }
                                            }
                                        }
                                        break;
                case TDisplayLine:     {
                                        if (entityarrayentry < LineList.Length && LineList[entityarrayentry].ItemNumber == ItemNumber && LineList[entityarrayentry].Points.Length) {
                                            DisplayList[displayarrayentry].UndoName = "Line (" + AnsiString(ItemNumber) + ")";
                                            DisplayList[displayarrayentry].Area.Left = LineList[entityarrayentry].Points[0].x;
                                            DisplayList[displayarrayentry].Area.Top = LineList[entityarrayentry].Points[0].y;
                                            DisplayList[displayarrayentry].Area.Right = LineList[entityarrayentry].Points[0].x;
                                            DisplayList[displayarrayentry].Area.Bottom = LineList[entityarrayentry].Points[0].y;
                                            for (int i = 1; i < LineList[entityarrayentry].Points.Length; i++) {
                                                if (DisplayList[displayarrayentry].Area.Left > LineList[entityarrayentry].Points[i].x) DisplayList[displayarrayentry].Area.Left = LineList[entityarrayentry].Points[i].x;
                                                if (DisplayList[displayarrayentry].Area.Top > LineList[entityarrayentry].Points[i].y) DisplayList[displayarrayentry].Area.Top = LineList[entityarrayentry].Points[i].y;
                                                if (DisplayList[displayarrayentry].Area.Right < LineList[entityarrayentry].Points[i].x) DisplayList[displayarrayentry].Area.Right = LineList[entityarrayentry].Points[i].x;
                                                if (DisplayList[displayarrayentry].Area.Bottom < LineList[entityarrayentry].Points[i].y) DisplayList[displayarrayentry].Area.Bottom = LineList[entityarrayentry].Points[i].y;
                                                }
                                            }
                                        }
                                        break;
                case TDisplayPolyLine:  {
                                        if (entityarrayentry < PolyLineList.Length && PolyLineList[entityarrayentry].ItemNumber == ItemNumber && PolyLineList[entityarrayentry].Points.Length) {
                                            DisplayList[displayarrayentry].UndoName = "Polyline (" + AnsiString(ItemNumber) + ")";
                                            DisplayList[displayarrayentry].Area.Left = PolyLineList[entityarrayentry].Points[0].x;
                                            DisplayList[displayarrayentry].Area.Top = PolyLineList[entityarrayentry].Points[0].y;
                                            DisplayList[displayarrayentry].Area.Right = PolyLineList[entityarrayentry].Points[0].x;
                                            DisplayList[displayarrayentry].Area.Bottom = PolyLineList[entityarrayentry].Points[0].y;
                                            for (int i = 1; i < PolyLineList[entityarrayentry].Points.Length; i++) {
                                                if (DisplayList[displayarrayentry].Area.Left > PolyLineList[entityarrayentry].Points[i].x) DisplayList[displayarrayentry].Area.Left = PolyLineList[entityarrayentry].Points[i].x;
                                                if (DisplayList[displayarrayentry].Area.Top > PolyLineList[entityarrayentry].Points[i].y) DisplayList[displayarrayentry].Area.Top = PolyLineList[entityarrayentry].Points[i].y;
                                                if (DisplayList[displayarrayentry].Area.Right < PolyLineList[entityarrayentry].Points[i].x) DisplayList[displayarrayentry].Area.Right = PolyLineList[entityarrayentry].Points[i].x;
                                                if (DisplayList[displayarrayentry].Area.Bottom < PolyLineList[entityarrayentry].Points[i].y) DisplayList[displayarrayentry].Area.Bottom = PolyLineList[entityarrayentry].Points[i].y;
                                                }
                                            }
                                        }
                                        break;
                case TDisplayFloodFill: {
                                        if (entityarrayentry < FloodFillList.Length && FloodFillList[entityarrayentry].ItemNumber == ItemNumber && FloodFillList[entityarrayentry].Points.Length) {
                                            DisplayList[displayarrayentry].UndoName = "FloodFill (" + AnsiString(ItemNumber) + ")";
                                            DisplayList[displayarrayentry].Area.Left = FloodFillList[entityarrayentry].Points[0].x;
                                            DisplayList[displayarrayentry].Area.Top = FloodFillList[entityarrayentry].Points[0].y;
                                            DisplayList[displayarrayentry].Area.Right = FloodFillList[entityarrayentry].Points[0].x;
                                            DisplayList[displayarrayentry].Area.Bottom = FloodFillList[entityarrayentry].Points[0].y;
                                            for (int i = 1; i < FloodFillList[entityarrayentry].Points.Length; i++) {
                                                if (DisplayList[displayarrayentry].Area.Left > FloodFillList[entityarrayentry].Points[i].x) DisplayList[displayarrayentry].Area.Left = FloodFillList[entityarrayentry].Points[i].x;
                                                if (DisplayList[displayarrayentry].Area.Top > FloodFillList[entityarrayentry].Points[i].y) DisplayList[displayarrayentry].Area.Top = FloodFillList[entityarrayentry].Points[i].y;
                                                if (DisplayList[displayarrayentry].Area.Right < FloodFillList[entityarrayentry].Points[i].x) DisplayList[displayarrayentry].Area.Right = FloodFillList[entityarrayentry].Points[i].x;
                                                if (DisplayList[displayarrayentry].Area.Bottom < FloodFillList[entityarrayentry].Points[i].y) DisplayList[displayarrayentry].Area.Bottom = FloodFillList[entityarrayentry].Points[i].y;
                                                }
                                            }
                                        }
                                        break;
                case TDisplayText:      {
                                        if (entityarrayentry < TextList.Length && TextList[entityarrayentry].ItemNumber == ItemNumber && TextList[entityarrayentry].Points.Length) {
                                            DisplayList[displayarrayentry].UndoName = "Text (" + AnsiString(ItemNumber) + ")";
                                            DisplayList[displayarrayentry].Area.Left = TextList[entityarrayentry].Points[0].x;
                                            DisplayList[displayarrayentry].Area.Top = TextList[entityarrayentry].Points[0].y;
                                            DisplayList[displayarrayentry].Area.Right = TextList[entityarrayentry].Points[0].x;
                                            DisplayList[displayarrayentry].Area.Bottom = TextList[entityarrayentry].Points[0].y;
                                            for (int i = 1; i < TextList[entityarrayentry].Points.Length; i++) {
                                                if (DisplayList[displayarrayentry].Area.Left > TextList[entityarrayentry].Points[i].x) DisplayList[displayarrayentry].Area.Left = TextList[entityarrayentry].Points[i].x;
                                                if (DisplayList[displayarrayentry].Area.Top > TextList[entityarrayentry].Points[i].y) DisplayList[displayarrayentry].Area.Top = TextList[entityarrayentry].Points[i].y;
                                                if (DisplayList[displayarrayentry].Area.Right < TextList[entityarrayentry].Points[i].x) DisplayList[displayarrayentry].Area.Right = TextList[entityarrayentry].Points[i].x;
                                                if (DisplayList[displayarrayentry].Area.Bottom < TextList[entityarrayentry].Points[i].y) DisplayList[displayarrayentry].Area.Bottom = TextList[entityarrayentry].Points[i].y;
                                                }
                                            }
                                        }
                                        break;
                case TDisplayRectangle: {
                                        if (entityarrayentry < RectangleList.Length && RectangleList[entityarrayentry].ItemNumber == ItemNumber && RectangleList[entityarrayentry].Points.Length) {
                                            DisplayList[displayarrayentry].UndoName = "Rectangle (" + AnsiString(ItemNumber) + ")";
                                            DisplayList[displayarrayentry].Area.Left = RectangleList[entityarrayentry].Points[0].x;
                                            DisplayList[displayarrayentry].Area.Top = RectangleList[entityarrayentry].Points[0].y;
                                            DisplayList[displayarrayentry].Area.Right = RectangleList[entityarrayentry].Points[0].x;
                                            DisplayList[displayarrayentry].Area.Bottom = RectangleList[entityarrayentry].Points[0].y;
                                            for (int i = 1; i < RectangleList[entityarrayentry].Points.Length; i++) {
                                                if (DisplayList[displayarrayentry].Area.Left > RectangleList[entityarrayentry].Points[i].x) DisplayList[displayarrayentry].Area.Left = RectangleList[entityarrayentry].Points[i].x;
                                                if (DisplayList[displayarrayentry].Area.Top > RectangleList[entityarrayentry].Points[i].y) DisplayList[displayarrayentry].Area.Top = RectangleList[entityarrayentry].Points[i].y;
                                                if (DisplayList[displayarrayentry].Area.Right < RectangleList[entityarrayentry].Points[i].x) DisplayList[displayarrayentry].Area.Right = RectangleList[entityarrayentry].Points[i].x;
                                                if (DisplayList[displayarrayentry].Area.Bottom < RectangleList[entityarrayentry].Points[i].y) DisplayList[displayarrayentry].Area.Bottom = RectangleList[entityarrayentry].Points[i].y;
                                                }
                                            }
                                        }
                                        break;
                case TDisplayCircle: {
                                        if (entityarrayentry < CircleList.Length && CircleList[entityarrayentry].ItemNumber == ItemNumber && CircleList[entityarrayentry].Points.Length) {
                                            DisplayList[displayarrayentry].UndoName = "Ellipse/Circle (" + AnsiString(ItemNumber) + ")";
                                            DisplayList[displayarrayentry].Area.Left = CircleList[entityarrayentry].Points[0].x;
                                            DisplayList[displayarrayentry].Area.Top = CircleList[entityarrayentry].Points[0].y;
                                            DisplayList[displayarrayentry].Area.Right = CircleList[entityarrayentry].Points[0].x;
                                            DisplayList[displayarrayentry].Area.Bottom = CircleList[entityarrayentry].Points[0].y;
                                            for (int i = 1; i < CircleList[entityarrayentry].Points.Length; i++) {
                                                if (DisplayList[displayarrayentry].Area.Left > CircleList[entityarrayentry].Points[i].x) DisplayList[displayarrayentry].Area.Left = CircleList[entityarrayentry].Points[i].x;
                                                if (DisplayList[displayarrayentry].Area.Top > CircleList[entityarrayentry].Points[i].y) DisplayList[displayarrayentry].Area.Top = CircleList[entityarrayentry].Points[i].y;
                                                if (DisplayList[displayarrayentry].Area.Right < CircleList[entityarrayentry].Points[i].x) DisplayList[displayarrayentry].Area.Right = CircleList[entityarrayentry].Points[i].x;
                                                if (DisplayList[displayarrayentry].Area.Bottom < CircleList[entityarrayentry].Points[i].y) DisplayList[displayarrayentry].Area.Bottom = CircleList[entityarrayentry].Points[i].y;
                                                }
                                            }
                                        }
                                        break;
                case TDisplayFreeForm:  {
                                        if (entityarrayentry < FreeFormList.Length && FreeFormList[entityarrayentry].ItemNumber == ItemNumber && FreeFormList[entityarrayentry].Points.Length) {
                                            DisplayList[displayarrayentry].UndoName = "Free-Form Shape (" + AnsiString(ItemNumber) + ")";
                                            DisplayList[displayarrayentry].Area.Left = FreeFormList[entityarrayentry].Points[0].x;
                                            DisplayList[displayarrayentry].Area.Top = FreeFormList[entityarrayentry].Points[0].y;
                                            DisplayList[displayarrayentry].Area.Right = FreeFormList[entityarrayentry].Points[0].x;
                                            DisplayList[displayarrayentry].Area.Bottom = FreeFormList[entityarrayentry].Points[0].y;
                                            for (int i = 1; i < FreeFormList[entityarrayentry].Points.Length; i++) {
                                                if (DisplayList[displayarrayentry].Area.Left > FreeFormList[entityarrayentry].Points[i].x) DisplayList[displayarrayentry].Area.Left = FreeFormList[entityarrayentry].Points[i].x;
                                                if (DisplayList[displayarrayentry].Area.Top > FreeFormList[entityarrayentry].Points[i].y) DisplayList[displayarrayentry].Area.Top = FreeFormList[entityarrayentry].Points[i].y;
                                                if (DisplayList[displayarrayentry].Area.Right < FreeFormList[entityarrayentry].Points[i].x) DisplayList[displayarrayentry].Area.Right = FreeFormList[entityarrayentry].Points[i].x;
                                                if (DisplayList[displayarrayentry].Area.Bottom < FreeFormList[entityarrayentry].Points[i].y) DisplayList[displayarrayentry].Area.Bottom = FreeFormList[entityarrayentry].Points[i].y;
                                                }
                                            }
                                        }
                                        break;
                case TDisplayEraseItem: {
                                        if (entityarrayentry < EraseList.Length && EraseList[entityarrayentry].ItemNumber == ItemNumber && EraseList[entityarrayentry].Points.Length) {
                                            DisplayList[displayarrayentry].UndoName = "Erase Object (" + AnsiString(ItemNumber) + ")";
                                            DisplayList[displayarrayentry].Area.Left = EraseList[entityarrayentry].Points[0].x;
                                            DisplayList[displayarrayentry].Area.Top = EraseList[entityarrayentry].Points[0].y;
                                            DisplayList[displayarrayentry].Area.Right = EraseList[entityarrayentry].Points[0].x;
                                            DisplayList[displayarrayentry].Area.Bottom = EraseList[entityarrayentry].Points[0].y;
                                            for (int i = 1; i < EraseList[entityarrayentry].Points.Length; i++) {
                                                if (DisplayList[displayarrayentry].Area.Left > EraseList[entityarrayentry].Points[i].x) DisplayList[displayarrayentry].Area.Left = EraseList[entityarrayentry].Points[i].x;
                                                if (DisplayList[displayarrayentry].Area.Top > EraseList[entityarrayentry].Points[i].y) DisplayList[displayarrayentry].Area.Top = EraseList[entityarrayentry].Points[i].y;
                                                if (DisplayList[displayarrayentry].Area.Right < EraseList[entityarrayentry].Points[i].x) DisplayList[displayarrayentry].Area.Right = EraseList[entityarrayentry].Points[i].x;
                                                if (DisplayList[displayarrayentry].Area.Bottom < EraseList[entityarrayentry].Points[i].y) DisplayList[displayarrayentry].Area.Bottom = EraseList[entityarrayentry].Points[i].y;
                                                }
                                            }
                                        }
                                        break;
                case TDisplayBlock: {
                                        if (entityarrayentry < BlockList.Length && BlockList[entityarrayentry].ItemNumber == ItemNumber && BlockList[entityarrayentry].Points.Length) {
                                            DisplayList[displayarrayentry].UndoName = "Block (" + AnsiString(ItemNumber) + ")";
                                            DisplayList[displayarrayentry].Area.Left = BlockList[entityarrayentry].Points[0].x;
                                            DisplayList[displayarrayentry].Area.Top = BlockList[entityarrayentry].Points[0].y;
                                            DisplayList[displayarrayentry].Area.Right = BlockList[entityarrayentry].Points[0].x;
                                            DisplayList[displayarrayentry].Area.Bottom = BlockList[entityarrayentry].Points[0].y;
                                            for (int i = 1; i < BlockList[entityarrayentry].Points.Length; i++) {
                                                if (DisplayList[displayarrayentry].Area.Left > BlockList[entityarrayentry].Points[i].x) DisplayList[displayarrayentry].Area.Left = BlockList[entityarrayentry].Points[i].x;
                                                if (DisplayList[displayarrayentry].Area.Top > BlockList[entityarrayentry].Points[i].y) DisplayList[displayarrayentry].Area.Top = BlockList[entityarrayentry].Points[i].y;
                                                if (DisplayList[displayarrayentry].Area.Right < BlockList[entityarrayentry].Points[i].x) DisplayList[displayarrayentry].Area.Right = BlockList[entityarrayentry].Points[i].x;
                                                if (DisplayList[displayarrayentry].Area.Bottom < BlockList[entityarrayentry].Points[i].y) DisplayList[displayarrayentry].Area.Bottom = BlockList[entityarrayentry].Points[i].y;
                                                }
                                            }
                                        }
                                        break;
                default:                break;
                }
            DisplayList[displayarrayentry].Area.Right += 1;
            DisplayList[displayarrayentry].Area.Bottom += 1;
            }

        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::ChangeText1Click(TObject *Sender)
{
    // Change selected text
    ResetActionButtons();
    bool found = false;
    int ItemNumber;
    int pointer = 0;
    while (!found && pointer < DisplayList.Length) {
        if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayText) {
            found = true;
            pointer--;
            }
        pointer++;
        }
    if (found) {
        ItemNumber = DisplayList[pointer].ItemNumber;
        int displaypointer = pointer;
        pointer = XRefs[ItemNumber].EntityXRef;

        if (XRefs[ItemNumber].DisplayType == TDisplayText && pointer > -1 && pointer < TextList.Length && TextList[pointer].ItemNumber == ItemNumber) found = true;

        if (found) {
            AnsiString Text = TextList[pointer].Text;
            KeyPreview = false;
            if (InputQuery("Edit Text","Please Enter the New Text",Text)) {
                if (!Undoing) {
                    if (SingleUndo) AddUndoTitle("Change Text");
                    AddUndo("Text,ChangeText," + AnsiString(ItemNumber) + "," + TextList[pointer].Text);
                    }
                if (deselectafteroperation) {
                    DisplayList[displaypointer].selected = false;
                    AddUndo("Select," + AnsiString(ItemNumber) + ",");
                    }
                TextList[pointer].Text = Text;
                FillPointsText(pointer,ItemNumber);
                DisplayListAreaUpdate(ItemNumber);
                DrawPicture();
                }
            KeyPreview = true;
            }
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::ChangeText(int ItemNumber, AnsiString NewText)
{
    // Change text of text object with item number 'ItemNumber'
    bool found = false;
    int pointer = XRefs[ItemNumber].EntityXRef;

    if (XRefs[ItemNumber].DisplayType == TDisplayText && pointer > -1 && pointer < TextList.Length && TextList[pointer].ItemNumber == ItemNumber) found = true;

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Change Text");
            AddUndo("Text,ChangeText," + AnsiString(ItemNumber) + "," + TextList[pointer].Text);
            if (deselectafteroperation) {
                int displaypointer = XRefs[ItemNumber].EntityXRef;
                found = false;
                if (displaypointer > -1 && displaypointer < DisplayList.Length && DisplayList[displaypointer].ItemNumber == ItemNumber) found = true;
                if (found) {
                    DisplayList[displaypointer].selected = false;
                    AddUndo("Select," + AnsiString(ItemNumber) + ",");
                    }
                }
            }
        TextList[pointer].Text = NewText;
        FillPointsText(pointer,ItemNumber);
        DisplayListAreaUpdate(ItemNumber);
        if (SingleUndo) DrawPicture();
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::RotateText1Click(TObject *Sender)
{
    //rotates existing text
    ResetActionButtons();
    bool found = false;
    int ItemNumber;
    int pointer = 0;
    while (!found && pointer < DisplayList.Length) {
        if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayText) {
            found = true;
            pointer--;
            }
        pointer++;
        }
    if (found) {
        ItemNumber = DisplayList[pointer].ItemNumber;
        int displaypointer = pointer;
        pointer = XRefs[ItemNumber].EntityXRef;

        if (XRefs[ItemNumber].DisplayType == TDisplayText && pointer > -1 && pointer < TextList.Length && TextList[pointer].ItemNumber == ItemNumber) found = true;

        if (found) {
            AnsiString Text = AnsiString(((double)(TextList[pointer].Angle))/10.0);
            KeyPreview = false;
            if (InputQuery("Edit Text Angle","Please Enter the New Absolute Angle (0-359.9 degrees)",Text)) {
                if (!Undoing) {
                    if (SingleUndo) AddUndoTitle("Rotate Text");
                    AddUndo("Rotate," + AnsiString(ItemNumber) + "," + AnsiString(TextList[pointer].StartPoint.x) + "," + AnsiString(TextList[pointer].StartPoint.y) + "," + AnsiString(TextList[pointer].Angle) + ",");
                    if (deselectafteroperation) {
                        DisplayList[displaypointer].selected = false;
                        AddUndo("Select," + AnsiString(ItemNumber) + ",");
                        }
                    }
                double angle = ROUND(ToDoubleDef(Text,0.0),1);
                while (angle > 360.0) {
                    angle -= 360.0;
                    }
                while (angle < 0.0) {
                    angle += 360.0;
                    }
                TextList[pointer].Angle = (int)(angle * 10.0);
                FillPointsText(pointer,ItemNumber);
                DisplayListAreaUpdate(ItemNumber);
                DrawPicture();
                }
            KeyPreview = true;
            }
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Help2Click(TObject *Sender)
{
    AnsiString Address = ExtractFileDir(Application->ExeName) + "\\BackStitch.chm";
    AnsiString Location = "mk:@MSITStore:" + Address + "::/imageeditor.html#start";
    ShellExecute(Application->Handle,"open",Location.c_str(),Location.c_str(),NULL,SW_SHOW);

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::SamplingClick(TObject *Sender)
{
    if (dynamic_cast <TComponent *>(Sender)) {
        AddUndoTitle("Change Subspace Sampling");
        AddUndo("AntiAlias," + AnsiString((int)(AntiAlias)) + "," + AnsiString(subspacesampling) + ",");
        subspacesampling = dynamic_cast <TComponent *>(Sender)->Tag;
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::SubspaceSampling1Click(TObject *Sender)
{
    None2->Checked = (None2->Tag == subspacesampling);
    N2xMedium->Checked = (N2xMedium->Tag == subspacesampling);
    N4xHigh->Checked = (N4xHigh->Tag == subspacesampling);
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::SetColourSpaceDivisions1Click(
      TObject *Sender)
{
    AnsiString Text = AnsiString(colourspacedivisions);
    KeyPreview = false;
    if (InputQuery("Number of Colour Space Divisions","Please Enter the New number of Divisions (2-100)",Text)) {
        colourspacedivisions = Text.ToIntDef(17);
        if (colourspacedivisions < 2) colourspacedivisions = 2;
        if (colourspacedivisions > 100) colourspacedivisions = 100;
        }
    KeyPreview = true;

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::EditText1Click(TObject *Sender)
{
    ChangeText1->Enabled = (bool)(NumberTextItemsSelected == 1);
    RotateText1->Enabled = ChangeText1->Enabled;        
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::BreakLink1Click(TObject *Sender)
{
    //break link for blocks
    TerminateCurrentAction();
    ResetActionButtons();
    AddUndoTitle("Break Selected Block Links");
    for (int i = 0; i < DisplayList.Length; i++) {
        if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayBlock) {
            int ItemNumber = DisplayList[i].ItemNumber;
            if (ItemNumber > -1 && ItemNumber < XRefs.Length && XRefs[ItemNumber].ItemNumber == ItemNumber && XRefs[ItemNumber].DisplayType == TDisplayBlock) {
                int arraypointer = XRefs[ItemNumber].EntityXRef;
                if (arraypointer > -1 && arraypointer < BlockList.Length && BlockList[arraypointer].ItemNumber == ItemNumber) {
                    if(BlockList[arraypointer].Linked) {
                        //it's a slave. Break link
                        AddUndo("Block,Link," + AnsiString(ItemNumber) + "," + AnsiString((int)(BlockList[arraypointer].Linked)) + "," + AnsiString(BlockList[arraypointer].LinkedBlock) + ",");
                        BlockList[arraypointer].Linked = false;
                        BlockList[arraypointer].LinkedBlock = -1;
                        } else {
                        //it's a master block. check to see if any slaves are linked to this one
                        for (int j = 0; j < BlockList.Length; j++) {
                            if (BlockList[j].Linked && BlockList[j].LinkedBlock == ItemNumber && BlockList[j].ItemNumber != ItemNumber) {
                                AddUndo("Block,Link," + AnsiString(BlockList[j].ItemNumber) + "," + AnsiString((int)(BlockList[j].Linked)) + "," + AnsiString(BlockList[j].LinkedBlock) + ",");
                                BlockList[j].Linked = false;
                                BlockList[j].LinkedBlock = -1;
                                }
                            }
                        }
                    }
                }
            if (deselectafteroperation) {
                //deselect regardless of whether link was broken
                AddUndo("Select," + AnsiString(ItemNumber) + ",");
                DisplayList[i].selected = false;
                }
            }
        }
    DrawPicture();
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::LinkBlocks1Click(TObject *Sender)
{
    //This method is called if there are only two selected blocks

    //If there are two master blocks, the one with the most slaves becomes the master.
    //If there are the same number of slaves, the oldest one becomes the master

    //if one is a master, and the other is a slave, then the slave changes its master

    //if both are slaves, the one whose master has fewer slaves, swaps master.

    if (NumberBlocksSelected == 2) {
        SingleUndo = false;
        blockquery Block1, Block2, swap;
        Block1.ismaster = false;
        Block1.numberofslaves = 0;
        Block2.ismaster = false;
        Block2.numberofslaves = 0;

        //Find item numbers
        bool found = false;
        int pointer = 0;

        while(!found && pointer < DisplayList.Length) {
            if (DisplayList[pointer].selected && DisplayList[pointer].DisplayType == TDisplayBlock) {
                Block1.ItemNumber = DisplayList[pointer].ItemNumber;
                Block1.DisplayXRef = pointer;
                found = true;
                }
            pointer++;
            }

        found = false;
        while(!found && pointer < DisplayList.Length) {
            if (DisplayList[pointer].selected && DisplayList[pointer].DisplayType == TDisplayBlock) {
                Block2.ItemNumber = DisplayList[pointer].ItemNumber;
                Block2.DisplayXRef = pointer;
                found = true;
                }
            pointer++;
            }

        if (found && Block1.ItemNumber != Block2.ItemNumber) {
            //have established the block numbers
            pointer = 0;
            bool block1found = false;
            bool block2found = false;
            while ((!block1found || !block2found) && pointer < BlockList.Length) {
                if (!block1found && BlockList[pointer].ItemNumber == Block1.ItemNumber) {
                    block1found = true;
                    Block1.EntityXRef = pointer;
                    }
                if (!block2found && BlockList[pointer].ItemNumber == Block2.ItemNumber) {
                    block2found = true;
                    Block2.EntityXRef = pointer;
                    }
                pointer++;
                }
            if (block1found && block2found) {
                //see if slave blocks
                if (!BlockList[Block1.EntityXRef].Linked) {
                    Block1.ismaster = true;
                    Block1.masterblock = -1;
                    } else {
                    Block1.ismaster = false;
                    Block1.masterblock = BlockList[Block1.EntityXRef].LinkedBlock;
                    }
                if (!BlockList[Block2.EntityXRef].Linked) {
                    Block2.ismaster = true;
                    Block2.masterblock = -1;
                    } else {
                    Block2.ismaster = false;
                    Block2.masterblock = BlockList[Block2.EntityXRef].LinkedBlock;
                    }
                for (int i = 0; i < BlockList.Length; i++) {
                    if (Block1.ismaster && BlockList[i].Linked && BlockList[i].LinkedBlock == Block1.ItemNumber) Block1.numberofslaves++;
                    if (Block2.ismaster && BlockList[i].Linked && BlockList[i].LinkedBlock == Block2.ItemNumber) Block2.numberofslaves++;
                    }
                //right, now have all the information necessary to do something.
                if (Block1.ismaster && Block2.ismaster) {
                    //see which has more slaves, and that becomes the new master
                    if (Block1.numberofslaves < Block2.numberofslaves) {
                        swap = Block1;
                        Block1 = Block2;
                        Block2 = swap;
                        }
                    //now Block2 and all its slaves are made slaves of Block1;
                    AddUndoTitle("Link Master Block " + AnsiString(Block2.ItemNumber) + " and all Linked Blocks to Block " + AnsiString(Block1.ItemNumber));
                    LinkBlock(Block2.ItemNumber,true,Block1.ItemNumber);
                    for (int i = 0; i < BlockList.Length; i++) {
                        if (BlockList[i].Linked && BlockList[i].LinkedBlock == Block2.ItemNumber) {
                            LinkBlock(BlockList[i].ItemNumber,true,Block1.ItemNumber);
                            }
                        }
                    } else {
                    //one or more slaves
                    if (!Block1.ismaster && !Block2.ismaster) {
                        //both slaves - check not of the same block.
                        if (Block1.masterblock != Block2.masterblock) {
                            //Find out how many slaves each one's master has
                            Block1.numberofslaves = 0;
                            Block2.numberofslaves = 0;
                            for (int i = 0; i < BlockList.Length; i++) {
                                if (BlockList[i].Linked && BlockList[i].LinkedBlock == Block1.masterblock) Block1.numberofslaves++;
                                if (BlockList[i].Linked && BlockList[i].LinkedBlock == Block2.masterblock) Block2.numberofslaves++;
                                }
                            if (Block1.numberofslaves < Block2.numberofslaves) {
                                swap = Block1;
                                Block1 = Block2;
                                Block2 = swap;
                                }
                            AddUndoTitle("Link Block " + AnsiString(Block2.ItemNumber) + " to Block " + AnsiString(Block1.masterblock));
                            LinkBlock(Block2.ItemNumber,true,Block1.masterblock);
                            }
                        } else {
                        //one of the blocks is a master, the other a slave
                        if (Block2.ismaster) {
                            swap = Block1;
                            Block1 = Block2;
                            Block2 = swap;
                            }
                        AddUndoTitle("Link Block " + AnsiString(Block2.ItemNumber) + " to Block " + AnsiString(Block1.ItemNumber));
                        LinkBlock(Block2.ItemNumber,true,Block1.ItemNumber);
                        }
                    }
                }
            if (deselectafteroperation) {
                AddUndo("Select," + AnsiString(Block1.ItemNumber) + ",");
                AddUndo("Select," + AnsiString(Block2.ItemNumber) + ",");
                DisplayList[Block1.DisplayXRef].selected = false;
                DisplayList[Block2.DisplayXRef].selected = false;
                }
            }

        SingleUndo = true;
        DrawPicture();
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::LinkBlock(int ItemNumber, bool Linked, int LinkedBlock)
{
    //changes the details in a block. When the block becomes a slave, its contents change to match
    //the master
    CreateXRefs();

    int pointer = XRefs[ItemNumber].EntityXRef;
    //int displaypointer = XRefs[ItemNumber].DisplayXRef;
    bool found = false;

    if (XRefs[ItemNumber].DisplayType == TDisplayBlock
            && pointer > -1
            && pointer < BlockList.Length
            && BlockList[pointer].ItemNumber == ItemNumber
            //&& displaypointer > -1
            //&& displaypointer < DisplayList.Length
            //&& DisplayList[displaypointer].DisplayType == TDisplayBlock
            //&& DisplayList[displaypointer].ItemNumber == ItemNumber
            ) found = true;

    if (found) {
        //OK, have established that the block exists and is displayed properly. Now to see if it needs to change, and how it needs to, as well.
        //bool changecontents = false;
        if (Linked && LinkedBlock > -1) {
            if (LinkedBlock != BlockList[pointer].LinkedBlock
                    && XRefs[LinkedBlock].DisplayType == TDisplayBlock
                    && XRefs[LinkedBlock].ItemNumber == LinkedBlock
                    && XRefs[LinkedBlock].EntityXRef > -1
                    && XRefs[LinkedBlock].EntityXRef < BlockList.Length
                    && BlockList[XRefs[LinkedBlock].EntityXRef].ItemNumber == LinkedBlock
                    ) {
                    //Linked block has been found
                    int linkedblockpointer = XRefs[LinkedBlock].EntityXRef;
                    //now to check if it's a slave
                    if (BlockList[linkedblockpointer].Linked && BlockList[linkedblockpointer].LinkedBlock > -1) {
                        //it's a slave, so point to the master instead
                        if (XRefs[BlockList[linkedblockpointer].LinkedBlock].DisplayType == TDisplayBlock
                                && XRefs[BlockList[linkedblockpointer].LinkedBlock].ItemNumber == BlockList[linkedblockpointer].LinkedBlock
                                && XRefs[BlockList[linkedblockpointer].LinkedBlock].EntityXRef > -1
                                && XRefs[BlockList[linkedblockpointer].LinkedBlock].EntityXRef < BlockList.Length
                                && BlockList[XRefs[BlockList[linkedblockpointer].LinkedBlock].EntityXRef].ItemNumber == BlockList[linkedblockpointer].LinkedBlock
                                ) {
                                linkedblockpointer = XRefs[BlockList[linkedblockpointer].LinkedBlock].EntityXRef;
                                LinkedBlock = BlockList[linkedblockpointer].ItemNumber;
                                }
                        }
                    //now definitely pointing to a master block
                    if (!Undoing) {
                        //set up undo
                        if (SingleUndo) AddUndoTitle("Break Block Link");
                        AnsiString text;
                        text = "Block,ChangeContents,"
                                + AnsiString(BlockList[pointer].ItemNumber) + ","
                                + AnsiString(BlockList[pointer].Area.Left) + ","
                                + AnsiString(BlockList[pointer].Area.Top) + ","
                                + AnsiString(BlockList[pointer].Area.Right) + ","
                                + AnsiString(BlockList[pointer].Area.Bottom) + ","
                                + AnsiString((int)(BlockList[pointer].Linked)) + ","
                                + AnsiString(BlockList[pointer].LinkedBlock) + ","
                                + AnsiString(BlockList[pointer].RotationCentre.x) + ","
                                + AnsiString(BlockList[pointer].RotationCentre.y) + ","
                                + AnsiString(BlockList[pointer].Angle) + ","
                                + AnsiString(BlockList[pointer].MirrorCentre.x) + ","
                                + AnsiString(BlockList[pointer].MirrorCentre.y) + ","
                                + AnsiString((int)(BlockList[pointer].Axis)) + ","
                                + AnsiString(BlockList[pointer].delta.x) + ","
                                + AnsiString(BlockList[pointer].delta.y) + ","
                                ;
                        for (int i = 0; i < BlockList[pointer].Points.Length; i++) {
                            text = text + AnsiString(BlockList[pointer].Points[i].x) + ","
                                        + AnsiString(BlockList[pointer].Points[i].y) + ","
                                        + AnsiString(BlockList[pointer].Points[i].originalx) + ","
                                        + AnsiString(BlockList[pointer].Points[i].originaly) + ","
                                        + AnsiString(BlockList[pointer].Points[i].Colour) + ","
                                        + AnsiString((int)(BlockList[pointer].Points[i].transparent)) + ","
                                        ;
                            }
                        AddUndo(text);
                        }
                    BlockList[pointer].Linked = Linked;
                    BlockList[pointer].LinkedBlock = LinkedBlock;
                    TPoint delta;
                    delta.x = BlockList[pointer].Area.Left - BlockList[linkedblockpointer].Area.Left;
                    delta.y = BlockList[pointer].Area.Top - BlockList[linkedblockpointer].Area.Top;
                    BlockList[pointer].Area.Right = BlockList[linkedblockpointer].Area.Right + delta.x;
                    BlockList[pointer].Area.Bottom = BlockList[linkedblockpointer].Area.Bottom + delta.y;
                    BlockList[pointer].Points.Length = BlockList[linkedblockpointer].Points.Length;
                    for (int i = 0; i < BlockList[pointer].Points.Length; i++) {
                        //BlockList[pointer].Points[i].x = BlockList[linkedblockpointer].Points[i].x + delta.x;
                        //BlockList[pointer].Points[i].y = BlockList[linkedblockpointer].Points[i].y + delta.y;
                        BlockList[pointer].Points[i].originalx = BlockList[linkedblockpointer].Points[i].originalx + delta.x;
                        BlockList[pointer].Points[i].originaly = BlockList[linkedblockpointer].Points[i].originaly + delta.y;
                        BlockList[pointer].Points[i].Colour = BlockList[linkedblockpointer].Points[i].Colour;
                        BlockList[pointer].Points[i].transparent = BlockList[linkedblockpointer].Points[i].transparent;
                        }
                    FillPointsBlock(pointer,ItemNumber);
                    DisplayListAreaUpdate(ItemNumber);
                    }
            } else {
            // Block is not linked now
            if (!Undoing) {
                //set up undo
                if (SingleUndo) AddUndoTitle("Break Block Link");
                AddUndo("Block,Link," + AnsiString(BlockList[pointer].ItemNumber) + "," + AnsiString((int)(BlockList[pointer].Linked)) + "," + AnsiString(BlockList[pointer].LinkedBlock) + ",");
                }
            BlockList[pointer].Linked = false;
            BlockList[pointer].LinkedBlock = -1;
            }
        }
}
//---------------------------------------------------------------------------


void __fastcall TImageEditorForm::FormKeyPress(TObject *Sender, char &Key)
{
    //allows the program to respond to keypresses
    switch (Key) {
        case 27:            {
                            //escape key pressed
                            TerminateCurrentAction();
                            ResetActionButtons();
                            //bool redraw = false;
                            //if (ActionType == TEditPointPoints) redraw = true;
                            ActionType = TNoAction;
                            //if (redraw) DrawPicture();
                            }
                            break;
        case 13:            {
                            CompleteCurrentAction();
                            //ResetActionButtons();
                            //ActionType = TNoAction;
                            }
                            break;
        default:            break;
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::CompleteCurrentAction(void)
{
    switch (ActionType) {
            case TPasteBlock:   {
                                ActionType = TNoAction;
                                int displaypointer = DisplayList.Length - 1;
                                if (DisplayList[displaypointer].selected && !DisplayList[displaypointer].visible && DisplayList[displaypointer].DisplayType == TDisplayBlock) {
                                    //have the right block
                                    TRect Rectangle;
                                    Rectangle = FindImage1Position(DisplayList[displaypointer].Area);
                                    TPoint delta;
                                    delta.x = Rectangle.Right - Rectangle.Left;
                                    delta.y = Rectangle.Bottom - Rectangle.Top;
                                    TPenMode oldmode = Image1->Picture->Bitmap->Canvas->Pen->Mode;
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = pmNot;
                                    Image1->Picture->Bitmap->Canvas->Pen->Style = psSolid;
                                    Image1->Picture->Bitmap->Canvas->Pen->Width = 1;
                                    if (!wipedout) {
                                        Rectangle.Left = OldMousePositionScreen.x;
                                        Rectangle.Top = OldMousePositionScreen.y;
                                        Rectangle.Right = Rectangle.Left + delta.x;
                                        Rectangle.Bottom = Rectangle.Top + delta.y;
                                        Image1->Picture->Bitmap->Canvas->DrawFocusRect(Rectangle);
                                        wipedout = true;
                                        }
                                    Image1->Picture->Bitmap->Canvas->Pen->Mode = oldmode;
                                    //now to make block visible and move it to the current position
                                    chartposition SP = FindMousePosition(OldMousePositionScreen.x,OldMousePositionScreen.y);
                                    delta.x = SP.X;
                                    delta.y = SP.Y;
                                    DisplayList[displaypointer].visible = true;
                                    Undoing = true;
                                    MoveBlock(delta,DisplayList[displaypointer].ItemNumber);
                                    Undoing = false;
                                    if (deselectafteroperation) {
                                        DisplayList[displaypointer].selected = false;
                                        }
                                    DrawPicture();
                                    }
                                }
                                break;
        case TEditFreeForm:
        case TDrawFreeForm:
        case TEditPolyLine:
        case TDrawPolyLine:     {
                                TerminateCurrentAction();
                                }
                                break;
        case TEditErasePoints:  {
                                ActionType = TNoAction;
                                int pointer = 0;
                                bool found = false;
                                while (!found && pointer < DisplayList.Length) {
                                    if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayEraseItem) {
                                        found = true;
                                        pointer--;
                                        }
                                    pointer++;
                                    }
                                if (deselectafteroperation) {
                                    if (found) {
                                        AddUndo("Select," + AnsiString(DisplayList[pointer].ItemNumber) + ",");
                                        DisplayList[pointer].selected = false;
                                        }
                                    }
                                Label1->Visible = true;
                                Image2->Visible = true;
                                if (blendthreads || !BlendColours1->Enabled) Image3->Visible = true;
                                Label2->Visible = Image3->Visible;
                                //Foreground->Brush->Color = ForegroundColour;
                                Background->Brush->Bitmap = NULL;
                                //Background->Brush->Color = BackgroundColour;
                                DisplayCurrentColours();
                                Timer1->Enabled = true;
                                Image1->Cursor = crTargetCursor;
                                if (found) {
                                    DisplayListAreaUpdate(DisplayList[pointer].ItemNumber);
                                    }
                                DrawPicture();
                                }
                                break;
        case TEditBlockPoints:  {
                                ActionType = TNoAction;
                                int pointer = 0;
                                bool found = false;
                                while (!found && pointer < DisplayList.Length) {
                                    if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayBlock) {
                                        found = true;
                                        pointer--;
                                        }
                                    pointer++;
                                    }
                                if (deselectafteroperation) {
                                    if (found) {
                                        AddUndo("Select," + AnsiString(DisplayList[pointer].ItemNumber) + ",");
                                        DisplayList[pointer].selected = false;
                                        }
                                    }
                                Background->Brush->Bitmap = NULL;
                                Background->Brush->Color = BackgroundColour;
                                Timer1->Enabled = true;
                                Image1->Cursor = crTargetCursor;
                                //now to update all the blocks linked to this one.
                                CreateXRefs();
                                bool found2 = false;
                                TPoint delta;
                                int arraypointer = XRefs[DisplayList[pointer].ItemNumber].EntityXRef;
                                if (arraypointer > -1 && arraypointer < BlockList.Length && BlockList[arraypointer].ItemNumber == DisplayList[pointer].ItemNumber) found2 = true;
                                if (found2) {
                                    //debug
                                    Memo1->Lines->Add("Editing Block");
                                    Memo1->Lines->Add("   Edited Block");
                                    DebugBlock(arraypointer);
                                    if (BlockList[arraypointer].RotationCentre.x != BlockList[arraypointer].MirrorCentre.x
                                            || BlockList[arraypointer].RotationCentre.y != BlockList[arraypointer].MirrorCentre.y
                                            || BlockList[arraypointer].RotationCentre.x != BlockList[arraypointer].Area.Left
                                            || BlockList[arraypointer].RotationCentre.y != BlockList[arraypointer].Area.Top
                                            )
                                            Memo1->Lines->Add("****   Block Error   ****");
                                    //Need to update the block data. Want the block Area top left to be the rotation point & mirror point
                                    TRect oldarea = BlockList[arraypointer].Area;
                                    TPoint oldrotcentre = BlockList[arraypointer].RotationCentre;
                                    //now need to work backwards from the display versions of the points to calculate the rotational centre
                                    //and the extent of the original points, then re-fill the original point array in the reverse of 'FillPointsBlock()'
                                    TRect newarea;
                                    newarea.Left = BlockList[arraypointer].Points[0].x;
                                    newarea.Top = BlockList[arraypointer].Points[0].y;
                                    newarea.Right = newarea.Left;
                                    newarea.Bottom = newarea.Top;
                                    for (int i = 1; i < BlockList[arraypointer].Points.Length; i++) {
                                        if (newarea.Left > BlockList[arraypointer].Points[i].x) newarea.Left = BlockList[arraypointer].Points[i].x;
                                        if (newarea.Top > BlockList[arraypointer].Points[i].y) newarea.Top = BlockList[arraypointer].Points[i].y;
                                        if (newarea.Right < BlockList[arraypointer].Points[i].x) newarea.Right = BlockList[arraypointer].Points[i].x;
                                        if (newarea.Bottom < BlockList[arraypointer].Points[i].y) newarea.Bottom = BlockList[arraypointer].Points[i].y;
                                        }
                                    //now take the brute ignorance & force method to determine where the centre of rotation should be
                                    TRect searcharea = DisplayList[pointer].Area;
                                    if (newarea.Left < searcharea.Left) searcharea.Left = newarea.Left - 1;
                                    if (newarea.Top < searcharea.Top) searcharea.Top = newarea.Top - 1;
                                    if (newarea.Right > searcharea.Right) searcharea.Right = newarea.Right + 1;
                                    if (newarea.Bottom > searcharea.Bottom) searcharea.Bottom = newarea.Bottom + 1;
                                    DynamicArray <blockcentresearch> CentreSearch;
                                    CentreSearch.Length = (searcharea.Right - searcharea.Left) * (searcharea.Bottom - searcharea.Top);
                                    for (int i = 0; i < CentreSearch.Length; i++) {
                                        CentreSearch[i].errorsquared = 0;
                                        }
                                    int searchpointer = 0;
                                    TPoint searchpoint;
                                    TPoint searchoffset;
                                    TPoint searchcentre;
                                    int swap;
                                    int error;
                                    double Angle = ((double)(BlockList[arraypointer].Angle))/10.0;
                                    TMirrorAxis Axis = BlockList[arraypointer].Axis;
                                    for (int x = searcharea.Left; x < searcharea.Right; x++) {
                                        for (int y = searcharea.Top; y < searcharea.Bottom; y++) {
                                            CentreSearch[searchpointer].x = x;
                                            CentreSearch[searchpointer].y = y;
                                            searchoffset.x = x - newarea.Left;
                                            searchoffset.y = y - newarea.Top;
                                            searchcentre.x = x;
                                            searchcentre.y = y;
                                            for (int i = 0; i < BlockList[arraypointer].Points.Length; i++) {
                                                searchpoint.x = BlockList[arraypointer].Points[i].originalx + searchoffset.x;
                                                searchpoint.y = BlockList[arraypointer].Points[i].originaly + searchoffset.y;
                                                if (Angle != 0.0) {
                                                    if (Angle == 270.0) {
                                                        searchpoint.x = searchpoint.x - searchcentre.x;
                                                        searchpoint.y = searchpoint.y - searchcentre.y;
                                                        swap = searchpoint.x;
                                                        searchpoint.x = -1 * searchpoint.y;
                                                        searchpoint.y = swap;
                                                        searchpoint.x = searchpoint.x + searchcentre.x;
                                                        searchpoint.y = searchpoint.y + searchcentre.y;
                                                        } else {
                                                        if (Angle == 180.0) {
                                                            searchpoint.x = searchpoint.x - searchcentre.x;
                                                            searchpoint.y = searchpoint.y - searchcentre.y;
                                                            searchpoint.x = -1 * searchpoint.x;
                                                            searchpoint.y = -1 * searchpoint.y;
                                                            searchpoint.x = searchpoint.x + searchcentre.x;
                                                            searchpoint.y = searchpoint.y + searchcentre.y;
                                                            } else {
                                                            if (Angle == 90.0) {
                                                                searchpoint.x = searchpoint.x - searchcentre.x;
                                                                searchpoint.y = searchpoint.y - searchcentre.y;
                                                                swap = -1 * searchpoint.x;
                                                                searchpoint.x = searchpoint.y;
                                                                searchpoint.y = swap;
                                                                searchpoint.x = searchpoint.x + searchcentre.x;
                                                                searchpoint.y = searchpoint.y + searchcentre.y;
                                                                } else {
                                                                searchpoint = RotateTPoint(searchpoint, searchcentre, Angle);
                                                                }
                                                            }
                                                        }
                                                    }
                                                if (Axis != TMANone) {
                                                    searchpoint = MirrorTPoint(searchpoint,searchcentre, Axis);
                                                    }
                                                error = (searchpoint.x - BlockList[arraypointer].Points[i].x) * (searchpoint.x - BlockList[arraypointer].Points[i].x) + (searchpoint.y - BlockList[arraypointer].Points[i].y) * (searchpoint.y - BlockList[arraypointer].Points[i].y);
                                                CentreSearch[searchpointer].errorsquared += error;
                                                } //end of 'for (int i = '
                                            searchpointer++;
                                            }   //end of 'for (int y = '
                                        } //end of 'for (int x = '
                                    //now find the centreposition with minimum error, and hope to goodness it works properly!
                                    error = CentreSearch[0].errorsquared;
                                    searchpointer = 0;
                                    for (int i = 0; i < CentreSearch.Length; i++) {
                                        if (CentreSearch[i].errorsquared < error) {
                                            searchpointer = i;
                                            error = CentreSearch[i].errorsquared;
                                            }
                                        }
                                    searchoffset.x = CentreSearch[searchpointer].x - newarea.Left;
                                    searchoffset.y = CentreSearch[searchpointer].y - newarea.Top;
                                    BlockList[arraypointer].Area.Left = newarea.Left + searchoffset.x;
                                    BlockList[arraypointer].Area.Top = newarea.Top + searchoffset.y;
                                    BlockList[arraypointer].Area.Right = newarea.Right + searchoffset.x;
                                    BlockList[arraypointer].Area.Bottom = newarea.Bottom + searchoffset.y;
                                    BlockList[arraypointer].RotationCentre.x = CentreSearch[searchpointer].x;
                                    BlockList[arraypointer].RotationCentre.y = CentreSearch[searchpointer].y;
                                    BlockList[arraypointer].MirrorCentre.x = CentreSearch[searchpointer].x;
                                    BlockList[arraypointer].MirrorCentre.y = CentreSearch[searchpointer].y;
                                    //now translate the original points by this offset
                                    for (int i = 0; i < BlockList[arraypointer].Points.Length; i++) {
                                        BlockList[arraypointer].Points[i].originalx = BlockList[arraypointer].Points[i].originalx + searchoffset.x;
                                        BlockList[arraypointer].Points[i].originaly = BlockList[arraypointer].Points[i].originaly + searchoffset.y;
                                        }
                                    CentreSearch.Length = 0;

                                    //right, found the centre point, now to update all linked blocks
                                    int master = BlockList[arraypointer].ItemNumber;
                                    if (BlockList[arraypointer].Linked) {
                                        master = BlockList[arraypointer].LinkedBlock;
                                        for (int i = 0; i < BlockList.Length; i++) {
                                            if (BlockList[i].ItemNumber == master) {
                                                //need to change this master block
                                                AnsiString text;
                                                text = "Block,ChangeContents," + AnsiString(BlockList[i].ItemNumber) + ","
                                                            + AnsiString(BlockList[i].Area.Left) + ","
                                                            + AnsiString(BlockList[i].Area.Top) + ","
                                                            + AnsiString(BlockList[i].Area.Right) + ","
                                                            + AnsiString(BlockList[i].Area.Bottom) + ","
                                                            + AnsiString((int)(BlockList[i].Linked)) + ","
                                                            + AnsiString(BlockList[i].LinkedBlock) + ","
                                                            + AnsiString(BlockList[i].RotationCentre.x) + ","
                                                            + AnsiString(BlockList[i].RotationCentre.y) + ","
                                                            + AnsiString(BlockList[i].Angle) + ","
                                                            + AnsiString(BlockList[i].MirrorCentre.x) + ","
                                                            + AnsiString(BlockList[i].MirrorCentre.y) + ","
                                                            + AnsiString((int)(BlockList[i].Axis)) + ","
                                                            + AnsiString(BlockList[i].delta.x) + ","
                                                            + AnsiString(BlockList[i].delta.y) + ","
                                                            ;
                                                for (int j = 0; j < BlockList[i].Points.Length; j++) {
                                                    text = text + AnsiString(BlockList[i].Points[j].x) + ","
                                                            + AnsiString(BlockList[i].Points[j].y) + ","
                                                            + AnsiString(BlockList[i].Points[j].originalx) + ","
                                                            + AnsiString(BlockList[i].Points[j].originaly) + ","
                                                            + AnsiString((int)(BlockList[i].Points[j].Colour)) + ","
                                                            + AnsiString((int)(BlockList[i].Points[j].transparent)) + ","
                                                            ;
                                                    }
                                                AddUndo(text);
                                                //delta.x = BlockList[i].Area.Left - BlockList[arraypointer].Area.Left;
                                                //delta.y = BlockList[i].Area.Top - BlockList[arraypointer].Area.Top;
                                                delta.x = BlockList[i].Area.Left - oldarea.Left + searchoffset.x;
                                                delta.y = BlockList[i].Area.Top - oldarea.Top + searchoffset.y;
                                                BlockList[i].Area.Left = BlockList[arraypointer].Area.Left + delta.x;
                                                BlockList[i].Area.Top = BlockList[arraypointer].Area.Top + delta.y;
                                                BlockList[i].Area.Right = BlockList[arraypointer].Area.Right + delta.x;
                                                BlockList[i].Area.Bottom = BlockList[arraypointer].Area.Bottom + delta.y;
                                                BlockList[i].RotationCentre.x = BlockList[arraypointer].RotationCentre.x + delta.x;
                                                BlockList[i].RotationCentre.y = BlockList[arraypointer].RotationCentre.y + delta.y;
                                                BlockList[i].MirrorCentre.x = BlockList[arraypointer].MirrorCentre.x + delta.x;
                                                BlockList[i].MirrorCentre.y = BlockList[arraypointer].MirrorCentre.y + delta.y;
                                                //BlockList[i].RotationCentre.x += searchoffset.x;
                                                //BlockList[i].RotationCentre.y += searchoffset.y;
                                                //BlockList[i].MirrorCentre.x += searchoffset.x;
                                                //BlockList[i].MirrorCentre.y += searchoffset.y;
                                                BlockList[i].Points.Length = BlockList[arraypointer].Points.Length;
                                                for (int j = 0; j < BlockList[i].Points.Length; j++) {
                                                    //BlockList[i].Points[j].x = BlockList[arraypointer].Points[j].x + delta.x;
                                                    //BlockList[i].Points[j].y = BlockList[arraypointer].Points[j].y + delta.y;
                                                    BlockList[i].Points[j].originalx = BlockList[arraypointer].Points[j].originalx + delta.x;
                                                    BlockList[i].Points[j].originaly = BlockList[arraypointer].Points[j].originaly + delta.y;
                                                    BlockList[i].Points[j].Colour = BlockList[arraypointer].Points[j].Colour;
                                                    BlockList[i].Points[j].transparent = BlockList[arraypointer].Points[j].transparent;
                                                    }
                                                FillPointsBlock(i,BlockList[i].ItemNumber);
                                                DisplayListAreaUpdate(BlockList[i].ItemNumber);
                                                Memo1->Lines->Add("   Master Block");
                                                DebugBlock(i);
                                                }
                                            }
                                        }
                                    for (int i = 0; i < BlockList.Length; i++) {
                                        if (i != arraypointer && BlockList[i].Linked && BlockList[i].LinkedBlock == master) {
                                            //need to change this slave block
                                            AnsiString text;
                                            text = "Block,ChangeContents," + AnsiString(BlockList[i].ItemNumber) + ","
                                                            + AnsiString(BlockList[i].Area.Left) + ","
                                                            + AnsiString(BlockList[i].Area.Top) + ","
                                                            + AnsiString(BlockList[i].Area.Right) + ","
                                                            + AnsiString(BlockList[i].Area.Bottom) + ","
                                                            + AnsiString((int)(BlockList[i].Linked)) + ","
                                                            + AnsiString(BlockList[i].LinkedBlock) + ","
                                                            + AnsiString(BlockList[i].RotationCentre.x) + ","
                                                            + AnsiString(BlockList[i].RotationCentre.y) + ","
                                                            + AnsiString(BlockList[i].Angle) + ","
                                                            + AnsiString(BlockList[i].MirrorCentre.x) + ","
                                                            + AnsiString(BlockList[i].MirrorCentre.y) + ","
                                                            + AnsiString((int)(BlockList[i].Axis)) + ","
                                                            + AnsiString(BlockList[i].delta.x) + ","
                                                            + AnsiString(BlockList[i].delta.y) + ","
                                                            ;
                                            for (int j = 0; j < BlockList[i].Points.Length; j++) {
                                                text = text + AnsiString(BlockList[i].Points[j].x) + ","
                                                            + AnsiString(BlockList[i].Points[j].y) + ","
                                                            + AnsiString(BlockList[i].Points[j].originalx) + ","
                                                            + AnsiString(BlockList[i].Points[j].originaly) + ","
                                                            + AnsiString((int)(BlockList[i].Points[j].Colour)) + ","
                                                            + AnsiString((int)(BlockList[i].Points[j].transparent)) + ","
                                                            ;
                                                }
                                            AddUndo(text);
                                            //delta.x = BlockList[i].Area.Left - BlockList[arraypointer].Area.Left;
                                            //delta.y = BlockList[i].Area.Top - BlockList[arraypointer].Area.Top;
                                            //delta.x = DisplayList[XRefs[BlockList[i].ItemNumber].DisplayXRef].Area.Left - DisplayList[pointer].Area.Left;
                                            //delta.y = DisplayList[XRefs[BlockList[i].ItemNumber].DisplayXRef].Area.Top - DisplayList[pointer].Area.Top;
                                            delta.x = BlockList[i].Area.Left - oldarea.Left + searchoffset.x;
                                            delta.y = BlockList[i].Area.Top - oldarea.Top + searchoffset.y;
                                            BlockList[i].Area.Left = BlockList[arraypointer].Area.Left + delta.x;
                                            BlockList[i].Area.Top = BlockList[arraypointer].Area.Top + delta.y;
                                            BlockList[i].Area.Right = BlockList[arraypointer].Area.Right + delta.x;
                                            BlockList[i].Area.Bottom = BlockList[arraypointer].Area.Bottom + delta.y;
                                            BlockList[i].RotationCentre.x = BlockList[arraypointer].RotationCentre.x + delta.x;
                                            BlockList[i].RotationCentre.y = BlockList[arraypointer].RotationCentre.y + delta.y;
                                            BlockList[i].MirrorCentre.x = BlockList[arraypointer].MirrorCentre.x + delta.x;
                                            BlockList[i].MirrorCentre.y = BlockList[arraypointer].MirrorCentre.y + delta.y;
                                            BlockList[i].Points.Length = BlockList[arraypointer].Points.Length;
                                            for (int j = 0; j < BlockList[i].Points.Length; j++) {
                                                //BlockList[i].Points[j].x = BlockList[arraypointer].Points[j].x + delta.x;
                                                //BlockList[i].Points[j].y = BlockList[arraypointer].Points[j].y + delta.y;
                                                BlockList[i].Points[j].originalx = BlockList[arraypointer].Points[j].originalx + delta.x;
                                                BlockList[i].Points[j].originaly = BlockList[arraypointer].Points[j].originaly + delta.y;
                                                //BlockList[i].Points[j].originalx = BlockList[arraypointer].Points[j].originalx - delta.x;
                                                //BlockList[i].Points[j].originaly = BlockList[arraypointer].Points[j].originaly - delta.y;
                                                BlockList[i].Points[j].Colour = BlockList[arraypointer].Points[j].Colour;
                                                BlockList[i].Points[j].transparent = BlockList[arraypointer].Points[j].transparent;
                                                }
                                            FillPointsBlock(i,BlockList[i].ItemNumber);
                                            DisplayListAreaUpdate(BlockList[i].ItemNumber);
                                            Memo1->Lines->Add("   Slave Block");
                                            DebugBlock(i);
                                            }
                                        //Update the area of the block regardless of whether is has been modified
                                        BlockList[i].Area.Left = BlockList[i].Points[0].originalx;
                                        BlockList[i].Area.Top = BlockList[i].Points[0].originaly;
                                        BlockList[i].Area.Right = BlockList[i].Points[0].originalx;
                                        BlockList[i].Area.Bottom = BlockList[i].Points[0].originaly;
                                        for (int j = 1; j < BlockList[i].Points.Length; j++) {
                                            if (BlockList[i].Points[j].x < BlockList[i].Area.Left) BlockList[i].Area.Left = BlockList[i].Points[j].originalx;
                                            if (BlockList[i].Points[j].y < BlockList[i].Area.Top) BlockList[i].Area.Top = BlockList[i].Points[j].originaly;
                                            if (BlockList[i].Points[j].x > BlockList[i].Area.Right) BlockList[i].Area.Right = BlockList[i].Points[j].originalx;
                                            if (BlockList[i].Points[j].y > BlockList[i].Area.Bottom) BlockList[i].Area.Bottom = BlockList[i].Points[j].originaly;
                                            }
                                        BlockList[i].Area.Right += 1;
                                        BlockList[i].Area.Bottom += 1;
                                        //update mirror & centre points
                                        BlockList[i].RotationCentre.x = BlockList[i].Area.Left;
                                        BlockList[i].RotationCentre.y = BlockList[i].Area.Top;
                                        BlockList[i].MirrorCentre = BlockList[i].RotationCentre;
                                        }
                                    }
                                if (found) {
                                    DisplayListAreaUpdate(DisplayList[pointer].ItemNumber);
                                    }
                                DrawPicture();
                                }
                                break;
        case TEditPointPoints:  {
                                ActionType = TNoAction;
                                int pointer = 0;
                                bool found = false;
                                while (!found && pointer < DisplayList.Length) {
                                    if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayPoint) {
                                        found = true;
                                        pointer--;
                                        }
                                    pointer++;
                                    }
                                if (deselectafteroperation) {
                                    if (found) {
                                        AddUndo("Select," + AnsiString(DisplayList[pointer].ItemNumber) + ",");
                                        DisplayList[pointer].selected = false;
                                        }
                                    }
                                Label1->Visible = true;
                                Image2->Visible = true;
                                if (blendthreads || !BlendColours1->Enabled) Image3->Visible = true;
                                Label2->Visible = Image3->Visible;
                                //Foreground->Brush->Color = ForegroundColour;
                                Background->Brush->Bitmap = NULL;
                                //Background->Brush->Color = BackgroundColour;
                                DisplayCurrentColours();
                                Timer1->Enabled = true;
                                Image1->Cursor = crTargetCursor;
                                if (found) {
                                    DisplayListAreaUpdate(DisplayList[pointer].ItemNumber);
                                    }
                                DrawPicture();
                                }
                                break;
        default:                break;
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::EditPencilObjectPoints1Click(
      TObject *Sender)
{
    //This is my first foray into changing the way a display behaves mid program
    //The screen will be blanked out and filled with a transparent patch
    bool found = false;
    int pointer = 0;

    while (!found && pointer < DisplayList.Length) {
        if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayPoint) {
            found = true;
            pointer--;
            }
        pointer++;
        }

    if (found) {
        CreateXRefs();
        int entitypointer = XRefs[DisplayList[pointer].ItemNumber].EntityXRef;

        if (entitypointer > -1 && entitypointer < PointList.Length && PointList[entitypointer].ItemNumber == DisplayList[pointer].ItemNumber) {
            TerminateCurrentAction();
            ResetActionButtons();
            ActionType = TEditPointPoints;
            StatusBar1->Panels->Items[4]->Text = "Edit Pencil Tool. Press 'Enter' Key to Accept, 'Esc' to abandon.";
            Label1->Visible = false;
            Image2->Visible = false;
            Image3->Visible = false;
            Label2->Visible = Image3->Visible;
            Foreground->Brush->Color = PointList[entitypointer].Colour;
            Background->Brush->Bitmap = TransparentColour;
            Image1->Cursor = crDrawCursor;
            AddUndoTitle("Edit Pencil Object");
            AddUndoChangePoint(DisplayList[pointer].ItemNumber);
            /*
            AnsiString text = "Point,ChangeContents,"
                                + AnsiString(DisplayList[pointer].ItemNumber) + ","
                                + AnsiString((int)(DisplayList[pointer].Colour)) + ","
                                ;
            for (int i = 0; i < PointList[entitypointer].Points.Length; i++) {
                text = text + AnsiString(PointList[entitypointer].Points[i].x) + ","
                            + AnsiString(PointList[entitypointer].Points[i].y) + ",";
                }
            AddUndo(text);
            */
            }
        DrawPicture();
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::EditPencilObject1Click(TObject *Sender)
{
    EditPencilObjectPoints1->Enabled = (bool)(NumberPointsSelected == 1);        
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::EditBlock1Click(TObject *Sender)
{
    //The screen will be blanked out and filled with a transparent patch
    bool found = false;
    int pointer = 0;

    while (!found && pointer < DisplayList.Length) {
        if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayBlock) {
            found = true;
            pointer--;
            }
        pointer++;
        }

    if (found) {
        CreateXRefs();
        int entitypointer = XRefs[DisplayList[pointer].ItemNumber].EntityXRef;

        if (entitypointer > -1 && entitypointer < BlockList.Length && BlockList[entitypointer].ItemNumber == DisplayList[pointer].ItemNumber) {
            TerminateCurrentAction();
            ResetActionButtons();
            ActionType = TEditBlockPoints;
            StatusBar1->Panels->Items[4]->Text = "Edit Block. Press 'Enter' Key to Accept, 'Esc' to abandon.";
            Background->Brush->Bitmap = TransparentColour;
            Image1->Cursor = crDrawCursor;
            //now see if this is a master block, if not, change the one being pointed to.
            bool masterblock = !BlockList[entitypointer].Linked;
            if (!masterblock) {
                if (BlockList[entitypointer].LinkedBlock > -1
                    && XRefs[BlockList[entitypointer].LinkedBlock].DisplayType == TDisplayBlock
                    && XRefs[BlockList[entitypointer].LinkedBlock].EntityXRef > -1
                    && XRefs[BlockList[entitypointer].LinkedBlock].EntityXRef < BlockList.Length
                    && BlockList[XRefs[BlockList[entitypointer].LinkedBlock].EntityXRef].ItemNumber == BlockList[entitypointer].LinkedBlock
                    ) {
                    entitypointer = XRefs[BlockList[entitypointer].LinkedBlock].EntityXRef;
                    } else {
                    masterblock = true;
                    }
                }
            AddUndoTitle("Edit Block");
            AnsiString text;
            text = "Block,ChangeContents," + AnsiString(BlockList[entitypointer].ItemNumber) + ","
                                + AnsiString(BlockList[entitypointer].Area.Left) + ","
                                + AnsiString(BlockList[entitypointer].Area.Top) + ","
                                + AnsiString(BlockList[entitypointer].Area.Right) + ","
                                + AnsiString(BlockList[entitypointer].Area.Bottom) + ","
                                + AnsiString((int)(BlockList[entitypointer].Linked)) + ","
                                + AnsiString(BlockList[entitypointer].LinkedBlock) + ","
                                + AnsiString(BlockList[entitypointer].RotationCentre.x) + ","
                                + AnsiString(BlockList[entitypointer].RotationCentre.y) + ","
                                + AnsiString(BlockList[entitypointer].Angle) + ","
                                + AnsiString(BlockList[entitypointer].MirrorCentre.x) + ","
                                + AnsiString(BlockList[entitypointer].MirrorCentre.y) + ","
                                + AnsiString((int)(BlockList[entitypointer].Axis)) + ","
                                + AnsiString(BlockList[entitypointer].delta.x) + ","
                                + AnsiString(BlockList[entitypointer].delta.y) + ","
                                ;
            for (int j = 0; j < BlockList[entitypointer].Points.Length; j++) {
                text = text + AnsiString(BlockList[entitypointer].Points[j].x) + ","
                            + AnsiString(BlockList[entitypointer].Points[j].y) + ","
                            + AnsiString(BlockList[entitypointer].Points[j].originalx) + ","
                            + AnsiString(BlockList[entitypointer].Points[j].originaly) + ","
                            + AnsiString((int)(BlockList[entitypointer].Points[j].Colour)) + ","
                            + AnsiString((int)(BlockList[entitypointer].Points[j].transparent)) + ","
                            ;
                }
            AddUndo(text);
            if (!masterblock) {
                AddUndo("Select," + AnsiString(DisplayList[pointer].ItemNumber) + ",");
                AddUndo("Deselect," + AnsiString(BlockList[entitypointer].ItemNumber) + ",");
                DisplayList[pointer].selected = false;
                DisplayList[XRefs[BlockList[entitypointer].ItemNumber].DisplayXRef].selected = true;
                }
            }
        DrawPicture();
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::MoveStartPoint1Click(TObject *Sender)
{
    if (dynamic_cast <TComponent *>(Sender)) {
        bool found = false;
        int pointer = 0;
        while (!found && pointer < DisplayList.Length) {
            if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayLine) {
                found = true;
                pointer--;
                }
            pointer++;
            }
        int arraypointer;
        if (found) {
            arraypointer = XRefs[DisplayList[pointer].ItemNumber].EntityXRef;
            found = false;
            }
        if (arraypointer > -1 && arraypointer < LineList.Length && LineList[arraypointer].ItemNumber == DisplayList[pointer].ItemNumber) found = true;

        if (found) {
            TerminateCurrentAction();
            ActionType = (TActionType) (dynamic_cast <TComponent *>(Sender)->Tag);
            switch (ActionType) {
                case TEditLineStart:    {
                                        StartPointChart = LineList[arraypointer].EndPoint;
                                        chartposition SP = FindImage1Position(StartPointChart.x, StartPointChart.y);
                                        StartPointScreen.x = SP.X;
                                        StartPointScreen.y = SP.Y;
                                        wipedout = true;
                                        dragging = true;
                                        }
                                        break;
                case TEditLineEnd:      {
                                        StartPointChart = LineList[arraypointer].StartPoint;
                                        chartposition SP = FindImage1Position(StartPointChart.x, StartPointChart.y);
                                        StartPointScreen.x = SP.X;
                                        StartPointScreen.y = SP.Y;
                                        wipedout = true;
                                        dragging = true;
                                        }
                                        break;
                default:                {
                                        ActionType = TNoAction;
                                        }
                                        break;
                }
            }
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::MovePolyLinePoints(TObject *Sender)
{
    //moves polyline points
    if (dynamic_cast <TComponent *>(Sender)) {
        bool found = false;
        int pointer = 0;
        while (!found && pointer < DisplayList.Length) {
            if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayPolyLine) {
                found = true;
                pointer--;
                }
            pointer++;
            }
        int arraypointer;
        if (found) {
            arraypointer = XRefs[DisplayList[pointer].ItemNumber].EntityXRef;
            found = false;
            }
        if (arraypointer > -1 && arraypointer < PolyLineList.Length && PolyLineList[arraypointer].ItemNumber == DisplayList[pointer].ItemNumber) found = true;

        if (found) {
            TerminateCurrentAction();
            ResetActionButtons();
            ActionType = TEditPolyLine;
            wipedout = true;
            dragging = false;
            pointbeingdragged = -1;
            StatusBar1->Panels->Items[4]->Text = " Press 'Enter' or 'Esc' to Finish.";
            Timer1->Enabled = true;
            }
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::MoveFreeFormPoints(TObject *Sender)
{
    //moves polyline points
    if (dynamic_cast <TComponent *>(Sender)) {
        bool found = false;
        int pointer = 0;
        while (!found && pointer < DisplayList.Length) {
            if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayFreeForm) {
                found = true;
                pointer--;
                }
            pointer++;
            }
        int arraypointer;
        if (found) {
            arraypointer = XRefs[DisplayList[pointer].ItemNumber].EntityXRef;
            found = false;
            }
        if (arraypointer > -1 && arraypointer < FreeFormList.Length && FreeFormList[arraypointer].ItemNumber == DisplayList[pointer].ItemNumber) found = true;

        if (found) {
            TerminateCurrentAction();
            ResetActionButtons();
            ActionType = TEditFreeForm;
            wipedout = true;
            dragging = false;
            pointbeingdragged = -1;
            StatusBar1->Panels->Items[4]->Text = " Press 'Enter' or 'Esc' to Finish.";
            Timer1->Enabled = true;
            }
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::EditLine1Click(TObject *Sender)
{
    MoveStartPoint1->Enabled = (bool)(NumberLinesSelected == 1);
    MoveEndPoint1->Enabled = MoveStartPoint1->Enabled;
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::EditEraseItem1Click(TObject *Sender)
{
    //The screen will be blanked out and filled with a transparent patch
    bool found = false;
    int pointer = 0;

    while (!found && pointer < DisplayList.Length) {
        if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayEraseItem) {
            found = true;
            pointer--;
            }
        pointer++;
        }

    if (found) {
        CreateXRefs();
        int entitypointer = XRefs[DisplayList[pointer].ItemNumber].EntityXRef;

        if (entitypointer > -1 && entitypointer < EraseList.Length && EraseList[entitypointer].ItemNumber == DisplayList[pointer].ItemNumber) {
            TerminateCurrentAction();
            ResetActionButtons();
            ActionType = TEditErasePoints;
            StatusBar1->Panels->Items[4]->Text = "Edit Erase Object. Press 'Enter' Key to Accept, 'Esc' to abandon.";
            Label1->Visible = false;
            Image2->Visible = false;
            Image3->Visible = false;
            Label2->Visible = Image3->Visible;
            Foreground->Brush->Color = clBlack;
            Background->Brush->Bitmap = TransparentColour;
            Image1->Cursor = crDrawCursor;
            AddUndoTitle("Edit Erase Object");
            AnsiString text;
            text = "Erase,ChangeContents," + AnsiString(DisplayList[pointer].ItemNumber) + ","
                                ;
            for (int j = 0; j < EraseList[entitypointer].Points.Length; j++) {
                text = text + AnsiString(EraseList[entitypointer].Points[j].x) + ","
                            + AnsiString(EraseList[entitypointer].Points[j].y) + ","
                            + AnsiString((int)(EraseList[entitypointer].Points[j].Colour)) + ","
                            ;
                }
            AddUndo(text);
            }
        DrawPicture();
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::LinearArray1Click(TObject *Sender)
{
    //creates a linear array of blocks. Need to input the numbers in each direction
    //Re use the NewImage Form and change the labels a bit.

    TNewImageForm *NewImageForm = new TNewImageForm(this);

    NewImageForm->Caption = "Linear Array for Copying Block";
    NewImageForm->Label1->Caption = "Number of Copies";
    NewImageForm->Label2->Caption = "Horizontally (X)";
    NewImageForm->Label3->Caption = "Vertically (Y)";
    NewImageForm->ImageWidth->Text = AnsiString(LinearArray.x);
    NewImageForm->ImageWidth->Left = NewImageForm->Label1->Left + NewImageForm->Label1->Width + 16;
    NewImageForm->ImageHeight->Text = AnsiString(LinearArray.y);
    NewImageForm->ImageHeight->Left = NewImageForm->ImageWidth->Left;
    NewImageForm->CheckBox1->Visible = true;
    NewImageForm->CheckBox2->Visible = true;
    NewImageForm->CheckBox3->Visible = true;
    NewImageForm->CheckBox2->Enabled = false;
    NewImageForm->CheckBox3->Enabled = false;

    NewImageForm->ShowModal();

    if (NewImageForm->ModalResult == mrOk) {
        LinearArray.x = NewImageForm->ImageWidth->Text.ToIntDef(LinearArray.x);
        LinearArray.y = NewImageForm->ImageHeight->Text.ToIntDef(LinearArray.y);
        if (LinearArray.x < 1) LinearArray.x = 1;
        if (LinearArray.y < 1) LinearArray.y = 1;
        bool copynow = NewImageForm->CheckBox1->Checked;
        //OK, block copy setup complete, now go to do the mouse pointer size stuff
        TerminateCurrentAction();
        ResetActionButtons();
        //find the block being copied
        bool found = false;
        int pointer = 0;
        while (!found && pointer < DisplayList.Length) {
            if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayBlock) {
                found = true;
                pointer--;
                }
            pointer++;
            }
        if (copynow) {
            //block array being copied to touch each other.
            TPoint delta,delta2;
            delta.x = DisplayList[pointer].Area.Right - DisplayList[pointer].Area.Left;
            delta.y = DisplayList[pointer].Area.Bottom - DisplayList[pointer].Area.Top;
            if (NewImageForm->CheckBox2->Checked) delta.y = -1 * delta.y;
            if (NewImageForm->CheckBox3->Checked) delta.x = -1 * delta.x;
            AddUndoTitle("Linear Array of Block " + AnsiString(DisplayList[pointer].ItemNumber));
            SingleUndo = false;
            for (int i = 0; i < LinearArray.x; i++) {
                for (int j = 0; j < LinearArray.y; j++) {
                    if (i != 0 || j != 0) {
                        delta2.x = delta.x * i;
                        delta2.y = delta.y * j;
                        DisplayList.Length++;
                        DisplayList[DisplayList.Length - 1] = CopyBlock(delta2,DisplayList[pointer].ItemNumber);
                        DisplayListAreaUpdate(DisplayList[DisplayList.Length - 1].ItemNumber);
                        }
                    }
                }
            SingleUndo = true;
            if (deselectafteroperation) {
                DisplayList[pointer].selected = false;
                AddUndo("Select," + AnsiString(DisplayList[pointer].ItemNumber) + ",");
                }
            DrawPicture();
            } else {
            //OK, block copy setup complete and it's being done by mouse picks, now go to do the mouse pointer size stuff
            ActionType = TBlockArray;
            wipedout = true;
            dragging = true;
            Image1->Cursor = crDrawBlock;
            //set up the start point
            StartPointChart.x = DisplayList[pointer].Area.Left;
            StartPointChart.y = DisplayList[pointer].Area.Top;
            chartposition SP = FindImage1Position(StartPointChart.x,StartPointChart.y);
            StartPointScreen.x = SP.X;
            StartPointScreen.y = SP.Y;
            }
        }

    delete NewImageForm;

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::EditBlock2Click(TObject *Sender)
{
    LinearArray1->Enabled = (bool)(NumberBlocksSelected == 1);
    RotateBlock90->Enabled = LinearArray1->Enabled;
    RotateBlock180->Enabled = LinearArray1->Enabled;
    RotateBlock270->Enabled = LinearArray1->Enabled;
    MirrorVertical->Enabled = LinearArray1->Enabled;
    MirrorHorizontal->Enabled = LinearArray1->Enabled;
    MirrorVertical2->Enabled = LinearArray1->Enabled;
    MirrorHorizontal2->Enabled = LinearArray1->Enabled;
}
//---------------------------------------------------------------------------

TPoint __fastcall TImageEditorForm::RotateTPoint(TPoint Point, TPoint Centre, double Angle)
{
    //gives the new position of a Point that has been rotated by an angle of Angle about Centre
    TPoint returnvalue;
    double deltax, deltay;
    deltax = (double)(Point.x - Centre.x);
    deltay = (double)(Point.y - Centre.y);

    //the '+ 0.5' is so that the integer conversion rounds to the nearest int rather than doing a 'floor' command
    returnvalue.x = Centre.x + (int)(deltax * cosD(Angle) + deltay * sinD(Angle) + 0.5);
    returnvalue.y = Centre.y + (int)(-1.0 * deltax * sinD(Angle) + deltay * cosD(Angle) + 0.5);
    //returnvalue.x = Centre.x + (int)(deltax * cosD(Angle) + deltay * sinD(Angle));
    //returnvalue.y = Centre.y + (int)(-1.0 * deltax * sinD(Angle) + deltay * cosD(Angle));

    return returnvalue;

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::RotatePoint(TPoint Centre, int ItemNumber, int Angle)
{
    //rotates points
    CreateXRefs();
    bool found = false;
    int pointer = XRefs[ItemNumber].EntityXRef;
    int displaypointer = XRefs[ItemNumber].DisplayXRef;

    if ( XRefs[ItemNumber].DisplayType == TDisplayPoint
        && pointer > -1
        && pointer < PointList.Length
        && PointList[pointer].ItemNumber == ItemNumber
        && displaypointer > -1
        && displaypointer < DisplayList.Length
        && DisplayList[displaypointer].DisplayType == TDisplayPoint
        && DisplayList[displaypointer].ItemNumber == ItemNumber
        ) {
        found = true;
        }

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Rotate Pencil Object");
            //AddUndo("Rotate," + AnsiString(ItemNumber) + "," + AnsiString(Centre.x) + "," + AnsiString(Centre.y) + "," + AnsiString(Angle * -1) + ",");
            /*AnsiString text;
            text = "Point,ChangeContents," + AnsiString(ItemNumber) + ","
                                + AnsiString((int)(PointList[pointer].Colour)) + ","
                                ;
            for (int j = 0; j < PointList[pointer].Points.Length; j++) {
                text = text + AnsiString(PointList[pointer].Points[j].x) + "," + AnsiString(PointList[pointer].Points[j].y) + ",";
                }
            AddUndo(text);
            */
            AddUndoChangePoint(ItemNumber);
            if (deselectafteroperation) {
                DisplayList[displaypointer].selected = false;
                AddUndo("Select," + AnsiString(ItemNumber) + ",");
                }
            }
        //change angle of points
        double angle = ((double) (Angle))/10.0;
        while (angle > 360.0) {
            angle -= 360.0;
            }
        while (angle < 0.0) {
            angle += 360.0;
            }
        //rotate the point array
        for (int i = 0; i < PointList[pointer].Points.Length; i++) {
            PointList[pointer].Points[i] = RotateTPoint(PointList[pointer].Points[i],Centre,angle);
            }
        //update the boundary rectangle
        DisplayListAreaUpdate(ItemNumber);
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::RotateLine(TPoint Centre, int ItemNumber, int Angle)
{
    //rotates lines
    CreateXRefs();
    bool found = false;
    int pointer = XRefs[ItemNumber].EntityXRef;
    int displaypointer = XRefs[ItemNumber].DisplayXRef;

    if ( XRefs[ItemNumber].DisplayType == TDisplayLine
        && pointer > -1
        && pointer < LineList.Length
        && LineList[pointer].ItemNumber == ItemNumber
        && displaypointer > -1
        && displaypointer < DisplayList.Length
        && DisplayList[displaypointer].DisplayType == TDisplayLine
        && DisplayList[displaypointer].ItemNumber == ItemNumber
        ) {
        found = true;
        }

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Rotate Line");
            AddUndo("Rotate," + AnsiString(ItemNumber) + "," + AnsiString(Centre.x) + "," + AnsiString(Centre.y) + "," + AnsiString(Angle * -1) + ",");
            if (deselectafteroperation) {
                DisplayList[displaypointer].selected = false;
                AddUndo("Select," + AnsiString(ItemNumber) + ",");
                }
            }
        //change angle of points
        double angle = ((double) (Angle))/10.0;
        while (angle > 360.0) {
            angle -= 360.0;
            }
        while (angle < 0.0) {
            angle += 360.0;
            }
        //rotate the start & ends
        LineList[pointer].StartPoint = RotateTPoint(LineList[pointer].StartPoint,Centre,angle);
        LineList[pointer].EndPoint = RotateTPoint(LineList[pointer].EndPoint,Centre,angle);
        //regenerate display points for line
        FillPointsLine(pointer,ItemNumber);
        //update the boundary rectangle
        DisplayListAreaUpdate(ItemNumber);
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::RotatePolyLine(TPoint Centre, int ItemNumber, int Angle)
{
    //rotates Polylines
    CreateXRefs();
    bool found = false;
    int pointer = XRefs[ItemNumber].EntityXRef;
    int displaypointer = XRefs[ItemNumber].DisplayXRef;

    if ( XRefs[ItemNumber].DisplayType == TDisplayPolyLine
        && pointer > -1
        && pointer < PolyLineList.Length
        && PolyLineList[pointer].ItemNumber == ItemNumber
        && displaypointer > -1
        && displaypointer < DisplayList.Length
        && DisplayList[displaypointer].DisplayType == TDisplayPolyLine
        && DisplayList[displaypointer].ItemNumber == ItemNumber
        ) {
        found = true;
        }

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Rotate Polyline");
            //AddUndo("Rotate," + AnsiString(ItemNumber) + "," + AnsiString(Centre.x) + "," + AnsiString(Centre.y) + "," + AnsiString(Angle * -1) + ",");
            AddUndoChangePolyLine(ItemNumber);
            if (deselectafteroperation) {
                DisplayList[displaypointer].selected = false;
                AddUndo("Select," + AnsiString(ItemNumber) + ",");
                }
            }
        //change angle of points
        double angle = ((double) (Angle))/10.0;
        while (angle > 360.0) {
            angle -= 360.0;
            }
        while (angle < 0.0) {
            angle += 360.0;
            }
        //rotate the corners
        for (int i = 0; i < PolyLineList[pointer].Corners.Length; i++) {
            PolyLineList[pointer].Corners[i] = RotateTPoint(PolyLineList[pointer].Corners[i],Centre,angle);
            }
        //regenerate display points for line
        FillPointsPolyLine(pointer,ItemNumber);
        //update the boundary rectangle
        DisplayListAreaUpdate(ItemNumber);
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::RotateFloodFill(TPoint Centre, int ItemNumber, int Angle)
{
    //rotates Flood Fills
    CreateXRefs();
    bool found = false;
    int pointer = XRefs[ItemNumber].EntityXRef;
    int displaypointer = XRefs[ItemNumber].DisplayXRef;

    if ( XRefs[ItemNumber].DisplayType == TDisplayFloodFill
        && pointer > -1
        && pointer < FloodFillList.Length
        && FloodFillList[pointer].ItemNumber == ItemNumber
        && displaypointer > -1
        && displaypointer < DisplayList.Length
        && DisplayList[displaypointer].DisplayType == TDisplayFloodFill
        && DisplayList[displaypointer].ItemNumber == ItemNumber
        ) {
        found = true;
        }

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Rotate Flood Fill");
            AnsiString text;
            text = "FloodFill,ChangeContents," + AnsiString(ItemNumber) + ","
                                + AnsiString((int)(FloodFillList[pointer].Colour)) + ","
                                + AnsiString((int)(FloodFillList[pointer].FilledColour)) + ","
                                + AnsiString(FloodFillList[pointer].StartPoint.x) + ","
                                + AnsiString(FloodFillList[pointer].StartPoint.y) + ","
                                ;
            for (int j = 0; j < FloodFillList[pointer].Points.Length; j++) {
                text = text + AnsiString(FloodFillList[pointer].Points[j].x) + "," + AnsiString(FloodFillList[pointer].Points[j].y) + ",";
                }
            AddUndo(text);
            //AddUndo("Rotate," + AnsiString(ItemNumber) + "," + AnsiString(Centre.x) + "," + AnsiString(Centre.y) + "," + AnsiString(Angle * -1) + ",");
            if (deselectafteroperation) {
                DisplayList[displaypointer].selected = false;
                AddUndo("Select," + AnsiString(ItemNumber) + ",");
                }
            }
        //change angle of points
        double angle = ((double) (Angle))/10.0;
        while (angle > 360.0) {
            angle -= 360.0;
            }
        while (angle < 0.0) {
            angle += 360.0;
            }
        //rotate the start point
        FloodFillList[pointer].StartPoint = RotateTPoint(FloodFillList[pointer].StartPoint,Centre,angle);
        //rotate the point array
        for (int i = 0; i < FloodFillList[pointer].Points.Length; i++) {
            FloodFillList[pointer].Points[i] = RotateTPoint(FloodFillList[pointer].Points[i],Centre,angle);
            }
        //update the boundary rectangle
        DisplayListAreaUpdate(ItemNumber);
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::RotateText(TPoint Centre, int ItemNumber, int Angle)
{
    CreateXRefs();
    bool found = false;
    int pointer = XRefs[ItemNumber].EntityXRef;
    int displaypointer = XRefs[ItemNumber].DisplayXRef;

    if ( XRefs[ItemNumber].DisplayType == TDisplayText
        && pointer > -1
        && pointer < TextList.Length
        && TextList[pointer].ItemNumber == ItemNumber
        && displaypointer > -1
        && displaypointer < DisplayList.Length
        && DisplayList[displaypointer].DisplayType == TDisplayText
        && DisplayList[displaypointer].ItemNumber == ItemNumber
        ) {
        found = true;
        }

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Rotate Text");
            AddUndo("Rotate," + AnsiString(ItemNumber) + "," + AnsiString(TextList[pointer].StartPoint.x) + "," + AnsiString(TextList[pointer].StartPoint.y) + "," + AnsiString(TextList[pointer].Angle) + ",");
            if (deselectafteroperation) {
                DisplayList[displaypointer].selected = false;
                AddUndo("Select," + AnsiString(ItemNumber) + ",");
                }
            }
        //change angle of text
        double temp1 = ((double) (Angle))/10.0;
        //double temp2 = ((double) (TextList[pointer].Angle))/10.0;
        double angle = temp1 /*+ temp2*/;
        while (angle > 360.0) {
            angle -= 360.0;
            }
        while (angle < 0.0) {
            angle += 360.0;
            }
        //rotate the start point
        TextList[pointer].StartPoint = RotateTPoint(TextList[pointer].StartPoint,Centre,temp1);
        //rotate the text itself
        TextList[pointer].Angle = (int)(angle * 10.0);
        FillPointsText(pointer,ItemNumber);
        //update the boundary rectangle
        DisplayListAreaUpdate(ItemNumber);
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::RotateRectangle(TPoint Centre, int ItemNumber, int Angle)
{
    //rotates rectangles
    CreateXRefs();
    bool found = false;
    int pointer = XRefs[ItemNumber].EntityXRef;
    int displaypointer = XRefs[ItemNumber].DisplayXRef;

    if ( XRefs[ItemNumber].DisplayType == TDisplayRectangle
        && pointer > -1
        && pointer < RectangleList.Length
        && RectangleList[pointer].ItemNumber == ItemNumber
        && displaypointer > -1
        && displaypointer < DisplayList.Length
        && DisplayList[displaypointer].DisplayType == TDisplayRectangle
        && DisplayList[displaypointer].ItemNumber == ItemNumber
        ) {
        found = true;
        }

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Rotate Rectangle");
            AddUndo("Rotate," + AnsiString(ItemNumber) + "," + AnsiString(Centre.x) + "," + AnsiString(Centre.y) + "," + AnsiString(Angle * -1) + ",");
            if (deselectafteroperation) {
                DisplayList[displaypointer].selected = false;
                AddUndo("Select," + AnsiString(ItemNumber) + ",");
                }
            }
        //change angle of points
        double angle = ((double) (Angle))/10.0;
        while (angle > 360.0) {
            angle -= 360.0;
            }
        while (angle < 0.0) {
            angle += 360.0;
            }
        //rotate the start & move the end
        TPoint Point, delta;
        Point.x = RectangleList[pointer].Area.Left;
        Point.y = RectangleList[pointer].Area.Top;
        Point = RotateTPoint(Point,Centre,angle);
        delta.x = RectangleList[pointer].Area.Right - RectangleList[pointer].Area.Left;
        delta.y = RectangleList[pointer].Area.Bottom - RectangleList[pointer].Area.Top;
        RectangleList[pointer].Area.Left = Point.x;
        RectangleList[pointer].Area.Top = Point.y;
        RectangleList[pointer].Area.Right = Point.x + delta.x;
        RectangleList[pointer].Area.Bottom = Point.y + delta.y;
        RectangleList[pointer].Angle += Angle;
        //regenerate display points for Rectangle
        FillPointsRectangle(pointer,ItemNumber);
        //update the boundary rectangle
        DisplayListAreaUpdate(ItemNumber);
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::RotateCircle(TPoint Centre, int ItemNumber, int Angle)
{
    //rotates circles
    CreateXRefs();
    bool found = false;
    int pointer = XRefs[ItemNumber].EntityXRef;
    int displaypointer = XRefs[ItemNumber].DisplayXRef;

    if ( XRefs[ItemNumber].DisplayType == TDisplayCircle
        && pointer > -1
        && pointer < CircleList.Length
        && CircleList[pointer].ItemNumber == ItemNumber
        && displaypointer > -1
        && displaypointer < DisplayList.Length
        && DisplayList[displaypointer].DisplayType == TDisplayCircle
        && DisplayList[displaypointer].ItemNumber == ItemNumber
        ) {
        found = true;
        }

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Rotate Circle");
            AddUndo("Rotate," + AnsiString(ItemNumber) + "," + AnsiString(Centre.x) + "," + AnsiString(Centre.y) + "," + AnsiString(Angle * -1) + ",");
            if (deselectafteroperation) {
                DisplayList[displaypointer].selected = false;
                AddUndo("Select," + AnsiString(ItemNumber) + ",");
                }
            }
        //change angle of points
        double angle = ((double) (Angle))/10.0;
        while (angle > 360.0) {
            angle -= 360.0;
            }
        while (angle < 0.0) {
            angle += 360.0;
            }
        //rotate the start & move the end
        TPoint Point, delta;
        Point.x = CircleList[pointer].Area.Left;
        Point.y = CircleList[pointer].Area.Top;
        Point = RotateTPoint(Point,Centre,angle);
        delta.x = CircleList[pointer].Area.Right - CircleList[pointer].Area.Left;
        delta.y = CircleList[pointer].Area.Bottom - CircleList[pointer].Area.Top;
        CircleList[pointer].Area.Left = Point.x;
        CircleList[pointer].Area.Top = Point.y;
        CircleList[pointer].Area.Right = Point.x + delta.x;
        CircleList[pointer].Area.Bottom = Point.y + delta.y;
        CircleList[pointer].Angle += Angle;
        //regenerate display points for Circle
        FillPointsCircle(pointer,ItemNumber);
        //update the boundary rectangle
        DisplayListAreaUpdate(ItemNumber);
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::RotateFreeForm(TPoint Centre, int ItemNumber, int Angle)
{
    //rotates FreeForms
    CreateXRefs();
    bool found = false;
    int pointer = XRefs[ItemNumber].EntityXRef;
    int displaypointer = XRefs[ItemNumber].DisplayXRef;

    if ( XRefs[ItemNumber].DisplayType == TDisplayFreeForm
        && pointer > -1
        && pointer < FreeFormList.Length
        && FreeFormList[pointer].ItemNumber == ItemNumber
        && displaypointer > -1
        && displaypointer < DisplayList.Length
        && DisplayList[displaypointer].DisplayType == TDisplayFreeForm
        && DisplayList[displaypointer].ItemNumber == ItemNumber
        ) {
        found = true;
        }

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Rotate Free-Form Shape");
            //AddUndo("Rotate," + AnsiString(ItemNumber) + "," + AnsiString(Centre.x) + "," + AnsiString(Centre.y) + "," + AnsiString(Angle * -1) + ",");
            AddUndoChangeFreeForm(ItemNumber);
            if (deselectafteroperation) {
                DisplayList[displaypointer].selected = false;
                AddUndo("Select," + AnsiString(ItemNumber) + ",");
                }
            }
        //change angle of points
        double angle = ((double) (Angle))/10.0;
        while (angle > 360.0) {
            angle -= 360.0;
            }
        while (angle < 0.0) {
            angle += 360.0;
            }
        //rotate the corners
        for (int i = 0; i < FreeFormList[pointer].Corners.Length; i++) {
            FreeFormList[pointer].Corners[i] = RotateTPoint(FreeFormList[pointer].Corners[i],Centre,angle);
            }
        //regenerate display points for line
        FillPointsFreeForm(pointer,ItemNumber);
        //update the boundary rectangle
        DisplayListAreaUpdate(ItemNumber);
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::RotateErase(TPoint Centre, int ItemNumber, int Angle)
{
    //rotates erase items
    CreateXRefs();
    bool found = false;
    int pointer = XRefs[ItemNumber].EntityXRef;
    int displaypointer = XRefs[ItemNumber].DisplayXRef;

    if ( XRefs[ItemNumber].DisplayType == TDisplayEraseItem
        && pointer > -1
        && pointer < EraseList.Length
        && EraseList[pointer].ItemNumber == ItemNumber
        && displaypointer > -1
        && displaypointer < DisplayList.Length
        && DisplayList[displaypointer].DisplayType == TDisplayEraseItem
        && DisplayList[displaypointer].ItemNumber == ItemNumber
        ) {
        found = true;
        }

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Rotate Erase Object");
            AnsiString text;
            text = "Erase,ChangeContents," + AnsiString(DisplayList[pointer].ItemNumber) + ","
                                ;
            for (int j = 0; j < EraseList[pointer].Points.Length; j++) {
                text = text + AnsiString(EraseList[pointer].Points[j].x) + ","
                            + AnsiString(EraseList[pointer].Points[j].y) + ","
                            + AnsiString((int)(EraseList[pointer].Points[j].Colour)) + ","
                            ;
                }
            AddUndo(text);
            //AddUndo("Rotate," + AnsiString(ItemNumber) + "," + AnsiString(Centre.x) + "," + AnsiString(Centre.y) + "," + AnsiString(Angle * -1) + ",");
            if (deselectafteroperation) {
                DisplayList[displaypointer].selected = false;
                AddUndo("Select," + AnsiString(ItemNumber) + ",");
                }
            }
        //change angle of points
        double angle = ((double) (Angle))/10.0;
        while (angle > 360.0) {
            angle -= 360.0;
            }
        while (angle < 0.0) {
            angle += 360.0;
            }
        //rotate the point array
        TPoint Point;
        for (int i = 0; i < EraseList[pointer].Points.Length; i++) {
            Point.x = EraseList[pointer].Points[i].x;
            Point.y = EraseList[pointer].Points[i].y;
            Point = RotateTPoint(Point,Centre,angle);
            EraseList[pointer].Points[i].x = Point.x;
            EraseList[pointer].Points[i].y = Point.y;
            EraseList[pointer].Points[i].Colour = Picture->Canvas->Pixels[Point.x][Point.y];
            }
        //update the boundary rectangle
        DisplayListAreaUpdate(ItemNumber);
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::RotateBlock(TPoint Centre, int ItemNumber, int Angle)
{
    //rotates blocks
    CreateXRefs();
    bool found = false;
    int pointer = XRefs[ItemNumber].EntityXRef;
    int displaypointer = XRefs[ItemNumber].DisplayXRef;

    if ( XRefs[ItemNumber].DisplayType == TDisplayBlock
        && pointer > -1
        && pointer < BlockList.Length
        && BlockList[pointer].ItemNumber == ItemNumber
        && displaypointer > -1
        && displaypointer < DisplayList.Length
        && DisplayList[displaypointer].DisplayType == TDisplayBlock
        && DisplayList[displaypointer].ItemNumber == ItemNumber
        ) {
        found = true;
        }

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Rotate Block");
            AnsiString text;
            text = "Block,ChangeContents,";
            text = text + AnsiString(BlockList[pointer].ItemNumber) + ",";
            text = text + AnsiString(BlockList[pointer].Area.Left) + ","
                                + AnsiString(BlockList[pointer].Area.Top) + ","
                                + AnsiString(BlockList[pointer].Area.Right) + ","
                                + AnsiString(BlockList[pointer].Area.Bottom) + ","
                                + AnsiString((int)(BlockList[pointer].Linked)) + ","
                                + AnsiString(BlockList[pointer].LinkedBlock) + ","
                                + AnsiString(BlockList[pointer].RotationCentre.x) + ","
                                + AnsiString(BlockList[pointer].RotationCentre.y) + ","
                                + AnsiString(BlockList[pointer].Angle) + ","
                                + AnsiString(BlockList[pointer].MirrorCentre.x) + ","
                                + AnsiString(BlockList[pointer].MirrorCentre.y) + ","
                                + AnsiString((int)(BlockList[pointer].Axis)) + ","
                                + AnsiString(BlockList[pointer].delta.x) + ","
                                + AnsiString(BlockList[pointer].delta.y) + ","
                                ;
            for (int j = 0; j < BlockList[pointer].Points.Length; j++) {
                text = text + AnsiString(BlockList[pointer].Points[j].x) + ","
                            + AnsiString(BlockList[pointer].Points[j].y) + ","
                            + AnsiString(BlockList[pointer].Points[j].originalx) + ","
                            + AnsiString(BlockList[pointer].Points[j].originaly) + ","
                            + AnsiString((int)(BlockList[pointer].Points[j].Colour)) + ","
                            + AnsiString((int)(BlockList[pointer].Points[j].transparent)) + ","
                            ;
                }
            AddUndo(text);
            if (deselectafteroperation) {
                DisplayList[displaypointer].selected = false;
                AddUndo("Select," + AnsiString(ItemNumber) + ",");
                }
            }
        //change angle of block. first translate to new point, then rotate about point
        double angle = ((double) (Angle))/10.0;
        while (angle > 360.0) {
            angle -= 360.0;
            }
        while (angle < 0.0) {
            angle += 360.0;
            }
        //rotate the point array
        TPoint Point, delta, delta2;
        Point.x = BlockList[pointer].Area.Left;
        Point.y = BlockList[pointer].Area.Top;
        Point = RotateTPoint(Point,Centre,angle);
        delta.x = BlockList[pointer].Area.Right - BlockList[pointer].Area.Left;
        delta.y = BlockList[pointer].Area.Bottom - BlockList[pointer].Area.Top;
        delta2.x = Point.x - BlockList[pointer].Area.Left;
        delta2.y = Point.y - BlockList[pointer].Area.Top;
        BlockList[pointer].Area.Left = Point.x;
        BlockList[pointer].Area.Top = Point.y;
        BlockList[pointer].Area.Right = Point.x + delta.x;
        BlockList[pointer].Area.Bottom = Point.y + delta.y;
        //Move rotationcentre point
        BlockList[pointer].RotationCentre.x += delta2.x;
        BlockList[pointer].RotationCentre.y += delta2.y;
        BlockList[pointer].Angle += Angle;
        //Move MirrorCentre
        BlockList[pointer].MirrorCentre.x += delta2.x;
        BlockList[pointer].MirrorCentre.y += delta2.y;
        //Move original poinys
        for (int i = 0; i < BlockList[pointer].Points.Length; i++) {
            BlockList[pointer].Points[i].originalx += delta2.x;
            BlockList[pointer].Points[i].originaly += delta2.y;
            }
        //fill display positions
        FillPointsBlock(pointer,ItemNumber);
        //update the boundary rectangle
        DisplayListAreaUpdate(ItemNumber);
        }
}
//---------------------------------------------------------------------------

double __fastcall TImageEditorForm::ExtractAngle(TPoint delta)
{
    //finds the angle that delta subtends to the line 1,0
    //there are a number of pitfalls this routine tries to avoid
    double l = sqrt((double)(delta.x * delta.x) + (double)(delta.y * delta.y));
    double angle;
    if (l < delta.x) l = delta.x;
    if(l == 0.0) {
        angle = 0.0;
        } else {
        angle = acosD(((double)(delta.x))/l);
        }
    if (delta.y > 0) angle = 360.0 - angle;
    while (angle > 360.0) {
        angle -= 360.0;
        }
    while (angle < 0.0) {
        angle += 360.0;
        }
    return angle;
}
//---------------------------------------------------------------------------

TRect __fastcall TImageEditorForm::MirrorRectanglePoints(TRect Rect,TPoint Centre, TMirrorAxis Axis)
{
    //Mirrors a rectangle about the mirror line passing through Centre
    TRect ReturnValue;
    int delta;

    switch (Axis) {
        case TMAVertical:   {
                            //vertical mirror line, so object flips horizontally about it
                            delta = Rect.Left - Centre.x;
                            ReturnValue.Right = Centre.x - delta;
                            ReturnValue.Top = Rect.Top;
                            delta = Rect.Right - Centre.x;
                            ReturnValue.Left = Centre.x - delta;
                            ReturnValue.Bottom = Rect.Bottom;
                            }
                            break;
        default:            {
                            //Horizontal mirror line, so rectangle flips up & down about it
                            ReturnValue.Left = Rect.Left;
                            delta = Rect.Top - Centre.y;
                            ReturnValue.Bottom = Centre.y - delta;
                            ReturnValue.Right = Rect.Right;
                            delta = Rect.Bottom - Centre.y;
                            ReturnValue.Top = Centre.y - delta;
                            }
                            break;
        }


    return ReturnValue;
}
//---------------------------------------------------------------------------

TPoint __fastcall TImageEditorForm::MirrorTPoint(TPoint Point,TPoint Centre, TMirrorAxis Axis)
{
    //Mirrors a rectangle about the mirror line passing through Centre
    TPoint ReturnValue;
    //int delta;
    float delta, centre;

    switch (Axis) {
        case TMAVertical:   {
                            //vertical mirror line, so point flips horizontally about it
                            //delta = Point.x - Centre.x;
                            //ReturnValue.x = Centre.x - delta;
                            centre = (float)(Centre.x) -0.5;
                            delta = (float)(Point.x) - centre;
                            ReturnValue.x = (int)(centre - delta);
                            ReturnValue.y = Point.y;
                            }
                            break;
        default:            {
                            //Horizontal mirror line, so point flips up & down about it
                            ReturnValue.x = Point.x;
                            //delta = Point.y - Centre.y;
                            //ReturnValue.y = Centre.y - delta;
                            centre = (float)(Centre.y) - 0.5;
                            delta = (float)(Point.y) - centre;
                            ReturnValue.y = (int)(centre - delta);
                            }
                            break;
        }


    return ReturnValue;
}
//---------------------------------------------------------------------------
/*
void __fastcall TImageEditorForm::MirrorPoint(TPoint Centre, int ItemNumber, TMirrorAxis Axis)
{
    //Mirrors all the points
    CreateXRefs();
    bool found = false;
    int pointer = XRefs[ItemNumber].EntityXRef;
    int displaypointer = XRefs[ItemNumber].DisplayXRef;

    if ( XRefs[ItemNumber].DisplayType == TDisplayPoint
        && pointer > -1
        && pointer < PointList.Length
        && PointList[pointer].ItemNumber == ItemNumber
        && displaypointer > -1
        && displaypointer < DisplayList.Length
        && DisplayList[displaypointer].DisplayType == TDisplayPoint
        && DisplayList[displaypointer].ItemNumber == ItemNumber
        ) {
        found = true;
        }

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Mirror Pencil Object");
            //AddUndo("Mirror," + AnsiString(ItemNumber) + "," + AnsiString(Centre.x) + "," + AnsiString(Centre.y) + "," + AnsiString((int)(Axis)) + ",");
            AnsiString text;
            text = "Point,ChangeContents," + AnsiString(ItemNumber) + ","
                                + AnsiString((int)(PointList[pointer].Colour)) + ","
                                ;
            for (int j = 0; j < PointList[pointer].Points.Length; j++) {
                text = text + AnsiString(PointList[pointer].Points[j].x) + "," + AnsiString(PointList[pointer].Points[j].y) + ",";
                }
            AddUndo(text);
            if (deselectafteroperation) {
                DisplayList[displaypointer].selected = false;
                AddUndo("Select," + AnsiString(ItemNumber) + ",");
                }
            }
        //mirror the point array
        for (int i = 0; i < PointList[pointer].Points.Length; i++) {
            PointList[pointer].Points[i] = MirrorTPoint(PointList[pointer].Points[i],Centre,Axis);
            }
        //update the boundary rectangle
        DisplayListAreaUpdate(ItemNumber);
        }
}
//---------------------------------------------------------------------------
*/

void __fastcall TImageEditorForm::MirrorCopyPoint(TPoint Centre, int ItemNumber, TMirrorAxis Axis)
{
    //Mirrors all the points
    CreateXRefs();
    bool found = false;
    int pointer = XRefs[ItemNumber].EntityXRef;
    int displaypointer = XRefs[ItemNumber].DisplayXRef;

    if ( XRefs[ItemNumber].DisplayType == TDisplayPoint
        && pointer > -1
        && pointer < PointList.Length
        && PointList[pointer].ItemNumber == ItemNumber
        && displaypointer > -1
        && displaypointer < DisplayList.Length
        && DisplayList[displaypointer].DisplayType == TDisplayPoint
        && DisplayList[displaypointer].ItemNumber == ItemNumber
        ) {
        found = true;
        }

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Mirror Pencil Object");
            AddUndo("Delete," + AnsiString(DisplayItemNumber) + ",");
            if (deselectafteroperation) {
                DisplayList[displaypointer].selected = false;
                AddUndo("Select," + AnsiString(ItemNumber) + ",");
                }
            }
        //create new point in point list
        int arrayentry = PointList.Length;
        PointList.Length++;
        PointList[arrayentry].ItemNumber = DisplayItemNumber;
        PointList[arrayentry].Colour = PointList[pointer].Colour;
        PointList[arrayentry].Points.Length = PointList[pointer].Points.Length;
        //mirror the point array
        for (int i = 0; i < PointList[pointer].Points.Length; i++) {
            PointList[arrayentry].Points[i] = MirrorTPoint(PointList[pointer].Points[i],Centre,Axis);
            }
        //create new display list entry
        arrayentry = DisplayList.Length;
        DisplayList.Length++;
        DisplayList[arrayentry].ItemNumber = DisplayItemNumber;
        DisplayList[arrayentry].DisplayType = TDisplayPoint;
        DisplayList[arrayentry].selected = false;
        DisplayList[arrayentry].visible = true;
        DisplayItemNumber++;
        //update the boundary rectangle
        CreateXRefs();
        DisplayListAreaUpdate(DisplayList[arrayentry].ItemNumber);
        }
}
//---------------------------------------------------------------------------

/*
void __fastcall TImageEditorForm::MirrorLine(TPoint Centre, int ItemNumber, TMirrorAxis Axis)
{
    //Mirrors a line
    CreateXRefs();
    bool found = false;
    int pointer = XRefs[ItemNumber].EntityXRef;
    int displaypointer = XRefs[ItemNumber].DisplayXRef;

    if ( XRefs[ItemNumber].DisplayType == TDisplayLine
        && pointer > -1
        && pointer < LineList.Length
        && LineList[pointer].ItemNumber == ItemNumber
        && displaypointer > -1
        && displaypointer < DisplayList.Length
        && DisplayList[displaypointer].DisplayType == TDisplayLine
        && DisplayList[displaypointer].ItemNumber == ItemNumber
        ) {
        found = true;
        }

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Mirror Line");
            AddUndo("Mirror," + AnsiString(ItemNumber) + "," + AnsiString(Centre.x) + "," + AnsiString(Centre.y) + "," + AnsiString((int)(Axis)) + ",");
            if (deselectafteroperation) {
                DisplayList[displaypointer].selected = false;
                AddUndo("Select," + AnsiString(ItemNumber) + ",");
                }
            }
        //mirror the start & ends
        LineList[pointer].StartPoint = MirrorTPoint(LineList[pointer].StartPoint,Centre,Axis);
        LineList[pointer].EndPoint = MirrorTPoint(LineList[pointer].EndPoint,Centre,Axis);
        //regenerate display points for line
        FillPointsLine(pointer,ItemNumber);
        //update the boundary rectangle
        DisplayListAreaUpdate(ItemNumber);
        }
}
//---------------------------------------------------------------------------
*/

void __fastcall TImageEditorForm::MirrorCopyLine(TPoint Centre, int ItemNumber, TMirrorAxis Axis)
{
    //Mirrors a line
    CreateXRefs();
    bool found = false;
    int pointer = XRefs[ItemNumber].EntityXRef;
    int displaypointer = XRefs[ItemNumber].DisplayXRef;

    if ( XRefs[ItemNumber].DisplayType == TDisplayLine
        && pointer > -1
        && pointer < LineList.Length
        && LineList[pointer].ItemNumber == ItemNumber
        && displaypointer > -1
        && displaypointer < DisplayList.Length
        && DisplayList[displaypointer].DisplayType == TDisplayLine
        && DisplayList[displaypointer].ItemNumber == ItemNumber
        ) {
        found = true;
        }

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Mirror Line");
            AddUndo("Delete," + AnsiString(DisplayItemNumber) + ",");
            if (deselectafteroperation) {
                DisplayList[displaypointer].selected = false;
                AddUndo("Select," + AnsiString(ItemNumber) + ",");
                }
            }
        int arrayentry = LineList.Length;
        LineList.Length++;
        LineList[arrayentry].ItemNumber = DisplayItemNumber;
        LineList[arrayentry].Colour = LineList[pointer].Colour;
        LineList[arrayentry].LineWidth = LineList[pointer].LineWidth;
        //mirror the start & ends
        LineList[arrayentry].StartPoint = MirrorTPoint(LineList[pointer].StartPoint,Centre,Axis);
        LineList[arrayentry].EndPoint = MirrorTPoint(LineList[pointer].EndPoint,Centre,Axis);
        //regenerate display points for line
        FillPointsLine(arrayentry,DisplayItemNumber);
        //create new display list entry
        arrayentry = DisplayList.Length;
        DisplayList.Length++;
        DisplayList[arrayentry].ItemNumber = DisplayItemNumber;
        DisplayList[arrayentry].DisplayType = TDisplayLine;
        DisplayList[arrayentry].selected = false;
        DisplayList[arrayentry].visible = true;
        DisplayItemNumber++;
        //update the boundary rectangle
        CreateXRefs();
        DisplayListAreaUpdate(DisplayList[arrayentry].ItemNumber);
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::MirrorCopyPolyLine(TPoint Centre, int ItemNumber, TMirrorAxis Axis)
{
    //Mirrors a Polyline
    CreateXRefs();
    bool found = false;
    int pointer = XRefs[ItemNumber].EntityXRef;
    int displaypointer = XRefs[ItemNumber].DisplayXRef;

    if ( XRefs[ItemNumber].DisplayType == TDisplayPolyLine
        && pointer > -1
        && pointer < PolyLineList.Length
        && PolyLineList[pointer].ItemNumber == ItemNumber
        && displaypointer > -1
        && displaypointer < DisplayList.Length
        && DisplayList[displaypointer].DisplayType == TDisplayPolyLine
        && DisplayList[displaypointer].ItemNumber == ItemNumber
        ) {
        found = true;
        }

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Mirror Polyline");
            AddUndo("Delete," + AnsiString(DisplayItemNumber) + ",");
            if (deselectafteroperation) {
                DisplayList[displaypointer].selected = false;
                AddUndo("Select," + AnsiString(ItemNumber) + ",");
                }
            }
        int arrayentry = PolyLineList.Length;
        PolyLineList.Length++;
        PolyLineList[arrayentry].ItemNumber = DisplayItemNumber;
        PolyLineList[arrayentry].PenColour = PolyLineList[pointer].PenColour;
        PolyLineList[arrayentry].BrushColour = PolyLineList[pointer].BrushColour;
        PolyLineList[arrayentry].LineWidth = PolyLineList[pointer].LineWidth;
        PolyLineList[arrayentry].closed = PolyLineList[pointer].closed;
        PolyLineList[arrayentry].filled = PolyLineList[pointer].filled;
        PolyLineList[arrayentry].Corners.Length = PolyLineList[pointer].Corners.Length;
        //mirror the corners
        for (int i = 0; i < PolyLineList[pointer].Corners.Length; i++) {
            PolyLineList[arrayentry].Corners[i] = MirrorTPoint(PolyLineList[pointer].Corners[i],Centre,Axis);
            }
        //regenerate display points for line
        FillPointsPolyLine(arrayentry,DisplayItemNumber);
        //create new display list entry
        arrayentry = DisplayList.Length;
        DisplayList.Length++;
        DisplayList[arrayentry].ItemNumber = DisplayItemNumber;
        DisplayList[arrayentry].DisplayType = TDisplayPolyLine;
        DisplayList[arrayentry].selected = false;
        DisplayList[arrayentry].visible = true;
        DisplayItemNumber++;
        //update the boundary rectangle
        CreateXRefs();
        DisplayListAreaUpdate(DisplayList[arrayentry].ItemNumber);
        }
}
//---------------------------------------------------------------------------

/*
void __fastcall TImageEditorForm::MirrorFloodFill(TPoint Centre, int ItemNumber, TMirrorAxis Axis)
{
    //Mirrors a flood fill
    CreateXRefs();
    bool found = false;
    int pointer = XRefs[ItemNumber].EntityXRef;
    int displaypointer = XRefs[ItemNumber].DisplayXRef;

    if ( XRefs[ItemNumber].DisplayType == TDisplayFloodFill
        && pointer > -1
        && pointer < FloodFillList.Length
        && FloodFillList[pointer].ItemNumber == ItemNumber
        && displaypointer > -1
        && displaypointer < DisplayList.Length
        && DisplayList[displaypointer].DisplayType == TDisplayFloodFill
        && DisplayList[displaypointer].ItemNumber == ItemNumber
        ) {
        found = true;
        }

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Mirror Flood Fill");
            AnsiString text;
            text = "FloodFill,ChangeContents," + AnsiString(ItemNumber) + ","
                                + AnsiString((int)(FloodFillList[pointer].Colour)) + ","
                                + AnsiString((int)(FloodFillList[pointer].FilledColour)) + ","
                                + AnsiString(FloodFillList[pointer].StartPoint.x) + ","
                                + AnsiString(FloodFillList[pointer].StartPoint.y) + ","
                                ;
            for (int j = 0; j < FloodFillList[pointer].Points.Length; j++) {
                text = text + AnsiString(FloodFillList[pointer].Points[j].x) + "," + AnsiString(FloodFillList[pointer].Points[j].y) + ",";
                }
            AddUndo(text);
            //AddUndo("Mirror," + AnsiString(ItemNumber) + "," + AnsiString(Centre.x) + "," + AnsiString(Centre.y) + "," + AnsiString((int)(Axis)) + ",");
            if (deselectafteroperation) {
                DisplayList[displaypointer].selected = false;
                AddUndo("Select," + AnsiString(ItemNumber) + ",");
                }
            }
        //Mirror the start point
        FloodFillList[pointer].StartPoint = MirrorTPoint(FloodFillList[pointer].StartPoint,Centre,Axis);
        //mirror the point array
        for (int i = 0; i < FloodFillList[pointer].Points.Length; i++) {
            FloodFillList[pointer].Points[i] = MirrorTPoint(FloodFillList[pointer].Points[i],Centre,Axis);
            }
        //update the boundary rectangle
        DisplayListAreaUpdate(ItemNumber);
        }
}
//---------------------------------------------------------------------------
*/

void __fastcall TImageEditorForm::MirrorCopyFloodFill(TPoint Centre, int ItemNumber, TMirrorAxis Axis)
{
    //Mirrors a flood fill
    CreateXRefs();
    bool found = false;
    int pointer = XRefs[ItemNumber].EntityXRef;
    int displaypointer = XRefs[ItemNumber].DisplayXRef;

    if ( XRefs[ItemNumber].DisplayType == TDisplayFloodFill
        && pointer > -1
        && pointer < FloodFillList.Length
        && FloodFillList[pointer].ItemNumber == ItemNumber
        && displaypointer > -1
        && displaypointer < DisplayList.Length
        && DisplayList[displaypointer].DisplayType == TDisplayFloodFill
        && DisplayList[displaypointer].ItemNumber == ItemNumber
        ) {
        found = true;
        }

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Mirror Flood Fill");
            AddUndo("Delete," + AnsiString(DisplayItemNumber) + ",");
            if (deselectafteroperation) {
                DisplayList[displaypointer].selected = false;
                AddUndo("Select," + AnsiString(ItemNumber) + ",");
                }
            }
        int arrayentry = FloodFillList.Length;
        FloodFillList.Length++;
        FloodFillList[arrayentry].ItemNumber = DisplayItemNumber;
        FloodFillList[arrayentry].Colour = FloodFillList[pointer].Colour;
        FloodFillList[arrayentry].FilledColour = FloodFillList[pointer].FilledColour;
        FloodFillList[arrayentry].StartPoint = MirrorTPoint(FloodFillList[pointer].StartPoint,Centre,Axis);
        //mirror the point array
        FloodFillList[arrayentry].Points.Length = FloodFillList[pointer].Points.Length;
        for (int i = 0; i < FloodFillList[pointer].Points.Length; i++) {
            FloodFillList[arrayentry].Points[i] = MirrorTPoint(FloodFillList[pointer].Points[i],Centre,Axis);
            }
        //create new display list entry
        arrayentry = DisplayList.Length;
        DisplayList.Length++;
        DisplayList[arrayentry].ItemNumber = DisplayItemNumber;
        DisplayList[arrayentry].DisplayType = TDisplayFloodFill;
        DisplayList[arrayentry].selected = false;
        DisplayList[arrayentry].visible = true;
        DisplayItemNumber++;
        //update the boundary rectangle
        CreateXRefs();
        DisplayListAreaUpdate(DisplayList[arrayentry].ItemNumber);
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::MirrorCopyRectangle(TPoint Centre, int ItemNumber, TMirrorAxis Axis)
{
    //Mirrors a Rectangle
    CreateXRefs();
    bool found = false;
    int pointer = XRefs[ItemNumber].EntityXRef;
    int displaypointer = XRefs[ItemNumber].DisplayXRef;

    if ( XRefs[ItemNumber].DisplayType == TDisplayRectangle
        && pointer > -1
        && pointer < RectangleList.Length
        && RectangleList[pointer].ItemNumber == ItemNumber
        && displaypointer > -1
        && displaypointer < DisplayList.Length
        && DisplayList[displaypointer].DisplayType == TDisplayRectangle
        && DisplayList[displaypointer].ItemNumber == ItemNumber
        ) {
        found = true;
        }

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Mirror Rectangle");
            AddUndo("Delete," + AnsiString(DisplayItemNumber) + ",");
            if (deselectafteroperation) {
                DisplayList[displaypointer].selected = false;
                AddUndo("Select," + AnsiString(ItemNumber) + ",");
                }
            }
        int arrayentry = RectangleList.Length;
        RectangleList.Length++;
        RectangleList[arrayentry].ItemNumber = DisplayItemNumber;
        RectangleList[arrayentry].PenColour = RectangleList[pointer].PenColour;
        RectangleList[arrayentry].BrushColour = RectangleList[pointer].BrushColour;
        RectangleList[arrayentry].LineWidth = RectangleList[pointer].LineWidth;
        //mirror the rectangle definition
        RectangleList[arrayentry].Area =  MirrorRectanglePoints(RectangleList[pointer].Area,Centre,Axis);
        RectangleList[arrayentry].Shape = RectangleList[pointer].Shape;
        RectangleList[arrayentry].Angle = RectangleList[pointer].Angle * -1;
        RectangleList[arrayentry].Filled = RectangleList[pointer].Filled;
        while (RectangleList[arrayentry].Angle < 0) {
            RectangleList[arrayentry].Angle += 3600;
            }
        //regenerate display points for Rectangle
        FillPointsRectangle(arrayentry,DisplayItemNumber);
        //create new display list entry
        arrayentry = DisplayList.Length;
        DisplayList.Length++;
        DisplayList[arrayentry].ItemNumber = DisplayItemNumber;
        DisplayList[arrayentry].DisplayType = TDisplayRectangle;
        DisplayList[arrayentry].selected = false;
        DisplayList[arrayentry].visible = true;
        DisplayItemNumber++;
        //update the boundary rectangle
        CreateXRefs();
        DisplayListAreaUpdate(DisplayList[arrayentry].ItemNumber);
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::MirrorCopyCircle(TPoint Centre, int ItemNumber, TMirrorAxis Axis)
{
    //Mirrors a Circle
    CreateXRefs();
    bool found = false;
    int pointer = XRefs[ItemNumber].EntityXRef;
    int displaypointer = XRefs[ItemNumber].DisplayXRef;

    if ( XRefs[ItemNumber].DisplayType == TDisplayCircle
        && pointer > -1
        && pointer < CircleList.Length
        && CircleList[pointer].ItemNumber == ItemNumber
        && displaypointer > -1
        && displaypointer < DisplayList.Length
        && DisplayList[displaypointer].DisplayType == TDisplayCircle
        && DisplayList[displaypointer].ItemNumber == ItemNumber
        ) {
        found = true;
        }

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Mirror Ellipse/Circle");
            AddUndo("Delete," + AnsiString(DisplayItemNumber) + ",");
            if (deselectafteroperation) {
                DisplayList[displaypointer].selected = false;
                AddUndo("Select," + AnsiString(ItemNumber) + ",");
                }
            }
        int arrayentry = CircleList.Length;
        CircleList.Length++;
        CircleList[arrayentry].ItemNumber = DisplayItemNumber;
        CircleList[arrayentry].PenColour = CircleList[pointer].PenColour;
        CircleList[arrayentry].BrushColour = CircleList[pointer].BrushColour;
        CircleList[arrayentry].LineWidth = CircleList[pointer].LineWidth;
        //mirror the Circle definition
        CircleList[arrayentry].Area =  MirrorRectanglePoints(CircleList[pointer].Area,Centre,Axis);
        CircleList[arrayentry].Shape = CircleList[pointer].Shape;
        CircleList[arrayentry].Angle = CircleList[pointer].Angle * -1;
        CircleList[arrayentry].Filled = CircleList[pointer].Filled;
        while (CircleList[arrayentry].Angle < 0) {
            CircleList[arrayentry].Angle += 3600;
            }
        //regenerate display points for Circle
        FillPointsCircle(arrayentry,DisplayItemNumber);
        //create new display list entry
        arrayentry = DisplayList.Length;
        DisplayList.Length++;
        DisplayList[arrayentry].ItemNumber = DisplayItemNumber;
        DisplayList[arrayentry].DisplayType = TDisplayCircle;
        DisplayList[arrayentry].selected = false;
        DisplayList[arrayentry].visible = true;
        DisplayItemNumber++;
        //update the boundary rectangle
        CreateXRefs();
        DisplayListAreaUpdate(DisplayList[arrayentry].ItemNumber);
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::MirrorCopyFreeForm(TPoint Centre, int ItemNumber, TMirrorAxis Axis)
{
    //Mirrors a FreeForm
    CreateXRefs();
    bool found = false;
    int pointer = XRefs[ItemNumber].EntityXRef;
    int displaypointer = XRefs[ItemNumber].DisplayXRef;

    if ( XRefs[ItemNumber].DisplayType == TDisplayFreeForm
        && pointer > -1
        && pointer < FreeFormList.Length
        && FreeFormList[pointer].ItemNumber == ItemNumber
        && displaypointer > -1
        && displaypointer < DisplayList.Length
        && DisplayList[displaypointer].DisplayType == TDisplayFreeForm
        && DisplayList[displaypointer].ItemNumber == ItemNumber
        ) {
        found = true;
        }

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Mirror Free-Form Shape");
            AddUndo("Delete," + AnsiString(DisplayItemNumber) + ",");
            if (deselectafteroperation) {
                DisplayList[displaypointer].selected = false;
                AddUndo("Select," + AnsiString(ItemNumber) + ",");
                }
            }
        int arrayentry = FreeFormList.Length;
        FreeFormList.Length++;
        FreeFormList[arrayentry].ItemNumber = DisplayItemNumber;
        FreeFormList[arrayentry].PenColour = FreeFormList[pointer].PenColour;
        FreeFormList[arrayentry].BrushColour = FreeFormList[pointer].BrushColour;
        FreeFormList[arrayentry].LineWidth = FreeFormList[pointer].LineWidth;
        FreeFormList[arrayentry].closed = FreeFormList[pointer].closed;
        FreeFormList[arrayentry].filled = FreeFormList[pointer].filled;
        FreeFormList[arrayentry].Corners.Length = FreeFormList[pointer].Corners.Length;
        //mirror the corners
        for (int i = 0; i < FreeFormList[pointer].Corners.Length; i++) {
            FreeFormList[arrayentry].Corners[i] = MirrorTPoint(FreeFormList[pointer].Corners[i],Centre,Axis);
            }
        //regenerate display points for line
        FillPointsFreeForm(arrayentry,DisplayItemNumber);
        //create new display list entry
        arrayentry = DisplayList.Length;
        DisplayList.Length++;
        DisplayList[arrayentry].ItemNumber = DisplayItemNumber;
        DisplayList[arrayentry].DisplayType = TDisplayFreeForm;
        DisplayList[arrayentry].selected = false;
        DisplayList[arrayentry].visible = true;
        DisplayItemNumber++;
        //update the boundary rectangle
        CreateXRefs();
        DisplayListAreaUpdate(DisplayList[arrayentry].ItemNumber);
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::MirrorCopyErase(TPoint Centre, int ItemNumber, TMirrorAxis Axis)
{
    //Mirrors all the points in an erase item
    CreateXRefs();
    bool found = false;
    int pointer = XRefs[ItemNumber].EntityXRef;
    int displaypointer = XRefs[ItemNumber].DisplayXRef;

    if ( XRefs[ItemNumber].DisplayType == TDisplayEraseItem
        && pointer > -1
        && pointer < EraseList.Length
        && EraseList[pointer].ItemNumber == ItemNumber
        && displaypointer > -1
        && displaypointer < DisplayList.Length
        && DisplayList[displaypointer].DisplayType == TDisplayEraseItem
        && DisplayList[displaypointer].ItemNumber == ItemNumber
        ) {
        found = true;
        }

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Mirror Erase Object");
            AddUndo("Delete," + AnsiString(DisplayItemNumber) + ",");
            if (deselectafteroperation) {
                DisplayList[displaypointer].selected = false;
                AddUndo("Select," + AnsiString(ItemNumber) + ",");
                }
            }
        //create new erase item in erase list
        int arrayentry = EraseList.Length;
        EraseList.Length++;
        EraseList[arrayentry].ItemNumber = DisplayItemNumber;
        EraseList[arrayentry].Points.Length = EraseList[pointer].Points.Length;
        //mirror the point array
        TPoint temp;
        for (int i = 0; i < EraseList[pointer].Points.Length; i++) {
            temp.x = EraseList[pointer].Points[i].x;
            temp.y = EraseList[pointer].Points[i].y;
            temp = MirrorTPoint(temp,Centre,Axis);
            EraseList[arrayentry].Points[i].x = temp.x;
            EraseList[arrayentry].Points[i].y = temp.y;
            EraseList[arrayentry].Points[i].Colour = Picture->Canvas->Pixels[temp.x][temp.y];
            }
        //create new display list entry
        arrayentry = DisplayList.Length;
        DisplayList.Length++;
        DisplayList[arrayentry].ItemNumber = DisplayItemNumber;
        DisplayList[arrayentry].DisplayType = TDisplayEraseItem;
        DisplayList[arrayentry].selected = false;
        DisplayList[arrayentry].visible = true;
        DisplayItemNumber++;
        //update the boundary rectangle
        CreateXRefs();
        DisplayListAreaUpdate(DisplayList[arrayentry].ItemNumber);
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::MirrorCopyBlock(TPoint Centre, int ItemNumber, TMirrorAxis Axis)
{
    //Mirrors a block
    CreateXRefs();
    bool found = false;
    int pointer = XRefs[ItemNumber].EntityXRef;
    int displaypointer = XRefs[ItemNumber].DisplayXRef;

    if ( XRefs[ItemNumber].DisplayType == TDisplayBlock
        && pointer > -1
        && pointer < BlockList.Length
        && BlockList[pointer].ItemNumber == ItemNumber
        && displaypointer > -1
        && displaypointer < DisplayList.Length
        && DisplayList[displaypointer].DisplayType == TDisplayBlock
        && DisplayList[displaypointer].ItemNumber == ItemNumber
        ) {
        found = true;
        }

    if (found) {
        if (!Undoing) {
            if (SingleUndo) AddUndoTitle("Mirror Block");
            AddUndo("Delete," + AnsiString(DisplayItemNumber) + ",");
            if (deselectafteroperation) {
                DisplayList[displaypointer].selected = false;
                AddUndo("Select," + AnsiString(ItemNumber) + ",");
                }
            }
        //create new block in block list
        int arrayentry = BlockList.Length;
        BlockList.Length++;
        BlockList[arrayentry].ItemNumber = DisplayItemNumber;
        //Move the block to the mirrored top left point
        bool needtorotate = false;
        if ((BlockList[pointer].Axis == TMAHorizontal && Axis == TMAVertical) || (BlockList[pointer].Axis == TMAVertical && Axis == TMAHorizontal)) needtorotate = true;
        TPoint delta;
        delta.x = BlockList[pointer].Area.Left;
        delta.y = BlockList[pointer].Area.Top;
        delta = MirrorTPoint(delta,Centre,Axis);
        delta.x = delta.x - BlockList[pointer].Area.Left;
        delta.y = delta.y - BlockList[pointer].Area.Top;
        BlockList[arrayentry].Area.Left = BlockList[pointer].Area.Left + delta.x;
        BlockList[arrayentry].Area.Top = BlockList[pointer].Area.Top + delta.y;
        BlockList[arrayentry].Area.Right = BlockList[pointer].Area.Right + delta.x;
        BlockList[arrayentry].Area.Bottom = BlockList[pointer].Area.Bottom + delta.y;
        BlockList[arrayentry].Linked = true;
        if (BlockList[pointer].Linked) {
            BlockList[arrayentry].LinkedBlock = BlockList[pointer].LinkedBlock;
            } else {
            BlockList[arrayentry].LinkedBlock = BlockList[pointer].ItemNumber;
            }
        BlockList[arrayentry].RotationCentre.x = BlockList[pointer].RotationCentre.x + delta.x;
        BlockList[arrayentry].RotationCentre.y = BlockList[pointer].RotationCentre.y + delta.y;
        BlockList[arrayentry].Angle = BlockList[pointer].Angle;
        if (needtorotate) BlockList[arrayentry].Angle += 1800;
        BlockList[arrayentry].MirrorCentre.x = BlockList[pointer].MirrorCentre.x + delta.x;
        BlockList[arrayentry].MirrorCentre.y = BlockList[pointer].MirrorCentre.y + delta.y;
        if (needtorotate) {
            BlockList[arrayentry].Axis = TMANone;
            } else {
            if (BlockList[pointer].Axis == Axis) {
                BlockList[arrayentry].Axis = TMANone;
                } else {
                BlockList[arrayentry].Axis = Axis;
                }
            }
        BlockList[arrayentry].delta = BlockList[pointer].delta;
        //now to copy the point array
        BlockList[arrayentry].Points.Length = BlockList[pointer].Points.Length;
        for (int i = 0; i < BlockList[pointer].Points.Length; i++) {
            BlockList[arrayentry].Points[i].originalx = BlockList[pointer].Points[i].originalx + delta.x;
            BlockList[arrayentry].Points[i].originaly = BlockList[pointer].Points[i].originaly + delta.y;
            BlockList[arrayentry].Points[i].Colour = BlockList[pointer].Points[i].Colour;
            BlockList[arrayentry].Points[i].transparent = BlockList[pointer].Points[i].transparent;
            }
        FillPointsBlock(arrayentry,BlockList[arrayentry].ItemNumber);
        //create new display list entry
        arrayentry = DisplayList.Length;
        DisplayList.Length++;
        DisplayList[arrayentry].ItemNumber = DisplayItemNumber;
        DisplayList[arrayentry].DisplayType = TDisplayBlock;
        DisplayList[arrayentry].selected = false;
        DisplayList[arrayentry].visible = true;
        DisplayItemNumber++;
        //update the boundary rectangle
        //CreateXRefs();
        DisplayListAreaUpdate(DisplayList[arrayentry].ItemNumber);
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::ChangeLineLineWidth(TObject *Sender)
{
    //changes the width of a line
    CreateXRefs();
    if (dynamic_cast < TComponent *>(Sender) ) {
        int LineWidth = (TDisplayType) (dynamic_cast < TComponent *>(Sender)->Tag);
        TerminateCurrentAction();
        AddUndoTitle("Change Line Widths of Selected Line(s)");
        SingleUndo = false;
        for (int i = 0; i < DisplayList.Length; i++) {
            if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayLine && XRefs[DisplayList[i].ItemNumber].DisplayType == TDisplayLine) {
                int pointer = XRefs[DisplayList[i].ItemNumber].EntityXRef;
                AnsiString text;
                text = "Line,ChangeContents," + AnsiString(LineList[pointer].ItemNumber) + ","
                                + AnsiString((int)(LineList[pointer].Colour)) + ","
                                + AnsiString(LineList[pointer].LineWidth) + ","
                                + AnsiString(LineList[pointer].StartPoint.x) + ","
                                + AnsiString(LineList[pointer].StartPoint.y) + ","
                                + AnsiString(LineList[pointer].EndPoint.x) + ","
                                + AnsiString(LineList[pointer].EndPoint.y) + ","
                                ;
                for (int j = 0; j < LineList[pointer].Points.Length; j++) {
                    text = text + AnsiString(LineList[pointer].Points[j].x) + "," + AnsiString(LineList[pointer].Points[j].y) + "," + AnsiString((int)(LineList[pointer].Points[j].Colour)) + ",";
                    }
                AddUndo(text);
                LineList[pointer].LineWidth = LineWidth;
                FillPointsLine(XRefs[DisplayList[i].ItemNumber].EntityXRef,DisplayList[i].ItemNumber);
                DisplayListAreaUpdate(DisplayList[i].ItemNumber);
                if (deselectafteroperation) {
                    AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                    DisplayList[i].selected = false;
                    }
                }
            }
        SingleUndo = true;

        Image1->Cursor = crTargetCursor;
        preparetosaveundo = false;
        ResetActionButtons();
        DrawPicture();
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::ChangePolyLineLineWidth(TObject *Sender)
{
    //changes the width of a line
    CreateXRefs();
    if (dynamic_cast < TComponent *>(Sender) ) {
        int LineWidth = (TDisplayType) (dynamic_cast < TComponent *>(Sender)->Tag);
        TerminateCurrentAction();
        AddUndoTitle("Change Line Widths of Selected Polyline(s)");
        SingleUndo = false;
        for (int i = 0; i < DisplayList.Length; i++) {
            if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayPolyLine && XRefs[DisplayList[i].ItemNumber].DisplayType == TDisplayPolyLine) {
                int pointer = XRefs[DisplayList[i].ItemNumber].EntityXRef;
                AnsiString text;
                AddUndoChangePolyLine(DisplayList[i].ItemNumber);
                PolyLineList[pointer].LineWidth = LineWidth;
                FillPointsPolyLine(pointer,DisplayList[i].ItemNumber);
                DisplayListAreaUpdate(DisplayList[i].ItemNumber);
                if (deselectafteroperation) {
                    AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                    DisplayList[i].selected = false;
                    }
                }
            }
        SingleUndo = true;

        Image1->Cursor = crTargetCursor;
        preparetosaveundo = false;
        ResetActionButtons();
        DrawPicture();
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::ChangeRectangleLineWidth(TObject *Sender)
{
    //changes the line width of a rectangle
    CreateXRefs();
    if (dynamic_cast < TComponent *>(Sender) ) {
        int LineWidth = (TDisplayType) (dynamic_cast < TComponent *>(Sender)->Tag);
        TerminateCurrentAction();
        AddUndoTitle("Change Line Widths of Selected Rectangle(s)");
        SingleUndo = false;
        for (int i = 0; i < DisplayList.Length; i++) {
            if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayRectangle && XRefs[DisplayList[i].ItemNumber].DisplayType == TDisplayRectangle) {
                int pointer = XRefs[DisplayList[i].ItemNumber].EntityXRef;
                /*
                AnsiString text;
                text = "Rectangle,ChangeContents," + AnsiString(RectangleList[pointer].ItemNumber) + ","
                                + AnsiString((int)(RectangleList[pointer].PenColour)) + ","
                                + AnsiString((int)(RectangleList[pointer].BrushColour)) + ","
                                + AnsiString(RectangleList[pointer].LineWidth) + ","
                                + AnsiString(RectangleList[pointer].Area.Left) + ","
                                + AnsiString(RectangleList[pointer].Area.Top) + ","
                                + AnsiString(RectangleList[pointer].Area.Right) + ","
                                + AnsiString(RectangleList[pointer].Area.Bottom) + ","
                                + AnsiString((int)(RectangleList[pointer].Shape)) + ","
                                + AnsiString(RectangleList[pointer].Angle) + ","
                                + AnsiString((int)(RectangleList[pointer].Filled)) + ","
                                ;
                for (int j = 0; j < RectangleList[pointer].Points.Length; j++) {
                    text = text + AnsiString(RectangleList[pointer].Points[j].x) + "," + AnsiString(RectangleList[pointer].Points[j].y) + ","+ AnsiString((int)(RectangleList[pointer].Points[j].Colour)) + ",";
                    }
                AddUndo(text);
                */
                AddUndoChangeRectangle(RectangleList[pointer].ItemNumber);
                RectangleList[pointer].LineWidth = LineWidth;
                FillPointsRectangle(XRefs[DisplayList[i].ItemNumber].EntityXRef,DisplayList[i].ItemNumber);
                DisplayListAreaUpdate(DisplayList[i].ItemNumber);
                if (deselectafteroperation) {
                    AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                    DisplayList[i].selected = false;
                    }
                }
            }
        SingleUndo = true;

        Image1->Cursor = crTargetCursor;
        preparetosaveundo = false;
        ResetActionButtons();
        DrawPicture();
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::ChangeCircleLineWidth(TObject *Sender)
{
    //changes the line width of a Circle
    CreateXRefs();
    if (dynamic_cast < TComponent *>(Sender) ) {
        int LineWidth = (TDisplayType) (dynamic_cast < TComponent *>(Sender)->Tag);
        TerminateCurrentAction();
        AddUndoTitle("Change Line Widths of Selected Circle(s)");
        SingleUndo = false;
        for (int i = 0; i < DisplayList.Length; i++) {
            if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayCircle && XRefs[DisplayList[i].ItemNumber].DisplayType == TDisplayCircle) {
                int pointer = XRefs[DisplayList[i].ItemNumber].EntityXRef;
                /*
                AnsiString text;
                text = "Circle,ChangeContents," + AnsiString(CircleList[pointer].ItemNumber) + ","
                                + AnsiString((int)(CircleList[pointer].PenColour)) + ","
                                + AnsiString((int)(CircleList[pointer].BrushColour)) + ","
                                + AnsiString(CircleList[pointer].LineWidth) + ","
                                + AnsiString(CircleList[pointer].Area.Left) + ","
                                + AnsiString(CircleList[pointer].Area.Top) + ","
                                + AnsiString(CircleList[pointer].Area.Right) + ","
                                + AnsiString(CircleList[pointer].Area.Bottom) + ","
                                + AnsiString((int)(CircleList[pointer].Shape)) + ","
                                + AnsiString(CircleList[pointer].Angle) + ","
                                + AnsiString((int)(CircleList[pointer].Filled)) + ","
                                ;
                for (int j = 0; j < CircleList[pointer].Points.Length; j++) {
                    text = text + AnsiString(CircleList[pointer].Points[j].x) + "," + AnsiString(CircleList[pointer].Points[j].y) + ","+ AnsiString((int)(CircleList[pointer].Points[j].Colour)) + ",";
                    }
                AddUndo(text);
                */
                AddUndoChangeCircle(CircleList[pointer].ItemNumber);
                CircleList[pointer].LineWidth = LineWidth;
                FillPointsCircle(XRefs[DisplayList[i].ItemNumber].EntityXRef,DisplayList[i].ItemNumber);
                DisplayListAreaUpdate(DisplayList[i].ItemNumber);
                if (deselectafteroperation) {
                    AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                    DisplayList[i].selected = false;
                    }
                }
            }
        SingleUndo = true;

        Image1->Cursor = crTargetCursor;
        preparetosaveundo = false;
        ResetActionButtons();
        DrawPicture();
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::ChangeFreeFormLineWidthClick(TObject *Sender)
{
   //changes the width of a line
    CreateXRefs();
    if (dynamic_cast < TComponent *>(Sender) ) {
        int LineWidth = (TDisplayType) (dynamic_cast < TComponent *>(Sender)->Tag);
        TerminateCurrentAction();
        AddUndoTitle("Change Line Widths of Selected Free-Form Shape(s)");
        SingleUndo = false;
        for (int i = 0; i < DisplayList.Length; i++) {
            if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayFreeForm && XRefs[DisplayList[i].ItemNumber].DisplayType == TDisplayFreeForm) {
                int pointer = XRefs[DisplayList[i].ItemNumber].EntityXRef;
                AnsiString text;
                AddUndoChangeFreeForm(DisplayList[i].ItemNumber);
                FreeFormList[pointer].LineWidth = LineWidth;
                FillPointsFreeForm(pointer,DisplayList[i].ItemNumber);
                DisplayListAreaUpdate(DisplayList[i].ItemNumber);
                if (deselectafteroperation) {
                    AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                    DisplayList[i].selected = false;
                    }
                }
            }
        SingleUndo = true;

        Image1->Cursor = crTargetCursor;
        preparetosaveundo = false;
        ResetActionButtons();
        DrawPicture();
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::ForegroundMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if (dynamic_cast <TShape *>(Sender)) {
        TEnterColourForm *EnterColourForm = new TEnterColourForm(this);
        rgb Colour = ExtractRGB(dynamic_cast <TShape *>(Sender)->Brush->Color);
        EnterColourForm->Red->Text = AnsiString(Colour.R);
        EnterColourForm->Green->Text = AnsiString(Colour.G);
        EnterColourForm->Blue->Text = AnsiString(Colour.B);
        EnterColourForm->RedChange(this);

        EnterColourForm->ShowModal();

        if (EnterColourForm->ModalResult == mrOk) {
            //AnsiString Name = dynamic_cast <TShape *>(Sender)->Name;
            if (dynamic_cast <TShape *>(Sender)->Name == "Foreground") {
                if (!EnterColourForm->UseBlend) {
                    Foreground->Brush->Color = EnterColourForm->Shape2->Brush->Color;
                    } else {
                    Foreground->Brush->Color = EnterColourForm->Shape3->Brush->Color;
                    preparetoblendforeground = true;
                    }
                ForegroundColour = Foreground->Brush->Color;
                DisplayCurrentColours();
                } else {
                if (!EnterColourForm->UseBlend) {
                    Background->Brush->Color = EnterColourForm->Shape2->Brush->Color;
                    } else {
                    Background->Brush->Color = EnterColourForm->Shape3->Brush->Color;
                    preparetoblendbackground = true;
                    }
                BackgroundColour = Background->Brush->Color;
                DisplayCurrentColours();
                }
            }
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::EditRectangle1Click(TObject *Sender)
{
    ChangeSize1->Enabled = (bool)(NumberRectanglesSelected == 1);
    PickColour1->Enabled = ChangeSize1->Enabled;
    RegenerateSelectedRectangles1->Enabled = ChangeSize1->Enabled;
    LineWidth12->Enabled = ChangeSize1->Enabled;
    LineWidth22->Enabled = ChangeSize1->Enabled;
    LineWidth42->Enabled = ChangeSize1->Enabled;
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::EditEllipseCircle1Click(TObject *Sender)
{
    ChangeSize2->Enabled = (bool)(NumberCirclesSelected == 1);
    PickCircleColour1->Enabled = ChangeSize2->Enabled;
    RegenerateSelectedEllipsesCircles1->Enabled = ChangeSize2->Enabled;
    LineWidth13->Enabled = ChangeSize2->Enabled;
    LineWidth23->Enabled = ChangeSize2->Enabled;
    LineWidth43->Enabled = ChangeSize2->Enabled;

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::DebugBlock(int arrayentry)
{
    Memo1->Lines->Add("BlockList[" + AnsiString(arrayentry) + "]");
    Memo1->Lines->Add("   ItemNumber=" + AnsiString(BlockList[arrayentry].ItemNumber));
    Memo1->Lines->Add("   Area=" + AnsiString(BlockList[arrayentry].Area.Left) + ","  + AnsiString(BlockList[arrayentry].Area.Top) + "," + AnsiString(BlockList[arrayentry].Area.Right) + "," + AnsiString(BlockList[arrayentry].Area.Bottom));
    Memo1->Lines->Add("   Linked=" + AnsiString((int)(BlockList[arrayentry].Linked)));
    Memo1->Lines->Add("   LinkedBlock=" + AnsiString(BlockList[arrayentry].LinkedBlock));
    Memo1->Lines->Add("   RotationCentre=" + AnsiString(BlockList[arrayentry].RotationCentre.x) + "," + AnsiString(BlockList[arrayentry].RotationCentre.y));
    Memo1->Lines->Add("   Angle=" + AnsiString(BlockList[arrayentry].Angle));
    Memo1->Lines->Add("   MirrorCentre=" + AnsiString(BlockList[arrayentry].MirrorCentre.x) + "," + AnsiString(BlockList[arrayentry].MirrorCentre.y));
    Memo1->Lines->Add("   Axis=" + AnsiString((int)(BlockList[arrayentry].Axis)));
    Memo1->Lines->Add("   delta=" + AnsiString(BlockList[arrayentry].delta.x) + "," + AnsiString(BlockList[arrayentry].delta.y));
    for (int i = 0; i < BlockList[arrayentry].Points.Length; i++) {
        Memo1->Lines->Add("   Points[" + AnsiString(i) + "]=" + AnsiString(BlockList[arrayentry].Points[i].x) + "," + AnsiString(BlockList[arrayentry].Points[i].y) + "," + AnsiString(BlockList[arrayentry].Points[i].originalx) + "," + AnsiString(BlockList[arrayentry].Points[i].originaly) + "," + AnsiString((int)(BlockList[arrayentry].Points[i].Colour)) + "," + AnsiString((int)(BlockList[arrayentry].Points[i].transparent)));
        }
    Memo1->Lines->Add("   ");
    Memo1->Lines->Add("Undo List");
    for (int i = 0; i < UndoTitleList->Count; i++) {
        Memo1->Lines->Add(UndoTitleList->Strings[i]);
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::RotateBlock90Click(TObject *Sender)
{
    if (dynamic_cast <TComponent *>(Sender)) {
        int Angle = dynamic_cast <TComponent *>(Sender)->Tag;

        bool found = false;
        int pointer = 0;
        while (!found && pointer < DisplayList.Length) {
            if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayBlock) {
                found = true;
                pointer--;
                }
            pointer++;
            }
        if (found) {
            found = false;
            if (DisplayList[pointer].ItemNumber < XRefs.Length
                && XRefs[DisplayList[pointer].ItemNumber].DisplayType == TDisplayBlock
                && XRefs[DisplayList[pointer].ItemNumber].EntityXRef > -1
                && XRefs[DisplayList[pointer].ItemNumber].EntityXRef < BlockList.Length
                && BlockList[XRefs[DisplayList[pointer].ItemNumber].EntityXRef].ItemNumber == DisplayList[pointer].ItemNumber
                ) found = true;
            }
        if (found) {
            TPoint DisplayCentre;
            DisplayCentre.x = (DisplayList[pointer].Area.Left + DisplayList[pointer].Area.Right)/2;
            DisplayCentre.y = (DisplayList[pointer].Area.Top + DisplayList[pointer].Area.Bottom)/2;
            SingleUndo = false;
            AddUndoTitle("Rotate Block " + AnsiString(DisplayList[pointer].ItemNumber) + ", " + AnsiString(Angle/10) + " Degrees Anticlockwise");
            if (BlockList[XRefs[DisplayList[pointer].ItemNumber].EntityXRef].Axis != TMANone && Angle != 1800) Angle += 1800;
            RotateBlock(DisplayCentre,DisplayList[pointer].ItemNumber,Angle);
            SingleUndo = true;
            DrawPicture();
            }
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::MirrorVerticalClick(TObject *Sender)
{
        bool found = false;
        int pointer = 0;
        while (!found && pointer < DisplayList.Length) {
            if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayBlock) {
                found = true;
                pointer--;
                }
            pointer++;
            }
        if (found) {
            TPoint DisplayCentre;
            DisplayCentre.x = DisplayList[pointer].Area.Right;
            DisplayCentre.y = DisplayList[pointer].Area.Top;
            SingleUndo = false;
            AddUndoTitle("Copy Mirror Block " + AnsiString(DisplayList[pointer].ItemNumber) + ", About Right Edge");
            MirrorCopyBlock(DisplayCentre,DisplayList[pointer].ItemNumber,TMAVertical);
            //now do a check to see if the display boxes touch
            if (DisplayList[pointer].Area.Right != DisplayList[DisplayList.Length - 1].Area.Left) {
                //don't need this move to be recorded in the undo list
                Undoing = true;
                TPoint delta;
                delta.x = DisplayList[pointer].Area.Right - DisplayList[DisplayList.Length-1].Area.Left;
                delta.y = 0;
                MoveBlock(delta,DisplayList[DisplayList.Length-1].ItemNumber);
                Undoing = false;
                }
            SingleUndo = true;
            DrawPicture();
            //debug
            Memo1->Lines->Add("Mirrored Block");
            for (int i = 0; i < BlockList.Length; i++) {
                DebugBlock(i);
                }
            }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::MirrorHorizontalClick(TObject *Sender)
{
        bool found = false;
        int pointer = 0;
        while (!found && pointer < DisplayList.Length) {
            if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayBlock) {
                found = true;
                pointer--;
                }
            pointer++;
            }
        if (found) {
            TPoint DisplayCentre;
            DisplayCentre.x = DisplayList[pointer].Area.Left;
            DisplayCentre.y = DisplayList[pointer].Area.Bottom;
            SingleUndo = false;
            AddUndoTitle("Copy Mirror Block " + AnsiString(DisplayList[pointer].ItemNumber) + ", About Bottom Edge");
            MirrorCopyBlock(DisplayCentre,DisplayList[pointer].ItemNumber,TMAHorizontal);
            //now do a check to see if the display boxes touch
            if (DisplayList[pointer].Area.Bottom != DisplayList[DisplayList.Length - 1].Area.Top) {
                //don't need this move to be recorded in the undo list
                Undoing = true;
                TPoint delta;
                delta.x = 0;
                delta.y = DisplayList[pointer].Area.Bottom - DisplayList[DisplayList.Length-1].Area.Top;
                MoveBlock(delta,DisplayList[DisplayList.Length-1].ItemNumber);
                Undoing = false;
                }
            SingleUndo = true;
            DrawPicture();
            }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::MirrorVertical2Click(TObject *Sender)
{
        bool found = false;
        int pointer = 0;
        while (!found && pointer < DisplayList.Length) {
            if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayBlock) {
                found = true;
                pointer--;
                }
            pointer++;
            }
        if (found) {
            TPoint DisplayCentre;
            DisplayCentre.x = DisplayList[pointer].Area.Left;
            DisplayCentre.y = DisplayList[pointer].Area.Top;
            SingleUndo = false;
            AddUndoTitle("Copy Mirror Block " + AnsiString(DisplayList[pointer].ItemNumber) + ", About Left Edge");
            MirrorCopyBlock(DisplayCentre,DisplayList[pointer].ItemNumber,TMAVertical);
            //now do a check to see if the display boxes touch
            if (DisplayList[pointer].Area.Left != DisplayList[DisplayList.Length - 1].Area.Right) {
                //don't need this move to be recorded in the undo list
                Undoing = true;
                TPoint delta;
                delta.x = DisplayList[pointer].Area.Left - DisplayList[DisplayList.Length-1].Area.Right;
                delta.y = 0;
                MoveBlock(delta,DisplayList[DisplayList.Length-1].ItemNumber);
                Undoing = false;
                }
            SingleUndo = true;
            DrawPicture();
            }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::MirrorHorizontal2Click(TObject *Sender)
{
        bool found = false;
        int pointer = 0;
        while (!found && pointer < DisplayList.Length) {
            if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayBlock) {
                found = true;
                pointer--;
                }
            pointer++;
            }
        if (found) {
            TPoint DisplayCentre;
            DisplayCentre.x = DisplayList[pointer].Area.Left;
            DisplayCentre.y = DisplayList[pointer].Area.Bottom;
            SingleUndo = false;
            AddUndoTitle("Copy Mirror Block " + AnsiString(DisplayList[pointer].ItemNumber) + ", About Top Edge");
            MirrorCopyBlock(DisplayCentre,DisplayList[pointer].ItemNumber,TMAHorizontal);
            //now do a check to see if the display boxes touch
            if (DisplayList[pointer].Area.Top != DisplayList[DisplayList.Length - 1].Area.Bottom) {
                //don't need this move to be recorded in the undo list
                Undoing = true;
                TPoint delta;
                delta.x = 0;
                delta.y = DisplayList[pointer].Area.Top - DisplayList[DisplayList.Length-1].Area.Bottom;
                MoveBlock(delta,DisplayList[DisplayList.Length-1].ItemNumber);
                Undoing = false;
                }
            SingleUndo = true;
            DrawPicture();
            }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::SetFillShapes(bool bvalue)
{
    if (!Undoing) {
        AddUndoTitle("Set Shape Fill");
        AddUndo("FillShapes," + AnsiString((int)(fFillShapes)) + ",");
        }
    fFillShapes = bvalue;
    FillShapeButton->Down = fFillShapes;
    Graphics::TBitmap *Bitmap = new Graphics::TBitmap();

    if (fFillShapes) {
        ImageList1->GetBitmap(41,Bitmap);
        Rectangle1->ImageIndex = 41;
        } else {
        ImageList1->GetBitmap(15,Bitmap);
        Rectangle1->ImageIndex = 15;
        }
    RectangleButton->Glyph->Assign(Bitmap);

    //to stop bleedthrough from one pic to the next due to auto transparency
    Bitmap->Width = 0;
    Bitmap->Height = 0;

    if (fFillShapes) {
        ImageList1->GetBitmap(42,Bitmap);
        Ellipse1->ImageIndex = 42;
        } else {
        ImageList1->GetBitmap(16,Bitmap);
        Ellipse1->ImageIndex = 16;
        }
    CircleButton->Glyph->Assign(Bitmap);

    //to stop bleedthrough from one pic to the next due to auto transparency
    Bitmap->Width = 0;
    Bitmap->Height = 0;

    if (fFillShapes) {
        ImageList1->GetBitmap(46,Bitmap);
        FreeForm1->ImageIndex = 46;
        } else {
        ImageList1->GetBitmap(47,Bitmap);
        FreeForm1->ImageIndex = 47;
        }
    FreeFormButton->Glyph->Assign(Bitmap);

    delete Bitmap;

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::FillShapeButtonClick(TObject *Sender)
{
    FillShapes = !FillShapes;
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Filled1Click(TObject *Sender)
{
    //fill the selected rectangles
    if (dynamic_cast <TComponent *>(Sender)) {
        bool Fill = (bool)(dynamic_cast <TComponent *>(Sender)->Tag);
        CreateXRefs();
        if (Fill) {
            AddUndoTitle("Solid Fill in Selected Rectangles");
            } else {
            AddUndoTitle("Clear Fill in Selected Rectangles");
            }
        for (int i = 0; i < DisplayList.Length; i++) {
            if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayRectangle) {
                bool found = false;
                int pointer = XRefs[DisplayList[i].ItemNumber].EntityXRef;
                if (pointer > -1
                    && pointer < RectangleList.Length
                    && RectangleList[pointer].ItemNumber == DisplayList[i].ItemNumber
                    ) found = true;
                if (found) {
                    if (RectangleList[pointer].Filled != Fill) {
                        AddUndoChangeRectangle(RectangleList[pointer].ItemNumber);
                        RectangleList[pointer].Filled = Fill;
                        FillPointsRectangle(pointer,RectangleList[pointer].ItemNumber);
                        DisplayListAreaUpdate(RectangleList[pointer].ItemNumber);
                        if (deselectafteroperation) {
                            AddUndo("Select," + AnsiString(RectangleList[pointer].ItemNumber) + ",");
                            DisplayList[i].selected = false;
                            }
                        }
                    }
                }
            }
        DrawPicture();
        }
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Filled2Click(TObject *Sender)
{
    //fill the selected circles
    if (dynamic_cast <TComponent *>(Sender)) {
        bool Fill = (bool)(dynamic_cast <TComponent *>(Sender)->Tag);
        CreateXRefs();
        if (Fill) {
            AddUndoTitle("Solid Fill in Selected Ellipses/Circles");
            } else {
            AddUndoTitle("Clear Fill in Selected Ellipses/Circles");
            }
        for (int i = 0; i < DisplayList.Length; i++) {
            if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayCircle) {
                bool found = false;
                int pointer = XRefs[DisplayList[i].ItemNumber].EntityXRef;
                if (pointer > -1
                    && pointer < CircleList.Length
                    && CircleList[pointer].ItemNumber == DisplayList[i].ItemNumber
                    ) found = true;
                if (found) {
                    if (CircleList[pointer].Filled != Fill) {
                        AddUndoChangeCircle(CircleList[pointer].ItemNumber);
                        CircleList[pointer].Filled = Fill;
                        FillPointsCircle(pointer,CircleList[pointer].ItemNumber);
                        DisplayListAreaUpdate(CircleList[pointer].ItemNumber);
                        if (deselectafteroperation) {
                            AddUndo("Select," + AnsiString(CircleList[pointer].ItemNumber) + ",");
                            DisplayList[i].selected = false;
                            }
                        }
                    }
                }
            }
        DrawPicture();
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Filled3Click(TObject *Sender)
{
    //fill the selected circles
    if (dynamic_cast <TComponent *>(Sender)) {
        bool Fill = (bool)(dynamic_cast <TComponent *>(Sender)->Tag);
        CreateXRefs();
        if (Fill) {
            AddUndoTitle("Solid Fill in Selected Free-Form Shapes");
            } else {
            AddUndoTitle("Clear Fill in Selected Free-Form Shapes");
            }
        for (int i = 0; i < DisplayList.Length; i++) {
            if (DisplayList[i].selected && DisplayList[i].visible && DisplayList[i].DisplayType == TDisplayFreeForm) {
                bool found = false;
                int pointer = XRefs[DisplayList[i].ItemNumber].EntityXRef;
                if (pointer > -1
                    && pointer < FreeFormList.Length
                    && FreeFormList[pointer].ItemNumber == DisplayList[i].ItemNumber
                    ) found = true;
                if (found) {
                    if (FreeFormList[pointer].filled != Fill) {
                        AddUndoChangeFreeForm(FreeFormList[pointer].ItemNumber);
                        FreeFormList[pointer].filled = Fill;
                        FillPointsFreeForm(pointer,FreeFormList[pointer].ItemNumber);
                        DisplayListAreaUpdate(FreeFormList[pointer].ItemNumber);
                        if (deselectafteroperation) {
                            AddUndo("Select," + AnsiString(FreeFormList[pointer].ItemNumber) + ",");
                            DisplayList[i].selected = false;
                            }
                        }
                    }
                }
            }
        DrawPicture();
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::EditPolyLine1Click(TObject *Sender)
{
    MovePoints1->Enabled = (bool)(NumberPolyLinesSelected == 1);    
}
//---------------------------------------------------------------------------


void __fastcall TImageEditorForm::PasteAsBackgroundImage1Click(
      TObject *Sender)
{
    //Paste the bitmap on clipboard into the background image, but do an image conversion while doing so.
    TClipboard *pCB = Clipboard();
    if (pCB->HasFormat(CF_BITMAP)) {
        Graphics::TBitmap *pBitmap = new Graphics::TBitmap();
        TThreadConversionForm *ThreadConversionForm = new TThreadConversionForm(this);
        try {
            pBitmap->LoadFromClipboardFormat(CF_BITMAP, pCB->GetAsHandle(CF_BITMAP), 0);

            //this allows the user to access the image colour reduction routine

            ThreadConversionForm->Image1->Picture->Bitmap->Assign(pBitmap);
            ThreadConversionForm->DMCColourList.Length = DMCColourList.Length;
            for (int i = 0; i < DMCColourList.Length; i++) {
                ThreadConversionForm->DMCColourList[i] = DMCColourList[i];
                }
            ThreadConversionForm->TweedList.Length = dynamic_cast<TPlanForm *>(Owner)->TweedList.Length;
            for (int i = 0; i < dynamic_cast<TPlanForm *>(Owner)->TweedList.Length; i++) {
                ThreadConversionForm->TweedList[i].Data = dynamic_cast<TPlanForm *>(Owner)->TweedList[i].Data;
                ThreadConversionForm->TweedList[i].ColourPairs.Length = dynamic_cast<TPlanForm *>(Owner)->TweedList[i].ColourPairs.Length;
                for (int j = 0; j < dynamic_cast<TPlanForm *>(Owner)->TweedList[i].ColourPairs.Length; j++) {
                    ThreadConversionForm->TweedList[i].ColourPairs[j] = dynamic_cast<TPlanForm *>(Owner)->TweedList[i].ColourPairs[j];
                    }
                }
            Conversion.imageheight = pBitmap->Height;
            Conversion.imagewidth = pBitmap->Width;
            Conversion.colourspace = colourspacedivisions;
            ThreadConversionForm->Conversion = Conversion;
            ThreadConversionForm->BlendThreads->Checked = blendthreads;
            ThreadConversionForm->Initialise();

            if (ThreadConversionForm->ShowModal() == mrOk) {
                //revised picture is OK, so swap out old picture for new one
                Picture->Assign(ThreadConversionForm->Image2->Picture->Bitmap);
                if (ThreadConversionForm->BlendThreads->Checked) blendthreads = true;
                DrawPicture();
                }
            }

        catch (...) {
            ShowMessage("Error during Paste Operation");
            }
        delete ThreadConversionForm;
        delete pBitmap;
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::PasteAsBlock1Click(TObject *Sender)
{
    //Paste the bitmap on clipboard into a new block, deselect everything except the new block, put the new block at 0,0 and trigger a special move so the user can put it where they want.
    TClipboard *pCB = Clipboard();
    if (pCB->HasFormat(CF_BITMAP)) {
        Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
        try {
            Bitmap->LoadFromClipboardFormat(CF_BITMAP, pCB->GetAsHandle(CF_BITMAP), 0);
            AddUndoTitle("Paste Bitmap as Block");
            for (int i = 0; i < DisplayList.Length; i++) {
                if (DisplayList[i].selected) {
                    AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                    DisplayList[i].selected = false;
                    }
                }
            int displaypointer = DisplayList.Length;
            DisplayList.Length++;
            DisplayList[displaypointer].ItemNumber = DisplayItemNumber;
            DisplayList[displaypointer].DisplayType = TDisplayBlock;
            DisplayList[displaypointer].UndoName = "Block (" + AnsiString(DisplayItemNumber) + ")";
            DisplayList[displaypointer].selected = true;
            DisplayList[displaypointer].visible = false;
            int arraypointer = BlockList.Length;
            BlockList.Length++;
            BlockList[arraypointer].ItemNumber = DisplayItemNumber;
            BlockList[arraypointer].Area.Left = 0;
            BlockList[arraypointer].Area.Top = 0;
            BlockList[arraypointer].Area.Right = Bitmap->Width;
            BlockList[arraypointer].Area.Left = Bitmap->Height;
            BlockList[arraypointer].Linked = false;
            BlockList[arraypointer].LinkedBlock = -1;
            BlockList[arraypointer].RotationCentre.x = 0;
            BlockList[arraypointer].RotationCentre.y = 0;
            BlockList[arraypointer].Angle = 0;
            BlockList[arraypointer].MirrorCentre = BlockList[arraypointer].RotationCentre;
            BlockList[arraypointer].Axis = TMANone;
            BlockList[arraypointer].delta = BlockList[arraypointer].RotationCentre;
            BlockList[arraypointer].Points.Length = Bitmap->Width * Bitmap->Height;
            int pointer = 0;
            for (int i = 0; i < Bitmap->Width; i++) {
                for (int j = 0; j < Bitmap->Height; j++) {
                    BlockList[arraypointer].Points[pointer].x = i;
                    BlockList[arraypointer].Points[pointer].y = j;
                    BlockList[arraypointer].Points[pointer].originalx = i;
                    BlockList[arraypointer].Points[pointer].originaly = j;
                    if (blendthreads) {
                        BlockList[arraypointer].Points[pointer].Colour = FindNearestBlendColour(Bitmap->Canvas->Pixels[i][j]);
                        } else {
                        BlockList[arraypointer].Points[pointer].Colour = FindNearestDMCColour(Bitmap->Canvas->Pixels[i][j]);
                        }
                    BlockList[arraypointer].Points[pointer].transparent = false;
                    pointer++;
                    }
                }
            AddUndo("Delete," + AnsiString(DisplayItemNumber) + ",");
            DisplayItemNumber++;
            DisplayListAreaUpdate(DisplayList[displaypointer].ItemNumber);
            TerminateCurrentAction();
            ResetActionButtons();
            ActionType = TPasteBlock;
            StartPointChart.x = 0;
            StartPointChart.y = 0;
            chartposition SP = FindImage1Position(0,0);
            StartPointScreen.x = SP.X;
            StartPointScreen.y = SP.Y;
            OldMousePositionScreen = StartPointScreen;
            wipedout = true;
            dragging = false;
            StatusBar1->Panels->Items[4]->Text = "Click or 'Enter' to position Block, 'Esc' to abandon paste.";
            Timer1->Enabled = true;
            }  //end of 'try {'

        catch (...) {
            ShowMessage("Error during 'Paste As Block' Operation");
            }
        delete Bitmap;
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::ChangeFont1Click(TObject *Sender)
{
    // Change selected text
    ResetActionButtons();
    bool found = false;
    int ItemNumber;
    int pointer = 0;
    while (!found && pointer < DisplayList.Length) {
        if (DisplayList[pointer].selected && DisplayList[pointer].visible && DisplayList[pointer].DisplayType == TDisplayText) {
            found = true;
            pointer--;
            }
        pointer++;
        }
    if (found) {
        ItemNumber = DisplayList[pointer].ItemNumber;
        int displaypointer = pointer;
        pointer = XRefs[ItemNumber].EntityXRef;
        found = false;

        if (XRefs[ItemNumber].DisplayType == TDisplayText && pointer > -1 && pointer < TextList.Length && TextList[pointer].ItemNumber == ItemNumber) found = true;

        if (found) {
            FontDialog1->Font->Name = TextList[pointer].Name;
            FontDialog1->Font->Height = TextList[pointer].Height;
            KeyPreview = false;
            if (FontDialog1->Execute()) {
                AddUndoTitle("Change Text Font");
                AddUndoChangeText(ItemNumber);
                if (deselectafteroperation) {
                    DisplayList[displaypointer].selected = false;
                    AddUndo("Select," + AnsiString(ItemNumber) + ",");
                    }
                TextList[pointer].Name = FontDialog1->Font->Name;
                TextList[pointer].Height = FontDialog1->Font->Height;
                //if (TextList[pointer].Height > 0) TextList[pointer].Height = TextList[pointer].Height * -1;
                FillPointsText(pointer,ItemNumber);
                DisplayListAreaUpdate(ItemNumber);
                DrawPicture();
                }
            KeyPreview = true;
            }
        }


}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::EditFreeFormShape1Click(TObject *Sender)
{
    MovePoints2->Enabled = (bool)(NumberFreeFormsSelected == 1);    
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::PopupMenu2Popup(TObject *Sender)
{
    AnsiString text = StatusBar1->Panels->Items[3]->Text.Trim();
    PointHelp->Visible = (bool)(text == PixelEditButton->Hint);
    EyeDropperHelp->Visible = (bool)(text == EyedropperButton->Hint) ;
    LineHelp->Visible = (bool)(text == LineButton->Hint) ;
    PolyLineHelp->Visible = (bool)(text == PolyLineButton->Hint) ;
    FloodFillHelp->Visible = (bool)(text == FloodFillButton->Hint) ;
    TextHelp->Visible = (bool)(text == TextButton->Hint) ;
    FontHelp->Visible = (bool)(text == FontButton->Hint) ;
    TextHeightHelp->Visible = (bool)(text == FontHeightComboBox->Hint) ;
    RectangleHelp->Visible = (bool)(text == RectangleButton->Hint) ;
    CircleHelp->Visible = (bool)(text == CircleButton->Hint) ;
    FreeFormHelp->Visible = (bool)(text == FreeFormButton->Hint) ;
    LineWidthHelp->Visible = (bool)(text == LineWidth1Button->Hint || text == LineWidth2Button->Hint || text == LineWidth4Button->Hint) ;
    FilledHelp->Visible = (bool)(text == FillShapeButton->Hint) ;
    UndoHelp->Visible = (bool)(text == UndoButton->Hint) ;
    SelectHelp->Visible = (bool)(text == SelectButton->Hint) ;
    EraseHelp->Visible = (bool)(text == EraseButton->Hint) ;
    BlockHelp->Visible = (bool)(text == BlockButton->Hint) ;
    ZoomInHelp->Visible = (bool)(text == ZoomInButton->Hint) ;
    ZoomOutHelp->Visible = (bool)(text == ZoomOutButton->Hint) ;
    Zoom1to1Help->Visible = (bool)(text == Zoom1to1Button->Hint) ;
}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::PointHelpClick(TObject *Sender)
{
    //Context sensitive help. Pain doing it this way, but can't do it for CHM files through the normal procedure.
    int Tag = dynamic_cast <TMenuItem *>(Sender)->Tag;
    AnsiString Address = ExtractFileDir(Application->ExeName) + "\\BackStitch.chm";
    AnsiString Location;
    switch (Tag) {
        case 0:     {
                    Location = "mk:@MSITStore:" + Address + "::/imageeditor.html#PencilTool";
                    }
                    break;
        case 1:     {
                    Location = "mk:@MSITStore:" + Address + "::/imageeditor.html#ColourPicker";
                    }
                    break;
        case 2:     {
                    Location = "mk:@MSITStore:" + Address + "::/imageeditor.html#LineTool";
                    }
                    break;
        case 3:     {
                    Location = "mk:@MSITStore:" + Address + "::/imageeditor.html#PolyLineTool";
                    }
                    break;
        case 4:     {
                    Location = "mk:@MSITStore:" + Address + "::/imageeditor.html#FloodFillTool";
                    }
                    break;
        case 5:     {
                    Location = "mk:@MSITStore:" + Address + "::/imageeditor.html#TextTool";
                    }
                    break;
        case 6:     {
                    Location = "mk:@MSITStore:" + Address + "::/imageeditor.html#FontPicker";
                    }
                    break;
        case 7:     {
                    Location = "mk:@MSITStore:" + Address + "::/imageeditor.html#TextHeight";
                    }
                    break;
        case 8:     {
                    Location = "mk:@MSITStore:" + Address + "::/imageeditor.html#Rectangle";
                    }
                    break;
        case 9:     {
                    Location = "mk:@MSITStore:" + Address + "::/imageeditor.html#Circle";
                    }
                    break;
        case 10:    {
                    Location = "mk:@MSITStore:" + Address + "::/imageeditor.html#FreeForm";
                    }
                    break;
        case 11:    {
                    Location = "mk:@MSITStore:" + Address + "::/imageeditor.html#LineWidth";
                    }
                    break;
        case 12:    {
                    Location = "mk:@MSITStore:" + Address + "::/imageeditor.html#FillSetting";
                    }
                    break;
        case 13:    {
                    Location = "mk:@MSITStore:" + Address + "::/imageeditor.html#Undo";
                    }
                    break;
        case 14:    {
                    Location = "mk:@MSITStore:" + Address + "::/imageeditor.html#Select";
                    }
                    break;
        case 15:    {
                    Location = "mk:@MSITStore:" + Address + "::/imageeditor.html#EraseTool";
                    }
                    break;
        case 16:    {
                    Location = "mk:@MSITStore:" + Address + "::/imageeditor.html#BlockTool";
                    }
                    break;
        case 17:    {
                    Location = "mk:@MSITStore:" + Address + "::/imageeditor.html#ZoomIn";
                    }
                    break;
        case 18:    {
                    Location = "mk:@MSITStore:" + Address + "::/imageeditor.html#ZoomOut";
                    }
                    break;
        case 19:    {
                    Location = "mk:@MSITStore:" + Address + "::/imageeditor.html#ZoomOneToOne";
                    }
                    break;
        default:    {
                    Location = "mk:@MSITStore:" + Address + "::/imageeditor.html#start";
                    }
                    break;
        }

    ShellExecute(Application->Handle,"open",Location.c_str(),Location.c_str(),NULL,SW_SHOW);

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::All3Click(TObject *Sender)
{
    //select all items
    AddUndoTitle("Select All Objects");
    for (int i = 0; i < DisplayList.Length; i++) {
        if (!DisplayList[i].visible) AddUndo("Hide," + AnsiString(DisplayList[i].ItemNumber) + ",");
        if (!DisplayList[i].selected) AddUndo("Deselect," + AnsiString(DisplayList[i].ItemNumber) + ",");
        DisplayList[i].visible = true;
        DisplayList[i].selected = true;
        }
    DrawPicture();

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::AllPencilObjects2Click(TObject *Sender)
{
    //select all of a type
    if (dynamic_cast <TComponent *>(Sender)) {
        TDisplayType DisplayType = (TDisplayType)(dynamic_cast <TComponent *>(Sender)->Tag);
        AnsiString text = "Select All ";
        switch (DisplayType) {
            case TDisplayBlock:     {
                                    text = text + "Blocks";
                                    }
                                    break;
            case TDisplayEraseItem: {
                                    text = text + "Erase Objects";
                                    }
                                    break;
            case TDisplayFreeForm:  {
                                    text = text + "Free-Form Shapes";
                                    }
                                    break;
            case TDisplayCircle:    {
                                    text = text + "Circles";
                                    }
                                    break;
            case TDisplayRectangle: {
                                    text = text + "Rectangles";
                                    }
                                    break;
            case TDisplayText:      {
                                    text = text + "Text Objects";
                                    }
                                    break;
            case TDisplayFloodFill: {
                                    text = text + "Flood Fills";
                                    }
                                    break;
            case TDisplayPolyLine:  {
                                    text = text + "Polylines";
                                    }
                                    break;
            case TDisplayLine:      {
                                    text = text + "Lines";
                                    }
                                    break;
            case TDisplayPoint:     {
                                    text = text + "Pencil Objects";
                                    }
                                    break;
            default:                break;
            }
        AddUndoTitle(text);
        for (int i = 0; i < DisplayList.Length; i++) {
            if (DisplayList[i].DisplayType == DisplayType) {
                if (!DisplayList[i].selected) AddUndo("Deselect," + AnsiString(DisplayList[i].ItemNumber) + ",");
                if (!DisplayList[i].visible) AddUndo("Hide," + AnsiString(DisplayList[i].ItemNumber) + ",");
                DisplayList[i].selected = true;
                DisplayList[i].visible = true;
                }
            }
        DrawPicture();
        }

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Select3Click(TObject *Sender)
{
    if (DisplayList.Length) {
        All3->Enabled = true;
        } else {
        All3->Enabled = false;
        }
    AllPencilObjects2->Enabled = (bool)(PointList.Length);
    AllLines3->Enabled = (bool)(LineList.Length);
    AllPolylines3->Enabled = (bool)(PolyLineList.Length);
    AllFloodFills3->Enabled = (bool)(FloodFillList.Length);
    AllTextObjects3->Enabled = (bool)(TextList.Length);
    AllRectangles3->Enabled = (bool)(RectangleList.Length);
    AllEllipsesCircles3->Enabled = (bool)(CircleList.Length);
    AllFreeFormShapes3->Enabled = (bool)(FreeFormList.Length);
    AllEraseObjects3->Enabled = (bool)(EraseList.Length);
    AllBlocks3->Enabled = (bool)(BlockList.Length);

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::InvertSelection1Click(TObject *Sender)
{
    //invert selection of items. All invisible objects become visible on selection
    AddUndoTitle("Invert Selection");
    for (int i = 0; i < DisplayList.Length; i++) {
        if (!DisplayList[i].selected) {
            AddUndo("Deselect," + AnsiString(DisplayList[i].ItemNumber) + ",");
            if (!DisplayList[i].visible) AddUndo("Hide," + AnsiString(DisplayList[i].ItemNumber) + ",");
            } else {
            AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
            }
        DisplayList[i].selected = !DisplayList[i].selected;
        if (DisplayList[i].selected) DisplayList[i].visible = true;
        }
    DrawPicture();

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::Deselect2Click(TObject *Sender)
{
    if (DisplayList.Length) {
        All4->Enabled = true;
        } else {
        All4->Enabled = false;
        }
    AllPencilObjects3->Enabled = (bool)(PointList.Length);
    AllLines3->Enabled = (bool)(LineList.Length);
    AllPolylines4->Enabled = (bool)(PolyLineList.Length);
    AllFloodFills4->Enabled = (bool)(FloodFillList.Length);
    AllTextObjects3->Enabled = (bool)(TextList.Length);
    AllRectangles4->Enabled = (bool)(RectangleList.Length);
    AllEllipsesCircles4->Enabled = (bool)(CircleList.Length);
    AllFreeFormShapes4->Enabled = (bool)(FreeFormList.Length);
    AllEraseObjects4->Enabled = (bool)(EraseList.Length);
    AllBlocks4->Enabled = (bool)(BlockList.Length);

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::All4Click(TObject *Sender)
{
    //deselect all items
    AddUndoTitle("Deselect All Objects");
    for (int i = 0; i < DisplayList.Length; i++) {
        if (DisplayList[i].selected) AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
        DisplayList[i].selected = false;
        }
    DrawPicture();

}
//---------------------------------------------------------------------------

void __fastcall TImageEditorForm::AllPencilObjects3Click(TObject *Sender)
{
    //select all of a type
    if (dynamic_cast <TComponent *>(Sender)) {
        TDisplayType DisplayType = (TDisplayType)(dynamic_cast <TComponent *>(Sender)->Tag);
        AnsiString text = "Deselect All ";
        switch (DisplayType) {
            case TDisplayBlock:     {
                                    text = text + "Blocks";
                                    }
                                    break;
            case TDisplayEraseItem: {
                                    text = text + "Erase Objects";
                                    }
                                    break;
            case TDisplayFreeForm:  {
                                    text = text + "Free-Form Shapes";
                                    }
                                    break;
            case TDisplayCircle:    {
                                    text = text + "Circles";
                                    }
                                    break;
            case TDisplayRectangle: {
                                    text = text + "Rectangles";
                                    }
                                    break;
            case TDisplayText:      {
                                    text = text + "Text Objects";
                                    }
                                    break;
            case TDisplayFloodFill: {
                                    text = text + "Flood Fills";
                                    }
                                    break;
            case TDisplayPolyLine:  {
                                    text = text + "Polylines";
                                    }
                                    break;
            case TDisplayLine:      {
                                    text = text + "Lines";
                                    }
                                    break;
            case TDisplayPoint:     {
                                    text = text + "Pencil Objects";
                                    }
                                    break;
            default:                break;
            }
        AddUndoTitle(text);
        for (int i = 0; i < DisplayList.Length; i++) {
            if (DisplayList[i].DisplayType == DisplayType) {
                if (DisplayList[i].selected) AddUndo("Select," + AnsiString(DisplayList[i].ItemNumber) + ",");
                DisplayList[i].selected = false;
                }
            }
        DrawPicture();
        }

}
//---------------------------------------------------------------------------

