//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "StitchForm.h"
#include <Printers.hpp>
#include "about.h"
#include <math.h>
#include <shellapi.h>
#include "StringHelp.h"
#include <clipbrd.hpp>
#include "Backstitchedit.h"
#include "Transparency.h"
#include "DefinePrintout.h"
#include "GraphicsHelp.h"
#include "ThreadConversion.h"
#include "ThreadMerge.h"
#include "CropChartImage.h"
#include <jpeg.hpp>
#include "GIFImage.hpp"
#include "DMCList.h"
#include "BlendList.h"
#include "PaletteList.h"
#include "ImageDetails.h"
#include "NewImage.h"
#include "ImageEditor.h"
#include "BackStitchList.h"
#include "SetSymbols.h"
#include "SetDefaultSymbols.h"
#include "DefaultSettings.h"
#include <IniFiles.hpp>
#include "AddThreadRange.h"
#include "DeleteThreadRange.h"
#include "ObtainRGB.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

static AnsiString VersionDate = "2 September 2015";

TPlanForm *PlanForm;
//---------------------------------------------------------------------------
__fastcall TPlanForm::TPlanForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TPlanForm::Exit1Click(TObject *Sender)
{
    Application->HelpCommand(HELP_QUIT,0);
    Close();    
}
//---------------------------------------------------------------------------
void __fastcall TPlanForm::PrintSetup1Click(TObject *Sender)
{
    PrinterSetupDialog1->Execute();
    FillPrinterData();

}
//---------------------------------------------------------------------------
void __fastcall TPlanForm::Open1Click(TObject *Sender)
{
    if (OpenDialog1->Execute()) {
        OpenImage();
        /*
        //Image1->Picture->LoadFromFile(OpenDialog1->FileName);
        Screen->Cursor = crHourGlass;
        AnsiString Ext = ExtractFileExt(OpenDialog1->FileName).LowerCase();
        if (Ext == ".bs") {
            //a project file has been opened, see if any image has the same file name
            if (FileExists(ChangeFileExt(OpenDialog1->FileName,".emf"))) OpenDialog1->FileName = ChangeFileExt(OpenDialog1->FileName,".emf");
            if (FileExists(ChangeFileExt(OpenDialog1->FileName,".jpeg"))) OpenDialog1->FileName = ChangeFileExt(OpenDialog1->FileName,".jpeg");
            if (FileExists(ChangeFileExt(OpenDialog1->FileName,".gif"))) OpenDialog1->FileName = ChangeFileExt(OpenDialog1->FileName,".gif");
            if (FileExists(ChangeFileExt(OpenDialog1->FileName,".jpg"))) OpenDialog1->FileName = ChangeFileExt(OpenDialog1->FileName,".jpg");
            if (FileExists(ChangeFileExt(OpenDialog1->FileName,".bmp"))) OpenDialog1->FileName = ChangeFileExt(OpenDialog1->FileName,".bmp");
            }
        if (Ext == ".bmp" || Ext == ".jpg" || Ext == ".jpeg" || Ext == ".emf") {
            //this round the houses methodology allows jpgs & emfs to be loaded as well as bmps.
            TImage *TempImage = new TImage(this);
            TempImage->AutoSize = true;
            TempImage->Picture->LoadFromFile(OpenDialog1->FileName);
            Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
            Bitmap->Width = TempImage->Width;
            Bitmap->Height = TempImage->Height;
            Bitmap->Canvas->Draw(0,0,TempImage->Picture->Graphic);
            Image1->Picture->Bitmap->Width = Bitmap->Width;
            Image1->Picture->Bitmap->Height = Bitmap->Height;
            Image1->Picture->Bitmap->Canvas->Draw(0,0,Bitmap);
            delete Bitmap;
            delete TempImage;
            }
        if (Ext == ".gif") {
            TGIFImage *Gif = new TGIFImage();
            Gif->LoadFromFile(OpenDialog1->FileName);
            Image1->Picture->Bitmap->Assign(Gif);
            delete Gif;
            }
        forceConfettiLevel = false;
        ReadBackStitches(OpenDialog1->FileName);
        PictureFileName = ChangeFileExt(OpenDialog1->FileName,".bmp");
        Image4->Top = Image1->Top + Image1->Height;
        Image4->Left = Image1->Left;
        PictureChanged = false;
        if (!OriginalBitmap->Empty) {
            OriginalBitmap->Width = 0;
            OriginalBitmap->Height = 0;
            }
        CreateImage4();
        FormResize(this);

        Caption = ExtractFileName(PictureFileName);

        FillPictureData();
        //Caption = ExtractFileName(PictureFileName);
        CountBackStitches();
        AssignAnchorColours();

        FillPrinterData();
        BackgroundClick(this);
        PrintKey->Enabled = true;
        PrintChart->Enabled = true;
        PrintFabricDetails1->Enabled = true;
        PrintFronticePiece1->Enabled = true;
        if (BackStitches.Length) PrintBackStitches1->Enabled = true;
        if (!UseAnchor->Checked) PrintPageStitchInfo->Enabled = true;
        PrintWholeChartDocument1->Enabled = true;
        Label3->Enabled = true;
        Label26->Enabled = true;
        Label27->Enabled = true;
        PageNumber->Enabled = true;
        UseAnchor->Enabled = true;
        PrintColour->Enabled = true;
        BackStitch1->Enabled = true;
        MergeSubstituteColours1->Enabled = true;
        CropImage1->Enabled = true;
        CopyPlanSheetXRef1->Enabled = true;
        ColourReduction1->Enabled = true;
        Image4->Top = Image1->Top + Image1->Height;
        Image4->Left = Image1->Left;
        UndoStitchOffset.X = 0;
        UndoStitchOffset.Y = 0;
        CreateImage4();
        Screen->Cursor = crDefault;
        */
        }
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::Open2Click(TObject *Sender)
{
    if (OpenDialog2->Execute()) {
        OpenDialog1->FileName = OpenDialog2->FileName;
        OpenImage();
        }

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::OpenImage(void)
{
        Screen->Cursor = crHourGlass;
        AnsiString Ext = ExtractFileExt(OpenDialog1->FileName).LowerCase();
        if (Ext == ".bs") {
            //a project file has been opened, see if any image has the same file name
            if (FileExists(ChangeFileExt(OpenDialog1->FileName,".emf"))) OpenDialog1->FileName = ChangeFileExt(OpenDialog1->FileName,".emf");
            if (FileExists(ChangeFileExt(OpenDialog1->FileName,".jpeg"))) OpenDialog1->FileName = ChangeFileExt(OpenDialog1->FileName,".jpeg");
            if (FileExists(ChangeFileExt(OpenDialog1->FileName,".gif"))) OpenDialog1->FileName = ChangeFileExt(OpenDialog1->FileName,".gif");
            if (FileExists(ChangeFileExt(OpenDialog1->FileName,".jpg"))) OpenDialog1->FileName = ChangeFileExt(OpenDialog1->FileName,".jpg");
            if (FileExists(ChangeFileExt(OpenDialog1->FileName,".bmp"))) OpenDialog1->FileName = ChangeFileExt(OpenDialog1->FileName,".bmp");
            }
        Ext = ExtractFileExt(OpenDialog1->FileName).LowerCase();
        if (Ext == ".bmp" || Ext == ".jpg" || Ext == ".jpeg" || Ext == ".emf") {
            //this round the houses methodology allows jpgs & emfs to be loaded as well as bmps.
            TImage *TempImage = new TImage(this);
            TempImage->AutoSize = true;
            TempImage->Picture->LoadFromFile(OpenDialog1->FileName);
            Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
            Bitmap->Width = TempImage->Width;
            Bitmap->Height = TempImage->Height;
            Bitmap->Canvas->Draw(0,0,TempImage->Picture->Graphic);
            Image1->Picture->Bitmap->Width = Bitmap->Width;
            Image1->Picture->Bitmap->Height = Bitmap->Height;
            Image1->Picture->Bitmap->Canvas->Draw(0,0,Bitmap);
            delete Bitmap;
            delete TempImage;
            }
        if (Ext == ".gif") {
            TGIFImage *Gif = new TGIFImage();
            Gif->LoadFromFile(OpenDialog1->FileName);
            Image1->Picture->Bitmap->Assign(Gif);
            delete Gif;
            }
        //last picture may have had its own symboltoglyphxref, now restore the default one:
        ReadSymbolToGlyphXRef();
        forceConfettiLevel = false;
        ReadBackStitches(OpenDialog1->FileName);
        FillPictureData();
        //ReadBackStitches(OpenDialog1->FileName);
        PictureFileName = ChangeFileExt(OpenDialog1->FileName,".bmp");
        Image4->Top = Image1->Top + Image1->Height;
        Image4->Left = Image1->Left;
        PictureChanged = false;
        if (!OriginalBitmap->Empty) {
            OriginalBitmap->Width = 0;
            OriginalBitmap->Height = 0;
            }
        CreateImage4();
        FormResize(this);

        Caption = ExtractFileName(PictureFileName);

        FillPictureData();
        //Caption = ExtractFileName(PictureFileName);
        CountBackStitches();
        AssignAnchorColours();

        FillPrinterData();
        BackgroundClick(this);
        PrintKey->Enabled = true;
        PrintChart->Enabled = true;
        PrintFabricDetails1->Enabled = true;
        PrintFronticePiece1->Enabled = true;
        if (BackStitches.Length) PrintBackStitches1->Enabled = true;
        if (!UseAnchor->Checked) PrintPageStitchInfo->Enabled = true;
        PrintWholeChartDocument1->Enabled = true;
        Label3->Enabled = true;
        Label26->Enabled = true;
        Label27->Enabled = true;
        PageNumber->Enabled = true;
        UseAnchor->Enabled = true;
        PrintColour->Enabled = true;
        BackStitch1->Enabled = true;
        MergeSubstituteColours1->Enabled = true;
        CropImage1->Enabled = true;
        CopyPlanSheetXRef1->Enabled = true;
        ColourReduction1->Enabled = true;
        Image4->Top = Image1->Top + Image1->Height;
        Image4->Left = Image1->Left;
        UndoStitchOffset.X = 0;
        UndoStitchOffset.Y = 0;
        CreateImage4();
        Screen->Cursor = crDefault;
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::PrintKeyClick(TObject *Sender)
{
    Screen->Cursor = crHourGlass;
    AnsiString key = Caption + "_Key";
    Printer()->Title = key;
    Printer()->BeginDoc();

    PrintKeyPages();

    Printer()->EndDoc();
    Screen->Cursor = crDefault;

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::FillPrinterData(void)
{
    //Screen->Cursor = crHourGlass;

    //"Hi There" is pretty close to 13mm wide when printed in 10 point Arial
    //HiThere1->Text = AnsiString(Printer()->Canvas->TextWidth("Hi There"));
    Printer()->Canvas->Font->Name = "Arial";
    Printer()->Canvas->Font->Size = 10;
    GlyphSize = (int) ((double)(Printer()->Canvas->TextWidth("Hi There")) * 25.4/ ((double)PrintCount->Items->Strings[PrintCount->ItemIndex].ToIntDef(1) * 13.34));
    //debug
    //int textwidth = Printer()->Canvas->TextWidth("Hi There");
    //int count = PrintCount->Items->Strings[PrintCount->ItemIndex].ToIntDef(1);
    //end debug
    Printer()->Canvas->Font->Name = ChartPrintout.ChartFont;
    Printer()->Canvas->Font->Size = ChartPrintout.ChartFontSize + 2;

    //find out how many pages there are (copied direct from the printing routine)

    pageinfo info = FindPages();
    Label26->Caption = (info.rows * info.columns > 1 ? "There are ":"There is ") + AnsiString(info.rows * info.columns) + (info.rows * info.columns > 1 ? " Pages.":" Page.") + ((info.rows * info.columns > 1) ? (" Rows = " + AnsiString(info.rows) + ", Columns = " + AnsiString(info.columns) + "."):AnsiString(" "));
    Label27->Caption = "Each Page is " + AnsiString(info.numglyphswide) + "W x " + AnsiString(info.numglyphshigh) + "H Symbols";
    //fill page list
    PageNumber->Items->Clear();
    PageNumber->Items->Add("All");
    if ( info.rows * info.columns > 1) {
        for (int i = 0; i < info.rows; i++) {
            for (int j = 0; j < info.columns; j++) {
                PageNumber->Items->Add("Page " + AnsiString(i * info.columns + j + 1) + "; Row " + AnsiString(i+1) + ", Column " + AnsiString(j+1) + ".");
                }
            }
        }
    PageNumber->ClientWidth = Canvas->TextWidth(PageNumber->Items->Strings[PageNumber->Items->Count - 1] + " ") + 25;
    PageNumber->ItemIndex = 0;

    //Screen->Cursor = crDefault;
    CreateImage4();
    //FormResize(this);


}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::FillPictureData(void)
{
    if (blendthreads) {
        FillBlendPictureData();
        } else {
        FillNoBlendPictureData();
        }
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::ShowPictureSize(void)
{
    double value = double(Image1->Height) /double( StitchCount->Items->Strings[StitchCount->ItemIndex].ToIntDef(14));
    value = ROUND(value * 100.0)/100.0;
    Label10->Caption = AnsiString(value) + "\"";
    value = value * 2.54;
    value = ROUND(value * 100.0)/100.0;
    Label10->Caption = Label10->Caption + ",   " + AnsiString(value) + "cm";
    value = double(Image1->Width) /double( StitchCount->Items->Strings[StitchCount->ItemIndex].ToIntDef(1));
    value = ROUND(value * 100.0)/100.0;
    Label11->Caption = AnsiString(value) + "\"";
    value = value * 2.54;
    value = ROUND(value * 100.0)/100.0;
    Label11->Caption = Label11->Caption + ",   " + AnsiString(value) + "cm";
    AnsiString text;
    int tpi = StitchCount->Items->Strings[StitchCount->ItemIndex].ToIntDef(14);
    switch (tpi) {
            case 21:
            case 22:
            case 23:
            case 24:
            case 25:
            case 26:
            case 27:
            case 28:
            case 29:
            case 30:
            case 31:
            case 32:
            case 33:
            case 34:
            case 35:
            case 36:
            case 37:
            case 38:
            case 39:
            case 40:    {
                        text = "1 thread in cross or 2 threads in half cross";
                        }
                        break;
            case 14:
            case 15:
            case 16:
            case 17:
            case 18:
            case 19:
            case 20:    {
                        text = "2 threads in full cross";
                        }
                        break;
            case 11:
            case 12:
            case 13:    {
                        text = "3 threads in full cross";
                        }
                        break;
            default:    {
                        text = "4 threads in full cross";
                        }
                        break;
            case 8:
            case 7:     {
                        text = "5 threads in full cross";
                        }
                        break;
            case 6:     {
                        text = "6 threads in full cross";
                        }
                        break;
            }
    Label28->Caption = text;

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::FillNoBlendPictureData(void)
{
    Screen->Cursor = crHourGlass;

    HeightLabel->Caption = AnsiString(Image1->Height) + " Pixels";
    WidthLabel->Caption = AnsiString(Image1->Width) + " Pixels";
    ShowPictureSize();
    //double value;
    /*
    double value = double(Image1->Height) /double( StitchCount->Items->Strings[StitchCount->ItemIndex].ToIntDef(14));
    value = ROUND(value * 100.0)/100.0;
    Label10->Caption = AnsiString(value) + "\"";
    value = value * 2.54;
    value = ROUND(value * 100.0)/100.0;
    Label10->Caption = Label10->Caption + ",   " + AnsiString(value) + "cm";
    value = double(Image1->Width) /double( StitchCount->Items->Strings[StitchCount->ItemIndex].ToIntDef(1));
    value = ROUND(value * 100.0)/100.0;
    Label11->Caption = AnsiString(value) + "\"";
    value = value * 2.54;
    value = ROUND(value * 100.0)/100.0;
    Label11->Caption = Label11->Caption + ",   " + AnsiString(value) + "cm";
    */

    //put in a check here to see how many colours there are in the picture.
    //If there are unknown colours or if the number of colours exceeds the number of DMC threads, the program pops out to the colour reduction unit.
    bool unknowncolour = false;
    DynamicArray <TColor> UsedColour;
    int x = 0;
    int y, localpointer;
    bool localfind;
    TColor Colour;
    while (!unknowncolour && x < Image1->Picture->Bitmap->Width && UsedColour.Length < DMCColourList.Length) {
        y = 0;
        while (!unknowncolour && y < Image1->Picture->Bitmap->Height && UsedColour.Length < DMCColourList.Length) {
            Colour = Image1->Picture->Bitmap->Canvas->Pixels[x][y];
            localfind = false;
            localpointer = 0;
            while (!localfind && localpointer < UsedColour.Length) {
                if (UsedColour[localpointer] == Colour) {
                    localfind = true;
                    }
                localpointer++;
                }
            if (!localfind) {
                localpointer = 0;
                while (!localfind && localpointer < DMCColourList.Length) {
                    if (Colour == DMCColourList[localpointer].Colour) {
                        localfind = true;
                        localpointer--;
                        }
                    localpointer++;
                    }
                if (localfind) {
                    UsedColour.Length++;
                    UsedColour[UsedColour.Length - 1] = DMCColourList[localpointer].Colour;
                    } else {
                    unknowncolour = true;
                    }
                }
            y++;
            }
        x++;
        }
    if (UsedColour.Length > DMCColourList.Length) unknowncolour = true;

    UsedColour.Length = 0;

    if (unknowncolour) {
        /*
        //unknown colours detected, so pop to the thread conversion form which will
        //allow DMC threads to be used.
        TThreadConversionForm *ThreadConversionForm = new TThreadConversionForm(this);

        //ThreadConversionForm->Image1->Picture->Bitmap->Assign(Image1->Picture->Bitmap);
        if (OriginalBitmap->Empty) {
            ThreadConversionForm->Image1->Picture->Bitmap->Assign(Image1->Picture->Bitmap);
            OriginalBitmap->Assign(Image1->Picture->Bitmap);
            } else {
            ThreadConversionForm->Image1->Picture->Bitmap->Assign(OriginalBitmap);
            }
        ThreadConversionForm->DMCColourList.Length = DMCColourList.Length;
        for (int i = 0; i < DMCColourList.Length; i++) {
            ThreadConversionForm->DMCColourList[i] = DMCColourList[i];
            }
        ThreadConversionForm->TweedList.Length = TweedList.Length;
        for (int i = 0; i < TweedList.Length; i++) {
            ThreadConversionForm->TweedList[i].Data = TweedList[i].Data;
            ThreadConversionForm->TweedList[i].ColourPairs.Length = TweedList[i].ColourPairs.Length;
            for (int j = 0; j < TweedList[i].ColourPairs.Length; j++) {
                ThreadConversionForm->TweedList[i].ColourPairs[j] = TweedList[i].ColourPairs[j];
                }
            }
        Conversion.imageheight = Image1->Height;
        Conversion.imagewidth = Image1->Width;
        ThreadConversionForm->Conversion = Conversion;
        ThreadConversionForm->BlendThreads->Checked = blendthreads;
        ThreadConversionForm->Initialise();

        if (ThreadConversionForm->ShowModal() == mrOk) {
            //revised picture is OK, so swap out old picture for new one
            PictureChanged = true;
            Image1->Picture->Bitmap->Assign(ThreadConversionForm->Image2->Picture->Bitmap);
            if (ThreadConversionForm->PictureChanged) {
                PictureFileName = ChangeFileExt(PictureFileName," Pasted Image.bmp");
                } else {
                PictureFileName = ChangeFileExt(PictureFileName," reduced colours.bmp");
                }
            HeightLabel->Caption = AnsiString(Image1->Height) + " Pixels";
            WidthLabel->Caption = AnsiString(Image1->Width) + " Pixels";
            value = double(Image1->Height) /double( StitchCount->Items->Strings[StitchCount->ItemIndex].ToIntDef(14));
            value = ROUND(value * 100.0)/100.0;
            Label10->Caption = AnsiString(value) + "\"";
            value = value * 2.54;
            value = ROUND(value * 100.0)/100.0;
            Label10->Caption = Label10->Caption + ",   " + AnsiString(value) + "cm";
            value = double(Image1->Width) /double( StitchCount->Items->Strings[StitchCount->ItemIndex].ToIntDef(1));
            value = ROUND(value * 100.0)/100.0;
            Label11->Caption = AnsiString(value) + "\"";
            value = value * 2.54;
            value = ROUND(value * 100.0)/100.0;
            Label11->Caption = Label11->Caption + ",   " + AnsiString(value) + "cm";
            ThreadConversionForm->RetrieveData();
            Conversion = ThreadConversionForm->Conversion;
            blendthreads = ThreadConversionForm->BlendThreads->Checked;
            UseAnchor->Enabled = !blendthreads;
            if (blendthreads) {
                UseAnchor->Checked = false;
                }
            }

        delete ThreadConversionForm;
        */
        ColourReduction1Click(this);
        //cursor can be switched to default in the thread conversion form
        FormResize(this);
        Screen->Cursor = crHourGlass;
        }

    if (blendthreads) {
        FillBlendPictureData();
        } else {
        //now to analyse the picture, pixel by pixel to find the DMC pixel colours
        PictureColourPallette.Length = 0;
        bool found;
        bool unknown = false;
        int k;
        for (int i = 0; i < Image1->Width; i++) {
            for (int j = 0; j < Image1->Height; j++) {
                found = false;
                k = 0;
                while (!found && k < PictureColourPallette.Length) {
                    //first check if it's in the list of already found colours
                    if (Image1->Canvas->Pixels[i][j] == PictureColourPallette[k].Colour){
                        PictureColourPallette[k].StitchCount++;
                        found = true;
                        }
                    k++;
                    }
                if (!found) {
                    k = 0;
                    while (!found && k < DMCColourList.Length) {
                        //not in the existing found list, so check in the DMC list
                        if (Image1->Canvas->Pixels[i][j] == DMCColourList[k].Colour){
                            PictureColourPallette.Length++;
                            PictureColourPallette[PictureColourPallette.Length-1].DMCColourNumber = DMCColourList[k].DMCColourNumber;
                            PictureColourPallette[PictureColourPallette.Length-1].DMCColourName = DMCColourList[k].DMCColourName;
                            PictureColourPallette[PictureColourPallette.Length-1].Colour = DMCColourList[k].Colour;
                            PictureColourPallette[PictureColourPallette.Length-1].DrawWhite = DMCColourList[k].DrawWhite;
                            PictureColourPallette[PictureColourPallette.Length-1].StitchCount = 1;
                            PictureColourPallette[PictureColourPallette.Length-1].AnchorColourNumber = DMCColourList[k].AnchorColourNumber;
                            found = true;
                            }
                        k++;
                        }
                    if (!found) {
                        PictureColourPallette.Length++;
                        PictureColourPallette[PictureColourPallette.Length-1].DMCColourNumber = "Unknown";
                        PictureColourPallette[PictureColourPallette.Length-1].DMCColourName = "Unknown";
                        PictureColourPallette[PictureColourPallette.Length-1].Colour = Image1->Canvas->Pixels[i][j];
                        PictureColourPallette[PictureColourPallette.Length-1].StitchCount = 1;
                        PictureColourPallette[PictureColourPallette.Length-1].AnchorColourNumber = "Unknown";
                        unknown = true;
                        }
                    }
                }
            }

        //Really ought to do something about any unknown colours here
        //do an RMS check on the nearest DMC colour? Then change the pixel colours.
        if (unknown) {
            //for the moment, just flag up the fact that non DMC colours have been found
            //Application->MessageBox("Unknown (Non-DMC) colours found","Error",MB_ICONERROR|IDOK);
            Application->MessageBox("Unknown colours found, ones that are not in the colour list","Error",MB_ICONERROR|IDOK);
            }

        //sort thread list
        SortThreads();

        //Set Background colour
        SelectBackground();
        /*
        It is assumed that the background colour will be chosen from a list of
         available fabrics and that the colour will be moved to PictureColourPallette[0]
        */
        if (PictureColourPallette.Length) {
            if ((TColor) PictureColourPallette[0].Colour == Image1->Picture->Bitmap->Canvas->Pixels[0][Image1->Picture->Bitmap->Height-1]) {
                Image1->Picture->Bitmap->Transparent = true;
                Image1->Picture->Bitmap->TransparentMode = tmAuto;
                //Image1->Picture->Bitmap->TransparentColor = (TColor) PictureColourPallette[0].Colour;
                Image1->Transparent = true;
                } else {
                Image1->Picture->Bitmap->Transparent = true;
                Image1->Picture->Bitmap->TransparentMode = tmFixed;
                Image1->Picture->Bitmap->TransparentColor = (TColor) PictureColourPallette[0].Colour;
                Image1->Transparent = true;
                }
            }
        }

    if (!forceConfettiLevel) {
        colourcomplexity Complexity = FindImageComplexity();
        ConfettiLevel = TLowConfetti;
        if (Complexity.maxcolours > 15 || Complexity.average > 7.9) ConfettiLevel = TMediumConfetti;
        if (Complexity.maxcolours > 35 || Complexity.average > 11.9) ConfettiLevel = THighConfetti;
        if (Complexity.maxcolours > 59 || Complexity.average > 17.9) ConfettiLevel = TUnstitchable;
        }

    Screen->Cursor = crDefault;


}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::FillBlendPictureData(void)
{
    Screen->Cursor = crHourGlass;

    HeightLabel->Caption = AnsiString(Image1->Height) + " Pixels";
    WidthLabel->Caption = AnsiString(Image1->Width) + " Pixels";
    ShowPictureSize();
    //double value;

    /*
    double value = double(Image1->Height) /double( StitchCount->Items->Strings[StitchCount->ItemIndex].ToIntDef(14));
    value = ROUND(value * 100.0)/100.0;
    Label10->Caption = AnsiString(value) + "\"";
    value = value * 2.54;
    value = ROUND(value * 100.0)/100.0;
    Label10->Caption = Label10->Caption + ",   " + AnsiString(value) + "cm";
    value = double(Image1->Width) /double( StitchCount->Items->Strings[StitchCount->ItemIndex].ToIntDef(1));
    value = ROUND(value * 100.0)/100.0;
    Label11->Caption = AnsiString(value) + "\"";
    value = value * 2.54;
    value = ROUND(value * 100.0)/100.0;
    Label11->Caption = Label11->Caption + ",   " + AnsiString(value) + "cm";
    */

    //put in a check here to see how many colours there are in the picture.
    //If there are colours not in the standard or blend list, the program pops out to the colour reduction unit.
    bool unknowncolour = false;
    DynamicArray <TColor> UsedColour;
    int x = 0;
    int y, localpointer;
    bool localfind;
    TColor Colour;
    while (!unknowncolour && x < Image1->Picture->Bitmap->Width) {
        y = 0;
        while (!unknowncolour && y < Image1->Picture->Bitmap->Height) {
            Colour = Image1->Picture->Bitmap->Canvas->Pixels[x][y];
            localfind = false;
            localpointer = 0;
            while (!localfind && localpointer < UsedColour.Length) {
                if (UsedColour[localpointer] == Colour) {
                    localfind = true;
                    }
                localpointer++;
                }
            if (!localfind) {
                //search DMC list
                localpointer = 0;
                while (!localfind && localpointer < DMCColourList.Length) {
                    if (Colour == DMCColourList[localpointer].Colour) {
                        localfind = true;
                        localpointer--;
                        }
                    localpointer++;
                    }
                if (localfind) {
                    UsedColour.Length++;
                    UsedColour[UsedColour.Length - 1] = DMCColourList[localpointer].Colour;
                    } else {
                    //not in DMC list, so search through blend list
                    localpointer = 0;
                    while (!localfind && localpointer < TweedList.Length) {
                        if (Colour == TweedList[localpointer].Data.Colour) {
                            localfind = true;
                            localpointer--;
                            }
                        localpointer++;
                        }
                    if (localfind) {
                        UsedColour.Length++;
                        UsedColour[UsedColour.Length - 1] = TweedList[localpointer].Data.Colour;
                        } else {
                        //not in blend list, so the colour isn't known
                        unknowncolour = true;
                        }
                    }
                }
            y++;
            }
        x++;
        }

    UsedColour.Length = 0;

    if (unknowncolour) {
        //unknown colours detected, so pop to the thread conversion form which will
        //allow DMC threads/blends to be used.
        /*
        TThreadConversionForm *ThreadConversionForm = new TThreadConversionForm(this);

        //ThreadConversionForm->Image1->Picture->Bitmap->Assign(Image1->Picture->Bitmap);
        if (OriginalBitmap->Empty) {
            ThreadConversionForm->Image1->Picture->Bitmap->Assign(Image1->Picture->Bitmap);
            OriginalBitmap->Assign(Image1->Picture->Bitmap);
            } else {
            ThreadConversionForm->Image1->Picture->Bitmap->Assign(OriginalBitmap);
            }
        ThreadConversionForm->DMCColourList.Length = DMCColourList.Length;
        for (int i = 0; i < DMCColourList.Length; i++) {
            ThreadConversionForm->DMCColourList[i] = DMCColourList[i];
            }
        ThreadConversionForm->TweedList.Length = TweedList.Length;
        for (int i = 0; i < TweedList.Length; i++) {
            ThreadConversionForm->TweedList[i].Data = TweedList[i].Data;
            ThreadConversionForm->TweedList[i].ColourPairs.Length = TweedList[i].ColourPairs.Length;
            for (int j = 0; j < TweedList[i].ColourPairs.Length; j++) {
                ThreadConversionForm->TweedList[i].ColourPairs[j] = TweedList[i].ColourPairs[j];
                }
            }
        Conversion.imageheight = Image1->Height;
        Conversion.imagewidth = Image1->Width;
        ThreadConversionForm->Conversion = Conversion;
        ThreadConversionForm->BlendThreads->Checked = blendthreads;
        ThreadConversionForm->Initialise();

        if (ThreadConversionForm->ShowModal() == mrOk) {
            //revised picture is OK, so swap out old picture for new one
            PictureChanged = true;
            Image1->Picture->Bitmap->Assign(ThreadConversionForm->Image2->Picture->Bitmap);
            if (ThreadConversionForm->PictureChanged) {
                PictureFileName = ChangeFileExt(PictureFileName," Pasted Image.bmp");
                } else {
                PictureFileName = ChangeFileExt(PictureFileName," reduced colours.bmp");
                }
            HeightLabel->Caption = AnsiString(Image1->Height) + " Pixels";
            WidthLabel->Caption = AnsiString(Image1->Width) + " Pixels";
            value = double(Image1->Height) /double( StitchCount->Items->Strings[StitchCount->ItemIndex].ToIntDef(14));
            value = ROUND(value * 100.0)/100.0;
            Label10->Caption = AnsiString(value) + "\"";
            value = value * 2.54;
            value = ROUND(value * 100.0)/100.0;
            Label10->Caption = Label10->Caption + ",   " + AnsiString(value) + "cm";
            value = double(Image1->Width) /double( StitchCount->Items->Strings[StitchCount->ItemIndex].ToIntDef(1));
            value = ROUND(value * 100.0)/100.0;
            Label11->Caption = AnsiString(value) + "\"";
            value = value * 2.54;
            value = ROUND(value * 100.0)/100.0;
            Label11->Caption = Label11->Caption + ",   " + AnsiString(value) + "cm";
            ThreadConversionForm->RetrieveData();
            Conversion = ThreadConversionForm->Conversion;
            blendthreads = ThreadConversionForm->BlendThreads->Checked;
            UseAnchor->Enabled = !blendthreads;
            if (blendthreads) {
                UseAnchor->Checked = false;
                }
            }

        delete ThreadConversionForm;
        */
        ColourReduction1Click(this);
        //cursor can be switched to default in the thread conversion form
        FormResize(this);
        Screen->Cursor = crHourGlass;
        }

    if (!blendthreads) {
        FillNoBlendPictureData();
        } else {
        //now to analyse the picture, pixel by pixel to find the DMC pixel colours
        PictureColourPallette.Length = 0;
        BlendReference.Length = 0;
        bool found;
        bool unknown = false;
        int k;
        for (int i = 0; i < Image1->Width; i++) {
            for (int j = 0; j < Image1->Height; j++) {
                //debug
                try {
                found = false;
                k = 0;
                while (!found && k < PictureColourPallette.Length) {
                    //first check if it's in the list of already found colours
                    if (Image1->Canvas->Pixels[i][j] == PictureColourPallette[k].Colour){
                        PictureColourPallette[k].StitchCount++;
                        found = true;
                        }
                    k++;
                    }
                if (!found) {
                    k = 0;
                    while (!found && k < DMCColourList.Length) {
                        //not in the existing found list, so check in the DMC list
                        if (Image1->Canvas->Pixels[i][j] == DMCColourList[k].Colour){
                            PictureColourPallette.Length++;
                            PictureColourPallette[PictureColourPallette.Length-1].DMCColourNumber = DMCColourList[k].DMCColourNumber;
                            PictureColourPallette[PictureColourPallette.Length-1].DMCColourName = DMCColourList[k].DMCColourName;
                            PictureColourPallette[PictureColourPallette.Length-1].Colour = DMCColourList[k].Colour;
                            PictureColourPallette[PictureColourPallette.Length-1].DrawWhite = DMCColourList[k].DrawWhite;
                            PictureColourPallette[PictureColourPallette.Length-1].StitchCount = 1;
                            PictureColourPallette[PictureColourPallette.Length-1].AnchorColourNumber = DMCColourList[k].AnchorColourNumber;
                            PictureColourPallette[PictureColourPallette.Length-1].Hue = DMCColourList[k].Hue;
                            PictureColourPallette[PictureColourPallette.Length-1].Saturation = DMCColourList[k].Saturation;
                            PictureColourPallette[PictureColourPallette.Length-1].Brightness = DMCColourList[k].Brightness;
                            BlendReference.Length++;
                            BlendReference[BlendReference.Length - 1].type = TDMCColour;
                            BlendReference[BlendReference.Length - 1].ColourNumber = DMCColourList[k].DMCColourNumber;
                            BlendReference[BlendReference.Length - 1].ColourName = DMCColourList[k].DMCColourName;
                            BlendReference[BlendReference.Length - 1].arrayref = k;
                            found = true;
                            }
                        k++;
                        }
                    if (!found) {
                        //not in the existing list or DMC list, so look at blend list
                        k = 0;
                        while (!found && k < TweedList.Length) {
                            if (Image1->Canvas->Pixels[i][j] == TweedList[k].Data.Colour){
                                if (TweedList[k].ColourPairs.Length) {
                                    PictureColourPallette.Length++;
                                    PictureColourPallette[PictureColourPallette.Length-1].DMCColourNumber = DMCColourList[TweedList[k].ColourPairs[0].x].DMCColourNumber + " + " + DMCColourList[TweedList[k].ColourPairs[0].y].DMCColourNumber;
                                    PictureColourPallette[PictureColourPallette.Length-1].DMCColourName = TweedList[k].Data.DMCColourName;
                                    PictureColourPallette[PictureColourPallette.Length-1].Colour = TweedList[k].Data.Colour;
                                    PictureColourPallette[PictureColourPallette.Length-1].DrawWhite = TweedList[k].Data.DrawWhite;
                                    PictureColourPallette[PictureColourPallette.Length-1].StitchCount = 1;
                                    PictureColourPallette[PictureColourPallette.Length-1].AnchorColourNumber = TweedList[k].Data.AnchorColourNumber;
                                    PictureColourPallette[PictureColourPallette.Length-1].Hue = TweedList[k].Data.Hue;
                                    PictureColourPallette[PictureColourPallette.Length-1].Saturation = TweedList[k].Data.Saturation;
                                    PictureColourPallette[PictureColourPallette.Length-1].Brightness = TweedList[k].Data.Brightness;
                                    BlendReference.Length++;
                                    BlendReference[BlendReference.Length - 1].type = TBlendedColour;
                                    BlendReference[BlendReference.Length - 1].ColourNumber = DMCColourList[TweedList[k].ColourPairs[0].x].DMCColourNumber + " + " + DMCColourList[TweedList[k].ColourPairs[0].y].DMCColourNumber;
                                    BlendReference[BlendReference.Length - 1].ColourName = TweedList[k].Data.DMCColourName;
                                    BlendReference[BlendReference.Length - 1].arrayref = k;
                                    } else {
                                    AnsiString temp = "Error with Blend Entry k=" + AnsiString(k) + " " + TweedList[k].Data.DMCColourName;
                                    Application->MessageBox(temp.c_str(),"Error",IDOK);
                                    }
                                found = true;
                                }
                            k++;
                            }
                        if (!found) {
                            PictureColourPallette.Length++;
                            PictureColourPallette[PictureColourPallette.Length-1].DMCColourNumber = "Unknown";
                            PictureColourPallette[PictureColourPallette.Length-1].DMCColourName = "Unknown";
                            PictureColourPallette[PictureColourPallette.Length-1].Colour = Image1->Canvas->Pixels[i][j];
                            PictureColourPallette[PictureColourPallette.Length-1].StitchCount = 1;
                            PictureColourPallette[PictureColourPallette.Length-1].AnchorColourNumber = "Unknown";
                            BlendReference.Length++;
                            BlendReference[BlendReference.Length - 1].type = TNoThread;
                            BlendReference[BlendReference.Length - 1].ColourNumber = "Unknown";
                            BlendReference[BlendReference.Length - 1].ColourName = "Unknown";
                            BlendReference[BlendReference.Length - 1].arrayref = 0;
                            unknown = true;
                            }
                        }
                    }
                }//close try{
                catch (...) {
                    AnsiString temp = "Error with i="+ AnsiString(i) + " j=" + AnsiString(j) + " k=" + AnsiString(k) + " DMCLength="+ AnsiString(DMCColourList.Length) + " BlendLength=" + AnsiString(TweedList.Length);
                    Application->MessageBox(temp.c_str(),"Error, please contact Technical Support",IDOK);
                    }

                } //end //for j
            } //enf //for i

        //Really ought to do something about any unknown colours here
        //do an RMS check on the nearest DMC colour? Then change the pixel colours.
        if (unknown) {
            //for the moment, just flag up the fact that non DMC colours have been found
            Application->MessageBox("Unknown colours found, ones that are neither blends nor unblended colours","Error",MB_ICONERROR|IDOK);
            }

        //sort thread list
        SortThreads();

        //Set Background colour
        SelectBackground();
        /*
        It is assumed that the background colour will be chosen from a list of
         available fabrics and that the colour will be moved to PictureColourPallette[0]
        */
        if (PictureColourPallette.Length) {
            if ((TColor) PictureColourPallette[0].Colour == Image1->Picture->Bitmap->Canvas->Pixels[0][Image1->Picture->Bitmap->Height-1]) {
                Image1->Picture->Bitmap->Transparent = true;
                Image1->Picture->Bitmap->TransparentMode = tmAuto;
                //Image1->Picture->Bitmap->TransparentColor = (TColor) PictureColourPallette[0].Colour;
                Image1->Transparent = true;
                } else {
                Image1->Picture->Bitmap->Transparent = true;
                Image1->Picture->Bitmap->TransparentMode = tmFixed;
                Image1->Picture->Bitmap->TransparentColor = (TColor) PictureColourPallette[0].Colour;
                Image1->Transparent = true;
                }
            }
        }

    if (!forceConfettiLevel) {
        colourcomplexity Complexity = FindImageComplexity();
        ConfettiLevel = TLowConfetti;
        if (Complexity.maxcolours > 15 || Complexity.average > 7.99) ConfettiLevel = TMediumConfetti;
        if (Complexity.maxcolours > 35 || Complexity.average > 11.99) ConfettiLevel = THighConfetti;
        if (Complexity.maxcolours > 59 || Complexity.average > 17.99) ConfettiLevel = TUnstitchable;
        }

    Screen->Cursor = crDefault;


}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::CountBackStitches(void)
{
    //Add in here the stitch count due to the back stitches
    if (BackStitches.Length) {
        //each back stitch uses 3x its own length of cotton, so for safety sake assume it's the same as a cross stitch.
        double stitchlength;
        double lx, ly;
        int length;
        for (int i = 0; i < BackStitches.Length; i++) {
            lx = BackStitches[i].X2 - BackStitches[i].X1;
            ly = BackStitches[i].Y2 - BackStitches[i].Y1;
            stitchlength = sqrt(lx * lx + ly * ly) + 0.5 /*rounding factor to nearest integer*/;
            length = (int) stitchlength;
            PictureColourPallette[BackStitches[i].ColourNumber].StitchCount += length;
            }
        }
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::AssignAnchorColours(void)
{
    //now to go through and check which colours can be combined for anchor & how many stitches there are.
    //Part 1, copy DMC stitches across and initialise colour to use
    for (int i = 0; i < PictureColourPallette.Length; i++) {
        PictureColourPallette[i].AnchorStitchCount = PictureColourPallette[i].StitchCount;
        PictureColourPallette[i].AnchorColourToUse = i;
        }
    //Part 2, check for same Anchor numbers
    bool found;
    int pointer;
    for (int i = 1; i < PictureColourPallette.Length; i++) {
        found = false;
        pointer = 0;
        while (!found && pointer < i) {
            if ( PictureColourPallette[i].AnchorColourNumber == PictureColourPallette[pointer].AnchorColourNumber) {
                found = true;
                PictureColourPallette[pointer].AnchorStitchCount += PictureColourPallette[i].AnchorStitchCount;
                PictureColourPallette[i].AnchorColourToUse = pointer;
                PictureColourPallette[i].AnchorStitchCount = 0;
                }
            pointer++;
            }
        }
    //part3, decide on the anchor glyphs to use
    pointer = 0;
    for (int i = 0; i < PictureColourPallette.Length; i++) {
        if (PictureColourPallette[i].AnchorColourToUse == i) {
            PictureColourPallette[i].AnchorGlyphToUse = pointer;
            pointer++;
            } else {
            if (PictureColourPallette[i].AnchorColourToUse < i && PictureColourPallette[i].AnchorColourToUse > -1) {
                PictureColourPallette[i].AnchorGlyphToUse = PictureColourPallette[PictureColourPallette[i].AnchorColourToUse].AnchorGlyphToUse;
                }
            }
        }

    //print data
    FillMemo1(found);
    /*
    Memo1->Lines->Clear();
    Label13->Caption = AnsiString(PictureColourPallette.Length);
    for (int i = 0; i < PictureColourPallette.Length; i++) {
        Memo1->Lines->Add(AnsiString (i) + ", DMC "
                            + PictureColourPallette[i].DMCColourNumber + ", "
                            + PictureColourPallette[i].DMCColourName + ", "
                            + AnsiString(PictureColourPallette[i].StitchCount)
                            + (PictureColourPallette[i].StitchCount == 1 ? " Stitch." : " Stitches.")
                            + ((i == 0 && found) ? "  Available as a coloured fabric." : " ")
                            );
        }
    Memo1->SelStart = 0;
    Memo1->SelLength = 0;
    */

    //Now to create the Images for the plotting array
    ImageListCreate();
    Screen->Cursor = crDefault;

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::FormCreate(TObject *Sender)
{
    Application->HelpFile = ChangeFileExt(Application->ExeName, ".hlp");
    Caption = Application->Title;
    PageNumber->ItemIndex = 0;
    inputfile = new TStringList();
    GlyphSize = 1;
    backgroundfilefound = false;
    backgroundcolourfound = false;
    printingbackstitches = false;
    while (StitchCount->Items->Strings[StitchCount->ItemIndex] != "14") {
        StitchCount->ItemIndex++;
        }
    while (PrintCount->Items->Strings[PrintCount->ItemIndex] != "10") {
        PrintCount->ItemIndex++;
        }
    //try to see if there is a printer with 'PDF' in the title, and go to that by default.
    bool found = false;
    int counter = 0;
    while (!found && counter < Printer()->Printers->Count) {
        if (Printer()->Printers->Strings[counter].Pos("PDF") || LeftString(Printer()->Printers->Strings[counter],3).UpperCase() == "PDF") {
            counter--;
            found = true;
            }
        counter++;
        }
    if (found) Printer()->PrinterIndex = counter;

    blendthreads = false;

    //set up to read thread data
    ThreadFileNamePointer = 0;
    ShortThreadName = "DMC";
    ThreadFileNameList = new TStringList();
    ThreadFileNameList->Add(ExtractFileDir(Application->ExeName) + "\\DMCCottonFloss");
    ThreadFileNameList->Add(ExtractFileDir(Application->ExeName) + "\\DMCMonochromeFloss");
    ThreadFileNameList->Add(ExtractFileDir(Application->ExeName) + "\\AnchorFloss");


    FillPrinterData();
    OpenDMCList();
    setsymbols = false;

    //original image
    OriginalImage = new Graphics::TBitmap();
    OriginalImage->Transparent = false;
    OriginalImageFile.loaded = false;
    OriginalImageFile.offsetx = 0;
    OriginalImageFile.offsety = 0;
    OriginalImageFile.scalefactor = 1.0;
    OriginalImageFile.saved = false;
    backstitcheschanged = false;
    PictureChanged = false;

    //setup default Chart Printout settings
    ChartPrintout.FrontSheet = true;
    ChartPrintout.IndexPage = true;
    ChartPrintout.ColourChart = true;
    ChartPrintout.MonochromeChart = true;
    ChartPrintout.DetailedKey = true;
    ChartPrintout.BackStitches = true;
    ChartPrintout.StitchesPerPage = true;
    ChartPrintout.FabricDetails = true;
    ChartPrintout.ChartPageXRef = true;
    ChartPrintout.TitleSize = 20;
    ChartPrintout.ImageCopyrightSize = 12;
    ChartPrintout.ChartCopyrightSize = 12;
    ChartPrintout.TitleFont = "Arial";
    ChartPrintout.ImageCopyrightFont = "Arial";
    ChartPrintout.ChartCopyrightFont = "Arial";
    ChartPrintout.Title = "This Chart";
    ChartPrintout.ImageCopyright = "Image  The Artist";
    ChartPrintout.ChartCopyright = "Chart  The Author";
    ChartPrintout.ChartFont = "Arial";
    ChartPrintout.ChartFontSize = 8;

    OriginalBitmap = new Graphics::TBitmap();

    Conversion.colourspace = 17;
    Conversion.imageheight = Image1->Height;
    Conversion.imagewidth = Image1->Width;
    Conversion.dithersetting = 5;
    Conversion.dither = false;
    Conversion.RGBOverall = 100.0;
    Conversion.R = 100.0;
    Conversion.G = 100.0;
    Conversion.B = 100.0;
    Conversion.HSBOverall = 0.0;
    Conversion.H = 100.0;
    Conversion.S = 100.0;
    Conversion.Br = 100.0;

    UndoStitchOffset.X = 0;
    UndoStitchOffset.Y = 0;

    SortOrder = TTSOStitchCount;

    ConfettiLevel = TLowConfetti;
    forceConfettiLevel = false;

    ReadIniFile();


}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::About1Click(TObject *Sender)
{
    //The about box is clicked
    TAboutBox *AboutBox = new TAboutBox(Application);
    AboutBox->Caption = Application->Title + " - " + VersionDate;
    AboutBox->ShowModal();
    delete AboutBox;

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::OpenDMCList(void)
{
    //This method opens the DMC colour list, and sets up the list as an array
    //The file is in the same directory as the application, and is a CSV file
    //AnsiString FileName = ExtractFileDir(Application->ExeName) + "\\dmc2a.csv";
    AnsiString FileName = ThreadFileNameList->Strings[ThreadFileNamePointer] + ".csv";
    if (FileExists(FileName)) {
        inputfile->LoadFromFile(FileName);
        //interpret file
        //first delete all comment lines
        for (int i = 0; i < inputfile->Count; i++) {
            if (LeftString(inputfile->Strings[i],1) == "#") {
                if (inputfile->Strings[i].Pos("Title=")){
                    ShortThreadName = DeleteWord(inputfile->Strings[i],"=");
                    }
                inputfile->Delete(i);
                i--;
                }
            }
        //now create colour array & fill it
        DMCColourList.Length = inputfile->Count;
        AnsiString text;
        int value;
        rgb RGB;
        hsb HSB;
        for (int i = 0; i < inputfile->Count; i++) {
            text = inputfile->Strings[i];
            text = text + ",";
            //Extract the DMC Colour number. This is a string as 'Ecru' has no numeric meaning!
            DMCColourList[i].DMCColourNumber = ExtractWord(text,",");
            text = DeleteWord(text,",");
            //Extract the DMC Colour Name
            DMCColourList[i].DMCColourName = ExtractWord(text,",");
            text = DeleteWord(text,",");
            DMCColourList[i].DrawWhite = true;
            //Now to decide if the individual colour components exceed 100, if so, draw the
            //glyph in black on the background, otherwise use white
            //The half-way value is 128, but printers tend to print colours a bit light
            //so can go below 128 and still read the black symbol
            value = ExtractWord(text,",").ToIntDef(0);
            DMCColourList[i].R = value;
            if (value > 100) DMCColourList[i].DrawWhite = false;
            text = DeleteWord(text,",");
            value = ExtractWord(text,",").ToIntDef(0);
            DMCColourList[i].G = value;
            if (value > 100) DMCColourList[i].DrawWhite = false;
            text = DeleteWord(text,",");
            value = ExtractWord(text,",").ToIntDef(0);
            DMCColourList[i].B = value;
            if (value > 100) DMCColourList[i].DrawWhite = false;
            /*value = ExtractWord(text,",").ToIntDef(0);
            if (value > 100) DMCColourList[i].DrawWhite = false;
            text = DeleteWord(text,",");
            value = ExtractWord(text,",").ToIntDef(0);
            if (value > 100) DMCColourList[i].DrawWhite = false;
            text = DeleteWord(text,",");
            value = ExtractWord(text,",").ToIntDef(0);
            if (value > 100) DMCColourList[i].DrawWhite = false;*/
            text = DeleteWord(text,",");
            DMCColourList[i].Colour = (TColor) ExtractWord(text,",").ToIntDef(0);
            text = DeleteWord(text,",");
            DMCColourList[i].StitchCount = 0;
            DMCColourList[i].AnchorColourNumber = ExtractWord(text,",");
            DMCColourList[i].AnchorColourToUse = 0;
            DMCColourList[i].AnchorStitchCount = 0;
            RGB.R = DMCColourList[i].R;
            RGB.G = DMCColourList[i].G;
            RGB.B = DMCColourList[i].B;
            HSB = RGBtoHSB(RGB);
            DMCColourList[i].Hue = HSB.Hue;
            DMCColourList[i].Saturation = HSB.Saturation;
            DMCColourList[i].Brightness = HSB.Brightness;
            }
        //finish interpretation
        inputfile->Clear();
        } else {
        //Application->MessageBox("DMC List (dmc2a.csv) not found in the application directory","Error",MB_ICONERROR|IDOK);
        AnsiString temp = "Thread Colour List (" + FileName + ") not found in the application directory";
        Application->MessageBox(temp.c_str(),"Error",MB_ICONERROR|IDOK);
        Open1->Enabled = false;
        }

    FileName = ExtractFileDir(Application->ExeName) + "\\background.csv";
    //FileName = ThreadFileNameList->Strings[ThreadFileNamePointer] + "Blend.csv";
    if (FileExists(FileName)) {
        inputfile->LoadFromFile(FileName);
        //interpret file
        //first delete all comment lines
        for (int i = 0; i < inputfile->Count; i++) {
            if (LeftString(inputfile->Strings[i],1) == "#") {
                inputfile->Delete(i);
                i--;
                }
            }
        //now create colour array & fill it
        BackgroundList.Length = inputfile->Count;
        AnsiString text;
        int value;
        for (int i = 0; i < inputfile->Count; i++) {
            //debug
            try {
            //end debug
            text = inputfile->Strings[i];
            text = text + ",";
            //Extract the DMC Colour number. This is a string as 'Ecru' has no numeric meaning!
            BackgroundList[i].DMCColourNumber = ExtractWord(text,",");
            text = DeleteWord(text,",");
            //Extract the DMC Colour Name
            BackgroundList[i].DMCColourName = ExtractWord(text,",");
            text = DeleteWord(text,",");
            BackgroundList[i].DrawWhite = true;
            //Now to decide if the individual colour components exceed 100, if so, draw the
            //glyph in black on the background, otherwise use white
            //The half-way value is 128, but printers tend to print colours a bit light
            //so can go below 128 and still read the black symbol
            value = ExtractWord(text,",").ToIntDef(0);
            if (value > 100) BackgroundList[i].DrawWhite = false;
            text = DeleteWord(text,",");
            value = ExtractWord(text,",").ToIntDef(0);
            if (value > 100) BackgroundList[i].DrawWhite = false;
            text = DeleteWord(text,",");
            value = ExtractWord(text,",").ToIntDef(0);
            if (value > 100) BackgroundList[i].DrawWhite = false;
            text = DeleteWord(text,",");
            //BackgroundList[i].Colour = (TColor) text.ToIntDef(0);
            BackgroundList[i].Colour = (TColor) ExtractWord(text,",").ToIntDef(0);
            text = DeleteWord(text,",");
            BackgroundList[i].StitchCount = 0;
            BackgroundList[i].AnchorColourNumber = ExtractWord(text,",");
            BackgroundList[i].AnchorColourToUse = 0;
            BackgroundList[i].AnchorStitchCount = 0;
            //debug
                }
            catch (...) {
                AnsiString temp = "i = " + AnsiString(i) + "\nLine = " + inputfile->Strings[i] + "\nText = " + text;
                temp += "\nFileName = " + FileName;
                temp += "\nThreadFileNamePointer = " + AnsiString(ThreadFileNamePointer);
                Application->MessageBox(temp.c_str(),"Background Error",IDOK);
                }
            }
        //finish interpretation
        inputfile->Clear();

        } else {
        Application->MessageBox("Background Fabric Colour List (background.csv) not found in the application directory","Error",MB_ICONERROR|IDOK);
        backgroundfilefound = false;
        }

    //FileName = ExtractFileDir(Application->ExeName) + "\\BlendColours.csv";
    FileName = ThreadFileNameList->Strings[ThreadFileNamePointer] + "Blend.csv";
    //reset tweed list
    for (int i = 0; i < TweedList.Length; i++) {
        TweedList[i].ColourPairs.Length = 0;
        }
    TweedList.Length = 0;

    if (FileExists(FileName)) {
        inputfile->LoadFromFile(FileName);
        //interpret file
        //first delete all comment lines
        for (int i = 0; i < inputfile->Count; i++) {
            if (LeftString(inputfile->Strings[i],1) == "#") {
                inputfile->Delete(i);
                i--;
                }
            }
        //now create colour array & fill it
        TweedList.Length = inputfile->Count;
        AnsiString text;
        int value;
        rgb RGB;
        hsb HSB;
        for (int i = 0; i < inputfile->Count; i++) {
            //debug
            try {
            //AnsiString debugtext = inputfile->Strings[i];
            //end debug
            text = inputfile->Strings[i];
            //text = text + ",";
            //Extract the DMC Colour numbers used for this Tweed. This is a string as 'Ecru+918' has no numeric meaning!
            TweedList[i].Data.DMCColourNumber = ExtractWord(text,",");
            text = DeleteWord(text,",");
            //Extract the DMC Colour Name
            //TweedList[i].Data.DMCColourName = ExtractWord(text,",");
            text = DeleteWord(text,",");
            TweedList[i].Data.DrawWhite = true;
            //Now to decide if the individual colour components exceed 100, if so, draw the
            //glyph in black on the background, otherwise use white
            //The half-way value is 128, but printers tend to print colours a bit light
            //so can go below 128 and still read the black symbol
            value = ExtractWord(text,",").ToIntDef(0);
            TweedList[i].Data.R = value;
            if (value > 100) TweedList[i].Data.DrawWhite = false;
            text = DeleteWord(text,",");
            value = ExtractWord(text,",").ToIntDef(0);
            TweedList[i].Data.G = value;
            if (value > 100) TweedList[i].Data.DrawWhite = false;
            text = DeleteWord(text,",");
            value = ExtractWord(text,",").ToIntDef(0);
            TweedList[i].Data.B = value;
            if (value > 100) TweedList[i].Data.DrawWhite = false;
            text = DeleteWord(text,",");
            //BackgroundList[i].Colour = (TColor) text.ToIntDef(0);
            TweedList[i].Data.Colour = (TColor) ExtractWord(text,",").ToIntDef(0);
            text = DeleteWord(text,",");
            TweedList[i].Data.StitchCount = 0;
            TweedList[i].Data.AnchorColourNumber = "";
            TweedList[i].Data.AnchorColourToUse = 0;
            TweedList[i].Data.AnchorStitchCount = 0;
            RGB.R = TweedList[i].Data.R;
            RGB.G = TweedList[i].Data.G;
            RGB.B = TweedList[i].Data.B;
            HSB = RGBtoHSB(RGB);
            TweedList[i].Data.Hue = HSB.Hue;
            TweedList[i].Data.Saturation = HSB.Saturation;
            TweedList[i].Data.Brightness = HSB.Brightness;
            //now to load in the cross references
            while (text.Length()) {
                TweedList[i].ColourPairs.Length++;
                value = ExtractWord(text,",").ToIntDef(0);
                TweedList[i].ColourPairs[TweedList[i].ColourPairs.Length - 1].x = value;
                text = DeleteWord(text,",");
                value = ExtractWord(text,",").ToIntDef(0);
                TweedList[i].ColourPairs[TweedList[i].ColourPairs.Length - 1].y = value;
                text = DeleteWord(text,",");
                }
            //Now to change the title a bit from that in the BlendColours list.
            AnsiString temp = "Blend ";
            for (int k = 0; k < TweedList[i].ColourPairs.Length; k++) {
                //debug
                //int limit = TweedList[i].ColourPairs.Length;
                if (k > 0) temp = temp + " or ";
                temp = temp + DMCColourList[TweedList[i].ColourPairs[k].x].DMCColourNumber + " + " + DMCColourList[TweedList[i].ColourPairs[k].y].DMCColourNumber;
                }
            TweedList[i].Data.DMCColourName = temp;
            //debug
                }
            catch (...) {
                AnsiString temp = "i = " + AnsiString(i) + "\nLine = " + inputfile->Strings[i] + "\nText = " + text;
                temp += "\nFileName = " + FileName;
                temp += "\nThreadFileNamePointer = " + AnsiString(ThreadFileNamePointer);
                Application->MessageBox(temp.c_str(),"Blend Error",IDOK);
                }
            }
        //finish interpretation
        inputfile->Clear();

        } else {
        //Application->MessageBox("List of Blending Colours (BlendColours.csv) not found in the application directory","Error",MB_ICONERROR|IDOK);
        AnsiString temp = "ist of Blending Colours (" + FileName + ") not found in the application directory";
        Application->MessageBox(temp.c_str(),"Error",MB_ICONERROR|IDOK);
        }

    ReadSymbolToGlyphXRef();

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::ReadSymbolToGlyphXRef(void)
{
    //read symboltoglyphxref
    AnsiString FileName = ExtractFileDir(Application->ExeName) + "\\SymbolToGlyphXRef.csv";
    SymboltoGlyphXRef.Length = 1000;
    for (int i = 0; i < SymboltoGlyphXRef.Length; i++) {
        SymboltoGlyphXRef[i] = i;
        }
    if (FileExists(FileName)) {
        //wipes out specific symbol allocation if previous chart had it
        setsymbols = false;
        inputfile->LoadFromFile(FileName);
        //interpret file
        //first delete all comment lines
        for (int i = 0; i < inputfile->Count; i++) {
            if (LeftString(inputfile->Strings[i],1) == "#") {
                inputfile->Delete(i);
                i--;
                }
            }
        //now create colour array & fill it
        AnsiString text;
        int value,arrayentry;
        for (int i = 0; i < inputfile->Count; i++) {
            text = inputfile->Strings[i];
            text = text + ",";
            //Extract the symbol number
            arrayentry = ExtractWord(text,",").ToIntDef(0);
            text = DeleteWord(text,",");
            //Extract the glyph number
            value = ExtractWord(text,",").ToIntDef(arrayentry);
            if (arrayentry < SymboltoGlyphXRef.Length) SymboltoGlyphXRef[arrayentry] = value;
            }
        //finish interpretation
        inputfile->Clear();

        }

}
//---------------------------------------------------------------------------


void __fastcall TPlanForm::FormDestroy(TObject *Sender)
{
    //Get rid of all un-needed data
    delete inputfile;
    delete ThreadFileNameList;
    DMCColourList.Length = 0;
    PictureColourPallette.Length = 0;
    BackgroundList.Length = 0;
    BackStitches.Length = 0;
    OriginalImage->FreeImage();
    OriginalBitmap->FreeImage();
    delete OriginalImage;
    delete OriginalBitmap;
    for (int i = 0; i < TweedList.Length; i++) {
        TweedList[i].ColourPairs.Length = 0;
        }
    TweedList.Length = 0;
    BlendReference.Length = 0;
    SymboltoGlyphXRef.Length = 0;
    //delete all menuitems created on the fly
    while (Range1->Count > 3) {
        Range1->Delete(3);
        }
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::StitchCountChange(TObject *Sender)
{
    //FillPictureData();
    ShowPictureSize();
    backstitcheschanged = true;
}
//---------------------------------------------------------------------------

double __fastcall TPlanForm::ROUND(double value)
{
    double result;
    if (floor(value) == floor(value + 0.5)) {
        result = floor(value);
        } else {
        result = floor(value + 0.5);
        }
    return result;

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::Image1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if (Button == mbLeft) {
        //debug method, however it's so visually interesting I've left it in
        Label14->Visible = true;
        Label15->Visible = true;
        Label16->Visible = true;
        Label17->Visible = true;
        Label18->Visible = true;
        Label19->Visible = true;
        Label15->Caption = AnsiString(Image1->Canvas->Pixels[X][Y]);
        Label17->Caption = AnsiString(X);
        Label19->Caption = AnsiString(Y);
        Graphics::TBitmap *Picture = new Graphics::TBitmap;
        Picture->Height = GlyphSize;
        Picture->Width = GlyphSize;
        Image3->Height = GlyphSize;
        Image3->Width = GlyphSize;
        Image3->Picture->Bitmap->Width = GlyphSize;
        Image3->Picture->Bitmap->Height = GlyphSize;
        for (int i = 0; i < PictureColourPallette.Length; i++) {
            if (Image1->Canvas->Pixels[X][Y] == PictureColourPallette[i].Colour) {
                DrawGlyph(Image3->Canvas,0,0,GlyphSize, i, false);
                //Label22->Caption = "DMC Colour# = " + PictureColourPallette[i].DMCColourNumber;
                //Label23->Caption = "DMC Name = " + PictureColourPallette[i].DMCColourName;
                Label22->Caption = ShortThreadName + " Colour# = " + PictureColourPallette[i].DMCColourNumber;
                Label23->Caption = ShortThreadName + " Name = " + PictureColourPallette[i].DMCColourName;
                Label24->Caption = "Stitch Count = " + AnsiString(PictureColourPallette[i].StitchCount);
                Label21->Caption = "Chart Key# = " + AnsiString(i);
                }
            }
        delete Picture;
        }

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::ImageListCreate(void)
{
    if (PictureColourPallette.Length > 600) {
        Application->MessageBox("Too many colours, cannot create full pattern.\nThe first 600 colours will have symbols","Warning",MB_ICONERROR|IDOK);
        }

    printingbackstitches = false;

    //Now to get the pictures per inch
    int PictureSize = (int) ((double)(Printer()->Canvas->TextWidth("Hi There")) * 25.4/ ((double)PrintCount->Items->Strings[PrintCount->ItemIndex].ToIntDef(1) * 13.34));
    GlyphSize = PictureSize;

        Image2->Height = PictureSize;
        Image2->Width = PictureSize * PictureColourPallette.Length;
        Image2->Picture->Bitmap->Height = PictureSize;
        Image2->Picture->Bitmap->Width = PictureSize * PictureColourPallette.Length;
        for(int i = 0; i < PictureColourPallette.Length; i++) {
            DrawGlyph(Image2->Canvas,i * PictureSize,0,GlyphSize, i, false);
            }

    if (PictureColourPallette.Length) {
        Label5->Caption = AnsiString(Image1->Height * Image1->Width - (Background->Checked ? 0 : PictureColourPallette[0].StitchCount));
        } else {
        Label5->Caption = "";
        }

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::PrintCountChange(TObject *Sender)
{
    ImageListCreate();
    FillPrinterData();
    backstitcheschanged = true;
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::BackgroundClick(TObject *Sender)
{
    if (PictureColourPallette.Length) {
        SortThreads();
        bool found = SelectBackground();
        FillMemo1(found);
        Image1->Picture->Bitmap->TransparentColor = PictureColourPallette[0].Colour;
        Image1->Transparent = !Background->Checked;
        Label5->Caption = AnsiString(Image1->Height * Image1->Width - (Background->Checked ? 0 : PictureColourPallette[0].StitchCount));
        }
    Image1->Transparent = !Background->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::DrawGlyph(TCanvas *Canvas,int X, int Y, int PictureSize, int i, bool PlotEdge)
{
    TColor PenColour, BrushColour;
    if (PictureColourPallette[i].DrawWhite && PrintColour->Checked) {
        PenColour = clWhite;
        } else {
        if (printingbackstitches) {
            PenColour = clGray;
            } else {
            PenColour = clBlack;
            }
        }
    if (PrintColour->Checked) {
        if (printingbackstitches) {
            int Red;
            int Green;
            int Blue;
            Blue = (int)(((int)PictureColourPallette[i].Colour) / (256 * 256));
            Green = (int)(((int)PictureColourPallette[i].Colour - Blue * 256 * 256)/256);
            Red = (int)PictureColourPallette[i].Colour - Blue * 256 * 256 - Green *256;
            Blue = ((Blue - 128)/4) + 224;
            Green = ((Green - 128)/4) + 224;
            Red = ((Red - 128)/4) + 224;
            int ModifiedColour = Blue * 256 * 256 + Green * 256 + Red;
            BrushColour = (TColor) (ModifiedColour);
            } else {
            BrushColour = PictureColourPallette[i].Colour;
            }
        } else {
        BrushColour = clWhite;
        }

    //allows for symbol substitution
    if (i < SymboltoGlyphXRef.Length) {
        //DrawGlyph2(Canvas,X,Y,PictureSize,SymboltoGlyphXRef[i],i,PlotEdge);
        DrawGlyph2(Canvas,X,Y,PictureSize,SymboltoGlyphXRef[i],PlotEdge,PenColour,BrushColour);
        } else {
        //DrawGlyph2(Canvas,X,Y,PictureSize,i,i,PlotEdge);
        DrawGlyph2(Canvas,X,Y,PictureSize,i,PlotEdge,PenColour,BrushColour);
        }
}
//---------------------------------------------------------------------------

//void __fastcall TPlanForm::DrawGlyph2(TCanvas *Canvas,int X, int Y, int PictureSize, int glyphno, int i, bool PlotEdge)
void __fastcall TPlanForm::DrawGlyph2(TCanvas *Canvas,int X, int Y, int PictureSize, int glyphno, bool PlotEdge, TColor PenColour, TColor BrushColour)
{
    //this routine does all the hard work of producing the glyph.
    //The size & location is variable, so that it can be positioned anywhere on a Canvas
    //Also, with this method, it's possible to change the canvas it's drawn on, and
    //so is not limited to the printer.

    //Canvas = Canvas used to plot on
    //X,Y = location on canvas
    //PictureSize = Size of glyph
    //glyphno = glyph number to be plotted
    //i = number of Picture Colour Pallette array to be plotted
    //PlotEdge = plot the boundary around the glyph
    //PenColour = Colour of Lines
    //BrushColour = Colour of Background
    TBrush *Brush = new TBrush;
    TPen *Pen = new TPen;
    Brush->Color = Canvas->Brush->Color;
    Brush->Style = Canvas->Brush->Style;
    Pen->Color = Canvas->Pen->Color;
    Pen->Style = Canvas->Pen->Style;
    Pen->Width = Canvas->Pen->Width;
            //Fill the background with the current colour or white if not printing in colour
            /*
            if (PrintColour->Checked) {
                if (printingbackstitches) {
                    int Red;
                    int Green;
                    int Blue;
                    Blue = (int)(((int)PictureColourPallette[i].Colour) / (256 * 256));
                    Green = (int)(((int)PictureColourPallette[i].Colour - Blue * 256 * 256)/256);
                    Red = (int)PictureColourPallette[i].Colour - Blue * 256 * 256 - Green *256;
                    //Blue = ((Blue - 128)/2) + 192;
                    //Green = ((Green - 128)/2) + 192;
                    //Red = ((Red - 128)/2) + 192;
                    Blue = ((Blue - 128)/4) + 224;
                    Green = ((Green - 128)/4) + 224;
                    Red = ((Red - 128)/4) + 224;
                    int ModifiedColour = Blue * 256 * 256 + Green * 256 + Red;
                    Canvas->Brush->Color = (TColor) ModifiedColour;
                    } else {
                    Canvas->Brush->Color = PictureColourPallette[i].Colour;
                    }
                } else {
                Canvas->Brush->Color = clWhite;
                }
            */
            Canvas->Brush->Color = BrushColour;
            Canvas->FillRect(Rect(X,Y,X + PictureSize,Y + PictureSize));
            //draw the intermediate lines on the top & left edges in light grey
            if (PlotEdge) {
                Canvas->Pen->Color = clSilver;
                Canvas->Pen->Mode = pmCopy;
                Canvas->Pen->Style = psSolid;
                Canvas->Pen->Width = PictureSize/10;
                Canvas->MoveTo(X,Y + PictureSize-1);
                Canvas->LineTo(X,Y);
                Canvas->LineTo(X + PictureSize-1,Y);
                Canvas->Pen->Width = 1;
                }

            //Now to draw the symbol
            //first thing, choose the symbol colour which is dependant on background
            //brightness
            /*
            if (PictureColourPallette[i].DrawWhite && PrintColour->Checked) {
                Canvas->Pen->Color = clWhite;
                Canvas->Brush->Color = clWhite;
                } else {
                if (printingbackstitches) {
                    Canvas->Pen->Color = clGray;
                    Canvas->Brush->Color = clGray;
                    } else {
                    Canvas->Pen->Color = clBlack;
                    Canvas->Brush->Color = clBlack;
                    }
                }
            */
            Canvas->Pen->Color = PenColour;
            Canvas->Brush->Color = PenColour;

            //now draw the symbol's shape on the symbol area
            switch (glyphno) {
                case 1: {
                        //simple circle
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 9: {
                        //Full CG symbol
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + PictureSize/2,Y + PictureSize,X + PictureSize,Y + PictureSize/2);
                        }
                case 8: {
                        //Part CG symbol
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + PictureSize/2,Y + 0,X + 0,Y + PictureSize/2);
                        }
                case 2: {
                        //simple hollow circle
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 5: {
                        //Fills in the top of the hourglass
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize/2,Y + PictureSize/2);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        }
                case 4: {
                        //Turns the cross into an hourglass
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        }
                case 3: {
                        //simple cross
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 7: {
                        //percent symbol
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        }
                case 6: {
                        //diagonal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 10:{
                        //Circle bottom filled
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + 0,Y + PictureSize/2,X + PictureSize,Y + PictureSize/2);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 15:{
                        //fill bottom right to result in a filled square CG symbol
                        Canvas->Rectangle(X + PictureSize /2,Y + PictureSize /2,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        }
                case 14:{
                        //fill top left
                        Canvas->Rectangle(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize /2,Y + PictureSize /2);
                        }
                case 13:{
                        //turn square into cross window frame
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize /2,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize /2,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                case 12:{
                        //turn square into horizontal window frame
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize /2);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize /2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                case 11:{
                        //square
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Rectangle(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 16:{
                        //Thick Diagonal
                        Canvas->Pen->Width = PictureSize*4/20;
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 0: {
                        //Plus Sign
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = 1;
                        }
                case 78:{
                        //Stick
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        }
                case 17:{
                        //Horizontal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize /2);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize /2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 30:{
                        //Christmas tree
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        }
                case 29:{
                        //up arrow
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        }
                case 18:{
                        //Vertical Line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize /2,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize /2,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 23:{
                        //Corner triangle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        }
                case 19:{
                        //L shape
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 21:{
                        //Fills in the diagonal arrow
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        }
                case 20:{
                        //Diagonal arrow
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 22:{
                        //Top corner flag
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 28:{
                        //Five circles
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        }
                case 27:{
                        //Four circles
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        }
                case 25:{
                        //two circles
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        }
                case 24:{
                        //one circle
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 26:{
                        //three circles
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 3/10,X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 31:{
                        //up & down arrow
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 34:{
                        //cross on Z
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        }
                case 33:{
                        //finish Z
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        }
                case 32:{
                        //part Z
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 37:{
                        //flag thingy filled in
                        TPoint points[6];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[3] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[4] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[5] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 5);
                        }
                case 36:{
                        //Flag thingy
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        }
                case 35:{
                        //M
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 38:{
                        //Backwards C
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 42:{
                        //zigzag with cross bar
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        }
                case 41:{
                        //Backwards full F
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        }
                case 40:{
                        //Backwards F
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        }
                case 39:{
                        //1
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 43:{
                        //Exclamation mark
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 6/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 45:{
                        //4 dots, 2 horizontal lines
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *3/10);
                        }
                case 44:{
                        //4 dots, 1 horizontal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *7/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 47:{
                        //4 dots, 2 diagonal lines
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *7/10);
                        }
                case 46:{
                        //4 dots, 1 diagonal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *3/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 49:{
                        //2 dots, 1 diagonal line
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        }
                case 48:{
                        //1 dot, 1 diagonal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *7/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 52:{
                        //filled in A
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 7/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 51:{
                        //A
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *5/10);
                        }
                case 50:{
                        //caret
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 54:{
                        //mountain with trees
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 3/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 3);
                        }
                case 53:{
                        //mountain
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 55:{
                        //squared U
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 56:{
                        //2 circles
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 2/10,X + PictureSize * 7/10,Y + PictureSize * 5/10);
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 5/10,X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        }
                        break;
                case 57:{
                        //2 circles, lower one filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 2/10,X + PictureSize * 7/10,Y + PictureSize * 5/10);
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 5/10,X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 58:{
                        //2 circles, concentric
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        }
                        break;
                case 59:{
                        //2 circles, concentric, one filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 61:{
                        //filled flag
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 60:{
                        //single flag
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 63:{
                        //double filled flag
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        }
                case 62:{
                        //double flag
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 67:{
                        //slashed Dollar
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                case 68:{
                        //double filled dollar
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 66:{
                        //single top filled dollar
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 65:{
                        //Dollar
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                case 64:{
                        //S
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 72:{
                        //double filled dumbel S
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 4/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 71:{
                        //single bottom filled dumbel S
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 70:{
                        //Diamond Dumbel S
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                case 69:{
                        //Diamond Dumbel S
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 75:{
                        //Double triangle, both filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 74:{
                        //Double triangle, lower filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                 case 73:{
                        //Double triangle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 77:{
                        //Double triangle, lower filled
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 3);
                        }
                case 76:{
                        //Treble triangle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 82:{
                        //Right point triangle, filled in
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 81:{
                        //Right point triangle, top filled in
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 80:{
                        //Right point triangle with horizontal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        }
                case 79:{
                        //Right point triangle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 85:{
                        //Left Pennant, filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 84:{
                        //Left Pennant, top filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 83:{
                        //Left Pennant
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 87:{
                        //I crossed
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        }
                case 86:{
                        //I
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 91:{
                        //Bottom point triangle, filled in
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 90:{
                        //Bottom point triangle, left filled in
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 89:{
                        //Bottom point triangle with vertical line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        }
                case 88:{
                        //Bottom point triangle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 94:{
                        //Top Pennant, filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 93:{
                        //Top Pennant, left filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 92:{
                        //Top Pennant
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 98:{
                        //Upsidedown T double tagged
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        }
                case 96:{
                        //Upsidedown T right tagged
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        }
                case 95:{
                        //Upsidedown T
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 99:{
                        //Upsidedown T, tags filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 97:{
                        //Upsidedown T, right tag filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 100: {
                        //face
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Ellipse(X + PictureSize * 25/100,Y + PictureSize * 25/100,X + PictureSize * 45/100,Y + PictureSize * 45/100);
                        Canvas->Ellipse(X + PictureSize * 55/100,Y + PictureSize * 25/100,X + PictureSize * 75/100,Y + PictureSize * 45/100);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *6/10);
                        }
                        break;
                case 102:{
                        //upsidedown Christmas tree
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        }
                case 101:{
                        //down arrow
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 104: {
                        //right tree
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        }
                case 103: {
                        //right arrow
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 106: {
                        //right tree
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        }
                case 105: {
                        //right arrow
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 107:{
                        //Top right corner flag
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 108:{
                        //top right Corner triangle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 109:{
                        //bottom right corner flag
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 110:{
                        //bottom right Corner triangle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 111:{
                        //bottom left corner flag
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 112:{
                        //bottom left Corner triangle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 113:{
                        //Fills in the top right diagonal arrow
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        }
                case 114:{
                        //top right Diagonal arrow
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 115:{
                        //Fills in the bottom left diagonal arrow
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        }
                case 116:{
                        //bottom left Diagonal arrow
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 117:{
                        //Fills in the bottom right diagonal arrow
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        }
                case 118:{
                        //bottom left Diagonal arrow
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 119:{
                        //cross on backwards Z
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        }
                case 120:{
                        //finish backwards Z
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        }
                case 121:{
                        //part backwards Z
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 122:{
                        //upsidedown M
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 123:{
                        //left M
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 124:{
                        //right M
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 125:{
                        //vertical version of 36
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 126:{
                        //vertical version of 37
                        TPoint points[6];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[4] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[5] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 5);
                        }
                case 127:{
                        // C
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 128:{
                        // 127 rot 90
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 129:{
                        // 128 + horizontal mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 130:{
                        //F
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        }
                case 131:{
                        //39 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 132:{
                        //131 + horiz mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 133:{
                        //132 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 134:{
                        //43 + horiz mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 135:{
                        //134 + 90 deg rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 136:{
                        //135 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 4/10,Y + PictureSize * 6/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 137:{
                        //4 dots, 1 horizontal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *3/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 138:{
                        //4 dots, 1 vertical line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *7/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 139:{
                        //4 dots, 1 vertical line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *7/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 140:{
                        //4 dots, 1 vertical line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *7/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 141:{
                        //4 dots, 1 diagonal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *7/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 142:{
                        //2 dots, 1 diagonal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *7/10);
                        //Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        //Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 143:{
                        //1 dot, 1 diagonal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *7/10);
                        //Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        //Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        //Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 144:{
                        //1 dot, 1 diagonal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *7/10);
                        //Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        //Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 145:{
                        //1 dot, 1 diagonal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *7/10);
                        //Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        //Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 146:{
                        //52 + horiz mirror
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 7/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 147:{
                        //51 + horiz mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *5/10);
                        }
                case 148:{
                        //50 + horiz mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 149:{
                        //146 + 90 deg rot
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 7/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 150:{
                        //147 + 90 deg rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *7/10);
                        }
                case 151:{
                        //148 + 90 deg rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 152:{
                        //149 + vert mirror
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 7/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 153:{
                        //150 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *7/10);
                        }
                case 154:{
                        //151 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 155:{
                        //54 + vert mirror
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 3/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 3);
                        }
                case 156:{
                        //53 + horiz mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 157:{
                        //155 + rot 90
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 7/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 3);
                        }
                case 158:{
                        //156 + rot 90
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 159:{
                        //157 + vert mirror
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 7/10);
                        points[3] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 3);
                        }
                case 160:{
                        //158 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 161: {
                        //55 + 90 rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 162: {
                        //161 + 90 rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 163: {
                        //162 + 90 rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 164:{
                        //2 circles, upper one filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 2/10,X + PictureSize * 7/10,Y + PictureSize * 5/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 5/10,X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 165:{
                        //2 circles, both filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 2/10,X + PictureSize * 7/10,Y + PictureSize * 5/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 5/10,X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 166:{
                        //2 circles next to each other, neither filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 3/10,X + PictureSize * 5/10,Y + PictureSize * 7/10);
                        Canvas->Ellipse(X + PictureSize * 5/10,Y + PictureSize * 3/10,X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 167:{
                        //2 circles next to each other, left filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 3/10,X + PictureSize * 5/10,Y + PictureSize * 7/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 5/10,Y + PictureSize * 3/10,X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 168:{
                        //2 circles next to each other, Right filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 3/10,X + PictureSize * 5/10,Y + PictureSize * 7/10);
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Ellipse(X + PictureSize * 5/10,Y + PictureSize * 3/10,X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 169:{
                        //2 circles next to each other, both filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 3/10,X + PictureSize * 5/10,Y + PictureSize * 7/10);
                        Canvas->Ellipse(X + PictureSize * 5/10,Y + PictureSize * 3/10,X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 170:{
                        //Greek Key
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 171:{
                        //170 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 172:{
                        //170 + horiz mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 173:{
                        //172 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 174:{
                        //170 + 90 deg rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                 case 175:{
                        //174 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 176:{
                        //174 + horiz mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 177:{
                        //176 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 178:{
                        //61 + horiz mirror
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 179:{
                        //60 + horiz mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 180:{
                        //61 + vert mirror
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 181:{
                        //60 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 182:{
                        //180 + horiz mirror
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 183:{
                        //181 + horiz mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 184:{
                        //horiz flag up right, filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 185:{
                        //horizontal flag up right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 186:{
                        //horiz flag down right, filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 187:{
                        //horizontal flag down right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 188:{
                        //horiz flag up left, filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 189:{
                        //horizontal flag up left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 190:{
                        //horiz flag down left, filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 191:{
                        //horizontal flag down left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 192:{
                        //partial cross upper left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 193:{
                        //partial cross lower right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 194:{
                        //partial cross upper right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 195:{
                        //partial cross lower left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 196:{
                        //partial plus upper
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 197:{
                        //partial plus left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 198:{
                        //partial plus left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 199:{
                        //left point triangle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        }
                case 200:{
                        //left point triangle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 201:{
                        //left point triangle, top half filled
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 202:{
                        //left point triangle, bottom half filled
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 203:{
                        //left point triangle, filled
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 204:{
                        //up point triangle with line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        }
                case 205:{
                        //up point triangle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 206:{
                        //up point triangle, left half filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 207:{
                        //up point triangle, right half filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 208:{
                        //up point triangle, filled
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Pen->Width = 1;
                        Canvas->Polygon(points, 2);
                        }
                        break;
                case 209:{
                        //right point triangle, bottom half filled
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 210:{
                        //down point triangle, right half filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 211:{
                        //left version of 84
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 212:{
                        //left version of 83
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 213:{
                        //211, bottom filled instead
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 214:{
                        //211, filled instead
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 215:{
                        //211 + 90 deg rot
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 216:{
                        //212 + 90 rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 217:{
                        //213 + 90 rot, bottom filled instead
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 218:{
                        //216, filled instead
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 219:{
                        //as 84, only bottom filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 220:{
                        //as 93, but right filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 224:{
                        //as 221 with both arrows filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 222:{
                        //as 221 with left arrow filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 221:{
                        //horizontal central pointing arrows
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 223:{
                        //as 221, right arrow filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 228:{
                        //224 + 90 deg rot
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 226:{
                        //222 + 90 deg rot
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 225:{
                        //221 + 90 deg rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 227:{
                        //223 + 90 deg rot
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 229:{
                        //horizontal right arrow left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 230:{
                        //horizontal right arrow mid
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 231:{
                        //horizontal right arrow right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 232:{
                        //horizontal right arrow left mid
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 233:{
                        //horizontal right arrow left right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 234:{
                        //horizontal right arrow mid right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 235:{
                        //horizontal right arrow left mid right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 236:{
                        //horizontal right arrow left filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 237:{
                        //horizontal right arrow mid filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 238:{
                        //horizontal right arrow right filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 239:{
                        //horizontal right arrow left mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 240:{
                        //horizontal right arrow left right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 241:{
                        //horizontal right arrow mid right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 242:{
                        //horizontal right arrow left mid right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 243:{
                        //horizontal right arrow left mid, left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 244:{
                        //horizontal right arrow left mid, right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 245:{
                        //horizontal right arrow left right, left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        //Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 246:{
                        //horizontal right arrow left right, right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 247:{
                        //horizontal right arrow mid right, mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 248:{
                        //horizontal right arrow mid right, right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 249:{
                        //horizontal right arrow left mid right, left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 250:{
                        //horizontal right arrow left mid right, mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 251:{
                        //horizontal right arrow left mid right, right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 252:{
                        //horizontal right arrow left mid right, left mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 253:{
                        //horizontal right arrow left mid right, left right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 254:{
                        //horizontal right arrow left mid right, mid right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 255:{
                        //left arrows, left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 256:{
                        //left arrows, mid
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 257:{
                        //left arrows, right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 258:{
                        //left arrows, left mid
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 259:{
                        //left arrows, left right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 260:{
                        //left arrows, mid right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 261:{
                        //left arrows, left mid right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 262:{
                        //left arrows, left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 263:{
                        //left arrows, mid  filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 264:{
                        //left arrows, right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 265:{
                        //left arrows, left mid, left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 266:{
                        //left arrows, left mid, mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 267:{
                        //left arrows, left mid, both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 268:{
                        //left arrows, left right, left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 269:{
                        //left arrows, left right, right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 270:{
                        //left arrows, left right, both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 271:{
                        //left arrows, mid right, mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 272:{
                        //left arrows, mid right, right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 273:{
                        //left arrows, mid right, both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 274:{
                        //left arrows, left mid right, left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 275:{
                        //left arrows, left mid right, mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 276:{
                        //left arrows, left mid right, right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 277:{
                        //left arrows, left mid right, left mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 278:{
                        //left arrows, left mid right, left right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 279:{
                        //left arrows, left mid right, mid right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 280:{
                        //left arrows, left mid right, all filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 281:{
                        //up arrows, top ,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 282:{
                        //up arrows, mid ,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 283:{
                        //up arrows, bot ,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 284:{
                        //up arrows, top mid,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 285:{
                        //up arrows, top bot,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 286:{
                        //up arrows, mid bot,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 287:{
                        //up arrows, top mid bot,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 288:{
                        //up arrows, top , top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 289:{
                        //up arrows, mid , mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 290:{
                        //up arrows, bot , bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 291:{
                        //up arrows, top mid , top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 292:{
                        //up arrows, top mid , mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                         Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 293:{
                        //up arrows, top mid , both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 294:{
                        //up arrows, top bot , top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 295:{
                        //up arrows, top bot , bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 296:{
                        //up arrows, top bot , both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 297:{
                        //up arrows, mid bot , mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 298:{
                        //up arrows, mid bot , bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 299:{
                        //up arrows, mid bot , both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 300:{
                        //up arrows, top mid bot , top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 301:{
                        //up arrows, top mid bot , mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 302:{
                        //up arrows, top mid bot , bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 303:{
                        //up arrows, top mid bot , top mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 304:{
                        //up arrows, top mid bot , top bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 305:{
                        //up arrows, top mid bot , mid bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 306:{
                        //up arrows, top mid bot , all filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 307:{
                        //down arrows, top ,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 308:{
                        //down arrows, mid ,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 309:{
                        //down arrows, bot ,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 310:{
                        //down arrows, top mid ,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 311:{
                        //down arrows, top bot,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 312:{
                        //down arrows, mid bot,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 313:{
                        //down arrows, top mid bot,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 314:{
                        //down arrows, top , top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 315:{
                        //down arrows, mid , mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 316:{
                        //down arrows, bot , bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 317:{
                        //down arrows, top mid , top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 318:{
                        //down arrows, top mid , mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 319:{
                        //down arrows, top mid , top mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 320:{
                        //down arrows, top bot , top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 321:{
                        //down arrows, top bot , bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 322:{
                        //down arrows, top bot , top bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 323:{
                        //down arrows, mid bot , mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 324:{
                        //down arrows, mid bot , bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 325:{
                        //down arrows, mid bot , mid bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 326:{
                        //down arrows, top mid bot , top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 327:{
                        //down arrows, top mid bot , mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 328:{
                        //down arrows, top mid bot , bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 329:{
                        //down arrows, top mid bot , top mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 330:{
                        //down arrows, top mid bot , top bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 331:{
                        //down arrows, top mid bot , mid bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 332:{
                        //down arrows, top mid bot , top mid bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 336:{
                        //both bumps filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        }
                case 334:{
                        //right bump  filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        }
                case 333:{
                        //road bump
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 335:{
                        //left road bump filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 340:{
                        //both bumps filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        }
                case 338:{
                        //right bump  filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        }
                case 337:{
                        //road bump
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 339:{
                        //left road bump filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 342:{
                        //twin squares with line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        }
                case 341:{
                        //twin squares
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 343:{
                        //twin squares, left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 20/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 3);
                        //points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        //points[2] = Point(X + PictureSize * 80/100,Y + PictureSize * 5/10);
                        //points[3] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        //Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 344:{
                        //twin squares, right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        //points[0] = Point(X + PictureSize * 20/100,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        //points[2] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        //points[3] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        //Canvas->Polygon(points, 3);
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 80/100,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 345:{
                        //twin squares, right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 20/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 3);
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 80/100,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 3);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 346:{
                        //twin squares, vert lines down both
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 347:{
                        //twin squares, vert lines down both, left left triange filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 20/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 348:{
                        //twin squares, vert lines down both, left right triange filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 349:{
                        //twin squares, vert lines down both, right left triange filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 350:{
                        //twin squares, vert lines down both, right right triange filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 80/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 351:{
                        //twin squares, vert lines down both, left left and right right triange filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 20/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 80/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 352:{
                        //twin squares, vert lines down both, left right and right left triange filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 353:{
                        //twin squares, vert lines down both, left right and right right triange filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 80/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 354:{
                        //twin squares, vert lines down both, left left and right left triange filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 20/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 355:{
                        //twin squares, vert lines down both, left left triange not filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 80/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 356:{
                        //twin squares, vert lines down both, left right triange not filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 20/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 80/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 357:{
                        //twin squares, vert lines down both, right left triange not filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 20/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 80/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 358:{
                        //twin squares, vert lines down both, right left triange not filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 20/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 359:{
                        //diamond with cross
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 360:{
                        //diamond with cross, top left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 361:{
                        //diamond with cross, top right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 362:{
                        //diamond with cross, bot left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 363:{
                        //diamond with cross, bot right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 364:{
                        //diamond with cross, top left, top right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 365:{
                        //diamond with cross, top right bot left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 366:{
                        //diamond with cross, top right bot right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 367:{
                        //diamond with cross, top left bot left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 368:{
                        //diamond with cross, top left bot right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 369:{
                        //diamond with cross, bot left bot right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 370:{
                        //diamond with cross, top left bot left bot right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 371:{
                        //diamond with cross, top right bot left bot right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 372:{
                        //diamond with cross, top right top left bot right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 373:{
                        //diamond with cross, top right top left top right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 374:{
                        //filled diamond
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 3);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 375:{
                        //window frame filled top right
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 376:{
                        //window frame filled bot right
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 377:{
                        //window frame filled bot left
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 378:{
                        //rectangle filled top half
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 379:{
                        //rectangle filled right half
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 380:{
                        //rectangle filled bot half
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 381:{
                        //rectangle filled left half
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 382:{
                        //window frame filled top half
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 383:{
                        //window frame filled right half
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 384:{
                        //window frame filled bot half
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 385:{
                        //window frame filled left half
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 386:{
                        //reversed 15
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 3);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 387:{
                        //window frame top right not filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[6];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[4] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[5] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 5);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 388:{
                        //window frame bot right not filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[6];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[4] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[5] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 5);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 389:{
                        //window frame bot left not filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[6];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[4] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[5] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 5);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 390:{
                        //window frame top left not filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[6];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[4] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[5] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 5);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 391:{
                        //filled square
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 3);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 392:{
                        //diagonal circles
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 393:{
                        //diagonal circles top filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 394:{
                        //diagonal circles bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 395:{
                        //diagonal circles both filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 396:{
                        //diagonal circles cross bot left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 397:{
                        //diagonal circles top filled  cross bot left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 398:{
                        //diagonal circles bot filled cross bot left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 399:{
                        //diagonal circles both filled cross bot left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 400:{
                        //diagonal circles cross top right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 401:{
                        //diagonal circles top filled  cross top right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 402:{
                        //diagonal circles bot filled cross top right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 403:{
                        //diagonal circles both filled cross top right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 404:{
                        //diagonal right circles
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 405:{
                        //diagonal right circles top filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 406:{
                        //diagonal right circles bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 407:{
                        //diagonal right circles both filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 408:{
                        //diagonal right circles cross top left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 409:{
                        //diagonal right circles top filled cross top left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 410:{
                        //diagonal right circles bot filled cross top left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 411:{
                        //diagonal right circles both filled cross top left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 412:{
                        //diagonal right circles cross bot right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 413:{
                        //diagonal right circles top filled cross bot right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 414:{
                        //diagonal right circles bot filled cross bot right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 415:{
                        //diagonal right circles both filled cross bot right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 416:{
                        //stalagtites
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 417:{
                        //stalagtites right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 418:{
                        //stalagtites left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 419:{
                        //stalagtites both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 420:{
                        //stalagmites
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 2/10);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 2/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 421:{
                        //stalagmites right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 2/10);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 422:{
                        //stalagmites left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 2/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 423:{
                        //stalagmites both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 424:{
                        //left horiz stalagmites
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 35/100);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 65/100);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 425:{
                        //left horiz stalagmites top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 35/100);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 65/100);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 426:{
                        //left horiz stalagmites bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 35/100);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 65/100);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 427:{
                        //left horiz stalagmites both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 35/100);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 65/100);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 428:{
                        //right horiz stalagmites
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 35/100);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 65/100);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 429:{
                        //right horiz stalagmites top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 35/100);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 65/100);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 430:{
                        //right horiz stalagmites bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 35/100);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 65/100);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 431:{
                        //right horiz stalagmites both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 35/100);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 65/100);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 432:{
                        //closed stalagtites
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 433:{
                        //closed stalagtites right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 434:{
                        //closed stalagtites left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 435:{
                        //closed stalagtites both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 436:{
                        //closed stalagmites
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 2/10);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 2/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 437:{
                        //closed stalagmites right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 2/10);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 438:{
                        //closed stalagmites left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 2/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 439:{
                        //closed stalagmites both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 440:{
                        //closed left horiz stalagmites
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 35/100);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 65/100);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 441:{
                        //closed left horiz stalagmites top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 35/100);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 65/100);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 442:{
                        //closed left horiz stalagmites bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 35/100);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 65/100);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 443:{
                        //closed left horiz stalagmites both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 35/100);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 65/100);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 444:{
                        //closed right horiz stalagmites
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 35/100);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 65/100);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 445:{
                        //closed right horiz stalagmites top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 35/100);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 65/100);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 446:{
                        //closed right horiz stalagmites bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 35/100);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 65/100);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 447:{
                        //closed right horiz stalagmites both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 35/100);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 65/100);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 448:{
                        //Large E
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 449:{
                        //Large Backwards E
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 450:{
                        //Large E pointing up
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 451:{
                        //Large E pointing down
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 452:{
                        //Large T on left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 453:{
                        //Large T on right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 454:{
                        //Large T
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 455:{
                        //triangle top, leg bottom left
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 456:{
                        //triangle top, leg bottom right
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 457:{
                        //triangle right, leg bottom left
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 458:{
                        //triangle right, leg top left
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 459:{
                        //triangle bottom, leg top left
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 460:{
                        //triangle bottom, leg top right
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 461:{
                        //triangle left, leg bottom right
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 462:{
                        //triangle left, leg top right
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 463:{
                        //two triangles pointing right, no fill
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 464:{
                        //two triangles pointing right, left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        //Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 465:{
                        //two triangles pointing right, right fill
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        //Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 466:{
                        //two triangles pointing right, both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        //Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        //Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 467:{
                        //two triangles pointing left, no filled
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 468:{
                        //two triangles pointing left, right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        //Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 469:{
                        //two triangles pointing left, left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        //Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 470:{
                        //two triangles pointing left, both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        //Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        //Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 471:{
                        //two triangles pointing up, no filled
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 472:{
                        //two triangles pointing up, top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        //Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 473:{
                        //two triangles pointing up, bottom filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        //Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 474:{
                        //two triangles pointing up, both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        //Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        //Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 475:{
                        //two triangles pointing down, no filled
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 476:{
                        //two triangles pointing down, top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //Canvas->Polygon(points, 2);
                        //Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 477:{
                        //two triangles pointing down, bottom filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        //Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 478:{
                        //two triangles pointing down, both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        //Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        //Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 479:{
                        //square, diagonal fill top left
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 480:{
                        //square, diagonal fill bottom left
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 481:{
                        //square, diagonal fill bottom right
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 482:{
                        //square, diagonal fill top right
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 483:{
                        // top right point huge arrow
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 484:{
                        // bottom right point huge arrow
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 485:{
                        // bottom left point huge arrow
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 486:{
                        // top left point huge arrow
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 487:{
                        // top left point thick arrow
                        Canvas->Pen->Width = PictureSize*4/20;
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 488:{
                        // bottom left point thick arrow
                        Canvas->Pen->Width = PictureSize*4/20;
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 489:{
                        // bottom right point thick arrow
                        Canvas->Pen->Width = PictureSize*4/20;
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 490:{
                        // bottom right point thick arrow
                        Canvas->Pen->Width = PictureSize*4/20;
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 491:{
                        // up point thick arrow
                        Canvas->Pen->Width = PictureSize*4/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 492:{
                        // down point thick arrow
                        Canvas->Pen->Width = PictureSize*4/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 493:{
                        // right point thick arrow
                        Canvas->Pen->Width = PictureSize*4/20;
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 494:{
                        // left point thick arrow
                        Canvas->Pen->Width = PictureSize*4/20;
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 495:{
                        // stook upright
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 496:{
                        // stook on side
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 498:{
                        // fat diamond with inner diamond
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        }
                case 497:{
                        // fat diamond
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 499:{
                        // fat diamond with fill
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[3] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 501:{
                        //square with cross
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        }
                case 500:{
                        // square with tl-br diagonal
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 502:{
                        // square with tr-bl diagonal
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 503:{
                        // square with inner square
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 504:{
                        // square with solid inner square
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        points[3] = Point(X + PictureSize * 6/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 505:{
                        // Narrow Diamond
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 3);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 506:{
                        // Narrow Diamond horiz
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 3);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 507:{
                        // Narrow Diamond tl-br diag
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 6/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 3);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 509:{
                        // Narrow Diamond tr-bl diag
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 3);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 510:{
                        // DrumStick tl-br diag
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 511:{
                        // DrumStick tr-bl diag
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 512:{
                        //planet with rings edge on
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->Ellipse(X + PictureSize * 35/100,Y + PictureSize * 35/100,X + PictureSize * 65/100,Y + PictureSize * 65/100);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 514:{
                        //disc with medium thick cross through
                        Canvas->Pen->Width = PictureSize*2/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        }
                case 513:{
                        //disc with medium thick line through  tr-bl
                        Canvas->Pen->Width = PictureSize*2/20;
                        Canvas->Ellipse(X + PictureSize * 35/100,Y + PictureSize * 35/100,X + PictureSize * 65/100,Y + PictureSize * 65/100);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 515:{
                        //disc with medium thick line through  tl-br
                        Canvas->Pen->Width = PictureSize*2/20;
                        Canvas->Ellipse(X + PictureSize * 35/100,Y + PictureSize * 35/100,X + PictureSize * 65/100,Y + PictureSize * 65/100);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 516:{
                        //disc over backwards L
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 517:{
                        //disc over L
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 518:{
                        //disc under upsiddownbackwards L
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 519:{
                        //disc under upsiddown L
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 520:{
                        //divide rotated 90 deg
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 4/10,Y + PictureSize * 6/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 521:{
                        //divide
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 6/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 522:{
                        //ball over surface
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 3/10,X + PictureSize * 7/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 508:{
                        // Narrow Diamond star
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 6/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 3);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 3);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 523: {
                        //percent symbol, #7 rotated
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 524: {
                        //colon
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 25/100,X + PictureSize * 6/10,Y + PictureSize * 45/100);
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 55/100,X + PictureSize * 6/10,Y + PictureSize * 75/100);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 525: {
                        //K
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 526: {
                        //Bottom Segment
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + 0,Y + PictureSize/2,X + PictureSize,Y + PictureSize/2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 527: {
                        //Side Segment
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + PictureSize * 5/10,Y + PictureSize*8/10,X + PictureSize*5/10,Y + 0);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 528: {
                        //Pie, br
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Pie(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 12/10,Y + PictureSize * 12/10,X + PictureSize * 8/10,Y + PictureSize*2/10,X + PictureSize*2/10,Y + PictureSize*8/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 14/10,Y + PictureSize * 14/10,X + PictureSize * 8/10,Y + PictureSize*2/10,X + PictureSize*2/10,Y + PictureSize*8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 529: {
                        //pie, bl
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Pie(X + PictureSize * -2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 12/10,X + PictureSize * 8/10,Y + PictureSize*8/10,X + PictureSize*2/10,Y + PictureSize*2/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pie(X + PictureSize * -4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 14/10,X + PictureSize * 8/10,Y + PictureSize*8/10,X + PictureSize*2/10,Y + PictureSize*2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 530: {
                        //pie, tl
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Pie(X + PictureSize * -2/10,Y + PictureSize * -2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 2/10,Y + PictureSize*8/10,X + PictureSize*8/10,Y + PictureSize*2/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pie(X + PictureSize * -4/10,Y + PictureSize * -4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + PictureSize * 2/10,Y + PictureSize*8/10,X + PictureSize*8/10,Y + PictureSize*2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 531: {
                        //pie, tr
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Pie(X + PictureSize * 4/10,Y + PictureSize * -2/10,X + PictureSize * 12/10,Y + PictureSize * 6/10,X + PictureSize * 2/10,Y + PictureSize*2/10,X + PictureSize*8/10,Y + PictureSize*8/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * -4/10,X + PictureSize * 14/10,Y + PictureSize * 8/10,X + PictureSize * 2/10,Y + PictureSize*2/10,X + PictureSize*8/10,Y + PictureSize*8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 532:{
                        //Circle top filled
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + + PictureSize * 8/10,Y + PictureSize/2,X + 0,Y + PictureSize/2);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 533:{
                        //Circle right filled
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + PictureSize/2,Y + PictureSize * 8/10,X + PictureSize/2,Y + 0);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 534:{
                        //Circle left filled
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + PictureSize/2,Y + 0,X + PictureSize/2,Y + PictureSize * 8/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 535:{
                        //Circle with cross
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 3/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize * 7/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 3/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 536:{
                        //Circle with plus
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 25/100);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 75/100);
                        Canvas->MoveTo(X + PictureSize * 25/100,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 75/100,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 537:{
                        //Circle with diagonal tr-bl
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 7/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 3/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 538:{
                        //Circle with diagonal tl-br
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 3/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 539:{
                        //522 rot 90
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 3/10,X + PictureSize * 7/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 540:{
                        //Venn Union
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Arc(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + PictureSize * 2/10,Y + PictureSize*6/10,X + PictureSize*8/10,Y + PictureSize*6/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 6/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 541:{
                        //540 + horiz mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Arc(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize*4/10,X + PictureSize*2/10,Y + PictureSize*4/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 4/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 542:{
                        //540 + 90 deg rot clock
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Arc(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 8/10,X + PictureSize * 4/10,Y + PictureSize*2/10,X + PictureSize*4/10,Y + PictureSize*8/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 543:{
                        //542 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Arc(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + PictureSize * 6/10,Y + PictureSize*8/10,X + PictureSize*6/10,Y + PictureSize*2/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 544:{
                        //Equals
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 6/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 545:{
                        //C++ OR
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 4/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 6/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 546:{
                        //diagonal slashes
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 547:{
                        //546 + 90 deg rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 548:{
                        //solid box
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Rectangle(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 549:{
                        //19 + 90 deg rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 550:{
                        //549 + 90 deg rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 551:{
                        //550 + 90 deg rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 552:{
                        //Hash sign
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 553: {
                        //Half Pie, R
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Pie(X + PictureSize * 5/10,Y + PictureSize * 3/10,X + PictureSize * 11/10,Y + PictureSize * 7/10,X + PictureSize * 8/10,Y + PictureSize*2/10,X + PictureSize*8/10,Y + PictureSize*8/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pie(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 12/10,Y + PictureSize * 8/10,X + PictureSize * 8/10,Y + PictureSize*2/10,X + PictureSize*8/10,Y + PictureSize*8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 554: {
                        //Half Pie, B
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Pie(X + PictureSize * 3/10,Y + PictureSize * 5/10,X + PictureSize * 7/10,Y + PictureSize * 11/10,X + PictureSize * 8/10,Y + PictureSize*8/10,X + PictureSize*2/10,Y + PictureSize*8/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 12/10,X + PictureSize * 8/10,Y + PictureSize*8/10,X + PictureSize*2/10,Y + PictureSize*8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 555: {
                        //Half Pie, L
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Pie(X + PictureSize * -1/10,Y + PictureSize * 3/10,X + PictureSize * 5/10,Y + PictureSize * 7/10,X + PictureSize * 2/10,Y + PictureSize*8/10,X + PictureSize*2/10,Y + PictureSize*2/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pie(X + PictureSize * -2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 8/10,X + PictureSize * 2/10,Y + PictureSize*8/10,X + PictureSize*2/10,Y + PictureSize*2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 556: {
                        //Half Pie, t
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Pie(X + PictureSize * 3/10,Y + PictureSize * -1/10,X + PictureSize * 7/10,Y + PictureSize * 5/10,X + PictureSize * 2/10,Y + PictureSize*2/10,X + PictureSize*8/10,Y + PictureSize*2/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * -2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10,X + PictureSize * 2/10,Y + PictureSize*2/10,X + PictureSize*8/10,Y + PictureSize*2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 557:{
                        //Arrow left with circle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 558:{
                        //Arrow right with circle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 4/10,Y + PictureSize * 6/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 559:{
                        //Arrow up with circle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 6/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 560:{
                        //Arrow down with circle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 4/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 561:{
                        //Narrow Elipse Vert
                        Canvas->Ellipse(X + PictureSize * 35/100,Y + PictureSize * 2/10,X + PictureSize * 65/100,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 562:{
                        //Narrow Elipse Horiz
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 35/100,X + PictureSize * 8/10,Y + PictureSize * 65/100);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 563:{
                        //Not Equals
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 6/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 564:{
                        //C++ Not OR
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 4/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 6/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 565:{
                        //Venn Union with dot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 3/10,X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        Canvas->Arc(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + PictureSize * 2/10,Y + PictureSize*6/10,X + PictureSize*8/10,Y + PictureSize*6/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 6/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 566:{
                        //541 + dot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 5/10,X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Arc(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize*4/10,X + PictureSize*2/10,Y + PictureSize*4/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 4/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 567:{
                        //542 + dot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 5/10,Y + PictureSize * 4/10,X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Arc(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 8/10,X + PictureSize * 4/10,Y + PictureSize*2/10,X + PictureSize*4/10,Y + PictureSize*8/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 568:{
                        //543 + dot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 4/10,X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        Canvas->Arc(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + PictureSize * 6/10,Y + PictureSize*8/10,X + PictureSize*6/10,Y + PictureSize*2/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 571:{
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 5/10,X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        }
                case 570:{
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 3/10,X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        }
                case 569:{
                        //circle with line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 572:{
                        //circle with line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 5/10,X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 573:{
                        //Narrow Elipse Vert
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 35/100,Y + PictureSize * 2/10,X + PictureSize * 65/100,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 574:{
                        //Narrow Elipse Horiz
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 35/100,X + PictureSize * 8/10,Y + PictureSize * 65/100);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 575:{
                        //add to set
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 3/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 576:{
                        //remove from set
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 577:{
                        //go up
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 578:{
                        //go down
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 7/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 579:{
                        //Gunsight
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 3/10,X + PictureSize * 7/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 580:{
                        //AE combined
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 3/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 581:{
                        //English Heritage Logo
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 582:{
                        //Music sharp
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 4/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 6/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        Canvas->MoveTo(X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 583:{
                        //Yen
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        Canvas->MoveTo(X + PictureSize * 4/10,Y + PictureSize * 6/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 584:{
                        //Less than or equals to
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 45/100);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 585:{
                        //More than or equals to
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 45/100);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 586:{
                        //Not less than
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 587:{
                        //Not greater than
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 588:{
                        //Teepee
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize * 4/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 589:{
                        //Open Teepee
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[6];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[3] = Point(X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        points[4] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        points[5] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 5);
                        Canvas->MoveTo(X + PictureSize * 4/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 590:{
                        //Waves
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 6/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 6/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 591:{
                        //Ship Bow
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 3/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 6/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 592:{
                        //Exactly Equals
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 593:{
                        //Crazy paving
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->MoveTo(X + PictureSize * 6/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 594:{
                        //Asterisk
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 595:{
                        //Asterisk + circle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 3/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize * 7/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 3/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 596:{
                        //Triangle bl + circle
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->Ellipse(X + PictureSize * 5/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 597:{
                        //Triangle br + circle
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 598:{
                        //Triangle tr + circle
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 5/10,X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 599:{
                        //Triangle tl + circle
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->Ellipse(X + PictureSize * 5/10,Y + PictureSize * 5/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                default:{
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                }

    //Restore original Canvas Brush & Pen properties to ensure printing is correct
    Canvas->Brush->Color = Brush->Color;
    Canvas->Brush->Style = Brush->Style;
    Canvas->Pen->Color = Pen->Color;
    Canvas->Pen->Style = Pen->Style;
    Canvas->Pen->Width = Pen->Width;
    delete Pen;
    delete Brush;

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::DrawEmptyGlyph(TCanvas *Canvas,int X, int Y, int PictureSize)
{
    //this routine creates an empty symbol for when the background isn't shown.
    TBrush *Brush = new TBrush;
    TPen *Pen = new TPen;
    Brush->Color = Canvas->Brush->Color;
    Brush->Style = Canvas->Brush->Style;
    Pen->Color = Canvas->Pen->Color;
    Pen->Style = Canvas->Pen->Style;
    Pen->Width = Canvas->Pen->Width;

    //clear the background
    Canvas->Brush->Color = clWhite;
    Canvas->FillRect(Rect(X,Y,X + PictureSize,Y + PictureSize));
    //draw the intermediate lines on the top & left edges in light grey
    Canvas->Pen->Color = clSilver;
    Canvas->Pen->Mode = pmCopy;
    Canvas->Pen->Style = psSolid;
    Canvas->Pen->Width = PictureSize/10;
    Canvas->MoveTo(X,Y + PictureSize-1);
    Canvas->LineTo(X,Y);
    Canvas->LineTo(X + PictureSize-1,Y);
    Canvas->Pen->Width = 1;

    Canvas->Brush->Color = Brush->Color;
    Canvas->Brush->Style = Brush->Style;
    Canvas->Pen->Color = Pen->Color;
    Canvas->Pen->Style = Pen->Style;
    Canvas->Pen->Width = Pen->Width;
    delete Pen;
    delete Brush;

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::PrintChartClick(TObject *Sender)
{
    //Print the chart
    //The chart is printed on a page.
    //If the chart is too wide & high to be printed on a single page, then it is
    //spanned over several pages wide and several pages high

    //The chart may have a simple key at the top.
    //Then the chart fills up the remainder of the page.
    //On the top edge is the number of the stitch, numbered every 10.
    //On the right edge is the number of the stitch, numbered every 10.
    //Every 10 stitches there is a solid black line replacing the grey
    //line surrounding each symbol.
    //At the centre the stitch is overlayed with an asterisk.
    //At the centre lines a purple line is drawn over the grey line surrounding each symbol
    //The purple line is drawn before the 10 stitch solid, so it's overwritten
    //if it's at a 'ten's' line, however as it's double the width of the 10s line some
    //may peek out on either side.

    //All-in-all this routine uses no elegant programming, just the brute ignorance
    //and force method.


    //Now to find out how deep the 'Simple Key' would be
    //In order to do that, the width is needed
    //Each entry will be Symbol (x 1.5 factor) + space + Symbol number + 3 spaces
    //spacing between rows is equivalent to the width of a space character
    //Screen->Cursor = crHourGlass;
    Printer()->Title = Caption + "_Cross_Stitch_Chart";
    Printer()->BeginDoc();
    PrintChartSheets();

    Printer()->EndDoc();
    //Screen->Cursor = crDefault;

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::FormResize(TObject *Sender)
{
    GroupBox1->Width = ClientWidth - GroupBox1->Left -4;
    GroupBox2->Width = GroupBox1->Width;
    GroupBox3->Width = GroupBox1->Width;
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::Help1Click(TObject *Sender)
{
    /*//Application->HelpCommand(HELP_CONTENTS,0);
    AnsiString Address = ExtractFileDir(Application->ExeName) + "\\BackStitch.chm#start";
    ShellExecute(Application->Handle,"open",Address.c_str(),NULL,NULL,SW_SHOW);*/
    AnsiString Address = ExtractFileDir(Application->ExeName) + "\\BackStitch.chm";
    //AnsiString Location = "mk:@MSITStore:" + Address + "::/index.html#start";
    AnsiString Location = "mk:@MSITStore:" + Address + "::/index.html";
    ShellExecute(Application->Handle,"open",Location.c_str(),Location.c_str(),NULL,SW_SHOW);
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::PrintFabricDetails1Click(TObject *Sender)
{
    //Prints the details of the background fabric.
    //Screen->Cursor = crHourGlass;
    AnsiString fabric = Caption + " Fabric Details";
    Printer()->Title = fabric;
    Printer()->BeginDoc();

    PrintFabricPages();

    Printer()->EndDoc();
    //Screen->Cursor = crDefault;


}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::Paste1Click(TObject *Sender)
{
    //Paste picture into Image1 and act on it.
    TClipboard *pCB = Clipboard();
    if (pCB->HasFormat(CF_BITMAP))
    {
        Screen->Cursor = crHourGlass;
        Graphics::TBitmap *pBitmap = new Graphics::TBitmap();
        try {
            pBitmap->LoadFromClipboardFormat(CF_BITMAP, pCB->GetAsHandle(CF_BITMAP), 0);
            Image1->Width = pBitmap->Width;
            Image1->Height = pBitmap->Height;
            Image1->Picture->Bitmap->Width = pBitmap->Width;
            Image1->Picture->Bitmap->Height = pBitmap->Height;
            Image1->Canvas->Draw(0,0,pBitmap);
            PictureChanged = false;
            OriginalBitmap->Width = 0;
            OriginalBitmap->Height = 0;
            }
        catch (...) {
            ShowMessage("Error during Paste Operation");
            }
        delete pBitmap;

        //GroupBox1->Left = Image1->Left + Image1->Width + 8;
        //GroupBox2->Left = GroupBox1->Left;
        //GroupBox3->Left = GroupBox1->Left;
        Image4->Top = Image1->Top + Image1->Height;
        Image4->Left = Image1->Left;
        forceConfettiLevel = false;

        CreateImage4();
        FormResize(this);

        //Caption = Application->Title + " - " + OpenDialog1->FileName;
        Caption = "Pasted Picture";
        PictureFileName = "Pasted Picture.bmp";



        //last image may have had its own symboltoglyph xref. set to default
        ReadSymbolToGlyphXRef();
        
        FillPictureData();
        //pasting an image, need to clear stitches, not load them!
        //ReadBackStitches(OpenDialog1->FileName);
        BackStitches.Length = 0;
        backstitcheschanged = false;
        AssignAnchorColours();

        FillPrinterData();

        PrintKey->Enabled = true;
        PrintChart->Enabled = true;
        PrintFabricDetails1->Enabled = true;
        PrintFronticePiece1->Enabled = true;
        if (BackStitches.Length) PrintBackStitches1->Enabled = true;
        if (!UseAnchor->Checked) PrintPageStitchInfo->Enabled = true;
        PrintWholeChartDocument1->Enabled = true;
        Label3->Enabled = true;
        Label26->Enabled = true;
        Label27->Enabled = true;
        PageNumber->Enabled = true;
        UseAnchor->Enabled = true;
        PrintColour->Enabled = true;
        BackStitch1->Enabled = true;
        ColourReduction1->Enabled = true;
        MergeSubstituteColours1->Enabled = true;
        CropImage1->Enabled = true;
        Screen->Cursor = crDefault;
        UndoStitchOffset.X = 0;
        UndoStitchOffset.Y = 0;


    }

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::Edit1Click(TObject *Sender)
{
    //checks to see if the clipboard has a compatible picture
    if (Clipboard()->HasFormat(CF_BITMAP)) {
        Paste1->Enabled = true;
        Paste2->Enabled = true;
        PasteHighResImage1->Enabled = true;
        } else {
        Paste1->Enabled = false;
        Paste2->Enabled = false;
        PasteHighResImage1->Enabled = false;
        }
    CopyHighResImage1->Enabled = !OriginalImage->Empty;
    //TransparencyBackStitch1->Enabled = (!OriginalImage->Empty && (bool)PictureColourPallette.Length);
    //TransparencyBackStitch1->Enabled = (OriginalImageFile.loaded && (bool)PictureColourPallette.Length);
    TransparencyBackStitch1->Enabled = OriginalImageFile.loaded;
    ReverttoOriginalImage1->Enabled = !OriginalBitmap->Empty;
    ImageEditor1->Enabled = ((Image1->Width > 0) && (Image1->Height > 0));
    SetSymbols1->Enabled = ImageEditor1->Enabled;

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::Copy1Click(TObject *Sender)
{
    unsigned int DataHandle = 0;
    HPALETTE APalette;
    unsigned short MyFormat = CF_BITMAP;
    Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
    try {
        // generate a clipboard format, with data and palette
        // save the data to the clipboard using that format and
        // the generated data
        //The use of an intervening bitmap allows the background to be either transparent or solid.
        //If the Image1->Picture->Bitmap is saved straight to clipboard, then the transparency info is
        //lost.
        Bitmap->Width = Image1->Width;
        Bitmap->Height = Image1->Height;
        Bitmap->Canvas->Draw(0,0,Image1->Picture->Bitmap);
        Bitmap->SaveToClipboardFormat(MyFormat,DataHandle,APalette);
        Clipboard()->SetAsHandle(CF_BITMAP,DataHandle);
        }

    catch (...) {
        ShowMessage("Sorry, Failed to copy image to clipboard.");
        }

    delete Bitmap;

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::Save1Click(TObject *Sender)
{
    //Save the image
    SavePictureDialog1->FileName = OpenDialog1->FileName;
    if (SavePictureDialog1->Execute()) {
        Image1->Picture->SaveToFile(ChangeFileExt(SavePictureDialog1->FileName,".bmp"));
        //save pasted high res image if it exists
        if (OriginalImageFile.filename == "Pasted Picture.bmp" && !OriginalImageFile.saved && !OriginalImage->Empty && !FileExists(ChangeFileExt(SavePictureDialog1->FileName," High Res.bmp"))) {
            OriginalImageFile.filename = ChangeFileExt(SavePictureDialog1->FileName," High Res.bmp");
            OriginalImage->SaveToFile(OriginalImageFile.filename);
            OriginalImageFile.saved = true;
            }
        SaveStitches(ChangeFileExt(SavePictureDialog1->FileName, ".bs"));
        Caption = ExtractFileName(ChangeFileExt(SavePictureDialog1->FileName,".bmp"));
        PictureChanged = false;
        backstitcheschanged = false;
        PictureFileName = ChangeFileExt(SavePictureDialog1->FileName,".bmp");
        UndoStitchOffset.X = 0;
        UndoStitchOffset.Y = 0;
        }
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::PrintFronticePiece1Click(TObject *Sender)
{
    //Prints the details of the background fabric.
    Screen->Cursor = crHourGlass;
    AnsiString fabric = Caption + " Frontice Piece";
    Printer()->Title = fabric;
    Printer()->BeginDoc();

    double scale, scalex, scaley;
    int topx, topy, picturewidth, pictureheight;
    if (OriginalImage->Empty) {
        //print chart image
        scalex = (double) (Printer()->PageWidth/Image1->Width);
        scaley = (double) (Printer()->PageHeight/Image1->Height);
        if (scalex >= scaley) {
            scale = scalex;
            } else {
            scale = scaley;
            }
        scale = scale/2;
        topx = (Printer()->PageWidth - (int)((double)Image1->Width * scale))/2;
        topy = (Printer()->PageHeight - (int)((double)Image1->Height * scale))/2;
        picturewidth = (int)((double)Image1->Width * scale);
        pictureheight = (int)((double)Image1->Height * scale);
        bool trans = Image1->Transparent;
        Image1->Transparent = false;
        Printer()->Canvas->StretchDraw(Rect(topx,topy,topx + picturewidth,topy + pictureheight),Image1->Picture->Bitmap);
        Image1->Transparent = trans;
        } else {
        //print high res image
        scalex = (double) (Printer()->PageWidth/OriginalImage->Width);
        scaley = (double) (Printer()->PageHeight/OriginalImage->Height);
        if (scalex >= scaley) {
            scale = scalex;
            } else {
            scale = scaley;
            }
        scale = scale/2;
        topx = (Printer()->PageWidth - (int)((double)OriginalImage->Width * scale))/2;
        topy = (Printer()->PageHeight - (int)((double)OriginalImage->Height * scale))/2;
        picturewidth = (int)((double)OriginalImage->Width * scale);
        pictureheight = (int)((double)OriginalImage->Height * scale);
        Printer()->Canvas->StretchDraw(Rect(topx,topy,topx + picturewidth,topy + pictureheight),OriginalImage);
        }


    Printer()->EndDoc();
    Screen->Cursor = crDefault;


}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::DrawAnchorGlyph(TCanvas *Canvas,int X, int Y, int PictureSize, int i, bool PlotEdge, TColor colour, bool usewhite)
{
    //allows for symbol substitution
    if (i < SymboltoGlyphXRef.Length) {
        DrawAnchorGlyph2(Canvas,X,Y,PictureSize,SymboltoGlyphXRef[i],i,PlotEdge,colour,usewhite);
        } else {
        DrawAnchorGlyph2(Canvas,X,Y,PictureSize,i,i,PlotEdge,colour,usewhite);
        }
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::DrawAnchorGlyph2(TCanvas *Canvas,int X, int Y, int PictureSize, int glyphno, int i, bool PlotEdge, TColor colour, bool usewhite)
{
    //this routine does all the hard work of producing the glyph for anchor plots.
    //The size & location is variable, so that it can be positioned anywhere on a Canvas
    //Also, with this method, it's possible to change the canvas it's drawn on, and
    //so is not limited to the printer.
    TBrush *Brush = new TBrush;
    TPen *Pen = new TPen;
    Brush->Color = Canvas->Brush->Color;
    Brush->Style = Canvas->Brush->Style;
    Pen->Color = Canvas->Pen->Color;
    Pen->Style = Canvas->Pen->Style;
    Pen->Width = Canvas->Pen->Width;
            //Fill the background with the current colour or white if not printing in colour
            if (PrintColour->Checked) {
                Canvas->Brush->Color = colour;
                } else {
                Canvas->Brush->Color = clWhite;
                }
            Canvas->FillRect(Rect(X,Y,X + PictureSize,Y + PictureSize));
            //draw the intermediate lines on the top & left edges in light grey
            if (PlotEdge) {
                Canvas->Pen->Color = clSilver;
                Canvas->Pen->Mode = pmCopy;
                Canvas->Pen->Style = psSolid;
                Canvas->Pen->Width = PictureSize/10;
                Canvas->MoveTo(X,Y + PictureSize-1);
                Canvas->LineTo(X,Y);
                Canvas->LineTo(X + PictureSize-1,Y);
                Canvas->Pen->Width = 1;
                }

            //Now to draw the symbol
            //first thing, choose the symbol colour which is dependant on background
            //brightness
            if (usewhite && PrintColour->Checked) {
                Canvas->Pen->Color = clWhite;
                Canvas->Brush->Color = clWhite;
                } else {
                Canvas->Pen->Color = clBlack;
                Canvas->Brush->Color = clBlack;
                }
            //now draw the symbol's shape on the symbol area
            switch (glyphno) {
                case 1: {
                        //simple circle
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 9: {
                        //Full CG symbol
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + PictureSize/2,Y + PictureSize,X + PictureSize,Y + PictureSize/2);
                        }
                case 8: {
                        //Part CG symbol
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + PictureSize/2,Y + 0,X + 0,Y + PictureSize/2);
                        }
                case 2: {
                        //simple hollow circle
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 5: {
                        //Fills in the top of the hourglass
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize/2,Y + PictureSize/2);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        }
                case 4: {
                        //Turns the cross into an hourglass
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        }
                case 3: {
                        //simple cross
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 7: {
                        //percent symbol
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        }
                case 6: {
                        //diagonal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 10:{
                        //Circle bottom filled
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + 0,Y + PictureSize/2,X + PictureSize,Y + PictureSize/2);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 15:{
                        //fill bottom right to result in a filled square CG symbol
                        Canvas->Rectangle(X + PictureSize /2,Y + PictureSize /2,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        }
                case 14:{
                        //fill top left
                        Canvas->Rectangle(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize /2,Y + PictureSize /2);
                        }
                case 13:{
                        //turn square into cross window frame
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize /2,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize /2,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                case 12:{
                        //turn square into horizontal window frame
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize /2);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize /2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                case 11:{
                        //square
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Rectangle(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 16:{
                        //Thick Diagonal
                        Canvas->Pen->Width = PictureSize*4/20;
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 0: {
                        //Plus Sign
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = 1;
                        }
                case 78:{
                        //Stick
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        }
                case 17:{
                        //Horizontal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize /2);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize /2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 30:{
                        //Christmas tree
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        }
                case 29:{
                        //up arrow
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        }
                case 18:{
                        //Vertical Line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize /2,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize /2,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 23:{
                        //Corner triangle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        }
                case 19:{
                        //L shape
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 21:{
                        //Fills in the diagonal arrow
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        }
                case 20:{
                        //Diagonal arrow
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 22:{
                        //Top corner flag
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 28:{
                        //Five circles
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        }
                case 27:{
                        //Four circles
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        }
                case 25:{
                        //two circles
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        }
                case 24:{
                        //one circle
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 26:{
                        //three circles
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 3/10,X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 31:{
                        //up & down arrow
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 34:{
                        //cross on Z
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        }
                case 33:{
                        //finish Z
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        }
                case 32:{
                        //part Z
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 37:{
                        //flag thingy filled in
                        TPoint points[6];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[3] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[4] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[5] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 5);
                        }
                case 36:{
                        //Flag thingy
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        }
                case 35:{
                        //M
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 38:{
                        //Backwards C
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 42:{
                        //zigzag with cross bar
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        }
                case 41:{
                        //Backwards full F
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        }
                case 40:{
                        //Backwards F
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        }
                case 39:{
                        //1
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 43:{
                        //Exclamation mark
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 6/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 45:{
                        //4 dots, 2 horizontal lines
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *3/10);
                        }
                case 44:{
                        //4 dots, 1 horizontal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *7/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 47:{
                        //4 dots, 2 diagonal lines
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *7/10);
                        }
                case 46:{
                        //4 dots, 1 diagonal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *3/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 49:{
                        //2 dots, 1 diagonal line
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        }
                case 48:{
                        //1 dot, 1 diagonal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *7/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 52:{
                        //filled in A
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 7/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 51:{
                        //A
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *5/10);
                        }
                case 50:{
                        //caret
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 54:{
                        //mountain with trees
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 3/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 3);
                        }
                case 53:{
                        //mountain
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 55:{
                        //squared U
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 56:{
                        //2 circles
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 2/10,X + PictureSize * 7/10,Y + PictureSize * 5/10);
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 5/10,X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        }
                        break;
                case 57:{
                        //2 circles, lower one filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 2/10,X + PictureSize * 7/10,Y + PictureSize * 5/10);
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 5/10,X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 58:{
                        //2 circles, concentric
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        }
                        break;
                case 59:{
                        //2 circles, concentric, one filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 61:{
                        //filled flag
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 60:{
                        //single flag
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 63:{
                        //double filled flag
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        }
                case 62:{
                        //double flag
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 67:{
                        //slashed Dollar
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                case 68:{
                        //double filled dollar
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 66:{
                        //single top filled dollar
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 65:{
                        //Dollar
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                case 64:{
                        //S
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 72:{
                        //double filled dumbel S
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 4/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 71:{
                        //single bottom filled dumbel S
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 70:{
                        //Diamond Dumbel S
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                case 69:{
                        //Diamond Dumbel S
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 75:{
                        //Double triangle, both filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 74:{
                        //Double triangle, lower filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                 case 73:{
                        //Double triangle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 77:{
                        //Double triangle, lower filled
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 3);
                        }
                case 76:{
                        //Treble triangle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 82:{
                        //Right point triangle, filled in
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 81:{
                        //Right point triangle, top filled in
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 80:{
                        //Right point triangle with horizontal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        }
                case 79:{
                        //Right point triangle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 85:{
                        //Left Pennant, filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 84:{
                        //Left Pennant, top filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 83:{
                        //Left Pennant
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 87:{
                        //I crossed
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        }
                case 86:{
                        //I
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 91:{
                        //Bottom point triangle, filled in
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 90:{
                        //Bottom point triangle, left filled in
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 89:{
                        //Bottom point triangle with vertical line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        }
                case 88:{
                        //Bottom point triangle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 94:{
                        //Top Pennant, filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 93:{
                        //Top Pennant, left filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 92:{
                        //Top Pennant
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 98:{
                        //Upsidedown T double tagged
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        }
                case 96:{
                        //Upsidedown T right tagged
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        }
                case 95:{
                        //Upsidedown T
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 99:{
                        //Upsidedown T, tags filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 97:{
                        //Upsidedown T, right tag filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 100: {
                        //face
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Ellipse(X + PictureSize * 25/100,Y + PictureSize * 25/100,X + PictureSize * 45/100,Y + PictureSize * 45/100);
                        Canvas->Ellipse(X + PictureSize * 55/100,Y + PictureSize * 25/100,X + PictureSize * 75/100,Y + PictureSize * 45/100);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *6/10);
                        }
                        break;
                case 102:{
                        //upsidedown Christmas tree
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        }
                case 101:{
                        //down arrow
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 104: {
                        //right tree
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        }
                case 103: {
                        //right arrow
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 106: {
                        //right tree
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        }
                case 105: {
                        //right arrow
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 107:{
                        //Top right corner flag
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 108:{
                        //top right Corner triangle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 109:{
                        //bottom right corner flag
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 110:{
                        //bottom right Corner triangle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 111:{
                        //bottom left corner flag
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 112:{
                        //bottom left Corner triangle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 113:{
                        //Fills in the top right diagonal arrow
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        }
                case 114:{
                        //top right Diagonal arrow
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 115:{
                        //Fills in the bottom left diagonal arrow
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        }
                case 116:{
                        //bottom left Diagonal arrow
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 117:{
                        //Fills in the bottom right diagonal arrow
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        }
                case 118:{
                        //bottom left Diagonal arrow
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 119:{
                        //cross on backwards Z
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        }
                case 120:{
                        //finish backwards Z
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        }
                case 121:{
                        //part backwards Z
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 122:{
                        //upsidedown M
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 123:{
                        //left M
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 124:{
                        //right M
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 125:{
                        //vertical version of 36
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 126:{
                        //vertical version of 37
                        TPoint points[6];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[4] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[5] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 5);
                        }
                case 127:{
                        // C
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 128:{
                        // 127 rot 90
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 129:{
                        // 128 + horizontal mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 130:{
                        //F
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        }
                case 131:{
                        //39 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 132:{
                        //131 + horiz mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 133:{
                        //132 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 134:{
                        //43 + horiz mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 135:{
                        //134 + 90 deg rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 136:{
                        //135 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 4/10,Y + PictureSize * 6/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 137:{
                        //4 dots, 1 horizontal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *3/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 138:{
                        //4 dots, 1 vertical line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *7/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 139:{
                        //4 dots, 1 vertical line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *7/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 140:{
                        //4 dots, 1 vertical line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *7/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 141:{
                        //4 dots, 1 diagonal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *7/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 142:{
                        //2 dots, 1 diagonal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *7/10);
                        //Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        //Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 143:{
                        //1 dot, 1 diagonal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *7/10);
                        //Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        //Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        //Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 144:{
                        //1 dot, 1 diagonal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *7/10);
                        //Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        //Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 145:{
                        //1 dot, 1 diagonal line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *7/10);
                        //Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        //Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 6/10,X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 146:{
                        //52 + horiz mirror
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 7/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 147:{
                        //51 + horiz mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *5/10);
                        }
                case 148:{
                        //50 + horiz mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 149:{
                        //146 + 90 deg rot
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 7/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 150:{
                        //147 + 90 deg rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *7/10);
                        }
                case 151:{
                        //148 + 90 deg rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 152:{
                        //149 + vert mirror
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 7/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 153:{
                        //150 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *7/10);
                        }
                case 154:{
                        //151 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 155:{
                        //54 + vert mirror
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 3/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 3);
                        }
                case 156:{
                        //53 + horiz mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 157:{
                        //155 + rot 90
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 7/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 3);
                        }
                case 158:{
                        //156 + rot 90
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 159:{
                        //157 + vert mirror
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 7/10);
                        points[3] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 3);
                        }
                case 160:{
                        //158 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 161: {
                        //55 + 90 rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 162: {
                        //161 + 90 rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 163: {
                        //162 + 90 rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 164:{
                        //2 circles, upper one filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 2/10,X + PictureSize * 7/10,Y + PictureSize * 5/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 5/10,X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 165:{
                        //2 circles, both filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 2/10,X + PictureSize * 7/10,Y + PictureSize * 5/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 5/10,X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 166:{
                        //2 circles next to each other, neither filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 3/10,X + PictureSize * 5/10,Y + PictureSize * 7/10);
                        Canvas->Ellipse(X + PictureSize * 5/10,Y + PictureSize * 3/10,X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 167:{
                        //2 circles next to each other, left filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 3/10,X + PictureSize * 5/10,Y + PictureSize * 7/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 5/10,Y + PictureSize * 3/10,X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 168:{
                        //2 circles next to each other, Right filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 3/10,X + PictureSize * 5/10,Y + PictureSize * 7/10);
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Ellipse(X + PictureSize * 5/10,Y + PictureSize * 3/10,X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 169:{
                        //2 circles next to each other, both filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 3/10,X + PictureSize * 5/10,Y + PictureSize * 7/10);
                        Canvas->Ellipse(X + PictureSize * 5/10,Y + PictureSize * 3/10,X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 170:{
                        //Greek Key
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 171:{
                        //170 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 172:{
                        //170 + horiz mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 173:{
                        //172 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 174:{
                        //170 + 90 deg rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                 case 175:{
                        //174 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 176:{
                        //174 + horiz mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 177:{
                        //176 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 178:{
                        //61 + horiz mirror
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 179:{
                        //60 + horiz mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 180:{
                        //61 + vert mirror
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 181:{
                        //60 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 182:{
                        //180 + horiz mirror
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 183:{
                        //181 + horiz mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 184:{
                        //horiz flag up right, filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 185:{
                        //horizontal flag up right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 186:{
                        //horiz flag down right, filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 187:{
                        //horizontal flag down right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 188:{
                        //horiz flag up left, filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 189:{
                        //horizontal flag up left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 190:{
                        //horiz flag down left, filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 191:{
                        //horizontal flag down left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 192:{
                        //partial cross upper left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 193:{
                        //partial cross lower right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 194:{
                        //partial cross upper right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 195:{
                        //partial cross lower left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 196:{
                        //partial plus upper
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 197:{
                        //partial plus left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 198:{
                        //partial plus left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 199:{
                        //left point triangle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        }
                case 200:{
                        //left point triangle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 201:{
                        //left point triangle, top half filled
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 202:{
                        //left point triangle, bottom half filled
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 203:{
                        //left point triangle, filled
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 204:{
                        //up point triangle with line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        }
                case 205:{
                        //up point triangle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 206:{
                        //up point triangle, left half filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 207:{
                        //up point triangle, right half filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 208:{
                        //up point triangle, filled
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Pen->Width = 1;
                        Canvas->Polygon(points, 2);
                        }
                        break;
                case 209:{
                        //right point triangle, bottom half filled
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 210:{
                        //down point triangle, right half filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 211:{
                        //left version of 84
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 212:{
                        //left version of 83
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 213:{
                        //211, bottom filled instead
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 214:{
                        //211, filled instead
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 215:{
                        //211 + 90 deg rot
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 216:{
                        //212 + 90 rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 217:{
                        //213 + 90 rot, bottom filled instead
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 218:{
                        //216, filled instead
                        TPoint points[3];
                        Canvas->Brush->Style = bsSolid;
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 219:{
                        //as 84, only bottom filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 220:{
                        //as 93, but right filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 224:{
                        //as 221 with both arrows filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 222:{
                        //as 221 with left arrow filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 221:{
                        //horizontal central pointing arrows
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 223:{
                        //as 221, right arrow filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 228:{
                        //224 + 90 deg rot
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 226:{
                        //222 + 90 deg rot
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        }
                case 225:{
                        //221 + 90 deg rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 227:{
                        //223 + 90 deg rot
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 229:{
                        //horizontal right arrow left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 230:{
                        //horizontal right arrow mid
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 231:{
                        //horizontal right arrow right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 232:{
                        //horizontal right arrow left mid
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 233:{
                        //horizontal right arrow left right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 234:{
                        //horizontal right arrow mid right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 235:{
                        //horizontal right arrow left mid right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 236:{
                        //horizontal right arrow left filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 237:{
                        //horizontal right arrow mid filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 238:{
                        //horizontal right arrow right filled
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 239:{
                        //horizontal right arrow left mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 240:{
                        //horizontal right arrow left right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 241:{
                        //horizontal right arrow mid right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 242:{
                        //horizontal right arrow left mid right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 243:{
                        //horizontal right arrow left mid, left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 244:{
                        //horizontal right arrow left mid, right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 245:{
                        //horizontal right arrow left right, left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        //Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 246:{
                        //horizontal right arrow left right, right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 247:{
                        //horizontal right arrow mid right, mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 248:{
                        //horizontal right arrow mid right, right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 249:{
                        //horizontal right arrow left mid right, left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 250:{
                        //horizontal right arrow left mid right, mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 251:{
                        //horizontal right arrow left mid right, right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 252:{
                        //horizontal right arrow left mid right, left mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 253:{
                        //horizontal right arrow left mid right, left right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 254:{
                        //horizontal right arrow left mid right, mid right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 255:{
                        //left arrows, left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 256:{
                        //left arrows, mid
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 257:{
                        //left arrows, right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 258:{
                        //left arrows, left mid
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 259:{
                        //left arrows, left right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 260:{
                        //left arrows, mid right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 261:{
                        //left arrows, left mid right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 262:{
                        //left arrows, left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 263:{
                        //left arrows, mid  filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 264:{
                        //left arrows, right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 265:{
                        //left arrows, left mid, left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 266:{
                        //left arrows, left mid, mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 267:{
                        //left arrows, left mid, both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 268:{
                        //left arrows, left right, left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 269:{
                        //left arrows, left right, right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 270:{
                        //left arrows, left right, both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 271:{
                        //left arrows, mid right, mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 272:{
                        //left arrows, mid right, right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 273:{
                        //left arrows, mid right, both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 274:{
                        //left arrows, left mid right, left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 275:{
                        //left arrows, left mid right, mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 276:{
                        //left arrows, left mid right, right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 277:{
                        //left arrows, left mid right, left mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 278:{
                        //left arrows, left mid right, left right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 279:{
                        //left arrows, left mid right, mid right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 280:{
                        //left arrows, left mid right, all filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 281:{
                        //up arrows, top ,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 282:{
                        //up arrows, mid ,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 283:{
                        //up arrows, bot ,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 284:{
                        //up arrows, top mid,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 285:{
                        //up arrows, top bot,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 286:{
                        //up arrows, mid bot,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 287:{
                        //up arrows, top mid bot,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 288:{
                        //up arrows, top , top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 289:{
                        //up arrows, mid , mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 290:{
                        //up arrows, bot , bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 291:{
                        //up arrows, top mid , top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 292:{
                        //up arrows, top mid , mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                         Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 293:{
                        //up arrows, top mid , both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 294:{
                        //up arrows, top bot , top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 295:{
                        //up arrows, top bot , bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 296:{
                        //up arrows, top bot , both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 297:{
                        //up arrows, mid bot , mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 298:{
                        //up arrows, mid bot , bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 299:{
                        //up arrows, mid bot , both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 300:{
                        //up arrows, top mid bot , top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 301:{
                        //up arrows, top mid bot , mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 302:{
                        //up arrows, top mid bot , bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 303:{
                        //up arrows, top mid bot , top mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 304:{
                        //up arrows, top mid bot , top bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 305:{
                        //up arrows, top mid bot , mid bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 306:{
                        //up arrows, top mid bot , all filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 307:{
                        //down arrows, top ,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 308:{
                        //down arrows, mid ,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 309:{
                        //down arrows, bot ,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 310:{
                        //down arrows, top mid ,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 311:{
                        //down arrows, top bot,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 312:{
                        //down arrows, mid bot,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 313:{
                        //down arrows, top mid bot,
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 314:{
                        //down arrows, top , top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 315:{
                        //down arrows, mid , mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 316:{
                        //down arrows, bot , bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 317:{
                        //down arrows, top mid , top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 318:{
                        //down arrows, top mid , mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 319:{
                        //down arrows, top mid , top mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 320:{
                        //down arrows, top bot , top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 321:{
                        //down arrows, top bot , bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 322:{
                        //down arrows, top bot , top bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 323:{
                        //down arrows, mid bot , mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 324:{
                        //down arrows, mid bot , bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 325:{
                        //down arrows, mid bot , mid bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 326:{
                        //down arrows, top mid bot , top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 327:{
                        //down arrows, top mid bot , mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 328:{
                        //down arrows, top mid bot , bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 329:{
                        //down arrows, top mid bot , top mid filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 330:{
                        //down arrows, top mid bot , top bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 331:{
                        //down arrows, top mid bot , mid bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 332:{
                        //down arrows, top mid bot , top mid bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 6/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 336:{
                        //both bumps filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        }
                case 334:{
                        //right bump  filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        }
                case 333:{
                        //road bump
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 335:{
                        //left road bump filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 340:{
                        //both bumps filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        }
                case 338:{
                        //right bump  filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        }
                case 337:{
                        //road bump
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 339:{
                        //left road bump filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 7/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 342:{
                        //twin squares with line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        }
                case 341:{
                        //twin squares
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 343:{
                        //twin squares, left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 20/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 3);
                        //points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        //points[2] = Point(X + PictureSize * 80/100,Y + PictureSize * 5/10);
                        //points[3] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        //Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 344:{
                        //twin squares, right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        //points[0] = Point(X + PictureSize * 20/100,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        //points[2] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        //points[3] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        //Canvas->Polygon(points, 3);
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 80/100,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 345:{
                        //twin squares, right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 20/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 3);
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 80/100,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 3);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 346:{
                        //twin squares, vert lines down both
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 347:{
                        //twin squares, vert lines down both, left left triange filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 20/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 348:{
                        //twin squares, vert lines down both, left right triange filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 349:{
                        //twin squares, vert lines down both, right left triange filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 350:{
                        //twin squares, vert lines down both, right right triange filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 80/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 351:{
                        //twin squares, vert lines down both, left left and right right triange filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 20/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 80/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 352:{
                        //twin squares, vert lines down both, left right and right left triange filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 353:{
                        //twin squares, vert lines down both, left right and right right triange filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 80/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 354:{
                        //twin squares, vert lines down both, left left and right left triange filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 20/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 355:{
                        //twin squares, vert lines down both, left left triange not filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 80/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 356:{
                        //twin squares, vert lines down both, left right triange not filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 20/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 80/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 357:{
                        //twin squares, vert lines down both, right left triange not filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 20/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 80/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 358:{
                        //twin squares, vert lines down both, right left triange not filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 20/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 35/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 50/100,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 65/100,Y + PictureSize * 3/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 7/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *80/100,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *20/100,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *65/100,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 359:{
                        //diamond with cross
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 360:{
                        //diamond with cross, top left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 361:{
                        //diamond with cross, top right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 362:{
                        //diamond with cross, bot left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 363:{
                        //diamond with cross, bot right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 364:{
                        //diamond with cross, top left, top right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 365:{
                        //diamond with cross, top right bot left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 366:{
                        //diamond with cross, top right bot right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 367:{
                        //diamond with cross, top left bot left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 368:{
                        //diamond with cross, top left bot right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 369:{
                        //diamond with cross, bot left bot right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 370:{
                        //diamond with cross, top left bot left bot right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 371:{
                        //diamond with cross, top right bot left bot right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 372:{
                        //diamond with cross, top right top left bot right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 373:{
                        //diamond with cross, top right top left top right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 374:{
                        //filled diamond
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 3);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 375:{
                        //window frame filled top right
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 376:{
                        //window frame filled bot right
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 377:{
                        //window frame filled bot left
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 378:{
                        //rectangle filled top half
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 379:{
                        //rectangle filled right half
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 380:{
                        //rectangle filled bot half
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 381:{
                        //rectangle filled left half
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 382:{
                        //window frame filled top half
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 383:{
                        //window frame filled right half
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 384:{
                        //window frame filled bot half
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 385:{
                        //window frame filled left half
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 386:{
                        //reversed 15
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 3);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 387:{
                        //window frame top right not filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[6];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[4] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[5] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 5);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 388:{
                        //window frame bot right not filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[6];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[4] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[5] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 5);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 389:{
                        //window frame bot left not filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[6];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[4] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[5] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 5);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 390:{
                        //window frame top left not filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[6];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[4] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[5] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 5);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 391:{
                        //filled square
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 3);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 392:{
                        //diagonal circles
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 393:{
                        //diagonal circles top filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 394:{
                        //diagonal circles bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 395:{
                        //diagonal circles both filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 396:{
                        //diagonal circles cross bot left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 397:{
                        //diagonal circles top filled  cross bot left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 398:{
                        //diagonal circles bot filled cross bot left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 399:{
                        //diagonal circles both filled cross bot left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *7/10);
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 400:{
                        //diagonal circles cross top right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 401:{
                        //diagonal circles top filled  cross top right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 402:{
                        //diagonal circles bot filled cross top right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 403:{
                        //diagonal circles both filled cross top right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        }
                        break;
                case 404:{
                        //diagonal right circles
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 405:{
                        //diagonal right circles top filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 406:{
                        //diagonal right circles bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 407:{
                        //diagonal right circles both filled
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 408:{
                        //diagonal right circles cross top left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 409:{
                        //diagonal right circles top filled cross top left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 410:{
                        //diagonal right circles bot filled cross top left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 411:{
                        //diagonal right circles both filled cross top left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *3/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *3/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *3/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *3/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 412:{
                        //diagonal right circles cross bot right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 413:{
                        //diagonal right circles top filled cross bot right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 414:{
                        //diagonal right circles bot filled cross bot right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 415:{
                        //diagonal right circles both filled cross bot right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->Brush->Style = bsSolid;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Brush->Color = Canvas->Pen->Color;
                        Canvas->MoveTo(X + PictureSize *7/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *7/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *7/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 416:{
                        //stalagtites
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 417:{
                        //stalagtites right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 418:{
                        //stalagtites left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 419:{
                        //stalagtites both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 420:{
                        //stalagmites
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 2/10);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 2/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 421:{
                        //stalagmites right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 2/10);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 422:{
                        //stalagmites left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 2/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 423:{
                        //stalagmites both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 424:{
                        //left horiz stalagmites
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 35/100);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 65/100);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 425:{
                        //left horiz stalagmites top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 35/100);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 65/100);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 426:{
                        //left horiz stalagmites bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 35/100);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 65/100);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 427:{
                        //left horiz stalagmites both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 35/100);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 65/100);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 428:{
                        //right horiz stalagmites
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 35/100);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 65/100);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 429:{
                        //right horiz stalagmites top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 35/100);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 65/100);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 430:{
                        //right horiz stalagmites bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 35/100);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 65/100);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 431:{
                        //right horiz stalagmites both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 35/100);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 65/100);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 432:{
                        //closed stalagtites
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 433:{
                        //closed stalagtites right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 434:{
                        //closed stalagtites left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 435:{
                        //closed stalagtites both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 436:{
                        //closed stalagmites
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 2/10);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 2/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 437:{
                        //closed stalagmites right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 2/10);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 438:{
                        //closed stalagmites left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 2/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 439:{
                        //closed stalagmites both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *35/100,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *65/100,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 440:{
                        //closed left horiz stalagmites
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 35/100);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 65/100);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 441:{
                        //closed left horiz stalagmites top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 35/100);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 65/100);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 442:{
                        //closed left horiz stalagmites bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 35/100);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 65/100);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 443:{
                        //closed left horiz stalagmites both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 35/100);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 65/100);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *65/100);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 444:{
                        //closed right horiz stalagmites
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 35/100);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 65/100);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 445:{
                        //closed right horiz stalagmites top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 35/100);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 65/100);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 446:{
                        //closed right horiz stalagmites bot filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 35/100);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 65/100);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 447:{
                        //closed right horiz stalagmites both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 35/100);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 65/100);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *35/100);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *65/100);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 448:{
                        //Large E
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 449:{
                        //Large Backwards E
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 450:{
                        //Large E pointing up
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 451:{
                        //Large E pointing down
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 452:{
                        //Large T on left
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 453:{
                        //Large T on right
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 454:{
                        //Large T
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 455:{
                        //triangle top, leg bottom left
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 456:{
                        //triangle top, leg bottom right
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 457:{
                        //triangle right, leg bottom left
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 458:{
                        //triangle right, leg top left
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 459:{
                        //triangle bottom, leg top left
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 460:{
                        //triangle bottom, leg top right
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 461:{
                        //triangle left, leg bottom right
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 462:{
                        //triangle left, leg top right
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 463:{
                        //two triangles pointing right, no fill
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 464:{
                        //two triangles pointing right, left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        //Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 465:{
                        //two triangles pointing right, right fill
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        //Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 466:{
                        //two triangles pointing right, both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        //Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        //Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 467:{
                        //two triangles pointing left, no filled
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 468:{
                        //two triangles pointing left, right filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        //Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 469:{
                        //two triangles pointing left, left filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        //Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 470:{
                        //two triangles pointing left, both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        //Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        //Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 471:{
                        //two triangles pointing up, no filled
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 472:{
                        //two triangles pointing up, top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        //Canvas->Polygon(points, 2);
                        //Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 473:{
                        //two triangles pointing up, bottom filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        //Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 474:{
                        //two triangles pointing up, both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        //Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        //Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 475:{
                        //two triangles pointing down, no filled
                        Canvas->Pen->Width = PictureSize/20;
                        //TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 476:{
                        //two triangles pointing down, top filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        //Canvas->Polygon(points, 2);
                        //Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 477:{
                        //two triangles pointing down, bottom filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        //points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        //points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        //points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        //Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        //Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 478:{
                        //two triangles pointing down, both filled
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        //Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        //Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        //Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        //Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 479:{
                        //square, diagonal fill top left
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 480:{
                        //square, diagonal fill bottom left
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 481:{
                        //square, diagonal fill bottom right
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 482:{
                        //square, diagonal fill top right
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 483:{
                        // top right point huge arrow
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 484:{
                        // bottom right point huge arrow
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 485:{
                        // bottom left point huge arrow
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 486:{
                        // top left point huge arrow
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 487:{
                        // top left point thick arrow
                        Canvas->Pen->Width = PictureSize*4/20;
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 488:{
                        // bottom left point thick arrow
                        Canvas->Pen->Width = PictureSize*4/20;
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 489:{
                        // bottom right point thick arrow
                        Canvas->Pen->Width = PictureSize*4/20;
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 490:{
                        // bottom right point thick arrow
                        Canvas->Pen->Width = PictureSize*4/20;
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 491:{
                        // up point thick arrow
                        Canvas->Pen->Width = PictureSize*4/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 492:{
                        // down point thick arrow
                        Canvas->Pen->Width = PictureSize*4/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *4/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 493:{
                        // right point thick arrow
                        Canvas->Pen->Width = PictureSize*4/20;
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 494:{
                        // left point thick arrow
                        Canvas->Pen->Width = PictureSize*4/20;
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 495:{
                        // stook upright
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 496:{
                        // stook on side
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 498:{
                        // fat diamond with inner diamond
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *4/10);
                        }
                case 497:{
                        // fat diamond
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 499:{
                        // fat diamond with fill
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[3] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 501:{
                        //square with cross
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        }
                case 500:{
                        // square with tl-br diagonal
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 502:{
                        // square with tr-bl diagonal
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 503:{
                        // square with inner square
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *6/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 504:{
                        // square with solid inner square
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        points[3] = Point(X + PictureSize * 6/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 3);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 505:{
                        // Narrow Diamond
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 3);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 506:{
                        // Narrow Diamond horiz
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        points[1] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        points[3] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        Canvas->Polygon(points, 3);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 507:{
                        // Narrow Diamond tl-br diag
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 6/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 3);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 509:{
                        // Narrow Diamond tr-bl diag
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 3);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 510:{
                        // DrumStick tl-br diag
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *4/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *4/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 511:{
                        // DrumStick tr-bl diag
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *6/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->MoveTo(X + PictureSize *6/10,Y + PictureSize *4/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 512:{
                        //planet with rings edge on
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 35/100,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 65/100,Y + PictureSize * 5/10);
                        Canvas->Polygon(points, 2);
                        Canvas->Ellipse(X + PictureSize * 35/100,Y + PictureSize * 35/100,X + PictureSize * 65/100,Y + PictureSize * 65/100);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 514:{
                        //disc with medium thick cross through
                        Canvas->Pen->Width = PictureSize*2/20;
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        }
                case 513:{
                        //disc with medium thick line through  tr-bl
                        Canvas->Pen->Width = PictureSize*2/20;
                        Canvas->Ellipse(X + PictureSize * 35/100,Y + PictureSize * 35/100,X + PictureSize * 65/100,Y + PictureSize * 65/100);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 515:{
                        //disc with medium thick line through  tl-br
                        Canvas->Pen->Width = PictureSize*2/20;
                        Canvas->Ellipse(X + PictureSize * 35/100,Y + PictureSize * 35/100,X + PictureSize * 65/100,Y + PictureSize * 65/100);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 516:{
                        //disc over backwards L
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 517:{
                        //disc over L
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 518:{
                        //disc under upsiddownbackwards L
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 519:{
                        //disc under upsiddown L
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *2/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 520:{
                        //divide rotated 90 deg
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 4/10,Y + PictureSize * 6/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->MoveTo(X + PictureSize *5/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *5/10,Y + PictureSize *2/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 521:{
                        //divide
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 6/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *5/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *5/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 522:{
                        //ball over surface
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 3/10,X + PictureSize * 7/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize *2/10,Y + PictureSize *8/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 508:{
                        // Narrow Diamond star
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[4];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 6/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 3);
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[3] = Point(X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 3);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 523: {
                        //percent symbol, #7 rotated
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 524: {
                        //colon
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 25/100,X + PictureSize * 6/10,Y + PictureSize * 45/100);
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 55/100,X + PictureSize * 6/10,Y + PictureSize * 75/100);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 525: {
                        //K
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize * 3/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 526: {
                        //Bottom Segment
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + 0,Y + PictureSize/2,X + PictureSize,Y + PictureSize/2);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 527: {
                        //Side Segment
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + PictureSize * 5/10,Y + PictureSize*8/10,X + PictureSize*5/10,Y + 0);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 528: {
                        //Pie, br
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Pie(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 12/10,Y + PictureSize * 12/10,X + PictureSize * 8/10,Y + PictureSize*2/10,X + PictureSize*2/10,Y + PictureSize*8/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 14/10,Y + PictureSize * 14/10,X + PictureSize * 8/10,Y + PictureSize*2/10,X + PictureSize*2/10,Y + PictureSize*8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 529: {
                        //pie, bl
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Pie(X + PictureSize * -2/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 12/10,X + PictureSize * 8/10,Y + PictureSize*8/10,X + PictureSize*2/10,Y + PictureSize*2/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pie(X + PictureSize * -4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 14/10,X + PictureSize * 8/10,Y + PictureSize*8/10,X + PictureSize*2/10,Y + PictureSize*2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 530: {
                        //pie, tl
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Pie(X + PictureSize * -2/10,Y + PictureSize * -2/10,X + PictureSize * 6/10,Y + PictureSize * 6/10,X + PictureSize * 2/10,Y + PictureSize*8/10,X + PictureSize*8/10,Y + PictureSize*2/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pie(X + PictureSize * -4/10,Y + PictureSize * -4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + PictureSize * 2/10,Y + PictureSize*8/10,X + PictureSize*8/10,Y + PictureSize*2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 531: {
                        //pie, tr
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Pie(X + PictureSize * 4/10,Y + PictureSize * -2/10,X + PictureSize * 12/10,Y + PictureSize * 6/10,X + PictureSize * 2/10,Y + PictureSize*2/10,X + PictureSize*8/10,Y + PictureSize*8/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * -4/10,X + PictureSize * 14/10,Y + PictureSize * 8/10,X + PictureSize * 2/10,Y + PictureSize*2/10,X + PictureSize*8/10,Y + PictureSize*8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 532:{
                        //Circle top filled
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + + PictureSize * 8/10,Y + PictureSize/2,X + 0,Y + PictureSize/2);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 533:{
                        //Circle right filled
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + PictureSize/2,Y + PictureSize * 8/10,X + PictureSize/2,Y + 0);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 534:{
                        //Circle left filled
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + PictureSize/2,Y + 0,X + PictureSize/2,Y + PictureSize * 8/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 535:{
                        //Circle with cross
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 3/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize * 7/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 3/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 536:{
                        //Circle with plus
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 25/100);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 75/100);
                        Canvas->MoveTo(X + PictureSize * 25/100,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 75/100,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 537:{
                        //Circle with diagonal tr-bl
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 7/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 3/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 538:{
                        //Circle with diagonal tl-br
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 3/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 539:{
                        //522 rot 90
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 3/10,X + PictureSize * 7/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize *8/10,Y + PictureSize *2/10);
                        Canvas->LineTo(X + PictureSize *8/10,Y + PictureSize *8/10);
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 540:{
                        //Venn Union
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Arc(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + PictureSize * 2/10,Y + PictureSize*6/10,X + PictureSize*8/10,Y + PictureSize*6/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 6/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 541:{
                        //540 + horiz mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Arc(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize*4/10,X + PictureSize*2/10,Y + PictureSize*4/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 4/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 542:{
                        //540 + 90 deg rot clock
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Arc(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 8/10,X + PictureSize * 4/10,Y + PictureSize*2/10,X + PictureSize*4/10,Y + PictureSize*8/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 543:{
                        //542 + vert mirror
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Arc(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + PictureSize * 6/10,Y + PictureSize*8/10,X + PictureSize*6/10,Y + PictureSize*2/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 544:{
                        //Equals
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 6/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 545:{
                        //C++ OR
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 4/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 6/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 546:{
                        //diagonal slashes
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 547:{
                        //546 + 90 deg rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 548:{
                        //solid box
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Rectangle(X + PictureSize * 4/10,Y + PictureSize * 4/10,X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 549:{
                        //19 + 90 deg rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 550:{
                        //549 + 90 deg rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 551:{
                        //550 + 90 deg rot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 552:{
                        //Hash sign
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 553: {
                        //Half Pie, R
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Pie(X + PictureSize * 5/10,Y + PictureSize * 3/10,X + PictureSize * 11/10,Y + PictureSize * 7/10,X + PictureSize * 8/10,Y + PictureSize*2/10,X + PictureSize*8/10,Y + PictureSize*8/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pie(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 12/10,Y + PictureSize * 8/10,X + PictureSize * 8/10,Y + PictureSize*2/10,X + PictureSize*8/10,Y + PictureSize*8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 554: {
                        //Half Pie, B
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Pie(X + PictureSize * 3/10,Y + PictureSize * 5/10,X + PictureSize * 7/10,Y + PictureSize * 11/10,X + PictureSize * 8/10,Y + PictureSize*8/10,X + PictureSize*2/10,Y + PictureSize*8/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 12/10,X + PictureSize * 8/10,Y + PictureSize*8/10,X + PictureSize*2/10,Y + PictureSize*8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 555: {
                        //Half Pie, L
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Pie(X + PictureSize * -1/10,Y + PictureSize * 3/10,X + PictureSize * 5/10,Y + PictureSize * 7/10,X + PictureSize * 2/10,Y + PictureSize*8/10,X + PictureSize*2/10,Y + PictureSize*2/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pie(X + PictureSize * -2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 8/10,X + PictureSize * 2/10,Y + PictureSize*8/10,X + PictureSize*2/10,Y + PictureSize*2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 556: {
                        //Half Pie, t
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Pie(X + PictureSize * 3/10,Y + PictureSize * -1/10,X + PictureSize * 7/10,Y + PictureSize * 5/10,X + PictureSize * 2/10,Y + PictureSize*2/10,X + PictureSize*8/10,Y + PictureSize*2/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Pie(X + PictureSize * 2/10,Y + PictureSize * -2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10,X + PictureSize * 2/10,Y + PictureSize*2/10,X + PictureSize*8/10,Y + PictureSize*2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 557:{
                        //Arrow left with circle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 6/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 558:{
                        //Arrow right with circle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 4/10,Y + PictureSize * 6/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 559:{
                        //Arrow up with circle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 6/10,X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 560:{
                        //Arrow down with circle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 4/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 561:{
                        //Narrow Elipse Vert
                        Canvas->Ellipse(X + PictureSize * 35/100,Y + PictureSize * 2/10,X + PictureSize * 65/100,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 562:{
                        //Narrow Elipse Horiz
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 35/100,X + PictureSize * 8/10,Y + PictureSize * 65/100);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 563:{
                        //Not Equals
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 6/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 564:{
                        //C++ Not OR
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 4/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 6/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 565:{
                        //Venn Union with dot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 3/10,X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        Canvas->Arc(X + PictureSize * 2/10,Y + PictureSize * 4/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + PictureSize * 2/10,Y + PictureSize*6/10,X + PictureSize*8/10,Y + PictureSize*6/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 6/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 566:{
                        //541 + dot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 5/10,X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Arc(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 6/10,X + PictureSize * 8/10,Y + PictureSize*4/10,X + PictureSize*2/10,Y + PictureSize*4/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 4/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 567:{
                        //542 + dot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 5/10,Y + PictureSize * 4/10,X + PictureSize * 7/10,Y + PictureSize * 6/10);
                        Canvas->Arc(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 6/10,Y + PictureSize * 8/10,X + PictureSize * 4/10,Y + PictureSize*2/10,X + PictureSize*4/10,Y + PictureSize*8/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 568:{
                        //543 + dot
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 4/10,X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        Canvas->Arc(X + PictureSize * 4/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10,X + PictureSize * 6/10,Y + PictureSize*8/10,X + PictureSize*6/10,Y + PictureSize*2/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 571:{
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 5/10,X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        }
                case 570:{
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 3/10,X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        }
                case 569:{
                        //circle with line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 572:{
                        //circle with line
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Ellipse(X + PictureSize * 4/10,Y + PictureSize * 5/10,X + PictureSize * 6/10,Y + PictureSize * 7/10);
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 573:{
                        //Narrow Elipse Vert
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 35/100,Y + PictureSize * 2/10,X + PictureSize * 65/100,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 574:{
                        //Narrow Elipse Horiz
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 35/100,X + PictureSize * 8/10,Y + PictureSize * 65/100);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 575:{
                        //add to set
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 3/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 576:{
                        //remove from set
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 577:{
                        //go up
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 578:{
                        //go down
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 7/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 579:{
                        //Gunsight
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 3/10,Y + PictureSize * 3/10,X + PictureSize * 7/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 580:{
                        //AE combined
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 3/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 581:{
                        //English Heritage Logo
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 582:{
                        //Music sharp
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 4/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 6/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        Canvas->MoveTo(X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 583:{
                        //Yen
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 3/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        Canvas->MoveTo(X + PictureSize * 4/10,Y + PictureSize * 6/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 584:{
                        //Less than or equals to
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 45/100);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 585:{
                        //More than or equals to
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 45/100);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 586:{
                        //Not less than
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 587:{
                        //Not greater than
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 588:{
                        //Teepee
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 2);
                        Canvas->MoveTo(X + PictureSize * 4/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 589:{
                        //Open Teepee
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[6];
                        points[0] = Point(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        points[3] = Point(X + PictureSize * 6/10,Y + PictureSize * 8/10);
                        points[4] = Point(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        points[5] = Point(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        Canvas->Polygon(points, 5);
                        Canvas->MoveTo(X + PictureSize * 4/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize * 3/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 590:{
                        //Waves
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 4/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 6/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 6/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 6/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 591:{
                        //Ship Bow
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 4/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 3/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 6/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 6/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 6/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 592:{
                        //Exactly Equals
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 3/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 7/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 593:{
                        //Crazy paving
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize * 4/10,Y + PictureSize * 8/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 6/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->MoveTo(X + PictureSize * 4/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->MoveTo(X + PictureSize * 6/10,Y + PictureSize * 4/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 2/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 594:{
                        //Asterisk
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 595:{
                        //Asterisk + circle
                        Canvas->Pen->Width = PictureSize/20;
                        Canvas->Brush->Style = bsClear;
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->MoveTo(X + PictureSize * 3/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 7/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize * 7/10,Y + PictureSize * 3/10);
                        Canvas->LineTo(X + PictureSize * 3/10,Y + PictureSize * 7/10);
                        Canvas->MoveTo(X + PictureSize * 2/10,Y + PictureSize * 5/10);
                        Canvas->LineTo(X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->MoveTo(X + PictureSize * 5/10,Y + PictureSize * 2/10);
                        Canvas->LineTo(X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 596:{
                        //Triangle bl + circle
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->Ellipse(X + PictureSize * 5/10,Y + PictureSize * 2/10,X + PictureSize * 8/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 597:{
                        //Triangle br + circle
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[2] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 2/10,X + PictureSize * 5/10,Y + PictureSize * 5/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 598:{
                        //Triangle tr + circle
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        points[1] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        Canvas->Polygon(points, 2);
                        Canvas->Ellipse(X + PictureSize * 2/10,Y + PictureSize * 5/10,X + PictureSize * 5/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                case 599:{
                        //Triangle tl + circle
                        Canvas->Pen->Width = PictureSize/20;
                        TPoint points[3];
                        points[0] = Point(X + PictureSize * 8/10,Y + PictureSize * 2/10);
                        points[1] = Point(X + PictureSize * 2/10,Y + PictureSize * 2/10);
                        points[2] = Point(X + PictureSize * 2/10,Y + PictureSize * 8/10);
                        Canvas->Polygon(points, 2);
                        Canvas->Ellipse(X + PictureSize * 5/10,Y + PictureSize * 5/10,X + PictureSize * 8/10,Y + PictureSize * 8/10);
                        Canvas->Pen->Width = 1;
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                default:{
                        Canvas->Brush->Style = bsSolid;
                        }
                        break;
                }

    //Restore original Canvas Brush & Pen properties to ensure printing is correct
    Canvas->Brush->Color = Brush->Color;
    Canvas->Brush->Style = Brush->Style;
    Canvas->Pen->Color = Pen->Color;
    Canvas->Pen->Style = Pen->Style;
    Canvas->Pen->Width = Pen->Width;
    delete Pen;
    delete Brush;

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::BackStitch1Click(TObject *Sender)
{
    if (OriginalBitmap->Empty) {
        OriginalBitmap->Assign(Image1->Picture->Bitmap);
        }

    //now fill in the thread colours in the backstitch unit.
    BackStitchForm->ColourList.Length = DMCColourList.Length;
    for (int i = 0; i < DMCColourList.Length; i++) {
        BackStitchForm->ColourList[i].DMCColourName = DMCColourList[i].DMCColourName;
        BackStitchForm->ColourList[i].Colour = DMCColourList[i].Colour;
        BackStitchForm->ColourList[i].DrawWhite = DMCColourList[i].DrawWhite;
        BackStitchForm->ColourList[i].StitchCount = DMCColourList[i].StitchCount;
        }
    BackStitchForm->FillColourList();
    BackStitchForm->UsedColourList.Length = PictureColourPallette.Length;
    for (int i = 0; i < PictureColourPallette.Length; i++) {
        BackStitchForm->UsedColourList[i].DMCColourName = PictureColourPallette[i].DMCColourName;
        BackStitchForm->UsedColourList[i].Colour = PictureColourPallette[i].Colour;
        BackStitchForm->UsedColourList[i].DrawWhite = PictureColourPallette[i].DrawWhite;
        BackStitchForm->UsedColourList[i].StitchCount = PictureColourPallette[i].StitchCount;
        }
    BackStitchForm->FillUsedColourList();

    //Fill the BackStitch array
    BackStitchForm->BackStitchList.Length = BackStitches.Length;
    for (int i = 0; i < BackStitches.Length; i++) {
        BackStitchForm->BackStitchList[i].X1 = BackStitches[i].X1;
        BackStitchForm->BackStitchList[i].Y1 = BackStitches[i].Y1;
        BackStitchForm->BackStitchList[i].X2 = BackStitches[i].X2;
        BackStitchForm->BackStitchList[i].Y2 = BackStitches[i].Y2;
        BackStitchForm->BackStitchList[i].ColourNumber = BackStitches[i].ColourNumber;
        BackStitchForm->BackStitchList[i].Colour = BackStitches[i].Colour;
        }

    //setup the picture
    BackStitchForm->Picture->Width = Image1->Width;
    BackStitchForm->Picture->Height = Image1->Height;
    bool temp = Image1->Transparent;
    Image1->Transparent = false;
    BackStitchForm->Picture->Canvas->Draw(0,0,Image1->Picture->Bitmap);
    Image1->Transparent = temp;

    //setup the stitch count
    BackStitchForm->PictureXStitchCount = StitchCount->Items->Strings[StitchCount->ItemIndex].ToIntDef(14);
    
    //draw the picture
    BackStitchForm->DrawBitmap();
    //Update selected colour
    BackStitchForm->PrintSelectedColour();

    if (BackStitchForm->ShowModal() == mrOk) {
        //Right. The Back Stitches have been approved, so load them into the stitch list
        if (BackStitches.Length != BackStitchForm->BackStitchList.Length) backstitcheschanged = true;
        BackStitches.Length = BackStitchForm->BackStitchList.Length;
        for (int i = 0; i < BackStitchForm->BackStitchList.Length; i++) {
            BackStitches[i].X1 = BackStitchForm->BackStitchList[i].X1;
            BackStitches[i].Y1 = BackStitchForm->BackStitchList[i].Y1;
            BackStitches[i].X2 = BackStitchForm->BackStitchList[i].X2;
            BackStitches[i].Y2 = BackStitchForm->BackStitchList[i].Y2;
            BackStitches[i].ColourNumber = BackStitchForm->BackStitchList[i].ColourNumber;
            BackStitches[i].Colour = BackStitchForm->BackStitchList[i].Colour;
            }
        if (BackStitchForm->imagechanged) {
            Image1->Picture->Bitmap->Assign(BackStitchForm->Picture);
            PictureChanged = true;
            FillPictureData();
            CountBackStitches();
            AssignAnchorColours();
            FillPrinterData();
            }  else {
            //check to see if any new colours have been added to the used pallette
            /*
            //This is what is done initially on opening the files
            FillPictureData();
            ReadBackStitches(OpenDialog1->FileName);
            CountBackStitches();
            AssignAnchorColours();
            */
            if (BackStitchForm->UsedColourList.Length != PictureColourPallette.Length) {
                PictureColourPallette.Length = BackStitchForm->UsedColourList.Length;
                for (int i = 0; i < PictureColourPallette.Length; i++) {
                    PictureColourPallette[i].DMCColourName = BackStitchForm->UsedColourList[i].DMCColourName;
                    PictureColourPallette[i].Colour = BackStitchForm->UsedColourList[i].Colour;
                    PictureColourPallette[i].DrawWhite = BackStitchForm->UsedColourList[i].DrawWhite;
                    PictureColourPallette[i].StitchCount = BackStitchForm->UsedColourList[i].StitchCount;
                    //now to get the other data entered
                    bool found = false;
                    int pointer = 0;
                    while (!found && pointer < DMCColourList.Length) {
                        if (PictureColourPallette[i].DMCColourName == DMCColourList[pointer].DMCColourName) {
                            found = true;
                            pointer--;
                            }
                        pointer++;
                        }
                    if (found) {
                        PictureColourPallette[i].DMCColourNumber = DMCColourList[pointer].DMCColourNumber;
                        PictureColourPallette[i].AnchorColourNumber = DMCColourList[pointer].AnchorColourNumber;
                        } else {
                        Application->MessageBox("Unknown Colours Found on returning from Back Stitch Form","Error",MB_OK + MB_ICONEXCLAMATION);
                        }
                    }
                }
            //add new colours to the picture pallette & display.

            //recalculate the number of equivalent stitches. Each backstitch
            //will take about the same length as an additional cross stitch.
            CountCrossStitches();
            CountBackStitches();
            AssignAnchorColours();
            }

        PrintBackStitches1->Enabled = (bool)BackStitches.Length;

        }
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::ReadBackStitches(AnsiString FileName)
{
    AnsiString Name = ChangeFileExt(FileName,".bs");
    if (FileExists(Name)) {
        inputfile->LoadFromFile(Name);
        //interpret file
        //first delete all comment lines
        for (int i = 0; i < inputfile->Count; i++) {
            if (LeftString(inputfile->Strings[i],1) == "#") {
                inputfile->Delete(i);
                i--;
                }
            }
        //now create backstitch array & fill it
        int counter = 0;
        for (int i = 0; i < inputfile->Count; i++) {
            if (LeftString(inputfile->Strings[i],6) == "Stitch") {
                counter++ ;
                }
            }
        BackStitches.Length = counter;
        //BackStitches.Length = inputfile->Count;

        AnsiString text;
        TColor RGBColour;
        bool found;
        int pointer;
        bool CountChanged = false;
        //The file format of the backstitch form is
        //Stitch, Stitch Start x, Stitch Start y, Stitch End x, Stitch End y, RGB colour of stitch
        //or
        // OriginalImageFile,offsetx,offsety,scalefactor,originalimagefilefilename
        // Title,[title text]
        // ImageCopyright,[image copyright text]
        // ChartCopyright,[chart copyright text]
        // Fonts,[title font],[title font size],[image copyright font],[image copyright size],[chart copyright font],[chart copyright size],[chart font],[chart font size]
        // Pages,[(all bool)FrontSheet],[IndexPage],[ColourChart],[MonochromeChart],[DetailedKey],[BackStitches],[StitchesPerPage],[FabricDetails]
        // or for backwards compatibility
        //Stitch Start x, Stitch Start y, Stitch End x, Stitch End y, RGB colour of stitch
        for (int i = 0; i < inputfile->Count; i++) {
            text = inputfile->Strings[i];
            text = text + ",";
            if (LeftString(text,6) == "Stitch") {
                text = DeleteWord(text,",");
                //Extract the X1 co-ord.
                BackStitches[i].X1 = (float) ToDoubleDef(ExtractWord(text,","),0.0);
                text = DeleteWord(text,",");
                //Extract the Y1 co-ord.
                BackStitches[i].Y1 = (float) ToDoubleDef(ExtractWord(text,","),0.0);
                text = DeleteWord(text,",");
                //Extract the X2 co-ord.
                BackStitches[i].X2 = (float) ToDoubleDef(ExtractWord(text,","),0.0);
                text = DeleteWord(text,",");
                //Extract the Y2 co-ord.
                BackStitches[i].Y2 = (float) ToDoubleDef(ExtractWord(text,","),0.0);
                text = DeleteWord(text,",");
                //Extract the Colour Number
                RGBColour = (TColor) ExtractWord(text,",").ToIntDef(0);
                //now to find the reference to the colour thread used for the stitch
                //and add it to the thread list if necessary.
                BackStitches[i].Colour = RGBColour;

                found = false;
                pointer = 0;
                while (!found && pointer < PictureColourPallette.Length) {
                    if (PictureColourPallette[pointer].Colour == RGBColour) {
                        pointer--;
                        found = true;
                        }
                    pointer++;
                    }
                if (!found) {
                    //not in the pallette of used stitches, so search for
                    //it in the available colour list
                    pointer = 0;
                    while (!found && pointer < DMCColourList.Length) {
                        if (DMCColourList[pointer].Colour == RGBColour) {
                            pointer--;
                            found = true;
                            }
                        pointer++;
                        }
                    PictureColourPallette.Length++;
                    if (found) {
                        PictureColourPallette[PictureColourPallette.Length-1].DMCColourNumber = DMCColourList[pointer].DMCColourNumber;
                        PictureColourPallette[PictureColourPallette.Length-1].DMCColourName = DMCColourList[pointer].DMCColourName;
                        PictureColourPallette[PictureColourPallette.Length-1].AnchorColourNumber = DMCColourList[pointer].AnchorColourNumber;
                        PictureColourPallette[PictureColourPallette.Length-1].Colour = DMCColourList[pointer].Colour;
                        PictureColourPallette[PictureColourPallette.Length-1].DrawWhite = DMCColourList[pointer].DrawWhite;
                        PictureColourPallette[PictureColourPallette.Length-1].StitchCount = 0;
                        PictureColourPallette[PictureColourPallette.Length-1].AnchorColourToUse = DMCColourList[pointer].AnchorColourToUse;
                        PictureColourPallette[PictureColourPallette.Length-1].AnchorStitchCount = DMCColourList[pointer].AnchorStitchCount;
                        PictureColourPallette[PictureColourPallette.Length-1].AnchorGlyphToUse = 0;
                        } else {
                        PictureColourPallette[PictureColourPallette.Length-1].DMCColourNumber = "None";
                        PictureColourPallette[PictureColourPallette.Length-1].DMCColourName = "Not Available";
                        PictureColourPallette[PictureColourPallette.Length-1].AnchorColourNumber = "Not Available";
                        PictureColourPallette[PictureColourPallette.Length-1].Colour = RGBColour;
                        PictureColourPallette[PictureColourPallette.Length-1].DrawWhite = false;
                        PictureColourPallette[PictureColourPallette.Length-1].StitchCount = 0;
                        PictureColourPallette[PictureColourPallette.Length-1].AnchorColourToUse = 0;
                        PictureColourPallette[PictureColourPallette.Length-1].AnchorStitchCount = 0;
                        PictureColourPallette[PictureColourPallette.Length-1].AnchorGlyphToUse = 0;
                        }
                    pointer = PictureColourPallette.Length-1;
                    }

                BackStitches[i].ColourNumber = pointer;
                } else {
                if (LeftString(text,4) == "Orig"
                        || LeftString(text,5) == "Title"
                        || LeftString(text,5) == "Image"
                        || LeftString(text,5) == "Chart"
                        || LeftString(text,5) == "Fonts"
                        || LeftString(text,5) == "Pages"
                        || LeftString(text,5) == "Count"
                        || LeftString(text,4) == "Mult"
                        || LeftString(text,5) == "Blend"
                        || LeftString(text,9) == "OverrideC"
                        || LeftString(text,5) == "ShowB"
                        || LeftString(text,10) == "ThreadSort"
                        || LeftString(text,9) == "SetSymbol"
                        || LeftString(text,5) == "Floss"
                        ) {
                    if (LeftString(text,4) == "Orig") {
                        //OK, original file definition has been found
                        // OriginalImageFile,offsetx,offsety,scalefactor,originalimagefilefilename
                        text = DeleteWord(text,",");
                        OriginalImageFile.offsetx = ExtractWord(text,",").ToIntDef(0);
                        text = DeleteWord(text,",");
                        OriginalImageFile.offsety = ExtractWord(text,",").ToIntDef(0);
                        text = DeleteWord(text,",");
                        OriginalImageFile.scalefactor = ToDoubleDef(ExtractWord(text,","),1.0);
                        text = DeleteWord(text,",");
                        OriginalImageFile.filename = ExtractWord(text,",");
                        OriginalImageFile.loaded = false;
                        if (FileExists(OriginalImageFile.filename)) {
                            AnsiString Ext = ExtractFileExt(OriginalImageFile.filename).LowerCase();
                            if (Ext == ".bmp" || Ext == ".jpg" || Ext == ".jpeg" || Ext == ".emf") {
                                //this round the houses methodology allows jpegs & emfs to be loaded
                                TImage *TempImage = new TImage(this);
                                TempImage->AutoSize = true;
                                TempImage->Picture->LoadFromFile(OriginalImageFile.filename);
                                OriginalImage->Width = TempImage->Width;
                                OriginalImage->Height = TempImage->Height;
                                OriginalImage->Canvas->Draw(0,0,TempImage->Picture->Graphic);
                                delete TempImage;
                                OriginalImageFile.loaded = true;
                                OriginalImageFile.saved = true;
                                }
                            if (Ext == ".gif") {
                                TGIFImage *Gif = new TGIFImage();
                                Gif->LoadFromFile(OriginalImageFile.filename);
                                OriginalImage->Assign(Gif);
                                delete Gif;
                                OriginalImageFile.loaded = true;
                                OriginalImageFile.saved = true;
                                }
                            //OriginalImage->LoadFromFile(OriginalImageFile.filename);

                            }
                        } //End of 'Original Image'
                    if (LeftString(text,5) == "Title") {
                        text = DeleteWord(text,",");
                        ChartPrintout.Title = LeftString(text,text.Length() - 1);
                        } //End of 'Title'
                    if (LeftString(text,5) == "Image") {
                        text = DeleteWord(text,",");
                        ChartPrintout.ImageCopyright = LeftString(text,text.Length() - 1);
                        } //End of 'ImageCopyright'
                    if (LeftString(text,5) == "Chart") {
                        text = DeleteWord(text,",");
                        ChartPrintout.ChartCopyright = LeftString(text,text.Length() - 1);
                        } //End of 'ChartCopyright'
                    if (LeftString(text,5) == "Fonts") {
                        text = DeleteWord(text,",");
                        ChartPrintout.TitleFont = ExtractWord(text,",");
                        text = DeleteWord(text,",");
                        ChartPrintout.TitleSize = ExtractWord(text,",").ToIntDef(20);
                        text = DeleteWord(text,",");
                        ChartPrintout.ImageCopyrightFont = ExtractWord(text,",");
                        text = DeleteWord(text,",");
                        ChartPrintout.ImageCopyrightSize = ExtractWord(text,",").ToIntDef(12);
                        text = DeleteWord(text,",");
                        ChartPrintout.ChartCopyrightFont = ExtractWord(text,",");
                        text = DeleteWord(text,",");
                        ChartPrintout.ChartCopyrightSize = ExtractWord(text,",").ToIntDef(12);
                        text = DeleteWord(text,",");
                        if (text.Length() == 0) {
                            //temporary kludge to get around the fact I've added the chart font reading to this line and there may be some project files without the chart font data there
                            text = text + "Arial,8,";
                            }
                        ChartPrintout.ChartFont = ExtractWord(text,",");
                        text = DeleteWord(text,",");
                        ChartPrintout.ChartFontSize = ExtractWord(text,",").ToIntDef(8);
                        } //End of 'Fonts'
                    if (LeftString(text,5) == "Pages") {
                        text = DeleteWord(text,",");
                        ChartPrintout.FrontSheet = (bool)ExtractWord(text,",").ToIntDef(1);
                        text = DeleteWord(text,",");
                        ChartPrintout.IndexPage = (bool)ExtractWord(text,",").ToIntDef(1);
                        text = DeleteWord(text,",");
                        ChartPrintout.ColourChart = (bool)ExtractWord(text,",").ToIntDef(1);
                        text = DeleteWord(text,",");
                        ChartPrintout.MonochromeChart = (bool)ExtractWord(text,",").ToIntDef(1);
                        text = DeleteWord(text,",");
                        ChartPrintout.DetailedKey = (bool)ExtractWord(text,",").ToIntDef(1);
                        text = DeleteWord(text,",");
                        ChartPrintout.BackStitches = (bool)ExtractWord(text,",").ToIntDef(1);
                        text = DeleteWord(text,",");
                        ChartPrintout.StitchesPerPage = (bool)ExtractWord(text,",").ToIntDef(1);
                        text = DeleteWord(text,",");
                        ChartPrintout.FabricDetails = (bool)ExtractWord(text,",").ToIntDef(1);
                        text = DeleteWord(text,",");
                        ChartPrintout.ChartPageXRef = (bool)ExtractWord(text,",").ToIntDef(1);
                        } //end of 'Pages'
                    if (LeftString(text,5) == "Count") {
                        text = DeleteWord(text,",");
                        StitchCount->ItemIndex = StitchCount->Items->IndexOf(ExtractWord(text,","));
                        text = DeleteWord(text,",");
                        PrintCount->ItemIndex = PrintCount->Items->IndexOf(ExtractWord(text,","));
                        CountChanged = true;
                        //StitchCountChange(this);
                        } //end of 'Count'
                    if (LeftString(text,4) == "Mult") {
                        text = DeleteWord(text,",");
                        MultiplesofTenCheckBox->Checked = (bool)ExtractWord(text,",").ToIntDef(0);
                        } //end of 'MultiplesofTen'
                    if (LeftString(text,5) == "Blend") {
                        text = DeleteWord(text,",");
                        blendthreads = (bool)ExtractWord(text,",").ToIntDef(0);
                        } //end of 'Blend'
                    if (LeftString(text,9) == "OverrideC") {
                        text = DeleteWord(text,",");
                        forceConfettiLevel = (bool)ExtractWord(text,",").ToIntDef(0);
                        text = DeleteWord(text,",");
                        ConfettiLevel = (TConfettiLevel)(ExtractWord(text,",").ToIntDef(0));
                        } //end of OverrideComplexity
                    if (LeftString(text,5) == "ShowB") {
                        text = DeleteWord(text,",");
                        Background->Checked = (bool)ExtractWord(text,",").ToIntDef(0);
                        //BackgroundClick(this);
                        } //end of ShowBackground
                    if (LeftString(text,10) == "ThreadSort") {
                        text = DeleteWord(text,",");
                        int sortmethod = ExtractWord(text,",").ToIntDef(0);
                        if (sortmethod > -1 && sortmethod < ThreadSortMethod->Items->Count) ThreadSortMethod->ItemIndex = sortmethod;
                        } //end of ThreadSortMethod
                    if (LeftString(text,9) == "SetSymbol") {
                        setsymbols = true;
                        text = DeleteWord(text,",");
                        int symbolnumber = ExtractWord(text,",").ToIntDef(SymboltoGlyphXRef.Length - 1);
                        text = DeleteWord(text,",");
                        int glyphnumber = ExtractWord(text,",").ToIntDef(symbolnumber);
                        if (symbolnumber > SymboltoGlyphXRef.Length - 1 || glyphnumber > SymboltoGlyphXRef.Length - 1) {
                            //extend symbol array if need be
                            int maxnumber = max(symbolnumber,glyphnumber);
                            int top = SymboltoGlyphXRef.Length;
                            SymboltoGlyphXRef.Length = maxnumber + 1;
                            for (int j = top; j < SymboltoGlyphXRef.Length; j++) {
                                SymboltoGlyphXRef[j] = j;
                                }
                            }
                        SymboltoGlyphXRef[symbolnumber] = glyphnumber;
                        } //end of 'SetSymbol'
                    if (LeftString(text,5) == "Floss") {
                        text = DeleteWord(text,",");
                        int threadfloss = ExtractWord(text,",").ToIntDef(0);
                        text = DeleteWord(text,",");
                        while (RightString(text,1) == ",") {
                            text = ChopOffLastChars(text,1);
                            }
                        if (threadfloss > -1 && threadfloss < ThreadFileNameList->Count && threadfloss != ThreadFileNamePointer && ThreadFileNameList->Strings[threadfloss].LowerCase() == text.LowerCase()) {
                            ThreadFileNamePointer = threadfloss;
                            TIniFile *IniFile = new TIniFile(ChangeFileExt(Application->ExeName, ".ini"));
                            IniFile->WriteInteger("ThreadSettings","CurrentRange",ThreadFileNamePointer);
                            delete IniFile;
                            OpenDMCList();
                            }
                        } //end of ShowBackground
                    } else {
                    //kept for backwards compatibility
                    //Extract the X1 co-ord.
                    BackStitches[i].X1 = (float) ToDoubleDef(ExtractWord(text,","),0.0);
                    text = DeleteWord(text,",");
                    //Extract the Y1 co-ord.
                    BackStitches[i].Y1 = (float) ToDoubleDef(ExtractWord(text,","),0.0);
                    text = DeleteWord(text,",");
                    //Extract the X2 co-ord.
                    BackStitches[i].X2 = (float) ToDoubleDef(ExtractWord(text,","),0.0);
                    text = DeleteWord(text,",");
                    //Extract the Y2 co-ord.
                    BackStitches[i].Y2 = (float) ToDoubleDef(ExtractWord(text,","),0.0);
                    text = DeleteWord(text,",");
                    //Extract the Colour Number
                    RGBColour = (TColor) ExtractWord(text,",").ToIntDef(0);
                    //now to find the reference to the colour thread used for the stitch
                    //and add it to the thread list if necessary.
                    BackStitches[i].Colour = RGBColour;

                    found = false;
                    pointer = 0;
                    while (!found && pointer < PictureColourPallette.Length) {
                        if (PictureColourPallette[pointer].Colour == RGBColour) {
                            pointer--;
                            found = true;
                            }
                        pointer++;
                        }
                    if (!found) {
                        //not in the pallette of used stitches, so search for
                        //it in the available colour list
                        pointer = 0;
                        while (!found && pointer < DMCColourList.Length) {
                            if (DMCColourList[pointer].Colour == RGBColour) {
                                pointer--;
                                found = true;
                                }
                            pointer++;
                            }
                        PictureColourPallette.Length++;
                        if (found) {
                            PictureColourPallette[PictureColourPallette.Length-1].DMCColourNumber = DMCColourList[pointer].DMCColourNumber;
                            PictureColourPallette[PictureColourPallette.Length-1].DMCColourName = DMCColourList[pointer].DMCColourName;
                            PictureColourPallette[PictureColourPallette.Length-1].AnchorColourNumber = DMCColourList[pointer].AnchorColourNumber;
                            PictureColourPallette[PictureColourPallette.Length-1].Colour = DMCColourList[pointer].Colour;
                            PictureColourPallette[PictureColourPallette.Length-1].DrawWhite = DMCColourList[pointer].DrawWhite;
                            PictureColourPallette[PictureColourPallette.Length-1].StitchCount = 0;
                            PictureColourPallette[PictureColourPallette.Length-1].AnchorColourToUse = DMCColourList[pointer].AnchorColourToUse;
                            PictureColourPallette[PictureColourPallette.Length-1].AnchorStitchCount = DMCColourList[pointer].AnchorStitchCount;
                            PictureColourPallette[PictureColourPallette.Length-1].AnchorGlyphToUse = 0;
                            } else {
                            PictureColourPallette[PictureColourPallette.Length-1].DMCColourNumber = "None";
                            PictureColourPallette[PictureColourPallette.Length-1].DMCColourName = "Not Available";
                            PictureColourPallette[PictureColourPallette.Length-1].AnchorColourNumber = "Not Available";
                            PictureColourPallette[PictureColourPallette.Length-1].Colour = RGBColour;
                            PictureColourPallette[PictureColourPallette.Length-1].DrawWhite = false;
                            PictureColourPallette[PictureColourPallette.Length-1].StitchCount = 0;
                            PictureColourPallette[PictureColourPallette.Length-1].AnchorColourToUse = 0;
                            PictureColourPallette[PictureColourPallette.Length-1].AnchorStitchCount = 0;
                            PictureColourPallette[PictureColourPallette.Length-1].AnchorGlyphToUse = 0;
                            }
                        pointer = PictureColourPallette.Length-1;
                        }

                    BackStitches[i].ColourNumber = pointer;
                    } // end of original style
                }
            }
        //finish interpretation
        inputfile->Clear();
        backstitcheschanged = false;
        if (CountChanged) StitchCountChange(this);
        }
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::SaveBackStitches1Click(TObject *Sender)
{
    SaveDialog1->FileName = ChangeFileExt(PictureFileName,".bs");
    if (SaveDialog1->Execute()) {
        SaveStitches(SaveDialog1->FileName);
        if (ChangeFileExt(SaveDialog1->FileName,".bmp").UpperCase() == PictureFileName.UpperCase()) backstitcheschanged = false;
        }
        
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::SaveStitches(AnsiString FileName)
{
        //Save the back stitch list
        inputfile->Clear();
        AnsiString text;
        inputfile->Add("# File format.");
        inputfile->Add("# Lines may be in any order. If lines are missing, program defaults are used. Comment lines start with a # character.");
        inputfile->Add("# Stitch,[Stitch Start x], [Stitch Start y], [Stitch End x], [Stitch End y], [RGB colour of stitch]");
        inputfile->Add("# OriginalImageFile,[offsetx],[offsety],[scalefactor],[originalimagefilefilename]");
        inputfile->Add("# Title,[title text]");
        inputfile->Add("# ImageCopyright,[image copyright text]");
        inputfile->Add("# ChartCopyright,[chart copyright text]");
        inputfile->Add("# Fonts,[title font],[title font size],[image copyright font],[image copyright size],[chart copyright font],[chart copyright size],[chart font],[chart font size]");
        inputfile->Add("# Pages,[(all bool)FrontSheet],[IndexPage],[ColourChart],[MonochromeChart],[DetailedKey],[BackStitches],[StitchesPerPage],[FabricDetails],[ChartPageXRef]");
        inputfile->Add("# Count,[fabric count],[chart count]");
        inputfile->Add("# MultiplesofTen,[1=Yes 0=No]");
        inputfile->Add("# BlendThreads,[1=Yes 0=No]");
        inputfile->Add("# OverrideComplexity,[1=Yes 0=No],[newvalue 0=Low 1=Medium 2=High 3=Extreme]");
        inputfile->Add("# ShowBackground,[1=Yes 0=No]");
        inputfile->Add("# ThreadSortMethod,[0=Stitch Count 1=Floss Number 2=Hue]");
        inputfile->Add("# SetSymbol,[Thread number],[Shape number]");
        inputfile->Add("# Floss,[Thread Range number],[Thread Range Filename (without extension)]");

        for (int i = 0; i < BackStitches.Length; i++) {
            text = "Stitch," + AnsiString(BackStitches[i].X1) + ",";
            text = text + AnsiString(BackStitches[i].Y1) + ",";
            text = text + AnsiString(BackStitches[i].X2) + ",";
            text = text + AnsiString(BackStitches[i].Y2) + ",";
            text = text + AnsiString((int)PictureColourPallette[BackStitches[i].ColourNumber].Colour) + ",";
            inputfile->Add(text);
            }
        if (OriginalImageFile.loaded) inputfile->Add("OriginalImageFile," + AnsiString(OriginalImageFile.offsetx) + ","  + AnsiString(OriginalImageFile.offsety) + "," + AnsiString(OriginalImageFile.scalefactor) + "," + OriginalImageFile.filename);
        inputfile->Add("Title," + ChartPrintout.Title);
        inputfile->Add("ImageCopyright," + ChartPrintout.ImageCopyright);
        inputfile->Add("ChartCopyright," + ChartPrintout.ChartCopyright);
        inputfile->Add("Fonts," + ChartPrintout.TitleFont + "," + AnsiString(ChartPrintout.TitleSize) + "," + ChartPrintout.ImageCopyrightFont + "," + AnsiString(ChartPrintout.ImageCopyrightSize) + "," + ChartPrintout.ChartCopyrightFont + "," + AnsiString(ChartPrintout.ChartCopyrightSize) + "," + ChartPrintout.ChartFont + "," + AnsiString(ChartPrintout.ChartFontSize));
        inputfile->Add("Pages," + AnsiString((int)ChartPrintout.FrontSheet)
                        + "," + AnsiString((int)ChartPrintout.IndexPage)
                        + "," + AnsiString((int)ChartPrintout.ColourChart)
                        + "," + AnsiString((int)ChartPrintout.MonochromeChart)
                        + "," + AnsiString((int)ChartPrintout.DetailedKey)
                        + "," + AnsiString((int)ChartPrintout.BackStitches)
                        + "," + AnsiString((int)ChartPrintout.StitchesPerPage)
                        + "," + AnsiString((int)ChartPrintout.FabricDetails)
                        + "," + AnsiString((int)ChartPrintout.ChartPageXRef)
                        );
        inputfile->Add("Count," + StitchCount->Items->Strings[StitchCount->ItemIndex] + "," + PrintCount->Items->Strings[PrintCount->ItemIndex]);
        inputfile->Add("MultiplesofTen," + AnsiString((int)MultiplesofTenCheckBox->Checked));
        inputfile->Add("BlendThreads," + AnsiString((int)blendthreads));
        if (forceConfettiLevel) {
            inputfile->Add("OverrideComplexity,1," + AnsiString(ConfettiLevel) + ",");
            }
        inputfile->Add("ShowBackground," + AnsiString((int)Background->Checked));
        inputfile->Add("ThreadSortMethod," + AnsiString(ThreadSortMethod->ItemIndex));
        if (setsymbols) {
            for (int i = 0; i < SymboltoGlyphXRef.Length; i++) {
                //if (i != SymboltoGlyphXRef[i]) {
                inputfile->Add("SetSymbol," + AnsiString(i) + "," + AnsiString(SymboltoGlyphXRef[i]));
                    //}
                }
            }
        inputfile->Add("Floss," + AnsiString(ThreadFileNamePointer) + "," + ThreadFileNameList->Strings[ThreadFileNamePointer]);
        inputfile->SaveToFile(FileName);
        inputfile->Clear();

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::File1Click(TObject *Sender)
{
    SaveBackStitches1->Enabled = backstitcheschanged;
    SaveHighResImage1->Enabled = !OriginalImage->Empty;
    if(OriginalImage->Empty) {
        PrintFronticePiece1->Caption = "Print Chart Image";
        } else {
        PrintFronticePiece1->Caption = "Print High Res. Image";
        }

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::CountCrossStitches(void)
{
    //first set all stitch counts to zero
    for (int i = 0; i < PictureColourPallette.Length; i++) {
        PictureColourPallette[i].StitchCount = 0;
        PictureColourPallette[i].AnchorStitchCount = 0;
        }

    //now to count the cross stitches in the picture
    bool found;
    int k;
    for (int i = 0; i < Image1->Width; i++) {
        for (int j = 0; j < Image1->Height; j++) {
            found = false;
            k = 0;
            while (!found && k < PictureColourPallette.Length) {
                //first check if it's in the list of already found colours
                if (Image1->Canvas->Pixels[i][j] == PictureColourPallette[k].Colour){
                    PictureColourPallette[k].StitchCount++;
                    found = true;
                    } 
                k++;
                }
            if (!found) {
                Application->MessageBox("Unknown Colours Found While Counting Stitches","Error",MB_OK + MB_ICONEXCLAMATION);
                }
            }
        }

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::PrintBackStitches1Click(TObject *Sender)
{
    //Print back stitches
    /*
    The back stitches are drawn in colour over the background. Initially
    the background will be a standard copy of the chart. I have changed the glyphs
    so that the contrast is reduced and the whiteness increased to make the
    background look washed out.

    The glyphs in the simple key will be replaced with horizontal coloured lines
    the width of the glyph.

    The back stitch lines will be drawn with thick lines, as wide as the line in glyph 16
    */

    //The chart is printed on a page.
    //If the chart is too wide & high to be printed on a single page, then it is
    //spanned over several pages wide and several pages high

    //The chart may have a simple key at the top.
    //Then the chart fills up the remainder of the page.
    //On the top edge is the number of the stitch, numbered every 10.
    //On the right edge is the number of the stitch, numbered every 10.
    //Every 10 stitches there is a solid black line replacing the grey
    //line surrounding each symbol.
    //At the centre the stitch is overlayed with an asterisk.
    //At the centre lines a purple line is drawn over the grey line surrounding each symbol
    //The purple line is drawn before the 10 stitch solid, so it's overwritten
    //if it's at a 'ten's' line, however as it's double the width of the 10s line some
    //may peek out on either side.

    //All-in-all this routine uses no elegant programming, just the brute ignorance
    //and force method.


    //Now to find out how deep the 'Simple Key' would be
    //In order to do that, the width is needed
    //Each entry will be Symbol (x 1.5 factor) + space + Symbol number + 3 spaces
    //spacing between rows is equivalent to the width of a space character
    Screen->Cursor = crHourGlass;
    printingbackstitches = true;
    Printer()->Title = Caption + "_Cross_Stitch_Chart";
    Printer()->BeginDoc();

    PrintBackstitchPages();


    Printer()->EndDoc();
    Screen->Cursor = crDefault;

}
//---------------------------------------------------------------------------

bool __fastcall TPlanForm::FindIntersection(float X1, float Y1, float X2, float Y2, float X3, float Y3, float X4, float Y4)
{
    //this finds if there is an intersection between two line segments, returning true if there is.
    //If there is, the X & Y position is put into global variables XIntersect & YIntersect
    //The stitch line will be in points 1 & 2, the boundary line in 3 & 4

    //quick check for parallel lines, if they are, then they won't intersect
    if ((X1 == X2 && X3 == X4) || (Y1 == Y2 && Y3 == Y4)) return false;

    //get the parameters
    float t1, t2;
    /*
    The following is based on finding the intersection between to parametric lines
    Where line 1 is described by X = X1 + t1 * (X2 - X1)
                                 Y = Y1 + t1 * (Y2 - Y1)
                                 also
                                 X = X3 + t2 * (X4 - X3)
                                 Y = Y3 + t2 * (Y4 - Y3)
    This gives 2 equations & 2 variables and two ways of orienting each equation
    to avoid a division by zero.
    */
    try {
        if (X4 == X3) {
            t1 = (X3 - X1 + Y1 * (X4 - X3)/(Y4 - Y3))/(X2 - X1 - (X2 - X1) * (X4 - X3)/(Y4 - Y3));
            t2 = (X1 + t1 * (Y2 - Y1))/(Y4 - Y3);
            } else {
            if ( (Y2 - Y1 - (Y2 - Y1) * (Y4 - Y3)/(X4 - X3)) == 0.0) {
                t1 = (X3 - X1 + Y1 * (X4 - X3)/(Y4 - Y3))/(X2 - X1 - (X2 - X1) * (X4 - X3)/(Y4 - Y3));
                } else {
                t1 = (Y3 - Y1 + X1 * (Y4 - Y3)/(X4 - X3))/(Y2 - Y1 - (Y2 - Y1) * (Y4 - Y3)/(X4 - X3));
                }
            t2 = (Y1 + t1 * (X2 - X1))/(X4 - X3);
            }

        if (t1 >= 0.0 && t1 <= 1.0 && t2 >= 0.0 && t2 <= 0.0) {
            //it's found a match
            XIntersect = X1 + t1 * (X2 - X1);
            YIntersect = Y1 + t1 * (Y2 - Y1);
            return true;
            } else {
            return false;
            }
        }

    catch (...) {
        //division by zero cannot be avoided, so probably doesn't intersect anyway
        return false;
        }


}
//---------------------------------------------------------------------------

pageinfo __fastcall TPlanForm::FindPages(void)
{
    //finds the number of pages in the plan document

    //The chart is printed on a page.
    //If the chart is too wide & high to be printed on a single page, then it is
    //spanned over several pages wide and several pages high

    //The chart may have a simple key at the top.
    //Then the chart fills up the remainder of the page.
    //On the top edge is the number of the stitch, numbered every 10.
    //On the right edge is the number of the stitch, numbered every 10.
    //Every 10 stitches there is a solid black line replacing the grey
    //line surrounding each symbol.
    //At the centre the stitch is overlayed with an asterisk.
    //At the centre lines a purple line is drawn over the grey line surrounding each symbol
    //The purple line is drawn before the 10 stitch solid, so it's overwritten
    //if it's at a 'ten's' line, however as it's double the width of the 10s line some
    //may peek out on either side.

    //All-in-all this routine uses no elegant programming, just the brute ignorance
    //and force method.


    //Now to find out how deep the 'Simple Key' would be
    //In order to do that, the width is needed
    //Each entry will be Symbol (x 1.5 factor) + space + Symbol number + 3 spaces
    //spacing between rows is equivalent to the width of a space character
    //Uses the 'Printer()' canvas regardless of the actual canvas used because the only
    //important destination is the printer canvas, and it's the number of printer pages that it's
    //concerned with.
    //printingbackstitches = true;
    Printer()->Title = Caption + "_Cross_Stitch_Chart";
    //Printer()->Canvas->Font->Name = "Arial";
    //Printer()->Canvas->Font->Size = 8;
    Printer()->Canvas->Font->Name = ChartPrintout.ChartFont;
    Printer()->Canvas->Font->Size = ChartPrintout.ChartFontSize;
    Printer()->Canvas->Font->Color = clBlack;

    int rowspacing = Printer()->Canvas->TextWidth(" ");
    int keyentrywidth = GlyphSize * 1.5 + Printer()->Canvas->TextWidth("    " + AnsiString(PictureColourPallette.Length));
    int keyentryheight = Printer()->Canvas->TextHeight("Tq");
    if (keyentryheight < GlyphSize * 1.5) keyentryheight = GlyphSize * 1.5;
    int keyentrycolumns = Printer()->PageWidth/keyentrywidth;
    keyentryheight += rowspacing;
    int keyentryrows = PictureColourPallette.Length/ keyentrycolumns + 1;
    int keyheight = keyentryrows * keyentryheight + rowspacing;
    //if the key is too long, there may not be enough room on the page for the simple key
    SimpleKey->OnClick = NULL;
    if (keyheight > (Printer()->PageHeight - 3 *(GlyphSize + rowspacing))) {
        SimpleKey->Checked = false;
        SimpleKey->Enabled = false;
        } else {
        SimpleKey->Enabled = true;
        }
    SimpleKey->OnClick = PrintCountChange;
    if (!SimpleKey->Checked) keyheight = keyentryheight;

    //now to find out how many glyphs etc
    int annotationwidth = Printer()->Canvas->TextWidth("  " + AnsiString(Image1->Height));
    int pageheight = Printer()->PageHeight - keyheight - 3 * keyentryheight;
    int pagewidth = Printer()->PageWidth - 2* annotationwidth - 2 * rowspacing;
    int pageglyphwidth = pagewidth/GlyphSize;
    int pageglyphheight = pageheight/GlyphSize;
    if (MultiplesofTenCheckBox->Checked) {
        //without the next checks, there's a risk of there being no symbols on a page
        if (pageglyphwidth > 10) {
            pageglyphwidth = pageglyphwidth / 10;
            pageglyphwidth = 10 * pageglyphwidth;
            }
        if (pageglyphheight > 10) {
            pageglyphheight = pageglyphheight / 10;
            pageglyphheight = 10 * pageglyphheight;
            }
        }
    int pageswide = Image1->Width/pageglyphwidth + 1;
    int pageshigh = Image1->Height/pageglyphheight + 1;

    pageinfo DocumentPageInfo;

    DocumentPageInfo.columns = pageswide;
    DocumentPageInfo.rows = pageshigh;
    DocumentPageInfo.numglyphswide = pageglyphwidth;
    DocumentPageInfo.numglyphshigh = pageglyphheight;

    return  DocumentPageInfo;


}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::Button1Click(TObject *Sender)
{
    //print page info.
    pageinfo info = FindPages();
    Memo1->Lines->Add("In the chart there are " + AnsiString(info.rows) + " rows and " + AnsiString(info.columns) + " columns of pages.");
    Memo1->Lines->Add("In the chart, each page shows " + AnsiString(info.numglyphswide) + " x " + AnsiString(info.numglyphshigh) + " stitches");
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::CopyPlanXRef1Click(TObject *Sender)
{
    //create plan vs picture xref of page numbers;
    pageinfo info = FindPages();
    Graphics::TBitmap *Picture = new Graphics::TBitmap();
    Picture->Width = Image1->Picture->Bitmap->Width + info.columns + 1;
    Picture->Height = Image1->Picture->Bitmap->Height + info.rows + 1;

    CreatePageXRef(Picture->Canvas);

    unsigned int DataHandle = 0;
    HPALETTE APalette;
    unsigned short MyFormat = CF_BITMAP;
    try {
        // generate a clipboard format, with data and palette
        // save the data to the clipboard using that format and
        // the generated data
        //The use of an intervening bitmap allows the background to be either transparent or solid.
        //If the Image1->Picture->Bitmap is saved straight to clipboard, then the transparency info is
        //lost.
        Picture->SaveToClipboardFormat(MyFormat,DataHandle,APalette);
        Clipboard()->SetAsHandle(CF_BITMAP,DataHandle);
        }

    catch (...) {
        ShowMessage("Sorry, Failed to copy image to clipboard.");
        }

    delete Picture;


}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::CreatePageXRef(TCanvas *Canvas)
{
    pageinfo info = FindPages();
    int CanvasWidth = Image1->Picture->Bitmap->Width + info.columns + 1;
    int CanvasHeight = Image1->Picture->Bitmap->Height + info.rows + 1;
    TRect FillRect = Rect(0, 0, CanvasWidth, CanvasHeight);
    Canvas->Brush->Color = clRed;
    Canvas->Brush->Style = bsSolid;
    Canvas->FillRect(FillRect);
    //Picture->Canvas->Font->Color = clWhite;
    Canvas->Font->Size = 18;
    int textwidth;
    int textheight;
    AnsiString text;

    for (int i = 0; i < info.rows; i++) {
        for (int j = 0; j < info.columns; j++) {
            TRect SourceRect = Rect(j*info.numglyphswide, i*info.numglyphshigh, j*info.numglyphswide + info.numglyphswide, i*info.numglyphshigh + info.numglyphshigh );
            TRect DestRect = Rect(j*info.numglyphswide + j + 1, i*info.numglyphshigh + i + 1, j*info.numglyphswide + info.numglyphswide + j + 1, i*info.numglyphshigh + info.numglyphshigh + i + 1);
            Canvas->CopyRect(DestRect,Image1->Picture->Bitmap->Canvas,SourceRect);
            text = AnsiString(i*info.columns + j + 1);
            textwidth = Canvas->TextWidth(text);
            textheight = Canvas->TextHeight(text);
            int x = j*info.numglyphswide + j + 1 + (info.numglyphswide - textwidth)/2;
            if (x + textwidth > CanvasWidth) {
                x = j*info.numglyphswide + j + 1 + (((CanvasWidth - (j*info.numglyphswide + j + 1)) - textwidth)/2) ;
                }
            if (x + textwidth > CanvasWidth) {
                x = CanvasWidth - textwidth - 1;
                }
            int y = i*info.numglyphshigh + i + 1 + (info.numglyphshigh - textheight)/2;
            if (y + textheight > CanvasHeight) {
                y = i*info.numglyphshigh + j + 1 + (((CanvasHeight - (i*info.numglyphshigh + i + 1)) - textheight)/2) ;
                }
            if (y + textheight > CanvasHeight) {
                y = CanvasHeight - textheight - 1;
                }
            TPenMode psMode = Canvas->Pen->Mode;
            TBrushStyle bsMode = Canvas->Brush->Style;
            Canvas->Pen->Mode = pmCopy;
            Canvas->Brush->Style = bsClear;
            //now need to determine the colour to print in. If the background is bright, then print in black, else white
            TColor pixelcolour;
            int red;
            int green;
            int blue;
            int localbrightness;
            int totalbrightness = 0;
            int total = 0;
            for (int k = x; k < x + textwidth + 1; k++) {
                for (int l = y; l < y + textheight + 1; l++) {
                    pixelcolour = Canvas->Pixels[k][l];
                    blue = (int) (pixelcolour / 65536);
                    green = (int) ((pixelcolour /256) - blue * 256);
                    red = (int) pixelcolour - green * 256 - blue * 65536;
                    localbrightness = red + green + blue;
                    localbrightness = localbrightness/3;
                    totalbrightness += localbrightness;
                    total++;
                    }
                }
            totalbrightness = totalbrightness/total;
            if ( totalbrightness > 140) {
                Canvas->Font->Color = clBlack;
                } else {
                Canvas->Font->Color = clWhite;
                }

            Canvas->TextOut(x,y,text);
            Canvas->Pen->Mode = psMode;
            Canvas->Brush->Style = bsMode;
            }
        }

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::CreateImage4(void)
{
    //create plan vs picture xref of page numbers;
    pageinfo info = FindPages();
    Image4->Width = Image1->Picture->Bitmap->Width + info.columns + 1;
    Image4->Height = Image1->Picture->Bitmap->Height + info.rows + 1;
    Image4->Picture->Bitmap->Width = Image4->Width;
    Image4->Picture->Bitmap->Height = Image4->Height;
    Image4->Top = Image1->Top + Image1->Height + 1;

    CreatePageXRef(Image4->Picture->Bitmap->Canvas);
    GroupBox1->Left = Image4->Left + Image4->Width + 8;
    GroupBox2->Left = GroupBox1->Left;
    GroupBox3->Left = GroupBox1->Left;
    GroupBox1->Width = ClientWidth - 8 - GroupBox1->Left;
    GroupBox2->Width = GroupBox1->Width;
    GroupBox3->Width = GroupBox1->Width;

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::SavePageIndex1Click(TObject *Sender)
{
    //saves the page index
    SavePictureDialog1->FileName = ChangeFileExt(OpenDialog1->FileName, " Plan Index.bmp");
    if (SavePictureDialog1->Execute()) {
        Image4->Picture->SaveToFile(SavePictureDialog1->FileName);
        }

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::PrintPageStitchInfoClick(TObject *Sender)
{

    //this is a slightly mad idea, but is intended to print off the stitch usage for each page.
    Screen->Cursor = crHourGlass;
    AnsiString printouttitle = Caption + "_SPP";
    Printer()->Title = printouttitle;
    Printer()->BeginDoc();

    PrintSPPPages();

    Printer()->EndDoc();
    Screen->Cursor = crDefault;


}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::UseAnchorClick(TObject *Sender)
{
    PrintPageStitchInfo->Enabled = !UseAnchor->Checked;

}
//---------------------------------------------------------------------------

int __fastcall TPlanForm::FindColoutRefAtPixel(int X, int Y)
{
    bool found = false;
    int counter = 0;
    while (!found && counter < PictureColourPallette.Length) {
        if (Image1->Canvas->Pixels[X][Y] == PictureColourPallette[counter].Colour) {
            counter--;
            found = true;
            }
        counter++;
        }
    return counter;
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::OpenImage1Click(TObject *Sender)
{
    if (OpenDialog1->Execute()) {
        Screen->Cursor = crHourGlass;
        //OriginalImage->LoadFromFile(OpenDialog1->FileName);
        AnsiString Ext = ExtractFileExt(OpenDialog1->FileName).LowerCase();
        if (Ext == ".bmp" || Ext == ".jpg" || Ext == ".jpeg" || Ext == "*.emf") {
            //this round the houses methodology allows jpegs & emfs to be loaded
            TImage *TempImage = new TImage(this);
            TempImage->AutoSize = true;
            TempImage->Picture->LoadFromFile(OpenDialog1->FileName);
            OriginalImage->Width = TempImage->Width;
            OriginalImage->Height = TempImage->Height;
            OriginalImage->Canvas->Draw(0,0,TempImage->Picture->Graphic);
            delete TempImage;
            }
        if (Ext == ".gif") {
            TGIFImage *Gif = new TGIFImage();
            Gif->LoadFromFile(OpenDialog1->FileName);
            OriginalImage->Assign(Gif);
            delete Gif;
            }
        OriginalImageFile.loaded = true;
        OriginalImageFile.filename = OpenDialog1->FileName;
        OriginalImageFile.saved = true;
        backstitcheschanged = true;
        Screen->Cursor = crDefault;
        }
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::SaveHighResImage1Click(TObject *Sender)
{
    //Save the image
    SavePictureDialog1->FileName = OriginalImageFile.filename;
    if (SavePictureDialog1->Execute()) {
        Screen->Cursor = crHourGlass;
        OriginalImage->SaveToFile(SavePictureDialog1->FileName);
        OriginalImageFile.filename = SavePictureDialog1->FileName;
        OriginalImageFile.saved = true;
        Screen->Cursor = crDefault;
        backstitcheschanged = true;
        }

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::CopyHighResImage1Click(TObject *Sender)
{
    unsigned int DataHandle = 0;
    HPALETTE APalette;
    unsigned short MyFormat = CF_BITMAP;
    Graphics::TBitmap *Bitmap = new Graphics::TBitmap();
    try {
        // generate a clipboard format, with data and palette
        // save the data to the clipboard using that format and
        // the generated data
        Bitmap->Width = OriginalImage->Width;
        Bitmap->Height = OriginalImage->Height;
        Bitmap->Canvas->Draw(0,0,OriginalImage);
        Bitmap->SaveToClipboardFormat(MyFormat,DataHandle,APalette);
        Clipboard()->SetAsHandle(CF_BITMAP,DataHandle);
        }

    catch (...) {
        ShowMessage("Sorry, Failed to copy image to clipboard.");
        }

    delete Bitmap;

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::PasteHighResImage1Click(TObject *Sender)
{
    //Paste picture into Image1 and act on it.
    TClipboard *pCB = Clipboard();
    if (pCB->HasFormat(CF_BITMAP))
    {
        Graphics::TBitmap *pBitmap = new Graphics::TBitmap();
        Screen->Cursor = crHourGlass;
        try {
            pBitmap->LoadFromClipboardFormat(CF_BITMAP, pCB->GetAsHandle(CF_BITMAP), 0);
            OriginalImage->Width = pBitmap->Width;
            OriginalImage->Height = pBitmap->Height;
            OriginalImage->Canvas->Draw(0,0,pBitmap);
            OriginalImageFile.loaded = true;
            OriginalImageFile.filename = ExtractFilePath(OpenDialog1->FileName) + "\High Res Image.bmp";
            OriginalImageFile.saved = false;
            backstitcheschanged = true;
            }
        catch (...) {
            ShowMessage("Error during Paste Operation");
            }
        delete pBitmap;
        Screen->Cursor = crDefault;

    }


}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::TransparencyBackStitch1Click(TObject *Sender)
{
    //OK. This is an interesting unit, which it's hoped will take over from the
    //back stitch unit when there is a high res image in memory.

    //TTransparencyForm *TransparencyForm = new TTransparencyForm(this);

    TransparencyForm->ChartImage->Assign(Image1->Picture->Bitmap);
    TransparencyForm->OriginalImage->Assign(OriginalImage);
    TransparencyForm->offsetx = OriginalImageFile.offsetx;
    TransparencyForm->offsety = OriginalImageFile.offsety;
    TransparencyForm->scale = OriginalImageFile.scalefactor;

    //now fill in the thread colours in the TransparencyForm unit.
    TransparencyForm->ColourList.Length = DMCColourList.Length;
    for (int i = 0; i < DMCColourList.Length; i++) {
        TransparencyForm->ColourList[i].DMCColourName = DMCColourList[i].DMCColourName;
        TransparencyForm->ColourList[i].Colour = DMCColourList[i].Colour;
        TransparencyForm->ColourList[i].DrawWhite = DMCColourList[i].DrawWhite;
        TransparencyForm->ColourList[i].StitchCount = DMCColourList[i].StitchCount;
        }
    TransparencyForm->FillColourList();
    
    TransparencyForm->UsedColourList.Length = PictureColourPallette.Length;
    for (int i = 0; i < PictureColourPallette.Length; i++) {
        TransparencyForm->UsedColourList[i].DMCColourName = PictureColourPallette[i].DMCColourName;
        TransparencyForm->UsedColourList[i].Colour = PictureColourPallette[i].Colour;
        TransparencyForm->UsedColourList[i].DrawWhite = PictureColourPallette[i].DrawWhite;
        TransparencyForm->UsedColourList[i].StitchCount = PictureColourPallette[i].StitchCount;
        }
    TransparencyForm->FillUsedColourList();

    //Fill the BackStitch array
    TransparencyForm->BackStitchList.Length = BackStitches.Length;
    for (int i = 0; i < BackStitches.Length; i++) {
        TransparencyForm->BackStitchList[i].X1 = BackStitches[i].X1;
        TransparencyForm->BackStitchList[i].Y1 = BackStitches[i].Y1;
        TransparencyForm->BackStitchList[i].X2 = BackStitches[i].X2;
        TransparencyForm->BackStitchList[i].Y2 = BackStitches[i].Y2;
        TransparencyForm->BackStitchList[i].ColourNumber = BackStitches[i].ColourNumber;
        TransparencyForm->BackStitchList[i].Colour = BackStitches[i].Colour;
        }

    TransparencyForm->SetSpinButtons();
    TransparencyForm->CreateDisplayImage();

    if (TransparencyForm->ShowModal() == mrOk) {
        Screen->Cursor = crHourGlass;
        if (BackStitches.Length != TransparencyForm->BackStitchList.Length || OriginalImageFile.offsetx != TransparencyForm->offsetx || OriginalImageFile.offsety != TransparencyForm->offsety || OriginalImageFile.scalefactor != TransparencyForm->scale || TransparencyForm->stitcheschanged) backstitcheschanged = true;
        OriginalImageFile.offsetx = TransparencyForm->offsetx;
        OriginalImageFile.offsety = TransparencyForm->offsety;
        OriginalImageFile.scalefactor = TransparencyForm->scale;

        //Right. The Back Stitches have been approved, so load them into the stitch list
        if (TransparencyForm->stitcheschanged) {
            BackStitches.Length = TransparencyForm->BackStitchList.Length;
            for (int i = 0; i < TransparencyForm->BackStitchList.Length; i++) {
                BackStitches[i].X1 = TransparencyForm->BackStitchList[i].X1;
                BackStitches[i].Y1 = TransparencyForm->BackStitchList[i].Y1;
                BackStitches[i].X2 = TransparencyForm->BackStitchList[i].X2;
                BackStitches[i].Y2 = TransparencyForm->BackStitchList[i].Y2;
                BackStitches[i].ColourNumber = TransparencyForm->BackStitchList[i].ColourNumber;
                BackStitches[i].Colour = TransparencyForm->BackStitchList[i].Colour;
                }
            }
        //check to see if any new colours have been added to the used pallette
        if (TransparencyForm->UsedColourList.Length != PictureColourPallette.Length) {
            PictureColourPallette.Length = TransparencyForm->UsedColourList.Length;
            for (int i = 0; i < PictureColourPallette.Length; i++) {
                PictureColourPallette[i].DMCColourName = TransparencyForm->UsedColourList[i].DMCColourName;
                PictureColourPallette[i].Colour = TransparencyForm->UsedColourList[i].Colour;
                PictureColourPallette[i].DrawWhite = TransparencyForm->UsedColourList[i].DrawWhite;
                PictureColourPallette[i].StitchCount = TransparencyForm->UsedColourList[i].StitchCount;
                //now to get the other data entered
                bool found = false;
                int pointer = 0;
                while (!found && pointer < DMCColourList.Length) {
                    if (PictureColourPallette[i].DMCColourName == DMCColourList[pointer].DMCColourName) {
                        found = true;
                        pointer--;
                        }
                    pointer++;
                    }
                if (found) {
                    PictureColourPallette[i].DMCColourNumber = DMCColourList[pointer].DMCColourNumber;
                    PictureColourPallette[i].AnchorColourNumber = DMCColourList[pointer].AnchorColourNumber;
                    } else {
                    Application->MessageBox("Unknown Colours Found on returning from TransparencyForm","Error",MB_OK + MB_ICONEXCLAMATION);
                    }
                }
            }

        //if the picture has changed, load it in
        if (TransparencyForm->imagechanged) {
            Image1->Picture->Bitmap->Assign(TransparencyForm->ChartImage);
            PictureChanged = true;
            }


        //recalculate the number of equivalent stitches. Each backstitch
        //will take about the same length as an additional cross stitch.
        CountCrossStitches();
        CountBackStitches();
        AssignAnchorColours();
        PrintBackStitches1->Enabled = (bool)BackStitches.Length;
        FillPrinterData();
        Screen->Cursor = crDefault;

        }

    //delete TransparencyForm;

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
    if (PictureChanged) {
        TMsgDlgButtons temp_set;
        temp_set<< mbYes<<mbNo <<mbCancel;
        String buffer = "Save changes to " + PictureFileName + "?";

        switch(MessageDlg(buffer, mtConfirmation,temp_set,0))
            {
            case mrYes:
                {
                Image1->Picture->SaveToFile(PictureFileName);
                if (OriginalImageFile.loaded && !OriginalImageFile.saved) {
                    if (!OriginalImageFile.filename.Length()) OriginalImageFile.filename = ChangeFileExt(PictureFileName,"high res image.bmp");
                    OriginalImage->SaveToFile(OriginalImageFile.filename);
                    }
                if (backstitcheschanged) SaveStitches(ChangeFileExt(PictureFileName,".bs"));
                }
                break;
            case mrCancel:
                CanClose=false;
                break;
            default: break;
            }

        } else {
        if (backstitcheschanged) {
            TMsgDlgButtons temp_set;
            temp_set<< mbYes<<mbNo <<mbCancel;
            String buffer = "Save changes to " + PictureFileName + " Project?";

            switch(MessageDlg(buffer, mtConfirmation,temp_set,0))
                {
                case mrYes:
                    if (OriginalImageFile.loaded && !OriginalImageFile.saved) {
                        if (!OriginalImageFile.filename.Length()) OriginalImageFile.filename = ChangeFileExt(PictureFileName,"high res image.bmp");
                        OriginalImage->SaveToFile(OriginalImageFile.filename);
                        }
                    SaveStitches(ChangeFileExt(PictureFileName,".bs"));
                    break;
                case mrCancel:
                    CanClose=false;
                    break;
                default: break;
                }

            }
        }
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::PrintWholeChartDocument1Click(TObject *Sender)
{
    //Print whole document
    TDefinePrintoutForm *DefinePrintoutForm = new TDefinePrintoutForm(this);

    //initialise data
    DefinePrintoutForm->ChartPrintout = ChartPrintout;
    DefinePrintoutForm->BackStitches->Enabled = (bool) BackStitches.Length;
    for (int i = 0; i < PageNumber->Items->Count; i++) {
        DefinePrintoutForm->PageNumber->Items->Add(PageNumber->Items->Strings[i]);
        }
    DefinePrintoutForm->PageNumber->ItemIndex = PageNumber->ItemIndex;
    DefinePrintoutForm->Initialise();

    if (DefinePrintoutForm->ShowModal() == mrOk) {
        ChartPrintout = DefinePrintoutForm->RetrieveData();
        if (!DefinePrintoutForm->Accept) {
            PageNumber->ItemIndex =  DefinePrintoutForm->PageNumber->ItemIndex;

            if (ChartPrintout.FrontSheet || ChartPrintout.IndexPage || ChartPrintout.ColourChart || ChartPrintout.MonochromeChart || ChartPrintout.BackStitches || ChartPrintout.DetailedKey || ChartPrintout.StitchesPerPage || ChartPrintout.FabricDetails ) {

                //now to do the chart printing;
                Screen->Cursor = crHourGlass;
                //update cross ref image
                CreateImage4();
                AnsiString fabric = Caption + " Chart Doc";
                Printer()->Title = fabric;
                Printer()->BeginDoc();
                pageinfo PageInfo = FindPages();
                try {
                    int sectioncount = 0;
                    if (ChartPrintout.FrontSheet) sectioncount++;
                    if (ChartPrintout.IndexPage) sectioncount++;
                    if (ChartPrintout.ColourChart) sectioncount++;
                    if (ChartPrintout.MonochromeChart) sectioncount++;
                    if (ChartPrintout.BackStitches && BackStitches.Length) sectioncount++;
                    if (ChartPrintout.DetailedKey) sectioncount++;
                    if (ChartPrintout.StitchesPerPage) sectioncount++;
                    if (ChartPrintout.FabricDetails) sectioncount++;

                    if (ChartPrintout.FrontSheet)  {
                        PrintFrontSheet();
                        sectioncount--;
                        if (sectioncount > 0) Printer()->NewPage();
                        }
                    if (ChartPrintout.IndexPage) {
                        PrintIndexPage();
                        sectioncount--;
                        if (sectioncount > 0) Printer()->NewPage();
                        }
                    if (ChartPrintout.ColourChart) {
                        bool temp = PrintColour->Checked;
                        PrintColour->OnClick = NULL;
                        PrintColour->Checked = true;
                        PageNumber->ItemIndex = DefinePrintoutForm->PageNumber->ItemIndex;
                        PrintChartSheets();
                        sectioncount--;
                        if (sectioncount > 0) Printer()->NewPage();
                        PrintColour->Checked = temp;
                        PrintColour->OnClick = PlanForm->PrintCountChange;
                        }
                    if (ChartPrintout.MonochromeChart) {
                        bool temp = PrintColour->Checked;
                        PrintColour->OnClick = NULL;
                        PrintColour->Checked = false;
                        PageNumber->ItemIndex = DefinePrintoutForm->PageNumber->ItemIndex;
                        PrintChartSheets();
                        sectioncount--;
                        if (sectioncount > 0) Printer()->NewPage();
                        PrintColour->Checked = temp;
                        PrintColour->OnClick = PlanForm->PrintCountChange;
                        }
                    if (ChartPrintout.BackStitches && BackStitches.Length) {
                        bool temp = PrintColour->Checked;
                        PrintColour->OnClick = NULL;
                        PageNumber->ItemIndex = DefinePrintoutForm->PageNumber->ItemIndex;
                        PrintBackstitchPages();
                        sectioncount--;
                        if (sectioncount > 0) Printer()->NewPage();
                        PrintColour->Checked = temp;
                        PrintColour->OnClick = PlanForm->PrintCountChange;
                        }
                    if (ChartPrintout.DetailedKey) {
                        //PrintKeyPages();
                        //line above was replaced by the next 6 lines
                        LocalChartPrintout = ChartPrintout;
                        int keypages = FindPagesforKey();
                        for (int i = 0; i < keypages; i++) {
                            DrawKeySheet(Printer()->Canvas,Printer()->PageWidth,Printer()->PageHeight,i,10);
                            if (i < keypages -1) Printer()->NewPage();
                            }
                        sectioncount--;
                        if (sectioncount > 0) Printer()->NewPage();
                        }
                    if (ChartPrintout.StitchesPerPage) {
                        //PrintSPPPages();
                        int spppages = FindPagesforSPP();
                        for (int i = 0; i < spppages; i++) {
                            DrawSPPSheet(Printer()->Canvas,Printer()->PageWidth,Printer()->PageHeight,i,PageInfo,10);
                            if (i < spppages -1) Printer()->NewPage();
                            }
                        sectioncount--;
                        if (sectioncount > 0) Printer()->NewPage();
                        }
                    if (ChartPrintout.FabricDetails) {
                        //PrintFabricPages();
                        DrawFabricSheet(Printer()->Canvas,Printer()->PageWidth,Printer()->PageHeight);
                        sectioncount--;
                        if (sectioncount > 0) Printer()->NewPage();
                        }
                    }
                __finally {
                    Printer()->EndDoc();
                    Screen->Cursor = crDefault;
                    backstitcheschanged = true;
                    }
                }
            }
        }


    delete DefinePrintoutForm;
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::PrintFrontSheet(void)
{
    //Prints the details of the background fabric.

    double scale, scalex, scaley;
    int topx, topy, picturewidth, pictureheight;
    if (OriginalImage->Empty) {
        //print chart image
        scalex = (double) (Printer()->PageWidth/Image1->Width);
        scaley = (double) (Printer()->PageHeight/Image1->Height);
        if (scalex <= scaley) {
        //if (scalex >= scaley) {
            scale = scalex;
            } else {
            scale = scaley;
            }
        scale = scale/2;
        topx = (Printer()->PageWidth - (int)((double)Image1->Width * scale))/2;
        topy = (Printer()->PageHeight - (int)((double)Image1->Height * scale))/2;
        picturewidth = (int)((double)Image1->Width * scale);
        pictureheight = (int)((double)Image1->Height * scale);
        bool trans = Image1->Transparent;
        Image1->Transparent = false;
        Printer()->Canvas->StretchDraw(Rect(topx,topy,topx + picturewidth,topy + pictureheight),Image1->Picture->Bitmap);
        Image1->Transparent = trans;
        } else {
        //print high res image
        scalex = (double) (Printer()->PageWidth/OriginalImage->Width);
        scaley = (double) (Printer()->PageHeight/OriginalImage->Height);
        if (scalex >= scaley) {
            scale = scalex;
            } else {
            scale = scaley;
            }
        scale = scale/2;
        topx = (Printer()->PageWidth - (int)((double)OriginalImage->Width * scale))/2;
        topy = (Printer()->PageHeight - (int)((double)OriginalImage->Height * scale))/2;
        picturewidth = (int)((double)OriginalImage->Width * scale);
        pictureheight = (int)((double)OriginalImage->Height * scale);
        Printer()->Canvas->StretchDraw(Rect(topx,topy,topx + picturewidth,topy + pictureheight),OriginalImage);
        }

    //now to print out the title etc
    if (ChartPrintout.Title.Length()) {
        Printer()->Canvas->Font->Name = ChartPrintout.TitleFont;
        Printer()->Canvas->Font->Size = ChartPrintout.TitleSize;
        int titletopx = (Printer()->PageWidth - Printer()->Canvas->TextWidth(ChartPrintout.Title))/2;
        int titletopy = (topy - Printer()->Canvas->TextHeight(ChartPrintout.Title))/2;
        Printer()->Canvas->TextOut(titletopx,titletopy,ChartPrintout.Title);
        }

    if (ChartPrintout.ImageCopyright.Length()) {
        Printer()->Canvas->Font->Name = ChartPrintout.ImageCopyrightFont;
        Printer()->Canvas->Font->Size = ChartPrintout.ImageCopyrightSize;
        int picturebottom = topy + pictureheight;
        int titletopx = (Printer()->PageWidth - Printer()->Canvas->TextWidth(ChartPrintout.ImageCopyright))/2;
        int titletopy = (Printer()->PageHeight + picturebottom)/2 - Printer()->Canvas->TextHeight(ChartPrintout.ImageCopyright);
        Printer()->Canvas->TextOut(titletopx,titletopy,ChartPrintout.ImageCopyright);
        }

    if (ChartPrintout.ChartCopyright.Length()) {
        Printer()->Canvas->Font->Name = ChartPrintout.ChartCopyrightFont;
        Printer()->Canvas->Font->Size = ChartPrintout.ChartCopyrightSize;
        int picturebottom = topy + pictureheight;
        int titletopx = (Printer()->PageWidth - Printer()->Canvas->TextWidth(ChartPrintout.ChartCopyright))/2;
        int titletopy = (Printer()->PageHeight + picturebottom)/2 + Printer()->Canvas->TextHeight(ChartPrintout.ChartCopyright);
        Printer()->Canvas->TextOut(titletopx,titletopy,ChartPrintout.ChartCopyright);
        }

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::PrintIndexPage(void)
{
    //When printing the index page, need to know how many pages there are going to be
    //in each section & if the section exists.
    int FrontPage = 1;
    int IndexPage = 1;
    pageinfo ChartInfo = FindPages();
    int ColourChart = ChartInfo.rows * ChartInfo.columns;
    if (PageNumber->ItemIndex != 0) {
        //only printing a single page from the chart
        ColourChart = 1;
        }
    int MonochromeChart = ColourChart;
    int BackStitch = ColourChart;
    int DetailedKey = FindPagesforKey();
    int StitchesPerPage = FindPagesforSPP();
    int FabricDetails = 1;

    int CurrentPage = 1;

    //right. That's all the page numbers calculated & it's time to start printing the page.
    //Printer()->Canvas->Font->Name = "Arial";
    Printer()->Canvas->Font->Name = ChartPrintout.ChartFont;
    Printer()->Canvas->Font->Size = ChartPrintout.TitleSize;
    int rowspacing = Printer()->Canvas->TextHeight("Hg")*1.5;
    int rowcount = 3;
    int textx;
    int texty;
    AnsiString text;

    //Print "Contents"
    textx = (Printer()->PageWidth - Printer()->Canvas->TextWidth("Contents"))/2;
    texty = rowcount * rowspacing;
    Printer()->Canvas->TextOut(textx,texty,"Contents");

    //Print header line
    rowcount += 2;
    int offsettexty = rowcount * rowspacing;
    if (ChartPrintout.TitleSize > 12) {
        Printer()->Canvas->Font->Size = 12;
        }
    rowspacing = Printer()->Canvas->TextHeight("Hg")*1.5;
    rowcount = 0;
    texty = offsettexty + rowcount * rowspacing;
    int tab1 = Printer()->Canvas->TextWidth("Page");
    int tab2 = Printer()->Canvas->TextWidth("Page      ") + tab1;
    Printer()->Canvas->TextOut(tab1,texty,"Page");
    Printer()->Canvas->TextOut(tab2,texty,"Section");

    //Print front page
    if (ChartPrintout.FrontSheet) {
        rowcount++;
        texty = offsettexty + rowcount * rowspacing;
        Printer()->Canvas->TextOut(tab1,texty,AnsiString(CurrentPage));
        Printer()->Canvas->TextOut(tab2,texty,"Front Sheet");
        CurrentPage += FrontPage;
        }
    //Print index page
    if (ChartPrintout.IndexPage) {
        rowcount++;
        texty = offsettexty + rowcount * rowspacing;
        Printer()->Canvas->TextOut(tab1,texty,AnsiString(CurrentPage));
        Printer()->Canvas->TextOut(tab2,texty,"Contents");
        CurrentPage += IndexPage;
        }
    //Print ColourChart
    if (ChartPrintout.ColourChart) {
        rowcount++;
        text = "Colour Chart";
        if (PageNumber->ItemIndex != 0) {
            //only printing a single page from the chart
            text += ", Sheet " + AnsiString(PageNumber->ItemIndex);
            }
        texty = offsettexty + rowcount * rowspacing;
        Printer()->Canvas->TextOut(tab1,texty,AnsiString(CurrentPage));
        Printer()->Canvas->TextOut(tab2,texty,text);
        CurrentPage += ColourChart;
        }
    //Print MonochromeChart
    if (ChartPrintout.MonochromeChart) {
        rowcount++;
        texty = offsettexty + rowcount * rowspacing;
        text = "Monochrome Chart";
        if (PageNumber->ItemIndex != 0) {
            //only printing a single page from the chart
            text += ", Sheet " + AnsiString(PageNumber->ItemIndex);
            }
        Printer()->Canvas->TextOut(tab1,texty,AnsiString(CurrentPage));
        Printer()->Canvas->TextOut(tab2,texty,text);
        CurrentPage += MonochromeChart;
        }
    //Print BackStitches
    if (BackStitches.Length > 0) {
        if (ChartPrintout.BackStitches) {
            rowcount++;
            texty = offsettexty + rowcount * rowspacing;
            text = "Back Stitches";
            if (PageNumber->ItemIndex != 0) {
                //only printing a single page from the chart
                text += ", Sheet " + AnsiString(PageNumber->ItemIndex);
                }
            Printer()->Canvas->TextOut(tab1,texty,AnsiString(CurrentPage));
            Printer()->Canvas->TextOut(tab2,texty,text);
            CurrentPage += BackStitch;
            }
        }
    //Print DetailedKey
    if (ChartPrintout.DetailedKey) {
        rowcount++;
        texty = offsettexty + rowcount * rowspacing;
        Printer()->Canvas->TextOut(tab1,texty,AnsiString(CurrentPage));
        Printer()->Canvas->TextOut(tab2,texty,"Detailed Key");
        CurrentPage += DetailedKey;
        }
    //Print StitchesPerPage
    if (ChartPrintout.StitchesPerPage) {
        rowcount++;
        texty = offsettexty + rowcount * rowspacing;
        Printer()->Canvas->TextOut(tab1,texty,AnsiString(CurrentPage));
        Printer()->Canvas->TextOut(tab2,texty,"Stitch Information for Each Page");
        CurrentPage += StitchesPerPage;
        }
    //Print FabricDetails
    if (ChartPrintout.FabricDetails) {
        rowcount++;
        texty = offsettexty + rowcount * rowspacing;
        Printer()->Canvas->TextOut(tab1,texty,AnsiString(CurrentPage));
        Printer()->Canvas->TextOut(tab2,texty,"Fabric Details");
        CurrentPage += FabricDetails;
        }

    //Print Chart Image
    //however, if no chart is being printed, why would you need a page xref?
    if (ChartPrintout.ChartPageXRef && (ChartPrintout.ColourChart || ChartPrintout.MonochromeChart || ChartPrintout.BackStitches)) {
        rowcount += 2;
        texty = offsettexty + rowcount * rowspacing;
        Printer()->Canvas->TextOut(tab1,texty,"Chart Page Index");
        rowcount++;
        texty = offsettexty + rowcount * rowspacing;
        int imagemaxheight = Printer()->PageHeight - texty;

        double scale, scalex, scaley, scaletext;
        int topx, topy, picturewidth, pictureheight;
        //print page x ref image
        scalex = (double) (Printer()->PageWidth/Image4->Width);
        scaley = (double) (imagemaxheight/Image4->Height);
        Image4->Canvas->Font->Size = 12;
        scaletext = ((double) Printer()->Canvas->TextHeight("Hg"))/((double)Image4->Canvas->TextHeight("Hg"));
        if (scalex >= scaley) {
            scale = scaley;
            } else {
            scale = scalex;
            }
        //this bit tries to ensure that the text size on the plan xref image is no bigger on the printed page than in the program
        if (scale > scaletext) scale = scaletext;
        topx = (Printer()->PageWidth - (int)((double)Image4->Width * scale))/2;
        topy = texty/*(Printer()->PageHeight - (int)((double)Image4->Height * scale))/2*/;
        picturewidth = (int)((double)Image4->Width * scale);
        pictureheight = (int)((double)Image4->Height * scale);
        Printer()->Canvas->StretchDraw(Rect(topx,topy,topx + picturewidth,topy + pictureheight),Image4->Picture->Bitmap);

        }

}
//---------------------------------------------------------------------------

int __fastcall TPlanForm::FindPagesforKey(void)
{
    //Calculate number of pages for the key
    //The printout columns will be of the form
    //Key Number, Key Shape, DMC Number/Anchor Number, DMC Name, Number of stitches, Approx Number of skeins
    //Printer()->Canvas->Font->Name = "Arial";
    //Printer()->Canvas->Font->Size = 10;
    Printer()->Canvas->Font->Name = ChartPrintout.ChartFont;
    Printer()->Canvas->Font->Size = ChartPrintout.ChartFontSize + 2;
    Printer()->Canvas->Font->Color = clBlack;
    int pages;

    int RowSpacing = 10;

    int SymbolWidth = Printer()->Canvas->TextWidth("Symbol");
    if (2 * GlyphSize > SymbolWidth) SymbolWidth = 2 * GlyphSize;
    int RowHeight = Printer()->Canvas->TextHeight("Tq");
    if (RowHeight < (2 * GlyphSize)) RowHeight = 2 * GlyphSize;
    //Right, now the only thing to do is to see how many pages there will be.
    int rowsperpage = Printer()->PageHeight/(RowHeight + RowSpacing) - 1;
    int numberofrows;
    //normal, no blending of threads
    if (UseAnchor->Checked) {
        numberofrows = 0;
        for (int i = 0; i < PictureColourPallette.Length; i++) {
            if (PictureColourPallette[i].AnchorStitchCount != 0) numberofrows++;
            }
        pages = numberofrows/rowsperpage;
        if ((numberofrows % rowsperpage)!= 0) pages++;
        } else {
        numberofrows = PictureColourPallette.Length;
        pages = PictureColourPallette.Length/rowsperpage;
        if ((PictureColourPallette.Length % rowsperpage) != 0) pages++;
        }
    //if blended colours are used, then there will be a purchasing section to the key for the threads to buy
    if (blendthreads) {
        DynamicArray <bool> UsedColourList;
        UsedColourList.Length = DMCColourList.Length;
        for (int i = 0; i < UsedColourList.Length; i++) {
            UsedColourList[i] = false;
            }
        for (int i = 0; i < BlendReference.Length; i++) {
            switch (BlendReference[i].type) {
                case TBlendedColour:    {
                                        if (BlendReference[i].arrayref < TweedList.Length) {
                                            if (TweedList[BlendReference[i].arrayref].ColourPairs[0].x < UsedColourList.Length) {
                                                UsedColourList[TweedList[BlendReference[i].arrayref].ColourPairs[0].x] = true;
                                                }
                                            if (TweedList[BlendReference[i].arrayref].ColourPairs[0].y < UsedColourList.Length) {
                                                UsedColourList[TweedList[BlendReference[i].arrayref].ColourPairs[0].y] = true;
                                                }
                                            }
                                        }
                                        break;
                case TDMCColour:        {
                                        if (BlendReference[i].arrayref < UsedColourList.Length) {
                                            UsedColourList[BlendReference[i].arrayref] = true;
                                            }
                                        }
                                        break;
                default:                break;
                }
            }
        int usedcolours = 0;
        for (int i = 0; i < UsedColourList.Length; i++) {
            if (UsedColourList[i]) usedcolours++;
            }
        UsedColourList.Length = 0;
        pages += usedcolours/rowsperpage;
        if ((usedcolours % rowsperpage) != 0) pages++;
        }

    return pages;

}
//---------------------------------------------------------------------------

int __fastcall TPlanForm::FindPagesforSPP(void)
{

    //this is a slightly mad idea, but is intended to print off the stitch usage for each page.
    pageinfo info = FindPages();

    //count all colours and put them in their page locations
    int numberofpages = info.rows * info.columns;
    DynamicArray < DynamicArray <int> > StitchData;

    //initialise array
    StitchData.Length = PictureColourPallette.Length;
    for (int i = 0; i < StitchData.Length; i++) {
        StitchData[i].Length = numberofpages;
        for (int j = 0; j < StitchData[i].Length; j++) {
            StitchData[i][j] = 0;
            }
        }

    //fill array - unfortunately this is needed to find max column width
    int pagenumber = -1;
    for (int i = 0; i < info.rows; i++) {
        for (int j = 0; j < info.columns; j++) {
            pagenumber++;
            bool found = false;
            int topleftX = j * info.numglyphswide;
            int toprightX = (j + 1) * info.numglyphswide;
            if (toprightX > Image1->Picture->Width) toprightX = Image1->Picture->Width;
            int topleftY = i * info.numglyphshigh;
            int bottomleftY = (i + 1) * info.numglyphshigh;
            if (bottomleftY > Image1->Picture->Height) bottomleftY = Image1->Picture->Height;
            int k;
            for (int l = topleftY; l < bottomleftY; l++) {
                for (int m = topleftX; m < toprightX; m++) {
                    found = false;
                    k = 0;
                    while (!found && k < PictureColourPallette.Length) {
                        //first check if it's in the list of already found colours
                        if (Image1->Canvas->Pixels[m][l] == PictureColourPallette[k].Colour){
                            StitchData[k][pagenumber] = StitchData[k][pagenumber] + 1;
                            found = true;
                            }
                        k++;
                        }
                    }
                }
            }
        }

    //That's the array filled. Now to simulate printing the data out.
    //Printer()->Canvas->Font->Name = "Arial";
    //Printer()->Canvas->Font->Size = 10;
    Printer()->Canvas->Font->Name = ChartPrintout.ChartFont;
    Printer()->Canvas->Font->Size = ChartPrintout.ChartFontSize + 2;
    Printer()->Canvas->Font->Color = clBlack;

    //"Hi There" has width 13.34mm at 10 Point Arial
    //the printout will be of the form
    //Key Number, Key Shape, DMC/Anchor Number, DMC Name, Stitches on Page1, Page2.... PageN
    //it will form columns of pages if necessary to get all the page stitch data out
    int temp;
    int ColumnSpacing = Printer()->Canvas->TextWidth("88");
    int RowSpacing = 10;
    int KeyNumberWidth = Printer()->Canvas->TextWidth("888");
    //int KeyNumberLeft = ColumnSpacing;
    int SymbolLeft = KeyNumberWidth + 2 * ColumnSpacing;
    int SymbolWidth = Printer()->Canvas->TextWidth("Symbol");
    if (2 * GlyphSize > SymbolWidth) SymbolWidth = 2 * GlyphSize;
    int DMCNumberWidth = 0;
    int DMCNameWidth = 0;
    for (int i = 0; i < PictureColourPallette.Length; i++) {
        if (UseAnchor->Checked) {
            temp = Printer()->Canvas->TextWidth(PictureColourPallette[i].AnchorColourNumber);
            if (DMCNumberWidth < temp) DMCNumberWidth = temp;
            } else {
            temp = Printer()->Canvas->TextWidth(PictureColourPallette[i].DMCColourNumber);
            if (DMCNumberWidth < temp) DMCNumberWidth = temp;
            }
        temp  = Printer()->Canvas->TextWidth(PictureColourPallette[i].DMCColourName);
        if (DMCNameWidth < temp) DMCNameWidth = temp;
        }
    if (DMCNameWidth > (Printer()->PageWidth/2) ) DMCNameWidth = Printer()->PageWidth/2;
    if (UseAnchor->Checked) {
        temp = Printer()->Canvas->TextWidth("Anchor#");
        if (DMCNumberWidth < temp) DMCNumberWidth = temp;
        temp  = Printer()->Canvas->TextWidth("Colour Name");
        if (DMCNameWidth < temp) DMCNameWidth = temp;
        } else {
        //temp = Printer()->Canvas->TextWidth("DMC#");
        temp = Printer()->Canvas->TextWidth(ShortThreadName + "#");
        if (DMCNumberWidth < temp) DMCNumberWidth = temp;
        }
    int DMCNumberLeft = SymbolLeft + SymbolWidth + ColumnSpacing;
    int DMCNameLeft = DMCNumberLeft + DMCNumberWidth + ColumnSpacing;
    int StitchLeft = DMCNameLeft + DMCNameWidth + ColumnSpacing;
    int RowHeight = Printer()->Canvas->TextHeight("Tq");
    if (RowHeight < (2 * GlyphSize)) RowHeight = 2 * GlyphSize;
    //Right, now the only thing to do is to see how many pages there will be.
    int rowsperpage = Printer()->PageHeight/(RowHeight + RowSpacing) - 2;
    int pages;
    int numberofrows;
    if (UseAnchor->Checked) {
        numberofrows = 0;
        for (int i = 0; i < PictureColourPallette.Length; i++) {
            if (PictureColourPallette[i].AnchorStitchCount != 0) numberofrows++;
            }
        pages = numberofrows/rowsperpage + 1;
        } else {
        numberofrows = PictureColourPallette.Length;
        pages = PictureColourPallette.Length/rowsperpage + 1;
        }
    //now to see how many columns there will be on each page
    int StitchPrintWidth = 0;
    for (int i = 0; i < StitchData.Length; i++) {
        for (int j = 0; j < StitchData[i].Length; j++) {
            temp = Printer()->Canvas->TextWidth(AnsiString(StitchData[i][j]));
            if (StitchPrintWidth < temp) StitchPrintWidth = temp;
            }
        }
    temp = Printer()->Canvas->TextWidth("P888");
    if (StitchPrintWidth < temp) StitchPrintWidth = temp;
    int numberofcolumnsperpage = (Printer()->PageWidth - StitchLeft + ColumnSpacing)/(StitchPrintWidth + ColumnSpacing);
    //int numberofpagecolumns = (numberofpages / numberofcolumnsperpage) + 1;
    int numberofpagecolumns = (numberofpages / numberofcolumnsperpage);
    if (numberofpages % numberofcolumnsperpage) numberofpagecolumns++;


    //now to get final data
    int totalpages = numberofpagecolumns * pages;

    //clear Data
    for (int i = 0; i < StitchData.Length; i++) {
        StitchData[i].Length = 0;
        }
    StitchData.Length = 0;

    return totalpages;

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::PrintChartSheets(void)
{
    //Printer()->Canvas->Font->Name = "Arial";
    //Printer()->Canvas->Font->Size = 8;
    Printer()->Canvas->Font->Name =  ChartPrintout.ChartFont;
    Printer()->Canvas->Font->Size = ChartPrintout.ChartFontSize;
    Printer()->Canvas->Font->Color = clBlack;

    int rowspacing = Printer()->Canvas->TextWidth(" ");
    int keyentrywidth = GlyphSize * 1.5 + Printer()->Canvas->TextWidth("    " + AnsiString(PictureColourPallette.Length));
    int keyentryheight = Printer()->Canvas->TextHeight("Tq");
    if (keyentryheight < GlyphSize * 1.5) keyentryheight = GlyphSize * 1.5;
    int keyentrycolumns = Printer()->PageWidth/keyentrywidth;
    keyentryheight += rowspacing;
    int keyentryrows = PictureColourPallette.Length/ keyentrycolumns + 1;
    int keyheight = keyentryrows * keyentryheight + rowspacing;
    if (!SimpleKey->Checked) keyheight = keyentryheight;

    //now to find out how many glyphs etc
    int annotationwidth = Printer()->Canvas->TextWidth("  " + AnsiString(Image1->Height));
    int pageheight = Printer()->PageHeight - keyheight - 3 * keyentryheight;
    int pagewidth = Printer()->PageWidth - 2* annotationwidth - 2 * rowspacing;
    int pageglyphwidth = pagewidth/GlyphSize;
    int pageglyphheight = pageheight/GlyphSize;
    int pageswide = Image1->Width/pageglyphwidth + 1;
    int pageshigh = Image1->Height/pageglyphheight + 1;
    int PictureHeight = Image1->Height;
    int PictureWidth = Image1->Width;

    printingbackstitches = false;


    for (int pagerow = 0; pagerow < pageshigh; pagerow++) {
        for (int pagecolumn = 0; pagecolumn < pageswide; pagecolumn++) {
        if (PageNumber->ItemIndex == 0 || ((pagerow ) *pageswide + pagecolumn + 1) == PageNumber->ItemIndex) {
            if (SimpleKey->Checked) {
                //Plot the simple key
                int indexcount = 0;
                if (!Background->Checked) indexcount = 1;
                for (int i = 0; i < keyentryrows; i++) {
                    for (int j = 0; j < keyentrycolumns; j++) {
                        //change for anchor
                        if (UseAnchor->Checked) {
                            while (indexcount < PictureColourPallette.Length && PictureColourPallette[indexcount].AnchorStitchCount == 0) {
                                indexcount++;
                                }
                            if (indexcount < PictureColourPallette.Length) {
                                DrawAnchorGlyph(Printer()->Canvas, rowspacing + j*keyentrywidth,rowspacing + i * keyentryheight,GlyphSize * 1.5,PictureColourPallette[indexcount].AnchorGlyphToUse,false, PictureColourPallette[indexcount].Colour, PictureColourPallette[indexcount].DrawWhite);
                                Printer()->Canvas->TextOut(rowspacing * 2 + j*keyentrywidth + GlyphSize * 1.5,rowspacing + i * keyentryheight,AnsiString(PictureColourPallette[indexcount].AnchorGlyphToUse));
                                }
                            indexcount++;
                            } else {
                            if (indexcount < PictureColourPallette.Length) {
                                DrawGlyph(Printer()->Canvas, rowspacing + j*keyentrywidth,rowspacing + i * keyentryheight,GlyphSize * 1.5,indexcount,false);
                                Printer()->Canvas->TextOut(rowspacing * 2 + j*keyentrywidth + GlyphSize * 1.5,rowspacing + i * keyentryheight,AnsiString(indexcount));
                                }
                            indexcount++;
                            }
                        //end of changed section for Anchor
                        }
                    }
                }//end of simple key

            //now to print out the chart
            int topleftX = pageglyphwidth * pagecolumn;
            int topleftY = pageglyphheight * pagerow;
            int rightedge = 0;
            int bottomedge = 0;
            int stitchcount = 0;
            int maxX = 0;
            int maxY = 0;
            for (int i = 0; i < pageglyphwidth; i++) {
                for (int j = 0; j < pageglyphheight; j++) {
                    int pixelX = topleftX + i;
                    int pixelY = topleftY + j;
                    if (pixelX < PictureWidth && pixelY < PictureHeight) {
                        //now can plot the glyph
                        bool found = false;
                        int counter = 0;
                        while (!found && counter < PictureColourPallette.Length) {
                            if (Image1->Canvas->Pixels[pixelX][pixelY] == PictureColourPallette[counter].Colour) {
                                found = true;
                                counter--;
                                }
                            counter++;
                            }
                        if (counter != 0 || (counter == 0 && Background->Checked)) {
                            //changed for anchor
                            if (UseAnchor->Checked) {
                                DrawAnchorGlyph(Printer()->Canvas,rowspacing + i*GlyphSize,keyheight + keyentryheight + j*GlyphSize,GlyphSize, PictureColourPallette[counter].AnchorGlyphToUse, true, PictureColourPallette[PictureColourPallette[counter].AnchorColourToUse].Colour, PictureColourPallette[counter].DrawWhite);
                                } else {
                                DrawGlyph(Printer()->Canvas,rowspacing + i*GlyphSize,keyheight + keyentryheight + j*GlyphSize,GlyphSize, counter, true);
                                }
                            //end of section changed for anchor
                            stitchcount++;
                            } else {
                            DrawEmptyGlyph(Printer()->Canvas,rowspacing + i*GlyphSize,keyheight + keyentryheight + j*GlyphSize,GlyphSize);
                            }
                        if (rightedge < (rowspacing + i*GlyphSize)) rightedge = rowspacing + i*GlyphSize;
                        if (bottomedge < (keyheight + keyentryheight + j*GlyphSize)) bottomedge = keyheight + keyentryheight + j*GlyphSize;
                        if (maxX < pixelX) maxX = pixelX;
                        if (maxY < pixelY) maxY = pixelY;
                        }
                    }
                }
            //draw on peripheral black lines
            Printer()->Canvas->Pen->Color = clBlack;
            Printer()->Canvas->Pen->Mode = pmCopy;
            Printer()->Canvas->Pen->Style = psSolid;
            Printer()->Canvas->Pen->Width = GlyphSize/20;
            rightedge += GlyphSize;
            bottomedge += GlyphSize;
            Printer()->Canvas->MoveTo(rightedge,keyheight + keyentryheight);
            Printer()->Canvas->LineTo(rightedge,bottomedge);
            Printer()->Canvas->LineTo(rowspacing,bottomedge);
            Printer()->Canvas->LineTo(rowspacing,keyheight + keyentryheight);
            Printer()->Canvas->LineTo(rightedge,keyheight + keyentryheight);

            //CL was here

            //draw 10's lines
            Printer()->Canvas->Pen->Color = clBlack;
            Printer()->Canvas->Pen->Mode = pmCopy;
            Printer()->Canvas->Pen->Style = psSolid;
            Printer()->Canvas->Pen->Width = GlyphSize/20;
            //Vertical lines & annotations
            for (int i = 0; i < pageglyphwidth + 1; i++) {
                int j = topleftX + i;
                if (j == (int) (ROUND((double)j/10.0) * 10.0) && j < PictureWidth + 1) {
                    //it's a line to be written
                    Printer()->Canvas->MoveTo(rowspacing + i * GlyphSize,keyheight + keyentryheight);
                    Printer()->Canvas->LineTo(rowspacing + i * GlyphSize,bottomedge);
                    Printer()->Canvas->TextOut(rowspacing + i * GlyphSize,keyheight ,AnsiString(j));
                    }
                }
            //Horizontal lines & annotations
            for (int i = 0; i < pageglyphheight + 1; i++) {
                int j = pageglyphheight * pagerow + i;
                if (j == (int) (ROUND((double)j/10.0) * 10.0) && j < Image1->Height + 1) {
                    //it's a line to be written
                    Printer()->Canvas->MoveTo(rowspacing,keyheight + keyentryheight + i*GlyphSize);
                    Printer()->Canvas->LineTo(rightedge,keyheight + keyentryheight + i*GlyphSize);
                    Printer()->Canvas->TextOut(rowspacing + rightedge,keyheight + keyentryheight/2 + i*GlyphSize,AnsiString(j));
                    }
                }
            //print right extreme character no & bottom extreme char no
            TBrushStyle t1 = Printer()->Canvas->Brush->Style;
            Printer()->Canvas->Brush->Style = bsClear;
            Printer()->Canvas->TextOut(rightedge, keyheight, AnsiString(maxX + 1));
            Printer()->Canvas->Brush->Style = t1;
            Printer()->Canvas->TextOut(rowspacing + rightedge, 3 + bottomedge - Printer()->Canvas->TextHeight("123"), AnsiString(maxY + 1));

            //draw centrelines
            //Vertical centreline
            bool clxfound = false;
            int xoffset,yoffset;
            bool clyfound = false;
            int centrelinex = Image1->Width/2;
            if (topleftX < centrelinex && (topleftX + pageglyphwidth) > centrelinex) {
                //it's on this page
                xoffset = (centrelinex - topleftX)*GlyphSize + rowspacing;
                clxfound = true;
                Printer()->Canvas->Pen->Color = clPurple;
                Printer()->Canvas->Pen->Mode = pmCopy;
                Printer()->Canvas->Pen->Style = psDashDotDot;
                Printer()->Canvas->Pen->Width = GlyphSize/10;
                Printer()->Canvas->MoveTo(xoffset,keyheight + keyentryheight);
                Printer()->Canvas->LineTo(xoffset,bottomedge);
                //draw CL mark
                TBrushStyle t1 = Printer()->Canvas->Brush->Style;
                int cwidth = Printer()->Canvas->TextWidth("C")/3;
                int cheight = Printer()->Canvas->TextHeight("C")/3;
                Printer()->Canvas->Brush->Style = bsClear;
                Printer()->Canvas->TextOut(xoffset - cwidth,keyheight ,"C");
                Printer()->Canvas->TextOut(xoffset,keyheight  + cheight,"L");
                Printer()->Canvas->Brush->Style = t1;
                }
            //Horizontal centreline
            int centreliney = Image1->Height/2;
            if (topleftY < centreliney && (topleftY + pageglyphheight) > centreliney) {
                //it's on this page
                yoffset = (centreliney - topleftY)*GlyphSize + keyheight + keyentryheight;
                clyfound = true;
                Printer()->Canvas->Pen->Color = clPurple;
                Printer()->Canvas->Pen->Mode = pmCopy;
                Printer()->Canvas->Pen->Style = psDashDotDot;
                Printer()->Canvas->Pen->Width = GlyphSize/10;
                Printer()->Canvas->MoveTo(rowspacing,yoffset);
                Printer()->Canvas->LineTo(rightedge,yoffset);
                //draw CL mark
                TBrushStyle t1 = Printer()->Canvas->Brush->Style;
                int cwidth = Printer()->Canvas->TextWidth("C")/3;
                int cheight = Printer()->Canvas->TextHeight("C")/3;
                Printer()->Canvas->Brush->Style = bsClear;
                Printer()->Canvas->TextOut(rowspacing + rightedge - cwidth,yoffset - cheight ,"C");
                Printer()->Canvas->TextOut(rowspacing + rightedge,yoffset ,"L");
                Printer()->Canvas->Brush->Style = t1;
                }

            //Highlight centrepoint
            if (clxfound && clyfound) {
                //draw red cross at centre point
                Printer()->Canvas->Pen->Color = clRed;
                Printer()->Canvas->Pen->Mode = pmCopy;
                Printer()->Canvas->Pen->Style = psSolid;
                Printer()->Canvas->Pen->Width = GlyphSize/5;
                Printer()->Canvas->MoveTo(xoffset,yoffset - GlyphSize/2);
                Printer()->Canvas->LineTo(xoffset,yoffset + GlyphSize/2);
                Printer()->Canvas->MoveTo(xoffset - GlyphSize/2, yoffset);
                Printer()->Canvas->LineTo(xoffset + GlyphSize/2, yoffset);
                Printer()->Canvas->MoveTo(xoffset - GlyphSize/2, yoffset - GlyphSize/2);
                Printer()->Canvas->LineTo(xoffset + GlyphSize/2, yoffset + GlyphSize/2);
                Printer()->Canvas->MoveTo(xoffset - GlyphSize/2, yoffset + GlyphSize/2);
                Printer()->Canvas->LineTo(xoffset + GlyphSize/2, yoffset - GlyphSize/2);
                }

            Printer()->Canvas->Pen->Width = GlyphSize/20;

            //footer so that the user never looses track of the page position or the number of stitches to be done
            Printer()->Canvas->TextOut(rowspacing,Printer()->PageHeight - keyentryheight,
                    "This is Page " + AnsiString(pagerow*pageswide + pagecolumn + 1)
                    + " of " + AnsiString(pageshigh * pageswide)
                    + ";    Row " + AnsiString(pagerow + 1) + " of " + AnsiString(pageshigh)
                    + ";    Column "  + AnsiString(pagecolumn + 1) + " of " + AnsiString(pageswide)
                    );
            Printer()->Canvas->TextOut(Printer()->PageWidth - Printer()->Canvas->TextWidth(AnsiString(stitchcount) + " of " + Label5->Caption + " Stitches on this Page.   "),Printer()->PageHeight - keyentryheight,
                    AnsiString(stitchcount) + " of " + Label5->Caption + " Stitches on this Page."
                    );


            //print this page, as it's complete.
            if (!(pagerow == pageshigh-1 && pagecolumn == pageswide-1) && PageNumber->ItemIndex == 0) Printer()->NewPage();
            }
            }    //end of  for (int pagecolumn = 0; pagecolumn < pageswide; pagecolumn++)
        } //end of  for (int pagerow = 0; pagerow < pageshigh; pagerow++)

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::PrintBackstitchPages(void)
{
    //Printer()->Canvas->Font->Name = "Arial";
    //Printer()->Canvas->Font->Size = 8;
    Printer()->Canvas->Font->Name = ChartPrintout.ChartFont;
    Printer()->Canvas->Font->Size = ChartPrintout.ChartFontSize;
    Printer()->Canvas->Font->Color = clBlack;

    int rowspacing = Printer()->Canvas->TextWidth(" ");
    int keyentrywidth = GlyphSize * 1.5 + Printer()->Canvas->TextWidth("    " + AnsiString(PictureColourPallette.Length));
    int keyentryheight = Printer()->Canvas->TextHeight("Tq");
    if (keyentryheight < GlyphSize * 1.5) keyentryheight = GlyphSize * 1.5;
    int keyentrycolumns = Printer()->PageWidth/keyentrywidth;
    keyentryheight += rowspacing;
    int keyentryrows = PictureColourPallette.Length/ keyentrycolumns + 1;
    int keyheight = keyentryrows * keyentryheight + rowspacing;
    if (!SimpleKey->Checked) keyheight = keyentryheight;

    //now to find out how many glyphs etc
    int annotationwidth = Printer()->Canvas->TextWidth("  " + AnsiString(Image1->Height));
    int pageheight = Printer()->PageHeight - keyheight - 3 * keyentryheight;
    int pagewidth = Printer()->PageWidth - 2* annotationwidth - 2 * rowspacing;
    int pageglyphwidth = pagewidth/GlyphSize;
    int pageglyphheight = pageheight/GlyphSize;
    int pageswide = Image1->Width/pageglyphwidth + 1;
    int pageshigh = Image1->Height/pageglyphheight + 1;
    int PictureHeight = Image1->Height;
    int PictureWidth = Image1->Width;
    //array to show colours used
    DynamicArray <bool> colourused;
    colourused.Length = PictureColourPallette.Length;
    for (int i = 0; i < colourused.Length; i++) {
        colourused[i] = false;
        }
    for (int i = 0; i < BackStitches.Length; i++) {
        colourused[BackStitches[i].ColourNumber] = true;
        }


    for (int pagerow = 0; pagerow < pageshigh; pagerow++) {
        for (int pagecolumn = 0; pagecolumn < pageswide; pagecolumn++) {
        if (PageNumber->ItemIndex == 0 || ((pagerow ) *pageswide + pagecolumn + 1) == PageNumber->ItemIndex) {
            if (SimpleKey->Checked) {
                //Plot the simple key
                int indexcount = 0;
                if (!Background->Checked && !colourused[0]) indexcount = 1;
                int PenWidth = Printer()->Canvas->Pen->Width;
                Printer()->Canvas->Pen->Width = GlyphSize*12/40;
                for (int i = 0; i < keyentryrows; i++) {
                    for (int j = 0; j < keyentrycolumns; j++) {
                        //change for anchor
                        if (UseAnchor->Checked) {
                            while (indexcount < PictureColourPallette.Length && PictureColourPallette[indexcount].AnchorStitchCount == 0) {
                                indexcount++;
                                }
                            if (indexcount < PictureColourPallette.Length && colourused[indexcount]) {
                                Printer()->Canvas->Pen->Color = PictureColourPallette[indexcount].Colour;
                                Printer()->Canvas->MoveTo(rowspacing + j*keyentrywidth,rowspacing + i * keyentryheight + GlyphSize * 3/4);
                                Printer()->Canvas->LineTo(rowspacing + j*keyentrywidth + GlyphSize * 3/2,rowspacing + i * keyentryheight + GlyphSize * 3/4);
                                Printer()->Canvas->TextOut(rowspacing * 2 + j*keyentrywidth + GlyphSize * 1.5,rowspacing + i * keyentryheight,AnsiString(PictureColourPallette[indexcount].AnchorGlyphToUse));
                                }
                            indexcount++;
                            } else {
                            if (indexcount < PictureColourPallette.Length && colourused[indexcount]) {
                                Printer()->Canvas->Pen->Color = PictureColourPallette[indexcount].Colour;
                                Printer()->Canvas->MoveTo(rowspacing + j*keyentrywidth,rowspacing + i * keyentryheight + GlyphSize * 3/4);
                                Printer()->Canvas->LineTo(rowspacing + j*keyentrywidth + GlyphSize * 3/2,rowspacing + i * keyentryheight + GlyphSize * 3/4);
                                Printer()->Canvas->TextOut(rowspacing * 2 + j*keyentrywidth + GlyphSize * 1.5,rowspacing + i * keyentryheight,AnsiString(indexcount));
                                }
                            indexcount++;
                            }
                        //end of changed section for Anchor
                        }
                    }
                Printer()->Canvas->Pen->Width = PenWidth;
                }//end of simple key

            //now to print out the chart
            int topleftX = pageglyphwidth * pagecolumn;
            int topleftY = pageglyphheight * pagerow;
            int rightedge = 0;
            int bottomedge = 0;
            int stitchcount = 0;
            int maxX = 0;
            int maxY = 0;
            for (int i = 0; i < pageglyphwidth; i++) {
                for (int j = 0; j < pageglyphheight; j++) {
                    int pixelX = topleftX + i;
                    int pixelY = topleftY + j;
                    if (pixelX < PictureWidth && pixelY < PictureHeight) {
                        //now can plot the glyph
                        bool found = false;
                        int counter = 0;
                        while (!found && counter < PictureColourPallette.Length) {
                            if (Image1->Canvas->Pixels[pixelX][pixelY] == PictureColourPallette[counter].Colour) {
                                found = true;
                                counter--;
                                }
                            counter++;
                            }
                        if (counter != 0 || (counter == 0 && Background->Checked)) {
                            //changed for anchor
                            if (UseAnchor->Checked) {
                                DrawAnchorGlyph(Printer()->Canvas,rowspacing + i*GlyphSize,keyheight + keyentryheight + j*GlyphSize,GlyphSize, PictureColourPallette[counter].AnchorGlyphToUse, true, PictureColourPallette[PictureColourPallette[counter].AnchorColourToUse].Colour, PictureColourPallette[counter].DrawWhite);
                                } else {
                                DrawGlyph(Printer()->Canvas,rowspacing + i*GlyphSize,keyheight + keyentryheight + j*GlyphSize,GlyphSize, counter, true);
                                }
                            //end of section changed for anchor
                            //stitchcount++;
                            } else {
                            DrawEmptyGlyph(Printer()->Canvas,rowspacing + i*GlyphSize,keyheight + keyentryheight + j*GlyphSize,GlyphSize);
                            }
                        if (rightedge < (rowspacing + i*GlyphSize)) rightedge = rowspacing + i*GlyphSize;
                        if (bottomedge < (keyheight + keyentryheight + j*GlyphSize)) bottomedge = keyheight + keyentryheight + j*GlyphSize;
                        if (maxX < pixelX) maxX = pixelX;
                        if (maxY < pixelY) maxY = pixelY;
                        }
                    }
                }

            //draw the back stitches
            //run through all stitches & see if they should be on this sheet
            for (int i = 0; i < BackStitches.Length; i++) {
                if ( BackStitches[i].X1 >= (float)topleftX
                    && BackStitches[i].X1 <= (float)maxX + 1.0
                    && BackStitches[i].Y1 >= (float)topleftY
                    && BackStitches[i].Y1 <= (float)maxY + 1.0) {
                    // end 1 is on the page, now check if end 2 is
                    if ( BackStitches[i].X2 >= (float)topleftX
                        && BackStitches[i].X2 <= (float)maxX + 1.0
                        && BackStitches[i].Y2 >= (float)topleftY
                        && BackStitches[i].Y2 <= (float)maxY + 1.0) {
                        // ends 1 & 2 are both on the page, now draw the stitch
                        stitchcount++;
                        Printer()->Canvas->Pen->Color = PictureColourPallette[BackStitches[i].ColourNumber].Colour;
                        Printer()->Canvas->Pen->Width = GlyphSize*4/20;
                        Printer()->Canvas->MoveTo(rowspacing + (BackStitches[i].X1 - topleftX)*GlyphSize, keyheight + keyentryheight + (BackStitches[i].Y1 - topleftY)*GlyphSize);
                        Printer()->Canvas->LineTo(rowspacing + (BackStitches[i].X2 - topleftX)*GlyphSize, keyheight + keyentryheight + (BackStitches[i].Y2 - topleftY)*GlyphSize);
                        } else {
                        //end point not in range, crosses edge & need to draw a line that stops at the edge of the plotted area
                        //Need to go through the four lines around the perimiter and find the intersection points, and also when the proportions along the line are both between 0 and 1
                        if (!FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,topleftX,topleftY,maxX + 1.0, topleftY)) {
                            if (!FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,maxX + 1.0,topleftY,maxX + 1.0, maxY + 1.0)){
                                if (!FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,topleftX,maxY + 1.0,maxX + 1.0, maxY + 1.0)) {
                                    if (!FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,topleftX,topleftY,topleftX,maxY + 1.0)) {
                                        //Oh blast, it has got through without being able to find an intersection.
                                        //Check X2 against right edge.
                                        if (BackStitches[i].X2 > maxX + 1.0) {
                                            XIntersect = maxX + 1.0;
                                            YIntersect = BackStitches[i].Y1 + (BackStitches[i].Y2 - BackStitches[i].Y1) * (maxX + 1.0 - BackStitches[i].X1)/(BackStitches[i].X2 - BackStitches[i].X1);
                                            } else {
                                            //Check X2 against left edge
                                            if (BackStitches[i].X2 < topleftX) {
                                                XIntersect = topleftX;
                                                YIntersect = BackStitches[i].Y1 + (BackStitches[i].Y2 - BackStitches[i].Y1) * (topleftX - BackStitches[i].X1)/(BackStitches[i].X2 - BackStitches[i].X1);
                                                } else {
                                                //Check Y2 against top edge
                                                if (BackStitches[i].Y2 < topleftY) {
                                                    XIntersect = BackStitches[i].X1 + (BackStitches[i].X2 - BackStitches[i].X1) * (topleftY - BackStitches[i].Y1)/(BackStitches[i].Y2 - BackStitches[i].Y1);
                                                    YIntersect = topleftY;
                                                    } else {
                                                    //Must cut bottom line if we've got here
                                                    if (BackStitches[i].Y2 > maxY + 1.0) {
                                                        XIntersect = BackStitches[i].X1 + (BackStitches[i].X2 - BackStitches[i].X1) * (maxY + 1.0 - BackStitches[i].Y1)/(BackStitches[i].Y2 - BackStitches[i].Y1);
                                                        YIntersect = maxY + 1.0;
                                                        } else {
                                                        Application->MessageBox(("End point not found for back stitch crossing page boundary at " + AnsiString(BackStitches[i].X1) + "," + AnsiString(BackStitches[i].Y1) + "/" + AnsiString(BackStitches[i].X2) + "," + AnsiString(BackStitches[i].Y2)).c_str(),"Error",MB_OK + MB_ICONEXCLAMATION);
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        stitchcount++;
                        Printer()->Canvas->Pen->Color = PictureColourPallette[BackStitches[i].ColourNumber].Colour;
                        Printer()->Canvas->Pen->Width = GlyphSize*4/20;
                        Printer()->Canvas->MoveTo(rowspacing + (BackStitches[i].X1 - topleftX)*GlyphSize, keyheight + keyentryheight + (BackStitches[i].Y1 - topleftY)*GlyphSize);
                        Printer()->Canvas->LineTo(rowspacing + (XIntersect - topleftX)*GlyphSize, keyheight + keyentryheight + (YIntersect - topleftY)*GlyphSize);
                        }
                    } else {
                    //check to see if, while the start isn't on the page, it ends on page
                    if ( BackStitches[i].X2 >= (float)topleftX
                        && BackStitches[i].X2 <= (float)maxX + 1.0
                        && BackStitches[i].Y2 >= (float)topleftY
                        && BackStitches[i].Y2 <= (float)maxY + 1.0) {
                        //point 1 not in range but point 2 is, crosses edge & need to draw a line that stops at the edge of the plotted area
                        //Need to go through the four lines around the perimiter and find the intersection points, and also when the proportions along the line are both between 0 and 1
                        if (!FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,topleftX,topleftY,maxX + 1.0, topleftY)) {
                            if (!FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,maxX + 1.0,topleftY,maxX + 1.0, maxY + 1.0)){
                                if (!FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,topleftX,maxY + 1.0,maxX + 1.0, maxY + 1.0)) {
                                    if (!FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,topleftX,topleftY,topleftX,maxY + 1.0)) {
                                        //Blow. No intersection found
                                        //Check X1 against right edge.
                                        if (BackStitches[i].X1 > maxX + 1.0) {
                                            XIntersect = maxX + 1.0;
                                            YIntersect = BackStitches[i].Y1 + (BackStitches[i].Y2 - BackStitches[i].Y1) * (maxX + 1.0 - BackStitches[i].X1)/(BackStitches[i].X2 - BackStitches[i].X1);
                                            } else {
                                            //Check X2 against left edge
                                            if (BackStitches[i].X1 < topleftX) {
                                                XIntersect = topleftX;
                                                YIntersect = BackStitches[i].Y1 + (BackStitches[i].Y2 - BackStitches[i].Y1) * (topleftX - BackStitches[i].X1)/(BackStitches[i].X2 - BackStitches[i].X1);
                                                } else {
                                                //Check Y2 against top edge
                                                if (BackStitches[i].Y1 < topleftY) {
                                                    XIntersect = BackStitches[i].X1 + (BackStitches[i].X2 - BackStitches[i].X1) * (topleftY - BackStitches[i].Y1)/(BackStitches[i].Y2 - BackStitches[i].Y1);
                                                    YIntersect = topleftY;
                                                    } else {
                                                    //Must cut bottom line if we've got here
                                                    if (BackStitches[i].Y1 > maxY + 1.0) {
                                                        XIntersect = BackStitches[i].X1 + (BackStitches[i].X2 - BackStitches[i].X1) * (maxY + 1.0 - BackStitches[i].Y1)/(BackStitches[i].Y2 - BackStitches[i].Y1);
                                                        YIntersect = maxY + 1.0;
                                                        } else {
                                                        Application->MessageBox(("End point not found for back stitch crossing page boundary at " + AnsiString(BackStitches[i].X1) + "," + AnsiString(BackStitches[i].Y1) + "/" + AnsiString(BackStitches[i].X2) + "," + AnsiString(BackStitches[i].Y2)).c_str(),"Error",MB_OK + MB_ICONEXCLAMATION);
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        stitchcount++;
                        Printer()->Canvas->Pen->Color = PictureColourPallette[BackStitches[i].ColourNumber].Colour;
                        Printer()->Canvas->Pen->Width = GlyphSize*4/20;
                        Printer()->Canvas->MoveTo(rowspacing + (BackStitches[i].X2 - topleftX)*GlyphSize, keyheight + keyentryheight + (BackStitches[i].Y2 - topleftY)*GlyphSize);
                        Printer()->Canvas->LineTo(rowspacing + (XIntersect - topleftX)*GlyphSize, keyheight + keyentryheight + (YIntersect - topleftY)*GlyphSize);
                        } else {
                        //stitch ends completely miss page, but may cross corners
                        if (FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,topleftX,topleftY,maxX + 1.0, topleftY)) {
                            //try top edge & 1 one other of right edge, bottom edge or left edge
                            float tempX = XIntersect;
                            float tempY = YIntersect;
                            bool found = FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,maxX + 1.0,topleftY,maxX + 1.0, maxY + 1.0);
                            if (!found) {
                                found = FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,topleftX,maxY + 1.0,maxX + 1.0, maxY + 1.0);
                                if (!found) {
                                    found = FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,topleftX,topleftY,topleftX,maxY + 1.0);
                                    }
                                }
                            if (found) {
                                stitchcount++;
                                Printer()->Canvas->Pen->Color = PictureColourPallette[BackStitches[i].ColourNumber].Colour;
                                Printer()->Canvas->Pen->Width = GlyphSize*4/20;
                                Printer()->Canvas->MoveTo(rowspacing + (tempX - topleftX)*GlyphSize, keyheight + keyentryheight + (tempY - topleftY)*GlyphSize);
                                Printer()->Canvas->LineTo(rowspacing + (XIntersect - topleftX)*GlyphSize, keyheight + keyentryheight + (YIntersect - topleftY)*GlyphSize);
                                }
                            } else {
                            //try right edge and one other of bottom edge or left edge
                            if (FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,maxX + 1.0,topleftY,maxX + 1.0, maxY + 1.0)) {
                                float tempX = XIntersect;
                                float tempY = YIntersect;
                                bool found = FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,topleftX,maxY + 1.0,maxX + 1.0, maxY + 1.0);
                                if (!found) {
                                    found = FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,topleftX,topleftY,topleftX,maxY + 1.0);
                                    }
                                if (found) {
                                    stitchcount++;
                                    Printer()->Canvas->Pen->Color = PictureColourPallette[BackStitches[i].ColourNumber].Colour;
                                    Printer()->Canvas->Pen->Width = GlyphSize*4/20;
                                    Printer()->Canvas->MoveTo(rowspacing + (tempX - topleftX)*GlyphSize, keyheight + keyentryheight + (tempY - topleftY)*GlyphSize);
                                    Printer()->Canvas->LineTo(rowspacing + (XIntersect - topleftX)*GlyphSize, keyheight + keyentryheight + (YIntersect - topleftY)*GlyphSize);
                                    }
                                } else {
                                //try bottom edge & left edge
                                if (FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,topleftX,maxY + 1.0,maxX + 1.0, maxY + 1.0)) {
                                    float tempX = XIntersect;
                                    float tempY = YIntersect;
                                    if (FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,topleftX,topleftY,topleftX,maxY + 1.0)) {
                                        stitchcount++;
                                        Printer()->Canvas->Pen->Color = PictureColourPallette[BackStitches[i].ColourNumber].Colour;
                                        Printer()->Canvas->Pen->Width = GlyphSize*4/20;
                                        Printer()->Canvas->MoveTo(rowspacing + (tempX - topleftX)*GlyphSize, keyheight + keyentryheight + (tempY - topleftY)*GlyphSize);
                                        Printer()->Canvas->LineTo(rowspacing + (XIntersect - topleftX)*GlyphSize, keyheight + keyentryheight + (YIntersect - topleftY)*GlyphSize);
                                        }
                                    }
                                }
                            }
                        }
                    }
                }


            //draw on peripheral black lines
            Printer()->Canvas->Pen->Color = clBlack;
            Printer()->Canvas->Pen->Mode = pmCopy;
            Printer()->Canvas->Pen->Style = psSolid;
            Printer()->Canvas->Pen->Width = GlyphSize/20;
            rightedge += GlyphSize;
            bottomedge += GlyphSize;
            Printer()->Canvas->MoveTo(rightedge,keyheight + keyentryheight);
            Printer()->Canvas->LineTo(rightedge,bottomedge);
            Printer()->Canvas->LineTo(rowspacing,bottomedge);
            Printer()->Canvas->LineTo(rowspacing,keyheight + keyentryheight);
            Printer()->Canvas->LineTo(rightedge,keyheight + keyentryheight);

            //centrelines were here

            //draw 10's lines
            Printer()->Canvas->Pen->Color = clBlack;
            Printer()->Canvas->Pen->Mode = pmCopy;
            Printer()->Canvas->Pen->Style = psSolid;
            Printer()->Canvas->Pen->Width = GlyphSize/20;
            //Vertical lines & annotations
            for (int i = 0; i < pageglyphwidth + 1; i++) {
                int j = topleftX + i;
                if (j == (int) (ROUND((double)j/10.0) * 10.0) && j < PictureWidth + 1) {
                    //it's a line to be written
                    Printer()->Canvas->MoveTo(rowspacing + i * GlyphSize,keyheight + keyentryheight);
                    Printer()->Canvas->LineTo(rowspacing + i * GlyphSize,bottomedge);
                    Printer()->Canvas->TextOut(rowspacing + i * GlyphSize,keyheight ,AnsiString(j));
                    }
                }
            //Horizontal lines & annotations
            for (int i = 0; i < pageglyphheight + 1; i++) {
                int j = pageglyphheight * pagerow + i;
                if (j == (int) (ROUND((double)j/10.0) * 10.0) && j < Image1->Height + 1) {
                    //it's a line to be written
                    Printer()->Canvas->MoveTo(rowspacing,keyheight + keyentryheight + i*GlyphSize);
                    Printer()->Canvas->LineTo(rightedge,keyheight + keyentryheight + i*GlyphSize);
                    Printer()->Canvas->TextOut(rowspacing + rightedge,keyheight + keyentryheight/2 + i*GlyphSize,AnsiString(j));
                    }
                }
            //print right extreme character no & bottom extreme char no
            TBrushStyle t1 = Printer()->Canvas->Brush->Style;
            Printer()->Canvas->Brush->Style = bsClear;
            Printer()->Canvas->TextOut(rightedge, keyheight, AnsiString(maxX + 1));
            Printer()->Canvas->Brush->Style = t1;
            Printer()->Canvas->TextOut(rowspacing + rightedge, 3 + bottomedge - Printer()->Canvas->TextHeight("123"), AnsiString(maxY + 1));

            //draw centrelines
            //Vertical centreline
            bool clxfound = false;
            int xoffset,yoffset;
            bool clyfound = false;
            int centrelinex = Image1->Width/2;
            if (topleftX < centrelinex && (topleftX + pageglyphwidth) > centrelinex) {
                //it's on this page
                xoffset = (centrelinex - topleftX)*GlyphSize + rowspacing;
                clxfound = true;
                Printer()->Canvas->Pen->Color = clPurple;
                Printer()->Canvas->Pen->Mode = pmCopy;
                Printer()->Canvas->Pen->Style = psDashDotDot;
                Printer()->Canvas->Pen->Width = GlyphSize/10;
                Printer()->Canvas->MoveTo(xoffset,keyheight + keyentryheight);
                Printer()->Canvas->LineTo(xoffset,bottomedge);
                //draw CL mark
                TBrushStyle t1 = Printer()->Canvas->Brush->Style;
                int cwidth = Printer()->Canvas->TextWidth("C")/3;
                int cheight = Printer()->Canvas->TextHeight("C")/3;
                Printer()->Canvas->Brush->Style = bsClear;
                Printer()->Canvas->TextOut(xoffset - cwidth,keyheight ,"C");
                Printer()->Canvas->TextOut(xoffset,keyheight  + cheight,"L");
                Printer()->Canvas->Brush->Style = t1;
                }
            //Horizontal centreline
            int centreliney = Image1->Height/2;
            if (topleftY < centreliney && (topleftY + pageglyphheight) > centreliney) {
                //it's on this page
                yoffset = (centreliney - topleftY)*GlyphSize + keyheight + keyentryheight;
                clyfound = true;
                Printer()->Canvas->Pen->Color = clPurple;
                Printer()->Canvas->Pen->Mode = pmCopy;
                Printer()->Canvas->Pen->Style = psDashDotDot;
                Printer()->Canvas->Pen->Width = GlyphSize/10;
                Printer()->Canvas->MoveTo(rowspacing,yoffset);
                Printer()->Canvas->LineTo(rightedge,yoffset);
                //draw CL mark
                TBrushStyle t1 = Printer()->Canvas->Brush->Style;
                int cwidth = Printer()->Canvas->TextWidth("C")/3;
                int cheight = Printer()->Canvas->TextHeight("C")/3;
                Printer()->Canvas->Brush->Style = bsClear;
                Printer()->Canvas->TextOut(rowspacing + rightedge - cwidth,yoffset - cheight ,"C");
                Printer()->Canvas->TextOut(rowspacing + rightedge,yoffset ,"L");
                Printer()->Canvas->Brush->Style = t1;
                }

            //Highlight centrepoint
            if (clxfound && clyfound) {
                //draw red cross at centre point
                Printer()->Canvas->Pen->Color = clRed;
                Printer()->Canvas->Pen->Mode = pmCopy;
                Printer()->Canvas->Pen->Style = psSolid;
                Printer()->Canvas->Pen->Width = GlyphSize/5;
                Printer()->Canvas->MoveTo(xoffset,yoffset - GlyphSize/2);
                Printer()->Canvas->LineTo(xoffset,yoffset + GlyphSize/2);
                Printer()->Canvas->MoveTo(xoffset - GlyphSize/2, yoffset);
                Printer()->Canvas->LineTo(xoffset + GlyphSize/2, yoffset);
                Printer()->Canvas->MoveTo(xoffset - GlyphSize/2, yoffset - GlyphSize/2);
                Printer()->Canvas->LineTo(xoffset + GlyphSize/2, yoffset + GlyphSize/2);
                Printer()->Canvas->MoveTo(xoffset - GlyphSize/2, yoffset + GlyphSize/2);
                Printer()->Canvas->LineTo(xoffset + GlyphSize/2, yoffset - GlyphSize/2);
                }
            Printer()->Canvas->Pen->Width = GlyphSize/20;

            //footer so that the user never looses track of the page position or the number of stitches to be done
            Printer()->Canvas->TextOut(rowspacing,Printer()->PageHeight - keyentryheight,
                    "This is Page " + AnsiString(pagerow*pageswide + pagecolumn + 1)
                    + " of " + AnsiString(pageshigh * pageswide)
                    + ";    Row " + AnsiString(pagerow + 1) + " of " + AnsiString(pageshigh)
                    + ";    Column "  + AnsiString(pagecolumn + 1) + " of " + AnsiString(pageswide)
                    );
            Printer()->Canvas->TextOut(Printer()->PageWidth - Printer()->Canvas->TextWidth(AnsiString(stitchcount) + " of " + Label5->Caption + " Stitches on this Page.   "),Printer()->PageHeight - keyentryheight,
                    AnsiString(stitchcount) + " of " + Label5->Caption + " Stitches on this Page."
                    );


            //print this page, as it's complete.
            if (!(pagerow == pageshigh-1 && pagecolumn == pageswide-1) && PageNumber->ItemIndex == 0) Printer()->NewPage();
            }
            }    //end of  for (int pagecolumn = 0; pagecolumn < pageswide; pagecolumn++)
        } //end of  for (int pagerow = 0; pagerow < pageshigh; pagerow++)
    printingbackstitches = false;
    colourused.Length = 0;

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::PrintKeyPages(void)
{
    //Printer()->Canvas->Font->Name = "Arial";
    //Printer()->Canvas->Font->Size = 10;
    Printer()->Canvas->Font->Name = ChartPrintout.ChartFont;
    Printer()->Canvas->Font->Size = ChartPrintout.ChartFontSize + 2;
    Printer()->Canvas->Font->Color = clBlack;
    printingbackstitches = false;
    //this is 13.34mm wide
    //Printer()->Canvas->TextOut(0,0,"Hi There");

        //This is a detailed key
        //The printout columns will be of the form
        //Key Number, Key Shape, DMC Number/Anchor Number, DMC Name, Number of stitches, Approx Number of skeins
        int ColumnSpacing = Printer()->Canvas->TextWidth("88");
        int RowSpacing = 10;
        int KeyNumberWidth = Printer()->Canvas->TextWidth("888");
        int KeyNumberLeft = ColumnSpacing;
        int SymbolLeft = KeyNumberWidth + 2 * ColumnSpacing;
        int SymbolWidth = Printer()->Canvas->TextWidth("Symbol");
        if (2 * GlyphSize > SymbolWidth) SymbolWidth = 2 * GlyphSize;
        int DMCNumberWidth = 0;
        int DMCNameWidth = 0;
        int temp;
        for (int i = 0; i < PictureColourPallette.Length; i++) {
            if (UseAnchor->Checked) {
                temp = Printer()->Canvas->TextWidth(PictureColourPallette[i].AnchorColourNumber);
                if (DMCNumberWidth < temp) DMCNumberWidth = temp;
                } else {
                temp = Printer()->Canvas->TextWidth(PictureColourPallette[i].DMCColourNumber);
                if (DMCNumberWidth < temp) DMCNumberWidth = temp;
                }
            temp  = Printer()->Canvas->TextWidth(PictureColourPallette[i].DMCColourName);
            if (DMCNameWidth < temp) DMCNameWidth = temp;
            }
        if (UseAnchor->Checked) {
            temp = Printer()->Canvas->TextWidth("Anchor#");
            if (DMCNumberWidth < temp) DMCNumberWidth = temp;
            temp  = Printer()->Canvas->TextWidth("Colour Name");
            if (DMCNameWidth < temp) DMCNameWidth = temp;
            } else {
            //temp = Printer()->Canvas->TextWidth("DMC#");
            temp = Printer()->Canvas->TextWidth(ShortThreadName + "#");
            if (DMCNumberWidth < temp) DMCNumberWidth = temp;
            }
        int DMCNumberLeft = SymbolLeft + SymbolWidth + ColumnSpacing;
        int DMCNameLeft = DMCNumberLeft + DMCNumberWidth + ColumnSpacing;
        int StitchWidth = Printer()->Canvas->TextWidth("Number of Stitches");
        int StitchLeft = DMCNameLeft + DMCNameWidth + ColumnSpacing;
        //int SkeinWidth = Printer()->Canvas->TextWidth("Approx Number of skeins");
        int SkeinLeft =  StitchLeft + StitchWidth + ColumnSpacing;
        int RowHeight = Printer()->Canvas->TextHeight("Tq");
        if (RowHeight < (2 * GlyphSize)) RowHeight = 2 * GlyphSize;
        //Right, now the only thing to do is to see how many pages there will be.
        int rowsperpage = Printer()->PageHeight/(RowHeight + RowSpacing) - 1;
        int pages;
        int numberofrows;
        if (UseAnchor->Checked) {
            numberofrows = 0;
            for (int i = 0; i < PictureColourPallette.Length; i++) {
                if (PictureColourPallette[i].AnchorStitchCount != 0) numberofrows++;
                }
            pages = numberofrows/rowsperpage + 1;
            } else {
            numberofrows = PictureColourPallette.Length;
            pages = PictureColourPallette.Length/rowsperpage + 1;
            }
        int countfactor = 4;
        int tpi = StitchCount->Items->Strings[StitchCount->ItemIndex].ToIntDef(9);
        switch (tpi) {
            case 21:
            case 22:
            case 23:
            case 24:
            case 25:
            case 26:
            case 27:
            case 28:
            case 29:
            case 30:
            case 31:
            case 32:
            case 33:
            case 34:
            case 35:
            case 36:
            case 37:
            case 38:
            case 39:
            case 40:    {
                        countfactor = 1;
                        }
                        break;
            case 14:
            case 15:
            case 16:
            case 17:
            case 18:
            case 19:
            case 20:    {
                        countfactor = 2;
                        }
                        break;
            case 11:
            case 12:
            case 13:    {
                        countfactor = 3;
                        }
                        break;
            default:    {
                        countfactor = 4;
                        }
                        break;
            case 8:
            case 7:     {
                        countfactor = 5;
                        }
                        break;
            case 6:     {
                        countfactor = 6;
                        }
                        break;
            }
        int stitchesperskein = (8000 * 6 * tpi)/ (215 * countfactor);
        //The 215 figure seems pretty random, but is made up as follows:
        //215 = length of thread per cross stitch as a multiple of the count (4.8: - 2 diagonals on the front @ 1.4 + 2 straight stitches on the back)
        //       * 25.4mm per inch * 1.175 (15% wasted per thread) * 1.5 (safety factor for tie off & moving between rows)
        //also works for tent stitches where the thread is usually doubled up compared to x stitch
        //The 8000 figure is the length of thread in each DMC skein in mm
        //The 6 figure is the number of individual threads in each DMC skein
        //The countfactor is the number of threads in each stitch depending on the stitch count,
        //and defaults to the value for 9 count in the event of error

        //also works for tent stitches where the thread is usually doubled up compared to x stitch

        //now to print
        int rowcount = 0;
        int colourcount = 0;
        if (!Background->Checked) {
            rowcount = 1;
            colourcount = 1;
            }
        for (int page = 0; page < pages; page++) {
            //Header Row
            Printer()->Canvas->TextOut(KeyNumberLeft,RowSpacing,"Ref#");
            Printer()->Canvas->TextOut(SymbolLeft,RowSpacing,"Shape");
            if (UseAnchor->Checked) {
                Printer()->Canvas->TextOut(DMCNumberLeft,RowSpacing,"Anchor#");
                Printer()->Canvas->TextOut(DMCNameLeft,RowSpacing,"Colour Name");
                } else {
                //Printer()->Canvas->TextOut(DMCNumberLeft,RowSpacing,"DMC#");
                //Printer()->Canvas->TextOut(DMCNameLeft,RowSpacing,"DMC Name");
                Printer()->Canvas->TextOut(DMCNumberLeft,RowSpacing,ShortThreadName + "#");
                Printer()->Canvas->TextOut(DMCNameLeft,RowSpacing,ShortThreadName + " Name");
                }
            Printer()->Canvas->TextOut(StitchLeft,RowSpacing,"Number of Stitches");
            Printer()->Canvas->TextOut(SkeinLeft,RowSpacing,"Approx Number of skeins");
            for (int i = 1; i < rowsperpage; i++) {
                //find the colour to print for this line
                bool stop = false;
                while (colourcount < PictureColourPallette.Length && !stop) {
                    if (UseAnchor->Checked) {
                        if (colourcount == PictureColourPallette[colourcount].AnchorColourToUse) {
                            stop = true;
                            } else {
                            colourcount++;
                            }
                        } else {
                        stop = true;
                        }
                    }
                //if (rowcount < PictureColourPallette.Length) {
                if (colourcount < PictureColourPallette.Length) {
                    if ((rowcount == 0 && Background->Checked) || rowcount > 0) {
                        int rowposition = i * (RowSpacing + RowHeight) + RowSpacing;
                        //Printer()->Canvas->TextOut(KeyNumberLeft,rowposition,AnsiString(rowcount));
                        //DrawGlyph(Printer()->Canvas,SymbolLeft,rowposition,RowHeight, rowcount, false);
                        int skeins;
                        if (UseAnchor->Checked) {
                            Printer()->Canvas->TextOut(KeyNumberLeft,rowposition,AnsiString(PictureColourPallette[colourcount].AnchorGlyphToUse));
                            DrawAnchorGlyph(Printer()->Canvas,SymbolLeft,rowposition,RowHeight,PictureColourPallette[colourcount].AnchorGlyphToUse, false, PictureColourPallette[colourcount].Colour, PictureColourPallette[colourcount].DrawWhite);
                            Printer()->Canvas->TextOut(DMCNumberLeft,rowposition,PictureColourPallette[colourcount].AnchorColourNumber);
                            Printer()->Canvas->TextOut(DMCNameLeft,rowposition,PictureColourPallette[colourcount].DMCColourName);
                            Printer()->Canvas->TextOut(StitchLeft,rowposition,AnsiString(PictureColourPallette[colourcount].AnchorStitchCount));
                            skeins = PictureColourPallette[colourcount].AnchorStitchCount/stitchesperskein + 1;
                            } else {
                            Printer()->Canvas->TextOut(KeyNumberLeft,rowposition,AnsiString(rowcount));
                            DrawGlyph(Printer()->Canvas,SymbolLeft,rowposition,RowHeight, rowcount, false);
                            Printer()->Canvas->TextOut(DMCNumberLeft,rowposition,PictureColourPallette[rowcount].DMCColourNumber);
                            Printer()->Canvas->TextOut(DMCNameLeft,rowposition,PictureColourPallette[rowcount].DMCColourName);
                            Printer()->Canvas->TextOut(StitchLeft,rowposition,AnsiString(PictureColourPallette[rowcount].StitchCount));
                            skeins = PictureColourPallette[rowcount].StitchCount/stitchesperskein + 1;
                            }
                        double roundedskeins = ROUND((((double)PictureColourPallette[rowcount].StitchCount/(double)stitchesperskein) + 0.05)*10.0)/10.0;
                        AnsiString output = AnsiString(skeins) + "  (" + AnsiString(roundedskeins) + ")";
                        Printer()->Canvas->TextOut(SkeinLeft,rowposition,output);
                        }
                    }
                rowcount++;
                colourcount++;
                }
            if (page < pages-1) Printer()->NewPage();
            }

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::PrintSPPPages(void)
{
    pageinfo info = FindPages();

    //count all colours and put them in their page locations
    int numberofpages = info.rows * info.columns;
    DynamicArray < DynamicArray <int> > StitchData;

    try {
        //initialise array
        StitchData.Length = PictureColourPallette.Length;
        for (int i = 0; i < StitchData.Length; i++) {
            StitchData[i].Length = numberofpages;
            for (int j = 0; j < StitchData[i].Length; j++) {
                StitchData[i][j] = 0;
                }
            }

        //fill array
        int pagenumber = -1;
        for (int i = 0; i < info.rows; i++) {
            for (int j = 0; j < info.columns; j++) {
                pagenumber++;
                bool found = false;
                int topleftX = j * info.numglyphswide;
                int toprightX = (j + 1) * info.numglyphswide;
                if (toprightX > Image1->Picture->Width) toprightX = Image1->Picture->Width;
                int topleftY = i * info.numglyphshigh;
                int bottomleftY = (i + 1) * info.numglyphshigh;
                if (bottomleftY > Image1->Picture->Height) bottomleftY = Image1->Picture->Height;
                int k;
                for (int l = topleftY; l < bottomleftY; l++) {
                    for (int m = topleftX; m < toprightX; m++) {
                        found = false;
                        k = 0;
                        while (!found && k < PictureColourPallette.Length) {
                            //first check if it's in the list of already found colours
                            if (Image1->Canvas->Pixels[m][l] == PictureColourPallette[k].Colour){
                                StitchData[k][pagenumber] = StitchData[k][pagenumber] + 1;
                                found = true;
                                }
                            k++;
                            }
                        }
                    }
                }
            }

        //That's the array filled. Now to print the data out.
        //Printer()->Canvas->Font->Name = "Arial";
        //Printer()->Canvas->Font->Size = 10;
        Printer()->Canvas->Font->Name = ChartPrintout.ChartFont;
        Printer()->Canvas->Font->Size = ChartPrintout.ChartFontSize + 2;
        Printer()->Canvas->Font->Color = clBlack;

        //"Hi There" has width 13.34mm at 10 Point Arial
        //the printout will be of the form
        //Key Number, Key Shape, DMC/Anchor Number, DMC Name, Stitches on Page1, Page2.... PageN
        //it will form columns of pages if necessary to get all the page stitch data out
        int temp;
        int ColumnSpacing = Printer()->Canvas->TextWidth("88");
        int RowSpacing = 10;
        int KeyNumberWidth = Printer()->Canvas->TextWidth("888");
        int KeyNumberLeft = ColumnSpacing;
        int SymbolLeft = KeyNumberWidth + 2 * ColumnSpacing;
        int SymbolWidth = Printer()->Canvas->TextWidth("Symbol");
        if (2 * GlyphSize > SymbolWidth) SymbolWidth = 2 * GlyphSize;
        int DMCNumberWidth = 0;
        int DMCNameWidth = 0;
        for (int i = 0; i < PictureColourPallette.Length; i++) {
            if (UseAnchor->Checked) {
                temp = Printer()->Canvas->TextWidth(PictureColourPallette[i].AnchorColourNumber);
                if (DMCNumberWidth < temp) DMCNumberWidth = temp;
                } else {
                temp = Printer()->Canvas->TextWidth(PictureColourPallette[i].DMCColourNumber);
                if (DMCNumberWidth < temp) DMCNumberWidth = temp;
                }
            temp  = Printer()->Canvas->TextWidth(PictureColourPallette[i].DMCColourName);
            if (DMCNameWidth < temp) DMCNameWidth = temp;
            }
        if (UseAnchor->Checked) {
            temp = Printer()->Canvas->TextWidth("Anchor#");
            if (DMCNumberWidth < temp) DMCNumberWidth = temp;
            temp  = Printer()->Canvas->TextWidth("Colour Name");
            if (DMCNameWidth < temp) DMCNameWidth = temp;
            } else {
            //temp = Printer()->Canvas->TextWidth("DMC#");
            temp = Printer()->Canvas->TextWidth(ShortThreadName + "#");
            if (DMCNumberWidth < temp) DMCNumberWidth = temp;
            }
        int DMCNumberLeft = SymbolLeft + SymbolWidth + ColumnSpacing;
        int DMCNameLeft = DMCNumberLeft + DMCNumberWidth + ColumnSpacing;
        int StitchLeft = DMCNameLeft + DMCNameWidth + ColumnSpacing;
        int RowHeight = Printer()->Canvas->TextHeight("Tq");
        if (RowHeight < (2 * GlyphSize)) RowHeight = 2 * GlyphSize;
        //Right, now the only thing to do is to see how many pages there will be.
        int rowsperpage = Printer()->PageHeight/(RowHeight + RowSpacing) - 2;
        int pages;
        int numberofrows;
        if (UseAnchor->Checked) {
            numberofrows = 0;
            for (int i = 0; i < PictureColourPallette.Length; i++) {
                if (PictureColourPallette[i].AnchorStitchCount != 0) numberofrows++;
                }
            pages = numberofrows/rowsperpage + 1;
            } else {
            numberofrows = PictureColourPallette.Length;
            pages = PictureColourPallette.Length/rowsperpage + 1;
            }
        //now to see how many columns there will be on each page
        int StitchPrintWidth = 0;
        for (int i = 0; i < StitchData.Length; i++) {
            for (int j = 0; j < StitchData[i].Length; j++) {
                temp = Printer()->Canvas->TextWidth(AnsiString(StitchData[i][j]));
                if (StitchPrintWidth < temp) StitchPrintWidth = temp;
                }
            }
        temp = Printer()->Canvas->TextWidth("P888");
        if (StitchPrintWidth < temp) StitchPrintWidth = temp;
        int numberofcolumnsperpage = (Printer()->PageWidth - StitchLeft + ColumnSpacing)/(StitchPrintWidth + ColumnSpacing);
        if (numberofcolumnsperpage == 0) numberofcolumnsperpage = 1;
        //int numberofpagecolumns = (numberofpages / numberofcolumnsperpage) + 1;
        int numberofpagecolumns = (numberofpages / numberofcolumnsperpage);
        if (numberofpages % numberofcolumnsperpage) numberofpagecolumns++;


        //now to print
        int rowcount = 0;
        int colourcount = 0;
        if (!Background->Checked) {
            rowcount = 1;
            colourcount = 1;
            }
        int thispage = 0;
        int totalpages = numberofpagecolumns * pages;

        for (int page = 0; page < pages; page++) {
            for (int pagecolumn = 0; pagecolumn < numberofpagecolumns; pagecolumn++) {
                colourcount = rowsperpage * (page );
                //rowcount = colourcount;
                rowcount = rowsperpage * (page);
                //rowcount = 0;
                thispage++;
                //Header Row
                Printer()->Canvas->TextOut(KeyNumberLeft,RowSpacing * 2 + RowHeight,"Ref#");
                Printer()->Canvas->TextOut(SymbolLeft,RowSpacing * 2 + RowHeight,"Shape");
                if (UseAnchor->Checked) {
                    Printer()->Canvas->TextOut(DMCNumberLeft,RowSpacing * 2 + RowHeight,"Anchor#");
                    Printer()->Canvas->TextOut(DMCNameLeft,RowSpacing * 2 + RowHeight,"Colour Name");
                    } else {
                    //Printer()->Canvas->TextOut(DMCNumberLeft,RowSpacing * 2 + RowHeight,"DMC#");
                    //Printer()->Canvas->TextOut(DMCNameLeft,RowSpacing * 2 + RowHeight,"DMC Name");
                    Printer()->Canvas->TextOut(DMCNumberLeft,RowSpacing * 2 + RowHeight,ShortThreadName + "#");
                    Printer()->Canvas->TextOut(DMCNameLeft,RowSpacing * 2 + RowHeight,ShortThreadName + " Name");
                    }
                Printer()->Canvas->TextOut(StitchLeft,RowSpacing,"Number of Stitches");
                for (int j = 0; j < numberofcolumnsperpage; j++) {
                    if ((j + numberofcolumnsperpage * pagecolumn) <  StitchData[0].Length) {
                        Printer()->Canvas->TextOut(StitchLeft + j *(StitchPrintWidth + ColumnSpacing) + StitchPrintWidth - Printer()->Canvas->TextWidth("P" + AnsiString(j + numberofcolumnsperpage * pagecolumn + 1)),RowSpacing * 2 + RowHeight,"P" + AnsiString(j + numberofcolumnsperpage * pagecolumn + 1));
                        }
                    }
                for (int i = 0; i < rowsperpage; i++) {
                    //find the colour to print for this line
                    bool stop = false;
                    while (colourcount < PictureColourPallette.Length && !stop) {
                        if (UseAnchor->Checked) {
                            if (colourcount == PictureColourPallette[colourcount].AnchorColourToUse) {
                                stop = true;
                                } else {
                                colourcount++;
                                }
                            } else {
                            stop = true;
                            }
                        }
                    if (colourcount < PictureColourPallette.Length) {
                        if ((rowcount == 0 && Background->Checked) || rowcount > 0) {
                            int rowposition = (i + 2) * (RowSpacing + RowHeight) + RowSpacing;
                            if (UseAnchor->Checked) {
                                Printer()->Canvas->TextOut(KeyNumberLeft,rowposition,AnsiString(PictureColourPallette[colourcount].AnchorGlyphToUse));
                                DrawAnchorGlyph(Printer()->Canvas,SymbolLeft,rowposition,RowHeight,PictureColourPallette[colourcount].AnchorGlyphToUse, false, PictureColourPallette[colourcount].Colour, PictureColourPallette[colourcount].DrawWhite);
                                Printer()->Canvas->TextOut(DMCNumberLeft,rowposition,PictureColourPallette[colourcount].AnchorColourNumber);
                                Printer()->Canvas->TextOut(DMCNameLeft,rowposition,PictureColourPallette[colourcount].DMCColourName);
                                } else {
                                Printer()->Canvas->TextOut(KeyNumberLeft,rowposition,AnsiString(rowcount));
                                DrawGlyph(Printer()->Canvas,SymbolLeft,rowposition,RowHeight, rowcount, false);
                                Printer()->Canvas->TextOut(DMCNumberLeft,rowposition,PictureColourPallette[rowcount].DMCColourNumber);
                                Printer()->Canvas->TextOut(DMCNameLeft,rowposition,PictureColourPallette[rowcount].DMCColourName);
                                for (int j = 0; j < numberofcolumnsperpage; j++) {
                                    if ((j + numberofcolumnsperpage * pagecolumn) <  numberofpages && rowcount < StitchData.Length) {
                                        Printer()->Canvas->TextOut(StitchLeft + j *(StitchPrintWidth + ColumnSpacing) + StitchPrintWidth - Printer()->Canvas->TextWidth(AnsiString(StitchData[rowcount][j + numberofcolumnsperpage * pagecolumn])) ,rowposition,AnsiString(StitchData[rowcount][j + numberofcolumnsperpage * pagecolumn]));
                                        }
                                    }
                                }
                            }
                        }
                    colourcount++;
                    rowcount++;
                    }
                if (thispage < totalpages) Printer()->NewPage();
                }
            }



        }

    __finally {
        //clear Data
        for (int i = 0; i < StitchData.Length; i++) {
            StitchData[i].Length = 0;
            }
        StitchData.Length = 0;
        }

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::PrintFabricPages(void)
{
    //Printer()->Canvas->Font->Name = "Arial";
    //Printer()->Canvas->Font->Size = 10;
    Printer()->Canvas->Font->Name = ChartPrintout.ChartFont;
    Printer()->Canvas->Font->Size = ChartPrintout.ChartFontSize + 2;
    Printer()->Canvas->Font->Color = clBlack;

    //now to do some calculations on the complexity of the pattern
    DynamicArray <bool> ColourUsed;
    ColourUsed.Length = PictureColourPallette.Length;
    int colourcount;
    int maxcolours = 0;
    int totalcolours = 0;
    int squarecount = 0;
    int maxx, maxy, result;
    int mincolour;
    if (backgroundcolourfound) {
        mincolour = 1;
        } else {
        mincolour = 0;
        }
    double averagecount = 0.0;
    bool firsttimeround = true;
    int mincolours, minx, miny, Maxx, Maxy;

    //for (int x = 0; x < Image1->Picture->Width - 10; x++) {
        //for (int y = 0; y < Image1->Picture->Height - 10; y++) {
    for (int x = 0; x < Image1->Picture->Width; x += 10) {
        for (int y = 0; y < Image1->Picture->Height; y += 10) {
            for (int i = 0; i < ColourUsed.Length; i++) {
                ColourUsed[i] = false;
                }
            maxx = 10;
            if (x + maxx > Image1->Picture->Width) maxx = Image1->Picture->Width - x;
            maxy = 10;
            if (y + maxy > Image1->Picture->Height) maxy = Image1->Picture->Height - y;
            for (int i = 0; i < maxx; i++) {
                for (int j = 0; j < maxy; j++) {
                    result = FindColoutRefAtPixel(x + i, y + j);
                    if (result > -1 && result < ColourUsed.Length) ColourUsed[result] = true;
                    }
                }
            colourcount = 0;
            for (int i = mincolour; i < ColourUsed.Length; i++) {
                if (ColourUsed[i]) {
                    colourcount++;
                    }
                }
            if (colourcount > maxcolours) {
                maxcolours = colourcount;
                Maxx = x;
                Maxy = y;
                }
            totalcolours += colourcount;
            if (colourcount > 0) squarecount++;
            if (firsttimeround && colourcount != 0) {
                mincolours = colourcount;
                firsttimeround = false;
                minx = x;
                miny = y;
                }
            if (mincolours > colourcount && colourcount != 0) {
                mincolours = colourcount;
                minx = x;
                miny = y;
                }
            }
        }

    if (squarecount != 0) averagecount = ((double) totalcolours)/((double) squarecount);

    ColourUsed.Length = 0;

        //This the fabric detail printout
        int ColumnSpacing = Printer()->Canvas->TextWidth("88");
        int RowSpacing = Printer()->Canvas->TextWidth(" ");
        int Tab1 = Printer()->Canvas->TextWidth("Fabric ") + ColumnSpacing;
        int Tab2 = Printer()->Canvas->TextWidth("Max. No. colours in 10 x 10 square   ") + ColumnSpacing;
        int row = 1;
        int RowHeight = Printer()->Canvas->TextHeight("Tg");
        AnsiString size;
        double dimension;
        double roundeddimension;
        Printer()->Canvas->Font->Style = Printer()->Canvas->Font->Style << fsBold;
        Printer()->Canvas->Font->Style = Printer()->Canvas->Font->Style << fsUnderline;
        Printer()->Canvas->TextOut(ColumnSpacing,row*(RowHeight + RowSpacing),"Fabric Details");
        Printer()->Canvas->Font->Style = Printer()->Canvas->Font->Style >> fsBold;
        Printer()->Canvas->Font->Style = Printer()->Canvas->Font->Style >> fsUnderline;
        row += 2;
        Printer()->Canvas->TextOut(ColumnSpacing,row*(RowHeight + RowSpacing),"Picture Thread Count");
        Printer()->Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),StitchCount->Items->Strings[StitchCount->ItemIndex] + " Stitches Per Inch");
        row++;
        Printer()->Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),Label5->Caption + " Stitches total.");
        row += 2;
        Printer()->Canvas->TextOut(ColumnSpacing,row*(RowHeight + RowSpacing),"Picture Size");
        dimension = (double)Image1->Width/(double)StitchCount->Items->Strings[StitchCount->ItemIndex].ToIntDef(9);
        roundeddimension = ROUND(dimension * 100.0)/100.0;
        size = "(" + AnsiString(roundeddimension) + " Inches, " + AnsiString(Image1->Width) + " Stitches) Wide.";
        dimension = dimension * 2.54;
        roundeddimension = ROUND(dimension * 10.0)/10.0;
        size = AnsiString(roundeddimension) + "cm " + size;
        Printer()->Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),size);
        row++;
        dimension = (double)Image1->Height/(double)StitchCount->Items->Strings[StitchCount->ItemIndex].ToIntDef(9);
        roundeddimension = ROUND(dimension * 100.0)/100.0;
        size = "(" + AnsiString(roundeddimension) + " Inches, " + AnsiString(Image1->Height) + " Stitches) High.";
        dimension = dimension * 2.54;
        roundeddimension = ROUND(dimension * 10.0)/10.0;
        size = AnsiString(roundeddimension) + "cm " + size;
        Printer()->Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),size);
        row += 2;
        Printer()->Canvas->TextOut(ColumnSpacing,row*(RowHeight + RowSpacing),"Minimum Fabric Size");
        dimension = (double)Image1->Width/(double)StitchCount->Items->Strings[StitchCount->ItemIndex].ToIntDef(9) + 5.0;
        roundeddimension = ROUND(dimension * 100.0)/100.0;
        size = "(" + AnsiString(roundeddimension) + " Inches) Wide.";
        dimension = dimension * 2.54;
        roundeddimension = ROUND(dimension * 10.0)/10.0;
        size = AnsiString(roundeddimension) + "cm " + size;
        Printer()->Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),size);
        row++;
        dimension = (double)Image1->Height/(double)StitchCount->Items->Strings[StitchCount->ItemIndex].ToIntDef(9) + 5.0;
        roundeddimension = ROUND(dimension * 100.0)/100.0;
        size = "(" + AnsiString(roundeddimension) + " Inches) High.";
        dimension = dimension * 2.54;
        roundeddimension = ROUND(dimension * 10.0)/10.0;
        size = AnsiString(roundeddimension) + "cm " + size;
        Printer()->Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),size);

        if (backgroundcolourfound) {
            if (UseAnchor->Checked) {
                row += 2;
                Printer()->Canvas->TextOut(ColumnSpacing,row*(RowHeight + RowSpacing),"Fabric");
                Printer()->Canvas->TextOut(Tab1,row*(RowHeight + RowSpacing),"Anchor Colour Number");
                Printer()->Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),PictureColourPallette[0].AnchorColourNumber);
                row++;
                Printer()->Canvas->TextOut(Tab1,row*(RowHeight + RowSpacing),"Colour Name");
                Printer()->Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),PictureColourPallette[0].DMCColourName);
                } else {
                row += 2;
                Printer()->Canvas->TextOut(ColumnSpacing,row*(RowHeight + RowSpacing),"Fabric");
                //Printer()->Canvas->TextOut(Tab1,row*(RowHeight + RowSpacing),"DMC Colour Number");
                Printer()->Canvas->TextOut(Tab1,row*(RowHeight + RowSpacing),ShortThreadName + " Colour Number");
                Printer()->Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),PictureColourPallette[0].DMCColourNumber);
                row++;
                //Printer()->Canvas->TextOut(Tab1,row*(RowHeight + RowSpacing),"DMC Colour Name");
                Printer()->Canvas->TextOut(Tab1,row*(RowHeight + RowSpacing),ShortThreadName + " Colour Name");
                Printer()->Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),PictureColourPallette[0].DMCColourName);
                }
            }

        //complexity info
        row += 2;
        Printer()->Canvas->TextOut(ColumnSpacing,row*(RowHeight + RowSpacing),"Picture Complexity");
        row++;
        Printer()->Canvas->TextOut(ColumnSpacing,row*(RowHeight + RowSpacing),"Max. No. colours in 10 x 10 square");
        Printer()->Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),AnsiString(maxcolours) + " at X = " + AnsiString(Maxx) + " Y = " + AnsiString(Maxy));
        row++;
        Printer()->Canvas->TextOut(ColumnSpacing,row*(RowHeight + RowSpacing),"Ave. No. colours in 10 x 10 square");
        Printer()->Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),DP(1,averagecount));
        if (mincolours != 0) {
            row++;
            Printer()->Canvas->TextOut(ColumnSpacing,row*(RowHeight + RowSpacing),"Min. No. colours in 10 x 10 square");
            Printer()->Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),AnsiString(mincolours) + " at X = " + AnsiString(minx) + " Y = " + AnsiString(miny));
            }

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::ColourReduction1Click(TObject *Sender)
{
    //this allows the user to access the image colour reduction routine
    TThreadConversionForm *ThreadConversionForm = new TThreadConversionForm(this);

    if (OriginalBitmap->Empty) {
        ThreadConversionForm->Image1->Picture->Bitmap->Assign(Image1->Picture->Bitmap);
        OriginalBitmap->Assign(Image1->Picture->Bitmap);
        } else {
        ThreadConversionForm->Image1->Picture->Bitmap->Assign(OriginalBitmap);
        }
    ThreadConversionForm->DMCColourList.Length = DMCColourList.Length;
    for (int i = 0; i < DMCColourList.Length; i++) {
        ThreadConversionForm->DMCColourList[i] = DMCColourList[i];
        }
    ThreadConversionForm->TweedList.Length = TweedList.Length;
    for (int i = 0; i < TweedList.Length; i++) {
        ThreadConversionForm->TweedList[i].Data = TweedList[i].Data;
        ThreadConversionForm->TweedList[i].ColourPairs.Length = TweedList[i].ColourPairs.Length;
        for (int j = 0; j < TweedList[i].ColourPairs.Length; j++) {
            ThreadConversionForm->TweedList[i].ColourPairs[j] = TweedList[i].ColourPairs[j];
            }
        }
    Conversion.imageheight = Image1->Height;
    Conversion.imagewidth = Image1->Width;
    ThreadConversionForm->Conversion = Conversion;
    ThreadConversionForm->BlendThreads->Checked = blendthreads;
    ThreadConversionForm->Initialise();

    if (ThreadConversionForm->ShowModal() == mrOk) {
        //revised picture is OK, so swap out old picture for new one
        PictureChanged = true;
        if (!OriginalImageFile.loaded && ThreadConversionForm->Image2->Picture->Bitmap->Width != OriginalBitmap->Width) {
            OriginalImage->Assign(OriginalBitmap);
            OriginalImageFile.loaded = true;
            OriginalImageFile.filename = PictureFileName;
            OriginalImageFile.scalefactor = ((double)(OriginalBitmap->Width))/((double)(ThreadConversionForm->Image2->Picture->Bitmap->Width));
            OriginalImageFile.offsetx = 0;
            OriginalImageFile.offsety = 0;
            OriginalImageFile.saved = false;
            }
        Image1->Picture->Bitmap->Assign(ThreadConversionForm->Image2->Picture->Bitmap);
        if (!PictureFileName.Pos("Pasted") && !PictureFileName.Pos("reduced colours")) {
            if (ThreadConversionForm->PictureChanged) {
                PictureFileName = ChangeFileExt(PictureFileName," Pasted Image.bmp");
                } else {
                PictureFileName = ChangeFileExt(PictureFileName," reduced colours.bmp");
                }
            }
        HeightLabel->Caption = AnsiString(Image1->Height) + " Pixels";
        WidthLabel->Caption = AnsiString(Image1->Width) + " Pixels";
        double value;
        value = double(Image1->Height) /double( StitchCount->Items->Strings[StitchCount->ItemIndex].ToIntDef(14));
        value = ROUND(value * 100.0)/100.0;
        Label10->Caption = AnsiString(value) + "\"";
        value = value * 2.54;
        value = ROUND(value * 100.0)/100.0;
        Label10->Caption = Label10->Caption + ",   " + AnsiString(value) + "cm";
        value = double(Image1->Width) /double( StitchCount->Items->Strings[StitchCount->ItemIndex].ToIntDef(1));
        value = ROUND(value * 100.0)/100.0;
        Label11->Caption = AnsiString(value) + "\"";
        value = value * 2.54;
        value = ROUND(value * 100.0)/100.0;
        Label11->Caption = Label11->Caption + ",   " + AnsiString(value) + "cm";
        ThreadConversionForm->RetrieveData();
        Conversion = ThreadConversionForm->Conversion;
        blendthreads = ThreadConversionForm->BlendThreads->Checked;
        UseAnchor->Enabled = !blendthreads;
        if (blendthreads) {
            UseAnchor->Checked = false;
            }
        FillPictureData();
        FillPrinterData();
        }

    delete ThreadConversionForm;

    FormResize(this);

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::ReverttoOriginalImage1Click(TObject *Sender)
{
        PictureChanged = false;
        Image1->Picture->Bitmap->Assign(OriginalBitmap);
        HeightLabel->Caption = AnsiString(Image1->Height) + " Pixels";
        WidthLabel->Caption = AnsiString(Image1->Width) + " Pixels";
        double value;
        value = double(Image1->Height) /double( StitchCount->Items->Strings[StitchCount->ItemIndex].ToIntDef(14));
        value = ROUND(value * 100.0)/100.0;
        Label10->Caption = AnsiString(value) + "\"";
        value = value * 2.54;
        value = ROUND(value * 100.0)/100.0;
        Label10->Caption = Label10->Caption + ",   " + AnsiString(value) + "cm";
        value = double(Image1->Width) /double( StitchCount->Items->Strings[StitchCount->ItemIndex].ToIntDef(1));
        value = ROUND(value * 100.0)/100.0;
        Label11->Caption = AnsiString(value) + "\"";
        value = value * 2.54;
        value = ROUND(value * 100.0)/100.0;
        Label11->Caption = Label11->Caption + ",   " + AnsiString(value) + "cm";
        if (BackStitches.Length && (UndoStitchOffset.X != 0 || UndoStitchOffset.Y != 0)) {
            for (int i = 0; i < BackStitches.Length; i++) {
                BackStitches[i].X1 += (float) UndoStitchOffset.X;
                BackStitches[i].Y1 += (float) UndoStitchOffset.Y;
                BackStitches[i].X2 += (float) UndoStitchOffset.X;
                BackStitches[i].Y2 += (float) UndoStitchOffset.Y;
                }
            backstitcheschanged = true;
            }
        OriginalImageFile.offsetx -= UndoStitchOffset.X * OriginalImageFile.scalefactor;
        OriginalImageFile.offsety -= UndoStitchOffset.Y * OriginalImageFile.scalefactor;
        UndoStitchOffset.X = 0;
        UndoStitchOffset.Y = 0;
        FillPictureData();
        CountBackStitches();
        AssignAnchorColours();
        FillPrinterData();

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::MergeSubstituteColours1Click(TObject *Sender)
{
    //Opens window to merge & substitute colours.
    if (OriginalBitmap->Empty) {
        OriginalBitmap->Assign(Image1->Picture->Bitmap);
        }
    TThreadMergeForm *ThreadMergeForm = new TThreadMergeForm(this);

    ThreadMergeForm->DMCColourList.Length = DMCColourList.Length;
    ThreadMergeForm->PictureColourPallette.Length = PictureColourPallette.Length;
    ThreadMergeForm->TweedList.Length = TweedList.Length;
    ThreadMergeForm->ShortThreadName = ShortThreadName;


    for (int i = 0; i < DMCColourList.Length; i++) {
        ThreadMergeForm->DMCColourList[i] = DMCColourList[i];
        }

    for (int i = 0; i < PictureColourPallette.Length; i++) {
        ThreadMergeForm->PictureColourPallette[i] = PictureColourPallette[i];
        }

    for (int i = 0; i < TweedList.Length; i++) {
        ThreadMergeForm->TweedList[i].Data = TweedList[i].Data;
        ThreadMergeForm->TweedList[i].ColourPairs.Length = TweedList[i].ColourPairs.Length;
        for (int k = 0; k < TweedList[i].ColourPairs.Length; k++) {
            ThreadMergeForm->TweedList[i].ColourPairs[k] = TweedList[i].ColourPairs[k];
            }
        }

    //ThreadMergeForm->UpdateListBoxes();
    Image1->Transparent = false;

    ThreadMergeForm->OriginalBitmap->Assign(Image1->Picture->Bitmap);
    ThreadMergeForm->ModifiedBitmap->Assign(Image1->Picture->Bitmap);
    Image1->Transparent = !Background->Checked;

    ThreadMergeForm->StatusBar1->Panels->Items[0]->Text = "No. Colours = " + AnsiString(PictureColourPallette.Length);
    ThreadMergeForm->blendthreads = blendthreads;

    //ThreadMergeForm->ImageResize();
    ThreadMergeForm->Initialise();

    if (ThreadMergeForm->ShowModal() == mrOk) {
        if (ThreadMergeForm->changed) {
            PictureChanged = true;
            Image1->Picture->Bitmap->Assign(ThreadMergeForm->ModifiedBitmap);
            blendthreads = ThreadMergeForm->blendthreads;
            FillPictureData();
            CountBackStitches();
            AssignAnchorColours();
            FillPrinterData();
            }
        }

    delete ThreadMergeForm;
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::CropImage1Click(TObject *Sender)
{
    //allows the user to crop the chart image
    if (OriginalBitmap->Empty) {
        OriginalBitmap->Assign(Image1->Picture->Bitmap);
        }

    TCropChartImageForm *CropChartImageForm = new TCropChartImageForm(this);

    Image1->Transparent = false;

    CropChartImageForm->OriginalBitmap->Assign(Image1->Picture->Bitmap);
    Image1->Transparent = !Background->Checked;
    CropChartImageForm->Initialise();

    if (CropChartImageForm->ShowModal() == mrOk) {
        if (CropChartImageForm->changed) {
            Image1->Picture->Bitmap->Assign(CropChartImageForm->Image2->Picture->Bitmap);
            PictureChanged = true;
            HeightLabel->Caption = AnsiString(Image1->Height) + " Pixels";
            WidthLabel->Caption = AnsiString(Image1->Width) + " Pixels";
            double value;
            value = double(Image1->Height) /double( StitchCount->Items->Strings[StitchCount->ItemIndex].ToIntDef(14));
            value = ROUND(value * 100.0)/100.0;
            Label10->Caption = AnsiString(value) + "\"";
            value = value * 2.54;
            value = ROUND(value * 100.0)/100.0;
            Label10->Caption = Label10->Caption + ",   " + AnsiString(value) + "cm";
            value = double(Image1->Width) /double( StitchCount->Items->Strings[StitchCount->ItemIndex].ToIntDef(1));
            value = ROUND(value * 100.0)/100.0;
            Label11->Caption = AnsiString(value) + "\"";
            value = value * 2.54;
            value = ROUND(value * 100.0)/100.0;
            Label11->Caption = Label11->Caption + ",   " + AnsiString(value) + "cm";
            //now fiddle with backstitches (if present), as they'll be in the wrong position
            chartposition localundo = CropChartImageForm->TopLeftCorner;
            if (BackStitches.Length && (localundo.X != 0 || localundo.Y != 0)) {
                for (int i = 0; i < BackStitches.Length; i++) {
                    BackStitches[i].X1 -= (float) localundo.X;
                    BackStitches[i].Y1 -= (float) localundo.Y;
                    BackStitches[i].X2 -= (float) localundo.X;
                    BackStitches[i].Y2 -= (float) localundo.Y;
                    }
                backstitcheschanged = true;
                //now set the offset for undoing
                UndoStitchOffset.X += localundo.X;
                UndoStitchOffset.Y += localundo.Y;
                OriginalImageFile.offsetx += localundo.X * OriginalImageFile.scalefactor;
                OriginalImageFile.offsety += localundo.Y * OriginalImageFile.scalefactor;
                }
            //now look at the rest of the stuff for doing the chart
            FillPictureData();
            CountBackStitches();
            AssignAnchorColours();
            FillPrinterData();
            }
        }

    delete CropChartImageForm;
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::ThreadSortMethodClick(TObject *Sender)
{
    SortOrder = (TThreadSortOrder) ThreadSortMethod->ItemIndex;
    if (PictureColourPallette.Length) {
        SortThreads();
        SelectBackground();
        //print data
        FillMemo1(false);
        /*
        Memo1->Lines->Clear();
        Label13->Caption = AnsiString(PictureColourPallette.Length);
        for (int i = 0; i < PictureColourPallette.Length; i++) {
            Memo1->Lines->Add(AnsiString (i) + ", DMC "
                                + PictureColourPallette[i].DMCColourNumber + ", "
                                + PictureColourPallette[i].DMCColourName + ", "
                                + AnsiString(PictureColourPallette[i].StitchCount)
                                + (PictureColourPallette[i].StitchCount == 1 ? " Stitch." : " Stitches.")
                                );
            }
        Memo1->SelStart = 0;
        Memo1->SelLength = 0;
        */

        //Now to create the Images for the plotting array
        ImageListCreate();
        }
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::SortThreads(void)
{
    if (PictureColourPallette.Length) {
        //DynamicArray <coloursort> Coloursort;
        //Coloursort.Length = PictureColourPallette.Length;
    //Debug
    /*
    AnsiString text;
    BackStitchListForm->Memo1->Lines->Add("Thread Sorting");
    for (int i = 0; i < BackStitches.Length; i++) {
        text = AnsiString(i) + " From " + AnsiString(BackStitches[i].X1) + "," + AnsiString(BackStitches[i].Y1) + " To " + AnsiString(BackStitches[i].X2) + "," + AnsiString(BackStitches[i].Y2) + "  Colour Ref = " + AnsiString(BackStitches[i].ColourNumber);
        BackStitchListForm->Memo1->Lines->Add(text);
        }
    */
    //end debug

        /*for (int i = 0; i < PictureColourPallette.Length; i++) {
            Coloursort[i].Colour = PictureColourPallette[i].Colour;
            Coloursort[i].newentry = 0;
            }
        */
        switch (SortOrder) {
            case TTSOHue: {
                    DMCColourData Swap;
                    BlendXRef BlendSwap;
                    bool swapped = true;

                    if (PictureColourPallette.Length > 1 && PictureColourPallette[0].Hue > PictureColourPallette[1].Hue) {
                        Swap = PictureColourPallette[0];
                        PictureColourPallette[0] = PictureColourPallette[1];
                        PictureColourPallette[1] = Swap;
                        if (blendthreads) {
                            BlendSwap = BlendReference[0];
                            BlendReference[0] = BlendReference[1];
                            BlendReference[1] = BlendSwap;
                            }
                        }

                    while (swapped) {
                        swapped = false;
                        for (int i = 0; i < PictureColourPallette.Length - 1; i++) {
                            if (PictureColourPallette[i].Hue > PictureColourPallette[i + 1].Hue) {
                                Swap = PictureColourPallette[i];
                                PictureColourPallette[i] = PictureColourPallette[i+1];
                                PictureColourPallette[i+1] = Swap;
                                if (blendthreads) {
                                    BlendSwap = BlendReference[i];
                                    BlendReference[i] = BlendReference[i+1];
                                    BlendReference[i + 1] = BlendSwap;
                                    }
                                swapped = true;
                                }
                            }
                        }
                    }
                    break;
            case TTSODMCNumber: {
                    DMCColourData Swap;
                    BlendXRef BlendSwap;
                    bool swapped = true;

                    if (PictureColourPallette.Length > 1 && (PictureColourPallette[0].DMCColourNumber).ToIntDef(0) > (PictureColourPallette[1].DMCColourNumber).ToIntDef(0)) {
                        Swap = PictureColourPallette[0];
                        PictureColourPallette[0] = PictureColourPallette[1];
                        PictureColourPallette[1] = Swap;
                        if (blendthreads) {
                            BlendSwap = BlendReference[0];
                            BlendReference[0] = BlendReference[1];
                            BlendReference[1] = BlendSwap;
                            }
                        }

                    while (swapped) {
                        swapped = false;
                        for (int i = 0; i < PictureColourPallette.Length - 1; i++) {
                            if (PictureColourPallette[i].DMCColourNumber.ToIntDef(0) == 0 && PictureColourPallette[i + 1].DMCColourNumber.ToIntDef(0) == 0) {
                                //neither thread number is an integer
                                if (PictureColourPallette[i].DMCColourNumber > PictureColourPallette[i + 1].DMCColourNumber) {
                                    Swap = PictureColourPallette[i];
                                    PictureColourPallette[i] = PictureColourPallette[i+1];
                                    PictureColourPallette[i+1] = Swap;
                                    swapped = true;
                                    if (blendthreads) {
                                        BlendSwap = BlendReference[i];
                                        BlendReference[i] = BlendReference[i+1];
                                        BlendReference[i + 1] = BlendSwap;
                                        }
                                    }
                                } else {
                                //One of the thread numbers is a number. This sorts the numbers to the end.
                                if (PictureColourPallette[i].DMCColourNumber.ToIntDef(0) > PictureColourPallette[i + 1].DMCColourNumber.ToIntDef(0)) {
                                    Swap = PictureColourPallette[i];
                                    PictureColourPallette[i] = PictureColourPallette[i+1];
                                    PictureColourPallette[i+1] = Swap;
                                    swapped = true;
                                    if (blendthreads) {
                                        BlendSwap = BlendReference[i];
                                        BlendReference[i] = BlendReference[i+1];
                                        BlendReference[i + 1] = BlendSwap;
                                        }
                                    }
                                }
                            }
                        }
                    }
                    break;
            default:    {
                    DMCColourData Swap;
                    BlendXRef BlendSwap;
                    bool swapped = true;

                    if (PictureColourPallette.Length > 1 && PictureColourPallette[0].StitchCount > PictureColourPallette[1].StitchCount) {
                        Swap = PictureColourPallette[0];
                        PictureColourPallette[0] = PictureColourPallette[1];
                        PictureColourPallette[1] = Swap;
                        if (blendthreads) {
                            BlendSwap = BlendReference[0];
                            BlendReference[0] = BlendReference[1];
                            BlendReference[1] = BlendSwap;
                            }
                        }

                    while (swapped) {
                        swapped = false;
                        for (int i = 0; i < PictureColourPallette.Length - 1; i++) {
                            if (PictureColourPallette[i].StitchCount < PictureColourPallette[i + 1].StitchCount) {
                                Swap = PictureColourPallette[i];
                                PictureColourPallette[i] = PictureColourPallette[i+1];
                                PictureColourPallette[i+1] = Swap;
                                swapped = true;
                                if (blendthreads) {
                                    BlendSwap = BlendReference[i];
                                    BlendReference[i] = BlendReference[i+1];
                                    BlendReference[i + 1] = BlendSwap;
                                    }
                                }
                            }
                        }
                    }
                    break;
            }
        if (BackStitches.Length) {
            /*
            //now go through the colours to find where they have moved to.
            for (int i = 0; i < Coloursort.Length; i++) {
                bool found = false;
                int pointer = 0;
                while (!found && pointer < PictureColourPallette.Length) {
                    if (Coloursort[i].Colour == PictureColourPallette[pointer].Colour) {
                        Coloursort[i].newentry = pointer;
                        found = true;
                        }
                    pointer++;
                    }
                }
            //now change the backstitch reference number
            for (int i = 0; i < BackStitches.Length; i++) {
                if (BackStitches[i].ColourNumber < Coloursort.Length) {
                    BackStitches[i].ColourNumber = Coloursort[BackStitches[i].ColourNumber].newentry;
                    }
                }
            */
            for (int i = 0; i < BackStitches.Length; i++) {
                bool found = false;
                int pointer = 0;
                BackStitches[i].ColourNumber = 0;
                while (!found && pointer < PictureColourPallette.Length) {
                    if (BackStitches[i].Colour == PictureColourPallette[pointer].Colour) {
                        BackStitches[i].ColourNumber = pointer;
                        found = true;
                        }
                    pointer++;
                    }
                }
            }
    //Debug
    /*
    BackStitchListForm->Memo1->Lines->Add("After Thread Sorting");
    for (int i = 0; i < BackStitches.Length; i++) {
        text = AnsiString(i) + " From " + AnsiString(BackStitches[i].X1) + "," + AnsiString(BackStitches[i].Y1) + " To " + AnsiString(BackStitches[i].X2) + "," + AnsiString(BackStitches[i].Y2) + "  Colour Ref = " + AnsiString(BackStitches[i].ColourNumber) + "  Colour= " + AnsiString(BackStitches[i].Colour);
        BackStitchListForm->Memo1->Lines->Add(text);
        }
    */
    /*for (int i = 0; i < Coloursort.Length; i++) {
        text = AnsiString(i) + " Colour " + AnsiString(Coloursort[i].Colour) + " New " + AnsiString(Coloursort[i].newentry);
        BackStitchListForm->Memo1->Lines->Add(text);
        }*/
    //end debug
        //Coloursort.Length = 0;
        }
}
//---------------------------------------------------------------------------

bool __fastcall TPlanForm::SelectBackground(void)
{
    bool found = false;

    if (!Background->Checked) {
        int pointer = 0;
        int savedpointer;
        int stitchnumber = -1;
        DMCColourData Swap;
        BlendXRef BlendSwap;

        while (pointer < PictureColourPallette.Length) {
            for (int i = 0; i < BackgroundList.Length; i++) {
                if (PictureColourPallette[pointer].Colour == BackgroundList[i].Colour) {
                    found = true;
                    if (PictureColourPallette[pointer].StitchCount > stitchnumber) {
                        savedpointer = pointer;
                        stitchnumber = PictureColourPallette[pointer].StitchCount;
                        }
                    }
                }
            pointer++;
            }
        if (found) {
            backgroundcolourfound = true;
            if (pointer != 0) {
                Swap = PictureColourPallette[savedpointer];
                if (blendthreads) BlendSwap = BlendReference[savedpointer];
                for (int i = savedpointer; i > 0; i--) {
                    PictureColourPallette[i] = PictureColourPallette[i - 1];
                    if (blendthreads) BlendReference[i] = BlendReference[i-1];
                    }
                PictureColourPallette[0] = Swap;
                if(blendthreads) BlendReference[0] = BlendSwap;
                }
            }
        }
    return found;
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::DrawFrontSheet(TCanvas *Canvas, int Width, int Height)
{
    //Draws the details of the front sheet on the specified canvas.

    double scale, scalex, scaley;
    int topx, topy, picturewidth, pictureheight;
    if (OriginalImage->Empty) {
        //print chart image
        scalex = (double) (Width/Image1->Width);
        scaley = (double) (Height/Image1->Height);
        if (scalex <= scaley) {
        //if (scalex >= scaley) {
            scale = scalex;
            } else {
            scale = scaley;
            }
        scale = scale/2;
        topx = (Width - (int)((double)Image1->Width * scale))/2;
        topy = (Height - (int)((double)Image1->Height * scale))/2;
        picturewidth = (int)((double)Image1->Width * scale);
        pictureheight = (int)((double)Image1->Height * scale);
        bool trans = Image1->Transparent;
        Image1->Transparent = false;
        Canvas->StretchDraw(Rect(topx,topy,topx + picturewidth,topy + pictureheight),Image1->Picture->Bitmap);
        Image1->Transparent = trans;
        } else {
        //print high res image
        scalex = (double) (Width/OriginalImage->Width);
        scaley = (double) (Height/OriginalImage->Height);
        if (scalex >= scaley) {
            scale = scalex;
            } else {
            scale = scaley;
            }
        scale = scale/2;
        topx = (Width - (int)((double)OriginalImage->Width * scale))/2;
        topy = (Height - (int)((double)OriginalImage->Height * scale))/2;
        picturewidth = (int)((double)OriginalImage->Width * scale);
        pictureheight = (int)((double)OriginalImage->Height * scale);
        OriginalImage->Transparent = false;
        Canvas->StretchDraw(Rect(topx,topy,topx + picturewidth,topy + pictureheight),OriginalImage);
        }

    //now to print out the title etc
    if (LocalChartPrintout.Title.Length()) {
        Canvas->Font->Name = LocalChartPrintout.TitleFont;
        Canvas->Font->Size = LocalChartPrintout.TitleSize;
        int titletopx = (Width - Canvas->TextWidth(LocalChartPrintout.Title))/2;
        int titletopy = (topy - Canvas->TextHeight(LocalChartPrintout.Title))/2;
        Canvas->TextOut(titletopx,titletopy,LocalChartPrintout.Title);
        }

    if (LocalChartPrintout.ImageCopyright.Length()) {
        Canvas->Font->Name = LocalChartPrintout.ImageCopyrightFont;
        Canvas->Font->Size = LocalChartPrintout.ImageCopyrightSize;
        int picturebottom = topy + pictureheight;
        int titletopx = (Width - Canvas->TextWidth(LocalChartPrintout.ImageCopyright))/2;
        int titletopy = (Height + picturebottom)/2 - Canvas->TextHeight(LocalChartPrintout.ImageCopyright);
        Canvas->TextOut(titletopx,titletopy,LocalChartPrintout.ImageCopyright);
        }

    if (LocalChartPrintout.ChartCopyright.Length()) {
        Canvas->Font->Name = LocalChartPrintout.ChartCopyrightFont;
        Canvas->Font->Size = LocalChartPrintout.ChartCopyrightSize;
        int picturebottom = topy + pictureheight;
        int titletopx = (Width - Canvas->TextWidth(LocalChartPrintout.ChartCopyright))/2;
        int titletopy = (Height + picturebottom)/2 + Canvas->TextHeight(LocalChartPrintout.ChartCopyright);
        Canvas->TextOut(titletopx,titletopy,LocalChartPrintout.ChartCopyright);
        }

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::DrawIndexSheet(TCanvas *Canvas, int Width, int Height, pageinfo PageInfo,int ItemIndex)
{
    //When printing the index page, need to know how many pages there are going to be
    //in each section & if the section exists.
    int FrontPage = 1;
    int IndexPage = 1;
    pageinfo ChartInfo = PageInfo;
    int ColourChart = ChartInfo.rows * ChartInfo.columns;
    if (ItemIndex != 0) {
        //only printing a single page from the chart
        ColourChart = 1;
        }
    int MonochromeChart = ColourChart;
    int BackStitch = ColourChart;
    int DetailedKey = FindPagesforKey();
    int StitchesPerPage = FindPagesforSPP();
    int FabricDetails = 1;

    int CurrentPage = 1;

    //right. That's all the page numbers calculated & it's time to start printing the page.
    //Printer()->Canvas->Font->Name = "Arial";
    Canvas->Font->Name = LocalChartPrintout.ChartFont;
    Canvas->Font->Size = LocalChartPrintout.TitleSize;
    int rowspacing = Canvas->TextHeight("Hg")*1.5;
    int rowcount = 3;
    int textx;
    int texty;
    AnsiString text;

    //Print "Contents"
    textx = (Width - Canvas->TextWidth("Contents"))/2;
    texty = rowcount * rowspacing;
    Canvas->TextOut(textx,texty,"Contents");

    //Print header line
    rowcount += 2;
    int offsettexty = rowcount * rowspacing;
    if (LocalChartPrintout.TitleSize > 12) {
        Canvas->Font->Size = 12;
        }
    rowspacing = Canvas->TextHeight("Hg")*1.5;
    rowcount = 0;
    texty = offsettexty + rowcount * rowspacing;
    int tab1 = Canvas->TextWidth("Page");
    int tab2 = Canvas->TextWidth("Page      ") + tab1;
    Canvas->TextOut(tab1,texty,"Page");
    Canvas->TextOut(tab2,texty,"Section");

    //Print front page
    if (LocalChartPrintout.FrontSheet) {
        rowcount++;
        texty = offsettexty + rowcount * rowspacing;
        Canvas->TextOut(tab1,texty,AnsiString(CurrentPage));
        Canvas->TextOut(tab2,texty,"Front Sheet");
        CurrentPage += FrontPage;
        }
    //Print index page
    if (LocalChartPrintout.IndexPage) {
        rowcount++;
        texty = offsettexty + rowcount * rowspacing;
        Canvas->TextOut(tab1,texty,AnsiString(CurrentPage));
        Canvas->TextOut(tab2,texty,"Contents");
        CurrentPage += IndexPage;
        }
    //Print ColourChart
    if (LocalChartPrintout.ColourChart) {
        rowcount++;
        text = "Colour Chart";
        if (PageNumber->ItemIndex != 0) {
            //only printing a single page from the chart
            text += ", Sheet " + AnsiString(PageNumber->ItemIndex);
            }
        texty = offsettexty + rowcount * rowspacing;
        Canvas->TextOut(tab1,texty,AnsiString(CurrentPage));
        Canvas->TextOut(tab2,texty,text);
        CurrentPage += ColourChart;
        }
    //Print MonochromeChart
    if (LocalChartPrintout.MonochromeChart) {
        rowcount++;
        texty = offsettexty + rowcount * rowspacing;
        text = "Monochrome Chart";
        if (PageNumber->ItemIndex != 0) {
            //only printing a single page from the chart
            text += ", Sheet " + AnsiString(PageNumber->ItemIndex);
            }
        Canvas->TextOut(tab1,texty,AnsiString(CurrentPage));
        Canvas->TextOut(tab2,texty,text);
        CurrentPage += MonochromeChart;
        }
    //Print BackStitches
    if (BackStitches.Length > 0) {
        if (LocalChartPrintout.BackStitches) {
            rowcount++;
            texty = offsettexty + rowcount * rowspacing;
            text = "Back Stitches";
            if (PageNumber->ItemIndex != 0) {
                //only printing a single page from the chart
                text += ", Sheet " + AnsiString(PageNumber->ItemIndex);
                }
            Canvas->TextOut(tab1,texty,AnsiString(CurrentPage));
            Canvas->TextOut(tab2,texty,text);
            CurrentPage += BackStitch;
            }
        }
    //Print DetailedKey
    if (LocalChartPrintout.DetailedKey) {
        rowcount++;
        texty = offsettexty + rowcount * rowspacing;
        Canvas->TextOut(tab1,texty,AnsiString(CurrentPage));
        Canvas->TextOut(tab2,texty,"Detailed Key");
        CurrentPage += DetailedKey;
        }
    //Print StitchesPerPage
    if (LocalChartPrintout.StitchesPerPage) {
        rowcount++;
        texty = offsettexty + rowcount * rowspacing;
        Canvas->TextOut(tab1,texty,AnsiString(CurrentPage));
        Canvas->TextOut(tab2,texty,"Stitch Information for Each Page");
        CurrentPage += StitchesPerPage;
        }
    //Print FabricDetails
    if (LocalChartPrintout.FabricDetails) {
        rowcount++;
        texty = offsettexty + rowcount * rowspacing;
        Canvas->TextOut(tab1,texty,AnsiString(CurrentPage));
        Canvas->TextOut(tab2,texty,"Fabric Details");
        CurrentPage += FabricDetails;
        }

    //Print Chart Image
    //however, if no chart is being printed, why would you need a page xref?
    if (LocalChartPrintout.ChartPageXRef && (LocalChartPrintout.ColourChart || LocalChartPrintout.MonochromeChart || LocalChartPrintout.BackStitches)) {
        rowcount += 2;
        texty = offsettexty + rowcount * rowspacing;
        Canvas->TextOut(tab1,texty,"Chart Page Index");
        rowcount++;
        texty = offsettexty + rowcount * rowspacing;
        int imagemaxheight = Printer()->PageHeight - texty;

        double scale, scalex, scaley, scaletext;
        int topx, topy, picturewidth, pictureheight;
        //print page x ref image
        scalex = (double) (Width/Image4->Width);
        scaley = (double) (imagemaxheight/Image4->Height);
        Image4->Canvas->Font->Size = 12;
        scaletext = ((double) Canvas->TextHeight("Hg"))/((double)Image4->Canvas->TextHeight("Hg"));
        if (scalex >= scaley) {
            scale = scaley;
            } else {
            scale = scalex;
            }
        //this bit tries to ensure that the text size on the plan xref image is no bigger on the printed page than in the program
        if (scale > scaletext) scale = scaletext;
        topx = (Width - (int)((double)Image4->Width * scale))/2;
        topy = texty/*(Printer()->PageHeight - (int)((double)Image4->Height * scale))/2*/;
        picturewidth = (int)((double)Image4->Width * scale);
        pictureheight = (int)((double)Image4->Height * scale);
        Canvas->StretchDraw(Rect(topx,topy,topx + picturewidth,topy + pictureheight),Image4->Picture->Bitmap);

        }

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::DrawChartSheet(TCanvas *Canvas, int Width, int Height, int Row, int Column, int GlyphsWide, int GlyphsHigh)
{
    //Printer()->Canvas->Font->Name = "Arial";
    //Printer()->Canvas->Font->Size = 8;
    Canvas->Font->Name =  LocalChartPrintout.ChartFont;
    Canvas->Font->Size = LocalChartPrintout.ChartFontSize;
    Canvas->Font->Color = clBlack;

    int rowspacing = Canvas->TextWidth(" ");
    int keyentrywidth = GlyphSize * 1.5 + Canvas->TextWidth("    " + AnsiString(PictureColourPallette.Length));
    int keyentryheight = Canvas->TextHeight("Tq");
    if (keyentryheight < GlyphSize * 1.5) keyentryheight = GlyphSize * 1.5;
    int keyentrycolumns = Width/keyentrywidth;
    keyentryheight += rowspacing;
    int keyentryrows = PictureColourPallette.Length/ keyentrycolumns + 1;
    int keyheight = keyentryrows * keyentryheight + rowspacing;
    if (!SimpleKey->Checked) keyheight = keyentryheight;

    //now to find out how many glyphs etc
    //int annotationwidth = Canvas->TextWidth("  " + AnsiString(Image1->Height));
    //int pageheight = Height - keyheight - 3 * keyentryheight;
    //int pagewidth = Width - 2* annotationwidth - 2 * rowspacing;
    //int pageglyphwidth = pagewidth/GlyphSize;
    //int pageglyphheight = pageheight/GlyphSize;
    int pageglyphwidth = GlyphsWide;
    int pageglyphheight = GlyphsHigh;
    int pageswide = Image1->Width/pageglyphwidth + 1;
    int pageshigh = Image1->Height/pageglyphheight + 1;
    int PictureHeight = Image1->Height;
    int PictureWidth = Image1->Width;

    printingbackstitches = false;


    //for (int pagerow = 0; pagerow < pageshigh; pagerow++) {
    int pagerow = Row;
        //for (int pagecolumn = 0; pagecolumn < pageswide; pagecolumn++) {
        int pagecolumn = Column;
        //if (PageNumber->ItemIndex == 0 || ((pagerow ) *pageswide + pagecolumn + 1) == PageNumber->ItemIndex) {
            if (SimpleKey->Checked) {
                //Plot the simple key
                int indexcount = 0;
                if (!Background->Checked) indexcount = 1;
                for (int i = 0; i < keyentryrows; i++) {
                    for (int j = 0; j < keyentrycolumns; j++) {
                        //change for anchor
                        if (UseAnchor->Checked) {
                            while (indexcount < PictureColourPallette.Length && PictureColourPallette[indexcount].AnchorStitchCount == 0) {
                                indexcount++;
                                }
                            if (indexcount < PictureColourPallette.Length) {
                                DrawAnchorGlyph(Canvas, rowspacing + j*keyentrywidth,rowspacing + i * keyentryheight,GlyphSize * 1.5,PictureColourPallette[indexcount].AnchorGlyphToUse,false, PictureColourPallette[indexcount].Colour, PictureColourPallette[indexcount].DrawWhite);
                                Canvas->TextOut(rowspacing * 2 + j*keyentrywidth + GlyphSize * 1.5,rowspacing + i * keyentryheight,AnsiString(PictureColourPallette[indexcount].AnchorGlyphToUse));
                                }
                            indexcount++;
                            } else {
                            if (indexcount < PictureColourPallette.Length) {
                                DrawGlyph(Canvas, rowspacing + j*keyentrywidth,rowspacing + i * keyentryheight,GlyphSize * 1.5,indexcount,false);
                                Canvas->TextOut(rowspacing * 2 + j*keyentrywidth + GlyphSize * 1.5,rowspacing + i * keyentryheight,AnsiString(indexcount));
                                }
                            indexcount++;
                            }
                        //end of changed section for Anchor
                        }
                    }
                }//end of simple key

            //now to print out the chart
            int topleftX = pageglyphwidth * pagecolumn;
            int topleftY = pageglyphheight * pagerow;
            int rightedge = 0;
            int bottomedge = 0;
            int stitchcount = 0;
            int maxX = 0;
            int maxY = 0;
            for (int i = 0; i < pageglyphwidth; i++) {
                for (int j = 0; j < pageglyphheight; j++) {
                    int pixelX = topleftX + i;
                    int pixelY = topleftY + j;
                    if (pixelX < PictureWidth && pixelY < PictureHeight) {
                        //now can plot the glyph
                        bool found = false;
                        int counter = 0;
                        while (!found && counter < PictureColourPallette.Length) {
                            if (Image1->Canvas->Pixels[pixelX][pixelY] == PictureColourPallette[counter].Colour) {
                                found = true;
                                counter--;
                                }
                            counter++;
                            }
                        if (counter != 0 || (counter == 0 && Background->Checked)) {
                            //changed for anchor
                            if (UseAnchor->Checked) {
                                DrawAnchorGlyph(Canvas,rowspacing + i*GlyphSize,keyheight + keyentryheight + j*GlyphSize,GlyphSize, PictureColourPallette[counter].AnchorGlyphToUse, true, PictureColourPallette[PictureColourPallette[counter].AnchorColourToUse].Colour, PictureColourPallette[counter].DrawWhite);
                                } else {
                                DrawGlyph(Canvas,rowspacing + i*GlyphSize,keyheight + keyentryheight + j*GlyphSize,GlyphSize, counter, true);
                                }
                            //end of section changed for anchor
                            stitchcount++;
                            } else {
                            DrawEmptyGlyph(Canvas,rowspacing + i*GlyphSize,keyheight + keyentryheight + j*GlyphSize,GlyphSize);
                            }
                        if (rightedge < (rowspacing + i*GlyphSize)) rightedge = rowspacing + i*GlyphSize;
                        if (bottomedge < (keyheight + keyentryheight + j*GlyphSize)) bottomedge = keyheight + keyentryheight + j*GlyphSize;
                        if (maxX < pixelX) maxX = pixelX;
                        if (maxY < pixelY) maxY = pixelY;
                        }
                    }
                }
            //draw on peripheral black lines
            Canvas->Pen->Color = clBlack;
            Canvas->Pen->Mode = pmCopy;
            Canvas->Pen->Style = psSolid;
            Canvas->Pen->Width = GlyphSize/20;
            rightedge += GlyphSize;
            bottomedge += GlyphSize;
            Canvas->MoveTo(rightedge,keyheight + keyentryheight);
            Canvas->LineTo(rightedge,bottomedge);
            Canvas->LineTo(rowspacing,bottomedge);
            Canvas->LineTo(rowspacing,keyheight + keyentryheight);
            Canvas->LineTo(rightedge,keyheight + keyentryheight);

            //CL was here

            //draw 10's lines
            Canvas->Pen->Color = clBlack;
            Canvas->Pen->Mode = pmCopy;
            Canvas->Pen->Style = psSolid;
            Canvas->Pen->Width = GlyphSize/20;
            //Vertical lines & annotations
            for (int i = 0; i < pageglyphwidth + 1; i++) {
                int j = topleftX + i;
                if (j == (int) (ROUND((double)j/10.0) * 10.0) && j < PictureWidth + 1) {
                    //it's a line to be written
                    Canvas->MoveTo(rowspacing + i * GlyphSize,keyheight + keyentryheight);
                    Canvas->LineTo(rowspacing + i * GlyphSize,bottomedge);
                    Canvas->TextOut(rowspacing + i * GlyphSize,keyheight ,AnsiString(j));
                    }
                }
            //Horizontal lines & annotations
            for (int i = 0; i < pageglyphheight + 1; i++) {
                int j = pageglyphheight * pagerow + i;
                if (j == (int) (ROUND((double)j/10.0) * 10.0) && j < Image1->Height + 1) {
                    //it's a line to be written
                    Canvas->MoveTo(rowspacing,keyheight + keyentryheight + i*GlyphSize);
                    Canvas->LineTo(rightedge,keyheight + keyentryheight + i*GlyphSize);
                    Canvas->TextOut(rowspacing + rightedge,keyheight + keyentryheight/2 + i*GlyphSize,AnsiString(j));
                    }
                }
            //print right extreme character no & bottom extreme char no
            TBrushStyle t1 = Canvas->Brush->Style;
            Canvas->Brush->Style = bsClear;
            Canvas->TextOut(rightedge, keyheight, AnsiString(maxX + 1));
            Canvas->Brush->Style = t1;
            Canvas->TextOut(rowspacing + rightedge, 3 + bottomedge - Canvas->TextHeight("123"), AnsiString(maxY + 1));

            //draw centrelines
            //Vertical centreline
            bool clxfound = false;
            int xoffset,yoffset;
            bool clyfound = false;
            int centrelinex = Image1->Width/2;
            if (topleftX < centrelinex && (topleftX + pageglyphwidth) > centrelinex) {
                //it's on this page
                xoffset = (centrelinex - topleftX)*GlyphSize + rowspacing;
                clxfound = true;
                Canvas->Pen->Color = clPurple;
                Canvas->Pen->Mode = pmCopy;
                Canvas->Pen->Style = psDashDotDot;
                Canvas->Pen->Width = GlyphSize/10;
                Canvas->MoveTo(xoffset,keyheight + keyentryheight);
                Canvas->LineTo(xoffset,bottomedge);
                //draw CL mark
                TBrushStyle t1 = Canvas->Brush->Style;
                int cwidth = Canvas->TextWidth("C")/3;
                int cheight = Canvas->TextHeight("C")/3;
                Canvas->Brush->Style = bsClear;
                Canvas->TextOut(xoffset - cwidth,keyheight ,"C");
                Canvas->TextOut(xoffset,keyheight  + cheight,"L");
                Canvas->Brush->Style = t1;
                }
            //Horizontal centreline
            int centreliney = Image1->Height/2;
            if (topleftY < centreliney && (topleftY + pageglyphheight) > centreliney) {
                //it's on this page
                yoffset = (centreliney - topleftY)*GlyphSize + keyheight + keyentryheight;
                clyfound = true;
                Canvas->Pen->Color = clPurple;
                Canvas->Pen->Mode = pmCopy;
                Canvas->Pen->Style = psDashDotDot;
                Canvas->Pen->Width = GlyphSize/10;
                Canvas->MoveTo(rowspacing,yoffset);
                Canvas->LineTo(rightedge,yoffset);
                //draw CL mark
                TBrushStyle t1 = Canvas->Brush->Style;
                int cwidth = Canvas->TextWidth("C")/3;
                int cheight = Canvas->TextHeight("C")/3;
                Canvas->Brush->Style = bsClear;
                Canvas->TextOut(rowspacing + rightedge - cwidth,yoffset - cheight ,"C");
                Canvas->TextOut(rowspacing + rightedge,yoffset ,"L");
                Canvas->Brush->Style = t1;
                }

            //Highlight centrepoint
            if (clxfound && clyfound) {
                //draw red cross at centre point
                Canvas->Pen->Color = clRed;
                Canvas->Pen->Mode = pmCopy;
                Canvas->Pen->Style = psSolid;
                Canvas->Pen->Width = GlyphSize/5;
                Canvas->MoveTo(xoffset,yoffset - GlyphSize/2);
                Canvas->LineTo(xoffset,yoffset + GlyphSize/2);
                Canvas->MoveTo(xoffset - GlyphSize/2, yoffset);
                Canvas->LineTo(xoffset + GlyphSize/2, yoffset);
                Canvas->MoveTo(xoffset - GlyphSize/2, yoffset - GlyphSize/2);
                Canvas->LineTo(xoffset + GlyphSize/2, yoffset + GlyphSize/2);
                Canvas->MoveTo(xoffset - GlyphSize/2, yoffset + GlyphSize/2);
                Canvas->LineTo(xoffset + GlyphSize/2, yoffset - GlyphSize/2);
                }

            Canvas->Pen->Width = GlyphSize/20;

            //footer so that the user never looses track of the page position or the number of stitches to be done
            Canvas->TextOut(rowspacing,Height - keyentryheight,
                    "This is Page " + AnsiString(pagerow*pageswide + pagecolumn + 1)
                    + " of " + AnsiString(pageshigh * pageswide)
                    + ";    Row " + AnsiString(pagerow + 1) + " of " + AnsiString(pageshigh)
                    + ";    Column "  + AnsiString(pagecolumn + 1) + " of " + AnsiString(pageswide)
                    );
            Canvas->TextOut(Width - Canvas->TextWidth(AnsiString(stitchcount) + " of " + Label5->Caption + " Stitches on this Page.   "),Height - keyentryheight,
                    AnsiString(stitchcount) + " of " + Label5->Caption + " Stitches on this Page."
                    );


            //print this page, as it's complete.
            //if (!(pagerow == pageshigh-1 && pagecolumn == pageswide-1) && PageNumber->ItemIndex == 0) Printer()->NewPage();
            //}
            //}    //end of  for (int pagecolumn = 0; pagecolumn < pageswide; pagecolumn++)
        //} //end of  for (int pagerow = 0; pagerow < pageshigh; pagerow++)

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::DrawBackstitchSheet(TCanvas *Canvas, int Width, int Height, int Row, int Column, int GlyphsWide, int GlyphsHigh)
{
    //Printer()->Canvas->Font->Name = "Arial";
    //Printer()->Canvas->Font->Size = 8;
    Canvas->Font->Name = LocalChartPrintout.ChartFont;
    Canvas->Font->Size = LocalChartPrintout.ChartFontSize;
    Canvas->Font->Color = clBlack;

    int rowspacing = Canvas->TextWidth(" ");
    int keyentrywidth = GlyphSize * 1.5 + Canvas->TextWidth("    " + AnsiString(PictureColourPallette.Length));
    int keyentryheight = Canvas->TextHeight("Tq");
    if (keyentryheight < GlyphSize * 1.5) keyentryheight = GlyphSize * 1.5;
    int keyentrycolumns = Width/keyentrywidth;
    keyentryheight += rowspacing;
    int keyentryrows = PictureColourPallette.Length/ keyentrycolumns + 1;
    int keyheight = keyentryrows * keyentryheight + rowspacing;
    if (!SimpleKey->Checked) keyheight = keyentryheight;

    //now to find out how many glyphs etc
    //int annotationwidth = Canvas->TextWidth("  " + AnsiString(Image1->Height));
    //int pageheight = Height - keyheight - 3 * keyentryheight;
    //int pagewidth = Width - 2* annotationwidth - 2 * rowspacing;
    int pageglyphwidth = GlyphsWide;
    int pageglyphheight = GlyphsHigh;
    int pageswide = Image1->Width/pageglyphwidth + 1;
    int pageshigh = Image1->Height/pageglyphheight + 1;
    int PictureHeight = Image1->Height;
    int PictureWidth = Image1->Width;
    //array to show colours used
    DynamicArray <bool> colourused;
    colourused.Length = PictureColourPallette.Length;
    for (int i = 0; i < colourused.Length; i++) {
        colourused[i] = false;
        }
    for (int i = 0; i < BackStitches.Length; i++) {
        colourused[BackStitches[i].ColourNumber] = true;
        }


    //for (int pagerow = 0; pagerow < pageshigh; pagerow++) {
    int pagerow = Row;
        //for (int pagecolumn = 0; pagecolumn < pageswide; pagecolumn++) {
        int pagecolumn = Column;
        //if (PageNumber->ItemIndex == 0 || ((pagerow ) *pageswide + pagecolumn + 1) == PageNumber->ItemIndex) {
            if (SimpleKey->Checked) {
                //Plot the simple key
                int indexcount = 0;
                if (!Background->Checked && !colourused[0]) indexcount = 1;
                int PenWidth = Canvas->Pen->Width;
                Canvas->Pen->Width = GlyphSize*12/40;
                for (int i = 0; i < keyentryrows; i++) {
                    for (int j = 0; j < keyentrycolumns; j++) {
                        //change for anchor
                        if (UseAnchor->Checked) {
                            while (indexcount < PictureColourPallette.Length && PictureColourPallette[indexcount].AnchorStitchCount == 0) {
                                indexcount++;
                                }
                            if (indexcount < PictureColourPallette.Length && colourused[indexcount]) {
                                Canvas->Pen->Color = PictureColourPallette[indexcount].Colour;
                                Canvas->MoveTo(rowspacing + j*keyentrywidth,rowspacing + i * keyentryheight + GlyphSize * 3/4);
                                Canvas->LineTo(rowspacing + j*keyentrywidth + GlyphSize * 3/2,rowspacing + i * keyentryheight + GlyphSize * 3/4);
                                Canvas->TextOut(rowspacing * 2 + j*keyentrywidth + GlyphSize * 1.5,rowspacing + i * keyentryheight,AnsiString(PictureColourPallette[indexcount].AnchorGlyphToUse));
                                }
                            indexcount++;
                            } else {
                            if (indexcount < PictureColourPallette.Length && colourused[indexcount]) {
                                Canvas->Pen->Color = PictureColourPallette[indexcount].Colour;
                                Canvas->MoveTo(rowspacing + j*keyentrywidth,rowspacing + i * keyentryheight + GlyphSize * 3/4);
                                Canvas->LineTo(rowspacing + j*keyentrywidth + GlyphSize * 3/2,rowspacing + i * keyentryheight + GlyphSize * 3/4);
                                Canvas->TextOut(rowspacing * 2 + j*keyentrywidth + GlyphSize * 1.5,rowspacing + i * keyentryheight,AnsiString(indexcount));
                                }
                            indexcount++;
                            }
                        //end of changed section for Anchor
                        }
                    }
                Canvas->Pen->Width = PenWidth;
                }//end of simple key

            //now to print out the chart
            int topleftX = pageglyphwidth * pagecolumn;
            int topleftY = pageglyphheight * pagerow;
            int rightedge = 0;
            int bottomedge = 0;
            int stitchcount = 0;
            int maxX = 0;
            int maxY = 0;
            for (int i = 0; i < pageglyphwidth; i++) {
                for (int j = 0; j < pageglyphheight; j++) {
                    int pixelX = topleftX + i;
                    int pixelY = topleftY + j;
                    if (pixelX < PictureWidth && pixelY < PictureHeight) {
                        //now can plot the glyph
                        bool found = false;
                        int counter = 0;
                        while (!found && counter < PictureColourPallette.Length) {
                            if (Image1->Canvas->Pixels[pixelX][pixelY] == PictureColourPallette[counter].Colour) {
                                found = true;
                                counter--;
                                }
                            counter++;
                            }
                        if (counter != 0 || (counter == 0 && Background->Checked)) {
                            //changed for anchor
                            if (UseAnchor->Checked) {
                                DrawAnchorGlyph(Canvas,rowspacing + i*GlyphSize,keyheight + keyentryheight + j*GlyphSize,GlyphSize, PictureColourPallette[counter].AnchorGlyphToUse, true, PictureColourPallette[PictureColourPallette[counter].AnchorColourToUse].Colour, PictureColourPallette[counter].DrawWhite);
                                } else {
                                DrawGlyph(Canvas,rowspacing + i*GlyphSize,keyheight + keyentryheight + j*GlyphSize,GlyphSize, counter, true);
                                }
                            //end of section changed for anchor
                            //stitchcount++;
                            } else {
                            DrawEmptyGlyph(Canvas,rowspacing + i*GlyphSize,keyheight + keyentryheight + j*GlyphSize,GlyphSize);
                            }
                        if (rightedge < (rowspacing + i*GlyphSize)) rightedge = rowspacing + i*GlyphSize;
                        if (bottomedge < (keyheight + keyentryheight + j*GlyphSize)) bottomedge = keyheight + keyentryheight + j*GlyphSize;
                        if (maxX < pixelX) maxX = pixelX;
                        if (maxY < pixelY) maxY = pixelY;
                        }
                    }
                }

            //draw the back stitches
            //run through all stitches & see if they should be on this sheet
            for (int i = 0; i < BackStitches.Length; i++) {
                if ( BackStitches[i].X1 >= (float)topleftX
                    && BackStitches[i].X1 <= (float)maxX + 1.0
                    && BackStitches[i].Y1 >= (float)topleftY
                    && BackStitches[i].Y1 <= (float)maxY + 1.0) {
                    // end 1 is on the page, now check if end 2 is
                    if ( BackStitches[i].X2 >= (float)topleftX
                        && BackStitches[i].X2 <= (float)maxX + 1.0
                        && BackStitches[i].Y2 >= (float)topleftY
                        && BackStitches[i].Y2 <= (float)maxY + 1.0) {
                        // ends 1 & 2 are both on the page, now draw the stitch
                        stitchcount++;
                        Canvas->Pen->Color = PictureColourPallette[BackStitches[i].ColourNumber].Colour;
                        Canvas->Pen->Width = GlyphSize*4/20;
                        Canvas->MoveTo(rowspacing + (BackStitches[i].X1 - topleftX)*GlyphSize, keyheight + keyentryheight + (BackStitches[i].Y1 - topleftY)*GlyphSize);
                        Canvas->LineTo(rowspacing + (BackStitches[i].X2 - topleftX)*GlyphSize, keyheight + keyentryheight + (BackStitches[i].Y2 - topleftY)*GlyphSize);
                        } else {
                        //end point not in range, crosses edge & need to draw a line that stops at the edge of the plotted area
                        //Need to go through the four lines around the perimiter and find the intersection points, and also when the proportions along the line are both between 0 and 1
                        if (!FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,topleftX,topleftY,maxX + 1.0, topleftY)) {
                            if (!FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,maxX + 1.0,topleftY,maxX + 1.0, maxY + 1.0)){
                                if (!FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,topleftX,maxY + 1.0,maxX + 1.0, maxY + 1.0)) {
                                    if (!FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,topleftX,topleftY,topleftX,maxY + 1.0)) {
                                        //Oh blast, it has got through without being able to find an intersection.
                                        //Check X2 against right edge.
                                        if (BackStitches[i].X2 > maxX + 1.0) {
                                            XIntersect = maxX + 1.0;
                                            YIntersect = BackStitches[i].Y1 + (BackStitches[i].Y2 - BackStitches[i].Y1) * (maxX + 1.0 - BackStitches[i].X1)/(BackStitches[i].X2 - BackStitches[i].X1);
                                            } else {
                                            //Check X2 against left edge
                                            if (BackStitches[i].X2 < topleftX) {
                                                XIntersect = topleftX;
                                                YIntersect = BackStitches[i].Y1 + (BackStitches[i].Y2 - BackStitches[i].Y1) * (topleftX - BackStitches[i].X1)/(BackStitches[i].X2 - BackStitches[i].X1);
                                                } else {
                                                //Check Y2 against top edge
                                                if (BackStitches[i].Y2 < topleftY) {
                                                    XIntersect = BackStitches[i].X1 + (BackStitches[i].X2 - BackStitches[i].X1) * (topleftY - BackStitches[i].Y1)/(BackStitches[i].Y2 - BackStitches[i].Y1);
                                                    YIntersect = topleftY;
                                                    } else {
                                                    //Must cut bottom line if we've got here
                                                    if (BackStitches[i].Y2 > maxY + 1.0) {
                                                        XIntersect = BackStitches[i].X1 + (BackStitches[i].X2 - BackStitches[i].X1) * (maxY + 1.0 - BackStitches[i].Y1)/(BackStitches[i].Y2 - BackStitches[i].Y1);
                                                        YIntersect = maxY + 1.0;
                                                        } else {
                                                        Application->MessageBox(("End point not found for back stitch crossing page boundary at " + AnsiString(BackStitches[i].X1) + "," + AnsiString(BackStitches[i].Y1) + "/" + AnsiString(BackStitches[i].X2) + "," + AnsiString(BackStitches[i].Y2)).c_str(),"Error",MB_OK + MB_ICONEXCLAMATION);
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        stitchcount++;
                        Canvas->Pen->Color = PictureColourPallette[BackStitches[i].ColourNumber].Colour;
                        Canvas->Pen->Width = GlyphSize*4/20;
                        Canvas->MoveTo(rowspacing + (BackStitches[i].X1 - topleftX)*GlyphSize, keyheight + keyentryheight + (BackStitches[i].Y1 - topleftY)*GlyphSize);
                        Canvas->LineTo(rowspacing + (XIntersect - topleftX)*GlyphSize, keyheight + keyentryheight + (YIntersect - topleftY)*GlyphSize);
                        }
                    } else {
                    //check to see if, while the start isn't on the page, it ends on page
                    if ( BackStitches[i].X2 >= (float)topleftX
                        && BackStitches[i].X2 <= (float)maxX + 1.0
                        && BackStitches[i].Y2 >= (float)topleftY
                        && BackStitches[i].Y2 <= (float)maxY + 1.0) {
                        //point 1 not in range but point 2 is, crosses edge & need to draw a line that stops at the edge of the plotted area
                        //Need to go through the four lines around the perimiter and find the intersection points, and also when the proportions along the line are both between 0 and 1
                        if (!FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,topleftX,topleftY,maxX + 1.0, topleftY)) {
                            if (!FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,maxX + 1.0,topleftY,maxX + 1.0, maxY + 1.0)){
                                if (!FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,topleftX,maxY + 1.0,maxX + 1.0, maxY + 1.0)) {
                                    if (!FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,topleftX,topleftY,topleftX,maxY + 1.0)) {
                                        //Blow. No intersection found
                                        //Check X1 against right edge.
                                        if (BackStitches[i].X1 > maxX + 1.0) {
                                            XIntersect = maxX + 1.0;
                                            YIntersect = BackStitches[i].Y1 + (BackStitches[i].Y2 - BackStitches[i].Y1) * (maxX + 1.0 - BackStitches[i].X1)/(BackStitches[i].X2 - BackStitches[i].X1);
                                            } else {
                                            //Check X2 against left edge
                                            if (BackStitches[i].X1 < topleftX) {
                                                XIntersect = topleftX;
                                                YIntersect = BackStitches[i].Y1 + (BackStitches[i].Y2 - BackStitches[i].Y1) * (topleftX - BackStitches[i].X1)/(BackStitches[i].X2 - BackStitches[i].X1);
                                                } else {
                                                //Check Y2 against top edge
                                                if (BackStitches[i].Y1 < topleftY) {
                                                    XIntersect = BackStitches[i].X1 + (BackStitches[i].X2 - BackStitches[i].X1) * (topleftY - BackStitches[i].Y1)/(BackStitches[i].Y2 - BackStitches[i].Y1);
                                                    YIntersect = topleftY;
                                                    } else {
                                                    //Must cut bottom line if we've got here
                                                    if (BackStitches[i].Y1 > maxY + 1.0) {
                                                        XIntersect = BackStitches[i].X1 + (BackStitches[i].X2 - BackStitches[i].X1) * (maxY + 1.0 - BackStitches[i].Y1)/(BackStitches[i].Y2 - BackStitches[i].Y1);
                                                        YIntersect = maxY + 1.0;
                                                        } else {
                                                        Application->MessageBox(("End point not found for back stitch crossing page boundary at " + AnsiString(BackStitches[i].X1) + "," + AnsiString(BackStitches[i].Y1) + "/" + AnsiString(BackStitches[i].X2) + "," + AnsiString(BackStitches[i].Y2)).c_str(),"Error",MB_OK + MB_ICONEXCLAMATION);
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        stitchcount++;
                        Canvas->Pen->Color = PictureColourPallette[BackStitches[i].ColourNumber].Colour;
                        Canvas->Pen->Width = GlyphSize*4/20;
                        Canvas->MoveTo(rowspacing + (BackStitches[i].X2 - topleftX)*GlyphSize, keyheight + keyentryheight + (BackStitches[i].Y2 - topleftY)*GlyphSize);
                        Canvas->LineTo(rowspacing + (XIntersect - topleftX)*GlyphSize, keyheight + keyentryheight + (YIntersect - topleftY)*GlyphSize);
                        } else {
                        //stitch ends completely miss page, but may cross corners
                        if (FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,topleftX,topleftY,maxX + 1.0, topleftY)) {
                            //try top edge & 1 one other of right edge, bottom edge or left edge
                            float tempX = XIntersect;
                            float tempY = YIntersect;
                            bool found = FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,maxX + 1.0,topleftY,maxX + 1.0, maxY + 1.0);
                            if (!found) {
                                found = FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,topleftX,maxY + 1.0,maxX + 1.0, maxY + 1.0);
                                if (!found) {
                                    found = FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,topleftX,topleftY,topleftX,maxY + 1.0);
                                    }
                                }
                            if (found) {
                                stitchcount++;
                                Canvas->Pen->Color = PictureColourPallette[BackStitches[i].ColourNumber].Colour;
                                Canvas->Pen->Width = GlyphSize*4/20;
                                Canvas->MoveTo(rowspacing + (tempX - topleftX)*GlyphSize, keyheight + keyentryheight + (tempY - topleftY)*GlyphSize);
                                Canvas->LineTo(rowspacing + (XIntersect - topleftX)*GlyphSize, keyheight + keyentryheight + (YIntersect - topleftY)*GlyphSize);
                                }
                            } else {
                            //try right edge and one other of bottom edge or left edge
                            if (FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,maxX + 1.0,topleftY,maxX + 1.0, maxY + 1.0)) {
                                float tempX = XIntersect;
                                float tempY = YIntersect;
                                bool found = FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,topleftX,maxY + 1.0,maxX + 1.0, maxY + 1.0);
                                if (!found) {
                                    found = FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,topleftX,topleftY,topleftX,maxY + 1.0);
                                    }
                                if (found) {
                                    stitchcount++;
                                    Canvas->Pen->Color = PictureColourPallette[BackStitches[i].ColourNumber].Colour;
                                    Canvas->Pen->Width = GlyphSize*4/20;
                                    Canvas->MoveTo(rowspacing + (tempX - topleftX)*GlyphSize, keyheight + keyentryheight + (tempY - topleftY)*GlyphSize);
                                    Canvas->LineTo(rowspacing + (XIntersect - topleftX)*GlyphSize, keyheight + keyentryheight + (YIntersect - topleftY)*GlyphSize);
                                    }
                                } else {
                                //try bottom edge & left edge
                                if (FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,topleftX,maxY + 1.0,maxX + 1.0, maxY + 1.0)) {
                                    float tempX = XIntersect;
                                    float tempY = YIntersect;
                                    if (FindIntersection(BackStitches[i].X1,BackStitches[i].Y1,BackStitches[i].X2,BackStitches[i].Y2,topleftX,topleftY,topleftX,maxY + 1.0)) {
                                        stitchcount++;
                                        Canvas->Pen->Color = PictureColourPallette[BackStitches[i].ColourNumber].Colour;
                                        Canvas->Pen->Width = GlyphSize*4/20;
                                        Canvas->MoveTo(rowspacing + (tempX - topleftX)*GlyphSize, keyheight + keyentryheight + (tempY - topleftY)*GlyphSize);
                                        Canvas->LineTo(rowspacing + (XIntersect - topleftX)*GlyphSize, keyheight + keyentryheight + (YIntersect - topleftY)*GlyphSize);
                                        }
                                    }
                                }
                            }
                        }
                    }
                }


            //draw on peripheral black lines
            Canvas->Pen->Color = clBlack;
            Canvas->Pen->Mode = pmCopy;
            Canvas->Pen->Style = psSolid;
            Canvas->Pen->Width = GlyphSize/20;
            rightedge += GlyphSize;
            bottomedge += GlyphSize;
            Canvas->MoveTo(rightedge,keyheight + keyentryheight);
            Canvas->LineTo(rightedge,bottomedge);
            Canvas->LineTo(rowspacing,bottomedge);
            Canvas->LineTo(rowspacing,keyheight + keyentryheight);
            Canvas->LineTo(rightedge,keyheight + keyentryheight);

            //centrelines were here

            //draw 10's lines
            Canvas->Pen->Color = clBlack;
            Canvas->Pen->Mode = pmCopy;
            Canvas->Pen->Style = psSolid;
            Canvas->Pen->Width = GlyphSize/20;
            //Vertical lines & annotations
            for (int i = 0; i < pageglyphwidth + 1; i++) {
                int j = topleftX + i;
                if (j == (int) (ROUND((double)j/10.0) * 10.0) && j < PictureWidth + 1) {
                    //it's a line to be written
                    Canvas->MoveTo(rowspacing + i * GlyphSize,keyheight + keyentryheight);
                    Canvas->LineTo(rowspacing + i * GlyphSize,bottomedge);
                    Canvas->TextOut(rowspacing + i * GlyphSize,keyheight ,AnsiString(j));
                    }
                }
            //Horizontal lines & annotations
            for (int i = 0; i < pageglyphheight + 1; i++) {
                int j = pageglyphheight * pagerow + i;
                if (j == (int) (ROUND((double)j/10.0) * 10.0) && j < Image1->Height + 1) {
                    //it's a line to be written
                    Canvas->MoveTo(rowspacing,keyheight + keyentryheight + i*GlyphSize);
                    Canvas->LineTo(rightedge,keyheight + keyentryheight + i*GlyphSize);
                    Canvas->TextOut(rowspacing + rightedge,keyheight + keyentryheight/2 + i*GlyphSize,AnsiString(j));
                    }
                }
            //print right extreme character no & bottom extreme char no
            TBrushStyle t1 = Canvas->Brush->Style;
            Canvas->Brush->Style = bsClear;
            Canvas->TextOut(rightedge, keyheight, AnsiString(maxX + 1));
            Canvas->Brush->Style = t1;
            Canvas->TextOut(rowspacing + rightedge, 3 + bottomedge - Canvas->TextHeight("123"), AnsiString(maxY + 1));

            //draw centrelines
            //Vertical centreline
            bool clxfound = false;
            int xoffset,yoffset;
            bool clyfound = false;
            int centrelinex = Image1->Width/2;
            if (topleftX < centrelinex && (topleftX + pageglyphwidth) > centrelinex) {
                //it's on this page
                xoffset = (centrelinex - topleftX)*GlyphSize + rowspacing;
                clxfound = true;
                Canvas->Pen->Color = clPurple;
                Canvas->Pen->Mode = pmCopy;
                Canvas->Pen->Style = psDashDotDot;
                Canvas->Pen->Width = GlyphSize/10;
                Canvas->MoveTo(xoffset,keyheight + keyentryheight);
                Canvas->LineTo(xoffset,bottomedge);
                //draw CL mark
                TBrushStyle t1 = Canvas->Brush->Style;
                int cwidth = Canvas->TextWidth("C")/3;
                int cheight = Canvas->TextHeight("C")/3;
                Canvas->Brush->Style = bsClear;
                Canvas->TextOut(xoffset - cwidth,keyheight ,"C");
                Canvas->TextOut(xoffset,keyheight  + cheight,"L");
                Canvas->Brush->Style = t1;
                }
            //Horizontal centreline
            int centreliney = Image1->Height/2;
            if (topleftY < centreliney && (topleftY + pageglyphheight) > centreliney) {
                //it's on this page
                yoffset = (centreliney - topleftY)*GlyphSize + keyheight + keyentryheight;
                clyfound = true;
                Canvas->Pen->Color = clPurple;
                Canvas->Pen->Mode = pmCopy;
                Canvas->Pen->Style = psDashDotDot;
                Canvas->Pen->Width = GlyphSize/10;
                Canvas->MoveTo(rowspacing,yoffset);
                Canvas->LineTo(rightedge,yoffset);
                //draw CL mark
                TBrushStyle t1 = Canvas->Brush->Style;
                int cwidth = Canvas->TextWidth("C")/3;
                int cheight = Canvas->TextHeight("C")/3;
                Canvas->Brush->Style = bsClear;
                Canvas->TextOut(rowspacing + rightedge - cwidth,yoffset - cheight ,"C");
                Canvas->TextOut(rowspacing + rightedge,yoffset ,"L");
                Canvas->Brush->Style = t1;
                }

            //Highlight centrepoint
            if (clxfound && clyfound) {
                //draw red cross at centre point
                Canvas->Pen->Color = clRed;
                Canvas->Pen->Mode = pmCopy;
                Canvas->Pen->Style = psSolid;
                Canvas->Pen->Width = GlyphSize/5;
                Canvas->MoveTo(xoffset,yoffset - GlyphSize/2);
                Canvas->LineTo(xoffset,yoffset + GlyphSize/2);
                Canvas->MoveTo(xoffset - GlyphSize/2, yoffset);
                Canvas->LineTo(xoffset + GlyphSize/2, yoffset);
                Canvas->MoveTo(xoffset - GlyphSize/2, yoffset - GlyphSize/2);
                Canvas->LineTo(xoffset + GlyphSize/2, yoffset + GlyphSize/2);
                Canvas->MoveTo(xoffset - GlyphSize/2, yoffset + GlyphSize/2);
                Canvas->LineTo(xoffset + GlyphSize/2, yoffset - GlyphSize/2);
                }
            Canvas->Pen->Width = GlyphSize/20;

            //footer so that the user never looses track of the page position or the number of stitches to be done
            Canvas->TextOut(rowspacing,Height - keyentryheight,
                    "This is Page " + AnsiString(pagerow*pageswide + pagecolumn + 1)
                    + " of " + AnsiString(pageshigh * pageswide)
                    + ";    Row " + AnsiString(pagerow + 1) + " of " + AnsiString(pageshigh)
                    + ";    Column "  + AnsiString(pagecolumn + 1) + " of " + AnsiString(pageswide)
                    );
            Canvas->TextOut(Width - Canvas->TextWidth(AnsiString(stitchcount) + " of " + Label5->Caption + " Stitches on this Page.   "),Height - keyentryheight,
                    AnsiString(stitchcount) + " of " + Label5->Caption + " Stitches on this Page."
                    );


            //print this page, as it's complete.
            //if (!(pagerow == pageshigh-1 && pagecolumn == pageswide-1) && PageNumber->ItemIndex == 0) Printer()->NewPage();
            //}
            //}    //end of  for (int pagecolumn = 0; pagecolumn < pageswide; pagecolumn++)
        //} //end of  for (int pagerow = 0; pagerow < pageshigh; pagerow++)
    printingbackstitches = false;
    colourused.Length = 0;

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::DrawKeySheet(TCanvas *Canvas, int Width, int Height, int PageNumber, int RowSpacing)
{
    //Printer()->Canvas->Font->Name = "Arial";
    //Printer()->Canvas->Font->Size = 10;
    Canvas->Font->Name = LocalChartPrintout.ChartFont;
    Canvas->Font->Size = LocalChartPrintout.ChartFontSize + 2;
    Canvas->Font->Color = clBlack;
    printingbackstitches = false;
    //this is 13.34mm wide
    //Canvas->TextOut(0,0,"Hi There");

        //This is a detailed key
        //The printout columns will be of the form
        //Key Number, Key Shape, DMC Number/Anchor Number, DMC Name, Number of stitches, Approx Number of skeins
        int ColumnSpacing = Canvas->TextWidth("88");
        //int RowSpacing = 10;
        int KeyNumberWidth = Canvas->TextWidth("888");
        int KeyNumberLeft = ColumnSpacing;
        int SymbolLeft = KeyNumberWidth + 2 * ColumnSpacing;
        int SymbolWidth = Canvas->TextWidth("Symbol");
        if (2 * GlyphSize > SymbolWidth) SymbolWidth = 2 * GlyphSize;
        int DMCNumberWidth = 0;
        int DMCNameWidth = 0;
        int temp;
        for (int i = 0; i < PictureColourPallette.Length; i++) {
            if (UseAnchor->Checked) {
                temp = Canvas->TextWidth(PictureColourPallette[i].AnchorColourNumber);
                if (DMCNumberWidth < temp) DMCNumberWidth = temp;
                } else {
                temp = Canvas->TextWidth(PictureColourPallette[i].DMCColourNumber);
                if (DMCNumberWidth < temp) DMCNumberWidth = temp;
                }
            temp  = Canvas->TextWidth(PictureColourPallette[i].DMCColourName);
            if (DMCNameWidth < temp) DMCNameWidth = temp;
            }
        if (UseAnchor->Checked) {
            temp = Canvas->TextWidth("Anchor#");
            if (DMCNumberWidth < temp) DMCNumberWidth = temp;
            temp  = Canvas->TextWidth("Colour Name");
            if (DMCNameWidth < temp) DMCNameWidth = temp;
            } else {
            if (blendthreads) {
                //temp = Canvas->TextWidth("DMC Name/Blend Options");
                temp = Canvas->TextWidth(ShortThreadName + " Name/Blend Options");
                } else {
                //temp = Canvas->TextWidth("DMC Name");
                temp = Canvas->TextWidth(ShortThreadName + " Name");
                }
            if (DMCNameWidth < temp) DMCNameWidth = temp;
            //temp = Canvas->TextWidth("DMC#");
            temp = Canvas->TextWidth(ShortThreadName + "#");
            if (DMCNumberWidth < temp) DMCNumberWidth = temp;
            }
        int DMCNumberLeft = SymbolLeft + SymbolWidth + ColumnSpacing;
        int DMCNameLeft = DMCNumberLeft + DMCNumberWidth + ColumnSpacing;
        int StitchWidth = Canvas->TextWidth("Number of Stitches");
        int StitchLeft = DMCNameLeft + DMCNameWidth + ColumnSpacing;
        //int SkeinWidth = Printer()->Canvas->TextWidth("Approx Number of skeins");
        int SkeinLeft =  StitchLeft + StitchWidth + ColumnSpacing;
        if (SkeinLeft > Width) {
            SkeinLeft = Width -Canvas->TextWidth("Approx Number of skeins");
            StitchLeft = SkeinLeft - ColumnSpacing - StitchWidth;
            }
        int RowHeight = Canvas->TextHeight("Tq");
        if (RowHeight < (2 * GlyphSize)) RowHeight = 2 * GlyphSize;
        //Right, now the only thing to do is to see how many pages there will be.
        int rowsperpage = Height/(RowHeight + RowSpacing) - 1;
        int pages;
        int numberofrows;
        if (UseAnchor->Checked) {
            numberofrows = 0;
            for (int i = 0; i < PictureColourPallette.Length; i++) {
                if (PictureColourPallette[i].AnchorStitchCount != 0) numberofrows++;
                }
            pages = numberofrows/rowsperpage;
            if ((numberofrows % rowsperpage) != 0) pages++;
            } else {
            numberofrows = PictureColourPallette.Length;
            pages = PictureColourPallette.Length/rowsperpage;
            if ((PictureColourPallette.Length % rowsperpage) != 0) pages++;
            }
        int countfactor = 4;
        int tpi = StitchCount->Items->Strings[StitchCount->ItemIndex].ToIntDef(9);
        switch (tpi) {
            case 21:
            case 22:
            case 23:
            case 24:
            case 25:
            case 26:
            case 27:
            case 28:
            case 29:
            case 30:
            case 31:
            case 32:
            case 33:
            case 34:
            case 35:
            case 36:
            case 37:
            case 38:
            case 39:
            case 40:    {
                        countfactor = 1;
                        }
                        break;
            case 14:
            case 15:
            case 16:
            case 17:
            case 18:
            case 19:
            case 20:    {
                        countfactor = 2;
                        }
                        break;
            case 11:
            case 12:
            case 13:    {
                        countfactor = 3;
                        }
                        break;
            default:    {
                        countfactor = 4;
                        }
                        break;
            case 8:
            case 7:     {
                        countfactor = 5;
                        }
                        break;
            case 6:     {
                        countfactor = 6;
                        }
                        break;
            }
        float safetyfactor;
        switch (ConfettiLevel) {
            case TUnstitchable:     {
                                    safetyfactor = 5.0;
                                    }
                                    break;
            case THighConfetti:     {
                                    safetyfactor = 3.0;
                                    }
                                    break;
            case TMediumConfetti:   {
                                    safetyfactor = 2.0;
                                    }
                                    break;
            default:                {
                                    safetyfactor = 1.5;
                                    }
                                    break;
            }
        int divisionfactor = (int) (4.8 * 25.4 * 1.175 * safetyfactor);
        //int stitchesperskein = (8000 * 6 * tpi)/ (215 * countfactor);
        int stitchesperskein = (8000 * 6 * tpi)/ (divisionfactor * countfactor);
        //The 215 figure seems pretty random, but is made up as follows:
        //215 = length of thread per cross stitch as a multiple of the count (4.8: - 2 diagonals on the front @ 1.4 + 2 straight stitches on the back)
        //       * 25.4mm per inch * 1.175 (15% wasted per thread) * 1.5 (safety factor for tie off & moving between rows)
        //also works for tent stitches where the thread is usually doubled up compared to x stitch
        //The 8000 figure is the length of thread in each DMC skein in mm
        //The 6 figure is the number of individual threads in each DMC skein
        //The countfactor is the number of threads in each stitch depending on the stitch count,
        //and defaults to the value for 9 count in the event of error

        //also works for tent stitches where the thread is usually doubled up compared to x stitch

        //now to print
        int rowcount = 0;
        int colourcount = 0;
        if (!Background->Checked) {
            rowcount = 1;
            colourcount = 1;
            }
        //for (int page = 0; page < pages; page++) {
        int page = PageNumber;
        if (page < pages) {
            //get to the right counter point for colourcount & rowcount
            bool stop;
            if (UseAnchor->Checked) {
                int limit = rowcount + rowsperpage * PageNumber;
                while (rowcount < limit) {
                    stop = false;
                    while (colourcount < PictureColourPallette.Length && !stop) {
                        if (colourcount == PictureColourPallette[colourcount].AnchorColourToUse) {
                            stop = true;
                            } else {
                            colourcount++;
                            }
                        }
                    rowcount++;
                    }
                } else {
                colourcount += rowsperpage * PageNumber;
                rowcount += rowsperpage * PageNumber;
                }
            //Header Row
            Canvas->TextOut(KeyNumberLeft,RowSpacing,"Ref#");
            Canvas->TextOut(SymbolLeft,RowSpacing,"Shape");
            if (UseAnchor->Checked) {
                Canvas->TextOut(DMCNumberLeft,RowSpacing,"Anchor#");
                Canvas->TextOut(DMCNameLeft,RowSpacing,"Colour Name");
                } else {
                if (blendthreads) {
                    //Canvas->TextOut(DMCNumberLeft,RowSpacing,"DMC#");
                    //Canvas->TextOut(DMCNameLeft,RowSpacing,"DMC Name/Blend Options");
                    Canvas->TextOut(DMCNumberLeft,RowSpacing,ShortThreadName + "#");
                    Canvas->TextOut(DMCNameLeft,RowSpacing,ShortThreadName + " Name/Blend Options");
                    } else {
                    //Canvas->TextOut(DMCNumberLeft,RowSpacing,"DMC#");
                    //Canvas->TextOut(DMCNameLeft,RowSpacing,"DMC Name");
                    Canvas->TextOut(DMCNumberLeft,RowSpacing,ShortThreadName + "#");
                    Canvas->TextOut(DMCNameLeft,RowSpacing,ShortThreadName + " Name");
                    }
                }
            Canvas->TextOut(StitchLeft,RowSpacing,"Number of Stitches");
            if (!blendthreads) Canvas->TextOut(SkeinLeft,RowSpacing,"Approx Number of skeins");
            for (int i = 1; i < rowsperpage + 1; i++) {
                //find the colour to print for this line
                stop = false;
                while (colourcount < PictureColourPallette.Length && !stop) {
                    if (UseAnchor->Checked) {
                        if (colourcount == PictureColourPallette[colourcount].AnchorColourToUse) {
                            stop = true;
                            } else {
                            colourcount++;
                            }
                        } else {
                        stop = true;
                        }
                    }
                //if (rowcount < PictureColourPallette.Length) {
                if (colourcount < PictureColourPallette.Length) {
                    if ((rowcount == 0 && Background->Checked) || rowcount > 0) {
                        int rowposition = i * (RowSpacing + RowHeight) + RowSpacing;
                        //Printer()->Canvas->TextOut(KeyNumberLeft,rowposition,AnsiString(rowcount));
                        //DrawGlyph(Printer()->Canvas,SymbolLeft,rowposition,RowHeight, rowcount, false);
                        int skeins;
                        if (UseAnchor->Checked) {
                            Canvas->TextOut(KeyNumberLeft,rowposition,AnsiString(PictureColourPallette[colourcount].AnchorGlyphToUse));
                            DrawAnchorGlyph(Canvas,SymbolLeft,rowposition,RowHeight,PictureColourPallette[colourcount].AnchorGlyphToUse, false, PictureColourPallette[colourcount].Colour, PictureColourPallette[colourcount].DrawWhite);
                            Canvas->TextOut(DMCNumberLeft,rowposition,PictureColourPallette[colourcount].AnchorColourNumber);
                            Canvas->TextOut(DMCNameLeft,rowposition,PictureColourPallette[colourcount].DMCColourName);
                            Canvas->TextOut(StitchLeft,rowposition,AnsiString(PictureColourPallette[colourcount].AnchorStitchCount));
                            skeins = PictureColourPallette[colourcount].AnchorStitchCount/stitchesperskein + 1;
                            } else {
                            Canvas->TextOut(KeyNumberLeft,rowposition,AnsiString(rowcount));
                            DrawGlyph(Canvas,SymbolLeft,rowposition,RowHeight, rowcount, false);
                            Canvas->TextOut(DMCNumberLeft,rowposition,PictureColourPallette[rowcount].DMCColourNumber);
                            //Canvas->TextOut(DMCNameLeft,rowposition,PictureColourPallette[rowcount].DMCColourName);
                            AnsiString text = PictureColourPallette[rowcount].DMCColourName;
                            bool cropped = false;
                            while ((DMCNameLeft + Canvas->TextWidth(text + "...") + ColumnSpacing) > StitchLeft) {
                                cropped = true;
                                text = ChopOffLastChars(text,1);
                                }
                            if (cropped) text += "...";
                            Canvas->TextOut(DMCNameLeft,rowposition,text);
                            Canvas->TextOut(StitchLeft,rowposition,AnsiString(PictureColourPallette[rowcount].StitchCount));
                            skeins = PictureColourPallette[rowcount].StitchCount/stitchesperskein + 1;
                            }
                        double roundedskeins = ROUND((((double)PictureColourPallette[rowcount].StitchCount/(double)stitchesperskein) + 0.05)*10.0)/10.0;
                        AnsiString output = AnsiString(skeins) + "  (" + AnsiString(roundedskeins) + ")";
                        if (!blendthreads) Canvas->TextOut(SkeinLeft,rowposition,output);
                        }
                    }
                rowcount++;
                colourcount++;
                }
            } else {
            if (blendthreads) {
                //this bit prints the actual DMC threads used in blends
                page = page - pages;
                DynamicArray <usedcolour> UsedColourList;
                UsedColourList.Length = DMCColourList.Length;
                for (int i = 0; i < UsedColourList.Length; i++) {
                    UsedColourList[i].used = false;
                    UsedColourList[i].refno = -1;
                    UsedColourList[i].stitches = 0;
                    UsedColourList[i].DMCArrayRef = i;
                    }
                for (int i = 0; i < BlendReference.Length; i++) {
                    switch (BlendReference[i].type) {
                        case TBlendedColour:    {
                                                if (BlendReference[i].arrayref < TweedList.Length) {
                                                    if (TweedList[BlendReference[i].arrayref].ColourPairs[0].x < UsedColourList.Length) {
                                                        UsedColourList[TweedList[BlendReference[i].arrayref].ColourPairs[0].x].used = true;
                                                        UsedColourList[TweedList[BlendReference[i].arrayref].ColourPairs[0].x].stitches += PictureColourPallette[i].StitchCount / 2 + 1;
                                                        }
                                                    if (TweedList[BlendReference[i].arrayref].ColourPairs[0].y < UsedColourList.Length) {
                                                        UsedColourList[TweedList[BlendReference[i].arrayref].ColourPairs[0].y].used = true;
                                                        UsedColourList[TweedList[BlendReference[i].arrayref].ColourPairs[0].y].stitches += PictureColourPallette[i].StitchCount / 2 + 1;
                                                        }
                                                    }
                                                }
                                                break;
                        case TDMCColour:        {
                                                if (BlendReference[i].arrayref < UsedColourList.Length) {
                                                    UsedColourList[BlendReference[i].arrayref].used = true;
                                                    UsedColourList[BlendReference[i].arrayref].refno = i;
                                                    UsedColourList[BlendReference[i].arrayref].stitches += PictureColourPallette[i].StitchCount;
                                                    }
                                                }
                                                break;
                        default:                break;
                        }
                    }
                //sort the list by DMC Number
                usedcolour SwapColour;
                bool swapped = true;
                while (swapped) {
                    swapped = false;
                    for (int i = 0; i < UsedColourList.Length - 1; i++) {
                        //if (DMCColourList[UsedColourList[i].DMCArrayRef].DMCColourNumber.ToIntDef(1) > DMCColourList[UsedColourList[i + 1].DMCArrayRef].DMCColourNumber.ToIntDef(1)) {
                        if (DMCColourList[UsedColourList[i].DMCArrayRef].DMCColourNumber.ToIntDef(1) > DMCColourList[UsedColourList[i + 1].DMCArrayRef].DMCColourNumber.ToIntDef(1)
                            ||
                            (
                            DMCColourList[UsedColourList[i].DMCArrayRef].DMCColourNumber.ToIntDef(-1) == DMCColourList[UsedColourList[i + 1].DMCArrayRef].DMCColourNumber.ToIntDef(-1)
                            && DMCColourList[UsedColourList[i].DMCArrayRef].DMCColourNumber > DMCColourList[UsedColourList[i + 1].DMCArrayRef].DMCColourNumber
                            )
                            ) {
                            swapped = true;
                            SwapColour = UsedColourList[i];
                            UsedColourList[i] = UsedColourList[i+1];
                            UsedColourList[i+1] = SwapColour;
                            }
                        }
                    }
                //re-calculate text width
                int RowText = KeyNumberLeft;
                KeyNumberLeft += Canvas->TextWidth("888  ");
                SymbolLeft += Canvas->TextWidth("888  ");
                DMCNumberLeft += Canvas->TextWidth("888  ");
                DMCNameLeft += Canvas->TextWidth("888  ");
                DMCNameWidth = 0;
                for (int i = 0; i < UsedColourList.Length; i++) {
                    if (Canvas->TextWidth(DMCColourList[UsedColourList[i].DMCArrayRef].DMCColourName) > DMCNameWidth) DMCNameWidth = Canvas->TextWidth(DMCColourList[UsedColourList[i].DMCArrayRef].DMCColourName);
                    }
                StitchLeft = DMCNameLeft + DMCNameWidth + ColumnSpacing;
                SkeinLeft =  StitchLeft + StitchWidth + ColumnSpacing;
                //now to spin through & print out the right page. First the header
                Canvas->TextOut(RowText,RowSpacing,"#");
                Canvas->TextOut(KeyNumberLeft,RowSpacing,"Ref#");
                Canvas->TextOut(SymbolLeft,RowSpacing,"Shape");
                //Canvas->TextOut(DMCNumberLeft,RowSpacing,"DMC#");
                //Canvas->TextOut(DMCNameLeft,RowSpacing,"DMC Name");
                Canvas->TextOut(DMCNumberLeft,RowSpacing,ShortThreadName + "#");
                Canvas->TextOut(DMCNameLeft,RowSpacing,ShortThreadName + " Name");
                Canvas->TextOut(StitchLeft,RowSpacing,"Number of Stitches");
                Canvas->TextOut(SkeinLeft,RowSpacing,"Approx Number of skeins");
                colourcount = 0;
                rowcount = 0;
                int limit = rowcount + rowsperpage * page;
                bool stop;
                while (rowcount < limit) {
                    stop = false;
                    while (colourcount < UsedColourList.Length && !stop) {
                        if (UsedColourList[colourcount].used) {
                            stop = true;
                            //} else {
                            //colourcount++;
                            }
                        colourcount++;
                        }
                    rowcount++;
                    }
                //now ready to draw this part of the blend data
                for (int i = 1; i < rowsperpage + 1; i++) {
                    //find the colour to print for this line
                    stop = false;
                    while (colourcount < UsedColourList.Length && !stop) {
                        if (UsedColourList[colourcount].used && (UsedColourList[colourcount].refno != 0 || (UsedColourList[colourcount].refno == 0 && Background->Checked))) {
                            stop = true;
                            } else {
                            colourcount++;
                            }
                        }
                    if (colourcount < UsedColourList.Length && UsedColourList[colourcount].used) {
                       // if (UsedColourList[colourcount].refno != 0 || (UsedColourList[colourcount].refno == 0 && Background->Checked)) {

                            int rowposition = i * (RowSpacing + RowHeight) + RowSpacing;
                            int skeins;
                            Canvas->TextOut(RowText,rowposition,AnsiString(rowcount + 1));
                            if (UsedColourList[colourcount].refno > -1) {
                                Canvas->TextOut(KeyNumberLeft,rowposition,AnsiString(UsedColourList[colourcount].refno));
                                DrawGlyph(Canvas,SymbolLeft,rowposition,RowHeight, UsedColourList[colourcount].refno, false);
                                }
                            //Canvas->TextOut(DMCNumberLeft,rowposition,DMCColourList[colourcount].DMCColourNumber);
                            //Canvas->TextOut(DMCNameLeft,rowposition,DMCColourList[colourcount].DMCColourName);
                            Canvas->TextOut(DMCNumberLeft,rowposition,DMCColourList[UsedColourList[colourcount].DMCArrayRef].DMCColourNumber);
                            Canvas->TextOut(DMCNameLeft,rowposition,DMCColourList[UsedColourList[colourcount].DMCArrayRef].DMCColourName);
                            Canvas->TextOut(StitchLeft,rowposition,AnsiString(UsedColourList[colourcount].stitches));
                            skeins = UsedColourList[colourcount].stitches/stitchesperskein + 1;
                            double roundedskeins = ROUND((((double)UsedColourList[colourcount].stitches/(double)stitchesperskein) + 0.05)*10.0)/10.0;
                            AnsiString output = AnsiString(skeins) + "  (" + AnsiString(roundedskeins) + ")";
                            Canvas->TextOut(SkeinLeft,rowposition,output);
                            //} else {
                            //rowcount--;
                            //}
                        }
                    rowcount++;
                    colourcount++;
                    }
                UsedColourList.Length = 0;
                }
            }

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::DrawSPPSheet(TCanvas *Canvas, int Width, int Height, int PageNumber, pageinfo PageInfo, int RowSpacing)
{
    pageinfo info = PageInfo;

    //count all colours and put them in their page locations
    int numberofpages = info.rows * info.columns;
    DynamicArray < DynamicArray <int> > StitchData;

    try {
        //initialise array
        StitchData.Length = PictureColourPallette.Length;
        for (int i = 0; i < StitchData.Length; i++) {
            StitchData[i].Length = numberofpages;
            for (int j = 0; j < StitchData[i].Length; j++) {
                StitchData[i][j] = 0;
                }
            }

        //fill array
        int pagenumber = -1;
        for (int i = 0; i < info.rows; i++) {
            for (int j = 0; j < info.columns; j++) {
                pagenumber++;
                bool found = false;
                int topleftX = j * info.numglyphswide;
                int toprightX = (j + 1) * info.numglyphswide;
                if (toprightX > Image1->Picture->Width) toprightX = Image1->Picture->Width;
                int topleftY = i * info.numglyphshigh;
                int bottomleftY = (i + 1) * info.numglyphshigh;
                if (bottomleftY > Image1->Picture->Height) bottomleftY = Image1->Picture->Height;
                int k;
                for (int l = topleftY; l < bottomleftY; l++) {
                    for (int m = topleftX; m < toprightX; m++) {
                        found = false;
                        k = 0;
                        while (!found && k < PictureColourPallette.Length) {
                            //first check if it's in the list of already found colours
                            if (Image1->Canvas->Pixels[m][l] == PictureColourPallette[k].Colour){
                                StitchData[k][pagenumber] = StitchData[k][pagenumber] + 1;
                                found = true;
                                }
                            k++;
                            }
                        }
                    }
                }
            }

        //That's the array filled. Now to print the data out.
        //Printer()->Canvas->Font->Name = "Arial";
        //Printer()->Canvas->Font->Size = 10;
        Canvas->Font->Name = LocalChartPrintout.ChartFont;
        Canvas->Font->Size = LocalChartPrintout.ChartFontSize + 2;
        Canvas->Font->Color = clBlack;

        //"Hi There" has width 13.34mm at 10 Point Arial
        //the printout will be of the form
        //Key Number, Key Shape, DMC/Anchor Number, DMC Name, Stitches on Page1, Page2.... PageN
        //it will form columns of pages if necessary to get all the page stitch data out
        int temp;
        int ColumnSpacing = Canvas->TextWidth("88");
        //int RowSpacing = 10;
        int KeyNumberWidth = Canvas->TextWidth("888");
        int KeyNumberLeft = ColumnSpacing;
        int SymbolLeft = KeyNumberWidth + 2 * ColumnSpacing;
        int SymbolWidth = Canvas->TextWidth("Symbol");
        if (2 * GlyphSize > SymbolWidth) SymbolWidth = 2 * GlyphSize;
        int DMCNumberWidth = 0;
        int DMCNameWidth = 0;
        for (int i = 0; i < PictureColourPallette.Length; i++) {
            if (UseAnchor->Checked) {
                temp = Canvas->TextWidth(PictureColourPallette[i].AnchorColourNumber);
                if (DMCNumberWidth < temp) DMCNumberWidth = temp;
                } else {
                temp = Canvas->TextWidth(PictureColourPallette[i].DMCColourNumber);
                if (DMCNumberWidth < temp) DMCNumberWidth = temp;
                }
            temp  = Canvas->TextWidth(PictureColourPallette[i].DMCColourName);
            if (DMCNameWidth < temp) DMCNameWidth = temp;
            }
        if (UseAnchor->Checked) {
            temp = Canvas->TextWidth("Anchor#");
            if (DMCNumberWidth < temp) DMCNumberWidth = temp;
            temp  = Canvas->TextWidth("Colour Name");
            if (DMCNameWidth < temp) DMCNameWidth = temp;
            } else {
            //temp = Canvas->TextWidth("DMC#");
            temp = Canvas->TextWidth(ShortThreadName + "#");
            if (DMCNumberWidth < temp) DMCNumberWidth = temp;
            }
        if (DMCNameWidth > (Width/2) ) DMCNameWidth = Width/2;
        int DMCNumberLeft = SymbolLeft + SymbolWidth + ColumnSpacing;
        int DMCNameLeft = DMCNumberLeft + DMCNumberWidth + ColumnSpacing;
        int StitchLeft = DMCNameLeft + DMCNameWidth + ColumnSpacing;
        int RowHeight = Canvas->TextHeight("Tq");
        if (RowHeight < (2 * GlyphSize)) RowHeight = 2 * GlyphSize;
        //Right, now the only thing to do is to see how many pages there will be.
        int rowsperpage = Height/(RowHeight + RowSpacing) - 2;
        //int pages;
        int numberofrows;
        if (UseAnchor->Checked) {
            numberofrows = 0;
            for (int i = 0; i < PictureColourPallette.Length; i++) {
                if (PictureColourPallette[i].AnchorStitchCount != 0) numberofrows++;
                }
            //pages = numberofrows/rowsperpage + 1;
            } else {
            numberofrows = PictureColourPallette.Length;
            //pages = PictureColourPallette.Length/rowsperpage + 1;
            }
        //now to see how many columns there will be on each page
        int StitchPrintWidth = 0;
        for (int i = 0; i < StitchData.Length; i++) {
            for (int j = 0; j < StitchData[i].Length; j++) {
                temp = Canvas->TextWidth(AnsiString(StitchData[i][j]));
                if (StitchPrintWidth < temp) StitchPrintWidth = temp;
                }
            }
        temp = Canvas->TextWidth("P888");
        if (StitchPrintWidth < temp) StitchPrintWidth = temp;
        int numberofcolumnsperpage = (Width - StitchLeft + ColumnSpacing)/(StitchPrintWidth + ColumnSpacing);
        //int numberofpagecolumns = (numberofpages / numberofcolumnsperpage) + 1;
        int numberofpagecolumns = (numberofpages / numberofcolumnsperpage);
        if (numberofpages % numberofcolumnsperpage) numberofpagecolumns++;


        //now to print
        int rowcount = 0;
        int colourcount = 0;
        if (!Background->Checked) {
            rowcount = 1;
            colourcount = 1;
            }
        int thispage = 0;
        //int totalpages = numberofpagecolumns * pages;

        //for (int page = 0; page < pages; page++) {
        int pagecolumn = (PageNumber % numberofpagecolumns);
        int page = (PageNumber - pagecolumn)/ numberofpagecolumns;
            //for (int pagecolumn = 0; pagecolumn < numberofpagecolumns; pagecolumn++) {
                colourcount = rowsperpage * (page );
                //rowcount = colourcount;
                rowcount = rowsperpage * (page);
                //rowcount = 0;
                thispage++;
                //Header Row
                Canvas->TextOut(KeyNumberLeft,RowSpacing * 2 + RowHeight,"Ref#");
                Canvas->TextOut(SymbolLeft,RowSpacing * 2 + RowHeight,"Shape");
                if (UseAnchor->Checked) {
                    Canvas->TextOut(DMCNumberLeft,RowSpacing * 2 + RowHeight,"Anchor#");
                    Canvas->TextOut(DMCNameLeft,RowSpacing * 2 + RowHeight,"Colour Name");
                    } else {
                    //Canvas->TextOut(DMCNumberLeft,RowSpacing * 2 + RowHeight,"DMC#");
                    //Canvas->TextOut(DMCNameLeft,RowSpacing * 2 + RowHeight,"DMC Name");
                    Canvas->TextOut(DMCNumberLeft,RowSpacing * 2 + RowHeight,ShortThreadName + "#");
                    Canvas->TextOut(DMCNameLeft,RowSpacing * 2 + RowHeight,ShortThreadName + " Name");
                    }
                Canvas->TextOut(StitchLeft,RowSpacing,"Number of Stitches");
                for (int j = 0; j < numberofcolumnsperpage; j++) {
                    if ((j + numberofcolumnsperpage * pagecolumn) <  StitchData[0].Length) {
                        Canvas->TextOut(StitchLeft + j *(StitchPrintWidth + ColumnSpacing) + StitchPrintWidth - Canvas->TextWidth("P" + AnsiString(j + numberofcolumnsperpage * pagecolumn + 1)),RowSpacing * 2 + RowHeight,"P" + AnsiString(j + numberofcolumnsperpage * pagecolumn + 1));
                        }
                    }
                for (int i = 0; i < rowsperpage; i++) {
                    //find the colour to print for this line
                    bool stop = false;
                    while (colourcount < PictureColourPallette.Length && !stop) {
                        if (UseAnchor->Checked) {
                            if (colourcount == PictureColourPallette[colourcount].AnchorColourToUse) {
                                stop = true;
                                } else {
                                colourcount++;
                                }
                            } else {
                            stop = true;
                            }
                        }
                    if (colourcount < PictureColourPallette.Length) {
                        if ((rowcount == 0 && Background->Checked) || rowcount > 0) {
                            int rowposition = (i + 2) * (RowSpacing + RowHeight) + RowSpacing;
                            if (UseAnchor->Checked) {
                                Canvas->TextOut(KeyNumberLeft,rowposition,AnsiString(PictureColourPallette[colourcount].AnchorGlyphToUse));
                                DrawAnchorGlyph(Canvas,SymbolLeft,rowposition,RowHeight,PictureColourPallette[colourcount].AnchorGlyphToUse, false, PictureColourPallette[colourcount].Colour, PictureColourPallette[colourcount].DrawWhite);
                                Canvas->TextOut(DMCNumberLeft,rowposition,PictureColourPallette[colourcount].AnchorColourNumber);
                                Canvas->TextOut(DMCNameLeft,rowposition,PictureColourPallette[colourcount].DMCColourName);
                                } else {
                                Canvas->TextOut(KeyNumberLeft,rowposition,AnsiString(rowcount));
                                DrawGlyph(Canvas,SymbolLeft,rowposition,RowHeight, rowcount, false);
                                Canvas->TextOut(DMCNumberLeft,rowposition,PictureColourPallette[rowcount].DMCColourNumber);
                                //Canvas->TextOut(DMCNameLeft,rowposition,PictureColourPallette[rowcount].DMCColourName);
                                bool cropped = false;
                                AnsiString Nametext = PictureColourPallette[rowcount].DMCColourName;
                                while ((DMCNameLeft + ColumnSpacing + Canvas->TextWidth(Nametext + "...")) > StitchLeft) {
                                    Nametext = ChopOffLastChars(Nametext,1);
                                    cropped = true;
                                    }
                                if (cropped) Nametext = Nametext + "...";
                                Canvas->TextOut(DMCNameLeft,rowposition,Nametext);
                                for (int j = 0; j < numberofcolumnsperpage; j++) {
                                    if ((j + numberofcolumnsperpage * pagecolumn) <  numberofpages && rowcount < StitchData.Length) {
                                        Canvas->TextOut(StitchLeft + j *(StitchPrintWidth + ColumnSpacing) + StitchPrintWidth - Canvas->TextWidth(AnsiString(StitchData[rowcount][j + numberofcolumnsperpage * pagecolumn])) ,rowposition,AnsiString(StitchData[rowcount][j + numberofcolumnsperpage * pagecolumn]));
                                        }
                                    }
                                }
                            }
                        }
                    colourcount++;
                    rowcount++;
                    }
                //if (thispage < totalpages) Printer()->NewPage();
                //}
            //}



        }

    __finally {
        //clear Data
        for (int i = 0; i < StitchData.Length; i++) {
            StitchData[i].Length = 0;
            }
        StitchData.Length = 0;
        }

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::DrawFabricSheet(TCanvas *Canvas, int Width, int Height)
{
    //Printer()->Canvas->Font->Name = "Arial";
    //Printer()->Canvas->Font->Size = 10;
    Canvas->Font->Name = ChartPrintout.ChartFont;
    Canvas->Font->Size = ChartPrintout.ChartFontSize + 2;
    Canvas->Font->Color = clBlack;

    int maxcolours;
    int mincolours, minx, miny, Maxx, Maxy;
    double averagecount;

    colourcomplexity Complexity = FindImageComplexity();
    maxcolours = Complexity.maxcolours;
    mincolours = Complexity.mincolours;
    Maxx = Complexity.Max.x;
    Maxy = Complexity.Max.y;
    minx = Complexity.Min.x;
    miny = Complexity.Min.y;
    averagecount = Complexity.average;

    /*
    //now to do some calculations on the complexity of the pattern
    DynamicArray <bool> ColourUsed;
    ColourUsed.Length = PictureColourPallette.Length;
    int colourcount;
    int maxcolours = 0;
    int totalcolours = 0;
    int squarecount = 0;
    int maxx, maxy, result;
    int mincolour;
    if (backgroundcolourfound) {
        mincolour = 1;
        } else {
        mincolour = 0;
        }
    double averagecount = 0.0;
    bool firsttimeround = true;
    int mincolours, minx, miny, Maxx, Maxy;

    //for (int x = 0; x < Image1->Picture->Width - 10; x++) {
        //for (int y = 0; y < Image1->Picture->Height - 10; y++) {
    for (int x = 0; x < Image1->Picture->Width; x += 10) {
        for (int y = 0; y < Image1->Picture->Height; y += 10) {
            for (int i = 0; i < ColourUsed.Length; i++) {
                ColourUsed[i] = false;
                }
            maxx = 10;
            if (x + maxx > Image1->Picture->Width) maxx = Image1->Picture->Width - x;
            maxy = 10;
            if (y + maxy > Image1->Picture->Height) maxy = Image1->Picture->Height - y;
            for (int i = 0; i < maxx; i++) {
                for (int j = 0; j < maxy; j++) {
                    result = FindColoutRefAtPixel(x + i, y + j);
                    if (result > -1 && result < ColourUsed.Length) ColourUsed[result] = true;
                    }
                }
            colourcount = 0;
            for (int i = mincolour; i < ColourUsed.Length; i++) {
                if (ColourUsed[i]) {
                    colourcount++;
                    }
                }
            if (colourcount > maxcolours) {
                maxcolours = colourcount;
                Maxx = x;
                Maxy = y;
                }
            totalcolours += colourcount;
            if (colourcount > 0) squarecount++;
            if (firsttimeround && colourcount != 0) {
                mincolours = colourcount;
                firsttimeround = false;
                minx = x;
                miny = y;
                }
            if (mincolours > colourcount && colourcount != 0) {
                mincolours = colourcount;
                minx = x;
                miny = y;
                }
            }
        }

    if (squarecount != 0) averagecount = ((double) totalcolours)/((double) squarecount);

    ColourUsed.Length = 0;
    */

        //This the fabric detail printout
        int ColumnSpacing = Canvas->TextWidth("88");
        int RowSpacing = Canvas->TextWidth(" ");
        int Tab1 = Canvas->TextWidth("Fabric ") + ColumnSpacing;
        int Tab2 = Canvas->TextWidth("Max. No. colours in 10 x 10 square   ") + ColumnSpacing;
        int row = 1;
        int RowHeight = Canvas->TextHeight("Tg");
        AnsiString size;
        double dimension;
        double roundeddimension;
        Canvas->Font->Style = Canvas->Font->Style << fsBold;
        Canvas->Font->Style = Canvas->Font->Style << fsUnderline;
        Canvas->TextOut(ColumnSpacing,row*(RowHeight + RowSpacing),"Fabric Details");
        Canvas->Font->Style = Canvas->Font->Style >> fsBold;
        Canvas->Font->Style = Canvas->Font->Style >> fsUnderline;
        row += 2;
        Canvas->TextOut(ColumnSpacing,row*(RowHeight + RowSpacing),"Picture Thread Count");
        Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),StitchCount->Items->Strings[StitchCount->ItemIndex] + " Stitches Per Inch");
        row++;
        Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),Label5->Caption + " Stitches total.");
        row += 2;
        Canvas->TextOut(ColumnSpacing,row*(RowHeight + RowSpacing),"Picture Size");
        dimension = (double)Image1->Width/(double)StitchCount->Items->Strings[StitchCount->ItemIndex].ToIntDef(9);
        roundeddimension = ROUND(dimension * 100.0)/100.0;
        size = "(" + AnsiString(roundeddimension) + " Inches, " + AnsiString(Image1->Width) + " Stitches) Wide.";
        dimension = dimension * 2.54;
        roundeddimension = ROUND(dimension * 10.0)/10.0;
        size = AnsiString(roundeddimension) + "cm " + size;
        Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),size);
        row++;
        dimension = (double)Image1->Height/(double)StitchCount->Items->Strings[StitchCount->ItemIndex].ToIntDef(9);
        roundeddimension = ROUND(dimension * 100.0)/100.0;
        size = "(" + AnsiString(roundeddimension) + " Inches, " + AnsiString(Image1->Height) + " Stitches) High.";
        dimension = dimension * 2.54;
        roundeddimension = ROUND(dimension * 10.0)/10.0;
        size = AnsiString(roundeddimension) + "cm " + size;
        Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),size);
        row += 2;
        Canvas->TextOut(ColumnSpacing,row*(RowHeight + RowSpacing),"Minimum Fabric Size");
        dimension = (double)Image1->Width/(double)StitchCount->Items->Strings[StitchCount->ItemIndex].ToIntDef(9) + 5.0;
        roundeddimension = ROUND(dimension * 100.0)/100.0;
        size = "(" + AnsiString(roundeddimension) + " Inches) Wide.";
        dimension = dimension * 2.54;
        roundeddimension = ROUND(dimension * 10.0)/10.0;
        size = AnsiString(roundeddimension) + "cm " + size;
        Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),size);
        row++;
        dimension = (double)Image1->Height/(double)StitchCount->Items->Strings[StitchCount->ItemIndex].ToIntDef(9) + 5.0;
        roundeddimension = ROUND(dimension * 100.0)/100.0;
        size = "(" + AnsiString(roundeddimension) + " Inches) High.";
        dimension = dimension * 2.54;
        roundeddimension = ROUND(dimension * 10.0)/10.0;
        size = AnsiString(roundeddimension) + "cm " + size;
        Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),size);

        if (backgroundcolourfound && !Background->Checked) {
            if (UseAnchor->Checked) {
                row += 2;
                Canvas->TextOut(ColumnSpacing,row*(RowHeight + RowSpacing),"Fabric");
                Canvas->TextOut(Tab1,row*(RowHeight + RowSpacing),"Anchor Colour Number");
                Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),PictureColourPallette[0].AnchorColourNumber);
                row++;
                Canvas->TextOut(Tab1,row*(RowHeight + RowSpacing),"Colour Name");
                Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),PictureColourPallette[0].DMCColourName);
                } else {
                row += 2;
                Canvas->TextOut(ColumnSpacing,row*(RowHeight + RowSpacing),"Fabric");
                //Canvas->TextOut(Tab1,row*(RowHeight + RowSpacing),"DMC Colour Number");
                Canvas->TextOut(Tab1,row*(RowHeight + RowSpacing),ShortThreadName + " Colour Number");
                Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),PictureColourPallette[0].DMCColourNumber);
                row++;
                //Canvas->TextOut(Tab1,row*(RowHeight + RowSpacing),"DMC Colour Name");
                Canvas->TextOut(Tab1,row*(RowHeight + RowSpacing),ShortThreadName + " Colour Name");
                Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),PictureColourPallette[0].DMCColourName);
                }
            } else {
            if (Background->Checked) {
                row += 2;
                Canvas->TextOut(ColumnSpacing,row*(RowHeight + RowSpacing),"Suggested Fabric, but all fabric is covered by image, so not critical.");
                row++;
                if (UseAnchor->Checked) {
                    //Canvas->TextOut(ColumnSpacing,row*(RowHeight + RowSpacing),"Fabric");
                    Canvas->TextOut(Tab1,row*(RowHeight + RowSpacing),"Anchor Colour Number");
                    Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),PictureColourPallette[0].AnchorColourNumber);
                    row++;
                    Canvas->TextOut(Tab1,row*(RowHeight + RowSpacing),"Colour Name");
                    Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),PictureColourPallette[0].DMCColourName);
                    } else {
                    //Canvas->TextOut(ColumnSpacing,row*(RowHeight + RowSpacing),"Fabric");
                    //Canvas->TextOut(Tab1,row*(RowHeight + RowSpacing),"DMC Colour Number");
                    Canvas->TextOut(Tab1,row*(RowHeight + RowSpacing),ShortThreadName + " Colour Number");
                    Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),PictureColourPallette[0].DMCColourNumber);
                    row++;
                    //Canvas->TextOut(Tab1,row*(RowHeight + RowSpacing),"DMC Colour Name");
                    Canvas->TextOut(Tab1,row*(RowHeight + RowSpacing),ShortThreadName + " Colour Name");
                    Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),PictureColourPallette[0].DMCColourName);
                    }
                }
            }

        //complexity info
        row += 2;
        Canvas->TextOut(ColumnSpacing,row*(RowHeight + RowSpacing),"Picture Complexity");
        switch (ConfettiLevel) {
            case TUnstitchable:     {
                                    Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),"Extremely Complex, may be unstitchable.");
                                    row++;
                                    Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),"Thread Length Safety Margin = 5");
                                    }
                                    break;
            case THighConfetti:     {
                                    Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),"Highly Complex");
                                    row++;
                                    Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),"Thread Length Safety Margin = 3");
                                    }
                                    break;
            case TMediumConfetti:   {
                                    Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),"Medium Complexity");
                                    row++;
                                    Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),"Thread Length Safety Margin = 2");
                                    }
                                    break;
            default:                {
                                    Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),"Low Complexity");
                                    row++;
                                    Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),"Thread Length Safety Margin = 1.5");
                                    }
                                    break;
            }
        row++;
        Canvas->TextOut(ColumnSpacing,row*(RowHeight + RowSpacing),"Max. No. colours in 10 x 10 square");
        Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),AnsiString(maxcolours) + " at X = " + AnsiString(Maxx) + " Y = " + AnsiString(Maxy));
        row++;
        Canvas->TextOut(ColumnSpacing,row*(RowHeight + RowSpacing),"Ave. No. colours in 10 x 10 square");
        Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),DP(1,averagecount));
        if (mincolours != 0) {
            row++;
            Canvas->TextOut(ColumnSpacing,row*(RowHeight + RowSpacing),"Min. No. colours in 10 x 10 square");
            Canvas->TextOut(Tab2,row*(RowHeight + RowSpacing),AnsiString(mincolours) + " at X = " + AnsiString(minx) + " Y = " + AnsiString(miny));
            }

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::DebugLists1Click(TObject *Sender)
{
    AnsiString text;
    for (int i = 0; i < DMCColourList.Length; i++) {
        text = AnsiString(i) + " Number=" + DMCColourList[i].DMCColourNumber + " Name=" + DMCColourList[i].DMCColourName;
        DMCListForm->Memo1->Lines->Add(text);
        }
    DMCListForm->Show();
    for (int i = 0; i < TweedList.Length; i++) {
        text = AnsiString(i) + " Number=" + TweedList[i].Data.DMCColourNumber + " Name=" + TweedList[i].Data.DMCColourName + " Pair=" + AnsiString(TweedList[i].ColourPairs[0].x) + "," + AnsiString(TweedList[i].ColourPairs[0].y);
        BlendListForm->Memo1->Lines->Add(text);
        }
    BlendListForm->Show();
    for (int i = 0; i < PictureColourPallette.Length; i++) {
        if (BlendReference.Length) {
            text = AnsiString(i) + " Number=" + PictureColourPallette[i].DMCColourNumber + " Name=" + PictureColourPallette[i].DMCColourName + " BlendRef=" + AnsiString(BlendReference[i].type) + "," + BlendReference[i].ColourName + "," + BlendReference[i].ColourNumber + "," + AnsiString(BlendReference[i].arrayref);
            } else {
            text = AnsiString(i) + " Number=" + PictureColourPallette[i].DMCColourNumber + " Name=" + PictureColourPallette[i].DMCColourName + " BlendRef=Empty";
            }
        PaletteListForm->Memo1->Lines->Add(text);
        }
    PaletteListForm->Show();
    for (int i = 0; i < BackStitches.Length; i++) {
        text = AnsiString(i) + " From " + AnsiString(BackStitches[i].X1) + "," + AnsiString(BackStitches[i].Y1) + " To " + AnsiString(BackStitches[i].X2) + "," + AnsiString(BackStitches[i].Y2) + "  Colour Ref = " + AnsiString(BackStitches[i].ColourNumber);
        BackStitchListForm->Memo1->Lines->Add(text);
        }
    BackStitchListForm->Show();

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::ImageComplexity1Click(TObject *Sender)
{
    LowComplexity1->Checked = (LowComplexity1->Tag == ((int)ConfettiLevel));
    MediumComplexity1->Checked = (MediumComplexity1->Tag == ((int)ConfettiLevel));
    HighlyComplex1->Checked = (HighlyComplex1->Tag == ((int)ConfettiLevel));
    AlmostImpossiblyComplex1->Checked = (AlmostImpossiblyComplex1->Tag == ((int)ConfettiLevel));
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::LowComplexity1Click(TObject *Sender)
{
    ConfettiLevel = (TConfettiLevel)dynamic_cast <TMenuItem *>(Sender)->Tag;
    forceConfettiLevel = true;
}
//---------------------------------------------------------------------------

colourcomplexity __fastcall TPlanForm::FindImageComplexity(void)
{


    //now to do some calculations on the complexity of the pattern
    DynamicArray <bool> ColourUsed;
    ColourUsed.Length = PictureColourPallette.Length;
    int colourcount;
    int maxcolours = 0;
    int totalcolours = 0;
    int squarecount = 0;
    int maxx, maxy, result;
    int mincolour;
    if (backgroundcolourfound) {
        mincolour = 1;
        } else {
        mincolour = 0;
        }
    double averagecount = 0.0;
    bool firsttimeround = true;
    int mincolours, minx, miny, Maxx, Maxy;

    //for (int x = 0; x < Image1->Picture->Width - 10; x++) {
        //for (int y = 0; y < Image1->Picture->Height - 10; y++) {
    for (int x = 0; x < Image1->Picture->Width; x += 10) {
        for (int y = 0; y < Image1->Picture->Height; y += 10) {
            for (int i = 0; i < ColourUsed.Length; i++) {
                ColourUsed[i] = false;
                }
            maxx = 10;
            if (x + maxx > Image1->Picture->Width) maxx = Image1->Picture->Width - x;
            maxy = 10;
            if (y + maxy > Image1->Picture->Height) maxy = Image1->Picture->Height - y;
            for (int i = 0; i < maxx; i++) {
                for (int j = 0; j < maxy; j++) {
                    result = FindColoutRefAtPixel(x + i, y + j);
                    if (result > -1 && result < ColourUsed.Length) ColourUsed[result] = true;
                    }
                }
            colourcount = 0;
            for (int i = mincolour; i < ColourUsed.Length; i++) {
                if (ColourUsed[i]) {
                    colourcount++;
                    }
                }
            if (colourcount > maxcolours) {
                maxcolours = colourcount;
                Maxx = x;
                Maxy = y;
                }
            totalcolours += colourcount;
            if (colourcount > 0) squarecount++;
            if (firsttimeround && colourcount != 0) {
                mincolours = colourcount;
                firsttimeround = false;
                minx = x;
                miny = y;
                }
            if (mincolours > colourcount && colourcount != 0) {
                mincolours = colourcount;
                minx = x;
                miny = y;
                }
            }
        }

    if (squarecount != 0) averagecount = ((double) totalcolours)/((double) squarecount);

    ColourUsed.Length = 0;

    colourcomplexity Complexity;
    Complexity.maxcolours = maxcolours;
    Complexity.mincolours = mincolours;
    Complexity.Max.x = Maxx;
    Complexity.Max.y = Maxy;
    Complexity.Min.x = minx;
    Complexity.Min.y = miny;
    Complexity.average = averagecount;

    return Complexity;
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::ImageDetails1Click(TObject *Sender)
{
    TImageDetailsForm *ImageDetailsForm = new TImageDetailsForm(this);
    AnsiString text;

    //ImageDetailsForm->RichEdit1->DefAttributes->Style = ImageDetailsForm->RichEdit1->DefAttributes->Style << fsBold;
    ImageDetailsForm->RichEdit1->SelAttributes->Style = ImageDetailsForm->RichEdit1->SelAttributes->Style << fsBold;
    ImageDetailsForm->RichEdit1->Lines->Add("Image Details for " + PictureFileName);
    //ImageDetailsForm->RichEdit1->DefAttributes->Style = ImageDetailsForm->RichEdit1->DefAttributes->Style >> fsBold;
    ImageDetailsForm->RichEdit1->SelAttributes->Style = ImageDetailsForm->RichEdit1->SelAttributes->Style >> fsBold;
    ImageDetailsForm->RichEdit1->Lines->Add(" ");
    ImageDetailsForm->RichEdit1->Lines->Add("Image is " + AnsiString(Image1->Width) + " Stitches Wide and " + AnsiString(Image1->Height) + " Stitches High.");
    ImageDetailsForm->RichEdit1->Lines->Add(" ");
    text = "There are " + AnsiString(PictureColourPallette.Length) + " Colours in the image.";
    if ((bool)PictureColourPallette.Length) text = text + " The thread colours used are:";
    ImageDetailsForm->RichEdit1->Lines->Add(text);
    if ((bool)PictureColourPallette.Length) {
        int start = 1;
        int offset = 0;
        if (Background->Checked) {
            start = 0;
            offset = 1;
            }
        if (UseAnchor->Checked) {
            ImageDetailsForm->RichEdit1->Lines->Add("Ref #\tAnchor#\tAnchor Name & Number of stitches");
            } else {
            //ImageDetailsForm->RichEdit1->Lines->Add("Ref #\tDMC#\tDMC Name & Number of stitches");
            ImageDetailsForm->RichEdit1->Lines->Add("Ref #\t" + ShortThreadName + "#\t" + ShortThreadName + " Name & Number of stitches");
            }
        while (start < PictureColourPallette.Length) {
            if (UseAnchor->Checked) {
                ImageDetailsForm->RichEdit1->Lines->Add(AnsiString(start + offset) + "\t" + PictureColourPallette[start].AnchorColourNumber + "\t" + PictureColourPallette[start].DMCColourName + ", " + AnsiString(PictureColourPallette[start].StitchCount) + " Stitches" );
                } else {
                ImageDetailsForm->RichEdit1->Lines->Add(AnsiString(start + offset) + "\t" + PictureColourPallette[start].DMCColourNumber + "\t" + PictureColourPallette[start].DMCColourName + ", " + AnsiString(PictureColourPallette[start].StitchCount) + " Stitches" );
                }
            start++;
            }
        if (blendthreads) {
            //OK. Now to construct the reference array to identify the threads used in the blends.
            //this bit prints the actual DMC threads used in blends
            DynamicArray <usedcolour> UsedColourList;
            UsedColourList.Length = DMCColourList.Length;
            for (int i = 0; i < UsedColourList.Length; i++) {
                UsedColourList[i].used = false;
                UsedColourList[i].refno = -1;
                UsedColourList[i].stitches = 0;
                UsedColourList[i].DMCArrayRef = i;
                }
            for (int i = 0; i < BlendReference.Length; i++) {
                switch (BlendReference[i].type) {
                    case TBlendedColour:    {
                                            if (BlendReference[i].arrayref < TweedList.Length) {
                                                if (TweedList[BlendReference[i].arrayref].ColourPairs[0].x < UsedColourList.Length) {
                                                    UsedColourList[TweedList[BlendReference[i].arrayref].ColourPairs[0].x].used = true;
                                                    UsedColourList[TweedList[BlendReference[i].arrayref].ColourPairs[0].x].stitches += PictureColourPallette[i].StitchCount / 2 + 1;
                                                    }
                                                if (TweedList[BlendReference[i].arrayref].ColourPairs[0].y < UsedColourList.Length) {
                                                    UsedColourList[TweedList[BlendReference[i].arrayref].ColourPairs[0].y].used = true;
                                                    UsedColourList[TweedList[BlendReference[i].arrayref].ColourPairs[0].y].stitches += PictureColourPallette[i].StitchCount / 2 + 1;
                                                    }
                                                }
                                            }
                                            break;
                    case TDMCColour:        {
                                            if (BlendReference[i].arrayref < UsedColourList.Length) {
                                                UsedColourList[BlendReference[i].arrayref].used = true;
                                                UsedColourList[BlendReference[i].arrayref].refno = i;
                                                UsedColourList[BlendReference[i].arrayref].stitches += PictureColourPallette[i].StitchCount;
                                                }
                                            }
                                            break;
                    default:                break;
                    }
                }
            //sort the list by DMC Number
            usedcolour SwapColour;
            bool swapped = true;
            while (swapped) {
                swapped = false;
                for (int i = 0; i < UsedColourList.Length - 1; i++) {
                    if (DMCColourList[UsedColourList[i].DMCArrayRef].DMCColourNumber.ToIntDef(1) > DMCColourList[UsedColourList[i + 1].DMCArrayRef].DMCColourNumber.ToIntDef(1)) {
                        swapped = true;
                        SwapColour = UsedColourList[i];
                        UsedColourList[i] = UsedColourList[i+1];
                        UsedColourList[i+1] = SwapColour;
                        }
                    }
                }
            int colourcount = 0;
            for (int i = 0; i < UsedColourList.Length; i++) {
                if (UsedColourList[i].used ) {
                    colourcount++;
                    }
                }
            ImageDetailsForm->RichEdit1->Lines->Add(" ");
            ImageDetailsForm->RichEdit1->Lines->Add("There are " + AnsiString(colourcount) + " thread colours used in the blends, and they are as below.");
            //ImageDetailsForm->RichEdit1->Lines->Add("Ref #\tDMC#\tDMC Name & Number of stitches");
            ImageDetailsForm->RichEdit1->Lines->Add("Ref #\t" + ShortThreadName + "#\t" + ShortThreadName + " Name & Number of stitches");
            colourcount = 0;
            for (int i = 0; i < UsedColourList.Length; i++) {
                if (UsedColourList[i].used ) {
                    colourcount++;
                    ImageDetailsForm->RichEdit1->Lines->Add(AnsiString(colourcount) + "\t" + DMCColourList[UsedColourList[i].DMCArrayRef].DMCColourNumber + "\t" + DMCColourList[UsedColourList[i].DMCArrayRef].DMCColourName + ", " + AnsiString(UsedColourList[i].stitches) + " Stitches" );
                    }
                }
            UsedColourList.Length = 0;
            }
        }

    ImageDetailsForm->RichEdit1->Lines->Add(" ");
    text = "The image is ";
        switch (ConfettiLevel) {
            case TUnstitchable:     {
                                    text = text + "'Extremely Complex, and it may be unstitchable'.";
                                    }
                                    break;
            case THighConfetti:     {
                                    text = text + "'Highly Complex'.";
                                    }
                                    break;
            case TMediumConfetti:   {
                                    text = text + "of 'Medium Complexity'.";
                                    }
                                    break;
            default:                {
                                    text = text + "of 'Low Complexity'.";
                                    }
                                    break;
            }
    ImageDetailsForm->RichEdit1->Lines->Add(text);

    ImageDetailsForm->ShowModal();

    delete ImageDetailsForm;    
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::New1Click(TObject *Sender)
{
    TNewImageForm *NewImageForm = new TNewImageForm(this);

    NewImageForm->ShowModal();

    if (NewImageForm->ModalResult == mrOk) {
        //change size of image 1
        Image1->Picture->Bitmap->Width = NewImageForm->ImageWidth->Text.ToIntDef(100);
        Image1->Picture->Bitmap->Height = NewImageForm->ImageHeight->Text.ToIntDef(100);
        //clear picture
        Image1->Picture->Bitmap->Canvas->Brush->Color = clWhite;
        Image1->Picture->Bitmap->Canvas->Pen->Color = clWhite;
        Image1->Picture->Bitmap->Canvas->Rectangle(0,0,Image1->Picture->Bitmap->Width,Image1->Picture->Bitmap->Height);
        //clear existing picture
        if (!OriginalBitmap->Empty) {
            OriginalBitmap->Width = 0;
            OriginalBitmap->Height = 0;
            }
        if (!OriginalImage->Empty) {
            OriginalImage->Width = 0;
            OriginalImage->Height = 0;
            }
        BackStitches.Length = 0;
        PictureFileName = "New Image.bmp";
        Image4->Top = Image1->Top + Image1->Height;
        Image4->Left = Image1->Left;
        PictureChanged = true;
        CreateImage4();
        FormResize(this);

        Caption = ExtractFileName(PictureFileName);

        FillPictureData();
        //Caption = ExtractFileName(PictureFileName);
        CountBackStitches();
        AssignAnchorColours();

        FillPrinterData();

        PrintKey->Enabled = true;
        PrintChart->Enabled = true;
        PrintFabricDetails1->Enabled = true;
        PrintFronticePiece1->Enabled = true;
        if (BackStitches.Length) PrintBackStitches1->Enabled = true;
        if (!UseAnchor->Checked) PrintPageStitchInfo->Enabled = true;
        PrintWholeChartDocument1->Enabled = true;
        Label3->Enabled = true;
        Label26->Enabled = true;
        Label27->Enabled = true;
        PageNumber->Enabled = true;
        UseAnchor->Enabled = true;
        PrintColour->Enabled = true;
        BackStitch1->Enabled = true;
        MergeSubstituteColours1->Enabled = true;
        CropImage1->Enabled = true;
        CopyPlanSheetXRef1->Enabled = true;
        ColourReduction1->Enabled = true;
        Image4->Top = Image1->Top + Image1->Height;
        Image4->Left = Image1->Left;
        UndoStitchOffset.X = 0;
        UndoStitchOffset.Y = 0;
        //CreateImage4();
        Screen->Cursor = crDefault;
        ImageEditor1Click(Sender);

        }

    delete NewImageForm;


}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::ImageEditor1Click(TObject *Sender)
{
    //Opens an Image Editor
    if (OriginalBitmap->Empty) {
        OriginalBitmap->Assign(Image1->Picture->Bitmap);
        }

    TImageEditorForm *ImageEditorForm = new TImageEditorForm(this);

    //now fill in the thread colours in the backstitch unit.
    ImageEditorForm->DMCColourList.Length = DMCColourList.Length;
    for (int i = 0; i < DMCColourList.Length; i++) {
        ImageEditorForm->DMCColourList[i].DMCColourNumber = DMCColourList[i].DMCColourNumber;
        ImageEditorForm->DMCColourList[i].DMCColourName = DMCColourList[i].DMCColourName;
        ImageEditorForm->DMCColourList[i].Colour = DMCColourList[i].Colour;
        ImageEditorForm->DMCColourList[i].DrawWhite = DMCColourList[i].DrawWhite;
        ImageEditorForm->DMCColourList[i].StitchCount = DMCColourList[i].StitchCount;
        ImageEditorForm->DMCColourList[i].R = DMCColourList[i].R;
        ImageEditorForm->DMCColourList[i].G = DMCColourList[i].G;
        ImageEditorForm->DMCColourList[i].B = DMCColourList[i].B;
        }
    ImageEditorForm->TweedList.Length = TweedList.Length;
    for (int i = 0; i < TweedList.Length; i++) {
        ImageEditorForm->TweedList[i].DMCColourNumber = TweedList[i].Data.DMCColourNumber;
        ImageEditorForm->TweedList[i].DMCColourName = TweedList[i].Data.DMCColourName;
        ImageEditorForm->TweedList[i].Colour = TweedList[i].Data.Colour;
        ImageEditorForm->TweedList[i].DrawWhite = TweedList[i].Data.DrawWhite;
        ImageEditorForm->TweedList[i].StitchCount = TweedList[i].Data.StitchCount;
        ImageEditorForm->TweedList[i].R = TweedList[i].Data.R;
        ImageEditorForm->TweedList[i].G = TweedList[i].Data.G;
        ImageEditorForm->TweedList[i].B = TweedList[i].Data.B;
        }

    //setup the picture
    ImageEditorForm->Picture->Width = Image1->Width;
    ImageEditorForm->Picture->Height = Image1->Height;
    bool temp = Image1->Transparent;
    Image1->Transparent = false;
    ImageEditorForm->Picture->Canvas->Draw(0,0,Image1->Picture->Bitmap);
    Image1->Transparent = temp;

    //setup the stitch count
    ImageEditorForm->PictureXStitchCount = StitchCount->Items->Strings[StitchCount->ItemIndex].ToIntDef(14);
    ImageEditorForm->blendthreads = blendthreads;
    ImageEditorForm->colourspacedivisions = Conversion.colourspace;
    ImageEditorForm->Conversion = Conversion;

    ImageEditorForm->ShortThreadName = ShortThreadName;
    
    ImageEditorForm->Initialise();

    ImageEditorForm->ShowModal();

    if (ImageEditorForm->ModalResult == mrOk) {
        //revised picture is OK, so swap out old picture for new one
        ImageEditorForm->Complete();
        Image1->Width = ImageEditorForm->Picture->Width;
        Image1->Height = ImageEditorForm->Picture->Height;
        Image1->Picture->Bitmap->Width = ImageEditorForm->Picture->Width;
        Image1->Picture->Bitmap->Height = ImageEditorForm->Picture->Height;
        Image1->Picture->Bitmap->Canvas->Draw(0,0,ImageEditorForm->Picture);
        blendthreads = ImageEditorForm->blendthreads;
        PictureChanged = true;
        HeightLabel->Caption = AnsiString(Image1->Height) + " Pixels";
        WidthLabel->Caption = AnsiString(Image1->Width) + " Pixels";
        double value;
        value = double(Image1->Height) /double( StitchCount->Items->Strings[StitchCount->ItemIndex].ToIntDef(14));
        value = ROUND(value * 100.0)/100.0;
        Label10->Caption = AnsiString(value) + "\"";
        value = value * 2.54;
        value = ROUND(value * 100.0)/100.0;
        Label10->Caption = Label10->Caption + ",   " + AnsiString(value) + "cm";
        value = double(Image1->Width) /double( StitchCount->Items->Strings[StitchCount->ItemIndex].ToIntDef(1));
        value = ROUND(value * 100.0)/100.0;
        Label11->Caption = AnsiString(value) + "\"";
        value = value * 2.54;
        value = ROUND(value * 100.0)/100.0;
        Label11->Caption = Label11->Caption + ",   " + AnsiString(value) + "cm";
        UseAnchor->Enabled = !blendthreads;
        if (blendthreads) {
            UseAnchor->Checked = false;
            }
        FillPictureData();
        CountBackStitches();
        AssignAnchorColours();
        FillPrinterData();
        }

    delete ImageEditorForm;
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::FillMemo1(bool found)
{
    Memo1->Lines->Clear();
    Label13->Caption = AnsiString(PictureColourPallette.Length);
    for (int i = 0; i < PictureColourPallette.Length; i++) {
        //Memo1->Lines->Add(AnsiString (i) + ", DMC "
        Memo1->Lines->Add(AnsiString (i) + ", " + ShortThreadName + " "
                            + PictureColourPallette[i].DMCColourNumber + ", "
                            + PictureColourPallette[i].DMCColourName + ", "
                            + AnsiString(PictureColourPallette[i].StitchCount)
                            + (PictureColourPallette[i].StitchCount == 1 ? " Stitch." : " Stitches.")
                            + ((i == 0 && found) ? "  Available as a coloured fabric." : " ")
                            );
        }
    Memo1->SelStart = 0;
    Memo1->SelLength = 0;
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::SetSymbols1Click(TObject *Sender)
{
    if (PictureColourPallette.Length < SymboltoGlyphXRef.Length) {
        //Opens a window to allow the symbols to be set for this chart only
        TSetSymbolsForm *SetSymbolsForm  = new TSetSymbolsForm(this);

        //send data to SetSymbolsForm
        SetSymbolsForm->PictureColourPallette.Length = PictureColourPallette.Length;
        for (int i = 0; i < PictureColourPallette.Length; i++) {
            SetSymbolsForm->PictureColourPallette[i] = PictureColourPallette[i];
            }
        SetSymbolsForm->UsedSymbols.Length = PictureColourPallette.Length;
        int max = PictureColourPallette.Length;
        if (max > SymboltoGlyphXRef.Length) max = SymboltoGlyphXRef.Length;
        for (int i = 0; i < max; i++) {
            SetSymbolsForm->UsedSymbols[i] = SymboltoGlyphXRef[i];
            }
        SetSymbolsForm->UnUsedSymbols.Length = SymboltoGlyphXRef.Length - max;
        for (int i = 0; i < SetSymbolsForm->UnUsedSymbols.Length; i++) {
            if (i + max < SymboltoGlyphXRef.Length) {
                SetSymbolsForm->UnUsedSymbols[i] = SymboltoGlyphXRef[i + max];
                }
            }
        SetSymbolsForm->Initialise();
        SetSymbolsForm->ShowModal();

        if (SetSymbolsForm->ModalResult == mrOk) {
            bool symbolchanged = false;
            for (int i = 0; i < SetSymbolsForm->UsedSymbols.Length; i++) {
                if (SymboltoGlyphXRef[i] != SetSymbolsForm->UsedSymbols[i]) {
                    SymboltoGlyphXRef[i] = SetSymbolsForm->UsedSymbols[i];
                    symbolchanged = true;
                    }
                }
            int glyphpointer = SetSymbolsForm->UsedSymbols.Length;
            int unusedsymbolpointer = 0;
            while (glyphpointer < SymboltoGlyphXRef.Length && unusedsymbolpointer < SetSymbolsForm->UnUsedSymbols.Length) {
                if (SymboltoGlyphXRef[glyphpointer] != SetSymbolsForm->UnUsedSymbols[unusedsymbolpointer]) {
                    SymboltoGlyphXRef[glyphpointer] = SetSymbolsForm->UnUsedSymbols[unusedsymbolpointer];
                    symbolchanged = true;
                    }
                glyphpointer++;
                unusedsymbolpointer++;
                }
            if (symbolchanged) {
                setsymbols = true;
                backstitcheschanged = true;
                ImageListCreate();
                }
            }

        delete SetSymbolsForm;

        } else {
        Application->MessageBox("Sorry, There are not enough symbols in the program for the number of colours in the image.\n\nSetting Symbols Aborted","Warning", MB_OK | MB_ICONERROR);
        }

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::SetSymbols2Click(TObject *Sender)
{
    //This is similar to the above, but enables the symbols to be changed for all
    //future projects.
    if (SymboltoGlyphXRef.Length) {
        //Opens a window to allow the symbols to be set for this chart only
        TSetDefaultSymbolsForm *SetDefaultSymbolsForm  = new TSetDefaultSymbolsForm(this);

        //send data to SetSymbolsForm
        SetDefaultSymbolsForm->Symbols.Length = SymboltoGlyphXRef.Length;
        for (int i = 0; i < SetDefaultSymbolsForm->Symbols.Length; i++) {
            SetDefaultSymbolsForm->Symbols[i] = SymboltoGlyphXRef[i];
            }
        SetDefaultSymbolsForm->Initialise();
        SetDefaultSymbolsForm->ShowModal();

        if (SetDefaultSymbolsForm->ModalResult == mrOk) {
            bool symbolchanged = false;
            for (int i = 0; i < SetDefaultSymbolsForm->Symbols.Length; i++) {
                if (SymboltoGlyphXRef[i] != SetDefaultSymbolsForm->Symbols[i]) {
                    SymboltoGlyphXRef[i] = SetDefaultSymbolsForm->Symbols[i];
                    symbolchanged = true;
                    }
                }
            if (symbolchanged) {
                //need to save the new default symbols
                inputfile->Clear();
                AnsiString text;
                inputfile->Add("# File format. Lines may be in any order.");
                inputfile->Add("# Symbol to Glyph XReference file");
                inputfile->Add("# May be manually edited");
                inputfile->Add("# Do not make two thread numbers reference the same shape");
                inputfile->Add("# If a thread number is not referenced in the file below, then it will default to the same shape number.");
                inputfile->Add("# At the moment there are 600 shapes, 0-599, but up to 1000 is catered for for future developments.");
                inputfile->Add("# See help file for how to use this file");
                inputfile->Add("# Each line must have the format below.");
                inputfile->Add("# Thread Number, Shape number to be referenced by that thread number.");

                for (int i = 0; i < SymboltoGlyphXRef.Length; i++) {
                    if (SymboltoGlyphXRef[i] != i) {
                        text = AnsiString(i) + "," + AnsiString(SymboltoGlyphXRef[i]);
                        inputfile->Add(text);
                        }
                    }
                AnsiString FileName = ExtractFileDir(Application->ExeName) + "\\SymbolToGlyphXRef.csv";
                inputfile->SaveToFile(FileName);
                inputfile->Clear();

                }
            }

        delete SetDefaultSymbolsForm;

        } else {
        Application->MessageBox("Sorry, There are no symbols in the program.\n\nSetting Symbols Aborted","Warning", MB_OK | MB_ICONERROR);
        }

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::DefaultSettings1Click(TObject *Sender)
{
    //sets the default settings for many things in the program
    TDefaultSettingsForm *DefaultSettingsForm = new TDefaultSettingsForm(this);

    DefaultSettingsForm->ShowModal();
    if (DefaultSettingsForm->ModalResult == mrOk) {
        ReadIniFile();
        }

    delete DefaultSettingsForm;
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::ReadIniFile(void)
{
    //opens the .ini file
    TIniFile *IniFile = new TIniFile(ChangeFileExt(Application->ExeName, ".ini"));
    ThreadSortMethod->ItemIndex = ThreadSortMethod->Items->IndexOf(IniFile->ReadString("ChartSettings","SortMethod","Stitch Count"));
    StitchCount->ItemIndex = StitchCount->Items->IndexOf(IniFile->ReadString("ChartSettings","StitchCount","14"));
    PrintCount->ItemIndex = PrintCount->Items->IndexOf(IniFile->ReadString("ChartSettings","PlanCount","10"));
    Background->Checked = IniFile->ReadBool("ChartSettings","ShowBackground",false);
    SimpleKey->Checked = IniFile->ReadBool("ChartSettings","SimpleKey",true);

    //Print Settings
    ChartPrintout.FrontSheet = IniFile->ReadBool("PrintSettings","FrontSheet",true);
    ChartPrintout.IndexPage = IniFile->ReadBool("PrintSettings","ContentsPage",true);
    ChartPrintout.ColourChart = IniFile->ReadBool("PrintSettings","ColourChart",true);
    ChartPrintout.MonochromeChart = IniFile->ReadBool("PrintSettings","MonochromeChart",true);
    ChartPrintout.BackStitches = IniFile->ReadBool("PrintSettings","BackStitches",true);
    ChartPrintout.DetailedKey = IniFile->ReadBool("PrintSettings","DetailedKey",true);
    ChartPrintout.StitchesPerPage = IniFile->ReadBool("PrintSettings","StitchInfo",true);
    ChartPrintout.FabricDetails = IniFile->ReadBool("PrintSettings","FabricDetails",true);
    ChartPrintout.ChartPageXRef = IniFile->ReadBool("PrintSettings","XRefImage",true);

    //font settings
    ChartPrintout.TitleFont = IniFile->ReadString("PrintSettings","TitleFont","Arial");
    ChartPrintout.TitleSize = IniFile->ReadString("PrintSettings","TitleSize","20").ToIntDef(20);
    ChartPrintout.ImageCopyrightFont = IniFile->ReadString("PrintSettings","ImageFont","Arial");
    ChartPrintout.ImageCopyrightSize = IniFile->ReadString("PrintSettings","ImageFontSize","12").ToIntDef(12);
    ChartPrintout.ChartCopyrightFont = IniFile->ReadString("PrintSettings","ChartCopyright","Arial");
    ChartPrintout.ChartCopyrightSize = IniFile->ReadString("PrintSettings","ChartCopyrightFontSize","12").ToIntDef(12);
    ChartPrintout.ChartFont = IniFile->ReadString("PrintSettings","ChartFont","Arial");
    ChartPrintout.ChartFontSize = IniFile->ReadString("PrintSettings","ChartFontSize","8").ToIntDef(8);

    //Load in names of custom thread ranges
    int numberofthreadranges = IniFile->ReadInteger("ThreadSettings","NumberofRanges",3);
    if (numberofthreadranges != 3) {
        while (ThreadFileNameList->Count > 3) ThreadFileNameList->Delete(3);
        for (int i = 3; i < numberofthreadranges; i++) {
            ThreadFileNameList->Add(IniFile->ReadString("ThreadSettings","RangeFilename" + AnsiString(i),"DMCCottonFloss"));
            }
        }

    int currentrange = IniFile->ReadInteger("ThreadSettings","CurrentRange",0);
    if (currentrange != ThreadFileNamePointer) {
        ThreadFileNamePointer = currentrange;
        OpenDMCList();
        }

    delete IniFile;

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::Range1Click(TObject *Sender)
{
    //This is stage 1 of making sure that it's possible to have alternative thread types
    while (Range1->Count > 3) {
        Range1->Delete(3);
        }

    TIniFile *IniFile = new TIniFile(ChangeFileExt(Application->ExeName, ".ini"));
    int numberofthreadranges = IniFile->ReadInteger("ThreadSettings","NumberofRanges",3);

    TMenuItem *NewItem;
    if (numberofthreadranges != 3) {
        for (int i = 3; i < numberofthreadranges; i++) {
            NewItem = new TMenuItem(this);
            NewItem->Caption = IniFile->ReadString("ThreadSettings","RangeTitle" + AnsiString(i),"DMC Cotton Floss");
            NewItem->Tag = i;
            NewItem->Hint = "Open Floss defined by '" + IniFile->ReadString("ThreadSettings","RangeFilename" + AnsiString(i),"DMCCottonFloss") + ".csv'";
            NewItem->OnClick = OpenFlossRange;
            Range1->Add(NewItem);
            }
        }
    delete IniFile;

    for (int i = 0; i < Range1->Count; i++) {
        NewItem = Range1->Items[i];
        NewItem->Checked = (NewItem->Tag == ThreadFileNamePointer); 
        }



}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::OpenFlossRange(TObject *Sender)
{
    //this is where it goes to when opening a new floss
    if (dynamic_cast <TMenuItem *>(Sender) && dynamic_cast <TMenuItem *>(Sender)->Tag < ThreadFileNameList->Count && dynamic_cast <TMenuItem *>(Sender)->Tag != ThreadFileNamePointer) {
        ThreadFileNamePointer = dynamic_cast <TMenuItem *>(Sender)->Tag;
        TIniFile *IniFile = new TIniFile(ChangeFileExt(Application->ExeName, ".ini"));
        IniFile->WriteInteger("ThreadSettings","CurrentRange",ThreadFileNamePointer);
        delete IniFile;
        OpenDMCList();

        FillPictureData();
        PictureChanged = true;
        CreateImage4();
        CountBackStitches();
        AssignAnchorColours();
        FillPrinterData();
        }
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::AddFlossRange1Click(TObject *Sender)
{
    //opens a new range of floss, creates blends, displays the range and saves
    //the data to the specified blend file and adds the range name to the .ini file
    if (OpenDialog3->Execute()) {
        TAddThreadRangeForm *AddThreadRangeForm = new TAddThreadRangeForm(this);

        AddThreadRangeForm->FileName = OpenDialog3->FileName;
        AddThreadRangeForm->Initialise();

        AddThreadRangeForm->ShowModal();

        if (AddThreadRangeForm->ModalResult == mrOk) {
            //update thread list
            TIniFile *IniFile = new TIniFile(ChangeFileExt(Application->ExeName, ".ini"));
            int numberofthreadranges = IniFile->ReadInteger("ThreadSettings","NumberofRanges",3);
            while (ThreadFileNameList->Count > 3) {
                ThreadFileNameList->Delete(3);
                }
            if (numberofthreadranges != 3) {
                for (int i = 3; i < numberofthreadranges; i++) {
                    ThreadFileNameList->Add(IniFile->ReadString("ThreadSettings","RangeFilename" + AnsiString(i),"DMCCottonFloss"));
                    }
                }
            delete IniFile;
            }

        delete AddThreadRangeForm;
        }
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::DeleteRange1Click(TObject *Sender)
{
    //deletes a selected floss range if it is present.
    if (ThreadFileNameList->Count > 3) {
        TDeleteThreadRangeForm *DeleteThreadRangeForm = new TDeleteThreadRangeForm(this);

        DeleteThreadRangeForm->ShowModal();

        if (DeleteThreadRangeForm->ModalResult == mrOk) {
            //update thread list
            TIniFile *IniFile = new TIniFile(ChangeFileExt(Application->ExeName, ".ini"));
            int numberofthreadranges = IniFile->ReadInteger("ThreadSettings","NumberofRanges",3);
            while (ThreadFileNameList->Count > 3) {
                ThreadFileNameList->Delete(3);
                }
            if (numberofthreadranges != 3) {
                for (int i = 3; i < numberofthreadranges; i++) {
                    ThreadFileNameList->Add(IniFile->ReadString("ThreadSettings","RangeFilename" + AnsiString(i),"DMCCottonFloss"));
                    }
                }
            ThreadFileNamePointer = IniFile->ReadInteger("ThreadSettings","CurrentRange",0);
            delete IniFile;
            }

        delete DeleteThreadRangeForm;

        }
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::FlossTypeClick(TObject *Sender)
{
    //disable the ability to delete a range if there are only 3 ranges
    DeleteRange1->Enabled = (bool)(ThreadFileNameList->Count > 3);
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::FromScratch1Click(TObject *Sender)
{
    TObtainRGBForm *ObtainRGBForm = new TObtainRGBForm(this);

    ObtainRGBForm->ShowModal();

        if (ObtainRGBForm->RegisteredThreads) {
            //new threads have been registered
            //update thread list
            TIniFile *IniFile = new TIniFile(ChangeFileExt(Application->ExeName, ".ini"));
            int numberofthreadranges = IniFile->ReadInteger("ThreadSettings","NumberofRanges",3);
            while (ThreadFileNameList->Count > 3) {
                ThreadFileNameList->Delete(3);
                }
            if (numberofthreadranges != 3) {
                for (int i = 3; i < numberofthreadranges; i++) {
                    ThreadFileNameList->Add(IniFile->ReadString("ThreadSettings","RangeFilename" + AnsiString(i),"DMCCottonFloss"));
                    }
                }
            delete IniFile;
           }

    delete ObtainRGBForm;
}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::EditARange1Click(TObject *Sender)
{
    TObtainRGBForm *ObtainRGBForm = new TObtainRGBForm(this);

    ObtainRGBForm->AppendColoursto1Click(Sender);

    //check to see if the file is one of the base ranges supplied with the program, and must not be edited
    AnsiString text = ChangeFileExt(ObtainRGBForm->OpenDialog1->FileName.LowerCase(),"");
    bool found = false;
    int entry = -1;
    for (int i = 0; i < ThreadFileNameList->Count; i++) {
        if (text == ThreadFileNameList->Strings[i].LowerCase()) {
            found = true;
            entry = i;
            }
        }

    if (!found) {
        //configure for correct display
        ObtainRGBForm->Save1->Enabled = true;
        ObtainRGBForm->SaveAs1->Enabled = false;
        ObtainRGBForm->SaveButton->Enabled = true;
        ObtainRGBForm->N3->Enabled = true;
        ObtainRGBForm->RegisterDefinitionFile1->Enabled = true;
        ObtainRGBForm->Caption = "Edit Thread Range";

        ObtainRGBForm->ShowModal();

        if (ObtainRGBForm->RegisteredThreads) {
            //new threads have been registered
            //update thread list
            TIniFile *IniFile = new TIniFile(ChangeFileExt(Application->ExeName, ".ini"));
            int numberofthreadranges = IniFile->ReadInteger("ThreadSettings","NumberofRanges",3);
            while (ThreadFileNameList->Count > 3) {
                ThreadFileNameList->Delete(3);
                }
            if (numberofthreadranges != 3) {
                for (int i = 3; i < numberofthreadranges; i++) {
                    ThreadFileNameList->Add(IniFile->ReadString("ThreadSettings","RangeFilename" + AnsiString(i),"DMCCottonFloss"));
                    }
                }
            delete IniFile;
           }
        } else {
        if (entry > -1 && entry < 3) {
            Application->MessageBox("Sorry, you cannot edit the Anchor, DMC or DMC Monochrome thread definitions supplied with the program.","Warning",IDOK | MB_ICONEXCLAMATION);
            } else {
            if (entry > 2) Application->MessageBox("Sorry, you cannot edit a registered thread definition, please de-register it first.\n\nThe reason for this is that the blend colours can get in a terrible muddle.","Warning",IDOK | MB_ICONEXCLAMATION);
            }
        }

    delete ObtainRGBForm;

}
//---------------------------------------------------------------------------

void __fastcall TPlanForm::CopyARange1Click(TObject *Sender)
{
    TObtainRGBForm *ObtainRGBForm = new TObtainRGBForm(this);

    ObtainRGBForm->OpenDialog1->Title = "Enter Name of Range to Copy";
    ObtainRGBForm->AppendColoursto1Click(Sender);
    //ObtainRGBForm->SaveDialog1->FileName = "Copy of " + ObtainRGBForm->SaveDialog1->FileName;
    ObtainRGBForm->Caption = "Copy a Thread Range";

    ObtainRGBForm->ShowModal();

        if (ObtainRGBForm->RegisteredThreads) {
            //new threads have been registered
            //update thread list
            TIniFile *IniFile = new TIniFile(ChangeFileExt(Application->ExeName, ".ini"));
            int numberofthreadranges = IniFile->ReadInteger("ThreadSettings","NumberofRanges",3);
            while (ThreadFileNameList->Count > 3) {
                ThreadFileNameList->Delete(3);
                }
            if (numberofthreadranges != 3) {
                for (int i = 3; i < numberofthreadranges; i++) {
                    ThreadFileNameList->Add(IniFile->ReadString("ThreadSettings","RangeFilename" + AnsiString(i),"DMCCottonFloss"));
                    }
                }
            delete IniFile;
           }

    delete ObtainRGBForm;

}
//---------------------------------------------------------------------------

